			     
			     SURF 
                             ~~~~	

			 VERSION 1.0
                    Author: Amitabh Varshney
			  1992-1994

The source code for SURF is copyrighted by the original author and the 
University of North Carolina at Chapel Hill. Permission to use, copy, 
modify, and distribute this software and its documentation for educational, 
research, and non-profit purposes is hereby granted, provided this notice, 
all the source files, and the name(s) of the original author(s) appear in 
all such copies.

BECAUSE THE CODE IS PROVIDED FREE OF CHARGE, IT IS PROVIDED "AS IS" AND
WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED. 

A Note from the Author:
~~~~~~~~~~~~~~~~~~~~~~~
Although I have written the code, the ideas used in this program have 
evolved over a course of three years of lively weekly discussions with 
Professor Frederick P. Brooks, Jr. (my advisor) and Professor William 
V. Wright. Of course, any bugs that might still be lurking in the 
program are solely my responsiblity. I would like to hear about them,
so please send me some email at: varshney@cs.unc.edu. 

People I would like to acknowledge for their time, help, and/or useful 
discussions during this project are: David Richardson (Duke), Dinesh 
Manocha (UNC), Pankaj Agarwal (Duke), Jan Prins (UNC), Mark Surles (SDSC), 
Larry Bergman (IBM), Lynn Ten Eyck (SDSC),  Mike Pique (Scripps)
Victoria Roberts (Scripps), the GLAB Hackers Inc. @ UNC and scores of
others, who I might be forgetting at this moment.

If you are using this code, I would really appreciate it if you could
kindly send a brief email/note regarding this fact to Professor Brooks
(brooks@cs.unc.edu) and/or Professor Wright (wright@cs.unc.edu). It helps 
us in our grant reviews.
  
-Amitabh 
March 16, 1994.

Installation:
~~~~~~~~~~~~
To install this, simply do a 
% make depend	------- this will set up the dependencies correctly
% make surf     ------- compiles the whole system

The whole thing will take just under a Megabyte of space.

Preparing the Input:
~~~~~~~~~~~~~~~~~~~~
Since .pdb files are such a pain to parse, I have adopted the following format 
to be read in by the system:

The input file consists of one line per atom. The entries
in each line are organized as follows:

<atom_id> <atom_radius> <atom_center_x> <atom_center_y> <atom_center_z>

I am appending the first few entries of a sample file for crambin. The program 
right now ignores all the <atom_id> values in the input file but in the output 
it tags each triangle with the sequential location of its atom position in the 
input file. I am planning to change this so that the triangle tag matches the
atom-id field in the input, but haven't done it yet. At present it would 
be best to just sequentially number the atoms in their <atom_id> field 
(as in the sample crambin file). 

-------------------begin crambin .pdb file ------------------
ATOM      1  HN1 THR     1      17.017  14.972   4.068
ATOM      2  HN2 THR     1      16.297  13.912   2.883
ATOM      3  N   THR     1      16.982  14.095   3.587
ATOM      4  HN3 THR     1      17.707  14.470   3.008
ATOM      5  CA  THR     1      16.949  12.808   4.348
ATOM      6  C   THR     1      15.686  12.779   5.142
ATOM      7  O   THR     1      15.236  13.827   5.603
ATOM      8  CB  THR     1      18.140  12.771   5.349
ATOM      9  OG1 THR     1      19.304  12.851   4.478
ATOM     10  CG2 THR     1      18.163  11.585   6.283
.....
-------------------end crambin .pdb file ------------------

----begin system input file-------------
0 1.00 17.017 14.972 4.068
1 1.00 16.297 13.912 2.883
2 1.75 16.982 14.095 3.587
3 1.00 17.707 14.470 3.008
4 1.85 16.949 12.808 4.348
5 1.85 15.686 12.779 5.142
6 1.60 15.236 13.827 5.603
7 1.85 18.140 12.771 5.349
8 1.60 19.304 12.851 4.478
9 1.85 18.163 11.585 6.283
.....
----end system input file----------------

You could write an awk script for this conversion, or use a program like the 
pdbtoview available from ftp.cs.unc.edu in directory pub/VIEW/Binaries. This
was written by Larry Bergman while he was at UNC-Chapel Hill. The documentation
regarding this is in pub/VIEW/Documentation.

A crude awk script to just get you started (it is not fail-proof and you will
have to change $3, $6, $7, $8 in the script below depending on the pdb file)
without the pdbtoview program appears next.

--------------begin awk script-------------
BEGIN {
  radius["H"] = "1.00";
  radius["N"] = "1.75"; 
  radius["C"] = "1.85"; 
  radius["O"] = "1.60"; 
  radius["S"] = "2.00"; 
  count = 0;
}
{ 
  print count, radius[substr($3,0,1)],$6, $7, $8;
  count++;
}
END {
}
------------------end awk script------------



Command-Line Parameters:
~~~~~~~~~~~~~~~~~~~~~~~~
-R flpt         This allows one to set any desired probe radius. The default
                is 1.4 angstroms, the radius of a water molecule.

-E flpt         This is the maximum edge length of any output triangle. The
                triangles are first generated and then recursively subdivided
                till all their edge lengths are less than or equal to this 
                threshold length. This default length is MAX_TESS_LEN == 1.2
	        (in surf.h)

-W              Controls the triangle writing stage. There are three options 
                for this: 
-W 0            This prevents any output generation. All triangles are computed
                (including recursive subdivision), but none are written out.
                This is just to get timings for surface generation program and
                to get a feel for how fast this would be if directly hooked
                up to a graphics workstation. This is the default if "-W" option
                is not specified.
-W 1            This option keeps writing out the triangles as they are generated.
                The advantage of this method is that it doesn't use any memory for 
                storing the triangles.
-W 2            This generates and keeps storing the triangles in an internal
                buffer and writes them out at the end. This is useful for
                separating the surface generation stage with the triangle 
                output stage. If this is used, it prompts the user for the 
                size of the internal buffer to be used (the input to be given
                is the number of triangles in units of a thousand). As an 
                example, for R = 1.4, E = 1.2 (the default values), the surface 
                for crambin (396 atoms) consists of 18.2K triangles. Thus the
                dialog goes as:
		% surf -W 2 crambin
		  Maximum expected size of the output surface (in thousands of tris): 19
                  ...etc.

-T int		This takes in the expected size of the ouput surface in thousands 
                of triangles. This instead of the above, you could simply give:
		%surf -W 2 -T 19 crambin

-C              This just turns on a few extra checks here and there. 

Output Format:
~~~~~~~~~~~~~
The program outputs triangles in the following format:
<atom_id>
<coord0_x> <coord0_y> <coord0_z> <normal0_x> <normal0_y> <normal0_z>
<coord1_x> <coord1_y> <coord1_z> <normal1_x> <normal1_y> <normal1_z>
<coord2_x> <coord2_y> <coord2_z> <normal2_x> <normal2_y> <normal2_z>

The output file name is assumed to be the input file name suffixed with
".tri".


Publications: 
~~~~~~~~~~~~
The following publications are directly related to SURF and could be referred
to for understanding the algorithms and workings of the system.

   ``Linearly Scalable Computation of Smooth Molecular Surfaces",
   A. Varshney, F. P. Brooks, Jr., and W. V. Wright, IEEE Computer Graphics
   and Applications, September 1994 [invited submission].

   ``Interactive Visualization of Weighted Three-dimensional Alpha Hulls",
   A. Varshney, F. P. Brooks, Jr., and W. V. Wright, accepted in the Third 
   Annual Video Review of Computational Geometry to be presented at the 
   Tenth Annual Symposium on Computational Geometry, Stony Brook,
   NY, June 6--8, 1994.

   ``Fast Analytical Computation for Richards's Smooth Molecular Surface",
   A. Varshney and F. P. Brooks, Jr., IEEE Visualization '93, eds. G. M. Nielson 
   and D. Bergeron, San Jose, CA, October 25--29, 1993, pp 300-307.

Following technical reports are also relevant. They are available from
the Department of Computer Science, University of North Carolina at
Chapel Hill, Chapel Hill, NC 27599-3175 or via anonymous ftp to 
ftp.cs.unc.edu (152.2.128.159) in the directory pub/techreports.

   ``Bounding the Number of Unit Spheres inside a larger Sphere",
   A. Varshney, W. V. Wright, and F. P. Brooks, Jr., Technical Report TR-93-039.

   ``Fast Analytical Computation of Richards's Smooth Molecular Surface",
   A. Varshney and F. P. Brooks, Jr., Technical Report TR-93-002.

      subroutine procnv
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      common /ecce/iecce,imod

      if (iftyp.eq.2.or.iftyp.eq.3) then
          if (iftyp.eq.3) then
             call cnvgus
          else
             call cnvgam
          endif
      elseif (iftyp.eq.4) then
          call cnvgau
      elseif (iftyp.eq.8) then
          call cnvqcm
      elseif (iftyp.eq.9) then
          call cnvorc
      elseif (iftyp.eq.15) then
          if (iecce.eq.1) then
             call ecvnwc
          else
             call cnvnwc
          endif
      elseif (iftyp.eq.7) then
          if (irtype.le.3) call cnvcpmd
      else
          if (iftyp.eq.5) then
             icvav1 = 0
             icvav2 = 0
          endif
      endif

      if (.not.(iftyp.eq.1.or.ipdbon.eq.1.or.iftyp.eq.6.or.
     &          isbin.eq.1.or.iftyp.eq.5)) 
     &     call mmcnv

      call parptr(4,convg1,fdum,idum)

      return
      end

      subroutine rdexbas(basfile)
      implicit double precision (a-h,o-z)
      parameter (maxbas=15)
      parameter (mxel=100)
      parameter (mxaorb=40)
      common /basext/ ibasin(mxel),eborbs(maxbas),
     &     pbas(mxaorb,mxaorb,maxbas)
      common /basopt/ extbas
      logical extbas
      character*75 basfile,line
      character*8 aname

      extbas = .false.

      open (unit=99,file=basfile,status='old',err=90)
      num = 1
      do while(.true.)
         
         read (99,'(A8)',end=10,err=100) aname
         read (99,*,err=100) line
         write(6,*) aname
         read (99,'(i4,i10)',err=100) icharge,norbs
         ibasin(icharge) = num
         eborbs(num) = norbs
         write(6,*) 'norbs=', eborbs(num),'icharge=', icharge
         do i=1,norbs
            read (99,'(6f15.10)',err=100) (pbas(i,j,num),j=1,norbs)
         end do
         num = num + 1
         read(99,*,err=100) line 
      end do
      close(99)

10    continue
      if (num.gt.1) extbas = .true.
      return

90    continue
      print*,'error opening file'
      return

100   continue
      return
      end

      subroutine newdenmad(
     &                     p,q)
c THIS IS REALLY newdenmat

c     returns density matrix in p common /densty/
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (maxbas=15)
      parameter (mxel=100)
      parameter (mxaorb=40)
      logical valenc,bonds,ovrlap,atomic,doori,orient,dolap,doelf
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf

      common /basext/ ibasin(mxel),eborbs(maxbas),
     &     pbas(mxaorb,mxaorb,maxbas)
      common /orbhlp/ mxorb,iuhf,ispd

      character*2 elemnt
      common /elem/elemnt(mxel)
      dimension p(*),q(*)

      do i=1,norbs
         do j=1,norbs
            q((j-1)*mxorb + i) = 0.0d0
         end do
      end do

      ix = 0
      do 700 k=1,natoms
         n = eborbs(ibasin(nat(k)))
         write(6,*) 'n=', n, 'K=',k
         if (ovrlap) then
c     
c============ do overlap densities only ========================
c
            do i=1,n
               do j=1,n
                     p((ix+j-1)*mxorb + (ix+i)) = 0.0d0
                  end do
               end do
            else
c
c============ molecule minus atoms =============================
c
               orient = .false.
C               do i=1,norien
C                  if (ori(i).eq.k) then
C                     orient = .true.
C                     ibal   = i
C                  endif
C               end do
               if (orient.and.doori) then
                  write (6,*) 'Orienting '
C                  
               else
c
c----- for all other atoms substract spherical density -----
c
                  do i=1,n
                     do j=1,n
c                        write (6,*) 'before:', ix,i,j,p((ix+j-1)*mxorb 
c     $                  + (ix+i)), pbas((ix+i),(ix+j),ibasin(nat(k))) 
                        p((ix+j-1)*mxorb + (ix+i)) = 
     $                   p((ix+j-1)*mxorb + (ix+i)) - pbas((ix+i),(ix+j)
     $                                 ,ibasin(nat(k)))
                        q((ix+j-1)*mxorb + (ix+i)) = 
     $                        pbas((ix+i),(ix+j),ibasin(nat(k)))
C                        write (6,*) 'after:' ,p(ix+i,ix+j)
                 end do
              end do
           endif
c
c============== clear out the overlap region of the density matrix
c               if ATOMIC is supplied
c
           if (atomic) then
              idavje = n 
              do i=ix+1,ix+idavje
                 if (k.ne.0) then
                    do j=1,ix
                       p((j-1)*mxorb + i) = 0.0d0
                    end do
                 endif
                 if (k.ne.natoms) then
                    do j=ix+idavje+1,norbs
                       p((j-1)*mxorb + i) = 0.0d0
                    end do
                 endif
              end do
           endif
        endif
        ix = ix + n 
 700  continue
      if (bonds.and.idebug.eq.1) then
         write(iun3,*)' '
         write(iun3,*)'***** Atomic Density Matrix *****'
         write(iun3,*)' '
         call prev(q,norbs,norbs,mxorb)
         write(iun3,*)' '
      endif
      
c############### end bonds , overlap , atomic ##################
      if (idebug.eq.1) then
          write(iun3,'(''   DENSITY MATRIX USED BY MAP'')')
          call prev(p,norbs,norbs,mxorb)
      endif

      return
      end

      subroutine parang(theta,phi)
      implicit double precision (a-h,o-z)
      common /eul/ ca,cb,sa,sb,ccab,scab,ssab,scba

      todeg = 45.0d0 / datan(1.0d0)
      sa    = dsin(theta / todeg)
      ca    = dcos(theta / todeg)
      sb    = dsin(phi / todeg)
      cb    = dcos(phi / todeg) 
      ccab  = ca * cb
      scab  = sa * cb
      ssab  = sa * sb
      scba  = sb * ca

      return
      end

      subroutine above(x1,y1,x2,y2,xq,yq,oans)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      oans=.true.
      if (x1.eq.xq.and.y1.eq.yq)then
         oans=.false.
         return
      endif
      if (x2.eq.xq.and.y2.eq.yq)then
         oans=.false.
         return
      endif
      dum=x2-x1
      if ( dum.ne.0.0d0 ) then
         dum=(y2-y1)*(xq-x1)/dum+(y1-yq)
         if ( dum.ge.0.0d0 ) oans=.false.
      else
         if ( yq.le.y1.or.yq.le.y2 ) oans=.false.
      endif
      return
      end

      subroutine srfcal(idomap,denn,fmap,coo,lwrit,ityp,icont,ncont)
c
c     routine calculates the z-values of the plot plane
c     output array dens and step
c
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxmmul=100)
      common /athlp/ iatoms, mxnat

      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      common /vropt/ ivtwo,ihand,ivadd
      common /grdhlp/ mx3d,mx3d2
      common /types/ iff
      integer srfmap,srfloc
      integer*2 ityp
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      common /multim/ imulm, nmulm,ihasqm(mxmmul)

      dimension denn(*),fmap(*),coo(3,*),icont(*),lwrit(*),ityp(*)
      dimension rt(3)

      call curs(1)

      npts1t = npts1
      npts2t = npts2
      npts3t = npts3

      if (ipdbon.eq.1) then
         npts1 = 45
         npts2 = 45
         npts3 = 45
      endif

      itsrf = 1
      if (idomap.ne.0) then
         if (ipdbon.eq.1) then
            if (ihasq.eq.0) then
               ifftmp = iff
               do i=1,iatoms
                  lwrit(i) = ityp(i)
               end do
               iff = 3
               call dotyp(0)
               call chkbck(0)
               iff = ifftmp
               do i=1,iatoms
                  ityp(i) = lwrit(i)
               end do
            endif
         else
            if (ihasq.eq.0) call eem(3,1,istat)
         endif
      endif

      call defsrf

      radius1 = 0.5d0 * r(1)
      radius2 = 0.5d0 * r(2)
      radius3 = 0.5d0 * r(3)
      rf1     = radius1 / (npts1-1.d0) * 2.d0
      rf2     = radius2 / (npts2-1.d0) * 2.d0
      rf3     = radius3 / (npts3-1.d0) * 2.d0

      radmx = radius1
      if (radius2.gt.radmx) radmx = radius2
      if (radius2.gt.radmx) radmx = radius3

      ncont = 0
      do i=1,iatoms
         xk = (vo(1) - coo(1,i))
         yk = (vo(2) - coo(2,i))
         zk = (vo(3) - coo(3,i))
         r2 = xk*xk+yk*yk+zk*zk
         if (r2.lt.2*radmx*radmx) then
            if (ncont.le.numat1) then
               ncont = ncont + 1
               icont(ncont) = i
            endif
         endif
      end do

c v1, v2 , v3 zijn genormeerde (norm is 1) richtings vectoren

      do kc=1,npts3
         z2=-radius3+(kc-1)*rf3
         ij     = 0
         do ic=1,npts2
             y2=-radius2+(ic-1)*rf2
             do jc=1,npts1
                 ij =  ij + 1
                 x2 = -radius1+(jc-1)*rf1
                 rt(1) = v1(1)*x2 + v2(1)*y2 + v3(1)*z2 + vo(1)
                 rt(2) = v1(2)*x2 + v2(2)*y2 + v3(2)*z2 + vo(2)
                 rt(3) = v1(3)*x2 + v2(3)*y2 + v3(3)*z2 + vo(3)
                 call srfden(rt(1),rt(2),rt(3),psi)
                 if (psi.gt.rmax) rmax = psi
                 denn((kc-1)*mx3d2 + ij) = psi
                 if (idomap.ne.0) then
                    if (idomap.eq.1) then
                       call espot(rt(1),rt(2),rt(3),f,0)
                    elseif (idomap.eq.2.and.ihasq.ne.0) then
                       call calc(rt(1),rt(2),rt(3),f)
                    elseif (idomap.eq.3) then
                       call clmons(rt,f,srfloc)
                    endif
                    fmap((kc-1)*mx3d2 + ij) = f
                 endif
             end do
         end do
      end do
c
c------------- end grid points loop -----------------------
c
c maak origin oorsprong zodat we makkelijk kunnen roteren en
c dan pas de translatie naar de oorsprong kunnen doen
c
      call setcod(0.05d0)

      mapit = 0
      if (idomap.ne.0) mapit = 1
      if (ihasq.eq.0.and.idomap.eq.3) mapit = 0

      call mapsrf(denn,fmap,mapit)

      npts1 = npts1t
      npts2 = npts2t
      npts3 = npts3t

      return
      end

      subroutine srfrd(denn,fmap,coo)
      implicit double precision (a-h,o-z)
      dimension denn(*),fmap(*),coo(3,*)

c      call setcod(0.05d0)

      mapit = 0
      call mapsrf(denn,fmap,mapit)

      return
      end

      subroutine mapsrf(denn,fmap,mapit)

c     routine calculates the z-values of the plot plane
c     output array dens and step

      implicit double precision (a-h,o-z)
      logical dolap, lapdbl
      common /vropt/ ivtwo,ihand,ivadd
      integer srfmap,srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      common /psa/ psa, tsa, exs, pol, pol2, epmin, epmax, ipsa,
     &             icpsa, idtpsa
      dimension denn(*),fmap(*)
      dimension origin(3),rt(3)
c------------- end grid points loop -----------------------
c
c maak origin oorsprong zodat we makkelijk kunnen roteren en
c dan pas de translatie naar de oorsprong kunnen doen
c
      call curs(1)

      toang = 0.52917706d0
      toang3 = toang*toang*toang

      valcnt = 0.05d0
      if (ipsa.eq.1) valcnt = 0.01 / toang

      do i=1,3
         origin(i) = 0.0d0
         rt(i) = 1.0d0
      end do

      ipsi = 0
      dolap =.false.
      lapdbl = .false.
      itrans = 0
      iun = 25

      ivtwot = ivtwo
      ivtwo = 4

c      call sribcol(7)

      call mcubes(npts1,npts2,npts3,denn,fmap,mapit,origin,valcnt,
     &                      -valcnt,rt,ipsi,dolap,lapdbl,itrans,iun)

      ivtwo = ivtwot
      call curs(0)

      return
      end

      subroutine srfded(x,y,z,f,ianz,isurf,coo,icont,ncont)
      implicit double precision (a-h,o-z)
      parameter (nsupp=15)
      parameter (mxel=100)
      common /srfcom/ nsupa(mxel),ngel(nsupp),npq(nsupp),nels(2,nsupp),
     &                sexp(2,nsupp),snrm(2,nsupp)
      dimension ianz(*),isurf(*),coo(3,*),icont(*)

      data ngel  /1,1,1,1,1,1,1,1,1,2,2,2,2,2,2/
      data npq   /0,1,1,1,1,1,1,1,1,1,1,1,1,3,4/
      data nels  /1,0,
     &            1,0,
     &            2,0,
     &            3,0,
     &            4,0,
     &            5,0,
     &            6,0,
     &            7,0,
     &            3,0,
     &            2,2,
     &            2,3,
     &            2,4,
     &            2,5,
     &            2,5,
     &            2,5/
      data sexp  /2.51710141d0,0.0d0,
     &            1.32733145d0,0.0d0,
     &            1.89771849d0,0.0d0,
     &            2.84749616d0,0.0d0,
     &            3.37802055d0,0.0d0,
     &            4.26257495d0,0.0d0,
     &            5.10217946d0,0.0d0,
     &            5.38296417d0,0.0d0,
     &            2.72912143d0,0.0d0,
     &            2.48690111d0,3.23138631d0,
     &            3.98498017d0,3.37475693d0,
     &            4.37094906d0,3.79680895d0,
     &            7.15208053d0,3.84805364d0,
     &            7.28371554d0,4.15598308d0,
     &            4.29535666d0,4.09983616d0/
      data snrm  /2.25307905d0,0.0d0,
     &            0.661170083d0,0.0d0,
     &            1.61601061d0,0.0d0,
     &            4.45679442d0,0.0d0,
     &            6.83156889d0,0.0d0,
     &            12.2192572d0,0.0d0,
     &            19.1537608d0,0.0d0,
     &            21.8987062d0,0.0d0,
     &            4.0079462d0,0.0d0,
     &            3.17695472d0,10.5899771d0,
     &            10.325953d0,11.8039962d0,
     &            13.0108029d0,15.8478254d0,
     &            44.5600556d0,16.3879870d0,
     &            241.467384d0,33.4857583d0,
     &            20.3083480d0,27.2240458d0/
      data nsupa
     &  /1,0,2,3,4,5,6,7,8,0,0,0,9,10,11,12,13,17*0,14,17*0,15,47*0/
c H  1
c 
c Li 2
c Be 3
c B  4
c C  5
c N  6
c O  7
c F  8
c Ne?
c Na?
c Mg?
c Al 9
c Si 10
c P  11
c S  12
c CL 13
c ....
c Br 14
c I  15

c map elemnts to supported atoms array 

c loop over atoms

      toang = 0.52917706d0
      cutoff = 6.0d0
      f = 0.0d0

      do l=1,ncont

         i = icont(l)
         isupe = nsupa(ianz(i))
         if (isupe.lt.0.or.isupe.gt.nsupp) isupe = 0
         if (isurf(i).ne.0.and.isupe.ne.0) then

            xk = (x - coo(1,i))*toang
            yk = (y - coo(2,i))*toang
            zk = (z - coo(3,i))*toang

            r2 = xk*xk+yk*yk+zk*zk

c only calculate contribution if distance is less than a cutoff

            if (r2.lt.cutoff) then
               r2 = r2+1.d-10
               r1 = dsqrt(r2)
               r22 = 1.0d0
               if (npq(isupe).eq.1) r22 = r2
               s1 = snrm(1,isupe)
               s2 = snrm(2,isupe)
               g = nels(1,isupe)*s1*s1*r22*fexp(-2.0d0*sexp(1,isupe)*r1)
               if (ngel(isupe).eq.2)
     &           g = g + 
     &             nels(2,isupe)*s2*s2*r22*fexp(-2.0d0*sexp(2,isupe)*r1)
               f = f + g
            endif

         endif

      end do
      
      return
      end

      subroutine defsrd(isurf,ianz,coo)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      dimension isurf(*),coo(3,*),ianz(*)

c vectors v1,v2,v3 need to be normalised 

      do i=1,3
        vo(i) = 0.0d0
        v1(i) = 0.0d0
        v2(i) = 0.0d0
        v3(i) = 0.0d0
      end do

      v1(1) = 1.0d0
      v2(2) = 1.0d0
      v3(3) = 1.0d0

      sl(1) = 1.0d0
      sl(2) = 1.0d0
      sl(3) = 1.0d0

      wo(1) = -0.5d0
      wo(2) = -0.5d0
      wo(3) = -0.5d0

      call cntsrf(vo,r,coo,ianz,isurf,iatoms)

      return
      end

      subroutine cntsrf(vec,r,coo,ianz,isurf,iatoms)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      dimension vec(3), r(3), coo(3,*), isurf(*),ianz(*)

      do i=1,3
         vec(i) = 0.0d0
         r(i) = 0.0d0
      end do

      if (iatoms.le.0) return
      
      itel = 0
      do i=1,iatoms
         if (isurf(i).ne.0.and.ianz(i).ne.100) then
            itel = itel + 1
            do j=1,3
               vec(j) = vec(j) + coo(j,i)
            end do
         endif
      end do
 
      do j=1,3
         vec(j) = vec(j) / dble(itel)
      end do

      do i=1,iatoms
         if (isurf(i).ne.0.and.ianz(i).ne.100) then
            do j=1,3
               rmax = dabs(vec(j) - coo(j,i))
               if (rmax.gt.r(j)) r(j) = rmax
            end do
         endif
      end do

      do i=1,3
         r(i) = r(i)*2.0d0 + 6.0d0
      end do

      return
      end

      subroutine rotbck(w1,w2,w3,wn)
      implicit double precision (a-h,o-z)
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      common /comtmp/  ifast
      dimension wn(3)

      if (ifast.ne.10000) then
         ifast = 10000
      endif

      do i=1,3
         wn(i) = v1(i)*(wo(1)+w1)*r(1) + 
     &           v2(i)*(wo(2)+w2)*r(2) +
     &           v3(i)*(wo(3)+w3)*r(3) + vo(i)
      end do

      return
      end

      subroutine rttbck(w1,w2,w3,wn)
      implicit double precision (a-h,o-z)
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      dimension wn(3)

      do i=1,3
         wn(i) = v1(i)*(-0.5d0+w1)*r(1) + 
     &           v2(i)*(-0.5d0+w2)*r(2) +
     &           v3(i)*(w3)*r(3) + vo(i)
      end do

      return
      end

      subroutine rtgbck(w1,w2,w3,wn)
      implicit double precision (a-h,o-z)
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      dimension wn(3)

      do i=1,3
         wn(i) = v1(i)*w1*sl(i) + 
     &           v2(i)*w2*sl(i) +
     &           v3(i)*w3*sl(i)
      end do

      return
      end

      subroutine cvtcom
      implicit double precision (a-h,o-z)
      common /comsrf/ vo(3),rt(3),v1t(3),v2t(3),v3t(3),wo(3),
     &                sl(3),isl
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat

      vo(1) = px
      vo(2) = py
      vo(3) = pz
      v3t(1) = -cx
      v3t(2) = -cy
      v3t(3) = -cz
      wo(1) = -0.5d0
      wo(2) = -0.5d0
      wo(3) = -0.5d0


      do i=1,3
         v1t(i) = v2(i)
         v2t(i) = v1(i)
      end do

      sl(1) = 1.0d0
      sl(2) = 1.0d0
      sl(3) = 1.0d0

      rt(1) = r(2)
      rt(2) = r(1)
      rt(3) = r(3)

      call vsc1(v1t,1.0d0,1.0d-4)
      call vsc1(v2t,1.0d0,1.0d-4)
      call vsc1(v3t,1.0d0,1.0d-4)

      return
      end

      subroutine getarg(i,line)
      parameter (maxarg=80)
      integer i
      character*80 words
      character*(*) line
      common /gargs/ words(maxarg)

      if (i.le.maxarg) line = words(i)    

      return
      end

      integer function iargc()
      parameter (maxarg=80)
      integer j,k
      character*80 line,words
      common /gargs/ words(maxarg)

      iargc = 0
      call lib$get_foreign(line,,,)

      if (ifblen(line).eq.0) return

      if (index(line,' ').eq.0) then

         iargc = 1
         words(1) = line//' '
         return

      else

         do k=1,maxarg
            j = index(line,' ')
            if (j.eq.0) then
               words(k) = line(1:)//' '
               iargc = k
               return
            else
               words(k) = line(1:j-1)//' '
               iargc = k
               line = line(j:)
               if (ifblen(line).eq.0) return
               do i=1,80
                  if (line(1:1).eq.' ') then
                     line = line(2:)
                  else
                     goto 10
                  endif
               end do
10             continue
            endif
         end do

      endif
      
      iargc = maxarg

      return
      end

      subroutine mmcnv
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      
      cnvmax = -1000000.d0
      cnvmin =  1000000.d0

      if (icvav1.eq.1) then
         do i=jstrt1,jend1
            if (convg1(i).lt.cnvmin) cnvmin = convg1(i)
            if (convg1(i).gt.cnvmax) cnvmax = convg1(i)
         end do
      endif

      if (icvav2.eq.1) then
         do i=jstrt2,jend2
            if (convg2(i).lt.cnvmin) cnvmin = convg2(i)
            if (convg2(i).gt.cnvmax) cnvmax = convg2(i)
         end do
      endif

      return
      end

      subroutine hidedr(x1,y1,x2,y2,x3,y3,iovis)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (isize=2000)
      common /hide/ upx(isize),upy(isize),downx(isize),downy(isize)
     &              ,nup,ndown
      dimension jdel(100),xadd(100),yadd(100)
      
      if (nup.gt.isize.or.ndown.gt.isize) return
      ipen = 1
      iadd = 0
      istart1 = 1
      iend1 = 0
      idel = 0
      istart2 = 1
      iend2 = 1
      do i=1,nup-1
         if (x1.ge.upx(i).and.x1.lt.upx(i+1)) istart1 = i
         if (x2.gt.upx(i).and.x2.le.upx(i+1)) iend1 = i
         if (x2.ge.upx(i).and.x2.lt.upx(i+1)) istart2 = i
         if (x3.gt.upx(i).and.x3.le.upx(i+1)) iend2 = i
         if (iend2.ne.1) goto 15
      end do
15    continue
      do i=istart1,iend1
         call above(upx(i),upy(i),upx(i+1),upy(i+1),x1,y1,oa)
         call above(upx(i),upy(i),upx(i+1),upy(i+1),x2,y2,ob)
         if (i.eq.istart1.and.oa) then
           call plotgh(ipen,x1,y1)
           iadd = iadd + 1
           xadd(iadd) = x1
           yadd(iadd) = y1
         endif
         if ((oa.and..not.ob).or.(ob.and..not.oa)) then
           call cross(upx(i),upy(i),upx(i+1),upy(i+1),x1,y1,x2,y2,os,
     &                xs,ys)
           if (os) then
             call plotgh(ipen,xs,ys)
             iadd = iadd + 1
             xadd(iadd) = xs
             yadd(iadd) = ys
           endif
         endif
         if (i.eq.iend1.and.ob) call plotgh(ipen,x2,y2)
         call above(x1,y1,x2,y2,upx(i),upy(i),ou)
         if (upx(i).ge.x1.and.(.not.ou).and.upy(i).ne.y1) then
           idel = idel + 1
           jdel(idel) = i
         endif
      end do

      do i=istart2,iend2
         call above(upx(i),upy(i),upx(i+1),upy(i+1),x2,y2,oa)
         call above(upx(i),upy(i),upx(i+1),upy(i+1),x3,y3,ob)
         if (i.eq.istart2.and.oa) then
           call plotgh(ipen,x2,y2)
           iadd = iadd + 1
           xadd(iadd) = x2
           yadd(iadd) = y2
         endif
         if ((oa.and..not.ob).or.(ob.and..not.oa)) then
           call cross(upx(i),upy(i),upx(i+1),upy(i+1),x2,y2,x3,y3,os,
     &                xs,ys)
           if (os) then
             call plotgh(ipen,xs,ys)
             iadd = iadd + 1
             xadd(iadd) = xs
             yadd(iadd) = ys
             if (x3.eq.xs.and.y3.eq.ys) iovis = 1
           endif
         endif
         if (i.eq.iend2.and.ob) then
           call plotgh(ipen,x3,y3)
           iadd = iadd + 1
           xadd(iadd) = x3
           yadd(iadd) = y3
           iovis = 1
         endif
         call above(x2,y2,x3,y3,upx(i),upy(i),ou)
         if (upx(i).ge.x2.and.(.not.ou).and.upy(i).ne.y2) then
           idel = idel + 1
           jdel(idel) = i
         endif
         if (i.eq.iend2.and.upx(i+1).eq.x3.and.oa) then
           call above(x2,y2,x3,y3,upx(i+1),upy(i+1),ou)
           if (.not.ou) then
             idel = idel + 1
             jdel(idel) = i + 1
           endif
         endif
      end do

      ieff = iadd - idel
      nup = nup + ieff
      iend = iend2 + 1

      do j=1,idel
         do inge = jdel(j)-j+1,iend-j
            upx(inge) = upx(inge+1)
            upy(inge) = upy(inge+1)
         end do
      end do

      if (ieff.eq.0) goto 70
         if (ieff.gt.0) then
           do inge=nup,iend+ieff+1,-1
             upx(inge) = upx(inge-ieff)
             upy(inge) = upy(inge-ieff)
           end do
         else
           do inge=iend+ieff+1,nup             
             upx(inge) = upx(inge-ieff)
             upy(inge) = upy(inge-ieff)
           end do
         endif
70       continue
      itemp = iend - idel
      if (istart1.eq.1) istart1 = 2
      do 80 j=1,iadd
         do i=istart1-1,itemp+j-1
            if (i.gt.0.and.j.gt.0) then
               if (xadd(j).ge.upx(i).and.xadd(j).lt.upx(i+1)) then
                 do k=itemp+j,i+2,-1
                    upx(k) = upx(k-1)
                    upy(k) = upy(k-1)
                 end do
                 upx(i+1) = xadd(j)
                 upy(i+1) = yadd(j)
                 goto 80
               endif
            endif
         end do
80    continue
      ipen = 1
      iadd = 0
      idel = 0
      iend2 = 0

      do i=1,ndown-1
         if (x1.ge.downx(i).and.x1.lt.downx(i+1)) istart1=i
         if (x2.gt.downx(i).and.x2.le.downx(i+1)) iend1=i
         if (x2.ge.downx(i).and.x2.lt.downx(i+1)) istart2=i
         if (x3.gt.downx(i).and.x3.le.downx(i+1)) iend2=i
         if (iend2.ne.0) goto 115
      end do

115   continue

      if (istart1.eq.1) istart1 = 2

      do i=istart1,iend1
         call under(downx(i),downy(i),downx(i+1),downy(i+1),x1,y1,oa)
         call under(downx(i),downy(i),downx(i+1),downy(i+1),x2,y2,ob)
         if (i.eq.istart1.and.oa) then
           call plotgh(ipen,x1,y1)
           iadd = iadd + 1
           xadd(iadd) = x1
           yadd(iadd) = y1
         endif
         if ((oa.and..not.ob).or.(ob.and..not.oa)) then
           call cross(downx(i),downy(i),downx(i+1),downy(i+1),x1,y1,x2
     &                ,y2,os,xs,ys)
           if (os) then
             call plotgh(ipen,xs,ys)
             iadd = iadd + 1
             xadd(iadd) = xs
             yadd(iadd) = ys
           endif
         endif
         if (i.eq.iend1.and.ob) call plotgh(ipen,x2,y2)
         call under(x1,y1,x2,y2,downx(i),downy(i),ou)
         if (downx(i).ge.x1.and.(.not.ou).and.downy(i).ne.y1) then
           idel = idel + 1
           jdel(idel) = i
         endif
      end do

      do i=istart2,iend2
         call under(downx(i),downy(i),downx(i+1),downy(i+1),x2,y2,oa)
         call under(downx(i),downy(i),downx(i+1),downy(i+1),x3,y3,ob)
         if (i.eq.istart2.and.oa) then
           call plotgh(ipen,x2,y2)
           iadd = iadd + 1
           xadd(iadd) = x2
           yadd(iadd) = y2
         endif
         if ((oa.and..not.ob).or.(ob.and..not.oa)) then
           call cross(downx(i),downy(i),downx(i+1),downy(i+1),x2,y2,x3
     &                ,y3,os,xs,ys)
           if (os) then
             call plotgh(ipen,xs,ys)
             iadd = iadd + 1
             xadd(iadd) = xs
             yadd(iadd) = ys
             if (x3.eq.xs.and.y3.eq.ys) iovis = 1
           endif
         endif
         if (i.eq.iend2.and.ob) then
           call plotgh(ipen,x3,y3)
           iadd = iadd + 1
           xadd(iadd) = x3
           yadd(iadd) = y3
           iovis = 1
         endif
         call under(x2,y2,x3,y3,downx(i),downy(i),ou)
         if (downx(i).ge.x2.and.(.not.ou).and.downy(i).ne.y2) then
           idel = idel + 1
           jdel(idel) = i
         endif
         if (i.eq.iend2.and.downx(i+1).eq.x3.and.oa) then
           call under(x2,y2,x3,y3,downx(i+1),downy(i+1),ou)
           if (.not.ou) then
             idel = idel + 1
             jdel(idel) = i + 1
           endif
         endif
      end do

      ieff = iadd - idel
      ndown = ndown + ieff
      iend = iend2 + 1
      if (ndown.gt.isize) ndown = isize

      do j=1,idel
         do inge=jdel(j)-j+1,iend-j
            downx(inge) = downx(inge+1)
            downy(inge) = downy(inge+1)
         end do
      end do

      if (ieff.eq.0) goto 170
         if (ieff.gt.0) then
           do inge=ndown,iend+ieff+1,-1
             downx(inge) = downx(inge-ieff)
             downy(inge) = downy(inge-ieff)
           end do
         else
           do inge=iend+ieff+1,ndown             
             downx(inge) = downx(inge-ieff)
             downy(inge) = downy(inge-ieff)
           end do
         endif
170   continue

      itemp = iend - idel
      if (itemp+iadd.gt.isize) goto 180

      do j=1,iadd
         do i=istart1-1,itemp+j-1
            if (xadd(j).ge.downx(i).and.xadd(j).lt.downx(i+1)) then
              do k=itemp+j,i+2,-1
                 downx(k) = downx(k-1)
                 downy(k) = downy(k-1)
              end do
              downx(i+1) = xadd(j)
              downy(i+1) = yadd(j)
              goto 180
            endif
          end do
      end do

180   continue
      return
      end

      subroutine ryspol(n,x,t,w)
      implicit double precision (a-h,o-z)
      dimension t(*),w(*)
      dimension f(10,10),c(10,10),ra(20),dr(20),ap(20)
      dimension rap(20),fmt(20),a(100)

      if (n.le.0) stop 'ryspol n illegal'

      call fmtgen(fmt,x,2*n+1,istatus)
      if (istatus.ne.0) stop 'ryspol in fmtgen'

      do j=1,n+1
         do i=1,n+1
            f(i,j) = fmt(i+j-1)
         end do
      end do

c start with identity matrix

      do i = 1,n+1
         do j = 1,n+1
            c(i,j) = 0.0d0
         end do
         c(i,i) = 1.0d0
      end do
 
      c(1,1) = 1.0d0 / dsqrt(f(1,1))
      temp = 1.0d0 / (dsqrt(f(1,1)*(f(1,1)*f(2,2) - f(2,1)*f(2,1))))
      c(1,2) =  -f(2,1)*temp
      c(2,2) =   f(1,1)*temp

      if (n+1.gt.100) stop 'ryspol nbasis.gt.100'
      if (n+1.le.1) goto 100
 
      do k=1,n + 1
         if (k.ne.1) then
            do i=1,n + 1
               a(i) = 0.0d0
               do j=1,n+1
                  a(i) = a(i) + c(j,k)*f(j,i)
               end do
            end do
            do j = 1,k - 1
               b = 0.0d0
               do i=1,n+1
                  b = b + c(i,j)*a(i)
               end do
               do i=1,n+1
                  c(i,k) = c(i,k) - b*c(i,j)
               end do
            end do
         endif
         tt = 0.0d0
         do i=1,n+1
            t1 = 0.0d0
            do j=1,n+1
               t1 = t1 + c(j,k)*f(j,i)
            end do
            tt = tt + c(i,k)*t1
         end do
         tt = 1.0d0 / dsqrt(tt)
         do i=1,n+1
            c(i,k) = c(i,k)*tt
         end do

      end do

100   continue

      if (n.le.1) then
         t(1) = dsqrt( - c(1,2)/c(2,2))
         w(1) = f(1,1)
         goto 300
      endif

      k = 2*n+1
      do i = 1,n+1
         ra(k) = c(i,n+1)
         k = k - 2
      end do
      ndeg = 2*n

      call rysrot(ndeg,ra,dr,rap)
      call fdpol(ndeg,nfd,a,ap)

      do i = 1,n
         root = dr(i)
         do j = 1,50
            f1 = fpol(ndeg,root,a)
            f2 = fpol(nfd,root,ap)
            if (dabs(f2).lt.1.0d-12) goto 200
            if (dabs(f1/(f2*root)).le.1.0d-12) goto 200
            root = root - f1 / f2
         end do
200      t(i) = root
      end do

      do i = 1,n
         w(i) = 0.0d0
         root = t(i)
         do j = 1,n
            sum = 0.0d0
            do k = 1,j
               km1 = k - 1
               sum = sum + (c(k,j)*(root**(2*km1)))
            end do
            w(i) = w(i) + sum*sum
         end do
         w(i) = 1.0d0/w(i)
      end do

300   continue

      do i = 1,n
         t(i) = t(i)*t(i)
      end do

      return
      end
      double precision function fpol(npol,x,f)
      implicit double precision (a-h,o-z)
      dimension f(*)
      fpol = 0.0d0
      if (npol.eq.0) fpol = f(1)
      if (npol.lt.1) return
      sum = f(npol+1)
      xx = x
      do i = 1, npol
         sum = sum + f(npol-i+1) * xx
         xx = xx*x
      end do
      fpol = sum

      return
      end
      subroutine fdpol(npow,nwpow,f,g)
      implicit double precision (a-h,o-z)
      dimension f(*), g(*)
 
      nwpow = npow - 1
      if (npow.lt.1) return
      do i = 1, npow
          g(i) = f(i) * dfloat(npow-i+1)
      end do

      return
      end

      subroutine wrinfd(npts1,npts2,dens)
      implicit double precision (a-h,o-z)

c THIS IS REALLY wrinfo

      parameter (numatm=2000)
      logical valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      character keywrd*320, keyori*320
      common /keywrd/ keywrd,keyori
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf

c      logical denok
      dimension dens(*)

c      ipsi = 0
c      bonds  = .false.
c      atomic = .false.
c      ovrlap = .false.
c      call denmak(denok)
c      call grdcal(dens,npts1,npts2,1,0)

      if (ipsi.ne.0.or.
     &       (ipsi.eq.0.and.(bonds.or.atomic.or.ovrlap))) then
         call messg(11)
      endif

      if (index(keywrd,'WRBAS=').ne.0) then
         call filkey('WRBAS',21,0)
      else
         ld = linlen(curdir)
         if (icmdf.eq.1) then
            open(unit=21,form='unformatted',
     &        file=curdir(1:ld)//'gridfile',status='unknown')
         else
            open(unit=21,form='unformatted',
     &        file='gridfile',status='unknown')
         endif
      endif

      write(21) natoms
      do i=1,natoms
         write(21)(xyz(j,i),j=1,3)
      end do
      write(21) px, py, pz, cx, cy, cz, r(1),r(2),npts1,npts2
      write(21)(dens(i),i=1,npts1*npts2)

      close(21)

      if (ipsi.eq.0.and..not.(bonds.or.atomic.or.ovrlap)) then
         call inferr('Normal Density written',0)
      endif

      return
      end

      subroutine wr3ind(npts1,npts2,npts3,adjus,denn)
      implicit double precision (a-h,o-z)

c THIS IS REALLY wr3inf

      parameter (numatm=2000)
      logical valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /grdhlp/ mx3d,mx3d2
      character keywrd*320, keyori*320
      common /keywrd/ keywrd,keyori
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf
      dimension denn(*)

      if (ipsi.ne.0.or.bonds.or.atomic.or.ovrlap) then
          call inferr('Only Normal Density Can be Written!',0)
          return
      endif

      if (index(keywrd,'WRBAS=').ne.0) then
         call filkey('WRBAS',21,0)
      else
         if (icmdf.eq.1) then
            ld = linlen(curdir)
            open(unit=21,form='unformatted',
     &        file=curdir(1:ld)//'3dgridfile',status='unknown')
         else
            open(unit=21,form='unformatted',
     &        file='3dgridfile',status='unknown')
         endif
      endif

      write(21) natoms
      write(21) (nat(i),i=1,natoms)
      write(21) adjus
      do i=1,natoms
         write(21)(xyz(j,i),j=1,3)
      end do
      write(21) px, py, pz, cx, cy, cz, r(1),r(2),r(3),
     &          npts1,npts2,npts3,iplat
      do i=1,npts3
         write(21)(denn((i-1)*mx3d2 + j),j=1,npts1*npts2)
      end do

      close(21)
      call inferr('3D Density written',0)

      return
      end

      subroutine shsort(n,arr,iarr)
      implicit double precision (a-h,o-z)
      parameter (aln2i = 1.0d0 / 0.69314718d0, tiny=1.d-6)
      dimension arr(*),iarr(*)
      if (n.eq.0) return
      lognb2 = int(dlog(dfloat(n))*aln2i+tiny)
      do i=1,n
         iarr(i) = i
      end do
      m = n
      do nn=1,lognb2
         m = m / 2
         k = n - m
         do j=1,k
            i = j
3           continue
            l = i + m
            if (arr(iarr(l)).lt.arr(iarr(i))) then
               it = iarr(i)
               iarr(i) = iarr(l)
               iarr(l) = it
               i = i - m
               if (i.ge.1) goto 3
            endif
         end do
      end do
       
      return
      end

      double precision function reada(a,istart,ll)
      implicit double precision (a-h,o-z)
      character*1 a(ll)
      logical multi,scient

      nine  = ichar('9')
      izero = ichar('0')
      minus = ichar('-')
      iplus = ichar('+')
      idot  = ichar('.')
      ie    = ichar('E')
      iee   = ichar('e')
      id    = ichar('D')
      idd   = ichar('d')
      idig  = 0
      k1    = 0
      k2    = 0
      k3    = 0
      one   = 1.d0
      x     = 1.d0
      do j=istart,ll
         n = ichar(a(j))
         if((n.le.nine.and.n.ge.izero).or. n.eq.minus.or.n.eq.idot)
     &   goto 7
      end do
      reada = 0.d0
      return

7     continue
c     before the dot
      do i=j,ll
         n = ichar(a(i))
         if (n.le.nine.and.n.ge.izero) then
            idig = idig + 1
            if (idig.gt.10) then
               ii = i
               goto 90
            endif
            k1 = k1*10 + n - izero
         elseif (n.eq.minus.and.i.eq.j) then
             one = -1.d0
         elseif (n.eq.idot) then
             goto 30
         else
             ii = i
             goto 90
         endif
      end do
30    continue
c     after the dot
      idig = 0
      do ii=i+1,ll
         n = ichar(a(ii))
         if (n.le.nine.and.n.ge.izero) then
            idig = idig + 1
            if (idig.gt.9) goto 90
            k2 = k2*10 + n - izero
            x = x /10
         elseif (n.eq.minus.and.ii.eq.i) then
            x = -x
         else
            goto 90
         endif
      end do
90    continue
      scient = .false.
      do jj=ii,ll
         n = ichar(a(jj))
         if (n.eq.ie.or.n.eq.iee.or.n.eq.id.or.n.eq.idd) goto 95
      end do
      goto 100
95    continue
         if (jj.lt.159) then
            scient = .true.
            n = ichar(a(jj+1))
            if (n.eq.minus.or.n.eq.iplus) then
                multi = .true.
                if (n.eq.minus) multi = .false.
                idig = 0
                do j=jj+2,ll
                   n = ichar(a(j))
                   if (n.le.nine.and.n.ge.izero) then
                       idig = idig + 1
                       if (idig.gt.9) goto 90
                       k3 = k3*10 + n - izero
                   else
                      goto 100
                   endif
                end do
            endif
         endif

100   continue
      reada = one * ( k1 + k2 * x)
      if (scient) then
          if (multi) then
              reada = reada * 10**k3
          else
              if (k3.gt.25) then
                 reada = 0.0d0
              else
                 reada = reada / 10**k3
              endif
          endif
      endif

      return
      end

      subroutine espod(x,y,z,epot,idebug,
     &                 p)
c THIS IS REALLY espot
      implicit double precision(a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (numtmp=4000)
      logical oeerst
      integer shella,shelln,shellt,shellc,shladf,aos
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /bounds/ ilow(5,5),iupp(5)
      common /indxe/  jx(35),jy(35),jz(35),ix(20),iy(20),iz(20)
      common /strt/   oeerst
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /pseudo / ipseud,ivale(numatm)
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /extchg/ exchg(3,3),iexchg(3),nexchg
      dimension tt(4),zz(4),pre(45),ca(35),cb(35),
     &          coeffx(192),coeffy(192),coeffz(192)
      dimension h(numtmp),f(numtmp),h2x(9),h2y(9),h2z(9),
     &          h3x(16),h3y(16),h3z(16)
      dimension p(*)
      data jx/1,2,1,1,3,1,1,2,2,1,4,1,1,2,3,3,2,1,1,2,
     &           5,1,1,4,4,2,1,2,1,3,3,1,3,2,2/
      data jy/1,1,2,1,1,3,1,2,1,2,1,4,1,3,2,1,1,2,3,2,
     &           1,5,1,2,1,4,4,1,2,3,1,3,2,3,2/
      data jz/1,1,1,2,1,1,3,1,2,2,1,1,4,1,1,2,3,3,2,2,
     &           1,1,5,1,2,1,2,4,4,1,3,3,2,2,3/
      data ix/0,4,0,0,8,0,0,4,4,0,12,0,0,4,8,8,4,0,0,4/
      data iy/0,0,4,0,0,8,0,4,0,4,0,12,0,8,4,0,0,4,8,4/
      data iz/0,0,0,4,0,0,8,0,4,4,0,0,12,0,0,4,8,8,4,4/
c iupp 1  4  10 20 35
c      s  3p 6d 10f 15g
c 
c ilow 0    1       2        3      4    <- shellt
c---------------------------------------
c 0    1(s) 1 (sp)  1 (spd)  1      1
c 1    1    2 (p)   5       11     21
c 2    1    1       5 (d)   11     21
c 3    1    1       5       11 (f) 21
c 4    1    1       5       11     21 (g)
c---------------------------------------
c ^
c | shellc
c
      data iupp/1,4,10,20,35/
      data ilow/5*1,1,2,5,11,21,1,1,5,11,21,1,1,5,11,21,
     &          1,1,5,11,21/

      if (oeerst) then
         call epint
         call setcon
         oeerst = .false.
      endif

      epot = 0.0d0
      pi = 4.d0*datan(1.d0)
c
c     loop over shell pairs.
c
      do ishell = 1, nshell
        xa = gx(ishell)
        ya = gy(ishell)
        za = gz(ishell)
        ifrst = shella(ishell)
        ilast = ifrst + shelln(ishell) - 1
        itype = shellt(ishell)
        itype1 = itype + 1
        istart = ilow(itype1,shellc(ishell)+1)
        iend = iupp(itype1)
        iendt = iend

        do jshell = 1,ishell
          xb = gx(jshell)
          yb = gy(jshell)
          zb = gz(jshell)
          jfsrt = shella(jshell)
          jlast = jfsrt + shelln(jshell) - 1
          jtype = shellt(jshell)
          jtype1 = jtype + 1
          jstart = ilow(jtype1,shellc(jshell)+1)
          jend = iupp(jtype1)
          ijtyp = itype1 + jtype1 - 1
          ndim = (iend-istart+1)*(jend-jstart+1)
          iminj = iabs(ishell - jshell)
          n = (itype + jtype) / 2 + 1
          xt = xb - xa
          yt = yb - ya
          zt = zb - za
          rsq = xt*xt + yt*yt + zt*zt
          if (ndim.gt.numtmp) 
     &       print*,'WARNING: exceding array limit in espot'
          do ii=1,ndim
             h(ii) = 0.0d0
          end do
          jendt = jend
c
c         loop over primitive gaussians.
c
          do igauss = ifrst, ilast
            ei = exx(igauss)
            call fcij(itype,ifrst,igauss,shladf(ishell),ca)
            do jgauss = jfsrt,jlast
              iend = iendt
              jend = jendt
              ej = exx(jgauss)
              call fcij(jtype,jfsrt,jgauss,shladf(jshell),cb)
              ep = ei + ej
              exptmp = ej*ei*rsq / ep
              if (exptmp.ge.600.0d0) goto 100
              expp = 2.0d0*dexp(-exptmp)
              tx = (ei*xa + ej*xb) / ep
              ty = (ei*ya + ej*yb) / ep
              tz = (ei*za + ej*zb) / ep
              xta = tx - xa
              yta = ty - ya
              zta = tz - za
              xtb = tx - xb
              ytb = ty - yb
              ztb = tz - zb
              call coeffs(coeffx,xta,xtb,itype1,jtype1)
              call coeffs(coeffy,yta,ytb,itype1,jtype1)
              call coeffs(coeffz,zta,ztb,itype1,jtype1)
              if (ndim.gt.numtmp) 
     &           print*,'WARNING: exceding array limit in espot'
              do ii=1,ndim
                  f(ii) = 0.0d0
              end do
              xct = x - tx
              yct = y - ty
              zct = z - tz
              expont = ep * (xct * xct + yct * yct + zct * zct)
              call rys(n,expont,tt,zz)
              epp = 0.5d0 / ep
              call calct(pre,epp,ijtyp)
              do ii = 1, n
                fac1 = (ep + ep)*tt(ii)
                zf = pi * expp * zz(ii) / ep
                call twocen(h2x,xct,1.d0,pre,fac1,ijtyp)
                call twocen(h2y,yct,1.d0,pre,fac1,ijtyp)
                call twocen(h2z,zct,zf,pre,fac1,ijtyp)
                call thrcen(h3x,h2x,coeffx,itype1,jtype1)
                call thrcen(h3y,h2y,coeffy,itype1,jtype1)
                call thrcen(h3z,h2z,coeffz,itype1,jtype1)

                k = 0
                do i = istart, iend
                  do j = jstart, jend
                    k = k + 1
                    if (k.gt.numtmp) 
     &                print*,'WARNING: exceding array limit in espot'
                    f(k) = f(k)-
     &           (h3x(jx(j)+ix(i))*h3y(jy(j)+iy(i))*h3z(jz(j)+iz(i)))
                  end do
                end do
              end do

              k = 0
              do i = istart, iend
                do j = jstart,jend
                  k = k + 1
                  if (k.gt.numtmp) 
     &              print*,'WARNING: exceding array limit in espot'
                  h(k) = h(k) + f(k)*ca(i)*cb(j)
                end do
              end do
              kend = k

100           continue
              end do
            end do

            call purdf(itype,jtype,istart,jstart,iend,jend,h)
c
c Density matrix contribution
c

            ii = 0
            ist = aos(ishell) - 1
            jst = aos(jshell) - 1
            do i = istart,iend
               do j = jstart,jend
                  ii = ii + 1
                  if (iminj.eq.0) then
                     a1or2 = 1.0d0
                     if (i-j.lt.0) then
                        pt = p((ist+i-1)*mxorb + (jst+j))
                     else
                        pt = p((jst+j-1)*mxorb + (ist+i))
                     endif
                  else
                     a1or2 = 2.0d0
                     pt = p((jst+j-1)*mxorb + (ist+i))
                  endif
                  phelp = pt*a1or2
                  epot = epot + phelp*h(ii)
            if (idebug.eq.1) print*,'v(',ist+i,',',jst+j,')=',h(ii)
               end do
            end do

            jend = jendt
            iend = iendt
        end do
      end do

c sum in nuclear contribution

c
      do ii = 1 ,natoms
          xt = xyz(1,ii) - x
          yt = xyz(2,ii) - y
          zt = xyz(3,ii) - z
          rsq = xt*xt + yt*yt + zt*zt
          if (rsq.ge.1.0d-8) then
             if (ipseud.eq.1) then
                epot = epot + dfloat(ivale(ii))*dsqrt(1.0d0 / rsq)
             else
                epot = epot + dfloat(nat(ii))*dsqrt(1.0d0 / rsq)
             endif
          endif
      end do

      if (nexchg.ne.0) then
          do ii=1,nexchg
             xt = exchg(1,ii) - x
             yt = exchg(2,ii) - y
             zt = exchg(3,ii) - z
             rsq = xt*xt + yt*yt + zt*zt
             if (rsq.ge.1.0d-8) then
                if (iexchg(ii).eq.1) then
                   epot = epot + dsqrt(1.0d0 / rsq)
                else
                   epot = epot - dsqrt(1.0d0 / rsq)
                endif
             endif
          end do
      endif

      return
      end

      subroutine espgrdd(npts1,npts2,npts3,idebug,
     &                   denn,p,xden,yden,zden)
c THIS IS REALLY espgrd
      implicit double precision(a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (nmcex2=numcex*numcex)
      parameter (numtmp=4000)
      character monstr*100
      character*2 gstr
      logical oeerst
      integer shella,shelln,shellt,shellc,shladf,aos
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /bounds/ ilow(5,5),iupp(5)
      common /indxe/  jx(35),jy(35),jz(35),ix(20),iy(20),iz(20)
      common /strt/   oeerst
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /pseudo / ipseud,ivale(numatm)
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /extchg/ exchg(3,3),iexchg(3),nexchg
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /grdhlp/ mx3d,mx3d2
      dimension tt(4),zz(4),pre(45),ca(35),cb(35),
     &          coeffx(192),coeffy(192),coeffz(192)
      dimension h(numtmp),f(numtmp),h2x(9),h2y(9),h2z(9),
     &          h3x(16),h3y(16),h3z(16),v3(3)
      dimension p(*),denn(*),xden(*),yden(*),zden(*)

      if (oeerst) then
         call epint
         call setcon
         oeerst = .false.
         do i=1,192
            coeffx(i) = 0.d0
         end do
      endif


      call pregrd(npts1,npts2,npts3,xden,yden,zden)

      do kc=1,npts3
          do ic=1,npts1
             do jc=1,npts2
                iadrs = (kc-1)*mx3d2 + ij
                denn(iadrs) = 0.0d0
             end do
          end do
      end do

      pi = 4.d0*datan(1.d0)
c
c     loop over shell pairs.
c
      nn = 0
      iup = 0
      do ishell = 1, nshell

        xa = gx(ishell)
        ya = gy(ishell)
        za = gz(ishell)

        ifrst = shella(ishell)
        ilast = ifrst + shelln(ishell) - 1
        itype = shellt(ishell)
        itype1 = itype + 1
        istart = ilow(itype1,shellc(ishell)+1)
        iend = iupp(itype1)
        iendt = iend

        do jshell = 1,ishell

          xb = gx(jshell)
          yb = gy(jshell)
          zb = gz(jshell)

          jfsrt = shella(jshell)
          jlast = jfsrt + shelln(jshell) - 1
          jtype = shellt(jshell)
          jtype1 = jtype + 1
          jstart = ilow(jtype1,shellc(jshell)+1)
          jend = iupp(jtype1)
          ijtyp = itype1 + jtype1 - 1
          ndim = (iend-istart+1)*(jend-jstart+1)
          iminj = iabs(ishell - jshell)

          n = (itype + jtype) / 2 + 1

          xt = xb - xa
          yt = yb - ya
          zt = zb - za

          rsq = xt*xt + yt*yt + zt*zt

          if (ndim.gt.numtmp) 
     &       print*,'WARNING: exceding array limit in espot'

c deze jendt moet niet in binnenste loop ??
          jendt = jend

          do kc=1,npts3

             monstr = 'Progress Monitor [1-' // gstr(npts3)//'] ' //
     &                 gstr(kc)
             ij = 0

             do ic=1,npts1
   
                do jc=1,npts2


                ij =  ij + 1
                iadrs = (kc-1)*mx3d2 + ij

                x  = xden(iadrs)
                y  = yden(iadrs)
                z  = zden(iadrs)


                do ii=1,ndim
                   h(ii) = 0.0d0
                end do

 
c         loop over primitive gaussians.
 
                do igauss = ifrst, ilast

                  ei = exx(igauss)
                  call fcij(itype,ifrst,igauss,shladf(ishell),ca)

                  do jgauss = jfsrt,jlast

                    iend = iendt
                    jend = jendt

                    ej = exx(jgauss)
                    call fcij(jtype,jfsrt,jgauss,shladf(jshell),cb)

                    ep = ei + ej
                    epr = 1.0d0 / ep

                    exptmp = ej*ei*rsq*epr

                    if (exptmp.ge.600.0d0) goto 100

                    expp = 2.0d0*dexp(-exptmp)
                    tx = (ei*xa + ej*xb) * epr
                    ty = (ei*ya + ej*yb) * epr
                    tz = (ei*za + ej*zb) * epr

                    xta = tx - xa
                    yta = ty - ya
                    zta = tz - za

                    xtb = tx - xb
                    ytb = ty - yb
                    ztb = tz - zb

                    call coeffs(coeffx,xta,xtb,itype1,jtype1)
                    call coeffs(coeffy,yta,ytb,itype1,jtype1)
                    call coeffs(coeffz,zta,ztb,itype1,jtype1)

                    if (ndim.gt.numtmp) 
     &                 print*,'WARNING: exceding array limit in espot'

                    do ii=1,ndim
                        f(ii) = 0.0d0
                    end do

                    xct = x - tx
                    yct = y - ty
                    zct = z - tz

                    expont = ep * (xct * xct + yct * yct + zct * zct)

                    call rys(n,expont,tt,zz)
                    epp = 0.5d0 * epr
                    call calct(pre,epp,ijtyp)
                    ep2 = ep + ep
                    pee = pi*expp*epr

                    do ii = 1, n
                      fac1 = ep2 * tt(ii)
                      zf = pee * zz(ii)
                      call twocen(h2x,xct,1.d0,pre,fac1,ijtyp)
                      call twocen(h2y,yct,1.d0,pre,fac1,ijtyp)
                      call twocen(h2z,zct,zf,pre,fac1,ijtyp)
                      call thrcen(h3x,h2x,coeffx,itype1,jtype1)
                      call thrcen(h3y,h2y,coeffy,itype1,jtype1)
                      call thrcen(h3z,h2z,coeffz,itype1,jtype1)

                      k = 0
                      do i = istart, iend
                        do j = jstart, jend
                          k = k + 1
                          if (k.gt.numtmp) print*,
     &                      'WARNING: exceding array limit in espot'
                          f(k) = f(k) - (h3x(jx(j)+ix(i))*
     &                                   h3y(jy(j)+iy(i))*
     &                                   h3z(jz(j)+iz(i)))

                        end do
                      end do

                    end do

                    k = 0
                    do i = istart, iend
                      do j = jstart,jend
                        k = k + 1

                        if (k.gt.numtmp) print*,
     &                    'WARNING: exceding array limit in espot'

                        h(k) = h(k) + f(k)*ca(i)*cb(j)

                      end do
                    end do


100                 continue

                  end do
                end do

                call purdf(itype,jtype,istart,jstart,iend,jend,h)
c
c Density matrix contribution
c

                ii = 0
                ist = aos(ishell) - 1
                jst = aos(jshell) - 1

                do i = istart,iend
                   do j = jstart,jend
                      ii = ii + 1
                      if (iminj.eq.0) then
                         a1or2 = 1.0d0
                         if (i-j.lt.0) then
                            pt = p((ist+i-1)*mxorb + (jst+j))
                         else
                            pt = p((jst+j-1)*mxorb + (ist+i))
                         endif
                      else
                         a1or2 = 2.0d0
                         pt = p((jst+j-1)*mxorb + (ist+i))
                      endif
                      phelp = pt*a1or2
                      denn(iadrs) =  denn(iadrs) + phelp*h(ii)

                      if (idebug.eq.1) 
     &                   print*,'v(',ist+i,',',jst+j,')=',h(ii)

                   end do
                end do

                jend = jendt
                iend = iendt

c  end do's kc,ic,jc

                end do
              end do
            end do

c  end do's ishell, jshell

        end do
      end do

c sum in nuclear contribution

      do kc=1,npts3
          ij = 0
          do ic=1,npts1
             do jc=1,npts2

                ij =  ij + 1
                iadrs = (kc-1)*mx3d2 + ij

                x  = xden(iadrs)
                y  = yden(iadrs)
                z  = zden(iadrs)

                do ii = 1,natoms

                    xt = xyz(1,ii) - x
                    yt = xyz(2,ii) - y
                    zt = xyz(3,ii) - z

                    rsq = xt*xt + yt*yt + zt*zt

                    if (rsq.ge.1.0d-8) then
                       if (ipseud.eq.1) then
                          denn(iadrs) = denn(iadrs) + 
     &                        dfloat(ivale(ii))*dsqrt(1.0d0 / rsq)
                       else
                          denn(iadrs) = denn(iadrs) + 
     &                        dfloat(nat(ii))*dsqrt(1.0d0 / rsq)
                       endif
                    endif
                end do

                if (nexchg.ne.0) then
                    do ii=1,nexchg
                       xt = exchg(1,ii) - x
                       yt = exchg(2,ii) - y
                       zt = exchg(3,ii) - z
                       rsq = xt*xt + yt*yt + zt*zt
                       if (rsq.ge.1.0d-8) then
                          if (iexchg(ii).eq.1) then
                             denn(iadrs) = denn(iadrs) + 
     &                                       dsqrt(1.0d0 / rsq)
                          else
                             denn(iadrs) = denn(iadrs) - 
     &                                       dsqrt(1.0d0 / rsq)
                          endif
                       endif
                    end do
                endif

             end do
          end do
      end do

      return
      end

      subroutine purdf(itype,jtype,istart,jstart,iend,jend,h)
c
c only iend and jend are really nescessary to return
c
c iupp 1  4  10 20 35
c      s  3p 6d 10f 15g
c 
c ilow 0    1       2        3      4    <- shellt
c---------------------------------------
c 0    1(s) 1 (sp)  1 (spd)  1      1
c 1    1    2 (p)   5       11     21
c 2    1    1       5 (d)   11     21
c 3    1    1       5       11 (f) 21
c 4    1    1       5       11     21 (g)
c---------------------------------------
c ^
c | shellc
c
c question does h come filled in shell form ?, eg d is really spd
c with start at 5 (instead of 1) (we treat d such but not f?)
c
c xxxx,yyyy,zzzz *1
c xxxy ...       *d7
c xxyy ...       *d5*d7/d3
c xxyz ...       *d5*d7
c
c via fcij ca and cb have these, and therfor h() has them 
c
      implicit double precision (a-h,o-z)
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /intcon/ d3,d5,d7,r1,r2,r3,r4,r3ov2,z1,z2,z3,
     &                g1,g2,g3,g4,g5,g6
      logical debug
      dimension h(*),inc(14)
      debug = .false.
c
c     convert  gaussians to pure angular functions.
c     (6D -> 5D, 10F -> 7F, 15G -> 9G)
c

      b1 = 1.0d0/d7
      b2 = d3/(d5*d7)
      b3 = 1.0d0/(d5*d7)

      idim = iend - istart + 1
      jdim = jend - jstart + 1

      if (ido5d.eq.1.and.jtype.eq.2) then
c
c     The row side of the matrix: pure d
c     

         i1 = 5 - jstart + 1

c     when d   shell jstart = 5 , i1 = 1, jend = 10, jdim = 6
c     when spd shell jstart = 1 , i1 = 5, jend = 10, jdim = 10
c     single d shell is stored in H() as:
c
c     d1 d2 d3 d4 d5 d6 NOT s px py pz d1 d2 etc

         do i=1,idim
            dz2 = h(i1+2) - 0.5d0*(h(i1) + h(i1+1))
            dx2y2 = r3ov2*(h(i1) - h(i1+1))
            h(i1  ) = dz2
            h(i1+1) = h(i1+4)
            h(i1+2) = h(i1+5)
            h(i1+4) = h(i1+3)
            h(i1+3) = dx2y2
            i1 = i1 + jdim
         end do

      endif
 
      if (ido7f.eq.1.and.jtype.eq.3) then
c
c     The row side af the matrix: pure f
c     
c     when f  shell jstart = 11 , jend = 20, jdim = 10
c
         i1 = 0
         do i=1,idim
 
            f0  = h(i1+3) - r2*(h(i1+6) + h(i1+9))
            f1p = r4*(z1*h(i1+7) - h(i1+1) - z2*h(i1+4))
            f1m = r4*(z1*h(i1+8) - h(i1+2) - z2*h(i1+5))
            f2p = r3ov2*(h(i1+6) - h(i1+9))
            f2m = h(i1+10)
            f3p = r1*(h(i1+1) - z3*h(i1+4))
            f3m = r1*(z3*h(i1+5) - h(i1+2))
 
            h(i1+1) = f0
            h(i1+2) = f1p
            h(i1+3) = f1m
            h(i1+4) = f2p
            h(i1+5) = f2m
            h(i1+6) = f3p
            h(i1+7) = f3m
 
            i1 = i1 + jdim

         end do
      endif

      if (ido9g.eq.1.and.jtype.eq.4) then
c
c     The row side af the matrix: pure g
c     
c     when g  shell jstart = 21 , jend = 35, jdim = 15
c
         i1 = 0
         do i=1,idim
 
          g0  = 
     &       0.375d0*h(i1+1)  + 0.375d0*  h(i1+2) +           h(i1+3) 
     &     -3.0d0*b2*h(i1+11) - 3.0d0*b2*h(i1+12) + 0.75d0*b2*h(i1+10)

          g1p = 
     &  g1*(4.0d0*b1*h(i1+8)  - 3.0d0*b3*h(i1+14) - 3.0d0*b1* h(i1+5))

          g1m = 
     &  g1*(4.0d0*b1*h(i1+9)  - 3.0d0*b3*h(i1+13) - 3.0d0*b1* h(i1+7))

          g2p = 
     &  g2*(6.0d0*b2*h(i1+11) - 6.0d0*b2*h(i1+12) -           h(i1+1) 
     &    +          h(i1+2))

          g2m = 
     &  g3*(6.0d0*b3*h(i1+15) - b1*      h(i1+4)  - b1*       h(i1+6))

          g3p = 
     &  g4*(   b1*   h(i1+5)  - 3.0d0*b3*h(i1+14))

          g3m = 
     &  g4*(3.0d0*b3*h(i1+13) -  b1*     h(i1+7))
 
          g4p = 
     &  g5*(         h(i1+1)  - 6.0d0*b2*h(i1+10) +           h(i1+2))

          g4m = 
     &  g6*b1*(      h(i1+4)  -          h(i1+6))

            h(i1+1) = g0
            h(i1+2) = g1p
            h(i1+3) = g1m
            h(i1+4) = g2p
            h(i1+5) = g2m
            h(i1+6) = g3p
            h(i1+7) = g3m
            h(i1+8) = g4p
            h(i1+9) = g4m
 
            i1 = i1 + jdim

         end do
      endif
c
c     the row size of the matrix has changed, so get rid of
c     the superflous functions.
c
      if ((ido5d.eq.1.and.jtype.eq.2).or.
     &    (ido7f.eq.1.and.jtype.eq.3).or.
     &    (ido9g.eq.1.and.jtype.eq.4)) then

         if (jtype.eq.2) then
            jendp = 9
         else if (jtype.eq.3) then
c     when f   shell jstart = 11 , jend = 17, jpure = jdim = 7, jend = 17
            jendp = 17
         else if (jtype.eq.4) then
c     when g   shell jstart = 21 , jendp = 29, jpure = jdim = 9, jend = 29
            jendp = 29
         endif
         if (debug) print*,'row.old.new ',itype,jtype,jend,jendp
         jrpure = jendp - jstart + 1
 
         i1 = 0
         i2 = 0
 
         do i=1,idim
            do j=1,jrpure
               h(i2+j) = h(i1+j)
            end do
            i1 = i1 + jdim
            i2 = i2 + jrpure
         end do
         jend = jendp
         jdim = jrpure

      endif
c
c     transformation at row side complete, start of column side
c

      if (ido5d.eq.1.and.itype.eq.2) then
c
c     The column side of the matrix: pure d
c
         i1 = (5-istart)*jdim + 1
         do i=1,5
            inc(i) = i*jdim
         end do
 
         do j=1,jdim
            dz2 = h(i1+inc(2)) - 0.5d0*(h(i1) + h(i1+inc(1)))
            dx2y2 = r3ov2*(h(i1) - h(i1+inc(1)))
            h(i1       ) = dz2
            h(i1+inc(1)) = h(i1+inc(4))
            h(i1+inc(2)) = h(i1+inc(5))
            h(i1+inc(4)) = h(i1+inc(3))
            h(i1+inc(3)) = dx2y2
            i1 = i1 + 1
         end do

      endif
 
      if (ido7f.eq.1.and.itype.eq.3) then
c
c     The column side af the matrix: pure F
c
         i1 = 1
         do i=1,9
            inc(i) = i*jdim
         end do
 
         do j=1,jdim
 
            f0  = h(i1+inc(2)) - r2*(h(i1+inc(5)) + h(i1+inc(8)))
            f1p = r4*(z1*h(i1+inc(6)) - h(i1) - z2*h(i1+inc(3)))
            f1m = r4*(z1*h(i1+inc(7)) - h(i1+inc(1))-z2*h(i1+inc(4)))
            f2p = r3ov2*(h(i1+inc(5)) - h(i1+inc(8)))
            f2m = h(i1+inc(9))
            f3p = r1*(h(i1) - z3*h(i1+inc(3)))
            f3m = r1*(z3*h(i1+inc(4)) - h(i1+inc(1)))
    
            h(i1       ) = f0
            h(i1+inc(1)) = f1p
            h(i1+inc(2)) = f1m
            h(i1+inc(3)) = f2p
            h(i1+inc(4)) = f2m
            h(i1+inc(5)) = f3p
            h(i1+inc(6)) = f3m
    
            i1 = i1 + 1
         end do

      endif
 
      if (ido9g.eq.1.and.itype.eq.4) then
c
c     The column side af the matrix: pure G
c
         i1 = 1
         do i=1,14
            inc(i) = i*jdim
         end do
 
         do j=1,jdim
 
          g0  = 
     &          0.375d0*h(i1)         + 0.375d0*  h(i1+inc(1))  +
     &                  h(i1+inc(2))  - 3.0d0*b2* h(i1+inc(10)) - 
     &         3.0d0*b2*h(i1+inc(11)) + 0.75d0*b2*h(i1+inc(9))

          g1p = 
     &     g1*(4.0d0*b1*h(i1+inc(7))  - 3.0d0*b3* h(i1+inc(13)) - 
     &         3.0d0*b1*h(i1+inc(4)))

          g1m = 
     &     g1*(4.0d0*b1*h(i1+inc(8))  - 3.0d0*b3* h(i1+inc(12)) - 
     &         3.0d0*b1*h(i1+inc(6)))

          g2p = 
     &     g2*(6.0d0*b2*h(i1+inc(10)) - 6.0d0*b2* h(i1+inc(11)) -
     &                  h(i1)         +           h(i1+inc(1)))

          g2m = 
     &     g3*(6.0d0*b3*h(i1+inc(14)) - b1*       h(i1+inc(3))  -
     &               b1*h(i1+inc(5)))

          g3p = 
     &     g4*(b1*      h(i1+inc(4))  - 3.0d0*b3* h(i1+inc(13)))

          g3m = 
     &     g4*(3.0d0*b3*h(i1+inc(12)) - b1*       h(i1+inc(6)))
 
          g4p = 
     &      g5*(        h(i1)         - 6.0d0*b2* h(i1+inc(9))  + 
     &                  h(i1+inc(1)))

          g4m = 
     &      g6*b1*(     h(i1+inc(3))  -           h(i1+inc(5)) )

            h(i1       ) = g0
            h(i1+inc(1)) = g1p
            h(i1+inc(2)) = g1m
            h(i1+inc(3)) = g2p
            h(i1+inc(4)) = g2m
            h(i1+inc(5)) = g3p
            h(i1+inc(6)) = g3m
            h(i1+inc(7)) = g4p
            h(i1+inc(8)) = g4m
 
            i1 = i1 + 1
         end do

      endif
      if ((ido5d.eq.1.and.itype.eq.2) .or.
     &    (ido7f.eq.1.and.itype.eq.3) .or.
     &    (ido9g.eq.1.and.itype.eq.4)) then

         if (debug) print*,'colm.old ',itype,jtype,iend
         if (itype.eq.2) then
            iend = 9
         else if (itype.eq.3) then
            iend = 17
         else if (itype.eq.4) then
            iend = 29
         endif
         if (debug) print*,'colm.new ',itype,jtype,iend

      endif
 
      return
      end

      subroutine setcon
      implicit double precision (a-h,o-z)
      common /intcon/ d3,d5,d7,r1,r2,r3,r4,r3ov2,z1,z2,z3,
     &                g1,g2,g3,g4,g5,g6
      d3 = dsqrt(3.0d0)
      d5 = dsqrt(5.0d0)
      d7 = dsqrt(7.0d0)
      z1 = 4.0d0/d5
      z2 = 1.0d0/d5
      z3 = 3.0d0/d5
      r1 = 0.5d0*dsqrt(5.0d0/2.0d0)
      r2 = 1.5d0/d5
      r3ov2 = 0.5d0*dsqrt(3.0d0)
      r3 = r3ov2
      r4 = 0.5d0*dsqrt(3.0d0/2.0d0)

      g1 = dsqrt(5.0d0/8.0d0)
      g2 = dsqrt(5.0d0/16.0d0)
      g3 = dsqrt(5.0d0/4.0d0)
      g4 = dsqrt(35.0d0/8.0d0)
      g5 = dsqrt(35.0d0/64.0d0)
      g6 = dsqrt(35.0d0/4.0d0)

      return
      end

      subroutine dipold(ntt,nor,dmao,focc,focb,vectrs,vectrb,p)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)

c     dipole integrals 

      logical debug
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /bounds/ ilow(5,5),iupp(5)
      common /orbhlp/ mxorb,iuhf,ispd
      common /coord / xyz(3,numatm)

      integer shella,shelln,shellt,shellc,shladf,aos
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp

      common /indxe/  jx(35),jy(35),jz(35),ix(20),iy(20),iz(20)
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      double precision imprd
      integer genaos

      dimension focc(*),focb(*),vectrs(*),vectrb(*),nor(*)
      dimension ca(35),cb(35),sx(36),sy(36),sz(36),dd(3,100),
     &    ccx(330),ccy(330),ccz(330),p(*),dmao(ntt,3),
     &    d12(100),dipon(3)

      lind(i,j) = ((max0(i,j)*(max0(i,j)-1)/2)+min0(i,j))

c iupp 1  4  10 20 35
c      s  3p 6d 10f 15g
c 
c ilow 0    1       2        3      4    <- shellt
c---------------------------------------
c 0    1(s) 1 (sp)  1 (spd)  1      1
c 1    1    2 (p)   5       11     21
c 2    1    1       5 (d)   11     21
c 3    1    1       5       11 (f) 21
c 4    1    1       5       11     21 (g)
c---------------------------------------
c ^
c | shellc
c

      debug = .false.
      cf = 2.5417463d0
      idum = genaos(.false.)

      pi = 4.d0*datan(1.d0)

      do i=1,3
         dipo(i) = 0.d0
         dipon(i) = 0.d0
      end do

      do i=1,natoms
         do j=1,3
            dipon(j) = dipon(j) + dble(nat(i))*xyz(j,i)
         end do
      end do

      call denini

      do ishell=1,nshell

         xi = gx(ishell)
         yi = gy(ishell)
         zi = gz(ishell)

         ifrst = shella(ishell)
         ilast = ifrst + shelln(ishell) - 1
         itype = shellt(ishell)

         itype1 = itype + 1
         lidim = itype1 + 2

         istart = ilow(itype1,shellc(ishell)+1)
         iend   = iupp(itype1)
         iendt  = iend

         do jshell=1,ishell

            xj = gx(jshell)
            yj = gy(jshell)
            zj = gz(jshell)

            jfrst = shella(jshell)
            jlast = jfrst + shelln(jshell) - 1
            jtype = shellt(jshell)

            jtype1 = jtype+1
            ljdim  = jtype+2

            jstart = ilow(jtype1,shellc(jshell)+1)
            jend   = iupp(jtype1)
            jendt  = jend
            lpdim  = lidim + ljdim

            xt = xi - xj
            yt = yi - yj
            zt = zi - zj

            r2 = xt*xt + yt*yt + zt*zt

            do l=1,100
               do k=1,3
                  dd(k,l) = 0.d0
               end do
            end do
 
            irp = iendt - istart + 1
            jrp = jendt - jstart + 1
            lentqp = irp*jrp

            if (ishell.eq.jshell) lentqp = (irp*(irp+1))/2

            do igauss=ifrst,ilast

               ei = exx(igauss)
               twoei = ei + ei

               call fcij(itype,ifrst,igauss,shladf(ishell),ca)
 
               do jgauss=jfrst,jlast

                  ej = exx(jgauss)
                  twoej = ej + ej

                  call fcij(jtype,jfrst,jgauss,shladf(jshell),cb)
    
                  ep = ei + ej

                  tx = (ei*xi + ej*xj) / ep
                  ty = (ei*yi + ej*yj) / ep
                  tz = (ei*zi + ej*zj) / ep

                  xit = tx - xi
                  yit = ty - yi
                  zit = tz - zi

                  xjt = tx - xj
                  yjt = ty - yj
                  zjt = tz - zj

                  expont = (ej*ei*r2) / ep
                  pexp   = 0.d0

                  if (expont.lt.600.d0) pexp = dexp(-expont)
 
                  call dipint(lidim,ljdim,lpdim,
     &                  xit,xjt,ccx, yit,yjt,ccy, zit,zjt,ccz,
     &                  ei,ej,pi,pexp,sx,sy,sz)
   
                  call dipao((ishell.eq.jshell),istart,iend,jstart,jend,
     &                 lidim,ljdim,ca,cb,
     &                 sx,sy,sz,xi,yi,zi,dd)

               end do
            end do

            do l=1,3
               call purdf(itype,jtype,istart,jstart,iend,jend,dd(l,1))
            end do

            ii = 0
            ist = aos(ishell) - 1
            jst = aos(jshell) - 1

            do i=istart,iend
               jnd = jend
               if (ishell.eq.jshell) jnd = i

               do j=jstart,jnd
                  ii = ii + 1
                  d12(ii) = p((ist+i-1)*mxorb + (jst+j))
                  if (ist+i.ne.jst+j) d12(ii) = 2.0d0*d12(ii)
                  ll = lind(ist+i,jst+j)
                  do l=1,3
                     dmao(ll,l) =  dd(l,ii)
                  end do
               end do

            end do

            do l=1,3
               dipo(l) = dipo(l) - imprd(lentqp,d12,dd,l)
            end do

         end do
      end do
 
      if (debug) then
         write(6,'(a)') 'Dipole moment vector (Debye)'
         write(6,'(a,3f10.4)') 'elec dipole ',(cf*dipo(i),i=1,3)
         write(6,'(a,3f10.4)') 'nuc  dipole ',(cf*dipon(i),i=1,3)

         dipt = 0.d0
         do l=1,3
            dipo(l) = dipo(l) + dipon(l)
            dipt = dipt + dipo(l)*dipo(l)
         end do
         dipt = dsqrt(dipt)
         write(6,'(a,3f10.4)') 'tot  dipole ',(cf*dipo(i),i=1,3)
         write(6,'(a,f10.4)') 'total dipole scalar ',cf*dipt
      endif
   
      call setnor(nocc,norbs,nor,focc)
      call boys(nocc,nor,dmao,vectrs)

      if (iuhf.ne.0) then
          call setnor(nocc,norbs,nor,focb)
          call boys(nocc,nor,dmao,vectrb)
      endif

      return
      end

      subroutine dipint(l1max,l2max,l12mxp,
     &                  ax,bx,ccx, ay,by,ccy, az,bz,ccz,
     &                  as,bs,pi,pexp,sx,sy,sz)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension ccx(l12mxp,l2max,l1max)
      dimension ccy(l12mxp,l2max,l1max)
      dimension ccz(l12mxp,l2max,l1max)
      dimension sx(l2max,l1max),sy(l2max,l1max),sz(l2max,l1max)
      dimension s1(21)
 
      do l1=1,l1max
         do l2=1,l2max
            do l12=1,l12mxp
               ccx(l12,l2,l1) = 0.d0
               ccy(l12,l2,l1) = 0.d0
               ccz(l12,l2,l1) = 0.d0
            end do
         end do
      end do

      ccx(2,1,1) = 1.d0
      ccy(2,1,1) = 1.d0
      ccz(2,1,1) = 1.d0

      do l1=1,l1max
         do l2=1,l2max
            iwmax = l1 + l2
            do iw=2,iwmax

               if (l1.gt.1) then

                   ccx(iw,l2,l1) = 
     &                  ax*ccx(iw,l2,l1-1) + ccx(iw-1,l2,l1-1)
                   ccy(iw,l2,l1) = 
     &                  ay*ccy(iw,l2,l1-1) + ccy(iw-1,l2,l1-1)
                   ccz(iw,l2,l1) = 
     &                  az*ccz(iw,l2,l1-1) + ccz(iw-1,l2,l1-1)

               elseif (l2.gt.1) then

                   ccx(iw,l2,l1) = 
     &                  bx*ccx(iw,l2-1,l1) + ccx(iw-1,l2-1,l1)
                   ccy(iw,l2,l1) =  
     &                  by*ccy(iw,l2-1,l1) + ccy(iw-1,l2-1,l1)
                   ccz(iw,l2,l1) = 
     &                  bz*ccz(iw,l2-1,l1) + ccz(iw-1,l2-1,l1)

               endif

            end do
         end do
      end do

      temp = 1.d0/(2.d0*(as+bs))
      s1(1) = dsqrt(pi/(as+bs))

      lim = l1max + l2max - 1

      if (lim.ge.2) then

         fact = 1.d0
   
         do i=2,lim
            if (mod(i,2).eq.0) then
               s1(i) = 0.d0
            else
               s1(i) = s1(i-2)*temp*fact
               fact   = fact + 2.d0
            endif
         end do

      endif

      do l1=1,l1max
         do l2=1,l2max

            x = 0.d0
            y = 0.d0
            z = 0.d0
            iwmax = l1 + l2 - 1

            do iw=1,iwmax
               x = x + ccx(iw+1,l2,l1)*s1(iw)
               y = y + ccy(iw+1,l2,l1)*s1(iw)
               z = z + ccz(iw+1,l2,l1)*s1(iw)
            end do

            sx(l2,l1) = x
            sy(l2,l1) = y
            sz(l2,l1) = z*pexp

         end do
      end do

      return
      end

      subroutine dipao(ieqj,istart,iend,jstart,jend,
     &                 l1max,l2max,ca,cb,sx,sy,sz,xa,ya,za,dd)
      implicit double precision (a-h,o-z), integer (i-n)
      logical ieqj
      common /indxe/  lx(35),ly(35),lz(35),kx(20),ky(20),kz(20)
      dimension ca(*),cb(*),dd(3,*)
      dimension sx(l2max,l1max),sy(l2max,l1max),sz(l2max,l1max)
      dimension rxyz(3)

      ii = 0

      do i=istart,iend

         ix = lx(i)
         iy = ly(i)
         iz = lz(i)
 
         jnd = jend

         if (ieqj) jnd = i

         do j=jstart,jnd

            jx = lx(j)
            jy = ly(j)
            jz = lz(j)

            ii = ii + 1
            coef = ca(i)*cb(j)

            rxyz(1) = (xa*sx(jx,ix) + sx(jx,ix+1))
     &                *sy(jy,iy)*sz(jz,iz)
            rxyz(2) = (ya*sy(jy,iy) + sy(jy,iy+1))
     &                *sx(jx,ix)*sz(jz,iz)
            rxyz(3) = (za*sz(jz,iz) + sz(jz,iz+1))
     &                *sx(jx,ix)*sy(jy,iy)

            do l=1,3
               dd(l,ii) = dd(l,ii) + coef*rxyz(l)
            end do

         end do
      end do

      return
      end

      double precision function imprd(n,a,b,l)
      implicit double precision (a-h,o-z), integer (i-n)
c     improduct of a and b.
      dimension a(*), b(3,*)
 
      imprd = 0.d0

      if (n.lt.1) return

      do i=1,n
          imprd = imprd + a(i)*b(l,i)
      end do

      return
      end

      subroutine boyd(norb,nor,dmao,cc,nbasis,ntt,cl,
     &                iord,iir,rij,qpix,qpjx)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numatm=2000)
      logical debug
 
C     Boys Localization.  After QCPE program 354
C
C     NOrb   ... Number of orbitals to localize.
C     CC     ... Input and output orbitals (NBasis,).
C     CL     ... Scratch matrix (NBasis,NOrb).

      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension cc(*), cl(nbasis,*), dmao(ntt,3), nor(nbasis,nbasis),
     &          iord(*), iir(*), rij(ntt,3), qpix(*), qpjx(*)

      lind(i,j) = ((max0(i,j)*(max0(i,j)-1)/2)+min0(i,j))
      kind(j,i) = ((i-1)*mxorb + j)

c essential that in above definition i and j have swapped places !!!


      debug = .false.
      cf = 2.5417463d0

      do itry=1,3

          do i=1,norb
              ii = i

              do j=1,i
                  jj = j
                  sumx = 0.0d0
                  sumy = 0.0d0
                  sumz = 0.0d0

                  do k=1,nbasis
                      do l=1,nbasis
                          cpr = cc(kind(k,ii))*cc(kind(l,jj))
                          sumx = sumx + cpr*dmao(lind(k,l),1)
                          sumy = sumy + cpr*dmao(lind(k,l),2)
                          sumz = sumz + cpr*dmao(lind(k,l),3)
                      end do
                  end do

                  rij(lind(i,j),1) = sumx
                  rij(lind(i,j),2) = sumy
                  rij(lind(i,j),3) = sumz

              end do

          end do


      call caltra(norb,ntt,rij,tracia)

      if (debug) write(6,'(a,f15.8)') 
     &          ' Initial TraceA=',tracia*cf*cf

      do i=1,nbasis
          do j=1,nbasis
             cl(i,j) = 0.0d0
          end do
      end do

      do i=1,norb
          cl(i,i) = 1.0d0
      end do

      iter = 0
      shift = datan(1.0d0)

      change = 1.0d0

       do while (iter.lt.150.and.change.gt.1.d-6)

         if (change.ge.1.d-10) then
            change = 0.0d0
   
            iter = iter + 1

            do i=1,norb
                iir(i) = i
            end do

            nnn = norb

            do i=1,norb
                iii = irnumb(nnn)
                iord(i) = iir(iii)
                iir(iii) = iir(nnn)
                nnn = nnn - 1
            end do

         endif

         do iii=1,norb
   
           i  = iord(iii)
           if (nor(i,i).eq.0) then

             li = lind(i,i)
             
             jm = 1
             rm = 0.0d0
             tm = 0.0d0
             sm = 0.0d0
             cm = 1.0d0

             do j=1,norb

               if (i.ne.j.and.nor(i,j).eq.0) then

                 lj = lind(j,j)
                 ij = lind(i,j)
                 t  = 0.0d0
                 tx = 0.0d0
   
                 do kk=1,3
                     t = t + 4.0d0*rij(ij,kk)**2 - rij(li,kk)**2
     &                  - rij(lj,kk)**2
     &                  + 2.0d0*rij(li,kk)*rij(lj,kk)
                     tx = tx + rij(ij,kk)*(rij(lj,kk)-rij(li,kk))
                 end do

                 if (dabs(t).gt.1.d-10.or.dabs(tx).gt.1.d-10) then

                    tx = 4.0d0*tx
                    t = datan2(tx,t)/4.0d0
                    sign = 1.0d0
                    if (t.gt.0.0d0) sign = -1.0d0
                    t = t + sign*shift
                    itim = 0

                    s = dsin(t)
                    c = dcos(t)
                    rin = 0.0d0
                    itim = itim + 1

                    do kk=1,3
                        qpi = c*c*rij(li,kk) + s*s*rij(lj,kk)
     &                        + 2.0d0*c*s*rij(ij,kk)
                        qpj = c*c*rij(lj,kk)+s*s*rij(li,kk)
     &                        - 2.0d0*c*s*rij(ij,kk)
                        rin = rin + qpi*qpi+qpj*qpj - rij(li,kk)**2
     &                            - rij(lj,kk)**2
                    end do

                    ttest = dabs(t) - shift

                    if (dabs(t).le.1.d-8.or.dabs(ttest).lt.1.d-8.or.
     &                  rin.ge.(-1.d-8)) then
                        if (rin.gt.rm) then
                            rm = rin
                            jm = j
                            sm = s
                            cm = c
                            tm = t
                        endif
                    else

                       if (debug) then
                         write(6,'(a,i4,a,i4,a,f15.8,a,f15.8)') 
     &               ' BoyLoc:  No rotation increases integrals for I=',
     &                    i,' J=',j,' Theta=',t,' Change=',rin
                       endif

                    endif

                 endif

               endif

             end do

c end  loop over j

             rin = rm
             j = jm
             s = sm
             c = cm
             t = tm

             ij = lind(i,j)
             lj = lind(j,j)

             if (nor(i,j).eq.0) then

                change = change + t*t

                do kk=1,3
                    qpi = c*c*rij(li,kk) + s*s*rij(lj,kk)
     &                                   + 2.0d0*c*s*rij(ij,kk)
                    qpj = c*c*rij(lj,kk) + s*s*rij(li,kk)
     &                                   - 2.0d0*c*s*rij(ij,kk)
                    qpij = (c*c-s*s)*rij(ij,kk) + 
     &                      c*s*(rij(lj,kk)-rij(li,kk))

                    do k=1,norb
                        if (i.ne.k.and.j.ne.k) then
                           ik = lind(i,k)
                           jk = lind(j,k)
                           qpix(k) = c*rij(ik,kk) + s*rij(jk,kk)
                           qpjx(k) = c*rij(jk,kk) - s*rij(ik,kk)
                        endif
                    end do

                    do k=1,norb
                        if (i.ne.k.and.j.ne.k) then
                           ik = lind(i,k)
                           jk = lind(j,k)
                           rij(ik,kk) = qpix(k)
                           rij(jk,kk) = qpjx(k)
                        endif
                    end do

                    rin = rin + qpi + qpj - rij(li,kk) - rij(lj,kk)
                    rij(li,kk) = qpi
                    rij(lj,kk) = qpj
                    rij(ij,kk) = qpij

                end do

                do k=1,norb
                    c1 =  c*cl(k,i) + s*cl(k,j)
                    c2 = -s*cl(k,i) + c*cl(k,j)
                    cl(k,i) = c1
                    cl(k,j) = c2
                end do

             endif

           endif
         end do

c end loop over iii
 
         change = dsqrt(2.0d0*change/dble(norb*(norb-1)))

   
         if (debug) then

            write(6,'(a,i4,a,f15.6)') 
     &              ' BoyLoc:  Iteration',iter,' Change=',change


         endif

       end do

      end do

      if (iter.gt.150) then
            write(6,'(a)') 
     &        ' Localization failed. after 3 tries of 150 iterations.'
      else
         if (change.le.1.d-6) then
           write(6,'(a,i4,a)')
     &          ' Localization complete after',iter,' iterations.'
         endif
      endif

      do i=1,norb

          do k=1,nbasis
             qpix(k) = 0.0d0
          end do

          do j=1,norb
              jj = j

              do k=1,nbasis
                  qpix(k) = qpix(k) + cc(kind(k,jj))*cl(j,i)
              end do

          end do

          do k=1,nbasis
             cl(k,i) = qpix(k)
          end do

      end do

c     put rotated orbitals back 

      do i=1,norb
          ii = i

          do k=1,nbasis
             cc(kind(k,ii)) = cl(k,i)
          end do
         
      end do

      if (debug) then

         print*,"rotated orbitals"
         print*," "
         call prev(cc,nbasis,nbasis,mxorb)

         call caltra(norb,ntt,rij,tracfa)
         write(6,'(a,f15.8)') ' Final TraceA=',tracfa

      endif

      call caldrv(norb,ntt,rij,dmax,imax,jmax)

      if (debug) then
          write(6,'(a,i3,a,i3,a,f15.8)') 
     &    ' Largest derivative:  DDelta(',imax,',',jmax,
     &    ')=', dmax
      endif

      if (dmax.gt.1.d-8) then
          write(6,'(a,i3,a,i3,a,f15.8)') 
     &    ' Internal error in BoyLoc, DDelta(',imax,',',jmax,
     &    ')=',dmax
      endif

      return
      end

      integer function irnumb(max)
      implicit double precision (a-h,o-z), integer (i-n)

      irnumb = int(random()*dble(max)+1.0d0)

      return
      end

      subroutine caltra(norb,ntt,rij,traca)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension rij(ntt,3)

      lind(i,j) = ((max0(i,j)*(max0(i,j)-1)/2)+min0(i,j))

      traca = 0.0d0

      ii = 0
      do i=1,norb
         ii = ii + i
         if (i.ne.1) then
         traca = traca + rij(ii,1)**2 + rij(ii,2)**2 + rij(ii,3)**2
         endif
      end do

      return
      end

      subroutine caldrv(norb,ntt,rij,dmax,imax,jmax)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension rij(ntt,3)

      lind(i,j) = ((max0(i,j)*(max0(i,j)-1)/2)+min0(i,j))

      dmax = -1.0d0

      do i=2,norb

          li = lind(i,i)

          do j=1,i-1

              lj = lind(j,j)
              ij = lind(i,j)
              dt = 0.0d0

              do kk=1,3
                  dt = dt + rij(ij,kk)*(rij(li,kk)-rij(lj,kk))
              end do

              if (dabs(dt).gt.dmax) then
                  dmax = dabs(dt)
                  imax = i
                  jmax = j
              endif

           end do
      end do

      dmax = 2.0d0*dmax

      return
      end

      double precision function random()
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mplier=16807,modlus=2147483647,mobymp=127773,
     &           momdmp=2836)
      common  /seed/jseed,ifrst,nextn
c     mseed comes from alloc.c
      integer hvlue, lvlue, testv, nextn, mseed
 
      if (ifrst.eq.0) then
        jseed = mseed()
        nextn = jseed
        ifrst = 1
      endif
 
      hvlue = nextn / mobymp
      lvlue = mod(nextn, mobymp)
      testv = mplier*lvlue - momdmp*hvlue

      if (testv.gt.0) then
        nextn = testv
      else
        nextn = testv + modlus
      endif

      random = dble(nextn)/dble(modlus)
 
      return
      end

      integer function ncoree()
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension ncore(103)
      data ncore /2*0,2*1,6*1,2*5,6*5,2*9,10*9,9,5*14,
     &            2*18,10*18,18,5*23,2*27,14*27,10*34,
     &            34,5*39,2*43,14*43,50/
 
      ncoree = 0

      do i=1,natoms
          ncoree = ncoree + ncore(nat(i))
      end do

      return
      end

      subroutine setnor(nocc,nbasis,nor,focc)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension focc(*),nor(nbasis,nbasis)

      nocc = 0
      do i=1,nbasis
         if (focc(i).ne.0.d0) then 
            nocc = nocc + 1
         endif
      end do

      do i=1,nbasis
         do j=1,nbasis
            nor(i,j) = 1
         end do
      end do

      mcore = ncoree()
      do i=mcore+1,nocc
         do j=mcore+1,nocc
            nor(i,j) = 0
         end do
      end do

      return
      end

      subroutine pregrd(npts1,npts2,npts3,xden,yden,zden)
      implicit double precision(a-h,o-z)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /grdhlp/ mx3d,mx3d2
      dimension v3(3),xden(*),yden(*),zden(*)

      v3(1) = cx
      v3(2) = cy
      v3(3) = cz

      call vnrm(v3)

      radius1 = 0.5d0 * r(1)
      radius2 = 0.5d0 * r(2)
      radius3 = 0.5d0 * r(3)
      rf1     = r(1) / dble(npts1-1)
      rf2     = r(2) / dble(npts2-1)
      rf3     = r(3) / dble(npts3-1)

      do kc=1,npts3
          z2 = -radius3+dble(kc-1)*rf3
          do ic=1,npts1
             x2 = -radius1+dble(ic-1)*rf1
             do jc=1,npts2
                y2 = -radius2+dble(jc-1)*rf2

                iadrs = (kc-1)*mx3d2 + ij

                xden(iadrs)  = v1(1)*x2 + v2(1)*y2 + px - v3(1)*z2
                yden(iadrs)  = v1(2)*x2 + v2(2)*y2 + py - v3(2)*z2
                zden(iadrs)  = v1(3)*x2 + v2(3)*y2 + pz - v3(3)*z2

             end do
          end do
      end do

      return
      end

      subroutine cnvgau
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      logical g92,g03
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      character lstr*137
      character tstr*137

      call rewfil
      icvav1 = 1
      icvav2 = 1
      g92 = .false.
      g03 = .false.

      call search(tstr,'03 program',istat)
      if (istat.eq.1) then
         g03 = .true.
      else
         call rewfil
      endif

c     SCF convergence first point

      call search(tstr,'nuclear repulsion energy',istat)
      if (istat.eq.0) goto 300

      call searchd(lstr,'iter  electronic-energy',
     &                  ' Cycle ',istat)
      if (istat.eq.0) goto 300
      if (lstr(1:6).eq.' Cycle'.or.lstr(1:6).eq.' CYCLE') then
         call bckfil
         g92 = .true.
      endif

c     defer reading nuclear repulsion energy until g92 is known
      if (g92) then
         read(tstr,'(37x,f15.10)',err=300) enuc
      else
         read(tstr,'(30x,f15.10)',err=300) enuc
      endif

      jstrt1 = 0

10    call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 300
      ilen = ifblen(lstr)
      if (index(lstr,'SCF Done').ne.0
     &    .or.index(lstr,'SCF DONE').ne.0) goto 20
      if (g92) then
         if (lstr(1:6).ne.' Cycle'.and.lstr(1:6).ne.' CYCLE')
     &   goto 10
         read(lstr,'(7x,i3)',err=300) jend1
         call search(lstr,' E=',istat)
         read(lstr,'(3x,f22.15)',end=300,err=300) convt
      else
         if (ilen.ne.4) goto 10
         read(lstr,'(1x,i3)',err=300) jend1
         call nxtlin(lstr,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 300
         read(lstr,'(6x,f22.15)',end=300,err=300) convt
      endif
      convg1(jend1) = convt
      if (jstrt1.eq.0) jstrt1 = jend1
      goto 10

20    continue
      if (.not.g03) then
         do j=jstrt1,jend1
            convg1(j) = convg1(j) + enuc
         end do
      endif

c     SCF convergence last point

      if (g92) then
         call search(lstr,' Cycle ',istat)
      else
         call search(lstr,'iter  electronic-energy',istat)
      endif
      if (istat.eq.0) goto 400
100   call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 400
      goto 100
110   call bckfil
      if (g92) then
         call scback(lstr,' Cycle ',istat)
      else
         call scback(lstr,'iter  electronic-energy',istat)
      endif
      if (istat.eq.0) goto 400
      call scback(lstr,'nuclear repulsion energy',istat)
      if (istat.eq.0) goto 400
      if (g92) then
         read(lstr,'(37x,f15.10)',err=300) enuc
      else
         read(lstr,'(30x,f15.10)',err=300) enuc
      endif

      if (g92) then
         call search(lstr,' Cycle ',istat)
         call bckfil
      else
         call search(lstr,'iter  electronic-energy',istat)
      endif
      if (istat.eq.0) goto 400
      jstrt2 = 0

120   call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 400

      ilen = ifblen(lstr)
      if (index(lstr,'SCF Done').ne.0
     &    .or.index(lstr,'SCF DONE').ne.0) goto 200
      if (g92) then
         if (lstr(1:6).ne.' Cycle'.and.lstr(1:6).ne.' CYCLE')
     &   goto 120
         read(lstr,'(7x,i3)',err=400) jend2
         call search(lstr,' E=',istat)
         read(lstr,'(3x,f22.15)',end=400,err=400) convt
      else
         if (ilen.ne.4) goto 120
         read(lstr,'(1x,i3)',err=400) jend2
         call nxtlin(lstr,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 400
         read(lstr,'(6x,f22.15)',end=400,err=400) convt
      endif
      convg2(jend2) = convt
      if (jstrt2.eq.0) jstrt2 = jend2
      goto 120

200   continue
      if (.not.g03) then
         do j=jstrt2,jend2
            convg2(j) = convg2(j) + enuc
         end do
      endif

      return

300   icvav1 = 0
      icvav2 = 0
      return

400   icvav2 = 0
      return

      end

      subroutine readvv(v,norbs,nocc,local)
      implicit double precision (a-h,o-z), integer ( i-n)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*137 line
      logical conti,local,reo,gamnew
      common /orbhlp/ mxorb,iuhf,ispd
      dimension v(*)
      dimension vt(6,12),irord(6)

      irord(1) = 3
      irord(2) = 1
      irord(3) = 2
      irord(4) = 5
      irord(5) = 6
      irord(6) = 4

      reo = .false.
      conti = .true.
      gamnew = .true.
      nlin = 8
      if (local) nlin = 3
c==== is format high or low ? =========
      max   = 7
      lprnt = norbs

      call nxtlin(line,jstat)

      if (line(20:20).eq.'.') gamnew = .false.
      if (gamnew) then
         if (line(27:27).eq.' ') max = 10
      else
         if (line(25:25).eq.' ') max = 12
      endif
      if (max.ge.10.and..not.local) lprnt = min0(nocc+5,norbs)

      call bckfil
      imax = 0
c======================================

100   imin = imax + 1
      imax = imax + max
      if ( imax .ge. lprnt ) then
         imax  = lprnt
         conti =.false.
      endif

      istrt = 0
      itel = 0
      nvec = imax - imin + 1
      do j=1,norbs

           call nxtlin(line,jstat)
           if (jstat.eq.1.or.jstat.eq.2) goto 200

           if (max.ge.10) then
c=========== format low  =============
              if (gamnew) then
                 read(line,'(17x,10f9.4)',err=150)
     &            (v((i-1)*mxorb+j),i=imin,imax)
              else
                 read(line,'(15x,12f9.4)',err=150)
     &            (v((i-1)*mxorb+j),i=imin,imax)
              endif
           else
c=========== format high =============
              if (gamnew) then
                 read(line,'(17x,7f15.10)',err=150)
     &            (v((i-1)*mxorb+j),i=imin,imax)
              else
                 read(line,'(15x,7f15.10)',err=150)
     &            (v((i-1)*mxorb+j),i=imin,imax)
              endif
           endif
c
c Reorder the F functions, to fit the gaussian order
c
           if (istrt.eq.0.and.line(12:15).eq.' xxy') then
              reo =.true.
              istrt = j
              itel = 0
           endif
           if (istrt.ne.0) then
              itel = itel + 1
              do k=1,nvec
                 vt(itel,k) = v((imin+k-1-1)*mxorb+j)
              end do
           endif
           if (itel.eq.6) then
              do l=1,6
                 do k=1,nvec
                    v((imin+k-1-1)*mxorb+(istrt+l-1)) = vt(irord(l),k)
                 end do
              end do
              istrt = 0
              itel = 0
           endif
      end do

50    if (.not. conti) then
         if (reo) then
             print*,'========================================'
             print*,'     Changed order of F functions:'
             print*,' '
             print*,'     xxy,xxz,xyy,yyz,xzz,yzz ->'
             print*,' '
             print*,'     xyy,xxy,xxz,xzz,yzz,yyz'
             print*,'========================================'
         endif
         return
      endif

      do j=1,nlin
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200
      end do
      goto 100
150   conti = .false.
      goto 50

200   call inferr('Error while reading vectors',1)
      end

      subroutine qvdwd(ec,ev,nac,iac,nad,iad,iresid,coo,iconn,
     &                  q,iopt,ityp,fx,fy,fz,
     &                  cx,cy,cz,vdwe,vdwr,potq,potv,
     &                  eps,pre6,iag,ikl,ftmp)
      implicit real(a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxneib=200)
      parameter (mxion=2000)
cmpi      include 'mpif.h'
cmpi      integer chunk
cmpi      integer status(mpi_status_size)
      real q,coo
      integer taskid,offset
      common /mpih/ nproc,taskid
      common /athlp/  iatoms, mxnat
      integer ambcls
      parameter (mxamb=1590)
      real ambchg
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      real ambvdwr,ambvdwe
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /premr/ rs(mxcls,mxcls),es(mxcls,mxcls),iprem
      common /debug/ ideb
      real gfvdw
      parameter (mxgff=72)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      logical box, cell, fast, dompi, dovdw
      real abc,abc2,angles
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      integer*2 ityp
      dimension vr(3),ded(3)
      dimension coo(3,*),q(*)
      dimension cx(*),cy(*),cz(*),ityp(*),iconn(mxcon+1,*),
     &          iresid(*),nac(*),nad(*),iac(mxac,*),iad(mxad,*),
     &          fx(*),fy(*),fz(*),potq(*),potv(*),iopt(*),ftmp(*)
      dimension vdwe(*),vdwr(*),iag(*),ikl(*),eps(*),pre6(*),
     &          qbck(13*mxcon),vbck(13*mxcon),ibck(13*mxcon)

cmpi      call mpi_comm_rank(mpi_comm_world, taskid, ierr)


      if (iprem.ne.1) call prmulr

cmpi      dompi = .true.
      econv = 332.05382e0
      v14scq = 1.0e0 / 1.2e0
      v14scv = 0.5e0
      dzero = 0.0e0
      cutvdw = 7.86e0
      dovdw = .true.

      iats  = iatoms
      if (fast.and.box) iats  = natnow

      ec = dzero
      ev = dzero

      do i=1,iatoms
         cx(i) = real(coo(1,i))
         cy(i) = real(coo(2,i))
         cz(i) = real(coo(3,i))
         fx(i) = dzero
         fy(i) = dzero
         fz(i) = dzero

         potq(i) = econv*real(q(i))
         potv(i) = 1.0e0
c         if (iopt(i).eq.1) then
c            potq(i) = econv*real(q(i))
c            potv(i) = 1.0e0
c         else
c            potq(i) = dzero
c            potv(i) = dzero
c         endif

         i1 = int(ityp(i))
         iag(i) = i1
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr(i) = real(ambvdwr(il))
            vdwe(i) = real(ambvdwe(il))
            ikl(i) = il
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr(i) = real(gfvdw(1,i1))
            vdwe(i) = real(gfvdw(2,i1))
         endif

      end do

      do i=1,iats

         nbck = 0
         vdwr1 = vdwr(i)
         vdwe1 = vdwe(i)
         i1 = iag(i)
         il = ikl(i)
         qi = real(q(i))

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               nbck = nbck + 1
               ibck(nbck) = jj
               qbck(nbck) = potq(jj)
               vbck(nbck) = potv(jj)
               potq(jj) = dzero
               potv(jj) = dzero
            endif
         end do

         do j=1,nac(i)
            jj = iac(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = dzero
            potv(jj) = dzero
         end do

         do j=1,nad(i)
            jj = iad(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = potq(jj)*v14scq
            potv(jj) = potv(jj)*v14scv
         end do

         dovdw = (vdwe1.ne.0.0e0)

         if (dovdw) then

            do k=i+1,iatoms

               vdwe2 = vdwe(k)

               if (vdwe2.ne.dzero) then
   
                  vdwr2 = vdwr(k)
                  i2 = iag(k)
                  kl = ikl(k)

                  if (i1.gt.0.and.i2.gt.0) then
                     pre6(k)  = rs(il,kl)
                     eps(k)   = es(il,kl)
                  else
                     rsum     = vdwr1 + vdwr2
                     rsum3    = rsum*rsum*rsum
                     eps(k)   = sqrt(vdwe1 * vdwe2)
                     pre6(k)  = rsum3*rsum3
                  endif

               else
                  pre6(k)  = 0.0e0
                  eps(k)   = 0.0e0
               endif

            end do
         endif

cmpi         chunk = ((iatoms-i)/nproc)
cmpi         ichkh = chunk/4
cmpi         chunk = ichkh*4
cmpi         if (chunk.lt.8) dompi = .false.
cmpi
cmpi         if (dompi) then
cmpi            if (taskid.eq.0) then
cmpi
cmpi
cmpi               offset = chunk + i + 1
cmpi
cmpi               do it=1, nproc - 1
cmpi                  call mpi_send(offset, 1, mpi_integer, it, 5,
cmpi     &              mpi_comm_world, ierr)
cmpi                  offset = offset + chunk
cmpi               end do
cmpi
cmpi               offset = i + 1
cmpi
cmpi            else
cmpi               call mpi_recv(offset, 1, mpi_integer, 0, 5,
cmpi     &            mpi_comm_world, status, ierr)
cmpi            endif
cmpi
cmpi            iend = offset + chunk - 1
cmpi            if (taskid.eq.nproc-1) iend = iatoms
cmpi
cmpi         else
cmpi
cmpi            if (taskid.eq.0) then
               offset = i + 1
               iend = iatoms
cmpi            else
cmpi               offset = 1
cmpi               iend = 0
cmpi            endif
cmpi
cmpi         endif


         evt = 0.0e0

         do k=offset,iend

               vr(1) = cx(i) - cx(k)
               vr(2) = cy(i) - cy(k)
               vr(3) = cz(i) - cz(k)

               if (box) call rddisr(vr)

               r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

               r = sqrt(r2)

               rinv = 1.0e0 / r
               r2inv = rinv*rinv

               e = qi * potq(k) * rinv

               de = -e * r2inv

               do j=1,3
                  ded(j) = de * vr(j)
               end do

               ec = ec + e

               epsm = eps(k)

               if (dovdw.and.epsm.ne.dzero.and.r.lt.cutvdw) then

                  r6inv = r2inv*r2inv*r2inv
                  p6 = pre6(k) * r6inv

                  epsm = epsm * potv(k)
                  p12  = p6 * p6

                  e    = epsm * (p12 - 2.0e0*p6)
                  de   = epsm * (p12 - p6) * (-12.0e0)

                  de   = de * r2inv

                  do j=1,3
                     ded(j) = ded(j) + de * vr(j)
                  end do

c                  ev   = ev + e
                  evt   = evt + e

               endif

               fx(i) = fx(i) + ded(1)
               fy(i) = fy(i) + ded(2)
               fz(i) = fz(i) + ded(3)

               fx(k) = fx(k) - ded(1)
               fy(k) = fy(k) - ded(2)
               fz(k) = fz(k) - ded(3)

         end do

         ev = ev + evt

         do k=1,nbck
            jj = ibck(k)
            potq(jj) = qbck(k)
            potv(jj) = vbck(k)
         end do


c         call mpi_barrier(mpi_comm_world, ierr)

      end do

cmpi      if (taskid.eq.0) then
cmpi
cmpi         do it=1, nproc - 1
cmpi            itmp = it
cmpi
cmpi            call mpi_recv(ftmp(1), iatoms, mpi_real,
cmpi     &        itmp, 3, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               fx(k) = fx(k) + ftmp(k)
cmpi            end do
cmpi
cmpi            call mpi_recv(ftmp(1), iatoms, mpi_real,
cmpi     &        itmp, 4, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               fy(k) = fy(k) + ftmp(k)
cmpi            end do
cmpi
cmpi            call mpi_recv(ftmp(1), iatoms, mpi_real,
cmpi     &        itmp, 5, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               fz(k) = fz(k) + ftmp(k)
cmpi            end do
cmpi
cmpi         end do
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum, 0,
cmpi     &                mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum, 0,
cmpi     &                mpi_comm_world, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(ectmp, 1, mpi_real, it, 6,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(evtmp, 1, mpi_real, it, 7,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(fx(1), iatoms, mpi_real, it, 8,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(fy(1), iatoms, mpi_real, it, 9,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(fz(1), iatoms, mpi_real, it, 10,
cmpi     &              mpi_comm_world, ierr)
cmpi         end do
cmpi
cmpi      else
cmpi
cmpi         call mpi_send(fx(1), iatoms, mpi_real, 0, 3,
cmpi     &              mpi_comm_world, ierr)
cmpi         call mpi_send(fy(1), iatoms, mpi_real, 0, 4,
cmpi     &              mpi_comm_world, ierr)
cmpi         call mpi_send(fz(1), iatoms, mpi_real, 0, 5,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum, 0,
cmpi     &              mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum, 0,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_recv(ectmp, 1, mpi_real, 0, 6,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(evtmp, 1, mpi_real, 0, 7,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(fx(1), iatoms, mpi_real, 0, 8,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(fy(1), iatoms, mpi_real, 0, 9,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(fz(1), iatoms, mpi_real, 0, 10,
cmpi     &              mpi_comm_world, status, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi      endif

      return
      end

      subroutine qvdwdd(ec,ev,ftmp,nac,iac,nad,iad,iresid,coo,iconn,
     &                  q,iopt,ityp,
     &                  vdwe,vdwr,potq,potv,
     &                  eps,pre6,iag,ikl,fftmp)
      implicit real(a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxneib=200)
      parameter (mxion=2000)
cmpi      include 'mpif.h'
cmpi      integer chunk
cmpi      integer status(mpi_status_size)
      integer taskid,offset
      common /mpih/ nproc,taskid
      common /athlp/  iatoms, mxnat
      integer ambcls
      parameter (mxamb=1590)
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /prem/ rs(mxcls,mxcls),es(mxcls,mxcls),iprem
      parameter (mxgff=72)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      logical box, cell, fast, dompi, dovdw
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      integer*2 ityp
      dimension vr(3),ded(3)
      dimension coo(3,*),q(*)
      dimension ityp(*),iconn(mxcon+1,*),
     &          iresid(*),nac(*),nad(*),iac(mxac,*),iad(mxad,*),
     &          potq(*),potv(*),iopt(*),ftmp(3,*),fftmp(3,*)
      dimension vdwe(*),vdwr(*),iag(*),ikl(*),eps(*),pre6(*),
     &          qbck(13*mxcon),vbck(13*mxcon),ibck(13*mxcon)

cmpi      call mpi_comm_rank(mpi_comm_world, taskid, ierr)


      if (iprem.ne.1) call premul

      dompi = .true.
      econv = 332.05382e0
      v14scq = 1.0e0 / 1.2e0
      v14scv = 0.5e0
      dzero = 0.0e0
      cutvdw = 7.86e0
      dovdw = .true.

      ec = 0.0e0
      ev = 0.0e0

      iat3 = iatoms*3

      iats  = iatoms
      if (fast.and.box) iats  = natnow

      do i=1,iatoms

         do j=1,3
            ftmp(j,i) = dzero
         end do

         potq(i) = econv*q(i)
         potv(i) = 1.0e0
c         if (iopt(i).eq.1) then
c            potq(i) = econv*q(i)
c            potv(i) = 1.0e0
c         else
c            potq(i) = dzero
c            potv(i) = dzero
c         endif

         i1 = int(ityp(i))
         iag(i) = i1
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr(i) = ambvdwr(il)
            vdwe(i) = ambvdwe(il)
            ikl(i) = il
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr(i) = gfvdw(1,i1)
            vdwe(i) = gfvdw(2,i1)
         endif

      end do

      do i=1,iats

         nbck = 0
         vdwr1 = vdwr(i)
         vdwe1 = vdwe(i)
         i1 = iag(i)
         il = ikl(i)
         qi = q(i)

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               nbck = nbck + 1
               ibck(nbck) = jj
               qbck(nbck) = potq(jj)
               vbck(nbck) = potv(jj)
               potq(jj) = dzero
               potv(jj) = dzero
            endif
         end do

         do j=1,nac(i)
            jj = iac(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = dzero
            potv(jj) = dzero
         end do

         do j=1,nad(i)
            jj = iad(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = potq(jj)*v14scq
            potv(jj) = potv(jj)*v14scv
         end do

         dovdw = (vdwe1.ne.0.0e0)

         if (dovdw) then

            do k=i+1,iatoms

               vdwe2 = vdwe(k)

               if (vdwe2.ne.dzero) then
   
                  vdwr2 = vdwr(k)
                  i2 = iag(k)
                  kl = ikl(k)

                  if (i1.gt.0.and.i2.gt.0) then
                     pre6(k)  = rs(il,kl)
                     eps(k)   = es(il,kl)
                  else
                     rsum     = vdwr1 + vdwr2
                     rsum3    = rsum*rsum*rsum
                     eps(k)   = sqrt(vdwe1 * vdwe2)
                     pre6(k)  = rsum3*rsum3
                  endif

               else

                  pre6(k)  = dzero
                  eps(k)   = dzero

               endif
            end do
         endif

cmpi         chunk = ((iatoms-i)/nproc)
cmpi         ichkh = chunk/4
cmpi         chunk = ichkh*4
cmpi         if (chunk.lt.8) dompi = .false.
cmpi
cmpi         if (dompi) then
cmpi            if (taskid.eq.0) then
cmpi
cmpi
cmpi               offset = chunk + i + 1
cmpi
cmpi               do it=1, nproc - 1
cmpi                  call mpi_send(offset, 1, mpi_integer, it, 5,
cmpi     &              mpi_comm_world, ierr)
cmpi                  offset = offset + chunk
cmpi               end do
cmpi
cmpi               offset = i + 1
cmpi
cmpi            else
cmpi               call mpi_recv(offset, 1, mpi_integer, 0, 5,
cmpi     &            mpi_comm_world, status, ierr)
cmpi            endif
cmpi
cmpi            iend = offset + chunk - 1
cmpi            if (taskid.eq.nproc-1) iend = iatoms
cmpi
cmpi         else
cmpi
cmpi            if (taskid.eq.0) then
               offset = i + 1
               iend = iatoms
cmpi            else
cmpi               offset = 1
cmpi               iend = 0
cmpi            endif
cmpi
cmpi         endif


         do k=offset,iend

               do j=1,3
                  vr(j) = coo(j,i) - coo(j,k)
               end do

               if (box) call reddis(vr)

               r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

               r = sqrt(r2)

               rinv = 1.0e0 / r
               r2inv = rinv*rinv

               e = qi * potq(k) * rinv

               de = -e * r2inv

               do j=1,3
                  ded(j) = de * vr(j)
               end do

               ec = ec + e

               epsm = eps(k)

               if (dovdw.and.epsm.ne.dzero.and.r.lt.cutvdw) then

                  r6inv = r2inv*r2inv*r2inv
                  p6 = pre6(k) * r6inv

                  epsm = epsm * potv(k)
                  p12  = p6 * p6

                  e    = epsm * (p12 - 2.0e0*p6)
                  de   = epsm * (p12 - p6) * (-12.0e0)

                  de   = de * r2inv

                  do j=1,3
                     ded(j) = ded(j) + de * vr(j)
                  end do

                  ev   = ev + e

               endif

               do j=1,3
                  ftmp(j,i) = ftmp(j,i) + ded(j)
                  ftmp(j,k) = ftmp(j,k) - ded(j)
               end do

         end do

         do k=1,nbck
            jj = ibck(k)
            potq(jj) = qbck(k)
            potv(jj) = vbck(k)
         end do

      end do

cmpi      if (taskid.eq.0) then
cmpi
cmpi         do it=1, nproc - 1
cmpi            itmp = it
cmpi
cmpi            call mpi_recv(fftmp(1,1), iat3, mpi_real,
cmpi     &        itmp, 3, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               do j=1,3
cmpi                  ftmp(j,k) = ftmp(j,k) + fftmp(j,k)
cmpi               end do
cmpi            end do
cmpi
cmpi         end do
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(ectmp, 1, mpi_real, it, 6,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(evtmp, 1, mpi_real, it, 7,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(ftmp(1,1), iat3, 
cmpi     &              mpi_real, it, 8,mpi_comm_world, ierr)
cmpi         end do
cmpi
cmpi      else
cmpi
cmpi         call mpi_send(ftmp(1,1), iat3, mpi_real, 0, 3,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &              0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum, 
cmpi     &              0, mpi_comm_world, ierr)
cmpi
cmpi         call mpi_recv(ectmp, 1, mpi_real, 0, 6,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(evtmp, 1, mpi_real, 0, 7,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(ftmp(1,1), iat3, mpi_real, 
cmpi     &              0, 8, mpi_comm_world, status, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi      endif

      return
      end

      subroutine qvd(ec,ev,nac,iac,nad,iad,iresid,coo,iconn,
     &                  q,forces,cellder,iopt,ityp,
     &                  vdwe,vdwr,potq,potv,
     &                  eps,pre6,iag,ikl,ftmp,fftmp,frac,exyz)
      implicit real(a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxneib=200)
cmpi      include 'mpif.h'
cmpi      integer chunk
cmpi      integer status(mpi_status_size)
      integer taskid,offset
      common /mpih/ nproc,taskid
      common /athlp/  iatoms, mxnat
      integer ambcls
      parameter (mxamb=1590)
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /prem/ rs(mxcls,mxcls),es(mxcls,mxcls),iprem
      parameter (mxgff=72)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      logical box, cell, fast, dompi, lcon
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /expnd/ addfr(3,125),ie(5),izero
      logical oje(125)
      integer*2 ityp
      dimension vr(3),ded(3),cellder(*),cxyz(3,125),lex(125)
      dimension coo(3,*),forces(3,*),q(*),frac(3,*),exyz(3,125,*)
      dimension ityp(*),iconn(mxcon+1,*),
     &          iresid(*),nac(*),nad(*),iac(mxac,*),iad(mxad,*),
     &          potq(*),potv(*),iopt(*),ftmp(3,*),fftmp(3,*),
     &          cder(6)
      dimension vdwe(*),vdwr(*),iag(*),ikl(*),eps(*),pre6(*),
     &          qbck(13*mxcon),vbck(13*mxcon),ibck(13*mxcon)

c difference with other routines: second loop runs from 1,iatoms
c instead of i,iatoms
c
c Secondly, routine could be faster if we go back to i,iatoms
c           then we have to correctly incoporate the second
c           expansion
c
cmpi      call mpi_comm_rank(mpi_comm_world, taskid, ierr)


      nexpnd = 124

cmpi      dompi = .true.
cmpi      chunk = iatoms/nproc
cmpi      if (chunk.lt.5) dompi = .false.

      if (iprem.ne.1) call premul

      call setfrac(coo,frac,exyz)

      do i=1,6
         cellder(i) = 0.0e0
      end do



      econv = 332.05382e0
      v14scq = 1.0e0 / 1.2e0
      v14scv = 0.5e0

      ec = 0.0e0
      ev = 0.0e0
      iat3 = iatoms*3

      do i=1,iatoms

         do j=1,3
            ftmp(j,i) = 0.0e0
         end do

         potq(i) = econv*q(i)
         potv(i) = 1.0e0
c         if (iopt(i).eq.1) then
c            potq(i) = econv*q(i)
c            potv(i) = 1.0e0
c         else
c            potq(i) = 0.0e0
c            potv(i) = 0.0e0
c         endif

         i1 = int(ityp(i))
         iag(i) = i1
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr(i) = ambvdwr(il)
            vdwe(i) = ambvdwe(il)
            ikl(i) = il
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr(i) = gfvdw(1,i1)
            vdwe(i) = gfvdw(2,i1)
         endif

      end do

      do i=1,iatoms

         nbck = 0
         vdwr1 = vdwr(i)
         vdwe1 = vdwe(i)
         i1 = iag(i)
         il = ikl(i)
         qi = q(i)

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               nbck = nbck + 1
               ibck(nbck) = jj
               qbck(nbck) = potq(jj)
               vbck(nbck) = potv(jj)
               potq(jj) = 0.0e0
               potv(jj) = 0.0e0
            endif
         end do

         do j=1,nac(i)
            jj = iac(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = 0.0e0
            potv(jj) = 0.0e0
         end do

         do j=1,nad(i)
            jj = iad(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = potq(jj)*v14scq
            potv(jj) = potv(jj)*v14scv
         end do

         do k=1,iatoms

            if (vdwe1.ne.0.0e0) then
               vdwe2 = vdwe(k)

               if (vdwe2.ne.0.0e0) then
   
                  vdwr2 = vdwr(k)
                  i2 = iag(k)
                  kl = ikl(k)

                  if (i1.gt.0.and.i2.gt.0) then
                     pre6(k)  = rs(il,kl)
                     eps(k)   = es(il,kl)
                  else
                     rsum     = vdwr1 + vdwr2
                     rsum3    = rsum*rsum*rsum
                     eps(k)   = sqrt(vdwe1 * vdwe2)
                     pre6(k)  = rsum3*rsum3
                  endif

               else

                  pre6(k)  = 0.0e0
                  eps(k)   = 0.0e0

               endif
            else
               pre6(k)  = 0.0e0
               eps(k)   = 0.0e0
            endif
         end do

cmpi         if (dompi) then
cmpi            ibeg = chunk*taskid + 1
cmpi            iend = chunk*(taskid+1)
cmpi            if (iend.gt.iatoms) iend = iatoms
cmpi         else
            ibeg = 1
            iend = iatoms
cmpi         endif

         do k=ibeg,iend

               epsm = eps(k)*potv(k)
               ptq  = qi*potq(k)
               pr6  = pre6(k)

               ist = 1
               if (i.eq.k) then
                  call expfr(i,cxyz,exyz,lex,nexpnd,oje)
                  lst = nexpnd
               else
                  call xpfr(i,k,cxyz,exyz,lex,nexpnd,oje)
                  lst = 1 + nexpnd
               endif

               do l=ist,lst

                  fct = 0.5e0

                  r2 = cxyz(1,l)*cxyz(1,l) + 
     &                 cxyz(2,l)*cxyz(2,l) + 
     &                 cxyz(3,l)*cxyz(3,l)

                  r = sqrt(r2)

                  if (oje(l).and.i.ne.k) then
                     e = ptq / r
                  else
                     e = econv*q(i)*q(k) / r
                  endif

                  de = -e / r2

                  call adcldr(cellder,cxyz(1,l),de,fct,lex(l))

                  do j=1,3
                     ded(j) = de * fct * cxyz(j,l)
                  end do

                  ec = ec + fct*e

                  p6 = pr6 / (r2*r2*r2)

                  p12  = p6 * p6

                
                  if (oje(l).and.i.ne.k) then
                     epsm = eps(k)*potv(k)
                  else
                     epsm = eps(k)
                  endif

                  e    = epsm * (p12 - 2.0e0*p6)
                  de   = epsm * (p12 - p6) * (-12.0e0)

                  de   = de / r2

                  do j=1,3
                     ded(j) = ded(j) + de * fct * cxyz(j,l)
                  end do


                  ev = ev + fct*e

                  do j=1,3
                     ftmp(j,i) = ftmp(j,i) + ded(j)
                     ftmp(j,k) = ftmp(j,k) - ded(j)
                  end do

                  call adcldr(cellder,cxyz(1,l),de,fct,lex(l))

               end do

         end do

         do k=1,nbck
            jj = ibck(k)
            potq(jj) = qbck(k)
            potv(jj) = vbck(k)
         end do

      end do

cmpi      if (taskid.eq.0) then
cmpi
cmpi         do it=1, nproc - 1
cmpi            itmp = it
cmpi
cmpi            call mpi_recv(fftmp, iat3, mpi_real,
cmpi     &        itmp, 3, mpi_comm_world, status, ierr)
cmpi
cmpi            do i=1,iatoms
cmpi               do j=1,3
cmpi                  ftmp(j,i) = ftmp(j,i) + fftmp(j,i)
cmpi               end do
cmpi            end do
cmpi
cmpi            call mpi_recv(cder, 6, mpi_real,
cmpi     &        itmp, 5, mpi_comm_world, status, ierr)
cmpi
cmpi            do j=1,6
cmpi               cellder(j) = cellder(j) + cder(j)
cmpi            end do
cmpi
cmpi         end do
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(ectmp, 1, mpi_real, it, 6,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(evtmp, 1, mpi_real, it, 7,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(ftmp, iat3, 
cmpi     &              mpi_real, it, 8,mpi_comm_world, ierr)
cmpi            call mpi_send(cellder, 6, 
cmpi     &              mpi_real, it, 10,mpi_comm_world, ierr)
cmpi         end do
cmpi
cmpi      else
cmpi
cmpi         call mpi_send(ftmp, iat3, mpi_real, 0, 3,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_send(cellder, 6, mpi_real, 0, 5,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &              0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum, 
cmpi     &              0, mpi_comm_world, ierr)
cmpi
cmpi         call mpi_recv(ectmp, 1, mpi_real, 0, 6,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(evtmp, 1, mpi_real, 0, 7,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(ftmp, iat3, mpi_real, 
cmpi     &              0, 8, mpi_comm_world, status, ierr)
cmpi         call mpi_recv(cellder, 6, mpi_real, 
cmpi     &              0, 10, mpi_comm_world, status, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi      endif

      do i=1,iatoms
         do j=1,3
            forces(j,i) = forces(j,i) + ftmp(j,i)
         end do
      end do

c      call prcldr(cellder,coo)

      return
      end

      subroutine qenvdd(ec,ev,nac,iac,nad,iad,iresid,
     &                  coo,iconn,q,forces,iopt,
     &                  nlst,lst,ityp,
     &                  idoq,idov,vdwe,vdwr,potq,potv,
     &                  eps,pre6,iag,ikl,ftmp,fftmp)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxneib=200)
      parameter (mxion=2000)
cmpi      include 'mpif.h'
cmpi      integer chunk
cmpi      integer status(mpi_status_size)
      integer taskid,offset
      common /mpih/ nproc,taskid
      common /athlp/  iatoms, mxnat
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      integer ambcls
      parameter (mxamb=1590)
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /prem/ rs(mxcls,mxcls),es(mxcls,mxcls),iprem
      parameter (mxgff=72)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      logical box,cell,fast,resinc,doit,dompi
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      integer*2 ityp
      dimension vr(3),ded(3)
      dimension coo(3,*),q(*),ityp(*),iconn(mxcon+1,*),iresid(*),
     &          nac(*),nad(*),iac(mxac,*),iad(mxad,*),
     &          forces(3,*),iopt(*),nlst(*),lst(*)
      dimension vdwe(*),vdwr(*),potq(*),potv(*),eps(*),pre6(*),
     &          iag(*),ikl(*),idoq(*),idov(*),ftmp(3,*),fftmp(3,*),
     &          qbck(13*mxcon),vbck(13*mxcon),ibck(13*mxcon)

cmpi      call mpi_comm_rank(mpi_comm_world, taskid, ierr)

      if (iprem.ne.1) call premul

      dompi = .true.
      econv = 332.05382e0
      v14scq = 1.0e0 / 1.2e0
      v14scv = 0.5e0

      ec = 0.0e0
      ev = 0.0e0
      iat3 = iatoms*3
      iats  = iatoms
      if (fast.and.box) iats  = natnow

      do i=1,iatoms

         do j=1,3
            ftmp(j,i) = 0.0e0
         end do

         potq(i) = econv*q(i)
         potv(i) = 1.0e0
c         if (iopt(i).eq.1) then
c            potq(i) = econv*q(i)
c            potv(i) = 1.0e0
c         else
c            potq(i) = 0.0e0
c            potv(i) = 0.0e0
c         endif

         i1 = int(ityp(i))
         iag(i) = i1
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr(i) = ambvdwr(il)
            vdwe(i) = ambvdwe(il)
            ikl(i) = il
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr(i) = gfvdw(1,i1)
            vdwe(i) = gfvdw(2,i1)
         endif

      end do

      do i=1,iats

         nbck = 0
         vdwr1 = vdwr(i)
         vdwe1 = vdwe(i)
         i1 = iag(i)
         il = ikl(i)
         qi = q(i)

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               nbck = nbck + 1
               ibck(nbck) = jj
               qbck(nbck) = potq(jj)
               vbck(nbck) = potv(jj)
               potq(jj) = 0.0e0
               potv(jj) = 0.0e0
            endif
         end do

         do j=1,nac(i)
            jj = iac(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = 0.0e0
            potv(jj) = 0.0e0
         end do

         do j=1,nad(i)
            jj = iad(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = potq(jj)*v14scq
            potv(jj) = potv(jj)*v14scv
         end do

         do k=i+1,iatoms

            idoq(k) = 0
            idov(k) = 0

            if (iopt(i).eq.1.or.iopt(k).eq.1) then
               idoq(k) = 1
               idov(k) = 1
            endif

            if (vdwe1.ne.0.0e0) then
               vdwe2 = vdwe(k)

               if (vdwe2.ne.0.0e0) then
   
                  vdwr2 = vdwr(k)
                  i2 = iag(k)
                  kl = ikl(k)

                  if (i1.gt.0.and.i2.gt.0) then
                     pre6(k)  = rs(il,kl)
                     eps(k)   = es(il,kl)
                  else
                     rsum     = vdwr1 + vdwr2
                     rsum3    = rsum*rsum*rsum
                     eps(k)   = sqrt(vdwe1 * vdwe2)
                     pre6(k)  = rsum3*rsum3
                  endif

               else

                  idov(k) = 0

               endif
            else
               idov(k) = 0
            endif

            if (.not.resinc(i,nlst(i),lst,iresid(k))) then
               idoq(k) = 0
               idov(k) = 0
            endif

         end do

cmpi         chunk = ((iatoms-i)/nproc)
cmpi         ichkh = chunk/4
cmpi         chunk = ichkh*4
cmpi         if (chunk.lt.8) dompi = .false.
cmpi
cmpi         if (dompi) then
cmpi            if (taskid.eq.0) then
cmpi
cmpi
cmpi               offset = chunk + i + 1
cmpi
cmpi               do it=1, nproc - 1
cmpi                  call mpi_send(offset, 1, mpi_integer, it, 5,
cmpi     &              mpi_comm_world, ierr)
cmpi                  offset = offset + chunk
cmpi               end do
cmpi
cmpi               offset = i + 1
cmpi
cmpi            else
cmpi               call mpi_recv(offset, 1, mpi_integer, 0, 5,
cmpi     &            mpi_comm_world, status, ierr)
cmpi            endif
cmpi
cmpi            iend = offset + chunk - 1
cmpi            if (taskid.eq.nproc-1) iend = iatoms
cmpi
cmpi         else
cmpi
cmpi            if (taskid.eq.0) then
               offset = i + 1
               iend = iatoms
cmpi            else
cmpi               offset = 1
cmpi               iend = 0
cmpi            endif
cmpi
cmpi         endif

         do k=offset,iend

           do j=1,3
              ded(j) = 0.0e0
           end do

           if (idoq(k).eq.1.or.idov(k).eq.1) then
               do j=1,3
                  vr(j) = coo(j,i) - coo(j,k)
               end do
               r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)
               if (box) call reddis(vr)
               r = sqrt(r2)
           endif

           if (idoq(k).eq.1) then


               if (r2.le.cutof2) then


                  e = qi * potq(k) / r

c since we do: de = de / r, and de*vr(j), we might aswell
c put 1/r in the dw

                  call swchg(r2,s,ds)

                  de = e*(ds - s)
                  e = e * s * r2

                  do j=1,3
                     ded(j) = de * vr(j)
                  end do

                  ec = ec + e

              endif

           end if

           if (idov(k).eq.1) then


               p6 = pre6(k) / (r2*r2*r2)
               epsm = eps(k)
               epsm = epsm * potv(k)


               p12  = p6 * p6

               e    = epsm * (p12 - 2.0e0*p6)
               de   = epsm * (p12 - p6) * (-12.0e0/r)

               if (r2.gt.cuton2) then
                  sw = swvdw(r2)
                  dsw = swdvdw(r2)
                  desw = de*sw
                  edsw = e*dsw
                  de = e*dsw + de*sw
                  e = e * sw
               endif

               de   = de / r

               do j=1,3
                  ded(j) = ded(j) + de * vr(j)
               end do

               ev   = ev + e
   
           end if

           do j=1,3
              ftmp(j,i) = ftmp(j,i) + ded(j)
              ftmp(j,k) = ftmp(j,k) - ded(j)
           end do

         end do

         do k=1,nbck
            jj = ibck(k)
            potq(jj) = qbck(k)
            potv(jj) = vbck(k)
         end do

      end do

cmpi      if (taskid.eq.0) then
cmpi
cmpi         do it=1, nproc - 1
cmpi            itmp = it
cmpi
cmpi            call mpi_recv(fftmp(1,1), iat3, mpi_real,
cmpi     &        itmp, 3, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               do j=1,3
cmpi                  ftmp(j,k) = ftmp(j,k) + fftmp(j,k)
cmpi               end do
cmpi            end do
cmpi
cmpi         end do
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(ectmp, 1, mpi_real, it, 6,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(evtmp, 1, mpi_real, it, 7,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(ftmp(1,1), iat3, 
cmpi     &              mpi_real, it, 8,mpi_comm_world, ierr)
cmpi         end do
cmpi
cmpi      else
cmpi
cmpi         call mpi_send(ftmp(1,1), iat3, mpi_real, 0, 3,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &              0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum, 
cmpi     &              0, mpi_comm_world, ierr)
cmpi
cmpi         call mpi_recv(ectmp, 1, mpi_real, 0, 6,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(evtmp, 1, mpi_real, 0, 7,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(ftmp(1,1), iat3, mpi_real, 
cmpi     &              0, 8, mpi_comm_world, status, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi      endif

      do i=1,iatoms
         do j=1,3
            forces(j,i) = forces(j,i) + ftmp(j,i)
         end do
      end do

      return
      end

      subroutine qvnod(ec,ev,nac,iac,nad,iad,iresid,
     &                  coo,iconn,q,forces,iopt,ityp,iwtpr,
     &                  vdwe,vdwr,potq,potv,
     &                  eps,pre6,iag,ikl,ftmp,fftmp)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxneib=200)
      parameter (mxion=2000)
cmpi      include 'mpif.h'
cmpi      integer chunk
cmpi      integer status(mpi_status_size)
      integer taskid,offset
      common /mpih/ nproc,taskid
      common /athlp/  iatoms, mxnat
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      integer ambcls
      parameter (mxamb=1590)
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /prem/ rs(mxcls,mxcls),es(mxcls,mxcls),iprem
      parameter (mxgff=72)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      logical box,cell,fast,resinc,doit,dompi
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      logical opt
      integer*2 ityp
      dimension vr(3),ded(3)
      dimension coo(3,*),q(*),ityp(*),iconn(mxcon+1,*),iresid(*),
     &          nac(*),nad(*),iac(mxac,*),iad(mxad,*),
     &          forces(3,*),iopt(*),iwtpr(*)
      dimension vdwe(*),vdwr(*),potq(*),potv(*),eps(*),pre6(*),
     &          iag(*),ikl(*),ftmp(3,*),fftmp(3,*),
     &          qbck(13*mxcon),vbck(13*mxcon),ibck(13*mxcon)

cmpi      call mpi_comm_rank(mpi_comm_world, taskid, ierr)

      if (iprem.ne.1) call premul

      dompi = .true.
      econv = 332.05382e0
      v14scq = 1.0e0 / 1.2e0
      v14scv = 0.5e0
      pi     = 4.d0*datan(1.d0)
      spi    = sqrt(pi)
      alfa   = 0.3e0
      alfa2  = alfa*alfa
      rc     = 9.0e0
      rc2    = rc*rc
      erfrc  = erfc(alfa*rc) / rc

c     max afstand rc = 9.0, alfa = 0.2:  max alfa*r = 1.8
c     approx array 1,8 miljoen ( 1.8 * 1.000000).
c     max -alfa**2*rc**2 = -3.24, approx exp array  3240000

c     max afstand rc = 9.0, alfa = 0.3:  max alfa*r = 2.7
c     approx array 2,7 miljoen ( 2.7 * 1.000000).
c     max -alfa**2*rc**2 = -7.29, approx exp array  7290000


c     max afstand rc = 15.0, alfa = 0.2:  max alfa*r = 3.0
c     approx array 3 miljoen ( 3 * 1.000000).
c
c     max -alfa**2*rc**2 = -9.0, approx exp array 9 miljoen
c     

      erfrc2 = (erfrc  + 
     &         2.0e0*alfa*exp(-1.0e0*alfa2*rc2)/spi)/rc

      ec = 0.0e0
      ev = 0.0e0
      iat3 = iatoms*3

      iats  = iatoms
      if (fast.and.box) iats  = natnow


      do i=1,iatoms

         do j=1,3
            ftmp(j,i) = 0.0e0
         end do

         potq(i) = econv*q(i)
         potv(i) = 1.0e0

c         if (iopt(i).eq.1) then
c            potq(i) = econv*q(i)
c            potv(i) = 1.0e0
c         else
c            potq(i) = 0.0e0
c            potv(i) = 0.0e0
c         endif

         i1 = int(ityp(i))
         iag(i) = i1
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr(i) = ambvdwr(il)
            vdwe(i) = ambvdwe(il)
            ikl(i) = il
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr(i) = gfvdw(1,i1)
            vdwe(i) = gfvdw(2,i1)
         endif

      end do

      do i=1,iats

         nbck = 0
         vdwr1 = vdwr(i)
         vdwe1 = vdwe(i)
         i1 = iag(i)
         il = ikl(i)
         qi = q(i)

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               nbck = nbck + 1
               ibck(nbck) = jj
               qbck(nbck) = potq(jj)
               vbck(nbck) = potv(jj)
               potq(jj) = 0.0e0
               potv(jj) = 0.0e0
            endif
         end do

         do j=1,nac(i)
            jj = iac(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = 0.0e0
            potv(jj) = 0.0e0
         end do

         do j=1,nad(i)
            jj = iad(j,i)
            nbck = nbck + 1
            ibck(nbck) = jj
            qbck(nbck) = potq(jj)
            vbck(nbck) = potv(jj)
            potq(jj) = potq(jj)*v14scq
            potv(jj) = potv(jj)*v14scv
         end do

cmpi         chunk = ((iats-i)/nproc)
cmpi         ichkh = chunk/4
cmpi         chunk = ichkh*4
cmpi         if (chunk.lt.8) dompi = .false.
cmpi
cmpi         if (dompi) then
cmpi            if (taskid.eq.0) then
cmpi
cmpi
cmpi               offset = chunk + i + 1
cmpi
cmpi               do it=1, nproc - 1
cmpi                  call mpi_send(offset, 1, mpi_integer, it, 5,
cmpi     &              mpi_comm_world, ierr)
cmpi                  offset = offset + chunk
cmpi               end do
cmpi
cmpi               offset = i + 1
cmpi
cmpi            else
cmpi               call mpi_recv(offset, 1, mpi_integer, 0, 5,
cmpi     &            mpi_comm_world, status, ierr)
cmpi            endif
cmpi
cmpi            iend = offset + chunk - 1
cmpi            if (taskid.eq.nproc-1) iend = iats
cmpi
cmpi         else
cmpi
cmpi            if (taskid.eq.0) then
               offset = i + 1
               iend = iats
cmpi            else
cmpi               offset = 1
cmpi               iend = 0
cmpi            endif
cmpi
cmpi         endif

         do k=offset,iend

           do j=1,3
              ded(j) = 0.0e0
           end do

           do j=1,3
              vr(j) = coo(j,i) - coo(j,k)
           end do
           if (box) call reddis(vr)
           r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)
           r = sqrt(r2)

           if (r2.le.rc2) then

               rinv = 1.0e0/r
               rinv2 = rinv*rinv
               opt = (iopt(i).eq.1.or.iopt(k).eq.1)


               if (opt) then

                  call apperfc(alfa*r,alerfc,alexp)
c                  alexp1 = 2.0e0*alfa*exp(-1.0e0*alfa2*r2)/spi


                  e = qi * potq(k) * 
     &                     (alerfc*rinv - erfrc + erfrc2*(r-rc))

c                  etmp =  qi *potq(k) * rinv

c                  print*,i,' ',k,' eqc=',e,' etmp=',etmp,
c     &                   alerfc,erfrc,erfrc2*(r-rc),' r-rc=',r-rc

                  de = qi * potq(k) * 
     &                     (alerfc*rinv2 + alexp*rinv - erfrc2)*rinv

                  do j=1,3
                     ded(j) = -de * vr(j)
                  end do

                  ec = ec + e

               endif


               if (opt.and.vdwe1.ne.0.0e0.and.vdwe(k).ne.0.0e0) then

                  i2 = iag(k)
                  kl = ikl(k)

                  if (i1.gt.0.and.i2.gt.0) then
                     pre6(k)  = rs(il,kl)
                     eps(k)   = es(il,kl)
                  else
                     rsum     = vdwr1 + vdwr(k)
                     rsum3    = rsum*rsum*rsum
                     eps(k)   = sqrt(vdwe1 * vdwe(k))
                     pre6(k)  = rsum3*rsum3
                  endif

                  p6 = pre6(k) * rinv2 * rinv2 * rinv2
                  epsm = eps(k)
                  epsm = epsm * potv(k)


                  p12  = p6 * p6

                  e    = epsm * (p12 - 2.0e0*p6)
                  de   = -12.0e0*rinv2*epsm*(p12 - p6)

                  do j=1,3
                     ded(j) = ded(j) + de * vr(j)
                  end do

                  ev   = ev + e
   
               end if

           end if

           do j=1,3
              ftmp(j,i) = ftmp(j,i) + ded(j)
              ftmp(j,k) = ftmp(j,k) - ded(j)
           end do

         end do

         do k=1,nbck
            jj = ibck(k)
            potq(jj) = qbck(k)
            potv(jj) = vbck(k)
         end do

      end do

cmpi      if (taskid.eq.0) then
cmpi
cmpi         do it=1, nproc - 1
cmpi            itmp = it
cmpi
cmpi            call mpi_recv(fftmp(1,1), iat3, mpi_real,
cmpi     &        itmp, 3, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               do j=1,3
cmpi                  ftmp(j,k) = ftmp(j,k) + fftmp(j,k)
cmpi               end do
cmpi            end do
cmpi
cmpi         end do
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(ectmp, 1, mpi_real, it, 6,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(evtmp, 1, mpi_real, it, 7,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(ftmp(1,1), iat3, 
cmpi     &              mpi_real, it, 8,mpi_comm_world, ierr)
cmpi         end do
cmpi
cmpi      else
cmpi
cmpi         call mpi_send(ftmp(1,1), iat3, mpi_real, 0, 3,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &              0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum, 
cmpi     &              0, mpi_comm_world, ierr)
cmpi
cmpi         call mpi_recv(ectmp, 1, mpi_real, 0, 6,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(evtmp, 1, mpi_real, 0, 7,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(ftmp(1,1), iat3, mpi_real, 
cmpi     &              0, 8, mpi_comm_world, status, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi      endif


      ecbck =  ec
      evbck =  ev

      do i=1,iatoms
         do j=1,3
            forces(j,i) = forces(j,i) + ftmp(j,i)
            ftmp(j,i) = 0.0e0
         end do
      end do

      if (.not.(fast.and.box)) return
c         call mpi_barrier(mpi_comm_world, ierr)


      ec = 0.0e0
      ev = 0.0e0

      do i=1,numwat

         if (iwtpr(i).eq.1) then
            ii0 = natnow + (i-1)*3

            do l=1,3
         
               ii = ii0 + l
               vdwr1 = vdwr(ii)
               vdwe1 = vdwe(ii)
               i1 = iag(ii)
               il = ikl(ii)
               qi = q(ii)

cmpi               chunk = (iats/nproc)
cmpi               ichkh = chunk/4
cmpi               chunk = ichkh*4
cmpi               if (chunk.lt.8) dompi = .false.
cmpi
cmpi               if (dompi) then
cmpi                  if (taskid.eq.0) then
cmpi
cmpi                     offset = chunk + 1
cmpi
cmpi                     do it=1, nproc - 1
cmpi                        call mpi_send(offset, 1, mpi_integer, it,17,
cmpi     &                    mpi_comm_world, ierr)
cmpi                        offset = offset + chunk
cmpi                     end do
cmpi
cmpi                     offset = 1
cmpi
cmpi                  else
cmpi                     call mpi_recv(offset, 1, mpi_integer, 0,17,
cmpi     &                  mpi_comm_world, status, ierr)
cmpi                  endif
cmpi
cmpi                  iend = offset + chunk - 1
cmpi                  if (taskid.eq.nproc-1) iend = iats
cmpi
cmpi               else
cmpi
cmpi                  if (taskid.eq.0) then
                     offset = 1
                     iend = iats
cmpi                  else
cmpi                     offset = 1
cmpi                     iend = 0
cmpi                  endif
cmpi
cmpi               endif

               do k=offset,iend

                 do j=1,3
                    ded(j) = 0.0e0
                 end do

                 do j=1,3
                    vr(j) = coo(j,ii) - coo(j,k)
                 end do
                 if (box) call reddis(vr)
                 r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)
                 r = sqrt(r2)

                 if (r2.le.rc2) then

                     rinv = 1.0e0/r
                     rinv2 = rinv*rinv
                     opt = (iopt(ii).eq.1.or.iopt(k).eq.1)

                     if (opt) then

                        call apperfc(alfa*r,alerfc,alexp)


                        e = qi * potq(k) * 
     &                           (alerfc*rinv - erfrc + erfrc2*(r-rc))


                        de = qi * potq(k) * 
     &                      (alerfc*rinv2 + alexp*rinv - erfrc2)*rinv

                        do j=1,3
                           ded(j) = -de * vr(j)
                        end do

                        ec = ec + e

                     endif


                     if (opt.and.vdwe1.ne.0.0e0
     &                  .and.vdwe(k).ne.0.0e0) then

                        i2 = iag(k)
                        kl = ikl(k)

                        if (i1.gt.0.and.i2.gt.0) then
                           pre6(k)  = rs(il,kl)
                           eps(k)   = es(il,kl)
                        else
                           rsum     = vdwr1 + vdwr(k)
                           rsum3    = rsum*rsum*rsum
                           eps(k)   = sqrt(vdwe1 * vdwe(k))
                           pre6(k)  = rsum3*rsum3
                        endif

                        p6 = pre6(k) * rinv2 * rinv2 * rinv2
                        epsm = eps(k)
                        epsm = epsm * potv(k)


                        p12  = p6 * p6

                        e    = epsm * (p12 - 2.0e0*p6)
                        de   = -12.0e0*rinv2*epsm*(p12 - p6)

                        do j=1,3
                           ded(j) = ded(j) + de * vr(j)
                        end do

                        ev   = ev + e
   
                     endif

                 endif

                 do j=1,3
                    ftmp(j,ii) = ftmp(j,ii) + ded(j)
                    ftmp(j,k) = ftmp(j,k) - ded(j)
                 end do

               end do

            end do
         endif
      end do

cmpi      if (taskid.eq.0) then
cmpi
cmpi         do it=1, nproc - 1
cmpi            itmp = it
cmpi
cmpi            call mpi_recv(fftmp(1,1), iat3, mpi_real,
cmpi     &        itmp,18, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               do j=1,3
cmpi                  ftmp(j,k) = ftmp(j,k) + fftmp(j,k)
cmpi               end do
cmpi            end do
cmpi
cmpi         end do
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(ectmp, 1, mpi_real, it,19,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(evtmp, 1, mpi_real, it,20,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(ftmp(1,1), iat3, 
cmpi     &              mpi_real, it,21,mpi_comm_world, ierr)
cmpi         end do
cmpi
cmpi      else
cmpi
cmpi         call mpi_send(ftmp(1,1), iat3, mpi_real, 0,18,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_reduce(ec, ectmp, 1, mpi_real, mpi_sum,
cmpi     &              0, mpi_comm_world, ierr)
cmpi         call mpi_reduce(ev, evtmp, 1, mpi_real, mpi_sum, 
cmpi     &              0, mpi_comm_world, ierr)
cmpi
cmpi         call mpi_recv(ectmp, 1, mpi_real, 0,19,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(evtmp, 1, mpi_real, 0,20,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(ftmp(1,1), iat3, mpi_real, 
cmpi     &              0,21, mpi_comm_world, status, ierr)
cmpi
cmpi         ec = ectmp
cmpi         ev = evtmp
cmpi
cmpi      endif

      ec = ec + ecbck
      ev = ev + evbck

      do i=1,iatoms
         do j=1,3
            forces(j,i) = forces(j,i) + ftmp(j,i)
         end do
      end do

      return
      end

      subroutine watcnd(coo)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxion=2000)
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      logical dowat
      dimension coo(3,*),vr(3)

      rcut = 7.86e0
      rcut2 = rcut*rcut
      zero = 0.0e0
      niwat = 0
      iaddr = natnow

      do i=1,numwat

         jaddr = iaddr + 3

         do j=i+1,numwat

           kaddr = iaddr + 1
           laddr = jaddr + 1

           do m=1,3
              vr(m) = coo(m,kaddr) - coo(m,laddr)
           end do
           
           call reddis(vr)

           r2 = zero
           do m=1,3
              r2 = r2 + vr(m)*vr(m)
           end do
           
           if (r2.lt.rcut2) niwat = niwat + 1

           jaddr = jaddr + 3

         end do

         iaddr =  iaddr + 3

      end do

      return
      end

      subroutine watlsd(coo,iwtpr,listw)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxion=2000)
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      parameter (mxproc=1000)
      common /mpiwat/ iprb(mxproc),ipre(mxproc),iniwat
      integer taskid,offset
      common /mpih/ nproc,taskid
      logical dowat
      dimension coo(3,*),vr(3),listw(2,*),iwtpr(*)

      rcut = 7.86e0
      rcut2 = rcut*rcut
      zero = 0.0e0
      niwat = 0
      iaddr = natnow

      do i=1,numwat

         kaddr = iaddr + 1
         jaddr = iaddr + 3

         do j=i+1,numwat

           laddr = jaddr + 1

           do m=1,3
              vr(m) = coo(m,kaddr) - coo(m,laddr)
           end do
           
           call reddis(vr)

           r2 = zero
           do m=1,3
              r2 = r2 + vr(m)*vr(m)
           end do
           
           if (r2.lt.rcut2) then
               niwat = niwat + 1
               listw(1,niwat) = iaddr + 1
               listw(2,niwat) = jaddr + 1
           endif

           jaddr = jaddr + 3


         end do

         iwtpr(i) = 0

         do j=1,natnow

            do k=1,3
               vr(k) = coo(k,iaddr+1) - coo(k,j)
            end do

            call reddis(vr)

            rab2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)
            if (rab2.lt.103.0e0) iwtpr(i) = 1

         end do

         iaddr =  iaddr + 3

      end do

      iniwat = 0

c      print*,"Updated water list"

      return
      end

      subroutine fstwad(ew,coo,ftmp,q,fftmp,listw,
     &                  woo,whh,woh,dewoo,dewhh,dewoh)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      common /athlp/  iatoms, mxnat
      parameter (mxion=2000)
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      integer ambcls
      parameter (mxamb=1590)
cmpi      include 'mpif.h'
cmpi      integer chunk
cmpi      integer status(mpi_status_size)
      logical dompi
      integer taskid
      common /mpih/ nproc,taskid
      parameter (mxproc=1000)
      common /mpiwat/ iprb(mxproc),ipre(mxproc),iniwat
      logical box, cell, fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      dimension coo(3,*),vr(3),q(*),listw(2,*),
     &          ftmp(3,*),fftmp(3,*)
      dimension woo(*),whh(*),woh(*),dewoo(*),dewhh(*),dewoh(*)

c
c Adaptation from:
c
c Cristopher J. Fennell and J. Daniel Gezelter,
c Journal of Chemical Physics. 124, 234104 (2006)
c
      dompi = .false.

cmpi      call mpi_comm_rank(mpi_comm_world, taskid, ierr)
cmpi      dompi = .true.
cmpi      call iniprc

      ew   = 0.0e0
      zero = 0.0e0
      thou = 1000.0e0

      rcut = 7.86e0
      rcut2 = rcut*rcut
      rcinv = 1.0e0 / rcut
      rc2inv = rcinv*rcinv

c interpolation Fapprox = (1-x)*F(i) + x*F(i+1)
c where i is: i = int(R/1000)
c where x is remainder: x = R - int(R/1000)

      iat3 = iatoms*3

      if (dompi) then
         ibeg = iprb(taskid+1)
         iend = ipre(taskid+1)
         iaddr = natnow + (ibeg-1)*3
      else
         ibeg = 1
         iend = niwat
      endif

      do i=ibeg,iend
       
            kaddr = listw(1,i)
            jaddr = listw(2,i)
            laddr = jaddr

c    O w1 <->  O w2
       
            do k=1,3
               vr(k) = coo(k,kaddr) - coo(k,laddr)
            end do
           
            call reddis(vr)

            r2 = zero
            do k=1,3
               r2 = r2 + vr(k)*vr(k)
            end do
           

            r = sqrt(r2) 
            if (r.le.8.999e0) then
               r1000 = r*thou
               ir = int(r1000)
               x = (r1000 - dble(ir))
               w = (1.0e0-x)*woo(ir) + x*woo(ir+1)

               ew = ew + w
               de = dewoo(ir)
       
               do k=1,3
                  ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                  ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
               end do
       

c    O w1 <->  H1 w2
       
               laddr = laddr + 1
               
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
           
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
           

               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*woh(ir) + x*woh(ir+1)
                  ew = ew + w
                  de = dewoh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif
       

c    O w1 <->  H2 w2
       
               laddr = laddr + 1
            
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
           
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
           

               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*woh(ir) + x*woh(ir+1)
                  ew = ew + w
                  de = dewoh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif
       

c    H1 w1 <->  O w2
       
               kaddr = kaddr + 1
             
               laddr = jaddr
       
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
           
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
           

               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*woh(ir) + x*woh(ir+1)
                  ew = ew + w
                  de = dewoh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif
       

c    H1 w1 <->  H1 w2
       
               laddr = laddr + 1
            
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
           
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
           
               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*whh(ir) + x*whh(ir+1)
                  ew = ew + w
                  de = dewhh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif

       
c    H1 w1 <->  H2 w2
       
               laddr = laddr + 1
            
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
           
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
           
               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*whh(ir) + x*whh(ir+1)
                  ew = ew + w
                  de = dewhh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif
       

c    H2 w1 <->  O w2
       
               kaddr = kaddr + 1
                
               laddr = jaddr
       
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
           
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
           
               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*woh(ir) + x*woh(ir+1)
                  ew = ew + w
                  de = dewoh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif
       

c    H2 w1 <->  H1 w2
       
               laddr = laddr + 1
           
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
           
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
              
               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*whh(ir) + x*whh(ir+1)
                  ew = ew + w
                  de = dewhh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif
       

c    H2 w1 <->  H2 w2
       
               laddr = laddr + 1
               
               do k=1,3
                  vr(k) = coo(k,kaddr) - coo(k,laddr)
               end do
              
               call reddis(vr)

               r2 = zero
               do k=1,3
                  r2 = r2 + vr(k)*vr(k)
               end do
           
               r = sqrt(r2) 
               if (r.le.8.999e0) then
                  r1000 = r*thou
                  ir = int(r1000)
                  x = (r1000 - dble(ir))
                  w = (1.0e0-x)*whh(ir) + x*whh(ir+1)
                  ew = ew + w
                  de = dewhh(ir)
       
                  do k=1,3
                     ftmp(k,kaddr) = ftmp(k,kaddr) + de*vr(k)
                     ftmp(k,laddr) = ftmp(k,laddr) - de*vr(k)
                  end do
               endif
       
            endif

      end do
           
cmpi      if (taskid.eq.0) then
cmpi
cmpi         do it=1, nproc - 1
cmpi            itmp = it
cmpi
cmpi            call mpi_recv(fftmp(1,1), iat3, mpi_real,
cmpi     &        itmp, 10, mpi_comm_world, status, ierr)
cmpi            do k=1,iatoms
cmpi               do j=1,3
cmpi                  ftmp(j,k) = ftmp(j,k) + fftmp(j,k)
cmpi               end do
cmpi            end do
cmpi
cmpi         end do
cmpi
cmpi         call mpi_reduce(ew, ewtmp, 1, mpi_real, mpi_sum,
cmpi     &                0, mpi_comm_world, ierr)
cmpi
cmpi         ew = ewtmp
cmpi
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(ewtmp, 1, mpi_real, it, 13,
cmpi     &              mpi_comm_world, ierr)
cmpi            call mpi_send(ftmp(1,1), iat3, 
cmpi     &              mpi_real, it, 14,mpi_comm_world, ierr)
cmpi         end do
cmpi
cmpi      else
cmpi
cmpi         call mpi_send(ftmp(1,1), iat3, mpi_real, 0, 10,
cmpi     &              mpi_comm_world, ierr)
cmpi
cmpi         call mpi_reduce(ew, ewtmp, 1, mpi_real, mpi_sum,
cmpi     &              0, mpi_comm_world, ierr)
cmpi
cmpi         call mpi_recv(ewtmp, 1, mpi_real, 0, 13,
cmpi     &              mpi_comm_world, status, ierr)
cmpi         call mpi_recv(ftmp(1,1), iat3, mpi_real, 
cmpi     &              0, 14, mpi_comm_world, status, ierr)
cmpi
cmpi         ew = ewtmp
cmpi
cmpi      endif

      return
      end

      subroutine iniprc
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxion=2000)
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      parameter (mxproc=1000)
      common /mpiwat/ iprb(mxproc),ipre(mxproc),iniwat
      integer taskid,chunk
      common /mpih/ nproc,taskid

      if (iniwat.eq.0) then
         chunk = niwat /nproc
         do i=1,nproc
            iprb(i) = (i-1)*chunk + 1
            ipre(i) = i*chunk
         end do
         ipre(nproc) = niwat
         iniwat = 1
      endif
           
      return
      end

      subroutine rdbad(idebug,dfree,istats,ityp)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (mxonh=100)
      parameter (mxexpo=100)
      parameter (mxshl=20)
      logical fndshl,eledon
      character*3 cnam
      character*2 ele
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp,dfree,rdbuf
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      integer*2 ityp
      equivalence (nshell,i)
      character*137 line,str
      common /curlin/ line
      integer getlin,getele
      logical gnreal
      dimension r(4),ityp(*),expo(mxexpo),coefo(mxexpo)
      dimension ishll(numatm,mxshl),ieler(numatm)

      do i=1,natoms
         do j=1,mxshl
            ishll(i,j)  = -1
         end do
         ieler(i) = -1
      end do

      istats = 1
      ig03 = 0
      ieleol = -1

      if (idebug.eq.1)
     &    call inferr('looking for gaussian basis-set',0)

1030  format(4d18.10)
1040  format(4x,4d18.10)
      if (dfree.ne.0) then
         if (dfree.eq.1) then
            call searchu(line,'[GTO]',istat)
         elseif (dfree.eq.2) then
            call srchmf(line,'$BASIS',istat)
         elseif (dfree.eq.3) then
            rewind(iun2)
            call search(line,'bas_input',istat)
            call search(line,'basis',istat)
            if (index(line,"cartesian").ne.0) then
               ido5d = 0
               ido7f = 0
               ido9g = 0
            endif
            if (index(line,"spherical").ne.0) then
               ido5d = 1
               ido7f = 1
               ido9g = 1
               print*,"mulliken charges of spherical F and G ",
     &                "dont add up !!"
              
            endif
         endif
      else
         call seardu(line,'Basis set in the form',
     &                    'AO basis set:',istat)
         if (istat.eq.0) then
             call inferr(
     &       'Use keyword gfinput in gaussian inputfile',1)
             goto 1000
         endif
         if (index(line,'AO basis set').ne.0) ig03 = 1
         if (index(line,'AO basis set:').ne.0) ig03 = 2
      endif

      i = 0
      k = 0
      if (ioni.eq.1) then
         do m=1,numatm
            iomap(m) = 0
            ityp(m) = 20000
         end do
      endif
      mm = 1
      mmdf = 1
      jann = 0
      jmode = 1
      ns = 0

10    if (dfree.ne.0) then
         if (getlin(0).eq.1) idum = 0
      else
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
      endif

      if (dfree.ne.0) then

         ktype = nxtwrd(str,nstr,itype,rtype)

         if (ktype.eq.1) then
            if (nstr.ge.1) then
               if (index(str,'[').ne.0) return
               if (dfree.eq.2) then
                  if (icdex(str,'$END').ne.0) return
               endif
               if (str(1:1).eq.'#'.or.str(1:1).eq.'*') then
                  if (dfree.eq.2) jmode = 1
                  goto 10
               endif
               if (jmode.eq.1.and.dfree.eq.2) then
                  jann = jann + 1
                  jmode = 0
                  goto 10
               endif
            endif
         elseif (ktype.eq.2) then
            jann = itype
            goto 10
         elseif (ktype.eq.0) then
            goto 10
         endif

      else

         if (ig03.eq.2.and.line(2:5).ne.'Atom') return

         if (i.eq.0.or.line(2:5).eq.'****'.or.line(2:5).eq.'Atom') then

            if (line(2:5).eq.'Atom') then
               ig03 = 2

c example: Atom B3       Shell     8 SP   2    bf   20 -    23

               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)

c break up string and extract jann

               do kk=1,nstr
                  ik = ichar(str(kk:kk))
                  if (ik.lt.48.or.ik.gt.57) str(kk:kk) = ' '
               end do

               do kk=1,nstr
                  if (str(kk:kk).ne.' ') istrt = kk
               end do

               jann = reada(str,1,nstr)
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)

               if (ktype.eq.1) then
                  cnam = '   '
                  if (nstr.gt.3) nstr = 3
                  cnam(1:nstr) = str(1:nstr)
                  call tocap(cnam,3)
               else
                  goto 1000
               endif

               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.2) then
                  nsh = itype
               else
                  goto 1000
               endif

            else

               if (line(2:5).eq.'****') then
                   call nxtlin(line,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   if (linlen(line).eq.0) return
               endif

               if (line(7:7).ne.' ') then
                  read(line,'(i7)',err=1000) jann
               elseif (line(4:4).ne.' ') then
                  read(line,'(i4)',err=1000) jann
               else
                  read(line,'(i3)',err=1000) jann
               endif

               if (ioni.eq.1) then
                  k = k + 1
                  iomap(k) = jann
                  nat(k) = nat(jann)
                  ityp(jann) = ityp(jann) - 20000

                  do ll=1,3
                     xyz(ll,k) = xyz(ll,jann)
                  end do

                  do jj=1,nion
                      if (jann.eq.ionih(jj)) then
                         nat(k) = natonh(jj)
                         do ll=1,3
                            xyz(ll,k) = xyzi(ll,jj)
                         end do
                      endif
                  end do

               endif

               call nxtlin(line,jstat)
               if (jstat.eq.1.or.jstat.eq.2) goto 1000
            endif
         endif
      endif

      if (dfree.eq.0.and.ig03.eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
      endif

      if (dfree.ne.0.or.ig03.eq.1) then
      
c         if (dfree.ne.3.or.ig03.eq.1) then
         if (ig03.eq.1) then
            cnam = '   '
            if (nstr.gt.3) nstr = 3
            cnam(1:nstr) = str(1:nstr)
            call tocap(cnam,3)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               nsh = itype
            endif
         else if (dfree.ne.3) then
            cnam = '   '
            if (nstr.gt.3) nstr = 3
            cnam(1:nstr) = str(1:nstr)
            call tocap(cnam,3)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               nsh = itype
            endif
         else if (dfree.eq.3) then
            call bckfil
         endif

      else
         if (ig03.eq.0) then
            read(line,'(1x,a3,1x,i2)',err=1000) cnam, nsh
         endif
      endif

      i = i + 1

      if (dfree.eq.3) then

c ish is the overall counter for shells
c ns  is the element counter for shells

         ish = 0

c read in element basis set

         do j=1,natoms

            ns = 0

            if (ieler(j).eq.-1) then

               call rewmf
               call search(line,'bas_input',istat)
               call search(line,'basis',istat)

               nprim = 0

               do while (nprim.ne.-2)
                  nprim = rdbuf(nat(j),expo,coefo,cnam)
                  if (nprim.eq.-1) goto 1000
                  if (j.eq.natoms) then
                     if (nprim.eq.-2) then
                        nshell = ish
c                        call basprt(6,.false.,.false.)
                        return
                     endif
                  else
                     if (nprim.eq.-2) goto 30
                  endif

                  ish = ish + 1
                  ns  = ns + 1

c store shell in common block /b/:

                  call pttshl(ish,nprim,j,ns,ishll,mm,mmdf,
     &                        expo,coefo,cnam)

               end do

               ieler(j) = ish

            else

c copy already read in basis for element into the 

               eledon = fndshl(j,ish,ishll,mm,mmdf)

            endif

30          continue
            
         end do

100      continue

      else

         if (i.gt.numprm) print*,"exceded parameter numprm=",numprm
         call settc(cnam,shellt(i),shellc(i))

         shelln(i)  = nsh
         shella(i)  = mm
         shladf(i)  = mmdf

         call rdshl(idebug,dfree,ioni,jann,ig03,i,k,nsh,mm,
     &                    mmdf,istats,cnam)
         if (istats.eq.0) goto 1000

      endif

      goto 10

1000  call inferr('error while reading Basis set!',1)
      istats = 0
      return
      end

      subroutine pttshl(ish,nprim,jann,ns,ishll,mm,mmdf,expo,coefo,cnam)
      implicit double precision (a-h,o-z)

      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (mxexpo=100)
      parameter (mxshl=20)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      character*3 cnam

      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp

      common /coord / xyz(3,numatm)
      dimension expo(mxexpo),coefo(mxexpo)
      dimension ishll(numatm,mxshl)

      call settc(cnam,shellt(ish),shellc(ish))

      ishll(jann,ns)  = ish

      shelln(ish)  = nprim
      shella(ish)  = mm
      shladf(ish)  = mmdf

      jan(ish)     = jann
      gx(ish)      = xyz(1,jann)
      gy(ish)      = xyz(2,jann)
      gz(ish)      = xyz(3,jann)

      call putshl(ish,nprim,mm,mmdf,expo,coefo)

      return
      end

      integer function iseqa(isq,ns,ishll)

c find the first occurance (sequence number) of element number isq 
c in coordinate set, that has not been initialised

      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxshl=20)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension ishll(numatm,mxshl)

      iseqa = -1

      do j=1,natoms
          if (isq.eq.nat(j).and.ishll(j,ns).eq.-1) then
             iseqa = j
             return
          endif
      end do

      return
      end

      logical function fndshl(jann,ishell,ishll,mm,mmdf)

c Finds element thats has previously been read and put into
c exponent and contraction coefficient arrays by putshl
c and calls copy shell (cpshl) for other instances of this element

      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxshl=20)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension ishll(numatm,mxshl)

      fndshl = .false.

      jold = -1

      do j=1,numatm
         if (nat(jann).eq.nat(j).and.ishll(j,1).ne.-1) then
            jold = j
         endif
      end do

      if (jold.ne.-1) then

          do k=1,mxshl

             if (ishll(jold,k).ne.-1) then
                 fndshl = .true.
                 call cpshl(jann,ishell,ishll(jold,k),mm,mmdf)
                 ishll(jann,k) = ishell
                 ishell = ishell + 1
             endif

          end do

      else

          print*,"presumed read in shell does not exist!"

      endif

      return
      end

      integer function getele(ele)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      character*2 ele,tocapf,elemnt
      common /elem/elemnt(mxel)

      getele = 0
      do i=1,mxel
         if (tocapf(ele).eq.tocapf(elemnt(i))) then
             getele = i
         endif
      end do 

      return
      end

      integer function rdbuf(iele,expo,coefo,cnam)

c Reads a NWCHEM element (iele) shell and returns the name of the shell in cnam,
c the coefficients and exponents
c in coefo and expo arrays and returns the number of primitives as rdbuf

      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxexpo=100)
      character*137 line,tlin,str
      character*3 cnam
      character*2 ele,tocapf
      common /curlin/ line
      character*2 elemnt
      common /elem/elemnt(mxel)
      integer getlin,getele
      logical gnreal
      dimension r(2),expo(mxexpo),coefo(mxexpo)

      ifndel = 0
      mm = 0

      do while (.true.)

20      if (getlin(0).eq.1) then

            tlin = line
            ktype = nxtwrd(str,nstr,itype,rtype)

c line starts with a string: read in element and shell name

            if (ktype.eq.1) then

               if (nstr.eq.3) then
                  if (str(1:3).eq.'end') then
                     if (ifndel.eq.1) goto 50
                     goto 200
                  endif
               endif

               if (ifndel.eq.1) goto 50

c convert element string to integer

               ele(1:2) = '  '
               if (nstr.eq.1) ele = ' '//str(1:1)
               if (nstr.eq.2) ele = str(1:2)

               iel = getele(ele)

c unknown element:

               if (iel.eq.0) goto 100


               if (ifndel.ne.1) then
c element is not the desired element:
                  if (iel.ne.iele) then
c                     mm = 0
                     goto 20
                  endif
               else
c done
                  call bckfil
                  goto 200
               endif

c found the desired element

               ifndel = 1
               
               ktype = nxtwrd(str,nstr,itype,rtype)

               if (ktype.eq.1) then
                  if (nstr.eq.3) then
                     cnam = str(1:nstr)
                  else if (nstr.eq.2) then
                     cnam = str(1:2)//' '
                  else if (nstr.eq.1) then
                     cnam = str(1:1)//'  '
                  else
                     goto 100
                  endif
                  call tocap(cnam,nstr)
                  mm = 0
               else
                  goto 100
               endif

            else

c line starts not with a string: read in exponent and coefficient

               line = tlin
               if (gnreal(r,2,.false.)) then
                  mm = mm + 1
                  expo(mm)   = r(1)
                  coefo(mm)  = r(2)
               else
                  goto 100
               endif
            endif

         else
            goto 100
         endif

      end do

50    rdbuf = mm
      call bckfil
      return

c     error
100   rdbuf = -1
      return

c     end
200   rdbuf = -2
      return
      end

      subroutine rdshl(idebug,dfree,ioni,jann,ig03,ishell,ksh,nshl,mm,
     &                 mmdf,istats,cnam)
      implicit double precision (a-h,o-z)

      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      logical gnreal
      character*3 cnam
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp,dfree

      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /coord / xyz(3,numatm)
      character*137 line,str
      common /curlin/ line
      dimension r(4)

1030  format(4d18.10)
1040  format(4x,4d18.10)

      istats = 1

      if (ioni.eq.1) then
         jan(ishell)     = ksh
         gx(ishell)      = xyz(1,ksh)
         gy(ishell)      = xyz(2,ksh)
         gz(ishell)      = xyz(3,ksh)
      else
         jan(ishell)     = jann
         gx(ishell)      = xyz(1,jann)
         gy(ishell)      = xyz(2,jann)
         gz(ishell)      = xyz(3,jann)
      endif

      do j = 1, nshl

           if (shellt(ishell).eq.0) then
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c1(mm)  = r(2)
                  endif
               else
                  call nxtlin(line,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 1000

                  if (ig03.gt.0) then
                     read(line,1040,err=1000) exx(mm), c1(mm)
                  else
                     read(line,1030,err=1000) exx(mm), c1(mm)
                  endif
               endif
           endif

           if (shellt(ishell).eq.1.and.shellc(ishell).eq.1) then
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c2(mm)  = r(2)
                  endif
               else
                  call nxtlin(line,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 1000

                  if (ig03.gt.0) then
                     read(line,1040,err=1000) exx(mm), c2(mm)
                  else
                     read(line,1030,err=1000) exx(mm), c2(mm)
                  endif
               endif
           endif

           if (shellt(ishell).eq.1.and.shellc(ishell).ne.1) then
               if (dfree.ne.0) then
                  if (gnreal(r,3,.true.)) then
                     exx(mm) = r(1)
                     c1(mm)  = r(2)
                     c2(mm)  = r(3)
                  endif
               else
                  call nxtlin(line,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 1000

                  if (ig03.gt.0) then
                     read(line,1040,err=1000) exx(mm), c1(mm), c2(mm)
                  else
                     read(line,1030,err=1000) exx(mm), c1(mm), c2(mm)
                  endif
               endif
           endif

           if (shellt(ishell).eq.2.and.shellc(ishell).eq.0) then
               if (dfree.ne.0) then
                  if (gnreal(r,4,.true.)) then
                     exx(mm) = r(1)
                     c1(mm)  = r(2)
                     c2(mm)  = r(3)
                     c3(mmdf)= r(4)
                  endif
               else
                  call nxtlin(line,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 1000

                  if (ig03.gt.0) then
                     read(line,1040,err=1000) 
     &                        exx(mm), c1(mm), c2(mm), c3(mmdf)
                  else
                     read(line,1030,err=1000) 
     &                        exx(mm), c1(mm), c2(mm), c3(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif

           if (shellt(ishell).eq.2.and.shellc(ishell).ne.0) then
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c3(mmdf)= r(2)
                  endif
               else
                  call nxtlin(line,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 1000

                  if (ig03.gt.0) then
                     read(line,1040,err=1000) exx(mm), c3(mmdf)
                  else
                     read(line,1030,err=1000) exx(mm), c3(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif

           if (shellt(ishell).eq.3) then 
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c4(mmdf)= r(2)
                  endif
               else
                  call nxtlin(line,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 1000

                  if (ig03.gt.0) then
                     read(line,1040,err=1000) exx(mm), c4(mmdf)
                  else
                     read(line,1030,err=1000) exx(mm), c4(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif

           if (shellt(ishell).eq.4) then 
               if (dfree.ne.0) then
                  if (gnreal(r,2,.true.)) then
                     exx(mm) = r(1)
                     c5(mmdf)= r(2)
                  endif
               else
                  call nxtlin(line,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 1000

                  if (ig03.gt.0) then
                     read(line,1040,err=1000) exx(mm), c5(mmdf)
                  else
                     read(line,1030,err=1000) exx(mm), c5(mmdf)
                  endif
               endif
               mmdf = mmdf + 1
           endif

           mm = mm + 1
      end do

      return

1000  istats = 0
      return
      end

      subroutine cpshl(jann,ishell,jshell,mm,mmdf)

c copies previously read shell (rdbuf) and parsed by putshl
c to same shell and element combination for another center

      implicit double precision (a-h,o-z)

      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      logical gnreal
      character*3 cnam
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp

      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /coord / xyz(3,numatm)

      jan(ishell)    = jann
      gx(ishell)     = xyz(1,jann)
      gy(ishell)     = xyz(2,jann)
      gz(ishell)     = xyz(3,jann)

      shelln(ishell) = shelln(jshell)
      shellt(ishell) = shellt(jshell)
      shellc(ishell) = shellc(jshell)
      shella(ishell) = mm
      shladf(ishell) = mmdf
      mmo            = shella(jshell) 
      mmdfo          = shladf(jshell) 

      isht = shellt(jshell)
      ishc = shellc(jshell)

      do j = 1, shelln(jshell)

           if (isht.eq.0) then
               exx(mm) = exx(mmo)
               c1(mm)  = c1(mmo)
           endif

           if (isht.eq.1.and.ishc.eq.1) then
               exx(mm) = exx(mmo)
               c2(mm)  = c2(mmo)
           endif

           if (isht.eq.1.and.ishc.ne.1) then
               exx(mm) = exx(mmo)
               c1(mm)  = c1(mmo)
               c2(mm)  = c2(mmo)
           endif

           if (isht.eq.2.and.ishc.eq.0) then
               exx(mm) = exx(mmo)
               c1(mm)  = c1(mmo)
               c2(mm)  = c2(mmo)
               c3(mmdf) = c3(mmdfo)

               mmdf  = mmdf  + 1
               mmdfo = mmdfo + 1
           endif

           if (isht.eq.2.and.ishc.ne.0) then
               exx(mm) = exx(mmo)
               c3(mmdf) = c3(mmdfo)
               mmdf  = mmdf  + 1
               mmdfo = mmdfo + 1
           endif

           if (isht.eq.3) then 
               exx(mm) = exx(mmo)
               c4(mmdf) = c4(mmdfo)
               mmdf  = mmdf  + 1
               mmdfo = mmdfo + 1
           endif

           if (isht.eq.4) then 
               exx(mm) = exx(mmo)
               c5(mmdf) = c5(mmdfo)
               mmdf  = mmdf  + 1
               mmdfo = mmdfo + 1
           endif

           mm  = mm  + 1
           mmo = mmo + 1
      end do

      return

      end

      subroutine putshl(ishell,nshl,mm,mmdf,expo,coefo)

c putshl: takes temporary exponents and contraction coefficients
c         read by rdbuf, and puts them in the permanent arrays
c         exx and c1 to c5 in common block /b/

      implicit double precision (a-h,o-z)

      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (mxexpo=100)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp

      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      dimension expo(mxexpo),coefo(mxexpo)

      mmo = 1

      do j = 1, nshl

           if (shellt(ishell).eq.0) then

               exx(mm) = expo(mmo)
               c1(mm)  = coefo(mmo)
               mm  = mm  + 1
           endif

           if (shellt(ishell).eq.1) then
               exx(mm) = expo(mmo)
               c2(mm)  = coefo(mmo)
               mm  = mm  + 1
           endif

           if (shellt(ishell).eq.2) then
               exx(mm)  = expo(mmo)
               c3(mmdf) = coefo(mmo)
               mm  = mm  + 1
               mmdf  = mmdf  + 1
           endif

           if (shellt(ishell).eq.3) then 
               exx(mm)  = expo(mmo)
               c4(mmdf) = coefo(mmo)
               mm  = mm  + 1
               mmdf  = mmdf  + 1
           endif

           if (shellt(ishell).eq.4) then 
               exx(mm)  = expo(mmo)
               c5(mmdf) = coefo(mmo)
               mm  = mm  + 1
               mmdf  = mmdf  + 1
           endif

           mmo = mmo + 1
      end do

      return

      end

      subroutine scback(line,name,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name
      character*137 caps

      istat = 0
      caps  = name
      len1  = len(name)
      call tocap(caps,len1)
1     call bckfil
      call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200
      call bckfil
      if (index(line,name).eq.0.and.index(line,caps(1:len1)).eq.0)
     &  go to 1
c
      istat=1
      return
100   call rewfil
      return
200   continue
      return
c
c
      end

      subroutine rotfid(ioxyz,ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (maxpt=1000)
      parameter (bignum=1.0d12)
      parameter (small=1.0d-4)
      common /athlp/ iatoms, mxnat
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg
      common /gamori/imap(numat1),cstand(3,numat1),istand(numat1),
     &               msucc
      common /savcor/ angs(3,maxpt),idon(maxpt)
      character line*137
      dimension angfir(3)
      dimension vect1(3),vect2(3),vect3(3)
      dimension fdist(numat1),cdist(numat1),cori(3,numat1),
     &          cttt(3,numat1),coo(3,*),ianz(*)
 
      tol = small
      msucc = 1
cd     write(iun3,'(a)')'enter subroutine rotfir'

c     read in coords prior to orient. + forces first point

      call rewfil
      ip = 1
      call gampoi(ip,istat,ioxyz)
      call docct
      
c     read in standard orientation

      call rewfil
      call search(line,'molecular geometry',istat)
      if (istat.eq.0) then
         call inferr('No molecular geometry found !',1)
         goto 1000
      endif
      call search(line,'atom   atomic',istat)
      call redel(line,3)

      katoms = 0
5        call nxtlin(line,jstat)
         if (jstat.eq.2) goto 1000
         if (line(10:14).eq.'*****') goto 10
         if (line(11:70).eq.' ') goto 5
         katoms = katoms + 1
         read(line,'(22x,f5.1,3(f12.7,3x))',err=1000)
     &    charge,cstand(1,katoms),cstand(2,katoms),cstand(3,katoms)
         istand(katoms) = charge
         goto 5
10    continue
      
      if (katoms .ne. iatoms) then
         call inferr('rotfir: #atoms orientation prior != standard',1)
         goto 1000
      endif

c     establish the mapping between z-mat and standard orientation

      do i=1,iatoms
         if (i.le.numat1) then
            fdist(i) = vlen(coo(1,i))
            cdist(i) = vlen(cstand(1,i))
         endif
      end do

      if ((ianz(1).eq.istand(1)).and.(fdist(1).gt.tol).and.
     &   ((fdist(1)-cdist(1))**2.lt.tol)) then
         ist = 1
      elseif ((ianz(2).eq.istand(2)).and.
     &   ((fdist(1)-cdist(1))**2.lt.tol)) then
         ist = 2
      else
         call inferr('rotfir: mapping scheme doesnt work',1)
         goto 1000
      endif

c     rotate atom 1 or 2 to standard orientation

      call crprod(coo(1,ist),cstand(1,ist),vect1)

      if (vlen(vect1).gt.small) then

         call impsc(coo(1,ist),cstand(1,ist),co1)
         call crprod(vect1,coo(1,ist),vect2)
         call impsc(cstand(1,ist),vect2,si1)
         call tessa(vect1,co1,si1,fdist,coo,cori,iatoms,tol)

      else

         do i=1,iatoms
            do j=1,3
              cori(j,i) = coo(j,i)
            end do
         end do

      endif

c     now rotate every other atom of the prior orientation to 
c     the next atom of the standard orientation (atom 2 or 3)
c     and see which rotation gives the smallest error 

      delta = bignum
      do n=1,iatoms-ist
         call crprod(cstand(1,ist),cstand(1,ist+n),vect2)
         call crprod(vect2,cstand(1,ist),vect1)
         if (vlen(vect2).gt.small) goto 30
      end do

30    continue
      
      inum = 1

      do i=ist+1,iatoms
         if((ianz(i).eq.istand(ist+n)).and.
     &      ((fdist(i)-cdist(ist+n))**2.lt.tol)) then

c           establish rotation angle

            call crprod(cstand(1,ist),cori(1,i),vect2)
            if(vlen(vect2).gt.small) then
               call crprod(vect2,cstand(1,ist),vect3)
               call impsc(vect1,vect2,si2)
               call impsc(vect3,vect1,co2)

c           the rotatation part

            call tessa(cstand(1,ist),co2,si2,fdist,cori,cttt,iatoms,tol)
            
            else
                do k=1,iatoms
                   do j=1,3
                     cttt(j,k) = cori(j,k)
                   end do
                end do
            endif
c           the mapping part

            call caldis(dis,cttt,fdist,cdist,tol,ianz)

            if (dis.lt.delta) then
               delta = dis
               inum = i
            endif

         endif
      end do
       
c     activate rotation and mapping

      call crprod(cstand(1,ist),cori(1,inum),vect2)
      if(vlen(vect2).gt.small) then
         call crprod(vect2,cstand(1,ist),vect3)
         call impsc(vect1,vect2,si2)
         call impsc(vect3,vect1,co2)
         call tessa(cstand(1,ist),co2,si2,fdist,cori,cttt,iatoms,tol)
      else
         do k=1,iatoms
            do j=1,3
              cttt(j,k) = cori(j,k)
            end do
         end do
      endif
      call caldis(dis,cttt,fdist,cdist,tol,ianz)

c     put standard orientation in correct order

      do i=1,iatoms
         do j=1,3
            cori(j,i) = cstand(j,imap(i))
         end do 
      end do
  
      do i=1,iatoms
         do j=1,3
            cstand(j,i) = cori(j,i)
         end do 
      end do

c     end of mapping start finding rotation angles first point

      todeg     = 45.0d0 / datan(1.0d0)
      delold    = 1.0d5

      amat(1,3) = 0.0d0
      amat(2,3) = 0.0d0
      amat(3,1) = 0.0d0
      amat(3,2) = 0.0d0
      amat(3,3) = 1.0d0

      bmat(1,2) = 0.0d0
      bmat(2,1) = 0.0d0
      bmat(2,2) = 1.0d0
      bmat(2,3) = 0.0d0
      bmat(3,2) = 0.0d0

      cmat(1,1) = 1.0d0
      cmat(1,2) = 0.0d0
      cmat(1,3) = 0.0d0
      cmat(2,1) = 0.0d0
      cmat(3,1) = 0.0d0


c----- start of coarse search ----

      do ia=0,360,10
         angfir(1)=dfloat(ia)
         call rota(angfir(1))
         do ib=0,360,10
            angfir(2)=dfloat(ib)
            call rotb(angfir(2))
            do ic=0,360,10
               angfir(3)=dfloat(ic)
               call rotc(angfir(3))
               delta=distot()
               if(delta.lt.delold)then
                 delold=delta
                 alopt=angfir(1)
                 beopt=angfir(2)
                 gaopt=angfir(3)
               endif
            end do
         end do
      end do

c----- end of coarse search ------

c----- start of medium search ----

      alco=alopt
      beco=beopt
      gaco=gaopt
      do ia=1,21
         angfir(1)=alco+dfloat(ia-1)-10.0d0
         call rota(angfir(1))
         do ib=1,21
            angfir(2)=beco+dfloat(ib-1)-10.0d0
            call rotb(angfir(2))
            do ic=1,21
               angfir(3)=gaco+dfloat(ic-1)-10.0d0
               call rotc(angfir(3))
               delta=distot()
               if(delta.lt.delold)then
                 delold=delta
                 alopt=angfir(1)
                 beopt=angfir(2)
                 gaopt=angfir(3)
               endif
            end do
         end do
      end do

c----- end of medium search ------

c----- start of fine search ----

      alco=alopt
      beco=beopt
      gaco=gaopt
      do ia=1,21
         angfir(1)=alco+dfloat(ia-1)*0.1d0-1.0d0
         call rota(angfir(1))
         do ib=1,21
            angfir(2)=beco+dfloat(ib-1)*0.1d0-1.0d0
            call rotb(angfir(2))
            do ic=1,21
               angfir(3)=gaco+dfloat(ic-1)*0.1d0-1.0d0
               call rotc(angfir(3))
               delta=distot()
               if(delta.lt.delold)then
                 delold=delta
                 alopt=angfir(1)
                 beopt=angfir(2)
                 gaopt=angfir(3)
               endif
            end do
         end do
      end do

c----- end of fine search ------
c     final angles

      angfir(1) = alopt
      angfir(2) = beopt
      angfir(3) = gaopt
      angs(1,1) = alopt
      angs(2,1) = beopt
      angs(3,1) = gaopt
      idon(1)   = 1

cd     write(iun3,'(a)')'leave subroutine rotfir'
      return
1000  msucc = 0
      call inferr('ERROR in rotation to Standard Orientation!',1)
cd     write(iun3,'(a)')'leave subroutine rotfir'
      return
      end

      subroutine eulerh(px,py,pz,cx,cy)
      implicit double precision (a-h,o-z)
************************************************************************
*
* EULER DOES A SIMPLE EULERIAN TRANSFORM ON THE POINT PX,PY,PZ TO
* PRODUCE A POINT FOR PLOTTING. IT HAS EXTRA CODE TO ALLOW THE USER
* TO SPECIFY WHICH TWO DIMENSIONS ARE TO BE PLOTTED.
* ON INPUT: 
*    THE FIRST CALL OF EULER (NOT EULERH) INITIALISES COMMON /EUL/
*    SET THE PLANE OF THE PLOT
*            PX,PY,PZ = POINT IN 3-D SPACE TO MOVE THE PEN TO.

************************************************************************
      common /eul/ ca,cb,sa,sb,ccab,scab,ssab,scba
      common /plrat/ rat(3)

      cy = ccab*(px-0.5d0)*rat(1) + scab*(py-0.5d0)*rat(2) - 
     &     sb*pz*rat(3)
      cx =  -sa*(px-0.5d0)*rat(1) +   ca*(py-0.5d0)*rat(2)

      return
      end

      subroutine crprod(a,b,c)
c
c       calculates cross product:   a x b = c
c                                   -   -   -
      implicit real (a-h,o-z)
      dimension a(3),b(3),c(3)
c
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end
      subroutine crpros(a,b,c)
c
c       calculates cross product:   a x b = c
c                                   -   -   -
      implicit real (a-h,o-z)
      dimension a(3),b(3),c(3)
c
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end
      subroutine vsc1(a,scale,tol)
      implicit real (a-h,o-z)
      dimension a(3)

      rlen = vlen(a)

      if (rlen.gt.tol) then
         do i=1,3
            a(i) = a(i)*scale/rlen
         end do
      endif

      return
      end

      subroutine vscal(a,n,scale)
      implicit real (a-h,o-z), integer (i-n)
      dimension a(n)


      do i=1,n
         a(i) = a(i)*scale
      end do

      return
      end

      subroutine vcpy(a,b,n)
      implicit real (a-h,o-z), integer (i-n)
      dimension a(n),b(n)

      do i=1,n
         a(i) = b(i)
      end do

      return
      end

      subroutine vadd(a,b,c,n)
      implicit real (a-h,o-z), integer (i-n)
      dimension a(n),b(n),c(n)

      do i=1,n
         c(i) = a(i) + b(i)
      end do

      return
      end

      subroutine vsub(a,b,c,n)
      implicit real (a-h,o-z), integer (i-n)
      dimension a(n),b(n),c(n)

      do i=1,n
         c(i) = a(i) - b(i)
      end do

      return
      end

      subroutine vseti(ia,n,ival)
      implicit real (a-h,o-z), integer (i-n)
      dimension ia(n)

      do i=1,n
         ia(i) = ival
      end do

      return
      end

      subroutine vsetr(a,n,rval)
      implicit real (a-h,o-z), integer (i-n)
      dimension a(n)

      do i=1,n
         a(i) = rval
      end do

      return
      end

      real function vlen(a)
      implicit real (a-h,o-z)
      dimension a(3)

      tot = a(1)*a(1)+a(2)*a(2)+a(3)*a(3)
      vlen = 0.0e0
      if (tot.gt.0.0e0) vlen = sqrt(tot)

      return
      end
      subroutine impsc(a,b,c)
      implicit real (a-h,o-z)
      dimension a(3),b(3)

      rimp = 0.0e0
    
      do i=1,3
         rimp = rimp + a(i)*b(i)
      end do

      al = vlen(a)
      bl = vlen(b)

      if (al.gt.0.0e0.and.bl.gt.0.0e0) then
         c = rimp/(al*bl)
      else
         c = 0.0e0
      endif

      return
      end

      subroutine timpsc(a,b,c)
      implicit real (a-h,o-z)
      dimension a(3),b(3)

      c = 0.0e0
    
      do i=1,3
         c = c + a(i)*b(i)
      end do

      return
      end

      character*2 function tocapf(line)
      character*2 line

      tocapf = line

      do i=1,2
         j = ichar(tocapf(i:i))
         if (j.ge.97.and.j.le.122) tocapf(i:i) = char(j-32)
      end do

      return
      end

      character*2 function tolowf(line)
      character*2 line

      tolowf = line

      do i=1,2
         j = ichar(tolowf(i:i))
         if (j.ge.65.and.j.le.90) tolowf(i:i) = char(j+32)
      end do

      return
      end

      integer function icdex(line,name)
      character*(*) line,name
      character*80 caps
      character*137 cline

      il1 = len(line)
      if (il1.gt.137) il1 = 137
      il2 = len(name)
      if (il2.gt.80) il2 = 80

      cline(1:il1) = line
      caps(1:il2) = name
      call tocap(cline,il1)
      call tocap(caps,il2)

      icdex = index(cline(1:il1),caps(1:il2))

      return
      end

      subroutine tocap(line,ncars)
      integer ncars
      character*(*) line

      do i=1,ncars
         j = ichar(line(i:i))
         if (j.ge.97.and.j.le.122) line(i:i) = char(j-32)
      end do

      return
      end

      subroutine zerstr(inum,str,isiz)
      integer inum,i,j,isiz,iwrk,ibig,icnt
      character*(*) str

      do i=1,isiz
         str(i:i) = char(48)
      end do

      iwrk = inum
      do i=isiz,1,-1
         ibig = 10**(i-1)
         if (ibig.le.iwrk) then
            icnt = iwrk/ibig
            j = isiz-i+1
            str(j:j) = char(48+icnt)
            iwrk = iwrk - icnt*ibig
         endif
      end do
      
      return
      end      

      subroutine fndchr(str,ilen,chr,ic)
      implicit real (a-h,o-z), integer (i-n)
      character*(*) str
      character*1 chr
      
      ic = 0
      do i=ilen,1,-1
         if (str(i:i).eq.chr) then
            ic = i
            return
         endif
      end do

      return
      end      

       logical function gargpl(fl,n,strng1,strng2)
       integer n,fln
       character*(*) fl
       character*(*) strng1,strng2

       gargpl = .false.
       
       fln = len(fl)
       if (strng1(1:fln).ne.fl) return 
       if (strng1(fln+1:fln+1).eq.' ') then
           n = n + 1
           call getarg(n,strng2)
           if (strng2(1:1).eq.'-'.or.strng2(1:1).eq.' ') return
           strng2 = strng2(1:index(strng2,' ')-1)
       else
           strng2 = strng1(fln+1:index(strng1,' ')-1)
       endif
       gargpl = .true.

       return
       end

      subroutine dumzz(cc,ianc,natoms,
     &              bl,alph,bet,ibl,ialph,ibet,imap,iann,iz,
     &              c,cz,alpha,beta,ian,coo,iresid,issdon)

c this is really dumzm

      implicit double precision (a-h,o-z)
      logical ottest, oerror, dozme
      common /athlp/ iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      common /zmpart/ ipart,imn,imx,idcur
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /cllab/ iclon,iclpnt(4)
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      dimension ian(*),c(3,*),cz(3,*),alpha(*),beta(*)
      dimension cc(3,*),ianc(*),imkeep(3)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),iann(*),iz(4,*)
      dimension cm(3,3),dum(3)
      dimension coo(3,*),iresid(*)

c
c     Convert Z-matrix to coordinates
c
      if (ialtyp.eq.1) then
         nstrt = mxnat-nscnd

         do i=1,3
            imkeep(i) = imap(i) - iscst
            do j=1,3
               cm(j,i) = coo(j,nstrt + imkeep(i))
               cz(j,i) = coo(j,nstrt + imkeep(i))
            end do
         end do
      else
         if (imap(1).eq.0.or.imap(2).eq.0.or.imap(3).eq.0) then
           do i=1,3
              imap(i) = i
           end do
         endif
         do i=1,3
            imkeep(i) = imap(i)
            do j=1,3
               cm(j,i) = coo(j,imap(i))
               cz(j,i) = coo(j,imap(i))
            end do
         end do
      endif

      if (idcur.eq.1) call curs(1)
      maxnz = mxzat
      ottest=.true.

      call stoc(maxnz,nz,ipart,imn,imx,iann,iz,bl,alph,bet,
     &        ottest,jatoms,ian,c,cz,imap,alpha,beta,
     &        oerror,.true.,.true.)

      if (.not.oerror) then

         issdon = 0
         iclon = 0
         ihaszm = 1

         if (ialtyp.eq.1) then

            nscnd = jatoms
            nstrt = mxnat-nscnd
            natoms = iscst + nscnd

c        Determine whether imap refers to protein+lig or lig

            idorem = 1
            do i=1,3
               if (imap(i).gt.iscst) idorem = 0
            end do

            if (idorem.eq.1) then
               do i=1,jatoms
                  imap(i) = imap(i) + iscst
               end do
            endif

         else

c            if (ipart.eq.1) then
c               jatoms = natoms
c            elseif (ipart.eq.2) then
c
c distinction between ipart=1 and 2 lost, gives problems
c since because of fake sec.struc atoms, natoms also contain fake atoms
c
            if (ipart.ne.0) then
               jatoms = nz
               natoms = nz
            else
               natoms = jatoms
            endif
            nstrt = 0
         endif

         do i=1,jatoms

            do j=1,3
               cc(j,nstrt+i) = c(j,i)
            end do

            ianc(nstrt+i) = ian(i)

            if (ialtyp.eq.1) then
               ianc(iscst+i) = ian(i)
               iresid(iscst+i) = -4
            else
               if (ipdbon.ne.1) then
                  if (iresid(iscst+i).eq.0) iresid(iscst+i) = -4
               endif
            endif

         end do
         
         call rdmapf(cm,imkeep,ierr)

         if (ialtyp.eq.1) then
            call alnrot(dum,1)
         else
            call zm2fr(cm,c,imkeep)
         endif

      else

         call inferr('ERROR Zmat NOT parsed !!',1)

      endif

c set to whole zmatrix parsing next time around

      ipart = 0
      if (idcur.eq.1) call curs(0)

      return
      end

      subroutine prtzz(bl,alph,bet,ibl,ialph,ibet,imap,ianz,iz)

c this is really prtzm

      parameter (mxel=100)
      implicit double precision (a-h,o-z)
c
      common /zmfrst/ ihaszm, nz, mxzat

      character*2 elemnt
      common /elem/elemnt(mxel)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianz(*),iz(4,*)

      print*,'nz=',nz
      do i=1,nz
         print*,elemnt(ianz(i)),iz(1,i),bl(i),iz(2,i),alph(i),iz(3,i),
     &          bet(i)
      end do

      return
      end

      subroutine chkmzz(istat,qat,rzp,ianzz,imap,ianz,lring,ityp,ipdbt)

c this is really chkmap

      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      integer*2 ityp,ipdbt
      common /types/ iff
      dimension ianzz(*),imap(*), qat(*), rzp(*)
      dimension ianz(*),ityp(*),ipdbt(*),lring(*)
c
c check if zmatrix ordering corresponds to coo ordering
c if not convert z-matrix to coo
c
c (mis)use lring array
c

      istat = 0

      if (ihaszm.eq.0) goto 100

      istat = 1

      if (nz.ne.iatoms) return

      do i=1,iatoms
        if (ianz(i).ne.ianzz(i)) goto 200
      end do

100   istat = 0
      return

200   if (iff.ne.0) then
         do i=1,iatoms
            lring(i) = ityp(i)
         end do
         do i=1,nz
            ityp(i) = lring(imap(i))
         end do
         do i=1,iatoms
            lring(i) = ipdbt(i)
         end do
         do i=1,nz
            ipdbt(i) = lring(imap(i))
         end do
         do i=1,iatoms
            rzp(i) = qat(i)
         end do
         do i=1,nz
            qat(i) = rzp(imap(i))
         end do
c have misused the rzp array, so we must restore it
         call qupd
      endif

      return
      end

      subroutine rdmapf(cm,imap,ierr)
      implicit double precision (a-h,o-z)
      logical opfil
      integer getlin
      character*137 line
      character*137 string
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /gtmfil/ igtfil
      dimension cm(3,3),imap(3)
      dimension cmt(3,3),imapt(3)

c     igtfil.eq.1 triggered by a keypress 'c'

      if (igtfil.eq.0) return

      toang = 0.52917706d0
      ierr = 0
      iform = 1
      if (opfil(46,'mapfile',7,iform,1,1)) then
         print*,'opened file mapfile'
         iuntmp = iun2
         iun2 = 46
         do i=1,3
             ii = getlin(0)
             ktype = nxtwrd(string,nstr,itype,rtype)
             if (ktype.eq.2) then
                imapt(i) = itype
             else
                ierr = 1
                goto 100
             endif
             do j=1,3
                ktype = nxtwrd(string,nstr,itype,rtype)
                if (ktype.eq.3) then
                   cmt(j,i) = rtype/toang
                else
                   ierr = 1
                   goto 100
                endif
             end do
         end do
100      close(46)
         iun2 = iuntmp
         do i=1,3
             imap(i) = imapt(i)
             do j=1,3
                cm(j,i) = cmt(j,i)
             end do
         end do
         if (ierr.eq.1) print*,'error reading mapfile'
      else
         print*,'could read mapfile'
      endif

      return
      end

      subroutine runjob(imod,iqopt,ihaszm)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      character*80 glin1,glin2,gtitl,rungam
      character*15 jname,qname
      common /gauopt/ ito,imo,ibo,itotc,imult,ibatch,ihess,itime,
     &                iwxyz,ichh,ichm,ichl,imh,imm,iml,iexk,
     &                glin1,glin2,gtitl,jname,qname,rungam
      common /athlp/  iatoms, mxnat
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm,icst
      common /types/ iff
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /pbc/ abc(3),ibox,icell,igfmap
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*80 taroot
      character*80 pwd
      character*80 user
      character*11 ename
      character*80 outfil
      character*137 line
      logical mapxyz,opfil,domap
      
      izmtmp = ihaszm

      jlen = linlen(jname)
      iqlen = linlen(qname)
      itnkln = linlen(tnknm)

      ename = 'PWD'
      call getenv(ename,pwd)

      ig94 = 1
      itnk = 0
      if (imod.eq.1) then
         ename = 'TA_ROOT'
      elseif (imod.eq.2) then
         ename = 'QNT_ROOT'
      elseif (imod.eq.3) then
         ename = 'TNK_ROOT'
      elseif (imod.eq.4) then
         ename = 'GAMESS_ROOT'
      elseif (imod.eq.5) then
         ename = 'g94root'
      elseif (imod.eq.6) then
         ename = 'MOPAC_ROOT'
      elseif (imod.eq.7) then
         ename = 'XTINKER'
      elseif (imod.eq.8) then
         ename = 'AMBFOR'
      elseif (imod.eq.9) then
         ename = ''
      endif

      call getenv(ename,taroot)
      if (taroot(1:1).eq.' ') then
          if (imod.eq.1) then
            call inferr('Environment variable TA_ROOT not set !',0)
            call zmterr('Environment variable TA_ROOT not set !',1,0,1)
          elseif (imod.eq.2) then
            call inferr('Environment variable QNT_ROOT not set !',0)
            call zmterr('Environment variable QNT_ROOT not set !',1,0,1)
          elseif (imod.eq.3) then
            call inferr('Environment variable TNK_ROOT not set !',0)
            call zmterr('Environment variable TNK_ROOT not set !',1,0,1)
          elseif (imod.eq.4) then
            call inferr('Environment variable GAMESS_ROOT not set !',0)
            call zmterr('Environment variable GAMESS_ROOT not set !',1,
     &                  0,1)
          elseif (imod.eq.5) then

c ig94   0  => g92
c ig94   1  => g94
c ig94   2  => g98
c ig94   3  => g03
c ig94   4  => g09
c ig94   5  => g16

            ename = 'g92root'
            call getenv(ename,taroot)
            if (taroot(1:1).eq.' ') then
               ename = 'g98root'
               call getenv(ename,taroot)
            else
               ig94 = 0
            endif
            if (taroot(1:1).eq.' ') then
               ename = 'g03root'
               call getenv(ename,taroot)
            else
               ig94 = 2
            endif
            if (taroot(1:1).eq.' ') then
               ename = 'g09root'
               call getenv(ename,taroot)
            else
               ig94 = 3
               goto 10
            endif
            if (taroot(1:1).eq.' ') then
               ename = 'g16root'
               call getenv(ename,taroot)
            else
               ig94 = 4
               goto 10
            endif
            if (taroot(1:1).eq.' ') then
               call inferr(
     &'Environment variable g92/g94/g98/g03/g09/g16root not set !',0)
               call zmterr(
     &'Environment variable g92/g94/g98/g03/g09/g16root not set !',
     &              1,0,1)
               goto 10
            else
               ig94 = 5
               goto 10
            endif
          elseif (imod.eq.6) then
            call inferr('Environment variable MOPAC_ROOT not set !',0)
            call zmterr('Environment variable MOPAC_ROOT not set !',1,
     &                   0,1)
          elseif (imod.eq.7) then
            ename = 'TNK_ROOT'
            call getenv(ename,taroot)
            if (taroot(1:1).eq.' ') then
               call inferr(
     &         'Environment variable TNK_ROOT/XTINKER not set !',0)
            else
               itnk = 1
               goto 10
            endif
          elseif (imod.eq.8) then
            taroot = '/usr/local/bin/'
            goto 10
          elseif (imod.eq.9) then
            goto 10
          endif
          return
      endif
10    itlen = linlen(taroot)

      iun = 50
      iuncln = 51

      if (imod.eq.1) then
         ixyz = 1
         call wrpnt('molin.mol2',10,4,0,0,0,0,1,0)
      elseif (imod.eq.2) then
         ixyz = 2
         call wrpnt('molin.msf',9,4,0,0,0,0,1,0)
      elseif (imod.eq.3) then
         ixyz = 3
         call wrpnt(tnknm(1:itnkln)//'.xyz',itnkln+4,4,0,0,0,0,1,0)
      elseif (imod.eq.4) then
         call wrpnt(jname(1:jlen)//'.in',1,19,0,0,0,0,1,0)
      elseif (imod.eq.5) then
         call wrpnt(jname(1:jlen)//'.com',1,20,0,0,0,0,1,0)
      elseif (imod.eq.6) then
         call wrpnt(jname(1:jlen)//'.dat',1,21,0,0,0,0,1,0)
      elseif (imod.eq.7) then
         if (iff.ne.1) then
             iff = 1
             call dotyp(1)
         endif
         ixyz = 5
         call wrpnt(tnknm(1:itnkln)//'.cssr',itnkln+5,4,0,0,0,0,1,0)
         if (iqopt.eq.0) then
            call fdat(16,0,0,0,0,0)
         else
            call fdat(17,0,0,0,0,0)
         endif
         call fdat(ifd,0,0,0,0,0)
      elseif (imod.eq.8) then
         nwramb = iatoms
         ixyz = 11
         call wrpnt(tnknm(1:itnkln)//'.xyz'//char(0),
     &              itnkln+4,4,0,0,0,0,1,0)
      elseif (imod.eq.9) then
c         call wrpnt(tnknm(1:itnkln)//'.run',itnkln+4,4,0,0,0,0,1,0)
         call getenv('USER',user)
         lu = linlen(user)

c create temporary user dir

         taroot = 'sh -c "[ ! -d /tmp/$USER ] && mkdir /tmp/$USER;"'
         nstr = linlen(taroot)
         iextmp = 0
         call exstr(taroot,nstr,iextmp)
         call wrpnt('/tmp/'//user(1:lu)//'/'//tnknm(1:itnkln)//'.nw',
     &              itnkln+lu+9,22,0,0,0,0,1,0)
      endif

      if (imod.ne.8) then
         if (imod.ge.3) then
            if (imod.eq.3.or.imod.eq.7) then
               open(unit=iun,form='formatted',
     &           file=tnknm(1:itnkln)//'.run',
     &           status='unknown',err=100)
               open(unit=iuncln,form='formatted',file='clnjob',
     &           status='unknown',err=100)
            else
               open(unit=iun,form='formatted',
     &           file=jname(1:jlen)//'.run',
     &           status='unknown',err=100)
            endif
         else
            open(unit=iun,form='formatted',file='runjob',
     &           status='unknown',err=100)
         endif
      endif

      if (imod.eq.1) then
         call runsyb(iun)
      elseif (imod.eq.2) then
         call runqnt(iun)
      elseif (imod.eq.3.or.imod.eq.7) then
         call runtnk(iun,iuncln,imod,itnkln,itnk)
      elseif (imod.eq.4) then
         call rungams(iun,rungam)
      elseif (imod.eq.5) then
         call rungau(iun,ig94)
      elseif (imod.eq.6) then
         call runmop(iun,pwd,taroot)
      elseif (imod.eq.9) then
         call runnwc(iun,jname,tnknm)
      endif

      if (imod.ne.8) close(iun)

c make jobscript executable

      if (imod.ge.3) then
         if (imod.eq.3.or.imod.eq.7) then
            taroot = 'chmod u+x '//tnknm(1:itnkln)//'.run'
            nstr = itnkln+14
         else
            taroot = 'chmod u+x '//jname(1:jlen)//'.run'
            nstr = jlen+14
         endif
      else
         taroot = 'chmod u+x runjob'
         nstr = 16
      endif

      iextmp = 0
      if (imod.ne.8) call exstr(taroot,nstr,iextmp)

c prepare cleaning up

      if (imod.eq.3.or.imod.eq.7) then
         taroot = 'chmod u+x clnjob'
         nstr = 16
         iextmp = 0
         call exstr(taroot,nstr,iextmp)
         taroot = '.'//char(47)//'clnjob'
         nstr = 8
         iextmp = 0
         call exstr(taroot,nstr,iextmp)
      endif

c are you ready ?

      if (imod.ne.3.and.imod.ne.7.and.imod.ne.8) call curs(1)
      call confrm(0,istat)
      if (istat.ne.1) then
          call curs(0)
          return
      endif

      if (imod.ge.3.and.imod.ne.8) then
         if (imod.eq.6.and.ibatch.eq.0) then
            taroot = 'qsub -eo -q '//qname(1:iqlen)//' '//
     &               jname(1:jlen)//'.run'
            nstr = jlen+iqlen+17
         else
            if (imod.eq.3.or.imod.eq.7) then
               taroot = '.'//char(47)//tnknm(1:itnkln)//'.run'
               nstr = itnkln+6
               if (tnkbg.eq.0) then
                   taroot = tnknm(1:itnkln)
                   nstr = itnkln
               endif
            else
               taroot = '.'//char(47)//jname(1:jlen)//'.run'
               nstr = jlen+6
            endif
         endif
      elseif (imod.eq.8) then
         taroot = 
     &      'ambfor '//tnknm(1:itnkln)//'.xyz'
         nstr = 7 + itnkln + 4
      else
        
         taroot = '.'//char(47)//'runjob'
         nstr = 8
      endif

c execute or batching of jobscript

      iextmp = 0
      if (imod.lt.3.or.(imod.ge.4.and.ibatch.eq.0).or.
     &    ((imod.eq.3.or.imod.eq.7).and.tnkbg.eq.0).or.
     &    (imod.eq.8.and.tnkbg.eq.0).or.
     &    (imod.eq.9.and.ibatch.eq.0)) then

         if ((imod.eq.3.or.imod.eq.7.or.imod.eq.8).and.
     &        tnkbg.eq.0) then

c    tinker in the background updating screen; also fork

            if (imod.eq.8) then
               taroot = tnknm(1:itnkln)
               nstr = itnkln
               iextmp = 3
               call exstr(taroot,nstr,iextmp)
            else
               iextmp = 2
               call exstr(taroot,nstr,iextmp)
            endif
         else

c    system

            iextmp = 0
            call exstr(taroot,nstr,iextmp)
         endif

      else

c    fork

         if (imod.eq.8) then
            taroot = tnknm(1:itnkln)
            nstr = itnkln
            iextmp = 4
         else
            iextmp = 1
         endif
         call exstr(taroot,nstr,iextmp)

      endif

      iexst = iextmp

c clean up tinker cycle files of a non detached job

      if ((imod.eq.3.or.imod.eq.7).and.tnkbg.eq.0) then
         open(unit=iuncln,form='formatted',file='clnjob',
     &     status='unknown',err=100)
         write(iuncln,'(''#!/bin/csh -f'')')
         if (tnkarc.eq.1) then
          if (imod.eq.3) then
            write(iuncln,*) '$TNK_ROOT/bin/archive '//tnknm(1:itnkln)
     &                     //' <<EOF >>& '//tnknm(1:itnkln)//'.log'
            write(iuncln,*) ' '
            write(iuncln,*) ' '
            write(iuncln,*) '1 1000 ',tnkarf
            write(iuncln,'(''EOF'')')
          else
            write(iuncln,*) 'cat '//tnknm(1:itnkln)//'.[0-9]* > '//
     &                    tnknm(1:itnkln)//'.arc'
          endif
         endif
         write(iuncln,*) 'unalias rm'
         write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.[0-9]*'
         write(iuncln,*) 'rm clnjob'
         close(iuncln)
         iextmp = 0
         taroot = 'chmod u+x clnjob'
         nstr = 16
         call exstr(taroot,nstr,iextmp)
         taroot = '.'//char(47)//'clnjob'
         nstr = 8
         call exstr(taroot,nstr,iextmp)
      endif


c open to be mapped file

      ierr = 0
      call tomap(imap,iambfr)
      if (imap.eq.0) ierr = 21 

      iform = 1
      domap = .true.
      if (imod.eq.1) then
         nstr = 11
         outfil = 'molout.mol2'
      elseif (imod.eq.2) then
         iform = 0
         nstr = 9
         outfil = 'molin.msf'
      elseif (imod.eq.3.and.tnkbg.eq.0.and.iexst.ne.-1) then
         nstr = itnkln+6
         outfil = tnknm(1:itnkln)//'.xyz_2'
      elseif (imod.eq.7.and.tnkbg.eq.0.and.iexst.ne.-1) then
         nstr = itnkln+7
         outfil = tnknm(1:itnkln)//'.cssr_2'
c      elseif (imod.eq.8.and.tnkbg.eq.0.and.iexst.ne.-1) then
      elseif (imod.eq.8.and.tnkbg.eq.0) then
         nstr = itnkln+8
         outfil = tnknm(1:itnkln)//'_opt.xyz'
         if (igfmap.ne.1.or.icell.eq.1) izmtmp = 0

c check for ambfor md run, does not need to map _opt file:

         call tomap(imap,iambfr)
         if (imap.eq.0) domap = .false.

      else
         domap = .false.
      endif

      if (domap) then
         if (opfil(iun,outfil,nstr,iform,1,0)) then
             rewind(iun)
         else
             ierr = 1
             goto 50
         endif
      else
         goto 50
      endif

c map the file onto the z-matrix, or just read it in

      if (imod.ne.4.and..not.
     &    ((imod.eq.3.or.imod.eq.7.or.imod.eq.8)
     &      .and.tnkbg.eq.1)) then
         ierr = 1
         call tomap(imap,iambfr)
         if (imap.eq.0) ierr = 21 

         if (iexst.ne.-1) iexst = imod
         if (mapxyz(iun,iexst,iff,izmtmp)) ierr = 0
         if (iexst.eq.-1) then
            ierr = 20
            call dohcon(0)
         else
            if (imod.eq.7) call fdat(ifd,0,0,0,0,0)
         endif
      endif
      if (domap) close(iun)

c check for tinker error conditions (non detached job)

50    if ((imod.eq.3.or.imod.eq.7)
     &   .and.tnkbg.eq.0.and.iexst.ne.-1) then
         if (opfil(iun,tnknm(1:itnkln)//'.log',itnkln+4,1,1,0)) then
             iuntmp = iun2
             iun2 = iun
             call searcht(line,'MECHANIC','Incomplete Convergence',
     &                'Too many Parameters',istat)
             if (istat.ne.0) then
                if (index(line,'MECHANIC').ne.0) then
                   ierr = 2
                elseif (index(line,'Incomplete Convergence').ne.0) then
                   ierr = 3
                elseif (index(line,'Too many Parameters').ne.0) then
                   ierr = 4
                endif
             endif
             close(iun)
             iun2 = iuntmp
         endif
      endif
      if ((imod.eq.3.or.imod.eq.7).and.iexst.eq.-1) ierr = 5

      if ((imod.ge.4.and.imod.lt.7).or.
     &   ((imod.eq.3.or.imod.eq.7.or.imod.eq.8.or.imod.eq.9)
     &   .and.tnkbg.eq.1)) ierr = 6
 
      if (imod.ne.3.and.imod.ne.7.and.imod.ne.8) call curs(0)

c popup status message

      call after_sub()
      call messg(ierr)
      call upajob

      return

100   call inferr('Error opening file !',0)
      return
      end

      subroutine runnwc(iun,jname,tnknm)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*15 jname
      character*80 tnknm
      character curdir*1024
      common /cwd/ curdir

      jlen = linlen(jname)
      itnkln = linlen(tnknm)
      iclen = linlen(curdir)

      write(iun,'(''#!/bin/csh'')')
      write(iun,*) 'cd '//curdir(1:iclen)
      write(iun,*) 'mkdir '//jname(1:jlen)
      write(iun,*) 'cd '//jname(1:jlen)
      write(iun,*) '\mv /tmp/$USER/'//tnknm(1:itnkln)//'.nw .'
      write(iun,*) 'nwchem '//tnknm(1:itnkln)//'.nw >& '//
     &              tnknm(1:itnkln)//'.nwout'

      return
      end

      subroutine runmop(iun,pwd,taroot)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*80 pwd,taroot
      character*80 glin1,glin2,gtitl,rungam
      character*15 jname,qname
      common /gauopt/ ito,imo,ibo,itotc,imult,ibatch,ihess,itime,
     &                iwxyz,ichh,ichm,ichl,imh,imm,iml,iexk,
     &                glin1,glin2,gtitl,jname,qname,rungam

      jlen = linlen(jname)
      itlen = linlen(taroot)

      write(iun,'(''#!/bin/csh'')')
      write(iun,*) "cd "//pwd(1:linlen(pwd))
      write(iun,*) "set pth="//taroot(1:itlen)//""
      write(iun,*) "if -f $pth/bin/mopac.csh then"
      write(iun,*) "   set mop = bin/mopac.csh"
      write(iun,*) "endif"
      write(iun,*) "if -f $pth/mopac.csh then"
      write(iun,*) "   set mop = mopac.csh"
      write(iun,*) "endif"
      write(iun,*) "if -f $pth/runmopac then"
      write(iun,*) "   set mop = runmopac"
      write(iun,*) "endif"
      write(iun,*) "${pth}/${mop} test  >& /dev/null"

      return
      end

      subroutine rungau(iun,ig94)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*80 glin1,glin2,gtitl,rungam
      character*15 jname,qname
      common /gauopt/ ito,imo,ibo,itotc,imult,ibatch,ihess,itime,
     &                iwxyz,ichh,ichm,ichl,imh,imm,iml,iexk,
     &                glin1,glin2,gtitl,jname,qname,rungam
      character curdir*1024
      common /cwd/ curdir

      jlen = linlen(jname)
      iqlen = linlen(qname)
      iclen = linlen(curdir)

      write(iun,'(''#!/bin/csh'')')
      write(iun,*) 'cd '//curdir(1:iclen)

      if (ig94.eq.1) then

            write(iun,*) 'source $g94root/g94/bsd/g94.login'

            if (ibatch.eq.1) then
               write(iun,*) 'g94 '//jname(1:jlen)
            else
               write(iun,*) 'subg94 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif

      elseif (ig94.eq.2) then

            write(iun,*) 'source $g98root/g98/bsd/g98.login'
            if (ibatch.eq.1) then
               write(iun,*) 'g98 '//jname(1:jlen)
            else
               write(iun,*) 'subg98 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif

      elseif (ig94.eq.3) then

            write(iun,*) 'source $g03root/g03/bsd/g03.login'
            if (ibatch.eq.1) then
               write(iun,*) 'g03 '//jname(1:jlen)
            else
               write(iun,*) 'subg03 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif

      elseif (ig94.eq.4) then

            write(iun,*) 'source $g09root/g09/bsd/g09.login'

            if (ibatch.eq.1) then
               write(iun,*) 'g09 '//jname(1:jlen)
            else
               write(iun,*) 'subg09 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif

      elseif (ig94.eq.5) then

            write(iun,*) 'source $g16root/g16/bsd/g16.login'

            if (ibatch.eq.1) then
               write(iun,*) 'g16 '//jname(1:jlen)
            else
               write(iun,*) 'subg16 '//qname(1:iqlen)//' '
     &                      //jname(1:jlen)
            endif

      else

            write(iun,*) 'source $g92root/g92/bsd/g92.login'
            if (ibatch.eq.1) then
               write(iun,*) 'g92 '//jname(1:jlen)
            else
               write(iun,*) 'subg92 '//qname(1:iqlen)//' '//
     &                       jname(1:jlen)
            endif

      endif

      write(iun,*) ' '
      write(iun,*) ' '
      write(iun,*) ' '

      return
      end

      subroutine rungams(iun,rungam)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*80 rungam
      character curdir*1024
      common /cwd/ curdir

      iclen = linlen(curdir)

      write(iun,'(''#!/bin/csh'')')
      write(iun,*) 'cd '//curdir(1:iclen)
      write(iun,'(a)') rungam(1:linlen(rungam))

      return
      end

      subroutine runtnk(iun,iuncln,imod,itnkln,itnk)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm,icst
      common /types/ iff
      character curdir*1024
      common /cwd/ curdir

      iclen = linlen(curdir)

      write(iuncln,'(''#!/bin/csh -f'')')
      write(iuncln,*) 'cd '//curdir(1:iclen)
      write(iuncln,*) 'unalias rm'
      write(iuncln,*) 'if ( -e '//tnknm(1:itnkln)//
     &                ' ) mv '//tnknm(1:itnkln)//' '//
     &                tnknm(1:itnkln)//'.bck'

      if (imod.eq.3) then
         write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.xyz_*'
      else
         write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.cssr_*'
      endif

      write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.[0-9]*'
      write(iuncln,*) 'rm '//tnknm(1:itnkln)//'.arc*'
      close(iuncln)

      write(iun,'(''#!/bin/csh -f'')')
      write(iun,*) 'cd '//curdir(1:iclen)
      write(iun,*) 'unalias rm'
      write(iun,*) 'rm clnjob'
      write(iun,*) 'setenv AMBER amber'
      write(iun,*) 'setenv CHARMM charmm'
      write(iun,*) 
     &  'if ( -f $TNK_ROOT/params/amber99.prm ) setenv AMBER amber99'
      write(iun,*) 
     &  'if ( -f $TNK_ROOT/params/charmm27.prm ) setenv CHARMM charmm27'

      if (imod.eq.3) then

        write(iun,*) 'cat <<EOF > '//tnknm(1:itnkln)//'.key'

        if (iff.le.1) then

         write(iun,*) 'parameters $TNK_ROOT/params/mm3'
         write(iun,*) 'torsion       5   2   3   6       '//
     &                '0.000 +1     8.000 -2     0.000 +3'
         write(iun,*) 'torsion       2   3   6  24       '//
     &                '0.000 +1     0.500 -2     0.000 +3'
         write(iun,*) 'angle         1    3    77    '//
     &                '0.850    123.500    123.500      0.000'
         write(iun,*) 'angle         1    3    78    '//
     &                '0.850    123.500    123.500      0.000'
         write(iun,*) 'angle         5    1    75    '//
     &                '0.820    110.000    108.900    108.700'
         write(iun,*) 'opbend        3    77         0.650'
         write(iun,*) 'opbend        3    78         0.650'

        elseif (iff.eq.2) then

         write(iun,*) 'parameters $TNK_ROOT/params/$CHARMM'

        elseif (iff.eq.3) then

         write(iun,*) 'parameters $TNK_ROOT/params/$AMBER'

        elseif (iff.eq.4) then

         write(iun,*) 'parameters $TNK_ROOT/params/amoebapro.prm'

        endif

        if (.not.(tnkbg.eq.1.and.tnkarc.eq.0)) 
     &     write(iun,*) 'save-cycle'
        write(iun,*) 'maxiter ',tnkit
        if (tnkprg.eq.5) write(iun,*) 'saddlepoint'
        write(iun,'(''EOF'')')

      else

        write(iun,*) 'cat < tnk.key > '//tnknm(1:itnkln)//'.key'
        write(iun,*) 'rm tnk.key'
        write(iun,*) 'cat <<EOF >>'//tnknm(1:itnkln)//'.key'
        if (.not.(tnkbg.eq.1.and.tnkarc.eq.0)) 
     &     write(iun,*) 'save-cycle'
        write(iun,*) 'maxiter ',tnkit
        write(iun,*) 'writeout 1'
        if (tnkprg.eq.5) write(iun,*) 'saddlepoint'
        write(iun,'(''EOF'')')

      endif

      if (tnkprg.eq.0) then

         write(iun,*) '$TNK_ROOT/bin/minimize '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'

      elseif (tnkprg.eq.1) then

         write(iun,*) '$TNK_ROOT/bin/optimize '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'

      elseif (tnkprg.eq.2.or.tnkprg.eq.5) then

         write(iun,*) '$TNK_ROOT/bin/newton '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         write(iun,*) ' '
         write(iun,*) ' '

      elseif (tnkprg.eq.3) then

         write(iun,*) '$TNK_ROOT/bin/dynamic '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         write(iun,*) '10000'
         write(iun,*) ' '
         write(iun,*) ' '
         write(iun,*) ' '
         write(iun,'(''EOF'')')

      elseif (tnkprg.eq.4) then

         if (itnk.eq.1) then
            write(iun,*) '$TNK_ROOT/bin/xxtalmins c '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         else
            write(iun,*) '$XTINKER/bin/xxtalmins c '//tnknm(1:itnkln)
     &                //' <<EOF >& '//tnknm(1:itnkln)//'.log'
         endif

      endif

      if (tnkprg.lt.3.or.tnkprg.eq.4) then
         write(iun,'(f12.8)') rmsgrd
         write(iun,'(''EOF'')')
      endif

      if (tnkbg.eq.1.and.tnkarc.eq.1) then
         if (imod.eq.3) then
            write(iun,*) '$TNK_ROOT/bin/archive '//tnknm(1:itnkln)
     &                   //' <<EOF >>& '//tnknm(1:itnkln)//'.log'
            write(iun,*) ' '
            write(iun,*) ' '
            write(iun,*) '1 1000 ',tnkarf
            write(iun,'(''EOF'')')
         else
            write(iun,*) 'cat '//tnknm(1:itnkln)//'.[0-9]* > '//
     &                    tnknm(1:itnkln)//'.arc'
         endif
         write(iun,*) 'rm '//tnknm(1:itnkln)//'.[0-9]*'
      endif

      return
      end

      subroutine runqnt(iun)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character curdir*1024
      common /cwd/ curdir

      iclen = linlen(curdir)

      write(iun,'(''#!/bin/csh'')')
      write(iun,*) 'cd '//curdir(1:iclen)
      write(iun,*) 'unalias mv'
      write(iun,*) 'unalias rm'
      write(iun,*) 'source /compchem/1/msi/quanta96/.setquanta'
      write(iun,*) 'mkdir qnt$$'
      write(iun,*) 'cd qnt$$'
      write(iun,*) 'cat <<EOF > quanta.scr'
      write(iun,*) 'mole init molin.msf'
      write(iun,*) 'charm init'
      write(iun,*) 'charm writ psf'
      write(iun,*) 'charm set mini nstep 1000'
      write(iun,*) 'charm do mini'
      write(iun,*) 'msf save over'
      write(iun,*) 'end'
      write(iun,'(''EOF'')')
      write(iun,*) 'cp $HYD_LIB/default.cst .cst'
      write(iun,*) 'mv ../molin.msf .'
      write(iun,*) 'chmod u+rwx .cst'
      write(iun,*) 'quanta -n -i quanta.scr -l quanta >& /dev/null'
      write(iun,*) 'mv molin.msf ..'
      write(iun,*) 'mv quanta.log ..'
      write(iun,*) 'cd ..'
      write(iun,*) 'unalias rm'
      write(iun,*) 'rm -rf qnt$$'
      return
      end

      subroutine runsyb(iun)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character curdir*1024
      common /cwd/ curdir

      iclen = linlen(curdir)

      write(iun,'(''#!/bin/sh'')')
      write(iun,*) 'cd '//curdir(1:iclen)
      write(iun,*) 'rm molout.mol2'
      write(iun,*) '. $TA_ROOT/lib/.profile'
      write(iun,*) '$TA_ROOT/bin/sybyl << EOF > molout.log'
      write(iun,*) 'tailor set mol file_format mol2 | |'
      write(iun,*) 'set autosave off'
      write(iun,*) 'mol in M1 molin.mol2'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!MINIMIZATION_METHOD POWELL'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!TERMINATION_OPTION GRADIENT'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!MIN_ENERGY_CHANGE  0.050'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!RMS_GRADIENT  0.050'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!RMS_DISPLACEMENT  0.001'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!MAXIMUM_ITERATIONS 1000'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!PARAMETER_SET Tripos'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!NON_BONDED_CUTOFF 8.0'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!DIELECTRIC_CONSTANT 1.0'
      write(iun,*) 
     &  'SETVAR TAILOR!FORCE_FIELD!DIELECTRIC_FUNCTION distance'
      write(iun,*) 
     &  'SETVAR TAILOR!FORCE_FIELD!REVIEW_HS_AND_LPS DO_NOT_CHANGE'
      write(iun,*) 'SETVAR TAILOR!MAXIMIN2!LIST_TERMS NO'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!ONE_FOUR_SCALING 1.0'
      write(iun,*) 'SETVAR TAILOR!FORCE_FIELD!HBOND_RAD_SCALING 0.7'
      write(iun,*) 'MAXIMIN2 M1 Electrostatics IGNORE_ELECTROSTATICS ',
     &             char(92)
      write(iun,*) 'Interesting M1(*-(0)) Boundary_Conditions ',char(92)
      write(iun,*) 'IGNORE_PBCS List DONE INTERACTIVE'
      write(iun,*) 'mol out M1 molout.mol2'
      write(iun,'(''EOF'')')
      return
      end

      subroutine tnkpnt(itmpon,ipnt,iret)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm,icst
      common /types/ iff
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character moldroot*512
      common /mldroot/ moldroot
      character*512 tnkfil
      character*3 tstr
      character*4 ttstr
      character*5 tttstr
      logical opfil

      iret = 0
      idummy = 0
      
      jlen = linlen(tnknm)
      jlent = jlen
      mlen = linlen(moldroot)

      if (ipnt.eq.-1) then
         if (itmpon.eq.1) then
            tnkfil = moldroot(1:mlen)//tnknm(1:jlen)//'.tmp'
            jlen = jlen + mlen + 1 + 3
         else
            tnkfil = tnknm(1:jlen)//'.tmp'
            jlen = jlen + 1 + 3
         endif
      elseif (ipnt.lt.1000) then
         call zerstr(ipnt,tstr,3,0)
         if (itmpon.eq.1) then
            tnkfil = moldroot(1:mlen)//tnknm(1:jlen)//'.'//tstr
            jlen = jlen + mlen + 1 + 3
         else
            tnkfil = tnknm(1:jlen)//'.'//tstr
            jlen = jlen + 1 + 3
         endif
      elseif (ipnt.lt.10000) then
         write(ttstr,'(i4)') ipnt
         if (itmpon.eq.1) then
            tnkfil = moldroot(1:mlen)//tnknm(1:jlen)//'.'//ttstr
            jlen = jlen + mlen + 1 + 4
         else
            tnkfil = tnknm(1:jlen)//'.'//ttstr
            jlen = jlen + 1 + 4
         endif
      elseif (ipnt.lt.100000) then
         write(ttstr,'(i5)') ipnt
         if (itmpon.eq.1) then
            tnkfil = moldroot(1:mlen)//tnknm(1:jlen)//'.'//tttstr
            jlen = jlen + mlen + 1 + 5
         else
            tnkfil = tnknm(1:jlen)//'.'//tttstr
            jlen = jlen + 1 + 5
         endif
      endif

      llen = jlen-jlent+8

      if (ixyz.eq.11) then
c ambfor
         do while (islck(ipnt).eq.1)
         end do

         if (ipnt.ne.1) then
            if (opfil(52,tnkfil,jlen,0,1,0)) then
                call rdbin(52,heat)
                iret = 1
                close(52)
            endif
         else

            if (opfil(52,tnkfil,jlen,1,1,0)) then
                iuntmp = iun2
                iun2 = 52
                call tnkfst(igttnk,0,1)
                if (igttnk.eq.1) iret = 1
                close(52)
                iun2 = iuntmp
            endif
         endif

      else

c tinker
         if (opfil(52,tnkfil,jlen,1,1,0)) then
             iuntmp = iun2
             iun2 = 52
             if (tnkprg.eq.4) then
                call rdchx(0,3,0,0,0,istat,icrtp)
                if (istat.gt.0) then
                   iret = 1
                   call fdat(ifd,0,0,0,0,0)
                endif
             else
                call gettnk(igttnk,0,idummy,iff,iheat,heat)
                if (igttnk.eq.1) iret = 1
             endif
             close(52)
             iun2 = iuntmp
         endif

      endif

      return
      end

      subroutine rdbid(iun,emin,coo,ianz,iatclr,iconn,ireord,
     &                  nat,norg,
     &                  xa,ya,yb,za,zb,zc,
     &                  a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      common /pbc/ abc(3),ibox,icell,igfmap
      real tmp,ar,br,cr,alphar,betar,gammar,emin
      dimension ireord(*),tmp(3)
      dimension coo(3,*),ianz(*),iatclr(*),iconn(mxcon+1,*)

      toang = 0.52917706d0

c read tinker coordinates binary form

      read(iun) natoms,emin

      jat = ntota

      do i=1,natoms
           read(iun,err=100,end=100) (tmp(j),j=1,3)

           if (i.gt.nwramb) then
              jat = jat + 1
              ire = jat
              if (ire.eq.0) ire = iat
           else
              ire = ireord(i)
              if (ire.eq.0) ire = iat
           endif

           if (ire.gt.0.and.ire.le.mxnat) then
              do j=1,3
                 coo(j,ire) = tmp(j)/toang
              end do
           endif
      end do

      if (icell.eq.1) then
           read(iun,err=100,end=100) ar,br,cr,alphar,betar,gammar
           a = dble(ar)
           b = dble(br)
           c = dble(cr)
           alpha = dble(alphar)
           beta = dble(betar)
           gamma = dble(gammar)
           call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,0)
           call cpmol2(nat,norg,xa,ya,yb,za,zb,zc,
     &                coo,ianz,iatclr,iconn)
           call updc(coo,xa,ya,yb,za,zb,zc)
      endif

100    continue
      return
      end

      subroutine tnkfsd(igttnk,idebug,ialloc,
     &                  coo,ianz,iatclr,iconn,ireord,
     &                  ichx,nat,norg,
     &                  xa,ya,yb,za,zb,zc,
     &                  a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str, tstr
      parameter (numatm=2000)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*137 line,tline
      common /curlin/ line
      common /pbc/ abc(3),ibox,icell,igfmap
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      logical dall,box,gnreal,owat,oion
      dimension coo(3,*),ianz(*),iatclr(*),iconn(mxcon+1,*)
      dimension ireord(*),v1(3),v2(3),v3(3)

      igttnk = 1
      dall = .false.
      owat = .true.
      oion = .true.
      if (ialloc.eq.1) then
         nwat = ntota + 1
         nsign = 0
         nions = -1
      endif
      igaff = 0
      toang = 0.52917706d0
      box = .false.
      natoms = 0

      if (idebug.eq.1) print*,'subroutine fsttnk'
   
      if (getlin(0).eq.1) then

         tline = line

         if (icdex(line,'[AMBFOR]').ne.0) then
            igaff = 1
            ic = icdex(line,'box')
            if (ic.ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               box = .true.
               do i=1,3
                  v1(i) = 0.0d0
                  v2(i) = 0.0d0
                  v3(i) = 0.0d0
               end do
               if (gnreal(abc,3,.false.)) then
                  ibox = 1
                  v1(1) = abc(1)/toang
                  v2(2) = abc(2)/toang
                  v3(3) = abc(3)/toang
               else
                  box = .false.
               endif
            endif

            ic = icdex(line,'cell')
            if (ic.ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               icell = 1

               if (gnreal(abc,3,.false.)) then
                  a = abc(1)
                  b = abc(2)
                  c = abc(3)
                  if (gnreal(abc,3,.false.)) then
                     alpha = abc(1)
                     beta  = abc(2)
                     gamma = abc(3)
                  else
                     icell = 0
                  endif
               else
                  icell = 0
               endif
               if (icell.eq.1) then
                  call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,0)
               endif
            endif

            if (getlin(0).eq.1) idum = 1
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            natoms = itype
            if (natoms.gt.mxnat) then
               dall = .true.
               goto 100
            endif
         else
            goto 100
         endif
         
      else
         goto 100
      endif

      jat = ntota

      do iat=1,natoms
         if (getlin(0).eq.1) then

           tline = line

           ktype = nxtwrd(str,nstr,itype,rtype)
           ktype = nxtwrd(str,nstr,itype,rtype)

           if (iat.gt.nwramb) then
              if (ktype.eq.1.and.oion.and..not.owat) then
                 if (nstr.eq.3) then
                    if (str(1:3).eq.'Na+'.or.str(1:3).eq.'Cl-') then
                      if (str(1:3).eq.'Cl-') nsign = 1
                      nions = iat
                      oion = .false.
                    endif
                 endif
              endif
              if (ktype.eq.1.and.owat) then
                 if (nstr.eq.2) then
                    if (str(1:2).eq.'OW'.or.str(1:2).eq.'HW') then
                        nwat = iat
                        owat = .false.
                    endif
                 endif
              endif
              jat = jat + 1
              ire = jat
              if (ire.eq.0) ire = iat
           else
              ire = ireord(iat)
              if (ire.eq.0) ire = iat
           endif

           if (ire.gt.0.and.ire.le.mxnat) then
              do i=1,3
                 ktype = nxtwrd(str,nstr,itype,rtype)
                 if (ktype.eq.3) then
                    coo(i,ire) = rtype/toang
                 else
                    goto 100
                 endif
              end do
           endif

         else
           print*,'Number of atoms read ',iat,
     &           ' less than specified in the header of file ',
     &           natoms
           goto 100
         endif

      end do

      if (icell.ne.1) then
         if (natoms.gt.nwramb.and.ialloc.eq.1) then
            iatoms = natoms
            call allon(ntota,nwat,nions,nsign,natoms,nresi)
            call doscal
            call docent
         endif
      endif


      if (box) then
         call addtbx(v1,v2,v3)
      endif

      if (icell.eq.1) then
         call cpmol2(nat,norg,xa,ya,yb,za,zb,zc,
     &              coo,ianz,iatclr,iconn)
         call updc(coo,xa,ya,yb,za,zb,zc)
      endif

      return

100   if (dall) then
         call rewfil
         igttnk = -1
         return
      endif

      if (idebug.eq.1) print*,'ERROR:',tline
      igttnk = 0

      return
      end

      subroutine wrtsng
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm,icst

      itnkln = linlen(tnknm)

      ixyz = 11
      call wrpnt(tnknm(1:itnkln)//'.xyz',itnkln+4,4,0,0,0,0,1,0)

      return
      end

      subroutine eucmol(vdwr,adjus)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character tk4014*5
      character str*100, el*2
      character esc, etx, gs, us
      real xx, yy
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /atopla/ xsym(numatm),ysym(numatm),zsym(numatm),
     &                isym(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plot/   iplot,iplwin,icolps
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      dimension vdwr(*)

      etx    = char(3)
      esc    = char(27)
      gs     = char(29)
      us     = char(31)

c
c WRITE ELEMENT NAMES and connect atoms in plot plane
c

      do i=1,natoms

         xa = 0.5d0 + ysym(i) / r(2)
         ya = 0.5d0 + xsym(i) / r(1)
         za = zsym(i) / r(3)

         if(xa.lt.1.0.and.xa.gt.0.0.and.ya.lt.1.0.and.ya.gt.0.0)then

            call eulerh(ya,xa,za,xaa,yaa)
            xaa = 0.5d0 + xaa
            yaa = 0.5d0 + yaa

            if (iplot.eq.0) then
               write(iun4,'(''.m '',f5.3,f6.3)') xaa,yaa
               write(iun4,'(''.to 5'')')
               write(iun4,'(''.sy 4'')')
               write(iun4,'(''.to 3'')')
               write(iun4,'(''.pt '',a2)')  elemnt(nat(i)) 
            endif

            if (iplot.eq.1) then
               write(iun4,'(''PU'',f5.3,f6.3,'';'')')xaa,yaa
               write(iun4,'(''WG0.005,0,360;'')')
               write(iun4,'(''PU'',f5.3,f6.3,'';LB'',a3,a,'';'')')
     +            xaa,yaa,elemnt(nat(i)),etx
            endif

            if (iplot.eq.3) then
c               write(iun4,*)esc//'/0d'
               write(iun4,*)gs//tk4014(int(xaa*3100),int(yaa*3100))
     +                    //us//elemnt(nat(i))
            endif

            if (iplot.eq.4) then
              write(iun4,'(''   0 setgray'')')
              write(iun4,'(''n '',i4,'' '',i4,'' 10 0 360 arc fill'')')
     +        int(xaa*2000),int(yaa*2000+125)
              write(iun4,'(''   1 setgray'')')
              write(iun4,'(''n '',i4,'' '',i4,'' 17 0 360 arc fill'')')
     +        int(xaa*2000+40),int(yaa*2000+138)
              write(iun4,'(''   0 setgray'')')
              write(iun4,'(i4,'' '',i4,'' m (   '',a,'') show'')')
     +        int(xaa*2000),int(yaa*2000+125),elemnt(nat(i))
            endif

            if (iplot.eq.6) then
               el = elemnt(nat(i))
               xx = 5.0
               yy = 0.0
               call xwin(xx,yy,99,str,nstr,idum1,idum2)
               xx = xaa
               yy = yaa
               call xwin(xx,yy,4,el,2,idum1,idum2)
            endif

         endif

         if (iplot.eq.6) then
           xx=3.0
           call xwin(xx,yy,10,str,nstr,idum1,idum2)
           call xwin(xx,yy,8,str,nstr,idum1,idum2)
           call ststip
         endif

         do j=1,natoms

            if(isym(j).eq.1.and.isym(i).eq.1)then
               if (iplot.eq.6) then
                  xx = 15.0
                  yy = 0.0
                  call xwin(xx,yy,99,str,nstr,idum1,idum2)
                  call unstip
               endif
               if (iplot.eq.4) then
                  write(iun4,'(''0 setgray'')')
               endif
            else
               if (iplot.eq.6) then
                  xx = 8.0
                  yy = 0.0
                  call xwin(xx,yy,99,str,nstr,idum1,idum2)
               endif
               if (iplot.eq.4) then
                  write(iun4,'(''0.5 setgray'')')
               endif
            endif

            dmaxsq = (vdwr(nat(i)) + vdwr(nat(j)))**2
            dijsq = ((xyz(1,i) - xyz(1,j))*adjus)**2
     +            + ((xyz(2,i) - xyz(2,j))*adjus)**2
     +            + ((xyz(3,i) - xyz(3,j))*adjus)**2
            if (dijsq.lt.dmaxsq) then
               xb = 0.5d0 + ysym(j) / r(2)
               yb = 0.5d0 + xsym(j) / r(1)
               zb = zsym(j) / r(3)
               if (xa.lt.1.0.and.xa.gt.0.0.and.ya.lt.1.0
     +         .and.ya.gt.0.0.and.xb.lt.1.0.and.xb.gt.0.0
     +         .and.yb.lt.1.0.and.yb.gt.0.0) then
                  if (iplot.eq.3) then
                     idum = 1
                     call plotgh(idum,0.0d0,0.0d0)
                  endif
                  if (iplot.eq.4) then
                     write(iun4,'(''n'')')
                  endif
                  call euler(ya,xa,za,1)
                  call euler(yb,xb,zb,2)
                  if (iplot.eq.4) then
                     write(iun4,'(''s'')')
                  endif
               endif
            endif
         end do

         if (iplot.eq.6) then
           xx=1.0
           call xwin(xx,yy,10,str,nstr,idum1,idum2)
           call xwin(xx,yy,8,str,nstr,idum1,idum2)
           call unstip
         endif

         if (iplot.eq.4) then
           write(iun4,'(''s'')')
           write(iun4,'(''0 setgray'')')
           write(iun4,'(''n'')')
         endif

      end do

      return
      end

      subroutine parpla(iat1,iat2,iat3,istat)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      dimension d1(3),d2(3),c12(3)

      istat = 0
      px = (xyz(1,iat1) + xyz(1,iat2) + xyz(1,iat3)) / 3.0d0
      py = (xyz(2,iat1) + xyz(2,iat2) + xyz(2,iat3)) / 3.0d0
      pz = (xyz(3,iat1) + xyz(3,iat2) + xyz(3,iat3)) / 3.0d0
      do i=1,3
        d1(i) = xyz(i,iat2) - xyz(i,iat1)
        d2(i) = xyz(i,iat3) - xyz(i,iat1)
      end do
      call impsc(d1,d2,cosb)
      cc = dabs(cosb) - 1.0d0
      if (dabs(cc).lt.1.0d-3) istat = 1
      call crprod(d1,d2,c12)
      cx = c12(1)
      cy = c12(2)
      cz = c12(3)
      iplat = iat1

      return
      end

      subroutine renorm(exx,c,iang)
      implicit double precision (a-h,o-z)
      data pi32 /5.56832799683170d0/
      data pt187 /1.875d+00/
      data pt5,pt75,pt656 /0.5d0,0.75d0,6.5625d0/

      ee = exx + exx
      if (ee.ne.0.0d0) then
        facs = pi32 / (ee * dsqrt(ee))
        if (iang.eq.0) fac = facs
        if (iang.eq.1) fac = pt5   * facs / ee
        if (iang.eq.2) fac = pt75  * facs / (ee*ee)
        if (iang.eq.3) fac = pt187 * facs / (ee*ee*ee)
        if (iang.eq.4) fac = pt656 * facs / (ee*ee*ee*ee)
        c = c / dsqrt(fac)
      endif

      return
      end

      subroutine norml
      implicit double precision (a-h,o-z)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp


      do i = 1, nshell

c what type of shell: s, p, d, f, sp, spd

         iscod = 0
         if(shellt(i).eq.0) iscod = 0
         if(shellt(i).eq.1.and.shellc(i).eq.1) iscod = 2
         if(shellt(i).eq.1.and.shellc(i).ne.1) iscod = 1
         if(shellt(i).eq.2.and.shellc(i).eq.0) iscod = 4
         if(shellt(i).eq.2.and.shellc(i).ne.0) iscod = 3
         if(shellt(i).eq.3) iscod = 5
         if(shellt(i).eq.4) iscod = 6

         mm = shella(i)
         mmdf = shladf(i)
         n = shelln(i)

         if (iscod.eq.0) then
            call normp(exx(mm),c1(mm),n,0)
         elseif (iscod.eq.1) then
            call normp(exx(mm),c1(mm),n,0)
            call normp(exx(mm),c2(mm),n,1)
         elseif (iscod.eq.2) then
            call normp(exx(mm),c2(mm),n,1)
         elseif (iscod.eq.4) then
            call normp(exx(mm),c1(mm),n,0)
            call normp(exx(mm),c2(mm),n,1)
            call normp(exx(mm),c3(mmdf),n,2)
         elseif (iscod.eq.3) then
            call normp(exx(mm),c3(mmdf),n,2)
         elseif (iscod.eq.5) then
            call normp(exx(mm),c4(mmdf),n,3)
         elseif (iscod.eq.6) then
            call normp(exx(mm),c5(mmdf),n,4)
         endif

      end do

      return
      end

      subroutine normp(exx,c,n,iang)
      implicit double precision (a-h,o-z)
      dimension exx(n),c(n)

      small = 1.0d-15

      pow  = (3.0d0 + 2.0d0*dble(iang))/4.0d0
      sint = 0.0d0
      do i=1,n
         ei = exx(i)
         do j=1,n
            ej = exx(j)
            sint = sint + 
     &       c(i)*c(j)*(4.0d0*ei*ej/((ei+ej)**2.0d0))**pow
         end do
      end do

      if (sint.gt.small) then
         do i=1,n
            c(i) = c(i) / dsqrt(sint)
         end do
      endif

      do i=1,n
         call renorm(exx(i),c(i),iang)
      end do

      return
      end

      subroutine tocap(line,ncars)
      integer ncars
      character*(*) line

      do i=1,ncars
         j = ichar(line(i:i))
         if (j.ge.97.and.j.le.122) line(i:i) = char(j-32)
      end do

      return
      end

      subroutine tolow(line,ncars)
      integer ncars
      character*(*) line

      do i=1,ncars
         j = ichar(line(i:i))
         if (j.ge.65.and.j.le.90) line(i:i) = char(j+32)
      end do

      return
      end

      double precision function vlen(a)
      implicit double precision (a-h,o-z)
      dimension a(3)

      tot = a(1)*a(1)+a(2)*a(2)+a(3)*a(3)
      vlen = 0.0d0
      if (tot.gt.0.0d0) vlen = dsqrt(tot)

      return
      end

      subroutine rotb(beta)
      implicit double precision (a-h,o-z)
      common/rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg

c--   beta expected in degrees
      radb = beta / todeg
      bmat(1,1) =  dcos(radb)
      bmat(1,3) =  dsin(radb)
      bmat(3,1) = -dsin(radb)
      bmat(3,3) =  dcos(radb)

      return
      end

      subroutine optimisd(emin,gtol,nsd,par,par1,g,g1,zr,y,yt,pt,s,
     &                    iopt,ityp)
      implicit real (a-h,o-z), integer (i-n)

c     BFGS method requires stores of Inverse Hessian, 
c                 only for small systems, for big systems:
c     conjugate gradient energy minimization

      parameter (maxbfgs=1000)
      parameter (mxunch=25)
      common /athlp/   iatoms, mxnat
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      logical reset, osingl, dolbfgs,oqscal
      integer*2 ityp
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /cell/ xa,ya,yb,za,zb,zc
      common /convg/ icyc

      dimension par(*),g(*),par1(*),zr(*),g1(*),
     &          y(*),pt(*),yt(*),s(*),iopt(*),ityp(*)
      dimension hessin(maxbfgs*maxbfgs),idx(maxbfgs),
     &          dg(maxbfgs),hdg(maxbfgs),elast(mxunch)
      
c iwrite: write structure file every iwrite iterations
c
c nsd   : maximum number of iterations
c
c deprls: When the gradient-norm is satisfied, test if energy does not change
c         more than DEPRLS upon making a new pair list
c
c derest: When the energy changes more than DEREST upon a making a new
c         pair list, the algoritm is restarted with the gradient vector.
c
c STEP0:  initial step-size in  line-minimization (bv. 1.0E-5)
c         Choose such that NITI (number of iterations in the 
c         line-minimization in the first cycle becomes 1 or 2


      iwrite = 1
      imeth  = 0
      derest = 0.2e0      
      deprls = 0.05e0
      step0  = 0.05e0
      n      = iatoms*3

      ilast = 0
      do i=1,mxunch
         elast(i) = 0.0e0
      end do

      write(iun5,*) 'Gradient tolerance: ',gtol
      write(iun5,*) 'Maximum iterations: ',nsd

      nflx = 0
      do i=1,iatoms
         if (iopt(i).eq.1) then
             if (nflx*3.le.maxbfgs) then
                nflx = nflx + 1
                idx((nflx-1)*3+1) = (i-1)*3 + 1
                idx((nflx-1)*3+2) = (i-1)*3 + 2
                idx((nflx-1)*3+3) = (i-1)*3 + 3
             endif
         endif
      end do
      nflx3 = nflx*3

      if (cell) then
         par(n+1) = xa
         par(n+2) = ya
         par(n+3) = yb
         par(n+4) = za
         par(n+5) = zb
         par(n+6) = zc

         nflx = nflx + 1

         idx((nflx-1)*3+1) = n + 1
         idx((nflx-1)*3+2) = n + 2
         idx((nflx-1)*3+3) = n + 3
         idx((nflx-1)*3+4) = n + 4
         idx((nflx-1)*3+5) = n + 5
         idx((nflx-1)*3+6) = n + 6

         nflx = nflx + 1
         nflx3 = nflx*3

         n = n + 6

      endif

      if (nflx3.gt.maxbfgs.or.cell) then
          imeth = 1
          write(iun5,'(a,i6,a)') 'Number of atoms times 3: ',nflx3,
     &                           ' > MAXBFGS using PB     '
          write(iun5,*) 'Powell-Beale conjugate gradients           '
      else 
          write(iun5,*) 'BFGS Variable Metric                      '

      endif

      nrstrt = nsd
      if (imeth.eq.1) nrstrt = n

      d0   = step0
      ncyc = 0
      icyc = 0
      npow = 0

c     Restart search direction to the steepest descent direction

      call enegrd(eold,par,g)
      if (osingl) then
          write(iun5,'(a,f12.3)') 'Estat=',eold
          return
      endif

      call resdir(istat,imeth,n,nflx3,d0,gtol,eold,g,
     &                  npl,step,d1g1,zr,hessin)
      if (istat.eq.0) then
         emin = eold
         return
      endif
      
c     BEGIN LOOP

      do while(.true.)

         tya = 0.0
         do i=1,n
            tya = tya - zr(i)*g(i)
         end do

         if (tya.ge.0.0e0) then

c           No energy gain in the search direction         

c            write(iun5,*) ' ***** ya positive: ',tya
            reset = .true.
            goto 100

         endif

         call linmin(istat,n,npl,step,d1g1,d0,eold,emin,
     &               zr,par,par1,g,g1,gtol)
         call restr(par1)
         if (istat.eq.0) then
            call enegrd(eold,par,g)
            reset = .true.
            goto 100
         endif

c  We have found a lower energy.
      
         ncyc = ncyc + 1

c  Write out the minimized structure

         if (mod(ncyc,iwrite) .eq. 0) then

c     arc file
             if (iarc.eq.1) call wrtout(iun4,emin)

c     intermediate file

             icyc = icyc + 1
             if (imon.ne.0) call wrmon(icyc,emin)

             if (usesw) then
                if (mod(icyc,10).eq.0) call bldlst
             endif

         end if

c     Calculate RMS gradient, update parameters, calc G1G for new restart
c     Calculate parameter shift s() (for MQN method)

         g1g1 = 0.0e0
         do i=1,n
            g1g1   = g1g1 + g1(i)*g1(i)
            s(i)   = par1(i) - par(i) 
            par(i) = par1(i)
         end do

         rmsgrd = sqrt(g1g1/float(n))

c     Check whether we are done:

c        1. Too many cycles performed:

         if (ncyc.gt.nsd)  then
            write(iun5,*) 'Exceeded maximum interations ',nsd
            return
         endif
      
         if (ilast.lt.mxunch) then
            elast(ilast+1) = emin
         else
            do i=2,mxunch
               elast(i-1) = elast(i)
            end do
            elast(mxunch) = emin
         endif

         ilast = ilast + 1

         eavg = 0.0e0
         emn = 1000000.0e0
         emx = -1000000.0e0
         do i=1,min(ilast,mxunch)
            if (elast(i).lt.emn) emn = elast(i)
            if (elast(i).gt.emx) emx = elast(i)
         end do
         eavg = abs((emx - emn) / 2.0e0)
         if (ilast.gt.mxunch.and.eavg.lt.0.002e0) then
               write(iun5,*) 
     &          'Energy change in last ',mxunch,' steps < 0.002'
               return
         endif

c        print energy

         call prtene(icyc,emin,rmsgrd)

c        2. Gradient vector sufficiently small:

         if (rmsgrd.lt.gtol) then

c           GTOL: stop earlier if RMSgrd gradient < GTOL
c           Check whether the pair list was still good:

            call enegrd(emin2,par,g1)
            if (abs(emin2-emin).lt.deprls) then
               emin = emin2
               write(iun5,*) 'Optimisation Converged'
               return
            endif


            if (abs(emin2-emin).gt.derest) then 

c              Restart search direction if the energy changed too much

               eold = emin2

               do k=1,n
                  g(k) = g1(k)
               end do

               reset = .true.
               goto 100

            else 

c              Continue normally with next search direction

               emin = emin2

            endif

         endif

         if (imeth.eq.0) then
   
            do i=1,nflx3
               dg(i)  = -( g1(idx(i)) - g(idx(i)) )            
               hdg(i) = 0.0e0
            end do
   
         else if (imeth.eq.1) then
   
            yg = 0.0e0         
            py = 0.0e0         
   
            do i=1,n
               y(i) = g(i) - g1(i)
               yg   = yg   - y(i)*g1(i)
               py   = py   + y(i)*zr(i)
            end do
   
         else if (imeth.eq.2) then
c MQN
   
            yy = 0.0e0
            sy = 0.0e0
            yg = 0.0e0
            sg = 0.0e0
   
            do i=1,n
               s(i) = par1(i) - par(i)
               y(i) = g(i)    - g1(i)
               yy   = yy      + y(i)*y(i)
               sy   = sy      + s(i)*y(i)
               yg   = yg      - y(i)*g1(i)
               sg   = sg      - s(i)*g1(i)
            end do
   
         endif
      
c For all methods:
c For restart criterium 
c Update derivatives;

         g1g  = 0.0e0
         g1g1 = 0.0e0

         do i=1,n
            g1g1 = g1g1 + g1(i)*g1(i)
            g1g  = g1g  + g1(i)*g(i)
            g(i) = g1(i)
         end do

         dnew   = g1g1
         rmsgrd = sqrt(g1g1/float(n))
         gnorm  = sqrt(g1g1)

c If RMS gradient is extremely high, perform another Search Dir step

         if (rmsgrd.gt.500.0e0) then
            eold  = emin
            reset = .true.
            goto 100
         endif

c Update inverse hessian by BFGS algoritm

         if (imeth.eq.0) call updhes(nflx3,hessin,hdg,dg,zr,idx)

         npl    = npl + 1
         npow   = npow + 1

         reset  = .false.
         
c Set new Search Direction in zr():

         if (imeth.eq.0) then
   
            do i=1,iatoms
               if (iopt(i).eq.0) then
                 i3 = (i-1)*3
                 do j=1,3
                    zr(i3+j) = 0.0e0
                 end do
               endif
            end do

            do i=1,nflx3

               zr(idx(i)) = 0.0e0

               do j=1,nflx3
                  ij    = (i-1)*nflx3 + j
                  zr(idx(i)) = zr(idx(i)) + hessin(ij)*g(idx(j))
               end do

            end do

            if (npl.eq.nrstrt) reset = .true.
   
         else if (imeth.eq.1) then
   
            gamma = yg/py

            if (abs(g1g).ge. 0.2e0*g1g1 .or. npl.eq.1 .or.
     &           npow.eq.nrstrt) then

               if (npl.ne.1) write(iun5,*) 'POWELL restart'

               gamma1 = 0.0e0
               ptyt   = 0.0e0
               npow   = 0

               do i=1,n
                  yt(i) = y(i)
                  pt(i) = zr(i)
                  ptyt  = ptyt + yt(i)*pt(i)
               end do

            else 

               ytg = 0.0e0

               do i=1,n
                  ytg = ytg - yt(i)*g(i)
               end do

               gamma1 = ytg/ptyt


            endif

            do i=1,n
               zr(i) = g(i) + gamma*zr(i) + gamma1*pt(i)
            end do
   
         else if (imeth.eq.2) then
c MQN
   
            do i=1,n
               zr(i) = g(i) + (y(i)*sg + s(i)*yg)/sy
     &              - (1.0e0 + yy/sy)*(s(i)*sg/sy)
            end do

            if (npl.eq.nrstrt)          reset = .true.
            if (abs(g1g).ge. 0.2*g1g1) reset = .true.
   
         endif
         
         d1g1   = 0.0e0
         zrnorm = 0.0e0

         do i=1,n
            d1g1   = d1g1   - g(i) *zr(i)
            zrnorm = zrnorm + zr(i)*zr(i)
         end do
   
         eold = emin
         step = d0/sqrt(zrnorm)
         if (step.lt.0.00001e0) step = 0.00001e0
         if (step.ne.step) write(iun5,*) 'warning step underflow'

100      if (reset) then

c           Restart search direction to the steepest descent direction

            d0 = step0
            call resdir(istat,imeth,n,nflx3,d0,gtol,eold,g,
     &                        npl,step,d1g1,zr,hessin)
            if (istat.eq.0) then
               emin = eold
               return
            endif
         endif

      end do

c     END LOOP

      return
      end

      subroutine updhes(n,hessin,hdg,dg,zr,idx)
      implicit real (a-h,o-z), integer (i-n)
      dimension hessin(*),hdg(*),dg(*),zr(*),idx(*)

      do j=1,n
         do i=1,n         
            ij = (i-1)*n + j
            hdg(i) = hdg(i) + hessin(ij)*dg(j)
         end do
      end do

      fac = 0.0e0
      fae = 0.0e0

      do i=1,n
         fac = fac + dg(i)*zr(idx(i))
         fae = fae + dg(i)*hdg(i)
      end do

      fac = 1.0e0/fac
      fad = 1.0e0/fae

      do i=1,n
         dg(i) = fac*zr(idx(i)) - fad*hdg(i)
      end do

      do j=1,n
         do i=1,n
            ij = (i-1)*n + j
            hessin(ij) = hessin(ij) + fac*zr(idx(i)) * zr(idx(j))
     &                              - fad*hdg(i) *hdg(j)
     &                              + fae*dg(i)  *dg(j)
         end do
      end do

      return
      end

      subroutine resdir(istat,imeth,n,nflx3,d0,tol,eold,g,
     &                  npl,step,d1g1,zr,hessin)
      implicit real (a-h,o-z), integer (i-n)
c     Restart search direction to the steepest descent direction
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      dimension hessin(*),g(*),zr(*)

      istat  = 1
      npl    = 0

      dold   = 0.0e0
      do i=1,n
         zr(i) = g(i)
         dold  = dold + zr(i)*zr(i)
      end do
      
c Initialize inverse hessian for BFGS variable metric      
      
      if (imeth.eq.0) then

         do i=1,nflx3
            do j=1,nflx3
               ij = (i-1)*nflx3 + j
               if (i.eq.j) then
                  hessin(ij) = 1.0e0
               else
                  hessin(ij) = 0.0e0
               endif
            end do
         end do

      endif

      d1g1  = -dold
      gnorm = sqrt(dold)
      step  = d0/gnorm
      if (step.ne.step) write(iun5,*) 'warning step underflow'

      if (eold.ge.50000.0e0) step = step*100.0e0

      rmsgrd = sqrt(dold/float(n))

      if (rmsgrd.lt.tol) then
         write(iun5,*) ' ***** Gradient norm satisfied at restart CG'
         istat = 0
      endif

      return
      end

      subroutine linmin(istat,n,npl,step,d1g1,
     &                  d0,eold,emin,zr,par,parn,g,gn,gtol)
      implicit real (a-h,o-z), integer (i-n)
      logical cont, updene
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      dimension zr(*),par(*),parn(*),gn(*),g(*)

c     Start LINE MINIMIZATION.
c     Calculate energies (EA, EB) and derivatives (YA, YB) at points
c     A and B along the search direction (ZR), starting with A = 0 and B = STEP.
c     If necessary, adjust A and B to find an optimum search range.
c     Find a minimum X in the search range between A and B by determining
c     the minimum of the third-degree polynomial fixed by EA, EB, YA and YB.

c     FDIV:  Divide step by FDIV, every cycle ( 1.05)
c     FMULT: Multiply step by FMULT if NITI is not zero.( 2.0)
c     eps1,eps2: values for Shanno's convergence criteria

      eps1 = 0.9e0
      eps2 = 0.0001e0
      fdiv = 1.05e0
c      fmult= 1.2e0
      fmult= 2.0e0
      istat = 1
      updene = .true.

      do while (.true.)

         nstijg = 0

         ya = 0.0
         do i=1,n
            ya = ya - zr(i)*g(i)
         end do

         if (ya.ge.0.0e0) then

c           No energy gain in the search direction         

            write(iun5,*) ' ***** ya positive: ',ya
            istat = 0
            return

         endif

         a  = 0.0e0
         ea = eold
         b  = step
         niti = 0

100      cont = .true.
         do while (cont)

            if (updene) then
               do i=1,n
                  parn(i) = par(i) + b*zr(i)
               end do

               call enegrd(eb,parn,gn)

               yb = 0.0
               do i=1,n
                  yb = yb - zr(i)*gn(i)
               end do
            endif

            updene = .true.
            cont = .false.

            if (yb.lt.0.0e0 .and. eb.lt.ea) then

c           There must be a lower minimum further away than B, so shift and
c           double the search range.

               w  = b - a
               a  = b
               b  = a + 2.0e0*w
c               b = 2.0e0*b
               ea = eb
               ya = yb
               niti = niti + 1
               cont = .true.

            endif

            if (eb.gt.ea .and. abs(eb/ea).gt.1000.0e0) then      

c           Very asymmetric energy function, decrease search range

               bt = b
               b = (b+a)/2.0e0
               cont = .true.
            endif
      
         end do

c     Now we can only get here if eb > ea
c     Now there must be a minimum X in the search range between A and B. 
c     Find it and calculate the energy there.

         if (niti.ne.0) then
            step = fmult*step
            if (step.ne.step) write(iun5,*) 'step underflow'
            d0   = fmult*d0
         endif

         z = 3.0e0*(ea-eb)/(b-a) + ya + yb
         w = z*z - ya*yb
   
         if (w.le.0.0e0) then
c            write(iun5,*) 
c     &        ' **** LINMIN: w < 0!!! This should never happen'
            x = 0.0e0
         else
            w = sqrt(w)
            x = b - (yb+w-z)/(yb-ya+2.0e0*w)*(b-a)
         endif
      
c     apply the next guess for the scaling (x) of the search direction 
c     to create new parameters (parn)

         do i=1,n
            parn(i) = par(i) + x*zr(i)
         end do

c     calculate the energy associated with the scaling (x)

         call enegrd(emin,parn,gn)

         d1gs = 0.0e0

         do i=1,n
            d1gs = d1gs - zr(i)*gn(i)
         end do

c     Is this the best scaling of the search direction ?
c     we have three energies now ea, eb and emin

         if (niti.lt.30.and.(emin.gt.eold+d1g1*x*eps2) 
     &     .or.(abs(d1gs).gt.eps1*abs(d1g1)) .or.
     &   (((emin.gt.ea) .or. (emin.gt.eb)).and.((x.gt.1.01*a).and.
     &     (x.lt.0.99e0*b)))) then

c           NOT converged yet

            nstijg = nstijg + 1
   
            if ((x*d1gs).ge.0) then
               b  = x
               eb = emin
               yb = d1gs
            else
               a  = x
               ea = emin
               ya = d1gs
            endif

            updene = .true.

            if (nstijg.lt.5) then

c              Try a next interation within the chosen range

               updene = .false.
               goto 100

            else

               if (npl.eq.0) then

c                 we had already reset search direction, so now
c                 decrease step and try again

                  step = step/10.0e0
                  if (step.ne.step) write(iun5,*) 'step underflow'
                  d0   = d0/10.0e0

                  if (step.lt.1.0e-05) then
                     write(iun5,*) ' STEP in LINMIN too small'
		     d1gs = 0.0e0
                     do i=1,n
                        d1gs = d1gs + gn(i)*gn(i)
                     end do
                     d1gs = sqrt(d1gs/float(n))
                     gtol  = d1gs*1.1e0
                     istat = 1
                     return
                  endif

               else

c                 Restart search direction to the steepest descent direction

                  istat = 0
                  return

               endif
            endif

         else

c Line minimization converged

c            d0 = d0/fdiv      
            return

         endif

      end do
 
      return
      end

      subroutine prtgrd(par,grd)
      implicit real (a-h,o-z), integer (i-n)
      common /athlp/   iatoms, mxnat
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      dimension par(3,*),grd(3,*)
      
      write(iun5,*) 'grd'
      do i=1,iatoms
         write(iun5,'(i5,3f8.3,a,3f8.3)') 
     &       i,(par(j,i),j=1,3),' = ',(grd(j,i),j=1,3)
      end do

      return
      end

      subroutine prtarr(zr,n,str)
      implicit real (a-h,o-z), integer (i-n)
      common /athlp/   iatoms, mxnat
      character*(*) str
      dimension zr(*)

      print*,str

      n3 = n/3
      do i=1,n3
         print*,i,' ',(zr((i-1)*3+j),j=1,3)
      end do

      return
      end

      subroutine plmod(coo,qat,rzp,ixp,iyp,
     &                 iconn,ianz,iaton,iatclr,iresid,inat,lab,labhet,
     &                 xv,yv,
     &                 icalf,ncalf,icxp,icyp,
     &                 scal,scali)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat
      common /cllab/ iclon,iclpnt(4)
      character*2 clstr,ccell
      common /clchr/ clstr(4)
      common /surf/  natorg,noscnd
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /gracom/ uscl,colscd,colscpd,ivdwpl

      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      parameter (mxres=42)
      character*3 aminos
      common /amino/aminos(mxres)
      logical dsurf,scnd,dcell
      integer dolabs,fancy,shade,atcol,persp,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo

      real xx
      integer*2 ixx(24)
      dimension zvect(3)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*),iconn(mxcon+1,*),
     &          ianz(*),iaton(*),iatclr(*),iresid(*),inat(*),qat(*)
      dimension icalf(6,*),icxp(*),icyp(*),lab(*),labhet(*)

      toang  = 0.52917706d0
      roddef = 0.7d0*vrad(1)
      zvect(1) = 0.0d0
      zvect(2) = 0.0d0
      zvect(3) = 1.0d0
c
c     colsc = color darker when object further away scaling
c
      colsc = colscd*uscl
c
c     icltan = color darker when a line under angle 
c              with light direction scaling factor
c
      icltan = 8

      call gethei(ihigh)

      if (iatoms.eq.0) return

      do j=1,iatoms
          call rott(coo(1,j),coo(2,j),coo(3,j),xc,yc,zc,1)
          rzp(j) = zc
          if (iaton(j).ge.1) then
             ixp(j) = (0.5d0 -(xc - xv)/scal)*ihigh
             iyp(j) = (0.5d0 -(yc - yv)/scal)*ihigh
          else
             ixp(j) = 0
             iyp(j) = 0
          endif
      end do

c      call shsort(iatoms,rzp,inat)
      call rqsrt(iatoms,rzp,inat)

      if (ipdbon.eq.1) then
         do k=1,ncalf
             j = icalf(1,k)
             if (j.gt.0) then
                call rott(coo(1,j),coo(2,j),coo(3,j),xc,yc,zc,1)
                icxp(k) = (0.5d0 -(xc - xv)/scal)*ihigh
                icyp(k) = (0.5d0 -(yc - yv)/scal)*ihigh
             else
                icxp(k) = (0.5d0 )*ihigh
                icyp(k) = (0.5d0 )*ihigh
             endif
         end do
      endif

      inr = 0
      call labnr(inr)

      if (fancy.eq.1) then

c     color + spheres for atoms

         do i=1,iatoms
            k = inat(i)
            dsurf = .false.
            if (k.gt.natorg.and.natorg.ne.0) dsurf = .true.
            scnd = .false.
            if (backb.eq.1.and.iresid(k).le.0.and.iresid(k).ge.-3) 
     &          scnd = .true.
            if (iaton(k).ge.1) then
            xs = (rzp(k)/scali-1.0d0)/2.0d0
c            rfac = (1.0d0-colsc*xs*xs)
            rfac = (1.0d0-1.d0*xs*xs)
            if (rfac.lt.0.0d0) rfac = 0.d0
            itemp = 9*rfac
            if (.not.dsurf) then
               ia = 0
               if (iaton(k).ge.2) ia = iaton(k)
               if (ivdwpl.eq.1.and..not.scnd) then
                  isph = (vdwr(ianz(k))/(toang*scal))*ihigh*2
               else
                  isph = (vrad(ianz(k))/scal)*ihigh*2
               endif
            
               if (shade.eq.1) then
                  if (atcol.eq.1) then
                     i1 = 16+(icol(ianz(k))-1)*10
                  else
                     i1 = 16+(iatclr(k)-1)*10
                  endif
                  i2 = itemp
                  call plsph3(iyp(k),ixp(k),isph,ia,i1,i2)
               else
                  if (atcol.eq.1) then
                     kcol = icol(ianz(k))
                  else
                     kcol = iatclr(k)
                  endif
                  call setcol(kcol)
                  call plsph(iyp(k),ixp(k),isph,ia)
               endif
               
               call stlab(iresid(k),ilab,idres,iqon,lab,labhet)
               if (dolabs.eq.1.or.idres.gt.0) then
                   if (shade.eq.1) then
                      kcol = 56.0 + itemp
                   else
                      kcol = 15.0
                   endif
                   call setcol(kcol)
                   call pllab(ixp(k),iyp(k),ianz(k),k,
     &                        qat(k),inr,ilab,iresid(k),0)
               endif
            endif
            if (dsurf.and.iclon.eq.1) then
               dcell = .false.
               do ik=1,4
                  if (k.eq.iclpnt(ik)) then
                     dcell = .true.
                     ccell = clstr(ik)
                  endif
               end do
                
               if (dcell) then
                  if (shade.eq.1) then
                     kcol = 56 + itemp
                  else
                     kcol = 15
                  endif
                  call setcol(kcol)
                  call drwstr(ixp(k),iyp(k),ccell,2,k)
               endif
            endif
            xx = 3.0
            call cwidth(xx)
            call sollin

            if (iconn(1,k).gt.mxcon)
     &          write(iun3,*) 'plmol bigger than mxcon'
            do j=1,iconn(1,k)
              im = iconn(j+1,k)
              m = abs(im)
              if (iaton(m).ge.1.and.rzp(k).le.rzp(m)) then
                  if (dsurf) then
                     if (atcol.eq.1) then
                       if (iatclr(m).ne.iatclr(k)) then
                         call astick(zvect,colsc,icltan,m,k,ihigh,
     &                             shade,0,1)
                       else
                         call mstick(zvect,colsc,icltan,m,k,shade,0)
                       endif
                     else
                         call astick(zvect,colsc,icltan,
     &                               m,k,ihigh,shade,0,0)
                     endif
                  else
                     if (im.lt.0) then
                         call astick(zvect,colsc,icltan,
     &                               m,k,ihigh,shade,1,0)
                     else
                       if (ivdwpl.eq.0.or.scnd) then
                         call fstick(roddef,rfac,zvect,colsc,icltan,
     &                           m,k,ihigh,shade,atcol,scnd)
                       endif
                     endif
                  endif
              endif
            end do

            if (fyesno.eq.1) 
     &          call plfc(shade,ixx,k,ihigh,colsc,icltan,zvect)
            if (idipon.eq.1) call pldip(shade,ihigh,colsc,icltan,zvect,
     &                                  dipo,coo,ianz,xv,yv,scal,scali)

            endif
         end do
      else

        if (atcol.eq.1) then
c
c        multi colored sticks
c
         do i=1,iatoms
            k = inat(i)
            if (iaton(k).ge.1) then
            scnd = .false.
            if (backb.eq.1.and.iresid(k).le.0.and.iresid(k).ge.-3) 
     &          scnd = .true.
            dsurf = .false.
            if (k.gt.natorg.and.natorg.ne.0) dsurf = .true.
            ia = 0
            if (iatoms.eq.1) ia = 2
            if (iaton(k).ge.2) ia = iaton(k)
            if (ia.ne.0) call plsel(iyp(k),ixp(k),ia)
            call stlab(iresid(k),ilab,idres,iqon,lab,labhet)
            if (((dolabs.eq.1.or.idres.ge.1).and..not.dsurf).or.
     &          (dsurf.and.iclon.eq.1)) then
                if (shade.eq.1) then
                   xs = (rzp(k)/scali-1.0d0)/2.0d0
                   rfac = (1.0d0-1.d0*xs*xs)
                   if (rfac.lt.0.0d0) rfac = 0.d0
                   itemp = 9*rfac
                   kcol = 56 + itemp
                else
                   kcol = 15
                endif
                call setcol(kcol)
                if (dsurf.and.iclon.eq.1) then
                   dcell = .false.
                   do ik=1,4
                      if (k.eq.iclpnt(ik)) then
                         dcell = .true.
                         ccell = clstr(ik)
                      endif
                   end do
                   if (dcell)
     &                call drwstr(ixp(k),iyp(k),ccell,2,k)
                else
                   call pllab(ixp(k),iyp(k),ianz(k),k,
     &                        qat(k),inr,ilab,iresid(k),0)
                endif
            endif
            nc = 0
            do j=1,iconn(1,k)
              im = iconn(j+1,k)
              m = abs(im)
              if (iaton(m).ge.1.and.rzp(k).le.rzp(m)) then
                 if (scnd.and..not.dsurf) then
                    call mstick(zvect,colsc,icltan,m,k,shade,0)
                 else
                    id = 0
                    if (im.lt.0) id = 1
                    call astick(zvect,colsc,icltan,m,k,ihigh,shade,id,0)
                 endif
              endif
              if (iaton(m).ge.1.and.im.gt.0) nc = nc + 1
            end do
            if (nc.eq.0.and..not.dsurf) 
     &           call snglat(zvect,scal,colsc,icltan,k,ihigh,
     &                               shade,atcol,0,0,0)
            if (fyesno.eq.1) 
     &          call plfc(shade,ixx,k,ihigh,colsc,icltan,zvect)
            if (idipon.eq.1) call pldip(shade,ihigh,colsc,icltan,zvect,
     &                                  dipo,coo,ianz,xv,yv,scal,scali)
            endif
         end do
        else
c
c        mono colored sticks
c
         do i=1,iatoms
            k = inat(i)
            if (iaton(k).ge.1) then
            dsurf = .false.
            if (k.gt.natorg.and.natorg.ne.0) dsurf = .true.
            ia = 0
            if (iatoms.eq.1) ia = 2
            if (iaton(k).ge.2) ia = iaton(k)
            if (ia.ne.0) call plsel(iyp(k),ixp(k),ia)
            call stlab(iresid(k),ilab,idres,iqon,lab,labhet)
            if (((dolabs.eq.1.or.idres.ge.1).and..not.dsurf).or.
     &          (dsurf.and.iclon.eq.1)) then
                if (shade.eq.1) then
                   xs = (rzp(k)/scali-1.0d0)/2.0d0
                   rfac = (1.0d0-1.d0*xs*xs)
                   if (rfac.lt.0.0d0) rfac = 0.d0
                   itemp = 9*rfac
                   kcol = 56 + itemp
                else
                   kcol = 15
                endif
                call setcol(kcol)
                if (dsurf.and.iclon.eq.1) then
                   dcell = .false.
                   do ik=1,4
                      if (k.eq.iclpnt(ik)) then
                         dcell = .true.
                         ccell = clstr(ik)
                      endif
                   end do
                   if (dcell)
     &                call drwstr(ixp(k),iyp(k),ccell,2,k)
                else
                   call pllab(ixp(k),iyp(k),ianz(k),k,
     &                        qat(k),inr,ilab,iresid(k),0)
                endif
            endif
            nc = 0
            do j=1,iconn(1,k)
              im = iconn(j+1,k)
              m = abs(im)
              if (m.ne.0.and.iaton(m).ge.1.and.rzp(k).le.rzp(m)) then
                 if (im.lt.0) then
                    call astick(zvect,colsc,icltan,m,k,ihigh,shade,1,1)
                 else
                    if (iatclr(m).ne.iatclr(k)) then
                       call astick(zvect,colsc,icltan,m,k,ihigh,
     &                             shade,0,1)
                    else
                       call mstick(zvect,colsc,icltan,m,k,shade,0)
                    endif
                 endif
              endif
              if (iaton(m).ge.1.and.im.gt.0) nc = nc + 1
            end do
            if (nc.eq.0.and..not.dsurf) 
     &          call snglat(zvect,scal,colsc,icltan,k,ihigh,
     &                               shade,atcol,0,0,0)
            if (fyesno.eq.1) 
     &          call plfc(shade,ixx,k,ihigh,colsc,icltan,zvect)
            if (idipon.eq.1) call pldip(shade,ihigh,colsc,icltan,zvect,
     &                                  dipo,coo,ianz,xv,yv,scal,scali)
            endif
         end do
        endif

      endif

      xx = 1.0
      call cwidth(xx)
      call sollin

      call plalab(iqon)
      call reslab
      
      return
      end

      subroutine plfd(shade,ixx,k,ihigh,colsc,icltan,zvect,
     &                coo,rzp,ixp,iyp,
     &                xv,yv,scal,scali)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat)
      real xx
      integer*2 ixx(24)
      integer shade
      character str*13
      dimension tmp1(3),tmp2(3),zvect(3)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*)

      do l=1,3
          tmp1(l) = fc(l,k) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      itemp = abs(icltan*cot1)
      xs    = (rzp(k)/scali-1.d0)/2.0d0

      rfac  = (1.0d0-colsc*xs*xs)
      if (rfac.lt.0.0d0) rfac = 0.d0
      if (rfac.gt.1.0d0) rfac = 1.d0

      itmp = 5*rfac

      if (shade.eq.1) then
         kcol = 16+(9-itemp)*rfac
      else
         kcol = 25
      endif

      call setcol(kcol)

      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call sollin

      ixx(2) = ixp(k)
      ixx(1) = iyp(k)

      call rotts(fc(1,k),fc(2,k),fc(3,k),xc,yc,zc,1)

      ixx(4) = (0.5d0 - (xc-xv)/scal)*ihigh
      ixx(3) = (0.5d0 - (yc-yv)/scal)*ihigh

      call drawseg(ixx,1,0)

      return
      end

      subroutine pldip(shade,ihigh,colsc,icltan,zvect,dipo,
     &                 coo,ianz,xv,yv,scal,scali)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      common /athlp/ iatoms, mxnat
      real xx
      integer*2 ixx(4)
      integer shade
      character str*13
      dimension tmp1(3),tmp2(3),tmp3(3),zvect(3)
      dimension coo(3,*),ianz(*),dipo(*)

      call cntvec(tmp1,coo,ianz,iatoms)

      do l=1,3
          tmp2(l) = dipo(l) - tmp1(l)
      end do

      call rott(tmp2(1),tmp2(2),tmp2(3),tmp3(1),tmp3(2),tmp3(3),0)
      call impsc(tmp3,zvect,cot1)

      call rott(tmp1(1),tmp1(2),tmp1(3),xc,yc,zc,1)
      ixx(2) = (0.5d0 -(xc - xv)/scal)*ihigh
      ixx(1) = (0.5d0 -(yc - yv)/scal)*ihigh

      itemp = abs(icltan*cot1)
      xs    = (zc/scali-1.d0)/2.0d0

      rfac  = (1.0d0-colsc*xs*xs)
      if (rfac.lt.0.0d0) rfac = 0.d0
      if (rfac.gt.1.0d0) rfac = 1.d0

      itmp = 5*rfac

      if (shade.eq.1) then
         kcol = 16+(9-itemp)*rfac
      else
         kcol = 25
      endif

      call setcol(kcol)

      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call sollin


      call rott(dipo(1),dipo(2),dipo(3),xc,yc,zc,1)

      ixx(4) = (0.5d0 - (xc-xv)/scal)*ihigh
      ixx(3) = (0.5d0 - (yc-yv)/scal)*ihigh

      call drawseg(ixx,1,0)

      return
      end

      subroutine msticd(zvect,colsc,icltan,m,k,shade,idash,
     &                  coo,rzp,ixp,iyp,iatclr,scali)
      implicit double precision (a-h,o-z)
      integer shade
      real xx
      integer*2 ixx(24)
      character str*13
      dimension tmp1(3),tmp2(3),zvect(3)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*),iatclr(*)

      do l=1,3
          tmp1(l) = coo(l,m) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      itemp = icltan*cot1
      xs = (((rzp(k) + 0.5d0*(rzp(m) - rzp(k)))/scali)-1.d0)/2.0d0

      rfac = (1.0d0-colsc*xs*xs)
      if (rfac.lt.0.0d0) rfac = 0.d0

      itmp = 5*rfac
      if (shade.eq.1) then
         kcol = 16+(iatclr(k)-1)*10+(9-itemp)*rfac
      else
         kcol = iatclr(k)
      endif

      call setcol(kcol)

      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call dash(idash)

      ixx(1) = iyp(k)
      ixx(2) = ixp(k)
      ixx(3) = iyp(m)
      ixx(4) = ixp(m)

      call drawseg(ixx,1,0)
      call dash(0)

      return
      end

      subroutine ssticd(coo,ixp,iyp,iaton,iconn,xy,yv,scal)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxseg=1000)
      common /athlp/ iatoms, mxnat
      real xx
      integer*2 ixx(mxseg*4)
      dimension coo(3,*),ixp(*),iyp(*),iaton(*),iconn(mxcon+1,*)

      xx = 1.0
      call cwidth(xx)
      call setcol(15)

      call gethei(ihigh)

      if (iatoms.eq.0) return

      do j=1,iatoms
          call rott(coo(1,j),coo(2,j),coo(3,j),xc,yc,zc,1)
          if (iaton(j).ge.1) then
             ixp(j) = (0.5d0 -(xc - xv)/scal)*ihigh
             iyp(j) = (0.5d0 -(yc - yv)/scal)*ihigh
          else
             ixp(j) = 0
             iyp(j) = 0
          endif
      end do

      nseg = 0

      do i=1,iatoms

         if (iaton(i).ge.1) then

            do j=1,iconn(1,i)
               m = iconn(1+j,i)
               nn = nseg*4

               ixx(nn+1) = iyp(i)
               ixx(nn+2) = ixp(i)
               ixx(nn+3) = iyp(m)
               ixx(nn+4) = ixp(m)

               nseg = nseg + 1

               if (nseg.eq.mxseg) then
                  call drwseg(ixx,mxseg,0)
                  nseg = 0
               endif

            end do

         endif

      end do

      if (nseg.gt.0) call drwseg(ixx,mxseg,0)

      return
      end

      subroutine asticd(zvect,colsc,icltan,m,k,ihigh,shade,idash,
     &                  imon,coo,rzp,ixp,iyp,ianz,iatclr,xv,yv,
     &                  scal,scali)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      integer shade
      real xx
      integer*2 ixx(24)
      dimension temp(6),tmp1(3),tmp2(3),zvect(3)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*),ianz(*),iatclr(*)

      ik = ianz(k)
      im = ianz(m)

      do l=1,3
         temp(l) = (coo(l,m) - coo(l,k))/2.0d0 + coo(l,k)
      end do

      call rott(temp(1),temp(2),temp(3),xc,yc,zc,1)

      ixt = (0.5d0 -(xc - xv)/scal)*ihigh
      iyt = (0.5d0 -(yc - yv)/scal)*ihigh

      do l=1,3
         tmp1(l) = coo(l,m) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      itemp = icltan*cot1
      xs = (rzp(k)/scali-1.0d0)/2.0d0

      rfac = (1.0d0-colsc*xs*xs)
      if (rfac.lt.0.0d0) rfac = 0.d0
      itmp = 5*rfac

      if (imon.eq.1) then
         icolt = iatclr(k)
      else
         if (ik.eq.6.and.icol(ik).eq.14) then
            icolt = 10
         else
            icolt = icol(ik)
         endif
      endif

      if (shade.eq.1) then
         kcol = 16+(icolt-1)*10+(9-itemp)*rfac
      else
         kcol = icolt
      endif

      call setcol(kcol)

      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call dash(idash)

      ixx(1) = iyp(k)
      ixx(2) = ixp(k)
      ixx(3) = iyt
      ixx(4) = ixt

      call drawseg(ixx,1,0)

      xs = (rzp(m)/scali-1.0d0)/2.0d0
      rfac = (1.0d0-colsc*xs*xs)
      if (rfac.lt.0.0d0) rfac = 0.d0
      itmp = 5*rfac

      if (imon.eq.1) then
         icolt = iatclr(m)
      else
         if (im.eq.6.and.icol(im).eq.14) then
            icolt = 10
         else
            icolt = icol(im)
         endif
      endif

      if (shade.eq.1) then
         kcol = 16+(icolt-1)*10+(9-itemp)*rfac
      else
         kcol = icolt
      endif

      call setcol(kcol)

      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call dash(idash)

      ixx(1) = iyp(m)
      ixx(2) = ixp(m)
      ixx(3) = iyt
      ixx(4) = ixt

      call drawseg(ixx,1,0)
      call dash(0)

      if (idash.eq.1) call pldst(k,m,ixt,iyt,0)

      return
      end

      subroutine snglad(zvect,scalp,colsc,icltan,k,ihigh,shade,
     &                  atcol,ipersp,ipost,icolps,
     &                  coo,rzp,ixp,iyp,ianz,iatclr,
     &                  xv,yv,zv,c0,scal,scali)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5

      integer shade,atcol
      real xx
      integer*2 ixx(4)
      dimension tmp1(3),tmp2(3),zvect(3)
      dimension cv(3,6),rzt(6),ixt(6),iyt(6),inat(6)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*),ianz(*),iatclr(*)

      ik = ianz(k)
      rsiz = 0.4d0

      do i=1,6
         do j=1,3
            cv(j,i) = 0.0d0
         end do
      end do
      do i=1,3
         cv(i,i) = rsiz
         cv(i,i+3) = -rsiz
      end do
      

      do i=1,6

         do j=1,3
            tmp1(j) = coo(j,k) + cv(j,i)
         end do

         call rott(tmp1(1),tmp1(2),tmp1(3),xc,yc,zc,1)

         rzt(i) = zc
         if (ipersp.eq.1) then
            rp = c0/(zv - zc + c0)
            ixt(i) = (0.5d0 -rp*(xc - xv)/scalp)*ihigh
            iyt(i) = (0.5d0 -rp*(yc - yv)/scalp)*ihigh
         else
            if (ipost.eq.1) then
               ixt(i) = (0.5d0 +(xc - xv)/scalp)*ihigh
               iyt(i) = (0.5d0 -(yc - yv)/scalp)*ihigh
            else
               ixt(i) = (0.5d0 -(xc - xv)/scal)*ihigh
               iyt(i) = (0.5d0 -(yc - yv)/scal)*ihigh
            endif
         endif
      end do
      call shsort(6,rzt,inat)

      if (ipost.eq.1) then
         call rott(coo(1,k),coo(2,k),coo(3,k),xc,yc,zc,1)
         ixpp = (0.5d0 +(xc - xv)/scalp)*ihigh
         iypp = (0.5d0 -(yc - yv)/scalp)*ihigh
      endif

      do i=1,6
         m = inat(i)

         do l=1,3
            tmp1(l) = cv(l,m)
         end do

         call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
         call impsc(tmp2,zvect,cot1)

         cot1 = dabs(cot1)
         itemp = icltan*cot1

         if (ipersp.eq.1) then
            xs = (zv - rzp(k))/scali
         else
            xs = (rzt(m)/scali-1.0d0)/2.0d0
         endif

         rfac = (1.0d0-colsc*xs*xs)
         if (rfac.lt.0.0d0) rfac = 0.d0

         if (atcol.eq.1) then
            if (ik.eq.6.and.icol(ik).eq.14) then
               icolt = 10
            else
               if (ik.le.0) then
                  icolt = 1
               else
                  icolt = icol(ik)
               endif
            endif
         else
            icolt = iatclr(k)
         endif

c postscript
         if (ipost.eq.1) then

            call plbnd(iun4,iypp,ixpp,iyt(m),ixt(m),1,1,icolps,
     &       1,icolt,cot1,0,atcol,shade,.false.,.false.,.false.)

         else
c xwindows
            if (shade.eq.1) then
               kk = (9-itemp)*rfac
               kcol = 16+(icolt-1)*10+kk
            else
               kcol = icolt
            endif

            call setcol(kcol)

            itmp = 5*rfac
            xx = (itmp+5)/2+0.5
            if (xx.lt.0.5) xx = 1.0

            call cwidth(xx)
            call dash(0)

            ixx(1) = iyp(k)
            ixx(2) = ixp(k)
            ixx(3) = iyt(m)
            ixx(4) = ixt(m)

            call drawseg(ixx,1,0)
   
         endif
      
      end do

      return
      end

      subroutine fsticd(roddef,rfac,zvect,colsc,icltan,m,k,ihigh,
     &                  shade,atcol,scnd,
     &                  coo,rzp,ianz,iatclr,
     &                  xv,yv,scal,scali)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /helpar/ helrod, ihtype
      logical scnd,twostk
      integer shade,atcol
      real cosa, sina
      dimension tmp1(3),tmp2(3),tmp3(3),zvect(3)
      dimension rtmp1(3),rtmp2(3),rtmp3(3)
      dimension coo(3,*),rzp(*),ianz(*),iatclr(*)

      tol = 1.0d-5

      ik = ianz(k)
      im = ianz(m)
      v1 = vrad(ik)
      v2 = vrad(im)
      twostk = .false.
      if (atcol.eq.1) then
         if (ik.ne.im) twostk = .true.
      else
         if (iatclr(k).ne.iatclr(m)) twostk = .true.
      endif

      if (ik.eq.100.and.im.eq.100) then
          rodrad = helrod
      elseif (ik.ne.1.and.im.ne.1) then
c          rodrad = roddef*2
          rodrad = 0.46d0*v1
          if (v2.lt.v1) rodrad = 0.46d0*v2
      else
          rodrad = roddef
      endif
      rodrd2 = rodrad*rodrad

      do l=1,3
          tmp1(l) = coo(l,m) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      do l=1,3
          tmp1(l) = coo(l,k) - coo(l,m)
      end do

      if (v1.lt.rodrad.and.v2.lt.rodrad) then

          do l=1,3
             tmp2(l) = coo(l,k)
          end do

          do l=1,3
             tmp3(l) = coo(l,m)
          end do 

      else

          sc1 = dsqrt(dabs(v1*v1-rodrd2))

          call vsc1(tmp1,sc1,tol)

          do l=1,3
             tmp2(l) = coo(l,k) - tmp1(l)
          end do

          sc2 = dsqrt(dabs(v2*v2-rodrd2))

          call vsc1(tmp1,sc2,tol)

          do l=1,3
             tmp3(l) = coo(l,m) + tmp1(l)
          end do 

      endif

      do l=1,3
          if (twostk) then
             tmp1(l) = (tmp3(l) - tmp2(l))/2.0d0 + tmp2(l)
          else
             tmp1(l) = tmp3(l)
          endif
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),rtmp1(1),rtmp1(2),rtmp1(3),1)
      call rott(tmp2(1),tmp2(2),tmp2(3),rtmp2(1),rtmp2(2),rtmp2(3),1)
      call rott(tmp3(1),tmp3(2),tmp3(3),rtmp3(1),rtmp3(2),rtmp3(3),1)

      itemp = 5*cot1
      idiam1 = (rodrad/scal)*ihigh

      if (shade.eq.1) then
          if (atcol.eq.1.and..not.scnd) then
             i1 = 16 +(icol(ik)-1)*10
          else
             i1 = 16 +(iatclr(k)-1)*10
          endif
          i2 = (9-itemp)*rfac+.5d0
      else
          if (atcol.eq.1.and..not.scnd) then
             i1 = icol(ik)
          else
             i1 = iatclr(k)
          endif
      endif

      do l=1,3
          tmp1(l) = rtmp2(l) - rtmp1(l)
      end do

      clll = dsqrt(tmp1(1)*tmp1(1) + tmp1(2)*tmp1(2))
      if (clll.lt.tol) clll = tol
      irodl = (clll/scal)*ihigh + 1

      call impsc(tmp1,zvect,cosb)

      idiam2 = (dabs(cosb)*rodrad/scal)*ihigh
      cosa = -tmp1(1)/clll
      sina = tmp1(2)/clll

      icy = (0.5d0 -(rtmp2(1) - xv)/scal)*ihigh
      icx = (0.5d0 -(rtmp2(2) - yv)/scal)*ihigh

      if (shade.eq.1) then
          call plrod3(icx,icy,idiam1,idiam2,idiam1,irodl,
     &                i1,i2,cosa,sina)
      else
          call plrodx(icx,icy,idiam1,idiam2,idiam1,irodl,
     &                i1,cosa,sina)
      endif

      if (twostk) then

          xs = (rzp(m)/scali-1.0d0)/2.0d0
          rfac = (1.0d0-1.d0*xs*xs)
          if (rfac.lt.0.0d0) rfac = 0.d0

          if (shade.eq.1) then
             if (atcol.eq.1.and..not.scnd) then
                i1 = 16 +(icol(im)-1)*10
             else
                i1 = 16 +(iatclr(m)-1)*10
             endif
          else
             if (atcol.eq.1.and..not.scnd) then
                i1 = icol(im)
             else
                i1 = iatclr(m)
             endif
          endif

          i2 = (9-itemp)*rfac+.5d0

          do l=1,3
             tmp1(l) = rtmp1(l) - rtmp3(l)
          end do

          clll = dsqrt(tmp1(1)*tmp1(1) + tmp1(2)*tmp1(2))

          if (clll.lt.tol) clll = tol
          irodl = (clll/scal)*ihigh + 1

          call impsc(tmp1,zvect,cosb)

          idiam2 = (dabs(cosb)*rodrad/scal)*ihigh

          cosa = -tmp1(1)/clll
          sina = tmp1(2)/clll

          icy = (0.5d0 -(rtmp1(1) - xv)/scal)*ihigh
          icx = (0.5d0 -(rtmp1(2) - yv)/scal)*ihigh

          if (shade.eq.1) then
              call plrod3(icx,icy,idiam1,idiam2,idiam1,irodl,
     &                    i1,i2,cosa,sina)
          else
              call plrodx(icx,icy,idiam1,idiam2,idiam1,irodl,
     &                    i1,cosa,sina)
          endif
      endif

      return
      end

      subroutine fndmzz(ixyz,istat,imap)

c this is really fndmap

      implicit double precision (a-h,o-z)
      common /zmfrst/ ihaszm, nz, mxzat
      dimension imap(*)

      istat = 0
      do i=1,nz
         if (imap(i).eq.ixyz) then
             istat = i
             return
         endif
      end do

      return
      end

      subroutine pldst(k,m,ixt,iyt,ipltyp)
      implicit double precision (a-h,o-z)
      parameter (maxdm=20)
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character vstr*8

      if (ipltyp.eq.0) call setcol(15)
      do i=1,ndm
         if ((idmon(1,i).eq.k.and.idmon(2,i).eq.m).or.
     &       (idmon(2,i).eq.k.and.idmon(1,i).eq.m)) then
             write(vstr,'(f8.3)') rdm(i)
             if (ipltyp.eq.0) then
                call drwstr(ixt,iyt,vstr,8,-1)
             else
                write(iun4,*) ixt,' ',iyt,'  m (',vstr,') show'
             endif
         endif
      end do

      return
      end

      subroutine pldstd(ixp,iyp)
      implicit double precision (a-h,o-z)
      parameter (maxdm=20)
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character vstr*8
      dimension ixp(*),iyp(*)

      call setcol(15)

      do i=1,ndm
         ixt = (ixp(idmon(1,i)) + ixp(idmon(2,i))) / 2
         iyt = (iyp(idmon(1,i)) + iyp(idmon(2,i))) / 2
         write(vstr,'(f8.3)') rdm(i)
         call drwstr(ixt,iyt,vstr,8,-1)
      end do

      return
      end

      subroutine pllad(ixp,iyp,ianz,k,qat,inr,iqon,ires,ipost,
     &                 ityp,ipdbt,iamino,reson)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (mxppmf=16)
      parameter (mxlpmf=26)
      parameter (mxmol2=41)
      parameter (mxmm3=164)
      parameter (mxchm=82)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxmsf=235)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      parameter (mxgmx=53)
      parameter (mxgmx2=57)
      parameter (mxg43=49)
      parameter (mxres=42)
      character str*19
      character*5 hstr 
      character*8 zst
      integer fndmap
      character*2 elemnt
      common /elem/elemnt(mxel)
      integer*2 ityp,ipdbt
      common /types/ iff
      character*2 ppmf, lpmf
      character*5 mol2
      character*19 mm3
      character*20 chmtnk
      character*20 ambstr
      character*20 amostr
      character*4 chmsf
      common /ftypes/ihasl(11),mol2(mxmol2),mm3(mxmm3),chmtnk(mxchtp),
     &               chmsf(mxmsf),ambstr(mxamb),amostr(mxamo),
     &               ppmf(mxppmf),lpmf(mxlpmf)
      character*3 pdbsym,hsym,chtnk,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      character*5 gro43,grogmx,grog2x,gro43l,grogmxl,grog2xl
      character*35 gro43s, grogms, grog2s
      common /symgro/ gro43(mxg43),grogmx(mxgmx),grog2x(mxgmx2),
     &                gro43l(mxg43),grogmxl(mxgmx),grog2xl(mxgmx2),
     &                gro43s(mxg43),grogms(mxgmx),grog2s(mxgmx2)
      integer reson
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /nmr/    shlnuc(numatm),ihsnmr
      dimension ityp(*),ipdbt(*),iamino(*),reson(*)

      if (ianz.eq.100) return

      nstr = 0
      str = "                  "

      if (iqon.eq.0) then

         str = elemnt(ianz)
         nstr = 2

      elseif (iqon.eq.1) then

         if (inr.eq.1) then
            call zzrstr(fndmap(k),zst,6,nstr)
            str =  elemnt(ianz)//zst(1:nstr)
            nstr = nstr + 2
         else
            call zzrstr(k,zst,6,nstr)
            str =  elemnt(ianz)//zst(1:nstr)
            nstr = nstr + 2
         endif

      elseif (iqon.eq.2) then

         il = ityp(k)
         ift = iff + 1
         if (ihasl(ift).gt.0.and.(il.gt.0.or.iff.eq.7)) then
            nstr = ihasl(ift)
            if (iff.eq.1) then
               str = mm3(il)
            elseif (iff.eq.2) then
               str = chtnk(il)
            elseif (iff.eq.3) then
               str = ambtnk(il)
            elseif (iff.eq.4) then
               str = amotnk(il)
            elseif (iff.eq.5) then
               str = mol2(il)
            elseif (iff.eq.6) then
               str = chmsf(il)
            elseif (iff.eq.7) then
               if (il.gt.0) then
                  str = ambtnk(il)
               elseif (il.lt.0) then
                  str = gffstr(iabs(il))
               endif
            elseif (iff.eq.8) then
               if (ires.gt.0) then
                  str = ppmf(il)
               else
                  str = lpmf(il)
               endif
            elseif (iff.eq.9) then
               str = grogmxl(il)
            elseif (iff.eq.10) then
               str = grog2xl(il)
            elseif (iff.eq.11) then
               str = gro43l(il)
            endif
         elseif (ihasl(ift).eq.0.and.il.gt.0) then
            str = hstr(il)
            nstr = 5
         else
            str = ' '
            nstr = 1
         endif

      elseif (iqon.eq.3) then

         if (ipost.eq.1) then
            write(str,'(a2,a1,f7.4)') elemnt(ianz),' ',qat
         endif
         nstr = 10

      elseif (iqon.eq.4) then

         if (ires.gt.0) then
            iam = iamino(ires)
            if (iam.gt.0.and.iam.le.mxres) then
               if (reson(ires).eq.1) then
                  if (ianz.eq.1) then
c                     ih = (ipdbt(k)-1)/3
c                     str = hsym(ih+1)
c                     nstr = 3
            ik = ipdbt(k)
            ih = (ipdbt(k)-1)/3
            call zzrstr(ik,zst,6,nstr)
            str =  hsym(ih+1)//zst(1:nstr)
            nstr = nstr + 3
                  else
c                     str = pdbsym(ipdbt(k))
c                     nstr = 3
            ik = ipdbt(k)
            call zzrstr(ik,zst,6,nstr)
            str =  pdbsym(ipdbt(k))//zst(1:nstr)
            nstr = nstr + 3
                  endif
               endif
            endif
         endif

      elseif (iqon.eq.6) then

         if (ipost.eq.1) then
            write(str,'(a2,a1,f7.4)') elemnt(ianz),' ',qat
         endif
         nstr = 10

      endif

      if (nstr.gt.0) then
         if (ipost.eq.1) then
            write(iun4,'(''labelcol'')')
            write(iun4,*) iyp,' ',ixp,' m (',str(1:nstr),') show'
         else
            if (iqon.eq.3) then
c this exception is to avoid recursive IO in fortran
               call drwqstr(ixp,iyp,ianz,qat,k)
            elseif (iqon.eq.6) then
               shl = shlnuc(k)
               call drwqstr(ixp,iyp,ianz,shl,k)
            else
               call drwstr(ixp,iyp,str,nstr,k)
            endif
         endif
      endif

      return
      end

      subroutine plalad(iqon,rzp,ixp,iyp,
     &                  icalf,ianf,islu,nchain,iamino,reson,
     &                  irsnr,achain,scali)
      implicit double precision (a-h,o-z)
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      integer reson
      integer dolabs,fancy,shade,atcol,persp,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      parameter (mxel=100)
      parameter (mxres=42)
      character*3 aminos
      common /amino/aminos(mxres)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      character str*13
      character*1 achain
      dimension rzp(*),ixp(*),iyp(*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),reson(*),
     &          irsnr(*),achain(*)

      if (iqon.eq.5.and.ipdbon.eq.1.and.dolabs.eq.1) then

         nstr = 8
         if (nchain.gt.1) nstr = 10

         do k=1,nchain

            do j=ianf(k),islu(k)

               jj = j - ianf(k) + 1

               if (reson(j).eq.1) then

                  l = icalf(1,j)

                  if (shade.eq.1) then
                     xs = (rzp(l)/scali-1.0d0)/2.0d0
                     rfac = (1.0d0-1.d0*xs*xs)
                     if (rfac.lt.0.0d0) rfac = 0.d0
                     kcol = 156 + 9*rfac
                  else
                     kcol = 15
                  endif

                  call setcol(kcol)

                  str(1:3) = aminos(iamino(j))
                  str(4:4) = ' '
                  write(str(5:8),'(i4)') irsnr(j)

                  if (nchain.gt.1) then
                     str(9:9) = '.'
                     str(10:10) = achain(j)
                  endif

                  call drwstr(ixp(l),iyp(l),str,nstr,l)

               endif

            end do

         end do

      end if

      return
      end

      integer function getprt(jres,ianz,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension iconn(mxcon+1,*),ianz(*)

      ind1 = 0
      ine2 = 0

      call getpdb(jres,ipdb,ihpdb)

      if (ipdb(20).ne.0) then
         if (iconn(1,ipdb(20)).eq.3) then
            if (ianz(iconn(2,ipdb(20))).eq.1) ind1 = 1
            if (ianz(iconn(3,ipdb(20))).eq.1) ind1 = 1
            if (ianz(iconn(4,ipdb(20))).eq.1) ind1 = 1
         endif
      endif

      if (ipdb(24).ne.0) then
         if (iconn(1,ipdb(24)).eq.3) then
            if (ianz(iconn(2,ipdb(24))).eq.1) ine2 = 1
            if (ianz(iconn(3,ipdb(24))).eq.1) ine2 = 1
            if (ianz(iconn(4,ipdb(24))).eq.1) ine2 = 1
         endif
      endif

      if (ind1.eq.1.and.ine2.eq.1) then
         getprt = 1
      else if (ind1.eq.1) then
         getprt = 2
      else if (ine2.eq.1) then
         getprt = 3
      endif

      return
      end

      subroutine reslad(rzp,ixp,iyp,ianz,iconn,
     &                  icalf,nchain,iamino,reson,
     &                  irsnr,lab,ihets,
     &                  achain,ncalf,scali)
      implicit double precision (a-h,o-z)
      integer reson,getprt
      parameter (mxcon=10)
      parameter (mxres=42)
      parameter (mxheta=150)
      character*3 aminos
      common /amino/aminos(mxres)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      character str*13
      character*1 achain
      dimension rzp(*),ixp(*),iyp(*),ianz(*)
      dimension icalf(6,*),iamino(*),reson(*),
     &          irsnr(*),lab(*),ihets(*),achain(*),iconn(mxcon+1,*)


      nstr = 8
      if (nchain.gt.1) nstr = 10

      do j=1,ncalf

         if (reson(j).eq.1.and.lab(j).eq.7) then

            l = icalf(1,j)

            if (shade.eq.1) then
               xs = (rzp(l)/scali-1.0d0)/2.0d0
               rfac = (1.0d0-1.d0*xs*xs)
               if (rfac.lt.0.0d0) rfac = 0.d0
               kcol = 156 + 9*rfac
            else
               kcol = 15
            endif

            call setcol(kcol)

            str(1:3) = aminos(iamino(j))
            iprt = getprt(j,ianz,iconn)

            if (iprt.eq.1) str(3:3) = "P"
            if (iprt.eq.2) str(3:3) = "D"
            if (iprt.eq.3) str(3:3) = "E"

            str(4:4) = ' '
            write(str(5:8),'(i4)') irsnr(j)

            if (nchain.gt.1) then
               str(9:9) = '.'
               str(10:10) = achain(j)
            endif

            call drwstr(ixp(l),iyp(l),str,nstr,-1)

         endif

      end do

      nstr = 4
      do i=1,mxheta
         if (ligcat(i).ne.-1.and.ihets(i).ge.1.and.
     &       labhet(i).eq.6) then
            l = ligcat(i) + 1

            if (shade.eq.1) then
               xs = (rzp(l)/scali-1.0d0)/2.0d0
               rfac = (1.0d0-1.d0*xs*xs)
               if (rfac.lt.0.0d0) rfac = 0.d0
               kcol = 156 + 9*rfac
            else
               kcol = 15
            endif

            call setcol(kcol)

            str(1:3) = hetz(i)
            str(4:4) = ' '

            call drwstr(ixp(l),iyp(l),str,nstr,-1)
         endif
      end do

      return
      end


      subroutine plald(iami,ixp,iyp,
     &                 icalf,iamino,irsnr)
      implicit double precision (a-h,o-z)
      parameter (mxres=42)
      character*3 aminos
      common /amino/aminos(mxres)
      character str*13
      dimension ixp(*),iyp(*),icalf(6,*),iamino(*),irsnr(*)

      nstr = 8
      l = icalf(1,iami)
      kcol = 15

      call setcol(kcol)

      str(1:3) = aminos(iamino(iami))
      str(4:4) = ' '
      write(str(5:8),'(i4)') irsnr(iami)

      call drwstr(ixp(l),iyp(l),str,nstr,l)

      return
      end

      subroutine stlab(irs,ilab,idres,iqon,lab,labhet)
      implicit double precision (a-h,o-z)
      dimension lab(*),labhet(*)

      idres = 0
      ilab = iqon
      if (irs.gt.0) then
         if (lab(irs).gt.0) then
            idres = 1
            ilab = lab(irs)-2
         endif
      else
         if (labhet(abs(irs)+1).gt.0) then
            idres = 1
            ilab = labhet(abs(irs)+1)-2
         endif
      endif

      return
      end

      subroutine snypnt(x1,y1,z1,x2,y2,z2,hght,sx,sy,sz)
      implicit double precision (a-h,o-z)
      dimension temp(3)

      temp(1) = x2 - x1
      temp(2) = y2 - y1
      temp(3) = z2 - z1

      rlambd = (hght - z1) / temp(3) 

      sx = x1 + rlambd*temp(1)
      sy = y1 + rlambd*temp(2)
      sz = z1 + rlambd*temp(3)

      return
      end

      subroutine plotgh(ipen,ex,ey)
      implicit double precision (a-h,o-z)
      character*64 carray
      character*5 tk4014
      character*13 str
      real xx, yy
      common /plot / iplot,iplwin,icolps
      common /tektro/ carray, ic
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
************************************************************************
*
* PLOTGH IS THE HIDE PLOTTING SUBROUTINE, AND SHOULD BE MODIFIED
*     t  TO SUIT THE LOCAL CONDITIONS.
* CONVENTIONS USED HERE ARE:
*   IPEN   = 1   PEN UP (NO LINE DRAWN, BUT PEN MOVES TO 
*                THE POSITION EX, EY)
*   IPEN   = 2   PEN DOWN (A LINE IS DRAWN FROM THE LAST POSITION TO 
*                THE POINT EX, EY)
*   EX, EY       'X' AND 'Y' COORDINATES. PEN WILL MOVE TO THIS POINT.
*
************************************************************************


      r2 = dsqrt(2.0d0)
      dx = 0.5d0 + ex/r2
      dy = 0.5d0 + ey/r2
      if (iplot.eq.6) then
         xx = dx
         yy = dy
         if (ipen.eq.1) then
             call xwin(xx,yy,2,str,nstr,inct,incp)
         else
             call xwin(xx,yy,3,str,nstr,inct,incp)
         endif
         ipen = 3 - ipen
         return
      endif
      dx = max(0.d0,min(1.d0,dx))
      dy = max(0.d0,min(1.d0,dy))
      if (ipen.eq.1) then
        if (iplot.eq.0) write(iun4,1)dx,dy
        if (iplot.eq.1) write(iun4,30)dx,dy
        if (iplot.eq.2) write(iun4,50)char(27),int(389*dx)
     +                             ,int(389*dy)
        if (iplot.eq.4) then
           write(iun4,'(''s'')')
           write(iun4,'(''n'')')
           write(iun4,90)int(dx*2000),int(dy*2000)+125
        endif
      else
        if (iplot.eq.0) write(iun4,2)dx,dy
        if (iplot.eq.1) write(iun4,40)dx,dy
        if (iplot.eq.2) write(iun4,60)char(27),int(389*dx)
     +                             ,int(389*dy)
        if (iplot.eq.4) then
          write(iun4,100)int(dx*2000),int(dy*2000)+125
        endif
 
      endif
      if (iplot.eq.3) then
         if (ipen.eq.1) then
c-- voer laaste line series uit
           if (carray(1:1).eq.char(29)) then
            carray(7+ic*5:7+ic*5) = char(13)
            write(iun4,'(a)') carray(1:7+ic*5)
           endif
           carray(1:1) = char(29)
           carray(2:6) = tk4014(int(dx*3100),int(dy*3100))
           ic = 0
         else
           if (ic.eq.9) then
             carray(7+ic*5:7+ic*5) = char(13)
             write(iun4,'(a)') carray(1:7+ic*5)
             carray(2:6)  = carray(2+ic*5:6+ic*5)
             carray(7:11) = tk4014(int(dx*3100),int(dy*3100))
             ic = 1
           else
             ic = ic + 1
             carray(2+ic*5:6+ic*5) = tk4014(int(dx*3100),
     &       int(dy*3100))
           endif
         endif
      endif
1     format('.m',f8.5,f8.5)  
2     format('.d',f8.5,f8.5)
30    format(' PU',f8.4,f8.4,';')  
40    format(' PD',f8.4,f8.4,';')
50    format(a,'*pa',i3,',',i3,'Z')
60    format(a,'*pb',i3,',',i3,'Z')
90    format(' ',i4,' ',i4,' m')
100    format(' ',i4,' ',i4,' l')
      ipen = 3 - ipen

      return
      end

      subroutine cond34(istat,nac,iac,nad,iad,iconn)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      common /athlp/  iatoms, mxnat
      dimension iconn(mxcon+1,*), 
     &          nac(*),nad(*),iac(mxac,*),iad(mxad,*)

      istat = 1

      do i=1,iatoms
         nac(i) = 0

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)

            if (jj.gt.0) then

               do k=1,iconn(1,jj)
                  kk = iconn(1+k,jj)

                  if (kk.ne.i.and.kk.gt.0) then
                     ido = 1

c check if 1-3 atom is not already 1-2

                     do l=1,iconn(1,i)
                        if (kk .eq. iconn(1+l,i)) ido = 0
                     end do

                     if (nac(i).lt.mxac) then
                        if (ido.eq.1) then
                           nac(i) = nac(i) + 1
                           iac(nac(i),i) = kk
                        endif
                     else
                        istat = 0
                        return
                     endif

                  endif

               end do

            endif

         end do

      end do

      do i=1,iatoms
         nad(i) = 0

         do j=1,nac(i)
            jj = iac(j,i)

            do k =1,iconn(1,jj)
               kk = iconn(1+k,jj)

               if (kk.ne.i.and.kk.gt.0) then
                  ido = 1

c check if 1-4 atom is not already 1-3, or 1-2

                  do l=1,iconn(1,i)
                     if (kk.eq.iconn(1+l,i)) ido = 0
                  end do
                  do l=1,nac(i)
                     if (kk.eq.iac(l,i)) ido = 0
                  end do
                  do l=1,nad(i)
                     if (kk.eq.iad(l,i)) ido = 0
                  end do

                  if (nad(i).lt.mxad) then
                     if (ido.eq.1) then
                        nad(i) = nad(i) + 1
                        iad(nad(i),i) = kk
                     endif
                  else
                     istat = 0
                     return
                  endif

               endif

            end do

         end do

      end do

      return
      end

      subroutine rdvecd(idebug,ig94,istats,
     &                  vectrs,vectrb,focc,eiga,eigb,ncols,ncolb)
      implicit double precision (a-h,o-z)
      parameter (mxcol=10)
      parameter (numatm=2000)
      character*137 line
      common /orbhlp/ mxorb,iuhf,ispd
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical natorb,nlmo,reo
      real eiga,eigb
      dimension vectrs(*),vectrb(*),focc(*),eiga(*),eigb(*)
      dimension vt(15,mxcol),irord(15)

      istats = 1
      reo = .false.

      irord(1)  = 15
      irord(2)  = 5
      irord(3)  = 1
      irord(4)  = 14
      irord(5)  = 13
      irord(6)  = 9
      irord(7)  = 4
      irord(8)  = 6
      irord(9)  = 2
      irord(10) = 12
      irord(11) = 10
      irord(12) = 3
      irord(13) = 11
      irord(14) = 8
      irord(15) = 7

      natorb = .false.
      nlmo = .false.
      npl = 5
      if (idebug.eq.1) 
     &      call inferr('Looking for Molecular Orbital Coefficients',0)

      call searcht(line,'Molecular Orbital Coefficients',
     &    'Natural Orbital Coefficients',
     &    'NLMOs in the AO basis:',istat)
      if (istat.eq.0) then
       call inferr('no MO COEFFICIENTS found on GAUSSIAN outputfile',0)
        goto 150
      endif
      if (index(line,'Natural').ne.0.or.index(line,'NATURAL').ne.0) then
          natorb = .true.
          iuhf = 0
      endif
      if (index(line,'NLMO').ne.0) then
          nlmo = .true.
          npl = 8
          iuhf = 0
          ido5d = 1
          ido7f = 1
          ido9g = 1
      endif
      imin = 0
      imax = 0
      npass = (ncols - 1) / npl + 1
      do ipass=1,npass
         imin = imax + 1
         imax = imax + npl
         imax = min0(ncols,imax)
         do i =1,10
            call nxtlin(line,jstat)
            call tocap(line,80)
            if (nlmo) then
               if (index(line,' AO ').ne.0) then
                  call redel(line,1)
                  goto 100
               endif
            else
               if (index(line,'EIGENVALUES').ne.0) goto 100
            endif
         end do
         if (imax.lt.ncols) goto 150
         return
100      continue
         if (natorb) then
            read(line,'(21x,5f10.5)',err=150) (focc(j),j=imin,imax)
            do j=imin,imax
                eiga(j) = 0.0d0
            end do
         else
            if (nlmo) then
               do j=imin,imax
                   eiga(j) = 0.0d0
               end do
            else
             read(line,'(21x,5f10.5)',err=150) (eiga(j),j=imin,imax)
            endif
         endif

         istrt = 0
         itel = 0
         nc = imax - imin + 1

         do irow=1,norbs
           call nxtlin(line,jstat)
           if (jstat.eq.2) goto 150
cnull           call rmnull(line)
           if (nlmo) then
              read(line,'(16x,8f8.4)',err=150)
     &         (vectrs((j-1)*mxorb+irow),j=imin,imax)
              if (index(line,'D6').ne.0.or.index(line,'d6').ne.0)
     &         ido5d = 0
              if (index(line,'F8').ne.0.or.index(line,'f8').ne.0)
     &         ido7f = 0
              if (index(line,'G10').ne.0.or.index(line,'g10').ne.0)
     &         ido9g = 0
           else
              read(line,'(21x,5f10.5)',err=150)
     &         (vectrs((j-1)*mxorb+irow),j=imin,imax)
              if (index(line,'D-2').ne.0.or.index(line,'d-2').ne.0)
     &         ido5d = 1
              if (index(line,'F-2').ne.0.or.index(line,'f-2').ne.0)
     &         ido7f = 1
              if (index(line,'G-2').ne.0.or.index(line,'g-2').ne.0)
     &         ido9g = 1
           endif

           if (istrt.eq.0.and.index(line,'ZZZZ').ne.0) then
               istrt = irow
               itel = 0
               reo = .true.
           endif

           if (istrt.ne.0) then
              itel = itel + 1
              do k=1,nc
                 vt(itel,k) = vectrs((imin+k-2)*mxorb+irow)
              end do
           endif

           if (itel.eq.15) then
              do l=1,15
                 do k=1,nc
                    vectrs((imin+k-2)*mxorb + (istrt+l-1)) = 
     &                   vt(irord(l),k)
                 end do
              end do
              istrt = 0
              itel = 0
           endif

         end do
      end do

      if (iuhf.eq.1) then
         call nxtlin(line,jstat)
         if (jstat.eq.2) goto 150
         imin = 0
         imax = 0
         do ipass=1,npass
            imin = imax + 1
            imax = imax + npl
            imax = min0(ncols,imax)
            do i =1,10
               call nxtlin(line,jstat)
               if (jstat.eq.2) goto 150
               call tocap(line,80)
               if (index(line,'EIGENVALUES').ne.0) goto 200
            end do
            if (imax.lt.ncolb) goto 150
            return
200         continue

            read(line,'(21x,5f10.5)',err=150) (eigb(j),j=imin,imax)

            istrt = 0
            itel = 0
            nc = imax - imin + 1

            do irow=1,norbs
cnull              call nxtlin(line,jstat)
cnull              if (jstat.eq.2) goto 150
cnull              call rmnull(line)
cnull              read(line,'(21x,5f10.5)',err=150)
              call nxtlin(line,jstat)
              read(line,'(21x,5f10.5)',err=150)
     &             (vectrb((j-1)*mxorb+irow),j=imin,imax)


              if (istrt.eq.0.and.index(line,'ZZZZ').ne.0) then
                  istrt = irow
                  itel = 0
                  reo = .true.
              endif

              if (istrt.ne.0) then
                 itel = itel + 1
                 do k=1,nc
                    vt(itel,k) = vectrb((imin+k-2)*mxorb+irow)
                 end do
              endif

              if (itel.eq.15) then
                 do l=1,15
                    do k=1,nc
                       vectrb((imin+k-2)*mxorb + (istrt+l-1)) = 
     &                      vt(irord(l),k)
                    end do
                 end do
                 istrt = 0
                 itel = 0
              endif

            end do
         end do
      endif

      if (reo) then
          print*,' '
          print*,'========================================'//
     &           '======================================'
          print*,'Changed order of G functions:'
          print*,' '
          print*,'zzzz,yzzz,yyzz,yyyz,yyyy,xzzz,xyzz,xyyz,',
     &           'xyyy,xxzz,xxyz,xxyy,xxxz,xxxy,xxxx ->'
          print*,' '
          print*,'xxxx,yyyy,zzzz,xxxy,xxxz,yyyx,yyyz,zzzx,',
     &           'zzzy,xxyy,xxzz,yyzz,xxyz,yyxz,zzxy'
          print*,' '
          print*,'========================================'//
     &           '======================================'
          print*,' '
      endif

      return

150   call inferr('error in reading vectors',1)
      if (ig94.eq.1) then
         call inferr('use IOP(6/7=3) in gaussian inputfile',1)
      else
         call inferr('use IOP(6/7=1) in gaussian inputfile',1)
      endif
      istats = 0
      return
      end

      subroutine getsord(v,ireord)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension v(*),ireord(*)
      dimension vt(9)
      dimension irord(5),irorf(7),irorg(9)
      dimension facd(5),facf(7),facg(9)

c spherical D,F and G

      irord(1) = 5
      irord(2) = 3
      irord(3) = 1
      irord(4) = -2
      irord(5) = 4

      d3i =  1.0 / dsqrt(3.0d0)

      facd(1) = 1.0d0
      facd(2) = d3i
      facd(3) = d3i
      facd(4) = 1.0d0
      facd(5) = d3i

      irorf(1)  = 7
      irorf(2)  = 5
      irorf(3)  = 3
      irorf(4)  = 1
      irorf(5)  = -2
      irorf(6)  = 4
      irorf(7)  = -6

c rescaling NWCHEM spherical F and G functions impossible ?
c F0 = (zzz-r2*(xxz+yyz))*conf rescaling ==>>
c      (zzz-r2*d5i(xxz+yyz))*conf
c
c now we have one part we dont need to scale (zzz) and one
c                 part we      need to scale (xxz+yyx)
c
c we chose to do nothing and just print a warning message

      d5i =  1.0 / dsqrt(5.0d0)

      facf(1)  =  1.0d0
      facf(2)  =  1.0d0
      facf(3)  =  1.0d0
      facf(4)  =  1.0d0
      facf(5)  =  1.0d0
      facf(6)  =  1.0d0
      facf(7)  =  1.0d0

      irorg(1)  = 9
      irorg(2)  = 7
      irorg(3)  = 5
      irorg(4)  = 3
      irorg(5)  = 1
      irorg(6)  = -2
      irorg(7)  = 4
      irorg(8)  = -6
      irorg(9)  = 8

      facg(1)  = 1.0d0
      facg(2)  = 1.0d0
      facg(3)  = 1.0d0
      facg(4)  = 1.0d0
      facg(5)  = 1.0d0
      facg(6)  = 1.0d0
      facg(7)  = 1.0d0
      facg(8)  = 1.0d0
      facg(9)  = 1.0d0

      iror = 0
      indst = -1
      nror = -1

      do j=1,norbs

         if (ireord(j).ne.-1) then

             if (indst.eq.-1) then

                 indst = j
                 iror = 1
                 if (ireord(j).eq.2) nror = 5
                 if (ireord(j).eq.3) nror = 7
                 if (ireord(j).eq.3) nror = 9

             endif


             if (nror.eq.5.and.iror.eq.5) then

                 if (irord(iror).lt.0) then
                    vt(iabs(irord(iror))) = -v(j)
                 else
                    vt(irord(iror)) = v(j)
                 endif

c put D coefficients in the right order

                 do jj=1,nror
                    v(indst+jj-1) = vt(jj)*facd(jj)
                 end do

                 iror = 1
                 indst = -1
                 nror = -1

             else if (nror.eq.7.and.iror.eq.7) then

                 if (irorf(iror).lt.0) then
                    vt(iabs(irorf(iror))) = -v(j)
                 else
                    vt(irorf(iror)) = v(j)
                 endif

c put F coefficients in the right order

                 do jj=1,nror
                    v(indst+jj-1) = vt(jj)
                 end do

                 iror = 1
                 indst = -1
                 nror = -1

             else if (nror.eq.9.and.iror.eq.9) then

                 if (irorg(iror).lt.0) then
                    vt(iabs(irorg(iror))) = -v(j)
                 else
                    vt(irorg(iror)) = v(j)
                 endif

c put G coefficients in the right order

                 do jj=1,nror
                    v(indst+jj-1) = vt(jj)
                 end do

                 iror = 1
                 indst = -1
                 nror = -1

             else

c fill D,F,G conversion array

                  if (nror.eq.5) then
                      if (irord(iror).lt.0) then
                         vt(iabs(irord(iror))) = -v(j)
                      else
                         vt(irord(iror)) = v(j)
                      endif
                  else if (nror.eq.7) then
                      if (irorf(iror).lt.0) then
                         vt(iabs(irorf(iror))) = -v(j)
                      else
                         vt(irorf(iror)) = v(j)
                      endif
                  else if (nror.eq.9) then
                      if (irorg(iror).lt.0) then
                         vt(iabs(irorg(iror))) = -v(j)
                      else
                         vt(irorg(iror)) = v(j)
                      endif
                  endif

             endif

             iror = iror + 1

         endif
      end do

      return
      end

      subroutine getoord(v,ireord)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension v(*),ireord(*)
      dimension vt(15)
      dimension irord(6),irorf(10),irorg(15)
      dimension facd(6),facf(10),facg(15)

c cartesian reorder D,F and G

      irord(1) = 1
      irord(2) = 4
      irord(3) = 5
      irord(4) = 2
      irord(5) = 6
      irord(6) = 3

      d3i =  1.0 / dsqrt(3.0d0)

      facd(1) = 1.0d0
      facd(2) = 1.0d0
      facd(3) = 1.0d0
      facd(4) = d3i
      facd(5) = d3i
      facd(6) = d3i

      irorf(1)  = 1
      irorf(2)  = 5
      irorf(3)  = 6
      irorf(4)  = 4
      irorf(5)  = 10
      irorf(6)  = 7
      irorf(7)  = 2
      irorf(8)  = 9
      irorf(9)  = 8
      irorf(10) = 3

      d5i =  1.0 / dsqrt(5.0d0)

      facf(1)  =  1.0d0
      facf(2)  =  1.0d0
      facf(3)  =  1.0d0
      facf(4)  =  d5i
      facf(5)  =  d5i
      facf(6)  =  d5i
      facf(7)  =  d5i
      facf(8)  =  d5i
      facf(9)  =  d5i
      facf(10) =  d5i*d3i

      irorg(1)  =  1
      irorg(2)  =  4
      irorg(3)  =  5
      irorg(4)  = 10
      irorg(5)  = 13
      irorg(6)  = 11
      irorg(7)  =  6
      irorg(8)  = 14
      irorg(9)  = 15
      irorg(10) =  8
      irorg(11) =  2
      irorg(12) =  7
      irorg(13) = 12
      irorg(14) =  9
      irorg(15) =  3

      d7i =  1.0 / dsqrt(7.0d0)

      facg(1)  =  1.0d0
      facg(2)  =  1.0d0
      facg(3)  =  1.0d0
      facg(4)  =  d7i
      facg(5)  =  d7i
      facg(6)  =  d7i
      facg(7)  =  d7i
      facg(8)  =  d7i
      facg(9)  =  d7i
      facg(10) =  d5i*d7i/d3i
      facg(11) =  d5i*d7i/d3i
      facg(12) =  d5i*d7i/d3i
      facg(13) =  d5i*d7i
      facg(14) =  d5i*d7i
      facg(15) =  d5i*d7i

      iror = 0
      indst = -1
      nror = -1

      do j=1,norbs

         if (ireord(j).ne.-1) then

             if (indst.eq.-1) then

                 indst = j
                 iror = 1
                 if (ireord(j).eq.2) nror = 6
                 if (ireord(j).eq.3) nror = 10
                 if (ireord(j).eq.4) nror = 15

             endif


             if (nror.eq.6.and.iror.eq.6) then

                 vt(irord(iror)) = v(j)

c put D coefficients in the right order

                 do jj=1,nror
                    v(indst+jj-1) = vt(jj)*facd(jj)
                 end do

                 iror = 1
                 indst = -1
                 nror = -1

             else if (nror.eq.10.and.iror.eq.10) then

                 vt(irorf(iror)) = v(j)

c put F coefficients in the right order

                 do jj=1,nror
                    v(indst+jj-1) = vt(jj)*facf(jj)
                 end do

                 iror = 1
                 indst = -1
                 nror = -1

             else if (nror.eq.15.and.iror.eq.15) then

                 vt(irorg(iror)) = v(j)

c put G coefficients in the right order

                 do jj=1,nror
                    v(indst+jj-1) = vt(jj)*facg(jj)
                 end do

                 iror = 1
                 indst = -1
                 nror = -1

             else

c fill D,F,G conversion array

                  if (nror.eq.6) then
                      vt(irord(iror)) = v(j)
                  else if (nror.eq.10) then
                      vt(irorf(iror)) = v(j)
                  else if (nror.eq.15) then
                      vt(irorg(iror)) = v(j)
                  endif

             endif

             iror = iror + 1

         endif
      end do

      return
      end

      subroutine rdvcd(idebug,istats,
     &           vectrs,vectrb,focc,focb,eiga,eigb,ncols,ncolb,ireord)
      implicit double precision (a-h,o-z)
      parameter (mxcol=10)
      parameter (numatm=2000)
      character*137 line,str
      common /curlin/ line
      common /orbhlp/ mxorb,iuhf,ispd
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical natorb,nlmo,reo
      real eiga,eigb
      integer getlin
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*)
c      dimension v(mxorb),ireord(*)
      dimension v(1024),ireord(*)

      call cntgaus(ireord)

      istats = 1
      ist = 0

      rewind(iun2)
      call search(line,'%molecular orbital range',ist)
      if (getlin(0).ne.1) goto 100

      ktype = nxtwrd(str,nstr,itype,rtype)

      if (ktype.eq.2) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            norbs = itype
            ncols = norbs
c            print*,"norbs ",norbs
         else
            goto 100
         endif
      else
         goto 100
      endif
         
      call rewfil

      call search(line,'%molecular orbital energies',ist)

      irow = 1

      do while (.true.)
10       if (getlin(0).ne.1) goto 100
         do i=1,4
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               eiga(irow) = rtype
               irow = irow + 1
               if (irow.gt.norbs) goto 20
            else
               goto 10
            endif
         end do
      end do

20    continue

      call search(line,'%molecular orbital occupations',ist)

      irow = 1

      do while (.true.)
30       if (getlin(0).ne.1) goto 100
         do i=1,4
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               focc(irow) = rtype
               irow = irow + 1
               if (irow.gt.norbs) goto 40
            else
               goto 30
            endif
         end do
      end do

40    continue

      call search(line,'%molecular orbital vectors',ist)

      irow = 1
      icol = 1

      do while (.true.)
         if (getlin(0).ne.1) goto 100
         do while (.true.)
            ktype = nxtwrz(str,nstr,itype,rtype)

            if (ktype.eq.3.or.ktype.eq.4) then
               if (ktype.eq.3) then
                  v(irow) = rtype
                  irow = irow + 1
               else
                  do j=0,itype-1
                       v(irow+j) = 0.0d0
                  end do
                  irow = irow + itype
               endif

            else if (ktype.eq.0) then

               if (irow-1.ge.norbs) then

                  if (irow-1.gt.norbs) irow = norbs

                  if (ido5d.eq.0.or.ido7f.eq.0) call getoord(v,ireord)

                  do j=1,irow-1
c                     print*,"v(",j,")=",v(j)
                     vectrs((icol-1)*mxorb+j) = v(j)
                  end do

                  irow = 1
                  icol = icol + 1
                  if (icol.gt.norbs) goto 51
               endif
               goto 50

            else
               goto 51
            endif

         end do
50       continue
      end do

51    idbl = nelecs/2

c      if (nelecs-idbl*2.eq.0) return

c search for beta information

      call rewfil

60    call search(line,'%molecular orbital range',ist)
      if (ist.eq.0) goto 100
      if (icdex(line,'beta').eq.0) goto 60
      iuhf = 1

      if (getlin(0).ne.1) goto 100

      ktype = nxtwrd(str,nstr,itype,rtype)

      if (ktype.eq.2) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            ncolb = itype
c            print*,"norbs ",norbs
         else
            goto 100
         endif
      else
         goto 100
      endif
         
      call rewfil

70    call search(line,'%molecular orbital energies',ist)
      if (ist.eq.0) goto 100
      if (icdex(line,'beta').eq.0) goto 70

      irow = 1

      do while (.true.)
80       if (getlin(0).ne.1) goto 100
         do i=1,4
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               eigb(irow) = rtype
               irow = irow + 1
               if (irow.gt.norbs) goto 90
            else
               goto 80
            endif
         end do
      end do

90    continue

      call search(line,'%molecular orbital occupations',ist)

      irow = 1

      do while (.true.)
81       if (getlin(0).ne.1) goto 100
         do i=1,4
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               focb(irow) = rtype
               irow = irow + 1
               if (irow.gt.norbs) goto 82
            else
               goto 81
            endif
         end do
      end do

82    continue

      call search(line,'%molecular orbital vectors',ist)

      irow = 1
      icol = 1

      do while (.true.)
         if (getlin(0).ne.1) goto 100
         do while (.true.)
            ktype = nxtwrz(str,nstr,itype,rtype)

            if (ktype.eq.3.or.ktype.eq.4) then
               if (ktype.eq.3) then
                  v(irow) = rtype
                  irow = irow + 1
               else
                  do j=0,itype-1
                       v(irow+j) = 0.0d0
                  end do
                  irow = irow + itype
               endif
            else if (ktype.eq.0) then
               if (irow-1.eq.norbs) then
                  do j=1,irow-1
c                     print*,"v(",j,")=",v(j)
                     vectrb((icol-1)*mxorb+j) = v(j)
                  end do
                  irow = 1
                  icol = icol + 1
                  if (icol.gt.norbs) return
               endif
               goto 99

            else
               goto 100
            endif

         end do
99       continue
      end do

      return

100   istats = 0
      return
      end

      subroutine gtnorb(idebug,istats)
      implicit double precision (a-h,o-z)
      parameter (mxcol=10)
      parameter (numatm=2000)
      character*137 line,str
      common /curlin/ line
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      istats = 1
      ist = 0

      call rewfil

      call search(line,"%molecular orbital vectors",ist)

      l = 0

      if (ist.eq.1) then
         i = 0
         do while (i.lt.3)
           l = index(line,'%')
           if (l.gt.0) then
              line = line(l+1:)
           endif
           i = i + 1
         end do
      endif

      if (l.gt.0) then
         norbs = reada(line,1,136)
      else
         norbs = 0
      endif

      return
      end

      subroutine slater(x,y,z,psi)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common/coord/ xyz(3,numatm)
      common /moldat/ natoms,norbs,nelecs,nat(numatm)
      common /mopac/ nfirst(numatm),nlast(numatm),
     &               npq(numatm),pqn(numatm),emus(numatm),
     &               emup(numatm),emud(numatm),consts(numatm),
     &               constp(numatm),constd(numatm),npqref(54)
      common /orbhlp/ mxorb,iuhf,ispd

      dimension psi(*)
c********************** slater type orbitals *********************
      do i=1,mxorb
          psi(i) = 0.0d0
      end do
      ico = 0

      do l=1,natoms

          xk = x - xyz(1,l)
          yk = y - xyz(2,l)
          zk = z - xyz(3,l)

          r2 = xk*xk + yk*yk + zk*zk
          r2 = r2 + 1.d-10
          r1 = dsqrt(r2)

          cons = consts(l)*r1**npq(l)*dexp(-emus(l)*r1)
          conp = constp(l)*r1**(npq(l)-1)*dexp(-emup(l)*r1)
          cond = constd(l)*r1**(pqn(l)-2)*dexp(-emud(l)*r1)

c          print*,'consts ',consts(l),' npq ',npq(l),' emus ',emus(l)
c          print*,'constp ',constp(l),' npq ',npq(l),' emup ',emup(l)
c          print*,'constd ',constd(l),' pqn ',pqn(l),' emud ',emud(l)

          i = nlast(l) - nfirst(l) + 1

          goto  (3,4,4,4,7,7,7,7,7),  i
 
 
    7     psi(ico+9)=               cond*xk*yk
          psi(ico+8)=               cond*yk*zk
          psi(ico+7)=0.2886751346d0*cond*(2.d0*zk*zk-yk*yk-xk*xk)
          psi(ico+6)=               cond*xk*zk
          psi(ico+5)=0.50d0*cond*(xk*xk-yk*yk)
   4      psi(ico+4)=conp*zk
          psi(ico+3)=conp*yk
          psi(ico+2)=conp*xk
   3      psi(ico+1)=cons
 
 
          ico=ico+i
      end do

      return
      end

      subroutine rotd(x,y,z,xc,yc,zc,itran,
     &                rx,ry,rz,t)
      implicit double precision (a-h,o-z)
      dimension rx(3),ry(3),rz(3),t(3)

      if (itran.eq.1) then
         xc = (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)
         yc = (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)
         zc = (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)
      else
         xc = x*rx(1)+y*rx(2)+z*rx(3)
         yc = x*ry(1)+y*ry(2)+z*ry(3)
         zc = x*rz(1)+y*rz(2)+z*rz(3)
      endif

      return
      end

      subroutine rottd(x,y,z,xc,yc,zc,itran,
     &                 rx,ry,rz,t)
      implicit double precision (a-h,o-z)
      real x,y,z
      dimension rx(3),ry(3),rz(3),t(3)

      if (itran.eq.1) then
         xc = (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)
         yc = (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)
         zc = (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)
      else
         xc = x*rx(1)+y*rx(2)+z*rx(3)
         yc = x*ry(1)+y*ry(2)+z*ry(3)
         zc = x*rz(1)+y*rz(2)+z*rz(3)
      endif

      return
      end

      subroutine mktrd(inct,incp,
     &                 xv,yv,zv,pincr,
     &                 scal,scali,smag)
      implicit double precision (a-h,o-z)
      parameter (ssincr=1.05d0)
      parameter (xincr=0.10d0)
      parameter (yincr=0.10d0)
      parameter (rincr=1.0d0)
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /coars/ icoars
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      dimension vec(3)

      celinc = 0.001d0*0.52917706d0

      if (irtcel.ne.0) then
         do i=1,3
            vec(i) = 0.0d0
         end do
      endif

      idir = 0
      if (inct.eq.290) then
         if (irtcel.ne.0) then
            idir = incp
            iax = 3
         else
            if (persp.eq.1) then
               if (incp.eq.1)  zv = zv + pincr
               if (incp.eq.-1) zv = zv - pincr
            else
               if (incp.eq.1)  smag = smag*ssincr
               if (incp.eq.-1) smag = smag/ssincr
               smag = max(smag,0.01d0)
               scal = scali*2.4d0*smag
            endif
         endif
      elseif (inct.eq.415) then
         if (irtcel.ne.0) then
            idir = 1
            if (incp.lt.0) idir = -1
            iax = 2
         else
            yv = yv + yincr*(5**icoars)*incp
         endif
      elseif (inct.eq.416) then
         if (irtcel.ne.0) then
            idir = 1
            if (incp.lt.0) idir = -1
            iax = 1
         else
            xv = xv + xincr*(5**icoars)*incp
         endif
      elseif (inct.eq.417) then
         if (irtcel.ne.0) then
            idir = 1
            if (incp.lt.0) idir = -1
            iax = 3
         else
            if (persp.eq.1) then
               zv = zv + pincr*incp
            else
               ssc = abs(incp)*ssincr
               if (incp.gt.0) smag = smag*ssc
               if (incp.lt.0) smag = smag/ssc
               smag = max(smag,0.01d0)
               smag = min(smag,1000.0d0)
               scal = scali*2.4d0*smag
            endif
         endif
      elseif (inct.eq.420) then
         if (irtcel.ne.0) then
            idir = -1
            iax = 2
         else
            yv = yv - yincr*(5**icoars)
         endif
      elseif (inct.eq.430) then
         if (irtcel.ne.0) then
            idir = 1
            iax = 2
         else
            yv = yv + yincr*(5**icoars)
         endif
      elseif (inct.eq.440) then
         if (irtcel.ne.0) then
            idir = -1
            iax = 1
         else
            xv = xv - xincr*(5**icoars)
         endif
      elseif (inct.eq.450) then
         if (irtcel.ne.0) then
            idir = 1
            iax = 1
         else
            xv = xv + xincr*(5**icoars)
         endif
      else 
         goto 100
      endif

      if (irtcel.ne.0) then
         if (itz.eq.1.and.iax.eq.3) then
            do i=1,3
               vec(i) =  idir*tz(i)*(10**icoars)
            end do
         else
            vec(iax) =  idir*celinc*(10**icoars)
            if ((inct.eq.415.or.inct.eq.416.or.inct.eq.417)
     &          .and.irtcel.eq.2) then
               do i=1,3
                  vec(i) =  celinc*(10**icoars)*incp*vecs(iax,i)
               end do
            endif
         endif
         if (irtcel.eq.1) then
            call cllrot(vec,0,ifd)
         else
            call alnrot(vec,0)
         endif
      endif

      goto 200

100   continue
      if (abs(incp).eq.1.or.abs(inct).eq.421.or.inct.eq.422) then
         if (abs(inct).eq.421) then
            theinc = -incp
            if (inct.eq.421) then
               inct = -3
            else
               inct = -2
            endif
         elseif(inct.eq.422) then
            theinc = -incp
            inct = -1
         else
            if (icoars.eq.2) then
               theinc = incp*rincr*45.0d0
            elseif (icoars.eq.1) then
               theinc = incp*rincr*5.0d0
            else
               theinc = incp*rincr
            endif
         endif

         if (irtcel.gt.0) then
            if (irtcel.eq.1) then
               call clmat(inct,theinc,1)
               call cllrot(vec,1,ifd)
            else
               if (ialtyp.eq.1) then
                  call clmat(inct,theinc,0)
               else
                  call clmat(inct,theinc,1)
               endif
               call alnrot(vec,1)
            endif
         else
            call xyzrot(inct,theinc)
         endif
      endif

200   if (irtcel.gt.1) then
         if (ialtyp.eq.1) then
            call totpmf(tpmf)
c            print*,'totpmf=',tpmf
            call upsco()
         endif
      endif

      return
      end

      subroutine mtind3(rx,ry,rz)
      implicit double precision (a-h,o-z)
      dimension al(9),alt(9)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      dimension rx(3),ry(3),rz(3)
   
      do i=1,3
         do j=1,3
            if (i.eq.j) then
               vecs(i,j) = 1.0d0
            else
               vecs(i,j) = 0.0d0
            endif
         end do
      end do

      do j=1,3
         al(j)   = rx(j)
         al(3+j) = ry(j)
         al(6+j) = rz(j)
         alt(j)   = rx(j)
         alt(3+j) = ry(j)
         alt(6+j) = rz(j)
      end do

      call matinv(al,3,det)

      do j=1,3
         rx(j) = al(j)
         ry(j) = al(3+j)
         rz(j) = al(6+j)
      end do

      call rott(vecs(1,1),vecs(1,2),vecs(1,3),xc,yc,zc,0)
      vecs(1,1) = xc
      vecs(1,2) = yc
      vecs(1,3) = zc
      call rott(vecs(2,1),vecs(2,2),vecs(2,3),xc,yc,zc,0)
      vecs(2,1) = xc
      vecs(2,2) = yc
      vecs(2,3) = zc
      call rott(vecs(3,1),vecs(3,2),vecs(3,3),xc,yc,zc,0)
      vecs(3,1) = xc
      vecs(3,2) = yc
      vecs(3,3) = zc

c restore original rotation

      do j=1,3
         rx(j) = alt(j)
         ry(j) = alt(3+j)
         rz(j) = alt(6+j)
      end do

      return
      end

      subroutine xyzrod(inct,theang,rx,ry,rz)
      implicit double precision (a-h,o-z)
      dimension rx(3),ry(3),rz(3)

      todeg = 45.0d0 / datan(1.0d0)

      sa = dsin(theang/todeg)
      ca = dcos(theang/todeg)

      if (inct.eq.-3) then
         do i=1,3
            y = ry(i)
            z = rz(i)
            ry(i) = ca*y + sa*z
            rz(i) = ca*z - sa*y
         end do
      elseif (inct.eq.-2) then
         do i=1,3
            x = rx(i)
            z = rz(i)
            rx(i) = ca*x + sa*z
            rz(i) = ca*z - sa*x
         end do
      elseif (inct.eq.-1) then
         do i=1,3
            x = rx(i)
            y = ry(i)
            rx(i) = ca*x - sa*y
            ry(i) = ca*y + sa*x
         end do
      endif

      return
      end

      subroutine inirod(rx,ry,rz,t)
      implicit double precision (a-h,o-z)
      dimension rx(3),ry(3),rz(3),t(3)

      do i=1,3
         rx(i) = 0.0d0
         ry(i) = 0.0d0
         rz(i) = 0.0d0
         t(i)  = 0.0d0
      end do

      rx(1) = 1.0d0
      ry(2) = 1.0d0
      rz(3) = 1.0d0

      return
      end

      subroutine strot(rx,ry,rz)
      implicit double precision (a-h,o-z)
      dimension rx(3),ry(3),rz(3)

      do i=1,3
         rx(i) = 0.0d0
         ry(i) = 0.0d0
         rz(i) = 0.0d0
      end do

      rx(1) = 1.0d0
      ry(3) = 1.0d0
      rz(2) = -1.0d0

      return
      end

      subroutine setord(iatom,t,coo)
      implicit double precision (a-h,o-z)
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      dimension t(3),coo(3,*)

      if (irtcel.eq.2) then
         call alnsorg(iatom,coo)
      else
         do i=1,3
            t(i) = coo(i,iatom)
         end do
      endif

c      call doscal

      call setxyv

      return
      end

      subroutine setxyd(xv,yv)
      implicit double precision (a-h,o-z)

      xv = 0.0d0
      yv = 0.0d0

      return
      end

      subroutine prtrot(rx,ry,rz,t)
      implicit double precision (a-h,o-z)
      dimension rx(3),ry(3),rz(3),t(3)

      print*,(rx(i),i=1,3)
      print*,(ry(i),i=1,3)
      print*,(rz(i),i=1,3)

      print*,(t(i),i=1,3)

      return
      end

      subroutine rarbxi
      implicit double precision (a-h,o-z)
      dimension v(3)
      common /rligx/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt

      todeg = 45.0d0 / datan(1.0d0)
      do i=1,3
         v(i) = vecs(1,i)
      end do

c Rotation about an arbitrary axis v (going through the origin)

      pi = 4.d0*datan(1.d0)

c calculate rho, theta, phi (Spherical coordinates)

      rho = vlen(v)

      if (v(1).gt.0.0d0) then
         theta = datan(v(2)/v(1))
      elseif (v(1).lt.0.0d0) then
         theta = pi + datan(v(2)/v(1))
      elseif (v(1).eq.0.0d0) then
         if (v(2).ge.0.0d0) then
            theta = pi / 2.0d0
         else
            theta = 3.0d0 * pi / 2.0d0
         endif
      endif
      
      phi = dacos(v(3)/rho)
      
      cs = dcos(theta)
      si = dsin(theta)

      rz(1,1) = cs
      rz(1,2) = si
      rz(1,3) = 0.0d0

      rz(2,1) = -si
      rz(2,2) = cs
      rz(2,3) = 0.0d0

      rz(3,1) = 0.0d0
      rz(3,2) = 0.0d0
      rz(3,3) = 1.0d0

      rzi(1,1) = cs
      rzi(1,2) = -si
      rzi(1,3) = 0.0d0

      rzi(2,1) = si
      rzi(2,2) = cs
      rzi(2,3) = 0.0d0

      rzi(3,1) = 0.0d0
      rzi(3,2) = 0.0d0
      rzi(3,3) = 1.0d0

      cs1 = dcos(phi)
      si1 = dsin(phi)

      ry(1,1) = cs1
      ry(1,2) = 0.0d0
      ry(1,3) = -si1

      ry(2,1) = 0.0d0
      ry(2,2) = 1.0d0
      ry(2,3) = 0.0d0

      ry(3,1) = si1
      ry(3,2) = 0.0d0
      ry(3,3) = cs1

      ryi(1,1) = cs1
      ryi(1,2) = 0.0d0
      ryi(1,3) = si1

      ryi(2,1) = 0.0d0
      ryi(2,2) = 1.0d0
      ryi(2,3) = 0.0d0

      ryi(3,1) = -si1
      ryi(3,2) = 0.0d0
      ryi(3,3) = cs1

c      print*,'matrix ry'
c      call prtmat(ry)
c      print*,'matrix rz'
c      call prtmat(rz)
c      print*,'matrix ryi'
c      call prtmat(ryi)
c      print*,'matrix rzi'
c      call prtmat(rzi)
      return

      end

      subroutine rarbx(alfat)
      implicit double precision (a-h,o-z)
      dimension r(3,3),rv(3,3),rout(3,3),rtmp(3,3),rcpy(3,3)
      common /rligx/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /cllmat/rxl(3),ryl(3),rzl(3),t(3),tz(3),tzorg(3),itz

      do i=1,3
         rcpy(i,1) = rxl(i)
         rcpy(i,2) = ryl(i)
         rcpy(i,3) = rzl(i)
      end do

c Rotation about an arbitrary axis v (going through the origin)
c alpha is the angle over which is rotated along axis v

      alfa = -alfat

      ca = dcos(alfa)
      sa = dsin(alfa)

      rv(1,1) = ca
      rv(1,2) = sa
      rv(1,3) = 0.0d0

      rv(2,1) = -sa
      rv(2,2) = ca
      rv(2,3) = 0.0d0

      rv(3,1) = 0.0d0
      rv(3,2) = 0.0d0
      rv(3,3) = 1.0d0

      call matmult(rzi,ryi,rtmp)
      call matmult(rtmp,rv,rout)
      call matmult(rout,ry,rtmp)
      call matmult(rtmp,rz,r)
      call matmult(rcpy,r,rtmp)

      do i=1,3
         rxl(i) = rtmp(i,1)
         ryl(i) = rtmp(i,2)
         rzl(i) = rtmp(i,3)
      end do

      return
      end

      subroutine rarbyi
      implicit double precision (a-h,o-z)
      dimension v(3)
      common /rligy/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt

      do i=1,3
         v(i) = vecs(2,i)
      end do

c Rotation about an arbitrary axis v (going through the origin)

      pi = 4.d0*datan(1.d0)

c calculate rho, theta, phi (Spherical coordinates)

      rho = vlen(v)

      if (v(1).gt.0.0d0) then
         theta = datan(v(2)/v(1))
      elseif (v(1).lt.0.0d0) then
         theta = pi + datan(v(2)/v(1))
      elseif (v(1).eq.0.0d0) then
         if (v(2).ge.0.0d0) then
            theta = pi / 2.0d0
         else
            theta = 3.0d0 * pi / 2.0d0
         endif
      endif
      
      phi = dacos(v(3)/rho)
      
      cs = dcos(theta)
      si = dsin(theta)

      rz(1,1) = cs
      rz(1,2) = si
      rz(1,3) = 0.0d0

      rz(2,1) = -si
      rz(2,2) = cs
      rz(2,3) = 0.0d0

      rz(3,1) = 0.0d0
      rz(3,2) = 0.0d0
      rz(3,3) = 1.0d0

      rzi(1,1) = cs
      rzi(1,2) = -si
      rzi(1,3) = 0.0d0

      rzi(2,1) = si
      rzi(2,2) = cs
      rzi(2,3) = 0.0d0

      rzi(3,1) = 0.0d0
      rzi(3,2) = 0.0d0
      rzi(3,3) = 1.0d0

      cs1 = dcos(phi)
      si1 = dsin(phi)

      ry(1,1) = cs1
      ry(1,2) = 0.0d0
      ry(1,3) = -si1

      ry(2,1) = 0.0d0
      ry(2,2) = 1.0d0
      ry(2,3) = 0.0d0

      ry(3,1) = si1
      ry(3,2) = 0.0d0
      ry(3,3) = cs1

      ryi(1,1) = cs1
      ryi(1,2) = 0.0d0
      ryi(1,3) = si1

      ryi(2,1) = 0.0d0
      ryi(2,2) = 1.0d0
      ryi(2,3) = 0.0d0

      ryi(3,1) = -si1
      ryi(3,2) = 0.0d0
      ryi(3,3) = cs1

c      print*,'y matrix ry'
c      call prtmat(ry)
c      print*,'y matrix rz'
c      call prtmat(rz)
c      print*,'y matrix ryi'
c      call prtmat(ryi)
c      print*,'y matrix rzi'
c      call prtmat(rzi)

      return
      end

      subroutine rarby(alfa)
      implicit double precision (a-h,o-z)
      dimension r(3,3),rv(3,3),rout(3,3),rtmp(3,3),rcpy(3,3)
      common /rligy/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /cllmat/rxl(3),ryl(3),rzl(3),t(3),tz(3),tzorg(3),itz

      do i=1,3
         rcpy(i,1) = rxl(i)
         rcpy(i,2) = ryl(i)
         rcpy(i,3) = rzl(i)
      end do


c Rotation about an arbitrary axis v (going through the origin)
c alpha is the angle over which is rotated along axis v

      ca = dcos(alfa)
      sa = dsin(alfa)

      rv(1,1) = ca
      rv(1,2) = sa
      rv(1,3) = 0.0d0

      rv(2,1) = -sa
      rv(2,2) = ca
      rv(2,3) = 0.0d0

      rv(3,1) = 0.0d0
      rv(3,2) = 0.0d0
      rv(3,3) = 1.0d0

      call matmult(rzi,ryi,rtmp)
      call matmult(rtmp,rv,rout)
      call matmult(rout,ry,rtmp)
      call matmult(rtmp,rz,r)
      call matmult(rcpy,r,rtmp)

      do i=1,3
         rxl(i) = rtmp(i,1)
         ryl(i) = rtmp(i,2)
         rzl(i) = rtmp(i,3)
      end do

      return
      end

      subroutine matmult(a,b,c)
      implicit double precision (a-h,o-z)
      dimension a(3,3),b(3,3),c(3,3)

      do i=1,3
         do j=1,3
            c(i,j)=0.0d0
            do k=1,3
               c(i,j) = c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do

      return
      end

      subroutine rarbzi
      implicit double precision (a-h,o-z)
      dimension v(3)
      common /rligz/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt

      todeg = 45.0d0 / datan(1.0d0)
      do i=1,3
         v(i) = vecs(3,i)
      end do

c Rotation about an arbitrary axis v (going through the origin)

      pi = 4.d0*datan(1.d0)

c calculate rho, theta, phi (Spherical coordinates)

      rho = vlen(v)

      if (v(1).gt.0.0d0) then
         theta = datan(v(2)/v(1))
      elseif (v(1).lt.0.0d0) then
         theta = pi + datan(v(2)/v(1))
      elseif (v(1).eq.0.0d0) then
         if (v(2).ge.0.0d0) then
            theta = pi / 2.0d0
         else
            theta = 3.0d0 * pi / 2.0d0
         endif
      endif
      
      phi = dacos(v(3)/rho)
      
      cs = dcos(theta)
      si = dsin(theta)

      rz(1,1) = cs
      rz(1,2) = si
      rz(1,3) = 0.0d0

      rz(2,1) = -si
      rz(2,2) = cs
      rz(2,3) = 0.0d0

      rz(3,1) = 0.0d0
      rz(3,2) = 0.0d0
      rz(3,3) = 1.0d0

      rzi(1,1) = cs
      rzi(1,2) = -si
      rzi(1,3) = 0.0d0

      rzi(2,1) = si
      rzi(2,2) = cs
      rzi(2,3) = 0.0d0

      rzi(3,1) = 0.0d0
      rzi(3,2) = 0.0d0
      rzi(3,3) = 1.0d0

      cs1 = dcos(phi)
      si1 = dsin(phi)

      ry(1,1) = cs1
      ry(1,2) = 0.0d0
      ry(1,3) = -si1

      ry(2,1) = 0.0d0
      ry(2,2) = 1.0d0
      ry(2,3) = 0.0d0

      ry(3,1) = si1
      ry(3,2) = 0.0d0
      ry(3,3) = cs1

      ryi(1,1) = cs1
      ryi(1,2) = 0.0d0
      ryi(1,3) = si1

      ryi(2,1) = 0.0d0
      ryi(2,2) = 1.0d0
      ryi(2,3) = 0.0d0

      ryi(3,1) = -si1
      ryi(3,2) = 0.0d0
      ryi(3,3) = cs1

c      print*,'matrix ry'
c      call prtmat(ry)
c      print*,'matrix rz'
c      call prtmat(rz)
c      print*,'matrix ryi'
c      call prtmat(ryi)
c      print*,'matrix rzi'
c      call prtmat(rzi)
      return

      end

      subroutine rarbz(alfa)
      implicit double precision (a-h,o-z)
      dimension r(3,3),rv(3,3),rout(3,3),rtmp(3,3),rcpy(3,3)
      common /rligz/ ry(3,3),rz(3,3),rzi(3,3),ryi(3,3)
      common /cllmat/rxl(3),ryl(3),rzl(3),t(3),tz(3),tzorg(3),itz

      do i=1,3
         rcpy(i,1) = rxl(i)
         rcpy(i,2) = ryl(i)
         rcpy(i,3) = rzl(i)
      end do

c Rotation about an arbitrary axis v (going through the origin)
c alpha is the angle over which is rotated along axis v


      ca = dcos(alfa)
      sa = dsin(alfa)

      rv(1,1) = ca
      rv(1,2) = sa
      rv(1,3) = 0.0d0

      rv(2,1) = -sa
      rv(2,2) = ca
      rv(2,3) = 0.0d0

      rv(3,1) = 0.0d0
      rv(3,2) = 0.0d0
      rv(3,3) = 1.0d0

      call matmult(rzi,ryi,rtmp)
      call matmult(rtmp,rv,rout)
      call matmult(rout,ry,rtmp)
      call matmult(rtmp,rz,r)
      call matmult(rcpy,r,rtmp)

      do i=1,3
         rxl(i) = rtmp(i,1)
         ryl(i) = rtmp(i,2)
         rzl(i) = rtmp(i,3)
      end do

      return
      end

      subroutine prtmat(a)
      implicit double precision (a-h,o-z)
      dimension a(3,3)

      do i=1,3
         write(6,'(3f12.4)') (a(i,j),j=1,3)
      end do

      return
      end

      subroutine rotmt(rot,t1,t2,t3)
      implicit double precision (a-h,o-z)
      parameter (pi=3.14159265d0)
      parameter (rad=pi/180.0d0)
      dimension rot(3,3)

      tp = t1
      tm = t3
      tt1 = (tp + tm)/2.0d0
      tt3 = (tp - tm)/2.0d0
 
      s1 = dsin(rad*tt1)
      s2 = dsin(rad*t2)
      s3 = dsin(rad*tt3)
      c1 = dcos(rad*tt1)
      c2 = dcos(rad*t2)
      c3 = dcos(rad*tt3)

      rot(1,1) = -s1*c2*s3 + c1*c3
      rot(1,2) =  c1*c2*s3 + s1*c3                   
      rot(1,3) =  s2*s3
      rot(2,1) = -s1*c2*c3 - c1*s3
      rot(2,2) =  c1*c2*c3 - s1*s3
      rot(2,3) =  s2*c3
      rot(3,1) =  s1*s2
      rot(3,2) = -c1*s2
      rot(3,3) =  c2

      return
      end

      subroutine supimp(coo1,coo2,iatoms1,iatoms2,
     &                  iamin1,iamin2,icalf1,icalf2,ncalf1,ncalf2,
     &                  isal1,isal2)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      logical ok
      dimension coo1(3,*),coo2(3,*),iamin1(*),iamin2(*),
     &          icalf1(6,*),icalf2(6,*),isal1(*),isal2(*)
      dimension ca1(3,numcal),ca2(3,numcal),
     &          x(3,numcal), y(3,numcal),
     &          iaatp1(numcal),iaatp2u(numcal)
      dimension ang(3),trans(3),rot(3,3),trans2(3)

      call fident(coo1,coo2,iamin1,iamin2,icalf1,icalf2,
     &            ncalf1,ncalf2,isal1,isal2,x,y,neq,ok)

      if (.not.ok) then

         print*,'identity too low switching to slower algorithm'

         call getca(coo1,coo2,iamin1,iamin2,icalf1,icalf2,
     &              ncalf1,ncalf2,ca1,ca2,iaatp1,iaatp2u)

c angscan is the slow part

         call angscan(ca1,ncalf1,ca2,ncalf2,ang,trans,iaatp1,iaatp2u)

         call getca(coo1,coo2,iamin1,iamin2,icalf1,icalf2,
     &              ncalf1,ncalf2,ca1,ca2,iaatp1,iaatp2u)

         call getequ(ca1,ncalf1,ca2,ncalf2,ang,trans,x,y,neq)

      endif

      call kabsch(x,y,neq,rot,trans2,ier)

      call rotcoo(coo2,iatoms2,trans2,rot)

      return
      end

      subroutine rotcoo(coo,iatoms,trans,rot)
      implicit double precision (a-h,o-z)
      dimension coo(3,*),rot(3,3),trans(3),x(3)

      do i=1,iatoms

         do j=1,3
            x(j) = rot(j,1)*coo(1,i) + 
     &             rot(j,2)*coo(2,i) + 
     &             rot(j,3)*coo(3,i) + trans(j)/0.52917706d0
         end do

         do j=1,3
            coo(j,i) = x(j)
         end do

      end do

      return
      end

      subroutine getca(coo1,coo2,iamin1,iamin2,icalf1,icalf2,
     &                 ncalf1,ncalf2,ca1,ca2,iaatp1,iaatp2u)
      implicit double precision (a-h,o-z)
      integer aatyp
      dimension coo1(3,*),coo2(3,*),iamin1(*),iamin2(*),
     &          icalf1(6,*),icalf2(6,*)
      dimension ca1(3,*),ca2(3,*),iaatp1(*),iaatp2u(*)
      dimension aatyp(42)

c aatyp:
c
c   1 hydrophilic 
c   2 hydrophobic 
c   3 large aromatic
c   4 nucleotide
      
      data aatyp/2,2,1,2,1,
     &           2,2,2,1,1,
     &           2,1,1,1,2,
     &           1,3,3,3,3,
     &           1,1,3,4,4,
     &           4,4,4,4,4,
     &           4,4,4,4,4,
     &           4,4,4,4,4,
     &           4,4/

      do i=1,ncalf1
         do j=1,3
            ca1(j,i) = coo1(j,icalf1(1,i))*0.52917706d0
         end do
         iaatp1(i) = aatyp(iamin1(i))
      end do

      do i=1,ncalf2
         do j=1,3
            ca2(j,i) = coo2(j,icalf2(1,i))*0.52917706d0
         end do
         iaatp2u(i) = aatyp(iamin2(i))
      end do

      return
      end

      subroutine getequ(ca1,ncalf1,ca2,ncalf2,ang,trans,x,y,neq)
      implicit double precision (a-h,o-z)
      dimension ca1(3,*),ca2(3,*),x(3,*),y(3,*),
     &          rot(3,3),ang(3),trans(3),t(3)

      cutoff = 1.9d0
      neq  = 0
      dsum = 0.0d0      

      call rotmt(rot,ang(1),ang(2),ang(3))

c transform coordinates according to best solution

      do j=1,ncalf2

        do i=1,3
           t(i) = rot(i,1)*ca2(1,j) + rot(i,2)*ca2(2,j) + 
     &            rot(i,3)*ca2(3,j) + trans(i)
        end do

c find closest equivalent in reference. 

        dmin = 10000

        do k=1,ncalf1

          d = (ca1(1,k)-t(1))**2 + (ca1(2,k)-t(2))**2 + 
     &        (ca1(3,k)-t(3))**2

          if (d.lt.dmin.and.d.lt.cutoff**2) then
            dmin  = d
            ksave = k
          endif

        end do

        if (dmin.lt.cutoff**2) then 

          dsum = dsum + dmin
          neq  = neq  + 1

          do k=1,3
            x(k,neq) = ca2(k,j)
            y(k,neq) = ca1(k,ksave)
          end do

        endif

      end do

      return
      end

      subroutine stosol(over,corr,np,nm,qaqa,
     &        n2cc,n2n2,phip,phi2,phim,
     &        trans,transb,qapr,ccpr,n2pr,
     &        n2n2m,corrp,n2prp,
     &        ccprp,ang)

      implicit double precision (a-h,o-z)
      dimension ang(3),trans(3),transb(3)

      if (np.gt.n2cc) then
        n2cc    = ncntp
      endif

      if (np+nm.gt.n2n2+n2n2m) then
        n2n2    = np
        n2n2m   = nm
      endif

      if (np*corr.gt.n2pr*ccpr) then
        qapr    = over
        ccpr    = corr
        n2pr    = np
      endif

      if (np*corrp.gt.n2prp*ccprp) then
        ccprp     = corrp
        n2prp     = np
        ang(1)  = phip
        ang(2)  = phi2
        ang(3)  = phim

        transb(1) = trans(1)
        transb(2) = trans(2)
        transb(3) = trans(3)
      endif

      if (over.gt.qaqa) then
        qaqa   = over
      endif

      return
      end

      subroutine calcor(ca1,cat,ncalf1,ncalf2,trans,n,np,nm,
     &                  corr,corrp)
      implicit double precision (a-h,o-z)
      dimension ca1(3,*),cat(3,*),trans(3)

      j1tot = 0
      j2tot = 0
      j1j2t = 0
      j1j1t = 0
      j2j2t = 0
      i1tot = 0
      i2tot = 0
      i1i2t = 0
      i1i1t = 0
      i2i2t = 0
      n     = 0
      np    = 0
      nm    = 0
      ilast = -1
      naddp = 1
      naddm = 1

      do k=1,ncalf1

        dstmin = 10000.0d0

c look for nearest equivalent atom

        do i=1,ncalf2

          dist = 0.0d0

          do j=1,3
             dist = dist + (cat(j,i) + trans(j) - ca1(j,k))**2 
          end do

          if (dist.lt.dstmin) then
            dstmin = dist
            near   = i
          endif

        end do

        if (dstmin.lt.(2.5d0)**2) then

          n     = n + 1
          i1    = k
          i2    = near
          i1tot = i1tot + i1        
          i2tot = i2tot + i2
          i1i2t = i1i2t + i1*i2
          i1i1t = i1i1t + i1*i1
          i2i2t = i2i2t + i2*i2

          if (near-ilast.eq.1) then

            naddp = naddp + 1

            if (naddp.eq.2.or.naddp.eq.1) then 

              np = np + naddp 

              do j=0,naddp-1
                i1    = k     - j
                i2    = near  - j
                j1tot = j1tot + i1
                j2tot = j2tot + i2
                j1j2t = j1j2t + i1*i2
                j1j1t = j1j1t + i1*i1
                j2j2t = j2j2t + i2*i2
              end do

              naddp = 0

            endif

            naddm = 1

          elseif (ilast-near.eq.1) then

            naddm = naddm + 1

            if (naddm.eq.2.or.naddm.eq.1) then
              nm = nm + naddm  
              naddm = 0
            endif

            naddp = 1

          else

            naddp = 1
            naddm = 1

          endif

          ilast = near

        else

          ilast = -1
          naddp =  1
          naddm =  1

        endif

      end do

      if (n.gt.0.and.n*i1i1t.gt.i1tot**2.and.n*i2i2t.gt.i2tot**2) then        

        corr =  (dble(i1i2t) - dble(i1tot*i2tot)/n) /
     &     dsqrt(dble(i1i1t) - dble(i1tot*i1tot)/n) /
     &     dsqrt(dble(i2i2t) - dble(i2tot*i2tot)/n)

      else

        corr = 0.0d0

      endif

      if (np.gt.0.and.np*j1j1t.gt.j1tot**2.and.
     &    np*j2j2t.gt.j2tot**2) then        

        corrp =  (dble(j1j2t) - dble(j1tot*j2tot)/np) /
     &      dsqrt(dble(j1j1t) - dble(j1tot*j1tot)/np) /
     &      dsqrt(dble(j2j2t) - dble(j2tot*j2tot)/np)

      else

        corrp = 0.0d0

      endif

      return
      end

      subroutine sort(x,n,iaatp)
      implicit double precision (a-h,o-z)
      parameter (np=850)
      parameter (numcal=50000)
      dimension x(3,*),tmp(np),indx(numcal),iaatp(*)

      if (n.gt.np) return 

      call v3cpy2(tmp,x,n,1)

      call rqsrt(n,tmp,indx)

      do i=1,n
         x(1,i) = tmp(indx(i))
      end do

      do i=1,n
         tmp(i) = x(2,indx(i))
      end do

      call v3cpy1(x,tmp,n,2)

      do i=1,n
         tmp(i) = x(3,indx(i))
      end do

      call v3cpy1(x,tmp,n,3)

      do i=1,n
         tmp(i) = iaatp(indx(i))
      end do

      do i=1,n
         iaatp(i) = nint(tmp(i))
      end do

      return
      end

      subroutine dotran(ca1,ncalf1,ca2,ncalf2,trans,best,maxd,
     &                  iaatp1,iaatp2)
      implicit double precision (a-h,o-z)
      parameter (np=850)
      dimension grid(-maxd:maxd,-maxd:maxd,-maxd:maxd)
      dimension ca1(3,*),ca2(3,*),trans(3),pam(3,3),
     &          ica2(3,np),iaatp1(*),iaatp2(*)
      data pam/1.0d0,0.3d0,0.6d0,
     &         0.3d0,1.0d0,0.6d0,
     &         0.6d0,0.6d0,1.0d0/

      if (ncalf2.gt.np) stop 'dotran: np underdim.'

      xcut = dble(min(ncalf1,ncalf2))/100.0d0
      
      maxd1 = (maxd-1)
      maxd2 = maxd1*maxd1
      best  = 0.0d0

      do i1=-maxd,maxd
         do i2=-maxd,maxd
            do i3=-maxd,maxd
               grid(i3,i2,i1) = 0.0d0
            end do
         end do
      end do

      do i=1,ncalf2
         do j=1,3
            ica2(j,i) = nint(ca2(j,i))
         end do
      end do

      jstart = 0

      do i=1,ncalf1

        ica1x = nint(ca1(1,i))
        ica1y = nint(ca1(2,i))
        ica1z = nint(ca1(3,i))

        do j=jstart+1,ncalf2
          i1 = ica1x - ica2(1,j)

          if (i1.gt.maxd1) then
            jstart = j
          else
             if (i1.lt.-maxd1) goto 100

             i2 = ica1y - ica2(2,j)

             if (abs(i2).le.maxd1) then
                i3 = ica1z - ica2(3,j)

                if (abs(i3).le.maxd1) then
                   grid(i3,i2,i1) = grid(i3,i2,i1) + 
     &                              pam(iaatp1(i),iaatp2(j))
                endif

             endif

          endif

        end do

100     continue
      end do

c     search within a sphere around the origin

      do i1=-maxd+1,maxd-1

         i = int(dsqrt(dble(maxd2-i1*i1)))

         do i2=-i,i

            j = int(dsqrt(dble(maxd2-i1*i1-i2*i2)))

            do i3=-j,j

              if (grid(i3,i2,i1).gt.xcut) then

                over = 0.0d0

                do k=-1,1

                   do l=-1,1

                      do m=-1,1
                         over = over + grid(m+i3,l+i2,k+i1)
                      end do

                   end do

                end do

                if (over.gt.best) then

                  best = over

                  call vsetr(trans,3,0.0d0)

                  do k=-1,1
                     do l=-1,1
                        do m=-1,1
                          trans(1) = trans(1) + 
     &                               grid(m+i3,l+i2,k+i1)*(k+i1)
                          trans(2) = trans(2) + 
     &                               grid(m+i3,l+i2,k+i1)*(l+i2)
                          trans(3) = trans(3) + 
     &                               grid(m+i3,l+i2,k+i1)*(m+i3)
                        end do
                     end do
                  end do

                  call vscal(trans,3,1.0d0/over)

                endif

              endif

            end do
         end do
      end do

      return
      end

      subroutine angscan(ca1,ncalf1,ca2,ncalf2,ang,transb,
     &                   iaatp1,iaatp2u)
      implicit double precision (a-h,o-z)
      parameter (rad=3.14159265d0/180.0d0)
      parameter (numcal=50000,maxd=20)
      dimension ca1(3,*),ca2(3,*),rot(3,3),trans(3),
     &  cen1(3),cen2(3),transb(3),ang(3)
      dimension iaatp1(*),iaatp2u(*)
      dimension cat(3,numcal),ca1u(3,numcal),catu(3,numcal),
     &          iaatp2(numcal)

      delt2 = 10.0d0

      rmom1 = 0.0d0
      rmom2 = 0.0d0

      call cntvc2(cen1,ca1,ncalf1)
      call cntvc2(cen2,ca2,ncalf2)

      do i=1,ncalf1
         do j=1,3
            ca1(j,i) = ca1(j,i) - cen1(j)
            rmom1 = rmom1 + ca1(j,i)**2
            ca1u(j,i) = ca1(j,i)
         end do
      end do

      do i=1,ncalf2
         do j=1,3
            ca2(j,i) = ca2(j,i) - cen2(j)
            rmom2 = rmom2 + ca2(j,i)**2
         end do
      end do

      if (ncalf1.gt.0) rmom1 = dsqrt(rmom1/ncalf1)
      if (ncalf2.gt.0) rmom2 = dsqrt(rmom2/ncalf2)

      maxd1 = nint(9.5d0 + dabs(rmom1-rmom2))

      if (maxd1.gt.maxd) maxd1 = maxd

      ccprp    = 0.0d0
      ccpr     = 0.0d0
      qaqa     = 0.0d0
      qapr     = 0.0d0
      totover2 = 0.0d0
      totover  = 0.0d0

      n2cc   = 0
      n2n2   = 0
      n2pr   = 0
      n2n2m  = 0
      n2prp  = 0
      nang   = 0

      call sort(ca1,ncalf1,iaatp1)

      phi2 = -delt2

      do iphi2=0,int(180.01d0/delt2)

        phi2 = phi2 + delt2

        if (phi2.lt.179.9d0) then
          deltp = delt2 / dcos(phi2/2.0d0*rad)
        else
          deltp = 720.01d0
        endif

        phip = -deltp

        do iphip=0,int(719.99d0/deltp)

          phip = phip + deltp

          if (iphi2.ne.0) then

            deltm = delt2/dsin(phi2/2.0d0*rad)

          else

            if (phip.gt.359.99d0) goto 100
            deltm = 360.02d0

          endif

          phim = -deltm

          do iphim=0,int(360.01d0/deltm)

            phim = phim + deltm

            if (phi2.gt.179.99d0.and.phim.gt.359.99d0) goto 100

            call rotmt(rot,phip,phi2,phim)

            do i=1,ncalf2

               iaatp2(i) = iaatp2u(i)

               do j=1,3
                  cat(j,i) = rot(j,1)*ca2(1,i) + rot(j,2)*ca2(2,i) + 
     &                       rot(j,3)*ca2(3,i)       
                  catu(j,i) = cat(j,i)
               end do

            end do

            call sort(cat,ncalf2,iaatp2)

            call dotran(ca1,ncalf1,cat,ncalf2,trans,over,maxd1,iaatp1,
     &                  iaatp2)

            nang     = nang + 1
            totover  = totover + over
            totover2 = totover2 + over*over
            corr     = 0.0d0
            corrp    = 0.0d0
            np       = 0
            nm       = 0

            overc = totover/nang + 2.0d0*
     &              dsqrt(dabs(totover2/nang - (totover/nang)**2))

            if (over.gt.qaqa.or.over.gt.overc)
     &          call calcor(ca1u,catu,ncalf1,ncalf2,trans,n,np,nm,
     &                      corr,corrp)        

c store solution

            call stosol(over,corr,np,nm,qaqa,n2cc,n2n2,
     &        phip,phi2,phim,
     &        trans,transb,qapr,ccpr,n2pr,n2n2m,corrp,n2prp,
     &        ccprp,ang)

c fine scan 

            overc = totover/nang + 3.0d0*
     &              dsqrt(dabs(totover2/nang - (totover/nang)**2))

            if (corrp*np.gt.0.9d0*(n2prp*ccprp).or.
     &          np+nm.gt.0.9d0*(n2n2+n2n2m).or.over.gt.overc) then

             do i1=-1,1
                do i2=-1,1
                   do i3=-1,1

                      if (.not.(i1.eq.0.and.i2.eq.0.and.i3.eq.0)) then

                          call rotmt(rot,phip + i1*deltp/2.0d0,
     &                                   phi2 + i2*delt2/2.0d0,
     &                                   phim + i3*deltm/2.0d0)
                          do i=1,ncalf2

                             iaatp2(i) = iaatp2u(i)

                             do j=1,3
                                cat(j,i) = rot(j,1)*ca2(1,i) + 
     &                                     rot(j,2)*ca2(2,i) + 
     &                                     rot(j,3)*ca2(3,i)      
                                catu(j,i) = cat(j,i)
                             end do

                          end do

                          call sort(cat,ncalf2,iaatp2)

                          call dotran(ca1,ncalf1,cat,ncalf2,trans,over,
     &                                maxd1,iaatp1,iaatp2)

                          call calcor(ca1u,catu,ncalf1,ncalf2,trans,
     &                                n,np,nm,corr,corrp)        

                          call stosol(over,corr,np,nm,qaqa,
     &                                n2cc,n2n2,
     &                                phip+i1*deltp/2.0d0,
     &                                phi2+i2*delt2/2.0d0,
     &                                phim+i3*deltm/2.0d0,
     &                                trans,transb,qapr,ccpr,n2pr,n2n2m,
     &                                corrp,n2prp,ccprp,ang)

                      endif
                   end do
                end do
             end do

            endif

          end do
        end do
100     continue
      end do

      totover = totover / nang
      totover2 = dsqrt(dabs(totover2/nang - totover**2))

      call rotmt(rot,ang(1),ang(2),ang(3)) 

      do j=1,3
         cat(j,1) = rot(j,1)*cen2(1) + rot(j,2)*cen2(2) + 
     &              rot(j,3)*cen2(3)
         transb(j) = transb(j) + cen1(j) - cat(j,1)
      end do

      return
      end         

      subroutine kabsch(x,y,n,u,t,ier)
      implicit double precision (a-h,o-z)
      double precision mu(3)
      dimension x(3,*),y(3,*),u(3,3),t(3),ip(9),r(3,3),
     &          a(3,3),b(3,3),rr(6),cen1(3),cen2(3)
      data ip /1,2,4,  2,3,5,  4,5,6/

      ier = -1

      if (n.lt.2) then

         do i=1,3
            do j=1,3
               if (i.eq.j) then
                  u(i,j) = 1.0d0
               else
                  u(i,j) = 0.0d0
               endif
            end do
         end do

         call vsetr(t,3,0.0d0)

         return
      endif

      call cntvc2(cen1,x,n)
      call cntvc2(cen2,y,n)

      do i=1,3

         do j=1,3
            r(i,j) = 0.0d0
         end do

      end do

      xyavl = 0.0d0

c R is the covariance matrix

      do m=1,n
         do i=1,3

            xyavl = xyavl + 
     &              ((x(i,m) - cen1(i))**2 + (y(i,m) - cen2(i))**2)

            do j=1,3
               r(i,j) = r(i,j) + (y(i,m) - cen2(i)) * (x(j,m) - cen1(j))
            end do

         end do
      end do

c     determinant of r(i,j)

      det = r(1,1)*(r(2,2)*r(3,3)-r(2,3)*r(3,2))
     &     -r(1,2)*(r(2,1)*r(3,3)-r(2,3)*r(3,1))
     &     +r(1,3)*(r(2,1)*r(3,2)-r(2,2)*r(3,1))

      dett = det

c     RR = transposed(R)*R

      m = 0
      do j=1,3
         do i=1,j
            m = m + 1
            rr(m) = r(1,i)*r(1,j) + r(2,i)*r(2,j) + r(3,i)*r(3,j)
         end do
      end do

      tracerr = (rr(1) + rr(3) + rr(6)) / 3.0d0
      cof = (rr(3)*rr(6) - rr(5)*rr(5) + rr(1)*rr(6) - rr(4)*rr(4) + 
     &       rr(1)*rr(3) - rr(2)*rr(2) ) / 3.0d0
      det = det*det

c     reduce cubic to standard form y**3-3hy+2g=0 by putting x=y-trace

      d = tracerr*tracerr
      h = d - cof
      g = tracerr*(cof*1.5d0 - d) - det*0.5d0

c     eigenvalues RR: mu(3), eigenvectors of RR: a(3,3) (A)

      if (h.le.d*1.0d-9) then

c     three roots the same

         mu(1) = tracerr
         mu(2) = tracerr
         mu(3) = tracerr

         do i=1,3
            do j=1,3
   
               if (i.eq.j) then
                  a(i,j) = 1.0d0
               else
                  a(i,j) = 0.0d0
               endif

            end do
         end do

      else

         sqrth = dsqrt(h)
         d = -g / (h*sqrth)
   
         if (d.gt. 0.9999999d0) then

c        two roots the same, two different 

            mu(1) = tracerr + sqrth + sqrth
            mu(2) = tracerr - sqrth
            mu(3) = mu(2)

            call root2(a,rr,mu,ip,1,3,1,2)

         else

            if (d.lt.-0.9999999d0) then

c           two roots the same, two different 

               mu(1) = tracerr + sqrth
               mu(2) = mu(1)
               mu(3) = tracerr - sqrth - sqrth

               call root2(a,rr,mu,ip,3,1,2,3)

            else

c           three different roots

               d   = dacos(d)/3.0d0
               cphi = sqrth*dcos(d)
               sphi = sqrth*dsin(d)*dsqrt(3.0d0)

               mu(1)  = tracerr + cphi + cphi
               mu(2)  = tracerr - cphi + sphi
               mu(3)  = tracerr - cphi - sphi

               call root3(a,rr,mu,ip)

            endif

         endif

      endif

c B = R*A

      do l=1,2

         d = 0.0d0

         do i=1,3
            b(i,l) = r(i,1)*a(1,l) + r(i,2)*a(2,l) + r(i,3)*a(3,l)
            d = d + b(i,l)**2
         end do

         d = dsqrt(d)

         do i=1,3
            b(i,l) = b(i,l) / d
         end do

      end do

      call axa(b,3,1,2)

c     rotation matrix U = B*A (U = At*R*A )

      do i=1,3
         do j=1,3
            u(i,j) = b(i,1)*a(j,1) + b(i,2)*a(j,2) + b(i,3)*a(j,3)
         end do
      end do

c     translation vector: center y - rotated center x

      do i=1,3
         t(i) = cen2(i) - 
     &         (u(i,1)*cen1(1) + u(i,2)*cen1(2) + u(i,3)*cen1(3))
      end do

c     rms error

      if (mu(3).lt.0.0d0) mu(3) = 0.0d0
      if (mu(2).lt.0.0d0) mu(2) = 0.0d0
      if (mu(1).lt.0.0d0) mu(1) = 0.0d0

      d = dsqrt(mu(3))
      if (dett.lt.0.0) d = -d
      d = d + dsqrt(mu(2)) + dsqrt(mu(1))
      rms = dabs(xyavl-2.0d0*d)
      print*,'rms unnorm ',rms
      rms = dsqrt(rms/n)

      print*,'rms ',rms,' (angstroms)'

      ier = 0

      return
      end

c     eigenvectors three distinct roots

      subroutine root3(a,rr,e,ip)
      implicit double precision (a-h,o-z)
      dimension a(3,3),ss(6),rr(6),e(3),ip(9)

      do l=1,2

         ss(1) = (e(l)-rr(3))*(e(l)-rr(6)) - rr(5)*rr(5)
         ss(2) = (e(l)-rr(6))*      rr(2)  + rr(4)*rr(5)
         ss(3) = (e(l)-rr(1))*(e(l)-rr(6)) - rr(4)*rr(4)
         ss(4) = (e(l)-rr(3))*      rr(4)  + rr(2)*rr(5)
         ss(5) = (e(l)-rr(1))*      rr(5)  + rr(2)*rr(4)
         ss(6) = (e(l)-rr(1))*(e(l)-rr(3)) - rr(2)*rr(2)

         if ( dabs(ss(1)).ge.dabs(ss(3)) ) then
            if ( dabs(ss(1)).lt.dabs(ss(6)) ) then
               j = 3
            else
               j = 1
            endif
         else 
            if ( dabs(ss(3)).ge.dabs(ss(6)) ) then
               j = 2
            else
               j = 3
            endif
         endif

         sum = 0.0d0
         j = 3*(j-1)

         do i=1,3
            a(i,l) = ss(ip(i+j))
            sum = sum + ss(ip(i+j))*ss(ip(i+j))
         end do
   
         sum = dsqrt(sum)

         do i=1,3
            a(i,l) = a(i,l) / sum
         end do

      end do

      call axa(a,3,1,2)

      return
      end

c     eigenvectors two distinct roots
c     h=trace+g

      subroutine root2(a,rr,e,ip,m,m1,m2,m3)
      implicit double precision (a-h,o-z)
      dimension a(3,3),rr(6),e(3),ip(9)

      p = 0.0d0

      h = e(2)

      do i=1,3

         k = (i*i + i)/2
         d = dabs(rr(k) - h)

         if (d.ge.p) then
            j = i
            p = d
         endif

      end do

      p = 0.0d0
      d = 0.0d0
      l = 3*(j-1)

      do i=1,3

         k = ip(i+l)
         a(i,2) = 1.0d0

         if (i.ne.j) then
            a(i,m) = rr(k)
            p = p - a(i,m)
         else
            a(i,m) = rr(k) - h
         endif

         d = d + a(i,m)**2
      end do

      a(j,2) = p / a(j,m)

      d = dsqrt(d)
      p = dsqrt(a(1,2)**2 + a(2,2)**2 + a(3,2)**2)

      do i=1,3
         a(i,2) = a(i,2) / p
         a(i,m) = a(i,m) / d
      end do

      call axa(a,m1,m2,m3)

      return
      end

      subroutine axa(a,m1,m2,m3)
      implicit double precision (a-h,o-z)
      dimension a(3,3)

      a(1,m1) = a(2,m2)*a(3,m3) - a(2,m3)*a(3,m2)
      a(2,m1) = a(3,m2)*a(1,m3) - a(3,m3)*a(1,m2)
      a(3,m1) = a(1,m2)*a(2,m3) - a(1,m3)*a(2,m2)

      return
      end

      logical function chksec(isal,ncalf)
      implicit double precision (a-h,o-z)
      dimension isal(*)

      chksec = .false.

      icoil = 0
      ihelsh = 0

      do i=1,ncalf
         is = isal(i)
         if (is.le.1) ihelsh = ihelsh + 1
         if (is.eq.3) icoil = icoil + 1
      end do

      ncalft = ihelsh + icoil
      if (dble(ihelsh)/dble(ncalft).gt.0.5d0) chksec = .true.

      return
      end

      subroutine fident(coo1,coo2,iamin1,iamin2,icalf1,icalf2,
     &                  ncalf1,ncalf2,isal1,isal2,x,y,neq,ok)
      implicit double precision (a-h,o-z)
      parameter (mxhits = 1000)
      logical ohit,ok,chksec,oscnd
      dimension coo1(3,*),coo2(3,*),iamin1(*),iamin2(*),
     &          icalf1(6,*),icalf2(6,*),isal1(*),isal2(*)
      dimension ihit(mxhits,2), x(3,*),y(3,*)

      oscnd = .false.
      if (chksec(isal1,ncalf1).and.chksec(isal2,ncalf2)) oscnd = .true.

      neql = 5
      nhit = 0

      ind1 = 1
      ind2 = 1

      do while(.true.)

         if (ohit(iamin1,iamin2,ncalf1,ncalf2,ind1,ind2,neql,
     &            isal1,isal2,oscnd)) then

            nhit = nhit + 1

            if (nhit.le.mxhits) then
               ihit(nhit,1) = ind1
               ihit(nhit,2) = ind2
            endif

            ind1 = ind1 + neql
            ind2 = ind2 + neql

            if (ind1.gt.ncalf1-neql) goto 10

            if (ind2.gt.ncalf2-neql) then
               ind1 = ind1 + 1
               if (nhit.gt.0) then
                  ind2 = ihit(nhit,2)
               else
                  ind2 = 1
               endif
            endif

         else

            ind2 = ind2 + 1

            if (ind2.gt.ncalf2-neql) then
               ind1 = ind1 + 1
               if (nhit.gt.0) then
                  ind2 = ihit(nhit,2)
               else
                  ind2 = 1
               endif
            endif

         endif 

      end do

10    if (nhit*neql.gt.(ncalf1+ncalf2)/6.0d0) then

         ok = .true.
         neq = 0

         do i=1,nhit

            i1 = ihit(i,1)
            i2 = ihit(i,2)

            do j=1,neql

               if (i1.le.ncalf1.and.i2.le.ncalf2) then

                  neq = neq + 1

                  do k=1,3
                     y(k,neq) = coo1(k,icalf1(1,i1))*0.52917706d0
                     x(k,neq) = coo2(k,icalf2(1,i2))*0.52917706d0
                  end do

                  i1 = i1 + 1
                  i2 = i2 + 1

               else
                  return
               endif

            end do

         end do

      else
         ok = .false.
      endif

      return
      end

      logical function ohit(iamin1,iamin2,ncalf1,ncalf2,ind1,ind2,neql,
     &                      isal1,isal2,oscnd)
      implicit double precision (a-h,o-z)
      logical oscnd
      dimension iamin1(*),iamin2(*),isal1(*),isal2(*)

      ohit = .true.
      do i=1,neql
         i1 = ind1+i-1
         i2 = ind2+i-1

         if (i1.le.ncalf1.and.i2.le.ncalf2) then
            if (oscnd) then
               if (iamin1(i1).ne.iamin2(i2).or.
     &             (isal1(i1).gt.1.or.isal2(i2).gt.1)) then
                  ohit = .false.
                  return
               endif
            else
               if (iamin1(i1).ne.iamin2(i2)) then
                  ohit = .false.
                  return
               endif
            endif
         endif

      end do

      return
      end

      subroutine gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)
      
      fgmax = -1000000.d0
      fgmin =  1000000.d0
      dgmax = -1000000.d0
      dgmin =  1000000.d0
      enmax = -1000000.d0
      enmin =  1000000.d0

      do i=1,ngeoms
        if(isav(i).eq.1) then
         if (formax(i).lt.fgmin) fgmin = formax(i)
         if (formax(i).gt.fgmax) fgmax = formax(i)
         if (forrms(i).lt.fgmin) fgmin = forrms(i)
         if (forrms(i).gt.fgmax) fgmax = forrms(i)
         if (dismax(i).lt.dgmin) dgmin = dismax(i)
         if (dismax(i).gt.dgmax) dgmax = dismax(i)
         if (disrms(i).lt.dgmin) dgmin = disrms(i)
         if (disrms(i).gt.dgmax) dgmax = disrms(i)
        endif
      end do

      do i=1,nepnts
         if (epoints(i).lt.enmin) enmin = epoints(i)
         if (epoints(i).gt.enmax) enmax = epoints(i)
      end do

      return
      end

      subroutine plhead(title)
      implicit double precision (a-h,o-z)
      real xx, yy
      character str*100, esc, etx, lf, gs, us
      character keywrd*320, keyori*320, title*80
      character tk4014*5

      common /plot/   iplot,iplwin,icolps
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /keywrd/ keywrd,keyori

      etx    = char(3)
      lf     = char(10)
      esc    = char(27)
      gs     = char(29)
      us     = char(31)

c------- Plot Header

      if (iplot.eq.0) then
         write(iun4,'(a)') '.nc 1'
         write(iun4,'(a)') '.to 3'
         write(iun4,'(a)') '.ch 2.0'
         write(iun4,'(a)') '.fo 1' 
         write(iun4,'(a)') '.td 270.0' 
         write(iun4,'(a)') '.m 1.47 1.0' 
         write(iun4,'(''.pt '',a)')'********* M O L D E N  **********'
         write(iun4,'(a)') '.m 1.42 1.0' 
         write(iun4,'(''.pt '',a)')title
         write(iun4,'(a)') '.m 1.37 1.0' 
         write(iun4,'(a)') '.ch 1.5'
         write(iun4,'(''.pt '',a)')keywrd(1:80)
         write(iun4,'(a)') '.m 1.32 1.0' 
         write(iun4,'(''.pt '',a)')keywrd(81:160)
      endif

      if (iplot.eq.1) then
        write(iun4,'(a)') 'SC0,36,0,18;SP1;DI0,-1;' 
        write(iun4,'(''PU51,18;LB********* M O L D E N  **********''
     +          ,a,'';'')')etx
        write(iun4,'(''SL0.6;PU50,18;LB'',a,a,'';'')')title,etx
        write(iun4,'(''PU49,18;LB'',a,a,'';'')')keywrd(1:80),etx
        write(iun4,'(''PU48,18;LB'',a,a,'';'')')keywrd(81:160),etx
      endif

      if (iplot.eq.2) then
c       text vertical no slanting
        write(iun4,'(a,''*m1nO'')')esc
c       position for text write
        write(iun4,'(a,''*pa408,379Z'')')esc
c       write text
        write(iun4,'(a,''*lM O L D E N '',a)') esc,lf
        write(iun4,'(a,''*l'',a)')esc,lf
c       text slanting
        write(iun4,'(a,''*mO'')')esc
        write(iun4,'(a,''*l'',a,a)')esc,title(1:15),lf
c       text horizontal
        write(iun4,'(a,''*m1nO'')')esc
      endif

      if (iplot.eq.3) then
c------ flush last instructions tek4014 ----------------
       idum=1
       call plotgh(idum,0.0d0,0.0d0)
c       write(iun4,*)esc//'/0d'
       write(iun4,*)gs//tk4014(int(1.05*3100),int(0.95*3100))
     +            //us//'M O L D E N'
      endif

      if (iplot.eq.6) then
        xx= 15.0
        yy= 0.0
        call xwin(xx,yy,99,str,nstr,idum1,idum2)
        xx= 1.02
        yy= 0.95
c        call xwin(xx,yy,4,'M O L D E N',11,idum1,idum2)
      endif

      return
      end

      subroutine rdpdd(istat,coo,ianz,ihashb)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /athlp/ iatoms, mxnat
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*2 elemnt
      common /elem/elemnt(mxel)
      character lstr*137
      character*2 tstr,tocapf
      dimension coo(3,*),ianz(*)

      ihashb = 0

      call rewfil
      istat = 1
      
10    call searchd(lstr,'ATOM','HETATM',istat)
      if (istat.eq.0) then
           call inferr('no ATOM/HETATM found !',0)
           goto 100
      endif
      if (lstr(1:4).ne.'ATOM'.and.lstr(1:6).ne.'HETATM') goto 10
      call bckfil

      iatoms = 0
      do while (.true.)
15        call nxtlin(lstr,jstat)
          if (jstat.eq.1) goto 20
          if (lstr(1:4).ne.'ATOM'.and.lstr(1:6).ne.'HETATM') goto 15
          if (iatoms.ge.mxnat) then
               call inferr('exceeded maximum atoms !',1)
               goto 100
          endif
          iatoms = iatoms + 1
          ianz(iatoms) = 0
          read(lstr,'(12x,a2,16x,3f8.3)') tstr,
     &        coo(1,iatoms),coo(2,iatoms),coo(3,iatoms)
          it = ichar(tstr(1:1))
          if (.not.(it.ge.65.and.it.le.90).and..not.
     &             (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
          do j=1,99
             if (tstr.eq.tocapf(elemnt(j))) ianz(iatoms) = j
          end do
          if (ianz(iatoms).eq.0.and.tstr(1:1).ne.' ') then
             tstr(1:1) = ' '
             do j=1,99
                if (tstr.eq.tocapf(elemnt(j))) ianz(iatoms) = j
             end do
          endif
          if (ianz(iatoms).le.0) then
             if (tstr(2:2).eq.'D') then
                ianz(iatoms) = 1
             else
                write(iun3,*) 'Unclassified atom =',tstr
                write(iun3,*) lstr
                ianz(iatoms) = 99
             endif
          endif
      end do

20    continue

      return
100   istat = 0
      return
      end

      subroutine pdbsiz(iszhnt)
      implicit double precision (a-h,o-z)
      integer iszhnt
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137

      call rewfil

      iszhnt = 0
      do while (.true.)
         call nxtlin(lstr,jstat)
         if (jstat.eq.1) goto 20
         if (lstr(1:4).eq."ATOM".or.lstr(1:6).eq."HETATM") 
     &       iszhnt = iszhnt + 1
      end do

20    iszhnt = 3*iszhnt

      return
      end

      subroutine pdbsdd(istat,doscnd,ioadd,
     &                  coo,ianz,iaton,iresid,iconn,ityp,
     &                  ncalf,ianf,islu,nchain,iamino,ihet,
     &                  isal,irsnr,achain,ihashb,ishoh)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      integer*2 ityp
      integer doscnd
      character*3 chtnk,pdbsym,hsym,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      common /athlp/ iatoms, mxnat
      common /surf / natorg,nosncd

      parameter (numcal=50000)
      parameter (mxres=42)
      parameter (mxheta=150)

      parameter (mxmmul=100)
      character*1 achain
      logical isatm,ishet,hasalt,skip,dall,goods
      character*3 aminos
      common /amino/ aminos(mxres)
      common /multim/imulm, nmulm,ihasqm(mxmmul)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      character*4 pdbc
      common /pdbcod/ pdbc

      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137
      character*2 tocapf,hetred
      character*4 tstr,tmpstr
      character*3 resi,resit
      character*1 restmp,resa,altloc,aloc,ach,tch,tach
      dimension ipdb(mxsym),hetred(4),
     &          ihpdb(mxhsym*3),tmp(3),isc(numcal)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*),
     &          ityp(*)
      dimension ianf(*),islu(*),iamino(*),ihet(*),isal(*),irsnr(*),
     &          achain(*)

      data hetred/
     &   'AC','AN','AO','AP'/

      imulm = 1
      if (ioadd.eq.0) then
         call parsfn('Helix',5,1)
         call parsfn('Beta',4,1)
         call parsfn('RNA/DNA',7,1)
         call parsfn('Coil',4,1)
         hetz(1) = 'Hel'
         hetz(2) = 'Bet'
         hetz(3) = 'DNA'
         hetz(4) = 'Coi'
      endif

      ihashb = 0

      ioatms = 0
      if (ioadd.eq.1) then
         natorg = iatoms
         do i=ncalf+1,numcal
             isal(i) = 3
             isc(i) = 0
         end do
         noff = ncalf
         ioatms = iatoms
      else
         do i=1,numcal
             isal(i) = 3
             isc(i) = 0
         end do
         noff = 0
      endif

      if (doscnd.eq.0) goto 5

      call rewfil
      call search(lstr,'HEADER',istat)
      if (istat.eq.1) then
         pdbc = lstr(63:66)
         call tolow(pdbc,4)
         call parstr(pdbc,11)
      else
         call rewfil
      endif
c
c     Proces Helix/Sheet information
c
      call rewfil

      icnt = 0
      do while (.true.)
          call searchd(lstr,'HELIX','SHEET',istat)
          if (istat.eq.0) goto 5
          if (index(lstr,'HELIX').eq.1) then
             read(lstr,'(19x,1a,1x,i4,8x,i4)',err=4,end=4) tch,i1,i2
             ihashb = 1
             if (noff+i1.gt.numcal) i1 = numcal
             if (noff+i2.gt.numcal) i2 = numcal
             i3 = i2 - i1 + 1
             if (i1.ne.0.and.i3.gt.1) then
                it = ichar(tch)
                if (it.ge.65) it = it - 65
                if (it.eq.32) it = 30
                do i=i1,i2
                   icnt = icnt + 1
                   isc(icnt) = it+0*32+i*128
                end do
             endif
          elseif (index(lstr,'SHEET').eq.1) then
             read(lstr,'(21x,1a,i4,7x,i4)',err=4,end=4) tch,i1,i2
             ihashb = 1
             if (noff+i1.gt.numcal) i1 = numcal
             if (noff+i2.gt.numcal) i2 = numcal
             i3 = i2 - i1 + 1
             if (i1.ne.0.and.i3.gt.1) then
                it = ichar(tch)
                if (it.ge.65) it = it - 65
                if (it.eq.32) it = 30
                do i=i1,i2
                   icnt = icnt + 1
                   isc(icnt) = it+1*32+i*128
                end do
             endif
          endif
      end do
4     call inferr('Error reading HELIX/SHEET record !',0)
5     continue

      call rewfil
      istat = 1
      hasalt = .false.
      dall = .false.
      
10    call searchd(lstr,'HETATM','ATOM',istat)
      if (istat.eq.0) then
           call inferr('no ATOM/HETATM record found !',0)
           call rewfil
           goto 210
      endif

      if (lstr(1:4).ne.'ATOM'.and.lstr(1:6).ne.'HETATM') goto 10
      call bckfil

      if (ioadd.eq.1) then
         call numhet(nhmol)
         nmulm = nhmol - 3
         nmulmt = nmulm
         icres = ncalf
         ianf(nchain+1) = 1
         islu(nchain+1) = 0
      else
         nhmol = 3
         iatoms = 0
         icres = 0
         nchain = 1
         ianf(1) = 1
         islu(1) = 0
         nmulm = 0
      endif

      jres = -1
      irtmp = -10000
      ipdb(38) = 0
      restmp = ' '
      tach = ' '
      ihashy = 0
      skip = .false.
      aloc = ' '

      do while (.true.)
15        call nxtlin(lstr,jstat)
          if (jstat.eq.1) goto 20
          isatm = (lstr(1:4).eq.'ATOM'.or.lstr(1:6).eq.'HETATM')
          if (lstr(1:6).eq.'ENDMDL') goto 20
          if (.not.isatm) goto 15
c
c found atom
c
          read(lstr,'(12x,a4,a1,a3,1x,a1,i4,a1,3x,3f8.3)') tstr,altloc,
     &       resi,ach,iresnr,resa,(tmp(l),l=1,3)
           
          call tocap(tstr,4)
          call tocap(resi,3)

          jrest = 0
          if (resi(2:3).eq.'  ') resi = '  '//resi(1:1)

          if (resi(2:2).eq.'D'.and.resi(1:1).eq.' ') then
             if (resi(3:3).eq.'A'.or.resi(3:3).eq.'C'.or.
     &           resi(3:3).eq.'G'.or.resi(3:3).eq.'T') then
                 resi(2:2) = ' '
             endif
          endif

          do j=1,mxres
             if (resi.eq.aminos(j)) jrest = j
          end do
          if (resi.eq.'HIP'.or.resi.eq.'HID'.or.
     &            resi.eq.'HIE') then
             jrest = 17
             resi = 'HIS'
          endif
          if (jrest.eq.0) goto 15

          do i=1,4
             if (ichar(tstr(i:i)).eq.39) tstr(i:i) = '*'
          end do
          if (tstr(3:4).eq.'**'.and.tstr(2:2).ne.'O') then
             tstr(2:4) = tstr(1:3)
             tstr(1:1) = ' '
          endif

          if (tstr(2:4).eq.'OT ') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'OCT') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'OP2') tstr(2:4) = 'O2P'
          if (tstr(2:4).eq.'OP1') tstr(2:4) = 'O1P'

          if (iresnr.ne.irtmp.or.restmp.ne.resa) then
c
c next amino acid
c
             if (iatoms.gt.mxnat-30) goto 20
             if (skip) then
                skip = .false.
                if (iresnr.eq.irtmp.and.restmp.ne.resa) skip = .true.
             else
c                if (icres.gt.0.and.jres.ne.0) then
                if (icres.gt.0.and.jres.gt.0) then
                   call mkcon(ipdb,jres,icres,ihpdb,ihashy,0)
                   call pdbtyp(ipdb,ihpdb,jres,1)
                endif
                if (jres.ne.0) icres  = icres + 1
                if (restmp.ne.resa) skip = .true. 
             endif
             if (icres.gt.0.and.icres.le.numcal) then
                iamino(icres) = jrest
                irsnr(icres) = iresnr
                achain(icres) = ach
                if (ihashb.eq.1.and.iresnr.gt.0.and.iresnr.le.numcal) 
     &          then
                  isal(icres) = 3
                  do ii=1,icnt
                    iiscm = isc(ii) / 128
                    iscd  = (isc(ii) - iiscm*128) / 32
                    it = isc(ii) - 128*iiscm - 32*iscd
                    if (it.eq.30) then
                        it = 32
                    else
                        it = it + 65
                    endif
                    if (it.eq.ichar(ach).and.iiscm.eq.iresnr) then
                       isal(icres) = iscd
                    endif
                  end do
                endif
             endif
             irtmp = iresnr
             restmp = resa
             jres = jrest
             do j=1,mxsym
                ipdb(j) = 0
             end do
             do j=1,mxhsym*3
                ihpdb(j) = 0
             end do
             ihashy = 0
             if (skip) goto 15
          else
             if (skip) goto 15
          endif

          if (iatoms.ge.mxnat-1000) then
             dall = .true.
             goto 100
          endif

          iatoms = iatoms + 1
          ianz(iatoms) = 0
          iconn(1,iatoms) = 0
          iresid(iatoms) = icres

          do l=1,3
             coo(l,iatoms) = tmp(l)
          end do

c determine ianz, see if hydrogen atom

          call detanz(resi,tstr,lstr,ifnd,ish,ianz(iatoms),ihashy)

          ihstyp = 0
          if (ish.eq.1) then
            do j=1,mxhsym
               if (tstr(2:4).eq.hsym(j)) then
                  ihstyp = 1
                  if (ihpdb((j-1)*3+1).eq.0) then
                     aloc = altloc
                  elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                  endif
                  do l=1,3
                     if (ihpdb((j-1)*3+l).eq.0) then
                        ihpdb((j-1)*3+l) = iatoms
                        goto 1000
                     endif
                  end do
1000              continue
               endif
            end do
            if (tstr(2:4).eq.'HG3') then
                ihstyp = 1
                if (ihpdb(16).ne.0.and.ihpdb(13).eq.0) then
c                     ihpdb(13) = ihpdb(16)
c                     ihpdb(16) = iatoms
                     ihpdb(10) = ihpdb(16)
                     ihpdb(11) = iatoms
                     ihpdb(16) = 0
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif
            if (tstr(2:4).eq.'HD3') then
                ihstyp = 1
                if (ihpdb(25).ne.0.and.ihpdb(22).eq.0) then
c                     ihpdb(22) = ihpdb(25)
c                     ihpdb(25) = iatoms
                     ihpdb(19) = ihpdb(25)
                     ihpdb(20) = iatoms
                     ihpdb(25) = 0
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif
            if (tstr(2:4).eq.'HE3') then
                ihstyp = 1
                if (ihpdb(34).ne.0.and.ihpdb(31).eq.0) then
                     ihpdb(28) = ihpdb(34)
                     ihpdb(29) = iatoms
                     ihpdb(34) = 0
                     ihpdb(37) = 0
                elseif (ihpdb(34).ne.0.and.ihpdb(31).ne.0) then
                     ihpdb(28) = ihpdb(31)
                     ihpdb(29) = ihpdb(34)
                     ihpdb(30) = iatoms
                     ihpdb(31) = 0
                     ihpdb(34) = 0
                     ihpdb(37) = 0
                elseif (ihpdb(37).ne.0.and.ihpdb(31).eq.0) then
                     ihpdb(31) = ihpdb(37)
                     ihpdb(37) = iatoms
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif
            if (tstr(2:4).eq.'HZ3') then
                if (ihpdb(43).ne.0.and.ihpdb(46).ne.0.and.
     &              ihpdb(49).ne.0) then
                     ihpdb(40) = ihpdb(43)
                     ihpdb(41) = ihpdb(46)
                     ihpdb(42) = ihpdb(49)
                     ihpdb(43) = 0
                     ihpdb(46) = 0
                     ihpdb(49) = 0
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif
            if (tstr(2:3).eq.'HC') then
                ihstyp = 1
                if (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif
          else
            do j=1,mxsym
               if (tstr(2:4).eq.pdbsym(j)) then
                  ihstyp = 1
c
c Allow only the first of alternate locations
c
                  if (ipdb(j).eq.0) then
                     ipdb(j) = iatoms
                  else
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                  endif
               endif
            end do
          endif
          if (ihstyp.eq.0) then
              nhmol = nhmol + 1
              iresid(iatoms) = -nhmol
              irtmp = -10000
              resi = 'UNK'
              call parsfn(resi,3,1)
              hetz(nhmol+1) = 'UNK'
          endif
          iaton(iatoms)  = 1
      end do


20    continue

c round up last amino acid

      
      if (jres.gt.0) then
         call mkcon(ipdb,jres,icres,ihpdb,ihashy,0)
         call pdbtyp(ipdb,ihpdb,jres,1)
      endif
      islu(nchain) = icres
      ncalf = icres
      namatm = iatoms
c
c do hetatm
c
      ishoh = 0
      irtmp = -10000
      resit = '   '
      tach = ' '

      call rewfil
210   call searchd(lstr,'HETATM','ATOM',istat)
      if (istat.eq.0) goto 220
      if (lstr(1:6).ne.'HETATM'.and.lstr(1:4).ne.'ATOM') goto 210
      call bckfil

      do while (.true.)
215        call nxtlin(lstr,jstat)
           if (jstat.eq.1) goto 220

           ishet = (lstr(1:6).eq.'HETATM')
           isatm = (lstr(1:4).eq.'ATOM')
           if (lstr(1:3).eq.'TER') irtmp = -10000
           if (lstr(1:6).eq.'ENDMDL') goto 220
           resi = lstr(18:20)
           if (ishet.or.isatm) then
              jrest = 0
              ishet = .false.
              if (resi(2:3).eq.'  ') resi = '  '//resi(1:1)
              if (resi(2:2).eq.'D'.and.resi(1:1).eq.' ') then
                 if (resi(3:3).eq.'A'.or.resi(3:3).eq.'C'.or.
     &               resi(3:3).eq.'G'.or.resi(3:3).eq.'T') then
                     resi(2:2) = ' '
                 endif
              endif
              do j=1,mxres
                 if (resi.eq.aminos(j)) jrest = j
              end do
              if (resi.eq.'HIP'.or.resi.eq.'HID'.or.
     &            resi.eq.'HIE') then
                 jrest = 17
                 resi = 'HIS'
              endif
              if (jrest.eq.0) ishet = .true.
           endif
           if (.not.ishet) goto 215

           if (iatoms.ge.mxnat-1000) then
               dall = .true.
               goto 100
           endif

           iatoms = iatoms + 1
           ianz(iatoms) = 0
           read(lstr,'(12x,a4,a1,a3,1x,a1,i4,4x,3f8.3)') tstr,altloc,
     &        resi,ach,iresnr, coo(1,iatoms),coo(2,iatoms),coo(3,iatoms)
           
           call tocap(tstr,4)

           if (altloc.ne.' '.and.altloc.ne.'A'.and.altloc.ne.'a'.and.
     &         altloc.ne.'1') then
              iatoms = iatoms - 1
              hasalt = .true.
              goto 215
           endif

           if (resi.ne.'HOH') then
              tmpstr = tstr(1:4)
              isl = len(tmpstr)
              call prslab(tmpstr,isl,iatoms)
           endif

           ic1 = 0
           ic2 = 0
           ls = len(lstr)
           goods = .false.
           if (ls.ge.78) then
              ic0 = ichar(lstr(76:76))
              ic1 = ichar(lstr(77:77))
              ic2 = ichar(lstr(78:78))
              goods = ( ((ic1.ge.65.and.ic1.le.90).or.ic1.eq.32) .and.
     &                  ((ic2.ge.65.and.ic2.le.90).or.ic2.eq.32) .and.
     &                  ic0.eq.32)
              if (goods) then
                  goods = (.not.(ic1.eq.32.and.ic2.eq.32))
              endif
           endif

           if (goods) then

              read(lstr,'(76x,a2)') tstr(1:2)

              do j=1,99
                if (tstr(1:2).eq.tocapf(elemnt(j))) ianz(iatoms) = j
              end do
            
           else

              if (resi.eq.'HEM') then
                 if (tstr(1:2).eq.'HA'.or.tstr(1:2).eq.'HB'.or.
     &               tstr(1:2).eq.'HM') tstr(1:4) = ' H  '
                 if (tstr(2:3).eq.'FE') tstr(1:3) = 'FE '
              endif

              if (resi.eq.'NDP') then
                 if (tstr(1:2).eq.'NP') tstr(1:4) = ' P  '
              endif

              do j=1,4
                 if (tocapf(tstr(1:2)).eq.hetred(j)) then
                     tstr(1:1) = ' '
                 endif
              end do

              it = ichar(tstr(1:1))
              if (.not.(it.ge.65.and.it.le.90).and..not.
     &           (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
              it2 = ichar(tstr(2:2))
              if (.not.(it2.ge.65.and.it2.le.90).and..not.
     &           (it2.ge.97.and.it2.le.122)) tstr(2:2) = ' '
              if (tstr(2:2).eq.' '.and.tstr(1:1).ne.' ') then
                 tstr(2:2) = tstr(1:1)
                 tstr(1:1) = ' '
              endif 

              do j=1,99
                if (tstr(1:2).eq.tocapf(elemnt(j))) ianz(iatoms) = j
              end do

              if (ianz(iatoms).eq.0.and.tstr(1:1).ne.' ') then
                 tstr(1:1) = ' '
                 do j=1,99
                     if (tstr(1:2).eq.tocapf(elemnt(j))) 
     &                  ianz(iatoms) = j
                 end do
              endif

           endif

           if (ianz(iatoms).le.0) then
              write(iun3,*) 'Unclassified atom =',tstr
              write(iun3,*) lstr
              ianz(iatoms) = 99
           endif
           iconn(1,iatoms) = 0
           iaton(iatoms)  = 0
           if (iresnr.ne.irtmp.or.resi(1:3).ne.resit(1:3).or.
     &         ach.ne.tach) then
              irtmp = iresnr
              resit = resi
              tach = ach
              if (resi(1:3).eq.'HOH'.or.resi(1:3).eq.'hoh') then
                  if (ishoh.eq.0) then
                     nhmol = nhmol + 1
                     if (nmulm.lt.mxmmul) nmulm = nmulm + 1
                     call parsfn(resi,3,1)
                     hetz(nhmol+1) = resi(1:3)
                     ishoh = nhmol
                  endif  
              else
                  nhmol = nhmol + 1
                  if (nmulm.lt.mxmmul) nmulm = nmulm + 1
                  call parsfn(resi,3,1)
                  hetz(nhmol+1) = resi(1:3)
              endif
           endif
           if (resi(1:3).eq.'HOH'.or.resi(1:3).eq.'hoh') then
              iresid(iatoms) = -ishoh
           else
              iresid(iatoms) = -nhmol
           endif
      end do
220   continue
c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm
      do ii=1,nhet
         i = namatm + ii
         do j=ioatms+1,namatm + ii - 1
            call connij(idum,i,j,0)
         end do
      end do

c
c make s-s connections
c
      do i=1,ncalf
         if (iamino(i).eq.4) then
            do j=1,i-1
               if (iamino(j).eq.4) then
                  ii = 0
                  jj = 0
                  do k=1,iatoms
                     if (ianz(k).eq.16) then
                        if (iresid(k).eq.i) ii = k
                        if (iresid(k).eq.j) jj = k
                     endif
                  end do
                  if (ii.ne.0.and.jj.ne.0) then
                     call connij(idum,ii,jj,0)
                     if (idum.eq.1) then
                        ityp(ii) = 82
                        ityp(jj) = 82
                        do l=1,iconn(1,ii)
                           ll = iabs(iconn(l+1,ii))
                           if (ianz(ll).eq.6) ityp(ll) = 38
                        end do
                        do l=1,iconn(1,jj)
                           ll = iabs(iconn(l+1,jj))
                           if (ianz(ll).eq.6) ityp(ll) = 38
                        end do
                     endif
                  endif
               endif
            end do
         endif
      end do

      do i=1,ncalf
         if (iamino(i).eq.21) iamino(i) = 10
         if (iamino(i).eq.22) iamino(i) = 14
      end do
      if (islu(1).lt.ianf(1)) nchain = 0

      if (ioadd.eq.1) then
         if (nmulmt.eq.0) nmulmt = 1
         do i=nmulmt,nmulm
            ihasqm(i) = 0
         end do
         do i=nmulmt+4,nhmol+1
            ihet(i) = 1
         end do
      endif

      ihashz = 1

      if (hasalt) call inferr('Alternate location(s) detected',0)
      return

100   istat = 0
      if (dall) then
         iatoms = natorg
         ncalf = noff
         istat = -1
      else
         if (islu(1).lt.ianf(1)) nchain = 0
      endif
      if (hasalt) call inferr('Alternate location(s) detected',0)
      return
      end

      subroutine conpdd(ianz,iconn,iresid,ncalf,iamino)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      common /athlp/ iatoms, mxnat
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension iconn(mxcon+1,*),ianz(*),iresid(*),iamino(*)

      namatm = 0

      do i=1,iatoms
         iconn(1,i) = 0
         if (iresid(i).le.0.and.namatm.eq.0) namatm = i-1
      end do

      if (namatm.eq.0) namatm = iatoms
     

      do i=1,ncalf
         call getpdb(i,ipdb,ihpdb)
         call mkcon(ipdb,iamino(i),i,ihpdb,1,1)
      end do

c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm

      do ii=1,nhet

         i = namatm + ii
         ir1 = iresid(i)

         do j=1,namatm + ii - 1
            ir2 = iresid(j)
            if (.not.(ir1.gt.0.and.ir2.gt.0)) then
               call connij(idum,i,j,1)
            endif
         end do

      end do

c
c make s-s connections
c
      do i=1,ncalf
         if (iamino(i).eq.4) then
            do j=1,i-1
               if (iamino(j).eq.4) then
                  ii = 0
                  jj = 0
                  do k=1,iatoms
                     if (ianz(k).eq.16) then
                        if (iresid(k).eq.i) ii = k
                        if (iresid(k).eq.j) jj = k
                     endif
                  end do
                  if (ii.ne.0.and.jj.ne.0) then
                     call connij(idcon,ii,jj,1)
                     if (idcon.eq.1) then
                        do l=1,iconn(1,ii)
                           ll = iabs(iconn(l+1,ii))
                        end do
                        do l=1,iconn(1,jj)
                           ll = iabs(iconn(l+1,jj))
                        end do
                     endif
                  endif
               endif
            end do
         endif
      end do

      return
      end

      subroutine convpdd(ianz,iconn,iresid,ncalf,iamino)
c same as conpdb, only before conversion to angstrom
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      common /athlp/ iatoms, mxnat
      common /cllab/ iclon,iclpnt(4)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension iconn(mxcon+1,*),ianz(*),iresid(*),iamino(*)

      namatm = 0
      do i=1,iatoms
         iconn(1,i) = 0
         if (iresid(i).le.0.and.namatm.eq.0) namatm = i-1
      end do
      if (namatm.eq.0) namatm = iatoms

      do i=1,ncalf
         call getpdb(i,ipdb,ihpdb)
         call mkcon(ipdb,iamino(i),i,ihpdb,1,1)
      end do

c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm
      do ii=1,nhet
         i = namatm + ii
         ir1 = iresid(i)
         do j=1,namatm + ii - 1
            ir2 = iresid(j)
            if (ir1.eq.ir2.and..not.(ir1.gt.0.and.ir2.gt.0)) then
               call connij(idum,i,j,0)
            endif
         end do
      end do

c
c make s-s connections
c
      do i=1,ncalf
         if (iamino(i).eq.4) then
            do j=1,i-1
               if (iamino(j).eq.4) then
                  ii = 0
                  jj = 0
                  do k=1,iatoms
                     if (ianz(k).eq.16) then
                        if (iresid(k).eq.i) ii = k
                        if (iresid(k).eq.j) jj = k
                     endif
                  end do
                  if (ii.ne.0.and.jj.ne.0) then
                     call connij(idcon,ii,jj,0)
                     if (idcon.eq.1) then
                        do l=1,iconn(1,ii)
                           ll = iabs(iconn(l+1,ii))
                        end do
                        do l=1,iconn(1,jj)
                           ll = iabs(iconn(l+1,jj))
                        end do
                     endif
                  endif
               endif
            end do
         endif
      end do

      return
      end

      subroutine consld(iconn,iresid)
c same as conpdb, only before conversion to angstrom, non residue
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension iconn(mxcon+1,*),iresid(*)

      namatm = 0
      do i=1,iatoms
         if (iresid(i).lt.-3) then
            iconn(1,i) = 0
         endif
         if (iresid(i).lt.-3.and.namatm.eq.0) namatm = i-1
      end do
      if (namatm.eq.0) namatm = iatoms

c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm
      do ii=1,nhet
         i = namatm + ii
         ir1 = iresid(i)
         do j=1,namatm + ii - 1
            ir2 = iresid(j)
            if (ir1.eq.ir2) then
               call connij(idcon,i,j,0)
            endif
         end do
      end do

      return
      end
c
      subroutine connid(idcon,i,j,idoconv,iconn,ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      logical coni,conj
      dimension ctemp(3),iconn(mxcon+1,*),ianz(*),coo(3,*)

      toang = 0.52917706d0
      toang2 = toang*toang

      idcon = 0
      coni = .true.
      conj = .true.

      k = iconn(1,i)
      m = iconn(1,j)

      do l=1,k
         if (iconn(1+l,i).eq.j) coni = .false.
      end do

      do l=1,m
         if (iconn(1+l,j).eq.i) conj = .false.
      end do

      if (.not.coni.and..not.conj) return

      dmaxsq = vdwr(ianz(i)) + vdwr(ianz(j))
      dmaxsq = dmaxsq * dmaxsq

      ia = ianz(i)
      ib = ianz(j)
      
      do l=1,3
         ctemp(l) = coo(l,i) - coo(l,j)
      end do

      dijsq = ctemp(1)*ctemp(1) + ctemp(2)*ctemp(2) 
     &             + ctemp(3)*ctemp(3)

      if (idoconv.eq.1) dmaxsq = dmaxsq / toang2

      if (dijsq.lt.dmaxsq) then
          idocon = 1
          k = k + 1
          m = m + 1
          if (k.le.mxcon.and.coni) then
             iconn(1,i) = k
             iconn(k+1,i) = j
          else
             write(iun3,*)'more than mxconn connections found'
          endif
          if (m.le.mxcon.and.conj) then
             iconn(1,j) = m
             iconn(m+1,j) = i
          else
             write(iun3,*)'more than mxconn connections found'
          endif
      endif

      return
      end

      subroutine mkcon(ipdb,jres,icres,ihpdb,ihashy,idoconv)
      implicit double precision (a-h,o-z)
      dimension ipdb(*), ihpdb(*)

      if (jres.gt.23) then
         call mknbck(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      else
         call mkback(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      endif
          

      goto (10,10,30,40,50,60,70,80,90,100,110,120,130,140,150,
     &      160,170,180,190,200,100,140,150,210,220,230,240,250,
     &      210,220,220,230,230,230,230,230,230,230,250,250,250,
     &      250) jres
      return
c
c glycine, alanine
c
10    goto 1000
c
c serine
c
30    call conat(ipdb,5,31,0)
      if (ihashy.eq.1) call conath(ipdb,ihpdb,31,10)
      goto 1000
c
c cysteine
c
40    call conat(ipdb,5,37,0)
c this H is dubious
      if (ihashy.eq.1) call conath(ipdb,ihpdb,37,10)
      goto 1000
c
c threonine
c
50    call conat(ipdb,5,32,0)
      call conat(ipdb,5,8,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,32,10)
          call conath(ipdb,ihpdb,32,13)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
      endif
      goto 1000
c
c isoleucine
c
60    call conat(ipdb,5,7,0)
      call conat(ipdb,5,8,0)
      call conat(ipdb,7,10,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,7,13)
          call conath(ipdb,ihpdb,7,14)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
          call conath(ipdb,ihpdb,10,22)
          call conath(ipdb,ihpdb,10,23)
          call conath(ipdb,ihpdb,10,24)
      endif
      goto 1000
c
c valine
c
70    call conat(ipdb,5,7,0)
      call conat(ipdb,5,8,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,7,13)
          call conath(ipdb,ihpdb,7,14)
          call conath(ipdb,ihpdb,7,15)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
      endif
      goto 1000
c
c methionine
c
80    call conat(ipdb,5,6,0)
      call conat(ipdb,6,36,0)
      call conat(ipdb,36,12,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,6,10)
          call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
          call conath(ipdb,ihpdb,6,13)
          call conath(ipdb,ihpdb,6,16)
          call conath(ipdb,ihpdb,12,28)
          call conath(ipdb,ihpdb,12,29)
          call conath(ipdb,ihpdb,12,30)
          call conath(ipdb,ihpdb,12,31)
          call conath(ipdb,ihpdb,12,34)
          call conath(ipdb,ihpdb,12,37)
      endif
      goto 1000
c
c aspartic acid
c
90    call conat(ipdb,5,6,0)
      call conat(ipdb,6,29,0)
      call conat(ipdb,6,30,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,29,22)
         call conath(ipdb,ihpdb,30,25)
      endif
      goto 1000
c
c asparagine
c
100   call conat(ipdb,5,6,0)
      call conat(ipdb,6,29,0)
      call conat(ipdb,6,21,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,21,25)
         call conath(ipdb,ihpdb,21,26)
      endif
      goto 1000
c
c leucine
c
110   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,10,23)
         call conath(ipdb,ihpdb,10,24)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,11,26)
         call conath(ipdb,ihpdb,11,27)
      endif
      goto 1000
c
c lysine
c
120   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,12,0)
      call conat(ipdb,12,27,0)
      if (ihashy.eq.1) then

         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)

         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
c        try HD1 and HD2 too
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)

         call conath(ipdb,ihpdb,12,28)
         call conath(ipdb,ihpdb,12,29)
c        try HE1 and HE2 , HE3 too
         call conath(ipdb,ihpdb,12,31)
         call conath(ipdb,ihpdb,12,34)
         call conath(ipdb,ihpdb,12,37)

         call conath(ipdb,ihpdb,27,40)
         call conath(ipdb,ihpdb,27,41)
         call conath(ipdb,ihpdb,27,42)
         call conath(ipdb,ihpdb,27,43)
         call conath(ipdb,ihpdb,27,46)
         call conath(ipdb,ihpdb,27,49)
      endif
      goto 1000
c
c glutamic acid
c
130   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,34,0)
      call conat(ipdb,9,35,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,34,31)
         call conath(ipdb,ihpdb,35,34)
      endif
      goto 1000
c
c glutamine
c
140   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,34,0)
      call conat(ipdb,9,24,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,24,34)
         call conath(ipdb,ihpdb,24,35)
      endif
      goto 1000
c
c proline
c 
150   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
c     bit tricky here
      call conat(ipdb,9,1,1)
      if (ipdb(28).ne.0) call conat(ipdb,6,28,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
c        try HD1 and HD2 too
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)
      endif
      goto 1000
c
c arginine
c
160   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,22,0)
      call conat(ipdb,22,17,0)
      call conat(ipdb,17,25,0)
      call conat(ipdb,17,26,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)
         call conath(ipdb,ihpdb,22,28)
         call conath(ipdb,ihpdb,25,55)
         call conath(ipdb,ihpdb,25,56)
         call conath(ipdb,ihpdb,26,58)
         call conath(ipdb,ihpdb,26,59)
      endif
      goto 1000
c
c histidine
c
170   call conat(ipdb,5,6,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,6,20,0)
      call conat(ipdb,11,24,0)
      call conat(ipdb,20,13,0)
c tricky
      call conat(ipdb,13,24,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,20,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,24,34)
      endif
      goto 1000
c
c phenylalanine
c
180   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,13,0)
      call conat(ipdb,11,14,0)
      call conat(ipdb,13,17,0)
      call conat(ipdb,14,17,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,14,34)
         call conath(ipdb,ihpdb,17,40)
      endif
      goto 1000
c
c tyrosine
c
190   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,13,0)
      call conat(ipdb,11,14,0)
      call conat(ipdb,13,17,0)
      call conat(ipdb,14,17,1)
      call conat(ipdb,17,33,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,14,34)
         call conath(ipdb,ihpdb,33,52)
      endif
      goto 1000
c
c tryptophan
c
200   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,23,0)
      call conat(ipdb,23,14,0)
      call conat(ipdb,14,11,1)
      call conat(ipdb,11,15,0)
      call conat(ipdb,14,18,0)
      call conat(ipdb,15,19,0)
      call conat(ipdb,18,16,0)
      call conat(ipdb,16,19,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,23,31)
         call conath(ipdb,ihpdb,15,37)
         call conath(ipdb,ihpdb,18,46)
         call conath(ipdb,ihpdb,19,49)
         call conath(ipdb,ihpdb,16,58)
      endif
      goto 1000
c
c adenosine
c
210   call conat(ipdb,54,66,0)
      call conat(ipdb,66,59,0)
      call conat(ipdb,66,56,0)
      call conat(ipdb,59,65,0)
      call conat(ipdb,65,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,57,56,0)
      call conat(ipdb,58,64,0)
      call conat(ipdb,58,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,56,62,1)
      call conat(ipdb,56,66,1)
      if (jres.eq.29) then
          call conat(ipdb,60,71,0)
          call conat(ipdb,60,79,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,55,82)
         call conath(ipdb,ihpdb,59,112)
         call conath(ipdb,ihpdb,64,106)
         call flagh(ihpdb,106)
         call conath(ipdb,ihpdb,64,109)
         call flagh(ihpdb,109)
         call conath(ipdb,ihpdb,64,136)
         call flagh(ihpdb,136)
         call conath(ipdb,ihpdb,64,137)
         call flagh(ihpdb,137)
         call conath(ipdb,ihpdb,64,103)
         call flagh(ihpdb,103)
         call conath(ipdb,ihpdb,64,104)
         call flagh(ihpdb,104)
         if (jres.eq.29) then
             call conath(ipdb,ihpdb,79,148)
             call conath(ipdb,ihpdb,79,149)
             call conath(ipdb,ihpdb,79,150)
             call conath(ipdb,ihpdb,58,103)
         endif
      endif
      goto 1000
c
c cytidine
c
220   call conat(ipdb,54,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,63,0)
      call conat(ipdb,56,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      if (jres.eq.30) then
         call conat(ipdb,57,72,0)
         call conat(ipdb,57,83,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,63,94)
         call flagh(ihpdb,94)
         call conath(ipdb,ihpdb,63,97)
         call flagh(ihpdb,97)
         call conath(ipdb,ihpdb,63,130)
         call flagh(ihpdb,130)
         call conath(ipdb,ihpdb,63,131)
         call flagh(ihpdb,131)
         call conath(ipdb,ihpdb,58,103)
         if (jres.eq.30) then
             call conath(ipdb,ihpdb,83,160)
             call conath(ipdb,ihpdb,83,161)
             call conath(ipdb,ihpdb,83,162)
         else
             call conath(ipdb,ihpdb,57,100)
         endif
      endif
      goto 1000
c
c guanosine
c
230   call conat(ipdb,54,66,0)
      call conat(ipdb,66,59,0)
      call conat(ipdb,66,56,0)
      call conat(ipdb,59,65,0)
      call conat(ipdb,65,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,57,56,0)
      call conat(ipdb,58,69,0)
      call conat(ipdb,58,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,62,0)
      if (jres.ne.38) call conat(ipdb,55,61,0)
      call conat(ipdb,56,62,1)
      call conat(ipdb,56,66,1)
      if (jres.eq.32) then
          call conat(ipdb,60,71,0)
          call conat(ipdb,60,79,0)
      endif
      if (jres.eq.33.or.jres.eq.34) then
          call conat(ipdb,61,73,0)
          call conat(ipdb,61,80,0)
      endif
      if (jres.eq.34) then
          call conat(ipdb,61,74,0)
          call conat(ipdb,61,79,0)
      endif
      if (jres.eq.35) then
          call conat(ipdb,65,75,0)
          call conat(ipdb,65,85,0)
      endif
      if (jres.eq.37) then
          call conat(ipdb,61,90,0)
          call conat(ipdb,62,88,0)
          call conat(ipdb,90,89,0)
          call conat(ipdb,90,91,0)
          call conat(ipdb,91,60,1)
          call conat(ipdb,91,92,0)
          call conat(ipdb,92,93,0)
          call conat(ipdb,93,94,0)
          call conat(ipdb,94,95,0)
          call conat(ipdb,95,96,0)
          call conat(ipdb,95,97,0)
          call conat(ipdb,97,98,0)
          call conat(ipdb,94,99,0)
          call conat(ipdb,99,100,0)
          call conat(ipdb,100,101,0)
          call conat(ipdb,100,102,0)
          call conat(ipdb,102,103,0)
      endif

      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,59,112)
         if (jres.ne.32.and.jres.ne.37) then
            call conath(ipdb,ihpdb,60,79)
            call flagh(ihpdb,79)
            call conath(ipdb,ihpdb,60,121)
            call flagh(ihpdb,121)
         endif
         if (jres.ne.33.and.jres.ne.34.and.jres.ne.37
     &       .and.jres.ne.38) then
            call conath(ipdb,ihpdb,61,85)
            call flagh(ihpdb,85)
            call conath(ipdb,ihpdb,61,125)
            call flagh(ihpdb,125)
            call conath(ipdb,ihpdb,61,82)
            call flagh(ihpdb,82)
            call conath(ipdb,ihpdb,61,83)
            call flagh(ihpdb,83)
         endif
         if (jres.ne.34.and.jres.ne.37.and.jres.ne.38) then
            call conath(ipdb,ihpdb,61,88)
            call flagh(ihpdb,88)
            call conath(ipdb,ihpdb,61,124)
            call flagh(ihpdb,124)
         endif
         if (jres.eq.33.or.jres.eq.34) then
            call conath(ipdb,ihpdb,80,151)
            call conath(ipdb,ihpdb,80,152)
            call conath(ipdb,ihpdb,80,153)
         endif
         if (jres.eq.31.or.jres.eq.34) then
            call conath(ipdb,ihpdb,79,148)
            call conath(ipdb,ihpdb,79,149)
            call conath(ipdb,ihpdb,79,150)
         endif
         if (jres.eq.35) then
            call conath(ipdb,ihpdb,85,166)
            call conath(ipdb,ihpdb,85,167)
            call conath(ipdb,ihpdb,85,168)
            call conath(ipdb,ihpdb,59,113)
         endif
         if (jres.eq.37) then
            call conath(ipdb,ihpdb,88,91)
            call conath(ipdb,ihpdb,88,92)
            call conath(ipdb,ihpdb,88,93)
            call conath(ipdb,ihpdb,89,175)
            call conath(ipdb,ihpdb,89,176)
            call conath(ipdb,ihpdb,89,177)
            call conath(ipdb,ihpdb,92,178)
            call conath(ipdb,ihpdb,92,179)
            call conath(ipdb,ihpdb,93,181)
            call conath(ipdb,ihpdb,93,182)
            call conath(ipdb,ihpdb,94,184)
            call conath(ipdb,ihpdb,98,187)
            call conath(ipdb,ihpdb,98,188)
            call conath(ipdb,ihpdb,98,189)
            call conath(ipdb,ihpdb,99,124)
            call conath(ipdb,ihpdb,103,190)
            call conath(ipdb,ihpdb,103,191)
            call conath(ipdb,ihpdb,103,192)
         endif
      endif
      goto 1000
c
c thymidine
c
240   call conat(ipdb,54,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,68,0)
      call conat(ipdb,56,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      call conat(ipdb,57,70,1)
      call conat(ipdb,57,83,1)
      call conat(ipdb,57,75,1)
      call conat(ipdb,57,85,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,58,103)
         call conath(ipdb,ihpdb,62,91)
         call flagh(ihpdb,91)
         call conath(ipdb,ihpdb,62,127)
         call flagh(ihpdb,127)
         call conath(ipdb,ihpdb,83,160)
         call conath(ipdb,ihpdb,83,161)
         call conath(ipdb,ihpdb,83,162)
         call conath(ipdb,ihpdb,70,160)
         call conath(ipdb,ihpdb,70,161)
         call conath(ipdb,ihpdb,70,162)
         call conath(ipdb,ihpdb,75,166)
         call conath(ipdb,ihpdb,75,167)
         call conath(ipdb,ihpdb,75,168)
         call conath(ipdb,ihpdb,85,166)
         call conath(ipdb,ihpdb,85,167)
         call conath(ipdb,ihpdb,85,168)
      endif
      goto 1000
c
c uridine
c
250   if (jres.eq.42) then
         call conat(ipdb,54,57,0)
      else
         call conat(ipdb,54,60,0)
      endif
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,68,0)
      call conat(ipdb,56,57,1)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      if (jres.eq.41) then
         call conat(ipdb,57,72,0)
         call conat(ipdb,57,83,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,58,103)
         if (jres.ne.41.and.jres.ne.42) call conath(ipdb,ihpdb,57,100)
         if (jres.eq.40) then
            call conath(ipdb,ihpdb,58,104)
            call conath(ipdb,ihpdb,57,101)
         endif
         call conath(ipdb,ihpdb,62,91)
         call flagh(ihpdb,91)
         call conath(ipdb,ihpdb,62,127)
         call flagh(ihpdb,127)
         if (jres.eq.41) then
            call conath(ipdb,ihpdb,83,160)
            call conath(ipdb,ihpdb,83,161)
            call conath(ipdb,ihpdb,83,162)
         endif
         if (jres.eq.42) call conath(ipdb,ihpdb,60,121)
      endif

1000  continue

      return
      end

      subroutine pdbtyd(ipdb,ihpdb,jres,ihashy,ipdbt)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      integer*2 ipdbt
      dimension ipdb(mxsym), ihpdb(mxhsym*3), ipdbt(*)

      do i=1,mxsym
         it = i
         if (i.eq.70) it = 83
         if (i.eq.71) it = 79
         if (i.eq.72) it = 83
         if (i.eq.73) it = 80
         if (i.eq.74) it = 79
         if (i.eq.75) it = 85
         if (jres.gt.23.and.i.eq.38) it = 76
         if (ipdb(i).gt.0) ipdbt(ipdb(i)) = it
      end do

      if (ihashy.eq.1) then
         do i=1,mxhsym*3
            it = i
            if (i.eq.85) it = 124
            if (i.eq.88) it = 125
            if (i.eq.94) it = 130
            if (i.eq.97) it = 131
            if (i.eq.106) it = 136
            if (i.eq.109) it = 137
            if (ihpdb(i).gt.0) ipdbt(ihpdb(i)) = it
         end do
      endif

      return
      end

      subroutine typeid(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxrss=20)
      parameter (mxatt=10)
      parameter (mxath=8)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      logical nterm
      integer*2 ityp
      common /types/ iff
      common /chmtyp/ ncc(mxrss),icc(2,mxatt,mxrss),
     &                nhh(mxrss),ihh(2,mxath,mxrss)
      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*)

      iff = 2

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20)

c     Backbone, no N-Term, C-Term yet
c               (Pro,Gly N-Term) CYS, sulfur bridged

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
      end do

      if (jres.le.0.or.jres.gt.mxrss) return

      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      call settyp(ityp,ipdb(1),63)
      call settyp(ityp,ipdb(2),23)
      call settyp(ityp,ipdb(3),20)
      call settyp(ityp,ipdb(4),74)

      if (ipdb(38).ne.0) then
          ityp(ipdb(38)) = 79
          call settyp(ityp,ipdb(4),79)
          call settyp(ityp,ipdb(3),22)
      endif

      do i=1,ncc(jres)
         call settyp(ityp,ipdb(icc(1,i,jres)),icc(2,i,jres))
      end do

      if (jres.eq.4) then
         do i=1,iconn(1,ipdb(37))
            if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &          call settyp(ityp,ipdb(37),82)
         end do
      endif

      if (jres.eq.17) then
         if (ihis.eq.2) then
             call settyp(ityp,ipdb(6),43)
             call settyp(ityp,ipdb(11),44)
             call settyp(ityp,ipdb(13),46)
             call settyp(ityp,ipdb(20),69)
             call settyp(ityp,ipdb(24),68)
         endif
         if (ihis.eq.3) then
             call settyp(ityp,ipdb(6),44)
             call settyp(ityp,ipdb(11),43)
             call settyp(ityp,ipdb(13),46)
             call settyp(ityp,ipdb(20),68)
             call settyp(ityp,ipdb(24),69)
         endif
      endif
      
      if (ihashy.eq.1) then

         n = 0
         do i=1,3
            if (ihpdb(i).ne.0) n = n + 1
         end do
         nterm = .false.
         if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.

         if (nterm) then
c H
            nt = 6
            if (jres.eq.15) nt = 7
            do i=1,n
               call settyp(ityp,ihpdb(i),nt)
            end do

c N
            nt = 65
            if (jres.eq.15.and.n.eq.2) nt = 67
            call settyp(ityp,ipdb(1),nt)

c CA
            nt = 23
            if (jres.eq.1) nt = 29
            if (jres.eq.15) nt = 33
            call settyp(ityp,ipdb(2),nt)

c CD
            if (jres.eq.15) call settyp(ityp,ipdb(9),34)

         else
            call settyp(ityp,ihpdb(1),3)
         endif
c HA
         nt = 4
         if (nterm.and.jres.ne.1) nt = 5
         call settyp(ityp,ihpdb(4),nt)
         call settyp(ityp,ihpdb(5),nt)

c HB, HG
         do i=1,3
            call settyp(ityp,ihpdb(6+i),1)
            call settyp(ityp,ihpdb(9+i),1)
         end do

         do i=1,nhh(jres)
            call settyp(ityp,ihpdb(ihh(1,i,jres)),ihh(2,i,jres))
         end do

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

         if (jres.eq.12) then
            call settyp(ityp,ihpdb(43),6)
            call settyp(ityp,ihpdb(46),6)
            call settyp(ityp,ihpdb(49),6)
         endif

         if (jres.eq.17) then
            if (ihis.eq.2) then
                call settyp(ityp,ihpdb(22),11)
                call settyp(ityp,ihpdb(25),14)
                call settyp(ityp,ihpdb(31),12)
            endif
            if (ihis.eq.3) then
                call settyp(ityp,ihpdb(25),15)
                call settyp(ityp,ihpdb(31),12)
                call settyp(ityp,ihpdb(34),11)
            endif
         endif
      endif

      return
      end

      subroutine chkrna(ncalf,iamino)
      implicit double precision (a-h,o-z)
      dimension iamino(*)

      modres = 0
      do i=1,ncalf
         if (iamino(i).eq.32) modres = 1
         if (iamino(i).eq.38) modres = 1
         if (iamino(i).eq.39) modres = 1
      end do

      if (modres.eq.1) then
         print*,' '
         print*,'The following Modified nucleosides '
         print*,'are not supported by Ambfor !:'
         print*,' '
         print*,'(1MG,I,+U)'
         print*,' '
      endif

      return
      end

      subroutine typamd(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxres=42)
      parameter (mxrss=20)
      parameter (mxrsa=23)
      parameter (mxata=9)
      parameter (mxatha=9)
      parameter (mxrso=24)
      parameter (mxato=10)
      parameter (mxatho=11)
      parameter (mxrsn=19)
      parameter (mxnucl=39)
      parameter (mxhnuc=27)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      logical nterm,cterm
      integer*2 ityp
      common /types/ iff
      common /athlp/ iatoms, mxnat
      integer amboff,ntca,ctca
      common /ambtyp/ amboff(mxrss*3),ntca(mxrss),ctca(mxrss),
     &                ncca(mxrsa),icca(2,mxata,mxrsa),
     &                nhha(mxrsa),ihha(2,mxatha,mxrsa),
     &                ncco(mxrso),icco(2,mxato,mxrso),
     &                nhho(mxrso),ihho(2,mxatho,mxrso),
     &                nnuc(mxrsn),nhnuc(mxrsn),irna(mxres-23),
     &                inuc(2,mxnucl,mxrsn),ihnuc(2,mxhnuc,mxrsn)
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      logical ismet

      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*),
     &          icn(4)

      iff = 3

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20) (HIP,HID,HIE and sulfer bridge covered)
c                (ORN, mALA and pyroglut not covered)


      if (jres.le.0.or.jres.gt.mxres) return
      if (jres.gt.mxrss) goto 100

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
         call setchg(ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
         call setchg(ihpdb(i),0)
      end do

      nterm = .false.
      n = 0
      do i=1,3
         if (ihpdb(i).ne.0) n = n + 1
      end do
      if (n.eq.0) then
         if (ihpdb(79).ne.0) n = n + 1
         if (ihpdb(82).ne.0) n = n + 1
         if (ihpdb(91).ne.0) n = n + 1
      endif
      if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.
      cterm = .false.
      if (ipdb(38).ne.0) cterm = .true.

      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      if (jres.eq.4) then
c iss = 0 (cysteine -SH), iss = 1 (cystine -SS-)
         iss = 0
         if (ipdb(37).ne.0) then
            do i=1,iconn(1,ipdb(37))
               if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &             iss = 1
            end do
         endif
      endif

      if (nterm) then
          ioff = amboff(jres+20)
      else if(cterm) then
          ioff = amboff(jres+40)
      else
        ioff = amboff(jres)
      endif

      if (jres.eq.17) then
         if (ihis.eq.2) ioff = 178
         if (ihis.eq.3) ioff = 194
      endif

      if (jres.eq.4.and.iss.eq.1) ioff = 87
      if (jres.eq.9.and.(ihpdb(22).ne.0.or.ihpdb(25).ne.0)) ioff = 660
      if (jres.eq.13.and.(ihpdb(31).ne.0.or.ihpdb(34).ne.0)) ioff = 672

      ihtot = 0
      do i=0,2
         if (ihpdb(40+i).ne.0) ihtot = ihtot + 1
      end do

      if (jres.eq.12.and.ihtot.eq.2) ioff = 686

      if (nterm) then
         if (jres.eq.17 .and. ihis.eq.2) ioff = 436
         if (jres.eq.17 .and. ihis.eq.3) ioff = 442
         if (jres.eq.4 .and. iss.eq.1) ioff = 398
      endif
      if (cterm) then
         if (jres.eq.17 .and. ihis.eq.2) ioff = 584
         if (jres.eq.17 .and. ihis.eq.3) ioff = 590
         if (jres.eq.4 .and. iss.eq.1) ioff = 549
      endif

      call settyp(ityp,ipdb(1),ioff)
      call settyp(ityp,ipdb(2),ioff+1)
      call settyp(ityp,ipdb(3),ioff+2)

      if (jres.eq.15.and..not.nterm) then
         call settyp(ityp,ipdb(4),ioff+3)
         if (cterm) call settyp(ityp,ipdb(38),ioff+3)
      else
         call settyp(ityp,ipdb(4),ioff+4)
         if (cterm) call settyp(ityp,ipdb(38),ioff+4)
      endif

      call settyp(ityp,ihpdb(1),ioff+3)
      call settyp(ityp,ihpdb(2),ioff+3)
      call settyp(ityp,ihpdb(3),ioff+3)
      call settyp(ityp,ihpdb(79),ioff+3)
      call settyp(ityp,ihpdb(82),ioff+3)
      call settyp(ityp,ihpdb(91),ioff+3)

      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ihpdb(4),409)
         else
            call settyp(ityp,ihpdb(4),ioff+4)
            call settyp(ityp,ihpdb(5),ioff+4)
         endif
      else
         call settyp(ityp,ihpdb(4),ioff+5)
         call settyp(ityp,ihpdb(5),ioff+5)
      endif

      if (nterm.or.cterm) then
         ioff = amboff(jres)
         if (jres.eq.17) then
            if (ihis.eq.2) ioff = 178
            if (ihis.eq.3) ioff = 194
         endif
         if (jres.eq.4.and.iss.eq.1) ioff = 87
      endif

      if (jres.eq.15) then
         call settyp(ityp,ipdb(5),ioff+5)
         call settyp(ityp,ihpdb(7),ioff+6)
         call settyp(ityp,ihpdb(8),ioff+6)
         call settyp(ityp,ihpdb(9),ioff+6)
      else
         call settyp(ityp,ipdb(5),ioff+6)
         call settyp(ityp,ihpdb(7),ioff+7)
         call settyp(ityp,ihpdb(8),ioff+7)
         call settyp(ityp,ihpdb(9),ioff+7)
      endif

      jtmp = jres
      if (jres.eq.17) then
         if (ihis.eq.2) jtmp = 22
         if (ihis.eq.3) jtmp = 23
      endif
      if (jres.eq.4.and.iss.eq.1) jtmp = 21
    
      do i=1,ncca(jtmp)
         call settyp(ityp,ipdb(icca(1,i,jtmp)),icca(2,i,jtmp))
      end do

      do i=1,nhha(jtmp)
         call settyp(ityp,ihpdb(ihha(1,i,jtmp)),ihha(2,i,jtmp))
      end do

      if (jres.eq.8) then
         call settyp(ityp,ihpdb(13),267)
         call settyp(ityp,ihpdb(16),267)
         call settyp(ityp,ihpdb(31),270)
         call settyp(ityp,ihpdb(34),270)
         call settyp(ityp,ihpdb(37),270)
      endif
      if (jres.eq.13) then
         call settyp(ityp,ihpdb(13),241)
         call settyp(ityp,ihpdb(16),241)
      endif
      if (jres.eq.14) then
         call settyp(ityp,ihpdb(13),253)
         call settyp(ityp,ihpdb(16),253)
      endif
      if (jres.eq.16) then
         call settyp(ityp,ihpdb(13),296)
         call settyp(ityp,ihpdb(16),296)
         call settyp(ityp,ihpdb(22),298)
         call settyp(ityp,ihpdb(25),298)
      endif

      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ipdb(9),410)
            call settyp(ityp,ihpdb(19),411)
            call settyp(ityp,ihpdb(20),411)
         endif
CNF  Nothing different between PRO and other residues for the C-Term case
CNF         if (cterm) then
CNF            call settyp(ityp,ipdb(9),412)
CNF            call settyp(ityp,ihpdb(19),413)
CNF            call settyp(ityp,ihpdb(20),413)
CNF         endif
      endif

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

      if (jres.eq.12) then
         call settyp(ityp,ihpdb(13),280)
         call settyp(ityp,ihpdb(16),280)
         call settyp(ityp,ihpdb(22),282)
         call settyp(ityp,ihpdb(25),282)
         call settyp(ityp,ihpdb(34),284)
         call settyp(ityp,ihpdb(37),284)
         call settyp(ityp,ihpdb(43),286)
         call settyp(ityp,ihpdb(46),286)
         call settyp(ityp,ihpdb(49),286)
      endif

c check asph, RECTIFICATION: asph, gluh neutral lys, neg cys
c are not in the tinker amber set.
c we could add our own, but it has not been done yet
c Original AMBER itself does not work with so many atom types.
c Tinker creates the extra atom types to incrporate the charges
c in there as well. Charges deviate slightly between
c cterm,nterm and regular residues
c see ~schaft/compile/linux/molden4.6/
c     forf/amber9.ffparms/dat/leap/prep/all_amino94.in
c for the charges
c we should add our own extra types for these residues

      if (jres.eq.9) then
         if (ihpdb(22).ne.0) then
            call settyp(ityp,ipdb(6),668)
            call settyp(ityp,ipdb(29),670)
            call settyp(ityp,ipdb(30),669)
            call settyp(ityp,ihpdb(22),671)
         endif
         if (ihpdb(25).ne.0) then
            call settyp(ityp,ipdb(6),668)
            call settyp(ityp,ipdb(29),669)
            call settyp(ityp,ipdb(30),670)
            call settyp(ityp,ihpdb(25),671)
         endif
      endif

      if (jres.eq.13) then
         if (ihpdb(31).ne.0) then
            call settyp(ityp,ipdb(6),680)
            call settyp(ityp,ipdb(9),682)
            call settyp(ityp,ipdb(34),684)
            call settyp(ityp,ipdb(35),683)
            call settyp(ityp,ihpdb(10),681)
            call settyp(ityp,ihpdb(11),681)
            call settyp(ityp,ihpdb(31),685)
         endif
         if (ihpdb(34).ne.0) then
            call settyp(ityp,ipdb(6),680)
            call settyp(ityp,ipdb(9),682)
            call settyp(ityp,ipdb(34),683)
            call settyp(ityp,ipdb(35),684)
            call settyp(ityp,ihpdb(10),681)
            call settyp(ityp,ihpdb(11),681)
            call settyp(ityp,ihpdb(34),685)
         endif
      endif

      if (jres.eq.12.and.ihtot.eq.2) then
            call settyp(ityp,ipdb(6),694)
            call settyp(ityp,ipdb(9),696)
            call settyp(ityp,ipdb(12),698)
            call settyp(ityp,ipdb(27),700)
            call settyp(ityp,ihpdb(10),695)
            call settyp(ityp,ihpdb(11),695)
            call settyp(ityp,ihpdb(19),697)
            call settyp(ityp,ihpdb(20),697)
            call settyp(ityp,ihpdb(28),699)
            call settyp(ityp,ihpdb(29),699)
            call settyp(ityp,ihpdb(40),701)
            call settyp(ityp,ihpdb(41),701)
            call settyp(ityp,ihpdb(42),701)
            call settyp(ityp,ihpdb(43),701)
            call settyp(ityp,ihpdb(46),701)
            call settyp(ityp,ihpdb(49),701)
      endif

      do i=1,mxsym
         call setchg(ipdb(i),1)
      end do
      do i=1,mxhsym*3
         call setchg(ihpdb(i),1)
      end do

      if (jres.eq.4) then

c ic = 0 (negative cysteine), apply different charges

         if (ipdb(37).ne.0) then
            ic = 0
            do i=1,iconn(1,ipdb(37))
               ii = iconn(1+i,ipdb(37))
               if (ii.gt.0.and.ii.ne.ipdb(5)) then
                   if (.not.ismet(ianz(ii))) ic = ic + 1
               endif
            end do

            if (ic.eq.0) then

               do i=1,mxsym
                  if (ipdb(i).ne.0) then
                     it = ityp(ipdb(i)) 
                     if (it.ge.77.and.it.le.85) then
                        it = 76 - it
                        call setchg(ipdb(i),it)
                     endif
                  endif
               end do

               do i=1,mxhsym*3
                  if (ihpdb(i).ne.0) then
                     it = ityp(ihpdb(i)) 
                     if (it.ge.77.and.it.le.85) then
                        it = 76 - it
                        call setchg(ihpdb(i),it)
                     endif
                  endif
               end do

            endif
         endif
      endif

      return

100   continue

c     NUCLEOTIDES

      isrna = 1
      jtmp = irna(jres - 23)

      if (ipdb(53).eq.0.and.jres.ne.27) then
         isrna = 0
         jtmp = jtmp + 4
      endif

      do i=1,nnuc(jtmp)
         call settyp(ityp,ipdb(inuc(1,i,jtmp)),inuc(2,i,jtmp))
      end do

      do i=1,nhnuc(jtmp)
         call settyp(ityp,ihpdb(ihnuc(1,i,jtmp)),ihnuc(2,i,jtmp))
      end do

      if (ihpdb(115).ne.0) then
c        3'-Hydroxyl
         if (isrna.eq.1) then
            call settyp(ityp,ipdb(51),1237)
            call settyp(ityp,ihpdb(115),1238)
         else
            call settyp(ityp,ipdb(51),1249)
            call settyp(ityp,ihpdb(115),1250)
         endif
      endif

      if (ihpdb(118).ne.0) then
c        5'-Hydroxyl
         if (isrna.eq.1) then
            call settyp(ityp,ipdb(46),1232)
            call settyp(ityp,ihpdb(118),1233)
         else
            call settyp(ityp,ipdb(46),1244)
            call settyp(ityp,ihpdb(118),1245)
         endif
      endif

c     check P connected to O3* (ipdb(51)), if nconn O = 4 => 3'-Phosphate

      call chkpo4(ipdb(51),isrna,1239,1240,1241,1251,1252,1253,
     &                  ianz,iconn,ityp)

c     check P connected to O5* (ipdb(46)), if nconn O = 4 => 5'-Phosphate

      call chkpo4(ipdb(46),isrna,1234,1235,1236,1246,1247,1248,
     &                  ianz,iconn,ityp)

      do i=1,mxsym
         call setchg(ipdb(i),1)
      end do

      do i=1,mxhsym*3
         call setchg(ihpdb(i),1)
      end do

      return
      end

      subroutine chkpo4(io35,isrna,ir1,ir2,ir3,id1,id2,id3,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      integer*2 ityp
      dimension icn(3),ianz(*),iconn(mxcon+1,*),ityp(*)

      ip = 0
      if (io35.eq.0) return

      do i=1,iconn(1,io35)
         j = iconn(1+i,io35)
         if (j.gt.0) then
            if (ianz(j).eq.15) ip = j
         endif
      end do

      if (ip.gt.0) then
         no = 0
         do i=1,iconn(1,ip)
            j = iconn(1+i,ip)

            if (j.gt.0) then
               if (ianz(j).eq.8.and.j.ne.io35) then
                  ido = 1

                  do k=1,iconn(1,j)
                     l = iconn(1+k,j)
                     if (l.gt.0) then
                        if (l.gt.1.and.l.ne.ip) ido = 0
                     endif
                  end do

                  if (ido.eq.1) then
                     no = no + 1
                     icn(no) = j
                  endif

               endif
            endif
         end do

         if (no.eq.3) then

            if (isrna.eq.1) then

c     R-3'-Phosphate: O3* 1239, P 1240 OP 1241

               call settyp(ityp,io35,ir1)
               call settyp(ityp,ip,ir2)
               call setchg(ip,1)

               do i=1,3
                  call settyp(ityp,icn(i),ir3)
                  call setchg(icn(i),1)
               end do

            else

c     D-3'-Phosphate: O3* 1251, P 1252 OP 1253

               call settyp(ityp,io35,id1)
               call settyp(ityp,ip,id2)
               call setchg(ip,1)

               do i=1,3
                  call settyp(ityp,icn(i),id3)
                  call setchg(icn(i),1)
               end do

            endif
         endif
      endif

      return
      end

      subroutine typado(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxres=42)
      parameter (mxrss=20)
      parameter (mxrsa=23)
      parameter (mxata=9)
      parameter (mxatha=9)
      parameter (mxrso=24)
      parameter (mxato=10)
      parameter (mxatho=11)
      parameter (mxrsn=19)
      parameter (mxnucl=39)
      parameter (mxhnuc=27)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      logical nterm,cterm
      integer*2 ityp
      common /types/ iff
      integer amboff,ntca,ctca
      common /ambtyp/ amboff(mxrss*3),ntca(mxrss),ctca(mxrss),
     &                ncca(mxrsa),icca(2,mxata,mxrsa),
     &                nhha(mxrsa),ihha(2,mxatha,mxrsa),
     &                ncco(mxrso),icco(2,mxato,mxrso),
     &                nhho(mxrso),ihho(2,mxatho,mxrso),
     &                nnuc(mxrsn),nhnuc(mxrsn),irna(mxres-23),
     &                inuc(2,mxnucl,mxrsn),ihnuc(2,mxhnuc,mxrsn)

      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)

      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*)

      iff = 4

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20) (HIP,HID,HIE and sulfer bridge covered)
c                (ORN, mALA and pyroglut not covered)


      if (jres.le.0.or.jres.gt.mxrss) return

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
         call setchg(ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
         call setchg(ihpdb(i),0)
      end do

      nterm = .false.
      n = 0
      do i=1,3
         if (ihpdb(i).ne.0) n = n + 1
      end do
      if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.
      cterm = .false.
      if (ipdb(38).ne.0) cterm = .true.

      ihis = 0
      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      iss = 0
      if (jres.eq.4) then
c iss = 0 (cysteine -SH), iss = 1 (cystine -SS-)
         do i=1,iconn(1,ipdb(37))
            if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &          iss = 1
         end do
      endif

      iasph = 0
      iasphh = 0
      if (jres.eq.9) then
c iasph is it aspartate or aspartic acid
         if (ipdb(28).ne.0) then
            do i=1,iconn(1,ipdb(28))
               if (ianz(abs(iconn(1+i,ipdb(28)))).eq.1) then
                   iasph = 28
                   iasphh = iabs(iconn(1+i,ipdb(28)))
               endif
            end do
         endif
         if (ipdb(29).ne.0) then
            do i=1,iconn(1,ipdb(29))
               if (ianz(abs(iconn(1+i,ipdb(29)))).eq.1) then
                   iasph = 29
                   iasphh = iabs(iconn(1+i,ipdb(29)))
               endif
            end do
         endif
         if (ipdb(30).ne.0) then
            do i=1,iconn(1,ipdb(30))
               if (ianz(abs(iconn(1+i,ipdb(30)))).eq.1) then
                   iasph = 30
                   iasphh = iabs(iconn(1+i,ipdb(30)))
               endif
            end do
         endif
      endif

      ioff = 7

      if (jres.eq.1) ioff = 1
      if (jres.eq.15) ioff = 50

c N
      if (nterm) then
         if (jres.eq.15) then
            call settyp(ityp,ipdb(1),194)
         else
            call settyp(ityp,ipdb(1),190)
         endif
      else
         call settyp(ityp,ipdb(1),ioff)
      endif
c CA
      if (jres.eq.3) then
         call settyp(ityp,ipdb(2),33)
      elseif (jres.eq.4) then
         call settyp(ityp,ipdb(2),44)
      elseif (jres.eq.15.and.nterm) then
         call settyp(ityp,ipdb(2),196)
      else
         call settyp(ityp,ipdb(2),ioff+1)
      endif
         
c C
      call settyp(ityp,ipdb(3),ioff+2)
      if (cterm) call settyp(ityp,ipdb(3),192)
      if (jres.eq.15.and.nterm) call settyp(ityp,ipdb(3),197)

c HN
      if (nterm) then
         if (jres.eq.15) then
            call settyp(ityp,ihpdb(1),195)
            call settyp(ityp,ihpdb(2),195)
            call settyp(ityp,ihpdb(3),195)
         else
            call settyp(ityp,ihpdb(1),191)
            call settyp(ityp,ihpdb(2),191)
            call settyp(ityp,ihpdb(3),191)
         endif
         
      else
         call settyp(ityp,ihpdb(1),ioff+3)
         call settyp(ityp,ihpdb(2),ioff+3)
         call settyp(ityp,ihpdb(3),ioff+3)
      endif

c O
      if (jres.eq.15.and..not.cterm) then
         if (nterm) then
            call settyp(ityp,ipdb(4),198)
         else
            call settyp(ityp,ipdb(4),ioff+3)
         endif
      else
         if (cterm) then
            call settyp(ityp,ipdb(4),193)
            call settyp(ityp,ipdb(38),193)
         else
            call settyp(ityp,ipdb(4),ioff+4)
         endif
      endif


c HA
      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ihpdb(4),199)
            call settyp(ityp,ihpdb(5),199)
         else
            call settyp(ityp,ihpdb(4),ioff+4)
            call settyp(ityp,ihpdb(5),ioff+4)
         endif
      else
         call settyp(ityp,ihpdb(4),ioff+5)
         call settyp(ityp,ihpdb(5),ioff+5)
      endif

      jtmp = jres
      if (jres.eq.17) then
         if (ihis.eq.2) jtmp = 22
         if (ihis.eq.3) jtmp = 23
      endif
      if (jres.eq.4.and.iss.eq.1) jtmp = 21
      if (jres.eq.9.and.iasph.ne.0) jtmp = 24
    
      do i=1,ncco(jtmp)
         call settyp(ityp,ipdb(icco(1,i,jtmp)),icco(2,i,jtmp))
      end do

      do i=1,nhho(jtmp)
         call settyp(ityp,ihpdb(ihho(1,i,jtmp)),ihho(2,i,jtmp))
      end do

      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ipdb(9),200)
            call settyp(ityp,ihpdb(19),201)
            call settyp(ityp,ihpdb(20),201)
         endif
      endif

      if (jres.eq.9.and.iasph.ne.0) then
         call settyp(ityp,ipdb(iasph),136)
         if (iasphh.ne.0) call settyp(ityp,iasphh,137)
c         call settyp(ityp,ihpdb(19),137)
c         call settyp(ityp,ihpdb(20),137)
c         call settyp(ityp,ihpdb(21),137)
      endif

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

      if (jres.eq.12) then
         call settyp(ityp,ihpdb(43),168)
         call settyp(ityp,ihpdb(46),168)
         call settyp(ityp,ihpdb(49),168)
      endif

c      do i=1,mxsym
c         call setchg(ipdb(i),1)
c      end do
c      do i=1,mxhsym*3
c         call setchg(ihpdb(i),1)
c      end do

      return
      end

      subroutine settyp(itypa,iat,ityp)
      implicit double precision (a-h,o-z)
      integer*2 itypa
      dimension itypa(*)
      common /typoni/ ioniad

      if (iat.gt.0) then
         if (ioniad.gt.0) then
            itypa(iat) =  itypa(iat) + ityp
         else
            itypa(iat) =  ityp
         endif
      endif

      return
      end

      subroutine setchd(iat,iopt,qat,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      integer*2 ityp,it,it10000
      common /typoni/ ioniad
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      dimension qat(*),ityp(*)

      it10000=10000


      if (iat.gt.0) then
         if (iopt.eq.1) then
            if (ioniad.gt.0) then
               it = mod(ityp(iat),it10000)
            else
               it = ityp(iat)
            endif
            if (it.gt.0) then
               qat(iat) = ambchg(int(it))
            endif
            ihasq = 1
         elseif (iopt.eq.0) then
            qat(iat) = 0.0d0
         elseif (iopt.lt.0) then
            qat(iat) = cysneg(abs(iopt))
         endif
      endif

      return
      end

      subroutine flagd(ihpdb,iat,isurf)
      implicit double precision (a-h,o-z)
      dimension ihpdb(*),isurf(*)

      if (ihpdb(iat).ne.0) isurf(ihpdb(iat)) = 1

      return
      end

      subroutine conad(ipdb,iat1,iat2,iop,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension ipdb(*),iconn(mxcon+1,*)

      ia1 = ipdb(iat1)
      ia2 = ipdb(iat2)

      if (ia1.ne.0.and.ia2.ne.0) then
         if (iconn(1,ia1).lt.mxcon) then
            iconn(1,ia1) = iconn(1,ia1) + 1
            iconn(iconn(1,ia1)+1,ia1) = ia2
         endif
         if (iop.eq.0) then
            iconn(1,ia2) = 1
            iconn(2,ia2) = ia1
         else
            if (iconn(1,ia2).lt.mxcon) then
               iconn(1,ia2) = iconn(1,ia2) + 1
               iconn(iconn(1,ia2)+1,ia2) = ia1
            endif
         endif
      endif

      return
      end

      subroutine conatd(ipdb,ihpdb,iat1,iat2,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension ipdb(*), ihpdb(*), iconn(mxcon+1,*)

      ia1 = ipdb(iat1)
      ia2 = ihpdb(iat2)

      if (ia1.ne.0.and.ia2.ne.0) then
         if (iconn(1,ia1).lt.mxcon) then
            iconn(1,ia1) = iconn(1,ia1) + 1
            iconn(iconn(1,ia1)+1,ia1) = ia2
         endif
         iconn(1,ia2) = 1
         iconn(2,ia2) = ia1
      endif

      return
      end

      subroutine mkbacd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo,
     &                  icalf,ianf,islu,nchain,iamino)

      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxcon=10)
      logical newch
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)


      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

c N-CA
      if (ipdb(1).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(1)) = 1
         iconn(2,ipdb(1)) = ipdb(2)
      endif

c CA-N, CA-C
      if (ipdb(2).ne.0) then
         iconn(1,ipdb(2)) = 0
         if (ipdb(1).ne.0) then
            iconn(2,ipdb(2)) = ipdb(1)
            iconn(1,ipdb(2)) = 1
            if (ipdb(3).ne.0) then
               iconn(3,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 2
            endif
         else
            if (ipdb(3).ne.0) then
               iconn(2,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 1
            endif
         endif
      endif

c C-CA,C-O
      if (ipdb(4).ne.0.and.ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
         if (ipdb(2).ne.0) then
            iconn(2,ipdb(3)) = ipdb(2)
            iconn(3,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 2
         else
            iconn(2,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 1
         endif
c O-C
         iconn(1,ipdb(4)) = 1
         iconn(2,ipdb(4)) = ipdb(3)

      elseif (ipdb(3).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(3)) = 1
         iconn(2,ipdb(3)) = ipdb(2)
      elseif (ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
      elseif (ipdb(4).ne.0) then
         iconn(1,ipdb(4)) = 0
      endif

c Possible OXT
      if (ipdb(38).ne.0.or.ipdb(76).ne.0) then
         if (ipdb(38).ne.0) then
            iox = ipdb(38)
         else
            iox = ipdb(76)
         endif
         iconn(1,ipdb(3)) = iconn(1,ipdb(3)) + 1
         iconn(iconn(1,ipdb(3))+1,ipdb(3)) = iox
         iconn(1,iox) = 1
         iconn(2,iox) = ipdb(3)
      endif

c C beta
      if (jres.gt.1.and.ipdb(5).ne.0) then
         iconn(1,ipdb(2)) = 3
         iconn(4,ipdb(2)) = ipdb(5)
         iconn(1,ipdb(5)) = 1
         iconn(2,ipdb(5)) = ipdb(2)
      endif
 
      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(2)
         icalf(2,icres) = ipdb(1)
         icalf(3,icres) = ipdb(3)
         icalf(4,icres) = 0
      endif

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         ic = icalf(3,icres-1)
         in = ipdb(1)
         if (iamino(icres-1).le.23.and.(ic.gt.0.and.in.gt.0)) then
            do i=1,3
               tmp(i) = coo(i,in) - coo(i,ic)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect N current residue to C previous
c
               iconn(1,in) = iconn(1,in) + 1 
               iconn(iconn(1,in)+1,in) = ic
c
c connect C previous to N current residue 
c
               iconn(1,ic) = iconn(1,ic) + 1 
               iconn(iconn(1,ic)+1,ic) = in
            else
               newch = .true.
            endif
         else 
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      if (ihashy.eq.1) then
          do i=1,3
             call conath(ipdb,ihpdb,1,i)
             call conath(ipdb,ihpdb,2,3+i)
             call conath(ipdb,ihpdb,5,6+i)
          end do
          call conath(ipdb,ihpdb,1,79)
          call conath(ipdb,ihpdb,1,82)
          call conath(ipdb,ihpdb,1,91)
      endif

      return
      end

      subroutine mkbadd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo,
     &                  icalf,ianf,islu,nchain,iamino)

      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxcon=10)
      logical newch
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

c N-CA
      if (ipdb(1).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(1)) = 1
         iconn(2,ipdb(1)) = ipdb(2)
      endif

c CA-N, CA-C
      if (ipdb(2).ne.0) then
         iconn(1,ipdb(2)) = 0
         if (ipdb(1).ne.0) then
            iconn(2,ipdb(2)) = ipdb(1)
            iconn(1,ipdb(2)) = 1
            if (ipdb(3).ne.0) then
               iconn(3,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 2
            endif
         else
            if (ipdb(3).ne.0) then
               iconn(2,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 1
            endif
         endif
      endif

c C-CA,C-O
      if (ipdb(4).ne.0.and.ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
         if (ipdb(2).ne.0) then
            iconn(2,ipdb(3)) = ipdb(2)
            iconn(3,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 2
         else
            iconn(2,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 1
         endif
c O-C
         iconn(1,ipdb(4)) = 1
         iconn(2,ipdb(4)) = ipdb(3)

      elseif (ipdb(3).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(3)) = 1
         iconn(2,ipdb(3)) = ipdb(2)
      elseif (ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
      elseif (ipdb(4).ne.0) then
         iconn(1,ipdb(4)) = 0
      endif


c Possible OXT
      if (ipdb(38).ne.0.or.ipdb(76).ne.0) then
         if (ipdb(38).ne.0) then
            iox = ipdb(38)
         else
            iox = ipdb(76)
         endif
         iconn(1,ipdb(3)) = iconn(1,ipdb(3)) + 1
         iconn(iconn(1,ipdb(3))+1,ipdb(3)) = iox
         iconn(1,iox) = 1
         iconn(2,iox) = ipdb(3)
      endif
c C beta
      if (jres.gt.1.and.ipdb(5).ne.0) then
         iconn(1,ipdb(2)) = 3
         iconn(4,ipdb(2)) = ipdb(5)
         iconn(1,ipdb(5)) = 1
         iconn(2,ipdb(5)) = ipdb(2)
      endif
 
      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(2)
         icalf(2,icres) = ipdb(1)
         icalf(3,icres) = ipdb(3)
         icalf(4,icres) = 0
      endif

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         ic = icalf(3,icres-1)
         in = ipdb(1)
         if (iamino(icres-1).le.23.and.(ic.gt.0.and.in.gt.0)) then
            do i=1,3
               tmp(i) = coo(i,in) - coo(i,ic)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect N current residue to C previous
c
               iconn(1,in) = iconn(1,in) + 1 
               iconn(iconn(1,in)+1,in) = ic
            else
               newch = .true.
            endif
         else 
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      if (icres.ge.1.and.icres.le.numcal-1) then
         ic = ipdb(3)
         in = icalf(2,icres+1)
         if (iamino(icres+1).le.23.and.(ic.gt.0.and.in.gt.0)) then
            do i=1,3
               tmp(i) = coo(i,in) - coo(i,ic)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect C previous to N current residue 
c
               iconn(1,ic) = iconn(1,ic) + 1 
               iconn(iconn(1,ic)+1,ic) = in
            endif
         endif

      endif

      if (ihashy.eq.1) then
          do i=1,3
             call conath(ipdb,ihpdb,1,i)
             call conath(ipdb,ihpdb,2,3+i)
             call conath(ipdb,ihpdb,5,6+i)
          end do
          call conath(ipdb,ihpdb,1,79)
          call conath(ipdb,ihpdb,1,82)
          call conath(ipdb,ihpdb,1,91)
      endif

      return
      end

      subroutine mknbcd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo,
     &                  icalf,ianf,islu,nchain,iamino)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxcon=10)
      logical newch
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

      if (ipdb(43).gt.0) then
         nc = 0
         if (ipdb(44).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(43)) = ipdb(44)
         endif
         if (ipdb(45).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(43)) = ipdb(45)
         endif
         if (ipdb(46).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(43)) = ipdb(46)
         endif
         iconn(1,ipdb(43)) = nc
      endif

      if (ipdb(44).gt.0) iconn(1,ipdb(44)) = 0
      if (ipdb(45).gt.0) iconn(1,ipdb(45)) = 0
      if (ipdb(46).gt.0) iconn(1,ipdb(46)) = 0

      if (ipdb(43).gt.0) then

         if (ipdb(44).gt.0) then
            iconn(2,ipdb(44)) = ipdb(43)
            iconn(1,ipdb(44)) = 1
         endif

         if (ipdb(45).gt.0) then
            iconn(2,ipdb(45)) = ipdb(43)
            iconn(1,ipdb(45)) = 1
         endif

         if (ipdb(46).gt.0) then
            iconn(2,ipdb(46)) = ipdb(43)
            iconn(1,ipdb(46)) = 1
         endif
      endif


      if (ipdb(47).gt.0) then
         if (ipdb(46).gt.0) then
            iconn(1,ipdb(46)) = iconn(1,ipdb(46)) + 1
            iconn(1+iconn(1,ipdb(46)),ipdb(46)) = ipdb(47)
            iconn(2,ipdb(47)) = ipdb(46)
            iconn(1,ipdb(47)) = 1
         endif
         if (ipdb(48).gt.0) then
            if (ipdb(46).gt.0) then
               iconn(1,ipdb(47)) = 2
               iconn(3,ipdb(47)) = ipdb(48)
            else
               iconn(1,ipdb(47)) = 1
               iconn(2,ipdb(47)) = ipdb(48)
            endif
         endif
      endif

      if (ipdb(48).gt.0) then
         nc = 0
         if (ipdb(47).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(48)) = ipdb(47)
         endif
         if (ipdb(49).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(48)) = ipdb(49)
         endif
         if (ipdb(50).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(48)) = ipdb(50)
         endif
         iconn(1,ipdb(48)) = nc
      endif

      if (ipdb(49).gt.0) then
         nc = 0
         if (ipdb(48).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(49)) = ipdb(48)
         endif
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(49)) = ipdb(54)
         endif
         iconn(1,ipdb(49)) = nc
      endif

      if (ipdb(49).gt.0) then
         nc = 0
         if (ipdb(48).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(50)) = ipdb(48)
         endif
         if (ipdb(51).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(50)) = ipdb(51)
         endif
         if (ipdb(52).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(50)) = ipdb(52)
         endif
         iconn(1,ipdb(50)) = nc
      endif

      if (ipdb(50).gt.0.and.ipdb(51).gt.0) then
         iconn(1,ipdb(51)) = 1
         iconn(2,ipdb(51)) = ipdb(50)
      endif

      if (ipdb(52).gt.0) then
         nc = 0
         if (ipdb(50).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(52)) = ipdb(50)
         endif
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(52)) = ipdb(54)
         endif
         iconn(1,ipdb(52)) = nc
      endif

      if (ipdb(53).gt.0.and.ipdb(52).gt.0) then
         nc = iconn(1,ipdb(52))
         nc = nc + 1
         iconn(1+nc,ipdb(52)) = ipdb(53)
         iconn(1,ipdb(52)) = nc
         iconn(1,ipdb(53)) = 1
         iconn(2,ipdb(53)) = ipdb(52)
      endif

      if (ipdb(54).ne.0) then
         nc = 0
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(54)) = ipdb(49)
         endif
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(54)) = ipdb(52)
         endif
         iconn(1,ipdb(54)) = nc
      endif

c Possible OXT

      if (ipdb(38).ne.0.and.ipdb(43).ne.0) then
         nc = iconn(1,ipdb(43))
         nc = nc + 1
         iconn(1+nc,ipdb(43)) = ipdb(38)
         iconn(1,ipdb(43)) = nc
         iconn(1,ipdb(38)) = 1
         iconn(2,ipdb(38)) = ipdb(43)
      endif

c Possible O3P (OXT is old O3P new)

      if (ipdb(76).ne.0.and.ipdb(43).ne.0) then
         nc = iconn(1,ipdb(43))
         nc = nc + 1
         iconn(1+nc,ipdb(43)) = ipdb(76)
         iconn(1,ipdb(43)) = nc
         iconn(1,ipdb(76)) = 1
         iconn(2,ipdb(76)) = ipdb(43)
      endif

      if (jres.eq.36.or.jres.eq.31) then
          call conat(ipdb,53,73,0)
          call conat(ipdb,53,80,0)
      endif

      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,47,61)
         call conath(ipdb,ihpdb,47,62)
         call conath(ipdb,ihpdb,48,64)
         call conath(ipdb,ihpdb,50,67)
         call conath(ipdb,ihpdb,52,70)
         call conath(ipdb,ihpdb,52,71)
         call conath(ipdb,ihpdb,54,73)
         if (ipdb(53).ne.0) call conath(ipdb,ihpdb,53,76)
         if ((jres.eq.36.or.jres.eq.31).and.ipdb(80).ne.0) then
             call conath(ipdb,ihpdb,80,151)
             call conath(ipdb,ihpdb,80,152)
             call conath(ipdb,ihpdb,80,153)
         endif
         call conath(ipdb,ihpdb,51,115)
         call conath(ipdb,ihpdb,46,118)
      endif

      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(43)
         icalf(2,icres) = ipdb(46)
         icalf(3,icres) = ipdb(47)
         icalf(4,icres) = ipdb(48)
         icalf(5,icres) = ipdb(50)
         icalf(6,icres) = ipdb(51)
      endif

      if (ipdb(43).eq.0.and.icres.le.numcal) then
         if (ihpdb(118).ne.0) then
             icalf(1,icres) = ihpdb(118)
         elseif (ipdb(46).ne.0) then
             icalf(1,icres) = ipdb(46)
         endif
      endif

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         if (iamino(icres-1).gt.23) then
            ip = ipdb(43)
            io = icalf(6,icres-1)
            if (io.gt.0.and.ip.gt.0) then
               do i=1,3
                  tmp(i) = coo(i,ip) - coo(i,io)
               end do
               distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &                  tmp(3)*tmp(3)
            else
               distsq = 100000.0d0
            endif
            if (distsq.lt.3.1684d0*fct) then
c
c connect P current residue to O previous
c
               iconn(1,ip) = iconn(1,ip) + 1 
               iconn(iconn(1,ip)+1,ip) = io
c
c connect O previous to P current residue 
c
               iconn(1,io) = iconn(1,io) + 1 
               iconn(iconn(1,io)+1,io) = ip
            else
               newch = .true.
            endif
         else
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      return
      end

      subroutine addhd(ires,jres,ipdb,ihpdb,nterm,
     &                 ianz,iaton,iatclr,iresid,iconn,isurf,ipdbt,ityp,
     &                 ncalf,icalf,coo)
c
c Add hydrogens
c Only the Hydrogens attached to the backbone N are not covered
c This is done by routine hcoord
c
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxres=42)
      parameter (mxhs=15)
      parameter (mxyg=26)
      common /hcom/  iat(4,mxhs,mxres),nrs(mxres),rint(3,mxhs,mxres),
     &               iatyg(4,mxyg),rintyg(3,mxyg)
      common /athlp/ iatoms, mxnat
      integer*2 ipdbt,ityp
      logical addat, o5pcon
      real dih
      dimension ipdb(*), ihpdb(*), it(4), rt(4), icalf(6,*),isel(4)
      dimension ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*),itp(3),
     &          iresid(*),coo(3,*),ipdbt(*),ityp(*),isurf(*)
      data nrs /2,4,4,4,6,10,8,8,3,5,10,12,5,7,7,12,6,8,8,9,3*0,
     &          11,11,11,12,10,13,13,13,13,13,15,15,13,0,10,0,12,
     &          12,10/
c gly
      data ((iat(i,j,1),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 3,1,2,5, 52*0/  
      data ((rint(i,j,1),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.9779d0,107.66d0,-118.0d0, 
     &     39*0.0d0/  
c ala
      data ((iat(i,j,2),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 3,2,5,7, 3,2,5,8, 3,2,5,9,
     &     44*0/  
      data ((rint(i,j,2),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     33*0.0d0/  
c ser
      data ((iat(i,j,3),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 2,5,31,10, 31,2,5,7, 31,2,5,8,
     &     44*0/  
      data ((rint(i,j,3),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.867d0,107.06d0,180.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     33*0.0d0/  
c cys
      data ((iat(i,j,4),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 2,5,37,10, 37,2,5,7, 37,2,5,8,
     &     44*0/  
      data ((rint(i,j,4),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.867d0,107.06d0,180.0d0, 
     &     0.990d0,112.5d0,120.0d0, 0.990d0,112.5d0,-120.0d0,
     &     33*0.0d0/  
c thr
      data ((iat(i,j,5),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 32,8,5,7, 2,5,32,13, 
     &     2,5,8,16, 2,5,8,17, 2,5,8,18,
     &     36*0/  
      data ((rint(i,j,5),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,-120.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     27*0.0d0/  
c ile
      data ((iat(i,j,6),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 7,8,5,7,  7,5,8,16, 7,5,8,17, 7,5,8,18,
     &     10,5,7,13, 10,5,7,14, 5,7,10,22, 5,7,10,23, 5,7,10,24,
     &     20*0/  
      data ((rint(i,j,6),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,-120.0d0, 
     &     0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     0.978d0,110.0d0,120.0d0, 0.978d0,110.0d0,-120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     15*0.0d0/  
c val
      data ((iat(i,j,7),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 7,8,5,7,  7,5,8,16, 7,5,8,17, 7,5,8,18,
     &     8,5,7,13, 8,5,7,14, 8,5,7,15,
     &     28*0/  
      data ((rint(i,j,7),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,120.0d0, 
     &     0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     21*0.0d0/  
c met
      data ((iat(i,j,8),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7,  6,2,5,8,
     &     36,5,6,10, 36,5,6,11, 
     &     6,36,12,28, 6,36,12,29, 6,36,12,30,
     &     28*0/  
      data ((rint(i,j,8),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,120.0d0, 
     &     0.990d0,109.08d0,-120.0d0,
     &     0.978d0,110.0d0,120.0d0, 0.978d0,110.0d0,-120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     21*0.0d0/  
c asp
      data ((iat(i,j,9),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     48*0/  
      data ((rint(i,j,9),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     36*0.0d0/  
c asn
      data ((iat(i,j,10),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     29,6,21,25, 29,6,21,26,
     &     40*0/  
      data ((rint(i,j,10),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.950d0,120.0d0,180.0d0, 0.950d0,120.0d0,0.0d0,
     &     30*0.0d0/  
c leu
      data ((iat(i,j,11),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     5,10,6,10, 5,6,10,22, 5,6,10,23, 5,6,10,24,
     &     5,6,11,25, 5,6,11,26, 5,6,11,27,
     &     20*0/  
      data ((rint(i,j,11),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.9779d0,107.63d0,120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     15*0.0d0/  
c lys
      data ((iat(i,j,12),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     12,6,9,19, 12,6,9,20, 27,9,12,28, 27,9,12,29,
     &     9,12,27,40, 9,12,27,41, 9,12,27,42,
     &     12*0/
      data ((rint(i,j,12),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     9*0/
c glu
      data ((iat(i,j,13),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     40*0/
      data ((rint(i,j,13),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     30*0/
c gln
      data ((iat(i,j,14),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     34,9,24,34, 34,9,24,35,
     &     32*0/
      data ((rint(i,j,14),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.950d0,120.0d0,180.0d0, 0.950d0,120.0d0,0.0d0,
     &     24*0/
c pro
      data ((iat(i,j,15),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     1,6,9,19, 1,6,9,20,
     &     32*0/
      data ((rint(i,j,15),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     24*0/
c arg
      data ((iat(i,j,16),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     22,6,9,19, 22,6,9,20, 9,17,22,28,
     &     22,17,25,55, 22,17,25,56, 22,17,26,58, 22,17,26,59,
     &     12*0/
      data ((rint(i,j,16),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     1.020d0,120.0d0,180.0d0,
     &     1.020d0,120.0d0,0.0d0, 1.020d0,120.0d0,180.0d0,
     &     1.020d0,120.0d0,0.0d0, 1.020d0,120.0d0,180.0d0,
     &     9*0/
c his
      data ((iat(i,j,17),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,20,22, 20,24,13,31, 24,6,11,25,
     &     36*0/
      data ((rint(i,j,17),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.020d0,126.0d0,180.0d0, 1.100d0,126.0d0,180.0d0,
     &     1.020d0,126.0d0,180.0d0, 1.100d0,126.0d0,180.0d0,
     &     24*0/
c phe
      data ((iat(i,j,18),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,10,22, 10,17,13,31, 13,14,17,40, 17,11,14,34,
     &     14,6,11,25,
     &     28*0/
      data ((rint(i,j,18),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0,
     &     21*0/
c tyr
      data ((iat(i,j,19),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,10,22, 10,17,13,31, 13,17,33,52, 17,11,14,34,
     &     14,6,11,25,
     &     28*0/
      data ((rint(i,j,19),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     0.970d0,108.0d0,0.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0,
     &     21*0/
c trp
      data ((iat(i,j,20),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,23,10,22, 10,14,23,31, 14,16,18,46, 18,19,16,58,
     &     16,15,19,49, 11,19,15,37,
     &     24*0/
      data ((rint(i,j,20),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,124.0d0,180.0d0, 1.050d0,124.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     18*0/

c asx,glx,hyp not yet

      data (((iat(i,j,k),i=1,4),j=1,mxhs),k=21,23) /180*0/
      data (((rint(i,j,k),i=1,3),j=1,mxhs),k=21,23) /135*0.0d0/

c adenosine

      data ((iat(i,j,24),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,62,60,55,82, 60,58,64,-136, 60,58,64,-137,
     &     16*0/
      data ((rint(i,j,24),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.080d0,116.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     12*0/

c cytidine

      data ((iat(i,j,25),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,58,56,57,100, 57,56,63,-130, 57,56,63,-131,
     &     16*0/
      data ((rint(i,j,25),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,123.4d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     12*0/

c guanosine

      data ((iat(i,j,26),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 60,55,61,-125,
     &     16*0/
      data ((rint(i,j,26),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     12*0/

c thimidine

      data ((iat(i,j,27),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103, 56,55,62,-127, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     12*0/
      data ((rint(i,j,27),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     9*0/

c uridine

      data ((iat(i,j,28),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,58,56,57,100, 56,55,62,-127, 
     &     20*0/
      data ((rint(i,j,28),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,119.4d0,180.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     15*0/

c 1MA

      data ((iat(i,j,29),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,62,60,55,82, 
     &     60,58,64,-137, 58,60,79,148, 58,60,79,149, 58,60,79,150, 
     &     0,0,0,0, 0,0,0,0/
      data ((rint(i,j,29),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 
     &     1.080d0,120.0d0,180.0d0,1.080d0,120.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,90.0d0,90.0d0,0.0d0,.0d0,0.0d0/

c 5MC

      data ((iat(i,j,30),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103, 57,56,63,-130, 57,56,63,-131, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     8*0/
      data ((rint(i,j,30),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 1.080d0,118.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     6*0/

c OMC

      data ((iat(i,j,31),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 
     &     52,53,80,151, 52,53,80,152, 52,53,80,153,
     &     60,57,58,103,58,56,57,100, 57,56,63,-130, 57,56,63,-131,
     &     8*0/
      data ((rint(i,j,31),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,123.4d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     6*0/

c 1MG

      data ((iat(i,j,32),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,
     &     58,60,79,148, 58,60,79,149, 58,60,79,150,
     &     60,55,61,-124, 60,55,61,-125,
     &     8*0/
      data ((rint(i,j,32),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 1.080d0,122.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     6*0/

c 2MG

      data ((iat(i,j,33),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 
     &     55,61,80,151, 55,61,80,152, 55,61,80,153,
     &     8*0/
      data ((rint(i,j,33),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,0.0d0, 
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     6*0/

c M2G

      data ((iat(i,j,34),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 
     &     55,61,79,148, 55,61,79,149, 55,61,79,150,
     &     55,61,80,151, 55,61,80,152, 55,61,80,153/
      data ((rint(i,j,34),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0/

c 7MG

      data ((iat(i,j,35),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 
     &     60,55,61,-125,57,65,85,166, 57,65,85,167, 57,65,85,168,
     &     0,0,0,0/
      data ((rint(i,j,35),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 
     &     1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,0.0d0,0.0d0,0.0d0/

c OMG

      data ((iat(i,j,36),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 
     &     52,53,80,151, 52,53,80,152, 52,53,80,153,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 60,55,61,-125,
     &     8*0/
      data ((rint(i,j,36),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     6*0/

c NO YG

      data ((iat(i,j,37),i=1,4),j=1,mxhs) /60*0/
      data ((rint(i,j,37),i=1,3),j=1,mxhs) /45*0.0d0/

c inosine

      data ((iat(i,j,38),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121,62,60,55,82, 
     &     20*0/
      data ((rint(i,j,38),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.080d0,122.0d0,180.0d0,
     &     15*0/

c NO +U

      data ((iat(i,j,39),i=1,4),j=1,mxhs) /60*0/
      data ((rint(i,j,39),i=1,3),j=1,mxhs) /45*0.0d0/

c H2U

      data ((iat(i,j,40),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,60,57,58,104,58,56,57,100,58,56,57,101,
     &     56,55,62,-127, 
     &     12*0/
      data ((rint(i,j,40),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,120.0d0, 1.080d0,119.4d0,-120.0d0,
     &     1.080d0,118.0d0,120.0d0, 1.080d0,119.4d0,-120.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     9*0/

c 5MU

      data ((iat(i,j,41),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,56,55,62,-127, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     12*0/
      data ((rint(i,j,41),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     9*0/


c PSU

      data ((iat(i,j,42),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,55,58,60,-121, 56,55,62,-127, 
     &     20*0/
      data ((rint(i,j,42),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     15*0/

c YG

      data ((iatyg(i,j),i=1,4),j=1,mxyg) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,56,62,88,91, 56,62,88,92, 56,62,88,93,
     &     61,90,89,175, 61,90,89,176, 61,90,89,177,
     &     91,93,92,178, 91,93,92,179,
     &     92,94,93,181, 92,94,93,182, 93,95,94,184,
     &     95,97,98,187, 95,97,98,188, 95,97,98,189,
     &     94,100,99,-124,
     &     100,102,103,190, 100,102,103,191, 100,102,103,192/
      data ((rintyg(i,j),i=1,3),j=1,mxyg) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.090d0,109.8d0,180.0d0,
     &     1.090d0,109.8d0,60.0d0, 1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0, 1.010d0,120.0d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0/

c
c for nucleotides the H's that make hydrogen bonds are added
c by subroutine mkcon, addhy1 and addhy2, these atoms are flagged
c via array isurf, which is used by dohcon to create hydrogen bonds
c this routine does not do that
c
c OXT = O3P , do we have to add H's to O2P,O3P, at present NO
c

      if (jres.le.0.or.jres.gt.mxres) return

      if (jres.eq.37) then
         nh = mxyg
      else
         nh = nrs(jres)
      endif

      do i=1,nh

          if (jres.eq.37) then
              do j=1,4
                 it(j) = iatyg(j,i)
              end do
              do j=1,3
                 rt(j) = rintyg(j,i)
              end do
          else
              do j=1,4
                 it(j) = iat(j,i,jres)
              end do
              do j=1,3
                 rt(j) = rint(j,i,jres)
              end do
          endif

          ih = abs(it(4))
          itp(1) = ipdb(it(1))
          itp(2) = ipdb(it(2))
          itp(3) = ipdb(it(3))
          ihp = ihpdb(ih)

          if (jres.eq.4.and.i.eq.2) then
              if (ipdb(37).gt.0.and.ipdb(37).lt.mxnat) then
                 if (iconn(1,ipdb(37)).gt.1) ihp = 1
              endif
          endif
          if (jres.eq.3.and.i.eq.2) then
              if (ipdb(31).gt.0.and.ipdb(31).lt.mxnat) then
                 if (iconn(1,ipdb(31)).gt.1) ihp = 1
              endif
          endif
          if (jres.eq.10.and.i.ge.4) then
              if (ipdb(21).gt.0.and.ipdb(21).lt.mxnat) then
                 if ((iconn(1,ipdb(21)).gt.1.and.i.eq.4).or.
     &               (iconn(1,ipdb(21)).gt.2.and.i.eq.5)) then
                     if (i.eq.4) then
                        rt(2) = 120.0d0
                        rt(3) = 180.0d0
                     elseif (i.eq.5) then
                        ihp = 1
                     endif
                 endif
              endif
          endif
          if (jres.eq.12.and.i.ge.10) then
              n = 0
              if (ipdb(27).gt.0.and.ipdb(27).lt.mxnat.and.i.eq.10) then
                  if (iconn(1,ipdb(27)).eq.2) ihp = 1
              endif
              if (ipdb(27).gt.0.and.ipdb(27).lt.mxnat) then
                 n = iconn(1,ipdb(27)) - 1
              endif
              if (n.gt.2) ihp = 1
          endif
          if (jres.eq.17.and.i.eq.4) then
              if (ipdb(20).gt.0) then
                 if (iconn(1,ipdb(20)).gt.2) ihp = 1
              endif
          endif
          if (ihp.eq.0) then
              if (addat(itp(1),itp(2),
     &            itp(3),1,rt(1),rt(2),rt(3),ihpdb(ih),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                  iresid(ihpdb(ih)) = ires
                  ipdbt(ihpdb(ih)) = ih
                  if (it(4).lt.0) isurf(ihpdb(ih)) = 1
              endif
          endif
      end do

      if (jres.gt.23) then
c
c deal with DNA as well
c
         if (ipdb(53).eq.0) then
             if (addat(ipdb(50),ipdb(54),ipdb(52),1,
     &        1.090d0,109.8d0,120.0d0,ihpdb(71),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                 iresid(ihpdb(71)) = ires
                 ipdbt(ihpdb(71)) = 71
             endif
         endif

c HO3

         if (ipdb(51).ne.0) then
             n = icred(ipdb(51),inoh,ih,ianz,iconn)
             if (inoh.eq.1.and.ih.eq.0) then
                if (addat(ipdb(52),ipdb(50),ipdb(51),1,
     &           0.960d0,109.8d0,120.0d0,ihpdb(115),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                    iresid(ihpdb(115)) = ires
                    ipdbt(ihpdb(115)) = 115
                endif
             endif
         endif

         if (ipdb(43).eq.0.and.ipdb(46).ne.0) then
             if (.not.o5pcon(ipdb(46),ianz,iconn)) then
                if (addat(ipdb(48),ipdb(47),ipdb(46),1,
     &           0.960d0,109.8d0,120.0d0,ihpdb(118),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                    iresid(ihpdb(118)) = ires
                    ipdbt(ihpdb(118)) = 118
                    icalf(1,ires) = ihpdb(118)
                endif
             endif
         endif

      else

         if (nterm.eq.1) then
            n = icred(ipdb(1),inoh,ih,ianz,iconn)
            if (inoh.eq.1.and.ih.eq.1.and.ihpdb(1).ne.0) then
               if (addat(ihpdb(1),ipdb(2),ipdb(1),1,
     &          1.010d0,109.8d0,120.0d0,ihpdb(2),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                   iresid(ihpdb(2)) = ires
                   ipdbt(ihpdb(2)) = 2
               endif
               if (addat(ihpdb(1),ipdb(2),ipdb(1),1,
     &          1.010d0,109.8d0,-120.0d0,ihpdb(3),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                   iresid(ihpdb(3)) = ires
                   ipdbt(ihpdb(3)) = 3
               endif
            endif
         endif

      endif

      return
      end

      logical function o5pcon(iat,ianz,iconn)
      parameter (mxcon=10)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      dimension ianz(*),iconn(mxcon+1,*)
   
      o5pcon = .false.

      do i=1,iconn(1,iat)
         ii = iconn(1+i,iat)
         if (ii.gt.0) then
            if (ianz(ii).eq.15) o5pcon = .true.
         endif
      end do
      
      return
      end

      subroutine rdprot
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxres=42)
      parameter (maxam=1000)
      character*137 line,string
      common /curlin/ line
      character*3 aminos
      common /amino/  aminos(mxres)
      integer getlin
      dimension iamin(maxam),angs(7,maxam)

      mxam = maxam
      namin = 0
      do while (getlin(0).eq.1)
         iam = 0
         ktype = nxtwrd(string,nstr,itype,rtype)
         if (ktype.eq.1.and.nstr.eq.3) then
             call tocap(string,3)
             do i=1,20
                if (string(1:3).eq.aminos(i)) iam = i
             end do
             if (iam.ne.0) then
                if (namin.lt.maxam) then
                   namin = namin + 1
                   iamin(namin) = iam - 1
                   do i=1,7
                      angs(i,namin) = -1
                      ktype = nxtwrd(string,nstr,itype,rtype)
                      if (ktype.eq.3) angs(i,namin) = rtype
                      if (ktype.eq.2) angs(i,namin) = dble(itype)
                   end do
                else
                   call inferr('To many RESIDUES !',0)
                endif
             endif
         endif
      end do

      call readsq(iamin,angs,namin)

      return
      end

      subroutine numhed(numhet,iresid)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension iresid(*)

      nhmtmp = -3
      do i=1,iatoms
         if (iresid(i).lt.nhmtmp) nhmtmp = iresid(i)
      end do
      numhet = iabs(nhmtmp)

      return
      end

      logical function chkpdb(ipdb,jres,icres,irsnr,isal)
      implicit double precision (a-h,o-z)
      parameter (mxres=42)
      parameter (mxares=20)
      parameter (mxaat=13)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      character*3 aminos
      common /amino/aminos(mxres)
      integer resn,resat
      common /resa/ resat(mxares,mxaat),resn(mxares)
      character*3 pdbsym,hsym,chtnk,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      parameter (mxinrs=100)
      common /incmpl/ incomp(mxinrs),nincmp
      dimension ipdb(*),irsnr(*)

      data resn/4,4,6,6,7,8,7,8,8,8,8,9,9,9,8,11,10,11,12,13/
c glycine
      data (resat(1,i),i=1,mxaat)/
     &          1,2,3,4,0,0,0,0,0,0,0,0,0/
c alanine
      data (resat(2,i),i=1,mxaat)/
     &          1,2,3,4,0,0,0,0,0,0,0,0,0/
c serine
      data (resat(3,i),i=1,mxaat)/
     &          1,2,3,4,5,31,0,0,0,0,0,0,0/
c cysteine
      data (resat(4,i),i=1,mxaat)/
     &          1,2,3,4,5,37,0,0,0,0,0,0,0/
c threonine
      data (resat(5,i),i=1,mxaat)/
     &          1,2,3,4,5,32,8,0,0,0,0,0,0/
c isoleucine
      data (resat(6,i),i=1,mxaat)/
     &          1,2,3,4,5,7,8,10,0,0,0,0,0/
c valine
      data (resat(7,i),i=1,mxaat)/
     &          1,2,3,4,5,7,8,0,0,0,0,0,0/
c methionine
      data (resat(8,i),i=1,mxaat)/
     &          1,2,3,4,5,6,36,12,0,0,0,0,0/
c aspartic acid
      data (resat(9,i),i=1,mxaat)/
     &          1,2,3,4,5,6,29,30,0,0,0,0,0/
c asparagine
      data (resat(10,i),i=1,mxaat)/
     &          1,2,3,4,5,6,29,21,0,0,0,0,0/
c leucine
      data (resat(11,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,0,0,0,0,0/
c lysine
      data (resat(12,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,12,27,0,0,0,0/
c glutamic acid
      data (resat(13,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,34,35,0,0,0,0/
c glutamine
      data (resat(14,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,24,34,0,0,0,0/
c proline 28 ?
      data (resat(15,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,1,0,0,0,0,0/
c arginine
      data (resat(16,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,17,22,25,26,0,0/
c histidine 
      data (resat(17,i),i=1,mxaat)/
     &          1,2,3,4,5,6,11,13,20,24,0,0,0/
c phenylalanine
      data (resat(18,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,13,14,17,0,0/
c tyrosine
      data (resat(19,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,13,14,17,33,0/
c tryptophan
      data (resat(20,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,14,15,16,18,23/

      iresa = -1
      if (jres.le.20) then
         do i=1,resn(jres)
            if (ipdb(2).le.0) isal = 4
            if (ipdb(resat(jres,i)).le.0) then
               chkpdb = .false.
               print*,'incomplete residue ',irsnr(icres),' ',
     &                 aminos(jres),' ',pdbsym(resat(jres,i))
               nincmp = nincmp + 1
               incomp(nincmp) = icres
               return
            endif
         end do
      endif

      chkpdb = .true.
      return
      end
          
      subroutine detanz(resi,tstr,lstr,ifnd,ish,ianz,ihashy)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137
      character*3 resi, atmp
      character*4 tstr
      character*2 tocapf

          ifnd = 1
          ish = 0
          atmp = tstr(2:4)
c
c Take care of ambiguity; asx->asn ,glx->gln ,his
c
          if (resi.eq.'ASX') then
              if (atmp.eq.'AD1') then
                  atmp = 'OD1'
              elseif (atmp.eq.'AD2') then
                  atmp = 'ND2'
              endif
          elseif (resi.eq.'GLX') then
              if (atmp.eq.'AE1') then
                  atmp = 'OE1'
              elseif (atmp.eq.'AE2') then
                  atmp = 'NE2'
              endif
          elseif (resi.eq.'HIS') then
              if (atmp.eq.'AD1') then
                  atmp = 'ND1'
              elseif (atmp.eq.'AD2') then
                  atmp = 'CD2'
              elseif (atmp.eq.'AE1') then
                  atmp = 'CE1'
              elseif (atmp.eq.'AE2') then
                  atmp = 'NE2'
              endif
          elseif (resi.eq.'ILE') then
              if (atmp.eq.'CD ') then
                  atmp = 'CD1'
              elseif (atmp.eq.'HD1') then
                  atmp = 'HD1'
                  tstr(1:4) = '1HD1'
              elseif (atmp.eq.'HD2') then
                  atmp = 'HD1'
                  tstr(1:4) = '2HD1'
              elseif (atmp.eq.'HD3') then
                  atmp = 'HD1'
                  tstr(1:4) = '3HD1'
              endif
          elseif (resi.eq.'SER'.or.resi.eq.'CYS') then
              if (atmp.eq.'HG1') atmp = 'HG '
          elseif (resi.eq.'  T'.or.resi.eq.' DT') then
              if (atmp(1:2).eq.'H7') atmp = 'HM7'
          endif
          if (atmp.ne.tstr(2:4)) tstr(2:4) = atmp


          if (tstr(1:2).eq.'HH'.or.tstr(1:2).eq.'HD'.or.
     &        tstr(1:2).eq.'HE'.or.tstr(1:2).eq.'HG') then
              atmp = tstr(1:3)
              tstr = ' '//atmp
          endif

c to unscrew whatif specific types

          if (tstr(2:4).eq.'O**') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'O* ') tstr(2:4) = 'O  '
          if (tstr(2:4).eq.'H5M') tstr(2:4) = 'HM5'
          if (tstr(2:4).eq.'H3T') tstr(2:4) = 'HO3'
          if (tstr(1:4).eq.'1H4 ') tstr(1:4) = ' H41'
          if (tstr(1:4).eq.'2H4 ') tstr(1:4) = ' H42'

          if (tstr(2:4).eq.'OT1') tstr(2:4) = 'O  '
          if (tstr(2:4).eq.'OT2') tstr(2:4) = 'OXT'

          it = ichar(tstr(2:2))
          it4 = ichar(tstr(4:4))
          if (it.eq.67) then
             ianz = 6
          elseif (it.eq.78) then
             ianz = 7
          elseif (it.eq.79) then
             ianz = 8
          elseif (it.eq.80) then
             ianz = 15
          elseif (it.eq.83) then
             ianz = 16
          elseif (it.eq.72.or.it.eq.68) then
             ianz = 1
             if (it.eq.68) tstr(2:2) = 'H'
             if (tstr(2:4).eq.'HN ') tstr(2:4) = 'H  '
             if ((tstr(2:3).eq.'HA'.or.tstr(2:3).eq.'HB').and.
     &           (tstr(4:4).ne.' ')) tstr(4:4) = ' '
             if (tstr(2:3).eq.'HT'.and.(it4.ge.49.and.it4.le.51))
     &       then
                tstr(3:4) = '  '
                tstr(1:1) = tstr(4:4)
             endif
             ihashy = 1
             ish = 1
c Below convert 1H8 to H81, which not recognized by molden
c it probably served to read in force field H label variant
c             if (tstr(4:4).eq.' ') then
c                it1 = ichar(tstr(1:1))
c                it3 = ichar(tstr(3:3))
c                if ((it1.ge.49.and.it1.le.57).and.
c     &              (it3.ge.49.and.it3.le.57)) tstr(4:4) = tstr(1:1)
c             endif
          else
             ifnd = 0 
          endif
          
          if (ifnd.eq.0) then
            it = ichar(tstr(1:1))
            if (.not.(it.ge.65.and.it.le.90).and..not.
     &             (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
            do j=1,99
             if (tstr(1:2).eq.tocapf(elemnt(j))) ianz = j
            end do
            if (ianz.eq.0.and.tstr(1:1).ne.' ') then
               tstr(1:1) = ' '
               do j=1,99
                  if (tstr(1:2).eq.tocapf(elemnt(j))) 
     &                ianz = j
               end do
            endif
            if (ianz.le.0) then
               if (tstr(2:2).eq.'D'.and.tstr(2:3).ne.'DY') then
                  ianz = 1
               else
                  write(iun3,*) 'Unclassified atom =',tstr
                  write(iun3,*) lstr
                  ianz = 99
               endif
            endif
          endif

      return
      end

c
c H-Bond geometry
c Thornton, MacDonald 1994
c
c D...A < 3.9 angstrom
c H...A < 2.5 angstrom
c D-H..A > 90 degrees
c
      subroutine opthdd(lflp,lhis,lres,lwat,
     &                  iupres,nupres,irsnr,
     &                  ncalf,icalf,coo,q,iconn,ianz,iresid,iamino,
     &                  ityp,ipdbt)
      implicit double precision (a-h,o-z)
      parameter (mxres=42)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /types/ iff
      integer*2 ityp,ipdbt
      character*3 aminos
      common /amino/ aminos(mxres)
      dimension copt(3),coo(3,*),q(*),iresid(*),ityp(*),iupres(*)
      dimension iamino(*),icalf(6,*),iconn(mxcon+1,*),ipdbt(*)
      dimension irsnr(*),ianz(*)

      call curs(1)

      if (lres.eq.1) then

         print*," "
         print*,"Optimising O-H orientation of residues:"
         print*," "


         nupres = 0
      
         do i=1,iatoms
            it = ityp(i)
            ires = iresid(i)

            if (it.eq.64.or.it.eq.74.or.it.eq.137) then

               if (ires.gt.0) print*,aminos(iamino(ires)),
     &                        " ",irsnr(ires)
               if (it.eq.64) ang = 72.94d0
               if (it.eq.74) ang = 67.5d0
               if (it.eq.137) ang = 72.0d0

               call fndoh(i,ang,ires,copt,istat)
               if (istat.eq.1) then
                  nupres = nupres + 1
                  iupres(nupres) = iresid(i)
                  do j=1,3
                     coo(j,i) = copt(j)
                  end do
               endif
            endif
         end do

      endif


      ifftmp = iff

      if (lflp.eq.1) then
         call flpasn(nupres,iupres,ncalf,icalf,iamino,coo,q,
     &            iconn,ianz,iresid,irsnr,ityp)
      endif
      
      if (lhis.eq.1) then
         call hiseva(nupres,iupres,ncalf,icalf,iamino,coo,q,
     &            iconn,iresid,irsnr,ityp,ipdbt)
      endif

      iff = ifftmp

      if (lwat.eq.1) call evwat

      call curs(0)

      return
      end

      logical function chk2flp(icl,ctmp,coo,iamino)
      implicit double precision (a-h,o-z)
      parameter (mxdbl=20)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (numcal=50000)
      parameter (mxliga=200)
      common /pmfrk/ pmlig(mxliga),ipmlig(mxliga),npmlig,
     &               ipmres(numcal),npmres
      dimension iamino(*),coo(3,*),idbl(mxdbl),cgd(3),ctmp(*)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)

      toang = 0.52917706d0
      toang2 = toang*toang

      ndbl = 0
      chk2flp = .false.

      do i=1,npmres
         im = ipmres(i)
         if (im.gt.0) then
            ia = iamino(im)
            if (ia.eq.10.or.ia.eq.14) then
               if (ndbl.lt.mxdbl) then
                  ndbl = ndbl + 1
                  idbl(ndbl) = im
               endif
            endif
         endif
      end do

      icl = 0
      dmn = 10000.0d0
      dthres =  25.0d0/toang2

      do i=1,ndbl
         im = idbl(i)
         call getpdb(im,ipdb,ihpdb)
         ia = iamino(im)
         if (ia.eq.10) then
            icgd = ipdb(6)
         else
            icgd = ipdb(9)
         endif
         do j=1,3
            cgd(j) = coo(j,icgd)
         end do
         d2 = dist2(ctmp,cgd)
         if (d2.lt.dmn.and.d2.lt.dthres) then
            dmn = d2
            icl = im
         endif
      end do

      if (icl.ne.0) chk2flp = .true.

      return
      end

      subroutine sngflp(ires,iamino,coo)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension coo(3,*),iamino(*)
      dimension chn1(3),chn2(3),cot(3),cnt(3)

      call getpdb(ires,ipdb,ihpdb)

      if (iamino(ires).eq.10) then
         iat1 = ipdb(21)
         iat2 = ipdb(6)
         iat3 = ipdb(29)
         ih1 =  ihpdb(25)
         ih2 =  ihpdb(26)
      else
         iat1 = ipdb(24)
         iat2 = ipdb(9)
         iat3 = ipdb(34)
         ih1 =  ihpdb(34)
         ih2 =  ihpdb(35)
      endif

      do j=1,3
         cnt(j)  = coo(j,iat1)
         cot(j)  = coo(j,iat3)
      end do

c swap O and N

      do j=1,3
         coo(j,iat1) = cot(j)
         coo(j,iat3) = cnt(j)
      end do

      call fliph(iat3,iat2,iat1,istat,
     &           0.950d0,120.0d0,180.0d0,chn1,coo)
      call fliph(iat3,iat2,iat1,istat,
     &           0.950d0,120.0d0,0.0d0,chn2,coo)

c New H coordinates

      do j=1,3
         coo(j,ih1) = chn1(j)
         coo(j,ih2) = chn2(j)
      end do

      return
      end

      subroutine flpasn(nupres,iupres,ncalf,icalf,iamino,coo,q,
     &                  iconn,ianz,iresid,irsnr,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      character*3 resn,resd
      integer*2 ityp
      logical chk2flp,dblflp,flp1,flp2,ck2het,flipem,chkpdb,resok
      dimension ipdb(mxsym),ihpdb(mxhsym*3),iupres(*)
      dimension jpdb(mxsym),jhpdb(mxhsym*3),iflip(4)
      dimension irsnr(*),iamino(*),icalf(6,*),iresid(*),ityp(*)
      dimension coo(3,*),q(*),iconn(mxcon+1,*),ianz(*),
     &          chn1(3),chn2(3),cho1(3),cho2(3),cot(3),cnt(3),vec(3)
      dimension dhn1(3),dhn2(3),dho1(3),dho2(3),
     &          dot(3),dnt(3),scori(4),isco(5),isre(4)


      print*,' '
      print*,'ASN and GLN residue flipped if score is 4.0 '
      print*,'points lower than unflipped one'
      print*,' '

      do i=1,ncalf

         if (iamino(i).eq.10.or.iamino(i).eq.14) then

            call getpdb(i,ipdb,ihpdb)


            resok = chkpdb(ipdb,iamino(i),i,irsnr,isl)
            if (resok.and..not.ck2het(ipdb,coo,iconn,ianz,iresid)) then

               nupres = nupres + 1
               iupres(nupres) = i

c iat1 = ND2,NE2 
c iat2 = CG,CD
c iat3 = OD1,OE1

               flp1 = .false.
               flp2 = .false.
               flipem = .true.

               if (iamino(i).eq.10) then
                  iat1 = ipdb(21)
                  iat2 = ipdb(6)
                  iat3 = ipdb(29)
                  ih1 =  ihpdb(25)
                  ih2 =  ihpdb(26)
                  resn = 'ASN'
               else
                  iat1 = ipdb(24)
                  iat2 = ipdb(9)
                  iat3 = ipdb(34)
                  ih1 =  ihpdb(34)
                  ih2 =  ihpdb(35)
                  resn = 'GLN'
               endif

               iflip(1) = iat1
               iflip(2) = iat3
               iflip(3) = ih1
               iflip(4) = ih2

               do j=1,3
                  cho1(j) = coo(j,ih1)
                  cho2(j) = coo(j,ih2)
                  cnt(j)  = coo(j,iat1)
                  cot(j)  = coo(j,iat3)
               end do

c update interacting residues

               do j=1,3
                  vec(j) = coo(j,iat2)
               end do

               call intres(0,i,vec,coo,iresid,irsnr,ncalf,icalf)

c check if other asn/gln is near: DOUBLE flip

               dblflp = chk2flp(idbl,vec,coo,iamino)

               if (dblflp.and.idbl.gt.i) then
                  call getpdb(idbl,jpdb,jhpdb)
                  if (iamino(idbl).eq.10) then
                     jat1 = jpdb(21)
                     jat2 = jpdb(6)
                     jat3 = jpdb(29)
                     jh1 =  jhpdb(25)
                     jh2 =  jhpdb(26)
                     resd = 'ASN'
                  else
                     jat1 = jpdb(24)
                     jat2 = jpdb(9)
                     jat3 = jpdb(34)
                     jh1 =  jhpdb(34)
                     jh2 =  jhpdb(35)
                     resd = 'GLN'
                  endif

                  do j=1,3
                     dho1(j) = coo(j,jh1)
                     dho2(j) = coo(j,jh2)
                     dnt(j)  = coo(j,jat1)
                     dot(j)  = coo(j,jat3)
                  end do

               endif

               if ((dblflp.and.idbl.gt.i).or..not.dblflp) then

c SINGLE flip res1

                  call evflp(iflip,score1,coo,q,iresid,ityp)
                  call evqvdw(i,ih1,ih2,scor,coo,q,ityp)
                  score1 = score1 + scor

                  if (dblflp) then
                     call evqvdw(idbl,jh1,jh2,scor,coo,q,ityp)
                     score1 = score1 + scor
                  endif

c swap O and N

                  do j=1,3
                     coo(j,iat1) = cot(j)
                     coo(j,iat3) = cnt(j)
                  end do

                  call fliph(iat3,iat2,iat1,istat,
     &                       0.950d0,120.0d0,180.0d0,chn1,coo)
                  call fliph(iat3,iat2,iat1,istat,
     &                       0.950d0,120.0d0,0.0d0,chn2,coo)

c New H coordinates

                  do j=1,3
                     coo(j,ih1) = chn1(j)
                     coo(j,ih2) = chn2(j)
                  end do

                  call evflp(iflip,score2,coo,q,iresid,ityp)
                  call evqvdw(i,ih1,ih2,scor,coo,q,ityp)
                  score2 = score2 + scor

                  if (dblflp) then
                     call evqvdw(idbl,jh1,jh2,scor,coo,q,ityp)
                     score2 = score2 + scor
                  endif

                  if (.not.dblflp) then
                     if (score2.lt.score1) flp1 = .true.
                     if (flp1.and.dabs(score2-score1).lt.4.0d0) 
     &                  flp1 = .false.
                  endif

               endif

               if (dblflp.and.idbl.gt.i) then

c double flip, flip res2

c swap O and N res 2

                  do j=1,3
                     coo(j,jat1) = dot(j)
                     coo(j,jat3) = dnt(j)
                  end do

                  call fliph(jat3,jat2,jat1,istat,
     &                       0.950d0,120.0d0,180.0d0,dhn1,coo)
                  call fliph(jat3,jat2,jat1,istat,
     &                       0.950d0,120.0d0,0.0d0,dhn2,coo)

c New H coordinates res2

                  do j=1,3
                     coo(j,jh1) = dhn1(j)
                     coo(j,jh2) = dhn2(j)
                  end do

                  call evflp(iflip,score3,coo,q,iresid,ityp)
                  call evqvdw(i,ih1,ih2,scor,coo,q,ityp)
                  score3 = score3 + scor
                  call evqvdw(idbl,jh1,jh2,scor,coo,q,ityp)
                  score3 = score3 + scor

                  do j=1,3
                     coo(j,iat1) = cnt(j)
                     coo(j,iat3) = cot(j)
                     coo(j,ih1)  = cho1(j)
                     coo(j,ih2)  = cho2(j)
                  end do

                  call evflp(iflip,score4,coo,q,iresid,ityp)
                  call evqvdw(i,ih1,ih2,scor,coo,q,ityp)
                  score4 = score4 + scor
                  call evqvdw(idbl,jh1,jh2,scor,coo,q,ityp)
                  score4 = score4 + scor

                  scori(1) = score1
                  scori(2) = score2
                  scori(3) = score3
                  scori(4) = score4

                  call rqsrt(4,scori,isco)

                  do k=1,4
                     do j=1,4
                        if (k.eq.isco(j)) isre(k) = j
                     end do
                  end do

                  if (dabs(scori(isco(1))-score1).lt.4.0d0) 
     &                  flipem = .false.

                  if (score2.lt.score1.and.score2.lt.score3.and.
     &                score2.lt.score4) flp1 = .true.

                  if (score4.lt.score1.and.score4.lt.score2.and.
     &                score4.lt.score3) flp2 = .true.


                  if (score3.lt.score1.and.score3.lt.score2.and.
     &                score3.lt.score4) then
                      flp1 = .true.
                      flp2 = .true.
                  endif

               endif

               if (flp1.and.flipem) then
c flip res 1
                  do j=1,3
                     coo(j,iat1) = cot(j)
                     coo(j,iat3) = cnt(j)
                     coo(j,ih1)  = chn1(j)
                     coo(j,ih2)  = chn2(j)
                  end do

                  print*,' ' 
                  print*,' Residue ',irsnr(i),' ',resn,' Flipped'
                  print*,' ' 
                  if (.not.dblflp) then
                     print*,' Score unflipped ',score1
                     print*,' Score   flipped ',score2
                     print*,' ' 
                  endif

               else

                  do j=1,3
                     coo(j,iat1) = cnt(j)
                     coo(j,iat3) = cot(j)
                     coo(j,ih1)  = cho1(j)
                     coo(j,ih2)  = cho2(j)
                  end do

               endif

               if (dblflp.and.idbl.gt.i) then

                  if (flp2.and.flipem) then
c flip res 2
                     do j=1,3
                        coo(j,jat1) = dot(j)
                        coo(j,jat3) = dnt(j)
                        coo(j,jh1)  = dhn1(j)
                        coo(j,jh2)  = dhn2(j)
                     end do

                     print*,' ' 
                     print*,' Residue ',irsnr(idbl),' ',resd,' Flipped'
                     print*,' ' 

                  else

                     do j=1,3
                        coo(j,jat1) = dnt(j)
                        coo(j,jat3) = dot(j)
                        coo(j,jh1)  = dho1(j)
                        coo(j,jh2)  = dho2(j)
                     end do

                  endif

                  print*,' Two flippable res in contact !'
                  print*,' ' 
                  print*,'   ',irsnr(i),'    ',irsnr(idbl),
     &                      '   score'
                  print*,' ------------------------'
                  print*,' unflip  unflip ',score1,' (',isre(1),')'
                  print*,'   flip  unflip ',score2,' (',isre(2),')'
                  print*,'   flip    flip ',score3,' (',isre(3),')'
                  print*,' unflip    flip ',score4,' (',isre(4),')'
                  print*,' ------------------------'
                  print*,' ' 

               endif

            endif

         endif

      end do

      return
      end

      subroutine fndod(itar,ang,ires,copt,istat,
     &                 coo,q,iconn,ityp,iresid,irsnr,ncalf,icalf)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      integer*2 ityp
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      dimension coo(3,*),iconn(mxcon+1,*),q(*),ityp(*),icalf(6,*)
      dimension iresid(*),irsnr(*)
      dimension a(3),b(3),c(3),copt(3),u(3),v(3),w(3),or(3),ar(3),vec(3)

      istat = 0
      todeg = 45.0d0 / datan(1.0d0)
      toang = 0.52917706d0
      sang = dsin(ang/todeg)
      cang = dcos(ang/todeg)
      oh = 1.002d0/toang
      soh = sang*oh
      coh = cang*oh

      do i=1,3
         a(i) = 0.0d0
         b(i) = 0.0d0
         vec(i) = coo(i,itar)
      end do

      i2 = 0
      i3 = 0
      in = iconn(1,itar)
      do i=1,in
         inn = iconn(1+i,itar)
         if (inn.gt.0) then
            i2 = inn
            do j=1,3
               a(j) = coo(j,i2)
            end do
         endif
      end do

      if (i2.ne.0) then
         in = iconn(1,i2)
         do i=1,in
            inn = iconn(1+i,i2)
            if (inn.gt.0.and.inn.ne.itar) then
               i3 = inn
               do j=1,3
                  b(j) = coo(j,i3)
               end do
            endif
         end do
      endif

      if (i2.eq.0.or.i3.eq.0) then
         print*,'problem with connections of Hydrogen to be optimised'
         return
      endif

      call intres(itar,ires,vec,coo,iresid,irsnr,ncalf,icalf)

      do i=1,3
         v(i) = a(i) - b(i)
      end do
      
      vl = vlen(v)

      call arbper(v,ar)

      do i=1,3
         v(i) = v(i)/vl
      end do

      call crprod(v,ar,u)
      call crprod(v,u,w)

      do i=1,3
         or(i) = a(i) + v(i)*coh
      end do
      
      qh = q(itar)
      iptp = ityp(itar)
      il = ambvdt(iptp)
      vdr = ambvw1(il)
      vde = ambvw2(il)

      scoro = 10000.0d0

      do i=0,360,10
         theta = dble(i) / todeg
         st = dsin(theta)
         ct = dcos(theta)

         do j=1,3 
            c(j) = soh*ct*u(j) + soh*st*w(j) + or(j)
         end do

         call evpos(c,qh,vdr,vde,itar,i2,i3,scor,coo,q,iresid,ityp)

         if (scor.lt.scoro) then
            scoro = scor
            do j=1,3 
               copt(j) = c(j)
            end do
         endif

      end do

      istat = 1

      return
      end

      subroutine intres(itar,ires,vec,coo,iresid,irsnr,ncalf,icalf)
      implicit double precision (a-h,o-z)
      parameter (mxliga=200)
      parameter (numcal=50000)
c (mis)use pmf work array to store close residues
      common /pmfrk/ pmlig(mxliga),ipmlig(mxliga),npmlig,
     &               ipmres(numcal),npmres
      common /athlp/ iatoms, mxnat
      dimension coo(3,*),icalf(6,*),vec(3),iresid(*),irsnr(*)


      erad = 19.0d0*19.0d0

c max radius amino acid estim. 10 Angs

      npmres = 0
      do i=1,ncalf

         if ((itar.eq.0.and.ires.ne.i).or.itar.ne.0) then

            if (itar.eq.0) then
               d2 = dist2(coo(1,icalf(1,i)),vec)
            else
               d2 = dist2(coo(1,icalf(1,i)),coo(1,itar))
            endif

            if (d2.lt.erad) then
               if (npmres.lt.numcal) then
                  npmres = npmres + 1
                  ipmres(npmres) = i
               endif
            endif

         endif
      end do

      do i=1,iatoms

         if (iresid(i).lt.-3) then

            if (itar.eq.0) then
               d2 = dist2(coo(1,i),vec)
            else
               d2 = dist2(coo(1,i),coo(1,itar))
            endif

            if (d2.lt.100.0d0) then

               ido = 1
               do j=1,npmres
                  if (ipmres(j).eq.iresid(i)) ido = 0
               end do

               if (ido.eq.1) then
                  if (npmres.lt.numcal) then
                     npmres = npmres + 1
                     ipmres(npmres) = iresid(i)
                  endif
               endif
            endif

        endif
      end do

      return
      end

      subroutine evqvdw(ires,i2,i3,scor,coo,q,ityp)

c score hydrogens of NH2 group asn/gln against other H same residue
c vdw part only

      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      integer*2 ityp,iptp,ihtp
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension coo(3,*),q(*),ityp(*)

      econv = 332.05382d0
      toang = 0.52917706d0
      scor = 0.0d0
      qh = 0.4223d0

      call getpdb(ires,ipdb,ihpdb)

      do j=1,mxhsym*3

         ipat = ihpdb(j)
         if (ipat.ne.0.and.ipat.ne.i2.and.ipat.ne.i3) then
            d2 = dist2(coo(1,ipat),coo(1,i2))
            d2 = dsqrt(d2)*toang
            eqt = (econv * q(ipat) * qh / d2)
            iptp = ityp(ipat)
            ihtp = ityp(i2)

            if (iptp.gt.0.and.ihtp.gt.0) then
               il = ambvdt(ihtp)
               vdwr1 = ambvw1(il)
               vdwe1 = ambvw2(il)
               il = ambvdt(iptp)
               vdwr2 = ambvw1(il)
               vdwe2 = ambvw2(il)
               rsum = vdwr1 + vdwr2
               p6 = (rsum/d2)**6.0d0
               p12 = p6 * p6
               epsm = dsqrt(vdwe1 * vdwe2)
               scor    = scor + eqt + epsm * (p12 - 2.0d0*p6)
            endif

            d2 = dist2(coo(1,ipat),coo(1,i3))
            d2 = dsqrt(d2)*toang
            eqt = (econv * q(ipat) * qh / d2)
            ihtp = ityp(i3)

            if (iptp.gt.0.and.ihtp.gt.0) then
               il = ambvdt(ihtp)
               vdwr1 = ambvw1(il)
               vdwe1 = ambvw2(il)
               il = ambvdt(iptp)
               vdwr2 = ambvw1(il)
               vdwe2 = ambvw2(il)
               rsum = vdwr1 + vdwr2
               p6 = (rsum/d2)**6.0d0
               p12 = p6 * p6
               epsm = dsqrt(vdwe1 * vdwe2)
               scor    = scor + eqt + epsm * (p12 - 2.0d0*p6)
            endif
         endif

      end do

      return
      end 

      subroutine evpos(vec,qh,vdwr1,vdwe1,itar,i2,i3,scor,coo,q,
     &                 iresid,ityp)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      parameter (mxliga=200)
      common /pmfrk/ pmlig(mxliga),ipmlig(mxliga),npmlig,
     &               ipmres(numcal),npmres
      integer*2 ityp,iptp
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      common /athlp/ iatoms, mxnat
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension coo(3,*),q(*),ityp(*),iresid(*),vec(*)

      toang = 0.52917706d0
      econv = 332.05382d0

      eq = 0.0d0
      ev = 0.0d0

      eqmn = 10000.0d0
      eqmx = -10000.0d0
      iqmn = 0
      iqmx = 0
      irn = 0
      irx = 0

      do i=1,npmres

         if (ipmres(i).gt.0) then
            call getpdb(ipmres(i),ipdb,ihpdb)

            do j=1,mxsym

               ip = ipdb(j)
               if (ip.ne.0.and.ip.ne.i2.and.ip.ne.i3) then

                  ipat = ip
                  iptp = ityp(ipat)

                  if (iptp.gt.0) then
                     d2 = dist2(coo(1,ipat),vec)
                     d2 = dsqrt(d2)*toang
                     eqt = (econv * q(ipat) * qh / d2)
                     if (eqt.lt.eqmn) then
                         eqmn = eqt
                         iqmn = ipat
                         irn = ipmres(i)
                     endif
                     if (eqt.gt.eqmx) then
                         eqmx = eqt
                         iqmx = ipat
                         irx = ipmres(i)
                     endif
                     eq = eq + eqt

                     il = ambvdt(iptp)
                     vdwr2 = ambvw1(il)
                     vdwe2 = ambvw2(il)

                     rsum = vdwr1 + vdwr2
                     p6 = (rsum/d2)**6.0d0
                     p12 = p6 * p6
                     epsm = dsqrt(vdwe1 * vdwe2)
                     ev    = ev + epsm * (p12 - 2.0d0*p6)

                  endif

               endif
            end do

            do j=1,mxhsym*3

               if (ihpdb(j).ne.0.and.ihpdb(j).ne.itar) then
                  ipat = ihpdb(j)
                  d2 = dist2(coo(1,ipat),vec)
                  d2 = dsqrt(d2)*toang
                  eqt = (econv * q(ipat) * qh / d2)
                  if (eqt.lt.eqmn) then
                      eqmn = eqt
                      iqmn = ipat
                      irn = ipmres(i)
                  endif
                  if (eqt.gt.eqmx) then
                      eqmx = eqt
                      iqmx = ipat
                      irx = ipmres(i)
                  endif
                  eq = eq + eqt

                  iptp = ityp(ipat)
                  if (iptp.gt.0) then
                     il = ambvdt(iptp)
                     vdwr2 = ambvw1(il)
                     vdwe2 = ambvw2(il)

                     rsum = vdwr1 + vdwr2
                     p6 = (rsum/d2)**6.0d0
                     p12 = p6 * p6
                     epsm = dsqrt(vdwe1 * vdwe2)
                     ev    = ev + epsm * (p12 - 2.0d0*p6)
                  endif

               endif
            end do

         else

            do j=1,iatoms
               if (iresid(j).eq.ipmres(i)) then
                  iptp = ityp(j)
                  il = abs(iptp)

                  d2 = dist2(coo(1,j),vec)
                  d2 = dsqrt(d2)*toang
                  eqt = (econv * q(j) * qh / d2)
                  eq = eq + eqt

                  if (il.gt.mxgff) then
                     il = ambvdt(iptp)
                     vdwr2 = ambvw1(il)
                     vdwe2 = ambvw2(il)
                  else
                     vdwr2 = gfvdw(1,il)
                     vdwe2 = gfvdw(2,il)
                  endif

                  rsum = vdwr1 + vdwr2
                  p6 = (rsum/d2)**6.0d0
                  p12 = p6 * p6
                  epsm = dsqrt(vdwe1 * vdwe2)
                  ev    = ev + epsm * (p12 - 2.0d0*p6)

               endif
            end do

         endif

      end do

      scor = eq + ev

      return
      end

      logical function ck2het(ipdb,coo,iconn,ianz,iresid)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxcon=10)
      logical ismet
      dimension ipdb(mxsym)
      dimension coo(3,*),iresid(*),ianz(*),iconn(mxcon+1,*)

      ck2het = .false.

      do i=1,mxsym
         ii = ipdb(i)
         if (ii.ne.0) then
            do j=1,iconn(1,ii)
               jj = iconn(1+j,ii)
               if (jj.gt.0) then
                  if (iresid(jj).lt.-3) then
                     if (.not.ismet(ianz(jj))) ck2het = .true.
                  endif
               endif
            end do
         endif
      end do

      return
      end

      subroutine evres(ires,ipdb,ihpdb,iretyp,score,
     &                 coo,q,iresid,ityp,ncalf,icalf)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      integer*2 ityp
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension coo(3,*),q(*),ityp(*),iresid(*),icalf(6,*)

      i0 = 0
      score = 0.0d0
      scorp = 0.0d0
      scorh = 0.0d0

      if (iretyp.eq.1) then
         call typamb(ipdb,17,ihpdb,1)
      endif

      do j=1,mxsym
         i2 = 0
         i3 = 0
         if (j.eq.1) then
            if (ires.gt.1) then
               i2 = icalf(3,ires-1)
               i3 = icalf(1,ires-1)
            endif
         elseif (j.eq.2) then
            if (ires.gt.1) then
               i2 = icalf(3,ires-1)
            endif
            if (ires.lt.ncalf) then
               i3 = icalf(2,ires+1)
            endif
         elseif (j.eq.3) then
            if (ires.lt.ncalf) then
               i2 = icalf(1,ires+1)
               i3 = icalf(2,ires+1)
            endif
         endif
         if (ipdb(j).ne.0) then
            ipat  = ipdb(j)
            iptp  = ityp(ipat)
            if (iptp.gt.0) then
               il    = ambvdt(iptp)
               vdr = ambvw1(il)
               vde = ambvw2(il)
               qh    = q(ipat)
               call evpos(coo(1,ipat),qh,
     &                 vdr,vde,i0,i2,i3,scor1,coo,q,iresid,ityp)
               scorp = scorp + scor1
            endif
         endif
      end do

      do j=1,mxhsym*3
         ipat  = ihpdb(j)
         if (ipat.ne.0) then
            iptp  = ityp(ipat)
            if (iptp.gt.0) then
               il    = ambvdt(iptp)
               vdr = ambvw1(il)
               vde = ambvw2(il)
               qh    = q(ipat)
               call evpos(coo(1,ipat),qh,
     &                    vdr,vde,i0,i0,i0,scor2,coo,q,iresid,ityp)
               scorh = scorh + scor2
            endif
         endif
      end do
    
      score = scorp + scorh

      return
      end

      subroutine evflp(iflip,score,coo,q,iresid,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      integer*2 ityp
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      dimension iflip(4)
      dimension coo(3,*),q(*),ityp(*),iresid(*)

      i0 = 0
      score = 0.0d0

      do j=1,4
         jj = iflip(j)
         if (jj.ne.0) then
            iptp  = ityp(jj)
            if (iptp.gt.0) then
               il    = ambvdt(iptp)
               vdr = ambvw1(il)
               vde = ambvw2(il)
               qh    = q(jj)
               scor1 = 0.0d0
               call evpos(coo(1,jj),qh,
     &                 vdr,vde,i0,i0,i0,scor1,coo,q,iresid,ityp)
               score = score + scor1
            endif
         endif
      end do

      return
      end

      subroutine hiseva(nupres,iupres,
     &                  ncalf,icalf,iamino,coo,q,
     &                  iconn,iresid,irsnr,ityp,ipdbt)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      logical chkat
      integer*2 ityp,ipdbt
      common /athlp/ iatoms, mxnat
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      dimension ipdb(mxsym),ihpdb(mxhsym*3),iconn(mxcon+1,*),iupres(*)
      dimension coo(3,*),q(*),iamino(*),icalf(6,*),ityp(*),ipdbt(*)
      dimension iresid(*),vhd(3),vhe(3),vec3(3),icnn(mxcon),irsnr(*)

c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)

      print*,' '
      print*,'Evaluation of Histidines:'
      print*,' '

      do i=1,ncalf

         if (iamino(i).eq.17) then

            nupres = nupres + 1
            iupres(nupres) = i

c when chkat is false, you should not take average
c vhd and vhe !!

            call getpdb(i,ipdb,ihpdb)
            if (.not.chkat(ipdb(6),ipdb(13),ipdb(20),
     &                1.020d0,126.0d0,180.0d0,vhd,coo)) then
                call vclr(vhd,1,3)
            endif
            if (.not.chkat(ipdb(13),ipdb(11),ipdb(24),
     &                1.020d0,126.0d0,180.0d0,vhe,coo)) then
                call vclr(vhe,1,3)
            endif

            do j=1,3
               vec3(j) = (vhd(j) + vhe(j)) / 2.0d0
            end do

            call intres(0,i,vec3,coo,iresid,irsnr,ncalf,icalf)

c save original HD1 pointer

            ihpdb22 = ihpdb(22)
            ihpdb34 = ihpdb(34)

c HIP
            ihpdb(22) = iatoms + 1
            ihpdb(34) = iatoms + 2
            do j=1,3
               coo(j,iatoms+1) = vhd(j)
               coo(j,iatoms+2) = vhe(j)
            end do
            call evres(i,ipdb,ihpdb,1,scorep,coo,q,iresid,ityp,
     &                 ncalf,icalf)

c HID
            ihpdb(22) = iatoms + 1
            ihpdb(34) = 0
            call evres(i,ipdb,ihpdb,1,scored,coo,q,iresid,ityp,
     &                 ncalf,icalf)

c HIE
            ihpdb(22) = 0
            ihpdb(34) = iatoms + 2
            call evres(i,ipdb,ihpdb,1,scoree,coo,q,iresid,ityp,
     &                 ncalf,icalf)

            write(*,'(a,i4,a,f9.3,a,f9.3,a,f9.3)') ' his residue ',
     &        irsnr(i),' score + ',scorep,' D ',scored,' E ',scoree

c decide HID or HIE: 
c assumes HID as default

            ihis = 2
            if (scoree.lt.scored) ihis = 3

            if (ihis.eq.1) then

                ihpdb(22) = ihpdb22
                ihpdb(34) = iatoms + 1

                do j=1,3
                   coo(j,ihpdb22)  = vhd(j)
                   coo(j,iatoms+1) = vhe(j)
                end do
   
                iconn(1,iatoms+1) = 1
                iconn(2,iatoms+1) = ipdb(24)

                iconn(1,ipdb(24)) = iconn(1,ipdb(24)) + 1
                ncon = iconn(1,ipdb(24))
                iconn(1+ncon,ipdb(24)) = iatoms + 1

c dont forget iatclr etc. (ipdbt also)

                iatoms = iatoms + 1


            else if (ihis.eq.2) then

                if (ihpdb22.gt.0.and.ihpdb22.le.mxnat) then
                   ihpdb(22) = ihpdb22
                   ihpdb(34) = 0
                   ipdbt(ihpdb(22)) = 22 
                   do j=1,3
                      coo(j,ihpdb22) = vhd(j)
                   end do
                endif

            else if(ihis.eq.3) then

c connect new HE2 to NE2


                if (ihpdb22.gt.0.and.ihpdb22.le.mxnat.and.
     &             ipdb(24).ne.0) then

                   ihpdb(22) = 0
                   if (ihpdb34.ne.0) then
                      ihpdb(34) = ihpdb34
                      ipdbt(ihpdb(34)) = 34 
                   else
                      ihpdb(34) = ihpdb22
                      ipdbt(ihpdb(34)) = 34 
   
                      do j=1,3
                         coo(j,ihpdb22) = vhe(j)
                      end do
   
                      iconn(2,ihpdb22) = ipdb(24)
   
                      iconn(1,ipdb(24)) = iconn(1,ipdb(24)) + 1
                      ncon = iconn(1,ipdb(24))
                      iconn(1+ncon,ipdb(24)) = ihpdb22
   
c disconnect HD1 from ND1
   
                      ic = 0
                      ncon = iconn(1,ipdb(20))

                      do j=1,ncon
                         icon = iconn(1+j,ipdb(20))
                         if (icon.ne.ihpdb22) then
                            ic = ic + 1
                            icnn(ic) = icon
                         endif
                      end do

                      iconn(1,ipdb(20)) = ic

                      do j=1,ic
                         iconn(1+j,ipdb(20)) = icnn(j)
                      end do

                   endif

                endif

            endif

            call typamb(ipdb,17,ihpdb,1)

         endif
      end do

      print*,' '
      print*,'Molden only chooses between HID and HIE.'
      print*,'The score of HIP is only calculated'
      print*,' '

      return
      end

      subroutine sethis(ires,ihis,
     &                  coo,q,iresid,iatclr,iaton,iconn,ianz,
     &                  ncalf,icalf,ityp,ipdbt)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      logical chkat
      integer*2 ipdbt,ityp
      common /athlp/ iatoms, mxnat
      dimension ipdb(mxsym),ihpdb(mxhsym*3),iconn(mxcon+1,*)
      dimension coo(3,*),q(*),iresid(*),ianz(*)
      dimension iatclr(*),iaton(*),ityp(*),ipdbt(*),icalf(6,*)
      dimension vhd(3),vhe(3),vec3(3),icnn(mxcon)

c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)

      call getpdb(ires,ipdb,ihpdb)

      if (.not.chkat(ipdb(6),ipdb(13),ipdb(20),
     &                1.020d0,126.0d0,180.0d0,vhd,coo)) then
          call vclr(vhd,1,3)
      endif

      if (.not.chkat(ipdb(13),ipdb(11),ipdb(24),
     &                1.020d0,126.0d0,180.0d0,vhe,coo)) then
          call vclr(vhe,1,3)
      endif

      do j=1,3
         vec3(j) = (vhd(j) + vhe(j)) / 2.0d0
      end do


c save original HD1 pointer

      ihpdb22 = ihpdb(22)
      ihpdb34 = ihpdb(34)

      if (ihis.eq.1) then

c HIP
          idel = 0
          ipnt1 = ihpdb22
          ipnt2 = ihpdb34
          if (ipnt1.eq.0) ipnt1 = iatoms + 1
          if (ipnt2.eq.0) ipnt2 = iatoms + 1

          ihpdb(22) = ipnt1
          ihpdb(34) = ipnt2

          do j=1,3
             coo(j,ipnt1) = vhd(j)
             coo(j,ipnt2) = vhe(j)
          end do
   
          iresid(ipnt1) = ires
          iresid(ipnt2) = ires
          iaton(ipnt1) = 1
          iaton(ipnt2) = 1
          ianz(ipnt1) = 1
          ianz(ipnt2) = 1
          ipdbt(ipnt1) = 22 
          ipdbt(ipnt2) = 34 
          iatclr(ipnt1) = iatclr(ipdb(20))
          iatclr(ipnt2) = iatclr(ipdb(24))

          if (ihpdb34.eq.0) then

             iconn(1,ipnt2) = 1
             iconn(2,ipnt2) = ipdb(24)

             iconn(1,ipdb(24)) = iconn(1,ipdb(24)) + 1
             ncon = iconn(1,ipdb(24))
             iconn(1+ncon,ipdb(24)) = ipnt2

          endif

          if (ihpdb22.eq.0) then

             iconn(1,ipnt1) = 1
             iconn(2,ipnt1) = ipdb(20)

             iconn(1,ipdb(20)) = iconn(1,ipdb(20)) + 1
             ncon = iconn(1,ipdb(20))
             iconn(1+ncon,ipdb(20)) = ipnt1

          endif

          if (ihpdb22.eq.0.or.ihpdb34.eq.0) then
             iatoms = iatoms + 1
          endif


      else if (ihis.eq.2) then

c HID

          idel = ihpdb34
          ihpdb(34) = 0

          if (ihpdb22.ne.0) then
             ihpdb(22) = ihpdb22
             ipdbt(ihpdb(22)) = 22 
          endif

          if (ihpdb22.eq.0) then

             ihpdb(22) = ihpdb34
             ipdbt(ihpdb(22)) = 22 

             do j=1,3
                coo(j,ihpdb34) = vhd(j)
             end do

c connect new HD1 to ND1

             iconn(2,ihpdb34) = ipdb(20)

             iconn(1,ipdb(20)) = iconn(1,ipdb(20)) + 1
             ncon = iconn(1,ipdb(20))
             iconn(1+ncon,ipdb(20)) = ihpdb34

          endif

          if (ihpdb34.ne.0) then
c disconnect HE2 from NE2

             ic = 0
             ncon = iconn(1,ipdb(24))

             do j=1,ncon
                icon = iconn(1+j,ipdb(24))
                if (icon.ne.ihpdb34) then
                   ic = ic + 1
                   icnn(ic) = icon
                endif
             end do

             iconn(1,ipdb(24)) = ic

             do j=1,ic
                iconn(1+j,ipdb(24)) = icnn(j)
             end do

          endif


      else if(ihis.eq.3) then

c HIE

c connect new HE2 to NE2

          idel = ihpdb22
          ihpdb(22) = 0
          if (ihpdb34.ne.0) then
             ihpdb(34) = ihpdb34
             ipdbt(ihpdb(34)) = 34 
          endif

          if (ihpdb34.eq.0) then
             ihpdb(34) = ihpdb22
             ipdbt(ihpdb(34)) = 34 

             do j=1,3
                coo(j,ihpdb22) = vhe(j)
             end do

             iconn(2,ihpdb22) = ipdb(24)

             iconn(1,ipdb(24)) = iconn(1,ipdb(24)) + 1
             ncon = iconn(1,ipdb(24))
             iconn(1+ncon,ipdb(24)) = ihpdb22
          endif

c disconnect HD1 from ND1

          if (ihpdb22.ne.0) then
             ic = 0
             ncon = iconn(1,ipdb(20))

             do j=1,ncon
                icon = iconn(1+j,ipdb(20))
                if (icon.ne.ihpdb22) then
                   ic = ic + 1
                   icnn(ic) = icon
                endif
             end do

             iconn(1,ipdb(20)) = ic

             do j=1,ic
                iconn(1+j,ipdb(20)) = icnn(j)
             end do

          endif

      endif

      call typamb(ipdb,17,ihpdb,1)

      if (ihpdb22.ne.0.and.ihpdb34.ne.0.and.idel.ne.0) then
          call atdel(idel,coo,q,iresid,iatclr,iaton,iconn,ianz,
     &               ncalf,icalf,ityp,ipdbt)
      endif

c two problems:
c going from hid,hie to hip, a new atom is added. This is on top of the list
c above the fake atoms for the secundary structure calculation.
c best solution would be to insert it in the residue range.
c
c going the other way, we have a atom position we nolonger should use.
c However it is still there. Decreasing iatoms, is not enough. We have to move
c everything one up. There are such routines in xwin.c i think.

      return
      end

      subroutine evwad(coo,q,iresid,irsnr,iatclr,iaton,iconn,ianz,
     &                 ncalf,icalf,ityp,ipdbt,ishoh)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      integer*2 ityp,ipdbt
      common /athlp/ iatoms, mxnat
      parameter (mxliga=200)
      parameter (numcal=50000)
c (mis)use pmf work array to store close residues
      common /pmfrk/ pmlig(mxliga),ipmlig(mxliga),npmlig,
     &               ipmres(numcal),npmres
      logical ismet
      dimension coo(3,*),q(*),iresid(*),irsnr(*),ianz(*),
     &          iconn(mxcon+1,*)
      dimension iatclr(*),iaton(*),ityp(*),ipdbt(*),icalf(6,*)
      dimension idona(2),rdon(2),vec(3),copt(3)
      

      toang = 0.52917706d0
      toang2 = toang*toang
      d2hb = 3.9d0*3.9d0/toang2
      d2ha = 2.5d0*2.5d0/toang2

      print*," "
      print*,"Optimising waters:"
      print*,"Deleting waters not in contact with protein,"
      print*,"Adding hydrogens to the ones that are."
      print*," "

      natoms = iatoms

      istart = 1
      do i=1,iatoms
         if (iresid(i).eq.-ishoh.and.ianz(i).eq.8) then
             istart = i
             goto 10
         endif
      end do
10    continue


      do i=1,iatoms
         if (iresid(i).le.0.and.ianz(i).eq.100) then
             natoms = i-1
             goto 20
         endif
      end do
20    continue

      i = istart
      if (istart.gt.natoms) natoms = iatoms

      do while(i.le.natoms)

         if (iresid(i).eq.-ishoh.and.ianz(i).eq.8) then

            ic = 0
            do j=1,iconn(1,i)
               icon = iconn(1+j,i)
               if (icon.gt.0) then
                  if (.not.ismet(ianz(icon))) ic = ic + 1
               endif
            end do

c           only if O is not connected, 
c           we know this is water without H's

            if (ic.eq.0) then

               idon = 0
               iacc = 0

               do j=1,natoms
                  ia = ianz(j)
                  if (iresid(j).gt.0.and.(ia.eq.7.or.ia.eq.8)) then
                     d2 = dist2(coo(1,i),coo(1,j))

                     if (d2.le.d2hb) then

c found O,N closer than 3.9 angs from water O

                        iacct = 0
                        do k=1,iconn(1,j)
                           icon = iconn(1+k,j)
                           if (icon.gt.0.and.ianz(iabs(icon)).eq.1) then
                              d2h = dist2(coo(1,i),coo(1,icon))

c the water O is an acceptor: iacc = 1

                              if (d2h.le.d2ha) iacct = 1

                           endif
                        end do


                        if (iacct.eq.1) then
                           iacc = 1
                        else
                           if (idon.eq.0) then
                              idon = 1
                              idona(1) = j
                              rdon(1) = d2
                           else if (idon.eq.1) then
                              idon = 2
                              idont = idona(1)
                              rdont = rdon(1)
                              if (d2.lt.rdon(1)) then
                                 idona(1) = j
                                 rdon(1) = d2
                                 idona(2) = idont
                                 rdon(2) = rdont
                              else
                                 idona(2) = j
                                 rdon(2) = d2
                              endif
                           else if (idon.eq.2) then
                              idont = idona(1)
                              rdont = rdon(1)
                              if (d2.lt.rdon(1)) then
                                 idona(1) = j
                                 rdon(1) = d2
                                 idona(2) = idont
                                 rdon(2) = rdont
                              else if (d2.lt.rdon(2)) then
                                 idona(2) = j
                                 rdon(2) = d2
                              endif
                           endif
                        endif

                     endif

                  endif
               end do

c we require Owat as: 1 acceptor and 1 donor / 2 donors or more

               if (iatoms+2.gt.mxnat) then
                  print*,'No room to add new hydrogens !'
                  return
               endif

               if (iacc.ge.2.or.idon.eq.2.or.
     &             (iacc.eq.1.and.idon.eq.1)) then

c              calculate vector from donor to Owat

                  do k=1,3
                     vec(k) = coo(k,i) - coo(k,idona(1))
                  end do

                  vl = vlen(vec)

                  do k=1,3
                     coo(k,iatoms+1) = coo(k,i) - 
     &                                 0.957*vec(k)/(vl*toang)
                  end do

                  iconn(1,i) = 1
                  iconn(2,i) = iatoms + 1

                  iconn(1,iatoms+1) = 1
                  iconn(2,iatoms+1) = i

                  ianz(iatoms+1) = 1
                  iatclr(iatoms+1) = 1
                  iaton(iatoms+1) = iaton(i)
                  q(iatoms+1) =  0.4710d0
                  ityp(iatoms+1) = 650
                  iresid(iatoms+1) = iresid(i)

                  iatoms = iatoms + 1

                  q(i) = -0.8340d0
                  ityp(i) = 649

                  ang = 75.48
                  ires = iresid(i)

                  iconn(1,i) = 2
                  iconn(3,i) = iatoms + 1
 
                  iconn(1,iatoms+1) = 1
                  iconn(2,iatoms+1) = i

                  ianz(iatoms+1) = 1
                  iatclr(iatoms+1) = 1
                  iaton(iatoms+1) = iaton(i)
                  q(iatoms+1) =  0.4710d0
                  ityp(iatoms+1) = 650
                  iresid(iatoms+1) = iresid(i)

c set temporary coordinates to water  O 

                  do j=1,3
                        coo(j,iatoms+1) = coo(j,i)
                  end do

                  call fndod(iatoms+1,ang,ires,copt,istat,
     &                       coo,q,iconn,ityp,iresid,irsnr,ncalf,icalf)

                  if (istat.eq.1) then

                     do j=1,3
                        coo(j,iatoms+1) = copt(j)
                     end do

                     iatoms = iatoms + 1

                  endif

                  i = i + 1

               else

c throw away this water Oxygen

                  call atdel(i,coo,q,iresid,iatclr,iaton,iconn,ianz,
     &                       ncalf,icalf,ityp,ipdbt)
                  if (i.gt.iatoms) return

               endif

            else
               i = i + 1
            endif

         else
            i = i + 1
         endif

      end do

      return
      end

      subroutine atdel(iat,coo,q,iresid,iatclr,iaton,iconn,ianz,
     &                 ncalf,icalf,ityp,ipdbt)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      integer*2 ityp,ipdbt
      common /athlp/ iatoms, mxnat
      parameter (numcal=50000)
      dimension coo(3,*),q(*),iresid(*),ianz(*),
     &          iconn(mxcon+1,*)
      dimension iatclr(*),iaton(*),ityp(*),ipdbt(*),icalf(6,*)

      do j=1,iatoms-1

         if (j.lt.iat) then

            do k=1,iconn(1,j)
               icon = iconn(1+k,j)
               if (icon.lt.0) then
                  if (iabs(icon).lt.iat) then
                     iconn(1+k,j) = icon
                  else
                     iconn(1+k,j) = icon + 1
                  endif
               else
                  if (icon.lt.iat) then
                     iconn(1+k,j) = icon
                  else
                     iconn(1+k,j) = icon - 1
                  endif
               endif
            end do

         else

            j1 = j + 1

            do k=1,3
               coo(k,j) = coo(k,j1)
            end do

            iconn(1,j) = iconn(1,j1)

            do k=1,iconn(1,j1)
               icon = iconn(1+k,j1)
               if (icon.lt.0) then
                  if (iabs(icon).lt.iat) then
                     iconn(1+k,j) = icon
                  else
                     iconn(1+k,j) = icon + 1
                  endif
               else
                  if (icon.lt.iat) then
                     iconn(1+k,j) = icon
                  else
                     iconn(1+k,j) = icon - 1
                  endif
               endif
            end do
   
            ianz(j)   = ianz(j1)
            iatclr(j) = iatclr(j1)
            iaton(j)  = iaton(j1)
            q(j)      = q(j1)
            ityp(j)   = ityp(j1)
            ipdbt(j)  = ipdbt(j1)
            iresid(j) = iresid(j1)
                     
         endif
      end do

      do k=1,ncalf
         if (icalf(1,k).gt.iat) 
     &       icalf(1,k) = icalf(1,k) - 1
         if (icalf(4,k).gt.iat) 
     &       icalf(4,k) = icalf(4,k) - 1
      end do

      iatoms = iatoms - 1

      return
      end

      subroutine quwad(nwat,iresid,iconn,ianz)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension iresid(*),ianz(*),iconn(mxcon+1,*)
      
      nwat = 0

      do i=1,iatoms

         if (iresid(i).lt.-3.and.ianz(i).eq.8) then

            ic = 0
            do j=1,iconn(1,i)
               icon = iconn(1+j,i)
               if (icon.gt.0) ic = ic + 1
            end do

            if (ic.eq.0) nwat = nwat + 1

         endif

      end do

      return
      end

      subroutine velind(coo,g,v,a,mass)
      implicit real (a-h,o-z), integer (i-n)
      real mass
      common /athlp/   iatoms, mxnat
      common /mdopt/ dt,temp,tau,nstep,ndump,nfree,idumv
      common /mdconv/ convert, gasconst, boltzmann, pi
      integer taskid
      common /mpih/ nproc,taskid
cmpi      include 'mpif.h'
cmpi      integer status(mpi_status_size)
      logical opfil
      dimension vec(3),coo(3,*),v(3,*),a(3,*),g(3,*),mass(*)

      call enegrd(ene,coo,g)

cmpi      call mpi_comm_rank(mpi_comm_world, taskid, ierr)


      do i=1,iatoms

            beta = sqrt(mass(i) / (2.0e0*boltzmann*temp))
            rho = random()
            xs  = erfinv(rho) / beta
            rho = random()
            ys  = erfinv(rho) / beta
            rho = random()
            zs  = erfinv(rho) / beta
            speed = sqrt(xs**2 + ys**2 + zs**2)

            call runitv(vec)

            do j=1,3
                v(j,i) = speed * vec(j)
            end do

      end do

cmpi      if (nproc.gt.1.and.taskid.eq.0) then
         if (idumv.eq.1) then
            if (opfil(53,'velos',5,1,0,0)) then
                do i=1,iatoms
                   write(53,'(3(f13.7,1x))') (v(j,i),j=1,3)
                end do
                close(53)
            endif
         else if (idumv.eq.-1) then
            if (opfil(53,'velos',5,1,1,0)) then
                do i=1,iatoms
                   read(53,'(3(f13.7,1x))') (v(j,i),j=1,3)
                end do
                close(53)
            endif
         endif
cmpi      endif

      do i=1,iatoms
         do j=1,3
             a(j,i) = convert * g(j,i) / mass(i)
         end do
      end do

cmpi      if (taskid.eq.0) then
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(v, 3*iatoms, mpi_real, it, 15,
cmpi     &                    mpi_comm_world, ierr)
cmpi         end do
cmpi      else
cmpi         call mpi_recv(v, 3*iatoms, mpi_real, 0, 15,
cmpi     &                    mpi_comm_world, status, ierr)
cmpi      endif

cmpi      if (taskid.eq.0) then
cmpi         do it=1, nproc - 1
cmpi            call mpi_send(a, 3*iatoms, mpi_real, it, 16,
cmpi     &                    mpi_comm_world, ierr)
cmpi         end do
cmpi      else
cmpi         call mpi_recv(a, 3*iatoms, mpi_real, 0, 16,
cmpi     &                    mpi_comm_world, status, ierr)
cmpi      endif


      return
      end

      subroutine verled(istep,coo,g,v,a,mass,ityp)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxion=2000)
      real mass
      integer*2 ityp
      logical osingl,dolbfgs,oqscal
      common /athlp/  iatoms, mxnat
      common /mdopt/ dt,temp,tau,nstep,ndump,nfree,idumv
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      common /mdconv/ convert, gasconst, boltzmann, pi
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/  numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      common /cyctmp/ icyc
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension coo(3,*),v(3,*),g(3,*),a(3,*),mass(*),ityp(*)

      dt_2  = dt / 2.0e0
      dt2_2 = dt * dt_2
 
c     store the current atom positions, then find new atom
c     positions and half-step velocities via Verlet recursion
 
      do i=1,iatoms

         do j=1,3
            coo(j,i) = coo(j,i) + v(j,i)*dt + a(j,i)*dt2_2
         end do

         do j=1,3
            v(j,i) = v(j,i) + a(j,i)*dt_2
         end do

      end do

      if (box.and.(mod(istep,2).eq.0.or.istep.eq.nstep)) 
     &        call appbnd(coo,ityp)

      if (box.and.fast) then
          if (mod(istep,6).eq.0) call watlst(niwat)
      endif

      call enegrd(ene,coo,g)
 
c     find the full-step velocities using the Verlet recursion
 
      do i=1,iatoms
          do j=1,3
c             a(j,i) = -convert * g(j,i) / mass(i)
             a(j,i) = convert * g(j,i) / mass(i)
             v(j,i) = v(j,i) + a(j,i)*dt_2
          end do
      end do
 
c     calculate the kinetic energy
 
      call kinetic(emv2,v,mass)
 
c     from kinetic energy calculate instantaneous temperature
c     make temperature corrections via berendsen thermostat
 
      call thermst(emv2,v)

      etot = emv2 + ene

      if (mod(istep,ndump).eq.0) then
         call wrtout(iun4,etot)
         icyc = icyc + 1
         if (imon.ne.0) call wrmon(icyc,etot)
      endif

      return
      end

      subroutine kinetic(emv2,v,mass)
      implicit real (a-h,o-z), integer (i-n)
      real mass
      common /mdconv/ convert, gasconst, boltzmann, pi
      common /athlp/  iatoms, mxnat
      dimension ekin(3,3),v(3,*),mass(*)

      emv2 = 0.0e0

      do i = 1, 3
         do j = 1, 3
            ekin(j,i) = 0.0e0
         end do
      end do

      do i=1,iatoms

          term = 0.5e0 * mass(i) / convert

          do j=1,3

             do k=1,3
                value = term * v(j,i) * v(k,i)
                ekin(k,j) = ekin(k,j) + value
             end do

          end do

      end do

      emv2 = ekin(1,1) + ekin(2,2) + ekin(3,3)

      return
      end


      subroutine thermst(emv2,v)
      implicit real (a-h,o-z), integer (i-n)
      common /mdopt/ dt,temp,tau,nstep,ndump,nfree,idumv
      common /mdconv/ convert, gasconst, boltzmann, pi
      common /athlp/  iatoms, mxnat
      dimension v(3,*)

c     scale velocities to satisfy Berendsen thermostat
c     instantaneous temperature from the kinetic energy

      tmpi = 2.0e0 * emv2 / (dble(nfree) * gasconst)

c     scale velocities

      if (tmpi.ne.0.0e0) then
         scale = sqrt(1.0e0 + (dt/tau)*(temp/tmpi-1.0e0))
      else
         scale = 1.0e0
      endif

      do i=1,iatoms

         do j=1,3
            v(j,i) = scale * v(j,i)
         end do

      end do

      return
      end

      subroutine assmad(ityp,mass)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      real mass
      integer*2 ityp
      dimension mass(*),ityp(*)
      common /masses/  ambmas(mxamb),gffmas(mxgff)
      common /athlp/   iatoms, mxnat

      do i=1,iatoms
         it = abs(ityp(i))
         if (ityp(i).gt.0) then
            mass(i) = ambmas(it)
         endif
         if (ityp(i).lt.0) then
            mass(i) = gffmas(it)
         endif
      end do

      return
      end

      subroutine pl3dm(adjus,ovis,height)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      character str*100
      real xx, yy
      logical ovis
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /atopla/ xsym(numatm),ysym(numatm),zsym(numatm),
     &                isym(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plot/   iplot,iplwin,icolps
      common /zproj/  zval(numatm),nindx(numatm),nconn(numatm)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)

c     Plot Molecule in the 3d mode

      if (iplot.eq.1) write(iun4,'(a)') 'SP2;'

      if (iplot.eq.4) then
         if (.not.(icolps.eq.1.and.ovis)) 
     &      write(iun4,'(''0.5 setgray'')')
         write(iun4,'(''14 setlinewidth'')')
         write(iun4,'(''1 setlinecap'')')
      endif

      if (iplot.eq.6) then
         xx = 4.0
         call xwin(xx,yy,10,str,nstr,idum1,idum2)
         call xwin(xx,yy,8,str,nstr,idum1,idum2)
      endif

      do m=1,natoms
         i = m
         if (ovis) i = nindx(m)
         xa = 0.5d0 + xsym(i) / r(1)
         ya = 0.5d0 + ysym(i) / r(2)
         za = zsym(i) / r(3)

         do j=1,natoms
            dmaxsq = (vdwr(nat(i)) + vdwr(nat(j)))**2
            dijsq = ((xyz(1,i)-xyz(1,j))*adjus)**2
     +             +((xyz(2,i)-xyz(2,j))*adjus)**2
     +             +((xyz(3,i)-xyz(3,j))*adjus)**2
            if (dijsq.lt.dmaxsq) then
               if (iplot.eq.6) then
                  if (isym(i).eq.1.and.isym(j).eq.1) then
                     xx = 12.0
                     call unstip
                  else
                     xx = 11.0
                     call ststip
                  endif
                  yy = 0.0
                  call xwin(xx,yy,99,str,nstr,idum1,idum2)
               endif
               xb = 0.5d0 + xsym(j) / r(1)
               yb = 0.5d0 + ysym(j) / r(2)
               zb = zsym(j) / r(3)
               if (.not.ovis) then
                  call euler(xa,ya,za,1)
                  call euler(xb,yb,zb,2)
               else
                 if (zval(i).le.zval(j)) then
                  xt = (xb - xa)/2.0d0 + xa
                  yt = (yb - ya)/2.0d0 + ya
                  zt = (zb - za)/2.0d0 + za

                  isend = 0
                  if (nconn(i).eq.1) isend = 1

                  if (iplot.eq.6) then
                     xx = icol(nat(i))
                     call xwin(xx,yy,99,str,nstr,idum1,idum2)
                  elseif (iplot.eq.4.and.icolps.eq.1) then
                     icolt = icol(nat(i))
                  endif

                  if (za.le.height.and.zt.le.height) then
                     if (iplot.eq.4.and.icolps.eq.1) then
                        call psbond(xa,ya,za,xt,yt,zt,icolt,isend)
                     else
                        call euler(xa,ya,za,1)
                        call euler(xt,yt,zt,2)
                     endif
                  elseif (za.le.height) then
                     call snypnt(xa,ya,za,xt,yt,zt,height,sx,sy,sz)
                     if (iplot.eq.4.and.icolps.eq.1) then
                        call psbond(xa,ya,za,sx,sy,sz,icolt,isend)
                     else
                        call euler(xa,ya,za,1)
                        call euler(sx,sy,sz,2)
                     endif
                  elseif (zt.le.height) then
                     call snypnt(xa,ya,za,xt,yt,zt,height,sx,sy,sz)
                     if (iplot.eq.4.and.icolps.eq.1) then
                        call psbond(xt,yt,zt,sx,sy,sz,icolt,0)
                     else
                        call euler(xt,yt,zt,1)
                        call euler(sx,sy,sz,2)
                     endif
                  endif

                  isend = 0
                  if (nconn(j).eq.1) isend = 1

                  if (iplot.eq.6) then
                     xx = icol(nat(j))
                     call xwin(xx,yy,99,str,nstr,idum1,idum2)
                  elseif (iplot.eq.4.and.icolps.eq.1) then
                     icolt = icol(nat(j))
                  endif

                  if (zb.le.height.and.zt.le.height) then
                     if (iplot.eq.4.and.icolps.eq.1) then
                        call psbond(xb,yb,zb,xt,yt,zt,icolt,isend)
                     else
                        call euler(xb,yb,zb,1)
                        call euler(xt,yt,zt,2)
                     endif
                  elseif (zb.le.height) then
                     call snypnt(xb,yb,zb,xt,yt,zt,height,sx,sy,sz)
                     if (iplot.eq.4.and.icolps.eq.1) then
                        call psbond(xb,yb,zb,sx,sy,sz,icolt,isend)
                     else
                        call euler(xb,yb,zb,1)
                        call euler(sx,sy,sz,2)
                     endif
                  elseif (zt.le.height) then
                     call snypnt(xb,yb,zb,xt,yt,zt,height,sx,sy,sz)
                     if (iplot.eq.4.and.icolps.eq.1) then
                        call psbond(xt,yt,zt,sx,sy,sz,icolt,0)
                     else
                        call euler(xt,yt,zt,1)
                        call euler(sx,sy,sz,2)
                     endif
                  endif
                 endif
               endif
            endif 
         end do
      end do

      if (iplot.eq.6) then
         call unstip
         xx = 1.0
         call xwin(xx,yy,10,str,nstr,idum1,idum2)
         call xwin(xx,yy,8,str,nstr,idum1,idum2)
      endif

      if (iplot.eq.4) then
         if (.not.(icolps.eq.1.and.ovis)) write(iun4,'(''s'')')
         write(iun4,'(''0 setgray'')')
         write(iun4,'(''n'')')
      endif

      return
      end

      subroutine psbond(px,py,pz,qx,qy,qz,icol,icap)
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plot / iplot,iplwin,icolps

      call pstran(px,py,pz,ix,iy)
      call pstran(qx,qy,qz,jx,jy)

      if (ix.eq.jx.and.iy.eq.jy) return

      write(iun4,*)'/col ',icol,' def'
      if (icap.eq.0) then
         write(iun4,*) ix,iy,jx,jy,' dobond'
      else
         write(iun4,*) ix,iy,jx,jy,ix,iy,' dobond2'
      endif

      return
      end

      subroutine pstran(px,py,pz,ix,iy)
      implicit double precision (a-h,o-z)
      logical euclid,yes
      common /cntval/ cntval, euclid, yes, icnt, iflag

      call eulerh(px,py,pz,cx,cy)

      if (euclid) then
         r2 = 1.0d0
      else
         r2 = dsqrt(2.0d0)
      endif
      cx = 0.5d0 + cx / r2
      cy = 0.5d0 + cy / r2

      cx = max(0.d0,min(1.d0,cx))
      cy = max(0.d0,min(1.d0,cy))

      ix = int(cx*2000)
      iy = int(cy*2000)+125

      return
      end

      double precision function rmomen(b)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (maxfat=1000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat

      dimension temp(3),rmom(3),b(3,numat1)

      call rotcor(b)

      do j=1,3
          rmom(j) = 0.0d0
      end do

      do i=1,iatoms
        call crpros(b(1,i),fxyz(1,i),temp)
        do j=1,3
           rmom(j) = rmom(j) + temp(j)
        end do
      end do

      rmomen = vlen(rmom)

      return
      end

      subroutine rotmod(ipoint,ifav,coo)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (maxfat=1000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat

      common/rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg
      parameter (maxpt=1000)
      common /savcor/ angs(3,maxpt),idon(maxpt)
      common /gamori/imap(numat1),cstand(3,numat1),istand(numat1),
     &               msucc
      dimension angle(3),cori(3,numat1),ftemp(3,numat1),coo(3,*)

      if (ipoint .gt. maxpt) return

      todeg=45.0d0/datan(1.0d0)
      delold=1.0d5

      amat(1,3)=0.0d0
      amat(2,3)=0.0d0
      amat(3,1)=0.0d0
      amat(3,2)=0.0d0
      amat(3,3)=1.0d0

      bmat(1,2)=0.0d0
      bmat(2,1)=0.0d0
      bmat(2,2)=1.0d0
      bmat(2,3)=0.0d0
      bmat(3,2)=0.0d0

      cmat(1,1)=1.0d0
      cmat(1,2)=0.0d0
      cmat(1,3)=0.0d0
      cmat(2,1)=0.0d0
      cmat(3,1)=0.0d0

c     put forces in correct order

      if (ifav.eq.1) then

         do i=1,iatoms
            do j=1,3
               ftemp(j,i) = fxyz(j,imap(i))
            end do 
         end do
   
         do i=1,iatoms
            do j=1,3
               fxyz(j,i) = ftemp(j,i)
            end do 
         end do

      endif

c     check if point already done

      if (idon(ipoint).eq.1) then

          do j=1,3
             angle(j) = angs(j,ipoint)
          end do

          goto 100

      endif

      if (ifav.eq.0) then

          do j=1,3
             angle(j) = angs(j,ipoint-1)
             angs(j,ipoint) = angs(j,ipoint-1)
          end do

          idon(ipoint) = 1
          goto 100

      endif

c----- start of medium search ----

      alco = angs(1,1)
      beco = angs(2,1)
      gaco = angs(3,1)

      do ia=1,21

         angle(1) = alco + dfloat(ia-1) - 10.0d0
         call rota(angle(1))

         do ib=1,21

            angle(2) = beco + dfloat(ib-1) - 10.0d0
            call rotb(angle(2))

            do ic=1,21

               angle(3) = gaco + dfloat(ic-1) - 10.0d0
               call rotc(angle(3))
               delta = rmomen(cori)

               if (delta.lt.delold) then
                 delold = delta
                 alopt  = angle(1)
                 beopt  = angle(2)
                 gaopt  = angle(3)
               endif

            end do

         end do

      end do

c----- end of medium search ------

c----- start of fine search ----

      alco = alopt
      beco = beopt
      gaco = gaopt

      do ia=1,21

         angle(1) = alco + dfloat(ia-1)*0.1d0 - 1.0d0
         call rota(angle(1))

         do ib=1,21

            angle(2) = beco + dfloat(ib-1)*0.1d0 - 1.0d0
            call rotb(angle(2))

            do ic=1,21

               angle(3) = gaco + dfloat(ic-1)*0.1d0 - 1.0d0
               call rotc(angle(3))
               delta=rmomen(cori)

               if (delta.lt.delold) then
                 delold = delta
                 alopt  = angle(1)
                 beopt  = angle(2)
                 gaopt  = angle(3)
               endif

            end do

         end do

      end do

c----- end of fine search ------
c     final angles

      angle(1)=alopt
      angle(2)=beopt
      angle(3)=gaopt

      idon(ipoint) = 1

      do j=1,3
         angs(j,ipoint) = angle(j)
      end do

100   continue

      call rota(angle(1))
      call rotb(angle(2))
      call rotc(angle(3))
      call rotcor(cori)

      do i=1,iatoms
         do j=1,3
            coo(j,i) = cori(j,i)
         end do
      end do

      return
      end

      subroutine datid(npts1,npts2,npts3,
     &                 ncols,ncolb,focc,focb,eiga,eigb)
c
c THIS IS REALLY datin
c
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      logical valenc,bonds,ovrlap,atomic,doori,ostep,
     &        fine,oscal,dolap,doelf
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /keywrd/ keywrd,keyori
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      character*320 keywrd,keyori
      logical keyi,keyr
      real eiga,eigb
      dimension focc(*),focb(*),eiga(*),eigb(*)

      write(iun3,'(80(''*''))')
      write(iun3,'(''   DATA  PROVIDED BY INPUT FILE '')')

c----- Proces PlotPlane keywords -------------------------------

      call planky(npts1,npts2,npts3,keywrd,.true.)

      if (keyr(keywrd,'CUT',cut)) then
         if ((cut.gt.1.0d0).or.(cut.lt.0.0d0)) then
             cut = min(max(0.0d0,cut),1.0d0)
             call inferr('ERROR  0.0 <= CUT <= 1.0 ',1)
         endif
      endif

c---- use negative numbers to specify beta orbital with uhf

      imos = 0      
      ipsi = 0

      if (keyi(keywrd,'PSI',ipsi)) then
          if ((ipsi.gt.0.and.ipsi.gt.ncols).or.
     &        (ipsi.lt.0.and.iabs(ipsi).gt.ncolb)) then
             call inferr('Invalid Orbital Number!',1)
          else
             imos = imos + 1
          endif
      endif

      i=index(keywrd,'SPINDENS')
      if (i.ne.0) ispd = 1

      i=index(keywrd,'HOMO')
      if (i.ne.0) then
          imos = imos + 1
          call homo(ipsi)
      endif
      i=index(keywrd,'LUMO')
      if (i.ne.0) then
          imos = imos + 1
          call lumo(ipsi)
      endif
      if (imos.gt.1) then
*
*   MADE A MISTAKE
* 
          call inferr('INCOMPATIBLE KEY-WORDS !',1)
      endif
c
c----- the occupancy directive -----------------------

      call occup(istat)
      if (istat.eq.1) ipsi = 0

      write(iun3,'(80(''*''))')
      return
      end

      subroutine occupd(istat,focc,focb)
c
c----- the occupancy directive -----------------------
c----- example occu = (1-22/0,9/1.0,10/2 ) 
c----          sets occupancies of orbital 1 through 22 to zero
c----                                      9 to 1
c----                                     10 to 2
c----          in sequential order
c
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /keywrd/ keywrd,keyori
      character*320 keywrd,keyori
      dimension focc(*),focb(*)

      istat = 0

      i = index(keywrd,'OCCU')
      if (i.ne.0) then
          call occin(i,focc,norbs)
          istat = 1
      endif

      i = index(keywrd,'OCCA')
      if (i.ne.0) then
          call occin(i,focc,norbs)
          istat = 1
      endif

      i = index(keywrd,'OCCB')
      if (i.ne.0) then
          call occin(i,focb,norbs)
          istat = 1
      endif

      return
      end

      subroutine homod(ipsi,focc,focb,eiga,eigb)
      implicit double precision (a-h,o-z)
      common /orbhlp/ mxorb,iuhf,ispd
      real eiga,eigb
      dimension focc(*),focb(*),eiga(*),eigb(*)

      ipsi = 0

      if (iuhf.eq.1) then
         ipsa = 0
         do ii = 1,mxorb
            if (focc(ii).eq.0.0d0.and.ipsa.eq.0) ipsa = ii - 1
         end do
         ipsb = 0
         do ii = 1,mxorb
            if (focb(ii).eq.0.0d0.and.ipsb.eq.0) ipsb = ii - 1
         end do
         if (eiga(ipsa).lt.eigb(ipsb)) then
            ipsi = -ipsb
         else
            ipsi = ipsa
         endif
      else
         do ii = 1,mxorb
           if (focc(ii).eq.0.0d0.and.ipsi.eq.0) ipsi = ii - 1
         end do
      endif

      return
      end

      subroutine lumod(ipsi,focc,focb,eiga,eigb)
      implicit double precision (a-h,o-z)
      common /orbhlp/ mxorb,iuhf,ispd
      real eiga,eigb
      dimension focc(*),focb(*),eiga(*),eigb(*)

      ipsi = 0

      if (iuhf.eq.1) then
         ipsa = 0
         do ii = 1,mxorb
            if (focc(ii).eq.0.0d0.and.ipsa.eq.0) ipsa = ii
         end do
         ipsb = 0
         do ii = 1,mxorb
            if (focb(ii).eq.0.0d0.and.ipsb.eq.0) ipsb = ii
         end do
         if (eiga(ipsa).lt.eigb(ipsb)) then
            ipsi = ipsa
         else
            ipsi = -ipsb
         endif
      else
         do ii = 1,mxorb
           if (focc(ii).eq.0.0d0.and.ipsi.eq.0) ipsi = ii 
         end do
      endif

      return
      end

      subroutine wrtoud(iun,emin,iconn,ityp,coo,q,iopt)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxcon=10)
      parameter (numres=50000)
      common /athlp/ iatoms, mxnat
      integer*2 ityp
      character*3 chtmp,ambstr
      character*2 gffstr
      common /ffstr/ ambstr(mxamb), gffstr(mxgff)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /prot/ ireswr
      integer taskid
      common /mpih/ nproc,taskid
      character*3 hetz
      common /resstr/ hetz(numres)
      dimension icnn(mxcon)
      dimension coo(3,*),q(*),iconn(mxcon+1,*),ityp(*),iopt(*)

      if (nproc.gt.1.and.taskid.ne.0) return

c write tinker .xyz file

      if (box) then
         write(iun,'(a,3(f9.3,1x))') 
     &      '[AMBFOR] box ',abc(1),abc(2),abc(3)
      else
         if (cell) then
            call getcel(abc(1),abc(2),abc(3),alpha,beta,gamma)
            write(iun,'(a,6(f9.3,1x))') 
     &      '[AMBFOR] cell ',abc(1),abc(2),abc(3),alpha,beta,gamma
         else
            write(iun,*) '[AMBFOR]'
         endif
      endif

      write(iun,'(i5,a,f15.3,a)') iatoms,' emin ',emin,
     &   '  AMBFOR/AMBMD generated .xyz (amber/gaff param.)'

      do i=1,iatoms

            ibnds = 0
            do j=1,iconn(1,i)
               if (iconn(j+1,i).gt.0) then
                  ibnds = ibnds + 1
                  icnn(ibnds) = iconn(j+1,i)
               endif
            end do

            itypi = ityp(i)

            if (itypi.gt.0) then

c Amber
                if (itypi.le.mxamb) then
                  chtmp = ambstr(itypi)
                  if (itypi.gt.mxamb) itypi = itypi + (2000-mxamb)
                endif

                write(iun,'(i6,2x,a3,1x,3(f10.5),1x,i4,8(1x,i6))')
     &            iopt(i),chtmp,(coo(j,i),j=1,3),
     &            itypi,(icnn(j),j=1,ibnds)

            elseif (ityp(i).lt.0) then

c GAFF
                if (iabs(itypi).le.mxgff) then
                  chtmp = gffstr(iabs(itypi))//' '
                endif

                write(iun,
     &            '(i6,2x,a3,1x,3(f10.5),1x,i4,1x,f6.3,8(1x,i6))')
     &            iopt(i),chtmp,(coo(j,i),j=1,3),
     &            itypi,q(i),(icnn(j),j=1,ibnds)
            endif


      end do

      if (iun.eq.iun3.or.(iun.eq.iun4.and.ireswr.eq.0)) then

         write(iun,'(a)') '[RESIDUES]'

         do i=1,ihsres
            if (hetz(i).ne."   ") then
               write(iun,'(i6,1x,i6,1x,a3)') ires(i),ibeg(i),hetz(i)
            else
               write(iun,'(i6,1x,i6)') ires(i),ibeg(i)
            endif
         end do

         if (iun.eq.iun4) ireswr = 1

      endif

      return
      end

      subroutine wrtbid(iun,emin,coo)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /athlp/ iatoms, mxnat
      logical box,cell,fast,addbox
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension coo(3,*)

c write tinker coordinates binary form

      write(iun) iatoms,emin

      do i=1,iatoms
           write(iun) (coo(j,i),j=1,3)
      end do

      if (cell) then
           call getcel(abc(1),abc(2),abc(3),alpha,beta,gamma)
           write(iun) abc(1),abc(2),abc(3),alpha,beta,gamma
      endif

      return
      end

      subroutine opfiles
      implicit real (a-h,o-z)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character fniun*132
      common /fnam/ fniun, lenf
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      character fniunt*132
      logical opfil, osingl,dolbfgs,oqscal

      fniunt = fniun(1:lenf)//'.xyz'
      lenft = lenf + 4

      if (opfil(48,fniunt,lenft,1,1,0)) then
         iun2 = 48
         if (iout.eq.1) then
            fniunt = fniun(1:lenf)//'_opt.xyz'
            lenft = lenf + 7
            if (opfil(50,fniunt,lenft,1,0,0)) then
               iun3 = 50
            else
               print*,'Cant open output file !'//fniunt(1:lenft)
               stop
            endif
         endif

         if (iarc.eq.1) then
            fniunt = fniun(1:lenf)//'.arc'
            lenft = lenf + 4
            if (opfil(60,fniunt,lenft,1,0,0)) then
               iun4 = 60
            else
               print*,'Cant find/open arc file !'//fniunt(1:lenft)
               stop
            endif
         endif

         if (ilog.eq.1) then
            fniunt = fniun(1:lenf)//'.log'
            lenft = lenf + 4
            if (opfil(70,fniunt,lenft,1,0,0)) then
               iun5 = 70
            else
               print*,'Cant find/open log file !'//fniunt(1:lenft)
               stop
            endif
         else
            iun5 = 6
         endif

      else
         print*,'Cant find/open file !'//fniunt(1:lenft)
         stop
      endif

      return
      end

      logical function opfil(iun,filenm,lenfn,iform,iold,isil)
      implicit real (a-h,o-z)
      character*(*) filenm
      character*7 stat

      opfil = .true.

      if (iold.eq.1) then
          stat = 'old'
      else
          stat = 'unknown'
      endif

      if (lenfn.eq.0.or.filenm.eq.' ') then
          print*, 'Invalid Filename !'
          opfil = .false.
      else
          close(iun)
          if (iform.eq.1) then
             open(unit=iun,form='formatted',file=filenm,
     &               status=stat,err=100)
          else
             open(unit=iun,form='unformatted',file=filenm,
     &               status=stat,err=100)
          endif
      endif

      return

100   if (isil.eq.0) print*,'Error Opening File !'

      opfil = .false.
      return
      end

      subroutine wrmod(ncyc,emin)
      implicit real (a-h,o-z), integer (i-n)
      character fniun*132
      common /fnam/ fniun, lenf
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      integer taskid
      common /mpih/ nproc,taskid
      character*20 ambfil
      character*3 tstr
      character*4 ttstr
      character*5 tttstr
      logical opfil, osingl,dolbfgs,oqscal

      if (nproc.gt.1.and.taskid.ne.0) return

      jlen = lenf
      if (ncyc.lt.1000) then
         call zerstr(ncyc,tstr,3)
         ambfil = fniun(1:lenf)//'.'//tstr
         jlen = jlen + 1 + 3
      elseif (ncyc.lt.10000) then
         write(ttstr,'(i4)') ncyc
         ambfil = fniun(1:lenf)//'.'//ttstr
         jlen = jlen + 1 + 4
      elseif (ncyc.lt.100000) then
         write(tttstr,'(i5)') ncyc
         ambfil = fniun(1:lenf)//'.'//tttstr
         jlen = jlen + 1 + 5
      endif


      if (imon.eq.2.and.ncyc.ne.1) then
         if (opfil(51,ambfil,jlen,0,0,0)) then
             call wrtbin(51,emin)
             close(51)
         endif
      else
         if (opfil(51,ambfil,jlen,1,0,0)) then
             call wrtout(51,emin)
             close(51)
         endif
      endif


      return
      end

      subroutine wrtesc
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /passe/ emin
      
      call wrtout(iun3,emin)

      return
      end

      subroutine wmdesc
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      
      close(iun4)

      return
      end

      subroutine getmdp(natoms,heat,izo,ido,istatz,cc,ianc,
     &              bl,alph,bet,ibl,ialph,ibet,imap,ianz,iz,
     &              c,cz,alpha,beta,ian)

c this is really getmop

      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 string
      character*2 catom,catomt,tolowf,iel
      logical first,ottest, oerror,zmstar,getnxt,gnreal

      common /zmfrst/ ihaszm, nz, mxzat

      dimension ian(*),c(3,*),cz(3,*),alpha(*),beta(*)
      dimension ianc(*),cc(3,*)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianz(*),iz(4,*)
      dimension izt(4),iztt(3,3),zzz(3),idm(3),tmp(3)
      dimension iel(100)
      character*137 coplin
      character*137 line
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x '/

      istatz = 0
      ifnd = 0
      irwd = 0
      toang = 0.52917706d0

5     continue

      first = .true.
      if (izo.eq.1) then
          nzz = nz
      else
          nz = 0
      endif
      maxnz = mxzat
      ottest=.true.
      heat = 0.0d0

10    continue
      zmstar = .false.
      nztt = 0
      do while (getlin(0).eq.1)
          if (icdex(line,'[AMB').ne.0) return
          i1 = index(line,'(')
          i2 = index(line,')')
          if (i1.ne.0.and.i2.ne.0.and.i2.gt.i1) then
               line = line(1:i1-1)//line(i2+1:)
          endif
          if (index(line,'VARIABLE        FUNCTION').ne.0) then
               nword = 3
               if (index(line,'SECOND').ne.0) nword = 4
               if (getlin(0).eq.0) goto 10
               do ii=1,nword
                   ktype = nxtwrd(string,nstr,itype,rtype)
               end do
               if (ktype.eq.3) then
                   heat = rtype
               endif
               goto 10
          endif
          if (index(line,'HEAT OF FORMATION').ne.0) then
             do while(.true.)
                ktype = nxtwrd(string,nstr,itype,rtype)
                if (ktype.eq.3) heat = rtype
                if (ktype.eq.0.or.ktype.eq.3) goto 10
             end do
          endif
          if (index(line,'POINT   POTENTIAL').ne.0.or.
     &        index(line,'POINT  POTENTIAL').ne.0) then
               in = 2
               if (index(line,'FEMTOSECONDS').ne.0) in = 3
               if (getlin(0).eq.0) goto 10
c               do ii=1,4
c Armando Juan Navarro Vazquez says total energy not interresting
c Use potential energy
c
               do ii=1,in
                   ktype = nxtwrd(string,nstr,itype,rtype)
               end do
               if (ktype.eq.3) heat = rtype
               goto 10
          endif
          if (index(line,'FINAL GEOMETRY OBTAINED').ne.0) then
             call redel(line,4)
             coplin = line
             iws = 0
             ktype = -1
             do while (ktype.ne.0)
                ktype = nxtwrd(string,nstr,itype,rtype)
                if (ktype.ne.0) iws = iws + 1
             end do
             line = coplin
             if (iws.eq.7) then
               natoms = 0
               do while(.true.)
                 ktype = nxtwrd(string,nstr,itype,rtype)
                 if (ktype.eq.1.and.(nstr.eq.1.or.nstr.eq.2)) then
                      if (nstr.eq.1) then
                         catomt(1:1) = string(1:1)
                         catomt(2:2) = ' '
                      else
                         catomt = string(1:2)
                      endif
                 else
                      if (natoms.ne.0) then
                         istatz = 2
                         return
                      endif
                      goto 100
                 endif

                 iatmp = 0
                 catom = tolowf(catomt)
                 do i=1,100
                    if ( catom .eq. iel(i) ) iatmp = i - 1
                 end do
                 if (catom.eq.'xx') iatmp = 99
                 if (catom.eq.'tv') iatmp = 99
                 if (iatmp.eq.0.or.iatmp.gt.100) goto 100

                 natoms = natoms + 1
                 ianc(natoms) = iatmp

                 do ii=1,3
                    ktype = nxtwrd(string,nstr,itype,rtype)
                    if (ktype.eq.3) then
                       cc(ii,natoms) = rtype / toang
                    else
                       goto 100
                    endif
                    ktype = nxtwrd(string,nstr,itype,rtype)
                    if (ktype.ne.2)  goto 100
                 end do
                 if (getlin(0).ne.1) return
               end do
             endif
          endif
          if (index(line,'scf done: ').ne.0) then
             do while(.true.)
                ktype = nxtwrd(string,nstr,itype,rtype)
                if (ktype.eq.3) heat = rtype
                if (ktype.eq.0.or.ktype.eq.3) goto 10
             end do
          endif
          do i=1,3
             idm(i) = 0
             zzz(i) = 0.0d0
             izt(i) = 0
          end do
          ktype = nxtwrd(string,nstr,itype,rtype)
          if (ktype.eq.2) then
             if (itype.eq.1.and.first) zmstar = .true.
             if (zmstar) then
                 ktype = nxtwrd(string,nstr,itype,rtype)
             else
                 goto 100
             endif
          endif
c element label
          if (ktype.eq.1.and.(nstr.eq.1.or.nstr.eq.2)) then
               if (nstr.eq.1) then
                  catomt(1:1) = string(1:1)
                  catomt(2:2) = ' '
               else
                  catomt = string(1:2)
               endif
          else
               goto 100
          endif

c check which zmstar type

          if (zmstar.and.nztt.eq.0) then
               izmtyp = 0
               if (gnreal(tmp,3,.false.)) izmtyp = 1
          endif

          num = nztt
          if (num.gt.3) num = 3
          if (.not.zmstar.or.(zmstar.and.izmtyp.eq.1)) num = 3

          getnxt = .true.
          do i=1,num
             if (getnxt) ktype = nxtwrd(string,nstr,itype,rtype)

c bl,aplh,bet

             getnxt = .true.
             if (ktype.eq.2.or.ktype.eq.3) then
                if (ktype.eq.2) then
                   zzz(i) = 1.0d0*itype
                else
                   zzz(i) = rtype
                endif
             else
                if (zmstar) then
                   if (ktype.eq.0) then
c                     read in connectivity
                      goto 200
                   else
                      goto 100
                   endif
                else
                   goto 100
                endif
             endif

c optimize flag 1-3

             ktype = nxtwrd(string,nstr,itype,rtype)
             if (zmstar) then
                if (ktype.eq.1) then
                   if (nstr.eq.1) then
                      if (string(1:1).eq.'*'.or.
     &                    string(1:1).eq.'+') then
                          idm(i) = 1
                      else
                          goto 100
                      endif
                   else
                      goto 100
                   endif
                else
                   getnxt = .false.
                   idm(i) = 0
                endif
             else
                if (ktype.eq.2) then
                   idm(i) = abs(itype)
                else
                   goto 100
                endif
             endif
          end do
200       continue
c
c connectivity
c
          num = nztt
          if (num.gt.3) num = 3
          if (.not.zmstar) num = 3

          do i=1,num
             if (getnxt) ktype = nxtwrd(string,nstr,itype,rtype)
             getnxt = .true.
             if (ktype.eq.2) then
                izt(i) = itype
             endif
          end do

c check first three atoms

          if (izo.ne.1) then
             ioke = 1
             if (nztt.le.2) then
                do i=1,3
                   iztt(i,nztt+1) = izt(i)
                end do
             endif
             if (nztt.le.2) then
                if (iztt(1,1).ne.0) ioke = 0
                if (iztt(2,1).ne.0) ioke = 0
                if (iztt(3,1).ne.0) ioke = 0
             endif
             if (nztt.ge.1.and.nztt.le.2) then
                if (iztt(1,2).le.0) ioke = 0
                if (iztt(2,2).ne.0) ioke = 0
                if (iztt(3,2).ne.0) ioke = 0
             endif
             if (nztt.eq.2) then
                if (iztt(1,3).le.0) ioke = 0
                if (iztt(2,3).le.0) ioke = 0
                if (iztt(3,3).ne.0) ioke = 0
             endif
             if (ioke.ne.1) then
                istatz = 0
                first = .true.
                goto 5
             endif
          endif

c check atom4 and upwards

          iztot = 0
          do i=1,3
             iztot = iztot + izt(i)
          end do
          if (nztt.gt.4.and.iztot.eq.0) then
             istatz = 0
             first = .true.
             goto 5
          endif

300       continue
          if (zmstar.and.heat.eq.0.0d0.and.ifnd.eq.0) then
             ifnd = 1
             goto 100
          endif
c
c copy temporary variables into z-mat
c
          iatmp = 0
          catom = tolowf(catomt)
          do i=1,100
             if ( catom .eq. iel(i) ) iatmp = i - 1
          end do
          if (catom.eq.'xx') iatmp = 99
          if (catom.eq.'tv') iatmp = 99
          if (iatmp.eq.0.or.iatmp.gt.100) goto 100
          first = .false.
          if (nztt.ge.1) istatz = 1
          nz = nz + 1
          nztt = nztt + 1
          ianz(nz) = iatmp
          do i=1,3
             iz(i,nz) = izt(i)
          end do

          iz(4,nz) = 0
          bl(nz) = zzz(1)
          ibl(nz) = idm(1)
          alph(nz) = zzz(2)
          ialph(nz) = idm(2)
          bet(nz) = zzz(3)
          ibet(nz) = idm(3)
      end do
      first = .false.

100   if (first) goto 10
      if (izo.eq.1) then
          if (istatz.eq.0) nz = nzz
          return
      endif
      if (istatz.eq.1) then
c          call prtzm
          ihaszm = 1
          call stocc(maxnz,nz,iz,bl,alph,bet,alpha,beta,ierror)
          if (ierror.lt.5) then
             call stoc(maxnz,nz,0,0,0,ianz,iz,bl,alph,bet,
     &       ottest,natoms,ian,c,cz,imap,alpha,beta,
     &       oerror,.true.,.true.)
             if (oerror) then
                istatz = 0
                return
             endif
          else
             istatz = 0
             return
          endif
          do i=1,natoms
             do j=1,3
                cc(j,i) = c(j,i)
             end do
             ianc(i) = ian(i)
          end do
      else
          if (ifnd.eq.1.and.irwd.eq.0.and.ido.eq.1) then
             irwd = 1
             call rewfil
             goto 5
          endif
      endif

      return
      end

      subroutine denmdd(ido,
     &                  vectrs,vectrb,focc,focb,p,paa,averag,q)
c THIS IS REALLY denmak
c     returns density matrix in p common /densty/
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      character bstrng(6)*8
      logical valenc,bonds,ovrlap,atomic,doori,orient,denok,dolap,
     &        doelf
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /atoms/  nbeg(68),natn(68),atmd(5440)
      common /bond/   nbas(numatm),ipol(numatm)
      common /orihlp/ ori(numatm),iuser(numatm),oalpha(numatm),
     $                obeta(numatm),norien,ibal
      common /del1/   dmolin(169),dofscl(169)
      common /del2/   d11(3,3),d12(3,3),d21(3,3),d22(3,3),
     &                f11(3),f12(3),f21(3),f22(3),occ(3),
     &                pr(3,3),ph(3,3),ibasis,idim
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /basopt/ extbas
      common /elem/elemnt(mxel)
      logical extbas
      character*2 elemnt
      dimension ioffst(4)
      dimension vectrs(*),vectrb(*),focc(*),focb(*),p(*),paa(*),
     &          averag(*),q(*)

      denok = .true.
      ido = 1
      if (ipsi.ne.0) then
         write(iun3,20)ipsi
20       format(//10x,'M.O. NUMBER ',i4,'  IS TO BE PLOTTED',/)
      endif
      if (ipsi.eq.0) call inferr('Calculating Density Matrix',0)

      ioffst(1) = 0
      ioffst(2) = 769
      ioffst(3) = 2608
      ioffst(4) = 3605

      bstrng(1) = 'sto3g   '
      bstrng(2) = '3-21g   '
      bstrng(3) = '4-31g   '
      bstrng(4) = '6-31g   '
      bstrng(5) = '4-31g*  '
      bstrng(6) = '6-31g*  '

c************ distribute electrons over mos *******************
*
      if (valenc) then
        if (iuhf.eq.1) call inferr('dont use VALENCE with uhf',1)
        if (iftyp.eq.1) call inferr('dont use VALENCE with MOPAC',1)
        izel = 0
        do j=1,natoms
          if (nat(j).lt.11.and.nat(j).gt.2)  izel = izel + 1
          if (nat(j).lt.19.and.nat(j).gt.10) izel = izel + 5
          if (nat(j).gt.18) 
     &      call inferr('Use VALENCE ONLY with atoms up to ARGON',1)
        end do
        do j=1,izel
          focc(j) = 0.0d0
        end do
      endif

      if (idebug.eq.1) then
         write(iun3,*)'----------------------------------------------'
         write(iun3,*)'Orbital Occupancies'
         write(iun3,*)' '

         if (iuhf.eq.1) then
           write(iun3,*)' '
           write(iun3,*)'Alpha set'
           write(iun3,*)' '
         endif

         do i=1,norbs
           write(iun3,'(i3,a,f9.4)')i,'  ',focc(i)
         end do

         if (iuhf.eq.1) then

           write(iun3,*)' '
           write(iun3,*)'Beta set'
           write(iun3,*)' '

           do i=1,norbs
               write(iun3,'(i3,a,f9.4)')i,'  ',focb(i)
           end do

         endif

         write(iun3,*)'----------------------------------------------'

      endif

      if (bonds .and. ipsi.ne.0) 
     &    call inferr('BONDS WITH A M.O. IS NOT PLOTTABLE',1)
      if (ipsi.ne.0) goto 2222

c      print*,"denmak:"
c      do i=1,norbs
c         print*,i,"focc ",focc(i)
c      end do
c      do i=1,norbs
c         print*,i,"focb ",focb(i)
c      end do

c
c   construct the DENSITY matrix
c
      ibonds = 0
      if (iftyp.eq.1.and.bonds) ibonds = 1

      do i=1,norbs
          do j=i,norbs

              sum = 0.d0

              do k=1,norbs
                  if (focc(k).gt.0.0d0) then
                     sum = sum + focc(k)*vectrs((k-1)*mxorb+i)
     &                                  *vectrs((k-1)*mxorb+j)
                  endif
                  if (iuhf.eq.1) then
                    if (ispd.eq.0) then
                       if (focb(k).gt.0.0d0) then
                          sum = sum + focb(k)*vectrb((k-1)*mxorb+i)
     &                                       *vectrb((k-1)*mxorb+j)
                       endif
                    else
                       if (focb(k).gt.0.0d0) then
                          sum = sum - focb(k)*vectrb((k-1)*mxorb+i)
     &                                       *vectrb((k-1)*mxorb+j)
                       endif
                    endif
                  endif
              end do

              p((i-1)*mxorb+j) = sum
              p((j-1)*mxorb+i) = sum
          end do

          if (ibonds.eq.1) p((i-1)*mxorb+i) = 
     &                     p((i-1)*mxorb+i) - averag(i)
      end do

      if ((bonds.or.ovrlap.or.atomic).and.iftyp.ne.1) then
c
c############# - substract atomic densities from molecular ####
c############# - or do overlap density                     ####
c############# - or do atomic density within molecule      ####
c
c    call new routines for external atomic density (Bjoern Pedersen)

         if (extbas) then
             call newdenmak
             if (denok) then
                ido = 1
             else
                ido = 0
             endif
             return
         endif

         if (iuhf.eq.1.and.bonds) then
             write(iun3,*)'BONDS with UHF wavefunction using '//
     +       'ROHF derived atomic densities'
         endif
         if (bonds.or.atomic)
     1   write(iun3,'(/,''ELECTRON DENSITIES DUE TO'',
     1  '' ATOMS ARE TO BE SUBTRACTED FROM DENSITY PLOT'',/)')
         if (ovrlap) write(iun3,*)'INTERATOMIC OVERLAP DENSITY USED'
         if (atomic) write(iun3,*)'ATOMIC PART LOOKED AT ONLY'
c
c IX     the start position for an atom within the molecular 
c        density matrix
c ATMD   a large array containing atomic densities.
c N      the number of basis functies per atom possibly minus 
c        polarisation functions
c ISTART the start position of an atom within ATMD 
c 
c  H  He   Li-F      Na-Cl
c  4  0    81        169
c 25  0    225       361
c-------------------------- -
c 21  0    144       192     iplus
c
c      ibasis=     (0,1,2,3 sto3g,321g,431g,631g)
c      ipolf=   0 or 1 ; are there polarisationfunctions
c
          write(iun3,*)' '
          call setbas(denok)

          if (denok) then
             ido = 1
          else
             ido = 0
          endif

          if (.not.denok) return

          do i=1,norbs
             do j=1,norbs
               q((j-1)*mxorb+i) = 0.0d0
             end do
          end do

          ix = 0

          do 700 k=1,natoms

            ibasis = nbas(k)
            ipolf  = ipol(k)

            if (nat(k).le.2) then
               iplus = 3
            elseif (nat(k).ge.3.and.nat(k).le.17) then
               iplus = 6
            else
               call inferr('BONDS: not standard basisset',1)
            endif

            n = natn(17*ibasis + nat(k))
            istart = ioffst(ibasis+1) + nbeg(17*ibasis+nat(k))
            write(iun3,*)elemnt(nat(k)),' ',bstrng(ibasis+1+2*ipolf)

            if (ovrlap) then
c
c============ do overlap densities only ========================
c
               do i=1,n+ipolf*iplus
                  do j=1,n+ipolf*iplus
                     p((ix+j-1)*mxorb+ix+i) = 0.0d0
                  end do
               end do
            else
c
c============ molecule minus atoms =============================
c
              orient = .false.
              do i=1,norien
                 if (ori(i).eq.k) then
                     orient = .true.
                     ibal   = i
                 endif
              end do
              if (orient.and.doori) then
              if (ibasis.eq.0) then
c
c------------ substract oriented sto3g o,f,s or cl ---------
c
                do i=1,3
                   do j=1,3
                      ph(i,j) = p((ix+n-3+j-1)*mxorb+(ix+n-3+i))
                   end do
                end do

                call rotatg(nat(k),idebug)

                do i=1,n-3
                 do j=1,n-3
                  p((ix+j-1)*mxorb + (ix+i)) = p((ix+j-1)*mxorb +(ix+i))
     &                  - atmd(istart+(j-1)+(i-1)*n)
                  q((ix+j-1)*mxorb + (ix+i)) = q((ix+j-1)*mxorb +(ix+i))
     &                  + atmd(istart+(j-1)+(i-1)*n)
                 end do
                end do

                do i=1,3
                 do j=1,3
                  p((ix+n-3+j-1)*mxorb + (ix+n-3+i)) = 
     &                p((ix+n-3+j-1)*mxorb + (ix+n-3+i)) - pr(i,j)
                  q((ix+n-3+j-1)*mxorb + (ix+n-3+i)) = pr(i,j)
                 end do
                end do

              else
c
c------------ substract oriented split valence o,f,s,cl -----
c
                idim=9
                if (nat(k).eq.16.or.nat(k).eq.17) idim = 13

                do i=1,idim
                 do j=1,idim
                  dmolin(j+(i-1)*idim) = p((ix+j-1)*mxorb + (ix+i))
                 end do
                end do

                call rotatg(nat(k),idebug)

                do i=1,idim
                 do j=1,idim
                  p((ix+j-1)*mxorb + (ix+i)) = p((ix+j-1)*mxorb +(ix+i))
     &                 - dofscl(j+(i-1)*idim)
                  q((ix+j-1)*mxorb + (ix+i)) = dofscl(j+(i-1)*idim)
                 end do
                end do

              endif
              else
c
c----- for all other atoms substract spherical density -----
c
                do i=1,n
                 do j=1,n
                  p((ix+j-1)*mxorb + (ix+i)) = p((ix+j-1)*mxorb +(ix+i))
     &                 - atmd(istart+(j-1)+(i-1)*n)
                  q((ix+j-1)*mxorb + (ix+i)) = 
     &                   atmd(istart+(j-1)+(i-1)*n)
                 end do
                end do

              endif
c
c============== clear out the overlap region of the density matrix
c               if ATOMIC is supplied
c
              if (atomic) then
               idavje = n + ipolf*iplus
               do i=ix+1,ix+idavje

                  if (k.ne.0) then
                     do j=1,ix
                        p((j-1)*mxorb + i) = 0.0d0
                     end do
                  endif

                  if (k.ne.natoms) then
                     do j=ix+idavje+1,norbs
                        p((j-1)*mxorb + i) = 0.0d0
                     end do
                  endif

               end do

              endif
              endif
                ix = ix + n + ipolf*iplus
700       continue

          if (bonds.and.idebug.eq.1) then
            write(iun3,*)' '
            write(iun3,*)'***** Atomic Density Matrix *****'
            write(iun3,*)' '
            call prev(q,norbs,norbs,mxorb)
            write(iun3,*)' '
          endif

      endif

c############### end bonds , overlap , atomic ##################

      if (idebug.eq.1) then
          write(iun3,'(''   DENSITY MATRIX USED BY MAP'')')
          call prev(p,norbs,norbs,mxorb)
      endif

      return

c~~~~~~~~~~~~~~~~~   PLOT PSI   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
2222  continue 
      if (ipsi.lt.0) then
         do i=1,norbs
             paa(i) = vectrb((-ipsi-1)*mxorb+i)
         end do
      else
         do i=1,norbs
             paa(i) = vectrs((ipsi-1)*mxorb+i)
         end do
      endif
      if (idebug.eq.1) then
        write(iun3,'(''  COEFFICIENTS OF M.O. TO BE PLOTTED'')')
        write(iun3,'(6f12.6)')(paa(i),i=1,norbs)
      endif

      return
      end

      logical function onden(idum)
      implicit double precision (a-h,o-z)
      logical valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      onden = .true.

      if (ipsi.ne.0) onden = .false.
      if (bonds.or.ovrlap.or.atomic.or.doelf) onden = .false.

      return
      end

	      subroutine allzmd(ipdbon,ianz,iaton,coo)
c
c This routine sets up the conversion of cartesian coordinates 
c to zmatrix, the actual converting is done by intzmt
c
      implicit double precision (a-h,o-z)
      common /athlp/  iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      common /zmatst/ nwrit,nvar,isimpl
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical opfil
      dimension coo(3,*),ianz(*),iaton(*)

      if (ihaszm.eq.0.and.ipdbon.eq.0) then
         do i=1,iatoms
             if (ianz(i).lt.100) then
                iaton(i) = 2
             else
                iaton(i) = 1
             endif
         end do
         if (isimpl.eq.3) then
            if (opfil(46,'mapfile',7,1,1,1)) then
               iuntmp = iun2
               iun2 = 46
               call getzm(iatoms,0,1,istat)
               if (istat.eq.1) then
                   ihaszm = 1
                   call dumzm(coo,ianz,iatoms)
               endif
               iun2 = iuntmp
               close(46)
            endif
            isimpl = 0
         else
            if (iatoms.gt.mxzat-100) then
c ask if you want a zmatrix of this molecule > 100 atoms
               call dozmt(istat)
               if (istat.eq.0) then
                  do i=1,iatoms
                      iaton(i) = 1
                  end do
                  return
               endif
            endif
            call intzmt(0)
         endif
         if (ihaszm.eq.1) ihaszm = 2
         call setarr(9,idum,idum)
      endif

      return
      end

      subroutine ligzmd(ianz,iaton)
c
c this a dedicated version of allzmt, it only converts the ligand
c part of a receptor - ligand complex to a zmatrix, used by manual
c docking
c
      implicit double precision (a-h,o-z)
      common /zmfrst/ ihaszm, nz, mxzat
      common /align/  vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension ianz(*),iaton(*)

      do i=1,iscst
          iaton(i) = 1
      end do

      do i=iscst+1,iscst+nscnd
          if (ianz(i).lt.100) then
             iaton(i) = 2
          else
             iaton(i) = 1
          endif
      end do

      call intzmt(0)
      if (ihaszm.eq.1) ihaszm = 2

      do i=iscst+1,iscst+nscnd
          iaton(i) = 1
      end do

      return
      end

      subroutine pdbzmd(ianz,iaton,iresid,iconn,ishoh)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      dimension ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*)

      if (ihaszm.eq.0) then

         ino = 0
         do i=1,iatoms
             if (ianz(i).lt.100) then
                if (iresid(i).eq.-ishoh) then
                   if (ianz(i).eq.8) then
                      ido = 0
                      do j=1,iconn(1,i)
                         jj = iconn(1+j,i)
                         if (jj.gt.0.and.ianz(iabs(jj)).gt.1) ido = 1
                      end do
                      if (ido.eq.1) then
                         iaton(i) = 2
                      else
                         ino = ino + 1
                         iaton(i) = 1
                      endif
                   elseif (ianz(i).eq.1) then
                      ido = 0
                      do j=1,iconn(1,i)
                         jj = iconn(1+j,i)
                         if (jj.gt.0) then
                            if (ianz(iabs(jj)).ne.8) then
                               ido = 1
                            else
                               io = iabs(jj)
                               do ll=1,iconn(1,io)
                                  iio = iconn(1+ll,io)
                                  if (iio.gt.0.and.iio.ne.i) then
                                     if (ianz(iio).ne.1) ido = 1
                                  endif
                               end do
                            endif
                         endif
                      end do
                      if (ido.eq.1) then
                         iaton(i) = 2
                      else
                         ino = ino + 1
                         iaton(i) = 1
                      endif
                   else
                      iaton(i) = 2
                   endif
                else
                   iaton(i) = 2
                endif
             else
                iaton(i) = 1
             endif
         end do

         call stowat(ino)

         call intzmt(1)
         ihaszm = 1

         do i=1,iatoms
             iaton(i) = 1
         end do

      endif

      return
      end

      subroutine haswad(ino,ianz,iaton,iresid,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      dimension ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*)

      ino = 0

      if (ihaszm.eq.0) then

         do i=1,iatoms
             if (ianz(i).lt.100) then
                if (iresid(i).le.0) then

                   if (ianz(i).eq.8) then

                      ido = 0

                      do j=1,iconn(1,i)
                         jj = iconn(1+j,i)
                         if (jj.gt.0.and.ianz(iabs(jj)).gt.1) ido = 1
                      end do

                      if (ido.ne.1) ino = ino + 1

                   elseif (ianz(i).eq.1) then

                      ido = 0

                      do j=1,iconn(1,i)
                         jj = iconn(1+j,i)
                         if (jj.gt.0) then
                            if (ianz(iabs(jj)).ne.8) then
                               ido = 1
                            else
                               io = iabs(jj)
                               do ll=1,iconn(1,io)
                                  iio = iconn(1+ll,io)
                                  if (iio.gt.0.and.iio.ne.i) ido = 1
                               end do
                            endif
                         endif
                      end do

                      if (ido.ne.1) ino = ino + 1

                   endif
                endif
             endif
         end do
      endif

      return
      end

      subroutine haszm(zmok)
      implicit double precision (a-h,o-z)
      common /zmfrst/ ihaszm, nz, mxzat

      logical zmok

      if (zmok) then
         ihaszm = 1
      else
         ihaszm = 0
         nz = 0
      endif
      
      return
      end

      logical function zmqok(idum)
      implicit double precision (a-h,o-z)
      common /zmfrst/ ihaszm, nz, mxzat
      character*80 glin1,glin2,gtitl,rungam
      character*15 jname,qname
      common /gauopt/ ito,imo,ibo,itotc,imult,ibatch,ihess,itime,
     &                iwxyz,ichh,ichm,ichl,imh,imm,iml,iexk,
     &                glin1,glin2,gtitl,jname,qname,rungam

      zmqok = .false.
      if (ihaszm.ne.0.or.iwxyz.ne.0) zmqok = .true.
      
      return
      end

      subroutine setzm(newnz)
      implicit double precision (a-h,o-z)
      common /zmfrst/ ihaszm, nz, mxzat

      if (ihaszm.ne.1) then
         ihaszm = 1
         nz = newnz
      endif
      
      return
      end

      logical function chkres(ires,icalf,iamino)
      implicit double precision (a-h,o-z)
      dimension icalf(6,*),iamino(*)

      chkres = .true.

      nat = 3
      if (iamino(ires).gt.23) nat = 6

      do i=1,nat
         do j=i+1,nat
            if (icalf(i,ires).eq.icalf(j,ires).or.icalf(i,ires).le.0)
     &      chkres = .false.
         end do
      end do

      return
      end

      logical function addiz(ipdb,k1,k2,l1,l2,lwrit,lring)
      implicit double precision (a-h,o-z)
      parameter (mxzz=115)
      common /pdbzm/ izz(4,mxzz)
      logical pcklin,dorng
      dimension isel(4)
      dimension ipdb(*),lwrit(*),lring(*)


      addiz = .true.
      if (k1.gt.mxzz.or.k2.gt.mxzz) return

      do k=k1,k2
         dorng = .false.
         if (l1.ne.0.and.k.ge.l1.and.k.le.l2) dorng = .true.
         do l=1,4
            it = ipdb(izz(l,k))
            if (it.eq.0) return
            if (l.eq.1) then
               it1 = it
            else
               if (lwrit(it).eq.0) return
            endif
            isel(l) = it
         end do
         
c         if (.not.pcklin(isel)) goto 100
         if (.not.pcklin(isel)) return
         if (dorng) lring(it1) = 1
      end do

      return

100   addiz = .false.
      return

      end

      logical function addone(i1,i2,i3,i4,iadd,lwrit)
      implicit double precision (a-h,o-z)
      logical pcklin
      dimension isel(4),lwrit(*)

      addone = .true.

      isel(1) = i1
      isel(2) = i2
      isel(3) = i3
      isel(4) = i4

      do l=1,4
         if (isel(l).eq.0) return
         if (l.gt.1) then
            if (lwrit(isel(l)).eq.0) return
         endif
      end do
         
      if (.not.pcklin(isel)) goto 100

      iadd = iadd + 1

      return

100   addone = .false.
      return

      end

      subroutine intzmd(ispdb,ianz,iaton,iresid,iconn,lwrit,lring,
     &                  icalf,ianf,islu,nchain,iamino)
      implicit double precision (a-h,o-z)
      parameter (ncmax=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxzz=115)

      common /athlp/  iatoms, mxnat
      common /selatm/ jring(numat1)
      common /zmatst/ nwrit,nvar,isimpl
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /surf/   natorg,noscnd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /pdbzm/ izz(4,mxzz)

      logical ocnos,parlea,pcklin,ringg,wring,debug,opfil,chkres,
     &        addiz,addone,parleh
      integer getlin
      character*137 str
      dimension isel(4),icalft(6),iring(6),idisc(ncmax)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*),
     &          lwrit(*),lring(*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      data ((izz(i,j),i=1,4),j=1,92) /
     &          49,48,47,46, 54,49,48,47, 52,54,49,48, 53,52,54,49,
     &          73,53,52,54, 44,43,46,47, 45,43,46,47,
     &          66,54,49,48, 59,66,54,49, 65,59,66,54, 57,65,59,66,
     &          56,57,65,59, 62,56,57,65, 55,62,56,57, 60,55,62,56,
     &          58,60,55,62, 60,54,49,48, 58,60,54,49, 57,58,60,54,
     &          56,57,58,60, 62,56,57,58, 55,62,56,57, 67,55,62,56,
     &          63,56,57,58, 68,56,57,58, 72,55,58,60, 83,57,58,60,
     &          64,58,57,65, 69,58,57,65, 61,55,60,58, 31, 5, 2, 1,
     &          37, 5, 2, 1, 32, 5, 2, 1,  8, 5, 2,32,  7, 5, 2, 1,
     &           8, 5, 2, 7, 10, 7, 5, 2,  7, 5, 2, 1,  8, 5, 2, 7,
     &           6, 5, 2, 1, 36, 6, 5, 2, 12,36, 6, 5,  6, 5, 2, 1,
     &          29, 6, 5, 2, 30, 6, 5,29,  6, 5, 2, 1, 29, 6, 5, 2,
     &          21, 6, 5,29,  6, 5, 2, 1, 10, 6, 5, 2, 11, 6, 5,10,
     &           6, 5, 2, 1,  9, 6, 5, 2, 12, 9, 6, 5, 27,12, 9, 6,
     &           6, 5, 2, 1,  9, 6, 5, 2, 34, 9, 6, 5, 35, 9, 6,34,
     &           6, 5, 2, 1,  9, 6, 5, 2, 34, 9, 6, 5, 24, 9, 6,34,
     &           6, 5, 2, 1,  9, 6, 5, 2,  6, 5, 2, 1,  9, 6, 5, 2,
     &          22, 9, 6, 5, 17,22, 9, 6, 25,17,22, 9, 26,17,22,25,
     &           6, 5, 2, 1, 20, 6, 5, 2, 13,20, 6, 5, 24,13,20, 6,
     &          11,24,13,20,  6, 5, 2, 1, 10, 6, 5, 2, 13,10, 6, 5,
     &          17,13,10, 6, 14,17,13,10, 11,14,17,13, 33,17,13,10,
     &           6, 5, 2, 1, 10, 6, 5, 2, 23,10, 6, 5, 14,23,10, 6,
     &          11,14,23,10, 15,11,14,23, 19,15,11,14, 16,19,15,11,
     &          18,16,19,15/

      data ((izz(i,j),i=1,4),j=93,98) /
     &          57,54,49,48, 58,57,54,49, 60,58,57,54,
     &          55,60,58,57, 62,55,60,58, 56,62,55,60/

      data ((izz(i,j),i=1,4),j=99,115) /
     &          90,61,55,60, 91,90,61,55, 92,91,90,61,
     &          93,92,91,90, 94,93,92,91, 95,94,93,92, 96,95,93,92,
     &          97,95,94,96, 98,97,95,96, 99,94,93,95, 100,99,94,93,
     &          101,100,99,94, 102,100,99,101, 103,102,100,101,
     &          88,62,55,60, 89,90,61,55, 76,43,46,47/

      debug = .false.
      if (debug) print*,'routine intzmt'
c
c     Convert Cartesian coordinates to Z-matrix
c
      call haszm(.true.)

      natorg = 0

      nvar = 0
      ndisc = 0
      nwrit = 0
      nwrith = 0

      noth = 0
      nsel = 0
      nconn = 0
      nzpdb = 0

      ilead = 0
      ilold = 0

      do i=1,iatoms
         lring(i) = 0
         lwrit(i) = 0
         if (ianz(i).ne.1.and.iaton(i).eq.2) noth = noth + 1
         if (iaton(i).eq.2) nsel = nsel + 1
         if (iaton(i).eq.2.and.iconn(1,i).ne.0) nconn = nconn + 1
      end do

      if (nconn.lt.3) then
         do i=1,iatoms
            if (iaton(i).eq.2.and.iconn(1,i).eq.0) then
                lwrit(i) = 1
                call icrcon(icrcn,isel,idisc,ndisc,1,0)
                if (icrcn.ne.0) then
                   jj = isel(1)
                   lwrit(jj) = 1
                   call icrcon(icrcn,isel,idisc,ndisc,1,0)
                   if (icrcn.ne.0) then
                       lwrit(i) = 0
                       lwrit(jj) = 0
                       goto 5
                   else 
                       lwrit(i) = 0
                       lwrit(jj) = 0
                   endif
                else
                   lwrit(i) = 0
                endif
            endif
         end do
      endif

      if (ispdb.eq.1) then

         ist = 1
         do i=1,6
           icalft(i) = 0
         end do
         irst = 0

         do i=1,nchain
           iaw = 0
           do j=ianf(i),islu(i)
           
            if (chkres(j,icalf,iamino)) then
             call getpdb(j,ipdb,ihpdb)
c
c Amino Acids
c
             if (iamino(j).le.23) then
c n (first residue)
               if (ist.eq.1) then
                  isel(1) = icalf(2,1)
                  isel(2) = 0
                  isel(3) = 0
                  isel(4) = 0
                  if (.not.pcklin(isel)) goto 100
               elseif (iaw.eq.0) then
                  isel(1) = icalf(2,j)
                  if (irst.gt.23) then
                    isel(2) = icalft(6)
                    isel(3) = icalft(5)
                    isel(4) = icalft(4)
                  else
                    isel(2) = icalft(3)
                    isel(3) = icalft(1)
                    isel(4) = icalft(2)
                  endif
                  if (.not.pcklin(isel)) goto 100
               endif
c ca
               isel(1) = icalf(1,j)
               isel(2) = icalf(2,j)
               if (ist.eq.1) then
                  isel(3) = 0
                  isel(4) = 0
               else
                  if (iaw.eq.0) then
                     if (irst.gt.23) then
                       isel(3) = icalft(6)
                       isel(4) = icalft(5)
                     else
                       isel(3) = icalft(3)
                       isel(4) = icalft(1)
                     endif
                     ifd = 0 
                     do k=1,iconn(1,isel(2))
                       kk = abs(iconn(k+1,isel(2)))
                       if (kk.eq.isel(3)) ifd = 1
                     end do
                     if (ifd.eq.0) 
     &               idum = jcrcon(isel(2),isel(3),idisc,ndisc,iconn)
                  else
                     if (iamino(j-1).gt.23) then
                       isel(3) = icalf(6,j-1)
                       isel(4) = icalf(5,j-1)
                     else
                       isel(3) = icalf(3,j-1)
                       isel(4) = icalf(1,j-1)
                     endif
                  endif
               endif
               if (.not.pcklin(isel)) goto 100
               if (iamino(j).eq.15) then
                  if (lwrit(icalf(1,j)).ne.0) lring(icalf(1,j)) = 1
               endif
c co
               isel(1) = icalf(3,j)
               isel(2) = icalf(1,j)
               isel(3) = icalf(2,j)
               if (ist.eq.1) then
                  isel(4) = 0
               else
                  if (iaw.eq.0) then
                     if (irst.gt.23) then
                       isel(4) = icalft(6)
                     else
                       isel(4) = icalft(3)
                     endif
                  else
                     if (iamino(j-1).gt.23) then
                       isel(4) = icalf(6,j-1)
                     else
                       isel(4) = icalf(3,j-1)
                     endif
                  endif
               endif
               if (.not.pcklin(isel)) goto 100
c n or oxt
               if (ipdb(38).ne.0) then
                  inxt = ipdb(38)
               elseif (ipdb(76).ne.0) then
                  inxt = ipdb(76)
               else
                  if (j.ne.islu(i)) then
                     if (iamino(j+1).gt.23) then
                       inxt = icalf(1,j+1)
                     else
                       inxt = icalf(2,j+1)
                     endif
                  else
                     inxt = 0
                  endif
               endif

               if (inxt.ne.0) then
                  isel(1) = inxt
                  isel(2) = icalf(3,j)
                  isel(3) = icalf(1,j)
                  isel(4) = icalf(2,j)
                  if (.not.pcklin(isel)) goto 100
                  if (iamino(j+1).eq.15) then
                     if (inxt.eq.icalf(2,j+1)) then
                        if (lwrit(icalf(2,j+1)).ne.0)
     &                     lring(icalf(2,j+1)) = 1
                     endif
                  endif
               endif
c o
               isel(1) = ipdb(4)
               isel(2) = icalf(3,j)
               isel(3) = icalf(1,j)
               if (inxt.eq.0) then
                  isel(4) = icalf(2,j)
               else
                  isel(4) = inxt
               endif
               if (.not.pcklin(isel)) goto 100

               do k=1,6
                 icalft(k) = icalf(k,j)
               end do
               irst = iamino(j)
               iaw = 1
c nh
               
               if (ist.eq.1) then
                  is = icalf(3,j)
               else
                  is = icalf(3,j-1)
               endif
               if (.not.addone(icalf(4,j),icalf(2,j),icalf(1,j),
     &             is,nwrith,lwrit)) goto 100

c c beta
               if (.not.addone(ipdb(5),icalf(1,j),icalf(3,j),
     &             icalf(2,j),idum,lwrit)) goto 100
               if (iamino(j).eq.15) then
                   if (ipdb(5).ne.0) then
                      if (lwrit(ipdb(5)).ne.0) lring(ipdb(5)) = 1
                   endif
               endif

c ser
               if (.not.addiz(ipdb,31,31,0,0,lwrit,lring)) goto 100
c cys
               if (.not.addiz(ipdb,32,32,0,0,lwrit,lring)) goto 100
c thr
               if (iamino(j).eq.5) then
                  if (.not.addiz(ipdb,33,34,0,0,lwrit,lring)) goto 100
               endif
c ile
               if (iamino(j).eq.6) then
                  if (.not.addiz(ipdb,35,37,0,0,lwrit,lring)) goto 100
               endif
c val
               if (iamino(j).eq.7) then
                  if (.not.addiz(ipdb,38,39,0,0,lwrit,lring)) goto 100
               endif
c met
               if (iamino(j).eq.8) then
                  if (.not.addiz(ipdb,40,42,0,0,lwrit,lring)) goto 100
               endif
c asp
               if (iamino(j).eq.9) then
                  if (.not.addiz(ipdb,43,45,0,0,lwrit,lring)) goto 100
               endif
c asn
               if (iamino(j).eq.10) then
                  if (.not.addiz(ipdb,46,48,0,0,lwrit,lring)) goto 100
               endif
c leu
               if (iamino(j).eq.11) then
                  if (.not.addiz(ipdb,49,51,0,0,lwrit,lring)) goto 100
               endif
c lys
               if (iamino(j).eq.12) then
                  if (.not.addiz(ipdb,52,55,0,0,lwrit,lring)) goto 100
               endif
c glu
               if (iamino(j).eq.13) then
                  if (.not.addiz(ipdb,56,59,0,0,lwrit,lring)) goto 100
               endif
c gln
               if (iamino(j).eq.14) then
                  if (.not.addiz(ipdb,60,63,0,0,lwrit,lring)) goto 100
               endif
c pro
               if (iamino(j).eq.15) then
                  if (.not.addiz(ipdb,64,65,64,65,lwrit,lring)) goto 100
               endif
c lys
               if (iamino(j).eq.16) then
                  if (.not.addiz(ipdb,66,71,0,0,lwrit,lring)) goto 100
               endif
c his
               if (iamino(j).eq.17) then
                  if (.not.addiz(ipdb,72,76,72,76,lwrit,lring)) goto 100
               endif
c phe
               if (iamino(j).eq.18) then
                  if (.not.addiz(ipdb,77,82,77,82,lwrit,lring)) goto 100
               endif
c tyr
               if (iamino(j).eq.19) then
                  if (.not.addiz(ipdb,77,83,77,82,lwrit,lring)) goto 100
               endif
c trp
               if (iamino(j).eq.20) then
                  if (.not.addiz(ipdb,84,92,84,92,lwrit,lring)) goto 100
               endif

               if (.not.addone(ihpdb(4),icalf(1,j),icalf(3,j),
     &             icalf(2,j),nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(5),icalf(1,j),icalf(3,j),
     &             icalf(2,j),nwrith,lwrit)) goto 100

               do m=6,mxhsym*3
                  l = ihpdb(m)
                  if (l.ne.0) then
                     if (ianz(l).eq.1.and.lwrit(l).eq.0
     &                    .and.iaton(l).eq.2) then
                        if (.not.parleh(l,isel,0)) then
                           if (ifcon(l,idisc,ndisc,0,ianz,iaton,iconn,
     &                               lwrit) .ne.0) then
                              if (.not.parleh(l,isel,0)) idum = 0
                           endif
                        endif
                        if (lwrit(l).eq.1) nwrith = nwrith + 1
                     endif
                  endif
               end do

c first residue more n-h ?

               if (ist.eq.1) then
                  do l=1,3
                     if (ihpdb(l).ne.icalf(4,j).and.ihpdb(l).ne.0) 
     &               then
                        if (.not.addone(ihpdb(l),icalf(2,j),
     &                     icalf(1,j),icalf(4,j),nwrith,lwrit)) goto 100
                     endif
                  end do
               endif

             else
c
c Nucleic Acids
c

c P
               isel(1) = icalf(1,j)
               if (ist.eq.1) then
                  isel(2) = 0
                  isel(3) = 0
                  isel(4) = 0
               else
                  if (iaw.eq.0) then
                     if (irst.le.23) then
                       isel(2) = icalft(3)
                       isel(3) = icalft(1)
                       isel(4) = icalft(2)
                     else
                       isel(2) = icalft(6)
                       isel(3) = icalft(5)
                       isel(4) = icalft(4)
                     endif
                     ifd = 0 
                     do k=1,iconn(1,isel(1))
                       kk = abs(iconn(k+1,isel(1)))
                       if (kk.eq.isel(2)) ifd = 1
                     end do
                     if (ifd.eq.0) 
     &               idum = jcrcon(isel(1),isel(2),idisc,ndisc,iconn)
                  else
                     if (iamino(j-1).le.23) then
                        isel(2) = icalf(3,j-1)
                        isel(3) = icalf(1,j-1)
                        isel(4) = icalf(2,j-1)
                     else
                        isel(2) = icalf(6,j-1)
                        isel(3) = icalf(5,j-1)
                        isel(4) = icalf(4,j-1)
                     endif
                  endif
               endif
               if (.not.pcklin(isel)) goto 100
c O5*
               isel(1) = icalf(2,j)
               isel(2) = icalf(1,j)
               if (ist.eq.1) then
                  isel(3) = 0
                  isel(4) = 0
               else
                  if (iaw.eq.0) then
                     if (irst.le.23) then
                        isel(3) = icalft(3)
                        isel(4) = icalft(1)
                     else
                        isel(3) = icalft(6)
                        isel(4) = icalft(5)
                     endif
                  else
                     if (iamino(j-1).le.23) then
                        isel(3) = icalf(3,j-1)
                        isel(4) = icalf(1,j-1)
                     else
                        isel(3) = icalf(6,j-1)
                        isel(4) = icalf(5,j-1)
                     endif
                  endif
               endif
               if (.not.pcklin(isel)) goto 100
c C5*
               isel(1) = icalf(3,j)
               isel(2) = icalf(2,j)
               isel(3) = icalf(1,j)
               if (ist.eq.1) then
                  isel(4) = 0
               else
                  if (iaw.eq.0) then
                     if (irst.le.23) then
                        isel(4) = icalft(3)
                     else
                        isel(4) = icalft(6)
                     endif
                  else
                     if (iamino(j-1).le.23) then
                        isel(4) = icalf(3,j-1)
                     else
                        isel(4) = icalf(6,j-1)
                     endif
                  endif
               endif
               if (.not.pcklin(isel)) goto 100
c C4*
               isel(1) = icalf(4,j)
               isel(2) = icalf(3,j)
               isel(3) = icalf(2,j)
               isel(4) = icalf(1,j)
               if (.not.pcklin(isel)) goto 100
               if (lwrit(isel(1)).ne.0) lring(isel(1)) = 1
c C3*
               isel(1) = icalf(5,j)
               isel(2) = icalf(4,j)
               isel(3) = icalf(3,j)
               isel(4) = icalf(2,j)
               if (.not.pcklin(isel)) goto 100
               if (lwrit(isel(1)).ne.0) lring(isel(1)) = 1
c O3*
               isel(1) = icalf(6,j)
               isel(2) = icalf(5,j)
               isel(3) = icalf(4,j)
               isel(4) = icalf(3,j)
               if (.not.pcklin(isel)) goto 100

               do k=1,6
                 icalft(k) = icalf(k,j)
               end do
               irst = iamino(j)
               iaw = 1
c O4*
               if (.not.addiz(ipdb,1,1,1,1,lwrit,lring)) goto 100
c C1*
               if (.not.addiz(ipdb,2,2,2,2,lwrit,lring)) goto 100
c C2*
               if (.not.addiz(ipdb,3,3,3,3,lwrit,lring)) goto 100
c O2*
               if (.not.addiz(ipdb,4,4,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,5,5,0,0,lwrit,lring)) goto 100

c O1P, O2P
               if (.not.addiz(ipdb,6,6,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,7,7,0,0,lwrit,lring)) goto 100
c OXT
               if (addiz(ipdb,115,115,0,0,lwrit,lring)) then
                   ldum = 1
               endif
               

               k1 = 0
c Adenosine Guanosine
               if (iamino(j).eq.24.or.iamino(j).eq.26.or.
     &             iamino(j).eq.29.or.(iamino(j).ge.32.and.
     &             iamino(j).le.38)) then
                  k1 = 8
                  k2 = 16
                  l1 = 8
                  l2 = 16
               endif
c cytidine Uridine Thymine
               if (iamino(j).eq.25.or.iamino(j).eq.27.or.
     &             iamino(j).eq.28.or.iamino(j).eq.30.or.
     &             iamino(j).eq.31.or.(iamino(j).ge.39.and.
     &             iamino(j).le.41)) then
                  k1 = 17
                  k2 = 23
                  l1 = 17
                  l2 = 22
               endif
c PSU 
               if (iamino(j).eq.42) then
                  k1 = 93
                  k2 = 98
                  l1 = 93
                  l2 = 98
               endif

               if (k1.ne.0) then
                  if (.not.addiz(ipdb,k1,k2,l1,l2,lwrit,lring)) goto 100
               endif

               if (iamino(j).eq.42) then
                   if (.not.addiz(ipdb,23,23,0,0,lwrit,lring)) goto 100
               endif

               if (.not.addiz(ipdb,24,24,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,25,25,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,26,26,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,27,27,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,28,28,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,29,29,0,0,lwrit,lring)) goto 100
               if (.not.addiz(ipdb,30,30,0,0,lwrit,lring)) goto 100

c - YG
               if (iamino(j).eq.37) then
                  k1 = 99
                  k2 = 114
                  l1 = 99
                  l2 = 114
                  if (.not.addiz(ipdb,k1,k2,l1,l2,lwrit,lring)) goto 100
               endif
c - 1MA
               if (iamino(j).eq.29.or.iamino(j).eq.32) then
                  if (.not.addone(ipdb(79),ipdb(60),ipdb(58),
     &                ipdb(57),nwrith,lwrit)) goto 100
               endif

c - OMC, OMG
               if (iamino(j).eq.31.or.iamino(j).eq.36) then
                  if (.not.addone(ipdb(80),ipdb(53),ipdb(52),
     &                ipdb(54),nwrith,lwrit)) goto 100
               endif

c - 2MG, M2G
               if (iamino(j).eq.33.or.iamino(j).eq.34) then
                  if (.not.addone(ipdb(80),ipdb(61),ipdb(55),
     &                ipdb(60),nwrith,lwrit)) goto 100
               endif

c - M2G
               if (iamino(j).eq.34) then
                  if (.not.addone(ipdb(79),ipdb(61),ipdb(55),
     &                ipdb(60),nwrith,lwrit)) goto 100
               endif

c - 7MG
               if (iamino(j).eq.35) then
                  if (.not.addone(ipdb(85),ipdb(65),ipdb(59),
     &                ipdb(66),nwrith,lwrit)) goto 100
               endif

c backbone H
               if (.not.addone(ihpdb(61),ipdb(47),ipdb(46),ipdb(43),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(62),ipdb(47),ipdb(46),ipdb(43),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(64),ipdb(48),ipdb(47),ipdb(46),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(67),ipdb(50),ipdb(48),ipdb(47),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(115),ipdb(51),ipdb(50),ipdb(52),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(70),ipdb(52),ipdb(50),ipdb(48),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(71),ipdb(52),ipdb(50),ipdb(48),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(73),ipdb(54),ipdb(52),ipdb(50),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(76),ipdb(53),ipdb(52),ipdb(50),
     &            nwrith,lwrit)) goto 100

c cytidine
c 101 and 104 are for H2U

               if (.not.addone(ihpdb(130),ipdb(63),ipdb(56),ipdb(57),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(131),ipdb(63),ipdb(56),ipdb(57),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(100),ipdb(57),ipdb(58),ipdb(56),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(101),ipdb(57),ipdb(58),ipdb(56),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(103),ipdb(58),ipdb(60),ipdb(57),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(104),ipdb(58),ipdb(60),ipdb(57),
     &            nwrith,lwrit)) goto 100

c Guanosine
               if (.not.addone(ihpdb(112),ipdb(59),ipdb(66),ipdb(65),
     &            nwrith,lwrit)) goto 100
               if (iamino(j).eq.35) then
                  if (.not.addone(ihpdb(113),ipdb(59),ipdb(66),
     &                ipdb(65),nwrith,lwrit)) goto 100
               endif
               if (.not.addone(ihpdb(121),ipdb(60),ipdb(58),ipdb(57),
     &            nwrith,lwrit)) goto 100
               if (.not.iamino(j).eq.37) then
                  if (.not.addone(ihpdb(124),ipdb(61),ipdb(55),
     &                ipdb(60),nwrith,lwrit)) goto 100
               endif
               if (.not.addone(ihpdb(125),ipdb(61),ipdb(55),ipdb(60),
     &            nwrith,lwrit)) goto 100
c Adenosine
               if (.not.addone(ihpdb(82),ipdb(55),ipdb(60),ipdb(58),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(136),ipdb(64),ipdb(58),ipdb(57),
     &            nwrith,lwrit)) goto 100
               if (.not.addone(ihpdb(137),ipdb(64),ipdb(58),ipdb(57),
     &            nwrith,lwrit)) goto 100
c Uridine
               if (.not.addone(ihpdb(127),ipdb(62),ipdb(56),ipdb(57),
     &            nwrith,lwrit)) goto 100

c Thymidine CM5 (= C5A,C5M) hydrogens, 5MC, 5MU H

               if (iamino(j).eq.27.or.iamino(j).eq.30
     &             .or.iamino(j).eq.41) then
                  if (ipdb(83).ne.0) then
                     if (.not.addone(ihpdb(160),ipdb(83),ipdb(57),
     &                   ipdb(56),nwrith,lwrit)) goto 100
                     if (.not.addone(ihpdb(161),ipdb(83),ipdb(57),
     &                   ihpdb(160),nwrith,lwrit)) goto 100
                     if (.not.addone(ihpdb(162),ipdb(83),ipdb(57),
     &                   ihpdb(160),nwrith,lwrit)) goto 100
                  elseif (ipdb(85).ne.0) then
                     if (.not.addone(ipdb(85),ipdb(57),ipdb(58),
     &                   ipdb(60),nwrith,lwrit)) goto 100
                     if (.not.addone(ihpdb(166),ipdb(85),ipdb(57),
     &                   ipdb(56),nwrith,lwrit)) goto 100
                     if (.not.addone(ihpdb(167),ipdb(85),ipdb(57),
     &                   ihpdb(160),nwrith,lwrit)) goto 100
                     if (.not.addone(ihpdb(168),ipdb(85),ipdb(57),
     &                   ihpdb(160),nwrith,lwrit)) goto 100
                  endif
               endif

c - 1MA H
               if (iamino(j).eq.29.or.iamino(j).eq.32) then
                  if (.not.addone(ihpdb(148),ipdb(79),ipdb(60),
     &                ipdb(58),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(149),ipdb(79),ipdb(60),
     &                ihpdb(148),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(150),ipdb(79),ipdb(60),
     &                ihpdb(148),nwrith,lwrit)) goto 100
c    H6 already covered
               endif

c - OMC, OMG H
               if (iamino(j).eq.31.or.iamino(j).eq.36) then
                  if (.not.addone(ihpdb(151),ipdb(80),ipdb(53),
     &                ipdb(52),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(152),ipdb(80),ipdb(53),
     &                ihpdb(151),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(153),ipdb(80),ipdb(53),
     &                ihpdb(151),nwrith,lwrit)) goto 100
               endif

c - 2MG H
               if (iamino(j).eq.33.or.iamino(j).eq.34) then
                  if (.not.addone(ihpdb(151),ipdb(80),ipdb(61),
     &                ipdb(55),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(152),ipdb(80),ipdb(61),
     &                ihpdb(151),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(153),ipdb(80),ipdb(61),
     &                ihpdb(151),nwrith,lwrit)) goto 100
               endif

c - M2G H
               if (iamino(j).eq.34) then
                  if (.not.addone(ihpdb(148),ipdb(79),ipdb(61),
     &                ipdb(55),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(149),ipdb(79),ipdb(61),
     &                ihpdb(148),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(150),ipdb(79),ipdb(61),
     &                ihpdb(148),nwrith,lwrit)) goto 100
               endif

c - 7MG H
               if (iamino(j).eq.35) then
                  if (.not.addone(ihpdb(166),ipdb(85),ipdb(65),
     &                ipdb(59),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(167),ipdb(85),ipdb(65),
     &                ihpdb(166),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(168),ipdb(85),ipdb(65),
     &                ihpdb(166),nwrith,lwrit)) goto 100
c the others ones are covered under guanosine
               endif

c - YG H
               if (iamino(j).eq.37) then
                  if (.not.addone(ihpdb(91),ipdb(88),ipdb(62),
     &                ipdb(56),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(92),ipdb(88),ipdb(62),
     &                ihpdb(91),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(93),ipdb(88),ipdb(62),
     &                ihpdb(91),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(175),ipdb(89),ipdb(90),
     &                ipdb(61),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(176),ipdb(89),ipdb(90),
     &                ihpdb(175),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(177),ipdb(89),ipdb(90),
     &                ihpdb(175),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(178),ipdb(92),ipdb(91),
     &                ipdb(93),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(179),ipdb(92),ipdb(91),
     &                ihpdb(178),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(181),ipdb(93),ipdb(92),
     &                ipdb(94),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(182),ipdb(93),ipdb(92),
     &                ihpdb(181),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(184),ipdb(94),ipdb(93),
     &                ipdb(95),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(187),ipdb(98),ipdb(97),
     &                ipdb(95),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(188),ipdb(98),ipdb(97),
     &                ihpdb(187),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(189),ipdb(98),ipdb(97),
     &                ihpdb(187),nwrith,lwrit)) goto 100
c 124 = HN2, this should actually be HN20, (or else H20)
c also wrong at routine addhs
                  if (.not.addone(ihpdb(124),ipdb(99),ipdb(100),
     &                ipdb(94),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(190),ipdb(103),ipdb(102),
     &                ipdb(100),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(191),ipdb(103),ipdb(102),
     &                ihpdb(190),nwrith,lwrit)) goto 100
                  if (.not.addone(ihpdb(192),ipdb(103),ipdb(102),
     &                ihpdb(190),nwrith,lwrit)) goto 100
               endif

             endif

             ist = 0
            endif

100         continue
           end do
         end do
         if (ist.eq.0) then
            nzpdb = nwrit
            call haszm(.true.)
c            goto 5
            goto 1000
         endif
      endif
      if (debug) call prtzm

c if the z-matrix is to be created using a predefined ordering of
c atoms

      if (isimpl.eq.2) then
         if (opfil(46,'mapfile',7,1,1,1)) then
            iuntmp = iun2
            iun2 = 46
            do i=1,iatoms
               if (getlin(0).eq.1) then
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) then
                     if (i.le.numat1) jring(i) = itype
                  else
                     isimpl = 1
                  endif
               else
                  isimpl = 1
               endif
            end do
            iun2 = iuntmp
            close(46)
         else
            isimpl = 1
         endif
      endif

5     if (isimpl.ge.1) goto 910
      
      do i=1,4
         isel(i) = 0
      end do

      if (ilead.eq.0) then
         do i=1,iatoms
            if (.not.ringg(i,iring,nring,.false.,ianz,iaton,iconn,
     &                     lwrit,lring)) goto 2000
            if (nring.ge.5) ilead = i
         end do
      endif
      if (ilead.eq.0) then
c        get other lead, eindstandig iets
         do i=1,4
            isel(i) = 0
         end do
         icmin = 100 
         do i=1,iatoms
            if (ianz(i).eq.6.and.iaton(i).eq.2) then
               icnos = 0
               do j=1,iconn(1,i)
                  jj = abs(iconn(j+1,i))
                  if (ocnos(jj,ianz,iaton)) icnos = icnos + 1
               end do
               if (icnos.lt.icmin) then
                   icmin = icnos
                   icat  = i
               endif
            endif
         end do
         if (icmin.ne.100) ilead = icat
         if (ilead.eq.0) then
            icmin = 100 
            do i=1,iatoms
               if (ocnos(i,ianz,iaton)) then
                  icnos = 0
                  do j=1,iconn(1,i)
                     jj = abs(iconn(j+1,i))
                     if (ocnos(jj,ianz,iaton)) icnos = icnos + 1
                  end do
                  if (icnos.lt.icmin) then
                      icmin = icnos
                      icat  = i
                  endif
               endif
            end do
            if (icmin.ne.100) ilead = icat
         endif
         if (ilead.eq.0) then
            mconn = -1 
            do i=1,iatoms
               if (ianz(i).ne.1.and.iaton(i).eq.2) then
                   if (iconn(1,i).gt.mconn) then
                      mconn = iconn(1,i)
                      ilead = i
                   endif
               endif
            end do
         endif
         if (ilead.eq.0) ilead = 1
      endif

      if (debug) print*,'start lead ',ilead
      
20    continue
      if (ilead.eq.ilold) goto 2000

      ilold = ilead
      if (.not.ringg(ilead,iring,nring,.false.,ianz,iaton,iconn,
     &               lwrit,lring)) goto 2000
      if (nring.ge.5) then
         if (debug) print*,'found ring n=',nring
c
c     ilead is a ring member
c
         if (.not.wring(iring,nring,isel,ianz,iaton,iconn,lwrit,lring)) 
     &      goto 2000
         if (debug) call prtzm
c
c        check for connected rings
c
10       do i=1,iatoms
            if (lring(i).eq.1) then
               if (.not.ringg(i,iring,nring,.false.,ianz,iaton,iconn,
     &                        lwrit,lring)) goto 2000
               if (nring.ge.5) then
                  if (.not.wring(iring,nring,isel,ianz,iaton,iconn,
     &                           lwrit,lring)) goto 2000
                  goto 10
               endif
            endif
         end do
      else
c
c     ilead is not a ring member
c
         if (isel(1).eq.0) then
c
c           this a new lead, so get 3 atoms to which it is connected
c
            idum = 0
            if (parlea(ilead,isel,ispdb)) idum = 1
            if (debug) then
               if (idum.eq.1) then
                  print*,'parse new lead'
               else
                  print*,'failed parsing new lead'
               endif
            endif
         else
            if (debug) print*,'parse extended lead'
            if (.not.pcklin(isel)) goto 2000
         endif
         if (debug) call prtzm
c
c        get atom connected to prev lead and ne isel(2)
c
         ilead = 0
         do j=1,iconn(1,isel(1))
            jj = abs(iconn(j+1,isel(1)))
            if (ianz(jj).ne.1.and.jj.ne.isel(2).and.lwrit(jj).eq.0
     &          .and.iaton(jj).eq.2)   ilead = jj
         end do
         if (ilead.eq.0) goto 1000
         if (debug) print*,'extend old lead ',ilead
         isel(4) = isel(3)
         isel(3) = isel(2)
         isel(2) = isel(1)
         isel(1) = ilead
         goto 20
      endif

1000  continue
      if (debug) print*,'make brand new lead'
      
c
c     get brand new lead, first ring connected then other ?
c
      ilead = 0
c      if (ispdb.eq.1) goto 1010
c
c     Check for atoms connected to rings
c
      do i=1,iatoms
         if (lring(i).ne.0) then
             do j=1,iconn(1,i)
                jj = abs(iconn(j+1,i))
                if (ianz(jj).ne.1.and.lwrit(jj).eq.0
     &          .and.iaton(jj).eq.2) then
                    if (.not.(ispdb.eq.1.and.iresid(i).gt.0)) then
                       ilead = jj
                       if (debug) print*,'ring atom'
                       goto 900
                    endif
                endif
             end do
         endif
      end do
      if (debug) print*,'not a ring atom'
c
c     other connected atoms
c
      if (ilead.eq.0) then
         do i=1,iatoms
            if (lwrit(i).ne.0.and.iaton(i).eq.2) then
                do j=1,iconn(1,i)
                   jj = abs(iconn(j+1,i))
                   if (ianz(jj).ne.1.and.ianz(jj).lt.99
     &             .and.lwrit(jj).eq.0.and.iaton(jj).eq.2) then
                      if (.not.(ispdb.eq.1.and.iresid(i).gt.0)) then
                       ilead = jj
                       if (debug) 
     &                     print*,'connected atom ',ilead,' to ',i,
     &                            ' written nr. ',lwrit(i)
                       goto 900
                      endif
                   endif
                end do
            endif
         end do
      endif
1010  continue
      if (debug) print*,'not a connected atom'
c
c     Check for non bonded atoms
c
      if (ilead.eq.0) then
         nanz = 1
         if (nwrit-nwrith.lt.noth.or.ispdb.eq.1) then
            ispdbt = ispdb
            if (ispdb.eq.1.and.nchain.le.0) ispdbt = 0
            call icrcon(ilead,isel,idisc,ndisc,nanz,ispdbt)
            if (ilead.ne.0.and.ispdbt.eq.1) then
c               ilead = 0
               goto 20
            endif
c         else
c            print*,'nwrit=',nwrit,' nwrith=',nwrith,' noth=',noth
         endif
      endif
      if (debug) print*,'non bonded atom'
900   if (ilead.ne.0) then
         if (debug) 
     &       print*,'found new lead , ilead=',ilead,' ',ianz(ilead)
         do i=1,4
            isel(i) = 0
         end do
         goto 20
      endif

910   continue
c      print*,'910 nwrit=',nwrit,' nwrith=',nwrith,' noth=',noth
c
c     Take care of hydrogens
c
      ilo = -1
      do l=1,iatoms
         il = l
         if (isimpl.ge.2) then
            if (l.le.numat1) il = jring(l)
         endif

         if (isimpl.ge.1.and.il.eq.0) then
            if (ilo.eq.-1) goto 2000

            do ii=1,iatoms
               if (ii.le.numat1) jring(ii) = 0
            end do

            isimpl = 0
c           No more atoms preferred ordering, continue with none
            ilead = 0

            do j=1,iconn(1,isel(1))
               jj = abs(iconn(j+1,isel(1)))
               if (ianz(jj).ne.1.and.jj.ne.isel(2).and.lwrit(jj).eq.0
     &             .and.iaton(jj).eq.2)   ilead = jj
            end do

            if (ilead.eq.0) goto 1000
            if (debug) print*,'extend old lead ',ilead

            isel(4) = isel(3)
            isel(3) = isel(2)
            isel(2) = isel(1)
            isel(1) = ilead

            if (debug) print*,'extend isel',(isel(ii),ii=1,4)
            goto 20
         endif

         if ((ianz(il).eq.1.or.isimpl.ge.1).and.lwrit(il).eq.0
     &        .and.iaton(il).eq.2) then
            ilo = il
            ilead = il
            if (.not.parlea(il,isel,0)) then
               if (ifcon(il,idisc,ndisc,0,ianz,iaton,iconn,lwrit)
     &                   .ne.0) then
                  if (.not.parlea(il,isel,0)) then
                      idum = 0
                  else
                    if (isimpl.ge.1) then
                      if (.not.ringg(il,iring,nring,.false.,
     &                               ianz,iaton,iconn,lwrit,lring)) then
                          goto 2000
                      else
                         lring(il) = 1
                      endif
                    endif
                  endif
               endif
            else
               if (isimpl.ge.1) then
                  if (.not.ringg(il,iring,nring,.false.,
     &                           ianz,iaton,iconn,lwrit,lring)) then
                      goto 2000
                  else
                     lring(il) = 1
                  endif
               endif
            endif
            if (debug) call prtzm
         endif
      end do

2000  continue

c
c     Disconnect Fake connections
c
      do i=1,ndisc,2

         j = idisc(i)
         k = idisc(i+1)

         do m=1,iconn(1,j)
c            if (abs(iconn(1+m,j)).eq.k) then
            if (iconn(1+m,j).eq.k) then
               do n=m+1,iconn(1,j)
                  iconn(n,j) = iconn(n+1,j)
               end do
               iconn(1,j) = iconn(1,j)-1
            endif
         end do

         do m=1,iconn(1,k)
c            if (abs(iconn(1+m,k)).eq.j) then
            if (iconn(1+m,k).eq.j) then
               do n=m+1,iconn(1,k)
                  iconn(n,k) = iconn(n+1,k)
               end do
               iconn(1,k) = iconn(1,k)-1
            endif
         end do

      end do

      if (ispdb.eq.1.and.nzpdb.ne.0) then
         call setzm(nzpdb)
      endif

      if (nwrit.lt.nsel) then
          print*,'Error in automatic cartesian -> z-matrix conversion'
          print*,'No. of atoms written ',nwrit,' not equal to total ',
     &           'No. of selected atoms ',nsel
          if (.true.) then
              do i=1,iatoms
                 if (iaton(i).eq.2.and.lwrit(i).eq.0) then
                    print*,i,' ',ianz(i),(iconn(j+1,i),j=1,iconn(1,i))
                 endif
              end do
          endif
      endif

      if (isimpl.ge.2) isimpl = 0

      return
      end

      subroutine icrcod(icrcon,isel,idisc,ndisc,nanz,ispdb,
     &                        ianz,iaton,iconn,lwrit,coo,
     &                        icalf,ncalf)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      parameter (ncmax=1000)
      logical pline,chkclf
      real bl,rmin
      dimension isel(4),idisc(ncmax)
      dimension ianz(*),iaton(*),iconn(mxcon+1,*),coo(3,*),lwrit(*)
      dimension icalf(6,*)

      icrcon = 0

      do i=1,4
         isel(i) = 0
      end do

      rmin = 1.0e5
      im1 = 0
      im2 = 0
      jtarg = 0
      do i=1,iatoms
         if (ianz(i).ne.nanz.and.lwrit(i).eq.0.and.
     &       iaton(i).eq.2) then
            if (ispdb.eq.1) then
               jtarg = 1
               dmn = 10000000.d0
               do j=1,ncalf
                if (icalf(1,j).ne.0) then
                  if (chkclf(j,icalf).and.
     &               iconn(1,icalf(1,j)).lt.mxcon) then
                     d2 = dist2(coo(1,icalf(1,j)),coo(1,i))
                     if (d2.lt.dmn
     &                  .and.(i.ne.icalf(1,j))
     &                  .and.(i.ne.icalf(2,j))
     &                  .and.(i.ne.icalf(3,j))
     &                  .and.(i.ne.icalf(4,j))) then
                        dmn = d2
                        jtarg = j
                     endif
                  endif
                endif
               end do
               isel(1) = i
               isel(2) = icalf(1,jtarg)
               call intcor(intc,bl,isel,2)
               if (intc.eq.0) then
                  call haszm(.false.)
                  return
               endif
               if (bl.lt.rmin) then
                  rmin = bl
                  im1 = i
                  im2 = icalf(1,jtarg)
               endif
               goto 10
            else
               do j=1,iatoms
                  if (ianz(j).ne.nanz.and.ianz(j).lt.99
     &            .and.iconn(1,j).lt.mxcon
     &            .and.lwrit(j).ne.0.and.iaton(j).eq.2.and.i.ne.j) then
                     isel(1) = i
                     isel(2) = j
                     call intcor(intc,bl,isel,2)
                     if (intc.eq.0) then
                        call haszm(.false.)
                        return
                     endif
                     if (bl.lt.rmin) then
                        rmin = bl
                        im1 = i
                        im2 = j
                     endif
                  endif
               end do
            endif
         endif
      end do

10    icrcon = jcrcon(im1,im2,idisc,ndisc,iconn)
      if (ispdb.eq.1.and.jtarg.ne.0) then
         isel(3) = icalf(2,jtarg)
         isel(4) = icalf(3,jtarg)
c         if (.not.pline(isel)) goto 100
      endif

      return
100   print*,'error'
      return
      end

      logical function chkclf(ires,icalf)
      implicit double precision (a-h,o-z)
      dimension icalf(6,*)

      chkclf = .true.
      do i=1,3
         if (icalf(1,ires).eq.icalf(1+i,ires)) chkclf = .false.
      end do
      do i=1,2
         if (icalf(2,ires).eq.icalf(2+i,ires)) chkclf = .false.
      end do
      if (icalf(3,ires).eq.icalf(4,ires)) chkclf = .false.

c      print*,'chkclf ires=',ires,' ',chkclf
c      if (.not.chkclf) print*,(icalf(i,ires),i=1,4)

      return
      end

      integer function ifcon(ilead,idisc,ndisc,nanz,
     &                       ianz,iaton,iconn,lwrit)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (ncmax=1000)
      common /athlp/ iatoms, mxnat
      real bl,rmin
      dimension isel(4),idisc(ncmax)
      dimension ianz(*),iaton(*),iconn(mxcon+1,*),lwrit(*)

      ifcon = 0

      rmin = 1.0e5
      im1 = 0
      im2 = 0
      do j=1,iatoms
         if (ianz(j).ne.nanz.and.ianz(j).lt.99
     &   .and.iconn(1,j).lt.mxcon
     &   .and.lwrit(j).ne.0.and.iaton(j).eq.2.and.ilead.ne.j) then
            isel(1) = ilead
            isel(2) = j
            call intcor(intc,bl,isel,2)
            if (intc.eq.0) then
               call haszm(.false.)
               return
            endif
            if (bl.lt.rmin) then
               rmin = bl
               im1 = ilead
               im2 = j
            endif
         endif
      end do

      ifcon = jcrcon(im1,im2,idisc,ndisc,iconn)

      return
      end

      integer function jcrcon(im1,im2,idisc,ndisc,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (ncmax=1000)
      dimension idisc(ncmax),iconn(mxcon+1,*)

      jcrcon = 0

      icim1 = 0
      icim2 = 0
      icimt = 0

      if (im1.ne.0.and.im2.ne.0) then
c
c Create fake connection
c

c check if they are not connected

          
          do i=1,iconn(1,im1)
             if (iconn(1+i,im1).eq.im2) icim1 = 1
          end do

          do i=1,iconn(1,im2)
             if (iconn(1+i,im2).eq.im1) icim2 = 1
          end do

          icimt = icim1 + icim2

          if (icimt.eq.2) then
              jcrcon = im1
              return
          endif

          if (iconn(1,im1).lt.mxcon.and.
     &        iconn(1,im2).lt.mxcon) then

             jcrcon =  im1
             iconn(2+iconn(1,im1),im1) = im2
             iconn(1,im1) = iconn(1,im1) + 1
             iconn(2+iconn(1,im2),im2) = im1
             iconn(1,im2) = iconn(1,im2) + 1

             if (ndisc.lt.ncmax-1) then
                 ndisc = ndisc + 1
                 idisc(ndisc) = im1
                 ndisc = ndisc + 1
                 idisc(ndisc) = im2
             else
                 print*,'intzmt: array to hold fake conn. full'
             endif

          else
              print*,'intzmt: couldnt create fake connection'
          endif

      endif

      return
      end

      subroutine getrng(iat,iout,ianz,iconn)
      implicit double precision (a-h,o-z)
      common /athlp/  iatoms, mxnat
      parameter (mxcon=10)
      dimension ianz(*),iconn(mxcon+1,*)
   
      iout = 0
      call ring5(nring,iat,ianz,iconn)

      if (nring.eq.5) iout = 1
   
      return
      end

      subroutine ring5(nring,iat,ianz,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      real dihed
      dimension isel(4),iring(6),ianz(*),iconn(mxcon+1,*)
      
c oflat finds flat 6,5 membered rings
  
      do i=1,6
         iring(i) = 0
      end do

      nring = 0
      ia = ianz(iat)
      if (ia.eq.6.or.ia.eq.7.or.ia.eq.8.or.ia.eq.16) then
         do j=1,iconn(1,iat)
            jj = abs(iconn(j+1,iat))
            ja = ianz(jj)
            if (ja.eq.6.or.ja.eq.7.or.ja.eq.8.or.ja.eq.16) then
               do k=1,iconn(1,jj)
                  kk = abs(iconn(k+1,jj))
                  ka = ianz(kk)
                  if ((ka.eq.6.or.ka.eq.7.or.ka.eq.8.or.ka.eq.16)
     &                 .and.kk.ne.iat) then
                     do l=1,iconn(1,kk)
                        ll = abs(iconn(l+1,kk))
                        la = ianz(ll)
                        if ((la.eq.6.or.la.eq.7.or.la.eq.8.or.la.eq.16)
     &                      .and.ll.ne.iat.and.ll.ne.jj) then
                           isel(1) = iat
                           isel(2) = jj
                           isel(3) = kk
                           isel(4) = ll
                           call intcor(intc,dihed,isel,4)
                           if (intc.eq.0) then
                              nring = 0
                              return
                           endif

                           if (abs(dihed).lt.5.0e0) then
                              do m=1,iconn(1,iat)
                                 mm = abs(iconn(m+1,iat))
                                 ma = ianz(mm)
                                 if ((ma.eq.6.or.ma.eq.7.or.ma.eq.8.or.
     &                                ma.eq.16).and.mm.ne.jj) then
                                    do n=1,iconn(1,ll)
                                       nn = abs(iconn(n+1,ll))
                                       na = ianz(nn)
                                       if ((na.eq.6.or.na.eq.7.or.
     &                                      na.eq.8.or.na.eq.16)
     &                                      .and.nn.ne.kk) then
                                          if (mm.eq.nn) then
                                             nring = 5
                                             iring(1) = iat
                                             iring(2) = jj
                                             iring(3) = kk
                                             iring(4) = ll
                                             iring(5) = mm
                                             call intcor(intc,dihed,
     &                                          iring(2),4)
                                             if (intc.eq.0) then
                                                nring = 0
                                                return
                                             endif

                                             if (abs(dihed).lt.5.0e0)
     &                                       then
                                                return
                                             endif

                                          endif
                                       endif
                                    end do
                                 endif
                              end do
                           endif
                        endif
                     end do
                  endif
               end do
            endif
         end do
      endif

      return
      end

      subroutine ringd(i,iring,nring,iflat,ianz,iaton,iconn,
     &                 lwrit,lring,iret)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      logical oflat,ringg
      dimension iring(6),ianz(*),iaton(*),iconn(mxcon+1,*)
      dimension lwrit(*),lring(*)

      if (iflat.gt.0) then
          oflat = .true.
      else 
          oflat = .false.
      endif

      iret = 0

      if (ringg(i,iring,nring,oflat,ianz,iaton,iconn,lwrit,lring)) then
         iret = 1
      endif

      return
      end

      logical function ringg(i,iring,nring,oflat,ianz,iaton,iconn,
     &                       lwrit,lring)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      logical ocnos,oring,oflat
      real dihed
      dimension isel(4),iring(6),ianz(*),iaton(*),iconn(mxcon+1,*)
      dimension lwrit(*),lring(*)
      
c oflat finds flat 6,5 membered rings
  
      ringg = .true.

      if (ocnos(i,ianz,iaton)) then
         do j=1,iconn(1,i)
            jj = abs(iconn(j+1,i))
            if (ocnos(jj,ianz,iaton)) then
               do k=1,iconn(1,jj)
                  kk = abs(iconn(k+1,jj))
                  if (ocnos(kk,ianz,iaton).and.kk.ne.i) then
                     do l=1,iconn(1,kk)
                        ll = abs(iconn(l+1,kk))
                        if (ocnos(ll,ianz,iaton).and.ll.ne.jj
     &                      .and.ll.ne.i) then
                           isel(1) = i
                           isel(2) = jj
                           isel(3) = kk
                           isel(4) = ll
                           call intcor(intc,dihed,isel,4)
                           if (intc.eq.0) then
                              call haszm(.false.)
                              ringg = .false.
                              return
                           endif
                           if ((.not.oflat.and.abs(dihed).lt.90.0e0)
     &                        .or.(oflat.and.abs(dihed).lt.5.0e0)) then
                              do m=1,iconn(1,i)
                                 mm = abs(iconn(m+1,i))
                                 if (ocnos(mm,ianz,iaton).and.mm.ne.jj) 
     &                           then
                                    do n=1,iconn(1,ll)
                                       nn = abs(iconn(n+1,ll))
                                       if (ocnos(nn,ianz,iaton).and.
     &                                           nn.ne.kk) then
                                          if (mm.eq.nn) then
                                             nring = 5
                                             iring(1) = i
                                             iring(2) = jj
                                             iring(3) = kk
                                             iring(4) = ll
                                             iring(5) = mm
                                             if (oflat) then
                                                call intcor(intc,dihed,
     &                                          iring(2),4)
                                                if (intc.eq.0) then
                                                call haszm(.false.)
                                                ringg = .false.
                                                return
                                                endif
                                             endif
                                             if (.not.oflat.or.(oflat
     &                                       .and.abs(dihed).lt.5.0e0))
     &                                       then
                                                if (oring(nring,iring,
     &                                              lwrit,lring)) then
                                                 return
                                                endif
                                             endif
                                          else
                                          do ii=1,iconn(1,nn)
                                             ij=abs(iconn(ii+1,nn))
                                             if (ocnos(ij,ianz,iaton)
     &                                           .and.ij.ne.ll)
     &                                       then
                                               if (ij.eq.mm.and.i.ne.nn) 
     &                                         then
                                                   nring = 6
                                                   iring(1) = i
                                                   iring(2) = jj
                                                   iring(3) = kk
                                                   iring(4) = ll
                                                   iring(5) = nn
                                                   iring(6) = ij

                                             if (oflat) then
                                                call intcor(intc,dihed,
     &                                                      iring(3),4)
                                                if (intc.eq.0) then
                                                    call haszm(.false.)
                                                    ringg = .false.
                                                    return
                                                endif
                                             endif

                                             if (.not.oflat.or.(oflat
     &                                       .and.abs(dihed).lt.5.0e0))
     &                                       then
                                                if (oring(nring,iring,
     &                                              lwrit,lring)) then
                                                  return
                                                endif
                                             endif
                                               endif
                                             endif
                                          end do
                                          endif
                                       endif
                                    end do
                                 endif
                              end do
                           endif
                        endif
                     end do
                  endif
               end do
            endif
         end do
      endif

      nring = 0

      return
      end

      logical function wring(iring,nring,isel,ianz,iaton,iconn,
     &                       lwrit,lring)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /zmatst/ nwrit,nvar,isimpl
      logical onorng,pline
      real angle
      dimension isel(4),isl(4),iring(6),kring(18)
      dimension ianz(*),iaton(*),iconn(mxcon+1,*),lwrit(*),lring(*)


c     first reorder

      wring = .true.
      tol = 1.0d-10

      do i=1,nring
         kring(6+i) = iring(i)
         kring(6-nring+i) = iring(i)
         kring(6+nring+i) = iring(i)
      end do

      iseed = 1
      isens = 1

      do i=1,nring

         if (lring(kring(6+i)).eq.1.and.
     &   (lring(kring(5+i)).eq.0.or.lring(kring(7+i)).eq.0)) then

            if (lring(kring(7+i)).eq.0) isens = -1
            iseed = i
            goto 10
         endif

      end do

10    do i=1,nring
         iring(i) = kring(6+iseed+isens*(i-1))
      end do

      do i=1,nring
         kring(3+i) = iring(i)
      end do

      itot = 0

      do i=1,nring
        itot = itot + lring(iring(i)) 
      end do

      kring(3) = 0
      kring(2) = 0
      kring(1) = 0
c
c Search for atoms this ring is connected to
c
c      if (itot.le.2.and.isel(1).eq.0) then
      if (itot.le.2.and.(isel(1).ne.iring(1))) then
        iat = iring(1)
50      do i=1,iconn(1,iat)
           ii = abs(iconn(i+1,iat))
           if (ianz(ii).ne.1.and.onorng(iring,nring,ii,lwrit).and.
     &         iaton(ii).eq.2) then
              kring(3) = ii
              do j=1,iconn(1,kring(3))
                 jj = abs(iconn(j+1,kring(3)))
                 if (ianz(jj).ne.1.and.onorng(iring,nring,jj,lwrit)
     &              .and.iaton(jj).eq.2) then
                    if (kring(2).ne.0) kring(1) = kring(2)
                    kring(2) = jj
                    isl(1) = iat
                    isl(2) = kring(3)
                    isl(3) = kring(2)
                    call tomold(angle,isl,3)
                    if (.not.(abs(angle).lt.tol.or.
     &                   abs(angle).gt.180.e0-tol)) then
                       do k=1,iconn(1,kring(2))
                          kk = abs(iconn(k+1,kring(2)))
                          if (ianz(kk).ne.1.and.
     &                        onorng(iring,nring,kk,lwrit).and.
     &                        kk.ne.kring(3).and.iaton(kk).eq.2) then
                             kring(1) = kk
                             goto 100
                          endif
                       end do
                    endif
                 endif
              end do
           endif
        end do
100     continue
        if ((kring(3).eq.0.and.nwrit.gt.2).and.iat.ne.iring(2)) then
           iat = iring(2)
           goto 50
        endif
      else
         kring(3) = isel(2)
         kring(2) = isel(3)
         kring(1) = isel(4)
      endif

      do i=1,nring
         j = iring(i)
         if (lwrit(j).eq.0) then
            lring(j) = 1
            isel(1) = kring(3+i)
            isel(2) = kring(2+i)
            isel(3) = kring(1+i)
            isel(4) = kring(i)
            if (.not.pline(isel)) then
                isel(1) = 0
                wring = .false.
                return
            endif
         endif
      end do

      isel(1) = 0
      return
      end

      logical function ocnos(inum,ianz,iaton)
      implicit double precision (a-h,o-z)
      dimension ianz(*),iaton(*)
      
      ocnos = .false.
      iatnr = ianz(inum)
      if ((iatnr.eq.6.or.iatnr.eq.7.or.iatnr.eq.8.or.iatnr.eq.16)
     &    .and.iaton(inum).eq.2) ocnos = .true.

      return
      end

      logical function oring(nring,iring,lwrit,lring)
      implicit double precision (a-h,o-z)
      dimension iring(6),lwrit(*),lring(*)

      oring = .false.
      itot = 0
      jtot = 0
      do i=1,nring
        itot = itot + lring(iring(i)) 
        if (lwrit(iring(i)).ne.0) jtot = jtot + 1
      end do
      if (itot.lt.nring.and.jtot.lt.nring) oring = .true.

      return
      end

      logical function onorng(iring,nring,isub,lwrit)
      implicit double precision (a-h,o-z)
      dimension iring(6),lwrit(*)

      onorng = .true.
      do i=1,nring
        if (isub.eq.iring(i)) onorng = .false.
      end do
      if (lwrit(isub).eq.0) onorng = .false.

      return
      end

      subroutine plinz(isel,istat,
     &              bl,alph,bet,ibl,ialph,ibet,imap,ianzz,iz,
     &              lwrit,ianz)

c this is really logical function pline

      implicit double precision (a-h,o-z)
      common /zmfrst/ ihaszm, nz, mxzat
      logical lineok
      real bond,angle,dihed
      common /zmatst/ nwrit,nvar,isimpl
      dimension isel(4),ian(4)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianzz(*),iz(4,*),lwrit(*),ianz(*)

      toang = 0.52917706d0

      istat = 1
      lineok = .true.

      nchk = nwrit + 1
      if (nchk.gt.4) nchk = 4
      do i=1,nchk
         lineok = (lineok.and.isel(i).ne.0)
      end do
      if (.not.lineok) goto 100

      nwrit = nwrit + 1
      lwrit(isel(1)) = nwrit
      
      do i=1,nchk
         ian(i) = ianz(isel(i))
      end do

      if (nwrit.ge.1) then
          ianzz(nwrit) = ian(1)
          imap(nwrit) = isel(1)
          iz(1,nwrit) = 0
          iz(2,nwrit) = 0
          iz(3,nwrit) = 0
          iz(4,nwrit) = 0
      endif
      if (nwrit.ge.2) then
          call intcor(intc,bond,isel,2)
          if (intc.eq.0) goto 90
          bond = bond * toang
          bl(nwrit) = bond
          ibl(nwrit) = 1
          iz(1,nwrit) = lwrit(isel(2))
      endif
      if (nwrit.ge.3) then
          call intcor(intc,angle,isel,3)
          if (intc.eq.0) goto 90
          alph(nwrit) = angle
          ialph(nwrit) = 1
          iz(2,nwrit) = lwrit(isel(3))
      endif
      if (nwrit.gt.3) then
          call intcor(intc,dihed,isel,4)
          if (intc.eq.0) goto 90
          bet(nwrit) = dihed
          ibet(nwrit) = 1
          iz(3,nwrit) = lwrit(isel(4))
          iz(4,nwrit) = 0
      endif

      nz = nwrit

      return

90    nwrit = nwrit - 1
      lwrit(isel(1)) = 0

100   istat = 0
      call haszm(.false.)

      return
      end

      subroutine dumliz(isel,blv,alphv,betv,
     &                  bl,alph,bet,ibl,ialph,ibet,imap,ianzz,iz,
     &                  lwrit,ianz)

c this is really dumlin

      implicit double precision (a-h,o-z)
      common /zmfrst/ ihaszm, nz, mxzat
      common /zmatst/ nwrit,nvar,isimpl
      dimension isel(4)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianzz(*),iz(4,*),lwrit(*),ianz(*)

c
c     Bond length expected in Angstroms
c
      nwrit = nwrit + 1
      lwrit(isel(1)) = nwrit

      ianzz(nwrit) = ianz(isel(1))

      do i=1,3
         iz(i,nwrit) = lwrit(isel(i+1))
      end do

      iz(4,nwrit) = 0

      bl(nwrit) = blv
      ibl(nwrit) = 1
      alph(nwrit) = alphv
      ialph(nwrit) = 1
      bet(nwrit) = betv
      ibet(nwrit) = 1

      imap(nwrit) = isel(1)

      nz = nwrit

      return
      end

      subroutine calcd(ical,isel,nx,ianz,iaton,iconn,coo)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /zmatst/ nwrit,nvar,isimpl
      dimension v32(3),v43(3),c1(3),c2(3),isel(4)
      dimension coo(3,*),ianz(*),iaton(*),iconn(mxcon+1,*)

c
c     Calculate coordinates dummy atom X, and add
c
      ical = 1
      
      tol = 1.0d-10
      toang = 0.52917706d0

      do i=1,3
          v32(i) = coo(i,isel(3)) - coo(i,isel(2))
          if (isel(4).ne.0) then
             v43(i) = coo(i,isel(4)) - coo(i,isel(3))
          else
             v43(i) = 0.0d0
          endif
      end do
      if (isel(4).eq.0) then
          v43(1) = 1.0d0
          call impsc(v32,v43,cosb)
          if (dabs(dabs(cosb)-1.0d0).lt.tol) then
              v43(1) = 0.0d0
              v43(2) = 1.0d0
          endif
          
      endif

      do i=1,4
         if ((isel(i).lt.1.and.nwrit.gt.2).or.isel(i).gt.iatoms) 
     &   goto 100
         do j=i+1,4
             if (isel(i).eq.isel(j)) goto 100
         end do
      end do

      call crprod(v32,v43,c1)
      call crprod(c1,v32,c2)
      call vsc1(c2,1.0d0/toang,tol)
      
      iatoms = iatoms + 1
      nx = iatoms

      do i=1,3
         coo(i,nx) = coo(i,isel(2)) + c2(i)
      end do

      iconn(1,nx) = 1
      iconn(2,nx) = isel(2)
      ianz(nx) = 99
      iaton(nx) = 2

      if (iconn(1,isel(2)).lt.mxcon) then
         iconn(1,isel(2)) = iconn(1,isel(2)) + 1
         iconn(iconn(1,isel(2))+1,isel(2)) = nx
      endif


      return

100   ical = 0
      return
      end

      subroutine atadd(iat1,iat2,iat3,ian,bl,alpha,dih,iret,
     &                 ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &                 ncalf,icalf,coo)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      logical addat
      integer*2 ityp,ipdbt
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*),ityp(*),ipdbt(*),icalf(6,*)

      if (.not.addat(iat1,iat2,iat3,ian,bl,alpha,dih,iret,0,
     &               ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &               ncalf,icalf,coo)) then
          print*,'error adding atom'
      endif
     
      return
      end

      logical function addat(iat1,iat2,iat3,ian,bl,alpha,dih,iret,ichk,
     &                       ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &                       ncalf,icalf,coo)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      integer*2 ityp,ipdbt
      common /athlp/ iatoms, mxnat
      dimension v21(3),v32(3),c1(3),c2(3),c3(3),c4(3),ctmp(3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*),ityp(*),ipdbt(*),icalf(6,*)

c
c     Add atom given bondlength, bondangle and dihedral with
c     respect to three atoms
c
      iret = 0
      addat = .true.
      
      if (iat1.le.0.or.iat1.gt.mxnat) goto 100
      if (iat2.le.0.or.iat2.gt.mxnat) goto 100
      if (iat3.le.0.or.iat3.gt.mxnat) goto 100

      tol = 1.0d-10
      toang = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)
      sa = dsin(alpha/todeg)
      ca = dcos(alpha/todeg)
      sd = dsin(dih/todeg)
      cd = dcos(dih/todeg)

      do i=1,3
          v21(i) = coo(i,iat2) - coo(i,iat1)
          v32(i) = coo(i,iat3) - coo(i,iat2)
      end do
      call vsc1(v32,1.0d0,tol)

c     check for three atoms on a line

      call impsc(v21,v32,cosb)
      if (dabs(cosb).lt.tol) goto 100

      call crprod(v21,v32,c1)
      call vsc1(c1,1.0d0,tol)
      call crprod(c1,v32,c2)
      call vsc1(c2,1.0d0,tol)

      do i=1,3
          c3(i) = cd*c2(i) + sd*c1(i)
      end do
      
      do i=1,3
          c4(i) = -ca*v32(i) + sa*c3(i)
      end do

      call vsc1(c4,bl/toang,tol)

      if (iatoms.ge.mxnat) goto 100

      do i=1,3
         ctmp(i) = coo(i,iat3) + c4(i)
      end do

      iflg = 0
      do i=1,iatoms
          d2 = dist2(ctmp,coo(1,i))
          if (d2*toang*toang.lt.0.7d0) then
             iflg = 1
             d2t = d2
             i2t = i
          endif
      end do

c      if (iflg.eq.1) then
c          print*,'i2t=',i2t,'d2=',d2t*toang*toang,
c     &  ' iatoms=',iatoms,' bl=',bl
c          print*,'ctmp ',(ctmp(i)*toang,i=1,3)
c          print*,'ci2t ',(coo(i,i2t)*toang,i=1,3)
c      endif
      if (iflg.eq.1.and.ichk.eq.1) goto 100

      natoms = 0
      if (iresid(iat3).lt.-3) then
         do i=1,iatoms
            if (iresid(i).eq.iresid(iat3)) then
               natoms = i + 1
            endif
         end do
      endif

      if (natoms.eq.0) then
          natoms = iatoms + 1
      else


         do i=1,natoms-1
            do j=1,iconn(1,i)
               it = iconn(1+j,i)
               iat = iabs(it)
               if (it.ge.0) then
                  if (it.ge.natoms) then
                     iconn(1+j,i) = it + 1
                  endif
               else
                  if (iat.ge.natoms) then
                     iconn(1+j,i) = it - 1
                  else
                     iconn(1+j,i) = it
                  endif
               endif
            end do
         end do

         do i=iatoms,natoms,-1
            iconn(1,i+1) = iconn(1,i)
            do j=1,iconn(1,i)
               it = iconn(1+j,i)
               iat = iabs(it)
               if (it.ge.0) then
                  if (it.ge.natoms) then
                     iconn(1+j,i+1) = it + 1
                  else
                     iconn(1+j,i+1) = it
                  endif
               else
                  if (iat.ge.natoms) then
                     iconn(1+j,i+1) = it - 1
                  else
                     iconn(1+j,i+1) = it
                  endif
               endif
            end do

            ianz(i+1)    = ianz(i)
            iaton(i+1)   = iaton(i)
            iatclr(i+1)  = iatclr(i)
            iresid(i+1)  = iresid(i)
            ityp(i+1)    = ityp(i)
            ipdbt(i+1)   = ipdbt(i)

            do j=1,3
               coo(j,i+1) = coo(j,i)
            end do

            call sftlab(i)

         end do

         do i=1,ncalf
            if (icalf(1,i).ge.natoms) icalf(1,i) = icalf(1,i) + 1
            if (icalf(4,i).ge.natoms) icalf(4,i) = icalf(4,i) + 1
         end do

      endif

      iatoms = iatoms + 1
      iret = natoms

      do i=1,3
         coo(i,natoms) = coo(i,iat3) + c4(i)
      end do

      iconn(1,natoms) = 1
      iconn(2,natoms) = iat3
      ianz(natoms)    = ian
      iaton(natoms)   = 1
      iatclr(natoms)  = iatclr(iat3)
      iresid(natoms)  = iresid(iat3)
      ityp(natoms)    = 0
      ipdbt(natoms)   = 0

      if (iconn(1,iat3).lt.mxcon) then
         iconn(1,iat3) = iconn(1,iat3) + 1
         iconn(iconn(1,iat3)+1,iat3) = natoms
      endif

      return

100   addat = .false.
c      print*,'ierr=',ierr
      return
      end

      subroutine fliph(iat1,iat2,iat3,istat,bl,alpha,dih,cret,coo)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension v21(3),v32(3),c1(3),c2(3),c3(3),c4(3)
      dimension coo(3,*),cret(*)

      istat = 0
      
      if (iat1.le.0.or.iat1.gt.mxnat) goto 100
      if (iat2.le.0.or.iat2.gt.mxnat) goto 100
      if (iat3.le.0.or.iat3.gt.mxnat) goto 100

      tol = 1.0d-10
      toang = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)
      sa = dsin(alpha/todeg)
      ca = dcos(alpha/todeg)
      sd = dsin(dih/todeg)
      cd = dcos(dih/todeg)

      do i=1,3
          v21(i) = coo(i,iat2) - coo(i,iat1)
          v32(i) = coo(i,iat3) - coo(i,iat2)
      end do
      call vsc1(v32,1.0d0,tol)

c     check for three atoms on a line

      call impsc(v21,v32,cosb)
      if (dabs(cosb).lt.tol) goto 100

      call crprod(v21,v32,c1)
      call vsc1(c1,1.0d0,tol)
      call crprod(c1,v32,c2)
      call vsc1(c2,1.0d0,tol)

      do i=1,3
          c3(i) = cd*c2(i) + sd*c1(i)
      end do
      
      do i=1,3
          c4(i) = -ca*v32(i) + sa*c3(i)
      end do

      call vsc1(c4,bl/toang,tol)

      do i=1,3
         cret(i) = coo(i,iat3) + c4(i)
      end do

      return

100   istat = 1
      return
      end

      logical function chkat(iat1,iat2,iat3,bl,alpha,dih,vec,coo)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension v21(3),v32(3),c1(3),c2(3),c3(3),c4(3)
      dimension vec(3),coo(3,*)

c
c     create coordinates of hypothetical added atom given 
c     bondlength, bondangle and dihedral with respect to three atoms
c
      chkat = .true.
      
      if (iat1.le.0.or.iat1.gt.mxnat) goto 100
      if (iat2.le.0.or.iat2.gt.mxnat) goto 100
      if (iat3.le.0.or.iat3.gt.mxnat) goto 100

      tol = 1.0d-10
      toang = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)
      sa = dsin(alpha/todeg)
      ca = dcos(alpha/todeg)
      sd = dsin(dih/todeg)
      cd = dcos(dih/todeg)

      do i=1,3
          v21(i) = coo(i,iat2) - coo(i,iat1)
          v32(i) = coo(i,iat3) - coo(i,iat2)
      end do
      call vsc1(v32,1.0d0,tol)

c     check for three atoms on a line

      call impsc(v21,v32,cosb)
      if (dabs(cosb).lt.tol) goto 100

      call crprod(v21,v32,c1)
      call vsc1(c1,1.0d0,tol)
      call crprod(c1,v32,c2)
      call vsc1(c2,1.0d0,tol)

      do i=1,3
          c3(i) = cd*c2(i) + sd*c1(i)
      end do
      
      do i=1,3
          c4(i) = -ca*v32(i) + sa*c3(i)
      end do
      call vsc1(c4,bl/toang,tol)

      if (iatoms.ge.mxnat) goto 100

      do i=1,3
         vec(i) = coo(i,iat3) + c4(i)
      end do

      return

100   chkat = .false.
      return
      end

      subroutine wlinz(iun,iopt,igamb,
     &                 bl,alph,bet,ibl,ialph,ibet,imap,ianzz,iz,
     &                 iconn,ianz,ityp,qat)

c this is really wline

      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      parameter (mxel=100)
      character*2 elemnt
      common /elem/  elemnt(mxel)
      common /zmfrst/ ihaszm, nz, mxzat

      character*2 tolowf
      character*8  bstr,tbstr
      character*10 astr,tastr
      character*7  dstr,tdstr
      common /zmatst/ nwrit,nvar,isimpl
      integer*2 ityp
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical nolink

CNF   Common to get the type of the atoms
CNF   0 < H < 10000 ; 10000 <= M < 20000 ; L >= 20000
      integer iqmmm
      character*3 oniom(6)
      character*3 link
      character*14 amblab

      dimension isel(4),ian(4)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianzz(*),iz(4,*),
     &          ianz(*),ityp(*),iconn(mxcon+1,*), qat(*)

      data oniom /'H  ','M  ','L  ','H H','M H','L H'/

      toang = 0.52917706d0
      zero = 0.0d0
      i0 = 0
      i1 = 1

      nwrit = nwrit + 1

      isel(1) = nwrit

      do i=1,3
         isel(i+1) = iz(i,nwrit)
      end do

      do i=1,4
         ian(i) = 0
         if (isel(i).gt.0.and.isel(i).le.mxnat) then
            ia = ianzz(isel(i))
            if (ia.gt.0.and.ia.le.mxel) ian(i) = ia
         endif
      end do

CNF   iqmmm (H: 0; M: 1; L: 2)

      iqmmm = ityp(isel(1))/10000
      link = oniom(iqmmm+1)
      do i = 2,iconn(1,isel(1))+1
          j = iconn(i,isel(1))
          ij = ityp(j)/10000
          if (j.ne.0 .and. ij.lt.iqmmm) link = oniom(iqmmm+4)
      end do
      call wrlab(isel(1),amblab,ianz,ityp,qat)

      iop1 = ibl(nwrit)
      iop2 = ialph(nwrit)
      iop3 = ibet(nwrit)
      j1 = iop1
      j2 = iop2
      j3 = iop3
      if (abs(j1).gt.1) j1 = 0
      if (abs(j2).gt.1) j2 = 0
      if (abs(j3).gt.1) j3 = 0

      call mkvar(nwrit,ianzz,iz,bstr,astr,dstr)
      if (nwrit.ge.2) then
          if (iop1.eq.0.and.nolink(nwrit,ibl,nz)) then
             bstr = '        '
             write(bstr,'(f8.5)') bl(nwrit)
          elseif (abs(iop1).gt.1) then
             tbstr = '        '
             call mkvar(iabs(ibl(nwrit)),ianzz,iz,tbstr,tastr,tdstr)
             bstr = tbstr
          else
             nvar = nvar + 1
          endif
      endif

      if (nwrit.ge.3) then
          if (iop2.eq.0.and.nolink(nwrit,ialph,nz)) then
             astr = '          '
             write(astr,'(f8.3)') alph(nwrit)
          elseif (abs(iop2).gt.1) then
             tastr = '        '
             call mkvar(iabs(ialph(nwrit)),ianzz,iz,tbstr,tastr,tdstr)
             astr = tastr
          else
             nvar = nvar + 1
          endif
      endif

      if (nwrit.ge.4) then
          if (iop3.eq.0.and.nolink(nwrit,ibet,nz)) then
             dstr = 'dih    '
             if (bet(nwrit).lt.0.0d0) then
                write(dstr,'(f7.2)') bet(nwrit)
             else
                write(dstr,'(f7.3)') bet(nwrit)
             endif
          elseif (abs(iop3).gt.1) then
             tdstr = '        '
             call mkvar(iabs(ibet(nwrit)),ianzz,iz,tbstr,tastr,tdstr)
             if (iop3.lt.0) then
                dstr(1:1) = '-'
                dstr(2:7) = tdstr(1:6)
             else
                dstr = tdstr
             endif
          else
             nvar = nvar + 1
          endif
      endif


      if (nwrit.eq.1) then
          if (isel(1).eq.0) print*,'isel(1)=0'
          if (iopt.le.2) then
             if (iopt.eq.2 .and. iqmmm.ne.0)
     &        print*,'The first atom must be at the H level only !'
             if (igamb.eq.1) then
                write(iun,'(a14)')amblab
             else
                write(iun,'(a2)')tolowf(elemnt(ian(1)))
             endif
          else
             write(iun,3000) elemnt(ian(1)),zero,
     &              i0,zero,i0,zero,i0,i0,i0,i0
          endif
      elseif (nwrit.eq.2) then
          if (isel(1).eq.0) print*,'isel(1)=0'
          if (isel(2).eq.0) print*,'isel(2)=0'
          if (iopt.le.2) then

             if (iopt.eq.2 .and. iqmmm.ne.0) then
2011            format(a2,1x,i3,1x,a8,1x,a3)
20110           format(a14,1x,i3,1x,a8,1x,a3)
                if (igamb.eq.1) then
                   write(iun,20110) amblab,isel(2), bstr(1:8), link
                else
                   write(iun,2011) tolowf(elemnt(ian(1))),
     &                             isel(2), bstr(1:8), link
                endif
             else
2001            format(a2,1x,i3,1x,a8)
20010           format(a14,1x,i3,1x,a8)
                if (igamb.eq.1) then
                   write(iun,20010) amblab,isel(2), bstr(1:8)
                else
                   write(iun,2001)tolowf(elemnt(ian(1))),
     &                            isel(2), bstr(1:8)
                endif
             endif

             if (iop1.eq.1) 
     &           write(47,'(a8,3x,f9.6)') bstr(1:8),bl(nwrit)
             if (iop1.eq.0.and..not.nolink(nwrit,ibl,nz)) 
     &           write(50,'(a8,3x,f9.6)') bstr(1:8),bl(nwrit)
          else
             write(iun,3000) elemnt(ian(1)),bl(nwrit),
     &              j1,zero,i0,zero,i0,isel(2),i0,i0
             if (abs(iop1).gt.1) 
     &           write(47,'(i4,a3,i4)') abs(iop1),',1,',nwrit
          endif
      elseif (nwrit.eq.3) then
          if (isel(1).eq.0) print*,'isel(1)=0'
          if (isel(2).eq.0) print*,'isel(2)=0'
          if (isel(3).eq.0) print*,'isel(3)=0'
         
          if (iopt.le.2) then

             if(iopt.eq.2 .and. iqmmm.ne.0) then
2012            format(a2,1x,i4,1x,a8,1x,i4,1x,a10,1x,a3)
20120           format(a14,1x,i4,1x,a8,1x,i4,1x,a10,1x,a3)
                if (igamb.eq.1) then
                   write(iun,20120) amblab,
     &               isel(2),bstr(1:8),isel(3),astr(1:10),link
                else
                   write(iun,2012) tolowf(elemnt(ian(1))),
     &               isel(2),bstr(1:8),isel(3),astr(1:10),link
                endif
             else
2002            format(a2,1x,i4,1x,a8,1x,i4,1x,a10)
20020           format(a14,1x,i4,1x,a8,1x,i4,1x,a10)
                if (igamb.eq.1) then
                   write(iun,20020) amblab,
     &               isel(2),bstr(1:8),isel(3),astr(1:10)
                else
                   write(iun,2002) tolowf(elemnt(ian(1))),
     &               isel(2),bstr(1:8),isel(3),astr(1:10)
                endif
             endif

             if (iop1.eq.1) 
     &           write(47,'(a8,3x,f9.6)') bstr(1:8),bl(nwrit)
             if (iop1.eq.0.and..not.nolink(nwrit,ibl,nz)) 
     &           write(50,'(a8,3x,f9.6)') bstr(1:8),bl(nwrit)
             if (iop2.eq.1) 
     &           write(47,'(a10,1x,f8.3)') astr(1:10),alph(nwrit)
             if (iop2.eq.0.and..not.nolink(nwrit,ialph,nz)) 
     &           write(50,'(a10,1x,f8.3)') astr(1:10),alph(nwrit)
          else
             write(iun,3000) elemnt(ian(1)),bl(nwrit),
     &               j1,alph(nwrit),j2,zero,i0,isel(2),isel(3),i0
             if (abs(iop1).gt.1) 
     &           write(47,'(i4,a3,i4)') abs(iop1),',1,',nwrit
             if (abs(iop2).gt.1) 
     &           write(47,'(i4,a3,i4)') abs(iop2),',2,',nwrit
          endif
      else
          if (isel(1).eq.0) print*,'isel(1)=0'
          if (isel(2).eq.0) print*,'isel(2)=0'
          if (isel(3).eq.0) print*,'isel(3)=0'
          if (isel(4).eq.0) print*,'isel(4)=0'
          if (iopt.le.2) then

             if (iopt.eq.2.and.iqmmm.ne.0) then
2013            format(a2,1x,i4,1x,a8,1x,i4,1x,a10,1x,i4,1x,a7,i2,1x,a3)
20130          format(a14,1x,i4,1x,a8,1x,i4,1x,a10,1x,i4,1x,a7,i2,1x,a3)
                if (igamb.eq.1) then
                   write(iun,20130) amblab,
     &              isel(2),bstr(1:8),isel(3),
     &              astr(1:10),isel(4),dstr(1:7),
     &              i0,link
                else
                   write(iun,2013) tolowf(elemnt(ian(1))),
     &              isel(2),bstr(1:8),isel(3),
     &              astr(1:10),isel(4),dstr(1:7),
     &              i0,link
                endif
             else
2003            format(a2,1x,i4,1x,a8,1x,i4,1x,a10,1x,i4,1x,a7)
20030           format(a14,1x,i4,1x,a8,1x,i4,1x,a10,1x,i4,1x,a7)
                if (igamb.eq.1) then
                   write(iun,20030) amblab,
     &              isel(2),bstr(1:8),isel(3),
     &              astr(1:10),isel(4),dstr(1:7)
                else
                   write(iun,2003) tolowf(elemnt(ian(1))),
     &              isel(2),bstr(1:8),isel(3),
     &              astr(1:10),isel(4),dstr(1:7)
                endif
             endif

             if (iop1.eq.1) 
     &           write(47,'(a8,3x,f9.6)') bstr(1:8),bl(nwrit)
             if (iop2.eq.1) 
     &           write(47,'(a10,1x,f8.3)') astr(1:10),alph(nwrit)
             if (iop3.eq.1) 
     &           write(47,'(a7,4x,f8.3)') dstr(1:7),bet(nwrit)
             if (iop1.eq.0.and..not.nolink(nwrit,ibl,nz)) 
     &           write(50,'(a8,3x,f9.6)') bstr(1:8),bl(nwrit)
             if (iop2.eq.0.and..not.nolink(nwrit,ialph,nz)) 
     &           write(50,'(a10,1x,f8.3)') astr(1:10),alph(nwrit)
             if (iop3.eq.0.and..not.nolink(nwrit,ibet,nz)) 
     &           write(50,'(a7,4x,f8.3)') dstr(1:7),bet(nwrit)
          else
             write(iun,3000) elemnt(ian(1)),bl(nwrit),
     &          j1,alph(nwrit),j2,bet(nwrit),j3,
     &          isel(2),isel(3),isel(4)
             if (abs(iop1).gt.1) 
     &           write(47,'(i4,a3,i4)') abs(iop1),',1,',nwrit
             if (abs(iop2).gt.1) 
     &           write(47,'(i4,a3,i4)') abs(iop2),',2,',nwrit
             if (iop3.gt.1) 
     &           write(47,'(i4,a3,i4)') abs(iop3),',3,',nwrit
             if (iop3.lt.0) 
     &           write(47,'(i4,a4,i4)') abs(iop3),',14,',nwrit
          endif
      endif

3000  format(a2,1x,3(f11.6,1x,i1,1x),3x,3(i4,1x))
      return
      end

      logical function nolink(nwrit,ibl,nz)
      implicit double precision (a-h,o-z)
      dimension ibl(*)

      nolink = .true.

      do i=nwrit+1,nz
         if (iabs(ibl(i)).eq.nwrit) nolink = .false.
      end do

      return
      end

      subroutine mkvar(nwrit,ianzz,iz,bstr,astr,dstr)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      dimension ianzz(*),iz(4,*)

      character*2 tolowf
      character*(*) bstr
      character*(*) astr
      character*(*) dstr

      dimension isel(4),ian(4)


      isel(1) = nwrit
      do i=1,3
         isel(i+1) = iz(i,nwrit)
      end do
      do i=1,4
         ian(i) = ianzz(isel(i))
      end do

      if (nwrit.ge.2) then
             bstr = '        '
             n = 2
             bstr(1:n) = tolowf(elemnt(ian(1)))
             if (bstr(1:1).eq.' ') then
                bstr(1:1) = bstr(2:2)
                n = 1
             endif
c no axp  bstr(1:n+2) = bstr(1:n)//tolowf(elemnt(ian(2)))
             bstr = bstr(1:n)//tolowf(elemnt(ian(2)))
             n = n + 2
             if (bstr(n-1:n-1).eq.' ') then
                bstr(n-1:n-1) = bstr(n:n)
                n = n - 1
             endif
             if (nwrit.ge.3) then
                astr = '          '
                astr(1:n) = bstr(1:n)
             endif
             n = n + 1
             if (nwrit.lt.10) then
                write(bstr(n:n),'(i1)') nwrit
             elseif (nwrit.lt.100) then
                write(bstr(n:n+1),'(i2)') nwrit
             elseif (nwrit.lt.1000) then
                write(bstr(n:n+2),'(i3)') nwrit
             else
                write(bstr(n:n+3),'(i4)') nwrit
             endif
      endif

      if (nwrit.ge.3) then
             n = n - 1
c no axp  astr(1:n+2) = astr(1:n)//tolowf(elemnt(ian(3)))
             astr = astr(1:n)//tolowf(elemnt(ian(3)))
             n = n + 2
             if (astr(n-1:n-1).eq.' ') then
                astr(n-1:n-1) = astr(n:n)
                n = n - 1
             endif
             n = n + 1
             if (nwrit.lt.10) then
                write(astr(n:n),'(i1)') nwrit
             elseif (nwrit.lt.100) then
                write(astr(n:n+1),'(i2)') nwrit
             elseif (nwrit.lt.1000) then
                write(astr(n:n+2),'(i3)') nwrit
             else
                write(astr(n:n+3),'(i4)') nwrit
             endif
      endif

      if (nwrit.ge.4) then
             dstr = 'dih    '
             n = 4
             if (nwrit.lt.10) then
                write(dstr(n:n),'(i1)') nwrit
             elseif (nwrit.lt.100) then
                write(dstr(n:n+1),'(i2)') nwrit
             elseif (nwrit.lt.1000) then
                write(dstr(n:n+2),'(i3)') nwrit
             else
                write(dstr(n:n+3),'(i4)') nwrit
             endif
      endif

      return
      end

      logical function parlea(ilead,isel,ispdb)
      implicit double precision (a-h,o-z)
      dimension isel(4)
      logical pcklin,pline
      logical debug

      debug = .false.
c
c     Find three atoms connected to ilead (Function prelea)
c     And parse zmatrix line (pline)
c
      parlea = .true.

c 
c to do: - current handeling of 3 atoms on a line is only correct
c          if they are exactly on a line angle123 = 180.0
c          otherwise you need to calculate another angle(or dihdral ?)
c        - after one parse in zmat-editor dummy is gone again, and
c          center of molecule not correct
c

      call prelea(iprel,ilead,isel,ispdb,0)
      if (iprel.eq.1) then
         
         if (debug) print*,'try lead without dummy'
         if (.not.pline(isel)) goto 100
         if (debug) print*,'lead without dummy'
         return
      else
         if (debug) print*,'try lead with dummy'
         call prelea(iprel,ilead,isel,ispdb,1)
         if (iprel.eq.0) goto 100
         if (debug) print*,'lead with dummy'
      endif
c
c     parse zmat line, check if dummy needs to be inserted
c
      if (.not.pcklin(isel)) goto 100

      return
100   parlea = .false.
      return
      end

      logical function parleh(ilead,isel,ispdb)
      implicit double precision (a-h,o-z)
      dimension isel(4)
      logical pcklin,pline
      logical debug

      debug = .false.
c
c     Find three atoms connected to ilead (Function preleh)
c     And parse zmatrix line (pline)
c     this version of the routine is for Hydrogen only
c
      parleh = .true.

c 
c to do: - current handeling of 3 atoms on a line is only correct
c          if they are exactly on a line angle123 = 180.0
c          otherwise you need to calculate another angle(or dihdral ?)
c        - after one parse in zmat-editor dummy is gone again, and
c          center of molecule not correct
c

      call preleh(iprel,ilead,isel,ispdb,0)
      if (iprel.eq.1) then
         
         if (debug) print*,'try lead without dummy'
         if (.not.pline(isel)) goto 100
         if (debug) print*,'lead without dummy'
         return
      else
         if (debug) print*,'try lead with dummy'
         call preleh(iprel,ilead,isel,ispdb,1)
         if (iprel.eq.0) goto 100
         if (debug) print*,'lead with dummy'
      endif
c
c     parse zmat line, check if dummy needs to be inserted
c
      if (.not.pcklin(isel)) goto 100

      return
100   parleh = .false.
      return
      end

      logical function pcklin(isel)
      implicit double precision (a-h,o-z)
      dimension isel(4)
      logical pline
      real angle,bl
      common /zmatst/ nwrit,nvar,isimpl

      pcklin = .true.

      tol = 1.0d-10
      toang = 0.52917706d0

      if (nwrit.gt.1) then
         call tomold(angle,isel,3)
         if ((abs(angle).lt.tol.or.abs(angle).gt.180.e0-tol)) then
            call calcx(ical,isel,nx)
            if (ical.eq.0) goto 100
            itmp = isel(1)
            isel(1) = nx
            call dumlin(isel,1.0d0,90.0d0,0.0d0)
            isel(1) = itmp
            isel(4) = isel(3)
            isel(3) = nx
            call tomold(bl,isel,2)
            call dumlin(isel,bl*toang,90.0d0,180.0d0)
         else
            if (.not.pline(isel)) goto 100
         endif
      else
         if (.not.pline(isel)) goto 100
      endif

      return

100   pcklin = .false.
      return
      end

      subroutine prelead(iprel,ilead,isel,ispdb,ithree,
     &                        ianz,iaton,iresid,iconn,lwrit)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /zmatst/ nwrit,nvar,isimpl
      real angle,tol
      logical doit
      dimension isel(4),iscr(4)
      dimension ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*),lwrit(*)


      tol = 0.1e0

      isel(1) = ilead
      isel(2) = 0
      isel(3) = 0
      isel(4) = 0

      itmp = 0
      jtmp = 0

      nanz = 1
      nfnd = 1

10    if (nwrit.gt.0) then
         do i=1,iconn(1,isel(1))
            ii = abs(iconn(i+1,isel(1)))
            if (ianz(ii).ne.nanz.and.lwrit(ii).ne.0
     &      .and.ianz(ii).lt.99.and.iaton(ii).eq.2.and.
     &      (ispdb.eq.0.or..not.(ispdb.eq.1.and.iresid(ii).gt.0)))
     &      then
               if (nwrit.eq.1) then
                  isel(2) = ii
                  nfnd = 2
                  goto 100
               endif
               do j=1,iconn(1,ii)
                  jj = abs(iconn(j+1,ii))
                  if (ianz(jj).ne.nanz.and.lwrit(jj).ne.0
     &                .and.jj.ne.isel(1).and.iaton(jj).eq.2.and.
     &      (ispdb.eq.0.or..not.(ispdb.eq.1.and.iresid(jj).gt.0)))
     &               then

                     doit = .false.
                     if (ithree.eq.0) then
                        iscr(1) = isel(1)
                        iscr(2) = ii
                        iscr(3) = jj
                        iscr(4) = 0
                        call tomold(angle,iscr,3)
                        if (abs(angle).ge.tol.and.
     &                      abs(angle).lt.180.e0-tol) then
                            doit = .true.
                        endif
                     else
                        doit = .true.
                     endif
                        
                     if (doit) then

                       if (nwrit.eq.2) then
                          isel(2) = ii
                          isel(3) = jj
                          nfnd = 3
                          goto 100
                       else
                          itmp = ii
                          jtmp = jj
                       endif
                     
                       do k=1,iconn(1,jj)
                          kk = abs(iconn(k+1,jj))
                          if (ianz(kk).ne.nanz.and.lwrit(kk).ne.0
     &                        .and.kk.ne.ii.and.iaton(kk).eq.2.and.
     &      (ispdb.eq.0.or..not.(ispdb.eq.1.and.iresid(kk).gt.0)))
     &                    then
                             iscr(1) = ii
                             iscr(2) = jj
                             iscr(3) = kk
                             iscr(4) = 0
                             call tomold(angle,iscr,3)
                             if (abs(angle).ge.tol.and.
     &                           abs(angle).lt.180.e0-tol) then
                                isel(2) = ii
                                isel(3) = jj
                                isel(4) = kk
                                nfnd = 4
                                goto 100
                             endif
                          endif
                       end do

                     endif
                  endif
               end do
            endif
         end do
      endif
100   if (nanz.eq.1.and.nfnd.lt.4.and.nfnd.lt.nwrit+1) then
c
c     go back once more and allow hydrogens
c
         nanz = 0
         goto 10
      endif
      if (isel(4).eq.0.and.itmp.ne.0) then
         do i=1,iconn(1,itmp)
            ii = abs(iconn(i+1,itmp))
            if (lwrit(ii).ne.0.and.iaton(ii).eq.2.and.ii.ne.jtmp) 
     &      then
                if (ithree.eq.1) then
                   isel(4) = ii
                else
                   iscr(1) = itmp
                   iscr(2) = jtmp
                   iscr(3) = ii
                   iscr(4) = 0
                   call tomold(angle,iscr,3)
                   if (abs(angle).ge.tol.and.
     &                 abs(angle).lt.180.e0-tol) then
                      isel(2) = itmp
                      isel(3) = jtmp
                      isel(4) = ii
                   endif
                endif
            endif
         end do
      endif
      if ((nwrit.eq.3.or.nwrit.eq.4).and.isel(4).eq.0.and.ithree.eq.1) 
     & then
         isel(2) = itmp
         isel(3) = jtmp
         do i=1,iatoms
            if (lwrit(i).ne.0) then
               k = 0
               do j=1,4
                  if (isel(j).eq.i) k = 1
               end do
               if (k.eq.0) isel(4) = i
            endif
         end do 
      endif

      iprel = 1

      nchk = nwrit + 1
      if (nchk.gt.4) nchk = 4
      do i=1,nchk
         if (iprel.eq.1.and.isel(i).ne.0) then
             iprel = 1
         else
             iprel = 0
         endif
      end do

      return
      end

      subroutine prelehd(iprel,ilead,isel,ispdb,ithree,
     &                        ianz,iaton,iresid,iconn,lwrit)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /zmatst/ nwrit,nvar,isimpl
      real angle,tol
      logical doit
      dimension isel(4),iscr(4),nn(mxcon+1)
      dimension inat(mxcon+1)
      dimension ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*),lwrit(*)


      tol = 0.1e0

      isel(1) = ilead
      isel(2) = 0
      isel(3) = 0
      isel(4) = 0

      itmp = 0
      jtmp = 0

      nanz = 1
      nfnd = 1

10    if (nwrit.gt.0) then
         do i=1,iconn(1,isel(1))
            ii = abs(iconn(i+1,isel(1)))
            mm = iconn(1,ii)
            if (mm.gt.2) then
               call cnvcon(iconn,inat,lwrit,ii,nn)
            else
               nn(1) = mm
               do jj=1,mm
                  nn(1+jj) = iconn(1+jj,ii)
               end do
            endif

            if (ianz(ii).ne.nanz.and.lwrit(ii).ne.0
     &      .and.ianz(ii).lt.99.and.iaton(ii).eq.2.and.
     &      (ispdb.eq.0.or..not.(ispdb.eq.1.and.iresid(ii).gt.0)))
     &      then
               if (nwrit.eq.1) then
                  isel(2) = ii
                  nfnd = 2
                  goto 100
               endif
               do j=1,nn(1)
                  jj = abs(nn(j+1))
                  if (ianz(jj).ne.nanz.and.lwrit(jj).ne.0
     &                .and.jj.ne.isel(1).and.iaton(jj).eq.2.and.
     &      (ispdb.eq.0.or..not.(ispdb.eq.1.and.iresid(jj).gt.0)))
     &               then

                     doit = .false.
                     if (ithree.eq.0) then
                        iscr(1) = isel(1)
                        iscr(2) = ii
                        iscr(3) = jj
                        iscr(4) = 0
                        call tomold(angle,iscr,3)
                        if (abs(angle).ge.tol.and.
     &                      abs(angle).lt.180.e0-tol) then
                            doit = .true.
                        endif
                     else
                        doit = .true.
                     endif
                        
                     if (doit) then

                       if (nwrit.eq.2) then
                          isel(2) = ii
                          isel(3) = jj
                          nfnd = 3
                          goto 100
                       else
                          itmp = ii
                          jtmp = jj
                       endif
                     
                       do k=1,iconn(1,ii)
                          kk = abs(iconn(k+1,ii))
                          if (ianz(kk).ne.nanz.and.lwrit(kk).ne.0
     &                        .and.kk.ne.jj.and.kk.ne.isel(1)
     &                        .and.iaton(kk).eq.2.and.
     &      (ispdb.eq.0.or..not.(ispdb.eq.1.and.iresid(kk).gt.0)))
     &                    then
                             iscr(1) = ii
                             iscr(2) = jj
                             iscr(3) = kk
                             iscr(4) = 0
                             call tomold(angle,iscr,3)
                             if (abs(angle).ge.tol.and.
     &                           abs(angle).lt.180.e0-tol) then
                                isel(2) = ii
                                isel(3) = jj
                                isel(4) = kk
                                nfnd = 4
                                goto 100
                             endif
                          endif
                       end do

                       do k=1,iconn(1,jj)
                          kk = abs(iconn(k+1,jj))
                          if (ianz(kk).ne.nanz.and.lwrit(kk).ne.0
     &                        .and.kk.ne.ii.and.
     &                        jj.ne.kk.and.iaton(kk).eq.2.and.
     &      (ispdb.eq.0.or..not.(ispdb.eq.1.and.iresid(kk).gt.0)))
     &                    then
                             iscr(1) = ii
                             iscr(2) = jj
                             iscr(3) = kk
                             iscr(4) = 0
                             call tomold(angle,iscr,3)
                             if (abs(angle).ge.tol.and.
     &                           abs(angle).lt.180.e0-tol) then
                                isel(2) = ii
                                isel(3) = jj
                                isel(4) = kk
                                nfnd = 4
                                goto 100
                             endif
                          endif
                       end do

                     endif
                  endif
               end do
            endif
         end do
      endif
100   if (nanz.eq.1.and.nfnd.lt.4.and.nfnd.lt.nwrit+1) then
c
c     go back once more and allow hydrogens
c
         nanz = 0
         goto 10
      endif
      if (isel(4).eq.0.and.itmp.ne.0) then
         do i=1,iconn(1,itmp)
            ii = abs(iconn(i+1,itmp))
            if (lwrit(ii).ne.0.and.iaton(ii).eq.2.and.ii.ne.jtmp) 
     &      then
                if (ithree.eq.1) then
                   isel(4) = ii
                else
                   iscr(1) = itmp
                   iscr(2) = jtmp
                   iscr(3) = ii
                   iscr(4) = 0
                   call tomold(angle,iscr,3)
                   if (abs(angle).ge.tol.and.
     &                 abs(angle).lt.180.e0-tol) then
                      isel(2) = itmp
                      isel(3) = jtmp
                      isel(4) = ii
                   endif
                endif
            endif
         end do
      endif
      if ((nwrit.eq.3.or.nwrit.eq.4).and.isel(4).eq.0.and.ithree.eq.1) 
     & then
         isel(2) = itmp
         isel(3) = jtmp
         do i=1,iatoms
            if (lwrit(i).ne.0) then
               k = 0
               do j=1,4
                  if (isel(j).eq.i) k = 1
               end do
               if (k.eq.0) isel(4) = i
            endif
         end do 
      endif

      iprel = 1

      nchk = nwrit + 1
      if (nchk.gt.4) nchk = 4
      do i=1,nchk
         if (iprel.eq.1.and.isel(i).ne.0) then
             iprel = 1
         else
             iprel = 0
         endif
      end do

      return
      end

      subroutine wrzmaz(iun,iopt,
     &          bl,alph,bet,ibl,ialph,ibet,imap,janz,iz,epoints,ianz)

c this is really wrzmat

      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxbas=17)
      parameter (mxtsk=13)
      parameter (mxmth=8)
      parameter (mxvec=7)
      common /athlp/  iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      common /zmatst/ nwrit,nvar,isimpl
      common /pnthlp/ ipoints,ipnt
      character*2 elemnt,tolowf,tstr
      common /elem/elemnt(mxel)
      common /geocnv/ fdum3(10),idum(7),ieav,ifrav,mxpnt
      logical hassym
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      character*80 glin1,glin2,gtitl,rungam,freez
      character*15 jname,qname
      common /gauopt/ ito,imo,ibo,itotc,imult,ibatch,ihess,itime,
     &                iwxyz,ichh,ichm,ichl,imh,imm,iml,iexk,
     &                glin1,glin2,gtitl,jname,qname,rungam
      character*80 lstr
      character*5 hstr,htstr
      character*3 sr
      character*7 bases
      character*8 basnw
      character*3 met
      common /sets/ nbas(6,mxbas),bases(mxbas)

      character*14 tasks
      common /tsk/ tasks(mxtsk)
      character*10 meth
      common /methods/ meth(mxmth)
      character*8 vecstr
      common /vstrs/ vecstr(mxvec)
      logical dblvec,domap
      common /zmtyp/ igztyp
      common /typoni/ ioniad
      common /types/ iff

      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),janz(*),iz(4,*)
      dimension epoints(*),ianz(*),basnw(8)

      data bases/'sto3g  ','3-21g  ','4-31g  ','6-31g  ','6-31g* ',
     &           '6-31g**','mini1  ','mini4  ','midi1  ','midi4  ',
     &           'dz     ','tzv    ','tzvp   ','ecpmin ','ecpdz  ',
     &           'ecptzv ','ecptzvp'/
      data basnw/'sto3g   ','3-21g   ','4-31g   ','6-31g   ','6-31g*  ',
     &           '6-31g** ','6-31+G* ','6-311G**'/
      data (nbas(i,1),i=1,6) /1,5,9,13,19,19/
      data (nbas(i,2),i=1,6) /2,9,13,17,29,23/
      data (nbas(i,3),i=1,6) /2,9,13,17,29,23/
      data (nbas(i,4),i=1,6) /2,9,13,17,29,23/
      data (nbas(i,5),i=1,6) /2,15,19,0,0,0/
      data (nbas(i,6),i=1,6) /5,15,19,0,0,0/
      data (nbas(i,7),i=1,6) /1,5,9,10,0,19/
      data (nbas(i,8),i=1,6) /1,5,9,10,0,19/
      data (nbas(i,9),i=1,6) /2,9,13,11,23,23/
      data (nbas(i,10),i=1,6) /2,9,13,14,26,29/
      data (nbas(i,11),i=1,6) /2,10,18,0,0,0/
      data (nbas(i,12),i=1,6) /3,14,21,0,46,0/
      data (nbas(i,13),i=1,6) /6,20,27,0,52,0/
      data (nbas(i,14),i=1,6) /1,4,4,4,10,4/
      data (nbas(i,15),i=1,6) /2,8,8,8,20,8/
      data (nbas(i,16),i=1,6) /3,12,12,0,0,0/
      data (nbas(i,17),i=1,6) /6,18,18,0,0,0/

      data tasks/'scf           ','optimise      ','optxyz        ',
     &           'saddle        ','force         ','hessian       ',
     &           'ci            ',
     &           'polarisability','hyper         ','magnet        ',
     &           'raman         ','infrared      ','analyse       '/
      data meth/ 'rhf       ','direct rhf','uhf       ',
     &           'gvb 1     ','mp2       ','direct mp2',
     &           'mp3       ','casscf    '/
      data vecstr/ 'atoms   ','hcore   ','minguess',
     &             'extguess','alphas  ','1       ','1 2     '/

      open(unit=47,form='formatted',status='scratch')
      open(unit=50,form='formatted',status='scratch')

      nwrit = 0
      nvar = 0
      hassym = .false.
      domap = .false.

      nglin1 = linlen(glin1)
      nglin2 = linlen(glin2)
      ngtitl = linlen(gtitl)

c MOPAC

      if (iopt.eq.3.or.iopt.eq.21) then
        do i=1,nz
           if (ibl(i).gt.1.or.ialph(i).gt.1.or.abs(ibet(i)).gt.1)
     &         hassym = .true.
        end do
        if (iopt.eq.21) then
           if (glin1(nglin1:nglin1).ne.'+') then
              write(iun,'(a)') glin1(1:nglin1)//' +'
           else
              write(iun,'(a)') glin1(1:nglin1)
           endif
           if (hassym) then
              write(iun,'(a)') glin2(1:nglin2)//' SYMMETRY'
           else
              write(iun,'(a)') glin2(1:nglin2)
           endif
           write(iun,'(a)') gtitl(1:ngtitl)
        else
           if (hassym) then
               write(iun,'(a)') 'SYMMETRY'
           else
               write(iun,'(a)') ' '
           endif
           if (ieav.eq.1) then
            if (iftyp.ge.2.and.iftyp.le.4) then
               write(iun,'(a,f12.6)') 'scf done: ',epoints(ipnt)
            else
               write(iun,'(a,f12.6)') 'FINAL HEAT OF FORMATION = ',
     &              epoints(ipnt)
            endif
           else
               write(iun,'(a)') ' '
           endif
        endif
        write(iun,'(a)') ' '
      endif

C NWCHEM

      if (iopt.eq.22.or.iopt.eq.7) then
        write(iun,'(a)') 'title '//char(34)//gtitl(1:ngtitl)//char(34)
        write(iun,'(a)') 'start '//gtitl(1:ngtitl)
        write(iun,'(a)') 'echo'
        write(iun,'(a,i3)') 'charge ',itotc
        write(iun,'(a)') 'geometry'
        if (iwxyz.eq.1) then
           if (icdex(glin1,'amber').ne.0) then
                 call wrcart(iun,0,2,1)
           else
                 call wrcart(iun,0,1,1)
           endif
           goto 889
        else
           write(iun,'(a)') 'zmatrix'
        endif
      endif

C GAMESS-UK

      if (iopt.eq.19) then
         if (ibatch.eq.0) write(iun,'(a,i5)') 'time ',itime
         if (imo.eq.6) write(iun,'(a)') 'memory 2000000'
         if (ito.ge.2.and.ito.le.4.and.ihess.eq.0) then
            write(iun,'(a)') 'dumpfile ed3 1500'
         endif
         if (ito.eq.13) write(iun,'(a)') 'restart'
         if (ito.eq.7) write(iun,'(a)') 'super off nosym'

         write(iun,'(a)') 'title'
         write(iun,'(a)') gtitl(1:ngtitl)
         write(iun,'(a,i3)') 'charge ',itotc
         write(iun,'(a,i2)') 'multiplicity ',imult
      endif

      if (iopt.eq.1.and.igztyp.eq.1) then
         nzt = nz*3 - 6
         if (nz.eq.1) nzt = 0
         if (nz.eq.2) nzt = 1
         if (nz.eq.3) nzt = 3

         write(iun,'(a,i4,a)') 
     &     ' $contrl runtyp=optimize coord=zmt nzvar=',nzt,' $end'
         write(iun,'(a)') 
     &     ' $basis  gbasis=N31 ngauss=6 ndfunc=1 npfunc=1 $end'

         nfrez = 0
         do i=1,nz
            if (ibl(i).eq.0.and.i.gt.1) nfrez = nfrez + 1
            if (ialph(i).eq.0.and.i.gt.2) nfrez = nfrez + 1
            if (ibet(i).eq.0.and.i.gt.3) nfrez = nfrez + 1
         end do

         if (nfrez.ne.0) then
            write(iun,'(a)') ' $statpt ifreez(1)= '
            freez = ' '
            nfrez = 0
            lfrez = 0
            do i=1,nz
               nv = (i-1)*3
               if (i.le.2) nv = 0
               if (i.eq.3) nv = 1
               if (i.ge.4) nv = nv - 6 
               if (ibl(i).eq.0.and.i.gt.1) then
                  nvt = nv + 1
                  htstr = hstr(nvt)
                  l = index(htstr,')')
                  sr = htstr(2:l-1)
                  freez = freez(1:lfrez) // sr(1:l-2) // ','
                  nfrez = nfrez + 1
                  lfrez = lfrez + l -1
               endif
               if (ialph(i).eq.0.and.i.gt.2) then
                  nvt = nv + 2
                  htstr = hstr(nvt)
                  l = index(htstr,')')
                  sr = htstr(2:l-1)
                  freez = freez(1:lfrez) // sr(1:l-2) // ','
                  nfrez = nfrez + 1
                  lfrez = lfrez + l -1
               endif
               if (ibet(i).eq.0.and.i.gt.3) then
                  nvt = nv + 3
                  htstr = hstr(nvt)
                  l = index(htstr,')')
                  sr = htstr(2:l-1)
                  freez = freez(1:lfrez) // sr(1:l-2) // ','
                  nfrez = nfrez + 1
                  lfrez = lfrez + l -1
               endif
               if (nfrez.gt.17) then
                  call spatrm(freez,l)
                  if (i.eq.nz) then
                      if (freez(l:l).eq.',') freez(l:l) = ' '
                  endif
                  write(iun,'(a)') freez(1:l)
                  freez = ' '
                  nfrez = 0
                  lfrez = 0
               endif
            end do

            call spatrm(freez,l)
            if (freez(l:l).eq.',') freez(l:l) = ' '
            write(iun,'(a)') freez(1:l)// '$end'
         endif
         write(iun,'(a)') ' $data'
         write(iun,'(a)') 'title'
         write(iun,'(a)') 'C1'
      endif

      if ((iopt.eq.1.or.iopt.eq.19).and.igztyp.ne.1) 
     &   write(iun,'(a)') 'zmat angstroms'

C GAUSSIAN

      if (iopt.eq.20) then
         write(iun,'(a)') '$ RunGauss'
         write(iun,'(a)') glin1(1:nglin1)
         write(iun,'(a)') glin2(1:nglin2)
         write(iun,'(a)') ' '
         write(iun,'(a)') gtitl(1:ngtitl)
         write(iun,'(a)') ' '

         ioniom = 1
         do i = 1,nglin1
           if (glin1(i:i).eq.':') ioniom = ioniom + 1
         end do
         if (ioniom .eq. 1) then
            write(iun,'(i3,1x,i2)') itotc,imult
         elseif (ioniom.eq.2) then
            write(iun,'(i3,1x,i2,1x,i3,1x,i2)') ichh,imh,ichl,iml
         else
            write(iun,'(i3,1x,i2,1x,i3,1x,i2,1x,i3,1x,i2)') ichh,imh,
     &          ichm,imm,ichl,iml
         endif
         if (iwxyz.eq.1) then
              if (icdex(glin1,'amber').ne.0) then
                 call wrcart(iun,0,2,1)
              else
                 call wrcart(iun,0,1,1)
              endif
              write(iun,'(a)') ' '
              goto 889
         endif
      endif

      iiopt = iopt
      if (iopt.eq.19) iiopt = 1
      if (iopt.eq.20) iiopt = 2
      if (iopt.eq.21) iiopt = 3
      if (iopt.eq.22) iiopt = 1
      if (iopt.eq.7)  iiopt = 1

      igamb = 0
      if (icdex(glin1,'amber').ne.0) then
          igamb = 1
          if (iff.ne.3) then
             iff = 3
             ioniad = 1
             call dotyp(0)
             ioniad = 0
          endif
      endif

      do i=1,nz
          call wline(iun,iiopt,igamb)
      end do

      rewind(47)
      if (iiopt.eq.1) then
         if (igztyp.eq.1) then
            write(iun,'(a)') ' '
         else
            if (.not.(iopt.eq.22.and.nz.eq.1)) 
     &           write(iun,'(a)') 'variables'
         endif
      endif
      if (iiopt.eq.2) write(iun,'(a)') ' '
      if (iiopt.eq.3.and.hassym) write(iun,'(a)') ' '
      do while (.true.)
         read(47,'(a)',end=888) lstr
         if (igztyp.eq.1) then
            ix = index(lstr,' ')
            if (ix.gt.0) lstr(ix:ix) = '='
         endif
         ilen = ifblen(lstr)
         if (ilen.ge.1) write(iun,'(a)') lstr(1:ilen)
      end do

888   rewind(50)
      if (iiopt.eq.1) then
         if (igztyp.eq.1) then
            write(iun,'(a)') ' '
            write(iun,'(a)') ' '
            write(iun,'(a)') ' $end'
         else
            write(iun,'(a)') 'constants'
         endif
      endif
      if (iiopt.eq.2) write(iun,'(a)') ' '
      do while (.true.)
         read(50,'(a)',end=889) lstr
         if (igztyp.eq.1) then
            ix = index(lstr,' ')
            if (ix.gt.0) lstr(ix:ix) = '='
         endif
         ilen = ifblen(lstr)
         if (ilen.ge.1) write(iun,'(a)') lstr(1:ilen)
      end do
889   continue

      if (iiopt.eq.1.and.igztyp.ne.1) write(iun,'(a)') 'end'
      if (iiopt.ge.2.or.iopt.eq.3) write(iun,'(a)') ' '
      close(47)
      close(50)

      if (domap) then
         write(iun,'(a)') 'map'
         do i=1,nz
            write(iun,'(i5)') imap(i)
         end do
      endif

      if (iopt.eq.22) then
        write(iun,'(a)') 'end'
        if (iexk.eq.0) write(iun,'(a)') 'ecce_print ecce.out'
        write(iun,'(a,a,a,a)') 'basis ',char(34)//"ao basis"//
     &                           char(34)//' cartesian print'
        if (ibo.eq.1) then
           write(iun,'(a)') '* library sto-3g'
        else
           write(iun,'(a,a,a,a)') '* library '//char(34)//
     &                          basnw(ibo)//char(34)
        endif
        write(iun,'(a)') 'end'

        if (imo.gt.2) then
           write(iun,'(a)') 'dft'
           if (imult.eq.2) write(iun,'(a)') 'mult 2'
           if (imult.eq.3) write(iun,'(a)') 'mult 3'
           if (imo.eq.3) write(iun,'(a)') 'XC slater perdew81'
           if (imo.eq.4) write(iun,'(a)') 'XC xpbe96 cpbe96'
           if (imo.eq.5) write(iun,'(a)') 'XC b3lyp'
           write(iun,'(a)') 'end'
        endif

        if (imo.eq.1) then
            met = 'scf'
        else if (imo.eq.2) then
            met = 'uhf'
        else if (imo.gt.2) then
            met = 'dft'
        endif

        if (imult.ne.1.and.imo.eq.1) then
          write(iun,'(a)') 'scf'
          if (imult.eq.2) write(iun,'(a)') 'doublet'
          if (imult.eq.3) write(iun,'(a)') 'triplet'
          write(iun,'(a)') 'end'
        endif

        if (ito.eq.1) then
          write(iun,'(a,a)') 'task '//met//' energy'
        else if (ito.eq.2) then
          write(iun,'(a,a)') 'task '//met//' optimize'
        else if (ito.eq.3) then
          write(iun,'(a,a)') 'task '//met//' saddle'
        else if (ito.eq.4) then
          write(iun,'(a,a)') 'task '//met//' freq'
        else if (ito.eq.5) then
          write(iun,'(a,a)') 'task '//met//' optimize'
          write(iun,'(a,a)') 'task '//met//' freq'
        endif

      endif

      if (iopt.eq.19) then
         write(iun,'(a,a)') 'basis ',bases(ibo)
         if (ibo.ge.14.and.ibo.le.17) then
            write(iun,'(a)') 'pseudo ecp'
            do i=1,iatoms
               tstr = tolowf(elemnt(ianz(i)))
               if (ianz(i).ne.1.and.ianz(i).ne.99)
     &            write(iun,'(a)') tstr//' '//tstr
            end do
         endif

         if (ito.ge.2.and.ito.le.4.and.ihess.eq.0) then
            write(iun,'(a,a,a)') 'runtype ',tasks(ito),' ed3 1'
         else
            write(iun,'(a,a)') 'runtype ',tasks(ito)
         endif

         if (ito.ne.7) write(iun,'(a,a)') 'scftype ',meth(imo)

         nelec = 0
         nnoth = 0
         do i=1,iatoms
            if (ianz(i).ne.99) nelec = nelec + ianz(i)
            if (ianz(i).ne.99.and.ianz(i).ne.1) nnoth = nnoth + 1
         end do
         nelec = nelec - itotc
         nelec2 = nelec / 2
         norb = nelec2
         if (nelec - nelec2*2.ne.0) norb = norb + 1

         if (imo.eq.8.and..not.ito.eq.7) then
            write(iun,'(a)') 'config'
            if (nnoth.gt.0) write(iun,'(a,i3,a,i3)') 
     &          'fzc ',1,' to ',nnoth
            write(iun,'(a,i3,a,i3)') 
     &          'doc ',nnoth+1,' to ',nelec2
            norb = nelec2
            if (nelec - nelec2*2.ne.0) then
                write(iun,'(a,i3)') 'alp ',norb
            endif
            write(iun,'(a,i3,a,i3)') 'uoc ',norb+1,' ',norb+2
            write(iun,'(a)') 'end'
            write(iun,'(a)') 'superci 1 to 4'
            write(iun,'(a)') 'newton 5 to 20'
            write(iun,'(a)') 'hessian 5 9 13 17'
         endif

         if (imo.eq.1.or.imo.eq.2.or.imo.eq.4.or.ito.eq.7) then
            if (imult.ne.1) then
                if (imult.eq.3) then
                   write(iun,'(a)') 'open 2 2'
                else
                   write(iun,'(a)') 'open 1 1'
                endif
            endif
         endif

         if (ito.eq.7) then
            nbasis = 0
            do i=1,iatoms
               ia = ianz(i)
               if (ia.ne.99) then
                   if (ia.ge.1.and.ia.le.2) then
                       igrp = 1
                   elseif (ia.ge.3.and.ia.le.10) then
                       igrp = 2
                   elseif (ia.ge.11.and.ia.le.18) then
                       igrp = 3
                   elseif (ia.ge.19.and.ia.le.20) then
                       igrp = 4
                   elseif (ia.ge.21.and.ia.le.30) then
                       igrp = 5
                   elseif (ia.ge.31) then
                       igrp = 6
                   endif
                   nbasis = nbasis + nbas(igrp,ibo)
               endif
            end do

            write(iun,'(a,i3,i3,i3)') 
     &         'direct ',nelec,norb,nbasis-norb
            if (imult.eq.2) write(iun,'(a)') 'spin doublet'
            if (imult.eq.3) write(iun,'(a)') 'spin triplet'
            write(iun,'(a)') 'conf'
            idm1 = 1
            idm2 = 2
            if (imult.eq.1) then
               write(iun,'(100(i3,1x))') (idm2,i=1,nelec2)
            endif
            if (imult.eq.2) then
               write(iun,'(100(i3,1x))') (idm2,i=1,nelec2),idm1
            endif
            if (imult.eq.3) then
               write(iun,'(100(i3,1x))') (idm2,i=1,nelec2-1),idm1,idm1
            endif
         endif

         if (ito.eq.13) then
            write(iun,'(a)') 'local'
            write(iun,'(a,i3,a)') '1 to ',norb,' end'
         endif

         dblvec = .false.
         if (imo.eq.3.or.imo.eq.4.or.imo.eq.8)
     &       dblvec = .true.
         if ((imo.eq.1.or.imo.eq.2).and.imult.ne.1) dblvec = .true.
         if (ito.eq.7.and.imult.ne.1) dblvec = .true.

         ivo = 2
         if (ibo.eq.1) ivo = 3
         if (ibo.ge.2.and.ibo.le.5) ivo = 4
         if (ito.eq.13) then
             ivo = 6
             if (dblvec) ivo = 7
         endif
         write(iun,'(a,a)') 'vectors ',vecstr(ivo)

         if (dblvec) then
            if (ito.eq.13) then
               write(iun,'(a,i3)') 'enter 3 4'
            else
               write(iun,'(a,i3)') 'enter 1 2'
            endif
         else
            if (ito.eq.13) then
               write(iun,'(a,i3)') 'enter 2'
            else
               write(iun,'(a,i3)') 'enter 1'
            endif
         endif

      endif
      
      return
      end

      subroutine wrcard(iun,dopdb,idogau,ipdbwh,epoints,
     &                  coo,qat,ianz,iaton,iresid,iconn,ityp,
     &                  ncalf,ianf,islu,nchain,iamino,reson,
     &                  irsnr,achain,ishoh)
c This is really wrcart
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (mxres=42)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      parameter (mxheta=150)
      common /athlp/  iatoms, mxnat
      common /pnthlp/ ipoints,ipnt
      character*2 elemnt,tocapf
      common /elem/   elemnt(mxel)
      common /geocnv/ fdum3(10),idum(7),ieav,ifrav,mxpnt
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /typoni/ ioniad
      common /cllab/  iclon,iclpnt(4)
      integer reson
      integer*2 ityp
      character*1 achain
      common /types/ iff
      character*4 pdbc
      common /pdbcod/ pdbc
      character*3 chtnk,pdbsym,hsym,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      character*3 aminos
      common /amino/aminos(mxres)
      character*3 hez
      character*4 stmp
      character*14 ttmp
      integer ionilv,ism,isl,dopdb
      character*3 oniom(6), link

      dimension ipdb(mxsym),ihpdb(mxhsym*3),ich(3)
      dimension epoints(*),qat(*),ityp(*)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*)
      dimension ianf(*),islu(*),iamino(*),reson(*),irsnr(*),achain(*)

      data oniom /'H  ','M  ','L  ','H H','M H','L H'/

      ism = 0
      isl = 0

c idogau = 2, try to write amber type

      igaut = idogau
      if (igaut.eq.2.and.iff.ne.3) then
         iff = 3
         ioniad = 1
         call dotyp(0)
         ioniad = 0
      endif


      toang  = 0.52917706d0
      
      jatoms = iatoms
      if (iclon.eq.1) jatoms = iatoms - 8
      natoms = 0
      do i=1,jatoms
          if (ianz(i).lt.100) natoms = natoms + 1
          if ((ityp(i)/10000) .eq. 1) ism = 1
          if ((ityp(i)/10000) .eq. 2) isl = 1
      end do

      ionilv = 1 + ism + isl

      if (dopdb.eq.1) then
          irsnrt = 1
          do i=1,ncalf
             if (irsnr(i).le.0) irsnrt = 0
          end do
          if (irsnrt.eq.0) then
             do i=1,ncalf
                irsnr(i) = i
             end do
          endif
          irsnrt = 1
          do i=1,ncalf
             if (len(achain(i)).le.0) then
                irsnrt = 0
             else
                ic = ichar(achain(i))
                if (.not.((ic.ge.97.and.ic.le.122).or.
     &                    (ic.ge.65.and.ic.le.90))) irsnrt = 0
             endif
          end do
          if (irsnrt.eq.0) then
             do k=1,nchain
                do j=ianf(k),islu(k)
                   achain(j) = char(64+k)
                end do
             end do
          endif
      endif

      if (dopdb.eq.1) then
         write(iun,"(a,a,a)") "HEADER"
     &   //"                                                        "
     &   //pdbc
      else
         if (igaut.eq.0) then
            write(iun,'(i5)') natoms
            if (ieav.eq.1) then
               iipnt = ipnt
               if (ipnt.eq.0) iipnt = 1
               if (iftyp.ge.2.and.iftyp.le.4) then
                  write(iun,'(a,f12.6)') 'scf done: ',epoints(iipnt)
               else
                  write(iun,'(a,f12.6)') 'FINAL HEAT OF FORMATION = ',
     &                                   epoints(iipnt)
               endif

            elseif (ionilv.ne.1) then
               write(iun,'(a5,1x,i1,1x,a6)') 'Oniom',ionilv,'levels'
            else
               write(iun,'(a)') ' '
            endif
         endif
      endif

      if (dopdb.eq.1) then

         iat = 0
         do i=1,ncalf
            if (ipdbwh.ne.2.or.(ipdbwh.eq.2.and.reson(i).eq.1)) then
               call getpdb(i,ipdb,ihpdb)
               do j=1,mxsym
                if (ipdb(j).ne.0) then
                   iat = iat + 1
                   stmp = ' '//pdbsym(j)
                   write(iun,'(a4,2x,i5,1x,a4,1x,a3,1x,a1,i4,4x,3f8.3)') 
     &             'ATOM',iat,stmp,aminos(iamino(i)),achain(i),irsnr(i),
     &             (coo(k,ipdb(j))*toang,k=1,3)
                endif
               end do
               if (ipdbwh.eq.0.or.(ipdbwh.eq.2.and.reson(i).eq.1)) then
                  do j=1,mxhsym*3
                     if (ihpdb(j).ne.0) then
                        iat = iat + 1
                        ih = (j-1)/3 
                        il = j - ih*3
                        if (ihpdb(ih*3+2).eq.0) then
                           stmp = ' '//hsym(ih+1)
                        else
                           stmp = char(48+il)//hsym(ih+1)
                        endif
                        write(iun,
     &                  '(a4,2x,i5,1x,a4,1x,a3,1x,a1,i4,4x,3f8.3)') 
     &                  'ATOM',iat,stmp,aminos(iamino(i)),achain(i),
     &                  irsnr(i),(coo(k,ihpdb(j))*toang,k=1,3)
                     endif
                  end do
               endif
            endif
         end do

         call hetnum(numhet)
         if (numhet.eq.0) numhet = 4

         do l=4,numhet
          do i=1,iatoms
            ir = iresid(i)
            if (ir.eq.-l.and.ir.ne.-ishoh.and.ianz(i).ne.100) then
              if (.not.((ipdbwh.eq.1.and.ianz(i).eq.1).or.
     &           (ipdbwh.eq.2.and.iaton(i).eq.0))) then
                 iat = iat + 1
                 ires = abs(iresid(i)) - 2
                 if (ihashz.eq.1) then
                    hez = hetz(ires-1+4)
                    if (hez.eq."   ") then
                       call gtht(ich,ires-1+4)
                       hez(1:1) = char(ich(1))
                       hez(2:2) = char(ich(2))
                       hez(3:3) = char(ich(3))
                    endif
                 else
                    write(hez,'(i3)') ires
                 endif
		 stmp = "    "
		 call gethet(i,nstat,stmp)
		 if (nstat.eq.0) stmp = tocapf(elemnt(ianz(i)))//'  '
                 write(iun,'(a6,i5,1x,a4,1x,a3,2x,i4,4x,3f8.3)') 
     &            'HETATM',iat,stmp,
     &             hez,ncalf+ires,(coo(j,i)*toang,j=1,3)
              endif
            endif
          end do
         end do

         do i=1,iatoms
            ir = iresid(i)
            if (ir.eq.-ishoh.and.ianz(i).ne.100) then
              if (.not.((ipdbwh.eq.1.and.ianz(i).eq.1).or.
     &           (ipdbwh.eq.2.and.iaton(i).eq.0))) then
                 iat = iat + 1
                 ires = abs(iresid(i)) - 2
                 if (ihashz.eq.1) then
                    hez = hetz(ires-1+4)
                    if (hez.eq."   ") then
                       call gtht(ich,ires-1+4)
                       hez(1:1) = char(ich(1))
                       hez(2:2) = char(ich(2))
                       hez(3:3) = char(ich(3))
                    endif
                 else
                    write(hez,'(i3)') ires
                 endif
		 stmp = "    "
		 call gethet(i,nstat,stmp)
		 if (nstat.eq.0) stmp = tocapf(elemnt(ianz(i)))//'  '
                 write(iun,'(a6,i5,1x,a4,1x,a3,2x,i4,4x,3f8.3)') 
     &            'HETATM',iat,stmp,
     &             hez,ncalf+ires,(coo(j,i)*toang,j=1,3)
              endif
            endif
         end do

      else

         do i=1,iatoms
           if (ianz(i).ne.100) then
              if (ihasq.eq.1.and.igaut.eq.0) then

                 write(iun,'(a2,1x,3(f12.6,1x),f9.6)') 
     &           elemnt(ianz(i)),(coo(j,i)*toang,j=1,3),qat(i)

              else

                 if (ionilv.eq.1) then

                    if (igaut.le.1) then
                       write(iun,'(a2,1x,3(f12.6,1x),1x,a1)')
     &                 elemnt(ianz(i)),(coo(j,i)*toang,j=1,3)
                    else
                       call wrlab(i,ttmp,ianz,ityp,qat)
                       write(iun,'(a14,1x,3(f12.6,1x),1x,a1)')
     &                 ttmp,(coo(j,i)*toang,j=1,3)
                    endif

                 else

                    iqmmm = ityp(i)/10000
                    link = oniom(iqmmm+1)
                    do l = 2,iconn(1,i)+1
                        j = iconn(l,i)
                        ij = ityp(j)/10000
                        if (j.ne.0 .and. ij.lt.iqmmm) 
     &                     link = oniom(iqmmm+4)
                    end do

                    if (igaut.le.1) then

                       write(iun,'(a2,1x,3(f12.6,1x),1x,a3)')
     &                 elemnt(ianz(i)),(coo(j,i)*toang,j=1,3),
     &                 link

                    elseif (igaut.eq.2) then

                       call wrlab(i,ttmp,ianz,ityp,qat)
                       write(iun,'(a14,1x,3(f12.6,1x),1x,a3)')
     &                 ttmp,(coo(j,i)*toang,j=1,3),
     &                 link

                    endif
                 endif
              endif
           endif
         end do

      endif

      return
      end

      subroutine wrpnt(filenm,lenfn,iopt,iapp,ipoints,
     &                 fancy,atcol,dolabs,backb)
      implicit double precision (a-h,o-z), integer (i-n)
      common /zmfrst/ ihaszm, nz, mxzat
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      common /vropt/  ivtwo,ihand,ivadd
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf
      character*(*) filenm
      character*1024 tfile
      character*80 ftmp
      logical zmqok, zok
      integer dolabs,fancy,atcol,backb

c
c     iapp
c     -------
c     0    open, write and close
c     1    open, write
c     2          write and close
c     3          write
c
c
c     iopt
c     -------
c     1    zmat gamess
c     2    zmat gaussian
c     3    zmat mopac
c     4    cartesian coordinates
c     5    VRML
c     6    moldenogl
c     7    zmat nwchem
c
c     ixyz
c     -------
c     0    xyz file
c     1    mol file
c     2    msf file
c     3    tinker xyz file
c     4    tinker xyz file ?
c     5    pdb file
c     6    chemx format
c     7    msi format
c     8    molden format file 
c     9    mol2 file 
c     11   ambfor xyz file 
c     12   mopac xyz input file 

      iun = 51

      zok = zmqok(idum)

      if (lenfn.eq.0.or.filenm.eq.' ') then
         call zmterr('Invalid Filename !',1,0,1)
      else
         if (iapp.le.1) then
             lc = linlen(curdir)
             if (icmdf.eq.1) then
                 tfile = curdir(1:lc)//'/'//filenm(1:lenfn)
                 ln = linlen(tfile)
             else
                 if (lenfn.le.1) then
                    ln = linlen(filenm)
                 else
                    ln = lenfn
                 endif
                 if (filenm(1:1).eq.'/') then
                    tfile = filenm(1:ln)
                 else
                    tfile = curdir(1:lc)//'/'//filenm(1:ln)
                    ln = ln + lc + 1
                 endif
             endif
             if (iopt.eq.4.and.ixyz.eq.2) then
                open(unit=iun,form='unformatted',
     &          file=tfile(1:ln),status='unknown',action='write',
     &          err=2000)
             else
                open(unit=iun,form='formatted',
     &          file=tfile(1:ln),status='unknown',action='write',
     &          err=2000)
             endif
         endif

         if (iopt.eq.4) then

             if (ixyz.eq.1) then
                call wrmol(iun)
             elseif (ixyz.eq.2) then
                call wrmsf(iun)
             elseif (ixyz.eq.3) then
                call wrtnk(iun)
             elseif (ixyz.eq.4) then
                call wrtnk(iun+100)
             elseif (ixyz.eq.5) then
                call wrcart(iun,1,0,ipdbwh)
             elseif (ixyz.eq.6) then
                call wrchx(iun)
             elseif (ixyz.eq.7) then
                call wrmsi(iun)
             elseif (ixyz.eq.8) then
                call prtmolf(iun,ihaszm,ipoints)
             elseif (ixyz.eq.9) then
                call outmol(iun)
             elseif (ixyz.eq.11) then
                call appchg
                call wrgff(iun)
             elseif (ixyz.eq.12) then
                call mopxyz(iun)
             else
                call wrcart(iun,0,0,0)
             endif

         elseif ((iopt.ge.1.and.iopt.le.3).or.iopt.eq.7.or.
     &           (iopt.ge.19.and.iopt.le.22)) then

             if (zok) call wrzmat(iun,iopt)

         elseif (iopt.eq.5) then

             if (iapp.le.1) call plvhd(iun)
             call plvrml(iun,fancy,atcol,dolabs,1,backb,.false.)
             if (iapp.eq.0.or.iapp.eq.2) call plvend(iun,0)
             if (iapp.eq.4) call plvend(iun,1)

         elseif (iopt.eq.6) then

             if (iapp.le.1.and.ivtwo.eq.3) then
                 write(iun,'(a)') '[MOLDENOGL]'
             endif
             call wrogl(iun)

         endif
      endif

      if (iapp.eq.0.or.iapp.eq.2.or.iapp.eq.4) then
         close(iun)
         ftmp = 'Succesfully wrote file: '//filenm(1:lenfn)
         if (iopt.lt.19) call zmterr(ftmp,1,0,0)
      endif
      return

2000  call zmterr('Error Opening File !',1,0,1)
      return
      end

      subroutine mapzzz(iun,imod,iff,izmtmp,istatz,
     &              bl,alph,bet,ibl,ialph,ibet,imap,ianzz,iz,ianz)

c this is really logical function mapxyz

      implicit double precision (a-h,o-z)
      common /athlp/  iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real bond,angle,dihed
      dimension isel(4)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianzz(*),iz(4,*),ianz(*)

      istatz = 1
      toang = 0.52917706d0
      iuntmp = iun2
      iun2 = iun
      ierr = 0
      idummy = 0
      
      if (imod.eq.1) then
         call rdmol(0,itmp,0,istat)
         if (istat.eq.0) then
            ierr = 1
            goto 100
         endif
      elseif (imod.eq.2) then
         call rdmsf(0,istat)
         if (istat.eq.0) then
            ierr = 2
            goto 100
         endif
      elseif (imod.eq.3) then
         call gettnk(igttnk,0,idummy,iff,iheat,heat)
         if (igttnk.eq.0) then
            ierr = 3
            goto 100
         else
            call dohcon(0)
         endif
      elseif (imod.eq.8) then
         call tnkfst(igttnk,0,0)
         if (igttnk.eq.0) then
            ierr = 3
            goto 100
         else
            call dohcon(0)
         endif
      elseif (imod.eq.7) then
         call rdchx(0,1,0,0,0,istat,1)
         if (istat.eq.0) then
            ierr = 4
            goto 100
         endif
      elseif (imod.eq.0) then
         call getxyz(igetxy,heat,0)
         if (igetxy.eq.0) then
            ierr = 4
            goto 100
         endif
      endif

      if (izmtmp.eq.0) then
         iun2 = iuntmp
         return
      endif

      ii = 0
      do i=1,nz
         if (imap(i).gt.0) then
            if (ianz(imap(i)).ne.ianzz(i)) then
               ierr = 5
               goto 100
            endif
            ii = ii + 1
         endif
      end do

      if (ii.ne.iatoms) then
         ierr = 4
         goto 100
      endif

      do i=1,nz
      
        isel(1) = imap(i)
        do j=1,3
           isel(j+1) = imap(iz(j,i))
        end do

        if (i.ge.2) then
            call intcor(intc,bond,isel,2)
            if (intc.eq.0) goto 100
            bond = bond * toang
            bl(i) = bond
        endif
        if (i.ge.3) then
            call intcor(intc,angle,isel,3)
            if (intc.eq.0) goto 100
            alph(i) = angle
        endif
        if (i.gt.3) then
            call intcor(intc,dihed,isel,4)
            if (intc.eq.0) goto 100
            bet(i) = dihed
        endif
      
      end do

      iun2 = iuntmp
      ihaszm = 1
      call upzme
      return

100   ihaszm = 0
      iun2 = iuntmp
      call inferr('ERROR mapping/reading XYZ file !',0)
      call zmterr('ERROR mapping/reading XYZ file !',1,0,1)
      print*,'mapping ERROR ',ierr
      istatz = 0
      return
      end

c========================= For the convenience of C =======
c========================= Map functions to subroutines ===

      logical function chkmap(idum)
      implicit double precision (a-h,o-z)

      call chkmaz(istat)

      if (istat.eq.0) chkmap = .false.
      if (istat.eq.1) chkmap = .true.

      return
      end

      integer function fndmap(ixyz)
      implicit double precision (a-h,o-z)

      call fndmaz(ixyz,istat)

      fndmap = istat

      return
      end

      logical function pline(isel)
      implicit double precision (a-h,o-z)
      dimension isel(4)

      call plinzz(isel,istat)

      if (istat.eq.0) pline = .false.
      if (istat.eq.1) pline = .true.

      return
      end

      logical function mapxyz(iun,imod,iff,izmtmp)
      implicit double precision (a-h,o-z)

      call mapxzz(iun,imod,iff,izmtmp,istat)

      if (istat.eq.0) mapxyz = .false.
      if (istat.eq.1) mapxyz = .true.

      return
      end

      logical function getzmu(idum)
      implicit double precision (a-h,o-z), integer (i-n)

      call getzmz(istat)

      if (istat.eq.0) getzmu = .false.
      if (istat.eq.1) getzmu = .true.

      return
      end

      subroutine atmd(mopac,ipsi,adfin)
      implicit double precision (a-h,o-z)
      logical mopac,adfin

      if (mopac) then
         imo = 1
      else
         imo = 0
      endif
      if (adfin) then
         iao = 1
      else
         iao = 0
      endif

      call atdd(imo,ipsi,iao)

      return
      end

      subroutine denmak(denok)
      implicit double precision (a-h,o-z)
      logical denok

      call denmad(ido)

      if (ido.eq.1) then
         denok = .true.
      else
         denok = .false.
      endif

      return
      end

      subroutine muldma(vdwr,moddma,domul,dodma)
      implicit double precision(a-h,o-z)
      logical domul,dodma
      dimension vdwr(*)

      if (domul) then
         idm = 1
      else
         idm = 0
      endif
      if (dodma) then
         idd = 1
      else
         idd = 0
      endif

      call muldmd(vdwr,moddma,idm,idd)

      return
      end

      subroutine rdgam(idebug,befo,statio,ioxyz,irtype,istats)
      implicit double precision (a-h,o-z)
      logical befo,statio

      if (befo) then
         ibefo = 1
      else
         ibefo = 0
      endif

      call rdgad(idebug,ibefo,istatio,ioxyz,irtype,istats)

      if (istatio.eq.1) then
         statio = .true.
      else
         statio = .false.
      endif

      return
      end

      subroutine rdgamu(idebug,befo,statio,irtype,hesend,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      logical befo,statio,hesend

      if (befo) then
         ibefo = 1
      else
         ibefo = 0
      endif

      if (hesend) then
         ihsend = 1
      else
         ihsend = 0
      endif

      call rdgamd(idebug,ibefo,istatio,irtype,ihsend,istats)

      if (istatio.eq.1) then
         statio = .true.
      else
         statio = .false.
      endif

      return
      end

      subroutine rdcpmd(idebug,befo,statio,ioxyz,irtype,hesend,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      logical befo,statio,hesend

      if (befo) then
         ibefo = 1
      else
         ibefo = 0
      endif

      if (hesend) then
         ihsend = 1
      else
         ihsend = 0
      endif

      call rdcpmdd(idebug,ibefo,istatio,ioxyz,irtype,ihsend,istats)

      if (istatio.eq.1) then
         statio = .true.
      else
         statio = .false.
      endif

      return
      end

      subroutine rdgaus(idebug,befo,statio,irtype,istats)
      implicit double precision (a-h,o-z)
      logical befo,statio

      if (befo) then
         ibefo = 1
      else
         ibefo = 0
      endif

      call rdgaud(idebug,ibefo,istatio,irtype,istats)

      if (istatio.eq.1) then
         statio = .true.
      else
         statio = .false.
      endif

      return
      end

      subroutine rdmaux(idebug,statio,istats)
      implicit double precision (a-h,o-z)
      logical statio

      call rdmaud(idebug,istatio,istats)

      if (istatio.eq.1) then
         statio = .true.
      else
         statio = .false.
      endif

      return
      end

      subroutine rdmolf(idebug,statio,irtype,iesp,istats)
      implicit double precision (a-h,o-z)
      logical statio

      call rdmold(idebug,istatio,irtype,iesp,istats)

      if (istatio.eq.1) then
         statio = .true.
      else
         statio = .false.
      endif

      return
      end

      subroutine rdnorb(naorbs,impas)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line
      logical datlin


      if (iftyp.eq.3) then

         call search(line,'NUMBER OF CARTESIAN GAUSSIAN BASIS',istat)
         if (istat.eq.1) then
             read(line,'(47x,i5)',err=1000) norbs
         else
             call rewfil
             call search(line,'NUMBER OF BASIS FUNCTIONS',istat)
             read(line,'(38x,i5)',err=1000) norbs
         endif

      elseif (iftyp.eq.2) then

         call search(line,'basis functions',istat)
         if (index(line,'cartesian').ne.0) then
            read(line,'(45x,i5)',err=1000) norbs
         else
            read(line,'(38x,i5)',err=1000) norbs
         endif

      elseif (iftyp.eq.4) then

         call search(line,'primitive gaussians',istat)
         if (istat.ne.0) then
            if (index(line,'primitive gaussians').eq.30) then
               read(line,'(1x,i3)',err=1000,end=1000) norbs
            else
               read(line,'(1x,i5)',err=1000,end=1000) norbs
            endif
         else
            goto 1000
         endif

      elseif (iftyp.eq.5) then

         norbs = naorbs

      elseif (iftyp.eq.1) then

         if (isbin.eq.1) then

             read(iun2,end=1000,err=1000)
     &       idum1,norbs,idum2,((rdum,j=1,idum1),i=1,3)
             if (idum1.gt.numatm) goto 1000 

         else

             call nxtlin(line,jstat)
             if (jstat.eq.1.or.jstat.eq.2) goto 1000

             if (.not.datlin(line)) goto 1000
             call bckfil
             if (index(line,"START OF MOPAC").ne.0) then
                call search(line,'AO_ZETA[',istat)
                if (istat.eq.1) then
                   norbs = intlin(line,istat)
                else
                   goto 1000
                endif
             else
                if (impas.eq.1) then
                   
                   call nxtlin(line,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(line,*,end=1000,err=1000)
     &             idum1,norbs,idum2,((rdum,j=1,idum1),i=1,3)
                   if (idum1.gt.numatm) goto 1000 
                else
                   call nxtlin(line,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(line,'(3i8)',err=1000)
     &                  idum1,norbs,idum2
                   do i=1,idum1
                      call nxtlin(line,jstat)
                      if (jstat.eq.1.or.jstat.eq.2) goto 1000
                      read(line,'(1x,3f16.8)',err=1000)
     &                   (rdum,j=1,3)
                   end do
                   if (idum1.gt.numatm) goto 1000 
                endif
             endif
         endif

      endif

      if (norbs.gt.mxorb) then
         nsiz = norbs/256 
         lsiz = norbs - nsiz*256
         if (lsiz.gt.0) nsiz = nsiz + 1
         nsiz = nsiz*256
         call allorb(nsiz,0)
         print*,'Allocating memory for orbitals !'
      endif

1000  call rewfil
      return
      end

      subroutine wrlab(i,ttmp,ianz,ityp,qat)
      implicit double precision (a-h,o-z)

      parameter (mxel=100)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)

      character*2 elemnt
      character*(*) ttmp
      common /elem/   elemnt(mxel)
      integer*2 ityp,it10000
      character*3 chtnk,pdbsym,hsym,ambtnk
      character*2 amotnk,gffstr
      character*7 chgstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      dimension ityp(*),ianz(*),qat(*)

      it10000 = 10000

      ttmp = '              '
      ttmp = elemnt(ianz(i))
c      if (ianz(i).eq.16) ttmp(2:2) = 'p'
      im = mod(ityp(i),it10000)

      if (im.gt.0) then
         ttmp(3:3) = '-'
         ttmp = ttmp(1:3)//ambtnk(im)
         if (iambch.eq.1) then
            ttmp(7:7) = '-'
            write(chgstr,'(f7.4)') qat(i)
            ttmp = ttmp(1:7)//chgstr
         endif
      endif

      call tocap(ttmp,14)
      if (ttmp(4:5).eq.'H1'.and.
     &   (im.ge.350.and.im.le.500)) ttmp(5:5) = 'P'

      l = 14
      call spatrm(ttmp,l)

      return
      end

      subroutine cnvcon(iconn,inat,lwrit,ii,nn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension nn(mxcon+1),icnn(mxcon+1),lcnn(mxcon+1),lb(mxcon+1)
      dimension inat(mxcon+1),iconn(mxcon+1,*),lwrit(*)

      ncnn = iconn(1,ii)
      mcnn = 0

      do j=1,ncnn

         icnn(j) = abs(iconn(j+1,ii))
         jj = lwrit(icnn(j))

         if (jj.gt.0) then
             mcnn = mcnn + 1
             lcnn(mcnn) = jj
             lb(mcnn) = j
         endif

      end do

      call srti(mcnn,lcnn,inat)

      nn(1) = mcnn
      do j=1,mcnn
         nn(j+1) = icnn(lb(inat(j)+1))
      end do

      return
      end

      double precision function distot()
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      common /athlp/ iatoms, mxnat
      common /gamori/imap(numat1),cstand(3,numat1),istand(numat1),
     &               msucc
      dimension b(3,numat1)

      call rotcor(b)

      distot = 0.0d0

      do i=1,iatoms
          d1 = b(1,i) - cstand(1,i)
          d2 = b(2,i) - cstand(2,i)
          d3 = b(3,i) - cstand(3,i)
          dist = d1*d1 + d2*d2 + d3*d3
          distot = distot + dist
      end do

      return
      end

      function locatc(label,nf,itext)
      implicit double precision (a-h,p-w),integer (i-n)
      implicit character *8 (z),character *1 (x)
      implicit character *4 (y), logical (o)
      character*(*) label,itext
      dimension label(*)

      do i=1,nf
         if (label(i).eq.itext) then
            locatc = i
            return
         endif
      end do

      locatc = 0

      return
      end

      subroutine geomop(formax,forrms,dismax,disrms,epoints,isav,
     &                  coo,ianz)
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /athlp/ iatoms, mxnat
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)
      dimension coo(3,*),ianz(*)

      call rewfil

      igcvav = 1
      ifmxav = 0
      ifrmav = 0
      idmxav = 0
      idrmav = 0
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0
      enmax = -1000000.0d0
      enmin = 1000000.0d0
      do i=1,mxpnt
         epoints(i) = 0.0d0
      end do
      ihasep = 0

      idomopf = 1
      do while (.true.)
         call getmop(iatoms,heat,0,idomopf,istat)
         if (istat.eq.0) goto 100
         idomopf = 0
         if (ngeoms.eq.mxpnt) then
             call inferr('exceeded MAXPNT !',1)
             goto 100
         endif
         ngeoms = ngeoms + 1
         isav(ngeoms) = 1
         if (heat.ne.0.0d0) then
            ihasep = 1
            epoints(ngeoms) = heat
            if (heat.gt.enmax) enmax = heat
            if (heat.lt.enmin) enmin = heat
         endif
      end do

100   continue
      nepnts =  ngeoms
      if (ihasep.eq.0) then
         igcvav = 0
         ieav = 0
      endif

      return
      end

      subroutine geoxyz(ihasg,iff,
     &      formax,forrms,dismax,disrms,epoints,isav,coo,ianz,istat)
      implicit double precision (a-h,o-z)
      logical goon
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /athlp/ iatoms, mxnat
      character*137 line
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)
      dimension coo(3,*),ianz(*)

      istat = -1
      ngeoms = 0
      if (ihasg.gt.0) then
         call rewmf
         call srchmf(line,'[GEOMETRIES]',istat1)
      else
         call rewfil
         igcvav = 1
         ifmxav = 0
         ifrmav = 0
         idmxav = 0
         idrmav = 0
         ieav = 1
         nepnts = 0
         dmaxt = 0.0d0
         fmaxt = 0.0d0
         drmst = 0.0d0
         frmst = 0.0d0
         enmax = -1000000.0d0
         enmin = 1000000.0d0
         ihasep = 0
         do i=1,mxpnt
            epoints(i) = 0.0d0
         end do
      endif

      do while (.true.)

         iheat = 0
         if (ihasg.le.1) then
             if (iftyp.eq.11.or.iftyp.eq.12) then
                if (iff.eq.7) then
                   call gtheat(igttnk,iheat,heat)
                else
                   call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                endif
                if (igttnk.eq.1) then
                   goon = .true.
                else
                   goon = .false.
                endif
             elseif (iftyp.eq.13) then
                call getmol(igetmo,0)
                if (igetmo.eq.1) then
                   goon = .true.
                else
                   goon = .false.
                endif
             else
                call getxyz(igetxy,heat,0)
                if (igetxy.eq.1) then
                   goon = .true.
                else
                   goon = .false.
                endif
                iheat = 1
             endif
         else
             call getzm(iatoms,0,0,istat1)
             if (istat1.eq.1) then
                 goon = .true.
             else
                 goon = .false.
             endif
         endif
         if (.not.goon) goto 80

         ngeoms = ngeoms + 1
         if (ihasg.eq.0.and.ngeoms.le.mxpnt) then
            isav(ngeoms) = 1
            if (iheat.eq.1) then
               ihasep = 1
               epoints(ngeoms) = heat
               if (heat.gt.enmax) enmax = heat
               if (heat.lt.enmin) enmin = heat
            endif
         endif
      end do

80    continue

      if (ngeoms.gt.mxpnt) then
          istat = ngeoms
          return
      endif

100   continue
      nepnts =  ngeoms
      if (enmax.eq.enmin) enmax = enmin + 0.00001d0
      if (ihasg.eq.0) then
         if (ihasep.eq.0) then
            igcvav = 0
            ieav = 0
         endif
      endif

      return
      end

      subroutine selsol
      implicit double precision (a-h,o-z)
      character str*100, esc
      real xx, yy
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plot/   iplot,iplwin,icolps

c----- select solid line again 

      esc    = char(27)

      if (iplot.eq.0) write(iun4,'(a)') '.ls 1 0'

      if (iplot.eq.1) write(iun4,'(a)') 'SP1;'

      if (iplot.eq.2) write(iun4,'(a,''*m1b'')')esc

      if (iplot.eq.4) then
         write(iun4,'(''s'')')
         write(iun4,'(''[] 0 setdash'')')
         write(iun4,'(''   1 setlinewidth'')')
         write(iun4,'(''n'')')
      endif

      if (iplot.eq.3) then
         idum=1
         call plotgh(idum,0.0d0,0.0d0)
         write(iun4,*) esc//'`'
      endif

      if (iplot.eq.6) then
         xx = 15.0
         yy = 0.0
         call xwin(xx,yy,99,str,nstr,idum1,idum2)
         call xwin(xx,yy,8,str,nstr,idum1,idum2)
         idum = 1
         call plotgh(idum,0.0d0,0.0d0)
      endif

      return
      end

      subroutine dencnd(npts1,npts2,fcnt,dens,iedlog)
      implicit double precision (a-h,o-z)

c THIS IS REALLY dencnt

      parameter (mxcntr=100)
      logical euclid, yes, oscal, ostep, fine
      logical valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      real xx, yy
      character str*100, esc
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /plot/   iplot,iplwin,icolps
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension fcnt(*),dens(*),iedlog(*)

      esc = char(27)

      if (iplot.eq.6) then
         xx = 2.0
         yy = 0.0
         call xwin(xx,yy,99,str,nstr,idum1,idum2)
      elseif (iplot.eq.4.and.icolps.eq.1) then
         write(iun4,*) 'poscontour setcol'
      else
         write(iun3,111) step
         write(iun3,'('' CONTOUR     CONTOURVALUE''//)')
      endif
111   format(//20x,'INTERVAL BETWEEN CONTOURS IS',f8.5,/,20x,
     +          '   ELECTRONS PER CUBIC A.U.',/)

      icnt = 0

c----- Positive Contours 

      is = 1
      if (bonds.or.ovrlap.or.atomic) is=2

      do i=is,100
          cntval = (i-1)*step
          if (cntval.lt.pmin*cut) goto 107
          if (cntval.gt.pmax*cut) goto 107
          iflag = 1
          if (i.eq.2) iflag = 0
          if (icnt.lt.mxcntr) then
             icnt = icnt + 1
             fcnt(icnt) = cntval
             if (iplot.ne.6) write(iun3,'(4x,i3,15x,f13.5)')
     +                    icnt,cntval
          endif
          height = cntval*scale
          if (iplot.eq.4.and.i.eq.1) write(iun4,*) 'nullcontour {'
          call cntour(dens,npts2,npts2,npts1,height,cntval,x,iedlog)
          if (iplot.eq.4.and.i.eq.1) write(iun4,*) '} if'
107       continue
      end do

c------ select other line type 

      if (iplot.eq.0) then
          write(iun4,'(a)') '.nc 3'
          write(iun4,'(a)') '.ls 2 0.2'
      endif
      if (iplot.eq.1) write(iun4,'(a)') 'SP3;'
      if (iplot.eq.2) write(iun4,'(a,''*m7b'')')esc
      if (iplot.eq.3) then
          idum = 1
          call plotgh(idum,0.0d0,0.0d0)
          write(iun4,*) esc//'a'
      endif
      if (iplot.eq.4) then
          write(iun4,'(''s'')')
          if (icolps.eq.1) then
              write(iun4,*) 'negcontour setcol'
          else
              write(iun4,'(''0 setlinecap [4 7] 0 setdash'')')
          endif
          write(iun4,'(''n'')')
      endif
      if (iplot.eq.6) then
          xx = 1.0
          yy = 0.0
          call xwin(xx,yy,99,str,nstr,idum1,idum2)
          call xwin(xx,yy,9,str,nstr,idum1,idum2)
          idum = 1
          call plotgh(idum,0.0d0,0.0d0)
      endif

c------ Negative Contours 

      do i=1,20
          cntval = -step*i
          if (cntval.lt.pmin*cut) goto 112
          if (cntval.gt.pmax*cut) goto 112
          iflag = 1
          if (i.eq.1) iflag = 0
          if (icnt.lt.mxcntr) then
              icnt = icnt + 1
              fcnt(icnt) = cntval
              if (iplot.ne.6) 
     +        write(iun3,'(4x,i3,15x,f13.5)') icnt,cntval
          endif
          height = cntval*scale
          call cntour(dens,npts2,npts2,npts1,height,cntval,x,iedlog)
112       continue
      end do

      if (iplot.eq.4.and.icolps.eq.1) then
          write(iun4,'(''s'')')
          write(iun4,'(''0 setgray'')')
          write(iun4,'(''n'')')
      endif

      cntval=99.999

      return
      end

C
c 11 jul 01: header fixed; send to Gijs
c  7 jun 01: determine runtype, scftype, dft, mp2 from output
c  6 jun 01: uhf fixed
c  4 jun 01: prepares MOLDEN Format file from CADPAC output for:
c  { rhf | uhf }
c  { ene | opt | hess }
c  { dft | mp2 }

c
c Mariusz Klobukowski 
c cad2mol is a minor modification of Chris Lovallo's hon2mol
c
C This program will take a CADPAC output file and convert it to
C Molden Format for use with Molden (as filename.mdn). The program
C should work for SP energy, geometry optimizations, and Hessians for
C any single-determinant wavefunction

C For the orbitals to be read correctly, NOPRINT OCCVECTORS must not
c be used

      program cad2mol    
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      character filenm*70
      parameter(inp=1,iout=2,itmp=3,maxbf=2000)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      dimension occ(maxbf)

C Open necessary files (input, output, and temp)

      call open_files(inp,iout,itmp,filenm)

C Print title onto files

      call write_files(iout,itmp,'[Molden Format]')

C Read and setup parameters of run

      call find_flags(inp,occ)
      rewind(inp)

C Find and write coordinates and basis set

      call find_coord(inp,iout,itmp)

C Find and write eigenvectors and eigenvalues

      call find_eigen(inp,iout,occ)

C Next (and last for SP energy) is SCF energy convergence

      rewind(inp)
      call find_conv1(inp,iout)

C End if the run is SP energy, skip to frequencies if run is Hessian

      if (irun .eq. 0) goto 9999
      if (irun .eq. 2) goto 10

C Find and write out geometry optimization data

      call find_gopt(inp,iout)
      if (irun .eq. 3) goto 10
      goto 9999

C Find and write frequencies and normal modes (for Hessian runs)

 10   call find_freq(inp,iout,itmp)

C Close files

 9999 call close_files(inp,iout,itmp)

C That's it! It's over! Bye now!

      end
C-----------------------------------------------------------------------
      subroutine open_files(inp,iout,itmp,filenm)
      character filenm*70

C Open input file (CADPAC output file)

      write(6,*) 'Opening necessary files...'
      call getarg(1,filenm)
      if(filenm.eq.' ') then
        write(6,fmt='('' Enter the input file name (with .out): '',$)')
        read (5,fmt='(a70)') filenm
      endif
      open(unit=inp,file=filenm,access='SEQUENTIAL',
     1     status='OLD',form='FORMATTED')

C Open output and temp files

      do i=1,67
        if (filenm(i:i+3) .eq. '.out') filenm(i:i+3)='.mdn'
      enddo
      open(unit=iout,file=filenm,access='SEQUENTIAL',
     1     status='UNKNOWN',form='FORMATTED')
      open(unit=itmp,access='SEQUENTIAL',
     1     status='UNKNOWN',name='TEMP',form='FORMATTED')
c    1     status='SCRATCH',form='FORMATTED')
      return
      end
C-----------------------------------------------------------------------
      subroutine find_flags(inp,occ)
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      character line*130
c     character kyword*26
      parameter(maxbf=2000)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      dimension occ(*)

C This subroutine searches the CADPAC file for various data pertaining
C to the run (type of wavefunction, number of basis functions and
C occupied orbitals, etc.)

      write(6,*) 'Beginning initialization...'

C Initialize flags

      flgrhf=.false.
      flguhf=.false.
      flgopn=.false.
      flgdft=.false.
      flggvb=.false.
      flgmp2=.false.
      flgmp4=.false.
      flgmc= .false.

C Search for type of run and properties - decode from command line
C Determine type of wavefunction - decode from command line
c cad2mol job.out
c  { rhf | uhf | rohf | gvb | mp2 | mp4 }
c  { ene | opt | hess }
c  { dft }

*     inparg=iargc()
*     write(6,'('' inparg:'',i3)') inparg

      irun = -1
      iwfn = -1
*     do narg=2,inparg
*       call getarg(narg,kyword)
*       write(6,'(''   narg:'',i3,'' kyword:'',a)') narg,kyword
*       call up_case(kyword,26)
*       call last_char(kyword,26,loc)
*       if     (kyword(1:loc).eq.'RHF') then
*         flgrhf=.true.
*         iwfn=0
*       else if(kyword(1:loc).eq.'ROHF') then
*         flguhf=.true.
*         flgopn=.true.
*         iwfn=0
*       else if(kyword(1:loc).eq.'GVB') then
*         flguhf=.true.
*         flgopn=.true.
*         iwfn=0
*       else if(kyword(1:loc).eq.'UHF') then
*         flguhf=.true.
*         flgopn=.true.
*         iwfn=0
*       else if(kyword(1:loc).eq.'MP2') then
*         iwfn=5
*         flgmp2=.true.
*       else if(kyword(1:loc).eq.'MP4') then
*         iwfn=6
*         flgmp4=.true.
*       else if(kyword(1:loc).eq.'CAS') then
*         iwfn=1
*       else if(kyword(1:loc).eq.'DFT') then
*         flgdft=.true.
*       else if(kyword(1:loc).eq.'ENE') then
*         irun=0
*       else if(kyword(1:loc).eq.'OPT') then
*         irun=1
*       else if(kyword(1:loc).eq.'HESS') then
*         irun=2
*       else if(kyword(1:loc).eq.'OPHS') then
*         irun=3
*       else
*         write(6,*) 'wrong parameter on command line'
*         call error
*       endif
*     enddo

      rewind(inp)
      ifound=0
      call search(inp,line,'RUN TYPE = ENERGY',ifound,0)
      if(ifound.eq.1) then
        write(6,*) 'RUN TYPE = ENERGY'
        irun=0
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'RUN TYPE = OPTIMIZE',ifound,0)
      if(ifound.eq.1) then
        write(6,*) 'RUN TYPE = OPTIMIZE'
        irun=1
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'RUN TYPE = SECDER',ifound,0)
      if(ifound.eq.1.and.irun.eq.-1) then
        irun=2
        write(6,*) 'RUN TYPE = SECDER -- only'
      endif
      if(ifound.eq.1.and.irun.eq.1) then
        irun=3
        write(6,*) 'RUN TYPE = SECDER -- after OPTIMIZE'
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'RUN TYPE = FORCE',ifound,0)
      if(ifound.eq.1.and.irun.eq.-1) then
        irun=2
        write(6,*) 'RUN TYPE = FORCE -- only'
      endif
      if(ifound.eq.1.and.irun.eq.1) then
        irun=3
        write(6,*) 'RUN TYPE = FORCE -- after OPTIMIZE'
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'SCF TYPE = CLOSED',ifound,0)
      if(ifound.eq.1) then
        flgrhf=.true.
        iwfn=0
        write(6,*) 'SCF TYPE = CLOSED'
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'UHF Calculation',ifound,0)
      if(ifound.eq.1) then
        iwfn=0
        flguhf=.true.
        flgopn=.true.
        write(6,*) 'UHF Calculation'
      endif 
      rewind(inp)
      ifound=0
      call search(inp,line,'CLOSED-SHELL KOHN-SHAM',ifound,0)
      if(ifound.eq.1) then
        flgdft=.true.
        write(6,*) 'CLOSED-SHELL KOHN-SHAM'
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'Unrestricted KOHN-SHAM',ifound,0)
      if(ifound.eq.1) then
        iwfn=0
        flgdft=.true.
        flguhf=.true.
        flgopn=.true.
        write(6,*) 'Unrestricted KOHN-SHAM'
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'RHF MP2 Calculation',ifound,0)
      if(ifound.eq.1) then
        iwfn=5
        flgmp2=.true.
        write(6,*) 'RHF MP2 Calculation'
      endif
      rewind(inp)
      ifound=0
      call search(inp,line,'UHF MP2 Calculation',ifound,0)
      if(ifound.eq.1) then
        iwfn=5
        flgmp2=.true.
        flguhf=.true.
        flgopn=.true.
        write(6,*) 'UHF MP2 Calculation'
      endif
      
      write(6,fmt='('' irun   ='',i2)') irun
      write(6,fmt='('' iwfn   ='',i2)') iwfn
      write(6,fmt='('' flgrhf ='',L2)') flgrhf
      write(6,fmt='('' flguhf ='',L2)') flguhf
      write(6,fmt='('' flgopn ='',L2)') flgopn
      write(6,fmt='('' flgdft ='',L2)') flgdft
      write(6,fmt='('' flgmp2 ='',L2)') flgmp2

      if (irun.ne.0. and.
     1    irun.ne.1 .and.
     1    irun.ne.2 .and.
     1    irun.ne.3) then
        write(6,*)  'Only RUNTYPs=0-3 (SP energy, geom opt, and Hessian)
     1 are currently implemented!'
        call error
      endif

      if (iwfn .ne. 0 .and. iwfn .ne. 5 .and. iwfn .ne. 1) then
       write(6,*)   'Only single-determinant and MCSCF wavefunctions are
     1 currently implemented!'
       call error
      endif

      rewind (inp)

C Find number of basis functions

      call search(inp,line,'Number of Basis Functions',ifound,-1)
      read(unit=line,fmt='(46x,i5)') nbf
      write(*,*) 'nbf  =',nbf
      if (nbf .ge. maxbf) then
        write(6,*)   'Error code 5! Number of basis functions is greater
     1 than parameter MAXBF!'
        write(6,*) 'Check parameter MAXBF and run program again.'
        call error
      endif


C Determine type of run and orbital occupancies

      if (iwfn .eq. 1 .or. iwfn .eq. 10 .or. iwfn .eq. 12) flgmc=.true.
      if (flgmc .or. iwfn .eq. 2) then
        call search(inp,line,'NUMBER OF ORBITALS',ifound,-1)
        read(unit=line,fmt='(27x,i5)') norb
        call search(inp,line,'# OF CORE   ORBITALS',ifound,-1)
        read(unit=line,fmt='(26x,i5)') ndoc  
        goto 20
      endif

C The program does not search for MP2/4 lines, it sets the
C flags according to iwfn

 10   if (iwfn .eq. 5) flgmp2=.true.
      if (iwfn .eq. 6) flgmp4=.true.
      if(flguhf) then
        call search(inp,line,'occupied alpha orbitals',ifound,-1)
        read(unit=line,fmt='(46x,i5)') ndoc
      else
        call search(inp,line,
     1       'Number of doubly occupied orbitals',ifound,-1)
        read(unit=line,fmt='(46x,i5)') ndoc
      endif
      write(*,*) 'ndoc =',ndoc
      if (.not. flgopn) goto 20
      if (flguhf) then
        call search(inp,line,'occupied beta orbitals',ifound,-1)
        read(unit=line,fmt='(46x,i5)') nsoc
        write(*,*) 'nsoc=',nsoc
        goto 20
      endif

 20   if (.not. flguhf) then
        do i=1,ndoc
          occ(i)=2.0
        enddo
        if (nsoc .gt. 0) then
          do i=ndoc+1,ndoc+1+nsoc
            occ(i)=1.0
          enddo
          do i=ndoc+1+nsoc,nbf
            occ(i)=0.0
          enddo
        else
          do i=ndoc+1,nbf
            occ(i)=0.0
          enddo
        endif
        goto 30
      else
        do i=1,ndoc
          occ(i)=1.0
        enddo
        do i=ndoc+1,nbf
          occ(i)=0.0
        enddo
      endif

C Determine maximum number of iterations (SCF or CI)  

 30   if (iwfn .eq. 2) then
        call search(inp,line,'MAX. NUMB. OF ITERATIONS',ifound,-1)
        read(unit=line,fmt='(29x,i6)') maxit
      else
        if(flguhf) then
         call search(inp,line,'Maximum Number of Iterations',ifound,-1)
        else
         call search(inp,line,'Maximum number of iterations',ifound,-1)
        endif
        read(unit=line,fmt='(32x,i6)') maxit
        write(*,*) 'maxit=',maxit
      endif
      maxit=maxit+1

      write(6,*) 'Initialization done!'
      return
      end
C-----------------------------------------------------------------------
      subroutine find_coord(inp,iout,itmp)
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130,atmnam*8
      parameter(maxat=100)
      dimension atmnam(maxat)

C This subroutine finds and writes out the coordinates of the atoms
C It searches for CHARGE, and then skips the --- and blank lines
C It then calls find_bas to write out the basis set

      write(6,*) 'Reading coordinates...'
      call write_files(iout,itmp,'[Atoms] AU')
      call search(inp,line,'Atom     Nuclear',ifound,-1)
      call skip(inp,2)
      i=1
 10   call read_line(inp,line)
      read(unit=line,fmt='(4x,a8)') atmnam(i)  
      if (atmnam(i) .eq. '--------') goto 20
      read(unit=line,fmt='(4x,a8,2x,f5.1,3f15.8)') atmnam(i),chrg
     1 ,x,y,z
      ichrg=int(chrg)
      write(*,fmt='(1x,a8,i3,i3,3(2x,f12.8))') atmnam(i),i,ichrg,x,y,z
      write(unit=lintmp,fmt='(1x,a8,i3,i3,3(2x,f12.7))') atmnam(i),i
     1      ,ichrg,x,y,z
      call write_files(iout,itmp,lintmp)
      i=i+1
      goto 10
 20   nat=i-1
      write(*,*) 'nat=',nat
      write(6,*) 'Done writing coordinates!'
      call find_bas(inp,iout,itmp,atmnam)
      return
      end
C-----------------------------------------------------------------------
      subroutine find_bas(inp,iout,itmp,atmnam)
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130,temp8*8,temp4*4,atmnam*8,shltyp*4
      parameter(mxprim=30)
      dimension atmnam(*),coef1(mxprim),coef2(mxprim),exp(mxprim)
 
C This subroutine reads and writes out the basis set, including looping
C over the non-symmetry unique atoms
 
      write(6,*) 'Reading basis set...'
      call skip(inp,6)
      call write_files(iout,itmp,'[GTO]')
      do j=1,nat
*     write(*,*) j,atmnam(j)
c ... reset cgtf count for each new atom
        ikount=0
        write(unit=lintmp,fmt='(i3,a5)') j, ' 0   '
        call write_files(iout,itmp,lintmp)
        call read_line(inp,line)
*       write(*,*) '>'//line(1:76)
        read(unit=line,fmt='(1x,a8)') temp8
*       write(*,*) 'temp8'//temp8
        if (temp8 .ne. atmnam(j)) then
C Either an error has occurred, or this is not a symmetry unique atom.
C Checking for an atom with the same name and copying basis set...
          backspace(inp)
          temp8=atmnam(j)
          do k=1,j-1
            if (temp8 .eq. atmnam(k)) then
              rewind(itmp)
              call search(itmp,line,atmnam(k),ifound,-1)
              read(unit=line,fmt='(10x,i3)') n
              write(unit=temp8,fmt='(i3,a5)') n, ' 0   '
              call search(itmp,line,temp8,ifound,-1)
              write(unit=temp8,fmt='(i3,a5)') n+1, ' 0   '
 10           call read_line(itmp,line)
*             write(*,*) '>'//line(1:76)
              if (line(1:8) .ne. temp8) then
                call write_files(iout,0,line)
                goto 10
              endif
              call ffwrd(itmp)
              goto 40
            endif
          enddo
 
C Nope! There was an error! Stopping...
 
          write(6,*) 'Error code 1 reading basis set!'
          call error
        endif
        
        l=1
 20     call read_line(inp,line)
*       write(*,*) '>'//line(1:76)
        if(line(1:6).eq.' Model') call read_line(inp,line)
        read(unit=line,fmt='(12x,i2,5x,a4,6x,f16.6,f15.6)')
     1     jkount,temp4,exp(l),coef1(l)
*       write(*,*) 'l ikount jkount',l,ikount,jkount,exp(l)
        if(jkount.eq.0) then
*          backspace(inp)
           ikount=jkount
           goto 30
        endif
        if(ikount.gt.0 .and. jkount.ne.ikount) then
          ikount=jkount
          backspace(inp)
          goto 30
        else
          ikount=jkount
        endif
        shltyp=temp4
        if (shltyp(1:1) .eq. 'L') then
          read(unit=line,fmt='(19x,a4,6x,f16.6,2f15.6)')
     1         shltyp,exp(l),coef1(l),coef2(l)
        endif
        l=l+1
        goto 20
 30     nprim=l-1
*       write(*,*) 'nprim exp',nprim,exp(nprim)
 
C Write basis set
 
        if (shltyp(1:1) .ne. 'L') then
          write(unit=lintmp,fmt='(a2,i5,a5)') shltyp(1:1),nprim, ' 1.00'
          call write_files(iout,itmp,lintmp)
          do l=1,nprim
            write(unit=lintmp,fmt='(2(1x,d17.10))') exp(l),coef1(l)
            call write_files(iout,itmp,lintmp)
          enddo
        elseif (shltyp(1:1) .eq. 'L') then
          write(unit=lintmp,fmt='(1x,a2,i4,a5)') 'SP',nprim,
     1          ' 1.00'
          call write_files(iout,itmp,lintmp)
          do l=1,nprim
            write(unit=lintmp,fmt='(3(1x,d17.10))') exp(l),coef1(l)
     1            ,coef2(l)
            call write_files(iout,itmp,lintmp)
          enddo
        else
          write(6,*) 'Error code 3 writing basis set!'
          call error
        endif
        if(jkount.eq.0) goto 40
        l=1
        goto 20
 40     call blank_line(iout)
      enddo
      call blank_line(iout)
      write(6,*) 'Done writing basis set!'
      return
      end
C-----------------------------------------------------------------------
      subroutine find_eigen(inp,iout,occ)
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130
      parameter(maxbf=2000)
      parameter (zero=0.0d+00, one=1.0d+00)
      dimension occ(*),orbs(maxbf,maxbf),eval(maxbf)

C This subroutine finds and writes out the molecular orbitals and
C orbital energies, along with their occupancies

      write(6,*) 'Reading orbitals and eigenvalues...'
      call write_files(iout,0,'[MO]')
c ... 1st MO output
      first_SCF=.true.
      if(flguhf) then
        call search(inp,line,'Alpha-spin Orbitals',ifound,-1)
      else
        call search(inp,line,'Molecular Orbitals',ifound,-1)
      endif
c ... 2nd MO output - used if opt+hess in the same run
      if (irun .eq. 1 .or. irun.eq.2 .or. irun.eq.3) then
        if(flguhf) then
          call search(inp,line,'Alpha-spin orbitals',ifound,0)
        else
          call search(inp,line,'Molecular orbitals',ifound,0)
        endif
      endif
      first_SCF=.false.
      if(ifound.eq.0) then
        write(*,*) '... only hessian'
        first_SCF=.true.
        rewind(inp)
        if(flguhf) then
          call search(inp,line,'Alpha-spin Orbitals',ifound,-1)
        else
          call search(inp,line,'Molecular Orbitals',ifound,-1)
        endif
      endif
c ... locate the 1st eigenvalue
      call search(inp,line,'     1    ',ifound,-1)
      backspace(inp)
c ... read the number of MOs printed
      found=.false.
      nmos=0
      do while (.not.found)
        call read_line(inp,line)
        if(line(1:20).ne.'                    ' .and.
     1     line(1:13).ne.' Eigenvectors') then
          nmos=nmos+1
        else
          found=.true.
          backspace(inp)
        endif
      enddo
      write(*,*) 'nmos=',nmos
      write(*,*) 'first_SCF ',first_SCF
      if(.not.flguhf) then
        if(irun.eq.0.or.first_SCF) call skip(inp,2)
      endif
      if(flguhf.and.first_SCF) call skip(inp,1)
      if (flggvb) call skip(inp,1)
      j=1
 10   k=j+4
      call skip(inp,2)
      call read_line(inp,line)
      read(unit=line,fmt='(12x,5(f13.6))') (eval(i), i=j,k)
      write(*,fmt='(5(i4,f13.6))') (i,eval(i), i=j,k)
      call skip(inp,1)
      do l=1,nbf
        call read_line(inp,line)
        read(unit=line,fmt='(12x,5(f13.6))') (orbs(i,l), i=j,k)
      enddo
      if (k .ge. nmos) then
        do i=1,nmos
          write(unit=lintmp,fmt='(a5,2x,f9.4)') ' Ene=',eval(i)
          call write_files(iout,0,lintmp)
          call write_files(iout,0,' Spin= Alpha')
          if(flguhf.and.i.gt.ndoc) occ(i)=zero
          write(unit=lintmp,fmt='(a7,f11.6)') ' Occup=',occ(i)
          call write_files(iout,0,lintmp)
          do j=1,nbf
            write(unit=lintmp,fmt='(i4,f11.6)') j,orbs(i,j)
            call write_files(iout,0,lintmp)
          enddo
        enddo
        if (.not. flguhf) goto 20

C Now read beta orbitals (for UHF runs only)

        write(6,*) 'Done writing alpha orbitals...'
        call find_beta(inp,iout,occ)
        write(6,*) 'Done writing beta  orbitals...'
        goto 20
      endif
      j=j+5
      goto 10
 20   write(6,*) 'Done writing orbitals and eigenvalues!' 
      return
      end
C-----------------------------------------------------------------------
      subroutine find_beta(inp,iout,occ)

C This subroutine finds and write the beta molecular orbitals and
C orbital energies for a UHF wavefunction

      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130
      parameter(maxbf=2000)
      dimension occ(*),orbs(maxbf,maxbf),eval(maxbf)

c ... locate start of current beta's
      call search(inp,line,'Beta-spin',ifound,-1)
c ... locate 1st beta MO
      call search(inp,line,'     1     ',ifound,-1)
      backspace(inp)
c ... read the number of MOs printed
      found=.false.
      nmos=0
      do while (.not.found)
        call read_line(inp,line)
        if(line(1:20).ne.'                    '.and.
     1     line(1:13).ne.' Eigenvectors') then
          nmos=nmos+1
        else
          found=.true.
          backspace(inp)
        endif
      enddo
      write(*,*) 'nmos=',nmos
      call read_line(inp,line)
      if(line(1:13).ne.' Eigenvectors') backspace(inp)
      j=1
 10   k=j+4
      call skip(inp,2)
      call read_line(inp,line)
      read(unit=line,fmt='(12x,5(f13.6))') (eval(i), i=j,k)
      write(*,fmt='(5(i4,f13.6))') (i,eval(i), i=j,k)
      call skip(inp,1)
      do l=1,nbf
        call read_line(inp,line)
        read(unit=line,fmt='(12x,5(f13.6))') (orbs(i,l), i=j,k)
      enddo
      if (k .ge. nmos) then
        do i=1,nmos
          write(unit=lintmp,fmt='(a5,2x,f9.4)') ' Ene=',eval(i)
          call write_files(iout,0,lintmp)
          call write_files(iout,0,' Spin= Beta')
          if(flguhf.and.i.gt.nsoc) occ(i)=zero
          write(unit=lintmp,fmt='(a7,f11.6)') ' Occup=',occ(i)
          call write_files(iout,0,lintmp)
          do j=1,nbf
            write(unit=lintmp,fmt='(i4,f11.6)') j,orbs(i,j)
            call write_files(iout,0,lintmp)
          enddo
        enddo
        goto 20
      endif
      j=j+5
      goto 10
 20   return
      end
C----------------------------------------------------------------------
      subroutine find_eigmc(inp,iout,occ)
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130
      parameter(maxbf=2000)
      dimension occ(*),orbs(maxbf,maxbf),eval(maxbf)

C This subroutine finds and writes out the natural orbitals and their
C occupancies (energies are all set to 0 if the Fock energies are not
C printed)

      do i=1,nbf
        eval(i)=0.0
      enddo
      rewind(inp)
      call search(inp,line,'EIGENVALUES OF -MC-',ifound,0)
      if (ifound .eq. 1) then
        call skip(inp,2)
        j=1
 10     k=j+5
        call read_line(inp,line)
        read(unit=line,fmt='(6(10x,f11.4))') (eval(i), i=j,k)
        j=j+6
        if (k .lt. nbf) goto 10
      endif
      rewind(inp)
      call write_files(iout,0,'[MO]')
      if (irun .ne. 1) goto 30
      n=0
 20   call search(inp,line,'CAN.CORE + ) NAT.VAL',ifound,0)
      if (ifound .eq. 1) then
        n=n+1
        goto 20
      endif
      rewind(inp)
      do i=1,n
        call search(inp,line,'CAN.CORE + ) NAT.VAL',ifound,-1)
      enddo
      goto 40
 30   call search(inp,line,'CAN.CORE + ) NAT.VAL',ifound,-1)
 40   call skip(inp,9)
      call read_line(inp,line)
      j=1
 50   k=j+6
      read(unit=line,fmt='(15x,7(f15.10))') (occ(i), i=j,k)
      call skip(inp,2)
      do l=1,nbf
        call read_line(inp,line)
        read(unit=line,fmt='(15x,7(f15.10))') (orbs(i,l), i=j,k)
      enddo
      if (k .ge. norb) then
        do i=1,norb
          write(unit=lintmp,fmt='(a5,2x,f9.4)') ' Ene=',eval(i)
          call write_files(iout,0,lintmp)
          call write_files(iout,0,' Spin= Alpha')
          write(unit=lintmp,fmt='(a7,f11.6)') ' Occup=',occ(i)
          call write_files(iout,0,lintmp)
          do j=1,nbf
            write(unit=lintmp,fmt='(i4,f11.6)') j,orbs(i,j)
            call write_files(iout,0,lintmp)
          enddo
        enddo
        goto 60
      endif
      j=j+7
      call skip(inp,8)
      call read_line(inp,line)
      goto 50
 60   return
      end
C-----------------------------------------------------------------------
      subroutine find_eigci(inp,iout,occ)
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130
      parameter(maxbf=2000)
      dimension occ(*),orbs(maxbf,maxbf),eval(maxbf)

C This subroutine finds and writes out the natural orbitals and their
C occupancies (energies are all set to 0)

      do i=1,nbf
        eval(i)=0.0
      enddo
      rewind(inp)
      call write_files(iout,0,'[MO]')
      if (irun .ne. 1) goto 30
      n=0
 20   call search(inp,line,'NATURAL ORBITALS IN ATOMIC',ifound,0)
      if (ifound .eq. 1) then
        n=n+1
        goto 20
      endif
      rewind(inp)
      do i=1,n
        call search(inp,line,'NATURAL ORBITALS IN ATOMIC',ifound,-1)
      enddo
      goto 40
 30   call search(inp,line,'NATURAL ORBITALS IN ATOMIC',ifound,-1)
 40   call skip(inp,6)
      call read_line(inp,line)
      j=1
 50   k=j+6
      read(unit=line,fmt='(15x,7(f15.10))') (occ(i), i=j,k)
      call skip(inp,2)
      do l=1,nbf
        call read_line(inp,line)
        read(unit=line,fmt='(15x,7(f15.10))') (orbs(i,l), i=j,k)
      enddo
      if (k .ge. norb) then
        do i=1,norb
          write(unit=lintmp,fmt='(a5,2x,f9.4)') ' Ene=',eval(i)
          call write_files(iout,0,lintmp)
          call write_files(iout,0,' Spin= Alpha')
          write(unit=lintmp,fmt='(a7,f11.6)') ' Occup=',occ(i)
          call write_files(iout,0,lintmp)
          do j=1,nbf
            write(unit=lintmp,fmt='(i4,f11.6)') j,orbs(i,j)
            call write_files(iout,0,lintmp)
          enddo
        enddo
        goto 60
      endif
      j=j+7
      call skip(inp,5)
      call read_line(inp,line)
      goto 50
 60   return
      end
C-----------------------------------------------------------------------
      subroutine find_conv1(inp,iout)
      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130,temp4*4
      parameter(maxits=101)
      dimension etot(maxits)

C This subroutine finds and writes out the SCF energy convergence
C (the first one)

      write(6,*) 'Reading energy convergence...' 
      if(flgdft) then
        write(6,*) '... DFT calculations - no energy convergence'
        return
      endif
      if (maxit .ge. maxits) then
        write(6,*)   'Error code 5! Number of iterations is greater than
     1 parameter MAXITS!'
        write(6,*) 'Check parameter MAXITS and run program again.'
        call error
      endif
      if (flgmc) then
        call search(inp,line,' CYCLE  TOTAL ENERGY',ifound,-1)
      else if (iwfn .eq. 2) then
        call search(inp,line,' ITER.    MAX.DEV.',ifound,-1)
        call skip(inp,1)
      else
*       call search(inp,line,'Cycle      Total energy',ifound,-1)
        call search(inp,line,'Cycle     ',ifound,-1)
        if(.not.flguhf) call skip(inp,1)
      endif
      i=0
      finish=.false.
      do while(.not.finish)
        call read_line(inp,line)
        if (iwfn .eq. 2) then
          read(unit=line,fmt='(a4,23x,f16.9)') temp4,etot(i)
        else
          if(line(1:5).ne.'     '.and.line(1:4).ne.' Den'
     1                           .and.line(1:5).ne.' Last'
     1                           .and.line(1:5).ne.' HOMO') then
            i=i+1
            read(unit=line,fmt='(5x,f18.9)') etot(i)
*           write(*,*) 'i e',i,etot(i)
          endif
        endif
        if (line(1:4) .eq. ' Den') then
          finish=.true.
        endif
      enddo
      ncyc=i
 10   call write_files(iout,0,'[SCFCONV]')
      write(unit=lintmp,fmt='(a22,i5)') 'scf-first    1 THROUGH',ncyc
      call write_files(iout,0,lintmp)
      do i=1,ncyc
       write(unit=lintmp,fmt='(f14.6)') etot(i)
        call write_files(iout,0,lintmp)
      enddo
      write(6,*) 'Finished writing energy convergence!'
      return
      end
C-----------------------------------------------------------------------
      subroutine find_gopt(inp,iout)

C This subroutine finds and writes the data pertaining to the geometry
C optimization process.

      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130,temp4*4,temp8*8,atmnam*8
      parameter(maxstp=200,bohr2a=5.29177249D-01,maxits=101,maxat=100)
      dimension estep(maxstp),xmxfor(maxstp),rmsfor(maxstp)
      dimension ecyc(maxits),atmnam(maxat),geom(3,maxat,maxstp)
*     dimension grdint(5*maxat)

      write(6,*) 'Reading geometry optimization information...'

c ... DFT calculations do not show SCF convergence 
c ... irrelevant for MP2
      if(flgdft .or. flgmp2) goto 25
      rewind(inp)
      nstep=0
 10   if (flgmc) then
        call search(inp,line,' CYCLE  TOTAL ENERGY',ifound,0)
      else if (iwfn .eq. 0) then
        if(flguhf) then
          call search(inp,line,' UHF Calculation',ifound,0)
        else
          call search(inp,line,' CLOSED-SHELL SCF CALCULATION',ifound,0)
        endif
      else
        call search(inp,line,' Cycle     ',ifound,0)
      endif
      if (ifound .eq. 1) then
        nstep=nstep+1
        goto 10
      endif
      write(*,*) 'nstep=',nstep

c ... position to the last SCF
      rewind(inp)
      do i=1,nstep
        if (flgmc) then
          call search(inp,line,' CYCLE  TOTAL ENERGY',ifound,-1)
        else if (iwfn .eq. 0) then
          if(flguhf) then
          call search(inp,line,' UHF Calculation',ifound,0)
          else
          call search(inp,line,' CLOSED-SHELL SCF CALCULATION',ifound,0)
          endif
          call skip(inp,1)
        else
          call search(inp,line,' CYCLE   TOTAL ENERGY',ifound,-1)
          call skip(inp,1)
        endif
      enddo
c ... located last SCF; find 1st scf cycle
      call search(inp,line,'  1  ',ifound,-1)
      backspace(inp)
      i=0
      finish=.false.
      do while(.not.finish)
        call read_line(inp,line)
        if (iwfn .eq. 2) then
          read(unit=line,fmt='(a4,23x,f16.9)') temp4,ecyc(i)
        else
          if(line(1:5).ne.'     '.and.line(1:4).ne.' Den'
     1                           .and.line(1:5).ne.' Last') then
            i=i+1
            read(unit=line,fmt='(5x,f18.9)') ecyc(i)
            write(*,*) 'i e',i,ecyc(i)
          endif
        endif
        if (line(1:4) .eq. ' Den') then
          finish=.true.
        endif
      enddo
      ncyc=i
      write(*,*) 'ncyc=',ncyc
c ... write scf convergence - last SCF
 20   write(unit=lintmp,fmt='(a21,i5)') 'scf-last    1 THROUGH',ncyc
      call write_files(iout,0,lintmp)
      do i=1,ncyc
        write(unit=lintmp,fmt='(f14.6)') ecyc(i)
        call write_files(iout,0,lintmp)
      enddo

  25  continue

C The program only uses those steps that have a progress line at the end
C of them (one with NSERCH, etc.), so nstep above may not be the nstep
C used later (see line 30)

      rewind(inp)
      nstep=0
 11   continue
        call search(inp,line,' RMS of gradient    ',ifound,0)
        if (ifound .eq. 1) then
          nstep=nstep+1
          goto 11
        endif
      write(*,*) 'n RMS=',nstep

      rewind(inp)
      do i=1,nstep
        call search(inp,line,' RMS of gradient',ifound,0)
        if (ifound .eq. 0)  goto 30
        call backs(inp,line,' Molecular Geometry',ifound,0)
        call skip(inp,2)
        do j=1,nat
          call read_line(inp,line)
          read(unit=line,fmt='(6x,a8,2x,3f20.10)') atmnam(j),
     1         geom(1,j,i),geom(2,j,i), geom(3,j,i)
          write(*,*) j,geom(1,j,i),geom(2,j,i), geom(3,j,i)
          do k=1,3
            geom(k,j,i) = geom(k,j,i)*bohr2a
          enddo
        enddo
        call search(inp,line,' Current energy    ',ifound,-1)
        read(unit=line,fmt='(32x,f19.10)') estep(i)
        write(*,*) 'estep(i)',i,estep(i)
        call skip(inp,2)
        call read_line(inp,line)
        read(unit=line,fmt='(32x,f13.6)') rmsfor(i)
        write(*,*) 'rmsfor(i)',rmsfor(i)
        call read_line(inp,line)
        read(unit=line,fmt='(32x,f13.6)') xmxfor(i)
        write(*,*) 'xmxfor(i)',xmxfor(i)
      enddo
      nstep=i
      write(*,*) 'nstep',nstep

C Now write everything out

 30   nstep=i-1
      call write_files(iout,0,'[GEOCONV]')
      call write_files(iout,0,'energy')
      do i=1,nstep
        write(unit=lintmp,fmt='(1x,f13.6)') estep(i)
        call write_files(iout,0,lintmp)
      enddo
      call write_files(iout,0,'max-force')
      do i=1,nstep
        write(unit=lintmp,fmt='(4x,f10.6)') xmxfor(i)
        call write_files(iout,0,lintmp)
      enddo
      call write_files(iout,0,'rms-force')
      do i=1,nstep
        write(unit=lintmp,fmt='(4x,f10.6)') rmsfor(i)
        call write_files(iout,0,lintmp)
      enddo

C Note that the program prints out only the Cartesian geometries 
C (no matter what coordinates were used in the optimization)

      call write_files(iout,0,'[GEOMETRIES] XYZ')
      write(unit=temp8,fmt='(i5)') nat
      do i=1,nstep
        write(unit=lintmp,fmt='(a9,f13.6)') 'scf done:', estep(i)
        call write_files(iout,0,temp8)
        call write_files(iout,0,lintmp)
        do j=1,nat
          write(unit=lintmp,fmt='(1x,a8,3(f11.6,2x))') atmnam(j),
     1          geom(1,j,i),geom(2,j,i), geom(3,j,i)
          call write_files(iout,0,lintmp)
        enddo
      enddo
      write(6,*) 'Finished writing geometry optimization information!'
      return
      end
C-----------------------------------------------------------------------
      subroutine find_freq(inp,iout,itmp)

C This subroutine finds and writes the frequencies and normal modes of
C vibration.

      implicit double precision(a-e,g-h,o-z)
      implicit logical(f)
      common /flags/ flgrhf,flguhf,flgopn,flgdft,flggvb,flgmp2,flgmp4
      common /flags2/ flgmc
      common /rundat/ irun,iwfn,nbf,ndoc,nsoc,maxit,nat,norb
      character line*130,lintmp*130
      parameter(maxat=100)
      dimension efreq(3*maxat),vibcor(3*maxat,3*maxat)

      write(6,*) 'Reading vibrational frequencies and displacements...'
      call write_files(iout,0,'[FREQ]')
      rewind(inp)
      call search(inp,line,'Transformation matrix from',ifound,-1)
      j=1
 10   k=j+5
      call skip(inp,3)
      call read_line(inp,line)
      read(unit=line,fmt='(17x,6f10.3)') (efreq(i), i=j,k)
      write(*,fmt='(6(i3,f9.3))') (i,efreq(i), i=j,k)
      call skip(inp,2)
      do l=1,3*nat
        call read_line(inp,line)
        read(unit=line,fmt='(17x,6f10.5)') (vibcor(i,l),i=j,k)
*       write(*,fmt='(6f10.5)') (vibcor(i,l),i=j,k)
      enddo
      if (k .ge. 3*nat) then
        do i=1,3*nat
          write(unit=lintmp,fmt='(f10.4)') efreq(i)
          call write_files(iout,0,lintmp)
        enddo
        call write_files(iout,0,'[FR-COORD]')
        rewind(itmp)
        call skip(itmp,2)
        do i=1,nat
          call read_line(itmp,line)
          read(unit=line,fmt='(1x,a8,6x,3(2x,f12.7))') atmnam,x,y,z
          write(unit=lintmp,fmt='(a8,3(1x,f12.6))') atmnam,x,y,z
          call write_files(iout,0,lintmp)
        enddo
        call write_files(iout,0,'[FR-NORM-COORD]')
        do i=1,3*nat
          write(unit=lintmp,fmt='(a9,i5)') 'vibration',i
          call write_files(iout,0,lintmp)
          do j=1,3*nat,3
            write(unit=lintmp,fmt='(3(f12.6,1x))') vibcor(i,j),
     1            vibcor(i,j+1),vibcor(i,j+2)
            call write_files(iout,0,lintmp)
          enddo
        enddo
      goto 20
      endif
      j=j+6
      goto 10
 20   write(6,*)           'Finished writing vibrational frequencies and
     1 displacements!' 
      return
      end
C----------------------------------------------------------------------
      subroutine close_files(inp,iout,itmp)  

C Closes all open files (temp file is deleted)

      write(6,*) 'Closing files...'
      close(unit=inp, err=10, status='KEEP')
      close(unit=iout, err=20, status='KEEP')
      close(unit=itmp, err=30, status='DELETE')
      goto 40
 10   write(6,*) 'An error occurred while closing the input file!'
      call error
 20   write(6,*) 'An error occurred while closing the output file!'
      call error
 30   write(6,*) 'An error occurred while closing the temp file!'
      call error
 40   write(6,*) 'All done! Ending program...' 
      return
      end
C-----------------------------------------------------------------------
      subroutine blank_line(iout)

C Writes a blank line to unit=iout.

      write(iout,fmt='(a)') ' '
      return
      end
C----------------------------------------------------------------------
      subroutine error
      write(6,*) 'An error has occurred while processing the file.'
      write(6,*) 'Aborting run...'
      stop
      end
C-----------------------------------------------------------------------
      subroutine ffwrd(iunit)

C Fast-forward unit=iunit to the end of the file

 10   read(iunit,fmt='(a130)',end=20) line
      goto 10
 20   return
      end
C----------------------------------------------------------------------
      subroutine last_char(line,length,loc)
      character*(*) line

C  Given string LINE of length LENGTH locate and return in LOC
C  the position of the last character.

      loc=length
      do i=length,1,-1
        if(line(i:i).ne.' ') then
          loc=i
          return
        endif
      enddo
      return
      end
C-----------------------------------------------------------------------
      subroutine read_line(iunit,line)
      character line*130
      read(iunit,fmt='(a130)') line
      return
      end
C-----------------------------------------------------------------------
      subroutine search(iunit,line,text,ifound,idbug)
      character*(*) text
      character line*130

C Scan unit IUNIT for the next occurence of TEXT.
C If idbug > 0 write line to unit idbug (probably 6).
C If idbug = -1 then stop program if TEXT not found

      ifound=0
      l=len(text)
 10   read(iunit,fmt='(a130)',end=20) line
      if (idbug .gt. 0) then
        call write_files(idbug,0,line)
      endif
      do i=1,130-l+1
        if (line(i:i+l-1) .eq. text) then
          ifound=1
          return
        endif
      enddo
      goto 10
 20   if (idbug .eq. 1) then
        write(6,*) 'Cannot find ', text(1:l+1)
        call error
      endif
      return
      end
C-----------------------------------------------------------------------
      subroutine skip(iunit,nlines)
      character char*1

C Skip next NLINES on unit IUNIT

      do i=1,nlines
        read(iunit,fmt='(1a1)') char
      enddo
      return
      end
C-----------------------------------------------------------------------
      subroutine write_files(iout1,iout2,text)
      character*(*) text

C Writes TEXT to files iout1 and iout2 (usually output and temp files)
C or just output file (iout2=0)

      loc1=len(text)
      call last_char(text,loc1,loc)
      write(iout1,'(a)') text(1:loc)
      if (iout2 .eq. 0) goto 10
      write(iout2,'(a)') text(1:loc)

 10   return
      end
C----------------------------------------------------------------------

      subroutine up_case(string,lenstr)
c convert all lower case characters to upper case
C
      CHARACTER*(*) STRING
      CHARACTER*26 UCASE,LCASE
C
      DATA UCASE /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA LCASE /'abcdefghijklmnopqrstuvwxyz'/
C
C        CONVERTS LOWER CASE TO UPPER CASE IN THE GIVEN STRING.
C
      DO 100 I=1,LENSTR
         IC = INDEX(LCASE,STRING(I:I))
         IF (IC.GT.0) STRING(I:I) = UCASE(IC:IC)
  100 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      subroutine backs(iunit,line,text,ifound,idbug)
      character*(*) text
      character line*130
 
C Scan unit IUNIT backwards for the occurence of TEXT.
C If idbug > 0 write line to unit idbug (probably 6).
C If idbug = -1 then stop program if TEXT not found
 
      ifound=0
      l=len(text)
 10   read(iunit,fmt='(a130)',end=20) line
      if (idbug .gt. 0) then
        call write_files(idbug,0,line)
      endif
      do i=1,130-l+1
        if (line(i:i+l-1) .eq. text) then
          ifound=1
          return
        endif
      enddo
      backspace(iunit)
      backspace(iunit)
      goto 10
 20   if (idbug .eq. 1) then
        write(6,*) 'Cannot find ', text(1:l+1)
        call error
      endif
      return
      end

      subroutine mopacd(istats,mopopt,irtype,ianz,iatclr,iconn,coo,qat,
     &                  nnat,icent,nspg,ichx,nopr,ir,it,
     &                  xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      common /coord/  xyz(3,numatm)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /curlin/ line
      character*137 string,line,str
      character*2 eltmp,tstr
      integer getlin
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      integer*2 ir,it
      logical chkesp
      dimension rr(3,3),coo(3,*),qat(*),ianz(*),iatclr(*),
     &          iconn(mxcon+1,*),ir(3,3,192),it(3,192)

      istats = 1
      ihasq = 0
      todeg = 45.0d0 / datan(1.0d0)

      call rewfil
      isol = 0
      call search(line,'THE SYSTEM IS A  SOLID',istat)
      if (istat.eq.1) isol = 1
      call rewfil

      irtype = 0
      if (mopopt.eq.1) then
         call searchv(line,'MOLECULE IN FORCE CALCULATION',
     &         'INTRINSIC REACTION COORDINATE',
     &         'POINTS ON REACTION COORDINATE',
     &         'FIRST VARIABLE   SECOND',
     &         'NUMBER OF POINTS IN PATH',istat)
         if (istat.eq.1) then
             if (index(line,'REACTION').ne.0.or.
     &           index(line,'POINTS IN PATH').ne.0.or.
     &           index(line,'VARIABLE').ne.0) goto 200
             irtype = 4
             natoms = 0
             call redel(line,3)
             do while (getlin(0).eq.1)
                if (linlen(line).le.1) return
                natoms = natoms + 1
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.2) goto 200
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1.and.ktype.ne.2) goto 200
                if (ktype.eq.1) then
                   nat(natoms) = iatnum(str,nstr)
                else
                   nat(natoms) = itype
                endif
                do i=1,3
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.ne.3) goto 200
                   xyz(i,natoms) = rtype
                end do
             end do
             return
         endif
      endif

      call rewfil
      ifrst = 0


c       skip the initial coordinates

      call search(string,'          Cartesian Coordinates',istat)
      if (istat.ne.1) goto 200

c       read the optimised coordinates

      call search(string,'          Cartesian Coordinates',istat)
      if (istat.ne.1) then
        ifrst = 1
        call rewfil
        call search(string,'          Cartesian Coordinates',istat)
      endif

      call nxtlin(string,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 200

      if (mopopt.lt.3.or.(mopopt.eq.5.and.ifrst.eq.1)) then
         call nxtlin(string,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200
         call nxtlin(string,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200
      endif


      i = 1
      if (mopopt.eq.1.or.mopopt.eq.3.or.mopopt.eq.5) then
         do while (.true.)
          call nxtlin(string,jstat)
          if (jstat.eq.1.or.jstat.eq.2) goto 200
          ichs = ifblen(string)
          if (ifrst.eq.1) then
           if (ichs.ne.50) goto 100
           if (mopopt.eq.3) then
              read(string,'(14x,i2,4x,3(f10.4))',err=200)
     &        nat(i),(xyz(j,i),j=1,3)
           else
              read(string,'(14x,a2,4x,3(f10.4))',err=200)
     &        eltmp,(xyz(j,i),j=1,3)
              do j=1,99
                if (eltmp.eq.elemnt(j)) nat(i) = j
              end do
           endif
          else
           if (ichs.ne.60) goto 100
           if (mopopt.eq.5) then
              read(string,'(7x,a2,3x,3(f16.9))',err=200)
     &        eltmp,(xyz(j,i),j=1,3)
           else
              read(string,'(14x,a2,14x,3(f10.4))',err=200)
     &        eltmp,(xyz(j,i),j=1,3)
           endif
           if (mopopt.eq.3.or.mopopt.eq.5) then
              tstr = eltmp(1:2)
              ii = ichar(tstr(2:2))
              if (ii.lt.65.or.ii.gt.122.or.(ii.lt.97.and.ii.gt.90))
     &        then
                 tstr(2:2) = tstr(1:1)
                 tstr(1:1) = ' '
              endif
              eltmp = tstr(1:2)
           endif
           do j=1,99
             if (eltmp.eq.elemnt(j)) nat(i) = j
           end do
          endif
           i = i + 1
         end do
      elseif (mopopt.eq.2) then
         do while (.true.)

           call nxtlin(string,jstat)
           if (jstat.eq.1.or.jstat.eq.2) goto 200

           ichs = ifblen(string)
           if (ichs.lt.2) goto 100
            if (ichs.lt.36) then
              read(string,'(4x,i5,3(f8.4,1x))',err=200)
     &        nat(i),(xyz(j,i),j=1,3)
              i = i + 1
            else
              read(string,'(4x,i5,3(f8.4,1x),5x,i5,2x,3(f8.4,1x))',
     &        err=200)nat(i),(xyz(j,i),j=1,3),nat(i+1),
     &        (xyz(j,i+1),j=1,3)
              i = i + 2
            endif
         end do
      endif

100   continue
      natoms = i - 1

      if (mopopt.eq.1.and.isol.eq.1) then
         call scback(line,' Tv ',istat)
         if (istat.eq.1) then
             call bckfil
             call bckfil
             do ii=1,3
               if (getlin(0).eq.1) then
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   kk = 0
                   do jj=1,6
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.3.and.kk.lt.3) then
                         kk = kk + 1
                         rr(kk,ii) = rtype
                      endif
                   end do
               endif
             end do
             nspg = 1
             a = vlen(rr(1,1))
             b = vlen(rr(1,2))
             c = vlen(rr(1,3))
             call impsc(rr(1,2),rr(1,3),csa)
             call impsc(rr(1,1),rr(1,3),csb)
             call impsc(rr(1,1),rr(1,2),csc)
             alpha = dacos(csa)*todeg
             beta = dacos(csb)*todeg
             gamma = dacos(csc)*todeg
             call prcell(nspg,a,b,c,alpha,beta,gamma)
             call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,1)
             call cprot(nspg,nopr,icent,ir,it,.false.)
             call xyzcoo(1,1,0)
             call doconn

             iatoms = natoms
             nnat = iatoms
             nstor = mxnat-iatoms
             do i=1,iatoms
                call crt2fr(xyz(1,i),coo(1,nstor+i),xa,ya,yb,za,zb,zc)
                ianz(nstor+i) = ianz(i)
                do j=1,iconn(1,i)+1
                   iconn(j,nstor+i) = iconn(j,i)
                end do
                iatclr(nstor+i) = iatclr(i)

             end do

c             call prop(nopr,ir,it)

             iftyp = 6
             ichx = 1
             call fdat(1,1,0,0,0,0)

         endif
      endif

      if (mopopt.eq.1.or.mopopt.eq.5) then
         chkesp = .false.
120      call rewfil
         if (chkesp) then
            call search(string,'ELECTROSTATIC POTENTIAL CHARGES',
     &                  istat)
         else
            call search(string,'NET ATOMIC CHARGES AND',istat)
         endif
         if (istat.eq.1) then
             ihasq = 1
             qtot = 0.0d0
             call redel(line,2)
             do i=1,natoms
                if (getlin(0).ne.1) goto 150
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.2) goto 150
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 150
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.3) goto 150
                qat(i) = rtype
                qtot = qtot + qat(i)
             end do
c             write(iun3,*) 'total charge ',qtot
         endif
         if (.not.chkesp) then
            chkesp = .true.
            goto 120
         endif
      endif

      return
150   ihasq = 0
      return

200   istats = 0
      return
      end

      integer function iatnum(str,nstr)
      parameter (mxel=100)
      character*(*) str
      character*2 catom,tolowf,elemnt
      common /elem/elemnt(mxel)

      iatnum = 100
      if (nstr.eq.1) then
          catom(1:1) = ' '
          catom(2:2) = str(1:1)
      else
          catom = str(1:2)
      endif
      do j=1,mxel
          if (tolowf(catom) .eq. tolowf(elemnt(j))) iatnum = j
      end do

      return
      end

      subroutine plini(iplot,fine,icolps)
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character esc, ff
      character*64 carray
      character line*80
      logical fine
      common /tektro/ carray, icn

      esc = char(27)
      ff = char(12)
c
c--------- plot initialisation ----------------
c
      if (iplot.eq.0) then
         write(iun4,'(a)') '.vp 0 150 0 100'
         write(iun4,'(a)') '.wn 0 1.5 0 1'
      endif

      if (iplot.eq.1) then
        line(1:1)   = esc
        line(2:3)   = '.('
        line(4:4)   = esc
        line(5:13)  = '.I81;;17:'
        line(14:14) = esc
        line(15:20) = '.N;19:'

        write(iun4,'(a)')line(1:20)
        write(iun4,'(a)')';IN;IP200,430,7400,7630;PA;' 
        write(iun4,'(a)') 'SC0,1,0,1;SL0;SR0.8,1.5;SP1;DI;'
      endif

      if (iplot.eq.2) then
c turn graphics on
        write(iun4,'(a,''*dC'')')esc
c turn alfa off
        write(iun4,'(a,''*dF'')')esc
c clear graphics
        write(iun4,'(a,''*dA'')')esc
c select solid line type
        write(iun4,'(a,''*m1b'')')esc
      endif

      if (iplot.eq.3) then
        icn=0
        carray(1:1)=' '
        write(iun4,*) esc//ff
        write(iun4,*) esc//'8'//esc//'`'
      endif

      if (iplot.eq.4.or.iplot.eq.6) then
       write(iun4,'(''%!PS-Adobe-2.0 EPSF-2.0'')')
       write(iun4,'(''%%Title: Molden'')')
       write(iun4,'(''%%For: Schaft'')')
       write(iun4,'(''%%Creator: Dr G Schaftenaar'')')
       write(iun4,'(''%%DocumentFonts: Courier'')')
       write(iun4,'(''%%Pages (atend)'')')
       write(iun4,'(''%%BoundingBox: 0 0 612 792'')')
       write(iun4,'(''%%EndComments'')')
       write(iun4,'(''%'')')
       write(iun4,'(''%###### User Preferences ############'')')
       write(iun4,'(''%'')')
       write(iun4,'(''%---- SIZE AND ORIENTATION OF THE PLOT ---'')')
       write(iun4,'(''%'')')
       write(iun4,'(''/size    {  0.24 } def'')')
       write(iun4,'(''%---- These number can be negative -------'')')
       write(iun4,'(''/originx {  39.0 } def'')')
       write(iun4,'(''/originy { 753.0 } def'')')
       write(iun4,'(''/angle   { -90.0 } def'')')
       write(iun4,'(''%For Portrait use'')')
       write(iun4,'(''%/originx { 40.0 } def'')')
       write(iun4,'(''%/originy { 240.0 } def'')')
       write(iun4,'(''%/angle   { 0.0 } def'')')
       write(iun4,'(''%and BoundingBox: 25 255 535 765'')')
       write(iun4,'(''%'')')
       write(iun4,'(''%---- COLORS FOR DENSITY CONTOURS  -------'')')
       write(iun4,'(''%'')')
       write(iun4,'(''/poscontour { 18 } def'')')
       write(iun4,'(''/negcontour { 19 } def'')')
       write(iun4,'(''%---- FILL COLORS OF DENSITY SPACE MODE  -'')')
       write(iun4,'(''/posfill { 16 } def'')')
       write(iun4,'(''/negfill { 17 } def'')')
       write(iun4,'(''%---- COLOR OF UNIT CELL DEF. BLACK -'')')
       write(iun4,'(''/cellcol { 0 setcol } def'')')
       write(iun4,'(''/labelcol { 0 setcol } def'')')
       write(iun4,'(''%/cellcol { 1 setcol } def'')')
       write(iun4,'(''%'')')
       write(iun4,'(''%---- COLORS HAVE A HUE AND SATURATION ---'')')
       write(iun4,'(''%'')')
       write(iun4,'(''/hues {[.0 .0 .17 .33 .66 .5 .12 .54 .0 '',
     + ''.83 .33 .1 .08 .15 .10 .0 .33 .1 .66 .0]} def'')')
       write(iun4,'(''/satus {[.0 .93 .95 1. .5 1. 1. .38 .0 '',
     + ''1. .9 .41 1. .6 .95 .0 .5 .7 1. 1.]} def'')')
       write(iun4,'(''%'')')
       write(iun4,'(''%---- SET BOND RENDERING:  ---------------'')')
       write(iun4,'(''%---- shadedrod, whiterod, blackrod  -----'')')
       write(iun4,'(''%'')')
       write(iun4,'(''/dorod { shadedrod } def'')')
       write(iun4,'(''%'')')
       write(iun4,'(''%---- Include Tabel & Logo, Fontsize -----'')')
       write(iun4,'(''/tabel {true} def'')')
       write(iun4,'(''/titleandlogo {true} def'')')
       write(iun4,'(''/nullcontour {false} def'')')
       write(iun4,'(''/contourvalues {false} def'')')
       write(iun4,'(''/stickwidth {8} def'')')
       write(iun4,'(''/fontwidth {27} def'')')
       write(iun4,'(''/fontheight {35} def'')')
       write(iun4,'(''/dobackground {false} def'')')
       write(iun4,'(''%'')')
       write(iun4,'(''%###### END User Preferences ########'')')
       write(iun4,'(''/hue {hues col get} def'')')
       write(iun4,'(''/satu {satus col get} def'')')
c       write(iun4,
c     +'(''/setcol {/col exch def hue satu 1.0 sethsbcolor} def'')')
       write(iun4,'(''/setcol {'')')
       write(iun4,'('' /col exch def col 0 eq'')')
       write(iun4,'('' {hue satu 0.0 sethsbcolor}'')')
       write(iun4,'('' {hue satu 1.0 sethsbcolor}'')')
       write(iun4,'(''ifelse} def'')')
       write(iun4,'(''/m { moveto } def'')')
       write(iun4,'(''/l { lineto } def'')')
       write(iun4,'(''/s { stroke } def'')')
       write(iun4,'(''/n { newpath } def'')')
       write(iun4,'(''/lc { setlinecap } def'')')
       write(iun4,'(''/offset { 0 0 moveto (A) false charpath'')')
       write(iun4,'(''flattenpath pathbbox'')')
       write(iun4,'(''pop pop pop -1 mul /xoff exch def } def'')')
       write(iun4,'(''/doatom'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  rx ry translate'')')
       if (fine) then
           write(iun4,'(''  90 -1 1'')')
       else
           write(iun4,'(''  90 -5 1'')')
       endif
       write(iun4,'(''  { gsave'')')
       if (icolps.eq.1) then
          write(iun4,
     &'(''    dup cos hue exch satu exch sethsbcolor sin dup scale'')')
       else
          write(iun4,'(''    dup cos setgray sin dup scale'')')
       endif
       write(iun4,'(''    newpath'')')
       write(iun4,'(''    0 0 rad 0 360 arc'')')
       write(iun4,'(''    closepath fill grestore } for'')')
       write(iun4,'(''    grestore } def'')')
       write(iun4,'(''/shadedrod'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  x1 y1 translate'')')
       write(iun4,'(''  x2 x1 neg add'')')
       write(iun4,'(''  y2 y1 neg add'')')
       write(iun4,'(''  {atan neg rotate} stopped not {'')')
       if (fine) then
          write(iun4,'(''  87 -3 0'')')
       else
          write(iun4,'(''  85 -5 0'')')
       endif
       write(iun4,'(''  {dup'')')
       write(iun4,'(''  gsave'')')
       write(iun4,'(''  newpath'')')
       if (icolps.eq.1) then
          write(iun4,'(''   cos 1.0 cosb 0.5 mul neg add mul'')')
          write(iun4,'(''   hue exch satu exch sethsbcolor'')')
       else
          write(iun4,
     &         '(''   cos 1.0 cosb 0.5 mul neg add mul setgray'')')
       endif
       write(iun4,'(''   sin 1.0 scale'')')
       write(iun4,'(''   1 cosb scale'')')
       write(iun4,'(''   0 0 hd 0 180 arcn'')')
       write(iun4,'(''   x2 x1 neg add dup mul'')')
       write(iun4,'(''   y2 y1 neg add dup mul'')')
       write(iun4,'(''   add sqrt'')')
       write(iun4,
     & '(''  0 cosb eq {/cosb 1.0 def} if 0 exch cosb div translate'')')
       write(iun4,'(''   0 0 hd 180 360 arc'')')
       write(iun4,'(''  closepath fill'')')
       write(iun4,'(''  grestore } for'')')
       write(iun4,'(''  } if'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/blackrod'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  x1 y1 translate'')')
       write(iun4,'(''  x2 x1 neg add'')')
       write(iun4,'(''  y2 y1 neg add'')')
       write(iun4,'(''  {atan neg rotate} stopped not {'')')
       write(iun4,'(''  newpath'')')
       write(iun4,'(''   0 setgray'')')
       write(iun4,'(''   1 cosb scale'')')
       write(iun4,'(''   0 0 hd 0 180 arcn'')')
       write(iun4,'(''   x2 x1 neg add dup mul'')')
       write(iun4,'(''   y2 y1 neg add dup mul'')')
       write(iun4,'(''   add sqrt'')')
       write(iun4,
     & '(''  0 cosb eq {/cosb 1.0 def} if 0 exch cosb div translate'')')
       write(iun4,'(''   0 0 hd 180 360 arc'')')
       write(iun4,'(''  closepath stroke'')')
       write(iun4,'(''  } if'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/whiterod'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  x1 y1 translate'')')
       write(iun4,'(''  x2 x1 neg add'')')
       write(iun4,'(''  y2 y1 neg add'')')
       write(iun4,'(''  {atan neg rotate} stopped not {'')')
       write(iun4,'(''  newpath'')')
       write(iun4,'(''   1 setgray'')')
       write(iun4,'(''   1 cosb scale'')')
       write(iun4,'(''   0 0 hd 0 180 arcn'')')
       write(iun4,'(''   x2 x1 neg add dup mul'')')
       write(iun4,'(''   y2 y1 neg add dup mul'')')
       write(iun4,'(''   add sqrt'')')
       write(iun4,
     & '(''  0 cosb eq {/cosb 1.0 def} if 0 exch cosb div translate'')')
       write(iun4,'(''   0 0 hd 180 360 arc'')')
       write(iun4,'(''  closepath stroke'')')
       write(iun4,'(''  } if'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/dobond'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  0 setlinecap'')')
       write(iun4,'(''  newpath moveto lineto'')')
       write(iun4,'(''  90 -5 5'')')
       write(iun4,
     & '(''  { gsave dup cos hue exch satu exch sethsbcolor'')')
       write(iun4,'(''    sin 23 mul setlinewidth'')')
       write(iun4,'(''    stroke grestore } for'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/dobond2'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  1 setlinecap'')')
       write(iun4,'(''  2 setlinejoin'')')
       write(iun4,'(''  newpath moveto lineto lineto'')')
       write(iun4,'(''  90 -5 5'')')
       write(iun4,
     & '(''  { gsave dup cos hue exch satu exch sethsbcolor'')')
       write(iun4,'(''    sin 23 mul setlinewidth'')')
       write(iun4,'(''    stroke grestore } for'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/doshadedstick'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  stickwidth setlinewidth'')')
       write(iun4,'(''  1 setlinecap'')')
       write(iun4,'(''  2 setlinejoin'')')
       if (icolps.eq.1) then
          write(iun4,'(''   1.0 cosb 0.8 mul neg add '')')
          write(iun4,'(''   hue exch satu exch sethsbcolor'')')
       else
          write(iun4,
     &         '(''   1.0 cosb 0.8 mul neg add setgray'')')
       endif
       write(iun4,'(''  newpath'')')
       write(iun4,'(''  x1 y1 moveto'')')
       write(iun4,'(''  x2 y2 lineto'')')
       write(iun4,'(''  stroke'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/dostick'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  stickwidth setlinewidth'')')
       write(iun4,'(''  1 setlinecap'')')
       write(iun4,'(''  2 setlinejoin'')')
       write(iun4,'(''  newpath'')')
       write(iun4,'(''  x1 y1 moveto'')')
       write(iun4,'(''  x2 y2 lineto'')')
       write(iun4,'(''  stroke'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/dobg'')')
       write(iun4,'(''{ gsave'')')
       write(iun4,'(''  setgray'')')
       write(iun4,'(''  newpath'')')
       write(iun4,'(''  0 0 m 2000 0 l 2000 2000 l 0 2000 l'')')
       write(iun4,'(''  closepath fill'')')
       write(iun4,'(''  grestore } def'')')
       write(iun4,'(''/Helvetica-Bold findfont '',
     + ''[ fontwidth   0   0  fontheight   0   0] makefont setfont'')')
       write(iun4,'(''originx originy translate'')')
       write(iun4,'(''angle rotate'')')
       write(iun4,'(''   3 setlinewidth'')')
       write(iun4,'(''2 setlinecap'')')
       write(iun4,'(''size size scale'')')
       write(iun4,'(''%%EndProlog'')')
       write(iun4,'(''%%Page: ? 1'')')
       write(iun4,'(''dobackground {0.5 dobg} if'')')
       write(iun4,'(''n'')')
      endif

      return
      end

      subroutine gtipar(istat,iat,iti,trsi1,trsi2,itorl,ityp)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxamb=1590)
      parameter (mxitor=42)
      integer*2 ityp
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /itrpar/ tori1(2,mxitor),tori2(2,mxitor),
     &                itrcon(4,mxitor)
      parameter (mxgitr=42)
      integer gficon
      common /gfipar/ gftri1(2,mxgitr),gftri2(2,mxgitr),
     &                gficon(4,mxgitr)

      logical doamb, dogaff
      save isq
      dimension iat(4),icls(4),iti(4),trsi1(4),trsi2(4),isq(3,6),
     &          it(4),itb(4),ityp(*)
      data isq / 1,2,4, 1,4,2, 2,1,4, 4,1,2, 2,4,1, 4,2,1/

      todeg = 45.0e0 / atan(1.0e0)
      wght6 = dble(1)/dble(6)
      doamb = .false.
      dogaff = .false.
      istat = 0

      i1 = int(ityp(iat(1)))
      i2 = int(ityp(iat(2)))
      i3 = int(ityp(iat(3)))
      i4 = int(ityp(iat(4)))

      if (i1.gt.0 .and. i2.gt.0 .and. i3.gt.0 .and. i4.gt.0) then
         doamb = .true.
      elseif (i1.lt.0 .or. i2.lt.0 .or. i3.lt.0 .or. i4.lt.0) then
         dogaff = .true.
      endif

      if (doamb) then

            do j=1,4
               icls(j) = ambcls(ityp(iat(j)))
            end do
               
            do j = 1, mxitor

               if (icls(3).eq.itrcon(3,j)) then

                  do k=1,6

                     if (icls(isq(1,k)).eq.itrcon(1,j).and.
     &                   icls(isq(2,k)).eq.itrcon(2,j).and.
     &                   icls(isq(3,k)).eq.itrcon(4,j)) then


                           istat = 1
                           iti(1) = iat(isq(1,k))
                           iti(2) = iat(isq(2,k))
                           iti(3) = iat(3)
                           iti(4) = iat(isq(3,k))
                 
                           trsi1(1) = tori1(1,j)
                           trsi1(2) = tori1(2,j)
                           angl = tori1(2,j) / todeg
                           trsi1(3) = cos(angl)
                           trsi1(4) = sin(angl)

                           trsi2(1) = tori2(1,j)
                           trsi2(2) = tori2(2,j)
                           angl = tori2(2,j) / todeg
                           trsi2(3) = cos(angl)
                           trsi2(4) = sin(angl)

                     end if

                  end do

               end if

            end do

      endif

      if (dogaff) then

          do j=1,4
             if (ityp(iat(j)).gt.0) then
                itb(j) = mapagf(ambcls(ityp(iat(j))))
             else
                itb(j) = iabs(int(ityp(iat(j))))
             endif
          end do

          do j=1,4
             it(j) = itb(j)
          end do

          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

c try one X, in all permutations

          do j=1,4
             it(j) = itb(j)
          end do
          it(1) = 1
          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

          do j=1,4
             it(j) = itb(j)
          end do
          it(2) = 1
          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

          do j=1,4
             it(j) = itb(j)
          end do
          it(4) = 1
          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

c try two X's, in all permutations

          do j=1,4
             it(j) = itb(j)
          end do
          it(1) = 1
          it(2) = 1
          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

          do j=1,4
             it(j) = itb(j)
          end do
          it(1) = 1
          it(4) = 1
          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

          do j=1,4
             it(j) = itb(j)
          end do
          it(2) = 1
          it(4) = 1
          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

c try three X's

          do j=1,4
             it(j) = itb(j)
          end do

          it(1) = 1
          it(2) = 1
          it(4) = 1

          call gtgfi(istat1,isq,iat,it,iti,trsi1,trsi2,itorl,ityp)
          if (istat1.ne.0) then
              istat = 1
              return
          endif

      endif

      return
      end

      subroutine gtgfi(istat,isq,iat,it,iti,trsi1,trsi2,itor,ityp)
      implicit real (a-h,o-z), integer (i-n)
      integer*2 ityp
      parameter (mxgitr=42)
      integer gficon
      common /gfipar/ gftri1(2,mxgitr),gftri2(2,mxgitr),
     &                gficon(4,mxgitr)

      dimension iat(4),icls(4),iti(4),trsi1(4),trsi2(4),isq(3,6),
     &          it(4),ityp(*)

      todeg = 45.0e0 / atan(1.0e0)
      istat = 0

      do j = 1, mxgitr

         if (it(3).eq.gficon(3,j)) then

            do k=1,6

               if (it(isq(1,k)).eq.gficon(1,j).and.
     &             it(isq(2,k)).eq.gficon(2,j).and.
     &             it(isq(3,k)).eq.gficon(4,j)) then


                     istat = 1
                     iti(1) = iat(isq(1,k))
                     iti(2) = iat(isq(2,k))
                     iti(3) = iat(3)
                     iti(4) = iat(isq(3,k))
                 
                     itor   = j
                     trsi1(1) = gftri1(1,j) 
                     trsi1(2) = gftri1(2,j)
                     angl = gftri1(2,j) / todeg
                     trsi1(3) = cos(angl)
                     trsi1(4) = sin(angl)

                     trsi2(1) = gftri2(1,j)
                     trsi2(2) = gftri2(2,j)
                     angl = gftri2(2,j) / todeg
                     trsi2(3) = cos(angl)
                     trsi2(4) = sin(angl)

               end if

            end do

         end if

      end do

      return
      end

      subroutine itrard(istat,mxitrs,
     &                  nti,iti,trsi1,trsi2,imptor,
     &                  iconn,ityp,iopt)

      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)

      common /athlp/  iatoms, mxnat
      integer*2 ityp
      dimension iconn(mxcon+1,*),ityp(*),iopt(*),
     &          iti(4,*),trsi1(4,*),trsi2(4,*),
     &          iat(4),icnn(mxcon)
      dimension itit(4),trsi1t(4),trsi2t(4),imptor(*)
      
      istat = 1
      nti = 0

      do i=1,iatoms

         ncnn = 0
         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               ncnn = ncnn + 1
               icnn(ncnn) = jj
            endif
         end do
         
         if (ncnn.eq.3) then

            iat(1)  = icnn(1)
            iat(2)  = icnn(2)
            iat(3)  = i
            iat(4)  = icnn(3)

            ido = 0
            do j=1,4
               if (iopt(iabs(iat(j))).eq.1) ido = 1
            end do

            call gtipar(istat,iat,itit,trsi1t,trsi2t,itorl,ityp)

            if (istat.eq.1.and.ido.eq.1) then

               nti = nti + 1
               if (nti.lt.mxitrs) then
                  imptor(nti) = itorl
                  do j=1,4
                     iti(j,nti) = itit(j)
                     trsi1(j,nti) = trsi1t(j)
                     trsi2(j,nti) = trsi2t(j)
                  end do
               else

                  istat = 0
                  return

               endif

            endif

         end if

      end do

      return
      end 

      subroutine gttpar(istat,iat,it,trs1,trs2,trs3,trs4,itor,ityp)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      integer*2 ityp
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      parameter (mxtor=351)
      integer torcon
      common /torpar/ tor1(2,mxtor),tor2(2,mxtor),
     &                tor3(2,mxtor),tor4(2,mxtor),
     &                torcon(4,mxtor)
      parameter (mxgtor=638)
      integer gftcon
      common /gftpar/ gftor1(2,mxgtor),gftor2(2,mxgtor),
     &                gftor3(2,mxgtor),gftor4(2,mxgtor),
     &                gftcon(4,mxgtor)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      character*3 ambstr
      character*2 gffstr
      common /ffstr/  ambstr(mxamb), gffstr(mxgff)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5

      logical doamb, dogaff, first
      dimension iat(4),it(4),trs1(4),trs2(4),trs3(4),trs4(4),
     &          ityp(*)

      todeg = 45.0e0 / atan(1.0e0)
      doamb = .false.
      dogaff = .false.
      first = .true.
      istat = 0

      i1 = int(ityp(iat(1)))
      i2 = int(ityp(iat(2)))
      i3 = int(ityp(iat(3)))
      i4 = int(ityp(iat(4)))

      if (i1.gt.0 .and. i2.gt.0 .and. i3.gt.0 .and. i4.gt.0) then
         doamb = .true.
      elseif (i1.lt.0 .or. i2.lt.0 .or. i3.lt.0 .or. i4.lt.0) then
         dogaff = .true.
      endif

      it(1) = iat(1)
      it(2) = iat(2)
      it(3) = iat(3)
      it(4) = iat(4)

      if (doamb) then
          ita = ambcls(i1)
          itb = ambcls(i2)
          itc = ambcls(i3)
          itd = ambcls(i4)
      endif
      
      if (dogaff) then

         if (i1.gt.0) then
            ita = mapagf(ambcls(i1))
         else
            ita = iabs(i1)
            if (ita.eq.72) ita = 6
         endif
         if (i2.gt.0) then
            itb = mapagf(ambcls(i2))
         else
            itb = iabs(i2)
            if (itb.eq.72) itb = 6
         endif
         if (i3.gt.0) then
            itc = mapagf(ambcls(i3))
         else
            itc = iabs(i3)
            if (itc.eq.72) itc = 6
         endif
         if (i4.gt.0) then
            itd = mapagf(ambcls(i4))
         else
            itd = iabs(i4)
            if (itd.eq.72) itd = 6
         endif
      endif

      if (itb.lt.itc) then
         it1 = ita
         it2 = itb
         it3 = itc
         it4 = itd
      elseif (itc.lt.itb) then
         it1 = itd
         it2 = itc
         it3 = itb
         it4 = ita
      elseif (ita.le.itd) then
         it1 = ita
         it2 = itb
         it3 = itc
         it4 = itd
      elseif (itd.lt.ita) then
         it1 = itd
         it2 = itc
         it3 = itb
         it4 = ita
      endif

      if (doamb) then

10        continue

          do l=1,mxtor
             if (torcon(1,l).eq.it1.and.
     &           torcon(2,l).eq.it2.and.
     &           torcon(3,l).eq.it3.and.
     &           torcon(4,l).eq.it4) then

                 istat = 1
                 trs1(1) = tor1(1,l)
                 trs1(2) = tor1(2,l)
                 angl = tor1(2,l) / todeg
                 trs1(3) = cos(angl)
                 trs1(4) = sin(angl)

                 trs2(1) = tor2(1,l)
                 trs2(2) = tor2(2,l)
                 angl = tor2(2,l) / todeg
                 trs2(3) = cos(angl)
                 trs2(4) = sin(angl)

                 trs3(1) = tor3(1,l)
                 trs3(2) = tor3(2,l)
                 angl = tor3(2,l) / todeg
                 trs3(3) = cos(angl)
                 trs3(4) = sin(angl)

                 trs4(1) = tor4(1,l)
                 trs4(2) = tor4(2,l)
                 angl = tor4(2,l) / todeg
                 trs4(3) = cos(angl)
                 trs4(4) = sin(angl)

             endif
          end do

          if (istat.eq.0.and.it2.eq.it3.and.first) then
             itmp = it1
             it1 = it4
             it4 = itmp
             first = .false.
             goto 10
          endif

          if (istat.eq.0.and.(i1.ge.1254.and.i2.ge.1254)
     &        .and.(i3.ge.1254.and.i3.ge.1254)) then
             ita = amb2gf(i1)
             itb = amb2gf(i2)
             itc = amb2gf(i3)
             itd = amb2gf(i4)

             if (itb.lt.itc) then
                it1 = ita
                it2 = itb
                it3 = itc
                it4 = itd
             elseif (itc.lt.itb) then
                it1 = itd
                it2 = itc
                it3 = itb
                it4 = ita
             elseif (ita.le.itd) then
                it1 = ita
                it2 = itb
                it3 = itc
                it4 = itd
             elseif (itd.lt.ita) then
                it1 = itd
                it2 = itc
                it3 = itb
                it4 = ita
             endif

             first = .true.
             dogaff = .true.
          endif

      endif

      if (dogaff) then

100       continue

          do l=1,mxgtor
             if (gftcon(1,l).eq.it1.and.
     &           gftcon(2,l).eq.it2.and.
     &           gftcon(3,l).eq.it3.and.
     &           gftcon(4,l).eq.it4) then

                 istat = 1
                 itor = l
                 trs1(1) = gftor1(1,l)
                 trs1(2) = gftor1(2,l)
                 angl = gftor1(2,l) / todeg
                 trs1(3) = cos(angl)
                 trs1(4) = sin(angl)

                 trs2(1) = gftor2(1,l)
                 trs2(2) = gftor2(2,l)
                 angl = gftor2(2,l) / todeg
                 trs2(3) = cos(angl)
                 trs2(4) = sin(angl)

                 trs3(1) = gftor3(1,l)
                 trs3(2) = gftor3(2,l)
                 angl = gftor3(2,l) / todeg
                 trs3(3) = cos(angl)
                 trs3(4) = sin(angl)

                 trs4(1) = gftor4(1,l)
                 trs4(2) = gftor4(2,l)
                 angl = gftor4(2,l) / todeg
                 trs4(3) = cos(angl)
                 trs4(4) = sin(angl)

             endif
          end do

          if (istat.eq.0.and.first) then
             it1 = 1
             it4 = 1
             first = .false.
             goto 100
          endif
      endif

      if (istat.eq.0) then
         if (doamb) then
            write(iun5,'(a,4(i4,1x),a,4(a3,1x),a,4(i4,1x))') 'atom ',
     &         it(1),it(2),it(3),it(4),' type ',
     &         ambstr(i1),ambstr(i2),ambstr(i3),ambstr(i4),
     &         ' class ',ita,itb,itc,itd
         endif
         if (dogaff) then
            write(iun5,'(4(i4,1x),4(a2,1x))') 
     &         it(1),it(2),it(3),it(4),
     &         gffstr(ita),gffstr(itb),gffstr(itc),gffstr(itd)
         endif
      endif

      return
      end

      subroutine torard(istat,maxtors,
     &                  nbnd,ibnd,
     &                  nt,it,trs1,trs2,trs3,trs4,itor,
     &                  iconn,ityp,iopt)

      implicit real (a-h,o-z), integer (i-n)

      parameter (mxcon=10)
      parameter (mxamb=1590)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxtor=351)
      integer torcon
      common /torpar/ tor1(2,mxtor),tor2(2,mxtor),
     &                tor3(2,mxtor),tor4(2,mxtor),
     &                torcon(4,mxtor)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      integer*2 ityp
      dimension ibnd(2,*),iconn(mxcon+1,*),ityp(*),iopt(*),itor(*),
     &          it(4,*),trs1(4,*),trs2(4,*),trs3(4,*),trs4(4,*),
     &          itt(4),trs1t(4),trs2t(4),trs3t(4),trs4t(4),iat(4)

      todeg = 45.0e0 / atan(1.0e0)
      istat = 1
      nt = 0

      do i=1,nbnd
         iat(2) = ibnd(1,i)
         iat(3) = ibnd(2,i)

         do j=1,iconn(1,iat(2))
            iat(1) = iconn(1+j,iat(2))
            if (iat(1).gt.0.and.iat(1).ne.iat(3)) then

               do k=1,iconn(1,iat(3))
                  iat(4) = iconn(1+k,iat(3))

                  if (iat(4).gt.0.and.
     &               (iat(4).ne.iat(2).and.iat(4).ne.iat(1))) then

                     ido = 0
                     do l=1,4
                        if (iopt(iabs(iat(l))).eq.1) ido = 1
                     end do

                     call gttpar(istat,
     &                     iat,itt,trs1t,trs2t,trs3t,trs4t,itorl,ityp)

                     if (istat.eq.1.and.ido.eq.1) then
                        nt = nt + 1
                        if (nt.lt.maxtors) then
                           itor(nt) = itorl
                           do l=1,4
                              it(l,nt)   = itt(l)
                              trs1(l,nt) = trs1t(l)
                              trs2(l,nt) = trs2t(l)
                              trs3(l,nt) = trs3t(l)
                              trs4(l,nt) = trs4t(l)
                           end do

                        else

                           istat = 0
                           return

                        endif
                     else
                        write(iun5,*) 'torsion parameter not found'
                     endif

                  endif

               end do

            endif

         end do

      end do

      return
      end

      subroutine prttod(istat,maxtors,
     &                  nt,it,trs1,trs2,trs3,trs4,
     &                  iconn,ityp,iopt)

      implicit real (a-h,o-z), integer (i-n)

      parameter (mxcon=10)
      parameter (mxamb=1590)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      integer*2 ityp
      dimension iconn(mxcon+1,*),ityp(*),iopt(*),
     &          it(4,*),trs1(4,*),trs2(4,*),trs3(4,*),trs4(4,*)

      print*,''
      print*,'Torsion parameters:'
      print*,''

      do i=1,nt
         print*,'it ',(it(l,i),l=1,4)
         print*,' trs1 ',(trs1(l,i),l=1,4)
         print*,' trs2 ',(trs2(l,i),l=1,4)
         print*,' trs3 ',(trs3(l,i),l=1,4)
         print*,' trs4 ',(trs4(l,i),l=1,4)
      end do

      print*,''

      return
      end

      subroutine pritod(istat,mxitrs,
     &                  nti,iti,trsi1,trsi2,
     &                  iconn,ityp,iopt)

      implicit real (a-h,o-z), integer (i-n)

      parameter (mxcon=10)
      parameter (mxamb=1590)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      integer*2 ityp
      dimension iconn(mxcon+1,*),ityp(*),iopt(*),
     &          iti(4,*),trsi1(4,*),trsi2(4,*)

      print*,''
      print*,'Impromper Torsion parameters:'
      print*,''

      do i=1,nti
         print*,'iti ',(iti(l,i),l=1,4)
         print*,' trsi1 ',(trsi1(l,i),l=1,4)
         print*,' trsi2 ',(trsi2(l,i),l=1,4)
      end do

      print*,''

      return
      end

      subroutine tors(et,idoimp,
     &                nt,it,trs1,trs2,trs3,trs4,
     &                nti,iti,trsi1,trsi2,
     &                coo,forces)

      implicit real (a-h,o-z), integer (i-n)

      common /athlp/  iatoms, mxnat

      dimension cosna(4),sinna(4),v(4),sa(4),ca(4),phi(4),dphi(4)
      dimension va(3),vb(3),vc(3),vd(3),vba(3),vcb(3),vdc(3)
      dimension vca(3),vdb(3),vt(3),vu(3),vtu(3),dedt(3),dedu(3)
      dimension deda(3),dedb(3),dedc(3),dedd(3),vtmp1(3),vtmp2(3)

      dimension coo(3,*),forces(3,*)
      dimension iti(4,*),trsi1(4,*),trsi2(4,*)
      dimension it(4,*),trs1(4,*),trs2(4,*),trs3(4,*),trs4(4,*)

      todeg = 45.0e0 / atan(1.0e0)
      et = 0.0e0

      if (idoimp.eq.1) then
         ntor = nti
         nterms = 2
      else
         ntor = nt
         nterms = 4
      endif

      do i =1,ntor
            if (idoimp.eq.1) then
               ia = iti(1,i)
               ib = iti(2,i)
               ic = iti(3,i)
               id = iti(4,i)
            else
               ia = it(1,i)
               ib = it(2,i)
               ic = it(3,i)
               id = it(4,i)
            endif

c coordinates of atoms a,b,c,d
            do j=1,3
              va(j) = coo(j,ia)
              vb(j) = coo(j,ib)
              vc(j) = coo(j,ic)
              vd(j) = coo(j,id)
            end do

c vectors ba, cb, dc, ca, db

            call vsub(vb,va,vba,3)
            call vsub(vc,vb,vcb,3)
            call vsub(vd,vc,vdc,3)
            call vsub(vc,va,vca,3)
            call vsub(vd,vb,vdb,3)

c t outvector ba x cb, u outvector cb x dc

            call crprod(vba,vcb,vt)
            call crprod(vcb,vdc,vu)

c tu outvector t x u

            call crprod(vt,vu,vtu)


            rt2 = vt(1)*vt(1) + vt(2)*vt(2) + vt(3)*vt(3)
            ru2 = vu(1)*vu(1) + vu(2)*vu(2) + vu(3)*vu(3)

            rtru = vlen(vu)*vlen(vt)

            if (rtru .ne. 0.0e0) then

               rcb = vlen(vcb)

c improduct t.u /|t||u| , cosine of angle  between t and u

               call impsc(vt,vu,cosna(1))

c improduct cb.tu /|cb||t||u|, this is mainly for the sign

               call timpsc(vcb,vtu,sinna(1))
               sinna(1) = sinna(1) / (rcb*rtru)

c torsional parameters 

               if (idoimp.eq.1) then

                  v (1) = trsi1(1,i)
                  ca(1) = trsi1(3,i)
                  sa(1) = trsi1(4,i)

                  v (2) = trsi2(1,i)
                  ca(2) = trsi2(3,i)
                  sa(2) = trsi2(4,i)

               else

                  v (1) = trs1(1,i)
                  ca(1) = trs1(3,i)
                  sa(1) = trs1(4,i)

                  v (2) = trs2(1,i)
                  ca(2) = trs2(3,i)
                  sa(2) = trs2(4,i)

                  v (3) = trs3(1,i)
                  ca(3) = trs3(3,i)
                  sa(3) = trs3(4,i)

                  v (4) = trs4(1,i)
                  ca(4) = trs4(3,i)
                  sa(4) = trs4(4,i)

               endif

c knowing    cos(1*angle) and sin(1*angle)
c calculate  cos(2*angle) and sin(2*angle) etc.
c
c cos(2*angle) = cos(angle+angle) = 
c                cos(angle)*cos(angle) - sin(angle)*sin(angle)
c
c cos(2*angle) = cos(angle)*cos(angle) - sin(angle)*sin(angle)
c sin(2*angle) = cos(angle)*sin(angle) + cos(angle)*sin(angle)

               do j=1,nterms-1
                  cosna(j+1) = cosna(1)*cosna(j) - sinna(1)*sinna(j)
                  sinna(j+1) = cosna(1)*sinna(j) + sinna(1)*cosna(j)
               end do

c Etors = sum n=1,nterms Vn*[1 + cos(n*angle-SHIFTANGLEn]
c parameters Vn and SHIFTANGLEn

c cos(alpha-beta) = cos(alpha)*cos(beta) + sin(alpha)*sin(beta)
c alpha=n*angle, beta = SHIFTANGLEn, 
c cos(SHIFTANGLEn) and sin(SHIFTANGLEn) stored in ca(n) and sa(n)

               do j=1,nterms
                  phi(j)  = 1.0e0 + (cosna(j)*ca(j) + sinna(j)*sa(j))
               end do

               do j=1,nterms
                  dphi(j) = dble(j)*(cosna(j)*sa(j) - sinna(j)*ca(j))
               end do

               e      = 0.0e0
               detor  = 0.0e0

               do j=1,nterms
                   e     = e     + v(j)*phi(j)
                   detor = detor + v(j)*dphi(j)
               end do

c detor -> u and t: du, dt
c detor * (t x cb) / |t| |cb|

               call crprod(vt,vcb,dedt)
               s = detor / (rt2*rcb)
               call vscal(dedt,3,s)

c detor * (u x cb) / |u| |cb|

               call crprod(vu,vcb,dedu)
               s = -detor / (ru2*rcb)
               call vscal(dedu,3,s)

c outvector cb x dt


               call crprod(vcb,dedt,deda)
               call vscal(deda,3,-1.0e0)

c outvector ca x dt + outvector dc x du

               call crprod(vca,dedt,vtmp1)
               call crprod(vdc,dedu,vtmp2)
               call vsub(vtmp1,vtmp2,dedb,3)

c outvector ba x dt + outvector db x du

               call crprod(vba,dedt,vtmp1)
               call crprod(vdb,dedu,vtmp2)
               call vsub(vtmp2,vtmp1,dedc,3)

c outvector cb x du

               call crprod(vcb,dedu,dedd)
               call vscal(dedd,3,-1.0e0)

c               if (idoimp.eq.0) 
c     &         write(6,'(i4,a,4(i3,a),f9.3,a,12f9.3)') 
c     &               i,' ',ia,' ',ib,' ',ic,' ',id,' ',e,' ded ',
c     &               (deda(j),j=1,3),(dedb(j),j=1,3),
c     &               (dedc(j),j=1,3),(dedd(j),j=1,3)
               

               et = et + e

               do j=1,3
                  forces(j,ia) = forces(j,ia) + deda(j)
                  forces(j,ib) = forces(j,ib) + dedb(j)
                  forces(j,ic) = forces(j,ic) + dedc(j)
                  forces(j,id) = forces(j,id) + dedd(j)
               end do

            end if
      end do

      return
      end

      logical function obin(line)
      implicit double precision (a-h,o-z)
      character line*(*)

      obin = .false.
      jmin = 256
      jmax = 0
      nbin = 0
      ncr = 0

      do j=1,len(line)
         k = ichar(line(j:j))
         if (k.gt.jmax.and.k.ne.9.and.k.ne.27) jmax = k
         if (k.lt.jmin.and.k.ne.9.and.k.ne.27) jmin = k
         if (k.gt.126.or.k.lt.32) nbin = nbin + 1
         if (k.eq.13) ncr = ncr + 1
      end do
           
      if (jmax.gt.126.or.jmin.lt.32) then
         if (ncr.ne.nbin) obin = .true.
      endif

      return
      end

      logical function odos(fniun)
      implicit double precision (a-h,o-z)
      character*(*) fniun
      integer*1 k ,kr
      dimension kr(800)

      odos = .false.

      close(48)
      open(unit=48,form='unformatted',file=fniun
     &     ,status='old',err=1000)

      rewind(48)

      jmin = 256
      jmax = 0
      nbin = 0
      ncr = 0
      ncrlf = 0

      do i=1,800
         kr(i) = 0
      end do

      read(48,end=10,err=100) kr

10    continue

      do j=1,800
         k = kr(j)
         if (k.gt.jmax.and.k.ne.9.and.k.ne.27) jmax = k
         if (k.lt.jmin.and.k.ne.9.and.k.ne.27) jmin = k
         if (k.gt.126.or.k.lt.32) nbin = nbin + 1
         if (k.eq.13) ncr = ncr + 1
         if (k.eq.10.and.ko.eq.1) ncrlf = ncrlf + 1
         ko = 0
         if (k.eq.13) ko = 1
      end do
           
100   close(48)
      if (jmax.gt.126.or.jmin.lt.32) then
         if (ncrlf.gt.0) odos = .true.
      endif

1000  continue
      return
      end

      subroutine search(line,name,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name
      character*137 caps

      istat = 0
      caps  = name  
      len1  = len(name)
      call tocap(caps,len1)
1     call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200
      if (index(line,name).eq.0.and.index(line,caps(1:len1)).eq.0)
     &  go to 1
c
      istat=1
      return
100   call rewfil
      return
200   continue
      return
c
c
      end 

      subroutine srclit(line,name,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name
      character*80 caps

      istat = 0
      caps  = name  
      len1  = len(name)
      call tocap(caps,len1)
1     call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200
      if (index(line,name).ne.1.and.index(line,caps(1:len1)).ne.1)
     &  go to 1
c
      istat=1
      return
100   call rewfil
      return
200   continue
      return
c
c
      end 

      integer function icdex(line,name)
      character*(*) line,name
      character*80 caps
      character*137 cline

      il1 = len(line)
      if (il1.gt.137) il1 = 137
      il2 = len(name)
      if (il2.gt.80) il2 = 80

      cline(1:il1) = line
      caps(1:il2) = name
      call tocap(cline,il1)
      call tocap(caps,il2)

      icdex = index(cline(1:il1),caps(1:il2))

      return
      end

      subroutine leftj(line,name)
      character*(*) line,name

      name = line
      len1  = len(line)

      nsp = 0
      do i=1,len1
         if (ichar(name(i:i)).ne.32) then
            nsp = i
            goto 10
         endif
      end do

10    continue

      if (nsp.ne.0) then
         name = name(nsp:len1)
      endif

      return
      end

      subroutine searchu(line,name,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name
      character*80 caps
      character*137 caps2

      istat = 0
      caps  = name  
      len1  = len(name)
      call tocap(caps,len1)
1     call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200
      caps2 = line
      len2 = len(line)
      call tocap(caps2,len2)
      if (index(caps2(1:len2),caps(1:len1)).eq.0) goto 1
c
      istat=1
      return
100   call rewfil
      return
200   continue
      return
c
c
      end 

      subroutine silld(const,npts,dens)
      implicit real (a-h,o-z)

c THIS IS REALLY silly

      double precision dens,const
      common /sgcon/ vec1(3,12800),vec2(3,12800),vec3(3,12800),
     &          vnorm(3,12800),npol
      dimension dens(*)

c     a grid of n*n points has n-1*n-1 squares
c     and twice as much triangular polygons
c     so 2*(npts-1)**2
c     npts is 80 at maximum so lets make it 12800
      ij=0
      noff=npts/2+1
      rpts=float(npts-1)
      do 100 i=1,npts-1
      do 100 j=1,npts-1
         ij=ij+1
c        first triangle
         vec1(1,ij)=float(j-noff)
         vec1(2,ij)=float(i-noff)
         vec1(3,ij)=sngl(dens(j+(i-1)*npts)*const)*rpts
         vec2(1,ij)=float(j+1-noff)
         vec2(2,ij)=float(i-noff)
         vec2(3,ij)=sngl(dens(j+1+(i-1)*npts)*const)*rpts
         vec3(1,ij)=float(j-noff)
         vec3(2,ij)=float(i+1-noff)
         vec3(3,ij)=sngl(dens(j+i*npts)*const)*rpts
         call crpsin(vec1(1,ij),vec2(1,ij),vec3(1,ij),vnorm(1,ij))
c        second triangle
         ij=ij+1
         vec1(1,ij)=float(j+1-noff)
         vec1(2,ij)=float(i-noff)
         vec1(3,ij)=sngl(dens(j+1+(i-1)*npts)*const)*rpts
         vec2(1,ij)=float(j+1-noff)
         vec2(2,ij)=float(i+1-noff)
         vec2(3,ij)=sngl(dens(j+1+i*npts)*const)*rpts
         vec3(1,ij)=float(j-noff)
         vec3(2,ij)=float(i+1-noff)
         vec3(3,ij)=sngl(dens(j+i*npts)*const)*rpts
         call crpsin(vec1(1,ij),vec2(1,ij),vec3(1,ij),vnorm(1,ij))
100   continue
      npol=ij
      call sgdisp
      return
      end
      subroutine crpsin(a,b,c,d)
c
c       calculates cross product:  (b-a) x (c-a) = d
c                                   ---     ---    -
      implicit real (a-h,o-z)
      dimension a(3),b(3),c(3),d(3)
      dimension v1(3),v2(3)
      do 10 i=1,3
         v1(i)=b(i)-a(i)
         v2(i)=c(i)-a(i)
10    continue
c
      d(1)=v2(2)*v1(3)-v2(3)*v1(2)
      d(2)=v2(3)*v1(1)-v2(1)*v1(3)
      d(3)=v2(1)*v1(2)-v2(2)*v1(1)
      dlen=sqrt(d(1)**2+d(2)**2+d(3)**2)
      do 20 i=1,3
20       d(i)=d(i)/dlen
      return
      end
      subroutine sgdisp
#include <gl/fgl.h>
#include <gl/fdevice.h>
      integer*4 iang,jang,kang
      dimension amat(15),alt(10),al(12),bmat(15),umat(4,4)
      data amat/ambien,.1,.1,.1,diffus,.200,.369,.065,
     &          specul,.5,.5,.5,shinin,30.0,lmnull/
      data bmat/ambien,.0,.0,.0,diffus,.0,.0,.0,
     &          specul,.0,.0,.0,shinin,.0,lmnull/
      data umat/1.0,0.0,0.0,0.0,
     &          0.0,1.0,0.0,0.0,
     &          0.0,0.0,1.0,0.0,
     &          0.0,0.0,0.0,1.0/
      data alt/lcolor,.8,1.0,.8,positi,2.,2.,2.,1.,lmnull/
      data al/ambien,.4,.1,.1,localv,0,twosid,1,attenu,.5,.1,lmnull/
c      data al/ambien,.1,.1,.1,localv,0.,twosid,0.,lmnull/
      call prefpo(0,1500,0,1200)
      call winope("molden",6)
      call zbuffe(.true.)
      call double
      call rgbmod
      call gconfi
      call mmode(mviewi)
      call loadma(umat)
      call ortho(-40.0,40.0,-40.0,40.0,-40.0,40.0)
      call lmdef(defmat,1,0,amat)
      call lmdef(deflig,2,0,alt)
      call lmdef(deflmo,3,0,al)
      call lmbind(materi,1)
c      call lmbind(backma,1)
      call lmbind(light0,2)
      call lmbind(lmodel,3)
      iang=0
      jang=0
      kang=0
      do 100 i=0,1000
         call pushma 
         call rotate(iang,'x')
         call rotate(jang,'y')
         call rotate(kang,'z')
         iang=iang+10
         jang=jang+13
         if(iang+jang.gt.3000)kang=kang+17
         if(iang.gt.3600) iang=iang-3600
         if(jang.gt.3600) jang=jang-3600
         if(kang.gt.3600) kang=kang-3600
         call cpack($0)
         call clear
         call zclear
         call drawsf
         call swapbu
         call popmat
100   continue
      return
      end
      subroutine drawsf
#include <gl/fgl.h>
#include <gl/fdevice.h>
      common /sgcon/ vec1(3,12800),vec2(3,12800),vec3(3,12800),
     &          vnorm(3,12800),npol
      do 100 i=1,npol
      call bgnpol
         call n3f(vnorm(1,i))
         call v3f(vec1(1,i))
         call v3f(vec2(1,i))
         call v3f(vec3(1,i))
      call endpol
100   continue
      return
      end

      subroutine gtapar(istat,swap,tryabc,i1,i2,i3,al,ak)
      implicit real (a-h,o-z), integer (i-n)
      integer*2 i1,i2,i3
      parameter (mxamb=1590)
      integer ambcls,angcon,gfacon
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      parameter (mxang=199)
      common /angpar/ ang(2,mxang),angcon(3,mxang)
      parameter (mxgff=72)
      parameter (mxgang=3506)
      common /gfapar/ gfang(2,mxgang),angint(2,mxgff),
     &                gfacon(3,mxgang)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      character*3 ambstr
      character*2 gffstr
      common /ffstr/  ambstr(mxamb), gffstr(mxgff)
      parameter (mxcor=42)
      common /corr/   iatcor(2,mxcor)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      logical swap, tryabc, doamb, dogaff
      logical docora, docorb, docorc, docrab, docrbc, docrac,
     &        docabc, doinit
      
      istat = 0
      doamb = .false.
      dogaff = .false.

      docora = .true.
      docorb = .true.
      docorc = .true.
      docrab = .true.
      docrbc = .true.
      docrac = .true.
      docabc = .true.
      doinit = .true.

      if (i1.gt.0 .and. i2.gt.0 .and. i3.gt.0) then
         doamb = .true.
      elseif (i1.lt.0 .or. i2.lt.0 .or.i3.lt.0) then
         dogaff = .true.
      endif

      if (doamb) then
         if (swap) then
            iac = ambcls(i1)
            ibc = ambcls(i2)
            icc = ambcls(i3)
         else
            iac = ambcls(i3)
            ibc = ambcls(i2)
            icc = ambcls(i1)
         endif

         if (iac.gt.icc) then
            ict = iac
            iac = icc
            icc = ict
         endif

         do l=1,mxang
            if ( iac.eq.angcon(1,l).and.ibc.eq.angcon(2,l)
     &    .and.  icc.eq.angcon(3,l) ) then
               istat = 1
               ak = ang(1,l)
               al = ang(2,l)
            endif
         end do

         if (istat.eq.0.and.
     &      (i1.ge.1254.and.i2.ge.1254.and.i3.ge.1254)) then
            if (swap) then
               iac = amb2gf(i1)
               ibc = amb2gf(i2)
               icc = amb2gf(i3)
            else
               iac = amb2gf(i3)
               ibc = amb2gf(i2)
               icc = amb2gf(i1)
            endif

            dogaff = .true.
            doinit = .false.
         endif

      endif

      if (dogaff) then

         if (doinit) then

            if (swap) then
               if (i1.gt.0) then
                  iac = mapagf(ambcls(i1))
               else
                  iac = abs(i1)
                  if (iac.eq.72) iac = 6
               endif
               if (i2.gt.0) then
                  ibc = mapagf(ambcls(i2))
               else
                  ibc = abs(i2)
                  if (ibc.eq.72) ibc = 6
               endif
               if (i3.gt.0) then
                  icc = mapagf(ambcls(i3))
               else
                  icc = abs(i3)
                  if (icc.eq.72) icc = 6
               endif
            else
               if (i3.gt.0) then
                  iac = mapagf(ambcls(i3))
               else
                  iac = abs(i3)
                  if (iac.eq.72) iac = 6
               endif
               if (i2.gt.0) then
                  ibc = mapagf(ambcls(i2))
               else
                  ibc = abs(i2)
                  if (ibc.eq.72) ibc = 6
               endif
               if (i1.gt.0) then
                  icc = mapagf(ambcls(i1))
               else
                  icc = abs(i1)
                  if (icc.eq.72) icc = 6
               endif
            endif
         endif

         if (iac.gt.icc) then
            ict = iac
            iac = icc
            icc = ict
         endif

         iact = iac
         ibct = ibc
         icct = icc

         irun = 0
10       continue

         irun = irun + 1
         do l=1,mxgang
            if ( iac.eq.gfacon(1,l).and.ibc.eq.gfacon(2,l)
     &    .and.  icc.eq.gfacon(3,l) ) then
               istat = 1
               ak = gfang(1,l)
               al = gfang(2,l)
            endif
         end do

         if (istat.ne.1.and.docorb) then

            iac = iact
            ibc = ibct
            icc = icct
            ibcs = 0

            do i=1,mxcor
               if (ibc.eq.iatcor(1,i)) ibc = iatcor(2,i)
            end do

            if (ibc.ne.ibct) ibcs = ibc

            docorb = .false.
            if (ibcs.ne.0) goto 10
         endif

         if (istat.ne.1.and.docora) then

            iac = iact
            ibc = ibct
            icc = icct
            iacs = 0

            do i=1,mxcor
               if (iac.eq.iatcor(1,i)) iac = iatcor(2,i)
            end do

            if (iac.ne.iact) iacs = iac

            if (iac.gt.icc) then
               ict = iac
               iac = icc
               icc = ict
            endif


            docora = .false.
            if (iacs.ne.0) goto 10
         endif

         if (istat.ne.1.and.docorc) then

            iac = iact
            ibc = ibct
            icc = icct
            iccs = 0

            do i=1,mxcor
               if (icc.eq.iatcor(1,i)) icc = iatcor(2,i)
            end do

            if (icc.ne.icct) iccs = icc

            if (iac.gt.icc) then
               ict = iac
               iac = icc
               icc = ict
            endif

            docorc = .false.
            if (iccs.ne.0) goto 10

         endif

         if (istat.ne.1.and.docrab) then

            docrab = .false.
            if (iacs.ne.0.and.ibcs.ne.0) then
               iac = iacs
               ibc = ibcs
               icc = icct

               if (iac.gt.icc) then
                  ict = iac
                  iac = icc
                  icc = ict
               endif

               goto 10
            endif

         endif

         if (istat.ne.1.and.docrbc) then

            docrbc = .false.

            if (ibcs.ne.0.and.iccs.ne.0) then
               iac = iact
               ibc = ibcs
               icc = iccs

               if (iac.gt.icc) then
                  ict = iac
                  iac = icc
                  icc = ict
               endif

               goto 10
            endif

         endif

         if (istat.ne.1.and.docrac) then

            docrac = .false.

            if (iacs.ne.0.and.iccs.ne.0) then
               iac = iacs
               ibc = ibct
               icc = iccs

               if (iac.gt.icc) then
                  ict = iac
                  iac = icc
                  icc = ict
               endif

               goto 10
            endif

         endif

         if (istat.ne.1.and.docabc) then

            docabc = .false.

            if (iacs.ne.0.and.ibcs.ne.0.and.iccs.ne.0) then
               iac = iacs
               ibc = ibcs
               icc = iccs

               if (iac.gt.icc) then
                  ict = iac
                  iac = icc
                  icc = ict
               endif

               goto 10
            endif

         endif

         iac = iact
         ibc = ibct
         icc = icct

         if (istat.eq.0.and.tryabc) then
            call parabc(istat,i1,i2,i3,al,ak)
         endif

      endif

      if (istat.eq.0) then

         if (doamb) then
            write(iun5,'(a,3(i4,1x),a,3(a3,1x))') 
     &         'amber type ', i1,i2,i3,
     &         ' label ',ambstr(i1),ambstr(i2),ambstr(i3)
         endif

         if (dogaff) then
            if (swap) then
               write(iun5,'(a,3(i4,1x),a,3(a3,1x),a,3(i5,1x))') 
     &         'type ',i3,i2,i1,
     &         ' label ',gffstr(iac),gffstr(ibc),gffstr(icc),
     &         ' gaff type ',iac,ibc,icc
            else
               write(iun5,'(a,3(i4,1x),a,3(a3,1x),a,3(i5,1x))') 
     &         'type ',i1,i2,i3,
     &         ' label ',gffstr(iac),gffstr(ibc),gffstr(icc),
     &         ' gaff type ',iac,ibc,icc
            endif
         endif
      endif

      return
      end

      subroutine parabc(istat,ia,ib,ic,angabc,fabc)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxgff=72)
      parameter (mxgbnd=747)
      integer gfbcon,gfacon
      common /gfbpar/ gfbnd(2,mxgbnd),gfbcon(2,mxgbnd)
      parameter (mxgang=3506)
      common /gfapar/ gfang(2,mxgang),angint(2,mxgff),
     &                gfacon(3,mxgang)
      integer*2 ia,ib,ic

      todeg = 45.0e0 / atan(1.0e0)
      istat = 0

      call gtapar(istat,.true.,.false.,ia,ib,ia,angaba,ak)
      if (istat.eq.0) return
      call gtapar(istat,.true.,.false.,ic,ib,ic,angcbc,ak)
      if (istat.eq.0) return

      angabc = (angaba + angcbc) / 2.0e0
      sanabc = sqrt(angabc / todeg)

      call gtbpar(istat,ia,ib,rab,bk)
      if (istat.eq.0) return
      call gtbpar(istat,ib,ic,rbc,bk)
      if (istat.eq.0) return

c
c formula gaff publication
c
c      d = (rab - rbc)**2 / (rab + rbc)**2
c
c as in parmchk:
c
      d = (rab-rbc)*(rab-rbc)
      d = d / (rab+rbc)*(rab+rbc)

      aa = angint(2,abs(ia))
      ab = angint(1,abs(ib))
      ac = angint(2,abs(ic))
c
c formula gaff publication
c
c      fabc = todeg*todeg*143.9e0*aa*ab*ac*
c     &       exp(-2.0e0*d) / ( (rab+rbc)*angabc*angabc )

c
c as in parmchk:
c
      fabc = 143.9e0*aa*ab*ac*
     &       exp(-2.0e0*d) / ( (rab+rbc)*sanabc )
      return
      end

      subroutine angard(istat,nang,iang,ango,ak,maxang,iconn,ityp,iopt)
c
c     create angle list from the connection array and assign parameters
c
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      integer*2 ityp
      dimension iconn(mxcon+1,*),ityp(*),iopt(*),
     &          iang(3,*),ango(*),ak(*)

      nang = 0
      istat = 1

      do i=1,iatoms

         do j=1,iconn(1,i) - 1
            jj = iconn(j+1,i)
            if (jj.gt.0) then

               do k=j+1,iconn(1,i)
                kk = iconn(k+1,i)
                if (kk.gt.0.and.kk.ne.jj.and.
     &          (iopt(i).eq.1.or.iopt(jj).eq.1.or.iopt(kk).eq.1)) then

                  if (nang.lt.maxang) then
                     nang = nang + 1
                     if (kk.ge.jj) then
                        iang(1,nang) = jj
                        iang(2,nang) = i
                        iang(3,nang) = kk
                     else
                        iang(1,nang) = kk
                        iang(2,nang) = i
                        iang(3,nang) = jj
                     endif

                     call gtapar(istat,
     &                    kk.ge.jj,.true.,ityp(jj),ityp(i),ityp(kk),
     &                    ango(nang),ak(nang))
                     if (istat.eq.0) then
                          write(iun5,*) 'angle parameter not found: ',
     &                    abs(ityp(jj)),abs(ityp(i)),abs(ityp(kk)),
     &                    ' atnr ',jj,i,kk

                     endif

                  else

                     istat = 0

                  endif

                endif
               end do

            endif

         end do

      end do

      return
      end

      subroutine angle(ea,nang,iang,ango,ak,coo,forces)
      implicit real (a-h,o-z), integer (i-n)
      common /athlp/  iatoms, mxnat
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension iang(3,*),ango(*),ak(*),coo(3,*),forces(3,*)
      dimension va(3),vb(3),vc(3),vab(3),vcb(3),vp(3),
     &          deda(3),dedb(3),dedc(3)

c initialize

      ea = 0.0e0
      todeg = 45.0e0 / atan(1.0e0)
      angu = 1.0e0 / (todeg*todeg)

      do i=1,nang

         ia = iang(1,i)
         ib = iang(2,i)
         ic = iang(3,i)

         aopt = ango(i)
         fk   = ak(i)

            do j=1,3
               va(j) = coo(j,ia)
               vb(j) = coo(j,ib)
               vc(j) = coo(j,ic)
            end do

            call vsub(va,vb,vab,3)
            call vsub(vc,vb,vcb,3)

            if (box) then
               call reddis(vab)
               call reddis(vcb)
            endif

            rab2 = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
            rcb2 = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)

            if (rab2.ne.0.0e0 .and. rcb2.ne.0.0e0) then
                  call crprod(vcb,vab,vp)
                  rp = vlen(vp)
                  rp = max(rp,0.000001e0)
                  call impsc(vab,vcb,cosa)
                  cosa = dble(min(1.0e0,max(-1.0e0,cosa)))
                  angl = todeg * acos(cosa)

                  dt  = angl - aopt
                  dt2 = dt * dt
                  e   = angu * fk * dt2
                  deddt = 2.d0 * fk * dt * angu * todeg

                  call crprod(vab,vp,deda)
                  rmul1 = -deddt / (rab2*rp)
                  call vscal(deda,3,rmul1)

                  call crprod(vcb,vp,dedc)
                  rmul2 =  deddt / (rcb2*rp)
                  call vscal(dedc,3,rmul2)

                  call vadd(deda,dedc,dedb,3)
                  call vscal(dedb,3,-1.0e0)

                  ea = ea + e
                  do j=1,3
                     forces(j,ia) = forces(j,ia) + deda(j)
                     forces(j,ib) = forces(j,ib) + dedb(j)
                     forces(j,ic) = forces(j,ic) + dedc(j)
                  end do
            end if
      end do

      return
      end

      subroutine reddis(vr)
      implicit real (a-h,o-z), integer (i-n)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension vr(3)
      
      
      
      do i=1,3
         vr(i) = mod(vr(i),abc(i))
         if (vr(i).gt.abc2(i)) then
            vr(i) = vr(i) - abc(i)
         endif
         if (vr(i).lt.-abc2(i)) then
            vr(i) = vr(i) + abc(i)
         endif
      end do

      return
      end

      subroutine rddisr(vr)
      implicit real (a-h,o-z), integer (i-n)
      real abc,abc2,angles
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension vr(3)
      
      do i=1,3
         do while (vr(i).gt.real(abc2(i)))
            vr(i) = vr(i) - real(abc(i))
         end do
         do while (vr(i).lt.-real(abc2(i)))
            vr(i) = vr(i) + real(abc(i))
         end do
      end do

      return
      end

      subroutine appbnd(coo,ityp)
      implicit real (a-h,o-z), integer (i-n)
      integer*2 ityp
      logical box,cell,fast,outbox
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /athlp/  iatoms, mxnat
      dimension coo(3,*),cw(3,3),vec(3),ityp(*)
      
c put water molecules which are entirely out of the box
c back in the box

      do i=1,iatoms

         if (ityp(i)  .eq.649.and.
     &       ityp(i+1).eq.650.and.
     &       ityp(i+2).eq.650) then

            outbox = .true.

            do j=1,3
               vec(j) = 0.0e0
            end do

            do k=1,3

               l = 0

               do j=1,3
                  cw(j,k) = coo(j,i+k-1)
                  if (cw(j,k).gt.abc2(j)) then
                     l = l + 1
                     if (k.eq.1) vec(j) = -abc(j)
                  endif
                  if (cw(j,k).lt.-abc2(j)) then
                     l = l + 1
                     if (k.eq.1) vec(j) = abc(j)
                  endif
               end do

               if (l.eq.0) outbox = .false.

            end do

c water out of the box, put it back

            if (outbox) then
               do k=1,3
                  do j=1,3
                     coo(j,i+k-1) = cw(j,k) + vec(j)
                  end do
               end do
            endif

         endif
      end do

      return
      end

      subroutine makbod(coo)
      implicit real (a-h,o-z), integer (i-n)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension coo(3,*),vec(3)

c     get largest diameter protein and add a default
c     set abc and abc2
c     set protein in center of the box

      offs = 14.0e0 

      call docnt(vec,coo)

      do i=1,3
         abc(i) = 2.0e0*vec(i) + offs
         abc2(i) = 0.5e0*abc(i)
      end do

      return
      end

      subroutine allbox
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxion=2000)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      common /athlp/  iatoms, mxnat
      dimension nbox(3)

      watd = 18.620e0
      nwater = 648/3

      do i=1,3
         t = abc(i)/watd
         nbox(i) = int(t) + 1
      end do

      newat = nbox(1)*nbox(2)*nbox(3)*nwater*3

      call allcoo(newat)
      if (nion.gt.0) call allq

      return
      end

      subroutine filbod(water,coo,iconn,iresid,ityp,
     &                  nac,iac,nad,
     &                  nbnd,ibnd,bl,bk,
     &                  nang,iang,ango,ak,q,iopt,iwtpr)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (numres=50000)
      parameter (mxion=2000)
      logical box,cell,fast,chkwat,chkbox,chkion
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /athlp/  iatoms, mxnat
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      common /h2oer/   numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      integer*2 ityp
      dimension water(3,*), coo(3,*), nbox(3), doff(3)
      dimension ityp(*),iconn(mxcon+1,*),iresid(*)
      dimension nac(*),nad(*),iac(mxac,*)
      dimension ibnd(2,*), bl(*), bk(*)
      dimension iang(3,*),ango(*),ak(*)
      dimension q(*),iopt(*),iwtpr(*),cwat(3,3),ibox(3)

      watd = 18.620e0
      nwater = 648/3

c 18.620 ang box
c     take prefilled water box and tile the real box with this
c     sub box
c     remove water that overlap with protein

      do i=1,3
         t = abc(i)/watd
         nbox(i) = int(t) + 1
      end do

      ishoh = ires(ihsres)
      if (ishoh.gt.0) then
          ishoh = -4
      else
          ishoh = ishoh - 1
      endif

      natnow = iatoms
      ioff = iatoms
      numwat = 0
      nwat = 0

      ibox(1) = 0

      do i=1,nbox(1)
         if (i.eq.nbox(1)) ibox(1) = 1
         ibox(2) = 0

         do j=1,nbox(2)
            if (j.eq.nbox(2)) ibox(2) = 1
            ibox(3) = 0

            do k=1,nbox(3)
               if (k.eq.nbox(3)) ibox(3) = 1

               doff(1) = -abc2(1) + 0.5e0*watd + watd*dble(i-1)
               doff(2) = -abc2(2) + 0.5e0*watd + watd*dble(j-1)
               doff(3) = -abc2(3) + 0.5e0*watd + watd*dble(k-1)

               chkbox = .false.
               if (i.eq.nbox(1).or.j.eq.nbox(2).or.k.eq.nbox(3))
     &             chkbox = .true.

               do n=1,nwater

                  in = (n-1)*3

                  do m=1,3
                     cwat(m,1) = water(m,in+1) + doff(m)
                     cwat(m,2) = water(m,in+2) + doff(m)
                     cwat(m,3) = water(m,in+3) + doff(m)
                  end do

                  if (chkwat(cwat,coo,ityp,iopt,ioff,ibox,
     &                       iwt,chkbox)) then


                     nwat = nwat + 1

                     if (.not.chkion(nwat)) then

c ADD WATER

                        numwat = numwat + 1
                        iwtpr(numwat) = iwt

                        if (ihsres.lt.numres) then
                           ihsres = ihsres + 1
                        endif

                        ires(ihsres) = ishoh
                        ibeg(ihsres) = ioff+1
                        iend(ihsres) = ioff+3
                        iresid(ioff+1) = ishoh
                        iresid(ioff+2) = ishoh
                        iresid(ioff+3) = ishoh
                        ishoh = ishoh - 1

                        do m=1,3
                           coo(m,ioff+1) = cwat(m,1)
                           coo(m,ioff+2) = cwat(m,2)
                           coo(m,ioff+3) = cwat(m,3)
                        end do
   
                        ityp(ioff+1) = 649
                        ityp(ioff+2) = 650
                        ityp(ioff+3) = 650

                        iwtpr(numwat) = 0
   
                        iconn(1,ioff+1) = 2
                        iconn(2,ioff+1) = ioff+2
                        iconn(3,ioff+1) = ioff+3
   
                        iconn(1,ioff+2) = 1
                        iconn(2,ioff+2) = ioff+1
   
                        iconn(1,ioff+3) = 1
                        iconn(2,ioff+3) = ioff+1

                        ibnd(1,nbnd+1) = ioff+1
                        ibnd(2,nbnd+1) = ioff+2
                        bl(nbnd+1)     = 0.9572e0
                        bk(nbnd+1)     = 553.0e0

                        ibnd(1,nbnd+2) = ioff+1
                        ibnd(2,nbnd+2) = ioff+3
                        bl(nbnd+2)     = 0.9572e0
                        bk(nbnd+2)     = 553.0e0
                        nbnd = nbnd + 2

                        nang = nang + 1
                        iang(1,nang) = ioff+2
                        iang(2,nang) = ioff+1
                        iang(3,nang) = ioff+3
                        ango(nang)   = 104.52e0
                        ak(nang)     = 100.00e0

                        q(ioff+1)    = -0.8340e0
                        q(ioff+2)    = 0.4170e0
                        q(ioff+3)    = 0.4170e0
   
                        if (i.eq.1.or.j.eq.1.or.k.eq.1) then
                           iopt(ioff+1) = 1
                           iopt(ioff+2) = 1
                           iopt(ioff+3) = 1
                        else
                           iopt(ioff+1) = 0
                           iopt(ioff+2) = 0
                           iopt(ioff+3) = 0
                        endif
   
                        nac(ioff+1) = 0
                        nac(ioff+2) = 1
                        nac(ioff+3) = 1
                        iac(1,ioff+2) = ioff+3
                        iac(1,ioff+3) = ioff+2
                        nad(ioff+1) = 0
                        nad(ioff+2) = 0
                        nad(ioff+3) = 0

                        ioff = ioff + 3

                     endif

                  endif

               end do
               
            end do
         end do
      end do

      do i=iatoms,ioff
         iopt(i) = 1
      end do

      iatoms = ioff

      if (nion.ne.0)
     &  call addions(coo,iconn,iresid,ityp,q,iopt)

      return
      end

      logical function chkion(iwat)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxion=2000)
      common /h2oer/  numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat

      chkion = .false.
      if (nion.eq.0) return

      do i=1,nion
         if (iwat.eq.iw(i)) then
            chkion = .true.
            return
         endif 
      end do

      return
      end

      subroutine addions(coo,iconn,iresid,ityp,q,iopt)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (numres=50000)
      parameter (mxion=2000)
      common /athlp/  iatoms, mxnat
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      common /h2oer/   numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      integer*2 ityp
      dimension coo(3,*), ityp(*),iconn(mxcon+1,*),iresid(*)
      dimension q(*),iopt(*)

c ADD ION

      ioff = iatoms
      ishoh = iresid(ioff) - 1

      do i=1,nion
         ihsres = ihsres + 1
         ires(ihsres) = ishoh
         ibeg(ihsres) = ioff+1
         iend(ihsres) = ioff+1
         iresid(ioff+1) = ishoh

         ishoh = ishoh - 1

         iatptr = natnow + (iw(i)-1)*3 + 1

         do j=1,3
            coo(j,ioff+1) = coo(j,iatptr)
         end do

         if (iontyp.eq.1) then
            ityp(ioff+1) = 659
            q(ioff+1)    = -1.0e0
         else
            ityp(ioff+1) = 652
            q(ioff+1)    = +1.0e0
         endif

         iconn(1,ioff+1) = 0
         iopt(ioff+1) = 1

         ioff = ioff + 1

      end do

      iatoms = ioff

      return
      end

      subroutine cntwad(water,coo,iconn,iresid,ityp,q,iopt,qpot)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (numres=50000)
      parameter (mxion=2000)
      logical doind,exclu,box,cell,fast,chkwat,chkbox
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /athlp/  iatoms, mxnat
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      common /h2oer/   numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      integer*2 ityp
      dimension water(3,*), coo(3,*), nbox(3), doff(3)
      dimension ityp(*),iconn(mxcon+1,*),iresid(*)
      dimension q(*),iopt(*),cwat(3,3),c1(3),c2(3),ibox(3),qpot(*)

      watd = 18.620e0
      nwater = 648/3

c 18.620 ang box
c     take prefilled water box and tile the real box with this
c     sub box
c     remove water that overlap with protein

      do i=1,3
         t = abc(i)/watd
         nbox(i) = int(t) + 1
      end do

      ioff = iatoms
      nitmp = 0

      ibox(1) = 0

      do i=1,nbox(1)
         if (i.eq.nbox(1)) ibox(1) = 1
         ibox(2) = 0

         do j=1,nbox(2)
            if (j.eq.nbox(2)) ibox(2) = 1
            ibox(3) = 0

            do k=1,nbox(3)
               if (k.eq.nbox(3)) ibox(3) = 1

               doff(1) = -abc2(1) + 0.5e0*watd + watd*dble(i-1)
               doff(2) = -abc2(2) + 0.5e0*watd + watd*dble(j-1)
               doff(3) = -abc2(3) + 0.5e0*watd + watd*dble(k-1)

               chkbox = .false.
               if (i.eq.nbox(1).or.j.eq.nbox(2).or.k.eq.nbox(3))
     &             chkbox = .true.

               do n=1,nwater

                  in = (n-1)*3

                  do m=1,3
                     cwat(m,1) = water(m,in+1) + doff(m)
                     cwat(m,2) = water(m,in+2) + doff(m)
                     cwat(m,3) = water(m,in+3) + doff(m)
                  end do

                  if (chkwat(cwat,coo,ityp,iopt,ioff,ibox,
     &                       iwt,chkbox)) then

                     numwat = numwat + 1

                     if (i.eq.1.or.j.eq.1.or.k.eq.1) then
                           iopt(ioff+1) = 1
                           iopt(ioff+2) = 1
                           iopt(ioff+3) = 1
                     else
                           iopt(ioff+1) = 0
                           iopt(ioff+2) = 0
                           iopt(ioff+3) = 0
                     endif

                     ityp(ioff+1) = 649
                     ityp(ioff+2) = 650
                     ityp(ioff+3) = 650

                     do m=1,3
                        coo(m,ioff+1) = cwat(m,1)
                        coo(m,ioff+2) = cwat(m,2)
                        coo(m,ioff+3) = cwat(m,3)
                     end do

                     if (ionpl.eq.1) then
                        call clmond(cwat(1,1),pot,coo,q)
                        qpot(numwat) = pot
                     endif

                     ioff = ioff + 3

                  endif

               end do
               
            end do
         end do
      end do

      if (ionpl.eq.1) then

         nitmp = 0

         do while (nitmp.lt.nion)

            doind = .false.
            potl = 1.0e10
            iptr = 0

            do i=1,numwat

               pot = qpot(i)

               exclu = .false.
               do j=1,nitmp
                  if (iw(j).eq.i) exclu = .true.
               end do

               if (pot.lt.potl.and..not.exclu) then
                  doind = .true.
                  potl = pot
                  iptr = i
               endif

            end do

            if (doind) then
               nitmp = nitmp + 1
               iw(nitmp) = iptr

               do i=1,numwat
                  iatptr = iatoms + (i-1)*3 + 1
                  do j=1,3
                     c1(j) = coo(j,iatptr)
                  end do

                  jatptr = iatoms + (iptr-1)*3 + 1
                  do j=1,3
                     c2(j) = coo(j,jatptr)
                  end do
                  r2 = dist2(c1,c2)
                  r = sqrt(r2)
                  qpot(i) = qpot(i) + 1.0e0/r

               end do

            endif

         end do

      else

         call crionp

      endif

      return
      end

      logical function chkvec(vec,cwat,coo,iopt,ityp,ioff)
      implicit real (a-h,p-w),integer (i-n),logical (o)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=49)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      common /athlp/  iatoms, mxnat
      integer*2 ityp
      dimension v(3),vec(3),cwat(3,3),coo(3,*),ityp(*)
      dimension iopt(*)

      chkvec = .true.

      vdwat = 2.7683e0

      do i=iatoms,ioff
            
         if (iopt(i).eq.1) then

            i1 = int(ityp(i))
            if (i1.gt.0) then
               il = ambcls(i1)
               vdwr = ambvdwr(il)
            else
               il = iabs(i1)
               vdwr = gfvdw(1,il)
            endif


               do k=1,3
                  v(k) = coo(k,i) + vec(k) - cwat(k,1)
               end do

               rab2 = v(1)*v(1) + v(2)*v(2) + v(3)*v(3)
               dmaxsq = vdwr + vdwat
               dmaxsq = dmaxsq * dmaxsq

               if (rab2.lt.dmaxsq) then
                  chkvec = .false.
                  return
               endif


         endif

      end do

      return
      end

      logical function chkwat(cwat,coo,ityp,iopt,ioff,ibox,iwrpr,chkbox)
      implicit real (a-h,p-w),integer (i-n),logical (o)
      parameter (mxamb=1590)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=49)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      parameter (mxgff=72)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      integer*2 ityp
      logical chkbox,chkvec
      common /athlp/  iatoms, mxnat
      logical box,cell,fast,owat
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension coo(3,*),ityp(*),cwat(3,3),v(3),vdwat(3),ibox(3)
      dimension vec(3),iopt(*)

      chkwat = .false.


      owat = .true.
      iwrpr = 0

      if (chkbox) then

         do i=1,3
            do j=1,3
               if (cwat(j,i).gt.abc2(j)) owat = .false.
            end do
         end do

         if (.not.owat) return

         do i=1,3

            do j=1,3
               vec(j) = 0.0e0
            end do

            if (ibox(i).eq.1) then
               vec(i) = abc(i)
               if (.not.chkvec(vec,cwat,coo,iopt,ityp,ioff)) return
            endif

         end do

c         chkwat = .true.
c         return

      endif

c check overlap with protein atoms 

      owat = .true.

      vdwat(1) = 2.7683e0

      do i=1,iatoms
         
         i1 = int(ityp(i))
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr = ambvdwr(il)
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr = gfvdw(1,i1)
         endif

         do k=1,3
            v(k) = coo(k,i) - cwat(k,1)
         end do
         rab2 = v(1)*v(1) + v(2)*v(2) + v(3)*v(3)
         dmaxsq = vdwr + vdwat(1)
         dmaxsq = dmaxsq * dmaxsq
         if (rab2.lt.dmaxsq) owat = .false.
         if (rab2.lt.81.0e0) iwrpr = 1

      end do

      if (owat) chkwat = .true.

      return
      end

      subroutine docnt(vecm,coo)
      implicit real (a-h,p-w),integer (i-n),logical (o)
      common /athlp/ iatoms, mxnat
      dimension vec(3),vecm(3)
      dimension coo(3,*)

      do i=1,3
         vecm(i) = 0.0e0
      end do

      call cntvec(vec,coo,iatoms)

      do i=1,iatoms
         do j=1,3
            coo(j,i) = coo(j,i) - vec(j)
            da = abs(coo(j,i))
            if (da.gt.vecm(j)) vecm(j) = da
         end do
      end do

      return
      end

      subroutine cntvec(vec,coo,iatoms)
      implicit real (a-h,p-w),integer (i-n),logical (o)
      dimension vec(3), coo(3,*)

      do i=1,3
         vec(i) = 0.0e0
      end do

      if (iatoms.le.0) return

      do i=1,iatoms
         do j=1,3
            vec(j) = vec(j) + coo(j,i)
         end do
      end do
 
      do j=1,3
         vec(j) = vec(j) / dble(iatoms)
      end do

      return
      end

      subroutine setop(a,b,c,alpha,beta,gamma)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cell/ xa,ya,yb,za,zb,zc
      real rxa,rya,ryb,rza,rzb,rzc
      common /cellr/ rxa,rya,ryb,rza,rzb,rzc

      torad = atan(1.0e0) / 45.0e0
      alpha = alpha*torad
      beta = beta*torad
      gamma = gamma*torad

      ca = cos(alpha)
      cb = cos(beta)
      cc = cos(gamma)
      sc = sin(gamma)
      sa = sin(alpha)
      cvol = a*b*c*
     &   sqrt(1-ca**2-cb**2-cc**2+2.0e0*ca*cb*cc)
      xa = cvol / (b*c*sa)
      ya = (a*(cc-(ca*cb)))/sa
      yb = (b*sa)
      za = (a*cb)
      zb = (b*ca)
      zc = c

      rxa = real(xa)
      rya = real(ya)
      ryb = real(yb)
      rza = real(za)
      rzb = real(zb)
      rzc = real(zc)

c      print*,' '
c      write(*,'(a,f9.3)') ' Cell Volume = ',cvol

      return
      end

      subroutine getcel(a,b,c,alpha,beta,gamma)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cell/ xa,ya,yb,za,zb,zc

      torad = atan(1.0e0) / 45.0e0

      a = sqrt(xa**2+ya**2+za**2)
      b = sqrt(yb**2+zb**2)
      c = zc

      sa = yb/b
      ca = zb/b
      cb = za/a
      cc = ca*cb + ya*sa/a

      alpha = acos(ca) / torad
      beta  = acos(cb) / torad
      gamma = acos(cc) / torad

      return
      end

      subroutine fr2crt(vec)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cell/ xa,ya,yb,za,zb,zc
      dimension vec(3)

      vec(3) = za*vec(1) + zb*vec(2) + zc*vec(3)
      vec(2) = ya*vec(1) + yb*vec(2)
      vec(1) = xa*vec(1)

      return
      end

      subroutine crt2fr(veci,veco)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cell/ xa,ya,yb,za,zb,zc
      dimension veci(3),veco(3)

      veco(1) =  veci(1) / xa
      veco(2) = (veci(2) - ya*veco(1)) / yb
      veco(3) = (veci(3) - za*veco(1) - zb*veco(2)) / zc 

      return
      end

      subroutine fr2crr(vec)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cellr/ xa,ya,yb,za,zb,zc
      dimension vec(3)

      vec(3) = za*vec(1) + zb*vec(2) + zc*vec(3)
      vec(2) = ya*vec(1) + yb*vec(2)
      vec(1) = xa*vec(1)

      return
      end

      subroutine crr2fr(veci,veco)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cellr/ xa,ya,yb,za,zb,zc
      dimension veci(3),veco(3)

      veco(1) =  veci(1) / xa
      veco(2) = (veci(2) - ya*veco(1)) / yb
      veco(3) = (veci(3) - za*veco(1) - zb*veco(2)) / zc

      return
      end

      subroutine redfr(xyz)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension xyz(3),fr(3)

      call crt2fr(xyz,fr)
      
      do i=1,3
         frt = 1.0e0
         if (fr(i).lt.0.0e0) then
             fr(i) = abs(fr(i))
             frt = -1.0e0
         endif

         fr(i) = mod(fr(i),1.0e0) 
         if (fr(i) .gt. 0.5e0) fr(i) = fr(i) - 1.0e0

         xyz(i) = frt*fr(i)
      end do

      call fr2crt(xyz)

      return
      end

      subroutine rddfrr(xyz)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      real abc,abc2,angles
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /debug/ ideb
      dimension xyz(3),fr(3)


      call crr2fr(xyz,fr)
      

      do i=1,3
         frt = 1.0e0
         if (fr(i).lt.0.0e0) then
             fr(i) = abs(fr(i))
             frt = -1.0e0
         endif

         fr(i) = amod(fr(i),1.0e0) 
         if (fr(i) .gt. 0.5e0) fr(i) = fr(i) - 1.0e0

         xyz(i) = frt*fr(i)
      end do


      call fr2crr(xyz)

      return
      end

      subroutine adcldr(cellder,ded,de,fct,lex)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cell/ xa,ya,yb,za,zb,zc
      common /expnd/ addfr(3,125),ie(5),izero
      dimension ded(3),cellder(6),addf(3)

      do j=1,3
         addf(j) = addfr(j,lex)
      end do

      cellder(1) = cellder(1) + addf(1)*ded(1)*de*fct

      cellder(2) = cellder(2) + addf(1)*ded(2)*de*fct
      cellder(3) = cellder(3) + addf(2)*ded(2)*de*fct

      cellder(4) = cellder(4) + addf(1)*ded(3)*de*fct
      cellder(5) = cellder(5) + addf(2)*ded(3)*de*fct
      cellder(6) = cellder(6) + addf(3)*ded(3)*de*fct

      return
      end

      subroutine prcldr(cellder,par)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /athlp/ iatoms, mxnat
      dimension cellder(6),par(3,*)

c      do i=1,6
c         print*,'cellder (',i,')=',cellder(i)
c      end do

      print*,'val ',par(1,iatoms+1),' cellder (1)=',cellder(1)
      print*,'val ',par(2,iatoms+1),' cellder (2)=',cellder(2)
      print*,'val ',par(3,iatoms+1),' cellder (3)=',cellder(3)
      print*,'val ',par(1,iatoms+2),' cellder (4)=',cellder(4)
      print*,'val ',par(2,iatoms+2),' cellder (5)=',cellder(5)
      print*,'val ',par(3,iatoms+2),' cellder (6)=',cellder(6)

      return
      end

      subroutine expfr(in,cxyz,exyz,lex,nexpnd,oje)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /expnd/ addfr(3,125),ie(5),izero
      logical oje(125)
      dimension lex(125),cxyz(3,125),exyz(3,125,*)

      l = 0

      do i=1,125

         if (i.ne.izero) then
            l = l + 1
            do j=1,3
               cxyz(j,l) = exyz(j,i,in) - exyz(j,izero,in)
            end do
            lex(l) = i
            oje(l) = .false.
         endif

      end do
      
      return
      end

      subroutine setfrac(coo,frac,exyz)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /athlp/  iatoms, mxnat
      common /expnd/ addfr(3,125),ie(5),izero
      dimension coo(3,*),frac(3,*),exyz(3,125,*),cxyz(3,125),dfr(3)

      do j=1,3
         dfr(j) = 0.0e0
      end do

      do i=1,iatoms

         do j=1,3
            if (abs(coo(j,i)).lt.0.001e0) coo(j,i) = 0.0e0
         end do

         call crt2fr(coo(1,i),frac(1,i))

         do j=1,3
            if (frac(j,i).lt.dfr(j)) dfr(j) = frac(j,i)
         end do

      end do

c huh ???

      do i=1,5
         do j=1,3
            if ((dfr(j).ge.dble(-1*i)).and.(dfr(j).lt.dble(-1*(i-1)))) 
     &          dfr(j) = dble(-1*i)
         end do
      end do

      do i=1,iatoms

          do j=1,3
             frac(j,i) = frac(j,i) - dfr(j)
          end do

          do k=1,125
             do j=1,3
                exyz(j,k,i) = frac(j,i) + addfr(j,k)
             end do
             call fr2crt(exyz(1,k,i))
          end do

      end do

      return
      end

      subroutine xpfr(in,kn,cxyz,exyz,lex,nexpnd,oje)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /expnd/ addfr(3,125),ie(5),izero
      logical oje(125)
      dimension cxyz(3,125),exyz(3,125,*),lex(125)

      do i=1,nexpnd+1
         oje(i) = .false.
         if (i.eq.izero) oje(i) = .true.
         do j=1,3
            cxyz(j,i) = exyz(j,i,in) - exyz(j,izero,kn)
         end do
         lex(i) = i
      end do
      
      return
      end

      subroutine initxp
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /expnd/ addfr(3,125),ie(5),izero
      data (ie(j),j=1,5)  / -2,-1,0,1,2/

      izero = 0

      l = 0
      do i=1,5
         do j=1,5
            do k=1,5
              l = l + 1
              addfr(1,l) = dble(ie(i))
              addfr(2,l) = dble(ie(j))
              addfr(3,l) = dble(ie(k))
              if (ie(i).eq.0.and.ie(j).eq.0.and.ie(k).eq.0) izero = l
            end do
         end do
      end do

      return
      end

      subroutine var2cl(x,n)
c copy cell variables to cell common
      implicit real (a-h,p-z),integer (i-n),logical (o)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /cell/ xa,ya,yb,za,zb,zc
      real rxa,rya,ryb,rza,rzb,rzc
      common /cellr/ rxa,rya,ryb,rza,rzb,rzc
      dimension x(*)

      n3 = n*3

      xa = x(n3+1)
      ya = x(n3+2)
      yb = x(n3+3)
      za = x(n3+4)
      zb = x(n3+5)
      zc = x(n3+6)

      abc(1) = sqrt(xa**2+ya**2+za**2)
      abc(2) = sqrt(yb**2+zb**2)
      abc(3) = zc

      do i=1,3
         abc2(i) = abc(i)*0.5e0
      end do

      rxa = real(x(n3+1))
      rya = real(x(n3+2))
      ryb = real(x(n3+3))
      rza = real(x(n3+4))
      rzb = real(x(n3+5))
      rzc = real(x(n3+6))

      return
      end

      subroutine grd2var(cellder,f,n)
c copy cell variables to cell common
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cell/ xa,ya,yb,za,zb,zc
      dimension cellder(6),f(*)

c      print*,'cellval ',xa,ya,yb,za,zb,zc

      n3 = n*3

      do i=1,6
         f(n3+i) = -cellder(i)
      end do

      return
      end

      subroutine uinner(uin,cellder,coo,f,q,n)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /cell/ xa,ya,yb,za,zb,zc
      dimension cellder(6),pole(3),coo(3,*),f(3,*),q(*)

      pi = 3.141592654e0
      pi43 = 4.0e0*pi/3.0e0
      econv = 332.05382e0
      fin =  pi43*econv/(xa*yb*zc)

      do j=1,3
         pole(j) = 0.0e0
      end do

      do i=1,n
         do j=1,3
            pole(j) = pole(j) + coo(j,i)*q(i)
         end do
      end do

      poll = 0.0e0
      do j=1,3
         poll = poll + pole(j)*pole(j)
      end do

      uin = -0.5e0*fin*poll

      cellder(1) = -uin/xa
      cellder(3) = -uin/yb
      cellder(6) = -uin/zc

      do i=1,n
         do j=1,3
            f(j,i) = f(j,i) - fin*pole(j)*q(i)
         end do
      end do

      return
      end

      subroutine crionp
      parameter (mxion=2000)
      implicit real (a-h,p-z),integer (i-n),logical (o)
      common /h2oer/   numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      logical doit

      nitmp = 0

      do while (nitmp.lt.nion)

         doit = .true.
         irnd =  numwat*random()

         do i=1,nitmp
            if (iw(i).eq.irnd) doit = .false.
         end do

         if (doit) then
           nitmp = nitmp + 1
           iw(nitmp) = irnd
         endif

      end do

      return
      end

      real function random()
      parameter (mplier=16807,modlus=2147483647,mobymp=127773,
     &           momdmp=2836)
      common  /seed/jseed,ifrst,nextn
c     mseed comes from alloc.c
      integer hvlue, lvlue, testv, nextn, mseed
 
      if (ifrst.eq.0) then
        jseed = mseed()
        nextn = jseed
        ifrst = 1
      endif
 
      hvlue = nextn / mobymp
      lvlue = mod(nextn, mobymp)
      testv = mplier*lvlue - momdmp*hvlue

      if (testv.gt.0) then
        nextn = testv
      else
        nextn = testv + modlus
      endif

      random = dble(nextn)/dble(modlus)
 
      return
      end

      subroutine mdout
      implicit double precision (a-h,o-z)
      common /del1/dmolin(169),dofscl(169)
      common /del2/d11(3,3),d12(3,3),d21(3,3),d22(3,3),
     &             f11(3),f12(3),f21(3),f22(3),occ(3),
     &             p(3,3),g(3,3),ibasis,idim

      do i=1,3
         k1 = (idim - 8 + i) * idim
         k2 = (idim - 4 + i) * idim
         do j=1,3
            l1 =idim - 7 + j
            l2 =l1 + 4
            dofscl(k1+l1) = d11(i,j)
            dofscl(k1+l2) = d12(i,j)
            dofscl(k2+l1) = d21(i,j)
            dofscl(k2+l2) = d22(i,j)
         end do
      end do

      return
      end

      subroutine cross(x1,y1,x2,y2,x3,y3,x4,y4,oans,xs,ys)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      dimension d(6)
      toler=1.0d-10
      oans=.false.
      if(x1.eq.x3.and.y1.eq.y3)then
        oans=.true.
        xs=x1
        ys=y1
        return
      endif
      if(x1.eq.x4.and.y1.eq.y4)then
        oans=.true.
        xs=x1
        ys=y1
        return
      endif
      if(x2.eq.x3.and.y2.eq.y3)then
        oans=.true.
        xs=x2
        ys=y2
        return
      endif
      if(x2.eq.x4.and.y2.eq.y4)then
        oans=.true.
        xs=x2
        ys=y2
        return
      endif
      d(1)=x2-x1
      d(2)=x3-x1
      d(3)=x4-x3
      d(4)=y2-y1
      d(5)=y3-y1
      d(6)=y4-y3
      rnoem=d(1)*d(6)-d(3)*d(4)
      if ( rnoem.ne.0.0d0 ) then
        rmu=(d(2)*d(4)-d(1)*d(5))/rnoem
        rlambd=(d(2)*d(6)-d(3)*d(5))/rnoem
        xs=x3+rmu*d(3)
        ys=y3+rmu*d(6)
        if ( (rmu.le.1.0d0+toler.and.rmu.ge.0.0d0).and.
     &       (rlambd.le.1.0d0+toler.and.rlambd.ge.0.0d0)
     &       ) oans=.true.
      endif
      return
      end

      subroutine vaxconv
      open(unit=45,form='formatted',file='scratch.com',
     &status='unknown')
      write(45,'(a)')'$ convert/fdl=sys$input plot.dat scratch.dat'
      write(45,'(a)')'FILE'
      write(45,'(a)')'ORGANIZATION SEQUENTIAL'
      write(45,'(a)')'RECORD'
      write(45,'(a)')'CARRIAGE_CONTROL CARRIAGE_RETURN'
      write(45,'(a)')'FORMAT VARIABLE'
      write(45,'(a)')'$ delete plot.dat;'
      write(45,'(a)')'$ rename scratch.dat plot.dat'
      write(45,'(a)')'$ delete scratch.com;'
      close(45)
      call Lib$Do_Command('@[]scratch.com')
      return
      end

      subroutine runjob(idum,iqopt,ihaszm)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      idum = 1
      print*,'RUNJOB not implemented on VMS'
      return
      end

      subroutine tnkpnt(ipnt,iret)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)

      print*,'RUNJOB not implemented on VMS'

      return
      end

      subroutine setbas(oooke)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      logical oooke
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common/bond/nbas(numatm),ipol(numatm)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      dimension npr(numatm),ltot1(numatm)

c     initialise

      oooke = .true.

      do i=1,natoms
        ltot1(i)=0
        npr(i)=0
      end do
c
c  set ltot1 per atom sum off maximum angular quantum number per shell +1
c      npr   total number off primitives per atom
c
c  TABEL npr and (ltot1)
c
c  nbas   basis    h-he   li-ne  na-cl
c--------------------------------------
c  0      sto3g     3 (1)   6 (3)  9 (5)
c  1      321g      3 (2)   6 (5)  9 (7)
c  2      431g      4       8     12
c  2      431g*     5       9     13
c  3      631g      4      10     16
c  3      631g*     5      11     17
c-------------------------------------
c
      do i=1,nshell
         ltot1(jan(i)) = ltot1(jan(i)) + shellt(i) + 1
         npr(jan(i))   = npr(jan(i)) + shelln(i)
      end do
c
c     determine type off basis per atom
c             nbas  ipol
c     sto3g    0     0
c     321g     1     0
c     431g     2     0
c     431g*    2     1
c     631g     3     0
c     631g*    3     1
      do 40 i=1,natoms
      goto (50,50,60,60,60,60,60,60,60,60,
     +      70,70,70,70,70,70,70) nat(i)
c.....h-he.................................
50    if (npr(i).eq.3) then
         nbas(i) = 0
         ipol(i) = 0
         if (ltot1(i).eq.2) nbas(i) = 1
         goto 40
      endif
      if (npr(i).eq.4) then
         ipol(i) = 0
         nbas(i) = 2
         goto 40
      endif
      if (npr(i).eq.5) then
         ipol(i) = 1
         nbas(i) = 2
         goto 40
      endif
      goto 200 
c.....li-ne............................
60    if (npr(i).eq.6) then
         nbas(i) = 0
         ipol(i) = 0
         if (ltot1(i).eq.5) nbas(i) = 1
         goto 40
      endif
      if (npr(i).eq.8) then
         ipol(i) = 0
         nbas(i) = 2
         goto 40
      endif
      if (npr(i).eq.9) then
         ipol(i) = 1
         nbas(i) = 2
         goto 40
      endif
      if (npr(i).eq.10) then
         ipol(i) = 0
         nbas(i) = 3
         goto 40
      endif
      if (npr(i).eq.11) then
         ipol(i) = 1
         nbas(i) = 3
         goto 40
      endif
      goto 200
c.....na-cl............................
70    if (npr(i).eq.9) then
         nbas(i) = 0
         ipol(i) = 0
         if (ltot1(i).eq.7) nbas(i) = 1
         goto 40
      endif
      if (npr(i).eq.12) then
         ipol(i) = 0
         nbas(i) = 2
         goto 40
      endif
      if (npr(i).eq.13) then
         ipol(i) = 1
         nbas(i) = 2
         goto 40
      endif
      if (npr(i).eq.16) then
         ipol(i) = 0
         nbas(i) = 3
         goto 40
      endif
      if (npr(i).eq.17) then
         ipol(i) = 1
         nbas(i) = 3
         goto 40
      endif
      goto 200
c
40    continue
      return
200   call inferr('When using BONDS only the following basissets',0)
      call inferr('on atoms from H to Cl are allowed ;',0)
      call inferr('Bonds: only sto3g 3-21g 4/6-31g(*/**)',1)

      oooke = .false.

      end

c
c
c     ############################################################
c     ##  COPYRIGHT (C) 1995 by Yong Kong & Jay William Ponder  ##
c     ##                  All Rights Reserved                   ##
c     ############################################################
c
c     "rtmat" find the rotation matrix that converts from the local
c     coordinate system at each multipole site to the global system
c
c     Modified version for MOLDEN
c     Distributed with the permission of Prof. Jay Ponder
c
      subroutine rtmat(i,j,k,itype,a)
      implicit double precision (a-h,o-z)
      parameter (mxsite=300)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
      character*8 ctag
      common /multip/ qmom(lmaxf,mxsite),car(3,mxsite),ctag(mxsite),
     &                nsites
      dimension a(3,3)
c
c
c     rotation matrix elements for z- and x-axes, first z then x
c
      if (itype.eq.1) then
         dx = car(1,j) - car(1,i)
         dy = car(2,j) - car(2,i)
         dz = car(3,j) - car(3,i)
         r = dsqrt(dx*dx + dy*dy + dz*dz)
         a(1,3) = dx / r
         a(2,3) = dy / r
         a(3,3) = dz / r
         dx = car(1,k) - car(1,i)
         dy = car(2,k) - car(2,i)
         dz = car(3,k) - car(3,i)
         dotxz = dx*a(1,3) + dy*a(2,3) + dz*a(3,3)
         dx = dx - dotxz*a(1,3)
         dy = dy - dotxz*a(2,3)
         dz = dz - dotxz*a(3,3)
         r = dsqrt(dx*dx + dy*dy + dz*dz)
         a(1,1) = dx / r
         a(2,1) = dy / r
         a(3,1) = dz / r
c
c     rotation matrix elements for z- and x-axes, bisector method
c
      else

         dx = car(1,j) - car(1,i)
         dy = car(2,j) - car(2,i)
         dz = car(3,j) - car(3,i)
         r = dsqrt(dx*dx + dy*dy + dz*dz)
         dx1 = dx / r
         dy1 = dy / r
         dz1 = dz / r
         dx = car(1,k) - car(1,i)
         dy = car(2,k) - car(2,i)
         dz = car(3,k) - car(3,i)
         r = dsqrt(dx*dx + dy*dy + dz*dz)
         dx2 = dx / r
         dy2 = dy / r
         dz2 = dz / r
         dx = dx1 + dx2
         dy = dy1 + dy2
         dz = dz1 + dz2
         r = dsqrt(dx*dx + dy*dy + dz*dz)
         a(1,3) = dx / r
         a(2,3) = dy / r
         a(3,3) = dz / r
         dotxz = dx2*a(1,3) + dy2*a(2,3) + dz2*a(3,3)
         dx = dx2 - dotxz*a(1,3)
         dy = dy2 - dotxz*a(2,3)
         dz = dz2 - dotxz*a(3,3)
         r = dsqrt(dx*dx + dy*dy + dz*dz)
         a(1,1) = dx / r
         a(2,1) = dy / r
         a(3,1) = dz / r
      endif
c
c     finally, find rotation matrix elements for the y-axis
c
      a(1,2) = a(3,1)*a(2,3) - a(2,1)*a(3,3)
      a(2,2) = a(1,1)*a(3,3) - a(3,1)*a(1,3)
      a(3,2) = a(2,1)*a(1,3) - a(1,1)*a(2,3)

      return
      end
      
c
c     "rotpole" computes the atomic multipole values in the global
c     coordinate frame by applying a rotation matrix to a set of
c     locally defined multipoles
c
c     Modified version for MOLDEN
c      
      subroutine rotpole (a,qrot)
      implicit double precision (a-h,o-z)
      dimension p2(3,3),r2(3,3),a(3,3),rpole(13),qrot(*)
c
c
c     monopoles have the same value in any coordinate frame
c
      rpole(1) = qrot(1)
c
c     rotate the dipoles
c
      do i= 2,4
         rpole(i) = 0.0d0
         do j= 2,4
            rpole(i) = rpole(i) + qrot(j)*a(i-1,j-1)
         end do
      end do
c
c     rotate the quadrupoles
c
      k = 5
      do i=1,3
         do j=1,3
            p2(i,j) = qrot(k)
            r2(i,j) = 0.0d0
            k = k + 1
         end do
      end do

      do i=1,3
         do j=1,3
            if (j.lt.i) then
               r2(i,j) = r2(j,i)
            else
               do k=1,3
                  do m=1,3
                     r2(i,j) = r2(i,j) + a(i,k)*a(j,m)*p2(k,m)
                  end do
               end do
            end if
         end do
      end do

      k = 5
      do i=1,3
         do j=1,3
            rpole(k) = r2(i,j)
            k = k + 1
         end do
      end do

c     Overwrite global multipoles in qrot  

      do i=1,13
         qrot(i) = rpole(i)
      end do

      return
      end
      

      subroutine convzmzz(cc,ianc,natoms,igo,ico,ido,
     &              bl,alph,bet,ibl,ialph,ibet,imap,ianz,iz,
     &              c,cz,alpha,beta,ian)

c this is really convzmat
c
c This routines reads a zmatrix from a gamess/gaussian output
c and converts it to cartesian coordinates (stoc)
c

      implicit double precision (a-h,o-z)
      logical ottest,oerror,zreadg,zreado
c
      common /zmfrst/ ihaszm, nz, mxzat
      dimension ian(*),c(3,*),cz(3,*),alpha(*),beta(*)
      dimension cc(3,*),ianc(*)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianz(*),iz(4,*)
c
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

cd     write(iun3,*)'enter subroutine convzmat'
      do i=1,3
         imap(i) = i
         do j=1,4
          iz(j,i) = 0
         end do
      end do

      maxnz = mxzat
      if (igo.eq.1) then
         if (.not.zreadg(nz,ianz,iz,bl,alph,bet)) then
            call haszm(.false.)
cd           write(iun3,*)'leave subroutine convzmat'
            return
         endif
      elseif (igo.eq.2) then
         if (.not.zreado(nz,ianz,iz,bl,alph,bet)) then
            call haszm(.false.)
            return
         endif
      else
         call zread(nz,ianz,iz,bl,alph,bet)
      endif

      if (ido.eq.1) then
         do i=1,3
            do l=1,3
               cz(l,i) = cc(l,imap(i))
            end do
         end do
      else
         do i=1,3
            do l=1,3
               cz(l,i) = 0.0d0
            end do
         end do
      endif

      ottest=.true.
      call stoc(maxnz,nz,0,0,0,ianz,iz,bl,alph,bet,ottest,natoms,
     &     ian,c,cz,imap,alpha,beta,oerror,.true.,.false.)
      if (.not.oerror) then
         ihaszm = 1
         do i=1,nz
            ibl(i) = 1
            ialph(i) = 1
            ibet(i) = 1
         end do
         if (ico.eq.1) then
            do i=1,natoms
               do j=1,3
                  cc(j,i) = c(j,i)
               end do
               ianc(i) = ian(i)
            end do
         endif
      endif

cd     write(iun3,*)'leave subroutine convzmat'
      return
      end

      subroutine calfd(istat,istpdb,iaddh,ioatms,nstrt,ioadd,
     &                 ianz,iconn,ityp,
     &                 icalf,ncalf,ianf,islu,nchain,iamino,
     &                 isal,irsnr,ihashb,rphi,rpsi)

      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      parameter (mxsym=103)
      parameter (mxhsym=64)
      logical chkpdb
      common /surf/ natorg,noscnd
      logical cn,cco,ccb,cco1,chkhs
      common /types/ iff
      integer*2 ityp
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension ianz(*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),isal(*),irsnr(*),
     &          ityp(*),rphi(*),rpsi(*)

c icalf(1,*) is Calfa
c icalf(2,*) is N connected to Calfa
c icalf(3,*) is C=O connected to Calfa

      istat = 1

      if (istpdb.eq.1) goto 1000

      if (ioadd.eq.0) ncalf = 0

      do i=ioatms+1,iatoms

         cn  = .false.
         cco = .false.
         ccb = .false.
         cco1 = .false.

         if (ianz(i).eq.6.and..not.(iff.eq.7.and.ityp(i).lt.0)) then

            icnso = 0

            do j=1,iconn(1,i)

               jj = abs(iconn(j+1,i))

               if (jj.gt.ioatms) then
                  if (ianz(jj).eq.6 ) icnso = icnso + 1
                  if (ianz(jj).eq.7 ) icnso = icnso + 1
                  if (ianz(jj).eq.8 ) icnso = icnso + 1
                  if (ianz(jj).eq.16) icnso = icnso + 1
               endif

            end do

           if (icnso.eq.2.or.icnso.eq.3) then
c is c connected to nitrogen ?
c
            do j=1,iconn(1,i)
               jj = abs(iconn(j+1,i))
               if (jj.gt.ioatms) then
                  if (ianz(jj).eq.7) then
                      cn = .true.
                      icn = jj
                  endif
               endif
            end do

            if (.not.cn) goto 100
c
c is c connected to carbonyl ?
c
            do j=1,iconn(1,i)
               l = abs(iconn(j+1,i))
               cco1 = .false.
               if (ianz(l).eq.6.and.l.gt.ioatms) then
                  if (iconn(1,l).eq.3.or.iconn(1,l).eq.2) then

                     do k=1,iconn(1,l)
                        kk = abs(iconn(k+1,l))
                        if (ianz(kk).eq.8.and.kk.gt.ioatms) then
                           cco1 = .true.
                        end if
                     end do

                     if (cco1) then
                       if (iconn(1,l).eq.3) then
                          do k=1,iconn(1,l)
                             kk = abs(iconn(k+1,l))
                             if (ianz(kk).eq.7.and.kk.gt.ioatms) then
                                cco = .true.
                                icco = l
                             end if
                          end do
                       else
                          cco = .true.
                          icco = l
                       endif
                     endif

                  endif 
               endif
            end do

            if (.not.cco) goto 100
c
c is c connected to carbon other than those found?
c
            if (icnso.eq.3) then

               do j=1,iconn(1,i)
                  l = abs(iconn(j+1,i))
                  if (l.gt.ioatms) then
                    if (ianz(l).eq.6.and.l.ne.icco) ccb = .true.
                  endif
               end do
            endif

            if (icnso.eq.2) ccb = .true.

            if (ccb) then
               ncalf = ncalf + 1
               icalf(1,ncalf) = i
               icalf(2,ncalf) = icn
               icalf(3,ncalf) = icco
            endif

          endif
         endif
100      continue
      end do

c     round up terminal C alfa

      if (ioadd.eq.1) then
         nstr = nstrt
      else 
         nchain = 0
         nstr = 1
      endif

      ncalft = ncalf

5     continue 

      ns = nstr

      do i=ns,ncalft
         do j=1,iconn(1,icalf(3,i))
            l = abs(iconn(j+1,icalf(3,i)))

c l = N connected to CO , but not yet in list

            if (ianz(l).eq.7.and.l.gt.ioatms) then

               call fndcal(l,2,idum,istat,icalf,ncalft)

               if (istat.eq.0) then

                  do k=1,iconn(1,l)
                    m = abs(iconn(k+1,l))

                    if (ianz(m).eq.6.and.m.ne.icalf(3,i).and.
     &                  m.gt.ioatms) then

c m = C(alfa?) connected to N and is not previous CO

                      do n=1,iconn(1,m)
                        mm = abs(iconn(n+1,m))
                        if (ianz(mm).eq.6.and.mm.gt.ioatms) then

                        if (iconn(1,mm).eq.3) then

                          ioo = 0
                          do in=1,3
                             if (ianz(abs(iconn(in+1,mm))).eq.8) 
     &                           ioo = ioo + 1
                          end do

c Calfa is connected to a CO2

                          if (ioo.eq.2) then
                             ncalf = ncalf + 1
                             icalf(1,ncalf) =  m
                             icalf(2,ncalf) =  l
                             icalf(3,ncalf) = mm
                             nstr = nstr + 1
                             goto 5
                          endif

                        endif

c Calfa is connected to a CO

                        if (iconn(1,mm).eq.2.and.(ianz(abs(iconn(2,mm)))
     &                  .eq.8.or.ianz(abs(iconn(3,mm))).eq.8)) then
                             ncalf = ncalf + 1
                             icalf(1,ncalf) =  m
                             icalf(2,ncalf) =  l
                             icalf(3,ncalf) = mm
                             nstr = nstr + 1
                             goto 5
                        endif

                        endif
                      end do
                    endif
                  end do
               endif
            end if
         end do
         nstr = nstr + 1
      end do

      if (ioadd.eq.1) then
         nstr = nstrt
      else 
         nchain = 0
         nstr = 1
      endif

10    continue

      do i=nstr,ncalf

         ico = 0

         do j=1,iconn(1,icalf(2,i))

c jj = N alfa not connected to a CO alfa of previous residue
c this an N-term

            jj = abs(iconn(j+1,icalf(2,i)))
            if (ianz(jj).eq.6.and.jj.gt.ioatms) then
               call fndcal(jj,3,indx,istat,icalf,ncalf)
               if (istat.eq.1) ico = 1
            endif

         end do

         if (ico.eq.0) then

             do k=1,3
                itemp = icalf(k,nstr)
                icalf(k,nstr) = icalf(k,i)
                icalf(k,i) = itemp
             end do

             nchain = nchain + 1
             ianf(nchain) = nstr
             goto 20

         endif

      end do

      goto 30

20    continue

          do j=1,iconn(1,icalf(3,nstr))
             jj = abs(iconn(j+1,icalf(3,nstr)))

c jj = N alfa connected to an CO alfa

             if (ianz(jj).eq.7.and.jj.gt.ioatms) then

                call fndcal(jj,2,indx,istat,icalf,ncalf)
                if (istat.eq.1) then

c                  go along chain untill C-Term found

                   nstr = nstr + 1

                   do k=1,3
                      itemp = icalf(k,nstr)
                      icalf(k,nstr) = icalf(k,indx)
                      icalf(k,indx) = itemp
                   end do

                   goto 20

                endif

             endif

          end do

c found C-Term; C=O, not connected to N 

          islu(nchain) = nstr
          nstr = nstr + 1

          goto 10
30    continue

      if (nchain.eq.0.and.ncalf.gt.0) then
          nchain = 1
          ianf(nchain) = 1
          islu(nchain) = ncalf
      endif

c determine what residue, doesnt work for nucls

      call samino(istat)

      call parsfn('Helix',5,1)
      call parsfn('Beta',4,1)
      call parsfn('RNA/DNA',7,1)
      call parsfn('Coil',4,1)
      call parsfn('HET',3,1)

1000  continue

c hcoord, hbond en vadar hebben geen ioadd provisie

      call hcoord(ioatms,nstrt,iaddh)
      call hbond(ioatms,nstrt)
      if (ihashb.eq.0) then
          call vadar(ioatms,nstrt,icalf,ncalf,ianf,islu,nchain,iamino,
     &               isal)
          call inferr('Secondary Structure calculated',0)
      else
          isold = 10000
          do i=1,ncalf
             if (iamino(i).gt.23) isal(i) = 2
             if (isal(i).ne.isold) then
                 if (i.gt.1) then
                    if (lng.le.2) isal(i-1) = 3
                 endif
                 if (i.gt.2) then
                    if (lng.eq.2) isal(i-2) = 3
                 endif
                 lng = 1
             else
                 lng = lng + 1
             endif
             isold = isal(i)
          end do
      endif
      
      if (iff.eq.0) then
         do i=1,nchain
            do j=ianf(i),islu(i)
               call getpdb(j,ipdb,ihpdb)
               if (.not.chkpdb(ipdb,iamino(j),j,irsnr,isal(j))) 
     &         then
                   print*,'incomplete residue: internal no. ',j
               endif
               if (iaddh.eq.1.and..not.chkhs(ihpdb)) then
                  if (j.eq.ianf(i)) then
                     call addhs(j,iamino(j),ipdb,ihpdb,1)
                  else
                     call addhs(j,iamino(j),ipdb,ihpdb,0)
                  endif
               endif
               call typeit(ipdb,iamino(j),ihpdb,1)
            end do
         end do
      else
         do i=1,nchain
            do j=ianf(i),islu(i)
               call getpdb(j,ipdb,ihpdb)
               if (.not.chkpdb(ipdb,iamino(j),j,irsnr,isal(j))) 
     &         then
                   print*,'incomplete residue: internal no.',j
               endif
            end do
         end do
      endif

      call prtcal(rphi,rpsi,icalf,ncalf,ianf,islu,nchain,iamino,isal)

      noscnd = iatoms

      return
      end

      subroutine setcdd(iopt,nchain,ianf,islu,irsnr,achain)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      character*1 achain
      dimension ianf(*),islu(*),irsnr(*),achain(*)

      if (iopt.eq.1) then

           do k=1,nchain
              do j=ianf(k),islu(k)
                 achain(j) = char(64+k)
                 irsnr(j) = j
              end do
           end do

      else 

           do k=1,nchain
              do j=ianf(k),islu(k)
                 achain(j) = char(64+k)
                 jj = j - ianf(k) + 1
                 irsnr(j) = jj
              end do
           end do

      endif

      return
      end

      subroutine rysrot(ndeg,a,r,ap)
      implicit double precision (a-h,o-z)
      dimension a(*),r(*),ap(*)

      step = .01d0
      call fdpol(ndeg,nfd,a,ap)
      nroots = ndeg / 2
      iroot = 1
      r(1) = 1.0d0

10    x = r(iroot) - .0001d0
      sgn1 = fpol(ndeg,x,a)

20    x = x - step
      if (x.lt.0.0d0) stop 'x is neg. in rysrot'
      sgn2 = fpol(ndeg,x,a)
      if (sign(1.d0,sgn1).eq.sign(1.d0,sgn2)) goto 20

      r(iroot) = x + .5d0*step

      do j=1,30
         f = fpol(ndeg,r(iroot),a)
         fp = fpol(nfd,r(iroot),ap)
         if (dabs(fp).lt.1.d-10) goto 60
         extrap = f / fp
         if (dabs(extrap/r(iroot)).le.1.d-5) goto 60
         r(iroot) = r(iroot) - extrap
      end do

60    iroot = iroot + 1
      if (iroot.gt.nroots) goto 70

      r(iroot) = r(iroot-1)

      goto 10

70    nhalf = nroots / 2
      if (1.gt.nhalf) return
      do  i=1,nhalf
         x = r(i)
         r(i) = r(nroots+1-i)
         r(nroots+1-i) = x
      end do

      return
      end

      subroutine docend(t,coo,ianz)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      common /athlp/ iatoms, mxnat
      dimension coo(3,*),ianz(*),t(*)

      call cntvec(t,coo,ianz,iatoms)

      return
      end

      subroutine doccd(coo,ianz)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      common /athlp/ iatoms, mxnat
      dimension vec(3)
      dimension coo(3,*),ianz(*)

      call cntvec(vec,coo,ianz,iatoms)

      do i=1,iatoms
         coo(1,i) = coo(1,i) - vec(1)
         coo(2,i) = coo(2,i) - vec(2)
         coo(3,i) = coo(3,i) - vec(3)
      end do

      return
      end

      subroutine cntvec(vec,coo,ianz,iatoms)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      dimension vec(3), coo(3,*), ianz(*)

      do i=1,3
         vec(i) = 0.0d0
      end do

      if (iatoms.le.0) return
      sum = 0.0d0
      do i=1,iatoms
         wat = dble(ianz(i))
         sum = sum + wat
         vec(1) = vec(1) + wat*coo(1,i)
         vec(2) = vec(2) + wat*coo(2,i)
         vec(3) = vec(3) + wat*coo(3,i)
      end do
 
      if (sum.gt.0.0d0) then
         vec(1) = vec(1) / sum
         vec(2) = vec(2) / sum
         vec(3) = vec(3) / sum
      endif

      return
      end

      subroutine cntvc2(vec,coo,iatoms)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      dimension vec(3), coo(3,*)

      do i=1,3
         vec(i) = 0.0d0
      end do

      if (iatoms.le.0) return
      do i=1,iatoms
         do j=1,3
            vec(j) = vec(j) + coo(j,i)
         end do
      end do
 
      do j=1,3
         vec(j) = vec(j) / dble(iatoms)
      end do

      return
      end

      subroutine dodcnt(td)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (numatm=2000)
      common /coord /xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension td(3)

      do i=1,3
         td(i) = 0.0d0
      end do

      if (natoms.le.0) return

      sum = 0.0d0
      do i=1,natoms
         wat = dble(nat(i))
         sum = sum + wat
         do j=1,3
            td(j) = td(j) + wat*xyz(j,i)
         end do
      end do
 
      if (sum.gt.0.0d0) then
         do j=1,3
            td(j) = td(j) / sum
         end do
      endif

      return
      end

      subroutine prtcal(rphi,rpsi,
     &                  icalf,ncalf,ianf,islu,nchain,iamino,isal)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxres=42)
      character*3 aminos
      character*1 scnd(4)
      character*1 schlp
      common /amino/aminos(mxres)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),isal(*)
      dimension rphi(*),rpsi(*)
      data scnd/'H','B','R','C'/

      do i=1,nchain
          nlen = islu(i)-ianf(i)+1
          write(iun3,*) 'Chain ',i,' Length = ',nlen
          write(iun3,*) '       '
          do j=ianf(i),islu(i),13
            kl = min(islu(i)-j+1,13)
            write(iun3,'(13(a3,1x))')(aminos(iamino(k+j-1)),k=1,kl)
          end do
      end do

      toang = 0.52917706d0
      write(iun3,*) ' nr res    hbond                scnd phi    psi'
      do i=1,ncalf
        if (iamino(i).le.23) then
         p1 = phi(i,icalf,ncalf,ianf,nchain)
         p2 = psi(i,icalf,ncalf,islu,nchain)
         rphi(i) = p1
         rpsi(i) = p2
         h1 = hbd(1,i)*toang
         h2 = hbd(2,i)*toang
         if (ihb(1,i).eq.0) h1 = 0.0d0
         if (ihb(2,i).eq.0) h2 = 0.0d0
         if (isal(i).eq.4) then
           schlp = 'C'
         else
           schlp = scnd(isal(i)+1)
         endif
         write(iun3,100) i,' ',aminos(iamino(i)),' ',
     &   ihb(1,i),',',ihb(2,i),' ',h1,',',h2,
     &   ' ',schlp,' ',p1,' ',p2
        endif
      end do

100   format(i4,a,a3,a,i4,a,i4,a,f6.3,a,f6.3,a,a,a,f6.1,a,f6.1)
      return
      end

      subroutine proato
c     make projection of atoms onto the plot plane
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /eulx/   ca,cb,sa,sb,cc,sc
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /atopla/ xsym(numatm),ysym(numatm),zsym(numatm),
     &                isym(numatm)

      do l=1,natoms
         isym(l) = 0
         xk      = xyz(1,l) - px
         yk      = xyz(2,l) - py
         zk      = xyz(3,l) - pz
c inproduct of vector atom-planecenter with outvector of plane
         xinp    = xk*cx + yk*cy + zk*cz
         xinp    = xinp * xinp
         if (xinp.lt.1.d-10) then
           isym(l) = 1
         endif
         xsym(l) =  - ((ca*xk + sa*yk)*cb - zk*sb)
         ysym(l) =  -  (ca*yk - sa*xk)
         zsym(l) = ((ca*xk + sa*yk)*sb + zk*cb)
         x1 = (cc*xsym(l) + sc*ysym(l))
         y1 = (-sc*xsym(l) + cc*ysym(l))
         xsym(l) = x1
         ysym(l) = y1  
      end do

      return
      end

      subroutine spacdd(npts1,npts2,npts3,valcnt,idofil,
     &                  adjus,ipsprt,idisml,idvrml,mapit,
     &                  denn,pmnn,iedlog,fmap)
      implicit double precision (a-h,o-z)

c THIS IS REALLY spaced

      parameter (numatm=2000)
      parameter (mxel=100)
      logical euclid, yes, euctmp
      logical oscal,ostep,fine,lapdbl
      real xx, yy
      integer*2 ixx
      character str*100, esc
      character monstr*100
      character*2 gstr
      character*80 vfile
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /fill /  ixx(1000),nixx,ihight,icol1
      common /plot/   iplot,iplwin,icolps
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /grdhlp/ mx3d,mx3d2
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /eul/    ca,cb,sa,sb,ccab,scab,ssab,scba
      common /atopla/ xsym(numatm),ysym(numatm),zsym(numatm),
     &                isym(numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /zproj/  zval(numatm),nindx(numatm),nconn(numatm)
      common /coord / xyz(3,numatm)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      logical valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /lapcom/ lapbox,lapdbl
      common /orbhlp/ mxorb,iuhf,ispd
      common /vropt/ ivtwo,ihand,ivadd
      character*80 spcdfil
      common /vrmlhl/ spcdfil
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf
      dimension origin(3),rt(3)
      dimension denn(*),pmnn(*),iedlog(*),fmap(*)

      esc = char(27)

      if (npts1.gt.mx3d.or.npts2.gt.mx3d.or.npts3.gt.mx3d) 
     &    stop 'this routine only handles 61 points'

      if (dolap.and.valcnt.eq.0.0d0) valcnt = -0.0001

      if (ofrst) print*,'Contour Value = ',valcnt

      osshad = .true.
      nixx = 0
      if (iplot.eq.6) call gethei(ihight)
      icol1 = 15

      call detone

      euctmp = euclid
      euclid = .false.
      pxt = px
      pyt = py
      pzt = pz
      pmint = pmin
      pmaxt = pmax

c     This will stop the Ultrix compiler from optimising pmaxt away
c     We could use -O0 compiler flag but this keeps the makefile simple
      pmax = pmaxt

      if (idofil.eq.1) ofill = .true.

      rf3 = r(3)/dble(npts3-1)
      iflag = 0
      if (lapbox.eq.0) then
         l1 = 1
         l2 = npts3
      elseif (lapbox.eq.1) then
         l1 = 1
         l2 = npts3/2 + 1
      elseif (lapbox.eq.2) then
         l1 = npts3/2 + 1
         l2 = npts3
      endif
         
     
      if (ofrst) then 
         if (iplot.eq.6) call curs(1)
         do i=1,natoms
            nconn(i) = 0
            do j=1,natoms
              if (i.ne.j) then
               dmaxsq = (vdwr(nat(i)) + vdwr(nat(j)))**2
               dijsq = ((xyz(1,i)-xyz(1,j))*adjus)**2
     +                +((xyz(2,i)-xyz(2,j))*adjus)**2
     +                +((xyz(3,i)-xyz(3,j))*adjus)**2
               if (dijsq.lt.dmaxsq) then
                   nconn(i) = nconn(i) + 1
               endif
              endif
            end do
        end do

        call precal(npts1,npts2)

        do i=l1,l2
            px = pxt
            py = pyt
            pz = pzt
            call precz(r(3),npts3,i)
            call dolift(0.5d0*r(3) - dble(i-1)*rf3)
            if (iplot.eq.6.or.ipsprt.eq.1) then
               monstr = 'Progress Monitor [1-'//gstr(l2)//'] '//gstr(i)
               call inferr(monstr,1)
            endif
            call grdcal(denn( (i-1)*mx3d2 + 1),npts1,npts2,0,1)
            pmnn(i) = pmax
         end do
         if (iplot.eq.6) call inferr('Space is Done !!',0)
         ofrst = .false.
         if (iplot.eq.6) call curs(0)
      endif

      do i=1,natoms
         zval(i) = scba*(0.5d0 + xsym(i) / r(1)) +
     &             ssab*(0.5d0 + ysym(i) / r(2)) + cb*zsym(i) / r(3)
      end do

      call shsort(natoms,zval,nindx)

      do i=l1,l2
        height = 0.5d0 - dble(i-1)/dble(npts3-1)
        if (dabs(valcnt).le.pmnn(i)) then
         call selsol
         if (iplot.eq.6) then
            xx = 2.0
            yy = 0.0
            call xwin(xx,yy,99,str,nstr,idum1,idum2)
            call xwin(xx,yy,8,str,nstr,idum1,idum2)
         elseif (iplot.eq.4.and.icolps.eq.1) then
            write(iun4,*) 'poscontour setcol'
         endif
         grey = 1.0
         cntval = valcnt
         call cntour(denn( (i-1)*mx3d2 + 1),npts2,npts2,npts1,
     &               height,cntval,x,iedlog)

c------ select other line type 

         if (iplot.eq.0) then
             write(iun4,'(a)') '.nc 3'
             write(iun4,'(a)') '.ls 2 0.2'
         endif
         if (iplot.eq.1) write(iun4,'(a)') 'SP3;'
         if (iplot.eq.2) write(iun4,'(a,''*m7b'')')esc
         if (iplot.eq.3) then
             idum = 1
             call plotgh(idum,0.0d0,0.0d0)
             write(iun4,*) esc//'a'
         endif
         if (iplot.eq.4) then
             write(iun4,'(''s'')')
             if (icolps.eq.1) then
                write(iun4,*) 'negcontour setcol'
             else
                write(iun4,'(''0 setlinecap [4 7] 0 setdash'')')
             endif
             write(iun4,'(''n'')')
         endif
         if (iplot.eq.6) then
             xx = 1.0
             yy = 0.0
             call xwin(xx,yy,99,str,nstr,idum1,idum2)
             call xwin(xx,yy,9,str,nstr,idum1,idum2)
             idum = 1
             call plotgh(idum,0.0d0,0.0d0)
         endif

         if (osshad) then
            grey = 0.8
         else
            grey = 1.0
         endif
         cntval = -1.0d0*valcnt
         if (.not.(dolap.and..not.lapdbl))
     &   call cntour(denn( (i-1)*mx3d2 + 1),npts2,npts2,npts1,
     &               height,cntval,x,iedlog)

       endif
       if (ofill.and.idisml.eq.1) then
           call selsol
           call pl3dm(adjus,.true.,height)
       endif
      end do
 
      if (iplot.eq.4) then
        write(iun4,'(''s'')')
        write(iun4,'(''   3 setlinewidth'')')
        write(iun4,'(''n'')')
      endif
      if (iplot.eq.3) then
         idum=1
         call plotgh(idum,0.0d0,0.0d0)
      endif
      if (iplot.eq.6) then
         idum=1
         call plotgh(idum,0.0d0,0.0d0)
      endif
      call selsol
      if ((idisml.eq.1.or.(idisml.eq.0.and.iplot.ne.6)).and..not.ofill)
     &     call pl3dm(adjus,.false.,rdum)

      euclid = euctmp 
      cntval = 99.999d0
      px = pxt
      py = pyt
      pz = pzt
      pmin = pmint
      pmax = pmaxt
      call parstp

      ofill = .false.

      if (idvrml.eq.1) then
         vfile = spcdfil
         if (iplot.eq.6) call curs(1)
         if (ivtwo.eq.3) then
            idum = 1
         elseif (ivtwo.eq.2) then
            call inferr('Generating POVRAY file',0)
         elseif (ivtwo.eq.0.or.ivtwo.eq.1) then
            call inferr('Generating VRML',0)
         endif
         itrans = 0
         if (ipsi.eq.0.and..not.bonds.and..not.dolap.and..not.elpot
     &       .and..not.molpot.and..not.chpot.and.ispd.eq.0) itrans = 1
         if (ivtwo.eq.4) then
            do i=1,3
               rt(i) = 1.0
               origin(i) = 0.0d0
            end do
            ny = npts1
            nx = npts2
            nz = npts3
            call cvtcom
         else
            origin(1) = -0.5d0 * r(2) / r(1)
            origin(2) = -0.5d0
            origin(3) = -0.5d0 * r(3) / r(1)
            do i=1,3
               rt(i) = r(i)
            end do
            nx = npts2
            ny = npts1
            nz = npts3
         endif


         if (ivtwo.eq.3) then
            iwrt = 1
            call initog(iwrt)
            call oginsp(rt,adjus,natoms,nat,idum,icol,xsym,ysym,zsym,
     &                  vdwr,idum,idum,idum,idum,iwrt)
         elseif (ivtwo.eq.4) then
            idum = 1
         else

            iun = 25

            lv = linlen(vfile)
            lc = linlen(curdir)
            if (index(vfile(1:lv),'/').eq.1.or.icmdf.eq.0) then
                vfile = vfile(1:lv)
            else
                vfile = curdir(1:lc)//vfile(1:lv)
            endif
            open(unit=iun,file=vfile,form='formatted',
     &        status='unknown',err=1000)
         endif

         if (lapbox.eq.0) then
            call mcubes(nx,ny,nz,denn,fmap,mapit,origin,valcnt,
     &                      -valcnt,rt,ipsi,dolap,lapdbl,itrans,iun)
         elseif (lapbox.eq.1) then
            nz = npts3/2 + 1
            call mcubes(nx,ny,nz,denn,fmap,mapit,origin,valcnt,
     &                      -valcnt,rt,ipsi,dolap,lapdbl,itrans,iun)
         elseif (lapbox.eq.2) then
            nz = npts3/2 + 1
            call mcubes(nx,ny,nz,denn( (nz-1)*mx3d2 + 1),
     &                  fmap( (nz-1)*mx3d2 + 1),mapit,origin,
     &                  valcnt,-valcnt,rt,ipsi,dolap,lapdbl,itrans,iun)
         endif

         if (ivtwo.eq.3) then
            call ogspst
         elseif (ivtwo.eq.4) then
            idum = 1
         else
            if (idisml.eq.1.or.(idisml.eq.0.and.iplot.ne.6))
     &        call plvmol(iun,npts2,adjus)
c
c --- Close out the object, and display it --- FPA 2/27/2000
c
            if (ivtwo .eq. 2) then
              write(iun,*) '}'
              write(iun,*) 'object {molecule}'
            end if
c
            close(iun)
            if (ivtwo.ne.4) call inferr('Wrote file: '//vfile,0)
         endif
         if (iplot.eq.6) call curs(0)
c
c write file points with xyz coordinates of each points of the 3d grid
c         if (ivtwo.eq.4) call wcubev(nx,ny,nz,denn,origin,rt)

         idvrml = 0
      endif

      mapit = 0
      return

1000  call inferr('Couldnt open file: '//vfile,0)
      mapit = 0
      return
      end

      subroutine spasrd(npts1,npts2,npts3,valcnt,
     &                  denn,pmnn,dens,iedlog)
      implicit double precision (a-h,o-z)

c THIS IS REALLY spasrf

      parameter (numatm=2000)
      logical euclid, yes, euctmp
      logical oscal,ostep,fine,lapdbl
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /grdhlp/ mx3d,mx3d2
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      logical valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /lapcom/ lapbox,lapdbl
      common /pntsta/ iproj,idrcol,nesp
      dimension vt1(3),vt2(3),rt(3)
      dimension denn(*),pmnn(*),dens(*),iedlog(*)

      if (ofrst)  return

      if (dolap.and.valcnt.eq.0.0d0) valcnt = -0.0001

      call pareul
      euctmp = euclid
      euclid = .false.
      pxt = px
      pyt = py
      pzt = pz
      pmint = pmin
      pmaxt = pmax
      do i=1,3
         vt1(i) = v1(i)
         vt2(i) = v2(i)
      end do
      cxt = cx
      cyt = cy
      czt = cz


c     This will stop the Ultrix compiler from optimising pmaxt away
c     We could use -O0 compiler flag but this keeps the makefile simple
      pmax = pmaxt

      rf3 = r(3)/dble(npts3-1)
      iproj = 0
      iflag = 1
      height = 0.0d0
      if (lapbox.eq.0) then
         l1 = 1
         l2 = npts3
      elseif (lapbox.eq.1) then
         l1 = 1
         l2 = npts3/2 + 1
      elseif (lapbox.eq.2) then
         l1 = npts3/2 + 1
         l2 = npts3
      endif
         
      call precal(npts1,npts2)

      do i=l1,l2
        px = pxt
        py = pyt
        pz = pzt
        call precz(r(3),npts3,i)
        call dolift(0.5d0*r(3) - dble(i-1)*rf3)

        if (dabs(valcnt).le.pmnn(i)) then
         idrcol = 11
         cntval = valcnt
         call cntour(denn( (i-1)*mx3d2 + 1),npts2,npts2,npts1,
     &               height,cntval,x,iedlog)

         cntval = -1.0d0*valcnt
         if (.not.(dolap.and..not.lapdbl)) then
            idrcol = 1
            call cntour(denn( (i-1)*mx3d2 + 1),npts2,npts2,npts1,
     &                  height,cntval,x,iedlog)
         endif

        endif
      end do
 
      rf1 = r(1)/dble(npts1-1)
      cx = vt1(1)
      cy = vt1(2)
      cz = vt1(3)
      v1(1) = cxt
      v1(2) = cyt
      v1(3) = czt
      do i=1,3
         rt(i) = r(i)
      end do
      r(1) = rt(3)
      r(3) = rt(1)

      call vsc1(v1,1.0d0,1.0d-4)

      do i=1,npts1
         px = pxt
         py = pyt
         pz = pzt
         ij = 0
         do k=1,npts3
            do j=1,npts2
               ij = ij + 1
               dens(ij) = 
     &           denn( (npts3-k)*mx3d2 + (j+npts2*((npts1-i+1)-1)))
            end do
         end do
         call precz(rt(1),npts1,i)
         call dolift(0.5d0*rt(1) - dble(i-1)*rf1)

         cntval = valcnt
         idrcol = 11
         call cntour(dens,npts2,npts2,npts3,height,cntval,x,iedlog)
         cntval = -1.0d0*valcnt
         if (.not.(dolap.and..not.lapdbl)) then
            idrcol = 1
            call cntour(dens,npts2,npts2,npts3,height,cntval,x,iedlog)
         endif
      end do

100   continue
      euclid = euctmp 
      cntval = 99.999d0
      px = pxt
      py = pyt
      pz = pzt
      pmin = pmint
      pmax = pmaxt
      cx = cxt
      cy = cyt
      cz = czt
      do i=1,3
         v1(i) = vt1(i)
         v2(i) = vt2(i)
      end do
      do i=1,3
         r(i) = rt(i)
      end do

      iproj = 1

      call docent
      call doscal
      call setxyv

      return
      end

      subroutine isoded(valc,nvalc,scincr,nespt,iwhere,
     &                  dens,iedlog)
      implicit double precision (a-h,o-z)

c THIS IS REALLY isoden

      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (mesp = (max3d*max3d*max3d+max3d)/4)
      parameter (mdum = (max3d*max3d*max3d+max3d) - mesp*4)
      parameter (mxvalc=10)
      logical euclid, yes, euctmp
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      logical oscal,ostep,fine
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /pntsta/ iproj,idrcol,nesp
      common /spa3d/  connl(3,mesp), esp(mesp), dum(mdum)
      common /srfhlp/ edge,ctval(mxvalc),pxyz(3),mvalc,nspts,istyp
      common /plot/   iplot,iplwin,icolps
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension vt1(3),vt2(3),valc(*),rtmp(3)
      dimension dens(*),iedlog(*)

      if (nspts.gt.max3d) then
         call inferr('To many grid points, adjusting !',0)
         nspts = max3d
      endif

      call pareul
      euctmp = euclid
      euclid = .false.
      pxtt = px
      pytt = py
      pztt = pz
      px = pxyz(1)
      py = pxyz(2)
      pz = pxyz(3)
      pxt = px
      pyt = py
      pzt = pz
      pmint = pmin
      pmaxt = pmax
      do i=1,3
         rtmp(i) = r(i)
         r(i) = edge
         vt1(i) = v1(i)
         vt2(i) = v2(i)
      end do
      cxt = cx
      cyt = cy
      czt = cz
      iflag = 1

      rf3 = r(3)/(nspts-1)

      iproj = iwhere
      idrcol = 13
      nesp = 0
      height = 0.0d0
      if (iplot.eq.6) call curs(1)

      call precal(nspts,nspts)

      do i=1,nspts
         px = pxt
         py = pyt
         pz = pzt
         call precz(r(3),nspts,i)
         call dolift(0.5d0*r(3) - dble(i-1)*rf3)
         call grdcal(dens,nspts,nspts,0,1)
         do j=1,nvalc
            call cntour(dens,nspts,nspts,nspts,height,valc(j),x,iedlog)
         end do
      end do


      rf1 = r(1)/(nspts-1)
      cx = vt1(1)
      cy = vt1(2)
      cz = vt1(3)
      v1(1) = cxt
      v1(2) = cyt
      v1(3) = czt
      call vsc1(v1,1.0d0,1.0d-4)

      px = pxt
      py = pyt
      pz = pzt

      call precal(nspts,nspts)

      do i=1,nspts
         px = pxt
         py = pyt
         pz = pzt
         call precz(r(1),nspts,i)
         call dolift(0.5d0*r(1) - dble(i-1)*rf1)
         call grdcal(dens,nspts,nspts,0,1)
         do j=1,nvalc
            call cntour(dens,nspts,nspts,nspts,height,valc(j),x,iedlog)
         end do
      end do

      rf2 = r(2)/(nspts-1)
      cx = vt2(1)
      cy = vt2(2)
      cz = vt2(3)
      v1(1) = vt1(1)
      v1(2) = vt1(2)
      v1(3) = vt1(3)
      v2(1) = cxt
      v2(2) = cyt
      v2(3) = czt
      call vsc1(v2,1.0d0,1.0d-4)

      px = pxt
      py = pyt
      pz = pzt
      call precal(nspts,nspts)

      do i=1,nspts
         px = pxt
         py = pyt
         pz = pzt
         call precz(r(2),nspts,i)
         call dolift(0.5d0*r(2) - dble(i-1)*rf2)
         call grdcal(dens,nspts,nspts,0,1)
         do j=1,nvalc
            call cntour(dens,nspts,nspts,nspts,height,valc(j),x,iedlog)
         end do
      end do

      if (iplot.eq.6) call curs(0)
      iproj = 1

      euclid = euctmp
      px = pxtt
      py = pytt
      pz = pztt
      pmin = pmint
      pmax = pmaxt
      do i=1,3
         r(i) = rtmp(i)
         v1(i) = vt1(i)
         v2(i) = vt2(i)
      end do
      cx = cxt
      cy = cyt
      cz = czt

      nespt = nesp

      return
      end

      subroutine wrsrd(iun,nesp,iesp,
     &                 ianz,iatclr,iconn,coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxel=100)
      parameter (mxcon=10)
      parameter (max3d=61)
      parameter (mxesp=max3d*max3d*max3d+max3d)
      common /surf/ natorg,nosncd
      common /spa3d/ esp(mxesp)
      dimension icnn(mxcon)
      dimension coo(3,*),ianz(*),iatclr(*),iconn(mxcon+1,*)

c write surface file

      toang = 0.52917706d0

      write(iun,'(a)') '[Molden Format]'
      write(iun,'(a)') '[SURFACE]'
      write(iun,'(i5,1x,i5,1x,i1)') nesp,natorg,iesp

      do i=1,nesp

         ibnds = 0

         do j=1,iconn(1,i)

            if (iconn(j+1,i).gt.0) then
               ibnds = ibnds + 1
               icnn(ibnds) = iconn(j+1,i)
            endif

         end do

         if (i.gt.natorg) then

            if (iesp.eq.1) then
              write(iun,'(i3,1x,3(f12.6),1x,f12.6,1x,6(i5,1x))')
     &        ianz(i),(coo(j,i)*toang,j=1,3),
     &        esp(i),(icnn(j),j=1,ibnds)
            else
              write(iun,'(i3,1x,3(f12.6),1x,i2,1x,6(i5,1x))')
     &        ianz(i),(coo(j,i)*toang,j=1,3),
     &        iatclr(i),(icnn(j),j=1,ibnds)
            endif

         else

            write(iun,'(i3,1x,3(f12.6),1x,6(i5,1x))')
     &        ianz(i),(coo(j,i)*toang,j=1,3),
     &        (icnn(j),j=1,ibnds)

         endif

      end do

      return
      end

      subroutine rdsrd(iun,istats,iesp,iaddprv,idebug,
     &                 ianz,iaton,iatclr,iresid,iconn,coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (max3d=61)
      parameter (mxesp=max3d*max3d*max3d+max3d)
      common /athlp/ iatoms, mxnat
      common /surf/  natorg,noscnd
      common /spa3d/ esp(mxesp)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*137 line,str
      common /curlin/ line
      logical gnreal
      integer getlin
      dimension r(4)
      dimension coo(3,*),ianz(*),iatclr(*),iconn(mxcon+1,*),
     &          iresid(*),iaton(*)

c read surface file

      istats = 1
      iuntmp = iun2
      iun2 = iun

      toang = 0.52917706d0

      call rewfil
      call searchu(line,'[SURFACE]',istat)
      if (istat.eq.0) goto 110
      iesp = 0

      if (getlin(0).eq.1) then
          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.2) then
             natoms = itype
             if (natoms.gt.mxnat) then
                 natoms = mxnat
                 call inferr('Exceeding MaxNum of atoms !',0)
             endif
             if (idebug.eq.1) print*,'iatoms=',natoms
             if (iaddprv.eq.1) then
                if (natoms+iatoms.gt.mxnat) then
                    call inferr('Exceeding MaxNum of atoms !',0)
                    goto 100
                endif
                iscst = iatoms
                nscnd = natoms
                ialtyp = 0
             else
                iscst = 0
             endif
          else 
             goto 100
          endif
          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.2) then
             natot = itype
             if (idebug.eq.1) print*,'natorg=',natot
          else 
             goto 100
          endif
          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.2) then
             iesp = itype
             if (idebug.eq.1) print*,'iesp=',iesp
          else 
             iesp = 1
          endif
      endif

      do i=1+iscst,natoms+iscst

         if (getlin(0).eq.1) then

             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.2) then
                ianz(i) = itype
             else
                goto 100
             endif

             if (gnreal(r,3,.false.)) then
                do j=1,3
                   coo(j,i) = r(j) / toang
                end do
             else
                goto 100
             endif

             if (i.gt.natot+iscst) then
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (iesp.eq.1.and.ktype.eq.3) then
                    esp(i) = rtype
                    iatclr(i) = 12
                elseif (iesp.eq.0.and.ktype.eq.2) then
                    iatclr(i) = itype
                else
                   goto 100
                endif
             else
                iatclr(i) = 12
             endif

             nc = 0
             do j=1,mxcon
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.2) then
                   if (itype.le.mxnat) then
                      iconn(j+1,i) = itype + iscst
                      nc = nc + 1
                   endif
                endif
             end do
             iconn(1,i) = nc
            
             iresid(i) = -4
             iaton(i) = 1

         else
            goto 100
         endif

      end do

      if (iaddprv.eq.1) then
         iatoms = iatoms + natoms
      else
         iatoms = natoms
         natorg = natot
      endif

      iun2 = iuntmp

      call doscal

      return

100   call inferr('Error reading surface file !',0)
      if (idebug.eq.1) print*,'line=',line
110   iuntmp = iun2
      istats = 0

      return
      end

      subroutine getzd(natoms,izo,ido,istatz,cc,ianc,
     &              bl,alph,bet,ibl,ialph,ibet,imap,ianz,iz,
     &              c,cz,alpha,beta,ian)

c this is really getzm

      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str
      character*2 catom,catomt,tolowf,iel
      parameter (maxat=1000)
      parameter (maxat3=maxat*3)
      logical oparse,ottest,oerror,ovar
      common /zmfrst/ ihaszm, nz, mxzat
      common /hlpzm/ iloos
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension ian(*),c(3,*),cz(3,*),alpha(*),beta(*)
      dimension ianc(*),cc(3,*)
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianz(*),iz(4,*)

      dimension iel(100)
      character*10 varnam,vartmp
      character*1 stmp
      dimension varnam(maxat3),ivar(maxat3),rvar(maxat3),ilnk(maxat3)
      character*137 line
      common /curlin/ line
      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x '/

      istatz = 0
      oparse = .false.
      maxnz = mxzat
      ottest=.true.
      if (izo.eq.0) then
         do i=1,3
            do j=1,4
             iz(j,i) = 0
            end do
         end do
         nz = 0
      endif
      ikeyzm = 0

      nzz = nz

100   continue
      ielins = 0
      if (izo.eq.1) then
         nz = nzz
      else
         nz = 0
      endif
      nzzt = 0
      izmat = 0
      do while (getlin(0).eq.1)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
           if ((str(1:4).eq.'vari'.or.str(1:4).eq.'VARI'
     &      .or.str(1:4).eq.'cons'.or.str(1:4).eq.'CONS'
     &      .or.str(1:4).eq.'end'.or.str(1:4).eq.'END').and.izmat.eq.1)
     &     then
             ielins = 1
             goto 200
           endif
           if (nstr.le.10.and.
     &     (str(1:4).eq.'zmat'.or.str(1:4).eq.'ZMAT')) then
             nz = nzz
             nzzt = 0
             ikeyzm = 1
             izmat = 1
             goto 150
           endif
           if (nstr.le.10) then
              nz = nz + 1
              nzzt = nzzt + 1
              numv = 3
              if (nzzt.le.3) numv = nzzt - 1
c
c Atom String
c
              if (oparse) then
                 if (nstr.eq.1) then
                    catomt(1:1) = str(1:1)
                    catomt(2:2) = ' '
                 else
                    catomt = str(1:2)
                    if (catomt(2:2).eq.'-') catomt(2:2) = ' '
                 endif
                 catom = tolowf(catomt)
                 do j=1,100
                    if (catom .eq. iel(j)) ianz(nz) = j - 1
                 end do
                 if (catom.eq.'xx') ianz(nz) = 99
              endif
              do j=1,numv
c
c Connectivity
c
                 if (nxtwrd(str,nstr,itype,rtype).ne.2) then
                    if (nzzt.eq.2) call bckfil
                    goto 100
                 else
                    if (oparse) iz(j,nz) = itype
                 endif
c
c Variable
c
                 ktype = nxtwrd(str,nstr,itype,rtype)
                 if (ktype.eq.0) then
                    if (nzzt.eq.2) call bckfil
                    goto 100
                 elseif (ktype.eq.1.and.nstr.gt.10) then
                    if (nzzt.eq.2) call bckfil
                    goto 100
                 elseif (ktype.eq.1.and.oparse) then
                    ovar = .false.
                    do k=1,nvars
                       if (str(1:nstr).eq.varnam(k)(1:ivar(k))) then
                          tmpvar = rvar(k)
                          if (ilnk(k).le.0) then
                             ivart = ilnk(k)+1
                             ilnk(k) = nz
                          else
                             ivart = ilnk(k)
                          endif
                          ovar = .true.
                       endif
                       if (nstr.gt.1) then
                          if (str(2:nstr).eq.varnam(k)(1:ivar(k)).and.
     &                        str(1:1).eq.'-') then
                             tmpvar = -rvar(k)
                             if (ilnk(k).le.0) then
                                ivart = ilnk(k)+1
                                ilnk(k) = nz
                             else
                                ivart = -ilnk(k)
                             endif
                             ovar = .true.
                          endif
                          if (str(2:nstr).eq.varnam(k)(1:ivar(k)).and.
     &                        str(1:1).eq.'+') then
                             tmpvar = rvar(k)
                             if (ilnk(k).le.0) then
                                ivart = ilnk(k)+1
                                ilnk(k) = nz
                             else
                                ivart = ilnk(k)
                             endif
                             ovar = .true.
                          endif
                       endif
                    end do
                    if (.not.ovar.and.nvars.ne.0) then
c                       if (nz.le.2) return
                       if (nzzt.le.2) then
                           if (nzzt.eq.2) call bckfil
                           goto 100
                       endif
                       call inferr(
     &                   'Gauss/Gamess: Missing Variable Name !',1)
                       call inferr(
     &                   'Variable: '//str(1:nstr),1)
                       return
                    endif
                 elseif (ktype.eq.2.and.oparse) then
                     tmpvar = 1.0d0*itype 
                     ivart = 0
                 elseif (ktype.eq.3.and.oparse) then
                     tmpvar = rtype 
                     ivart = 0
                 endif
                 if (oparse) then
                    if (j.eq.1) then
                       bl(nz) = tmpvar
                       if (izo.eq.1) then
                          ibl(nz) = 1
                       else
                          ibl(nz) = ivart
                       endif
                    elseif (j.eq.2) then
                       alph(nz) = tmpvar 
                       if (izo.eq.1) then
                          ialph(nz) = 1
                       else
                          ialph(nz) = ivart
                       endif
                    elseif (j.eq.3) then
                       bet(nz) = tmpvar
                       if (izo.eq.1) then
                          ibet(nz) = 1
                       else
                          ibet(nz) = ivart
                       endif
                    endif
                 endif
              end do
c
c Check for Gamess ITYPE
c
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (oparse) iz(4,nz) = 0
              if (ktype.ne.0) then
                 if (ktype.eq.2) then
                     if (oparse.and.(abs(itype).eq.1.or.itype.eq.0)) 
     &                   iz(4,nz) = itype
                 elseif (ktype.eq.3) then
                     if (oparse.and.abs(rtype).eq.1.0d0)
     &                   iz(4,nz) = int(rtype)
                 elseif (ktype.eq.1.and.nstr.eq.1) then
                     stmp = str(1:1)
                     if (stmp.eq.'L'.or.stmp.eq.'l'.or.
     &                   stmp.eq.'H'.or.stmp.eq.'h'.or.
     &                   stmp.eq.'M'.or.stmp.eq.'m') then
                     else
                        if (nzzt.eq.2) call bckfil
                        goto 100
                     endif
                 else
                     if (nzzt.eq.2) call bckfil
                     goto 100
                 endif
              endif
           endif
c
c Empty Line
c
         elseif (ktype.eq.0.and.nzzt.gt.1) then
           ielins = 1
           goto 200
         else
c
c First word is not a string
c
           goto 100
         endif
150      continue
      end do
c
c Out of Lines, Didnt Find Zmat
c
      
      return

200   continue
c
c Found Zmat
c
      if (oparse) goto 500

c
c Get Variables Constants if any
c
300   if (ielins.eq.1) then
        nvars = 0
        do while (getlin(1).eq.1)
          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.1) then
            if (str(1:4).eq.'cons'.or.str(1:4).eq.'CONS') then
               ielins = 2
            elseif (str(1:3).eq.'end'.or.str(1:3).eq.'END') then
               goto 400
            else
               if (nstr.gt.10) goto 400
               vartmp = str
               ntmp = nstr
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.ne.2.and.ktype.ne.3) goto 400
               nvars = nvars + 1
               varnam(nvars) = vartmp
               ivar(nvars) = ntmp
               ilnk(nvars) = 0
               if (ielins.eq.2) ilnk(nvars) = -1
               if (ktype.eq.2) rvar(nvars) = 1.0d0*itype
               if (ktype.eq.3) rvar(nvars) = rtype
            endif
          elseif (ktype.eq.0) then
            ielins = ielins + 1
            if (ielins.eq.3) goto 400
          else
             goto 400
          endif
        end do
      endif

400   if (ido.eq.1) then
          icnt = 0
          istmp = 0
          do while (getlin(1).eq.1)
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.1) then
                if (nstr.ge.3) then
                   if (icdex(str,'map').ne.0) istmp = 1
                endif
             elseif (ktype.eq.2.and.istmp.eq.1) then
                do i=1,icnt
                   if (itype.eq.imap(i)) then
                      call inferr('Two map numbers are equal!!',0)
                      return
                   endif
                end do
                icnt = icnt + 1
                imap(icnt) = itype
             endif
          end do
          if (icnt.ne.nz) then
              call inferr('Not enough map numbers !!',0)
              return
          endif
      endif

      if (ikeyzm.eq.1) then
         call scback(line,'zmat',istat)
      else
         call rewfil
      endif
      
      oparse = .true.
      goto 100

500    continue
      if (iloos.eq.0) then
         if (nz.le.2) return
      else 
         if (nz.lt.2) return
      endif
      istatz = 1
c      do i=1,nz
c         print*,ianz(i),bl(i),alph(i),bet(i),(iz(j,i),j=1,4)
c      end do
      if (izo.eq.1.or.ido.eq.1) return
      call stoc(maxnz,nz,0,0,0,ianz,iz,bl,alph,bet,
     &       ottest,natoms,ian,c,cz,imap,alpha,beta,
     &       oerror,.true.,.true.)
      if (oerror) then
         istatz = 0
      else
         ihaszm = 1
         do i=1,natoms
            do j=1,3
               cc(j,i) = c(j,i)
            end do
            ianc(i) = ian(i)
         end do
      endif

      return
      end

      subroutine lbfgd(emin,ggtol,nsd,x,g,diag,w)
      implicit real (a-h,o-z), integer (i-n)
      common /lb3/gtol,stpmin,stpmax
      common /athlp/   iatoms, mxnat
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      logical osingl,dolbfgs,oqscal
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /cell/ xa,ya,yb,za,zb,zc
      common /convg/ icyc
      dimension x(*),g(*),diag(*),w(*)

      write(iun5,*) 'L-BFGS method'
      write(iun5,*) ' '

      gtol = 0.9e0
      stpmin = 1.0e-20
      stpmax = 1.0e+20
      iwrite = 1

      n = iatoms*3

      if (cell) then
         x(n+1) = xa
         x(n+2) = ya
         x(n+3) = yb
         x(n+4) = za
         x(n+5) = zb
         x(n+6) = zc

         n = n + 6
      endif

      m = 5


      eps    = ggtol

      xtol   = 1.0e-16
      write(iun5,*) 'Gradient tolerance: ',eps
      write(iun5,*) 'Maximum iterations: ',nsd
      write(iun5,*) ' '

      ncyc  = 0
      icyc  = 0

      iflag  = 0

      do while (.true.)

         call enegrd(emin,x,g)
         call rmsg(n,g,rmsgrd)

         if (osingl) then
             write(iun5,'(a,f12.3)') 'Estat=',emin
             return
         endif

         do i=1,n
            g(i) = -g(i)
         end do

         call dlbfgs(n,m,x,emin,g,diag,eps,xtol,w,iflag)
         if (iflag.eq.0) return
         if (iflag.lt.0) then
                return
         endif

c  We have found a lower energy.
      
         ncyc = ncyc + 1

c  Write out the minimized structure

         if (mod(ncyc,iwrite) .eq. 0) then

c     arc file
             if (iarc.eq.1) call wrtout(iun4,emin)

c     intermediate file

             icyc = icyc + 1
             if (imon.ne.0) call wrmon(icyc,emin)

             if (usesw) then
                if (mod(icyc,10).eq.0) call bldlst
             endif

         end if

         if (ncyc.gt.nsd) then
             write(iun5,*) 'Exceeded maximum interations ',nsd
             return
         endif

      end do

      return
      end

      subroutine dlbfgs(n,m,x,f,g,diag,eps,xtol,w,iflag)
      implicit real (a-h,o-z), integer (i-n)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension x(*),g(*),diag(*),w(*)

c        limited memory bfgs method for large scale optimization
c                          jorge nocedal

      common /lb3/gtol,stpmin,stpmax
      common /rdwr/ iun1,iun2,iun3,iun4,iun5

      integer bound,cp,point
      logical finish
      save

c     initialize

      if (iflag.eq.1)  goto 172

      iter = 0
      
      if (n.le.0.or.m.le.0) goto 196

      if (gtol.le.1.e-04) then
        write(iun5,245)
        gtol = 9.e-01
      endif

      nfun   = 1
      point  = 0
      finish = .false.

      do i=1,n
         diag(i) = 1.0e0
      end do

      ispt = n+2*m
      iypt = ispt+n*m     

      do i=1,n
         w(ispt+i) = -g(i)*diag(i)
      end do

      gnorm = sqrt(ddot(n,g,g))
      gpnorm = sqrt(ddot(n,g,g)/dble(n))
      stp1  = 1.0e0/gnorm

c     parameters for line search routine
     
      ftol   = 1.0e-4
      maxfev = 20

      call prtene(nfun,f,gpnorm)

c    --------------------
c     main iteration loop
c    --------------------

100      continue

         iter  = iter+1
         info  = 0
         bound = iter-1

         if (iter.ne.1) then
            if (iter.gt.m) bound = m

            ys = ddot(n,w(iypt+npt+1),w(ispt+npt+1))
            yy = ddot(n,w(iypt+npt+1),w(iypt+npt+1))

            do i=1,n
               diag(i) = ys/yy
            end do

            cp = point
            if (point.eq.0) cp = m
            w(n+cp) = 1.0e0/ys

            do i=1,n
               w(i) = -g(i)
            end do

            cp = point
   
            do i=1,bound
               cp = cp-1
               if (cp.eq. -1) cp = m-1
               sq = ddot(n,w(ispt+cp*n+1),w)
               inmc = n + m + cp + 1
               iycn = iypt + cp*n
               w(inmc) = w(n+cp+1)*sq
               call daxpy(n,-w(inmc),w(iycn+1),w)
            end do

            do i=1,n
               w(i) = diag(i)*w(i)
            end do

            do i=1,bound

               yr   = ddot(n,w(iypt+cp*n+1),w)
               beta = w(n+cp+1)*yr
               inmc = n + m + cp + 1
               beta = w(inmc)-beta
               iscn = ispt + cp*n

               call daxpy(n,beta,w(iscn+1),w)

               cp   = cp + 1
               if (cp.eq.m) cp = 0

            end do

            do i=1,n
               w(ispt+point*n+i) = w(i)
            end do

         endif

         nfev = 0
         stp  = 1.0e0
         if (iter.eq.1) stp = stp1

         do i=1,n
            w(i) = g(i)
         end do

 172     continue

         call mcsrch(n,x,f,g,w(ispt+point*n+1),stp,ftol,
     &               xtol,maxfev,info,nfev,diag)
         if (info .eq. -1) then
            iflag = 1
            return
         endif

         if (info.ne.1) goto 190

         nfun = nfun + nfev

c     compute the new step and gradient change 

         npt = point*n
         do i=1,n
            w(ispt+npt+i) = stp*w(ispt+npt+i)
            w(iypt+npt+i) = g(i)-w(i)
         end do

         point = point + 1
         if (point.eq.m) point = 0

c     termination test

         gnorm = sqrt(ddot(n,g,g))
         gpnorm = sqrt(ddot(n,g,g)/dble(n))
         xnorm = sqrt(ddot(n,x,x))
         xnorm = max(1.0e0,xnorm)

         if (gpnorm .le. eps) finish = .true.

         call prtene(nfun,f,gpnorm)

         if (finish) then
            write(iun5,*) 'Optimisation Converged'
            iflag = 0
            return
         endif

      goto 100

c     end of main iteration loop. error exits.

 190  iflag=-1
      write(iun5,200) info
      return

 195  iflag=-2
      write(iun5,235) i
      return

 196  iflag= -3
      write(iun5,240)

c     formats

 200  format(/' iflag= -1 ',/' line search failed. see',
     &        ' documentation of routine mcsrch',/' error return',
     &        ' of line search: info= ',i2,/
     &        ' possible causes: function or gradient are incorrect',/,
     &        ' or incorrect tolerances')
 235  format(/' iflag= -2',/' the',i5,'-th diagonal element of the',/,
     &       ' inverse hessian approximation is not positive')
 240  format(/' iflag= -3',/' improper input parameters (n or m',
     &       ' are not positive)')
 245  format(/'  gtol is less than or equal to 1.e-04',
     &       / ' it has been reset to 9.e-01')

      return
      end

      subroutine daxpy(n,da,dx,dy)
      implicit real (a-h,o-z), integer (i-n)
      dimension dx(*),dy(*)

      if (n.le.0.or.da.eq.0.0e0) return

      m = mod(n,4)

      if (m.ne.0) then
         do i= 1,m
           dy(i) = dy(i) + da*dx(i)
         end do

         if (n.lt.4) return

      endif

      mp1 = m + 1

      do i= mp1,n,4
         dy(i)   = dy(i)   + da*dx(i)
         dy(i+1) = dy(i+1) + da*dx(i+1)
         dy(i+2) = dy(i+2) + da*dx(i+2)
         dy(i+3) = dy(i+3) + da*dx(i+3)
      end do

      return
      end

      real function ddot(n,dx,dy)

c     forms the dot product of two vectors.

      implicit real (a-h,o-z), integer (i-n)
      dimension dx(*),dy(*)

      ddot = 0.0e0
      dtemp = 0.0e0

      if (n.le.0) return


      m = mod(n,5)
      if (m.ne.0) then

          do i=1,m
            dtemp = dtemp + dx(i)*dy(i)
          end do

          if (n.lt.5) goto 60
      endif

      mp1 = m + 1

      do i = mp1,n,5
         dtemp = dtemp + dx(i)*dy(i) + dx(i+1)*dy(i+1) +
     &   dx(i+2)*dy(i+2) + dx(i+3)*dy(i+3) + dx(i+4)*dy(i+4)
      end do


60    ddot = dtemp

      return
      end


      subroutine mcsrch(n,x,f,g,s,stp,ftol,xtol,maxfev,info,nfev,wa)

c     line search routine

      implicit real (a-h,o-z), integer (i-n)
      common /lb3/gtol,stpmin,stpmax
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      save
      logical brackt,stage1

      dimension x(*),g(*),s(*),wa(*)

      if (info.ne.-1) then

         infoc = 1


         if (n .le. 0 .or. stp .le. 0.0e0 .or. ftol .lt. 0.0e0 .or.
     &    gtol .lt. 0.0e0 .or. xtol .lt. 0.0e0 .or. stpmin .lt. 0.0e0
     &    .or. stpmax .lt. stpmin .or. maxfev .le. 0) return

         dginit = 0.0e0

         do j = 1, n
            dginit = dginit + g(j)*s(j)
         end do

         if (dginit .ge. 0.0e0) then
            write(iun5,'(a)')
     &       '  the search direction is not a descent direction'
            return
         endif


         brackt = .false.
         stage1 = .true.
         nfev = 0
         finit = f
         dgtest = ftol*dginit
         width = stpmax - stpmin
         width1 = width/0.5e0

         do j = 1, n
            wa(j) = x(j)
         end do

         stx = 0.0e0
         fx  = finit
         dgx = dginit
         sty = 0.0e0
         fy  = finit
         dgy = dginit
   
      endif

c     start of iteration.

      do while (.true.)

         if (info.ne.-1) then
            if (brackt) then
               stmin = min(stx,sty)
               stmax = max(stx,sty)
            else
               stmin = stx
               stmax = stp + 4.0e0*(stp - stx)
            end if

            stp = max(stp,stpmin)
            stp = min(stp,stpmax)


            if ((brackt .and. (stp.le.stmin .or. stp.ge.stmax))
     &      .or. nfev.ge.maxfev-1 .or. infoc.eq.0
     &      .or. (brackt .and. stmax-stmin.le.xtol*stmax)) stp = stx

            do j = 1, n
               x(j) = wa(j) + stp*s(j)
            end do

            info = -1
            return

         endif

         info = 0
         nfev = nfev + 1
         dg = 0.0e0

         do j = 1, n
            dg = dg + g(j)*s(j)
         end do

         ftest1 = finit + stp*dgtest

c        test for convergence.

         if ((brackt .and. (stp.le.stmin .or. stp.ge.stmax))
     &      .or. infoc.eq.0) info = 6

         if (stp.eq.stpmax .and.
     &       f.le.ftest1 .and. dg.le.dgtest) info = 5

         if (stp.eq.stpmin .and.
     &       (f.gt.ftest1 .or. dg.ge.dgtest)) info = 4

         if (nfev.ge.maxfev) info = 3

         if (brackt .and. stmax-stmin.le.xtol*stmax) info = 2

         if (f.le.ftest1 .and. abs(dg).le.gtol*(-dginit)) info = 1

c        check for termination.

         if (info.ne.0) return


         if (stage1 .and. f.le.ftest1 .and.
     &       dg.ge.min(ftol,gtol)*dginit) stage1 = .false.

         if (stage1 .and. f.le.fx .and. f.gt.ftest1) then

            fm   = f - stp*dgtest
            fxm  = fx - stx*dgtest
            fym  = fy - sty*dgtest
            dgm  = dg - dgtest
            dgxm = dgx - dgtest
            dgym = dgy - dgtest

            call mcstep(stx,fxm,dgxm,sty,fym,dgym,stp,fm,dgm,
     &                 brackt,stmin,stmax,infoc)

            fx = fxm + stx*dgtest
            fy = fym + sty*dgtest
            dgx = dgxm + dgtest
            dgy = dgym + dgtest

         else

            call mcstep(stx,fx,dgx,sty,fy,dgy,stp,f,dg,
     &                 brackt,stmin,stmax,infoc)
         end if

         if (brackt) then

            if (abs(sty-stx).ge.0.66e0*width1)
     &          stp = stx + 0.5e0*(sty - stx)
            width1 = width
            width  = abs(sty-stx)

         end if

      end do

      return
      end

      subroutine mcstep(stx,fx,dx,sty,fy,dy,stp,fp,dp,brackt,
     &                  stpmin,stpmax,info)
      implicit real (a-h,o-z), integer (i-n)
      logical brackt,bound

c     the purpose of mcstep is to compute a safeguarded step for
c     a linesearch and to update an interval of uncertainty for
c     a minimizer of the function.
 

      info = 0

c     check the input parameters for errors.

      if ((brackt .and. (stp .le. min(stx,sty) .or.
     &    stp .ge. max(stx,sty))) .or.
     &    dx*(stp-stx) .ge. 0.0e0 .or. stpmax .lt. stpmin) return

c     determine if the derivatives have opposite sign.

      sgnd = dp*(dx/abs(dx))

c     first case. a higher function value.
c     the minimum is bracketed. if the cubic step is closer
c     to stx than the quadratic step, the cubic step is taken,
c     else the average of the cubic and quadratic steps is taken.

      if (fp .gt. fx) then

              info = 1
              bound = .true.
              theta = 3*(fx - fp)/(stp - stx) + dx + dp
              s = max(abs(theta),abs(dx),abs(dp))
              gamma = s*sqrt((theta/s)**2 - (dx/s)*(dp/s))
              if (stp .lt. stx) gamma = -gamma
              p = (gamma - dx) + theta
              q = ((gamma - dx) + gamma) + dp
              r = p/q
              stpc = stx + r*(stp - stx)
              stpq = stx + ((dx/((fx-fp)/(stp-stx)+dx))/2)*(stp - stx)

              if (abs(stpc-stx) .lt. abs(stpq-stx)) then
                 stpf = stpc
              else
                stpf = stpc + (stpq - stpc)/2
              end if

              brackt = .true.

c     second case. a lower function value and derivatives of
c     opposite sign. the minimum is bracketed. if the cubic
c     step is closer to stx than the quadratic (secant) step,
c     the cubic step is taken, else the quadratic step is taken.

      else if (sgnd .lt. 0.0) then

              info = 2
              bound = .false.
              theta = 3*(fx - fp)/(stp - stx) + dx + dp
              s = max(abs(theta),abs(dx),abs(dp))
              gamma = s*sqrt((theta/s)**2 - (dx/s)*(dp/s))
              if (stp .gt. stx) gamma = -gamma
              p = (gamma - dp) + theta
              q = ((gamma - dp) + gamma) + dx
              r = p/q
              stpc = stp + r*(stx - stp)
              stpq = stp + (dp/(dp-dx))*(stx - stp)

              if (abs(stpc-stp) .gt. abs(stpq-stp)) then
                 stpf = stpc
              else
                 stpf = stpq
              end if

              brackt = .true.

c     third case. a lower function value, derivatives of the
c     same sign, and the magnitude of the derivative decreases.
c     the cubic step is only used if the cubic tends to infinity
c     in the direction of the step or if the minimum of the cubic
c     is beyond stp. otherwise the cubic step is defined to be
c     either stpmin or stpmax. the quadratic (secant) step is also
c     computed and if the minimum is bracketed then the the step
c     closest to stx is taken, else the step farthest away is taken.

      else if (abs(dp) .lt. abs(dx)) then

              info = 3
              bound = .true.
              theta = 3*(fx - fp)/(stp - stx) + dx + dp
              s = max(abs(theta),abs(dx),abs(dp))

c        the case gamma = 0 only arises if the cubic does not tend
c        to infinity in the direction of the step.

              gamma = s*sqrt(max(0.0e0,(theta/s)**2 - (dx/s)*(dp/s)))

              if (stp .gt. stx) gamma = -gamma

              p = (gamma - dp) + theta
              q = (gamma + (dx - dp)) + gamma
              r = p/q

              if (r .lt. 0.0e0 .and. gamma .ne. 0.0e0) then
                 stpc = stp + r*(stx - stp)
              else if (stp .gt. stx) then
                 stpc = stpmax
              else
                 stpc = stpmin
              endif

              stpq = stp + (dp/(dp-dx))*(stx - stp)

              if (brackt) then

                 if (abs(stp-stpc) .lt. abs(stp-stpq)) then
                    stpf = stpc
                 else
                    stpf = stpq
                 end if

              else

                 if (abs(stp-stpc) .gt. abs(stp-stpq)) then
                    stpf = stpc
                 else
                    stpf = stpq
                 end if

              end if

c     fourth case. a lower function value, derivatives of the
c     same sign, and the magnitude of the derivative does
c     not decrease. if the minimum is not bracketed, the step
c     is either stpmin or stpmax, else the cubic step is taken.

      else

              info = 4
              bound = .false.

              if (brackt) then
                 theta = 3*(fp - fy)/(sty - stp) + dy + dp
                 s = max(abs(theta),abs(dy),abs(dp))
                 gamma = s*sqrt((theta/s)**2 - (dy/s)*(dp/s))
                 if (stp .gt. sty) gamma = -gamma
                 p = (gamma - dp) + theta
                 q = ((gamma - dp) + gamma) + dy
                 r = p/q
                 stpc = stp + r*(sty - stp)
                 stpf = stpc
              else if (stp .gt. stx) then
                 stpf = stpmax
              else
                 stpf = stpmin
              end if

      endif

c     update the interval of uncertainty. this update does not
c     depend on the new step or the case analysis above.

      if (fp .gt. fx) then

         sty = stp
         fy = fp
         dy = dp

      else

         if (sgnd.lt.0.0e0) then
            sty = stx
            fy = fx
            dy = dx
         end if

         stx = stp
         fx = fp
         dx = dp

      endif

c     compute the new step and safeguard it.

      stpf = min(stpmax,stpf)
      stpf = max(stpmin,stpf)
      stp = stpf

      if (brackt .and. bound) then

         stt = stx+0.66*(sty-stx)

         if (sty .gt. stx) then
            stp = min(stt,stp)
         else
            stp = max(stt,stp)
         endif

      endif

      return
      end

      subroutine rmsg(n,g1,rmsgrd)
      implicit real (a-h,o-z), integer (i-n)
      dimension g1(*)

      g1g1 = 0.0e0
      do i=1,n
         g1g1   = g1g1 + g1(i)*g1(i)
      end do

      rmsgrd = sqrt(g1g1/dble(n))

      return
      end

      subroutine vsc1(a,scale,tol)
      implicit double precision (a-h,o-z)
      dimension a(3)

      rlen = vlen(a)

      if (rlen.gt.tol) then
         do i=1,3
            a(i) = a(i)*scale/rlen
         end do
      endif

      return
      end

      subroutine vnrm(a)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(3)

      vl = vlen(a)

      if (vl.gt.0.0d0) then
         do i=1,3
            a(i) = a(i)/vl
         end do
      endif

      return
      end

      subroutine vscal(a,n,scale)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(n)


      do i=1,n
         a(i) = a(i)*scale
      end do

      return
      end

      subroutine vcpy(a,b,n)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(n),b(n)

      do i=1,n
         a(i) = b(i)
      end do

      return
      end

      subroutine v3cpy1(a,b,n,iel)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(3,n),b(n)

      do i=1,n
         a(iel,i) = b(i)
      end do

      return
      end

      subroutine v3cpy2(a,b,n,iel)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(n),b(3,n)

      do i=1,n
         a(i) = b(iel,i)
      end do

      return
      end

      subroutine vadd(a,b,c,n)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(n),b(n),c(n)

      do i=1,n
         c(i) = a(i) + b(i)
      end do

      return
      end

      subroutine v3add1(a,b,c,n,iel)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(3,n),b(n),c(n)

      do i=1,n
         c(i) = a(iel,i) + b(i)
      end do

      return
      end

      subroutine v3add2(a,b,c,iel)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(3,*),b(3),c(3)

      do i=1,3
         c(i) = a(i,iel) + b(i)
      end do

      return
      end

      subroutine vsub(a,b,c,n)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(n),b(n),c(n)

      do i=1,n
         c(i) = a(i) - b(i)
      end do

      return
      end

      subroutine vseti(ia,n,ival)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension ia(n)

      do i=1,n
         ia(i) = ival
      end do

      return
      end

      subroutine vsetr(a,n,rval)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(n)

      do i=1,n
         a(i) = rval
      end do

      return
      end

      subroutine prev(v,m,n,ndim)
c
c     ----- print out matrices
c     vectors density etc.
c
      implicit double precision (a-h,o-z)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      dimension v(ndim,*)

      max  = 12
      imax = 0

100      imin = imax + 1
         imax = imax + max
         if (imax .gt. m) imax = m
         write (iun3,9008)
         write (iun3,8028) (i,i = imin,imax)
         write (iun3,9008)
         do j = 1,n
            write (iun3,8048) j,(v(j,i),i = imin,imax)
         end do
         if (imax .lt. m) go to 100

      return
 9008 format(/)
 8028 format(7x,12(3x,i3,3x))
 8048 format(i5,2x,12f9.5)

      end

      subroutine rdgadd(idebug,ibefo,istatio,irtype,ihsend,
     &                  istats,vectrs,vectrb,focc,focb,eiga,eigb,
     &                  nocc,nocb,ncols,ncolb)

c THIS IS REALLY rdgamu

      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line
      real eiga,eigb
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*)
      parameter (one=1.0d+00, two=2.0d+00)

      i0 = 0
      i1 = 1
      i2 = 2
      istats = 1
      istatio = 0
      iuhf = 0

      if (idebug.eq.1) write(iun3,'(a)')'subroutine rdgamu'

c
c==== Read # of basis functions, electrons
c
C**      call search(line,'NUMBER OF BASIS FUNCTIONS',istat)
c.. New GAMESS can handle both cartesian and polar coords
c.. However, it prints eigenvectors in terms of 6d
c..
      call searchd(line,'NUMBER OF CARTESIAN GAUSSIAN BASIS',
     &                  'NUMBER OF BASIS FUNCTIONS',istat)
      if (istat.eq.1) then 
         if (icdex(line,'CARTESIAN GAUSSIAN').ne.0) then
c
c This is a new version of GAMESS.  Lines are wider
c
            read(line,'(47x,i5)') norbs
            call search(line,'NUMBER OF ELECTRONS',istat)
            read(line,'(47x,i5)') nelecs
            call search(line,'NUMBER OF OCCUPIED ORBITALS (ALPHA',istat)
            read(line,'(47x,i5)') nalpha
c           write(*,*) ' ... nalpha = ',nalpha
            call search(line,'NUMBER OF OCCUPIED ORBITALS (BETA ',istat)
            read(line,'(47x,i5)') nbeta
c           write(*,*) ' ... nbeta  = ',nbeta 
            read(line,'(47x,i5)') nbeta

c       ... check if PP used
            call search(line,'PP    =',istat)
c           write(*,*) line(9:12)
            if (line(9:12).eq.'NONE') then
              is_pp=0
            else
              is_pp=1
            endif

c       ... read PP valence electrons
            if (is_pp.eq.1) then
              call search(line,'NUMBER OF ELECTRONS KEPT IN THE ',istat)
              read(line,'(50x,i4)') nelecs
              call redel(line,1)
              read(line,'(50x,i4)') nalpha
              call redel(line,1)
              read(line,'(50x,i4)') nbeta
c             write(*,*) nelecs,nalpha,nbeta
            endif
c
c======= Occupy Orbitals - just in case, done here
c
            do i=1,norbs
              focc(i) = 0.0d0
            end do

            if (nalpha.eq.nbeta) then

              do mel=1,nalpha
                focc(mel) = two
              end do

            else

              do mel=1,nalpha
                focc(mel) = one
              end do

              do mel=1,nbeta
                focb(mel) = one
              end do

            endif
         else 
c
c.. Old GAMESS (Pre-Jan10 2000)
c
            read(line,'(38x,i5)') norbs
            call nxtlin(line,jstat)
            read(line,'(38x,i5)') nelecs

            do i=1,norbs
              focc(i) = 0.0d0
              focb(i) = 0.0d0
            end do

         endif   
      endif   
      call rewfil

      if (norbs .gt. mxorb) then
         call inferr('Exceeding MaxNum of Orbitals!',1)
         goto 1000
      endif

c==== Establish Scftype and Runtype ====

      irtype = 1

      call search(line,'CONTRL OPTIONS',istat)
      call search(line,'SCFTYP=',istat)
      if (index(line,'UHF').ne.0) iuhf=1
c      call search(line,'RUNTYP=',istat)
      if (index(line,'HESSIAN').ne.0) irtype=4

      call search(line,'STATIONARY POINT LOCATION RUN',istat)
      if (istat.eq.1) then
          call search(line,'HSSEND =',istat)
          if (istat.eq.1) then
              if (index(line,' T').ne.0) then
                 if (ihsend.eq.1) then
                    irtype=4
                 else
                    call inferr(
     &               'Use commandlineflag -H for normal modes',0)
                 endif
              endif
          endif
          call search(line,'EQUILIBRIUM GEOMETRY LOCATED',istat)
          if (istat.eq.1) istatio = 1
          if (irtype.ne.4) irtype = 2
      endif

      call rewfil
c
c==== First read coordinates, and vectors
c
      if (istatio.eq.1.and.ibefo.eq.0) then
c
c ====== Stationary Point ================
c
         call search(line,'EQUILIBRIUM GEOMETRY LOCATED',istat)

         call rdmolu(i1,i2,i0,i1,istat)
         call searcht(line,'MOLECULAR ORBITALS',
     &                     '-MCHF- NATURAL ORBITALS',
     &                     'MCSCF NATURAL ORBITALS',istat)
c     &                     'NATURAL ORBITALS IN ATOMIC', istat)
         if (iuhf.eq.1) then
            call redel(line,3)
         else
            call redel(line,1)
         endif
         call rdvecu(vectrs,eiga,focc,norbs,ncols,istats,.false.,
     &               .false.)

         if (iuhf.eq.1) then
            call bckfil
            call bckfil
            call bckfil
            call search(line,'BETA SET',istat)
            call rdvecu(vectrb,eigb,focc,norbs,ncolb,istats,.false.,
     &                  .false.)
         endif

         call inferr('Using Density of stationary point',0)

      else
c
c ====== First Point ===========
c
         call rdmolu(i2,i1,i0,i0,istat)
c STRIPPED a space character because PC-UNIX output misses first column
c         call searcht(line,'          EIGENVECTORS',
         call searcht(line,'         EIGENVECTORS',
     &                     '-MCHF- NATURAL ORBITALS',
     &                     'MCSCF NATURAL ORBITALS',istat)
c     &                     'NATURAL ORBITALS IN ATOMIC',istat)
         call redel(line,1)
         call rdvecu(vectrs,eiga,focc,norbs,ncols,istats,.false.,
     &               .false.)
         if (iuhf.eq.1) then
            call bckfil
            call bckfil
c            call search(line,'          EIGENVECTORS',istat)
            call search(line,'         EIGENVECTORS',istat)
            call redel(line,1)
            call rdvecu(vectrb,eigb,focc,norbs,ncolb,istats,.false.,
     &                  .false.)
         endif
         call inferr('Using Density of first point',0)

      endif

      call rewfil
c
c======= Read Basis Set ===========
c
c     mdebug=idebug
c     idebug=1
      call rdbasg(idebug,.true.,istat)
c     idebug=mdebug

      if (istat.eq.0) goto 1000

      call search(line,'MULLIKEN AND LOWDIN POPULATION ANALYSES',
     &            istat)

c     Alpha

      call search(line,'MULLIKEN ATOMIC POPULATION',istat)
      if (iuhf.eq.1) call redel(line,1)
      call rdpopu(focc,natoms,istats)

c     Beta

      if (iuhf.eq.1) then
         call rewfil
         call search(line,'MULLIKEN ATOMIC POPULATION',istat)
         call search(line,'MULLIKEN ATOMIC POPULATION',istat)
         call redel(line,1)
         call rdpopu(focb,natoms,istats)
      endif

      call xyzcoo(1,0,0)

c>>> Added Pipek-Mezey and Edmiston-Ruedenberg  FPA 3/15/2000

      call rewfil
      call searcht(line,'BOYS ORBITAL LOCALIZATION',
     &                  'LOCALIZED BY THE POPULATION',
     &                  'EDMISTON-RUEDENBERG',istat)
      if (istat.ne.0) then

          if (index(line,'BOYS ORBITAL LOCALIZATION').ne.0) then
              print*,'***** READING BOYS  LOCALIZED ORBITALS *****'
              call search(line,'THE BOYS LOCALIZED ORBITALS ARE',
     &                    istat)
              call rdvecu(vectrs,eiga,focc,norbs,ncols,istats,.true.,
     &                    .false.)

              if (iuhf.eq.1) then
                call search(line,'THE BOYS LOCALIZED ORBITALS ARE',
     &                      istat)
                call rdvecu(vectrb,eigb,focc,norbs,ncolb,istats,.true.,
     &                      .false.)
              endif

          elseif (index(line,'LOCALIZED BY THE POPULATION').ne.0) then

              print*,
     &            '***** READING Pipek-Mezey LOCALIZED ORBITALS *****'
              call search(line,'POPULATION LOCALIZED ORBITALS ARE',
     &                    istat)
              call rdvecu(vectrs,eiga,focc,norbs,ncols,istats,.true.,
     &                    .false.)

              if (iuhf.eq.1) then
                call search(line,'POPULATION LOCALIZED ORBITALS ARE',
     &                     istat)
                call rdvecu(vectrb,eigb,focc,norbs,ncolb,istats,.true.,
     &                      .false.)
              endif

          elseif (index(line,'EDMISTON-RUEDENBERG').ne.0) then

              print*,
     &          '** READING Edmiston-Ruedenberg LOCALIZED ORBITALS**'
              call search(line,'ENERGY LOCALIZED ORBITALS',istat)
              call rdvecu(vectrs,eiga,focc,norbs,ncols,istats,.true.,
     &                    .false.)

              if (iuhf.eq.1) then
                call search(line,'ENERGY LOCALIZED ORBITALS',istat)
                call rdvecu(vectrb,eigb,focc,norbs,ncolb,istats,.true.,
     &                      .false.)
              endif
          endif

c no orbital energies associated with localised orbitals

          do i=1,norbs
              eiga(i) = 0.0e0
              eigb(i) = 0.0e0
          end do

      endif

c-------- Try for GUGA Natural Orbitals

      call rewfil
      call search(line,'NATURAL ORBITALS IN ATOMIC',istat)
      if (istat.ne.0) then
          call rdvecu(vectrs,eiga,focc,norbs,ncols,istats,.false.,
     &                .true.)
c no orbital energies associated with localised orbitals

          do i=1,norbs
              eiga(i) = 0.0e0
              eigb(i) = 0.0e0
          end do

      endif

      call rewfil
c      call gamunmr

      return

1000  istats = 0
      call inferr('ERROR reading GAMESS output file!',1)
      return
      end

      subroutine rdvecu(v,e,focc,norbs,ncol,istats,boys,nos)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxcol=10)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      common /orbhlp/ mxorb,iuhf,ispd
      character*137 line,str
      integer getlin
      real e
      logical boys,reo,nos
      dimension v(*), e(*), focc(*)
      dimension vt(6,mxcol),irord(6)
c
c====== read vectors ==================
c
      istats = 1

      reo = .false.
      irord(1) = 3
      irord(2) = 1
      irord(3) = 2
      irord(4) = 5
      irord(5) = 6
      irord(6) = 4

      lmin = 0
      do while (.true.)

         if (boys) then
             call redel(line,1)
         else
             if (nos) then
                call redel(line,3)
             else
                call redel(line,2)
             endif
         endif

c
c    Get Eigenvalues
c
         if (getlin(0).ne.1) goto 1000
         if (linlen(line).le.1) then
             if (getlin(0).ne.1) goto 1000
         endif
         nc = 0
         do i=1,mxcol
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.0) goto 5
             if (ktype.eq.3) then
                nc = nc + 1
                if (nos) then
                   focc(lmin+i) = rtype
                else
                   e(lmin+i) = rtype
                endif
             elseif (ktype.eq.2.and.boys) then
                nc = nc + 1
             else
                goto 100
             endif
         end do

5        continue
         call redel(line,1)
         
c
c    Get Eigenvectors
c
         istrt = 0
         itel = 0

         do j=1,norbs

            if (getlin(0).ne.1) goto 1000
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.2) goto 100
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.1) goto 100
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.1.and.ktype.ne.2) goto 100
            if (ktype.eq.2) then
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
            endif
            if (istrt.eq.0.and.nstr.eq.3) then
                if (str(1:3).eq.'XXY') then
                   istrt = j
                   itel = 0
                   reo = .true.
                endif
            endif

            do i=1,mxcol
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.0) goto 10
                if (ktype.ne.3) goto 100
                v((lmin+i-1)*mxorb+j) = rtype
            end do
          
10          continue

           if (istrt.ne.0) then
              itel = itel + 1
              do k=1,nc
                 vt(itel,k) = v((lmin+k-1)*mxorb+j)
              end do
           endif

           if (itel.eq.6) then
              do l=1,6
                 do k=1,nc
                    v((lmin+k-1)*mxorb + (istrt+l-1)) = vt(irord(l),k)
                 end do
              end do
              istrt = 0
              itel = 0
           endif

         end do

         lmin = lmin + nc
      end do

100   continue
      ncol = lmin

      if (reo) then
          print*,'========================================'
          print*,'Changed order of F functions:'
          print*,' '
          print*,'xxy,xxz,yyx,yyz,zzx,zzy ->'
          print*,'xyy,xxy,xxz,xzz,yzz,yyz'
          print*,'========================================'
      endif

      return

1000  istats = 0
      call inferr('ERROR reading vectors!',1)
      return
      end

      subroutine rdpopu(focc,natoms,istats)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxcol=10)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      character*137 line,str
      integer getlin
      dimension focc(*)
c
c====== read populations ==================
c
      istats = 1

      
      lmin = 0
      do while (.true.)

         call redel(line,3)

c
c    Get Populations
c
         if (getlin(0).ne.1) goto 1000
         nc = 0
         do i=1,mxcol
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.0) goto 5
             if (ktype.ne.3) goto 100
             nc = nc + 1
             focc(lmin+i) = rtype
         end do

5        continue
         call redel(line,1)
         
c
c    Dummy reads
c
         do j=1,natoms

            if (getlin(0).ne.1) goto 1000
          
         end do

         lmin = lmin + nc
      end do

100   continue
      ncol = lmin

      return

1000  istats = 0
      call inferr('ERROR reading Populations!',1)
      return
      end

      subroutine rdmodu(ilino,iemlin,idocoo,idobohr,istats,
     &                  coo,ianz)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      common /athlp/  iatoms, mxnat
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      character*137 line,str
      integer getlin
      dimension coo(3,*),ianz(*)
c
c====== read molecular geometry ==================
c
c     sline = search this line first
c     iemlin = then skip this many lines
c
      istats = 1
      toang = 0.52917706d0

      if (ilino.eq.1) then
         call search(line,
     &        'COORDINATES OF ALL ATOMS ARE (ANGS)',istat)
      elseif (ilino.eq.2) then
         call search(line,
     &        'ATOM      ATOMIC                      COORDINATES',
     &             istat)
      endif

      if (istat.eq.0) goto 1000
      call redel(line,iemlin)

      if (idocoo.eq.1) then
         iatoms = 0
      else
         natoms = 0
      endif

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) return
         if (index(line,'......').ne.0) return
         if (idocoo.eq.1) then
            iatoms = iatoms + 1
         else
            natoms = natoms + 1
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.gt.2) goto 1000
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 1000
         if (idocoo.eq.1) then
            ianz(iatoms) = rtype
         else
            nat(natoms) = rtype
         endif
         do i=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 1000
            if (idobohr.eq.1) rtype = rtype / toang
            if (idocoo.eq.1) then
               coo(i,iatoms) = rtype
            else
               xyz(i,natoms) = rtype
            endif
         end do
      end do

1000  istats = 0
      call inferr('ERROR reading molecular geometry!',1)
      return
      end

      subroutine gamupd(ipnt,istat,coo,ianz)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (maxfat=1000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat
      common /gammus/iold

      integer getlin
      logical getzmu,usnew
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*137 line,str
      common /curlin/ line
      dimension coo(3,*),ianz(*)

      i0 = 0
      i1 = 1
      i2 = 2
c
c     Read Next Point in geometry optimization
c
      toang=0.52917706d0
      iatoms = 0
      jatoms = 0
      usnew = .false.

      if (iold.eq.1) then
         if (ipnt.eq.1) then
            call searchd(line,
     &       'ATOM      ATOMIC                      COORDINATES',
     &                'GRADIENT (HARTREE/BOHR)',istat)
         else
            call searchd(line,'COORDINATES OF ALL ATOMS ARE (ANGS)',
     &                'GRADIENT (HARTREE/BOHR)',istat)
         endif
         
         if (index(line,'ALL ATOMS').ne.0.or.
     &       index(line,'ATOM      ATOMIC').ne.0) then
            call bckfil
            if (ipnt.eq.1) then
                call rdmolu(i2,i1,i1,i0,istat)
            else
                call rdmolu(i1,i2,i1,i1,istat)
            endif
            call search(line,'GRADIENT (HARTREE/BOHR)',istat)
         endif
         if (istat.eq.0) return
         call haszm(.false.)
      else
         if (ipnt.eq.1) then
           call searcht(line,
     &       'ATOM      ATOMIC                      COORDINATES',
     &             'GRADIENT (HARTREE/BOHR)',
     &             'CURRENT FULLY SUBSTITUTED Z-MATRIX',istat)
         else
           call searcht(line,'COORDINATES OF ALL ATOMS ARE (ANGS)',
     &             'GRADIENT (HARTREE/BOHR)',
     &             'CURRENT FULLY SUBSTITUTED Z-MATRIX',istat)
         endif
         if (istat.eq.0) return

         if (index(line,'ALL ATOMS').ne.0.or.
     &       index(line,'ATOMIC').ne.0) then
             call bckfil
             if (ipnt.eq.1) then
                call rdmolu(i2,i1,i1,i0,istat)
             else
                call rdmolu(i1,i2,i1,i1,istat)
             endif
             call searchd(line,'GRADIENT (HARTREE/BOHR)',
     &             'CURRENT FULLY SUBSTITUTED Z-MATRIX',istat)
             if (istat.eq.0) return
         endif

         if (index(line,'CURRENT FULLY').ne.0) then
             if (getzmu(0)) then
                 call haszm(.true.)
             endif
             call search(line,'GRADIENT (HARTREE/BOHR)',istat)
             if (istat.eq.0) return
         else
             call haszm(.false.)
         endif
      endif

      call redel(line,3)

      usnew = .false.
      if (line(2:4).eq.'---') usnew = .true.

      if (.not.usnew) then
         call redel(line,2)
         iatoms = 0
      endif

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) return
         jatoms = jatoms + 1
         if (.not.usnew) iatoms = iatoms + 1
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.2) goto 1000
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.1) goto 1000
         ktype = nxtwrd(str,nstr,itype,rtype)

         if (ktype.ne.3) goto 1000
         if (.not.usnew) ianz(iatoms) = rtype

         if (.not.usnew) then
            do i=1,3
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.ne.3) goto 1000
               coo(i,iatoms) = rtype
            end do
         endif

         do i=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 1000
            fxyz(i,jatoms) = rtype
         end do
      end do

      return

1000  istat = 0
      return

      end

      subroutine geogus(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character lstr*137
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

c
c     Read Geometry Convergence data
c
      call rewfil
      igcvav = 1
      ifmxav = 1
      ifrmav = 1
      idmxav = 0
      idrmav = 0
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0

      do i=1,mxpnt
         call search(lstr,'  NSERCH=',istat)
         if (istat.eq.0) goto 100
         if (index(lstr,'FAILURE TO LOCATE').ne.0) goto 100
         ngeoms =  ngeoms + 1
         isav(i) = 1
         i1 = index(lstr,'ENERGY=')
         epoints(i) = reada(lstr,i1+7,len(lstr))
         call search(lstr,'MAXIMUM GRADIENT',istat)
         if (istat.eq.0) goto 100
         i1 = index(lstr,'MAXIMUM GRADIENT =')
         formax(i) = reada(lstr,i1+18,len(lstr))
         i1 = index(lstr,'RMS GRADIENT =')
         forrms(i) = reada(lstr,i1+14,len(lstr))

      end do

100   continue
      if (ngeoms.eq.0) then
          igcvav = 0
          ifmxav = 0
          ifrmav = 0
          idmxav = 0
          idrmav = 0
          ieav = 0
      else
          nepnts = ngeoms
      endif

      return
      end

      subroutine cnvgus
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      common /curlin/ line
      character*137 line,str
      integer getlin
      logical last,datlin

c
c     Read Scf Convergence data
c
      call rewfil
      icvav1 = 1
      icvav2 = 1

c     SCF convergence first point

      call searchd(line,' ITER EX',' ITER    TOTAL ENERGY',istat)
      if (istat.eq.0) goto 1000

      jstrt1 = 0

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) goto 100
         if (datlin(line)) then
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.2) goto 1000
            jend1 = itype
            do i=1,3
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.3) then
                  convg1(jend1) = rtype
                  goto 50
               endif
            end do
50          continue
            if (jstrt1.eq.0) jstrt1 = jend1
         endif
      end do

100   continue


      last = .false.

200   call searchd(line,' ITER EX',' ITER    TOTAL ENERGY',istat)
      if (istat.eq.0) goto 2000

      last = .true.

      jstrt2 = 0

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) goto 200
         if (datlin(line)) then
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.2) goto 2000
            if (itype.gt.MAXITER) goto 2000
            jend2 = itype
            do i=1,3
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.3) then
                  convg2(jend2) = rtype
                  goto 500
               endif
            end do
500         continue
            if (jstrt2.eq.0) jstrt2 = jend2
         endif
      end do

      return

1000  icvav1 = 0
      icvav2 = 0
      return

2000  if (.not.last) then
         icvav2 = 0
      endif
      return

      end

      subroutine ugetfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      common /curlin/ line
      character*137 line,str
      integer getlin
      dimension coo(3,*)

      istat = 1

      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0
      call rewfil

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in Gamess US Frequencies

10    itel = ivibs
      call search(line,'FREQUENCY:',istat)
      if (istat.eq.0) goto 100
      call bckfil
      if (getlin(0).eq.0) goto 100
      ktype = nxtwrd(str,nstr,itype,rtype)
      if (ktype.ne.1) goto 100
      do i=1,9
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) then
            if (ktype.eq.1.and.nstr.eq.1) then
                if (str(1:1).eq.'I') then
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.ne.3) goto 20
                endif
            endif
            if (ktype.eq.0) goto 20
         endif
         ivibs = ivibs + 1
         freq(ivibs) = rtype
      end do
20    continue

c skip symmetry line if present
      if (getlin(0).eq.0) goto 100
      if (index(line,'SYMMETRY').ne.0) then
c        write(*,*) line(1:20)
      else
         call bckfil
      endif

c get intensities

      if (getlin(0).eq.0) goto 100
      if (index(line,'REDUCED').ne.0) then
         if (getlin(0).eq.0) goto 100
      endif
      ktype = nxtwrd(str,nstr,itype,rtype)
      if (ktype.ne.1) goto 100
      if (nstr.eq.2.and.str.eq.'IR') 
     &   ktype = nxtwrd(str,nstr,itype,rtype)
      do i=1,9
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) then
            if (ktype.eq.1.and.nstr.eq.1) then
                if (str(1:1).eq.'I') then
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.ne.3) goto 30
                endif
            endif
            if (ktype.eq.0) goto 30
         endif
         ihasi = 1
         itel = itel + 1
         frint(itel) = rtype
         ramint(itel) = 0.0d0
      end do
30    continue
      goto 10

100   if (ivibs.eq.0) istat = 0

      nfreq = ivibs
      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)

      return
      end 

      subroutine ucoorg(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /curlin/ line
      character*137 line,str
      integer getlin

c     Get ifreq 'th Norm. Cordinates from Gamess US Output

      istat = 1
      call rewfil
      call iatnox(iatoms)

10    call search(line,'FREQUENCY:',istat)
      if (istat.eq.0) goto 100
      ivibs = 0
      ihfor = 0
      call bckfil
      call bckfil
      if (getlin(0).eq.0) goto 1000
      if (index(line,'FORCE CONST.:').ne.0) then
         ihfor = 1
         call bckfil
         call bckfil
         if (getlin(0).eq.0) goto 1000
      endif
      do i=1,9
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.2) goto 20
         ivibs = ivibs + 1
         if (itype.eq.ifreq) goto 100
      end do
20    continue
      if (ihfor.eq.1) then
         call redel(line,3)
      else
         call redel(line,2)
      endif
      goto 10

100   if (ihfor.eq.1) then
         call redel(line,3)
      else
         call redel(line,2)
      endif
c     Skip next line in Gamess US 20 JUN 2002 Output
      if (index(line,'SYMMETRY:').ne.0) call redel(line,1)
      if (index(line,'REDUCED MASS:').ne.0) call redel(line,1)
      if (index(line,'INTENSITY:').ne.0) call redel(line,1)

      do i=1,iatoms
         do j=1,3
            if (getlin(0).eq.0) goto 1000
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
            endif
            if (ktype.ne.1) goto 1000
            do k=1,ivibs
               ktype = nxtwrd(str,nstr,itype,rtype)
            end do
            if (ktype.ne.3) goto 1000
            a(j,i) = rtype
         end do
      end do

      if (idebug.eq.1) call prtfr(ifreq)
      return

1000  istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine getzzz(istatz,
     &              bl,alph,bet,ibl,ialph,ibet,imap,ianz,iz)

c this is really getzmu

      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str
      character*2 catom,catomt,tolowf,iel
      common /zmfrst/ ihaszm, nz, mxzat
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      dimension iel(100)
      character*137 line
      common /curlin/ line
      dimension bl(*),alph(*),bet(*),ibl(*),ialph(*),ibet(*),
     &          imap(*),ianz(*),iz(4,*)
      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x '/

      istatz = 0
      maxnz = mxzat
      do i=1,3
         do j=1,4
           iz(j,i) = 0
          end do
      end do
      nz = 0

      do while (getlin(0).eq.1)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
           if (nstr.le.8) then
              nz = nz + 1
              imap(nz) = 0
              numv = 3
              if (nz.le.3) numv = nz - 1
c
c Atom String
c
              if (nstr.eq.1) then
                 catomt(1:1) = str(1:1)
                 catomt(2:2) = ' '
              else
                 catomt = str(1:2)
              endif
              catom = tolowf(catomt)
              do j=1,100
                 if (catom .eq. iel(j)) ianz(nz) = j - 1
              end do
              do j=1,numv
c
c Connectivity
c
                 if (nxtwrd(str,nstr,itype,rtype).ne.2) then
                    goto 100
                 else
                    iz(j,nz) = itype
                 endif
c
c Variable
c
                 ktype = nxtwrd(str,nstr,itype,rtype)
                 if (ktype.eq.0.or.ktype.eq.1) then
                    goto 100
                 elseif (ktype.eq.2) then
                     tmpvar = 1.0d0*itype 
                 elseif (ktype.eq.3) then
                     tmpvar = rtype 
                 endif
                 if (j.eq.1) then
                    bl(nz) = tmpvar
                 elseif (j.eq.2) then
                    alph(nz) = tmpvar 
                 elseif (j.eq.3) then
                    bet(nz) = tmpvar
                 endif
              end do
c
c Check for Gamess ITYPE
c
              ktype = nxtwrd(str,nstr,itype,rtype)
              iz(4,nz) = 0
              if (ktype.ne.0) then
                 if (ktype.eq.2.and.itype.eq.1.or.itype.eq.0) then
                     iz(4,nz) = itype
                 elseif (ktype.eq.3.and.rtype.eq.-1.0d0) then
                     iz(4,nz) = -1
                 else
                     goto 100
                 endif
              endif
           endif
c
c Empty Line
c
         elseif (ktype.eq.0.and.nz.gt.1) then
           goto 200
         endif
      end do
c
c Out of Lines, Didnt Find Zmat
c
100   continue
      
      return

200   continue
c
c Found Zmat
c

      istatz = 1
      do i=1,nz
         ibl(i) = 1
         ialph(i) = 1
         ibet(i) = 1
      end do
c      do i=1,nz
c         print*,ianz(i),bl(i),alph(i),bet(i),(iz(j,i),j=1,4)
c      end do

      return
      end

      subroutine gamunmr
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character*137 line,str
      common /curlin/ line
      integer getlin
      common /nmr/    shlnuc(numatm),ihsnmr
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      call search(line,'GIAO CHEMICAL SHIELDING TENSOR (PPM):',istat)

      if (istat.ne.0) then
          call redel(line,1)
          do i=1,natoms
             call redel(line,6)
             if (getlin(0).ne.1) goto 1000
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                shlnuc(i) = rtype
             else
                goto 1000
             endif
          end do
          ihsnmr = 2

      endif

      return

1000  call inferr('Error reading Isotropical Shielding !!',1)
      return
      end

      double precision function del(var)
      implicit double precision (a-h,o-z)
      common /del1/dmolin(169),dofscl(169)
      common /del2/d11(3,3),d12(3,3),d21(3,3),d22(3,3),
     &             f11(3),f12(3),f21(3),f22(3),occ(3),
     &             p(3,3),g(3,3),ibasis,idim
      dimension var(2)

      call rota(var(1))
      call rotb(var(2))
      call rotm

      if (ibasis.eq.0) then

         call rotden(p,occ)
         del=0.0d0

         do i=1,3
            do j=1,3
               del=del+(p(i,j)-g(i,j))**2
            end do
         end do

      else

         call rotden(d11,f11)
         call rotden(d12,f12)
         call rotden(d21,f21)
         call rotden(d22,f22)
         call mdout
         del=0.0d0

         do i=1,idim
            do j=1,idim
                 iaddr=j+(i-1)*idim
                 del=del+(dofscl(iaddr)-dmolin(iaddr))**2
            end do
         end do

      endif

      return
      end

      subroutine pargeo
      parameter (MAXPNT=2000)
      implicit double precision ( a-h,o-z )
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)

      mxpnt = MAXPNT
      call parptr(3,fmaxt,fdum,idum)
      call parptr(151,formax,fdum,idum)

      return
      end

      subroutine proged(ipoints,iff,istat,
     &                  formax,forrms,dismax,disrms,epoints,isav,
     &                  coo,ianz,icrtp)
C this is really progeo
      implicit double precision ( a-h,o-z )
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      common /mopver/ mopopt
      common /ecce/iecce,imod
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*),coo(3,*),ianz(*)

      istat = -1

c can NOT set ngeoms = 0 here because some reading routines have
c already set ngeoms (for example:  mopac2007 aux files)
c                    (iftyp = 1, mopopt 4)

      if (iftyp.eq.1.and.iconv.eq.0) then
          call geomop(
     &            formax,forrms,dismax,disrms,epoints,isav,coo,ianz)
      elseif (iftyp.eq.2) then
          call geogam(formax,forrms,dismax,disrms,epoints,isav)
      elseif (iftyp.eq.3) then
          call geogus(formax,forrms,dismax,disrms,epoints,isav)
      elseif (iftyp.eq.4) then
          call geogau(formax,forrms,dismax,disrms,epoints,isav)
      elseif (iftyp.eq.5) then
          if (ihasg.gt.0) then
             call geoxyz(ihasg,iff,
     &       formax,forrms,dismax,disrms,epoints,isav,coo,ianz,needm)
             if (needm.ne.-1) then
                istat = needm
                return
             else
                call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
             endif
          else
             ngeoms = 0
          endif
      elseif (iftyp.eq.7) then
          call geocpmd(formax,forrms,dismax,disrms,epoints,isav,
     &                 needm)
          if (needm.ne.-1) istat = needm
      elseif (iftyp.eq.8) then
          call geoqcm(formax,forrms,dismax,disrms,epoints,isav)
      elseif (iftyp.eq.9) then
          call geoorc(formax,forrms,dismax,disrms,epoints,isav)
      elseif (iftyp.eq.10) then
          call geoxyz(0,iff,
     &      formax,forrms,dismax,disrms,epoints,isav,coo,ianz,needm)
          if (needm.ne.-1) then
             istat = needm
             return
          endif
      elseif (iftyp.eq.11) then
          if (iff.eq.7) then
             call geoxyz(0,iff,
     &        formax,forrms,dismax,disrms,epoints,isav,coo,ianz,needm)
          else
             call geoxyz(-1,iff,
     &        formax,forrms,dismax,disrms,epoints,isav,coo,ianz,needm)
          endif
          if (needm.ne.-1) then
             istat = needm
             return
          endif
      elseif (iftyp.eq.12) then
          call geoxyz(0,iff,
     &        formax,forrms,dismax,disrms,epoints,isav,coo,ianz,needm)
          if (needm.ne.-1) then
             istat = needm
             return
          endif
      elseif (iftyp.eq.14) then
          ngeoms = 1
      elseif (iftyp.eq.15) then
          if (iecce.eq.1) then
             call egeonw(formax,forrms,dismax,disrms,epoints,isav)
          else
             call geonwc(formax,forrms,dismax,disrms,epoints,isav)
          endif
      elseif (icrtp.eq.5) then
          call geoxdt(formax,forrms,dismax,disrms,epoints,isav)
      elseif (icrtp.eq.3) then
          call geobio(formax,forrms,dismax,disrms,epoints,isav)
          call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
      elseif (icrtp.eq.2) then
          call geofdt(formax,forrms,dismax,disrms,epoints,isav)
          call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
      elseif (icrtp.eq.1) then
          call geochx(formax,forrms,dismax,disrms,epoints,isav)
          call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)
      elseif (ipdbgro.eq.1) then
c done this already
          idum = 1
      elseif (iftyp.eq.1.and.mopopt.eq.4) then
          idum = 1
      else
          igcvav = 0
      endif

      if ((iftyp.ge.2.and.iftyp.le.4).or.(iftyp.ge.7.and.iftyp.le.9)
     &    .or.(iftyp.eq.15)
     &    .or.(iftyp.eq.1.and.(iconv.eq.0.or.mopopt.eq.4)) ) 
     &     call gmmcnv(formax,forrms,dismax,disrms,epoints,isav)

      ipoints = ngeoms

      return
      end

      subroutine rdcor(idebug,istat)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character*137 line,str
      integer getlin
      logical gnreal
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor,
     &                ixyz98,iopr,isymm,irc,imp2,icntp,itd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      dimension r(3)

      ig98 = 0

      if (isymm.eq.0) goto 1000

      if (idebug.eq.1)
     &   call inferr('looking for Standard orientation',0)

      call search(line,'Standard orientation:',istat)
      if (istat.eq.0) then
          if (idebug.eq.1)
     &      call inferr('Standard orientation not found!',0)
          return
      else
          call redel(line,2)
          call nxtlin(line,jstat)
          if (jstat.eq.1.or.jstat.eq.2) goto 20
          if (icdex(line,'Type').ne.0) ig98 = 1
          call redel(line,1)
      endif

      natoms = 0

      do while ( .true. )
        if (getlin(1).eq.1) then
         if (line(2:5).eq.'----') goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.2) goto 20
         natoms = itype
         if ( natoms .gt. numatm ) then
             call inferr('Exceeding Max Atoms!',0)
             goto 20
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.2) goto 20
         nat(natoms) = itype
         if (ig98.eq.1) then
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.2) goto 20
         endif
         if (gnreal(r,3,.false.)) then
             do j=1,3
                xyz(j,natoms) = r(j)
             end do
         else 
             goto 20
         endif
        endif
      end do


c
c===== Z-Matrix/ Input orientation
c
1000  if (idebug.eq.1) call inferr(
     &    'looking for Z-Matrix/Input orientation',0)

      call searchd(line,'Z-Matrix orientation:',
     &             'Input orientation:',istat)
      if (istat.eq.0) then
          if (idebug.eq.1) call inferr(
     &    'Z-Matrix/Input orientation not found!',0)
          return
      else
          call redel(line,2)
          call nxtlin(line,jstat)
          if (jstat.eq.1.or.jstat.eq.2) goto 20
          if (icdex(line,'Type').ne.0) ig98 = 1
          call redel(line,1)
      endif

      natoms = 0
      do while ( .true. )
         if (getlin(1).eq.1) then
            if (line(2:4).eq.'---') goto 100
            natoms = natoms + 1
            ktype = nxtwrd(str,nstr,itype,rtype)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.2) goto 20
            nat(natoms) = itype
            if (ig98.eq.1) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.ne.2) goto 20
            endif
            if (gnreal(r,3,.false.)) then
                do j=1,3
                   xyz(j,natoms) = r(j)
                end do
            else 
                goto 20
            endif
         endif
      end do

100   continue
      if (idebug.eq.1) then
         do i=1,natoms
            write(iun3,'(i3,3f12.6)') nat(i),(xyz(j,i),j=1,3)
         end do
         write(iun3,*) ' '
      endif
c
c get rid off dummy atoms
c
200   continue
      do i=1,natoms
         if (nat(i).lt.0) then
            do j=i+1,natoms
               nat(j-1) = nat(j)
               do k=1,3
                  xyz(k,j-1) = xyz(k,j)
               end do
            end do
            natoms = natoms - 1
            goto 200
         endif
      end do

      toang = 0.52917706d0
c
c convert to atomic units
c
      do i=1,natoms
         do j=1,3
            xyz(j,i) = xyz(j,i) / toang
         end do
      end do

      istat = 1
      return

20    call inferr('Error reading Standard orientation!',1)
      istat = 0
      return
      end

      subroutine wrmsfd(iun,
     &                  coo,qat,ianz,iaton,iatclr,iresid,iconn,
     &                  lring,ityp,nat,nspg,icel,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxel=100)
      parameter (numatm=2000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (mxsg=238)
      common /athlp/  iatoms, mxnat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      integer*2 ityp
      common /types/  iff
      character*7 spnam
      common /spgrnm/ spnam(mxsg)
      character*2 elemnt
      common /elem/   elemnt(mxel)
      character*200 header
      character*100 fname
      character*80  col
      character*10  version
      character*6   mklab
      integer*2 nbc(numat1),ibc(numat1,mxcon),ictyp
      integer*2 i2dum,ibc2,iorder(numat1*mxcon)
      real rdum
      logical ochg
      dimension ibc2(2,numat1*mxcon),rr(3,3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*),qat(*),ityp(*),lring(*),
     &          ir(3,3,192),it(3,192)

      istat = 1
      toang = 0.52917706d0
      torad = datan(1.0d0) / 45.0d0
      idochg = 0

      fname = 'kull'
      natoms = iatoms

      if (icel.eq.1) then

         if (ochg(idum,ianz)) then
             idochg = 1
         else
             idochg = 0
         endif

         natoms = nat
         nstor = mxnat-natoms

         do i=1,natoms
            do j=1,3
               coo(j,i) = coo(j,nstor+i)
            end do
            ianz(i) = ianz(nstor+i)
            do j=1,iconn(1,nstor+i)+1
               iconn(j,i) = iconn(j,nstor+i)
            end do
            iatclr(i) = iatclr(nstor+i)
         end do

      else
         if (ihasq.eq.1) idochg = 1
      endif

      do i=1,natoms
         lring(i) = 0
         iaton(i) = 2
      end do

      ns = 1
      nr = 1
      version = 'QUANTAR3.3'
      header = 'Molden generated MSF'
      write(iun) ns,nr,natoms,version,header
      col = 'END'
      write(iun) col

c
c write segment information
c
      i2dum = 1
      write(iun) 'NEWS'
      write(iun) i2dum
      write(iun) i2dum

c
c write residue information
c
      i2dum = 1
      write(iun) 'RES1  '
      write(iun) 'RES1'
      write(iun) i2dum
      i2dum = natoms
      write(iun) i2dum
      i2dum = 1
      write(iun) i2dum

      rdum = 0.0e0
      write(iun) rdum
      write(iun) rdum
      write(iun) rdum
      rdum = 10.0e0
      write(iun) rdum
c
c write atom info
c
      if (icel.eq.1) then

         call setrr(alpha,beta,gamma,a,b,c,rr)

         do j=1,3
            write(iun) (real(trc(coo(1,i),rr,j)),i=1,natoms)
         end do
      else
         do j=1,3
            write(iun) (real(coo(j,i)*toang),i=1,natoms)
         end do
      endif
 
      write(iun) (mklab(ianz(i),i),i=1,natoms)

      i2dum = 1
      write(iun) (i2dum,i=1,natoms)

      if (iff.eq.6) then
         write(iun) (ityp(i),i=1,natoms)
      else
         write(iun) (ictyp(i,ianz(i),idochg,ianz,iconn),i=1,natoms)
      endif

      write(iun) (real(qat(i)),i=1,natoms)

c
c write the extra data
c

      rdum = 0.0e0
      write(iun) 'BVALUE    ','REAL',natoms,fname
      write(iun) (rdum,i=1,natoms)

      write(iun) 'CONNECT   ','BOND',natoms,fname

      do i=1,natoms
         nbc(i) = 0
         do j=1,iconn(1,i)
            if (iconn(1+j,i).gt.0) then
               nbc(i) = nbc(i) + 1
               ibc(i,nbc(i)) = iconn(1+j,i)
            endif
         end do
      end do
      write(iun) (nbc(i),(ibc(i,j),j=1,nbc(i)),i=1,natoms)

      nbnds = 0
      do i=1,natoms
         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               if (jj.gt.i) then
                  nbnds = nbnds + 1
                  iorder(nbnds) = ibtyp(i,jj,idochg,1,ianz)
                  if (iorder(nbnds).eq.4) iorder(nbnds) = 7
                  ibc2(1,nbnds) = i
                  ibc2(2,nbnds) = jj
               endif
            endif
         end do
      end do

      write(iun) 'ORDER     ','BOND',nbnds,fname
      write(iun) (iorder(i),(ibc2(j,i),j=1,2),i=1,nbnds)

      if (icel.eq.1) then
          write(iun) spnam(nspg),'   ','SYMM',2,fname
          write(col,'(a5,6(f9.3),i2,i6,3x,a7)') 'CELL ',a,b,c,
     &        alpha/torad,beta/torad,gamma/torad,1,nspg,spnam(nspg)
          write(iun) col
          col = 'END'
          write(iun) col
          call fdat(1,0,0,0,0,0)
      endif

      do i=1,natoms
         iaton(i) = 1
      end do

      return
      end

      subroutine getrcn(iat,iconn,ianz)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /conrl/ ibnds,icnn(mxcon),io,in,ic,ih,ian1,ian2,ian3,ian4
      dimension iconn(mxcon+1,*),ianz(*)

      ibnds = 0
      io = 0
      in = 0
      ic = 0
      ih = 0
      ian1 = 0
      ian2 = 0
      ian3 = 0
      ian4 = 0

      if (iat.eq.0) return

      do i=1,iconn(1,iat)
         if (iconn(i+1,iat).gt.0) then
            ibnds = ibnds + 1
            icnn(ibnds) = iconn(i+1,iat)
            ia = ianz(icnn(ibnds))
            if (ia.eq.1) ih = ih + 1
            if (ia.eq.6) ic = ic + 1
            if (ia.eq.7) in = in + 1
            if (ia.eq.8) io = io + 1
         endif
      end do

      if (ibnds.gt.0) ian1 = ianz(icnn(1))
      if (ibnds.gt.1) ian2 = ianz(icnn(2))
      if (ibnds.gt.2) ian3 = ianz(icnn(3))
      if (ibnds.gt.4) ian4 = ianz(icnn(4))

      return
      end


      subroutine addcoo(ic,icc,rcoo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (numatm=2000)
      common /extchg/ exchg(3,3),iexchg(3),nexchg
      common /coord / xyz(3,numatm)
      dimension tmp(3),iflg(numatm)

      nexchg = nexchg + 1
      iexchg(nexchg) = 1

      do i=1,3
         tmp(i) = xyz(i,ic) - xyz(i,icc)
      end do

      rc = vlen(tmp)

      do i=1,3
         tmp(i) = (tmp(i)*rcoo)/rc
      end do

      do i=1,3
         exchg(i,nexchg) = xyz(i,ic) + tmp(i)
      end do

      print*,"Added extra positive charge at coordinates (bohr):"
      print*,(exchg(jj,nexchg),jj=1,3)

      return
      end

      subroutine chkcod(kcoo,kcooh,ianz,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (numatm=2000)
      common /athlp/ iatoms, mxnat
      common /totchg/ itot
      dimension iconn(mxcon+1,*),ianz(*),icnn(mxcon),ifl(numatm)

      call qmtot

      do i=1,iatoms
         ifl(i) = 0
      end do

      kcoo = 0
      kcooh = 0

      do i=1,iatoms
         call ispn(irs,i,irng,idochg,1)
         if (ifl(i).eq.0.and.irs.eq.10) then
            kcoo = 1
            ic  = 0
            io  = i
            io2 = 0
            icc = 0
            ifl(i) = 1

            icooh = 0
            do j=1,iconn(1,i)
               jj = iconn(1+j,i)
               ian = ianz(iconn(1+j,i))
               if (ian.eq.6) ic = jj
               if (ian.eq.1) icooh = 1
            end do
            if (icooh.eq.0) then
               do j=1,iconn(1,ic)
                  jj = iconn(1+j,ic)
                  ian = ianz(jj)
                  if (ian.eq.8.and.jj.ne.i) io2 = jj
                  if (ian.eq.6) icc = jj
               end do
               if (io2.ne.0) then
                  ifl(io2) = 1
                  do j=1,iconn(1,io2)
                     ian = ianz(iconn(1+j,io2))
                     if (ian.eq.1) icooh = 1
                  end do
               endif
            endif
            if (icooh.eq.0.and.itot.lt.0) then
               kcooh = 0
               call addcoo(ic,icc,2.281d0)
            endif
            
         endif
      end do

      return
      end

      subroutine gentau(i,ianz,iaton,iatclr,iresid,iconn,ipdbt,ityp,
     &                 ncalf,icalf,coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      logical addat
      integer*2 ipdbt,ityp
      dimension iaton(*),iatclr(*),iresid(*),ipdbt(*),ityp(*),icalf(6,*)
      dimension coo(3,*),iconn(mxcon+1,*),ianz(*),icnn(mxcon)

      do j=1,iconn(1,i)
         jj = iconn(1+j,i)
         ian = ianz(iconn(1+j,i))

         if (ian.eq.6) then
            ih = 0
            ih2 = 0
            do k=1,iconn(1,jj)
               kk = iconn(1+k,jj)
               ian = ianz(kk)

               if ((ian.eq.6.or.ian.eq.7).and.ih.eq.0) then
                 nl = 0 
                 do l=1,iconn(1,kk)
                    ll = iconn(1+l,kk)
                    ian = ianz(ll)
                    if (ian.eq.1) then
                       if (ih.eq.0) then
                          io = i
                          ic = jj
                          icc = kk
                          ih = ll
                       else
                          ih2 = ll
                          nl = nl + 1
                          icnn(nl) = iconn(1+l,kk)
                       endif
                    else
                       nl = nl + 1
                       icnn(nl) = iconn(1+l,kk)
                    endif
                 end do

                 if (ih.ne.0) then
                   iconn(1,icc) = iconn(1,icc) - 1
                   do l=1,nl
                       iconn(1+l,icc) = icnn(l)
                   end do
                         
                   if (addat(icc,ic,io,
     &                      1,1.090d0,109.47d0,180.0d0,iret,1,
     &                      ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &                      ncalf,icalf,coo)) then
                      do l=1,3
                         coo(l,ih) = coo(l,iatoms)
                      end do
                      iconn(2,ih) = iconn(2,iatoms)
                      iconn(3,io) = ih
                      iatoms = iatoms - 1
                   endif

                   if (ih2.ne.0) then
                     if (addat(io,ic,icc,
     &                      1,1.090d0,120.0d0,0.0d0,iret,1,
     &                      ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &                      ncalf,icalf,coo)) then
                      do l=1,3
                         coo(l,ih2) = coo(l,iatoms)
                      end do
                      iatoms = iatoms - 1
                     endif
                   endif

                 endif

               endif

            end do
         endif

      end do

      return
      end

      subroutine copmol(ianz,iatclr,iconn,ityp,coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      integer*2 ityp
      dimension iatclr(*),ityp(*)
      dimension coo(3,*),iconn(mxcon+1,*),ianz(*)

      nstor = mxnat-iatoms
      do i=1,iatoms
         do j=1,3
            coo(j,nstor+i) = coo(j,i)
         end do
         ianz(nstor+i) = ianz(i)
         do j=1,iconn(1,i)+1
            iconn(j,nstor+i) = iconn(j,i)
         end do
         iatclr(nstor+i) = iatclr(i)
      end do

      return
      end

      subroutine rstmol(ianz,iatclr,iconn,ityp,coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      integer*2 ityp
      dimension iatclr(*),ityp(*)
      dimension coo(3,*),iconn(mxcon+1,*),ianz(*)

      nstor = mxnat-iatoms
      do i=1,iatoms
         do j=1,3
            coo(j,i) = coo(j,nstor+i)
         end do
         ianz(i) = ianz(nstor+i)
         do j=1,iconn(1,nstor+i)+1
            iconn(j,i) = iconn(j,nstor+i)
         end do
         iatclr(i) = iatclr(nstor+i)
      end do

      return
      end

      subroutine tautd(ianz,iaton,iatclr,iresid,iconn,ipdbt,ityp,
     &                 ncalf,icalf,coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxel=100)
      character*2 elemnt
      common /athlp/ iatoms, mxnat
      common /elem/   elemnt(mxel)
      character keywrd*320, keyori*320
      common /keywrd/ keywrd,keyori
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      common /pnthlp/ ipoints,ipnt
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /types/ iff
      integer*2 ipdbt,ityp
      character*2 ggstr
      logical keyi,oxyz
      dimension iaton(*),iatclr(*),iresid(*),ipdbt(*),ityp(*),icalf(6,*)
      dimension coo(3,*), iconn(mxcon+1,*),ianz(*),icnn(mxcon),itau(5)

c ixyz =
c 1       mol file
c 2       msf file
c 3       tinker xyz file
c 4       tinker xyz file ?
c 5       xyz format
c 6       chemx format
c 7       msi format
c 8       molden format file 
c 9       mol2 file 
c 11      ambfor xyz file 
c 12      mopac xyz input file 

      ntau = 0

      ixyzt = -1
      oxyz = keyi(keywrd,'WRTAUTO',ixyzt)
      ixyzo = ixyz
      ixyz = ixyzt

      do i=1,iatoms
         icoo = 0
         ic = 0
         call ispn(irs,i,irng,1,1)
         if (ianz(i).eq.8.and.irs.eq.3) then
            do m=1,iconn(1,i)
               mm = iconn(1+m,i)
               if (mm.gt.0) then
                  if (ianz(mm).eq.6) ic = mm
               endif
            end do
            if (ic.ne.0) then
               do m=1,iconn(1,ic)
                  mm = iconn(1+m,ic)
                  if (mm.gt.0) then
                     call ispn(mirs,mm,irng,1,1)
                     if (ianz(mm).eq.8.and.mirs.eq.4) icoo = mm
                     if (ianz(mm).eq.7.and.mirs.eq.8) icoo = mm
                     if (ianz(mm).eq.6.and.mirs.ne.4) icoo = mm
                  endif
               end do
            endif
            if (icoo.eq.0) then
               ntau = ntau + 1
               itau(ntau) = i
            endif
         endif
      end do

      call addchg

      iff = 7
      itmpat = iatoms

      call copmol(ianz,iatclr,iconn,ityp,coo)

      do n=1,ntau
         call gentau(itau(n),ianz,iaton,iatclr,iresid,iconn,ipdbt,ityp,
     &                 ncalf,icalf,coo)
         call dotyp(0)
         call wrpnt('taut'//ggstr(n)//'.xyz',10,4,0,ipoints,
     &                 fancy,atcol,dolabs,backb)
         iatoms = itmpat
         call rstmol(ianz,iatclr,iconn,ityp,coo)
      end do

      iatoms = itmpat
      call rstmol(ianz,iatclr,iconn,ityp,coo)
      if (ntau.gt.1) then
         call gentau(itau(1),ianz,iaton,iatclr,iresid,iconn,ipdbt,ityp,
     &                 ncalf,icalf,coo)
         call gentau(itau(2),ianz,iaton,iatclr,iresid,iconn,ipdbt,ityp,
     &                 ncalf,icalf,coo)
         call dotyp(0)
         call wrpnt('taut'//ggstr(1)//ggstr(2)//'.xyz',12,4,
     &              0,ipoints,fancy,atcol,dolabs,backb)
      endif

      ixyz = ixyzo

      return

100   print*,"Error opening file for writing"
      return
      end

      integer*2 function ictyp(iat,ian,idochg,ianz,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxt=14)
      parameter (mxmsf=235)
      character*4 atype
      common /atypes/ ihbt(mxt),atype(mxt)
      common /msft/   ltyp(mxmsf)
      common /conrl/ ibnds,icnn(mxcon),io,in,ic,ih,ian1,ian2,ian3,ian4
      dimension iconn(mxcon+1,*),ianz(*)

      call getrcn(iat,iconn,ianz)

      call ispn(irs,iat,irng,idochg,1)
      ihb = ihbt(irs)
      
      ictyp = 1
      if (ian.eq.1) then
         ictyp = 1
         if (ibnds.eq.1) then
            if (ian1.eq.6.or.ian1.eq.14) ictyp = 3
            if (ian1.eq.7) then
               ib = icred(icnn(1),idum1,idum2,ianz,iconn)
               if (ib.eq.4) ictyp = 2
            endif
            if (ian1.eq.8.or.ian1.eq.14) then
               if (ian1.eq.14) ictyp = 8
               if (ian1.eq.8) then
                  ib = 0
                  ic = 0
                  kat = icnn(1)
                  do j=1,iconn(1,kat)
                     jat = iconn(j+1,kat)
                     if (jat.gt.0) then
                        ib = ib + 1
                        if (ianz(jat).eq.6) ic = jat
                     endif
                  end do
                  if (ib.eq.2.and.ic.ne.0) then
                     ictyp = 8
                     ib = 0
                     io = 0
                     do j=1,iconn(1,ic)
                        jat = iconn(j+1,ic)
                        if (jat.gt.0.and.jat.ne.icnn(1)) then
                           ib = ib + 1
                           if (ianz(jat).eq.8) io = jat
                        endif
                     end do
                     if (ib.eq.2.and.io.ne.0) ictyp = 1
                  endif
               endif
            endif
         endif
      elseif (ian.eq.6) then
         if (ihb.eq.1) then
            ictyp = 18
         elseif (ihb.eq.2) then
            ictyp = 14
            if (ibnds.eq.3) then
               do i=1,3
                  call ispn(irs,icnn(i),irng,idochg,1)
                  if (ianz(icnn(i)).eq.6.and.
     &                ihbt(irs).eq.2)
     &                ictyp = 16
               end do
               if (io.gt.0) ictyp = 14
            endif
         elseif (ihb.eq.3) then
            ictyp = 10
         elseif (ihb.eq.4) then
            if (irng.eq.1) then
               ictyp = 22
            elseif (irng.eq.2) then
               ictyp = 21
            elseif (irng.eq.3) then
               ictyp = 27
            elseif (irng.eq.4) then
               ictyp = 25
            elseif (irng.eq.5) then
               ictyp = 26
            endif
         endif
      elseif (ian.eq.7) then
         if (ihb.eq.1) then
            ictyp = 31
         elseif (ihb.eq.2) then
            ictyp = 32
         elseif (ihb.eq.3) then
            ictyp = 36
            do i=1,ibnds
               call ispn(irs,icnn(i),jrng,idochg,1)
               iht = ihbt(irs)
               if (ianz(icnn(i)).eq.6.and.
     &             (iht.eq.2.or.iht.eq.4))
     &             ictyp = 32
            end do
            if (ibnds.eq.3.and.io.eq.2) ictyp = 38
         elseif (ihb.eq.4) then
            ictyp = 35
            if (irng.eq.2) ictyp = 34
         endif
      elseif (ian.eq.8) then
         if (ihb.eq.1) then
            ictyp = 48
         elseif (ihb.eq.2) then
            ictyp = 40
            if (ibnds.eq.1.and.ian1.ne.1) then
               jat = icnn(1)
               if (iconn(1,jat).eq.3.or.
     &           (ian1.eq.15.and.iconn(1,jat).eq.4)) then
                  ih = 0
                  ic = 0
                  ipo = 0
                  do i=1,iconn(1,jat)
                     kat = iconn(1+i,jat)
                     if (kat.gt.0.and.kat.ne.iat) then
                        if (ianz(kat).eq.8) then
                           if (ian1.eq.15) ipo = ipo + 1
                           ib = icred(kat,idum1,idum2,ianz,iconn)
                           if (ib.eq.2.and.ian1.eq.6) ictyp = 51
                           if (ib.eq.1) ictyp = 43
                        elseif (ianz(kat).eq.1) then
                           ih = ih + 1
                        elseif (ianz(kat).eq.6) then
                           ic = ic + 1
                        endif
                        if (ib.eq.0) then
                           if (ic.eq.2.and.ian1.eq.6) ictyp = 42
                           if (ic.eq.1.and.ih.eq.1.and.ian1.eq.6) 
     &                        ictyp = 41
                        endif
                     endif
                  end do
                  if (ipo.eq.4) ictyp = 43
               endif
            endif
         elseif (ihb.eq.3) then
            ictyp = 45
            if (ibnds.eq.2) then
               if (ian1.ne.1.and.ian2.ne.1) then
                  ictyp = 50
                  do i=1,2
                     jat = icnn(i)
                     if ((ianz(jat).ne.1.and.iconn(1,jat).eq.3).or.
     &               (ianz(jat).eq.15.and.iconn(1,jat).eq.4)) then
                        do j=1,iconn(1,jat)
                           kat = iconn(1+j,jat)
                           if (kat.gt.0.and.kat.ne.iat) then
                              if (ianz(kat).eq.8) then
                                 ib = icred(kat,idum1,idum2,ianz,iconn)
                                 if (ib.eq.1) ictyp = 49
                              endif
                           endif
                        end do
                     endif
                  end do
                  if (ian1.eq.14.and.ian1.eq.14) ictyp = 55
                  if (ian1.eq.13.and.ian1.eq.14) ictyp = 56
                  if (ian1.eq.14.and.ian1.eq.13) ictyp = 56
                  if (ian1.eq.13.and.ian1.eq.13) ictyp = 56
               endif
            endif
         elseif (ihb.eq.4) then
            ictyp = 53
            if (irng.eq.2) ictyp = 52
         endif
      elseif (ian.eq.15) then
         if (ihb.eq.1) then
            ictyp = 233
         elseif (ihb.eq.2) then
            ictyp = 62
         elseif (ihb.eq.3) then
            ictyp = 60
            if (ibnds.eq.4.or.ibnds.eq.3) then
               if (io.eq.3) ictyp = 61
               if (io.eq.4) ictyp = 62
            endif
         elseif (ihb.eq.4) then
            ictyp = 64
         endif
      elseif (ian.eq.16) then
         if (ihb.eq.1) then
            ictyp = 70
         elseif (ihb.eq.2) then
            ictyp = 75
         elseif (ihb.eq.3) then
            ictyp = 70
            if (ibnds.eq.2) then
               if (ian1.ne.1.and.ian2.ne.1.and.
     &             ian1.ne.16.and.ian2.ne.16) ictyp = 74
            endif
         elseif (ihb.eq.4) then
            ictyp = 73
            if (irng.eq.2) ictyp = 72
         endif
         if (io.eq.4) then
            ictyp = 79
         elseif (io.eq.3) then
            ictyp = 78
         elseif (io.eq.2) then
            ictyp = 77
         elseif (io.eq.1) then
            ictyp = 76
         endif
      elseif (ian.eq.99) then
         ictyp = 489
      else
         do i=1,mxmsf
            if (ltyp(i).eq.ian) ictyp = i
         end do
      endif
      
      return
      end


      integer*2 function igtyp(iat,ian,idochg,ianz,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxt=14)
      character*4 atype
      common /atypes/ ihbt(mxt),atype(mxt)
      dimension icnn(mxcon),iccn(mxcon),icnn2(mxcon),iconn(mxcon+1,*),
     &          ianz(*)

      ibnds = 0
      ih = 0
      ihc = 0
      io = 0
      in = 0
      ic = 0
      is = 0
      ian1 = 0
      ian2 = 0
      ian3 = 0

      do i=1,mxcon
         icnn(i) = 0
         iccn(i) = 0
      end do

      do i=1,iconn(1,iat)
         if (iconn(i+1,iat).gt.0) then
            ibnds = ibnds + 1
            icnn(ibnds) = iconn(i+1,iat)
            ia = ianz(icnn(ibnds))
            if (ia.eq.1) ih = ih + 1
            if (ia.eq.6) ic = ic + 1
            if (ia.eq.6.or.ia.eq.1) ihc = ihc + 1
            if (ia.eq.7) in = in + 1
            if (ia.eq.8) io = io + 1
            if (ia.eq.16) is = is + 1
         endif
      end do
      if (ibnds.gt.0) ian1 = ianz(icnn(1))
      if (ibnds.gt.1) ian2 = ianz(icnn(2))
      if (ibnds.gt.2) ian3 = ianz(icnn(3))

      call ispn(irs,iat,irng,idochg,1)
      
c irs    1      2      3      4      5      6       7
c      '    ','.1  ','.2  ','.3  ','.4  ','.ar ','.cat'
c irs    8      9     10     11     12     13      14
c      '.am ','.pl3','.co2','.spc','.t3p','.O  ','.O2 '

      igtyp = 1
      if (ian.eq.1) then

         igtyp = 1
         if (ibnds.eq.1) then
            if (ian1.eq.6) then
               igtyp = 25
               call ispn(itmp,icnn(1),irng,idochg,1)
               if (itmp.eq.6.or.itmp.eq.3) igtyp = 24

               call flth(icnn(1),icnn2,ibnds2,iconn)

               nhcp = 0
               do i=1,ibnds2
                   ia = ianz(icnn2(i))
                   if (.not.(ia.eq.6.or.ia.eq.1.or.ia.eq.15)) then
                      nhcp = nhcp + 1
                      iccn(nhcp) = icnn2(i)
                   endif
               end do

               if (nhcp.ne.0) then
                  if (igtyp.eq.25) then
                     igtyp = 18 + nhcp
                  elseif (igtyp.eq.24) then
                     igtyp = 21 + nhcp
                  endif
               endif
               if (nhcp.eq.1.and.(iccn(1).gt.1.and.icnn(1).lt.100)) 
     &         then
                  if (ianz(iccn(1)).eq.8.and.
     &               (itmp.eq.6.or.itmp.eq.3)) then
                     igtyp = 24
                  endif
               endif
            endif
            if (ian1.eq.7)  igtyp = 26
            if (ian1.eq.8)  then
               igtyp = 27
               call flth(icnn(1),icnn2,ibnds2,iconn)
               if (ibnds2.eq.2) then
                  if (ianz(icnn2(1)).eq.1.and.ianz(icnn2(2)).eq.1)
     &               igtyp = 30
               endif
            endif
            if (ian1.eq.15) igtyp = 28
            if (ian1.eq.16) igtyp = 29
         endif

      elseif (ian.eq.6) then

         if (irs.eq.2) igtyp = 3
         if (irs.eq.3) igtyp = 4
         if (irs.eq.4) igtyp = 5
         if (irs.eq.6) igtyp = 6
         if (irs.eq.7) then
            igtyp = 6
            if (in.eq.3) igtyp = 72
         endif

         if ((irs.eq.3.or.irs.eq.6).and.ibnds.eq.3.and.
     &      (io.ge.1.or.is.ge.1)) then
            icon = 0
            if (ian1.eq.8.or.ian1.eq.16) icon = icnn(1)
            if (ian2.eq.8.or.ian2.eq.16) icon = icnn(2)
            if (ian3.eq.8.or.ian3.eq.16) icon = icnn(3)
            if (icon.gt.0) then
               call ispn(itmp,icon,irng,idochg,1)
               if ((itmp.eq.10.or.itmp.eq.3).and.irng.le.0) igtyp = 2
            endif
         endif

      elseif (ian.eq.7) then

c n1     (.1)
         if (irs.eq.2) igtyp = 37
c n2, nc (.2,.ar) (nc contributes 1 el to pi system)
         if ((irs.eq.3.or.irs.eq.6).and.ibnds.eq.2) then
            igtyp = 38
            if (irs.eq.6) igtyp = 43
         endif
c na     (.2,.ar,.pl) (.pl contributes 2 el to pi system)
         if ((irs.eq.3.or.irs.eq.6.or.irs.eq.9).and.ibnds.eq.3) 
     &      igtyp = 41
c n3     (.3)
         if (irs.eq.4.and.ibnds.eq.3) igtyp = 39
c no     (.2,.3,.pl)
         if ((irs.eq.3.or.irs.eq.4.or.irs.eq.9).and.
     &      ibnds.eq.3.and.io.eq.2) igtyp = 48
c n4     (.4)
         if (irs.eq.5) igtyp = 40
c n      (.am)
         if (irs.eq.8) igtyp = 36
c nh     (.3)
         if ((irs.eq.4.or.irs.eq.9).and.ibnds.eq.3.and.ihc.eq.3) then
            iar = 0
            if (ian1.ne.1) then
               call ispn(itmp,icnn(1),irng,idochg,1)
               if (itmp.eq.6) iar = iar + 1
            endif
            if (ian2.ne.1) then
               call ispn(itmp,icnn(2),irng,idochg,1)
               if (itmp.eq.6) iar = iar + 1
            endif
            if (ian3.ne.1) then
               call ispn(itmp,icnn(3),irng,idochg,1)
               if (itmp.eq.6) iar = iar + 1
            endif
            if (iar.gt.0) igtyp = 47
         endif
         if (ibnds.eq.3.and.ic.gt.0) then
            do i=1,ibnds
               nat = ianz(icnn(i))
               if (nat.eq.6) then
                  call flth(icnn(i),icnn2,ibnds2,iconn)
                  if (ibnds2.eq.3) then
                      iscat = 1
                      do j=1,3
                         if (ianz(icnn2(j)).ne.7) iscat = 0
                      end do
                      if (iscat.eq.1) igtyp = 47
                  endif
               endif
            end do
         endif

      elseif (ian.eq.8) then

         if (irs.eq.3.or.irs.eq.10) igtyp = 49
         if ((irs.eq.4.or.irs.eq.6).and.ibnds.eq.2) then
            if (ih.eq.2) then 
               igtyp = 52
            elseif (ih.eq.1) then
               igtyp = 50
            else
               igtyp = 51
            endif
         endif

      elseif (ian.eq.15) then

         if (ibnds.le.2) igtyp = 53
         if (ibnds.eq.3) then

c difference between p3 and p4 may need some adjustment

            iar = 0
            if (ian1.ne.1) then
               call ispn(itmp,icnn(1),irng,idochg,1)
               if (itmp.eq.3) iar = iar + 1
            endif
            if (ian2.ne.1) then
               call ispn(itmp,icnn(2),irng,idochg,1)
               if (itmp.eq.3) iar = iar + 1
            endif
            if (ian3.ne.1) then
               call ispn(itmp,icnn(3),irng,idochg,1)
               if (itmp.eq.3) iar = iar + 1
            endif
            if (iar.gt.0) then
               igtyp = 55
            else
               igtyp = 54
            endif
         endif
         if (ibnds.ge.4) igtyp = 56

      elseif (ian.eq.16) then

         if (ibnds.eq.1) igtyp = 64
c ibnds = 2 may need some refinement, sh clear, ss clear, but s2 ?
         if (ibnds.eq.2) then
            if (ih.ge.1) then
               igtyp = 68
            else
               if ((irs.eq.4.or.irs.eq.6).or.is.eq.1) then
                  igtyp = 69
               else
                  igtyp = 65
               endif
            endif
         endif
         if (ibnds.eq.3) igtyp = 66
         if (ibnds.ge.4) igtyp = 67

      elseif (ian.eq.9) then
         if (ibnds.eq.1) igtyp = 32
      elseif (ian.eq.17) then
         if (ibnds.eq.1) igtyp = 33
      elseif (ian.eq.35) then
         if (ibnds.eq.1) igtyp = 34
      elseif (ian.eq.53) then
         if (ibnds.eq.1) igtyp = 35
      endif
      
      return
      end

      integer function icred(iat,inoh,ih,ianz,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      dimension iconn(mxcon+1,*),ianz(*)

      icred = 0
      if (iat.le.0) return

      inoh = 0
      ih = 0
      do j=1,iconn(1,iat)
         jat = iconn(j+1,iat)
         if (jat.gt.0) then
            icred = icred + 1
            if (ianz(jat).eq.1) then
               ih = ih + 1
            else
               inoh = inoh + 1
            endif
         endif
      end do

      return
      end

      character*6 function mklab(ian,lab)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxel=100)
      character*2 elemnt,ggstr
      common /elem/elemnt(mxel)

      mklab = '      '
      mklab(1:2) = elemnt(ian)
      if (lab.gt.99) return
      if (mklab(2:2).eq.' ') then
          mklab(2:3) = ggstr(lab)
      else
          mklab(3:4) = ggstr(lab)
      endif

      return
      end

      integer function ifmt(in)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      integer teni

      teni = 1
      ifmt = 1

      do while(.true.)
         teni = teni * 10
         ifmt = ifmt + 1
         if (mod(in,teni) .eq. in)  return
      end do

      return
      end

      subroutine wrtnd(iun,ianz,iaton,iconn,lring,ityp,coo)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/  elemnt(mxel)
      common /cllab/ iclon,iclpnt(4)
      integer*2 ityp
      common /types/ iff
      character*3 pdbsym,hsym,chtnk,chtmp,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      logical isqmmm
      integer*2 itypi,it10000
      character*40 fmtstr
      dimension icnn(mxcon),lring(*)
      dimension coo(3,*),ianz(*),iaton(*),iconn(mxcon+1,*),ityp(*)


      it10000=10000

      if (iun.gt.100) then
         isqmmm = .true.
         iun = iun - 100
      else
         isqmmm = .false.
      endif

c write tinker .xyz file, charmm atom types are written

      toang = 0.52917706d0

      natoms = 0
      ioffmx = mxnat
      ioffmn = 0
      do i=1,iatoms
         if (ianz(i).lt.100.and.ianz(i).gt.0) natoms = natoms + 1
         if (ianz(i).eq.100) then
             ioffmx = i
             if (ioffmn.eq.0) ioffmn = i
         endif
      end do
      ioffmn = ioffmx - ioffmn + 1

      do i=1,iatoms
         lring(i) = 0
         iaton(i) = 2
      end do

      fmtstr = '(i5,1x,a2,1x,3(f12.6),1x,i6,1x,8(i5,1x))'
      ifm = ifmt(natoms)
      fmtstr(3:3) = char(48+ifm)
      fmtstr(35:35) = char(48+ifm)
      if (iff.ge.2.and.iff.le.4) then
         fmtstr(9:9) = char(51)
      endif

c tinker

      if (iff.eq.2) then
         write(iun,*) natoms,
     &   ' molden generated tinker .xyz (charmm param.)'
      elseif (iff.eq.3) then
         write(iun,*) natoms,
     &   ' molden generated tinker .xyz (amber param.)'
      elseif (iff.eq.4) then
         write(iun,*) natoms,
     &   ' molden generated tinker .xyz (amoeba param.)'
      else
         write(iun,*) natoms,
     &   ' molden generated tinker .xyz (mm3 param.)'
      endif

      do i=1,iatoms

         if (ianz(i).ne.100) then
            ibnds = 0
            do j=1,iconn(1,i)
               if (iconn(j+1,i).gt.0) then
                  ibnds = ibnds + 1
                  if (iconn(j+1,i).gt.ioffmx) then
                     icnn(ibnds) = iconn(j+1,i) - ioffmn
                  else
                     icnn(ibnds) = iconn(j+1,i)
                  endif
               endif
            end do

CNF 	QM atoms are at the H level, while MM atoms are at M and L levels               
            if (isqmmm. and. ityp(i).lt.10000) then
                itypi = ityp(i) + 20000
            else if(isqmmm) then
                itypi = ityp(i) - (ityp(i)/10000)*10000
            else
                itypi = mod(ityp(i),it10000)
            endif

            if (iff.ge.2.and.iff.le.4) then

               chtmp = elemnt(ianz(i))//' '
               if (iff.eq.2) then
                  if (ityp(i).gt.0.and.(mod(itypi,it10000)).le.mxchtp)
     &               chtmp = chtnk(mod(itypi,it10000))
               endif
               if (iff.eq.3) then
                  if (ityp(i).gt.0.and.(mod(itypi,it10000)).le.mxamb)
     &            then
                     chtmp = ambtnk(mod(itypi,it10000))
                     if (itypi.gt.mxamb) itypi = itypi + (2000-mxamb)
                  endif
               endif
               if (iff.eq.4) then
                  if (ityp(i).gt.0.and.(mod(itypi,it10000)).le.mxamo)
     &               chtmp = amotnk(mod(itypi,it10000))
               endif
c               write(iun,'(i6,2x,a3,1x,3(f12.6),1x,i6,1x,8i5)')
               write(iun,fmtstr)
     &            i,chtmp,(coo(j,i)*toang,j=1,3),
     &            itypi,(icnn(j),j=1,ibnds)

            elseif (iff.eq.1) then

c               write(iun,'(i5,1x,a2,1x,3(f12.6),1x,i6,1x,8i5)')
               write(iun,fmtstr)
     &            i,elemnt(ianz(i)),(coo(j,i)*toang,j=1,3),
     &            itypi,(icnn(j),j=1,ibnds)
            else

               itypi = mmtyp(i,ianz(i),0,ianz,iaton,iconn)
               if (isqmmm. and. ityp(i).lt.10000) then
                  itypi = itypi + 20000
               elseif(isqmmm) then
                  itypi = itypi - (itypi/10000)*10000
               else
                  itypi = mod(itypi,it10000)
               endif
c               write(iun,'(i5,1x,a2,1x,3(f12.6),1x,i6,1x,8i5)')
               write(iun,fmtstr)
     &            i,elemnt(ianz(i)),(coo(j,i)*toang,j=1,3),
     &            itypi,(icnn(j),j=1,ibnds)

            endif


         endif

      end do

      do i=1,iatoms
         iaton(i) = 1
      end do

      return
      end

      subroutine reordc(iatom,ibnds,icnn,iconn,nmet,imet,lring,ityp)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      logical doit
      integer*2 ityp
      dimension icnn(mxcon), iconn(mxcon+1,*),imet(*),lring(*),ityp(*)

      ibnds = 0
      do i=1,nmet
          if (iatom.eq.imet(i)) return
      end do

      do j=1,iconn(1,iatom)
         jj = iconn(j+1,iatom)

         if (jj.gt.0) then
            doit = .true.
            do i=1,nmet
               if (jj.eq.imet(i)) doit = .false.
            end do
            if (ityp(iatom).eq.649.and.ityp(jj).ne.650) doit = .false.
            if (ityp(iatom).ne.650.and.ityp(jj).eq.649) doit = .false.
            if (doit) then
               ibnds = ibnds + 1
               icnn(ibnds) = lring(iconn(j+1,iatom))
            endif
         endif
      end do

      return
      end

      subroutine wraone(iun,iatom,ibnds,icnn,ianz,isurf,ityp,coo,q)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      character*3 pdbsym,hsym,chtnk,chtmp,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm,icst
      parameter (mxel=100)
      character*2 elemnt
      common /elem/  elemnt(mxel)
      integer*2 ityp
      parameter (mxcon=10)
      dimension icnn(mxcon)
      dimension coo(3,*),q(*),ianz(*),ityp(*),isurf(*)

      toang = 0.52917706d0

      if (icst.eq.1) then
         iopt = isurf(iatom)
      else
         iopt = 1
      endif

      chtmp = elemnt(ianz(iatom))//' '
      itypi = ityp(iatom)

      if (itypi.gt.0) then


c Amber
          if (itypi.le.mxamb) then
            chtmp = ambtnk(itypi)
            if (itypi.gt.mxamb) itypi = itypi + (2000-mxamb)
          endif

          write(iun,'(i6,2x,a3,1x,3(f9.3),1x,i4,1x,8(i6,1x))')
     &      iopt,chtmp,(coo(j,iatom)*toang,j=1,3),
     &      itypi,(icnn(j),j=1,ibnds)

      elseif (itypi.lt.0) then
c GAFF
          if (iabs(itypi).le.mxgff) then
            chtmp = gffstr(iabs(itypi))//' '
          endif

          write(iun,
     &      '(i6,2x,a3,1x,3(f9.3),1x,i3,1x,f6.3,1x,8(i6,1x))')
     &      iopt,chtmp,(coo(j,iatom)*toang,j=1,3),
     &      itypi,q(iatom),(icnn(j),j=1,ibnds)

      elseif (itypi.eq.0) then

          write(iun,
     &      '(i6,2x,a3,1x,3(f9.3),1x,i3,1x,f6.3,1x,8(i6,1x))')
     &      iopt,chtmp,(coo(j,iatom)*toang,j=1,3),
     &      itypi,q(iatom),(icnn(j),j=1,ibnds)

      endif


      return
      end

      logical function ismet(ian)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mexcl=10)
      common /metexc/ qexcl(mexcl),ianexc(mexcl)

      ismet = .false.

      do i=1,mexcl
         if (ian.eq.ianexc(i)) ismet = .true.
      end do

      return
      end

      subroutine wrgfd(iun,ianz,iaton,iconn,isurf,lring,lwrit,ncalf,
     &                 ishoh,iresid,ityp,coo,q,
     &                 xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxchtp=136)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      parameter (mxcon=10)
      parameter (numcal=50000)
      parameter (mxmet=500)
      parameter (mxheta=150)
      common /athlp/ iatoms, mxnat
      integer*2 ityp
      logical ismet
      common /types/ iff
      common /pbc/ abc(3),ibox,icell,igfmap
      character*3 pdbsym,hsym,chtnk,chtmp,ambtnk
      character*2 amotnk,gffstr
      character*3 hez
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),chtnk(mxchtp),
     &                ambtnk(mxamb),amotnk(mxamo),gffstr(mxgff)
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      logical odupl
      dimension ipdb(mxsym),ihpdb(mxhsym*3),ich(3)
      dimension icnn(mxcon),ihcnn(mxcon)
      dimension coo(3,*),q(*),ianz(*),iaton(*),iconn(mxcon+1,*),
     &          ityp(*),isurf(*),lring(*),lwrit(*),iresid(*)
      dimension iresb(numcal),iresn(numcal),ireso(numcal),imet(mxmet)

c write AMBFOR .xyz file, amber/gaff atom types are written


      if (iff.ne.7) then
         iff = 7
         call dotyp(0)
      endif

      torad = datan(1.0d0) / 45.0d0
      nuntyp = 0
      nmet = 0
      ntota = iatoms

      do i=1,iatoms

         if (ianz(i).lt.100.and.ianz(i).gt.0) then
             if (ityp(i).eq.0.or.ityp(i).eq.-1) then
                print*,'atom ',i,' unknown ',ianz(i)
                nuntyp = nuntyp + 1
             endif
         endif
         if (nmet.lt.mxmet) then
             if (ismet(ianz(i))) then
                 nmet = nmet + 1
                 imet(nmet) = i
             endif
         endif

      end do

      if (nuntyp.ne.0) then
         print*,nuntyp,' untyped atoms '
         print*,' '
         print*,'Remember, the only metals supported by amber/gaff'
         print*,'are:'
         print*,' '
         do i=651,658
            print*,ambtnk(i)
         end do
      endif


c     determine new order of atoms to be written (kept in lring)

      do i=1,iatoms
         lwrit(i) = 0
      end do

      natoms = 0
      do i=1,ncalf
         
         call getpdb(i,ipdb,ihpdb)
         do j=1,mxsym
             if (ipdb(j).ne.0) then
                natoms = natoms + 1
                lring(ipdb(j)) = natoms
                lwrit(ipdb(j)) = 1
             endif
         end do
         do j=1,mxhsym*3
             if (ihpdb(j).ne.0) then
                natoms = natoms + 1
                lring(ihpdb(j)) = natoms
                lwrit(ihpdb(j)) = 1
             endif
         end do

      end do

      do i=1,iatoms
         if (ianz(i).ne.100.and.lwrit(i).eq.0) then
            if (ianz(i).eq.8.and.ityp(i).eq.649) then
               natoms = natoms + 1 
               lring(i) = natoms
               lwrit(i) = 1
               do j=1,iconn(1,i)
                  jj = iconn(j+1,i)
                  if (jj.gt.0) then
                     if (ianz(jj).eq.1.and.ityp(jj).eq.650) then
                        natoms = natoms + 1 
                        lring(jj) = natoms
                        lwrit(jj) = 1
                     endif
                  endif
               end do
            else
               if (lwrit(i).eq.0.and.
     &            odupl(i,coo,xa,ya,yb,za,zb,zc)) then
                  natoms = natoms + 1 
                  lring(i) = natoms
                  lwrit(i) = 1
               endif
            endif
         endif
      end do

c ambfor amber + gaff

      nwramb = natoms

      if (ibox.eq.1) then
         write(iun,'(a,3(f9.3,1x))')
     &      '[AMBFOR] box ',abc(1),abc(2),abc(3)
      else
         if (icell.eq.1) then
             write(iun,'(a,6(f9.3,1x))')
     &          '[AMBFOR] cell ',a,b,c,
     &          alpha/torad,beta/torad,gamma/torad
         else
             write(iun,*) '[AMBFOR]'
         endif
      endif

      write(iun,*) natoms,
     &   ' molden generated ambfor .xyz '

      do i=1,iatoms
         lwrit(i) = 0
      end do

      ires = 0
      do i=1,ncalf

         iresb(i) = 0
         call getpdb(i,ipdb,ihpdb)

         do j=1,mxsym
             if (ipdb(j).ne.0) then

                 call reordc(ipdb(j),ibnds,icnn,iconn,nmet,imet,lring,
     &                       ityp)
                 call wraone(iun,ipdb(j),ibnds,icnn,ianz,isurf,
     &                       ityp,coo,q)

                 lwrit(ipdb(j)) = 1
                 if (iresb(i).eq.0) then
                     iresb(i) = lring(ipdb(j))
                     ireso(i) = ipdb(j)
                     iresn(i) = i
                     ires = iresid(ipdb(j))
                 endif
             endif
         end do

         do j=1,mxhsym*3
             if (ihpdb(j).ne.0) then
                 call reordc(ihpdb(j),ibnds,icnn,iconn,nmet,imet,lring,
     &                       ityp)
                 call wraone(iun,ihpdb(j),ibnds,icnn,ianz,isurf,
     &                       ityp,coo,q)

                 lwrit(ihpdb(j)) = 1
             endif
         end do

      end do

      nres = ncalf
      nhoh = 0
      do i=1,iatoms

         if (ianz(i).ne.100.and.lwrit(i).eq.0) then

            call reordc(i,ibnds,icnn,iconn,nmet,imet,lring,ityp)
            call wraone(iun,i,ibnds,icnn,ianz,isurf,ityp,coo,q)
            lwrit(i) = 1

            if (iresid(i).ne.ires) then
               nres = nres + 1
               iresb(nres) = lring(i)
               ireso(nres) = i
               iresn(nres) = iresid(i)
               ires = iresid(i)
            elseif (iresid(i).eq.-ishoh.and.ityp(i).eq.649) then
               nres = nres + 1
               nhoh = nhoh + 1
               iresb(nres) = lring(i)
               ireso(nres) = i
               iresn(nres) = -(ishoh+nhoh)
            endif

            if (ianz(i).eq.8.and.ityp(i).eq.649) then
               do j=1,iconn(1,i)
                  jj = iconn(j+1,i)
                  if (jj.gt.0) then
                     if (ianz(jj).eq.1.and.ityp(jj).eq.650) then
                        call reordc(jj,ibnds,icnn,iconn,nmet,imet,lring,
     &                              ityp)
                        call wraone(iun,jj,ibnds,icnn,ianz,isurf,
     &                              ityp,coo,q)
                        lwrit(jj) = 1
                     endif
                  endif
               end do

            endif

         endif

      end do

      write(iun,'(a)') '[RESIDUES]'

      do i=1,nres
         ires = abs(iresn(i)) - 2
         if (ihashz.eq.1) then
            if (ires-1+4.gt.mxheta) then
               hez =  "   "
               if (ityp(ireso(i)).eq.649) hez = "HOH"
               if (ityp(ireso(i)).eq.659) hez = "Cl-"
               if (ityp(ireso(i)).eq.652) hez = "Na+"
            else
               hez = hetz(ires-1+4)
               if (hez.eq."   ") then
                  call gtht(ich,ires-1+4)
                  hez(1:1) = char(ich(1))
                  hez(2:2) = char(ich(2))
                  hez(3:3) = char(ich(3))
               endif
            endif
         else
            write(hez,'(i3)') ires
         endif
         if (iresn(i).gt.-4) then
            write(iun,'(i5,1x,i5,1x,a3)') iresn(i),iresb(i)
         else
            write(iun,'(i5,1x,i5,1x,a3)') iresn(i),iresb(i),hez
         endif
      end do

      nresi = iresn(nres)
      do i=1,iatoms
         lwrit(i) = lring(i)
      end do

      do i=1,iatoms
         il = lwrit(i)
         if (il.gt.0.and.il.le.mxnat) then
            lring(lwrit(i)) = i
         endif
      end do

      do i=natoms+1,iatoms
         lring(i) = 0
      end do

      return
      end

      subroutine wrogd(iun,rx,ry,rz,
     &                 ianz,iaton,iatclr,iresid,iconn,lring,coo,rzp,
     &                 reson,ianf,nchain,ncalf)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxel=100)
      parameter (mxcon=10)
      parameter (ncmx=32)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat
      common /surf/  natorg,noscnd
      character*2 elemnt
      common /elem/  elemnt(mxel)
      logical dozme
      common /getpnt/irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &               iconv,ircus,dozme
      integer dolabs,fancy,shade,atcol,persp,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /vropt/ ivtwo,ihand,ivadd
      integer reson
      common /cllab/ iclon,iclpnt(4)
      logical doit
      common /gracom/ uscl,colscd,colscpd,ivdwpl
      common /strips/ qnormo(3),crpnto(3,ncmx),crnrmo(3,ncmx),
     &                numcir,nquad
      common /vrcol/ jcol(3,16)
      common /setogl/ idirogl
      dimension rx(3),ry(3),rz(3)
      dimension icnn(mxcon),t(3),tmp1(3),tmp2(3),tmp3(3),tlpos(3)
      dimension rxyzt(3,3),ianz(*),iresid(*),iaton(*),iatclr(*),
     &          coo(3,*),rzp(*),iconn(mxcon+1,*),lring(*),reson(*),
     &          ianf(*)

      ihand = 0

c write moldenogl .ogl file or ribbon povray file

      toang = 0.52917706d0

      do i=1,iatoms
         lring(i) = 0
      end do

      natoms = 0
      do i=1,iatoms

         doit = .false.
         if (ipdbon.eq.1) then
             if (iresid(i).gt.0) then
                if (reson(iresid(i)).eq.1) 
     &            doit = .true. 
             elseif (iresid(i).lt.-3) then
                  doit = .true. 
             endif
         else
             doit = .true. 
         endif

         if (ianz(i).lt.100.and.ianz(i).gt.0.and.iaton(i).gt.0
     &       .and.doit) then
             natoms = natoms + 1
             lring(i) = natoms
         endif

      end do


      if (ivtwo.eq.3) then

c ogl file

        if (atcol.eq.1) then
         if (ivdwpl.eq.1.and.fancy.eq.1) then
            if (numcir.gt.8) then
               write(iun,'(a)') 
     &           '[MOLECULE] UNSCALED SPACEFILL CONN HIGH'
            else
               write(iun,'(a)') '[MOLECULE] UNSCALED SPACEFILL CONN'
            endif
         else
            if (numcir.gt.8) then
               write(iun,'(a)') '[MOLECULE] UNSCALED CONN HIGH'
            else
               write(iun,'(a)') '[MOLECULE] UNSCALED CONN'
            endif
         endif
        else
         if (ivdwpl.eq.1.and.fancy.eq.1) then
            if (numcir.gt.8) then
               write(iun,'(a)') 
     &          '[MOLECULE] UNSCALED GRPCOL SPACEFILL CONN HIGH'
            else
               write(iun,'(a)') 
     &          '[MOLECULE] UNSCALED GRPCOL SPACEFILL CONN'
            endif
         else
            if (numcir.gt.8) then
               write(iun,'(a)') 
     &          '[MOLECULE] UNSCALED GRPCOL CONN HIGH'
            else
               write(iun,'(a)') '[MOLECULE] UNSCALED GRPCOL CONN'
            endif
         endif
        endif
        write(iun,*) natoms

      elseif (ivtwo.eq.2) then

        call cntvec(t,coo,ianz,iatoms)

c        sc1 = vlen(t)*1.4d0

        rzpmax = -10000.d0
        do i=1,iatoms
           if (rzp(i).gt.rzpmax) rzpmax = rzp(i)
        end do

        sc1 = rzpmax*1.8d0

c transpose rotation matrix

        do i=1,3
           rxyzt(1,i) = rx(i)
           rxyzt(2,i) = ry(i)
           rxyzt(3,i) = rz(i)
        end do

        g = rxyzt(1,2) 
        rxyzt(1,2) = rxyzt(2,1)
        rxyzt(2,1) = g

        g = rxyzt(1,3) 
        rxyzt(1,3) = rxyzt(3,1)
        rxyzt(3,1) = g

        g = rxyzt(2,3) 
        rxyzt(2,3) = rxyzt(3,2)
        rxyzt(3,2) = g


c position of the eye in tmp1

        tmp2(1) = 0.0d0
        tmp2(2) = 0.0d0
        tmp2(3) = sc1

        tmp1(1) = 
     &    tmp2(1)*rxyzt(1,1)+tmp2(2)*rxyzt(1,2)+tmp2(3)*rxyzt(1,3)
        tmp1(2) = 
     &    tmp2(1)*rxyzt(2,1)+tmp2(2)*rxyzt(2,2)+tmp2(3)*rxyzt(2,3)
        tmp1(3) = 
     &    tmp2(1)*rxyzt(3,1)+tmp2(2)*rxyzt(3,2)+tmp2(3)*rxyzt(3,3)


c eye looks at center tmp2

        tmp2(1) = 0.0d0
        tmp2(2) = 0.0d0
        tmp2(3) = 0.0d0
        
c position of the light in tlpos

        tmp3(1) = dsqrt(3.0d0)/3.0d0*sc1
        tmp3(2) = dsqrt(3.0d0)/3.0d0*sc1
        tmp3(3) = dsqrt(3.0d0)/3.0d0*sc1

        tlpos(1) = 
     &    tmp3(1)*rxyzt(1,1)+tmp3(2)*rxyzt(1,2)+tmp3(3)*rxyzt(1,3)
        tlpos(2) = 
     &    tmp3(1)*rxyzt(2,1)+tmp3(2)*rxyzt(2,2)+tmp3(3)*rxyzt(2,3)
        tlpos(3) = 
     &    tmp3(1)*rxyzt(3,1)+tmp3(2)*rxyzt(3,2)+tmp3(3)*rxyzt(3,3)


        call plcini
        call plphd(iun,ihand,tmp1,tmp2,tlpos)

      endif
      call cntvec(t,coo,ianz,iatoms)

c  the molecule

      ilin = 0
      do i=1,iatoms

         if (i.gt.natorg.and.natorg.ne.0) ilin = 1

         if (ianz(i).lt.100) then

           ibnds = 0
           do j=1,iconn(1,i)
              if (iconn(j+1,i).gt.0) then
                 if (iaton(iconn(j+1,i)).gt.0) then
                    if (lring(iconn(j+1,i)).gt.0) then
                       ibnds = ibnds + 1
                       icnn(ibnds) = lring(iconn(j+1,i))
                    endif
                 endif
              endif
           end do

           doit = .false.
           if (ipdbon.eq.1) then
               if (iresid(i).gt.0) then
                  if (reson(iresid(i)).eq.1) 
     &              doit = .true. 
               elseif (iresid(i).lt.-3) then
                    doit = .true. 
               endif
           else
               doit = .true. 
           endif

           if (iaton(i).gt.0.and.doit) then

             do j=1,3
                 tmp1(j) = (coo(j,i)-t(j))*toang
             end do

             ia = ianz(i)
             if (atcol.eq.1) then

              if (ivtwo.eq.3) then

               write(iun,'(i3,1x,3(f12.6),1x,i2,1x,8i5)')
     &         ianz(i),(tmp1(j),j=1,3),ibnds,
     &         (icnn(k),k=1,ibnds)

              elseif (ivtwo.eq.2) then

               ic = icol(ia)
               call plvsph(iun,jcol,ic,tmp1,vdwr(ia)/toang)

              endif

             else

              if (ivtwo.eq.3) then

               write(iun,'(i3,1x,i2,1x,3(f12.6),1x,i2,1x,8i5)')
     &         ianz(i),iatclr(i),(tmp1(j),j=1,3),
     &         ibnds,(icnn(k),k=1,ibnds)

              elseif (ivtwo.eq.2) then

               ic = iatclr(i)
               call plvsph(iun,jcol,ic,tmp1,vdwr(ia)/toang)

              endif
             endif

           endif


         endif

      end do

      if (ivtwo.eq.2) then
         write(iun,*) '}'
         write(iun,*) 'molecule'
      endif

c lines

      if (ilin.eq.1.and.ivtwo.eq.3) then
         write(iun,'(a)') '[LINES]'
         do i=1,iatoms
            if (i.gt.natorg.and.natorg.ne.0) then
               do j=1,iconn(1,i)
                  jj = abs(iconn(j+1,i))
                  if (jj.lt.i) then
                    write(iun,'(i2,1x,3(f12.6),1x,3(f12.6))')
     &              iatclr(i),((coo(k,i)-t(k))*toang,k=1,3),
     &              ((coo(k,jj)-t(k))*toang,k=1,3)
                  endif
               end do
            endif
         end do
      endif

c ribbons

100   if (ipdbon.eq.1) then

         if (ivtwo.eq.3) then

          write(iun,'(a)') '[COL STRANDTOP] 1.0 0.0 1.0'
          write(iun,'(a)') '[COL STRANDBOTTOM] 1.0 0.0 1.0'
          write(iun,'(a)') '[COL HELIXOUT] 0.0 1.0 0.0'
          write(iun,'(a)') '[COL HELIXIN] 0.6 0.6 0.6'
          write(iun,'(a)') '[COL RNA] 0.5 1.0 0.5'
          write(iun,'(a)') '[COL COIL] 1.0 1.0 1.0'

          idirogl = 0
          call ribgll(iun,ianf,nchain,ncalf,iatoms)


         elseif (ivtwo.eq.2) then

          write(iun,*) '#declare STRANDTOP = texture {'
          write(iun,*) 'pigment { color rgb<0.0, 0.0, 1.0> }'
          write(iun,*)
     &       'finish { ambient 0.4 diffuse 0.4 specular 0.9}'
          write(iun,*) '}'

          write(iun,*) '#declare STRANDBOTTOM = texture {'
          write(iun,*) 'pigment { color rgb<1.0, 0.0, 1.0> }'
          write(iun,*)
     &       'finish { ambient 0.4 diffuse 0.4 specular 0.9}'
          write(iun,*) '}'

          write(iun,*) '#declare HELIXOUT = texture {'
          write(iun,*) 'pigment { color rgb<0.0, 1.0, 0.0> }'
          write(iun,*)
     &       'finish { ambient 0.4 diffuse 0.4 specular 0.9}'
          write(iun,*) '}'

          write(iun,*) '#declare HELIXIN = texture {'
          write(iun,*) 'pigment { color rgb<0.6, 0.6, 0.6> }'
          write(iun,*)
     &       'finish { ambient 0.4 diffuse 0.4 specular 0.9}'
          write(iun,*) '}'

          write(iun,*) '#declare RNA = texture {'
          write(iun,*) 'pigment { color rgb<0.5, 1.0, 0.5> }'
          write(iun,*)
     &       'finish { ambient 0.4 diffuse 0.4 specular 0.9}'
          write(iun,*) '}'

          write(iun,*) '#declare COIL = texture {'
          write(iun,*) 'pigment { color rgb<1.0, 1.0, 1.0> }'
          write(iun,*)
     &       'finish { ambient 0.4 diffuse 0.4 specular 0.9}'
          write(iun,*) '}'

          call ribbon(0,2,1,iun,0,0,0)
          call ribbon(0,2,2,iun,0,0,0)
          call ribbon(0,2,3,iun,0,0,0)
          call ribbon(0,2,4,iun,0,0,0)
          call ribbon(1,2,1,iun,0,0,0)
          call ribbon(1,2,2,iun,0,0,0)
          call ribbon(1,2,3,iun,0,0,0)
          call ribbon(1,2,4,iun,0,0,0)
          call ribbon(3,2,1,iun,0,0,0)
          call ribbon(2,2,1,iun,0,0,0)

         endif

      endif

      ihand = 1

      do i=1,iatoms
         lring(i) = 0
      end do

      return
      end

      integer function mmtyp(iat,ian,idochg,ianz,iaton,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxt=14)
      character*4 atype
      common /atypes/ ihbt(mxt),atype(mxt)
      logical smrng
      integer*2 ictyp
      dimension icnn(mxcon),iring(4),ianz(*),iaton(*),iconn(mxcon+1,*)

      call ispn(isp,iat,irng,idochg,0)
      ihb = ihbt(isp)
      ict = ictyp(iat,ian,idochg,ianz,iconn)

      ibnds = 0
      ih0 = 0
      ic0 = 0
      in0 = 0
      io0 = 0
      ip0 = 0
      is0 = 0
      ili = 0
      do i=1,iconn(1,iat)
         if (iconn(i+1,iat).gt.0) then
            ibnds = ibnds + 1
            icnn(ibnds) = iconn(i+1,iat)
            ian0 = ianz(iconn(i+1,iat))
            if (ian0.eq.1) then
               ih0 = ih0 + 1
            elseif (ian0.eq.3) then
               ili = ili + 1
            elseif (ian0.eq.6) then
               ic0 = ic0 + 1
            elseif (ian0.eq.7) then
               in0 = in0 + 1
            elseif (ian0.eq.8) then
               io0 = io0 + 1
            elseif (ian0.eq.15) then
               ip0 = ip0 + 1
            elseif (ian0.eq.16) then
               is0 = is0 + 1
            endif
         endif
      end do

      mmtyp = 0

      if (ian.eq.1) then

         mmtyp = 5

         if (ibnds.eq.1) then

            ian1 = ianz(icnn(1))

            if (ian1.eq.6) then

               mmtyp = 5
CNF Add the case of acetylene -> mmtyp = 124
               if (icred(icnn(1),idum1,idum2,ianz,iconn)
     &             .eq.2) mmtyp = 124

            elseif (ian1.eq.7) then

               mmtyp = 23
               if (icred(icnn(1),idum1,idum2,ianz,iconn)
     &             .eq.4) mmtyp = 48
               call ispn(irs,icnn(1),irng,idochg,0)
               if (irs.eq.8) mmtyp = 28

            elseif (ian1.eq.8) then

CNF Add the case of phenol/enol -> mmtyp = 73
               mmtyp = 21

               if (icred(icnn(1),idum1,idum2,ianz,iconn)
     &             .eq.2) then
                  do i=1,iconn(1,icnn(1))
                     l = abs(iconn(i+1,icnn(1)))
                     if (ianz(l).eq.6) then
                        if (icred(l,idum1,idum2,ianz,iconn)
     &                      .eq.3) then
                           io = 0
                           ic = 0
                           do j=1,iconn(1,l)
                              k = abs(iconn(j+1,l))
                              if (ianz(k).eq.8) io = io + 1
                              if (ianz(k).eq.6) ic = ic + 1
                           end do
                           if (io.eq.2) mmtyp = 24
                           if (ictyp(l,ianz(l),idochg,ianz,iconn)
     &                          .eq.16) mmtyp = 24
                           if (ic.ge.1) mmtyp = 73
                        endif
                     endif
                  end do
               endif
            elseif (ian1.eq.16) then
               mmtyp = 44
            endif
         endif
      elseif (ian.eq.6) then
         mmtyp = 1
         if (ihb.eq.1) then
            mmtyp = 4
         elseif(ihb.eq.2.or.ihb.eq.4) then
            mmtyp = 2
            do i=1,ibnds
               if (ianz(icnn(i)).eq.8) then
                  if (icred(icnn(i),idum1,idum2,ianz,iconn)
     &                .eq.1) mmtyp = 3
               endif
            end do
            if (smrng(iat,iring,nring,ianz,iaton,iconn)) then
               if (nring.eq.3) mmtyp = 38
               if (nring.eq.4) mmtyp = 57
            endif
         elseif(ihb.eq.3) then
            mmtyp = 1
            if (smrng(iat,iring,nring,ianz,iaton,iconn)) then
               if (nring.eq.3) mmtyp = 22
               if (nring.eq.4) mmtyp = 56
            endif
         endif
      elseif (ian.eq.7) then
         mmtyp = 8
         if (ihb.eq.1) then
            mmtyp = 10
         elseif(ihb.eq.2.or.ihb.eq.4) then
            mmtyp = 37
            if (isp.eq.8) mmtyp = 9
         elseif(ihb.eq.3) then
            mmtyp = 8
            if (isp.eq.5) mmtyp = 39
            if (isp.eq.8) mmtyp = 9
            if (ict.eq.34) mmtyp = 40
            if (ict.eq.38) mmtyp = 46
            if (ili.gt.0) mmtyp = 164
         endif
      elseif (ian.eq.8) then
         mmtyp = 6
         if (ihb.eq.2) then
            mmtyp = 7
            if (ibnds.eq.1.and.ic0.eq.1) then
               do i=1,iconn(1,icnn(1))
                  iat2 = iconn(i+1,icnn(1))
                  if (ianz(iat2).eq.8.and.iat2.ne.iat) then
                     icc = 0
                     do j=1,iconn(1,iat2)
                       iat3 = iconn(j+1,iat2)
                       if (iat3.gt.0) then
                          if (ianz(iat3).eq.6) icc = icc + 1
                       endif
                     end do
                     if (icc.eq.1) mmtyp = 77
                     if (icc.eq.2) mmtyp = 78
                  endif
               end do
            endif
            if (ict.eq.52) mmtyp = 41
            if (isp.eq.10.and.ianz(icnn(1)).eq.6) mmtyp = 47
         elseif(ihb.eq.3) then
            mmtyp = 6
            if (ic0.ge.1) then
               do i=1,ibnds
                  if (ianz(icnn(i)).eq.6.and.icnn(i).ne.iat) then
                     do j=1,iconn(1,icnn(i))
                        jj = iconn(1+j,icnn(i))
                        if (ianz(iabs(jj)).eq.8.and.iabs(jj).ne.iat)
     &                  then
                          if (icred(icnn(i),idum1,idum2,ianz,iconn)
     &                        .eq.3) mmtyp = 75 
                        endif
                     end do
                  endif
               end do
            endif
            if (ict.eq.52) mmtyp = 41
            if (smrng(iat,iring,nring,ianz,iaton,iconn)) then
               if (nring.eq.3) mmtyp = 49
            endif
         endif
      elseif (ian.eq.15) then
         mmtyp = 60
         if (ibnds.eq.3) mmtyp = 25
      elseif (ian.eq.16) then
         mmtyp = 15
         if (isp.eq.13) mmtyp = 17
         if (isp.eq.14) mmtyp = 18
         if (ict.eq.72.or.ibnds.eq.1) mmtyp = 42
         if (ibnds.eq.2.and.is0.eq.1) mmtyp = 104
      else
         if (ian.eq.2) mmtyp = 51
         if (ian.eq.3) mmtyp = 163
         if (ian.eq.5) then
            mmtyp = 27
            if (ibnds.eq.3) mmtyp = 26
         endif
         if (ian.eq.9)  mmtyp = 11
         if (ian.eq.10) mmtyp = 52
         if (ian.eq.12) mmtyp = 59
         if (ian.eq.14) mmtyp = 19
         if (ian.eq.17) mmtyp = 12
         if (ian.eq.18) mmtyp = 53
         if (ian.eq.20) mmtyp = 125
         if (ian.eq.26) mmtyp = 61
         if (ian.eq.27) mmtyp = 65
         if (ian.eq.28) mmtyp = 63
         if (ian.eq.32) mmtyp = 31
         if (ian.eq.34) mmtyp = 34
         if (ian.eq.35) mmtyp = 13
         if (ian.eq.36) mmtyp = 54
         if (ian.eq.38) mmtyp = 126
         if (ian.eq.50) mmtyp = 32
         if (ian.eq.52) mmtyp = 35
         if (ian.eq.53) mmtyp = 14
         if (ian.eq.54) mmtyp = 55
         if (ian.ge.56.and.ian.le.71) mmtyp = ian + 71
         if (ian.eq.82) mmtyp = 33
      endif

      if (mmtyp.eq.0) print*,'no mm3 type for this atom'

      return
      end

      logical function smrng(i,iring,nring,ianz,iaton,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      logical ocnos
      dimension iring(4),ianz(*),iaton(*),iconn(mxcon+1,*)

c finds 3,4 membered rings

      smrng = .false.

      if (ocnos(i,ianz,iaton)) then
         do j=1,iconn(1,i)
            jj = abs(iconn(j+1,i))
            if (ocnos(jj,ianz,iaton)) then
               do k=1,iconn(1,jj)
                  kk = abs(iconn(k+1,jj))
                  if (ocnos(kk,ianz,iaton).and.kk.ne.i) then
                     do l=1,iconn(1,kk)
                        ll = abs(iconn(l+1,kk))
                        if (ocnos(ll,ianz,iaton).and.ll.ne.jj) then
                           if (ll.eq.i) then
                              nring = 3
                              iring(1) = i
                              iring(2) = jj
                              iring(3) = kk
                              smrng = .true.
                              return
                           else
                              do m=1,iconn(1,ll)
                                 mm = abs(iconn(m+1,ll))
                                 if (ocnos(mm,ianz,iaton).and.mm.ne.kk) 
     &                           then
                                    if (mm.eq.i) then
                                       nring = 4
                                       iring(1) = i
                                       iring(2) = jj
                                       iring(3) = kk
                                       iring(4) = ll
                                       smrng = .true.
                                       return
                                    endif
                                 endif
                              end do
                           endif
                        endif
                     end do
                  endif
               end do
            endif
         end do
      endif

      return
      end

      subroutine gtheat(igttnk,iheat,heat)
      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*137 line
      common /curlin/ line

      igttnk = 1
      idebug = 0

      if (idebug.eq.1) print*,'subroutine gtheat'

      call search(line,'[AMBFOR]',istat)

      if (istat.eq.1) then

         if (getlin(0).eq.1) idum = 1

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.2) goto 100
         
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
            if (nstr.eq.4) then
               if (icdex(str,"emin").ne.0) then
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.2) then
                       iheat = 1
                       heat = dble(itype)
                   endif
                   if (ktype.eq.3) then
                       iheat = 1
                       heat = rtype
                   endif
               endif
            endif
         endif
      else
         goto 100
      endif
 
      return

100   igttnk = 0
      return
      end

      subroutine gettyd(ires,iat1,iat2,ityp,ipdbt,
     &                  ianz,iresid,iamino,icalf,ncalf)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxgff=72)
      parameter (mxamb=1590)
      parameter (mxrsn=19)
      parameter (mxcat=79)
      parameter (numcal=50000)
      common /ambtmp/ ianamb(mxamb),iangff(mxgff),itpdbt(mxamb),
     &                iamca(2,mxcat),iamop(2,mxrsn)
      integer*2 ipdbt,ityp
      dimension icalf(6,*)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension ianz(*),iresid(*),ipdbt(*),ityp(*),iamino(*)

      do i=iat1,iat2
         iresid(i) = ires
      end do

      if (ires.le.0) return

      do i=1,mxsym
          ipdb(i) = 0
      end do

      do i=1,mxhsym*3
          ihpdb(i) = 0
      end do

      iam = 0

      do i=iat1,iat2

         it = ityp(i)
         if (it.ne.0.and.it.le.mxamb) then
             if (ianz(i).eq.1) then

                ip = itpdbt(it)

                if (ip.ne.0) then
                   ipinc = 1
                   if (it.eq.117.or.it.eq.119.or.it.eq.132.or.it.eq.134)
     &                ipinc = 3
                   if (it.eq.303) then
                      if (ihpdb(ip).eq.0) then
                         ipdbt(i) =  ip
                         ihpdb(ip) = i
                      elseif (ihpdb(ip+1).eq.0) then
                         ipdbt(i) =  ip+1
                         ihpdb(ip+1) = i
                      elseif (ihpdb(ip+3).eq.0) then
                         ipdbt(i) =  ip+3
                         ihpdb(ip+3) = i
                      else
                         ipdbt(i) =  ip+4
                         ihpdb(ip+4) = i
                      endif
                   else
                      if (ihpdb(ip).eq.0) then
                         ipdbt(i) =  ip
                         ihpdb(ip) = i
                      elseif (ihpdb(ip+ipinc).eq.0) then
                         ipdbt(i) =  ip+ipinc
                         ihpdb(ip+ipinc) = i
                      else
                         ipdbt(i) =  ip+2
                         ihpdb(ip+2) = i
                      endif
                   endif
                endif

             else

                ip = itpdbt(it)
                if (ip.ne.0) then
                   if (ip.eq.4) then
                      if (ipdb(4).eq.0) then
                         ipdbt(i) =  4
                         ipdb(4) = i
                      elseif (ipdb(38).eq.0) then
                         ipdbt(i) = 38
                         ipdb(38) = i
                      endif
                   else
                      if (ipdb(ip).eq.0) then
                         ipdbt(i) =  ip
                         ipdb(ip) = i
                      elseif (ipdb(ip+1).eq.0) then
                         ipdbt(i) =  ip+1
                         ipdb(ip+1) = i
                      endif
                   endif
                endif

                if (ipdbt(i).eq.2) then
                   do j=1,mxcat
                      if (iamca(1,j).eq.it) iam = iamca(2,j)
                   end do
                elseif (ipdbt(i).eq.46) then
                   do j=1,mxrsn
                      if (iamop(1,j).eq.it) iam = iamop(2,j)
                   end do
                   if (iam.eq.0) then
                      inc = 0
                      if (it.eq.1244.or.it.eq.1232) inc = 1
                      if (it.eq.1246.or.it.eq.1234) inc = 1
                      it1 = ityp(i+inc)
                      do j=1,mxrsn
                         if (iamop(1,j)+inc.eq.it1) iam = iamop(2,j)
                      end do
                   endif
                   
                endif

             endif
         endif

      end do

      iamino(ires) = iam
  
      if (iam.gt.0.and.iam.le.20) then

         icalf(1,ires) = ipdb(2)
         icalf(2,ires) = ipdb(1)
         icalf(3,ires) = ipdb(3)
         icalf(4,ires) = ihpdb(1)

      elseif (iam.gt.23) then

         icalf(1,ires) = ipdb(43)
         icalf(2,ires) = ipdb(46)
         icalf(3,ires) = ipdb(47)
         icalf(4,ires) = ipdb(48)
         icalf(5,ires) = ipdb(50)
         icalf(6,ires) = ipdb(51)

c         if (ipdb(43).eq.0.and.ipdb(46).ne.0.and.ires.le.numcal)
c     &       icalf(1,ires) = ipdb(46)

         if (ipdb(43).eq.0.and.ires.le.numcal) then
             if (ihpdb(118).ne.0) then
                 icalf(1,ires) = ihpdb(118)
             elseif (ipdb(46).ne.0) then
                 icalf(1,ires) = ipdb(46)
             endif
         endif

      endif

      ncalf = ires

      return
      end

      subroutine gettnd(igttnk,idebug,ipdbon,iffset,iheat,heat,
     &                  ianz,iconn,iatclr,ityp,coo,q,isurf,issdon,
     &                  iclon,ichx,ishoh,ision,nspg,nat,norg,
     &                  xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str, tstr
      character*2 catom, catomt, tolowf,iel, ggstr
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (numcal=50000)
      parameter (maxsym=108)
      parameter (mxrsn=19)
      parameter (mxgff=72)
      parameter (mxamb=1590)
      parameter (mxcat=79)
      parameter (mxheta=150)
      common /athlp/ iatoms, mxnat
      integer*2 ityp
      common /types/ iff
      common /zmfrst/ ihaszm, nz, mxzat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*137 line,tline
      common /curlin/ line
      character*80 tnknm
      integer tnkbg,tnkit,tnkarc,tnkarf,tnkprg
      common /tnkopt/ rmsgrd,tnkbg,tnkit,tnkarc,tnkarf,tnkprg,tnknm,icst
      common /tnkpro/ iresrd
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      common /pbc/ abc(3),ibox,icell,igfmap
      common /ambtmp/ ianamb(mxamb),iangff(mxgff),itpdbt(mxamb),
     &                iamca(2,mxcat),iamop(2,mxrsn)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      logical first,dall,box,gnreal
      dimension iel(maxsym)
      dimension coo(3,*),q(*),ianz(*),iconn(mxcon+1,*),ityp(*),
     &          isurf(*),iatclr(*),v1(3),v2(3),v3(3)
      dimension ires(numcal),ibeg(numcal),iend(numcal)

      data iangff /
     & 99, 6, 6, 6, 6, 6, 
     &  6, 6, 6, 6, 6, 6, 
     &  6, 6, 6, 6, 6, 6, 
     &  1, 1, 1, 1, 1, 1, 
     &  1, 1, 1, 1, 1, 1,
     &  1, 9,17,35,53, 7, 
     &  7, 7, 7, 7, 7, 7, 
     &  7, 7, 7, 7, 7, 7, 
     &  8, 8, 8, 8,15,15, 
     & 15,15,15,15,15,15,
     & 15,15,15,16,16,16, 
     & 16,16,16,16,16,6/

      data (ianamb(i),i=1,60) /
     &   7, 6, 6, 1, 8, 1,
     &   7, 6, 6, 1, 8, 1,
     &   6, 1, 7, 6, 6, 1,
     &   8, 1, 6, 1, 6, 1,
     &   6, 1, 7, 6, 6, 1,
     &   8, 1, 6, 1, 6, 1,
     &   6, 1, 6, 1, 7, 6,
     &   6, 1, 8, 1, 6, 1,
     &   6, 1, 6, 1, 6, 1,
     &   7, 6, 6, 1, 8, 1/
      data (ianamb(i),i=61,120) /
     &   6, 1, 8, 1, 7, 6,
     &   6, 1, 8, 1, 6, 1,
     &   8, 1, 6, 1, 7, 6,
     &   6, 1, 8, 1, 6, 1,
     &  16, 1, 7, 6, 6, 1,
     &   8, 1, 6, 1,16, 7,
     &   6, 6, 8, 1, 6, 1,
     &   6, 1, 6, 1, 7, 6,
     &   6, 1, 8, 1, 6, 1,
     &   6, 6, 1, 6, 1, 6/
      data (ianamb(i),i=121,180) /
     &   1, 7, 6, 6, 1, 8,
     &   1, 6, 1, 6, 6, 1,
     &   6, 1, 6, 8, 1, 7,
     &   6, 6, 1, 8, 1, 6,
     &   1, 6, 6, 1, 6, 7,
     &   1, 6, 6, 1, 6, 1,
     &   6, 1, 6, 1, 7, 6,
     &   6, 1, 8, 1, 6, 1,
     &   6, 7, 1, 6, 1, 6,
     &   1, 7, 1, 7, 6, 6/
      data (ianamb(i),i=181,240) /
     &   1, 8, 1, 6, 1, 6,
     &   7, 1, 6, 1, 6, 1,
     &   7, 7, 6, 6, 1, 8,
     &   1, 6, 1, 6, 7, 6,
     &   1, 6, 1, 7, 1, 7,
     &   6, 6, 1, 8, 1, 6,
     &   1, 6, 8, 7, 6, 6,
     &   1, 8, 1, 6, 1, 6,
     &   8, 7, 1, 7, 6, 6,
     &   1, 8, 1, 6, 1, 6/
      data (ianamb(i),i=241,300) /
     &   1, 6, 8, 7, 6, 6,
     &   1, 8, 1, 6, 1, 6,
     &   1, 6, 8, 7, 1, 7,
     &   6, 6, 1, 8, 1, 6,
     &   1, 6, 1,16, 6, 1,
     &   7, 6, 6, 1, 8, 1,
     &   6, 1, 6, 1, 6, 1,
     &   6, 1, 7, 1, 7, 6,
     &   6, 1, 8, 1, 6, 1,
     &   6, 1, 6, 1, 7, 1/
      data (ianamb(i),i=301,360) /
     &   6, 7, 1, 7, 6, 6,
     &   1, 8, 1, 6, 1, 6,
     &   1, 6, 1, 7, 1, 7,
     &   6, 6, 1, 8, 6, 1,
     &   7, 6, 6, 1, 8, 1,
     &   6, 1, 6, 1, 6, 8,
     &   6, 1, 8, 6, 1, 6,
     &   8, 7, 1, 7, 1, 6,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1,8/
      data (ianamb(i),i=361,420) /
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 6, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6/
      data (ianamb(i),i=421,480) /
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6/
      data (ianamb(i),i=481,540) /
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 1, 7, 6, 6,
     &   1, 8, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 1/
      data (ianamb(i),i=541,600) /
     &   8, 1, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 1,
     &   8, 1, 7, 6, 6, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8/
      data (ianamb(i),i=601,659) /
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   1, 7, 6, 6, 1, 8,
     &   8, 1, 3,11,19,37,
     &  55,12,20,30,17/
      data (ianamb(i),i=660,671) /
     &   7, 6, 6, 1, 8, 1,
     &   6, 1, 6, 8, 8, 1/
      data (ianamb(i),i=672,685) /
     &   7, 6, 6, 1, 8, 1,
     &   6, 1, 6, 1, 6, 8,
     &   8, 1/
      data (ianamb(i),i=686,701) /
     &   7, 6, 6, 1, 8, 1,
     &   6, 1, 6, 1, 6, 1,
     &   6, 1, 7, 1/

      data (ianamb(i),i=702,1000) /299*0/

      data (ianamb(i),i=1001,1253) /
     & 8,6,1,1,6,1,8,6,1,6,1,6,1,8,1,8,7,6,6,7,
     & 6,7,6,7,6,1,7,1,1,1,8,6,1,1,6,1,8,6,1,6,
     & 1,6,1,8,1,8,7,6,6,7,6,7,6,7,6,1,7,1,1,8,
     & 1,8,6,1,1,6,1,8,6,1,6,1,6,1,8,1,8,7,6,7,
     & 6,6,6,8,7,1,1,1,1,8,6,1,1,6,1,8,6,1,6,1,
     & 6,1,8,1,8,7,6,7,6,6,6,8,1,8,1,1,8,6,1,1,
     & 6,1,8,6,1,6,1,6,1,1,8,7,6,6,7,6,7,6,7,6,
     & 1,7,1,1,1,8,6,1,1,6,1,8,6,1,6,1,6,1,1,8,
     & 7,6,6,7,6,7,6,7,6,1,7,1,1,8,1,8,6,1,1,6,
     & 1,8,6,1,6,1,6,1,1,8,7,6,7,6,6,6,8,7,1,1,
     & 1,1,8,6,1,1,6,1,8,6,1,6,1,6,1,1,8,7,6,7,
     & 6,6,6,8,1,8,6,1,1,15,8,8,1,8,15,8,8,1,8,15,
     & 8,15,8,8,1,8,15,8,8,1,8,15,8/

      data (ianamb(i),i=1254,1590) /
     & 8,6,1,1,6,1,8,6,1,6,1,6,1,8,1,8,7,6,6,7,
     & 6,7,6,7,6,1,7,1,1,6,1,8,6,1,6,1,8,6,1,6,
     & 1,6,1,8,1,8,7,6,7,6,6,6,1,8,7,1,6,1,8,6,
     & 1,6,1,8,6,1,6,1,6,1,8,8,7,6,8,7,6,7,1,6,
     & 1,6,1,6,1,8,6,1,6,1,8,6,1,6,1,6,1,8,1,8,
     & 7,6,6,7,6,1,7,6,7,1,6,8,6,1,6,1,8,6,1,6,
     & 1,8,6,1,6,1,6,1,8,1,8,7,6,6,7,6,7,6,7,6,
     & 8,1,1,7,6,1,8,6,1,6,1,8,6,1,6,1,6,1,8,1,
     & 8,7,6,6,7,6,7,6,7,6,8,1,1,7,1,6,1,8,6,1,
     & 6,1,8,6,1,6,1,6,1,8,8,7,6,6,7,6,7,6,7,6,
     & 8,1,1,7,1,6,1,8,6,1,6,1,8,6,1,6,1,6,1,8,
     & 1,8,7,6,6,7,6,7,6,7,6,8,7,6,6,1,6,1,6,1,
     & 6,1,6,1,6,1,6,8,8,6,1,7,1,6,8,8,6,1,8,6,
     & 1,6,1,8,6,1,6,1,6,1,8,1,8,7,6,7,6,6,6,8,
     & 8,1,1,1,8,6,1,6,1,8,6,1,6,1,6,1,8,1,8,7,
     & 6,7,6,6,6,8,8,1,1,6,1,8,6,1,6,1,8,6,1,6,
     & 1,6,1,8,1,8,6,6,7,6,7,6,8,8,1,1,1/

      data (itpdbt(i),i=1,150) /
     & 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 5, 7, 1, 2,
     & 3, 1, 4, 4, 5, 7, 7, 13, 8, 16, 1, 2, 3, 1, 4,
     & 4, 5, 7, 6, 10, 10, 22, 11, 25, 1, 2, 3, 1, 4, 4,
     & 5, 7, 7, 13, 8, 16, 10, 22, 1, 2, 3, 1, 4, 4, 5,
     & 7, 31, 10, 1, 2, 3, 1, 4, 4, 5, 7, 32, 13, 8, 16,
     & 1, 2, 3, 1, 4, 4, 5, 7, 37, 10, 1, 2, 3, 1, 4,
     & 4, 5, 7, 37, 1, 2, 3, 4, 4, 5, 7, 6, 10, 9, 19,
     & 1, 2, 3, 1, 4, 4, 5, 7, 6, 10, 22, 13, 31, 17, 40,
     & 1, 2, 3, 1, 4, 4, 5, 7, 6, 10, 22, 13, 31, 17, 33,
     & 52, 1, 2, 3, 1, 4, 4, 5, 7, 6, 10, 22, 11, 23/

      data (itpdbt(i),i=151,300) /
     & 31, 14, 15, 37, 18, 46, 19, 49, 16, 58, 1, 2, 3, 1, 4,
     & 4, 5, 7, 6, 20, 22, 11, 25, 13, 31, 24, 34, 1, 2, 3,
     & 1, 4, 4, 5, 7, 6, 20, 22, 11, 25, 13, 31, 24, 1, 2,
     & 3, 1, 4, 4, 5, 7, 6, 20, 11, 25, 13, 31, 24, 34, 1,
     & 2, 3, 1, 4, 4, 5, 7, 6, 29, 1, 2, 3, 1, 4, 4,
     & 5, 7, 6, 29, 21, 25, 1, 2, 3, 1, 4, 4, 5, 7, 6,
     & 10, 9, 34, 1, 2, 3, 1, 4, 4, 5, 7, 6, 10, 9, 34,
     & 24, 34, 1, 2, 3, 1, 4, 4, 5, 7, 6, 10, 36, 12, 28,
     & 1, 2, 3, 1, 4, 4, 5, 7, 6, 10, 9, 19, 12, 28, 27,
     & 40, 1, 2, 3, 1, 4, 4, 5, 7, 6, 10, 9, 19, 22, 28/

      data (itpdbt(i),i=301,450) /
     & 17, 25, 55, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 1, 2, 3, 1, 4, 5, 9, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4,
     & 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2,
     & 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4,
     & 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2,
     & 3, 1, 4, 4, 9, 19, 1, 2, 3, 1, 4, 4, 1, 2, 3,
     & 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4,
     & 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3/

      data (itpdbt(i),i=451,600) /
     & 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4,
     & 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3,
     & 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4,
     & 1, 2, 3, 1, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1,
     & 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1,
     & 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1,
     & 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1,
     & 2, 3, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4,
     & 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2,
     & 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4/

      data (itpdbt(i),i=601,750) /
     & 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2,
     & 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4,
     & 4, 1, 2, 3, 1, 4, 4, 1, 2, 3, 1, 4, 4, 1, 2,
     & 3, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
     & 2, 3, 1, 4, 4, 5, 8, 6, 29, 30, 25, 1, 2, 3, 1,
     & 4, 4, 5, 8, 6, 11, 9, 34, 35, 34, 1, 2, 3, 1, 4,
     & 4, 5, 8, 6, 11, 9, 20, 12, 29, 27, 42, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/

      data (itpdbt(i),i=751,900) /
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/

      data (itpdbt(i),i=901,1050) /
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     & 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 46, 47, 61, 62, 48,
     & 64, 49, 54, 73, 50, 67, 52, 70, 53, 76, 51, 66, 56, 57, 65,
     & 59, 62, 55, 60, 58, 82, 64, 136, 137, 112, 46, 47, 61, 62, 48,
     & 64, 49, 54, 73, 50, 67, 52, 70, 53, 76, 51, 66, 56, 57, 65/

      data (itpdbt(i),i=1051,1200) /
     & 59, 62, 55, 60, 58, 121, 61, 124, 125, 69, 112, 46, 47, 61, 62,
     & 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76, 51, 60, 55, 62,
     & 56, 57, 58, 67, 63, 130, 131, 100, 103, 46, 47, 61, 62, 48, 64,
     & 49, 54, 73, 50, 67, 52, 70, 53, 76, 51, 60, 55, 62, 56, 57,
     & 58, 67, 127, 68, 100, 103, 46, 47, 61, 62, 48, 64, 49, 54, 73,
     & 50, 67, 52, 70, 71, 51, 66, 56, 57, 65, 59, 62, 55, 60, 58,
     & 82, 64, 136, 137, 112, 46, 47, 61, 62, 48, 64, 49, 54, 73, 50,
     & 67, 52, 70, 71, 51, 66, 56, 57, 65, 59, 62, 55, 60, 58, 121,
     & 61, 124, 125, 69, 112, 46, 47, 61, 62, 48, 64, 49, 54, 73, 50,
     & 67, 52, 70, 71, 51, 60, 55, 62, 56, 57, 58, 67, 63, 130, 131/

      data (itpdbt(i),i=1201,1253) /
     & 100, 103, 46, 47, 61, 62, 48, 64, 49, 54, 73, 50, 67, 52, 70,
     & 71, 51, 60, 55, 62, 56, 57, 58, 67, 127, 68, 83, 160, 103, 43,
     & 44, 46, 118, 46, 43, 44, 51, 115, 51, 43, 44, 43, 44, 46, 118,
     & 46, 43, 44, 51, 115, 51, 43, 44/

c 1MA

      data (itpdbt(i),i=1254,1284) /
     & 46, 47, 61, 62, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53,
     & 76, 51, 66, 56, 57, 65, 59, 62, 55, 60, 58, 82, 64, 136,
     & 112, 79, 148/

c 5MC

      data (itpdbt(i),i=1285,1311) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 60, 55, 62, 56, 57, 58, 103, 67, 63, 130, 83, 160/

c OMC

      data (itpdbt(i),i=1312,1338) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 51,
     & 60, 55, 67, 62, 56, 63, 130, 57, 100, 58, 103, 80, 151/
     
c 2MG

      data (itpdbt(i),i=1339,1369) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 66, 56, 57, 65, 59, 112, 62, 55, 60, 79, 58, 69, 61,
     & 124, 80, 151/

c M2G

      data (itpdbt(i),i=1370,1399) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 66, 56, 57, 65, 59, 62, 55, 60, 58, 69, 121, 112, 61,
     & 79, 148/
c 7MG

      data (itpdbt(i),i=1400,1430) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 66, 56, 57, 65, 59, 62, 55, 60, 58, 69, 121, 112, 61,
     & 125, 85, 166/

c OMG

      data (itpdbt(i),i=1431,1460) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 51,
     & 66, 56, 57, 65, 59, 62, 55, 60, 58, 69, 121, 112, 61, 124,
     & 80, 151/

c YG

      data (itpdbt(i),i=1461,1511) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 66, 56, 57, 65, 59, 62, 55, 60, 58, 69, 61, 90, 91,
     & 112, 88, 91, 89, 175, 92, 178, 93, 181, 94, 184, 95, 96,
     & 97, 98, 187, 99, 124, 100, 101, 102, 103, 190/
    
c H2U

      data (itpdbt(i),i=1512,1537) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 60, 55, 62, 56, 57, 58, 67, 68, 127, 100, 103/ 

c 5MU
 
      data (itpdbt(i),i=1538,1564) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 60, 55, 62, 56, 57, 58, 67, 68, 127, 103, 83, 160/

c PSU
 
      data (itpdbt(i),i=1565,1590) /
     & 46, 47, 61, 48, 64, 49, 54, 73, 50, 67, 52, 70, 53, 76,
     & 51, 57, 58, 60, 55, 62, 56, 67, 68, 103, 121, 127/

c CA amber types

       data ((iamca(i,j),i=1,2),j=1,mxcat) /
     & 2,1, 8,2, 16,7, 28,11, 42,6, 56,3, 66,5, 78,4, 
     & 88,4, 97,15, 108,18, 123,19, 139,20, 162,17, 179,17, 195,17, 
     & 211,9, 221,10, 233,13, 245,14, 259,8, 272,12, 288,16, 305,0, 
     & 319,2, 326,13, 351,1, 357,2, 363,7, 369,11, 375,6, 381,3,
     & 387,5, 393,4, 399,4, 405,15, 413,18, 419,19, 425,20, 431,17,
     & 437,17, 443,17, 449,9, 455,10, 461,13, 467,14, 473,8, 479,12,
     & 485,16, 491,0, 497,0, 502,1, 508,2, 514,7, 520,11, 526,6,
     & 532,3, 538,5, 544,4, 550,4, 556,15, 561,18, 567,19, 573,20,
     & 579,17, 585,17, 591,17, 597,9, 603,10, 609,13, 615,14, 621,8,
     & 627,12, 633,16, 639,0, 645,0, 661,9, 673,13, 687,12/

c o5* amber nucleotides

       data ((iamop(i,j),i=1,2),j=1,mxrsn) /
     & 1001,24, 1031,26, 1062,25, 1090,28, 
     & 1117,24, 1146,26, 1176,25, 1203,27,
     & 1254,29, 1285,30, 1312,31, 1339,33,
     & 1370,34, 1400,35, 1431,36, 1461,37,
     & 1512,40, 1538,41, 1565,42/

      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x ','oo','oa','ob','oc','ab','bc','ac','zz'/


      igttnk = 1
      first = .true.
      dall = .false.
      ifndhn = 0
      igaff = 0
      iprot = 0
      toang = 0.52917706d0
      box = .false.
      nions = -1

      if (idebug.eq.1) print*,'subroutine gettnk'

c get number of atoms

10    continue

      if (getlin(0).eq.1) then

         tline = line

         if (icdex(line,'[AMBMD]').ne.0) then
            call redel(line,1)
         endif

         if (icdex(line,'[AMBFOR]').ne.0) then
            igaff = 1
            first = .false.
            ic = icdex(line,'box')
            if (ic.ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               box = .true.
               do i=1,3
                  v1(i) = 0.0d0
                  v2(i) = 0.0d0
                  v3(i) = 0.0d0
               end do
               if (gnreal(abc,3,.false.)) then
                  ibox = 1
                  v1(1) = abc(1)/toang
                  v2(2) = abc(2)/toang
                  v3(3) = abc(3)/toang
               else
                  box = .false.
               endif
            endif

            ic = icdex(line,'cell')
            if (ic.ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               icell = 1

               if (gnreal(abc,3,.false.)) then
                  a = abc(1)
                  b = abc(2)
                  c = abc(3)
                  if (gnreal(abc,3,.false.)) then
                     alpha = abc(1)
                     beta  = abc(2)
                     gamma = abc(3)
                  else
                     icell = 0
                  endif
               else
                  icell = 0
               endif
               if (icell.eq.1) then
                  call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,1)
                  iclon = 1
                  ichx = 1
                  nspg = 1
               endif
            endif

            if (getlin(0).eq.1) idum = 1
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            iatoms = itype
            if (iatoms.gt.mxnat) then
               dall = .true.
               goto 100
            endif
         else
            goto 100
         endif

         
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
            if (nstr.eq.4) then
               if (icdex(str,"emin").ne.0) then
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.2) then
                       iheat = 1
                       heat = dble(itype)
                   endif
                   if (ktype.eq.3) then
                       iheat = 1
                       heat = rtype
                   endif
               endif
            endif
         endif
      else
         goto 100
      endif

110   continue

      if (iatoms.eq.0) goto 100

      do iat=1,iatoms
         if (getlin(0).eq.1) then

           tline = line

           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.ne.2) goto 100
           if (igaff.eq.1) isurf(iat) = itype

           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.1) then
              tstr = str
              nstrt = nstr
           else
              goto 100
           endif

           do i=1,3
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) then
                 coo(i,iat) = rtype
              else
                 goto 100
              endif
           end do

           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.2) then
              ityp(iat) = itype
              if (itype.lt.0) then
                 igaff = 1
c this is a gaff atom type, so read in an extra charge field

                 ktype = nxtwrd(str,nstr,itype,rtype)
                 if (ktype.eq.3) then
                    q(iat) = rtype
                    ihasq = 1
                 else
                    goto 100
                 endif

              endif
           else
              goto 100
           endif
           nc = 0
           do i=1,mxcon
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.2) then
                 iconn(i+1,iat) = itype
                 nc = nc + 1
              endif
           end do
           iconn(1,iat) = nc

c determine elemnt

           if (igaff.eq.1) then

c AMBFOR atomnumber

              i1 = abs(ityp(iat))
              if (ityp(iat).lt.0) then
                 if (i1.gt.0.and.i1.le.mxgff) iatmp = iangff(i1)
              else
                 iprot = 1
                 if (i1.gt.0.and.i1.le.mxamb) iatmp = ianamb(i1)
              endif

           else

c other force fields atomnumber

              if (nstrt.eq.1) then
                 catomt(1:1) = tstr(1:1)
                 catomt(2:2) = ' '
              else
                 catomt = tstr(1:2)
                 if (catomt(2:2).eq.'+'.or.catomt(2:2).eq.'-'
     &              .or.catomt(2:2).eq.'*') catomt(2:2) = ' '
              endif
              catom = tolowf(catomt)
              iatmp = 0

              if (first.and.iffset.le.1) then

                 do j=1,maxsym
                    if (catom .eq. iel(j)) iatmp = j - 1
                 end do
                 if (catom.eq.'xx') iatmp = 99
                 if (catom.eq.'lp') iatmp = 99

              else

                 if (nstrt.eq.3) then
                     if (tstr(1:3).eq.'SOD'.or.tstr(1:3).eq.'sod') 
     &                   iatmp = 11
                     if (tstr(1:3).eq.'CAL'.or.tstr(1:3).eq.'cal') 
     &                   iatmp = 20
                     if (tstr(1:3).eq.'Li+') iatmp = 3
                     if (tstr(1:3).eq.'Na+') then
                         nions = iat
                         iatmp = 11
                     endif
                     if (tstr(1:3).eq.'Rb+') iatmp = 37
                     if (tstr(1:3).eq.'Cs+') iatmp = 55
                     if (tstr(1:3).eq.'Mg+') iatmp = 12
                     if (tstr(1:3).eq.'Ca+') iatmp = 20
                     if (tstr(1:3).eq.'Zn+') iatmp = 30
                     if (tstr(1:3).eq.'Cl+') then
                         nions = iat
                         iatmp = 17
                     endif
                 elseif (nstrt.eq.2) then
                     if (tolowf(tstr(1:2)).eq.'mg') iatmp = 12
                     if (tolowf(tstr(1:2)).eq.'fe') iatmp = 26
                     if (tolowf(tstr(1:2)).eq.'zn') iatmp = 30
                     if (tolowf(tstr(1:2)).eq.'h1') ifndhn = 1
                     if (tolowf(tstr(1:2)).eq.'hn') ifndhn = 2
                     if (tolowf(tstr(1:2)).eq.'k+') iatmp = 19
                 endif

                 if (iatmp.eq.0) then
                     if (catom(1:1).eq.'h') iatmp = 1
                     if (catom(1:1).eq.'c') iatmp = 6
                     if (catom(1:1).eq.'n') iatmp = 7
                     if (catom(1:1).eq.'o') iatmp = 8
                     if (catom(1:1).eq.'f') iatmp = 9
                     if (catom(1:1).eq.'p') iatmp = 15
                     if (catom(1:1).eq.'s') iatmp = 16
                     if (catom(1:2).eq.'cl') iatmp = 17
                     if (catom(1:2).eq.'br') iatmp = 35
                     if (catom(1:1).eq.'i') iatmp = 53
                     if (catom(1:1).eq.'x') iatmp = 99
                 endif
              endif
              if (iatmp.le.0.or.iatmp.gt.maxsym-1) goto 100

           endif

           ianz(iat) = iatmp

        else
          print*,'Number of atoms read ',iat,
     &           ' less than specified in the header of file ',
     &           iatoms
          goto 100
        endif

      end do

      if (getlin(0).eq.1) then

         if (icdex(line,'[RESIDUES]').ne.0) then

             ihsres = 0
             do while (getlin(0).eq.1)

                if (icdex(line,'[AMBFOR]').ne.0) then
                   call bckfil
                   goto 200
                endif

                if (iresrd.eq.0) then

                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.2) then
                      ihsres = ihsres + 1
                      irs = itype
                      if (irs.eq.0) then
                         print*,"entry residue list equals zero"
                         goto 100
                      endif
                      ires(ihsres) = irs
                   endif

                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.2) then
                      istrt = itype
                      ibeg(ihsres) = istrt
                      if (ihsres.gt.1) iend(ihsres-1) = istrt - 1
                   endif

                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.1) then
                      if (nstr.eq.3) then
                         hetz(ihsres) = str(1:3)
                      elseif (nstr.eq.2) then
                         hetz(ihsres) = ' '//str(1:2)
                      endif
                      ihashz = 1
                   endif

                endif

             end do

200          if (iresrd.eq.0) then

                iend(ihsres) = iatoms

                if (ihsres.gt.1) then

                   do i=1,ihsres
                      call gettyp(ires(i),ibeg(i),iend(i))
                   end do

                   call chkbrk

                   call parsfn('Helix',5,1)
                   call parsfn('Beta',4,1)
                   call parsfn('RNA/DNA',7,1)
                   call parsfn('Coil',4,1)

                   ihet = 0
                   iwat = 0
                   iion = 0
                   iset = 0
                   iseti = 0

                   do i=1,ihsres
                     if (ires(i).lt.0) then
                      ihet = ihet + 1
                      if (iend(i)-ibeg(i)+1.eq.3) then
                         ib = ibeg(i)
                         it1 = ityp(ib)
                         it2 = ityp(ib+1)
                         it3 = ityp(ib+2)
                         if (it1.eq.649.and.it2.eq.650.and.it3.eq.650)
     &                      iwat = 1
                      endif
                      if (iend(i)-ibeg(i)+1.eq.1.and.iset.eq.1) then
                         ib = ibeg(i)
                         if (ib.gt.0) then
                            if (ityp(ib).eq.659.or.ityp(ib).eq.652)
     &                          iion = 1
                         endif
                      endif

                      if (iion.eq.1) then
                         if (iseti.eq.0) then
                            ision = ires(i)
                            nion = iabs(ires(i))
                            iseti = 1
                            call parsfn('ion',3,1)
                         endif
                         iion = 0
                      elseif (iwat.eq.1) then
                         if (iset.eq.0) then
                            ishoh = iabs(ires(i))
                            iset = 1
                            call parsfn('HOH',3,1)
                         endif
                         iwat = 0
                      else
c                         call parsfn('HET'//ggstr(ihet),5,1)
                         call parsfn(hetz(i),3,1)
                      endif
                     endif
                   end do

                   nresi = ires(ihsres)
                   ntota = iatoms
                   iresrd = 1
                endif

             endif

         else

             call bckfil

         endif


      endif

c     Following statement just to convert to au
      call xyzcoo(0,1,0)
      call cooxyz(ianz,iatoms)

      ihaszm = 0
      issdon = 0

      if (iffset.eq.0) then
         if (first) then
            iff = 1
            if (igaff.eq.1) iff = 7
         else
            ipdbon = 1
            if (igaff.eq.1) then
               iff = 7
               if (iprot.ne.1) ipdbon = 0
            else
               if (ifndhn.eq.1) then
                  iff = 3
               elseif (ifndhn.eq.2) then
                  iff = 4
               else
                  iff = 2
               endif
            endif
         endif
         if (iff.eq.3.or.iff.eq.7) then
            do iat=1,iatoms
               call setchg(iat,1)
            end do
         endif
      endif

      if (icell.eq.1) then
         call cpmol2(nat,norg,xa,ya,yb,za,zb,zc,
     &              coo,ianz,iatclr,iconn)
         call addc(coo,ianz,iconn,iatclr,iatoms,xa,ya,yb,za,zb,zc)
      endif

      if (box) then
         iclon = 1
         call addtbx(v1,v2,v3)
      endif

      return

100   if (dall) then
         call rewfil
         igttnk = -1
         return
      endif

      if (first.and.iffset.eq.0) then
         call rewfil
         first = .false.
         ifndhn = 0
         goto 10
      else
         if (idebug.eq.1) print*,'ERROR:',tline
      endif
      igttnk = 0

      return
      end

      subroutine dotyd(icel,ianz,iaton,iatclr,iconn,iresid,
     &                 lwrit,lring,ityp,coo,qat,icont,
     &                 icalf,ncalf,ianf,islu,nchain,iamino,ishoh,
     &                 nat,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)

      parameter (mxel=100)
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (mxt=14)
      parameter (mxppmf=16)
      parameter (mxlpmf=26)
      parameter (mxmol2=41)
      parameter (mxmm3=164)
      parameter (mxchtp=136)
      parameter (mxmsf=235)
      parameter (mxamb=1590)
      parameter (mxamo=201)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxheta=150)

      common /athlp/ iatoms, mxnat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      integer*2 ityp
      common /types/ iff
      character*2  ppmf, lpmf
      character*5  mol2
      character*19 mm3
      character*20 chmtnk
      character*20 ambstr
      character*20 amostr
      character*4  chmsf
      common /ftypes/ihasl(11),mol2(mxmol2),mm3(mxmm3),chmtnk(mxchtp),
     &               chmsf(mxmsf),ambstr(mxamb),amostr(mxamo),
     &               ppmf(mxppmf),lpmf(mxlpmf)
      character*6 atmp
      character*4 atype
      common /atypes/ ihbt(mxt),atype(mxt)
      character*2 elemnt,atom
      common /elem/elemnt(mxel)
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /typoni/ ioniad
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      integer*2 ictyp,igtyp
      logical ochg
      dimension rr(3,3),tr1(3)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*),
     &          iresid(*),ityp(*),lwrit(*),lring(*),qat(*),icont(*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      natoms = iatoms

      if (icel.eq.1) then

         if (ochg(idum,ianz)) then
            idochg = 1
         else
            idochg = 0
         endif

         natoms = nat
         nstor = mxnat-natoms

         do i=1,natoms

            do j=1,3
               coo(j,i) = coo(j,nstor+i)
            end do

            ianz(i) = ianz(nstor+i)

            do j=1,iconn(1,nstor+i)+1
               iconn(j,i) = iconn(j,nstor+i)
            end do

            iatclr(i) = iatclr(nstor+i)

         end do

      else
         if (ihasq.eq.1) idochg = 1
      endif

      do i=1,natoms
         lwrit(i) = 0
         lring(i) = 0
         icont(i) = iaton(i)
         iaton(i) = 2
         if (ioniad.eq.0) ityp(i) = 0
      end do

      if (icel.eq.1) then

         call setrr(alpha,beta,gamma,a,b,c,rr)
  
         do i=1,nat
            do k=1,3
               tr1(k) = trc(coo(1,i),rr,k)
            end do
            do k=1,3
               coo(k,i) = tr1(k)
            end do
         end do

      endif

      if (iff.eq.2) then

c Tinker Charmm
         do i=1,ncalf
             call getpdb(i,ipdb,ihpdb)
             call typeit(ipdb,iamino(i),ihpdb,1)
         end do

      elseif (iff.eq.3.or.iff.eq.7) then

         ifftmp = iff

         if (iff.eq.7) then
            do i=1,natoms
               ir = iresid(i)
               if ((ir.lt.-3.and.ihqset(iabs(ir)+1).eq.0).or.
     &             (ir.le.0.and.ir.ge.-3)) then
                  qat(i) = 0.0d0
               endif
            end do
         endif

c Tinker Amber

         call chkrna(ncalf,iamino)

         do i=1,ncalf
             call getpdb(i,ipdb,ihpdb)
             call typamb(ipdb,iamino(i),ihpdb,1)
         end do

         if (ncalf.gt.0) then
            do i=1,nchain
c n-term cap
              call chkcap(ianf(i),1,iconn,ianz,iresid,qat,icalf,iamino)
c c-term cap
              call chkcap(islu(i),2,iconn,ianz,iresid,qat,icalf,iamino)
            end do
         endif

         iff = ifftmp
         do i=1,natoms
            if (iresid(i).le.-4) then
               if (iresid(i).eq.-ishoh) then
                  if (ianz(i).eq.8) ityp(i) = 649
                  if (ianz(i).eq.1) ityp(i) = 650
               else
                  ncnn = 0
                  do j=1,iconn(1,i)
                     if (iconn(1+j,i).gt.0) ncnn = ncnn + 1
                  end do

                  iset = 0
                  if (ianz(i).eq.3) then
                     ityp(i) = 651
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.11) then
                     ityp(i) = 652
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.19) then
                     ityp(i) = 653
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.37) then
                     ityp(i) = 654
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.55) then
                     ityp(i) = 655
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.12) then
                     ityp(i) = 656
                     qat(i) = 2.0d0
                     iset = 1
                  else if (ianz(i).eq.20) then
                     ityp(i) = 657
                     qat(i) = 2.0d0
                     iset = 1
                  else if (ianz(i).eq.30) then
                     ityp(i) = 658
                     qat(i) = 2.0d0
                     iset = 1
                  else if (ianz(i).eq.17.and.ncnn.eq.0) then
                     ityp(i) = 659
                     qat(i) = -1.0d0
                     iset = 1
                  endif

                  if (iset.ne.1) then
                     if (iff.eq.7) then
                        ityp(i) = igtyp(i,ianz(i),idochg,ianz,iconn)
                        ityp(i) = -ityp(i)
                     endif
                  endif

               endif
            endif
         end do

      elseif (iff.eq.4) then

c Tinker Amoeba
         do i=1,ncalf
             call getpdb(i,ipdb,ihpdb)
             call typamo(ipdb,iamino(i),ihpdb,1)
         end do

      else

         do i=1,natoms
            ityp(i) = 0

            if (iff.eq.1) then
c Tinker MM3
                ityp(i) = mmtyp(i,ianz(i),0,ianz,iaton,iconn)

            elseif (iff.eq.5) then

c Sybyl Mol2
                ityp(i) = 1
                atom = elemnt(ianz(i))
                call ispn(irs,i,irng,idochg,1)
                atmp = atom//atype(irs)
                if (atmp(1:1).eq.' ') atmp(1:5) = atmp(2:6)

                do j=1,mxmol2
                   if (atmp(1:5).eq.mol2(j)) ityp(i) = j
                end do

                if (ityp(i).eq.1.and.ianz(i).eq.16) then
                   if (atmp(1:5).eq."S.ar ") then
                       ityp(i) = 23
                       atmp(1:5) = "S.2  "
                   endif
                endif

            elseif (iff.eq.6) then

c Quanta Charmm
                ityp(i) = ictyp(i,ianz(i),idochg,ianz,iconn)

            elseif (iff.eq.8) then

c PMF scoring
c                call ipmtyp(ipmt,i,ianz(i),idochg)
c                ityp(i) = ipmt

            endif
         end do

      endif

      do i=1,iatoms
         iaton(i) = icont(i)
      end do

      if (icel.eq.1) call fdat(ifd,0,0,0,0,0)

c      do i=1,iatoms
c         iaton(i) = icont(i)
c      end do

      return
      end

      subroutine chkcap(irs,iterm,iconn,ianz,iresid,qat,
     &                  icalf,iamino)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /conrl/ ibnds,icnn(mxcon),io,in,ic,ih,ian1,ian2,ian3,ian4
      dimension iconn(mxcon+1,*),ianz(*),iresid(*),qat(*)
      dimension nace(6),qace(6),nme(6),qnme(6),qnh2(3)
      dimension icalf(6,*),iamino(*)
      data qace /0.59720,-0.56790,-0.36620,0.11230,0.11230,0.11230/
      data qnme /-0.41570,0.27190,-0.14900,0.09760,0.09760,0.09760/
      data qnh2 /-0.46300,0.23150,0.23150/

      if (iterm.eq.1) then
         ncterm = icalf(2,irs)
      else
         ncterm = icalf(3,irs)
      endif

      call getrcn(ncterm,iconn,ianz)

      if (iterm.eq.1) then
c N-term
c        establish carbonyl C of ACE

         do i=1,6
             nace(i) = 0
         end do

         iace = 0
         if ((ic.eq.2.and.iamino(irs).ne.15).or.
     &       (ic.eq.3.and.iamino(irs).eq.15)) then
             
             do i=1,ibnds
                if (ianz(icnn(i)).eq.6.and.iresid(icnn(i)).ne.irs)
     &            iace = icnn(i)
             end do
             if (iace.eq.0) return

         else
            return
         endif

         nace(1) = iace
         call getrcn(iace,iconn,ianz)
         if (io.eq.1) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.8) nace(2) = icnn(i)
             end do
         else
             return
         endif

         if (ic.eq.1) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.6) nace(3) = icnn(i)
             end do
         else
             return
         endif

         call getrcn(nace(3),iconn,ianz)
         if (ih.eq.3) then
             itel = 4
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) then
                    nace(itel) = icnn(i)
                    itel = itel + 1
                endif
             end do
         else
             return
         endif

c        check if all atoms ACE found

         do i=1,6
            if (nace(i).le.0) return
         end do

         do i=1,6
            qat(nace(i)) = qace(i)
         end do

      else

c C-term
c        establish n-methyl N of NME/NH2

         do i=1,6
             nme(i) = 0
         end do

         inme = 0

         if (in.eq.1) then
             
             do i=1,ibnds
                if (ianz(icnn(i)).eq.7.and.iresid(icnn(i)).ne.irs)
     &            inme = icnn(i)
             end do
             if (inme.eq.0) return

         else
            return
         endif

         nme(1) = inme
         inh2 = 0
         call getrcn(inme,iconn,ianz)
         if (ih.eq.1) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) nme(2) = icnn(i)
             end do
         else if (ih.eq.2) then
             inh2 = 1
             itel = 0
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) then
                   nme(2+itel) = icnn(i)
                   itel = itel + 1
                endif
             end do
         else
             return
         endif

         if (inh2.eq.1) then

c           this is NH2 cap

            do i=1,3
               if (nme(i).le.0) return
            end do

            do i=1,3
               qat(nme(i)) = qnh2(i)
            end do

            return
         endif

c        this is NME cap

         if (ic.eq.2) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.6.and.iresid(icnn(i)).ne.irs) 
     &             nme(3) = icnn(i)
             end do
         else
             return
         endif

         call getrcn(nme(3),iconn,ianz)
         if (ih.eq.3) then
             itel = 4
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) then
                    nme(itel) = icnn(i)
                    itel = itel + 1
                endif
             end do
         else
             return
         endif

c        check if all atoms NME found

         do i=1,6
            if (nme(i).le.0) return
         end do

         do i=1,6
            qat(nme(i)) = qnme(i)
         end do

      endif

      return
      end

      subroutine fixchg(ich,qat)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxel=100)
      common /athlp/ iatoms, mxnat
      dimension qat(*)

      addup = dble(ich)

      totch = 0.0d0
      do i=1,iatoms
          totch = totch + qat(i)
      end do 

      totch = totch - addup
      if (dabs(totch).gt.1.0d-7) then
           totch = totch/dble(iatoms)
           do i=1,iatoms
               qat(i) = qat(i) - totch
           end do
      endif

      return
      end

      subroutine adffud(x,y,z,psi,
     &                  stoalfa,stobnorm,istos,naorbs)
c     THIS iS REALLY adffun
c
c     data description
c
c     Integer for SLater functions in ADF
c     istos(5,maxao)      (1) = p orbital is centered on atom (1,p)
c                         (2) = x exponent of p orbtal
c                         (3) = y exponent of p orbtal
c                         (4) = z exponent of p orbtal
c                         (5) = r exponent of p orbtal
c
c     Double for SLater functions in ADF
c     dsladf(2,maxao)     (1) = alfa axponent of p orbital
c                         (2) = normalzzation factor for p orbital
c
c     Double Atomic to Molecular ADF coefficients
c     damadf(maxmo,maxao) LCAO coefficients
c
c
c     xyz(3,numatm)       Atomic coordinates as defined il molden source.
c
c     Number Of SLater functions
c     nosf                number of total slater function defined.
c
c     Number Of Molecular Orbitals
c     nomo                number of defined molecular orbitals
c                         In molden is norbs.
c
c     Number Of total AToms
c     noat                number of total atoms. In molden is natoms.
c
c     Comment:
c             These variables must be seved in a common block and this can
c             be a dedidcated ADF common block or one of the just used
c             common block. Using an old common block we may use the same
c             variables or we can define a new sets of variables with the
c             same memory space. In this last case the portability of source
c             code must be evaluated.
c             Now this function make a loop over all defined molecular
c             orbitals. Code for select the MO to be use in a grid must be
c             write.
c

c
c     declarations
c
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /orbhlp/ mxorb,iuhf,ispd
      common/coord/ xyz(3,numatm)
      common /moldat/ natoms,norbs,nelecs,nat(numatm) 
      real stoalfa,stobnorm
      dimension istos(5,*),stoalfa(*),stobnorm(*)
      dimension psi(*)
c
c     local declarations
c
c     reset psi
c
      do i=1,mxorb
         psi(i) = 0.0d0
      end do


c
c     loop over atomic orbitals
c
         do iao = 1,naorbs
c
c     detect distance from right atom
c
               xk = x - xyz(1,istos(1,iao))
               yk = y - xyz(2,istos(1,iao))
               zk = z - xyz(3,istos(1,iao))
               r2 = xk*xk + yk*yk + zk*zk
               r2 = r2 + 1.d-10
               r1 = dsqrt(r2)


c
c     evaluate function
c
               adffunct = adfpsi(r1,xk,yk,zk,
     &              istos(2,iao),istos(3,iao),
     &              istos(4,iao),istos(5,iao),
     &              stoalfa(iao),stobnorm(iao))
               psi(iao) = adffunct


c            endif
         
         end do

      return
      end

      double precision function adfpsi(r,x,y,z,ia,ib,ic,id,da,dn)
c     
c     variables descriptions:
c     r         atom-point distance
c     x,y,z     point coordinates
c     ia,ib,ic  x,y,z exponents
c     id        r exponent
c     da,dn     alfa and normalizzation factor
c
c     function:
c     psi = dn * x^ia * y^ib * z^ic * r^id * exp(da*r)
c     
      parameter (small=1.0d-10, big=30., zero=0.0d0)
      integer ia,ib,ic,id
      real da,dn
      double precision r,x,y,z,rho,desp
      integer l,n
c
c
      l = ia + ib + ic
      n = l + id + 1
c
      if (dabs(x).lt.small) x = zero
      if (dabs(y).lt.small) y = zero
      if (dabs(z).lt.small) z = zero

c
c     the point is on the nucleus      
c
      if (r.lt.small) then
         if (l.eq.0.and.n.eq.1) then
            adfpsi = 1.0d0
         else
            adfpsi = zero
         endif
         return
      endif
c
c     general case
c
      rho = da * r
      if (rho.lt.big) then
         adfpsi = dn * desp(x,ia) * desp(y,ib) * desp(z,ic) * 
     1        desp(r,id) * dexp(-rho)
      else
         adfpsi = zero
      endif

      return
      end


      double precision function desp(x,a)
      integer a
      double precision x

      if (a.eq.0) then
         desp = 1.0d0
      else 
         desp = x**a
      endif

      return
      end

      subroutine mopdd(istat,ibin,impas,
     &                 vectrs,averag,p,focc,eiga,halfs,psi,nocc,ncols)

c THIS IS REALLY mopin

      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
c**************************************************************************
      logical dat3ln
      character*80 temps
      character*2 gstr
      character*137 lstr
      common /orbhlp/ mxorb,iuhf,ispd
      common /coord / xyz(3,numatm)
      common /moldat/ natoms,norbs,nelecs,nat(numatm)
      common /mopac/  nfirst(numatm),nlast(numatm),
     &                npq(numatm),pqn(numatm),emus(numatm),
     &                emup(numatm),emud(numatm),consts(numatm),
     &                constp(numatm),constd(numatm),npqref(54)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real eiga
      dimension halfs(*), psi(*), vectrs(*),averag(*),focc(*),p(*),
     &          eiga(*)
      dimension emu(numatm,3)
      equivalence (emu(1,1),emus(1)),
     &            (emu(1,2),emup(1)),
     &            (emu(1,3),emud(1))
c
c*********************** mopac file read **************************
c

      istat = 1

      do i=1,mxorb
         psi(i) = 0.d0
      end do

      natoms = 0

      if (ibin.eq.1) then

             read(iun2,end=1000,err=1000) natoms
             if (natoms.gt.numatm.or.natoms.le.0) then
                 natoms = 0
                 istat = 0
                 return
             endif
             rewind iun2
             read(iun2,end=1000,err=1000)
     &       natoms,norbs,nelecs,((xyz(i,j),j=1,natoms),i=1,3)
      else
             call nxtlin(lstr,jstat)
             if (jstat.eq.1.or.jstat.eq.2) goto 1000
             if (.not.dat3ln(lstr)) goto 1000
             call bckfil
             impas = 2
             if (linlen(lstr).gt.25) impas = 1
             if (impas.eq.1) then
                call nxtlin(lstr,jstat)
                if (jstat.eq.1.or.jstat.eq.2) goto 1000
                read(lstr,*,end=1000,err=1000)
     &          natoms,norbs,nelecs,((xyz(i,j),j=1,natoms),i=1,3)
             else
                il = linlen(lstr)
                if (il.eq.25) then
                   call nxtlin(lstr,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(lstr,'(1x,3i8)',end=1000,err=1000)
     &                natoms,norbs,nelecs
                elseif (il.eq.0) then
                   goto 1000
                else
                   call nxtlin(lstr,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(lstr,'(3i8)',end=1000,err=1000)
     &                natoms,norbs,nelecs
                endif
                do i=1,natoms
                   call nxtlin(lstr,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(lstr,'(1x,3f16.8)',end=1000,err=1000)
     &                (xyz(j,i),j=1,3)
                end do
             endif
      endif

      if (norbs.gt.mxorb) then
              temps = 'Max. No. of Orbitals '//gstr(mxorb)//
     &                ' Exceeded'
              if (ibin.eq.0) call inferr(temps,1)
              istat = 0
              return
      endif

      if (ibin.eq.1) then
             read(iun2,end=1000,err=1000)
     &         (nlast(i),nfirst(i),i=1,natoms)
             read(iun2,end=1000,err=1000)
     &         ((emu(j,i),j=1,natoms),i=1,3),(nat(i),i=1,natoms)
      else
             if (impas.eq.1) then
                call nxtlin(lstr,jstat)
                if (jstat.eq.1.or.jstat.eq.2) goto 1000
                read(lstr,*,end=1000,err=1000)
     &            (nlast(i),nfirst(i),i=1,natoms)
                call nxtlin(lstr,jstat)
                if (jstat.eq.1.or.jstat.eq.2) goto 1000
                read(lstr,*,end=1000,err=1000)
     &         ((emu(j,i),j=1,natoms),i=1,3),(nat(i),i=1,natoms)
             else
                do i=1,natoms
                   call nxtlin(lstr,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(lstr,'(1x,2i8)',err=1000)
     &               nfirst(i),nlast(i)
                end do
                do i=1,natoms
                   call nxtlin(lstr,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(lstr,'(1x,3f16.8,i8)',err=1000)
     &            (emu(i,j),j=1,3),nat(i)
                end do
             endif
      endif


      linear = norbs*norbs
c
c  need to read in un-normalised eigenvectors and
c  inverse of overlap matrix
c
      if (ibin.eq.1) then
             read(iun2,end=1000,err=1000)
     &          ((p((i-1)*mxorb+j),j=1,norbs),i=1,norbs)
             read(iun2,end=1000,err=1000)(halfs(i),i=1,linear)
      else
             if (impas.eq.1) then
                call nxtlin(lstr,jstat)
                if (jstat.eq.1.or.jstat.eq.2) goto 1000
                read(lstr,*,end=1000,err=1000)
     &             ((p((i-1)*mxorb+j),j=1,norbs),i=1,norbs)
                call nxtlin(lstr,jstat)
                if (jstat.eq.1.or.jstat.eq.2) goto 1000
                read(lstr,*,end=1000,err=1000)(halfs(i),i=1,linear)
             else
                do i=1,norbs
                   do j=1,norbs
                       call nxtlin(lstr,jstat)
                       if (jstat.eq.1.or.jstat.eq.2) goto 1000
                       read(lstr,'(1x,f16.8)',end=1000,err=1000)
     &                    p((i-1)*mxorb+j)
                   end do
                end do
                do i=1,linear
                   call nxtlin(lstr,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 1000
                   read(lstr,'(1x,f16.8)',end=1000,err=1000) halfs(i)
                end do
             endif
      endif

      call averg(averag,p)
      call mulpxs(p,halfs,psi,vectrs)
      call setcst

      do i=1,norbs
         focc(i) = 0.0d0
      end do

      nelec = nelecs / 2

      do i=1,nelec
         focc(i) = 2.0d0
      end do

      nocc = nelec

      if (nelec*2.ne.nelecs) then
         focc(nelec+1) = 1.0d0
         nocc = nocc + 1
      endif

      ncols = norbs

      do i=1,ncols
         eiga(i) = 0.0e0
      end do

      return
1000  istat = 0
      call inferr('ERROR reading .gpt file',0)
c      call inferr('Unknown File Type !',1)
      return
      end

      subroutine averg(averag,p)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms,norbs,nelecs,nat(numatm)
      common /mopac/  nfirst(numatm),nlast(numatm),
     &                npq(numatm),pqn(numatm),emus(numatm),
     &                emup(numatm),emud(numatm),consts(numatm),
     &                constp(numatm),constd(numatm),npqref(54)
      dimension averag(*),p(*)

      nelec = nelecs/2
      jj = nelec + 1
      fract = 0.5d0*(nelecs-nelec*2)

      do i=1,norbs
        x = 0.d0
        do j=1,nelec
           x = x + p((j-1)*mxorb+i)**2
        end do
        x = x + p((jj-1)*mxorb+i)**2*fract
        averag(i) = x*2
      end do

c
c loop to calculate spherical-average atomic orbital occupancy
c
      do i=1,natoms

           il = nfirst(i)
           iu = nlast(i)
           ir = iu - il + 1

           goto (120,130,130,130,140,140,140,140,140),ir
140            x = 0.d0

               do j=1,5
                   ji = j + il + 3
                   x = x + averag(ji)
               end do

               x = x*0.2d0

               do j=1,5
                   ji = j + il + 3
                   averag(ji) = x
               end do

130            x = 0.d0

               do j=1,3
                   ji = j + il
                   x = x + averag(ji)
               end do

               x = x*0.333333d0

               do j=1,3
                   ji = j + il
                   averag(ji) = x
               end do

120       continue
      end do

      return
      end

      subroutine setcst
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms,norbs,nelecs,nat(numatm)
      common /mopac/  nfirst(numatm),nlast(numatm),
     &                npq(numatm),pqn(numatm),emus(numatm),
     &                emup(numatm),emud(numatm),consts(numatm),
     &                constp(numatm),constd(numatm),npqref(54)
      dimension fa(20)
      data npqref/1,0, 2,2,2,2,2,2,2,0, 
     & 2,2,2,2,2,2,2,0,
     & 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,0, 
     & 5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5/

      do i=1,numatm
          emus(i) = emus(i)/0.529167d0
          emup(i) = emup(i)/0.529167d0
          emud(i) = emud(i)/0.529167d0
      end do

      do i=1,natoms
         npq(i) = npqref(nat(i))
      end do

      fa(2) = dsqrt(2.d0)

      do i=4,20,2
         fa(i) = fa(i-2)*dsqrt(i*i-i*1.d0)
      end do

c
c setting up of orbital constants for density map
c
      do i=1,natoms

          j = 2*npq(i)
          pqn(i) = npq(i)
          if (j.gt.6) pqn(i) = pqn(i) - 1.d0
          k = pqn(i)*2.01
c
c  0.282095  =  sqrt( 1/(4*pi))
c  0.48860   =  sqrt( 3/(4*pi))
c  1.092547  =  sqrt(15/(4*pi))
c
c   for slater-type orbitals radial normalisation constant 
c
c    2**(pqn+1/2)*sqrt(factorial((2*pqn)))
c
c   angular normalisation constants
c
c   s:   1,   p:  sqrt(3),   d: sqrt(15)
c
          if (fa(j).eq..0d0) then
             goto 1000
          else
             consts(i)=(2.d0*emus(i))**(npq(i)+0.5d0)/fa(j)*0.282095
             constp(i)=(2.d0*emup(i))**(npq(i)+0.5d0)/fa(j)*0.48860
          endif

          if (fa(k).eq..0d0) then
             goto 1000
          else
             constd(i)=(2.d0*emud(i))**(pqn(i)+0.5d0)/fa(k)*1.092547
          endif

      end do

      do i=1,natoms
          pqn(i) = pqn(i) - 1
          npq(i) = npq(i) - 1
      end do

      return

1000  print*,'error fa'
      return
      end

      subroutine mulpxs(p,halfs,psi,vectrs)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms,norbs,nelecs,nat(numatm)
      common /mopac/  nfirst(numatm),nlast(numatm),
     &                npq(numatm),pqn(numatm),emus(numatm),
     &                emup(numatm),emud(numatm),consts(numatm),
     &                constp(numatm),constd(numatm),npqref(54)
      dimension halfs(*),psi(*),vectrs(*),p(*)
c
c matrix multiply eigenvectors by inverse square-root of overlap matrix
c
      do i=1,norbs

           l = 0
           do j=1,norbs
               x = 0.d0
               do k=1,norbs
                   l = l + 1
                   x = x + p((i-1)*mxorb+k)*halfs(l)
               end do
               psi(j) = x
           end do

           do j=1,norbs
               p((i-1)*mxorb+j) = psi(j)
           end do

      end do

      do i=1,norbs
           do j=1,norbs
               vectrs((i-1)*mxorb+j) = p((i-1)*mxorb+j)
           end do
      end do

      return
      end

      subroutine mopxyd(iun,coo,ianz,iconn)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxcon=10)
      parameter (maxsym=108)
      parameter (mxel=100)
      character*2 elemnt,tocapf
      character*3 atom,atomt
      common /athlp/  iatoms, mxnat
      common /elem/   elemnt(mxel)
      character*137 line
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*)

      toang = 0.52917706d0
      natoms = iatoms
      nbnds = 0
      idochg = 0

      write(iun,'(a)') 'PM6 XYZ MMOK '
      write(iun,'(a)') '  '
      write(iun,'(a)') '  '

      do i=1,natoms
         atomt = '   '
         atomt(1:2) = tocapf(elemnt(ianz(i)))
         call leftj(atomt,atom)
         write(iun,'(a3,a1,f10.4,a3,f10.4,a3,f10.4,a3)') 
     &      atom,' ',coo(1,i)*toang,' 1 ',coo(2,i)*toang,' 1 ',
     &               coo(3,i)*toang,' 1 '
      end do

      return
      end

      subroutine pdbsiz(iszhnt)
      implicit double precision (a-h,o-z)
      integer iszhnt
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137

      call rewfil

      iszhnt = 0
      do while (.true.)
         call nxtlin(lstr,jstat)
         if (jstat.eq.1) goto 20
         if (lstr(1:4).eq."ATOM".or.lstr(1:6).eq."HETATM") 
     &       iszhnt = iszhnt + 1
      end do

20    iszhnt = 3*iszhnt

      return
      end

      subroutine numhed(numhet,iresid)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension iresid(*)

      nhmtmp = -3
      do i=1,iatoms
         if (iresid(i).lt.nhmtmp) nhmtmp = iresid(i)
      end do
      numhet = iabs(nhmtmp)

      return
      end

      subroutine pdbtyd(ipdb,ihpdb,jres,ihashy,ipdbt)
      implicit double precision (a-h,o-z)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      dimension ipdb(mxsym), ihpdb(mxhsym*3), ipdbt(*)

      do i=1,mxsym
         it = i
         if (i.eq.70) it = 83
         if (i.eq.71) it = 79
         if (i.eq.72) it = 83
         if (i.eq.73) it = 80
         if (i.eq.74) it = 79
         if (i.eq.75) it = 85
         if (jres.gt.23.and.i.eq.38) it = 76
         if (ipdb(i).gt.0) ipdbt(ipdb(i)) = it
      end do

      if (ihashy.eq.1) then
         do i=1,mxhsym*3
            it = i
            if (i.eq.85) it = 124
            if (i.eq.88) it = 125
            if (i.eq.94) it = 130
            if (i.eq.97) it = 131
            if (i.eq.106) it = 136
            if (i.eq.109) it = 137
            if (ihpdb(i).gt.0) ipdbt(ihpdb(i)) = it
         end do
      endif

      return
      end

      subroutine tocap(line,ncars)
      integer ncars
      character*(*) line

      do i=1,ncars
         j = ichar(line(i:i))
         if (j.ge.97.and.j.le.122) line(i:i) = char(j-32)
      end do

      return
      end

      subroutine tolow(line,ncars)
      integer ncars
      character*(*) line

      do i=1,ncars
         j = ichar(line(i:i))
         if (j.ge.65.and.j.le.90) line(i:i) = char(j+32)
      end do

      return
      end

      character*2 function tocapf(line)
      character*2 line

      tocapf = line

      do i=1,2
         j = ichar(tocapf(i:i))
         if (j.ge.97.and.j.le.122) tocapf(i:i) = char(j-32)
      end do

      return
      end

      subroutine search(line,name,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name
      character*137 caps

      istat = 0
      caps  = name  
      len1  = len(name)
      call tocap(caps,len1)
1     call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200
      if (index(line,name).eq.0.and.index(line,caps(1:len1)).eq.0)
     &  go to 1
c
      istat=1
      return
100   call rewfil
      return
200   continue
      return
c
c
      end 

      subroutine searchd(line,name1,name2,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name1,name2
      character*137 caps1, caps2

      istat = 0
      caps1 = name1
      caps2 = name2
      len1  = len(name1)
      len2  = len(name2)
      call tocap(caps1,len1)
      call tocap(caps2,len2)
1     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      if (index(line,name1).eq.0.and.index(line,name2).eq.0
     &.and.index(line,caps1(1:len1)).eq.0
     &.and.index(line,caps2(1:len2)).eq.0) go to 1
c
      istat=1
      return
c
100   call rewfil
c
      return
      end 

      subroutine bcfile()
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      backspace iun2

      return
      end

      subroutine connid(idcon,i,j,idoconv,iconn,ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      logical coni,conj
      dimension ctemp(3),iconn(mxcon+1,*),ianz(*),coo(3,*)

      toang = 0.52917706d0
      toang2 = toang*toang

      idcon = 0
      coni = .true.
      conj = .true.

      k = iconn(1,i)
      m = iconn(1,j)

      do l=1,k
         if (iconn(1+l,i).eq.j) coni = .false.
      end do

      do l=1,m
         if (iconn(1+l,j).eq.i) conj = .false.
      end do

      if (.not.coni.and..not.conj) return

      dmaxsq = vdwr(ianz(i)) + vdwr(ianz(j))
      dmaxsq = dmaxsq * dmaxsq

      ia = ianz(i)
      ib = ianz(j)
      
      do l=1,3
         ctemp(l) = coo(l,i) - coo(l,j)
      end do

      dijsq = ctemp(1)*ctemp(1) + ctemp(2)*ctemp(2) 
     &             + ctemp(3)*ctemp(3)

      if (idoconv.eq.1) dmaxsq = dmaxsq / toang2

      if (dijsq.lt.dmaxsq) then
          idocon = 1
          k = k + 1
          m = m + 1
          if (k.le.mxcon.and.coni) then
             iconn(1,i) = k
             iconn(k+1,i) = j
          else
             write(iun3,*)'more than mxconn connections found'
          endif
          if (m.le.mxcon.and.conj) then
             iconn(1,j) = m
             iconn(m+1,j) = i
          else
             write(iun3,*)'more than mxconn connections found'
          endif
      endif

      return
      end

      subroutine pdbsdd(istat,doscnd,
     &                  coo,ianz,iaton,iresid,iconn,ityp,
     &                  ncalf,ianf,islu,nchain,iamino,ihet,
     &                  isal,irsnr,achain,ihashb,ishoh)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      integer doscnd
      character*3 pdbsym,hsym,ambtnk
      character*2 gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),
     &                ambtnk(mxamb),gffstr(mxgff)
      common /athlp/ iatoms, mxnat
      common /surf / natorg,nosncd

      parameter (numcal=50000)
      parameter (mxres=42)
      parameter (mxheta=150)

      parameter (mxmmul=100)
      character*1 achain
      logical isatm,ishet,hasalt,skip,dall,goods
      character*3 aminos
      common /amino/ aminos(mxres)
      common /multim/imulm, nmulm,ihasqm(mxmmul)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      character*4 pdbc
      common /pdbcod/ pdbc

      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137
      character*2 tocapf,hetred
      character*4 tstr,tmpstr
      character*3 resi,resit
      character*1 restmp,resa,altloc,aloc,ach,tch,tach
      dimension ipdb(mxsym),hetred(4),
     &          ihpdb(mxhsym*3),tmp(3),isc(numcal)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*),
     &          ityp(*)
      dimension ianf(*),islu(*),iamino(*),ihet(*),isal(*),irsnr(*),
     &          achain(*)

      data hetred/
     &   'AC','AN','AO','AP'/

      imulm = 1
      call parsfn('Helix',5,1)
      call parsfn('Beta',4,1)
      call parsfn('RNA/DNA',7,1)
      call parsfn('Coil',4,1)
      hetz(1) = 'Hel'
      hetz(2) = 'Bet'
      hetz(3) = 'DNA'
      hetz(4) = 'Coi'

      ihashb = 0

      do i=1,numcal
         isal(i) = 3
         isc(i) = 0
      end do

      noff = 0

      if (doscnd.eq.0) goto 5

      call rewfil
      call search(lstr,'HEADER',istat)
      if (istat.eq.1) then
         pdbc = lstr(63:66)
         call tolow(pdbc,4)
         call parstr(pdbc,11)
      else
         call rewfil
      endif
c
c     Proces Helix/Sheet information
c
      call rewfil

      icnt = 0
      do while (.true.)
          call searchd(lstr,'HELIX','SHEET',istat)
          if (istat.eq.0) goto 5

          if (index(lstr,'HELIX').eq.1) then

             read(lstr,'(19x,1a,1x,i4,8x,i4)',err=4,end=4) tch,i1,i2
             ihashb = 1
             if (noff+i1.gt.numcal) i1 = numcal
             if (noff+i2.gt.numcal) i2 = numcal
             i3 = i2 - i1 + 1
             if (i1.ne.0.and.i3.gt.1) then
                it = ichar(tch)
                if (it.ge.65) it = it - 65
                if (it.eq.32) it = 30
                do i=i1,i2
                   icnt = icnt + 1
                   isc(icnt) = it+0*32+i*128
                end do
             endif

          elseif (index(lstr,'SHEET').eq.1) then

             read(lstr,'(21x,1a,i4,7x,i4)',err=4,end=4) tch,i1,i2
             ihashb = 1
             if (noff+i1.gt.numcal) i1 = numcal
             if (noff+i2.gt.numcal) i2 = numcal
             i3 = i2 - i1 + 1
             if (i1.ne.0.and.i3.gt.1) then
                it = ichar(tch)
                if (it.ge.65) it = it - 65
                if (it.eq.32) it = 30
                do i=i1,i2
                   icnt = icnt + 1
                   isc(icnt) = it+1*32+i*128
                end do
             endif
          endif
      end do

4     print*, 'Error reading HELIX/SHEET record !'
5     continue

      call rewfil
      istat = 1
      hasalt = .false.
      dall = .false.
      
10    call searchd(lstr,'HETATM','ATOM',istat)
      if (istat.eq.0) then
           print*,'no ATOM/HETATM record found !'
           call rewfil
           goto 210
      endif

      if (lstr(1:4).ne.'ATOM'.and.lstr(1:6).ne.'HETATM') goto 10
      call bckfil

      nhmol = 3
      iatoms = 0
      icres = 0
      nchain = 1
      ianf(1) = 1
      islu(1) = 0
      nmulm = 0

      jres = -1
      irtmp = -10000
      ipdb(38) = 0
      restmp = ' '
      tach = ' '
      ihashy = 0
      skip = .false.
      aloc = ' '

      do while (.true.)

15        call nxtlin(lstr,jstat)
          if (jstat.eq.1) goto 20

          isatm = (lstr(1:4).eq.'ATOM'.or.lstr(1:6).eq.'HETATM')
          if (lstr(1:6).eq.'ENDMDL') goto 20
          if (.not.isatm) goto 15
c
c found atom
c
          read(lstr,'(12x,a4,a1,a3,1x,a1,i4,a1,3x,3f8.3)') tstr,altloc,
     &       resi,ach,iresnr,resa,(tmp(l),l=1,3)
           
          call tocap(tstr,4)
          call tocap(resi,3)

          jrest = 0
          if (resi(2:3).eq.'  ') resi = '  '//resi(1:1)

          if (resi(2:2).eq.'D'.and.resi(1:1).eq.' ') then
             if (resi(3:3).eq.'A'.or.resi(3:3).eq.'C'.or.
     &           resi(3:3).eq.'G'.or.resi(3:3).eq.'T') then
                 resi(2:2) = ' '
             endif
          endif

          do j=1,mxres
             if (resi.eq.aminos(j)) jrest = j
          end do

          if (resi.eq.'HIP'.or.resi.eq.'HID'.or.
     &            resi.eq.'HIE') then
             jrest = 17
             resi = 'HIS'
          endif

          if (jrest.eq.0) goto 15

          do i=1,4
             if (ichar(tstr(i:i)).eq.39) tstr(i:i) = '*'
          end do

          if (tstr(3:4).eq.'**'.and.tstr(2:2).ne.'O') then
             tstr(2:4) = tstr(1:3)
             tstr(1:1) = ' '
          endif

          if (tstr(2:4).eq.'OT ') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'OCT') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'OP2') tstr(2:4) = 'O2P'
          if (tstr(2:4).eq.'OP1') tstr(2:4) = 'O1P'

          if (iresnr.ne.irtmp.or.restmp.ne.resa) then
c
c next amino acid
c
             if (iatoms.gt.mxnat-30) goto 20

             if (skip) then
                skip = .false.
                if (iresnr.eq.irtmp.and.restmp.ne.resa) skip = .true.
             else
                if (icres.gt.0.and.jres.gt.0) then
                   call mkcon(ipdb,jres,icres,ihpdb,ihashy,0)
                   call pdbtyp(ipdb,ihpdb,jres,1)
                endif

                if (jres.ne.0) icres  = icres + 1
                if (restmp.ne.resa) skip = .true. 
             endif

             if (icres.gt.0.and.icres.le.numcal) then
                iamino(icres) = jrest
                irsnr(icres) = iresnr
                achain(icres) = ach

                if (ihashb.eq.1.and.iresnr.gt.0.and.iresnr.le.numcal) 
     &          then

                  isal(icres) = 3
                  do ii=1,icnt
                    iiscm = isc(ii) / 128
                    iscd  = (isc(ii) - iiscm*128) / 32
                    it = isc(ii) - 128*iiscm - 32*iscd

                    if (it.eq.30) then
                        it = 32
                    else
                        it = it + 65
                    endif

                    if (it.eq.ichar(ach).and.iiscm.eq.iresnr) then
                       isal(icres) = iscd
                    endif

                  end do
                endif
             endif

             irtmp = iresnr
             restmp = resa
             jres = jrest

             do j=1,mxsym
                ipdb(j) = 0
             end do

             do j=1,mxhsym*3
                ihpdb(j) = 0
             end do

             ihashy = 0
             if (skip) goto 15
          else
             if (skip) goto 15
          endif

          if (iatoms.ge.mxnat-1000) then
             dall = .true.
             goto 100
          endif

          iatoms = iatoms + 1
          ianz(iatoms) = 0
          iconn(1,iatoms) = 0
          iresid(iatoms) = icres

          do l=1,3
             coo(l,iatoms) = tmp(l)
          end do

c determine ianz, see if hydrogen atom

          call detanz(resi,tstr,lstr,ifnd,ish,ianz(iatoms),ihashy)

          ihstyp = 0

          if (ish.eq.1) then

            do j=1,mxhsym
               if (tstr(2:4).eq.hsym(j)) then
                  ihstyp = 1
                  if (ihpdb((j-1)*3+1).eq.0) then
                     aloc = altloc
                  elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                  endif

                  do l=1,3
                     if (ihpdb((j-1)*3+l).eq.0) then
                        ihpdb((j-1)*3+l) = iatoms
                        goto 1000
                     endif
                  end do

1000              continue
               endif
            end do

            if (tstr(2:4).eq.'HG3') then
                ihstyp = 1

                if (ihpdb(16).ne.0.and.ihpdb(13).eq.0) then
                     ihpdb(10) = ihpdb(16)
                     ihpdb(11) = iatoms
                     ihpdb(16) = 0
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif

            if (tstr(2:4).eq.'HD3') then
                ihstyp = 1
                if (ihpdb(25).ne.0.and.ihpdb(22).eq.0) then
                     ihpdb(19) = ihpdb(25)
                     ihpdb(20) = iatoms
                     ihpdb(25) = 0
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif

            if (tstr(2:4).eq.'HE3') then
                ihstyp = 1
                if (ihpdb(34).ne.0.and.ihpdb(31).eq.0) then
                     ihpdb(28) = ihpdb(34)
                     ihpdb(29) = iatoms
                     ihpdb(34) = 0
                     ihpdb(37) = 0
                elseif (ihpdb(34).ne.0.and.ihpdb(31).ne.0) then
                     ihpdb(28) = ihpdb(31)
                     ihpdb(29) = ihpdb(34)
                     ihpdb(30) = iatoms
                     ihpdb(31) = 0
                     ihpdb(34) = 0
                     ihpdb(37) = 0
                elseif (ihpdb(37).ne.0.and.ihpdb(31).eq.0) then
                     ihpdb(31) = ihpdb(37)
                     ihpdb(37) = iatoms
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif

            if (tstr(2:4).eq.'HZ3') then
                if (ihpdb(43).ne.0.and.ihpdb(46).ne.0.and.
     &              ihpdb(49).ne.0) then
                     ihpdb(40) = ihpdb(43)
                     ihpdb(41) = ihpdb(46)
                     ihpdb(42) = ihpdb(49)
                     ihpdb(43) = 0
                     ihpdb(46) = 0
                     ihpdb(49) = 0
                elseif (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif

            if (tstr(2:3).eq.'HC') then
                ihstyp = 1
                if (altloc.ne.aloc) then
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                endif
            endif

          else

            do j=1,mxsym
               if (tstr(2:4).eq.pdbsym(j)) then
                  ihstyp = 1
c
c Allow only the first of alternate locations
c
                  if (ipdb(j).eq.0) then
                     ipdb(j) = iatoms
                  else
                     hasalt = .true.
                     iatoms = iatoms - 1
                     goto 15
                  endif
               endif
            end do

          endif

          if (ihstyp.eq.0) then
              nhmol = nhmol + 1
              iresid(iatoms) = -nhmol
              irtmp = -10000
              resi = 'UNK'
              call parsfn(resi,3,1)
              hetz(nhmol+1) = 'UNK'
          endif
          iaton(iatoms)  = 1
      end do


20    continue

c round up last amino acid

      
      if (jres.gt.0) then
         call mkcon(ipdb,jres,icres,ihpdb,ihashy,0)
         call pdbtyp(ipdb,ihpdb,jres,1)
      endif

      islu(nchain) = icres
      ncalf = icres
      namatm = iatoms
c
c do hetatm
c
      ishoh = 0
      irtmp = -10000
      resit = '   '
      tach = ' '

      call rewfil

210   call searchd(lstr,'HETATM','ATOM',istat)

      if (istat.eq.0) goto 220
      if (lstr(1:6).ne.'HETATM'.and.lstr(1:4).ne.'ATOM') goto 210
      call bckfil

      do while (.true.)
215        call nxtlin(lstr,jstat)
           if (jstat.eq.1) goto 220

           ishet = (lstr(1:6).eq.'HETATM')
           isatm = (lstr(1:4).eq.'ATOM')
           if (lstr(1:3).eq.'TER') irtmp = -10000
           if (lstr(1:6).eq.'ENDMDL') goto 220
           resi = lstr(18:20)
           if (ishet.or.isatm) then
              jrest = 0
              ishet = .false.
              if (resi(2:3).eq.'  ') resi = '  '//resi(1:1)
              if (resi(2:2).eq.'D'.and.resi(1:1).eq.' ') then
                 if (resi(3:3).eq.'A'.or.resi(3:3).eq.'C'.or.
     &               resi(3:3).eq.'G'.or.resi(3:3).eq.'T') then
                     resi(2:2) = ' '
                 endif
              endif
              do j=1,mxres
                 if (resi.eq.aminos(j)) jrest = j
              end do
              if (resi.eq.'HIP'.or.resi.eq.'HID'.or.
     &            resi.eq.'HIE') then
                 jrest = 17
                 resi = 'HIS'
              endif
              if (jrest.eq.0) ishet = .true.
           endif
           if (.not.ishet) goto 215

           if (iatoms.ge.mxnat-1000) then
               dall = .true.
               goto 100
           endif

           iatoms = iatoms + 1
           ianz(iatoms) = 0
           read(lstr,'(12x,a4,a1,a3,1x,a1,i4,4x,3f8.3)') tstr,altloc,
     &        resi,ach,iresnr, coo(1,iatoms),coo(2,iatoms),coo(3,iatoms)
           
           call tocap(tstr,4)

           if (altloc.ne.' '.and.altloc.ne.'A'.and.altloc.ne.'a'.and.
     &         altloc.ne.'1') then
              iatoms = iatoms - 1
              hasalt = .true.
              goto 215
           endif

           if (resi.ne.'HOH') then
              tmpstr = tstr(1:4)
              isl = len(tmpstr)
              call prslab(tmpstr,isl,iatoms)
           endif

           ic1 = 0
           ic2 = 0
           ls = len(lstr)
           goods = .false.
           if (ls.ge.78) then
              ic0 = ichar(lstr(76:76))
              ic1 = ichar(lstr(77:77))
              ic2 = ichar(lstr(78:78))
              goods = ( ((ic1.ge.65.and.ic1.le.90).or.ic1.eq.32) .and.
     &                  ((ic2.ge.65.and.ic2.le.90).or.ic2.eq.32) .and.
     &                  ic0.eq.32)
              if (goods) then
                  goods = (.not.(ic1.eq.32.and.ic2.eq.32))
              endif
           endif

           if (goods) then

              read(lstr,'(76x,a2)') tstr(1:2)

              do j=1,99
                if (tstr(1:2).eq.tocapf(elemnt(j))) ianz(iatoms) = j
              end do
            
           else

              if (resi.eq.'HEM') then
                 if (tstr(1:2).eq.'HA'.or.tstr(1:2).eq.'HB'.or.
     &               tstr(1:2).eq.'HM') tstr(1:4) = ' H  '
                 if (tstr(2:3).eq.'FE') tstr(1:3) = 'FE '
              endif

              if (resi.eq.'NDP') then
                 if (tstr(1:2).eq.'NP') tstr(1:4) = ' P  '
              endif

              do j=1,4
                 if (tocapf(tstr(1:2)).eq.hetred(j)) then
                     tstr(1:1) = ' '
                 endif
              end do

              it = ichar(tstr(1:1))
              if (.not.(it.ge.65.and.it.le.90).and..not.
     &           (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
              it2 = ichar(tstr(2:2))
              if (.not.(it2.ge.65.and.it2.le.90).and..not.
     &           (it2.ge.97.and.it2.le.122)) tstr(2:2) = ' '
              if (tstr(2:2).eq.' '.and.tstr(1:1).ne.' ') then
                 tstr(2:2) = tstr(1:1)
                 tstr(1:1) = ' '
              endif 

              do j=1,99
                if (tstr(1:2).eq.tocapf(elemnt(j))) ianz(iatoms) = j
              end do

              if (ianz(iatoms).eq.0.and.tstr(1:1).ne.' ') then
                 tstr(1:1) = ' '
                 do j=1,99
                     if (tstr(1:2).eq.tocapf(elemnt(j))) 
     &                  ianz(iatoms) = j
                 end do
              endif

           endif

           if (ianz(iatoms).le.0) then
              write(iun3,*) 'Unclassified atom =',tstr
              write(iun3,*) lstr
              ianz(iatoms) = 99
           endif

           iconn(1,iatoms) = 0
           iaton(iatoms)  = 0

           if (iresnr.ne.irtmp.or.resi(1:3).ne.resit(1:3).or.
     &         ach.ne.tach) then
              irtmp = iresnr
              resit = resi
              tach = ach

              if (resi(1:3).eq.'HOH'.or.resi(1:3).eq.'hoh') then
                  if (ishoh.eq.0) then
                     nhmol = nhmol + 1
                     if (nmulm.lt.mxmmul) nmulm = nmulm + 1
                     call parsfn(resi,3,1)
                     hetz(nhmol+1) = resi(1:3)
                     ishoh = nhmol
                  endif  
              else
                  nhmol = nhmol + 1
                  if (nmulm.lt.mxmmul) nmulm = nmulm + 1
                  call parsfn(resi,3,1)
                  hetz(nhmol+1) = resi(1:3)
              endif

           endif

           if (resi(1:3).eq.'HOH'.or.resi(1:3).eq.'hoh') then
              iresid(iatoms) = -ishoh
           else
              iresid(iatoms) = -nhmol
           endif
      end do

220   continue

c
c do connectivity between all except amino-amino
c
      nhet = iatoms - namatm
      do ii=1,nhet
         i = namatm + ii
         do j=1,namatm + ii - 1
            call connij(idum,i,j,0)
         end do
      end do

c
c make s-s connections
c
      do i=1,ncalf
         if (iamino(i).eq.4) then
            do j=1,i-1
               if (iamino(j).eq.4) then
                  ii = 0
                  jj = 0
                  do k=1,iatoms
                     if (ianz(k).eq.16) then
                        if (iresid(k).eq.i) ii = k
                        if (iresid(k).eq.j) jj = k
                     endif
                  end do
                  if (ii.ne.0.and.jj.ne.0) then
                     call connij(idum,ii,jj,0)
                     if (idum.eq.1) then
                        ityp(ii) = 82
                        ityp(jj) = 82
                        do l=1,iconn(1,ii)
                           ll = iabs(iconn(l+1,ii))
                           if (ianz(ll).eq.6) ityp(ll) = 38
                        end do
                        do l=1,iconn(1,jj)
                           ll = iabs(iconn(l+1,jj))
                           if (ianz(ll).eq.6) ityp(ll) = 38
                        end do
                     endif
                  endif
               endif
            end do
         endif
      end do

      do i=1,ncalf
         if (iamino(i).eq.21) iamino(i) = 10
         if (iamino(i).eq.22) iamino(i) = 14
      end do

      if (islu(1).lt.ianf(1)) nchain = 0

      if (ioadd.eq.1) then
         if (nmulmt.eq.0) nmulmt = 1
         do i=nmulmt,nmulm
            ihasqm(i) = 0
         end do
         do i=nmulmt+4,nhmol+1
            ihet(i) = 1
         end do
      endif

      ihashz = 1

      if (hasalt) print*,'Alternate location(s) detected'
      return

100   istat = 0
      if (dall) then
         iatoms = natorg
         ncalf = noff
         istat = -1
      else
         if (islu(1).lt.ianf(1)) nchain = 0
      endif
      if (hasalt) print*,'Alternate location(s) detected'
      return
      end



      subroutine flagd(ihpdb,iat,isurf)
      implicit double precision (a-h,o-z)
      dimension ihpdb(*),isurf(*)

      if (ihpdb(iat).ne.0) isurf(ihpdb(iat)) = 1

      return
      end

      subroutine conad(ipdb,iat1,iat2,iop,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension ipdb(*),iconn(mxcon+1,*)

      ia1 = ipdb(iat1)
      ia2 = ipdb(iat2)

      if (ia1.ne.0.and.ia2.ne.0) then
         if (iconn(1,ia1).lt.mxcon) then
            iconn(1,ia1) = iconn(1,ia1) + 1
            iconn(iconn(1,ia1)+1,ia1) = ia2
         endif
         if (iop.eq.0) then
            iconn(1,ia2) = 1
            iconn(2,ia2) = ia1
         else
            if (iconn(1,ia2).lt.mxcon) then
               iconn(1,ia2) = iconn(1,ia2) + 1
               iconn(iconn(1,ia2)+1,ia2) = ia1
            endif
         endif
      endif

      return
      end

      subroutine conatd(ipdb,ihpdb,iat1,iat2,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension ipdb(*), ihpdb(*), iconn(mxcon+1,*)

      ia1 = ipdb(iat1)
      ia2 = ihpdb(iat2)

      if (ia1.ne.0.and.ia2.ne.0) then
         if (iconn(1,ia1).lt.mxcon) then
            iconn(1,ia1) = iconn(1,ia1) + 1
            iconn(iconn(1,ia1)+1,ia1) = ia2
         endif
         iconn(1,ia2) = 1
         iconn(2,ia2) = ia1
      endif

      return
      end

      subroutine mkcon(ipdb,jres,icres,ihpdb,ihashy,idoconv)
      implicit double precision (a-h,o-z)
      dimension ipdb(*), ihpdb(*)

      if (jres.gt.23) then
         call mknbck(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      else
         call mkback(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      endif
          

      goto (10,10,30,40,50,60,70,80,90,100,110,120,130,140,150,
     &      160,170,180,190,200,100,140,150,210,220,230,240,250,
     &      210,220,220,230,230,230,230,230,230,230,250,250,250,
     &      250) jres
      return
c
c glycine, alanine
c
10    goto 1000
c
c serine
c
30    call conat(ipdb,5,31,0)
      if (ihashy.eq.1) call conath(ipdb,ihpdb,31,10)
      goto 1000
c
c cysteine
c
40    call conat(ipdb,5,37,0)
c this H is dubious
      if (ihashy.eq.1) call conath(ipdb,ihpdb,37,10)
      goto 1000
c
c threonine
c
50    call conat(ipdb,5,32,0)
      call conat(ipdb,5,8,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,32,10)
          call conath(ipdb,ihpdb,32,13)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
      endif
      goto 1000
c
c isoleucine
c
60    call conat(ipdb,5,7,0)
      call conat(ipdb,5,8,0)
      call conat(ipdb,7,10,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,7,13)
          call conath(ipdb,ihpdb,7,14)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
          call conath(ipdb,ihpdb,10,22)
          call conath(ipdb,ihpdb,10,23)
          call conath(ipdb,ihpdb,10,24)
      endif
      goto 1000
c
c valine
c
70    call conat(ipdb,5,7,0)
      call conat(ipdb,5,8,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,7,13)
          call conath(ipdb,ihpdb,7,14)
          call conath(ipdb,ihpdb,7,15)
          call conath(ipdb,ihpdb,8,16)
          call conath(ipdb,ihpdb,8,17)
          call conath(ipdb,ihpdb,8,18)
      endif
      goto 1000
c
c methionine
c
80    call conat(ipdb,5,6,0)
      call conat(ipdb,6,36,0)
      call conat(ipdb,36,12,0)
      if (ihashy.eq.1) then
          call conath(ipdb,ihpdb,6,10)
          call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
          call conath(ipdb,ihpdb,6,13)
          call conath(ipdb,ihpdb,6,16)
          call conath(ipdb,ihpdb,12,28)
          call conath(ipdb,ihpdb,12,29)
          call conath(ipdb,ihpdb,12,30)
          call conath(ipdb,ihpdb,12,31)
          call conath(ipdb,ihpdb,12,34)
          call conath(ipdb,ihpdb,12,37)
      endif
      goto 1000
c
c aspartic acid
c
90    call conat(ipdb,5,6,0)
      call conat(ipdb,6,29,0)
      call conat(ipdb,6,30,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,29,22)
         call conath(ipdb,ihpdb,30,25)
      endif
      goto 1000
c
c asparagine
c
100   call conat(ipdb,5,6,0)
      call conat(ipdb,6,29,0)
      call conat(ipdb,6,21,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,21,25)
         call conath(ipdb,ihpdb,21,26)
      endif
      goto 1000
c
c leucine
c
110   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,10,23)
         call conath(ipdb,ihpdb,10,24)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,11,26)
         call conath(ipdb,ihpdb,11,27)
      endif
      goto 1000
c
c lysine
c
120   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,12,0)
      call conat(ipdb,12,27,0)
      if (ihashy.eq.1) then

         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)

         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
c        try HD1 and HD2 too
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)

         call conath(ipdb,ihpdb,12,28)
         call conath(ipdb,ihpdb,12,29)
c        try HE1 and HE2 , HE3 too
         call conath(ipdb,ihpdb,12,31)
         call conath(ipdb,ihpdb,12,34)
         call conath(ipdb,ihpdb,12,37)

         call conath(ipdb,ihpdb,27,40)
         call conath(ipdb,ihpdb,27,41)
         call conath(ipdb,ihpdb,27,42)
         call conath(ipdb,ihpdb,27,43)
         call conath(ipdb,ihpdb,27,46)
         call conath(ipdb,ihpdb,27,49)
      endif
      goto 1000
c
c glutamic acid
c
130   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,34,0)
      call conat(ipdb,9,35,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,34,31)
         call conath(ipdb,ihpdb,35,34)
      endif
      goto 1000
c
c glutamine
c
140   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,34,0)
      call conat(ipdb,9,24,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,24,34)
         call conath(ipdb,ihpdb,24,35)
      endif
      goto 1000
c
c proline
c 
150   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
c     bit tricky here
      call conat(ipdb,9,1,1)
      if (ipdb(28).ne.0) call conat(ipdb,6,28,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
c        try HG1 and HG2 too
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
c        try HD1 and HD2 too
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)
      endif
      goto 1000
c
c arginine
c
160   call conat(ipdb,5,6,0)
      call conat(ipdb,6,9,0)
      call conat(ipdb,9,22,0)
      call conat(ipdb,22,17,0)
      call conat(ipdb,17,25,0)
      call conat(ipdb,17,26,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,6,10)
         call conath(ipdb,ihpdb,6,11)
         call conath(ipdb,ihpdb,6,13)
         call conath(ipdb,ihpdb,6,16)
         call conath(ipdb,ihpdb,9,19)
         call conath(ipdb,ihpdb,9,20)
         call conath(ipdb,ihpdb,9,22)
         call conath(ipdb,ihpdb,9,25)
         call conath(ipdb,ihpdb,22,28)
         call conath(ipdb,ihpdb,25,55)
         call conath(ipdb,ihpdb,25,56)
         call conath(ipdb,ihpdb,26,58)
         call conath(ipdb,ihpdb,26,59)
      endif
      goto 1000
c
c histidine
c
170   call conat(ipdb,5,6,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,6,20,0)
      call conat(ipdb,11,24,0)
      call conat(ipdb,20,13,0)
c tricky
      call conat(ipdb,13,24,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,20,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,24,34)
      endif
      goto 1000
c
c phenylalanine
c
180   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,13,0)
      call conat(ipdb,11,14,0)
      call conat(ipdb,13,17,0)
      call conat(ipdb,14,17,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,14,34)
         call conath(ipdb,ihpdb,17,40)
      endif
      goto 1000
c
c tyrosine
c
190   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,13,0)
      call conat(ipdb,11,14,0)
      call conat(ipdb,13,17,0)
      call conat(ipdb,14,17,1)
      call conat(ipdb,17,33,0)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,11,25)
         call conath(ipdb,ihpdb,13,31)
         call conath(ipdb,ihpdb,14,34)
         call conath(ipdb,ihpdb,33,52)
      endif
      goto 1000
c
c tryptophan
c
200   call conat(ipdb,5,6,0)
      call conat(ipdb,6,10,0)
      call conat(ipdb,6,11,0)
      call conat(ipdb,10,23,0)
      call conat(ipdb,23,14,0)
      call conat(ipdb,14,11,1)
      call conat(ipdb,11,15,0)
      call conat(ipdb,14,18,0)
      call conat(ipdb,15,19,0)
      call conat(ipdb,18,16,0)
      call conat(ipdb,16,19,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,10,22)
         call conath(ipdb,ihpdb,23,31)
         call conath(ipdb,ihpdb,15,37)
         call conath(ipdb,ihpdb,18,46)
         call conath(ipdb,ihpdb,19,49)
         call conath(ipdb,ihpdb,16,58)
      endif
      goto 1000
c
c adenosine
c
210   call conat(ipdb,54,66,0)
      call conat(ipdb,66,59,0)
      call conat(ipdb,66,56,0)
      call conat(ipdb,59,65,0)
      call conat(ipdb,65,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,57,56,0)
      call conat(ipdb,58,64,0)
      call conat(ipdb,58,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,56,62,1)
      call conat(ipdb,56,66,1)
      if (jres.eq.29) then
          call conat(ipdb,60,71,0)
          call conat(ipdb,60,79,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,55,82)
         call conath(ipdb,ihpdb,59,112)
         call conath(ipdb,ihpdb,64,106)
         call flagh(ihpdb,106)
         call conath(ipdb,ihpdb,64,109)
         call flagh(ihpdb,109)
         call conath(ipdb,ihpdb,64,136)
         call flagh(ihpdb,136)
         call conath(ipdb,ihpdb,64,137)
         call flagh(ihpdb,137)
         call conath(ipdb,ihpdb,64,103)
         call flagh(ihpdb,103)
         call conath(ipdb,ihpdb,64,104)
         call flagh(ihpdb,104)
         if (jres.eq.29) then
             call conath(ipdb,ihpdb,79,148)
             call conath(ipdb,ihpdb,79,149)
             call conath(ipdb,ihpdb,79,150)
             call conath(ipdb,ihpdb,58,103)
         endif
      endif
      goto 1000
c
c cytidine
c
220   call conat(ipdb,54,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,63,0)
      call conat(ipdb,56,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      if (jres.eq.30) then
         call conat(ipdb,57,72,0)
         call conat(ipdb,57,83,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,63,94)
         call flagh(ihpdb,94)
         call conath(ipdb,ihpdb,63,97)
         call flagh(ihpdb,97)
         call conath(ipdb,ihpdb,63,130)
         call flagh(ihpdb,130)
         call conath(ipdb,ihpdb,63,131)
         call flagh(ihpdb,131)
         call conath(ipdb,ihpdb,58,103)
         if (jres.eq.30) then
             call conath(ipdb,ihpdb,83,160)
             call conath(ipdb,ihpdb,83,161)
             call conath(ipdb,ihpdb,83,162)
         else
             call conath(ipdb,ihpdb,57,100)
         endif
      endif
      goto 1000
c
c guanosine
c
230   call conat(ipdb,54,66,0)
      call conat(ipdb,66,59,0)
      call conat(ipdb,66,56,0)
      call conat(ipdb,59,65,0)
      call conat(ipdb,65,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,57,56,0)
      call conat(ipdb,58,69,0)
      call conat(ipdb,58,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,62,0)
      if (jres.ne.38) call conat(ipdb,55,61,0)
      call conat(ipdb,56,62,1)
      call conat(ipdb,56,66,1)
      if (jres.eq.32) then
          call conat(ipdb,60,71,0)
          call conat(ipdb,60,79,0)
      endif
      if (jres.eq.33.or.jres.eq.34) then
          call conat(ipdb,61,73,0)
          call conat(ipdb,61,80,0)
      endif
      if (jres.eq.34) then
          call conat(ipdb,61,74,0)
          call conat(ipdb,61,79,0)
      endif
      if (jres.eq.35) then
          call conat(ipdb,65,75,0)
          call conat(ipdb,65,85,0)
      endif
      if (jres.eq.37) then
          call conat(ipdb,61,90,0)
          call conat(ipdb,62,88,0)
          call conat(ipdb,90,89,0)
          call conat(ipdb,90,91,0)
          call conat(ipdb,91,60,1)
          call conat(ipdb,91,92,0)
          call conat(ipdb,92,93,0)
          call conat(ipdb,93,94,0)
          call conat(ipdb,94,95,0)
          call conat(ipdb,95,96,0)
          call conat(ipdb,95,97,0)
          call conat(ipdb,97,98,0)
          call conat(ipdb,94,99,0)
          call conat(ipdb,99,100,0)
          call conat(ipdb,100,101,0)
          call conat(ipdb,100,102,0)
          call conat(ipdb,102,103,0)
      endif

      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,59,112)
         if (jres.ne.32.and.jres.ne.37) then
            call conath(ipdb,ihpdb,60,79)
            call flagh(ihpdb,79)
            call conath(ipdb,ihpdb,60,121)
            call flagh(ihpdb,121)
         endif
         if (jres.ne.33.and.jres.ne.34.and.jres.ne.37
     &       .and.jres.ne.38) then
            call conath(ipdb,ihpdb,61,85)
            call flagh(ihpdb,85)
            call conath(ipdb,ihpdb,61,125)
            call flagh(ihpdb,125)
            call conath(ipdb,ihpdb,61,82)
            call flagh(ihpdb,82)
            call conath(ipdb,ihpdb,61,83)
            call flagh(ihpdb,83)
         endif
         if (jres.ne.34.and.jres.ne.37.and.jres.ne.38) then
            call conath(ipdb,ihpdb,61,88)
            call flagh(ihpdb,88)
            call conath(ipdb,ihpdb,61,124)
            call flagh(ihpdb,124)
         endif
         if (jres.eq.33.or.jres.eq.34) then
            call conath(ipdb,ihpdb,80,151)
            call conath(ipdb,ihpdb,80,152)
            call conath(ipdb,ihpdb,80,153)
         endif
         if (jres.eq.31.or.jres.eq.34) then
            call conath(ipdb,ihpdb,79,148)
            call conath(ipdb,ihpdb,79,149)
            call conath(ipdb,ihpdb,79,150)
         endif
         if (jres.eq.35) then
            call conath(ipdb,ihpdb,85,166)
            call conath(ipdb,ihpdb,85,167)
            call conath(ipdb,ihpdb,85,168)
            call conath(ipdb,ihpdb,59,113)
         endif
         if (jres.eq.37) then
            call conath(ipdb,ihpdb,88,91)
            call conath(ipdb,ihpdb,88,92)
            call conath(ipdb,ihpdb,88,93)
            call conath(ipdb,ihpdb,89,175)
            call conath(ipdb,ihpdb,89,176)
            call conath(ipdb,ihpdb,89,177)
            call conath(ipdb,ihpdb,92,178)
            call conath(ipdb,ihpdb,92,179)
            call conath(ipdb,ihpdb,93,181)
            call conath(ipdb,ihpdb,93,182)
            call conath(ipdb,ihpdb,94,184)
            call conath(ipdb,ihpdb,98,187)
            call conath(ipdb,ihpdb,98,188)
            call conath(ipdb,ihpdb,98,189)
            call conath(ipdb,ihpdb,99,124)
            call conath(ipdb,ihpdb,103,190)
            call conath(ipdb,ihpdb,103,191)
            call conath(ipdb,ihpdb,103,192)
         endif
      endif
      goto 1000
c
c thymidine
c
240   call conat(ipdb,54,60,0)
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,68,0)
      call conat(ipdb,56,57,0)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      call conat(ipdb,57,70,1)
      call conat(ipdb,57,83,1)
      call conat(ipdb,57,75,1)
      call conat(ipdb,57,85,1)
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,58,103)
         call conath(ipdb,ihpdb,62,91)
         call flagh(ihpdb,91)
         call conath(ipdb,ihpdb,62,127)
         call flagh(ihpdb,127)
         call conath(ipdb,ihpdb,83,160)
         call conath(ipdb,ihpdb,83,161)
         call conath(ipdb,ihpdb,83,162)
         call conath(ipdb,ihpdb,70,160)
         call conath(ipdb,ihpdb,70,161)
         call conath(ipdb,ihpdb,70,162)
         call conath(ipdb,ihpdb,75,166)
         call conath(ipdb,ihpdb,75,167)
         call conath(ipdb,ihpdb,75,168)
         call conath(ipdb,ihpdb,85,166)
         call conath(ipdb,ihpdb,85,167)
         call conath(ipdb,ihpdb,85,168)
      endif
      goto 1000
c
c uridine
c
250   if (jres.eq.42) then
         call conat(ipdb,54,57,0)
      else
         call conat(ipdb,54,60,0)
      endif
      call conat(ipdb,60,55,0)
      call conat(ipdb,55,67,0)
      call conat(ipdb,55,62,0)
      call conat(ipdb,62,56,0)
      call conat(ipdb,56,68,0)
      call conat(ipdb,56,57,1)
      call conat(ipdb,57,58,0)
      call conat(ipdb,60,58,1)
      if (jres.eq.41) then
         call conat(ipdb,57,72,0)
         call conat(ipdb,57,83,0)
      endif
      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,58,103)
         if (jres.ne.41.and.jres.ne.42) call conath(ipdb,ihpdb,57,100)
         if (jres.eq.40) then
            call conath(ipdb,ihpdb,58,104)
            call conath(ipdb,ihpdb,57,101)
         endif
         call conath(ipdb,ihpdb,62,91)
         call flagh(ihpdb,91)
         call conath(ipdb,ihpdb,62,127)
         call flagh(ihpdb,127)
         if (jres.eq.41) then
            call conath(ipdb,ihpdb,83,160)
            call conath(ipdb,ihpdb,83,161)
            call conath(ipdb,ihpdb,83,162)
         endif
         if (jres.eq.42) call conath(ipdb,ihpdb,60,121)
      endif

1000  continue

      return
      end

      subroutine mknbcd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo,
     &                  icalf,ianf,islu,nchain,iamino)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxcon=10)
      logical newch
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

      if (ipdb(43).gt.0) then
         nc = 0
         if (ipdb(44).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(43)) = ipdb(44)
         endif
         if (ipdb(45).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(43)) = ipdb(45)
         endif
         if (ipdb(46).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(43)) = ipdb(46)
         endif
         iconn(1,ipdb(43)) = nc
      endif

      if (ipdb(44).gt.0) iconn(1,ipdb(44)) = 0
      if (ipdb(45).gt.0) iconn(1,ipdb(45)) = 0
      if (ipdb(46).gt.0) iconn(1,ipdb(46)) = 0

      if (ipdb(43).gt.0) then

         if (ipdb(44).gt.0) then
            iconn(2,ipdb(44)) = ipdb(43)
            iconn(1,ipdb(44)) = 1
         endif

         if (ipdb(45).gt.0) then
            iconn(2,ipdb(45)) = ipdb(43)
            iconn(1,ipdb(45)) = 1
         endif

         if (ipdb(46).gt.0) then
            iconn(2,ipdb(46)) = ipdb(43)
            iconn(1,ipdb(46)) = 1
         endif
      endif


      if (ipdb(47).gt.0) then
         if (ipdb(46).gt.0) then
            iconn(1,ipdb(46)) = iconn(1,ipdb(46)) + 1
            iconn(1+iconn(1,ipdb(46)),ipdb(46)) = ipdb(47)
            iconn(2,ipdb(47)) = ipdb(46)
            iconn(1,ipdb(47)) = 1
         endif
         if (ipdb(48).gt.0) then
            if (ipdb(46).gt.0) then
               iconn(1,ipdb(47)) = 2
               iconn(3,ipdb(47)) = ipdb(48)
            else
               iconn(1,ipdb(47)) = 1
               iconn(2,ipdb(47)) = ipdb(48)
            endif
         endif
      endif

      if (ipdb(48).gt.0) then
         nc = 0
         if (ipdb(47).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(48)) = ipdb(47)
         endif
         if (ipdb(49).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(48)) = ipdb(49)
         endif
         if (ipdb(50).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(48)) = ipdb(50)
         endif
         iconn(1,ipdb(48)) = nc
      endif

      if (ipdb(49).gt.0) then
         nc = 0
         if (ipdb(48).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(49)) = ipdb(48)
         endif
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(49)) = ipdb(54)
         endif
         iconn(1,ipdb(49)) = nc
      endif

      if (ipdb(49).gt.0) then
         nc = 0
         if (ipdb(48).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(50)) = ipdb(48)
         endif
         if (ipdb(51).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(50)) = ipdb(51)
         endif
         if (ipdb(52).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(50)) = ipdb(52)
         endif
         iconn(1,ipdb(50)) = nc
      endif

      if (ipdb(50).gt.0.and.ipdb(51).gt.0) then
         iconn(1,ipdb(51)) = 1
         iconn(2,ipdb(51)) = ipdb(50)
      endif

      if (ipdb(52).gt.0) then
         nc = 0
         if (ipdb(50).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(52)) = ipdb(50)
         endif
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(52)) = ipdb(54)
         endif
         iconn(1,ipdb(52)) = nc
      endif

      if (ipdb(53).gt.0.and.ipdb(52).gt.0) then
         nc = iconn(1,ipdb(52))
         nc = nc + 1
         iconn(1+nc,ipdb(52)) = ipdb(53)
         iconn(1,ipdb(52)) = nc
         iconn(1,ipdb(53)) = 1
         iconn(2,ipdb(53)) = ipdb(52)
      endif

      if (ipdb(54).ne.0) then
         nc = 0
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(54)) = ipdb(49)
         endif
         if (ipdb(54).gt.0) then
            nc = nc + 1
            iconn(1+nc,ipdb(54)) = ipdb(52)
         endif
         iconn(1,ipdb(54)) = nc
      endif

c Possible OXT

      if (ipdb(38).ne.0.and.ipdb(43).ne.0) then
         nc = iconn(1,ipdb(43))
         nc = nc + 1
         iconn(1+nc,ipdb(43)) = ipdb(38)
         iconn(1,ipdb(43)) = nc
         iconn(1,ipdb(38)) = 1
         iconn(2,ipdb(38)) = ipdb(43)
      endif

c Possible O3P (OXT is old O3P new)

      if (ipdb(76).ne.0.and.ipdb(43).ne.0) then
         nc = iconn(1,ipdb(43))
         nc = nc + 1
         iconn(1+nc,ipdb(43)) = ipdb(76)
         iconn(1,ipdb(43)) = nc
         iconn(1,ipdb(76)) = 1
         iconn(2,ipdb(76)) = ipdb(43)
      endif

      if (jres.eq.36.or.jres.eq.31) then
          call conat(ipdb,53,73,0)
          call conat(ipdb,53,80,0)
      endif

      if (ihashy.eq.1) then
         call conath(ipdb,ihpdb,47,61)
         call conath(ipdb,ihpdb,47,62)
         call conath(ipdb,ihpdb,48,64)
         call conath(ipdb,ihpdb,50,67)
         call conath(ipdb,ihpdb,52,70)
         call conath(ipdb,ihpdb,52,71)
         call conath(ipdb,ihpdb,54,73)
         if (ipdb(53).ne.0) call conath(ipdb,ihpdb,53,76)
         if ((jres.eq.36.or.jres.eq.31).and.ipdb(80).ne.0) then
             call conath(ipdb,ihpdb,80,151)
             call conath(ipdb,ihpdb,80,152)
             call conath(ipdb,ihpdb,80,153)
         endif
         call conath(ipdb,ihpdb,51,115)
         call conath(ipdb,ihpdb,46,118)
      endif

      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(43)
         icalf(2,icres) = ipdb(46)
         icalf(3,icres) = ipdb(47)
         icalf(4,icres) = ipdb(48)
         icalf(5,icres) = ipdb(50)
         icalf(6,icres) = ipdb(51)
      endif

      if (ipdb(43).eq.0.and.icres.le.numcal) then
         if (ihpdb(118).ne.0) then
             icalf(1,icres) = ihpdb(118)
         elseif (ipdb(46).ne.0) then
             icalf(1,icres) = ipdb(46)
         endif
      endif

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         if (iamino(icres-1).gt.23) then
            ip = ipdb(43)
            io = icalf(6,icres-1)
            if (io.gt.0.and.ip.gt.0) then
               do i=1,3
                  tmp(i) = coo(i,ip) - coo(i,io)
               end do
               distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &                  tmp(3)*tmp(3)
            else
               distsq = 100000.0d0
            endif
            if (distsq.lt.3.1684d0*fct) then
c
c connect P current residue to O previous
c
               iconn(1,ip) = iconn(1,ip) + 1 
               iconn(iconn(1,ip)+1,ip) = io
c
c connect O previous to P current residue 
c
               iconn(1,io) = iconn(1,io) + 1 
               iconn(iconn(1,io)+1,io) = ip
            else
               newch = .true.
            endif
         else
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      return
      end

      subroutine mkbacd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo,
     &                  icalf,ianf,islu,nchain,iamino)

      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxcon=10)
      logical newch
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)


      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

c N-CA
      if (ipdb(1).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(1)) = 1
         iconn(2,ipdb(1)) = ipdb(2)
      endif

c CA-N, CA-C
      if (ipdb(2).ne.0) then
         iconn(1,ipdb(2)) = 0
         if (ipdb(1).ne.0) then
            iconn(2,ipdb(2)) = ipdb(1)
            iconn(1,ipdb(2)) = 1
            if (ipdb(3).ne.0) then
               iconn(3,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 2
            endif
         else
            if (ipdb(3).ne.0) then
               iconn(2,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 1
            endif
         endif
      endif

c C-CA,C-O
      if (ipdb(4).ne.0.and.ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
         if (ipdb(2).ne.0) then
            iconn(2,ipdb(3)) = ipdb(2)
            iconn(3,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 2
         else
            iconn(2,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 1
         endif
c O-C
         iconn(1,ipdb(4)) = 1
         iconn(2,ipdb(4)) = ipdb(3)

      elseif (ipdb(3).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(3)) = 1
         iconn(2,ipdb(3)) = ipdb(2)
      elseif (ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
      elseif (ipdb(4).ne.0) then
         iconn(1,ipdb(4)) = 0
      endif

c Possible OXT
      if (ipdb(38).ne.0.or.ipdb(76).ne.0) then
         if (ipdb(38).ne.0) then
            iox = ipdb(38)
         else
            iox = ipdb(76)
         endif
         iconn(1,ipdb(3)) = iconn(1,ipdb(3)) + 1
         iconn(iconn(1,ipdb(3))+1,ipdb(3)) = iox
         iconn(1,iox) = 1
         iconn(2,iox) = ipdb(3)
      endif

c C beta
      if (jres.gt.1.and.ipdb(5).ne.0) then
         iconn(1,ipdb(2)) = 3
         iconn(4,ipdb(2)) = ipdb(5)
         iconn(1,ipdb(5)) = 1
         iconn(2,ipdb(5)) = ipdb(2)
      endif
 
      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(2)
         icalf(2,icres) = ipdb(1)
         icalf(3,icres) = ipdb(3)
         icalf(4,icres) = 0
      endif

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         ic = icalf(3,icres-1)
         in = ipdb(1)
         if (iamino(icres-1).le.23.and.(ic.gt.0.and.in.gt.0)) then
            do i=1,3
               tmp(i) = coo(i,in) - coo(i,ic)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect N current residue to C previous
c
               iconn(1,in) = iconn(1,in) + 1 
               iconn(iconn(1,in)+1,in) = ic
c
c connect C previous to N current residue 
c
               iconn(1,ic) = iconn(1,ic) + 1 
               iconn(iconn(1,ic)+1,ic) = in
            else
               newch = .true.
            endif
         else 
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      if (ihashy.eq.1) then
          do i=1,3
             call conath(ipdb,ihpdb,1,i)
             call conath(ipdb,ihpdb,2,3+i)
             call conath(ipdb,ihpdb,5,6+i)
          end do
          call conath(ipdb,ihpdb,1,79)
          call conath(ipdb,ihpdb,1,82)
          call conath(ipdb,ihpdb,1,91)
      endif

      return
      end

      subroutine detanz(resi,tstr,lstr,ifnd,ish,ianz,ihashy)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character lstr*137
      character*3 resi, atmp
      character*4 tstr
      character*2 tocapf

          ifnd = 1
          ish = 0
          atmp = tstr(2:4)
c
c Take care of ambiguity; asx->asn ,glx->gln ,his
c
          if (resi.eq.'ASX') then
              if (atmp.eq.'AD1') then
                  atmp = 'OD1'
              elseif (atmp.eq.'AD2') then
                  atmp = 'ND2'
              endif
          elseif (resi.eq.'GLX') then
              if (atmp.eq.'AE1') then
                  atmp = 'OE1'
              elseif (atmp.eq.'AE2') then
                  atmp = 'NE2'
              endif
          elseif (resi.eq.'HIS') then
              if (atmp.eq.'AD1') then
                  atmp = 'ND1'
              elseif (atmp.eq.'AD2') then
                  atmp = 'CD2'
              elseif (atmp.eq.'AE1') then
                  atmp = 'CE1'
              elseif (atmp.eq.'AE2') then
                  atmp = 'NE2'
              endif
          elseif (resi.eq.'ILE') then
              if (atmp.eq.'CD ') then
                  atmp = 'CD1'
              elseif (atmp.eq.'HD1') then
                  atmp = 'HD1'
                  tstr(1:4) = '1HD1'
              elseif (atmp.eq.'HD2') then
                  atmp = 'HD1'
                  tstr(1:4) = '2HD1'
              elseif (atmp.eq.'HD3') then
                  atmp = 'HD1'
                  tstr(1:4) = '3HD1'
              endif
          elseif (resi.eq.'SER'.or.resi.eq.'CYS') then
              if (atmp.eq.'HG1') atmp = 'HG '
          elseif (resi.eq.'  T'.or.resi.eq.' DT') then
              if (atmp(1:2).eq.'H7') atmp = 'HM7'
          endif
          if (atmp.ne.tstr(2:4)) tstr(2:4) = atmp


          if (tstr(1:2).eq.'HH'.or.tstr(1:2).eq.'HD'.or.
     &        tstr(1:2).eq.'HE'.or.tstr(1:2).eq.'HG') then
              atmp = tstr(1:3)
              tstr = ' '//atmp
          endif

c to unscrew whatif specific types

          if (tstr(2:4).eq.'O**') tstr(2:4) = 'OXT'
          if (tstr(2:4).eq.'O* ') tstr(2:4) = 'O  '
          if (tstr(2:4).eq.'H5M') tstr(2:4) = 'HM5'
          if (tstr(2:4).eq.'H3T') tstr(2:4) = 'HO3'
          if (tstr(1:4).eq.'1H4 ') tstr(1:4) = ' H41'
          if (tstr(1:4).eq.'2H4 ') tstr(1:4) = ' H42'

          if (tstr(2:4).eq.'OT1') tstr(2:4) = 'O  '
          if (tstr(2:4).eq.'OT2') tstr(2:4) = 'OXT'

          it = ichar(tstr(2:2))
          it4 = ichar(tstr(4:4))
          if (it.eq.67) then
             ianz = 6
          elseif (it.eq.78) then
             ianz = 7
          elseif (it.eq.79) then
             ianz = 8
          elseif (it.eq.80) then
             ianz = 15
          elseif (it.eq.83) then
             ianz = 16
          elseif (it.eq.72.or.it.eq.68) then
             ianz = 1
             if (it.eq.68) tstr(2:2) = 'H'
             if (tstr(2:4).eq.'HN ') tstr(2:4) = 'H  '
             if ((tstr(2:3).eq.'HA'.or.tstr(2:3).eq.'HB').and.
     &           (tstr(4:4).ne.' ')) tstr(4:4) = ' '
             if (tstr(2:3).eq.'HT'.and.(it4.ge.49.and.it4.le.51))
     &       then
                tstr(3:4) = '  '
                tstr(1:1) = tstr(4:4)
             endif
             ihashy = 1
             ish = 1
c Below convert 1H8 to H81, which not recognized by molden
c it probably served to read in force field H label variant
c             if (tstr(4:4).eq.' ') then
c                it1 = ichar(tstr(1:1))
c                it3 = ichar(tstr(3:3))
c                if ((it1.ge.49.and.it1.le.57).and.
c     &              (it3.ge.49.and.it3.le.57)) tstr(4:4) = tstr(1:1)
c             endif
          else
             ifnd = 0 
          endif
          
          if (ifnd.eq.0) then
            it = ichar(tstr(1:1))
            if (.not.(it.ge.65.and.it.le.90).and..not.
     &             (it.ge.97.and.it.le.122)) tstr(1:1) = ' '
            do j=1,99
             if (tstr(1:2).eq.tocapf(elemnt(j))) ianz = j
            end do
            if (ianz.eq.0.and.tstr(1:1).ne.' ') then
               tstr(1:1) = ' '
               do j=1,99
                  if (tstr(1:2).eq.tocapf(elemnt(j))) 
     &                ianz = j
               end do
            endif
            if (ianz.le.0) then
               if (tstr(2:2).eq.'D'.and.tstr(2:3).ne.'DY') then
                  ianz = 1
               else
                  write(iun3,*) 'Unclassified atom =',tstr
                  write(iun3,*) lstr
                  ianz = 99
               endif
            endif
          endif

      return
      end

      subroutine chkcap(irs,iterm,iconn,ianz,iresid,qat,
     &                  icalf,iamino)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      common /conrl/ ibnds,icnn(mxcon),io,in,ic,ih,ian1,ian2,ian3,ian4
      dimension iconn(mxcon+1,*),ianz(*),iresid(*),qat(*)
      dimension nace(6),qace(6),nme(6),qnme(6),qnh2(3)
      dimension icalf(6,*),iamino(*)
      data qace /0.59720,-0.56790,-0.36620,0.11230,0.11230,0.11230/
      data qnme /-0.41570,0.27190,-0.14900,0.09760,0.09760,0.09760/
      data qnh2 /-0.46300,0.23150,0.23150/

      if (iterm.eq.1) then
         ncterm = icalf(2,irs)
      else
         ncterm = icalf(3,irs)
      endif

      call getrcn(ncterm,iconn,ianz)

      if (iterm.eq.1) then
c N-term
c        establish carbonyl C of ACE

         do i=1,6
             nace(i) = 0
         end do

         iace = 0
         if ((ic.eq.2.and.iamino(irs).ne.15).or.
     &       (ic.eq.3.and.iamino(irs).eq.15)) then
             
             do i=1,ibnds
                if (ianz(icnn(i)).eq.6.and.iresid(icnn(i)).ne.irs)
     &            iace = icnn(i)
             end do
             if (iace.eq.0) return

         else
            return
         endif

         nace(1) = iace
         call getrcn(iace,iconn,ianz)
         if (io.eq.1) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.8) nace(2) = icnn(i)
             end do
         else
             return
         endif

         if (ic.eq.1) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.6) nace(3) = icnn(i)
             end do
         else
             return
         endif

         call getrcn(nace(3),iconn,ianz)
         if (ih.eq.3) then
             itel = 4
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) then
                    nace(itel) = icnn(i)
                    itel = itel + 1
                endif
             end do
         else
             return
         endif

c        check if all atoms ACE found

         do i=1,6
            if (nace(i).le.0) return
         end do

         do i=1,6
            qat(nace(i)) = qace(i)
         end do

      else

c C-term
c        establish n-methyl N of NME/NH2

         do i=1,6
             nme(i) = 0
         end do

         inme = 0

         if (in.eq.1) then
             
             do i=1,ibnds
                if (ianz(icnn(i)).eq.7.and.iresid(icnn(i)).ne.irs)
     &            inme = icnn(i)
             end do
             if (inme.eq.0) return

         else
            return
         endif

         nme(1) = inme
         inh2 = 0
         call getrcn(inme,iconn,ianz)
         if (ih.eq.1) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) nme(2) = icnn(i)
             end do
         else if (ih.eq.2) then
             inh2 = 1
             itel = 0
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) then
                   nme(2+itel) = icnn(i)
                   itel = itel + 1
                endif
             end do
         else
             return
         endif

         if (inh2.eq.1) then

c           this is NH2 cap

            do i=1,3
               if (nme(i).le.0) return
            end do

            do i=1,3
               qat(nme(i)) = qnh2(i)
            end do

            return
         endif

c        this is NME cap

         if (ic.eq.2) then
             do i=1,ibnds
                if (ianz(icnn(i)).eq.6.and.iresid(icnn(i)).ne.irs) 
     &             nme(3) = icnn(i)
             end do
         else
             return
         endif

         call getrcn(nme(3),iconn,ianz)
         if (ih.eq.3) then
             itel = 4
             do i=1,ibnds
                if (ianz(icnn(i)).eq.1) then
                    nme(itel) = icnn(i)
                    itel = itel + 1
                endif
             end do
         else
             return
         endif

c        check if all atoms NME found

         do i=1,6
            if (nme(i).le.0) return
         end do

         do i=1,6
            qat(nme(i)) = qnme(i)
         end do

      endif

      return
      end

      subroutine getrcn(iat,iconn,ianz)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /conrl/ ibnds,icnn(mxcon),io,in,ic,ih,ian1,ian2,ian3,ian4
      dimension iconn(mxcon+1,*),ianz(*)

      ibnds = 0
      io = 0
      in = 0
      ic = 0
      ih = 0
      ian1 = 0
      ian2 = 0
      ian3 = 0
      ian4 = 0

      if (iat.eq.0) return

      do i=1,iconn(1,iat)
         if (iconn(i+1,iat).gt.0) then
            ibnds = ibnds + 1
            icnn(ibnds) = iconn(i+1,iat)
            ia = ianz(icnn(ibnds))
            if (ia.eq.1) ih = ih + 1
            if (ia.eq.6) ic = ic + 1
            if (ia.eq.7) in = in + 1
            if (ia.eq.8) io = io + 1
         endif
      end do

      if (ibnds.gt.0) ian1 = ianz(icnn(1))
      if (ibnds.gt.1) ian2 = ianz(icnn(2))
      if (ibnds.gt.2) ian3 = ianz(icnn(3))
      if (ibnds.gt.4) ian4 = ianz(icnn(4))

      return
      end

      integer function igtyp(iat,ian,idochg,ianz,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxt=14)
      character*4 atype
      common /atypes/ ihbt(mxt),atype(mxt)
      dimension icnn(mxcon),iccn(mxcon),icnn2(mxcon),iconn(mxcon+1,*),
     &          ianz(*)

      ibnds = 0
      ih = 0
      ihc = 0
      io = 0
      in = 0
      ic = 0
      is = 0
      ian1 = 0
      ian2 = 0
      ian3 = 0

      do i=1,mxcon
         icnn(i) = 0
         iccn(i) = 0
      end do

      do i=1,iconn(1,iat)
         if (iconn(i+1,iat).gt.0) then
            ibnds = ibnds + 1
            icnn(ibnds) = iconn(i+1,iat)
            ia = ianz(icnn(ibnds))
            if (ia.eq.1) ih = ih + 1
            if (ia.eq.6) ic = ic + 1
            if (ia.eq.6.or.ia.eq.1) ihc = ihc + 1
            if (ia.eq.7) in = in + 1
            if (ia.eq.8) io = io + 1
            if (ia.eq.16) is = is + 1
         endif
      end do
      if (ibnds.gt.0) ian1 = ianz(icnn(1))
      if (ibnds.gt.1) ian2 = ianz(icnn(2))
      if (ibnds.gt.2) ian3 = ianz(icnn(3))

      call ispn(irs,iat,irng,idochg,1)
      
c irs    1      2      3      4      5      6       7
c      '    ','.1  ','.2  ','.3  ','.4  ','.ar ','.cat'
c irs    8      9     10     11     12     13      14
c      '.am ','.pl3','.co2','.spc','.t3p','.O  ','.O2 '

      igtyp = 1
      if (ian.eq.1) then

         igtyp = 1
         if (ibnds.eq.1) then
            if (ian1.eq.6) then
               igtyp = 25
               call ispn(itmp,icnn(1),irng,idochg,1)
               if (itmp.eq.6.or.itmp.eq.3) igtyp = 24

               call flth(icnn(1),icnn2,ibnds2,iconn)

               nhcp = 0
               do i=1,ibnds2
                   ia = ianz(icnn2(i))
                   if (.not.(ia.eq.6.or.ia.eq.1.or.ia.eq.15)) then
                      nhcp = nhcp + 1
                      iccn(nhcp) = icnn2(i)
                   endif
               end do

               if (nhcp.ne.0) then
                  if (igtyp.eq.25) then
                     igtyp = 18 + nhcp
                  elseif (igtyp.eq.24) then
                     igtyp = 21 + nhcp
                  endif
               endif
               if (nhcp.eq.1.and.(iccn(1).gt.1.and.icnn(1).lt.100)) 
     &         then
                  if (ianz(iccn(1)).eq.8.and.
     &               (itmp.eq.6.or.itmp.eq.3)) then
                     igtyp = 24
                  endif
               endif
            endif
            if (ian1.eq.7)  igtyp = 26
            if (ian1.eq.8)  then
               igtyp = 27
               call flth(icnn(1),icnn2,ibnds2,iconn)
               if (ibnds2.eq.2) then
                  if (ianz(icnn2(1)).eq.1.and.ianz(icnn2(2)).eq.1)
     &               igtyp = 30
               endif
            endif
            if (ian1.eq.15) igtyp = 28
            if (ian1.eq.16) igtyp = 29
         endif

      elseif (ian.eq.6) then

         if (irs.eq.2) igtyp = 3
         if (irs.eq.3) igtyp = 4
         if (irs.eq.4) igtyp = 5
         if (irs.eq.6) igtyp = 6
         if (irs.eq.7) then
            igtyp = 6
            if (in.eq.3) igtyp = 72
         endif

         if ((irs.eq.3.or.irs.eq.6).and.ibnds.eq.3.and.
     &      (io.ge.1.or.is.ge.1)) then
            icon = 0
            if (ian1.eq.8.or.ian1.eq.16) icon = icnn(1)
            if (ian2.eq.8.or.ian2.eq.16) icon = icnn(2)
            if (ian3.eq.8.or.ian3.eq.16) icon = icnn(3)
            if (icon.gt.0) then
               call ispn(itmp,icon,irng,idochg,1)
               if ((itmp.eq.10.or.itmp.eq.3).and.irng.le.0) igtyp = 2
            endif
         endif

      elseif (ian.eq.7) then

c n1     (.1)
         if (irs.eq.2) igtyp = 37
c n2, nc (.2,.ar) (nc contributes 1 el to pi system)
         if ((irs.eq.3.or.irs.eq.6).and.ibnds.eq.2) then
            igtyp = 38
            if (irs.eq.6) igtyp = 43
         endif
c na     (.2,.ar,.pl) (.pl contributes 2 el to pi system)
         if ((irs.eq.3.or.irs.eq.6.or.irs.eq.9).and.ibnds.eq.3) 
     &      igtyp = 41
c n3     (.3)
         if (irs.eq.4.and.ibnds.eq.3) igtyp = 39
c no     (.2,.3,.pl)
         if ((irs.eq.3.or.irs.eq.4.or.irs.eq.9).and.
     &      ibnds.eq.3.and.io.eq.2) igtyp = 48
c n4     (.4)
         if (irs.eq.5) igtyp = 40
c n      (.am)
         if (irs.eq.8) igtyp = 36
c nh     (.3)
         if ((irs.eq.4.or.irs.eq.9).and.ibnds.eq.3.and.ihc.eq.3) then
            iar = 0
            if (ian1.ne.1) then
               call ispn(itmp,icnn(1),irng,idochg,1)
               if (itmp.eq.6) iar = iar + 1
            endif
            if (ian2.ne.1) then
               call ispn(itmp,icnn(2),irng,idochg,1)
               if (itmp.eq.6) iar = iar + 1
            endif
            if (ian3.ne.1) then
               call ispn(itmp,icnn(3),irng,idochg,1)
               if (itmp.eq.6) iar = iar + 1
            endif
            if (iar.gt.0) igtyp = 47
         endif
         if (ibnds.eq.3.and.ic.gt.0) then
            do i=1,ibnds
               nat = ianz(icnn(i))
               if (nat.eq.6) then
                  call flth(icnn(i),icnn2,ibnds2,iconn)
                  if (ibnds2.eq.3) then
                      iscat = 1
                      do j=1,3
                         if (ianz(icnn2(j)).ne.7) iscat = 0
                      end do
                      if (iscat.eq.1) igtyp = 47
                  endif
               endif
            end do
         endif

      elseif (ian.eq.8) then

         if (irs.eq.3.or.irs.eq.10) igtyp = 49
         if ((irs.eq.4.or.irs.eq.6).and.ibnds.eq.2) then
            if (ih.eq.2) then 
               igtyp = 52
            elseif (ih.eq.1) then
               igtyp = 50
            else
               igtyp = 51
            endif
         endif

      elseif (ian.eq.15) then

         if (ibnds.le.2) igtyp = 53
         if (ibnds.eq.3) then

c difference between p3 and p4 may need some adjustment

            iar = 0
            if (ian1.ne.1) then
               call ispn(itmp,icnn(1),irng,idochg,1)
               if (itmp.eq.3) iar = iar + 1
            endif
            if (ian2.ne.1) then
               call ispn(itmp,icnn(2),irng,idochg,1)
               if (itmp.eq.3) iar = iar + 1
            endif
            if (ian3.ne.1) then
               call ispn(itmp,icnn(3),irng,idochg,1)
               if (itmp.eq.3) iar = iar + 1
            endif
            if (iar.gt.0) then
               igtyp = 55
            else
               igtyp = 54
            endif
         endif
         if (ibnds.ge.4) igtyp = 56

      elseif (ian.eq.16) then

         if (ibnds.eq.1) igtyp = 64
c ibnds = 2 may need some refinement, sh clear, ss clear, but s2 ?
         if (ibnds.eq.2) then
            if (ih.ge.1) then
               igtyp = 68
            else
               if ((irs.eq.4.or.irs.eq.6).or.is.eq.1) then
                  igtyp = 69
               else
                  igtyp = 65
               endif
            endif
         endif
         if (ibnds.eq.3) igtyp = 66
         if (ibnds.ge.4) igtyp = 67

      elseif (ian.eq.9) then
         if (ibnds.eq.1) igtyp = 32
      elseif (ian.eq.17) then
         if (ibnds.eq.1) igtyp = 33
      elseif (ian.eq.35) then
         if (ibnds.eq.1) igtyp = 34
      elseif (ian.eq.53) then
         if (ibnds.eq.1) igtyp = 35
      endif
      
      return
      end

      subroutine mkbadd(ipdb,ihpdb,jres,icres,ihashy,idoconv,
     &                  iconn,coo,
     &                  icalf,ianf,islu,nchain,iamino)

      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxcon=10)
      logical newch
      dimension ipdb(*),ihpdb(*),tmp(3),coo(3,*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      fct = 1.0d0
      if (idoconv.eq.1) fct = 1.0d0 / (0.52917706d0*0.52917706d0)

c N-CA
      if (ipdb(1).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(1)) = 1
         iconn(2,ipdb(1)) = ipdb(2)
      endif

c CA-N, CA-C
      if (ipdb(2).ne.0) then
         iconn(1,ipdb(2)) = 0
         if (ipdb(1).ne.0) then
            iconn(2,ipdb(2)) = ipdb(1)
            iconn(1,ipdb(2)) = 1
            if (ipdb(3).ne.0) then
               iconn(3,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 2
            endif
         else
            if (ipdb(3).ne.0) then
               iconn(2,ipdb(2)) = ipdb(3)
               iconn(1,ipdb(2)) = 1
            endif
         endif
      endif

c C-CA,C-O
      if (ipdb(4).ne.0.and.ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
         if (ipdb(2).ne.0) then
            iconn(2,ipdb(3)) = ipdb(2)
            iconn(3,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 2
         else
            iconn(2,ipdb(3)) = ipdb(4)
            iconn(1,ipdb(3)) = 1
         endif
c O-C
         iconn(1,ipdb(4)) = 1
         iconn(2,ipdb(4)) = ipdb(3)

      elseif (ipdb(3).ne.0.and.ipdb(2).ne.0) then
         iconn(1,ipdb(3)) = 1
         iconn(2,ipdb(3)) = ipdb(2)
      elseif (ipdb(3).ne.0) then
         iconn(1,ipdb(3)) = 0
      elseif (ipdb(4).ne.0) then
         iconn(1,ipdb(4)) = 0
      endif


c Possible OXT
      if (ipdb(38).ne.0.or.ipdb(76).ne.0) then
         if (ipdb(38).ne.0) then
            iox = ipdb(38)
         else
            iox = ipdb(76)
         endif
         iconn(1,ipdb(3)) = iconn(1,ipdb(3)) + 1
         iconn(iconn(1,ipdb(3))+1,ipdb(3)) = iox
         iconn(1,iox) = 1
         iconn(2,iox) = ipdb(3)
      endif
c C beta
      if (jres.gt.1.and.ipdb(5).ne.0) then
         iconn(1,ipdb(2)) = 3
         iconn(4,ipdb(2)) = ipdb(5)
         iconn(1,ipdb(5)) = 1
         iconn(2,ipdb(5)) = ipdb(2)
      endif
 
      if (icres.le.numcal) then
         icalf(1,icres) = ipdb(2)
         icalf(2,icres) = ipdb(1)
         icalf(3,icres) = ipdb(3)
         icalf(4,icres) = 0
      endif

      if (icres.gt.1.and.icres.le.numcal) then
         newch = .false.
         ic = icalf(3,icres-1)
         in = ipdb(1)
         if (iamino(icres-1).le.23.and.(ic.gt.0.and.in.gt.0)) then
            do i=1,3
               tmp(i) = coo(i,in) - coo(i,ic)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect N current residue to C previous
c
               iconn(1,in) = iconn(1,in) + 1 
               iconn(iconn(1,in)+1,in) = ic
            else
               newch = .true.
            endif
         else 
            newch = .true.
         endif

         if (newch.and.idoconv.eq.0) then
            if (nchain.lt.mxchai) then
               islu(nchain) = icres-1
               nchain = nchain + 1
               ianf(nchain) = icres
            endif
         endif

      endif

      if (icres.ge.1.and.icres.le.numcal-1) then
         ic = ipdb(3)
         in = icalf(2,icres+1)
         if (iamino(icres+1).le.23.and.(ic.gt.0.and.in.gt.0)) then
            do i=1,3
               tmp(i) = coo(i,in) - coo(i,ic)
            end do
            distsq = tmp(1)*tmp(1) + tmp(2)*tmp(2) +
     &               tmp(3)*tmp(3)
            if (distsq.lt.3.1684d0*fct) then
c
c connect C previous to N current residue 
c
               iconn(1,ic) = iconn(1,ic) + 1 
               iconn(iconn(1,ic)+1,ic) = in
            endif
         endif

      endif

      if (ihashy.eq.1) then
          do i=1,3
             call conath(ipdb,ihpdb,1,i)
             call conath(ipdb,ihpdb,2,3+i)
             call conath(ipdb,ihpdb,5,6+i)
          end do
          call conath(ipdb,ihpdb,1,79)
          call conath(ipdb,ihpdb,1,82)
          call conath(ipdb,ihpdb,1,91)
      endif

      return
      end

      subroutine setchd(iat,iopt,qat,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      common /charge/ ihasq
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      dimension qat(*),ityp(*)

      if (iat.gt.0) then
         if (iopt.eq.1) then
            it = ityp(iat)
            if (it.gt.0) then
               qat(iat) = ambchg(int(it))
            endif
            ihasq = 1
         elseif (iopt.eq.0) then
            qat(iat) = 0.0d0
         elseif (iopt.lt.0) then
            qat(iat) = cysneg(abs(iopt))
         endif
      endif

      return
      end

      subroutine settyp(itypa,iat,ityp)
      implicit double precision (a-h,o-z)
      dimension itypa(*)

      if (iat.gt.0) then
          itypa(iat) = ityp
      endif

      return
      end

      subroutine typamd(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxres=42)
      parameter (mxrss=20)
      parameter (mxrsa=23)
      parameter (mxata=9)
      parameter (mxatha=9)
      parameter (mxrso=24)
      parameter (mxato=10)
      parameter (mxatho=11)
      parameter (mxrsn=19)
      parameter (mxnucl=39)
      parameter (mxhnuc=27)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxambc=49)
      logical nterm,cterm
      common /types/ iff
      common /athlp/ iatoms, mxnat
      integer amboff,ntca,ctca
      common /ambtyp/ amboff(mxrss*3),ntca(mxrss),ctca(mxrss),
     &                ncca(mxrsa),icca(2,mxata,mxrsa),
     &                nhha(mxrsa),ihha(2,mxatha,mxrsa),
     &                ncco(mxrso),icco(2,mxato,mxrso),
     &                nhho(mxrso),ihho(2,mxatho,mxrso),
     &                nnuc(mxrsn),nhnuc(mxrsn),irna(mxres-23),
     &                inuc(2,mxnucl,mxrsn),ihnuc(2,mxhnuc,mxrsn)
      integer ambvdt
      common /fcharg/ ambchg(mxamb),ambvw1(mxambc),ambvw2(mxambc),
     &                gfvdw(2,mxgff),ambvdt(mxamb),cysneg(9)
      logical ismet

      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*),
     &          icn(4)

      iff = 3

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20) (HIP,HID,HIE and sulfer bridge covered)
c                (ORN, mALA and pyroglut not covered)


      if (jres.le.0.or.jres.gt.mxres) return
      if (jres.gt.mxrss) goto 100

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
         call setchg(ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
         call setchg(ihpdb(i),0)
      end do

      nterm = .false.
      n = 0
      do i=1,3
         if (ihpdb(i).ne.0) n = n + 1
      end do
      if (n.eq.0) then
         if (ihpdb(79).ne.0) n = n + 1
         if (ihpdb(82).ne.0) n = n + 1
         if (ihpdb(91).ne.0) n = n + 1
      endif
      if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.
      cterm = .false.
      if (ipdb(38).ne.0) cterm = .true.

      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      if (jres.eq.4) then
c iss = 0 (cysteine -SH), iss = 1 (cystine -SS-)
         iss = 0
         if (ipdb(37).ne.0) then
            do i=1,iconn(1,ipdb(37))
               if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &             iss = 1
            end do
         endif
      endif

      if (nterm) then
          ioff = amboff(jres+20)
      else if(cterm) then
          ioff = amboff(jres+40)
      else
        ioff = amboff(jres)
      endif

      if (jres.eq.17) then
         if (ihis.eq.2) ioff = 178
         if (ihis.eq.3) ioff = 194
      endif

      if (jres.eq.4.and.iss.eq.1) ioff = 87
      if (jres.eq.9.and.(ihpdb(22).ne.0.or.ihpdb(25).ne.0)) ioff = 660
      if (jres.eq.13.and.(ihpdb(31).ne.0.or.ihpdb(34).ne.0)) ioff = 672

      ihtot = 0
      do i=0,2
         if (ihpdb(40+i).ne.0) ihtot = ihtot + 1
      end do

      if (jres.eq.12.and.ihtot.eq.2) ioff = 686

      if (nterm) then
         if (jres.eq.17 .and. ihis.eq.2) ioff = 436
         if (jres.eq.17 .and. ihis.eq.3) ioff = 442
         if (jres.eq.4 .and. iss.eq.1) ioff = 398
      endif
      if (cterm) then
         if (jres.eq.17 .and. ihis.eq.2) ioff = 584
         if (jres.eq.17 .and. ihis.eq.3) ioff = 590
         if (jres.eq.4 .and. iss.eq.1) ioff = 549
      endif

      call settyp(ityp,ipdb(1),ioff)
      call settyp(ityp,ipdb(2),ioff+1)
      call settyp(ityp,ipdb(3),ioff+2)

      if (jres.eq.15.and..not.nterm) then
         call settyp(ityp,ipdb(4),ioff+3)
         if (cterm) call settyp(ityp,ipdb(38),ioff+3)
      else
         call settyp(ityp,ipdb(4),ioff+4)
         if (cterm) call settyp(ityp,ipdb(38),ioff+4)
      endif

      call settyp(ityp,ihpdb(1),ioff+3)
      call settyp(ityp,ihpdb(2),ioff+3)
      call settyp(ityp,ihpdb(3),ioff+3)
      call settyp(ityp,ihpdb(79),ioff+3)
      call settyp(ityp,ihpdb(82),ioff+3)
      call settyp(ityp,ihpdb(91),ioff+3)

      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ihpdb(4),409)
         else
            call settyp(ityp,ihpdb(4),ioff+4)
            call settyp(ityp,ihpdb(5),ioff+4)
         endif
      else
         call settyp(ityp,ihpdb(4),ioff+5)
         call settyp(ityp,ihpdb(5),ioff+5)
      endif

      if (nterm.or.cterm) then
         ioff = amboff(jres)
         if (jres.eq.17) then
            if (ihis.eq.2) ioff = 178
            if (ihis.eq.3) ioff = 194
         endif
         if (jres.eq.4.and.iss.eq.1) ioff = 87
      endif

      if (jres.eq.15) then
         call settyp(ityp,ipdb(5),ioff+5)
         call settyp(ityp,ihpdb(7),ioff+6)
         call settyp(ityp,ihpdb(8),ioff+6)
         call settyp(ityp,ihpdb(9),ioff+6)
      else
         call settyp(ityp,ipdb(5),ioff+6)
         call settyp(ityp,ihpdb(7),ioff+7)
         call settyp(ityp,ihpdb(8),ioff+7)
         call settyp(ityp,ihpdb(9),ioff+7)
      endif

      jtmp = jres
      if (jres.eq.17) then
         if (ihis.eq.2) jtmp = 22
         if (ihis.eq.3) jtmp = 23
      endif
      if (jres.eq.4.and.iss.eq.1) jtmp = 21
    
      do i=1,ncca(jtmp)
         call settyp(ityp,ipdb(icca(1,i,jtmp)),icca(2,i,jtmp))
      end do

      do i=1,nhha(jtmp)
         call settyp(ityp,ihpdb(ihha(1,i,jtmp)),ihha(2,i,jtmp))
      end do

      if (jres.eq.8) then
         call settyp(ityp,ihpdb(13),267)
         call settyp(ityp,ihpdb(16),267)
         call settyp(ityp,ihpdb(31),270)
         call settyp(ityp,ihpdb(34),270)
         call settyp(ityp,ihpdb(37),270)
      endif
      if (jres.eq.13) then
         call settyp(ityp,ihpdb(13),241)
         call settyp(ityp,ihpdb(16),241)
      endif
      if (jres.eq.14) then
         call settyp(ityp,ihpdb(13),253)
         call settyp(ityp,ihpdb(16),253)
      endif
      if (jres.eq.16) then
         call settyp(ityp,ihpdb(13),296)
         call settyp(ityp,ihpdb(16),296)
         call settyp(ityp,ihpdb(22),298)
         call settyp(ityp,ihpdb(25),298)
      endif

      if (jres.eq.15) then
         if (nterm) then
            call settyp(ityp,ipdb(9),410)
            call settyp(ityp,ihpdb(19),411)
            call settyp(ityp,ihpdb(20),411)
         endif
      endif

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

      if (jres.eq.12) then
         call settyp(ityp,ihpdb(13),280)
         call settyp(ityp,ihpdb(16),280)
         call settyp(ityp,ihpdb(22),282)
         call settyp(ityp,ihpdb(25),282)
         call settyp(ityp,ihpdb(34),284)
         call settyp(ityp,ihpdb(37),284)
         call settyp(ityp,ihpdb(43),286)
         call settyp(ityp,ihpdb(46),286)
         call settyp(ityp,ihpdb(49),286)
      endif

c check asph, RECTIFICATION: asph, gluh neutral lys, neg cys
c are not in the tinker amber set.
c we could add our own, but it has not been done yet
c Original AMBER itself does not work with so many atom types.
c Tinker creates the extra atom types to incrporate the charges
c in there as well. Charges deviate slightly between
c cterm,nterm and regular residues
c see ~schaft/compile/linux/molden4.6/
c     forf/amber9.ffparms/dat/leap/prep/all_amino94.in
c for the charges
c we should add our own extra types for these residues

      if (jres.eq.9) then
         if (ihpdb(22).ne.0) then
            call settyp(ityp,ipdb(6),668)
            call settyp(ityp,ipdb(29),670)
            call settyp(ityp,ipdb(30),669)
            call settyp(ityp,ihpdb(22),671)
         endif
         if (ihpdb(25).ne.0) then
            call settyp(ityp,ipdb(6),668)
            call settyp(ityp,ipdb(29),669)
            call settyp(ityp,ipdb(30),670)
            call settyp(ityp,ihpdb(25),671)
         endif
      endif

      if (jres.eq.13) then
         if (ihpdb(31).ne.0) then
            call settyp(ityp,ipdb(6),680)
            call settyp(ityp,ipdb(9),682)
            call settyp(ityp,ipdb(34),684)
            call settyp(ityp,ipdb(35),683)
            call settyp(ityp,ihpdb(10),681)
            call settyp(ityp,ihpdb(11),681)
            call settyp(ityp,ihpdb(31),685)
         endif
         if (ihpdb(34).ne.0) then
            call settyp(ityp,ipdb(6),680)
            call settyp(ityp,ipdb(9),682)
            call settyp(ityp,ipdb(34),683)
            call settyp(ityp,ipdb(35),684)
            call settyp(ityp,ihpdb(10),681)
            call settyp(ityp,ihpdb(11),681)
            call settyp(ityp,ihpdb(34),685)
         endif
      endif

      if (jres.eq.12.and.ihtot.eq.2) then
            call settyp(ityp,ipdb(6),694)
            call settyp(ityp,ipdb(9),696)
            call settyp(ityp,ipdb(12),698)
            call settyp(ityp,ipdb(27),700)
            call settyp(ityp,ihpdb(10),695)
            call settyp(ityp,ihpdb(11),695)
            call settyp(ityp,ihpdb(19),697)
            call settyp(ityp,ihpdb(20),697)
            call settyp(ityp,ihpdb(28),699)
            call settyp(ityp,ihpdb(29),699)
            call settyp(ityp,ihpdb(40),701)
            call settyp(ityp,ihpdb(41),701)
            call settyp(ityp,ihpdb(42),701)
            call settyp(ityp,ihpdb(43),701)
            call settyp(ityp,ihpdb(46),701)
            call settyp(ityp,ihpdb(49),701)
      endif

      do i=1,mxsym
         call setchg(ipdb(i),1)
      end do
      do i=1,mxhsym*3
         call setchg(ihpdb(i),1)
      end do

      if (jres.eq.4) then

c ic = 0 (negative cysteine), apply different charges

         if (ipdb(37).ne.0) then
            ic = 0
            do i=1,iconn(1,ipdb(37))
               ii = iconn(1+i,ipdb(37))
               if (ii.gt.0.and.ii.ne.ipdb(5)) then
                   if (.not.ismet(ianz(ii))) ic = ic + 1
               endif
            end do

            if (ic.eq.0) then

               do i=1,mxsym
                  if (ipdb(i).ne.0) then
                     it = ityp(ipdb(i)) 
                     if (it.ge.77.and.it.le.85) then
                        it = 76 - it
                        call setchg(ipdb(i),it)
                     endif
                  endif
               end do

               do i=1,mxhsym*3
                  if (ihpdb(i).ne.0) then
                     it = ityp(ihpdb(i)) 
                     if (it.ge.77.and.it.le.85) then
                        it = 76 - it
                        call setchg(ihpdb(i),it)
                     endif
                  endif
               end do

            endif
         endif
      endif

      return

100   continue

c     NUCLEOTIDES

      isrna = 1
      jtmp = irna(jres - 23)

      if (ipdb(53).eq.0.and.jres.ne.27) then
         isrna = 0
         jtmp = jtmp + 4
      endif

      do i=1,nnuc(jtmp)
         call settyp(ityp,ipdb(inuc(1,i,jtmp)),inuc(2,i,jtmp))
      end do

      do i=1,nhnuc(jtmp)
         call settyp(ityp,ihpdb(ihnuc(1,i,jtmp)),ihnuc(2,i,jtmp))
      end do

      if (ihpdb(115).ne.0) then
c        3'-Hydroxyl
         if (isrna.eq.1) then
            call settyp(ityp,ipdb(51),1237)
            call settyp(ityp,ihpdb(115),1238)
         else
            call settyp(ityp,ipdb(51),1249)
            call settyp(ityp,ihpdb(115),1250)
         endif
      endif

      if (ihpdb(118).ne.0) then
c        5'-Hydroxyl
         if (isrna.eq.1) then
            call settyp(ityp,ipdb(46),1232)
            call settyp(ityp,ihpdb(118),1233)
         else
            call settyp(ityp,ipdb(46),1244)
            call settyp(ityp,ihpdb(118),1245)
         endif
      endif

c     check P connected to O3* (ipdb(51)), if nconn O = 4 => 3'-Phosphate

      call chkpo4(ipdb(51),isrna,1239,1240,1241,1251,1252,1253,
     &                  ianz,iconn,ityp)

c     check P connected to O5* (ipdb(46)), if nconn O = 4 => 5'-Phosphate

      call chkpo4(ipdb(46),isrna,1234,1235,1236,1246,1247,1248,
     &                  ianz,iconn,ityp)

      do i=1,mxsym
         call setchg(ipdb(i),1)
      end do

      do i=1,mxhsym*3
         call setchg(ihpdb(i),1)
      end do

      return
      end

      subroutine chkpo4(io35,isrna,ir1,ir2,ir3,id1,id2,id3,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      dimension icn(3),ianz(*),iconn(mxcon+1,*),ityp(*)

      ip = 0
      if (io35.eq.0) return

      do i=1,iconn(1,io35)
         j = iconn(1+i,io35)
         if (j.gt.0) then
            if (ianz(j).eq.15) ip = j
         endif
      end do

      if (ip.gt.0) then
         no = 0
         do i=1,iconn(1,ip)
            j = iconn(1+i,ip)

            if (j.gt.0) then
               if (ianz(j).eq.8.and.j.ne.io35) then
                  ido = 1

                  do k=1,iconn(1,j)
                     l = iconn(1+k,j)
                     if (l.gt.0) then
                        if (l.gt.1.and.l.ne.ip) ido = 0
                     endif
                  end do

                  if (ido.eq.1) then
                     no = no + 1
                     icn(no) = j
                  endif

               endif
            endif
         end do

         if (no.eq.3) then

            if (isrna.eq.1) then

c     R-3'-Phosphate: O3* 1239, P 1240 OP 1241

               call settyp(ityp,io35,ir1)
               call settyp(ityp,ip,ir2)
               call setchg(ip,1)

               do i=1,3
                  call settyp(ityp,icn(i),ir3)
                  call setchg(icn(i),1)
               end do

            else

c     D-3'-Phosphate: O3* 1251, P 1252 OP 1253

               call settyp(ityp,io35,id1)
               call settyp(ityp,ip,id2)
               call setchg(ip,1)

               do i=1,3
                  call settyp(ityp,icn(i),id3)
                  call setchg(icn(i),1)
               end do

            endif
         endif
      endif

      return
      end

      subroutine dotyd(ianz,iaton,iatclr,iconn,iresid,
     &                 lwrit,lring,ityp,coo,qat,icont,
     &                 icalf,ncalf,ianf,islu,nchain,iamino,ishoh)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)

      parameter (mxel=100)
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (mxt=14)
      parameter (mxmol2=41)
      parameter (mxamb=1590)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxres=42)

      common /athlp/ iatoms, mxnat
      common /charge/ ihasq
      common /types/ iff
      character*5  mol2
      character*20 ambstr
      common /ftypes/ihasl(11),mol2(mxmol2),ambstr(mxamb)
      character*3 aminos
      common /amino/aminos(mxres)
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*),
     &          iresid(*),ityp(*),lwrit(*),lring(*),qat(*),icont(*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      natoms = iatoms

      if (ihasq.eq.1) idochg = 1

      do i=1,natoms
         lwrit(i) = 0
         lring(i) = 0
         icont(i) = iaton(i)
         iaton(i) = 2
         ityp(i) = 0
      end do


      iff = 3

c Tinker Amber

      do i=1,ncalf
         call getpdb(i,ipdb,ihpdb)
         call typamb(ipdb,iamino(i),ihpdb,1)
      end do

      if (ncalf.gt.0) then
          do i=1,nchain
c n-term cap
              call chkcap(ianf(i),1,iconn,ianz,iresid,qat,icalf,iamino)
c c-term cap
              call chkcap(islu(i),2,iconn,ianz,iresid,qat,icalf,iamino)
          end do
      endif

      do i=1,natoms

            if (iresid(i).le.-4) then
               if (iresid(i).eq.-ishoh) then
                  if (ianz(i).eq.8) ityp(i) = 649
                  if (ianz(i).eq.1) ityp(i) = 650
               else
                  ncnn = 0
                  do j=1,iconn(1,i)
                     if (iconn(1+j,i).gt.0) ncnn = ncnn + 1
                  end do

c metals
                  iset = 0
                  if (ianz(i).eq.3) then
                     ityp(i) = 651
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.11) then
                     ityp(i) = 652
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.19) then
                     ityp(i) = 653
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.37) then
                     ityp(i) = 654
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.55) then
                     ityp(i) = 655
                     qat(i) = 1.0d0
                     iset = 1
                  else if (ianz(i).eq.12) then
                     ityp(i) = 656
                     qat(i) = 2.0d0
                     iset = 1
                  else if (ianz(i).eq.20) then
                     ityp(i) = 657
                     qat(i) = 2.0d0
                     iset = 1
                  else if (ianz(i).eq.30) then
                     ityp(i) = 658
                     qat(i) = 2.0d0
                     iset = 1
                  else if (ianz(i).eq.17.and.ncnn.eq.0) then
                     ityp(i) = 659
                     qat(i) = -1.0d0
                     iset = 1
                  endif

               endif
            endif
      end do

      do i=1,iatoms
         iaton(i) = icont(i)
      end do

      return
      end

      subroutine calfd(istat,istpdb,iaddh,
     &                 ianz,iconn,ityp,
     &                 icalf,ncalf,ianf,islu,nchain,iamino,
     &                 isal,irsnr)

      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      parameter (mxsym=103)
      parameter (mxhsym=64)
      logical chkpdb
      common /surf/ natorg,noscnd
      logical cn,cco,ccb,cco1,chkhs
      common /types/ iff
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension ianz(*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),isal(*),irsnr(*),
     &          ityp(*)

c icalf(1,*) is Calfa
c icalf(2,*) is N connected to Calfa
c icalf(3,*) is C=O connected to Calfa

      istat = 1

      call hcoord(iaddh)

      isold = 10000
      do i=1,ncalf
         if (iamino(i).gt.23) isal(i) = 2
         if (isal(i).ne.isold) then
             if (i.gt.1) then
                 if (lng.le.2) isal(i-1) = 3
             endif
             if (i.gt.2) then
                 if (lng.eq.2) isal(i-2) = 3
             endif
             lng = 1
         else
             lng = lng + 1
         endif
         isold = isal(i)
      end do
      
      if (iff.eq.0) then
         do i=1,nchain
            do j=ianf(i),islu(i)
               call getpdb(j,ipdb,ihpdb)
               if (.not.chkpdb(ipdb,iamino(j),j,irsnr,isal(j))) 
     &         then
                   print*,'incomplete residue: internal no. ',j
               endif
               if (iaddh.eq.1.and..not.chkhs(ihpdb)) then
                  if (j.eq.ianf(i)) then
                     call addhs(j,iamino(j),ipdb,ihpdb,1)
                  else
                     call addhs(j,iamino(j),ipdb,ihpdb,0)
                  endif
               endif
               call typeit(ipdb,iamino(j),ihpdb,1)
            end do
         end do
      else
         do i=1,nchain
            do j=ianf(i),islu(i)
               call getpdb(j,ipdb,ihpdb)
               if (.not.chkpdb(ipdb,iamino(j),j,irsnr,isal(j))) 
     &         then
                   print*,'incomplete residue: internal no.',j
               endif
            end do
         end do
      endif

      noscnd = iatoms

      return
      end

      subroutine addhd(ires,jres,ipdb,ihpdb,nterm,
     &                 ianz,iaton,iatclr,iresid,iconn,isurf,ipdbt,ityp,
     &                 ncalf,icalf,coo)
c
c Add hydrogens
c Only the Hydrogens attached to the backbone N are not covered
c This is done by routine hcoord
c
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxres=42)
      parameter (mxhs=15)
      parameter (mxyg=26)
      common /hcom/  iat(4,mxhs,mxres),nrs(mxres),rint(3,mxhs,mxres),
     &               iatyg(4,mxyg),rintyg(3,mxyg)
      common /athlp/ iatoms, mxnat
      logical addat, o5pcon
      real dih
      dimension ipdb(*), ihpdb(*), it(4), rt(4), icalf(6,*),isel(4)
      dimension ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*),itp(3),
     &          iresid(*),coo(3,*),ipdbt(*),ityp(*),isurf(*)
      data nrs /2,4,4,4,6,10,8,8,3,5,10,12,5,7,7,12,6,8,8,9,3*0,
     &          11,11,11,12,10,13,13,13,13,13,15,15,13,0,10,0,12,
     &          12,10/
c gly
      data ((iat(i,j,1),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 3,1,2,5, 52*0/  
      data ((rint(i,j,1),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.9779d0,107.66d0,-118.0d0, 
     &     39*0.0d0/  
c ala
      data ((iat(i,j,2),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 3,2,5,7, 3,2,5,8, 3,2,5,9,
     &     44*0/  
      data ((rint(i,j,2),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     33*0.0d0/  
c ser
      data ((iat(i,j,3),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 2,5,31,10, 31,2,5,7, 31,2,5,8,
     &     44*0/  
      data ((rint(i,j,3),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.867d0,107.06d0,180.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     33*0.0d0/  
c cys
      data ((iat(i,j,4),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 2,5,37,10, 37,2,5,7, 37,2,5,8,
     &     44*0/  
      data ((rint(i,j,4),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.867d0,107.06d0,180.0d0, 
     &     0.990d0,112.5d0,120.0d0, 0.990d0,112.5d0,-120.0d0,
     &     33*0.0d0/  
c thr
      data ((iat(i,j,5),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 32,8,5,7, 2,5,32,13, 
     &     2,5,8,16, 2,5,8,17, 2,5,8,18,
     &     36*0/  
      data ((rint(i,j,5),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,-120.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     27*0.0d0/  
c ile
      data ((iat(i,j,6),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 7,8,5,7,  7,5,8,16, 7,5,8,17, 7,5,8,18,
     &     10,5,7,13, 10,5,7,14, 5,7,10,22, 5,7,10,23, 5,7,10,24,
     &     20*0/  
      data ((rint(i,j,6),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,-120.0d0, 
     &     0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     0.978d0,110.0d0,120.0d0, 0.978d0,110.0d0,-120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     15*0.0d0/  
c val
      data ((iat(i,j,7),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 7,8,5,7,  7,5,8,16, 7,5,8,17, 7,5,8,18,
     &     8,5,7,13, 8,5,7,14, 8,5,7,15,
     &     28*0/  
      data ((rint(i,j,7),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,120.0d0, 
     &     0.978d0,110.0d0,180.0d0,
     &     0.978d0,110.0d0,60.0d0, 0.978d0,110.0d0,-60.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     21*0.0d0/  
c met
      data ((iat(i,j,8),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7,  6,2,5,8,
     &     36,5,6,10, 36,5,6,11, 
     &     6,36,12,28, 6,36,12,29, 6,36,12,30,
     &     28*0/  
      data ((rint(i,j,8),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 0.990d0,109.08d0,120.0d0, 
     &     0.990d0,109.08d0,-120.0d0,
     &     0.978d0,110.0d0,120.0d0, 0.978d0,110.0d0,-120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     21*0.0d0/  
c asp
      data ((iat(i,j,9),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     48*0/  
      data ((rint(i,j,9),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     36*0.0d0/  
c asn
      data ((iat(i,j,10),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     29,6,21,25, 29,6,21,26,
     &     40*0/  
      data ((rint(i,j,10),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.950d0,120.0d0,180.0d0, 0.950d0,120.0d0,0.0d0,
     &     30*0.0d0/  
c leu
      data ((iat(i,j,11),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8,
     &     5,10,6,10, 5,6,10,22, 5,6,10,23, 5,6,10,24,
     &     5,6,11,25, 5,6,11,26, 5,6,11,27,
     &     20*0/  
      data ((rint(i,j,11),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.9779d0,107.63d0,120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     15*0.0d0/  
c lys
      data ((iat(i,j,12),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     12,6,9,19, 12,6,9,20, 27,9,12,28, 27,9,12,29,
     &     9,12,27,40, 9,12,27,41, 9,12,27,42,
     &     12*0/
      data ((rint(i,j,12),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,109.8d0,180.0d0, 
     &     0.990d0,109.8d0,60.0d0, 0.990d0,109.8d0,-60.0d0,
     &     9*0/
c glu
      data ((iat(i,j,13),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     40*0/
      data ((rint(i,j,13),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     30*0/
c gln
      data ((iat(i,j,14),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     34,9,24,34, 34,9,24,35,
     &     32*0/
      data ((rint(i,j,14),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.950d0,120.0d0,180.0d0, 0.950d0,120.0d0,0.0d0,
     &     24*0/
c pro
      data ((iat(i,j,15),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     1,6,9,19, 1,6,9,20,
     &     32*0/
      data ((rint(i,j,15),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     0.990d0,109.4d0,-120.0d0, 0.990d0,109.4d0,120.0d0,
     &     24*0/
c arg
      data ((iat(i,j,16),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 9,5,6,10, 9,5,6,11,
     &     22,6,9,19, 22,6,9,20, 9,17,22,28,
     &     22,17,25,55, 22,17,25,56, 22,17,26,58, 22,17,26,59,
     &     12*0/
      data ((rint(i,j,16),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     0.990d0,112.5d0,-120.0d0, 0.990d0,112.5d0,120.0d0,
     &     1.020d0,120.0d0,180.0d0,
     &     1.020d0,120.0d0,0.0d0, 1.020d0,120.0d0,180.0d0,
     &     1.020d0,120.0d0,0.0d0, 1.020d0,120.0d0,180.0d0,
     &     9*0/
c his
      data ((iat(i,j,17),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,20,22, 20,24,13,31, 24,6,11,25,
     &     36*0/
      data ((rint(i,j,17),i=1,3),j=1,mxhs) /
     &     0.9779d0,107.63d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.020d0,126.0d0,180.0d0, 1.100d0,126.0d0,180.0d0,
     &     1.020d0,126.0d0,180.0d0, 1.100d0,126.0d0,180.0d0,
     &     24*0/
c phe
      data ((iat(i,j,18),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,10,22, 10,17,13,31, 13,14,17,40, 17,11,14,34,
     &     14,6,11,25,
     &     28*0/
      data ((rint(i,j,18),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0,
     &     21*0/
c tyr
      data ((iat(i,j,19),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,13,10,22, 10,17,13,31, 13,17,33,52, 17,11,14,34,
     &     14,6,11,25,
     &     28*0/
      data ((rint(i,j,19),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     0.970d0,108.0d0,0.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0,
     &     21*0/
c trp
      data ((iat(i,j,20),i=1,4),j=1,mxhs) /
     &     3,1,2,4, 6,2,5,7, 6,2,5,8, 
     &     6,23,10,22, 10,14,23,31, 14,16,18,46, 18,19,16,58,
     &     16,15,19,49, 11,19,15,37,
     &     24*0/
      data ((rint(i,j,20),i=1,3),j=1,mxhs) /
     &     1.110d0,107.9d0,118.0d0, 
     &     1.110d0,109.4d0,-120.0d0, 1.110d0,109.4d0,120.0d0,
     &     1.100d0,124.0d0,180.0d0, 1.050d0,124.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     1.100d0,120.0d0,180.0d0, 1.100d0,120.0d0,180.0d0,
     &     18*0/

c asx,glx,hyp not yet

      data (((iat(i,j,k),i=1,4),j=1,mxhs),k=21,23) /180*0/
      data (((rint(i,j,k),i=1,3),j=1,mxhs),k=21,23) /135*0.0d0/

c adenosine

      data ((iat(i,j,24),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,62,60,55,82, 60,58,64,-136, 60,58,64,-137,
     &     16*0/
      data ((rint(i,j,24),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.080d0,116.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     12*0/

c cytidine

      data ((iat(i,j,25),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,58,56,57,100, 57,56,63,-130, 57,56,63,-131,
     &     16*0/
      data ((rint(i,j,25),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,123.4d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     12*0/

c guanosine

      data ((iat(i,j,26),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 60,55,61,-125,
     &     16*0/
      data ((rint(i,j,26),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     12*0/

c thimidine

      data ((iat(i,j,27),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103, 56,55,62,-127, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     12*0/
      data ((rint(i,j,27),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     9*0/

c uridine

      data ((iat(i,j,28),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,58,56,57,100, 56,55,62,-127, 
     &     20*0/
      data ((rint(i,j,28),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,119.4d0,180.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     15*0/

c 1MA

      data ((iat(i,j,29),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,62,60,55,82, 
     &     60,58,64,-137, 58,60,79,148, 58,60,79,149, 58,60,79,150, 
     &     0,0,0,0, 0,0,0,0/
      data ((rint(i,j,29),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 
     &     1.080d0,120.0d0,180.0d0,1.080d0,120.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,90.0d0,90.0d0,0.0d0,.0d0,0.0d0/

c 5MC

      data ((iat(i,j,30),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103, 57,56,63,-130, 57,56,63,-131, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     8*0/
      data ((rint(i,j,30),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 1.080d0,118.0d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     6*0/

c OMC

      data ((iat(i,j,31),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 
     &     52,53,80,151, 52,53,80,152, 52,53,80,153,
     &     60,57,58,103,58,56,57,100, 57,56,63,-130, 57,56,63,-131,
     &     8*0/
      data ((rint(i,j,31),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,118.0d0,180.0d0, 1.080d0,123.4d0,180.0d0,
     &     1.010d0,120.0d0,180.0d0, 1.010d0,120.0d0,0.0d0,
     &     6*0/

c 1MG

      data ((iat(i,j,32),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,
     &     58,60,79,148, 58,60,79,149, 58,60,79,150,
     &     60,55,61,-124, 60,55,61,-125,
     &     8*0/
      data ((rint(i,j,32),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0, 1.080d0,122.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     6*0/

c 2MG

      data ((iat(i,j,33),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 
     &     55,61,80,151, 55,61,80,152, 55,61,80,153,
     &     8*0/
      data ((rint(i,j,33),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,0.0d0, 
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     6*0/

c M2G

      data ((iat(i,j,34),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 
     &     55,61,79,148, 55,61,79,149, 55,61,79,150,
     &     55,61,80,151, 55,61,80,152, 55,61,80,153/
      data ((rint(i,j,34),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0/

c 7MG

      data ((iat(i,j,35),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 
     &     60,55,61,-125,57,65,85,166, 57,65,85,167, 57,65,85,168,
     &     0,0,0,0/
      data ((rint(i,j,35),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 
     &     1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,0.0d0,0.0d0,0.0d0/

c OMG

      data ((iat(i,j,36),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 
     &     52,53,80,151, 52,53,80,152, 52,53,80,153,
     &     66,65,59,112,58,55,60,-121, 60,55,61,-124, 60,55,61,-125,
     &     8*0/
      data ((rint(i,j,36),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0, 1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.009d0,120.0d0,180.0d0, 1.009d0,120.0d0,0.0d0,
     &     6*0/

c NO YG

      data ((iat(i,j,37),i=1,4),j=1,mxhs) /60*0/
      data ((rint(i,j,37),i=1,3),j=1,mxhs) /45*0.0d0/

c inosine

      data ((iat(i,j,38),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,58,55,60,-121,62,60,55,82, 
     &     20*0/
      data ((rint(i,j,38),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.008d0,118.5d0,180.0d0,
     &     1.080d0,122.0d0,180.0d0,
     &     15*0/

c NO +U

      data ((iat(i,j,39),i=1,4),j=1,mxhs) /60*0/
      data ((rint(i,j,39),i=1,3),j=1,mxhs) /45*0.0d0/

c H2U

      data ((iat(i,j,40),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,60,57,58,104,58,56,57,100,58,56,57,101,
     &     56,55,62,-127, 
     &     12*0/
      data ((rint(i,j,40),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,120.0d0, 1.080d0,119.4d0,-120.0d0,
     &     1.080d0,118.0d0,120.0d0, 1.080d0,119.4d0,-120.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     9*0/

c 5MU

      data ((iat(i,j,41),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,56,55,62,-127, 
     &     56,57,83,160, 56,57,83,161, 56,57,83,162,
     &     12*0/
      data ((rint(i,j,41),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0, 
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     9*0/


c PSU

      data ((iat(i,j,42),i=1,4),j=1,mxhs) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     60,57,58,103,55,58,60,-121, 56,55,62,-127, 
     &     20*0/
      data ((rint(i,j,42),i=1,3),j=1,mxhs) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,118.0d0,180.0d0, 1.010d0,117.0d0,180.0d0,
     &     1.010d0,117.0d0,180.0d0, 
     &     15*0/

c YG

      data ((iatyg(i,j),i=1,4),j=1,mxyg) /
     &     46,48,47,61, 46,48,47,62, 47,49,48,64,
     &     48,52,50,67, 50,54,52,70, 52,49,54,73, 50,52,53,76,
     &     66,65,59,112,56,62,88,91, 56,62,88,92, 56,62,88,93,
     &     61,90,89,175, 61,90,89,176, 61,90,89,177,
     &     91,93,92,178, 91,93,92,179,
     &     92,94,93,181, 92,94,93,182, 93,95,94,184,
     &     95,97,98,187, 95,97,98,188, 95,97,98,189,
     &     94,100,99,-124,
     &     100,102,103,190, 100,102,103,191, 100,102,103,192/
      data ((rintyg(i,j),i=1,3),j=1,mxyg) /
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,-120.0d0, 1.090d0,109.8d0,120.0d0,
     &     0.957d0,108.4d0,49.8d0,
     &     1.080d0,122.0d0,180.0d0, 1.090d0,109.8d0,180.0d0,
     &     1.090d0,109.8d0,60.0d0, 1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,120.0d0, 1.090d0,109.8d0,-120.0d0,
     &     1.090d0,109.8d0,120.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0, 1.010d0,120.0d0,180.0d0,
     &     1.090d0,109.8d0,180.0d0,1.090d0,109.8d0,60.0d0,
     &     1.090d0,109.8d0,-60.0d0/

c
c for nucleotides the H's that make hydrogen bonds are added
c by subroutine mkcon, addhy1 and addhy2, these atoms are flagged
c via array isurf, which is used by dohcon to create hydrogen bonds
c this routine does not do that
c
c OXT = O3P , do we have to add H's to O2P,O3P, at present NO
c

      if (jres.le.0.or.jres.gt.mxres) return

      if (jres.eq.37) then
         nh = mxyg
      else
         nh = nrs(jres)
      endif

      do i=1,nh

          if (jres.eq.37) then
              do j=1,4
                 it(j) = iatyg(j,i)
              end do
              do j=1,3
                 rt(j) = rintyg(j,i)
              end do
          else
              do j=1,4
                 it(j) = iat(j,i,jres)
              end do
              do j=1,3
                 rt(j) = rint(j,i,jres)
              end do
          endif

          ih = abs(it(4))
          itp(1) = ipdb(it(1))
          itp(2) = ipdb(it(2))
          itp(3) = ipdb(it(3))
          ihp = ihpdb(ih)

          if (jres.eq.4.and.i.eq.2) then
              if (ipdb(37).gt.0.and.ipdb(37).lt.mxnat) then
                 if (iconn(1,ipdb(37)).gt.1) ihp = 1
              endif
          endif
          if (jres.eq.3.and.i.eq.2) then
              if (ipdb(31).gt.0.and.ipdb(31).lt.mxnat) then
                 if (iconn(1,ipdb(31)).gt.1) ihp = 1
              endif
          endif
          if (jres.eq.10.and.i.ge.4) then
              if (ipdb(21).gt.0.and.ipdb(21).lt.mxnat) then
                 if ((iconn(1,ipdb(21)).gt.1.and.i.eq.4).or.
     &               (iconn(1,ipdb(21)).gt.2.and.i.eq.5)) then
                     if (i.eq.4) then
                        rt(2) = 120.0d0
                        rt(3) = 180.0d0
                     elseif (i.eq.5) then
                        ihp = 1
                     endif
                 endif
              endif
          endif
          if (jres.eq.12.and.i.ge.10) then
              n = 0
              if (ipdb(27).gt.0.and.ipdb(27).lt.mxnat.and.i.eq.10) then
                  if (iconn(1,ipdb(27)).eq.2) ihp = 1
              endif
              if (ipdb(27).gt.0.and.ipdb(27).lt.mxnat) then
                 n = iconn(1,ipdb(27)) - 1
              endif
              if (n.gt.2) ihp = 1
          endif
          if (jres.eq.17.and.i.eq.4) then
              if (ipdb(20).gt.0) then
                 if (iconn(1,ipdb(20)).gt.2) ihp = 1
              endif
          endif
          if (ihp.eq.0) then
              if (addat(itp(1),itp(2),
     &            itp(3),1,rt(1),rt(2),rt(3),ihpdb(ih),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                  iresid(ihpdb(ih)) = ires
                  ipdbt(ihpdb(ih)) = ih
                  if (it(4).lt.0) isurf(ihpdb(ih)) = 1
              endif
          endif
      end do

      if (jres.gt.23) then
c
c deal with DNA as well
c
         if (ipdb(53).eq.0) then
             if (addat(ipdb(50),ipdb(54),ipdb(52),1,
     &        1.090d0,109.8d0,120.0d0,ihpdb(71),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                 iresid(ihpdb(71)) = ires
                 ipdbt(ihpdb(71)) = 71
             endif
         endif

c HO3

         if (ipdb(51).ne.0) then
             n = icred(ipdb(51),inoh,ih,ianz,iconn)
             if (inoh.eq.1.and.ih.eq.0) then
                if (addat(ipdb(52),ipdb(50),ipdb(51),1,
     &           0.960d0,109.8d0,120.0d0,ihpdb(115),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                    iresid(ihpdb(115)) = ires
                    ipdbt(ihpdb(115)) = 115
                endif
             endif
         endif

         if (ipdb(43).eq.0.and.ipdb(46).ne.0) then
             if (.not.o5pcon(ipdb(46),ianz,iconn)) then
                if (addat(ipdb(48),ipdb(47),ipdb(46),1,
     &           0.960d0,109.8d0,120.0d0,ihpdb(118),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                    iresid(ihpdb(118)) = ires
                    ipdbt(ihpdb(118)) = 118
                    icalf(1,ires) = ihpdb(118)
                endif
             endif
         endif

      else

         if (nterm.eq.1) then
            n = icred(ipdb(1),inoh,ih,ianz,iconn)
            if (inoh.eq.1.and.ih.eq.1.and.ihpdb(1).ne.0) then
               if (addat(ihpdb(1),ipdb(2),ipdb(1),1,
     &          1.010d0,109.8d0,120.0d0,ihpdb(2),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                   iresid(ihpdb(2)) = ires
                   ipdbt(ihpdb(2)) = 2
               endif
               if (addat(ihpdb(1),ipdb(2),ipdb(1),1,
     &          1.010d0,109.8d0,-120.0d0,ihpdb(3),1,
     &            ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &            ncalf,icalf,coo)) then
                   iresid(ihpdb(3)) = ires
                   ipdbt(ihpdb(3)) = 3
               endif
            endif
         endif

      endif

      return
      end

      logical function addat(iat1,iat2,iat3,ian,bl,alpha,dih,iret,ichk,
     &                       ianz,iaton,iatclr,iconn,iresid,ityp,ipdbt,
     &                       ncalf,icalf,coo)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension v21(3),v32(3),c1(3),c2(3),c3(3),c4(3),ctmp(3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*),ityp(*),ipdbt(*),icalf(6,*)

c
c     Add atom given bondlength, bondangle and dihedral with
c     respect to three atoms
c
      iret = 0
      addat = .true.
      
      if (iat1.le.0.or.iat1.gt.mxnat) goto 100
      if (iat2.le.0.or.iat2.gt.mxnat) goto 100
      if (iat3.le.0.or.iat3.gt.mxnat) goto 100

      tol = 1.0d-10
      toang = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)
      sa = dsin(alpha/todeg)
      ca = dcos(alpha/todeg)
      sd = dsin(dih/todeg)
      cd = dcos(dih/todeg)

      do i=1,3
          v21(i) = coo(i,iat2) - coo(i,iat1)
          v32(i) = coo(i,iat3) - coo(i,iat2)
      end do
      call vsc1(v32,1.0d0,tol)

c     check for three atoms on a line

      call impsc(v21,v32,cosb)
      if (dabs(cosb).lt.tol) goto 100

      call crprod(v21,v32,c1)
      call vsc1(c1,1.0d0,tol)
      call crprod(c1,v32,c2)
      call vsc1(c2,1.0d0,tol)

      do i=1,3
          c3(i) = cd*c2(i) + sd*c1(i)
      end do
      
      do i=1,3
          c4(i) = -ca*v32(i) + sa*c3(i)
      end do

      call vsc1(c4,bl/toang,tol)

      if (iatoms.ge.mxnat) goto 100

      do i=1,3
         ctmp(i) = coo(i,iat3) + c4(i)
      end do

      iflg = 0
      do i=1,iatoms
          d2 = dist2(ctmp,coo(1,i))
          if (d2*toang*toang.lt.0.7d0) then
             iflg = 1
             d2t = d2
             i2t = i
          endif
      end do

      if (iflg.eq.1.and.ichk.eq.1) goto 100

      natoms = 0
      if (iresid(iat3).lt.-3) then
         do i=1,iatoms
            if (iresid(i).eq.iresid(iat3)) then
               natoms = i + 1
            endif
         end do
      endif

      if (natoms.eq.0) then
          natoms = iatoms + 1
      else


         do i=1,natoms-1
            do j=1,iconn(1,i)
               it = iconn(1+j,i)
               iat = iabs(it)
               if (it.ge.0) then
                  if (it.ge.natoms) then
                     iconn(1+j,i) = it + 1
                  endif
               else
                  if (iat.ge.natoms) then
                     iconn(1+j,i) = it - 1
                  else
                     iconn(1+j,i) = it
                  endif
               endif
            end do
         end do

         do i=iatoms,natoms,-1
            iconn(1,i+1) = iconn(1,i)
            do j=1,iconn(1,i)
               it = iconn(1+j,i)
               iat = iabs(it)
               if (it.ge.0) then
                  if (it.ge.natoms) then
                     iconn(1+j,i+1) = it + 1
                  else
                     iconn(1+j,i+1) = it
                  endif
               else
                  if (iat.ge.natoms) then
                     iconn(1+j,i+1) = it - 1
                  else
                     iconn(1+j,i+1) = it
                  endif
               endif
            end do

            ianz(i+1)    = ianz(i)
            iaton(i+1)   = iaton(i)
            iatclr(i+1)  = iatclr(i)
            iresid(i+1)  = iresid(i)
            ityp(i+1)    = ityp(i)
            ipdbt(i+1)   = ipdbt(i)

            do j=1,3
               coo(j,i+1) = coo(j,i)
            end do

         end do

         do i=1,ncalf
            if (icalf(1,i).ge.natoms) icalf(1,i) = icalf(1,i) + 1
            if (icalf(4,i).ge.natoms) icalf(4,i) = icalf(4,i) + 1
         end do

      endif

      iatoms = iatoms + 1
      iret = natoms

      do i=1,3
         coo(i,natoms) = coo(i,iat3) + c4(i)
      end do

      iconn(1,natoms) = 1
      iconn(2,natoms) = iat3
      ianz(natoms)    = ian
      iaton(natoms)   = 1
      iatclr(natoms)  = iatclr(iat3)
      iresid(natoms)  = iresid(iat3)
      ityp(natoms)    = 0
      ipdbt(natoms)   = 0

      if (iconn(1,iat3).lt.mxcon) then
         iconn(1,iat3) = iconn(1,iat3) + 1
         iconn(iconn(1,iat3)+1,iat3) = natoms
      endif

      return

100   addat = .false.
      return
      end

      subroutine vsc1(a,scale,tol)
      implicit double precision (a-h,o-z)
      dimension a(3)

      rlen = vlen(a)

      if (rlen.gt.tol) then
         do i=1,3
            a(i) = a(i)*scale/rlen
         end do
      endif

      return
      end

      subroutine impsc(a,b,c)
      implicit double precision (a-h,o-z)
      dimension a(3),b(3)

      rimp = 0.0d0
    
      do i=1,3
         rimp = rimp + a(i)*b(i)
      end do

      al = vlen(a)
      bl = vlen(b)

      if (al.gt.0.0d0.and.bl.gt.0.0d0) then
         c = rimp/(vlen(a)*vlen(b))
      else
         c = 0.0d0
      endif

      return
      end

      double precision function dist2(a,b)
c
c     determine distances between neighboring atoms
c
      implicit double precision (a-h,o-z)
      dimension a(3)
      dimension b(3)

      d1 = a(1)-b(1)
      d2 = a(2)-b(2)
      d3 = a(3)-b(3)

      dist2 = d1*d1 + d2*d2 + d3*d3

      return
      end

      logical function o5pcon(iat,ianz,iconn)
      parameter (mxcon=10)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      dimension ianz(*),iconn(mxcon+1,*)
   
      o5pcon = .false.

      do i=1,iconn(1,iat)
         ii = iconn(1+i,iat)
         if (ii.gt.0) then
            if (ianz(ii).eq.15) o5pcon = .true.
         endif
      end do
      
      return
      end

      subroutine hcoodd(istat,iaddh,
     &                  ipdbt,coo,ianz,iaton,iresid,iconn,
     &                  icalf,ncalf,ianf,islu,nchain,iamino)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      logical hashy
      dimension tmp(3),ipdbt(*)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      istat = 1

c     nhbond in A.U. Atomic Units

      if (iatoms+ncalf.le.mxnat.and.ncalf.gt.0) then

         nhatm = iatoms

         do k=1,nchain
c
c           first residue
c
	  ianfk = ianf(k)
          if (icalf(2,ianf(k)).eq.0) ianfk = ianfk+1

          if (iamino(ianfk).le.23.and.ianfk.ge.0.and.
     &        ianfk.gt.0) then

            hashy = .false.
            if (iaddh.eq.1) hashy = .true.

            do n=1,iconn(1,icalf(2,ianfk))
               nn = abs(iconn(n+1,icalf(2,ianfk)))
               if (ianz(nn).eq.1) then
                  hashy = .true.
                  icalf(4,ianf(k)) = nn
                  iaton(nn) = 0
                  iresid(nn) = ianf(k)
               endif
            end do

            if (.not.hashy.and.iamino(ianfk).ne.15.and.
     &         iamino(ianfk).ne.0) then
               call bckok(ibckok,ianfk,2)
               if (ibckok.eq.1) then
                  icor = 0
                  do j=1,iconn(1,icalf(2,ianfk))
                     jc = iconn(1+j,icalf(2,ianfk))
                     jc = iabs(jc)
                     if (iresid(jc).lt.-3) then
                        if (ianz(jc).eq.6) then
                           do jj=1,iconn(1,jc)
                              jo = iconn(1+jj,jc)
                              jo = iabs(jo)
                              if (ianz(jo).eq.8) then
                                icor = jo
                              endif
                           end do
                        endif
                     endif
                  end do
                  nhatm = nhatm + 1
                  icalf(4,ianfk) = nhatm

                  if (icor.ne.0) then
                     do j=1,3
                        tmp(j) = 2.0d0*coo(j,icalf(2,ianf(k))) 
     &                         - coo(j,icalf(1,ianf(k)))
     &                         - coo(j,icor)
                     end do

                     tmpl = vlen(tmp)

                     do j=1,3
                        coo(j,nhatm) = coo(j,icalf(2,ianf(k))) 
     &                                 +(tmp(j)/tmpl)*1.89d0
                     end do
                  else

                     do j=1,3
                        tmp(j) = coo(j,icalf(1,ianf(k))) 
     &                         - coo(j,icalf(3,ianf(k)))
                     end do

                     tmpl = vlen(tmp)

                     if (icalf(2,ianf(k)).gt.0) then
                        do j=1,3
                           coo(j,nhatm) = coo(j,icalf(2,ianf(k))) 
     &                                    +(tmp(j)/tmpl)*1.89d0
                        end do
                     endif

                  endif

                  iaton(nhatm) = 0
                  ianz(nhatm) = 1
                  iconn(1,nhatm) = 1

                  m = icalf(2,ianf(k))
                  if (m.ne.-1) then
                     iconn(2,nhatm) = m
                     iconn(1,m) = iconn(1,m) + 1
                     iconn(1+iconn(1,m),m) = nhatm
                  endif

                  iresid(nhatm) = ianf(k)
                  ipdbt(nhatm) = 1
               endif
            endif
            ihb(1,ianfk) = 0
            ihb(2,ianfk) = 0
           endif
c
c           other residues
c
           if (ianfk.ge.0) then

            do i=ianfk+1,islu(k)
             if (iamino(i).le.23) then
               icalf(4,i) = 0
               hashy = .false.
               do n=1,iconn(1,icalf(2,i))
                  nn = abs(iconn(n+1,icalf(2,i)))
                  if (ianz(nn).eq.1) then
                     hashy = .true.
                     icalf(4,i) = nn
                     iaton(nn) = 0
                     iresid(nn) = i
                  endif
               end do

               if (.not.hashy.and.iamino(i).ne.15) then

                  m = icalf(2,i)
                  idxc = icalf(3,i-1)
                  idxo = 0

                  do j=1,iconn(1,idxc)
                     kk = abs(iconn(j+1,idxc))
                     if (ianz(kk).eq.8) idxo = kk
                  end do

                  call bckok(ibckok,i,2)

                  if (idxo.ne.0.and.ibckok.eq.1) then

                     nhatm = nhatm + 1
                     icalf(4,i) = nhatm

                     do j=1,3
                        tmp(j) = coo(j,idxc) - coo(j,idxo)
                     end do

                     tmpl = vlen(tmp)

                     do j=1,3
                        coo(j,nhatm) = coo(j,m) +
     &                             (tmp(j) / tmpl)*1.89d0
                     end do

                     iaton(nhatm) = 0
                     ianz(nhatm) = 1
                     iconn(1,nhatm) = 1
                     iconn(2,nhatm) = m
                     iconn(1,m) = iconn(1,m) + 1
                     iconn(1+iconn(1,m),m) = nhatm
                     iresid(nhatm) = i
                     ipdbt(nhatm) = 1
                  else
                     icalf(4,i) = 0
                  endif

               endif

               ihb(1,i) = 0
               ihb(2,i) = 0
              endif
            end do
           endif
         end do
         iatoms = nhatm
      else

         istat = 0
         do i=1,ncalf
            if (iamino(i).le.23) icalf(4,i) = 0
         end do

      endif

      return
      end

      subroutine bckod(ibckok,ires,iop,
     &                  ianz,iresid,ipdbt,iamino)
      implicit double precision (a-h,o-z)

      parameter (mxsym=103)
      common /athlp/ iatoms, mxnat
      dimension ipdb(mxsym)
      dimension ianz(*),iresid(*),ipdbt(*),iamino(*)

c checks if Calpha is present (iop=1)

      ibckok = 0

      do i=1,mxsym
          ipdb(i) = 0
      end do

      do i=1,iatoms
          if (iresid(i).eq.ires) then
              if (ipdbt(i).ne.0) then
                  if (ianz(i).ne.1) then
                     ipdb(ipdbt(i)) = i
                  endif
              endif
          endif
      end do

c has Calpha
      if (iamino(ires).gt.23) then
         if (iop.eq.1.and.(ipdb(43).ne.0.or.ipdb(46).ne.0)) 
     &       ibckok = 1
      else
         if (iop.eq.1.and.ipdb(2).ne.0) ibckok = 1
         if (iop.eq.2.and.
     &      (ipdb(1).ne.0.and.ipdb(2).ne.0.and.ipdb(3).ne.0)
     &      ) ibckok = 1
      endif

      return
      end

      logical function chkpdb(ipdb,jres,icres,irsnr,isal)
      implicit double precision (a-h,o-z)
      parameter (mxres=42)
      parameter (mxares=20)
      parameter (mxaat=13)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxamo=201)
      character*3 aminos
      common /amino/aminos(mxres)
      integer resn,resat
      common /resa/ resat(mxares,mxaat),resn(mxares)
      character*3 pdbsym,hsym,chtnk,ambtnk
      character*2 amotnk,gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),
     &                ambtnk(mxamb),gffstr(mxgff)
      parameter (mxinrs=100)
      common /incmpl/ incomp(mxinrs),nincmp
      dimension ipdb(*),irsnr(*)

      data resn/4,4,6,6,7,8,7,8,8,8,8,9,9,9,8,11,10,11,12,13/
c glycine
      data (resat(1,i),i=1,mxaat)/
     &          1,2,3,4,0,0,0,0,0,0,0,0,0/
c alanine
      data (resat(2,i),i=1,mxaat)/
     &          1,2,3,4,0,0,0,0,0,0,0,0,0/
c serine
      data (resat(3,i),i=1,mxaat)/
     &          1,2,3,4,5,31,0,0,0,0,0,0,0/
c cysteine
      data (resat(4,i),i=1,mxaat)/
     &          1,2,3,4,5,37,0,0,0,0,0,0,0/
c threonine
      data (resat(5,i),i=1,mxaat)/
     &          1,2,3,4,5,32,8,0,0,0,0,0,0/
c isoleucine
      data (resat(6,i),i=1,mxaat)/
     &          1,2,3,4,5,7,8,10,0,0,0,0,0/
c valine
      data (resat(7,i),i=1,mxaat)/
     &          1,2,3,4,5,7,8,0,0,0,0,0,0/
c methionine
      data (resat(8,i),i=1,mxaat)/
     &          1,2,3,4,5,6,36,12,0,0,0,0,0/
c aspartic acid
      data (resat(9,i),i=1,mxaat)/
     &          1,2,3,4,5,6,29,30,0,0,0,0,0/
c asparagine
      data (resat(10,i),i=1,mxaat)/
     &          1,2,3,4,5,6,29,21,0,0,0,0,0/
c leucine
      data (resat(11,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,0,0,0,0,0/
c lysine
      data (resat(12,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,12,27,0,0,0,0/
c glutamic acid
      data (resat(13,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,34,35,0,0,0,0/
c glutamine
      data (resat(14,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,24,34,0,0,0,0/
c proline 28 ?
      data (resat(15,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,1,0,0,0,0,0/
c arginine
      data (resat(16,i),i=1,mxaat)/
     &          1,2,3,4,5,6,9,17,22,25,26,0,0/
c histidine 
      data (resat(17,i),i=1,mxaat)/
     &          1,2,3,4,5,6,11,13,20,24,0,0,0/
c phenylalanine
      data (resat(18,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,13,14,17,0,0/
c tyrosine
      data (resat(19,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,13,14,17,33,0/
c tryptophan
      data (resat(20,i),i=1,mxaat)/
     &          1,2,3,4,5,6,10,11,14,15,16,18,23/

      iresa = -1
      if (jres.le.20) then
         do i=1,resn(jres)
            if (ipdb(2).le.0) isal = 4
            if (ipdb(resat(jres,i)).le.0) then
               chkpdb = .false.
               print*,'incomplete residue ',irsnr(icres),' ',
     &                 aminos(jres),' ',pdbsym(resat(jres,i))
               nincmp = nincmp + 1
               incomp(nincmp) = icres
               return
            endif
         end do
      endif

      chkpdb = .true.
      return
      end
          
      logical function chkhs(ihpdb)
      implicit double precision (a-h,o-z)
      parameter (mxhsym=64)
      dimension ihpdb(*)

      chkhs = .false.
      do i=2,mxhsym*3
         if (ihpdb(i).ne.0) chkhs = .true.
      end do

      return
      end

      subroutine typeid(ipdb,jres,ihpdb,ihashy,
     &                  ianz,iconn,ityp)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxrss=20)
      parameter (mxatt=10)
      parameter (mxath=8)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      logical nterm
      common /types/ iff
      common /chmtyp/ ncc(mxrss),icc(2,mxatt,mxrss),
     &                nhh(mxrss),ihh(2,mxath,mxrss)
      dimension ipdb(*), ihpdb(*),ianz(*),iconn(mxcon+1,*),ityp(*)

      iff = 2

c     currently only works for aminoacids, not nucleic acids 
c     (mxrss=20)

c     Backbone, no N-Term, C-Term yet
c               (Pro,Gly N-Term) CYS, sulfur bridged

      do i=1,mxsym
         call settyp(ityp,ipdb(i),0)
      end do
      do i=1,mxhsym*3
         call settyp(ityp,ihpdb(i),0)
      end do

      if (jres.le.0.or.jres.gt.mxrss) return

      if (jres.eq.17) then
c ihis
c 
c  1  HIS+ (HIP)
c  2  HISD (HID)
c  3  HISE (HIE)
c
         ihis = 1
         if (ihashy.eq.1) then
            if (ihpdb(34).eq.0) ihis = 2
            if (ihpdb(22).eq.0) ihis = 3
         endif
      endif

      call settyp(ityp,ipdb(1),63)
      call settyp(ityp,ipdb(2),23)
      call settyp(ityp,ipdb(3),20)
      call settyp(ityp,ipdb(4),74)

      if (ipdb(38).ne.0) then
          ityp(ipdb(38)) = 79
          call settyp(ityp,ipdb(4),79)
          call settyp(ityp,ipdb(3),22)
      endif

      do i=1,ncc(jres)
         call settyp(ityp,ipdb(icc(1,i,jres)),icc(2,i,jres))
      end do

      if (jres.eq.4) then
         do i=1,iconn(1,ipdb(37))
            if (ianz(abs(iconn(1+i,ipdb(37)))).eq.16) 
     &          call settyp(ityp,ipdb(37),82)
         end do
      endif

      if (jres.eq.17) then
         if (ihis.eq.2) then
             call settyp(ityp,ipdb(6),43)
             call settyp(ityp,ipdb(11),44)
             call settyp(ityp,ipdb(13),46)
             call settyp(ityp,ipdb(20),69)
             call settyp(ityp,ipdb(24),68)
         endif
         if (ihis.eq.3) then
             call settyp(ityp,ipdb(6),44)
             call settyp(ityp,ipdb(11),43)
             call settyp(ityp,ipdb(13),46)
             call settyp(ityp,ipdb(20),68)
             call settyp(ityp,ipdb(24),69)
         endif
      endif
      
      if (ihashy.eq.1) then

         n = 0
         do i=1,3
            if (ihpdb(i).ne.0) n = n + 1
         end do
         nterm = .false.
         if (n.eq.3.or.(jres.eq.15.and.n.eq.2)) nterm = .true.

         if (nterm) then
c H
            nt = 6
            if (jres.eq.15) nt = 7
            do i=1,n
               call settyp(ityp,ihpdb(i),nt)
            end do

c N
            nt = 65
            if (jres.eq.15.and.n.eq.2) nt = 67
            call settyp(ityp,ipdb(1),nt)

c CA
            nt = 23
            if (jres.eq.1) nt = 29
            if (jres.eq.15) nt = 33
            call settyp(ityp,ipdb(2),nt)

c CD
            if (jres.eq.15) call settyp(ityp,ipdb(9),34)

         else
            call settyp(ityp,ihpdb(1),3)
         endif
c HA
         nt = 4
         if (nterm.and.jres.ne.1) nt = 5
         call settyp(ityp,ihpdb(4),nt)
         call settyp(ityp,ihpdb(5),nt)

c HB, HG
         do i=1,3
            call settyp(ityp,ihpdb(6+i),1)
            call settyp(ityp,ihpdb(9+i),1)
         end do

         do i=1,nhh(jres)
            call settyp(ityp,ihpdb(ihh(1,i,jres)),ihh(2,i,jres))
         end do

c check for lysine alternative HZ1,HZ2,HZ3 instead of 1HZ,2HZ,3HZ

         if (jres.eq.12) then
            call settyp(ityp,ihpdb(43),6)
            call settyp(ityp,ihpdb(46),6)
            call settyp(ityp,ihpdb(49),6)
         endif

         if (jres.eq.17) then
            if (ihis.eq.2) then
                call settyp(ityp,ihpdb(22),11)
                call settyp(ityp,ihpdb(25),14)
                call settyp(ityp,ihpdb(31),12)
            endif
            if (ihis.eq.3) then
                call settyp(ityp,ihpdb(25),15)
                call settyp(ityp,ihpdb(31),12)
                call settyp(ityp,ihpdb(34),11)
            endif
         endif
      endif

      return
      end

      character*2 function gstr(i)
      character*1 sl,sh
      integer i,il,ih

      gstr = '**'
      if ( i .gt. 99 .or. i.lt.0) return

      ih = i / 10
      sh = char(ih+48)
      if (ih.eq.0) sh = char(32)
      il = i - ih*10
      sl = char(il+48)
      
      gstr = sh//sl

      return
      end      

      character*2 function ggstr(i)
      character*1 sl,sh
      integer i,il,ih

      ggstr = '**'
      if ( i .gt. 99 .or. i.lt.0) return

      ih = i / 10
      sh = char(ih+48)
      if (ih.eq.0) sh = char(48)
      il = i - ih*10
      sl = char(il+48)
      
      ggstr = sh//sl

      return
      end      

      character*2 function agstr(i,upp)
      character*1 sl,sh
      integer i,il,ih
      logical upp

      agstr = '**'
      if (i.gt.26*26.or.i.lt.0) return

      ioff = 97
      if (upp) ioff = 65
      ih = i / 26
      sh = char(ih+ioff)
      il = i - ih*26
      sl = char(il+ioff)
      
      agstr = sh//sl

      return
      end      

      character*5 function hstr(i)
      character*1 sl,sh,shh
      integer i,il,ih,ihh

      hstr = '(***)'
      if ( i .gt. 999 .or. i.lt.0) return


      ihh = i / 100
      shh = char(ihh+48)

      ih = (i - ihh*100) / 10 
      sh = char(ih+48)

      il = i - ihh*100 - ih*10
      sl = char(il+48)

      if (ihh.eq.0.and.ih.eq.0) then
          hstr = '('//sl//')  '
      elseif (ihh.eq.0) then
          hstr = '('//sh//sl//') '
      else
          hstr = '('//shh//sh//sl//')'
      endif

      return
      end      

      subroutine zerstr(inum,str,isiz,iopt)
      integer inum,i,j,isiz,iwrk,ibig,icnt
      character*(*) str

      do i=1,isiz
         str(i:i) = char(48)
      end do

      iwrk = inum
      do i=isiz,1,-1
         ibig = 10**(i-1)
         if (ibig.le.iwrk) then
            icnt = iwrk/ibig
            j = isiz-i+1
            str(j:j) = char(48+icnt)
            iwrk = iwrk - icnt*ibig
         endif
      end do
      
      if (iopt.eq.1) then
         i = 1
         do while (str(i:i).eq.char(48) )
            str(i:i) = char(32)
            i = i + 1
         end do
      endif

      return
      end      

      subroutine zzrstr(inum,str,isiz,isout)
      integer inum,i,j,isiz,iwrk,ibig,icnt,isout
      character*(*) str

      do i=1,isiz
         str(i:i) = char(48)
      end do
      str(1:1) = '('

      istrt = 0
      iwrk = inum
      j = 1
      do i=isiz,1,-1
         ibig = 10**(i-1)
         if (ibig.le.iwrk.or.istrt.eq.1) then
            istrt = 1
            j = j + 1
            icnt = iwrk/ibig
            str(j:j) = char(48+icnt)
            iwrk = iwrk - icnt*ibig
         endif
      end do
      j = j + 1
      str(j:j) = ')'
      isout = j
      
      return
      end      

      subroutine getfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr,str
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*5 frsym
      common /frstr/ frsym(maxfrq)
      integer getlin
      logical g94,dosym
      dimension coo(3,*)

      istat = 1

      g94 = .false.
      dosym = .true.
      ihasi = 2
      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0

      call rewfil

      call iatnox(natoms)

      do i=1,natoms
         do j=1,3
             fcoo(j,i) = coo(j,i)
         end do
      end do

c     Read in Gaussian Frequencies

      nvibs = 3*natoms - 6
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1

13    call search(lstr,'Frequencies --',istat)
      if (istat.eq.0) goto 100
      if (ivibs.gt.nvibs) goto 100
      g94 = (index(lstr,'Frequencies --').eq.2)

      if (dosym) then
         call bckfil
         call bckfil
         idum = getlin(0)
         if (g94) then
            nv = 3
         else
            nv = 5
         endif
         do i=1,nv
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               ns = nstr
               if (ns.gt.3) ns = 3
               frsym(ivibs+i) = '   '
               frsym(ivibs+i) = str(1:ns)
            else
            endif
         end do
         call redel(lstr,1)
      endif

      if (g94) then
         indfr = index(lstr,'Frequencies --')
         lstr = lstr(indfr+14:)
         read(lstr,'(3(f10.4,13x))',err=100,end=100) 
     &          (freq(i),i=ivibs+1,ivibs+3)
         call redel(lstr,3)
         lstr = lstr(indfr+14:)
         read(lstr,'(3(f10.4,13x))',err=100,end=100) 
     &          (frint(i),i=ivibs+1,ivibs+3)
         call redel(lstr,1)
         if (index(lstr,'Raman').eq.0) then
            ihasi = 1
         else
            lstr = lstr(indfr+14:)
            read(lstr,'(3(f10.4,13x))',err=100,end=100) 
     &          (ramint(i),i=ivibs+1,ivibs+3)
         endif
         ivibs = ivibs + 3
      else
         indfr = index(lstr,'Frequencies --')
         lstr = lstr(indfr+16:)
         read(lstr,'(5f10.4)',err=100,end=100) 
     &          (freq(i),i=ivibs+1,ivibs+5)
         call redel(lstr,3)
         lstr = lstr(indfr+16:)
         read(lstr,'(5f10.4)',err=100,end=100) 
     &          (frint(i),i=ivibs+1,ivibs+5)
         call redel(lstr,1)
         if (index(lstr,'Raman').eq.0) then
            ihasi = 1
         else
            lstr = lstr(indfr+16:)
            read(lstr,'(5f10.4)',err=100,end=100) 
     &          (ramint(i),i=ivibs+1,ivibs+5)
         endif
         ivibs = ivibs + 5
      endif
      goto 13

100   if (ivibs.eq.0) istat = 0
200   if (freq(ivibs).eq.0.0d0.and.ivibs.ne.0) then
         ivibs = ivibs - 1
         goto 200
      endif
      nfreq = ivibs
      ihasi = 2
      
      if (dosym) then
         ihasi = -ihasi
         do i=1,ivibs
            call parsfn(frsym(i),3,12)
         end do
      endif

      return
      end 

      subroutine ncoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr
c      character*2 gstr
      character*5 tstr
      real freqt
      dimension freqt(5),frtt(3,3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      logical g94,g09

c     Get ifreq 'th Norm. Cordinates from Gaussian Output

      istat = 1
      ifroz = 0
      g94 = .false.
      g09 = .false.

      call rewfil
      ilegnd = 3
      call iatnox(iatoms)
      nvibs = nfreq

      call search(lstr,'atoms frozen in the vibrational analysis',istat)
      if (istat.ne.0) then
         read(lstr,'(i5)') nfroz
         ifroz = 1
      else
         call rewfil
      endif

      call search(lstr,'Frequencies -- ',istat)
      if (istat.eq.0) goto 100
      g94 = (index(lstr,'Frequencies --').eq.2)

c Find out length of legend

      if (g94) then
         do i=1,8
             call nxtlin(lstr,jstat)
             if (jstat.eq.1.or.jstat.eq.2) goto 100

             g09 = (index(lstr,'Atom  AN      X').eq.3)
             if (index(lstr,'Atom AN      X').ne.0.or.
     &           index(lstr,'Atom  AN      X').ne.0) goto 15
             ilegnd = ilegnd + 1
         end do
15       continue
      else
          ilegnd = 8
      endif

      jatoms = iatoms
      if (ifroz.eq.1.and.g09) jatoms = iatoms - nfroz
      
      call scback(lstr,'and normal coordinates:',istat)
      call redel(lstr,1)
      if (istat.eq.0) goto 100
      if (g94) then
         ioff = ifreq - ((ifreq-1)/3)*3
      else
         ioff = ifreq - ((ifreq-1)/5)*5
      endif


      ivibs = 0
10    call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100

      if (ivibs.ge.nvibs) goto 20
      if (index(lstr,'and normal coordinates:').ne.0) goto 20
      tstr = '     '
      write(tstr,'(1a,i3,1a)') ' ',ifreq,' '
c      tstr = ' '//gstr(ifreq)//' '

      if (index(lstr,tstr).ne.0) then
         call redel(lstr,ilegnd)
         if (g94) then
            do i=1,jatoms
               if (g09) then
c                  read(iun2,'(10x,3(2x,3f7.2))',err=100,end=100) 
c     &             ((frtt(j,k),j=1,3),k=1,3)
                  call nxtlin(lstr,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 100
                  read(lstr,'(i6,4x,3(2x,3f7.2))',err=100,end=100) 
     &             iattmp,((frtt(j,k),j=1,3),k=1,3)
                  do j=1,3
                      a(j,iattmp) = frtt(j,ioff)
                  end do
               else
                  call nxtlin(lstr,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 100
                  read(lstr,'(8x,3(2x,3f7.2))',err=100,end=100) 
     &             ((frtt(j,k),j=1,3),k=1,3)
                  do j=1,3
                      a(j,i) = frtt(j,ioff)
                  end do
               endif
            end do
         else
            do i=1,iatoms
               do j=1,3
                   call nxtlin(lstr,jstat)
                   if (jstat.eq.1.or.jstat.eq.2) goto 100
                   read(lstr,'(23x,5f10.5)',err=100,end=100) 
     &                  (freqt(k),k=1,5)
                   a(j,i) = freqt(ioff)
               end do
            end do
         endif
      else
         if (g94) then
            call redel(lstr,jatoms+ilegnd)
         else
            call redel(lstr,iatoms*3+ilegnd)
         endif
      endif
      if (g94) then
         ivibs = ivibs + 3
      else
         ivibs = ivibs + 5
      endif
      goto 10

20    if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine ggetfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      dimension coo(3,*)

cd     write(iun3,'(a)')'enter subroutine ggetfr'
      istat = 1

      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0
      call rewfil

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in Gamess Frequencies

      nvibs = 3*natoms - 6
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1
      call search(line,'cartesians to normal mode',istat)
      if (istat.eq.0) goto 10

c...  This is a Hessian run
      call redel(line,6)
50    call redel(line,1)
      if (ivibs.lt.nvibs+6) then
         read(line,'(15x,8f11.2)',end=100,err=100)
     &        (freq(i),i=ivibs+1,ivibs+8)
         ivibs = ivibs + 8
         call redel(line,3*iatoms+7)
         goto 50
      endif
      n = ivibs
      ivibs = 0
      do i=1,n
         if (freq(i).ne.0.0d0) then
            ivibs=ivibs+1
            freq(ivibs)=freq(i)
         endif
      enddo
      goto 200

10    continue
c...  This is a Force run
      call search(line,'frequencies ----',istat)
      if (istat.eq.0) goto 100
      if (ivibs.gt.nvibs) goto 100
      line = line(index(line,'frequencies ----')+22:)
      read(line,'(9f10.4)',err=100,end=100) 
     &     (freq(i),i=ivibs+1,ivibs+9)
      ivibs = ivibs + 9
      goto 10

100   if (ivibs.eq.0) istat = 0
200   if (freq(ivibs).eq.0.0d0.and.ivibs.ne.0) then
         ivibs = ivibs - 1
         goto 200
      endif
      nfreq = ivibs
      ihasi = 0
cd     write(iun3,'(a)')'leave subroutine ggetfr'
      return
      end 

      subroutine ncoorg(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr
      character*2 gstr
      character*4 tstr
      real freqt
      dimension freqt(9)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi

c     Get ifreq 'th Norm. Cordinates from Gamess Output
cd     write(iun3,'(a)')'enter subroutine ncoorg'

      istat = 1

      call rewfil
      call iatnox(iatoms)
      nvibs = nfreq

      call search(lstr,'cartesians to normal mode',istat)
      if (istat.eq.0) goto 30
c
c...  This is a Hessian run
c
      if (freq(ifreq).lt.0.0d0) then
         ifreq1 = ifreq
      else
         ifreq1 = ifreq+6
      endif
      ioff = ifreq1 - ((ifreq1-1)/8)*8
      ivibs = 0
      tstr = ' '//gstr(ifreq1)//' '
      call redel(lstr,3)
40    call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100

      if (ivibs.lt.nvibs+6) then
         if (index(lstr,tstr).ne.0) then
            call redel(lstr,5)
            do i=1,iatoms
               do j=1,3
                  call nxtlin(lstr,jstat)
                  if (jstat.eq.1.or.jstat.eq.2) goto 100

                  read(lstr,'(15x,8f11.6)',err=100)
     &                 (freqt(k),k=1,8)
                  a(j,i) = freqt(ioff)
               end do
            end do
            call redel(lstr,2)
         else
            call redel(lstr,iatoms*3+7)
         endif
         ivibs = ivibs+8
         goto 40
      endif
      goto 20

30    continue
c
c...  This is a Force run
c
      ioff = ifreq - ((ifreq-1)/9)*9
      call search(lstr,'and normalised normal coordinates',istat)
      if (istat.eq.0) goto 100
      call redel(lstr,3)

      ivibs = 0
10    call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100

      if (ivibs.gt.nvibs) goto 20
      if (index(lstr,'===========================').ne.0) goto 20
      tstr = ' '//gstr(ifreq)//' '

      if (index(lstr,tstr).ne.0) then
          call redel(lstr,7)
          do i=1,iatoms
             do j=1,3
                 call nxtlin(lstr,jstat)
                 if (jstat.eq.1.or.jstat.eq.2) goto 100

                 read(lstr,'(23x,9f10.5)',err=100,end=100) 
     &                (freqt(k),k=1,9)
                 a(j,i) = freqt(ioff)
             end do
          end do
          call redel(lstr,2)
      else
          call redel(lstr,iatoms*3+9)
      endif
      ivibs = ivibs + 9
      goto 10

20    if (idebug.eq.1) call prtfr(ifreq)
cd     write(iun3,'(a)')'leave subroutine ncoorg'
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
cd     write(iun3,'(a)')'leave subroutine ncoorg'
      return
      end

      subroutine getfrd(istat,coo,ianz)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr, str
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      common /frmop/ imop6
      character*5 frsym
      common /frstr/ frsym(maxfrq)
      integer getlin
      logical dosym
      character*2 iel,catomt,catom,tolowf
      dimension iel(100),xyz(3)
      dimension coo(3,*),ianz(*)
      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x '/

      istat = 1

      imop6 = 0
      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0
      ihasi = 0
      toau = 0.52917706d0
      dosym = .true.

      call rewfil

      call search(lstr,'ORIENTATION OF MOLECULE IN FORCE',istat)
      if (istat.eq.0) goto 1000

      icoord = 0
      iatoms = 0
      do while (getlin(0).eq.1)
         if (nxtwrd(str,nstr,itype,rtype).ne.2) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1.and.(nstr.eq.1.or.nstr.eq.2)) then
             if (nstr.eq.1) then
                 catomt(1:1) = str(1:1)
                 catomt(2:2) = ' '
             else
                 catomt = str(1:2)
             endif
             catom = tolowf(catomt)
         else
             if (ktype.eq.2) then
                 imop6 = 1
                 ianzt = itype
             else
                 goto 100
             endif
         endif
         do j=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
                xyz(j) = rtype
            else
                goto 100
            endif
         end do
         if (icoord.eq.0) icoord = 1
         iatoms = iatoms + 1
         if (imop6.eq.1) then
            ianz(iatoms) = ianzt
         else
            do i=1,100
               if ( catom .eq. iel(i) ) ianz(iatoms) = i - 1
            end do
         endif
         do j=1,3
            coo(j,iatoms) = xyz(j) / toau
         end do
         goto 150
100      if (icoord.eq.1) goto 200
150      continue
      end do

200   continue


      do i=1,iatoms
         do j=1,3
             fcoo(j,i) = coo(j,i)
         end do
      end do


c     Read in Mopac Frequencies

      nvibs = 3*iatoms - 6
      if (iatoms.eq.1) nvibs = 0
      if (iatoms.eq.2) nvibs = 1

c      call search(lstr,'NORMAL COORDINATE ANALYSIS',istat)
      call search(lstr,'MASS-WEIGHTED COORDINATE ANALYSIS',istat)
13    call search(lstr,'Root No.',istat)
      if (istat.eq.0) goto 1000
         if (ivibs.eq.nvibs) goto 1000
         if (imop6.eq.1) then
            call redel(lstr,1)
         else
            if (dosym) then
               call redel(lstr,2)
               read(lstr,'(12x,10(4x,a4))',err=1000,end=1000)
     &               (frsym(ivibs+i),i=1,8)
               call redel(lstr,1)
            else
               call redel(lstr,3)
            endif
         endif
         idum = getlin(0)
         do while (nxtwrd(str,nstr,itype,rtype).eq.3) 
            ivibs = ivibs + 1
            freq(ivibs) = rtype
         end do
      goto 13

1000  if (ivibs.eq.0) istat = 0
      nfreq = ivibs

c find transition dipole moments (T-DIPOLE)

      call rewfil
      do i=1,nfreq
         frint(i) = -1.0d0
      end do
      call search(lstr,'DESCRIPTION OF VIBRATIONS',istat)
      if (istat.eq.1) then
         do i=1,nfreq
            do while (getlin(0).eq.1)
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1.and.nstr.eq.9) then
                  if (str.eq.'VIBRATION') then
                     ktype = nxtwrd(str,nstr,itype,rtype)
                     if (ktype.eq.2) then
                        ivib = itype
                        call redel(lstr,1)
                        idum = getlin(0)
                        if (idum.eq.1) then
                           ktype = nxtwrd(str,nstr,itype,rtype)
                           if (ktype.eq.1.and.nstr.eq.8) then
                              if (str.eq.'T-DIPOLE') then
                                 ktype = nxtwrd(str,nstr,itype,rtype)
                                 if (ktype.eq.3) then
                                  if (ivib.gt.0.and.ivib.le.maxfrq) then
                                    frint(ivib) = rtype
                                  endif
                                 else
                                    goto 3000
                                 endif
                              else
                                 goto 3000
                              endif
                           else
                              goto 3000
                           endif
                        else
                           goto 3000
                        endif
                     endif
                     goto 2000
                  else
                     goto 3000
                  endif
               endif
            end do

c found frequency T-DIPOLE

2000        continue
         end do
      else
         goto 3000
      endif
      ihasi = 1


      if (dosym) then
         ihasi = -ihasi
         do i=1,ivibs
            call parsfn(frsym(i),3,12)
         end do
      endif

      return

3000  ihasi = 0
      ihasi = 1
      return
      end 

      subroutine mcoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr,line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frmop/ imop6
      common /curlin/ line
      integer getlin

c     Get ifreq 'th Norm. Cordinates from Mopac Output

      istat = 1

      call rewfil
      toau = 0.52917706d0
      if (imop6.eq.1) then
          nvlin = 6
      else
          nvlin = 8
      endif
      call iatnox(iatoms)
      nvibs = nfreq
      ioff = ifreq - ((ifreq-1)/nvlin)*nvlin
c      call search(lstr,'NORMAL COORDINATE ANALYSIS',istat)
c
c      if you choose for the above the algorithm still comes up
c      with the MASS-WEIGHTED set, have to look at this some time
c
      call search(lstr,'MASS-WEIGHTED COORDINATE ANALYSIS',istat)
      if (istat.eq.0) goto 100

      ivibs = 0
10    call search(lstr,'Root No.',istat)
      if (istat.eq.0.or.ivibs.ge.nvibs) goto 20
      call bckfil
      n = getlin(0)
      do while (.true.)
         n = nxtwrd(lstr,nstr,itype,rtype)
         if (n.eq.0) then
            goto 10
         elseif (n.eq.2.and.itype.eq.ifreq) then
            goto 15
         endif
      end do
15    continue
      if (imop6.eq.1) then
         call redel(lstr,3)
      else
         call redel(lstr,5)
      endif

      do i=1,iatoms
         do j=1,3
             idum = getlin(0)
             if (imop6.eq.1.and.line(1:1).eq.'1') idum = getlin(0)
             do n=1,ioff+1
                ktype = nxtwrd(lstr,nstr,itype,rtype)
             end do
             if (ktype.eq.3) then
                a(j,i) = rtype / toau
             endif
         end do
      end do
      ivibs = ivibs + nvlin
      goto 10

20    if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine getfrad(istat,ianz)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      parameter (mxel=100)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*2 elemnt
      common /elem/elemnt(mxel)
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      character*2 tocapf
      dimension r(3)
      dimension ianz(*)


      istat =  1

      ivibs = 0
      idirct = 1
      nframe = 5
      iframe = 0

      call rewmf

      call srchmf(line,'[FREQ]',istats)
      if (istats.eq.0) goto 100
 
      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.3) then
             ivibs = ivibs + 1
             freq(ivibs) = rtype
          elseif (ktype.eq.1) then
             if (str(1:1).eq.'[') goto 10
          endif

      end do

10    nfreq = ivibs

      call rewmf
      call srchmf(line,'[FR-COORD]',istats)
      if (istats.eq.0) goto 100

      iat = 0
      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)

          if (ktype.eq.1) then
              if (str(1:1).eq.'[') goto 20
              if (nstr.eq.1) then
                  str(2:2) = str(1:1)
                  str(1:1) = ' '
                  nstr = 2
              endif

              ifound = 0
              if (nstr.eq.2) then
                 do i=1,mxel
                    if (tocapf(str(1:2)).eq.tocapf(elemnt(i))) 
     &                  ifound = i
                 end do
                 if (ifound.ne.0) then
                    iat = iat + 1
                    ianz(iat) = ifound
                    if (gnreal(r,3,.false.)) then
                       do i=1,3
                          fcoo(i,iat) = r(i)
                       end do
                    endif
                 endif
              endif

          endif

      end do

20    iatoms = iat

      call resfr

      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine getint(istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*137 line,str
      common /curlin/ line
      integer getlin

      istat =  1

      i = 0
      ihsv = 0
      ihsram = 0
      ihasi = 0

      call rewmf

      call srchmf(line,'[INT]',istats)
      if (istats.eq.0) then
          istat = 0
          return
      endif
 
      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.3) then
             i = i + 1
             frint(i) = rtype
             ihsv = 1
          elseif (ktype.eq.1) then
             if (str(1:1).eq.'[') goto 10
          endif

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.3) then
             ramint(i) = rtype
             ihsram = 1
          elseif (ktype.eq.1) then
             if (str(1:1).eq.'[') goto 10
          elseif (ktype.eq.0) then
          endif

      end do

10    ihasi = ihsv + ihsram

      return
      end

      subroutine acoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      dimension r(3)

      istat = 1
      call rewmf
      call iatnox(iatoms)
      call srchmf(line,'[FR-NORM',istats)
      if (istats.eq.0) goto 100

      do while (getlin(0).eq.1)

          ktype = nxtwrd(str,nstr,itype,rtype)

          if (ktype.eq.1) then
             if (nstr.ge.3) then
                 if (icdex(str,'vib').ne.0) then
                    ktype = nxtwrd(str,nstr,itype,rtype)
                    if (ktype.eq.2) then
                       if (itype.eq.ifreq) goto 50
                    else
                       goto 100
                    endif
                 endif
             endif
          endif

      end do

      goto 100

50    do i=1,iatoms
         
          if (gnreal(r,3,.true.)) then
             do j=1,3
                a(j,i) = r(j)
             end do
          else
             goto 60
          endif

      end do

60    if (idebug.eq.1) call prtfr(ifreq)

      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine frqstr(ifrq,movfil,movlen)
      implicit double precision (a-h,o-z)
      character*11 movfil
      character*5 hstr,tstr

      tstr = hstr(ifrq)
      i = index(tstr,')')
      movlen = 4+i-2+4
      movfil = 'freq'//tstr(2:i-1)//'.xyz'

      return
      end

      subroutine nxtpnd(iopt,fancy,atcol,dolabs,backb,wpnt,
     &                  coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      common /athlp/ iatoms, mxnat
      common /pnthlp/ ipoints,ipnt
      logical wpnt
      integer dolabs,fancy,atcol,backb
      character*11 movfil
      character*5 hstr,tstr
      dimension coo(3,*)

      call iatnox(natoms)

      if (wpnt) then
         call frqstr(ifrq,movfil,movlen)
         if (iopt.eq.5) movfil(movlen-2:movlen) = 'wrl'
         if (iopt.eq.6) movfil = 'molden.ogl'
      endif

      iframe = iframe + idirct
      if (iframe.ge.nframe.or.iframe.le.-nframe) then
         idirct = -1*idirct
         iloop = iloop + 1
      endif

      do i=1,natoms
        do j=1,3
           coo(j,i) = fcoo(j,i) + iframe*frmul*a(j,i)
        end do
      end do

      if (wpnt.and.iloop.lt.3) then

        if (iloop.eq.1.and.iframe.eq.nframe) then
            call wrpnt(movfil,movlen,iopt,1,nframe*2,
     &                 fancy,atcol,dolabs,backb)
        elseif (iloop.eq.2.and.iframe.eq.nframe-1) then
            ipts = ipoints
            ipoints = nframe*4
            call wrpnt(movfil,movlen,iopt,4,0,
     &                 fancy,atcol,dolabs,backb)
            ipoints = ipts
            call inferr('wrote file: '//movfil,0)
            if (iopt.eq.6) call viewer
        else
            call wrpnt(movfil,movlen,iopt,3,0,
     &                 fancy,atcol,dolabs,backb)
        endif

      endif

      return
      end

      subroutine scalfd(iopt,fancy,atcol,dolabs,backb,wpnt,
     &                  t,coo,scal,scali,smag)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      logical wpnt
      integer dolabs,fancy,atcol,backb
      dimension t(3),coo(3,*)

      idirct = 1
      iframe = nframe - 1
      call nxtpnt(iopt,fancy,atcol,dolabs,backb,wpnt)

      call iatnox(natoms)

      scali = 0.0d0
      do i=1,natoms
         dist = 0.0d0
         do j=1,3
             dt = coo(j,i)-t(j)
             dist = dist + dt*dt
         end do
         if (dist.gt.scali) scali = dist
      end do
      scali = dsqrt(scali)
      scal = scali * 2.4d0 * smag

      return
      end

      subroutine resfd(coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      dimension coo(3,*)

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           coo(j,i) = fcoo(j,i)
        end do
      end do

      return
      end

      subroutine tofcod(coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      dimension coo(3,*)

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

      return
      end

      subroutine prtfr(ifreq)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      call iatnox(iatoms)

      write(iun3,*) ' '
      write(iun3,*) 'Coordinates used in frequency calculation (au)'
      write(iun3,*) '============='
      do i=1,iatoms
         write(iun3,*) (fcoo(j,i),j=1,3)
      end do

      write(iun3,*) ' '
      write(iun3,*) 'Norm. Mode ',ifreq,' (au)'
      write(iun3,*) '============='

      do i=1,iatoms
         write(iun3,*) (a(j,i),j=1,3)
      end do

      return
      end

      logical function negfrq(ifreq)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi

      negfrq = .false.

      if (freq(ifreq).lt.0.0e0) negfrq = .true.

      return
      end

      subroutine iatnod(iatnox,ianz)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension ianz(*)

      iatnox = 0
      do i=1,iatoms
         if (ianz(i).ne.99) iatnox = iatnox + 1
      end do

      return
      end

      subroutine calspc
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      logical opfil

      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      if (opfil(46,'fr.out',6,1,0,0)) then
         do i=1,nfreq
            write(46,'(f10.4,2x,f10.4)') freq(i),frint(i)
         end do
         close(46)
      endif

      return
      end

      subroutine gttrns(istats)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*5 frsym
      common /frstr/ frsym(maxfrq)
      character*137 line,str
      common /curlin/ line
      integer getlin
      double precision reada
      logical g94,dosym

      istats = 1

      ihasi = -2
      nfreq = 0
      do while(.true.)
         call search(line,"Excited State ",istat)
         if (istat.ne.0) then
            if (index(line,":").ne.0) then
                nfreq = nfreq + 1
                do i=1,4
                   ktype = nxtwrd(str,nstr,itype,rtype)
                end do
                if (ktype.eq.1) then
                    ind = index(str,"Singlet")
                    if (ind.eq.1) then
                       str = 'S'//str(8:)
                    endif
                    ind = index(str,"Triplet")
                    if (ind.eq.1) then
                       str = 'T'//str(8:)
                    endif
                    n = len(str)
                    frsym(nfreq) = str(1:n)
                endif
                do i=1,3
                   ktype = nxtwrd(str,nstr,itype,rtype)
                end do
                if (ktype.eq.3) then
                    freq(nfreq) = rtype
                endif
                do i=1,2
                   ktype = nxtwrd(str,nstr,itype,rtype)
                end do
                if (ktype.eq.1) then
                   frint(nfreq) = reada(str,3,nstr)
                endif
            endif
         else
            goto 10
         endif
      end do

10    continue

      do i=1,nfreq
         n = len(frsym(i))
         call parsfn(frsym(i),n,12)
      end do

      return
      end

      subroutine nrmi(ifrq)
      implicit double precision (a-h,o-z)
      logical wmovie,dconpt

      wmovie = .false.
      dconpt = .false.

      call setnrm(ifrq,0,wmovie,dconpt)

      return
      end

      subroutine setnrm(ifrq,iwopt,wmovie,dconpt)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 line,str
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifreq,normc
      character*5 frsym
      common /frstr/ frsym(maxfrq)
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      logical valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /ecce/iecce,imod
      logical dconpt,negfrq,wmovie,dozme

      normc = 1
      ifreq = ifrq
      dconpt = negfrq(ifreq)
      if (irtype.eq.4) then
           iloop = 0
           call resfr
           call doconn

           if (iftyp.eq.1) then
              call mcoord(idebug,ifreq,istat)
           elseif (iftyp.eq.2.or.iftyp.eq.3) then
              if (iftyp.eq.3) then
                  call ucoorg(idebug,ifreq,istat)
              else
                  call ncoorg(idebug,ifreq,istat)
              endif
           elseif (iftyp.eq.4) then
              call curs(1)
              call rewfil
              call search(line,'Frequencies --',istat)
              call scback(line,'orientation:',istat)
              if (istat.eq.1) then
                   call bckfil
                   call rdcor(idebug,istat)
                   if (istat.eq.1) then
                       call xyzcoo(1,0,0)
                       call tofcoo
                       call doconn
                   endif
              endif
              call ncoord(idebug,ifreq,istat)
              call curs(0)
           elseif (iftyp.eq.5) then
              call acoord(idebug,ifreq,istat)
           elseif (iftyp.eq.7) then
              call cpmdcoorg(idebug,ifreq,istat)
           elseif (iftyp.eq.8) then
              call qcoord(idebug,ifreq,istat)
           elseif (iftyp.eq.9) then
              call ocoord(idebug,ifreq,istat)
           elseif (iftyp.eq.15) then
              if (iecce.eq.1) then
                 call enwcrd(idebug,ifreq,istat)
              else
                 call nwcord(idebug,ifreq,istat)
              endif
           endif
           call scalfr(iwopt,fancy,atcol,dolabs,backb,wmovie)
      endif

      return
      end

      integer function nfrqs()
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi

      nfrqs = nfreq

      return
      end

      subroutine vaxconv
cvax      open(unit=45,form='formatted',file='scratch.com',
cvax     &status='unknown')
cvax      write(45,'(a)')'$ convert/fdl=sys$input plot.dat scratch.dat'
cvax      write(45,'(a)')'FILE'
cvax      write(45,'(a)')'ORGANIZATION SEQUENTIAL'
cvax      write(45,'(a)')'RECORD'
cvax      write(45,'(a)')'CARRIAGE_CONTROL CARRIAGE_RETURN'
cvax      write(45,'(a)')'FORMAT VARIABLE'
cvax      write(45,'(a)')'$ delete plot.dat;'
cvax      write(45,'(a)')'$ rename scratch.dat plot.dat'
cvax      write(45,'(a)')'$ delete scratch.com;'
cvax      close(45)
cvax      call Lib$Do_Command('@[]scratch.com')
      return
      end

      subroutine actcad(iopt,
     &                  iaton,iatclr,iresid,
     &                  icalf,ianf,islu,nchain,iamino,ibck)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      parameter (mxres=42)
      parameter (mxchai=50)
      common /clfhlp/ isndcl(4),iamicl(mxres),ichcol(mxchai)
      common /cllab/  iclon,iclpnt(4)
      dimension iaton(*),iatclr(*),iresid(*),iamino(*)
      dimension icalf(6,*),ianf(*),islu(*),ibck(*)

      icllow = 0
      if (iclon.eq.1) icllow = iclpnt(1) 

      if (iopt.eq.1) then
         do i=1,iatoms
             iaton(i) = 0
         end do

         do i=1,nchain
             do j=ianf(i),islu(i)
                if (iamino(j).gt.23) then
                   n = 6
                else
                   n = 3
                endif
                do k=1,n
                   if (icalf(k,j).ne.0) then
                       iaton(icalf(k,j)) = 1
                       iatclr(icalf(k,j)) = ichcol(i)
                   endif
                end do
             end do
         end do
      end if

      if (iopt.le.0) then
         do i=1,iatoms
             iaton(i) = 1
             if (iclon.eq.0.or.(iclon.eq.1.and.i.lt.icllow)) then
                if (iresid(i).eq.0) then
                   iatclr(i) =  isndcl(1)
                elseif (iresid(i).eq.-1) then
                   iatclr(i) =  isndcl(2)
                elseif (iresid(i).eq.-2) then
                   iatclr(i) =  isndcl(3)
                elseif (iresid(i).eq.-3) then
                   iatclr(i) =  isndcl(4)
                elseif (iopt.eq.0.and.iresid(i).lt.-3) then
                   iatclr(i) =  1
                else
                   if (iopt.eq.0) iatclr(i) =  12
                endif
             endif
         end do
      end if

      do i=1,4
         ibck(i) = 1
      end do

      return
      end

      subroutine acthed(iopt,iscnd,jcolsp,inclbb,
     &                  iaton,iatclr,iresid,iconn,
     &                  icalf,ianf,islu,nchain,iamino,ihet,
     &                  reson,isal,ibck)
c     switches off the backbone and activates helix, beta sheet, coil
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat
      parameter (mxres=42)
      parameter (mxchai=50)
      common /clfhlp/ isndcl(4),iamicl(mxres),ichcol(mxchai)
      integer reson
      logical edge
      dimension iaton(*),iatclr(*),iresid(*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),ihet(*),reson(*),
     &          isal(*),ibck(*)

      if (iscnd.lt.0.or.iscnd.gt.3) return


      jcol = jcolsp
      if (jcol.eq.0) then
         if (iscnd.eq.0) then
            jcol = isndcl(1)
         elseif (iscnd.eq.1) then
            jcol = isndcl(2)
         elseif (iscnd.eq.2) then
            jcol = isndcl(3)
         elseif (iscnd.eq.3) then
            jcol = isndcl(4)
         else
            jcol = 12
         endif
      endif

      icol(100) = 10
      ifnd = 0
      do i=1,iatoms
         if (iresid(i).eq.-iscnd) then
            iaton(i) = iopt
            iatclr(i) = jcol
            ifnd = 1
         endif
      end do

      if (ifnd.eq.0) then
         if (iscnd.eq.0) then
             call inferr('No Helix found !',0)
         elseif (iscnd.eq.1) then
             call inferr('No Beta found !',0)
         elseif (iscnd.eq.2) then
             call inferr('No RNA/DNA backbone found !',0)
         elseif (iscnd.eq.3) then
             call inferr('No Coil found !',0)
         endif
      endif

      iset = inclbb
      if (iopt.eq.0) iset = 1
      ibck(iscnd+1) = iset

      do i=1,nchain
          istr = 0
          ichlen = islu(i) - ianf(i) + 1
          do k=1,ichlen
             j = ianf(i) + k - 1
             edge = .false.
             ido = 0
             if (iscnd.eq.3) then

                if (isal(j).eq.iscnd.and.reson(j).eq.0) ido = 1

                if (isal(j).ne.iscnd.and.reson(j).eq.0) then
                 if (iamino(j).le.23) then
                    if (.not.(k.eq.1.or.k.eq.ichlen)) then
                       if (isal(j-1).eq.iscnd.or.
     &                     isal(j+1).eq.iscnd) then
                         ido = 1
                         if ((ihet(isal(j)+1).eq.0.and.iset.eq.0) 
     &                   .or.(ihet(isal(j)+1).eq.1.and.iset.eq.1))
     &                   edge = .true.
                       endif
                    endif
                 endif
                endif

                if ((isal(j).eq.0.and.isal(j+1).eq.1).or.
     &              (isal(j).eq.1.and.isal(j+1).eq.0).or.
     &              (isal(j).eq.0.and.isal(j-1).eq.1).or.
     &              (isal(j).eq.1.and.isal(j-1).eq.0)) then
                   if (.not.(k.eq.1.or.k.eq.ichlen)) then
                      if ((isal(j).eq.0.and.isal(j+1).eq.1).or.
     &                    (isal(j).eq.1.and.isal(j+1).eq.0)) ido = 2
                      if ((isal(j).eq.0.and.isal(j-1).eq.1).or.
     &                    (isal(j).eq.1.and.isal(j-1).eq.0)) ido = 3
                      if (ihet(isal(j)+1).eq.0.and.iset.eq.0) 
     &                    edge = .true.
                      if (ihet(isal(j)+1).eq.1.and.iset.eq.1) 
     &                    edge = .true.
                   endif
                endif

             else

                if (isal(j).eq.iscnd.and.reson(j).eq.0) then
                 ido = 1
                 if (iamino(j).le.23) then
                    if (.not.(k.eq.1.or.k.eq.ichlen)) then

                       if (.not.(isal(j-1).eq.iscnd.and.
     &                     isal(j+1).eq.iscnd)) then
                         if (isal(j-1).ne.iscnd) then
                            if (isal(j-1).eq.3) then
                              if (ihet(isal(j-1)+1).eq.0.and.iset.eq.0)
     &                            edge = .true.
                              if (ihet(isal(j-1)+1).eq.1.and.iset.eq.1)
     &                            edge = .true.
                            else
                              if (ihet(4).eq.0.and.iset.eq.0) 
     &                            edge = .true.
                              if (ihet(4).eq.1.and.iset.eq.1) 
     &                            edge = .true.
                            endif
                         endif
                         if (isal(j+1).ne.iscnd) then
                            if (isal(j+1).eq.3) then
                              if (ihet(isal(j+1)+1).eq.0.and.iset.eq.0)
     &                            edge = .true.
                              if (ihet(isal(j+1)+1).eq.1.and.iset.eq.1)
     &                            edge = .true.
                            else
                              if (ihet(4).eq.0.and.iset.eq.0) 
     &                            edge = .true.
                              if (ihet(4).eq.1.and.iset.eq.1) 
     &                            edge = .true.
                            endif
                         endif
                       endif

                    endif
                 endif
                endif
             endif

             if (ido.gt.0) then
                if (edge) then

                   ioff = 1
                   if (ido.eq.1.and.isal(j-1).eq.iscnd) ioff = -1
                   if (ido.eq.3) ioff = -1
                   if (iamino(j).le.23) then
                      if (iset.eq.1) iaton(icalf(1,j)) = 1
                      do l=2,3
                         i1 = icalf(l,j)
                         do n=1,iconn(1,i1)
                            do ll=2,3
                               i2 = icalf(ll,j+ioff)
                               if (abs(iconn(n+1,i1)).eq.i2) 
     &                             iaton(i1) = iset
                            end do
                         end do
                      end do
                   endif

                else

                   n=6
                   if (iamino(j).le.23) n=3
                   do l=1,n
                      if (icalf(l,j).ne.0) then
                         iaton(icalf(l,j)) = iset
                      endif
                   end do

                endif
             endif

          end do
      end do

      ihet(iscnd+1) = iopt

      return
      end

      subroutine plbox
      implicit double precision (a-h,o-z)

      common /plot/   iplot,iplwin,icolps
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
*
*  DRAW A BOX AROUND THE PLOT
*
      if (iplot.eq.0) write(iun4,'(a)') '.nc 1'
      if (iplot.eq.1) write(iun4,'(a)') 'SP1;'

      call euler(0.d0,0.d0,0.d0,1)
      call euler(1.d0,0.d0,0.d0,2)
      call euler(1.d0,1.d0,0.d0,2)
      call euler(0.d0,1.d0,0.d0,2)
      call euler(0.d0,0.d0,0.d0,2)

      if (iplot.eq.4) write(iun4,'(''s'')')

      return
      end

      subroutine getpod(icom,ifd,iff,doscl,ioatms,ioadd,
     &                  coo,ianz,iaton,iconn,
     &                  scal,scali,smag,natc,ichx,icrtp)

      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (mxonh=100)
      parameter (numatm=2000)
      parameter (small=1.0d-4)
      common /pnthlp/ ipoints,ipnt
      common /athlp/ iatoms, mxnat
      common /gamori/imap(numat1),cstand(3,numat1),istand(numat1),
     &               msucc
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor,
     &                ixyz98,iopr,isymm,irc,imp2,icntp,itd
      common /align/  vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /zmpart/ ipart,imn,imx,idcur
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fdum3(10),idum(7),ieav,ifrav,mxpnt
      common /mopver/ mopopt
      common /animo/  movie

      character lstr*137
      character*6 astr
      character*8 refcod
      integer first,prev,next,last,getmf,doscl
      logical dummy,dozme
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /cllab/  iclon,iclpnt(4)
      common /ecce/iecce,imod
      character*23 stmp
      dimension dum(3),coo(3,*),ianz(*),iaton(*),iconn(mxcon+1,*)

c iftyp      file type
c
c 1          mopac
c 2          gamess
c 3          gamus
c 4          gauss
c 5          adfin
c 6          chemx
c 7          cpmd
c 8          qchem
c 9          orca
c 10         xyz
c 11         tinker + small
c 12         tinker protein
c 13         mol file
c 15         nwchem

cd     write(iun3,'(a)')'enter subroutine getpoi'

      first = -1
      next  = -2
      last  = -3
      prev  = -4
      tol = small
      idoprt = 0

      icomm = icom

c     parse variables to C used in getpoi

      call parpoi(nzm,nso,nio,nzo,ioropt,ifor,ixyz98,iopr,isymm,irc,
     &            imp2,icntp,msucc,ioni,mopopt,isbin,irtype,
     &            ipdbgro,ifav,ioxyz,iconv,ircus,nscnd,iscst,ialtyp)

c for gaussian
 
      stmp = 'Input orientation:'
      ns = 18
      if (ixyz98.gt.0.and.(ioropt.eq.2)) then
          stmp = 'Standard orientation:'
          ns = 22
      endif

      if (dozme) then
c since dumzm resets the ipart variable, we need the help variable dopart
c this is because otherwise conpdb downstream goes wrong
          if (ipart.eq.1) idoprt = ipart
          ifav = 0
          call dumzm(coo,ianz,iatoms)
          goto 100
      endif

c     mopac binary .gpt or GRAPH file (msf excluded by
c                                      iftyp.ne.6: .not.chemx)

      if (isbin.eq.1.and.iftyp.ne.6) iatoms = 0

c     convert mopac coordinates to a.u.
c     vdwr are in angstrom, vrad in a.u.

      if (iftyp.eq.1.and.iconv.eq.1) call xyzcoo(1,1,0)

c     CPMD

      if (iftyp.eq.7.and.ipoints.eq.0.and.
     &    (ioxyz.eq.1.or.irtype.eq.4)) then
          call xyzcoo(1,0,0)
          call haszm(.false.)
      endif

c     GAMESS xyz optimise or FREQ job

      if (iftyp.eq.2.and.ipoints.eq.0.and.
     &    (ioxyz.eq.1.or.irtype.eq.4)) then
          call xyzcoo(1,0,0)
          call haszm(.false.)
      endif

c     GAUSSIAN single point or FREQ job, the first point

      if (iftyp.eq.4.and.
     &    (ipoints.le.1.or.irtype.eq.4).and.icomm.eq.-1) then
          call rewfil
          call gaupoi(istat)
          if (istat.eq.-1) then
             ifav = 0
          else
             ifav = 1
          endif
          if ((istat.eq.0.or.irtype.eq.4).and.ioni.ne.1) 
     &          call xyzcoo(1,0,0)
          if (istat.eq.0) call haszm(.false.)
      endif
      
      if (icomm.eq.prev) then
          if ( ipnt.le.1 ) return
          ipnt = ipnt -1
          icomm = ipnt
      endif

      ifav = 0

c     NOT {GAMESS-UK,GAMESS-US,GAUSSIAN or CPMD}
c     AND iatoms=0: EXIT

      if (iatoms.eq.0.and..not.
     &    ((iftyp.ge.2.and.iftyp.le.4).or.iftyp.eq.7)) then
          call inferr('No coordinates found !',0)
cd         write(iun3,'(a)')'leave subroutine getpoi'
          return
      endif

c Mopac2007 AUX file

      if (iftyp.eq.1.and.mopopt.eq.4.and.ipoints.ge.1) then

          if (icomm .eq. first) then
             call rewfil
             call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
             call redel(lstr,2)
             if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
             if (istat.eq.1) ipnt = 1
          elseif (icomm .eq. next) then
             call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
             call redel(lstr,2)
             if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
             if (istat.eq.1) then
                ipnt = ipnt +1
             else
                call rewfil
                call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
                call redel(lstr,2)
                if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
                if (istat.eq.1) ipnt = 1
             endif
          elseif (icomm.gt.0) then
             call rewfil
             do i=1,icomm
                call search(lstr,'HEAT_OF_FORM_UPDATED',istat)
                call redel(lstr,2)
                if (istat.eq.1) call gtapnt(iatoms,coo,istat) 
                if (istat.eq.1) then
                    dummy = .true.
                else
                    dummy = .false.
                endif
             end do
             ipnt = icomm
          endif
c         convert coo from angs to au
          call xyzcoo(0,1,0)
      endif

      if (iftyp.eq.1.and.iconv.eq.0.and.ipoints.ge.1) then
          if (icomm .eq. first) then
             call rewfil
             call getmop(iatoms,heat,0,1,istat) 
             if (istat.eq.1) ipnt = 1
          elseif (icomm .eq. next) then
             call getmop(iatoms,heat,0,0,istat) 
             if (istat.eq.1) then
                ipnt = ipnt +1
             else
                call rewfil
                call getmop(iatoms,heat,0,0,istat) 
                if (istat.eq.1) ipnt = 1
             endif
          elseif (icomm.gt.0) then
             call rewfil
             idomopf = 1
             do i=1,icomm
                call getmop(iatoms,heat,0,idomopf,istat) 
                if (istat.eq.1) then
                    dummy = .true.
                else
                    dummy = .false.
                endif
                idomopf = 0
             end do
             ipnt = icomm
          endif
      endif

      if ((iftyp.ge.10.or.(iftyp.eq.5.and.ihasg.ge.1)).and.
     &    ipoints.gt.1) then

          if (icomm .eq. first) then

             if (iftyp.eq.5) then
                call rewmf
                call srchmf(lstr,'[GEOMETRIES]',istat)
             else
                call rewfil
             endif

             if (iftyp.eq.5.and.ihasg.eq.2) then
                call getzm(iatoms,0,0,istat)
                if (istat.eq.1) ipnt = 1
             else
                if (iftyp.eq.11.or.iftyp.eq.12) then
                   call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                   if (igttnk.eq.1) ipnt = 1
                elseif (iftyp.eq.13) then
                   call getmol(igetmo,0)
                   if (igetmo.eq.1) ipnt = 1
                else
                   call getxyz(igetxy,heat,0)
                   if (igetxy.eq.1) ipnt = 1
                endif
             endif

             if (iftyp.eq.5) then
                iolin = getmf()
                call rdfc(ipnt,istat)
                if (istat.eq.1) then
                   ifav = 1
                else
                   ifav = 0
                endif
                call putmf(iolin)
             endif

          elseif (icomm .eq. next.and..not.
     &            (iftyp.eq.5.and.ifrav.eq.1)) then
             if (iftyp.eq.5.and.ihasg.eq.2) then
                call getzm(iatoms,0,0,istat)
                if (istat.eq.1) then
                   dummy = .true.
                else
                   dummy = .false.
                endif
             else
                if (iftyp.eq.11.or.iftyp.eq.12) then
                   call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                   if (igttnk.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                elseif (iftyp.eq.13) then
                   call getmol(igetmo,0)
                   if (igetmo.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                else
                   call getxyz(igetxy,heat,0)
                   if (igetxy.eq.1) then
                       dummy = .true.
                   else
                       dummy = .false.
                   endif
                endif
             endif
             if (dummy) then
                ipnt = ipnt +1
             else
                if (iftyp.eq.5) then
                   call rewmf
                   call srchmf(lstr,'[GEOMETRIES]',istat)
                else
                   call rewfil
                endif
                if (iftyp.eq.5.and.ihasg.eq.2) then
                   call getzm(iatoms,0,0,istat)
                   if (istat.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                else
                   if (iftyp.eq.11.or.iftyp.eq.12) then
                      call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                      if (igttnk.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   elseif (iftyp.eq.13) then
                      call getmol(igetmo,0)
                      if (igetmo.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   else
                      call getxyz(igetxy,heat,0)
                      if (igetxy.eq.1) then
                          dummy = .true.
                      else
                          dummy = .false.
                      endif
                   endif
                endif
                if (dummy) ipnt = 1
             endif
          elseif (icomm.gt.0.or.
     &           (icomm.eq.next.and.iftyp.eq.5.and.ifrav.eq.1)) then
             if (icomm.eq.next) then
                ipntt = ipnt + 1
                if (ipntt.gt.ipoints) ipntt = ipoints
             endif
             if (icomm.gt.0) ipntt = icomm
             if (iftyp.eq.5) then
                call rewmf
                call srchmf(lstr,'[GEOMETRIES]',istat)
             else
                call rewfil
             endif
             do i=1,ipntt
                if (iftyp.eq.5.and.ihasg.eq.2) then
                   call getzm(iatoms,0,0,istat)
                   if (istat.eq.1) then
                      dummy = .true.
                   else
                      dummy = .false.
                   endif
                else
                   if (iftyp.eq.11.or.iftyp.eq.12) then
                      if (iff.eq.7) then

c                        speed things up ambfor MD trajectories

                         if (i.ne.ipntt) then
                            call gtheat(igttnk,iheat,heat)
                         else
                            call search(lstr,'[AMBFOR]',istat)
                            if (istat.eq.1) then
                                call bckfil
                                call gettnk(
     &                               igttnk,0,ipdbon,iff,iheat,heat)
                            else
                                igttnk = 0
                            endif
                         endif
                      else
                         call gettnk(igttnk,0,ipdbon,iff,iheat,heat)
                      endif
                      if (igttnk.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   elseif (iftyp.eq.13) then
                      call getmol(igetmo,0)
                      if (igetmo.eq.1) then
                         dummy = .true.
                      else
                         dummy = .false.
                      endif
                   else
                      call getxyz(igetxy,heat,0)
                      if (igetxy.eq.1) then
                          dummy = .true.
                      else
                          dummy = .false.
                      endif
                   endif
                endif
             end do
             if (iftyp.eq.5) then
                call rdfc(ipntt,istat)
                if (istat.eq.1) then
                   ifav = 1
                else
                   ifav = 0
                endif
             endif
             ipnt = ipntt
          endif
      endif

      if (iftyp.eq.8) then
          if ( icomm .eq. first ) then
             call rewmf
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             call rewmf
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewmf
             ipnt = icomm
          endif
          call qcxyz(0,.false.,ipnt,istat)
          if (istat.eq.-1) then
               ifav = 0
          else
               ifav = 1
          endif
      endif

      if (iftyp.eq.9) then
          if ( icomm .eq. first ) then
             call rewmf
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             call rewmf
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewmf
             ipnt = icomm
          endif
          call orcxyz(0,ipnt,istat)
          if (istat.eq.-1) then
               ifav = 0
          else
               ifav = 1
          endif
      endif

      if (iftyp.eq.15) then
          if ( icomm .eq. first ) then
             if (iecce.eq.1) then
                call rewfil
             else
                call rewmf
             endif
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             if (iecce.eq.1) then
                call rewfil
             else
                call rewmf
             endif
             ipnt = ipoints
          elseif (icomm.gt.0) then
             if (iecce.eq.1) then
                call rewfil
             else
                call rewmf
             endif
             ipnt = icomm
          endif
          if (iecce.eq.1) then
             call enwxyz(0,ipnt,imod,istat)
          else
             call nwxyz(0,ipnt,istat)
          endif
      endif

      if (iftyp.eq.2.and.ipoints.gt.0) then
          if ( icomm .eq. first ) then
             call rewfil
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             call rewfil
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewfil
             ipnt = icomm
          endif
          if (ioxyz.eq.1) then
             itmp = ipnt - 1
             call gampoi(itmp,istat,ioxyz)
          else
             call gampoi(ipnt,istat,ioxyz)
          endif
          if ( istat .eq. -1 ) then
               ifav = 0
          else
               ifav = 1
          endif
c          if (msucc.eq.0.and.ioxyz.eq.0) ifav = 0
      endif

      if (iftyp.eq.4.and.ipoints.gt.1) then
          if ( icomm .eq. first ) then
             call rewfil
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
          elseif ( icomm .eq. last ) then
             call rewfil
             do i=1,ipoints
                 if ((nzm.eq.nzo.or.2*nzm.eq.nzo).and.nzm.gt.0) then
                    call search(lstr,'Z-MATRIX (ANGSTROMS',istat)
                 elseif (nzo.gt.0) then
                    call search(lstr,'Z-Matrix orientation:',istat)
                 else
                    call search(lstr,stmp(1:ns),istat)
                 endif
             end do
             call bckfil
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewfil
             do i=1,icomm
                 if ((nzm.eq.nzo.or.2*nzm.eq.nzo).and.nzm.gt.0) then
                    call search(lstr,'Z-MATRIX (ANGSTROMS',istat)
                 elseif (nzo.gt.0) then
                    call search(lstr,'Z-Matrix orientation:',istat)
                 else
                    call search(lstr,stmp(1:ns),istat)
                 endif
             end do
             call bckfil
             ipnt = icomm
          endif
          call gaupoi(istat)
          if ( istat .eq. -1 ) then
               ifav = 0
          else
               ifav = 1
          endif
      endif

      if (iftyp.eq.3.and..not.(ipoints.le.1.and.iatoms.gt.0) ) then
          if ( icomm .eq. first ) then
             call rewfil
             ipnt = 1
             call gamupt(ipnt,istat)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             call gamupt(ipnt,istat)
          elseif ( icomm .eq. last ) then
             call rewfil
             do i=1,ipoints
                call gamupt(ipoints,istat)
             end do
             call bckfil
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewfil
             do i=1,icomm
                call gamupt(icomm,istat)
             end do
             call bckfil
             ipnt = icomm
          endif
          ifav = 1
      endif

      if (iftyp.eq.7.and..not.(ipoints.le.1.and.iatoms.gt.0)
     &     .and.irtype.ne.3 ) then
c          iunt = iun2
c          iun2 = iun5
          if ( icomm .eq. first ) then
             call rewfil
             ipnt = 1
             call cpmdpt(ipnt,istat)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             call cpmdpt(ipnt,istat)
          elseif ( icomm .eq. last ) then
             call rewfil
             do i=1,ipoints
                call cpmdpt(ipoints,istat)
             end do
             call bckfil
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewfil
             do i=1,icomm
                call cpmdpt(icomm,istat)
             end do
             call bckfil
             ipnt = icomm
          endif
          ifav = 1
c          iun2 = iunt
      endif

      if (iftyp.eq.7.and..not.(ipoints.le.1.and.iatoms.gt.0)
     &     .and.irtype.eq.3 ) then
          if (icomm.ne.first) then
             iunt = iun2
             iun2 = iun5
          endif
          if ( icomm .eq. first ) then
             call rewfil
             ipnt = 1
             call cpmdpt(ipnt,istat)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             call cpmdptdyn(ipnt,istat)
          elseif ( icomm .eq. last ) then
             call rewfil
             do i=1,ipoints
                call cpmdptdyn(ipoints,istat)
             end do
             call bckfil
             ipnt = ipoints
          elseif (icomm.gt.0) then
             call rewfil
             do i=1,icomm
                call cpmdptdyn(icomm,istat)
             end do
             call bckfil
             ipnt = icomm
          endif
          ifav = 1
          if (icomm.ne.first) iun2 = iunt
      endif

      if (((icrtp.le.3.and.icrtp.ge.1).or.icrtp.eq.5)
     &     .and.ipoints.gt.1) then
          if (icomm.eq.first) then
             call rewfil
             if (icrtp.eq.3) then
                call rfbio(0,1,istat)
             elseif (icrtp.eq.1) then
                call rdchx(0,3,0,0,0,istat,1)
             elseif (icrtp.eq.5) then
                call getxdt(1,natc,istat)
             else
                call rfdat(0,istat,refcod)
             endif
             ipnt = 1
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt +1
             if (icrtp.eq.3) then
                call rfbio(0,0,istat)
             elseif (icrtp.eq.1) then
                call rdchx(0,3,0,0,0,istat,1)
             elseif (icrtp.eq.5) then
                call getxdt(ipnt,natc,istat)
             else
                call rfdat(0,istat,refcod)
             endif
          elseif (icomm.gt.0) then
             call rewfil
             if (icrtp.eq.3) then
                call rfbio(0,1,istat)
             elseif (icrtp.eq.1) then
                call rdchx(0,3,0,0,0,istat,1)
             elseif (icrtp.eq.5) then
                call getxdt(icomm,natc,istat)
             else
                call rfdat(0,istat,refcod)
             endif
             if (icrtp.ne.5) then
                do i=1,icomm-1
                   if (icrtp.eq.3) then
                      call rfbio(0,0,istat)
                   elseif (icrtp.eq.1) then
                      call rdchx(0,3,0,0,0,istat,1)
                   else
                      call rfdat(0,istat,refcod)
                   endif
                end do
             endif
             ipnt = icomm
          endif
          if (.not.(icrtp.eq.3.and.istat.eq.1)) 
     &       call fdat(ifd,0,0,0,0,0)
      endif

      if (ipdbon.eq.1.and.ipdbgro.eq.1) then
          if (icomm.eq.first) then
             ipnt = 1
             call gtfrm(ipnt)
          elseif ( icomm .eq. next ) then
             if ( ipnt.ge.ipoints ) return
             ipnt = ipnt + 1
             call gtfrm(ipnt)
          elseif (icomm.gt.0) then
             call rewfil
             call gtfrm(icomm)
             ipnt = icomm
          endif
      endif

100   continue

      if (ioadd.eq.0) then
        if (.not.(
     &    ( (iftyp.eq.2.or.iftyp.eq.3).and.ipoints.eq.0
     &      .and.(ioxyz.eq.1.or.irtype.eq.4) ).or.
     &    (iftyp.eq.4.and.ipoints.le.1).or.
     &    (icrtp.eq.3.and.ipoints.gt.1).or.
     &    (ipdbon.eq.1.and.dozme))) call docent
      endif

      if (iftyp.eq.2.and.ipoints.gt.0.and.ioxyz.eq.0.and.msucc.eq.1
     &    .and.(.not.dozme)) 
     &    call rotmom(ipnt,ifav)


      ibeg = 1
      if (ioadd.eq.1) ibeg = ioatms + 1

      do i=ibeg,iatoms
         if (ipdbgro.eq.1) then
            if (ianz(i).eq.100.and.ipnt.gt.1) then
               if (i.gt.iclpnt(1)+7) iaton(i) = 0
            else
               iaton(i) = 1
            endif
         else
            iaton(i) = 1
         endif
      end do

      if (ipdbon.eq.1) then
         if (ialtyp.eq.1) then
            if (dozme) then
               call convar(coo,iconn,ianz,nscnd,iscst)
               call pmfass(1,0)
               call totpmf(dum(1))
               call upsco()
            endif
         else
            if (dozme) then
               if (idoprt.eq.0) call conpdb
               call chkbck(0)
            else
               if (((iftyp.eq.11.or.iftyp.eq.12).and.iff.eq.7)
     &             .or.ipdbgro.eq.1) call chkbck(1)
            endif
         endif
      else
         if ((.not.(iftyp.eq.6.or.ichx.ne.0).and.
     &        .not.(iftyp.eq.5.and.ihasg.eq.1).and.
     &        .not.(iftyp.ge.10.and.iftyp.lt.15)
     &       ).or.(dozme.and..not.ichx.eq.1)) call doconn
      endif


      if (ipdbon.eq.0) then
         if (.not.ichx.eq.1.and.iff.ne.7) call dohcon(0)
      else
         call domcon(1,1)
      endif
c
c  get scale
c

      if (ioadd.eq.0) then
         if (doscl.eq.1.and..not.(icrtp.eq.3.and.ipoints.gt.1).and.
     &       .not.(ipdbon.eq.1.and.dozme)) then
            call doscal
            if (dozme.and.iatoms.lt.7) scali = 3.5d0
            scal = scali * 2.4d0 * smag
         endif
      endif

      if (ifav.eq.1) call parfc

      call drwgeo

      if (movie.eq.0.or.(movie.ne.0.and.ipnt.eq.ipoints)) then
         if (ctoz) call allzmt(ipdbon)
         if (.not.dozme) call upzme
      endif

      dozme = .false.

      if (icrtp.eq.2.and.ipoints.gt.1) then
          lstr = refcod
          call inferr(lstr,0)
cd         write(iun3,'(a)')'leave subroutine getpoi'
          return
      elseif (icrtp.eq.5.and.ipoints.gt.1) then
          call zerstr(ipnt,astr,6,1)
          lstr = 'point '//astr
          call inferr(lstr,0)
          return
      endif

      if (.not.( iftyp.eq.7.or.
     &          (iftyp.ge.2.and.iftyp.le.4).or.
     &          (iftyp.eq.1.and.iconv.eq.0).or.
     &          (iftyp.ge.10.and.ipoints.gt.1)
     &         ).or.dozme) then
cd        write(iun3,'(a)')'leave subroutine getpoi'
         return
      endif

      if (ipoints.eq.0) then
         lstr = ' '
         if (iftyp.ne.1) then
             lstr = 'Single point'
         endif
      elseif (ipnt.eq.1) then
         lstr = 'First point'
      elseif (ipnt.eq.ipoints) then
         lstr = 'Last point'
      else
         if (ioxyz.eq.1) then
            call zerstr(ipnt-1,astr,6,1)
         else
            call zerstr(ipnt,astr,6,1)
         endif
         lstr = 'point '//astr
      endif

      if (iftyp.eq.7) lstr=lstr(1:22)//'CPMD output file'

      call inferr(lstr,0)

cd     write(iun3,'(a)')'leave subroutine getpoi'
      return
      end

      subroutine docond(coo,iconn,ianz)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*)

      call convar(coo,iconn,ianz,iatoms,0)

      return
      end

      subroutine convar(coo,iconn,ianz,iatoms,ioff)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      dimension coo(3,*),iconn(mxcon+1,*),ianz(*),ctemp(3)

      adjus=0.52917706d0

      do i=ioff+1,ioff+iatoms

         k = 0
         iconn(1,i) = 0
         iani = ianz(i)

         do j=ioff+1,ioff+iatoms

            ianj = ianz(j)

            if (iani.gt.0.and.ianj.gt.0.and.
     &          iani.le.100.and.ianj.le.100) then

               dmaxsq = (vdwr(iani) + vdwr(ianj))/adjus
               dmaxsq = dmaxsq*dmaxsq

               dijsq = 0
               do l=1,3
                  ctemp(l) = coo(l,i) - coo(l,j)
                  dijsq = dijsq + ctemp(l)*ctemp(l)
               end do

               if (i.ne.j.and.iani.ne.99.and.ianj.ne.99) then
                 if (dijsq.lt.dmaxsq) then
                     k = k + 1
                     if (k.le.mxcon) then
                        iconn(1,i) = k
                        iconn(k+1,i) = j
                     else
                        write(iun3,*) 
     &                     'more than mxconn connections found'
                     endif
                 endif
               endif

            endif

         end do
      end do

      return
      end

      subroutine dohcod(ihflag,coo,ianz,iconn,isurf)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (nacc=6)
      parameter (ndon=4)
      common /athlp/ iatoms, mxnat
      logical hon
      common /hcon/ iacc(nacc),idon(ndon),hdmin,hdmax,hamin,hamax,hon
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      logical isacc,isdon
      real angle,hamin,hamax
      dimension ctemp(3),isel(4)
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*),isurf(*)

      call domcon(1,1)

      if (.not.hon) return

      hdmin2 = hdmin*hdmin
      hdmax2 = hdmax*hdmax

c
c Hydrogen bonds
c
      do i=1,iatoms
         do j=i+1,iatoms
           if (ihflag.eq.0.or.
     &     (ihflag.gt.0.and.(isurf(i).eq.1.or.isurf(j).eq.1))) then
            iai = ianz(i)
            iaj = ianz(j)
            dijsq = 0
            do l=1,3
               ctemp(l) = coo(l,i) - coo(l,j)
               dijsq = dijsq + ctemp(l)*ctemp(l)
            end do
            if ((iai.eq.1.and.isacc(iaj)).or.
     &          (iaj.eq.1.and.isacc(iai))) then
               if (dijsq.gt.hdmin2.and.dijsq.lt.hdmax2) then
                  isel(1) = 0
                  if (iai.eq.1) then
                      if (iconn(1,i).gt.0) then
                         iai = ianz(iconn(2,i))
                         if (isdon(iai)) then
                            isel(1) = iconn(2,i)
                            isel(2) = i
                            isel(3) = j
                         endif
                      endif
                  else
                      if (iconn(1,j).gt.0) then
                         iaj = ianz(iconn(2,j))
                         if (isdon(iaj)) then
                            isel(1) = iconn(2,j)
                            isel(2) = j
                            isel(3) = i
                         endif
                      endif
                  endif
                  if (isel(1).ne.0) then
                    call intcor(intc,angle,isel,3)
                    if (intc.eq.1) then
                     if (abs(angle).gt.hamin.and.
     &                    abs(angle).lt.hamax) then
                         k = iconn(1,i)
                         if (k.lt.mxcon) then
                            iconn(1,i) = iconn(1,i) + 1
                            iconn(iconn(1,i)+1,i) = -j
                         else
                            write(iun3,*) 
     &                        'more than mxconn connections found'
                         endif
                         k = iconn(1,j)
                         if (k.lt.mxcon) then
                            iconn(1,j) = iconn(1,j) + 1
                            iconn(iconn(1,j)+1,j) = -i
                         else
                            write(iun3,*) 
     &                        'more than mxconn connections found'
                         endif
                     endif
                    endif
                  endif
               endif
            endif
           endif
         end do
      end do

      if (ihflag.eq.1) call clrsrf

      return
      end

      subroutine nohcod(iconn)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension icn(mxcon+1),iconn(mxcon+1,*)

c
c Deactivate Hydrogen bonds
c
      do i=1,iatoms
          inn = 0
          do j=1,iconn(1,i)
             if (iconn(1+j,i).gt.0) then
                inn = inn + 1
                icn(inn) = iconn(1+j,i)
             endif
          end do  
          iconn(1,i) = inn
          do j=1,inn
             iconn(1+j,i) = icn(j)
          end do
      end do

      return
      end

      logical function isacc(iatnr)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (nacc=6)
      parameter (ndon=4)
      logical hon
      common /hcon/ iacc(nacc),idon(ndon),hdmin,hdmax,hamin,hamax,hon
      real hamin,hamax

      isacc = .false.

      do i=1,nacc
          if (iatnr.eq.iacc(i)) isacc = .true.
      end do

      return
      end

      logical function isdon(iatnr)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (nacc=6)
      parameter (ndon=4)
      logical hon
      common /hcon/ iacc(nacc),idon(ndon),hdmin,hdmax,hamin,hamax,hon
      real hamin,hamax

      isdon = .false.

      do i=1,ndon
          if (iatnr.eq.idon(i)) isdon = .true.
      end do

      return
      end

      subroutine doscad(t,coo,zv,pincr,scal,scali,smag,iscupd)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /athlp/ iatoms, mxnat
      common /gracom/  uscl,colscd,colscpd,ivdwpl
      dimension t(3),coo(3,*)

      scali = 0.0d0
      do i=1,iatoms
         dist = 0.0d0
         do j=1,3
             dt = coo(j,i)-t(j)
             dist = dist + dt*dt
         end do
         if (dist.gt.scali) scali = dist
      end do
      if (scali.eq.0.0d0) then
         scali = 1.0d0
      else
         scali = dsqrt(scali)
      endif
      scal = scali * 2.4d0 * smag

      if (scali.gt.15.0d0) then
         colscpd = 1.3d0
      else
         colscpd = .4d0
      endif

      colscd = 2.0d0

      if (iscupd.eq.1) then
         zv = scali
         iscupd = 0
      endif

      pincr = 0.02d0*scali

      return
      end

      subroutine redcod(iconn)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension icnn(mxcon),iconn(mxcon+1,*)

      do j=1,iatoms
         ibnds = 0
         do i=1,iconn(1,j)
            ioke = 1
            do k=1,i-1
               if (iconn(k+1,j).eq.iconn(i+1,j)) ioke = 0
            end do
            if (ioke.eq.1.and.ibnds.lt.mxcon) then
               ibnds = ibnds + 1
               icnn(ibnds) = iconn(i+1,j)
            endif
         end do
         iconn(1,j) = ibnds
         do i=1,ibnds
            iconn(i+1,j) = icnn(i)
         end do
      end do

      return
      end

      subroutine domcod(ipt,idoall,monmod,iconn)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (maxdm=20)
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      real rout
      dimension iconn(mxcon+1,*)


      if (idoall.eq.1) then
         ibeg = 1
         iend = ndm
      else
         ibeg = ipt
         iend = ipt
      endif

      do i=ibeg,iend
         if (monmod.eq.2) then
            call intcor(intc,rout,idmon(1,i),2)
         else
            intc = 1
         endif
         if (intc.eq.1) then
            if (monmod.eq.2) rdm(i) = dble(rout)*0.52917706d0
            if (ifogl.ne.1) then
               i1 = idmon(1,i)
               i2 = idmon(2,i)
               k = iconn(1,i1)
               if (k.lt.mxcon) then
                  iconn(1,i1) = k + 1
                  iconn(k+2,i1) = -i2
               endif
               k = iconn(1,i2)
               if (k.lt.mxcon) then
                  iconn(1,i2) = k + 1
                  iconn(k+2,i2) = -i1
               endif
            endif
         endif
      end do

      call ogmon

      return
      end

      subroutine chkbcd(ncalf,ihet,reson,iaton,iatclr,ision)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      integer fancy,shade,atcol,dolabs,persp,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      common /cllab/  iclon,iclpnt(4)
      common /boxion/ ionon,ionclr
      parameter (mxheta=150)
      integer reson
      dimension ihet(*),reson(*),iaton(*),iatclr(*)

      if (backb.eq.1) then
         call actcal(1)
         call ribbs
         if (ihet(1).eq.1) call acthel(1,0,0,0)
         if (ihet(2).eq.1) call acthel(1,1,0,0)
         if (ihet(3).eq.1) call acthel(1,2,0,0)
         if (ihet(4).eq.1) call acthel(1,3,0,0)
         do i=5,mxheta
            j = -i+1
            if (ihet(i).eq.1) then
               call actami(j,0,1,0)
            endif
         end do
         if (ionon.eq.0) then
            call actami(ision,ionclr,1,0)
         endif
         do i=1,ncalf
            if (reson(i).eq.1) then
               call actami(i,0,1,0)
            endif
         end do
         if (iclon.eq.1) then
            icllow = iclpnt(1) 
            do i=0,7
               iaton(icllow+i) = 1
               iatclr(icllow+i) = 11
            end do
         endif
      endif

      return
      end

      subroutine readel(line,n)
      character*(*) line
      character*137 lstr
      common /rdwr/ iun1,iun2,iun3,iun4,iun5

      do i=1,n
        read(iun2,'(a)',err=100,end=100) lstr
      end do
      line(1:137) = lstr(1:137)
c
      return
c
100   call inferr('Premature end of file !',1)
c
      end 

      subroutine rotden(p,occ)
      implicit double precision (a-h,o-z)
      common/rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg
      dimension p(3,3),occ(3)

      do i=1,3
          do j=i,3
             sum = 0.d0
             do k=1,3
                 sum = sum + occ(k)*rmat(k,i)*rmat(k,j)
             end do
             p(j,i)=sum
             p(i,j)=sum
          end do
      end do

      return
      end

      subroutine dmat(p,vectrs,vectrb,focc,focb)

c new style atomic density matrix goes with densmat 

      implicit double precision (a-h,p-z),integer (i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      dimension p(*),vectrs(*),vectrb(*),focc(*),focb(*)
c
c   construct a density matrix from orbital occupancies
c
      do i=1,norbs
          do j=i,norbs
              sum = 0.d0
              do k=1,norbs
                  sum = sum + focc(k)*vectrs((k-1)*mxorb+i)
     &                               *vectrs((k-1)*mxorb+j)
                  if (iuhf.eq.1) then
                    if (ispd.eq.0) then
                       sum = sum + focb(k)*vectrb((k-1)*mxorb+i)
     &                                    *vectrb((k-1)*mxorb+j)
                    else
                       sum = sum - focb(k)*vectrb((k-1)*mxorb+i)
     &                                    *vectrb((k-1)*mxorb+j)
                    endif
                  endif
              end do
              p((i-1)*mxorb+j) = sum
              p((j-1)*mxorb+i) = sum
          end do
      end do

      return
      end

c OLD style atomic density matrix creator, goes with densmto

      subroutine dmato(v,pop,norbs,p)
      implicit double precision (a-h,p-w),integer   (i-n)
      common /orbhlp/ mxorb,iuhf,ispd
      dimension v(*),p(*),pop(*)
c
c   construct a density matrix from orbital occupancies
c
      do i=1,norbs
         do j=i,norbs
            sum = 0.d0
            do k=1,norbs
               sum = sum + pop(k)*v((k-1)*mxorb+i)*v((k-1)*mxorb+j)
            end do
            p((i-1)*norbs+j) = sum
            p((j-1)*norbs+i) = sum
         end do
      end do

      return
      end

      subroutine parori
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common/orihlp/ori(numatm),iuser(numatm),oalpha(numatm),
     $              obeta(numatm),norien,ibal

      norien = 0
      do k=1,natoms
          if (nat(k).eq.8.or.nat(k).eq.9.or.nat(k).eq.16
     &       .or.nat(k).eq.17) then
             norien        = norien + 1
             ori(norien)   = k
             iuser(norien) = 0
          endif
      end do

      return
      end

      subroutine asschd(idebug,ityp,iconn,q)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxamb=1590)
      parameter (mxcon=10)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      common /athlp/  iatoms, mxnat
      logical opfil,gargpl,osingl,dolbfgs,oqscal
      common /opts/ ideb,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      integer*2 ityp
      dimension q(*),ityp(*),iconn(mxcon+1,*)


      do i=1,iatoms
          if (ityp(i).gt.0.and.ityp(i).le.mxamb) then
             q(i) = ambchg(ityp(i))
          elseif (ityp(i).eq.0) then
             q(i) = 0.0e0
          endif
      end do

      call ckncys(q,ityp,iconn)

      call discq(q)

      call sumq(idebug,q)

      if (oqscal) call qscal(q)

      return
      end

      subroutine ckncys(q,ityp,iconn)
c  check for negative cysteine
      implicit real (a-h,o-z), integer ( i-n)
      parameter (numres=50000)
      parameter (mxcon=10)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      common /cyschg/ cysneg(9)
      integer*2 ityp
      dimension q(*),ityp(*),iconn(mxcon+1,*)

      do i=1,ihsres
         ineg = 0
         do j=ibeg(i),iend(i)
            if (ityp(j).eq.85) then
               if (iconn(1,j).eq.1) then
                  if (ityp(iconn(2,j)).eq.83) ineg = 1
               endif
            endif
         end do

         if (ineg.eq.1) then
            do j=ibeg(i),iend(i)
               jj = ityp(j) - 76
               if (jj.ge.1.and.jj.le.9) then
                  q(j) = cysneg(jj)
               endif
            end do
         endif

      end do

      return
      end

      subroutine sumq(idebug,q)
      implicit real (a-h,o-z), integer ( i-n)
      parameter (numres=50000)
      parameter (mxion=2000)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      common /h2oer/   numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      character*5 strion
      common /ions/    strion(2)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension q(*)
      data strion /' Cl- ',' Na+ '/

      qtot = 0.0e0
      write(iun5,'(a)') ' '
      do i=1,ihsres
         sum = 0.0e0
c         print*,'ibeg ',ibeg(i),' iend ',iend(i)
         do j=ibeg(i),iend(i)
            sum = sum + q(j)
c            print*,'   ',q(j)
         end do
         qtot = qtot + sum
         if (idebug.eq.1) 
     &      write(iun5,'(a,i5,a,f8.3)') 'res ',i,' tot charge ',sum
      end do

      nion = abs(nint(qtot))
      if (qtot.lt.0.0e0) iontyp = 2

      if (nion.ne.0) then
         write(iun5,'(a,f7.3)') ' Total charge box ',qtot
         write(iun5,'(a)') ' '
         if (.not.cell) then
            write(iun5,'(a,i4,a,a)') ' Adding ',nion,strion(iontyp),
     &                     ' ions, to neutralise box'
         endif
      endif

      write(iun5,'(a)') ' '

      return
      end

      subroutine discq(q)
      implicit real (a-h,o-z), integer ( i-n)
      parameter (numres=50000)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      logical corr
      dimension q(*)

      write(iun5,'(a)') ' '


      do i=1,ihsres
         n = iend(i) - ibeg(i) + 1
         corr = .false.
         if (n.eq.1) then

            qt = q(ibeg(i))
            rq = nint(qt)
            if (qt-rq.ne.0.0e0) then
               write(iun5,'(a,i5,a,f9.3)') ' Single atom ',ibeg(i),
     &                           ' has non integer charge: ',qt
            endif

         else if (ires(i).lt.0) then

            sum = 0.0e0
            do j=ibeg(i),iend(i)
               sum = sum + q(j)
            end do
            dis = nint(sum)
            if (abs(dis-sum).gt.0.001e0) corr = .true.

            if (corr) then
               dq = (dis - sum)/dble(n)
               sumn = 0.0e0
               do j=ibeg(i),iend(i)
                  q(j) = q(j) + dq
                  sumn = sumn + q(j)
               end do
               write(iun5,'(a,i5)') 
     &            ' Corrected total charge of residue: ',ires(i)
               write(iun5,'(a,f9.3,a,f9.3)') 
     &            '  Sum charges: old ',sum,' new ',sumn
            endif

         endif
      end do

      write(iun5,'(a)') ' '

      return
      end

      subroutine charge(ec,nac,iac,nad,iad,
     &                  coo,iconn,q,forces,potscl,iopt)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      common /athlp/  iatoms, mxnat
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      dimension vr(3),ded(3)
      dimension coo(3,*),q(*),iconn(mxcon+1,*),
     &          nac(*),nad(*),iac(mxac,*),iad(mxad,*),
     &          forces(3,*),potscl(*),iopt(*)

      econv = 332.05382e0
      v14sc = 1.0e0 / 1.2e0
      ec = 0.0e0

      do i=1,iatoms

         do j=1,iatoms
            potscl(j) = 1.0e0
         end do

         do j=1,iconn(1,i)
            jj = iconn(1+j,i)
            if (jj.gt.0) then
               potscl(jj) = 0.0e0
            endif
         end do

         do j=1,nac(i)
            potscl(iac(j,i)) = 0.0e0
         end do

         do j=1,nad(i)
            potscl(iad(j,i)) = v14sc
         end do

         do k=i+1,iatoms

            if (potscl(k).ne.0.0e0.and.
     &          (iopt(i).eq.1.or.iopt(k).eq.1) ) then

               do j=1,3
                  vr(j) = coo(j,i) - coo(j,k)
               end do

               if (box) call reddis(vr)

               r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

               if (r2.le.cutof2) then
                  r = sqrt(r2)

                  e = econv * q(i) * q(k) * potscl(k) / r

                  de = -e / r
                  de = de / r

                  do j=1,3
                     ded(j) = de * vr(j)
                  end do

                  ec = ec + e

                  do j=1,3
                     forces(j,i) = forces(j,i) + ded(j)
                     forces(j,k) = forces(j,k) - ded(j)
                  end do

               end if
            end if
         end do
      end do

      return
      end

      subroutine clmond(car,pot,coo,qat)
      implicit real (a-h,o-z), integer( i-n)
      common /athlp/ iatoms, mxnat
      dimension car(3),coo(3,*),qat(*)

      pot = 0.0e0

      do i=1,iatoms
         r2 = dist2(car,coo(1,i))
         r = sqrt(r2)
         pot = pot + qat(i)/r
      end do

      return
      end 

      subroutine qscal(q)
      implicit real (a-h,o-z), integer( i-n)
      common /passq/ scalq
      common /athlp/ iatoms, mxnat
      dimension q(*)

      print*,'Old charges:\\'
      do i=1,iatoms
         print*,i,' ',q(i)
      end do
      print*,'\\'

      print*,'New charges:\\'
      do i=1,iatoms
         q(i) = q(i)*scalq
         print*,i,' ',q(i)
      end do
      print*,'\\'

      return
      end 

      subroutine rdmodd(idebug,istatio,irtype,iesp,istats,
     &                 vectrs,vectrb,focc,focb,eiga,eigb,
     &                 nocc,nocb,ncols,ncolb,
     &                 stoalfa,stobnorm,istos,naorbs,
     &                 formax,forrms,dismax,disrms,epoints,isav)

c THIS IS REALLY rdmolf
 
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXITER=1000)
c
c     *******************************************************************
c     F.Mariotti: ADF common for store AO data
c     *******************************************************************
c
c
      common /athlp/ iatoms, mxnat

c     molecula data
      common /moldat/ natoms,norbs,nelecs,nat(numatm) 

c     atoms coordinates
      common /coord / xyz(3,numatm)

c     orbitals data, via arguments
 
      common /orbhlp/ mxorb,iuhf,ispd

c     scf convergence
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2

c     geo convergence
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt

      common /pseudo / ipseud,ivale(numatm)

c     reading and writing routines
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      character*137 line,str,tstr
      common /curlin/ line
      integer getlin,genaos
      logical doconv
      real eiga,eigb,stoalfa,stobnorm
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*)
      dimension istos(5,*),stoalfa(*),stobnorm(*)
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

c
c     ***************
c     local variables
c     ***************
c

c     Title is read but not saved in molden

      character*137 MOLTitle

c     Cell data are read but not saved in molden

      double precision dCellAng(3), dCellVec(3)

      istatio = 1
      doconv = .true.
      toang = 0.52917706d0
      isgau = 0
      istats = 0
      iatfnd = 1

c
      nelecs = 0
      relecs = 0.0d0
      norbs = 0

      if (idebug.eq.1) call inferr('subroutine rdmolf',0)
c
      irtype = 0
c
c     *********************
c     search for title line
c     *********************
c
      call rewmf
      call srchmf(line,'[Title]',istat)
c
c
      if (istat.eq.1) then
          MOLTitle = line
      else
          if (idebug.eq.1) call inferr('NO Title card found',0)
      endif

      call rewmf

c
c     ********************
c     search for Cell data
c     ********************
c

c
c     F.Mariotti COMMENT
c     Now cell data are not used. Only stored in un-common variables
c

      call srchmf(line,'[Cell]',istat)
c
      if (istat.eq.0) then
          if (idebug.eq.1) call inferr('No Cell card found',0)
          goto 5
      endif

      if (getlin(0).eq.1) then
         do i=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               dCellAng(i) = dble(itype)
            elseif (ktype.eq.3) then
               dCellAng(i) = rtype
            else
               goto 5
            endif
         end do
         do i=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               dCellVec(i) = dble(itype)
            elseif (ktype.eq.3) then
               dCellVec(i) = rtype
            else
               goto 5
            endif
         end do
      else
         goto 5
      endif

      if (idebug.eq.1) call inferr('MOLF: Cell data read',0)
c
5     call rewmf

c
c     *********************
c     search for Atoms data
c     *********************
c
c     Default in Angstroms
c     ADF/STO GTO works with xyz in au's
c

      call srchmf(line,'[Atoms]',istat)
      if (istat.eq.1) then
         if (idebug.eq.1) call inferr('ATOMS card found',0)
         if (icdex(line,'Angs').ne.0) doconv = .true.
         if (icdex(line,'AU').ne.0) doconv = .false.
      else
         call inferr('No ATOMS card found',1)
         iatfnd = 0
         goto 100
      end if
c
      natoms = 0
c
c     get coordinates line
c

      do while (getlin(0).eq.1)

c     Atom data

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.1) then
             if (index(str,'[').ne.0) goto 10
             tstr = line(1:8)
          else
             print*,line
             call inferr('string expected',1)
             goto 100
          endif

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.2) then
             na = itype
             if (na.gt.numatm) then
                call inferr('Exceeded max. number of atoms',1)
                goto 100
             endif
          else
             print*,line
             call inferr('integer expected',1)
             goto 100
          endif

c     Atoms type

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.2) then
             nat(na) = itype
          else
             print*,line
             call inferr('integer expected',1)
             goto 100
          endif

          do i=1,3
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                xyz(i,na) = rtype
             else
                print*,line
                call inferr('real expected',1)
                goto 100
             endif
          end do
      end do
c
10    if (idebug.eq.1) call inferr('MOLF: Atoms data read',0)

c
      natoms = na
      iatoms = na

      if (doconv) then
         do i=1,natoms
             do j=1,3
                xyz(j,i) = xyz(j,i) / toang  
             end do
         end do
      endif

      call xyzcoo(1,0,0)

c search for Pseudopotential records

      call rewmf
      call srchmf(line,'[PSEUDO]',istat)
      if (istat.eq.1) then
         if (idebug.eq.1) call inferr('PSEUDO card found',0)
         ipseud = 1
         do while (getlin(0).eq.1)

            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               if (index(str,'[').ne.0) goto 12
            else
               print*,line
               call inferr('string expected',1)
               goto 100
           endif

           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.2) then
              na = itype
              if (na.gt.numatm) then
                 call inferr('Exceeded max. number of atoms',1)
                 goto 100
              endif
           else
              print*,line
              call inferr('integer expected',1)
              goto 100
           endif

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.2) then
             ivale(na) = itype
          else
             print*,line
             call inferr('integer expected',1)
             goto 100
          endif

        end do

      end if

12    continue
c
c     *******************************
c     search for Atomic Orbitals data
c     *******************************
c
      call rewmf
      ibasst = 1

      call srchmf(line,'[STO]',istat)
      if (istat.eq.0) then
         if (idebug.eq.1) call inferr('No STO card found',0)

         call rdbas(idebug,1,istat)
         if (istat.eq.0) then
            print*,line
            call inferr('Error reading Basis set',1)
            goto 100
         else
            call norml
            isgau = 1
            if (idebug.eq.1) call basprt(iun3,.false.,.false.)
            call rewmf
            call srchmf(line,'[5D',istat)
            if (istat.eq.1) then
               if (icdex(line,'[5D]').ne.0.or.
     &             icdex(line,'[5D7F]').ne.0) then
                   ido5d = 1
                   ido7f = 1
               elseif (icdex(line,'[5D10F]').ne.0) then
                   ido5d = 1
               endif
            endif
            call rewmf
            call srchmf(line,'[7F]',istat)
            if (istat.eq.1) ido7f = 1
            call rewmf
            call srchmf(line,'[9G]',istat)
            if (istat.eq.1) ido9g = 1
            nbas = genaos(.true.)
            goto 20
         endif
      else
         isgau = 0
         if (idebug.eq.1) call inferr('STO card found',0)
      end if
c
      nbas = 0
      do while (getlin(0).eq.1)

c     Atom data

          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.1) then
             if (index(str,'[').ne.0) goto 20
          else
             nbas = nbas + 1
             if (nbas.gt.mxorb) then
                ibasst = 0
                goto 15
             endif

             if (ktype.eq.2) then
                istos(1,nbas) = itype
             else
                print*,line
                call inferr('real expected',1)
                goto 100
             endif
             do i=2,5
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.2) then
                   istos(i,nbas) = itype
                else
                   print*,line
                   call inferr('real expected',1)
                   goto 100
                endif
             end do

             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                stoalfa(nbas) = rtype
             else
                goto 100
             endif

             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                stobnorm(nbas) = rtype
             else
                print*,line
                print*,'expected a real number'
                goto 100
             endif

          endif
15        continue
      end do

20    continue
c
      if (idebug.eq.1) call inferr('MOLF: AO data read',0)
c
      naorbs = nbas

      if (ibasst.eq.0) then
          call inferr('AO basis larger than parameter',1)
          goto 100
      endif


c
c     **********************************
c     search for Molecular Orbitals data
c     **********************************
c
      call rewmf

      call srchmf(line,'[MO]',istat)
      if (istat.eq.0) then
         call inferr('No MO card found',0)
         goto 100
      else
         if (idebug.eq.1) call inferr('MO card found',0)
      endif
c
      nmos = 0
      iuhf = 0
      ncols = 0
      ncolb = 0

      do i=1,mxorb
         focc(i) = 0.0d0
         focb(i) = 0.0d0
      end do
      do i=1,mxorb
        ii = (i-1)*mxorb
        do j=1,mxorb
           vectrs(ii+j) = 0.0d0
           vectrb(ii+j) = 0.0d0
        end do
      end do

      do while (getlin(1).eq.1)

         ktype = nxtwrd(str,nstr,itype,rtype)

         if (ktype.eq.1) then

            if (icdex(str,'Sym').ne.0) then
               iab = 0
               ktype = nxtwrd(str,nstr,itype,rtype)
            endif

            if (icdex(str,'Ene').ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.3) ener = rtype
            endif

            if (icdex(str,'Spin').ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1) then
                  if (nstr.eq.5) then
                      iab = 0
                      ncols = ncols + 1
                      if (ncols.gt.mxorb) then
                         call inferr('N of MO larger than parameter',1)
                         goto 100
                      else
                          eiga(ncols) = real(ener)
                      endif
                  elseif (nstr.eq.4) then
                      iab = 1
                      iuhf = 1
                      ncolb = ncolb + 1
                      if (ncolb.gt.mxorb) then
                         call inferr('N of MO larger than parameter',1)
                         goto 100
                      else
                          eigb(ncolb) = real(ener)
                      endif
                  endif
               endif
            endif

            if (icdex(str,'Occup').ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.3) then
                  if (iab.eq.0) then
                     if (ncols.le.mxorb) focc(ncols) = rtype
                     relecs = relecs + rtype
                  else
                     if (ncolb.le.mxorb) focb(ncolb) = rtype
                     relecs = relecs + rtype
                  endif
               elseif (ktype.eq.2) then
                  if (iab.eq.0) then
                     if (ncols.le.mxorb) focc(ncols) = dble(itype)
                     relecs = relecs + dble(rtype)
                  else
                     if (ncolb.le.mxorb) focb(ncolb) = dble(itype)
                     relecs = relecs + dble(rtype)
                  endif
               endif
            endif

            if (index(str,'[').ne.0) goto 30

         elseif (ktype.eq.2) then
            ii = itype
            if (ii.gt.mxorb) then
               call inferr('N of MO larger than parameter',0)
               goto 100
            endif

            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               if (iab.eq.0) then
                  vectrs((ncols-1)*mxorb+ii) = rtype
               else
                  vectrb((ncolb-1)*mxorb+ii) = rtype
               endif
            else
               print*,line
               call inferr('real expected',1)
            endif
         else
            if (ktype.eq.0) goto 30
            print*,line
            call inferr('integer expected',1)
            goto 100
         endif

      end do

      nelecs = dnint(relecs)

30    norbs = nbas
      ihasd = 1
      istats = 1

100   continue
 
      if (idebug.eq.1) call inferr('MOLF: MO data read',0)
      
      call rewmf

      call srchmf(line,'[SCFCONV]',istat)

      if (istat.eq.0) then

         call inferr('No SCFCONV card found',0)

      else
         if (idebug.eq.1) call inferr('SCFCONV card found',0)

         i1or2 = 0
         do while (getlin(0).eq.1)

            ktype = nxtwrd(str,nstr,itype,rtype)

            if (ktype.eq.1) then
                
               if (icdex(str,'scf-first').ne.0) then

                  i1or2 = 1
                  icvav1 = 1
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) jstrt1 = itype
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) jend1 = itype
                  icnt = jstrt1

               elseif (icdex(str,'scf-last').ne.0) then

                  i1or2 = 2
                  icvav2 = 1
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) jstrt2 = itype
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) jend2 = itype
                  icnt = jstrt2

               elseif (index(str,'[').ne.0) then
                  goto 40
               endif

            elseif (ktype.eq.3) then

               if (i1or2.eq.1) then
                   convg1(icnt) = rtype
               elseif (i1or2.eq.2) then
                   convg2(icnt) = rtype
               endif
               icnt = icnt + 1

            endif

         end do
      endif

40    continue
      call mmcnv

      call parptr(4,convg1,fdum,idum)
 
      call rewmf

      call srchmf(line,'[GEOCONV]',istat)

      if (istat.eq.0) then

         call inferr('No GEOCONV card found',0)

      else
         if (idebug.eq.1) call inferr('GEOCONV card found',0)

         nepnts = 0
         do while (getlin(0).eq.1)
            ktype = nxtwrd(str,nstr,itype,rtype)

            if (ktype.eq.1) then

               if (index(str,'[').ne.0) goto 50

               if (icdex(str,'energy').ne.0) then
                  iopt = 1
                  ieav = 1
               endif
               if (icdex(str,'max-f').ne.0) then
                  iopt = 2
                  ifmxav = 1
                  ngeoms = 0
               endif
               if (icdex(str,'rms-f').ne.0) then
                  iopt = 3
                  ifrmav = 1
                  ngeoms = 0
               endif
               if (icdex(str,'max-s').ne.0) then
                  iopt = 4
                  idmxav = 1
                  ngeoms = 0
               endif
               if (icdex(str,'rms-s').ne.0) then
                  iopt = 5
                  idrmav = 1
                  ngeoms = 0
               endif
 
               if (str(1:1).eq.'-') then
                  ngeoms = ngeoms + 1
                  isav(ngeoms) = 0
               endif

            elseif (ktype.eq.3) then

               if (iopt.eq.1) nepnts = nepnts + 1
               if (iopt.gt.1) then
                  ngeoms = ngeoms + 1
                  isav(ngeoms) = 1
               endif

               if (iopt.eq.1) then
                  epoints(nepnts) = rtype
               elseif (iopt.eq.2) then
                  formax(ngeoms) = rtype
               elseif (iopt.eq.3) then
                  forrms(ngeoms) = rtype
               elseif (iopt.eq.4) then
                  dismax(ngeoms) = rtype
               elseif (iopt.eq.5) then
                  disrms(ngeoms) = rtype
               endif

            endif

         end do
      endif

50    continue


      call rewmf

      call srchmf(line,'[GEOMETRIES]',istat)

      if (istat.eq.0) then

         call inferr('No GEOMETRIES card found',0)

      else
         if (idebug.eq.1) call inferr('GEOMETRIES card found',0)
         ihasg = 1
         if (icdex(line,'ZMAT').ne.0) ihasg = 2
         igcvav = 1
      endif

      call rewmf

      call srchmf(line,'[FORCES]',istat)
      if (istat.eq.0) then
         ifrav = 0 
         call inferr('No FORCES card found',0)
      else
         ifrav = 1 
         if (idebug.eq.1) call inferr('FORCES card found',0)
      endif

      call rewmf

      call srchmf(line,'[FREQ]',istat)

      if (istat.eq.0) then

         call inferr('No FREQ card found',0)

      else
         irtype = 4
         if (idebug.eq.1) call inferr('FREQ card found',0)
         if (iatfnd.ne.1) then
             call getfra(istat)
             call getint(istat)
         endif
      endif

      call rdsrf(iun2,istat,iesp,0,idebug)

      return
      end

      subroutine prtmold(iun,ihaszm,ipoints,
     &                 vectrs,vectrb,focc,focb,eiga,eigb,
     &                 nocc,nocb,ncols,ncolb,
     &                 stoalfa,stobnorm,istos,naorbs,
     &                 formax,forrms,dismax,disrms,epoints,isav,ianz)
c
c THIS IS REALLY prtmolf
c
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (MAXITER=1000)
      parameter (MAXPNT=2000)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)

c [GTO]
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /moldat/ natoms,norbs,nelecs,nat(numatm) 
c [ATOMS]
      common /coord / xyz(3,numatm)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
c [SCFCONV]
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
c [GEOCONV]
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
c [FREQ]
      common /athlp/ iatoms, mxnat
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /pseudo / ipseud,ivale(numatm)
c
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
c [STO],[MO]
      common /orbhlp/ mxorb,iuhf,ispd
      real eiga,eigb,stoalfa,stobnorm
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*)
      dimension istos(5,*),stoalfa(*),stobnorm(*)
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)
      dimension ifrcs(MAXPNT),ianz(*)


      iunt = iun3
      iun3 = iun
      toang = 0.52917706d0

      write(iun3,'(a)') '[Molden Format]'

      if (ihasd.eq.0) goto 50

c [ATOMS]
      write(iun3,'(a)') '[Atoms] Angs'

      fact = toang
      do i=1,natoms
          write(iun3,'(a2,1x,i5,1x,i2,3(1x,f12.6))')
     &       elemnt(nat(i)),i,nat(i),(xyz(j,i)*fact,j=1,3)
      end do
      
      
      if (isgau.eq.1) then
         if (ido5d.eq.1.and.ido7f.eq.1) then
             write(iun3,'(a)') '[5D7F]'
         elseif (ido5d.eq.1.and.ido7f.eq.0) then
             write(iun3,'(a)') '[5D10F]'
         elseif (ido5d.eq.0.and.ido7f.eq.1) then
             write(iun3,'(a)') '[7F]'
         elseif (ido9g.eq.1) then
             write(iun3,'(a)') '[9G]'
         endif
c [PSEUDO]
         if (ipseud.eq.1) then
             write(iun3,'(a)') '[PSEUDO]'
             do i=1,natoms
                write(iun3,'(a2,1x,i5,1x,i3)')
     &                elemnt(nat(i)),i,ivale(i)
             end do
         endif
c [GTO]
         write(iun3,'(a)') '[GTO]'
         call basprt(iun3,.true.,.false.)
      else
c [STO]
         write(iun3,'(a)') '[STO]'
         do i=1,norbs
             write(iun3,'(5(i5,1x),2(f10.4,1x))')
     &         (istos(j,i),j=1,5),stoalfa(i),stobnorm(i)
         end do
      endif

100   format(i4,1x,f10.6)

c [MO]
      write(iun3,'(a)') '[MO]'
      do i=1,ncols
         write(iun3,'(a,f10.4)') ' Ene= ',eiga(i)
         write(iun3,'(a)') ' Spin= Alpha'
         write(iun3,'(a,f10.6)') ' Occup= ',focc(i)
         do j=1,norbs
            write(iun3,100) j,vectrs((i-1)*mxorb+j)
         end do
      end do

      if (iuhf.eq.1) then
         do i=1,ncolb
            write(iun3,'(a,f10.4)') ' Ene= ',eigb(i)
            write(iun3,'(a)') ' Spin= Beta'
            write(iun3,'(a,f10.6)') ' Occup= ',focb(i)
            do j=1,norbs
               write(iun3,100) j,vectrb((i-1)*mxorb+j)
            end do
         end do
      endif

50    continue

c [SCFCONV]
      if (icvav1.eq.1.or.icvav2.eq.1) then
         write(iun3,'(a)') '[SCFCONV]'
         if (icvav1.eq.1) then
            write(iun3,'(a,i4,a,i4)') 
     &          'scf-first ',jstrt1,' THROUGH ',jend1
            do i=jstrt1,jend1
                write(iun3,'(f14.6)') convg1(i)
            end do
         endif
         if (icvav2.eq.1) then
            write(iun3,'(a,i4,a,i4)') 
     &          'scf-last ',jstrt2,' THROUGH ',jend2
            do i=jstrt2,jend2
                write(iun3,'(f14.6)') convg2(i)
            end do
         endif
      endif

c [GEOCONV]
      i = ieav + ifmxav + ifrmav + idmxav + idrmav
      if (i.ne.0) then
         write(iun3,'(a)') '[GEOCONV]'

         if (ieav.eq.1) then
            write(iun3,'(a)') 'energy'
            do i=1,nepnts
               write(iun,'(f14.6)') epoints(i)
            end do
         endif

         if (ifmxav.eq.1) 
     &      call prtarr(iun3,'max-force',formax,ngeoms,isav)

         if (ifrmav.eq.1) 
     &      call prtarr(iun3,'rms-force',forrms,ngeoms,isav)

         if (idmxav.eq.1) 
     &      call prtarr(iun3,'max-step',dismax,ngeoms,isav)

         if (idrmav.eq.1) 
     &      call prtarr(iun3,'rms-step',disrms,ngeoms,isav)

      endif

      call rewmf

      if (ipoints.gt.1.or.ihasd.eq.0) then

         if (ihaszm.eq.1) then
             write(iun3,'(a)') '[GEOMETRIES] ZMAT'
         else
             write(iun3,'(a)') '[GEOMETRIES] XYZ' 
         endif

         if (ipoints.le.1.and.ihasd.eq.0) then
            if (ihaszm.eq.1) then
               call wrzmat(iun3,1)
            else
               call wrcart(iun3,0,0,0)
            endif
         else
            do i=1,ipoints
                call getpoi(i,0,0,1,idum,0)
                ifrcs(i) = 0
                if (ifav.eq.1) ifrcs(i) = 1
                if (ihaszm.eq.1) then
                   call wrzmat(iun3,1)
                else
                   call wrcart(iun3,0,0,0)
                endif
            end do
         endif
      endif

c [FORCES]
      if (ipoints.gt.1) then
         ifpts = 0
         do i=1,ipoints
            if (ifrcs(i).eq.1) ifpts = ifpts + 1
         end do
         if (ifpts.gt.0) then
            call rewmf
            if (iftyp.eq.3) then
               write(iun3,'(a)') '[FORCES] COORD'
            else
               write(iun3,'(a)') '[FORCES]'
            endif
            do i=1,ipoints
               call getpoi(i,0,0,1,idum,0)
               if (ifav.eq.1) then
                  write(iun3,'(a,i4)') 'point ',i
                  call wrfc(iun3)
               endif
            end do
         endif
      endif

c [FREQ]
      if (irtype.eq.4) then

         write(iun3,'(a)') '[FREQ]'
         do i=1,nfreq
            write(iun3,'(f10.4)') freq(i)
         end do

         if (ihasi.ne.0) then
            write(iun3,'(a)') '[INT]'
            do i=1,nfreq
               if (iabs(ihasi).eq.1) then
                  write(iun3,'(f10.4)') frint(i)
               elseif (iabs(ihasi).eq.2) then
                  write(iun3,'(f10.4,1x,f10.4)') frint(i),ramint(i)
               endif
            end do
         endif

         write(iun3,'(a)') '[FR-COORD]'
         do i=1,iatoms
             write(iun3,'(a2,1x,3(f12.6,1x))') 
     &        elemnt(ianz(i)),(fcoo(j,i),j=1,3)
         end do

         write(iun3,'(a)') '[FR-NORM-COORD]'
         do i=1,nfreq

            write(iun3,'(a,i5)') 'vibration ',i
            if (iftyp.eq.1) then
                call mcoord(0,i,istat)
            elseif (iftyp.eq.2.or.iftyp.eq.3) then
                if (iftyp.eq.3) then
                   call ucoorg(0,i,istat)
                else
                   call ncoorg(0,i,istat)
                endif
            elseif (iftyp.eq.4) then
                call ncoord(0,i,istat)
            endif

            do k=1,iatoms
                write(iun3,'(3(f12.6,1x))') (a(j,k),j=1,3)
            end do

         end do

      endif

      iun3 = iunt

      return
      end

      subroutine prtarr(iun,str,arr,narr,isav)
      implicit double precision (a-h,o-z)
      character*(*) str
      dimension arr(*),isav(*)

      write(iun,'(a)') str
      do i=1,narr
         if (isav(i).eq.1) then
            write(iun,'(f14.6)') arr(i)
         else
            write(iun,'(a)') '-'
         endif
      end do

      return
      end

      subroutine parsmd(molin)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,caps
      character*40 title
      character*2 gstr
      dimension molin(*)
      
      call rewfil

      imol = 1
      molin(1) = 0
      nmols = 0
      ilin = 0

c      call srchmf(line,'[MULTIMOL]',istat)
c      if (istat.ge.1) then


1        call nxtlin(line,jstat)
         if (jstat.eq.1) goto 100
         if (jstat.eq.2) goto 200
         caps = line
         len1  = len(line)
         call tocap(caps,len1)
         ilin = ilin + 1
         if (index(caps,'[TITL').ne.0) then
            call nxtlin(line,jstat)
            if (jstat.eq.1) goto 100
            if (jstat.eq.2) goto 200
            title = line(1:40)
            ilin = ilin + 1
         endif
         if (index(caps,'[MOLE').eq.0) goto 1

         if (nmols.lt.maxmol) then
            nmols = nmols + 1
            molin(nmols) = ilin
            if (nmols.gt.1) call parsfn(title,linlen(title),13)
            title = 'molecule '//gstr(nmols)
         endif

         goto 1

c      endif

100   ielin = ilin
      if (nmols.eq.0) then
         nmols = 1
         title = 'molecule '//gstr(nmols)
      endif
      call parsfn(title,linlen(title),13)

      return

200   return
      end

      subroutine srchmf(line,name,istat)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /mflin/ linmf
      character*(*) line,name
      character*80 caps
      character*137 caps2

      istat = 0
      caps  = name  
      len1  = len(name)
      call tocap(caps,len1)
1     call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200

      linmf = linmf + 1
      if (linmf.gt.iendmf) goto 100
      caps2 = line
      len2 = len(line)
      call tocap(caps2,len2)
      if (index(caps2(1:len2),caps(1:len1)).eq.0) goto 1
 
      istat = 1
      return

100   call rewmf
      return

200   continue
      print*,'error search mf'

      return
      end 

      subroutine srcdmf(line,name1,name2,istat)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /mflin/ linmf
      character*(*) line,name1,name2
      character*80 caps
      character*137 caps1,caps2

      istat = 0
      caps1  = name1
      caps2  = name2
      len1  = len(name1)
      len2  = len(name2)
      call tocap(caps1,len1)
      call tocap(caps2,len2)

1     call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200

      linmf = linmf + 1
      if (linmf.gt.iendmf) goto 100
      if (index(line,name1).eq.0.and.index(line,name2).eq.0
     &.and.index(line,caps1(1:len1)).eq.0
     &.and.index(line,caps2(1:len2)).eq.0) go to 1

 
      istat = 1
      return

100   call rewmf
      return

200   continue
      print*,'error searchd mf'

      return
      end 

      subroutine srctmf(line,name1,name2,name3,istat)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /mflin/ linmf
      character*(*) line,name1,name2,name3
      character*80 caps
      character*137 caps1,caps2,caps3

      istat = 0
      caps1  = name1
      caps2  = name2
      caps3  = name3
      len1  = len(name1)
      len2  = len(name2)
      len3  = len(name3)
      call tocap(caps1,len1)
      call tocap(caps2,len2)
      call tocap(caps3,len3)
1     call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200

      linmf = linmf + 1
      if (linmf.gt.iendmf) goto 100
      if (index(line,name1).eq.0.and.index(line,name2).eq.0
     &    .and.index(line,name3).eq.0
     &.and.index(line,caps1(1:len1)).eq.0
     &.and.index(line,caps2(1:len2)).eq.0
     &.and.index(line,caps3(1:len3)).eq.0) go to 1

 
      istat = 1
      return

100   call rewmf
      return

200   continue
      print*,'error searchd mf'

      return
      end 

      subroutine rdmf(line,cline,istat)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /mflin/ linmf
      character*(*) line,cline

      istat = 0
      call nxtlin(line,jstat)
      if (jstat.eq.1) goto 100
      if (jstat.eq.2) goto 200

      linmf = linmf + 1
      if (linmf.gt.iendmf) goto 100
      cline = line
      len2 = len(line)
      call tocap(cline,len2)

      istat = 1
      return

100   call rewmf
      return

200   continue
      print*,'error search mf'
      return
c
c
      end 

      subroutine rewmd(molin)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /mflin/ linmf
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*137 line
      dimension molin(*)

      call rewfil
      linmf = 0

      imol2 = imol
      if (imol.eq.0) imol2=1
      
      do i=1,molin(imol2)
          call nxtlin(line,jstat)
          if (jstat.eq.1) goto 100
          if (jstat.eq.2) goto 200

          linmf = linmf + 1
      end do
      call bckfil
      linmf = linmf - 1

      if (imol.ge.nmols) then
         iendmf = ielin
      else
         iendmf = molin(imol+1)
      endif

      return

100   continue
200   continue
      print*,'error rewind mf'
      return

      end 

      subroutine setmf(im)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin

      imol = im
      if (im.gt.nmols) imol = nmols

      return
      end 

      integer function getmf()
      integer linmf
      common /mflin/ linmf

      getmf = linmf

      return
      end 

      subroutine putmf(iline)
      implicit double precision (a-h,o-z)
      common /mflin/ linmf
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*137 line

      call rewfil

      do i=1,iline
          call nxtlin(line,jstat)
          if (jstat.eq.1) goto 100
          if (jstat.eq.2) goto 100
      end do
      call bckfil

      linmf = iline

100   return
      end 

      subroutine wrfd(iun3,coo)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (maxfat=1000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat
      logical ctoz,molpot,elpot,chpot
      common /choic/ iftyp,isbin,ctoz,molpot,elpot,chpot
      dimension coo(3,*)


      fsgn = 1.0d0
      if (iftyp.eq.2.or.iftyp.eq.3) fsgn = -1.0d0

      write(iun3,'(i4)') iatoms
      do i=1,iatoms
         if (iftyp.eq.3) then
            write(iun3,'(6(1x,f12.6))') (fsgn*fxyz(j,i),j=1,3),
     &            (coo(j,i),j=1,3)
         else
            write(iun3,'(3(1x,f12.6))') (fsgn*fxyz(j,i),j=1,3)
         endif
      end do

      return
      end

      subroutine rdfd(ipnt,istats,coo)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (mxel=100)
      parameter (maxfat=1000)
      logical gnreal,addcoo
      integer getlin
      character*137 str
      character*137 line
      common /curlin/ line
      common /athlp/ iatoms, mxnat
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      dimension ftmp(3),coo(3,*)

      istats = 1
      addcoo = .false.

c      print*,'rdfc point ',ipnt
      call rewmf
      call srchmf(line,'[FORCES]',istat)
      if (istat.eq.1) then
         if (icdex(line,'COORD').ne.0) addcoo = .true.
      else
         goto 100
      endif

      do while(.true.)
         call srchmf(line,'point',istat)
         if (istat.eq.1) then
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.2) then
                  if (itype.eq.ipnt) goto 10
               else
                  goto 100
               endif
            else
               goto 100
            endif
         else
            goto 100
         endif
      end do

10    if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            iatoms = itype
         else
            goto 100
         endif
      else
         goto 100
      endif

      do i=1,iatoms
         if (getlin(0).eq.1) then
            if (.not.gnreal(ftmp,3,.false.)) goto 100
            do j=1,3
               fxyz(j,i) = ftmp(j)
            end do
c            print*,'fxyz ',i,' ',(fxyz(j,i),j=1,3)
            if (addcoo) then
               if (.not.gnreal(coo(1,i),3,.false.)) goto 100
            endif
         else
            goto 100
         endif
      end do

      return

100   istats = 0
      return
      end

      subroutine prsgmd(iopt,molin)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,caps
      character*40 title
      character*2 gstr
      dimension molin(*)
      
      call rewfil

      imol = 1
      molin(1) = 0
      nmols = 0
      ilin = 0


1        call nxtlin(line,jstat)
         if (jstat.eq.1) goto 100
         if (jstat.eq.2) goto 200

         if ((iopt.eq.3.or.iopt.eq.1).and.nmols.eq.0) then
            ilin = ilin + 1
            nmols = 1
            molin(nmols) = ilin
            if (iopt.ne.1) call parsfn(line,linlen(line),13)
            call nxtlin(line,jstat)
            if (jstat.eq.1) goto 100
            if (jstat.eq.2) goto 200
            if (iopt.eq.1) call parsfn(line,linlen(line),13)

         endif
         caps = line
         len1  = len(line)
         call tocap(caps,len1)
         ilin = ilin + 1
         if (iopt.eq.1) then
            if (index(caps,'@<TRIPOS>MOLECULE').eq.0) goto 1
         elseif (iopt.eq.2) then
            if (index(caps,'* O   R   C   A *').eq.0) goto 1
         elseif (iopt.eq.3) then
            if (index(caps,'$$$$').eq.0) goto 1
         elseif (iopt.eq.4) then
            if (index(caps,'PREPARE MODULE').ne.0) then
                if (nmols.ge.0) nmols = nmols - 1
            endif
            if (index(caps,'QM/MM INTERFACE MODULE').ne.0) then
                if (nmols.ge.0) nmols = nmols - 1
            endif
            if (index(caps,'NWCHEM INPUT MODULE').eq.0) goto 1
         endif

         if (nmols.lt.maxmol) then
            nmols = nmols + 1
            molin(nmols) = ilin
            if (iopt.eq.1) then
               call nxtlin(line,jstat)
               if (jstat.eq.1) goto 100
               if (jstat.eq.2) goto 200

               if (line(1:16).eq.'Molden generated') then
                  title = line(18:40)
               else
                  title = line(1:40)
               endif
               ilin = ilin + 1
               call parsfn(title,linlen(title),13)
            elseif (iopt.eq.2) then
               title = 'molecule '//gstr(nmols)
               if (nmols.gt.1) call parsfn(title,linlen(title),13)
            elseif (iopt.eq.3) then

               call nxtlin(line,jstat)
               if (jstat.eq.1) goto 100
               if (jstat.eq.2) goto 200

               ilin = ilin + 1
               molin(nmols) = ilin
               call parsfn(line,linlen(line),13)
            elseif (iopt.eq.4) then
               call redel(line,4)
               ilin = ilin + 4
               call lsparm(line,ll)
               if (index(line,'WARN').ne.0) ll = 0
               do while(ll.eq.0.or.ll.eq.1)
                  call redel(line,1)
                  ilin = ilin + 1
                  call lsparm(line,ll)
               end do 
               title = line(1:40)
               molin(nmols) = ilin
               call parsfn(title,linlen(title),13)
            endif
         endif

         goto 1


100   ielin = ilin
      if (nmols.eq.0) then
         nmols = 1
         title = 'molecule '//gstr(nmols)
      endif
      if (iopt.eq.3) then
         nmols = nmols + 1
         molin(nmols) = ilin
      endif
      if (iopt.eq.3.or.iopt.eq.4) then
         nmols = nmols - 1
      else
         if (iopt.ne.1) then
            call parsfn(title,linlen(title),13)
         endif
      endif

      return

200   return
      end


      subroutine rotfil
      implicit double precision (a-h,o-z)
      integer getlin
      logical gnreal,opfil
      common /filrot/ctmp(3,3),ir3(3)
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,str,tstr

      toang = 0.52917706d0
      iun2t = iun2
      iun2 = 46

      if (opfil(46,'rotfil',6,1,1,0)) then
         i = 0
         do while (.true.)
         if (getlin(0).eq.1) then
               i = i + 1
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.2) then
                  ir3(i) = itype
               else
                  goto 100
               endif
               if (.not.gnreal(ctmp(1,i),3,.false.)) goto 100
               do j=1,3
                  ctmp(j,i) = ctmp(j,i) / toang
               end do
         else
            goto 10
         endif
         end do
10       print*,'ir3=',(ir3(i),i=1,3)
         print*,'ctmp(1,1)=',(ctmp(i,1),i=1,3)
         print*,'ctmp(1,2)=',(ctmp(i,2),i=1,3)
         print*,'ctmp(1,3)=',(ctmp(i,3),i=1,3)
      endif

      iun2 = iun2t
      return

100   print*,'error parsing rotfil'
      iun2 = iun2t
      return
      end

csg      subroutine crpsin(a,b,c,d)
csgc
csgc       calculates cross product:  (b-a) x (c-a) = d
csgc                                   ---     ---    -
csg      implicit real (a-h,o-z)
csg      dimension a(3),b(3),c(3),d(3)
csg      dimension v1(3),v2(3)
csg      do 10 i=1,3
csg         v1(i)=b(i)-a(i)
csg         v2(i)=c(i)-a(i)
csg10    continue
csgc
csg      d(1)=v2(2)*v1(3)-v2(3)*v1(2)
csg      d(2)=v2(3)*v1(1)-v2(1)*v1(3)
csg      d(3)=v2(1)*v1(2)-v2(2)*v1(1)
csg      dlen=sqrt(d(1)**2+d(2)**2+d(3)**2)
csg      do 20 i=1,3
csg20       d(i)=d(i)/dlen
csg      return
csg      end
csg      subroutine sgdisp
csg#include <gl/fgl.h>
csg#include <gl/fdevice.h>
csg      integer*4 iang,jang,kang
csg      dimension amat(15),alt(10),al(12),bmat(15),umat(4,4)
csg      data amat/ambien,.1,.1,.1,diffus,.200,.369,.065,
csg     &          specul,.5,.5,.5,shinin,30.0,lmnull/
csg      data bmat/ambien,.0,.0,.0,diffus,.0,.0,.0,
csg     &          specul,.0,.0,.0,shinin,.0,lmnull/
csg      data umat/1.0,0.0,0.0,0.0,
csg     &          0.0,1.0,0.0,0.0,
csg     &          0.0,0.0,1.0,0.0,
csg     &          0.0,0.0,0.0,1.0/
csg      data alt/lcolor,.8,1.0,.8,positi,2.,2.,2.,1.,lmnull/
csg      data al/ambien,.4,.1,.1,localv,0,twosid,1,attenu,.5,.1,lmnull/
csgc      data al/ambien,.1,.1,.1,localv,0.,twosid,0.,lmnull/
csg      call prefpo(0,1500,0,1200)
csg      call winope("molden",6)
csg      call zbuffe(.true.)
csg      call double
csg      call rgbmod
csg      call gconfi
csg      call mmode(mviewi)
csg      call loadma(umat)
csg      call ortho(-40.0,40.0,-40.0,40.0,-40.0,40.0)
csg      call lmdef(defmat,1,0,amat)
csg      call lmdef(deflig,2,0,alt)
csg      call lmdef(deflmo,3,0,al)
csg      call lmbind(materi,1)
csgc      call lmbind(backma,1)
csg      call lmbind(light0,2)
csg      call lmbind(lmodel,3)
csg      iang=0
csg      jang=0
csg      kang=0
csg      do 100 i=0,1000
csg         call pushma 
csg         call rotate(iang,'x')
csg         call rotate(jang,'y')
csg         call rotate(kang,'z')
csg         iang=iang+10
csg         jang=jang+13
csg         if(iang+jang.gt.3000)kang=kang+17
csg         if(iang.gt.3600) iang=iang-3600
csg         if(jang.gt.3600) jang=jang-3600
csg         if(kang.gt.3600) kang=kang-3600
csg         call cpack($0)
csg         call clear
csg         call zclear
csg         call drawsf
csg         call swapbu
csg         call popmat
csg100   continue
csg      return
csg      end
csg      subroutine drawsf
csg#include <gl/fgl.h>
csg#include <gl/fdevice.h>
csg      common /sgcon/ vec1(3,12800),vec2(3,12800),vec3(3,12800),
csg     &          vnorm(3,12800),npol
csg      do 100 i=1,npol
csg      call bgnpol
csg         call n3f(vnorm(1,i))
csg         call v3f(vec1(1,i))
csg         call v3f(vec2(1,i))
csg         call v3f(vec3(1,i))
csg      call endpol
csg100   continue
csg      return
csg      end

      subroutine eem(iop,iasel,istat)
c
c     program for the calculation of eem parameters
c     patrick bultinck, jrf, 2001
c
c     J. Phys. Chem. A (2002)
c
      implicit double precision(a-h,o-z)
      parameter (mxeat=300)
      dimension var(mxeat,2),ipntr(mxeat)

      istat = 0
      numat = 0
      call valdis(var,ipntr,numat,iop,iasel,istat)
      if (istat.eq.0) call eemcalc(var,ipntr,numat)

   
      return

      end

      subroutine valdid(var,ipntr,numat,iop,iasel,istat,
     &                  ianz,iresid,qat)

      implicit double precision(a-h,o-z), integer (i-n)
      parameter (mxeat=300)
      parameter (maxtyp=19)
      parameter (mxtyp4=4*maxtyp)
      parameter (mxel=100)
      parameter (mexcl=10)

      common /eempar/param(maxtyp,2),pparam(maxtyp,2),
     &               peparm(10,2),esffprm(19,2),ipt(mxel,4)
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /metexc/ qexcl(mexcl),ianexc(mexcl)
      dimension ianz(*),iresid(*),qat(*),var(mxeat,2),ipntr(mxeat)

c eem NPA

      data ((param(i,k),k=1,2),i=1,maxtyp) /
     & -0.00298,0.89729,0.54541,0.00000,0.93882,0.00000,
     &  0.00000,0.10570,0.00000,0.61634,0.35970,0.33639,
     &  0.53938,0.37574,1.04219,0.72138,1.44195,1.57956,
     &  0.28351,0.00000,0.00000,0.00000,0.00000,0.00000,
     &  0.00000,0.00000,0.00000,0.00000,0.00000,0.00000,
     &  0.00000,0.00000,0.00000,0.00000,0.00000,0.00000,
     &  0.00000,0.00000/
c eem Mull + P en CL estimated
      data ((pparam(i,k),k=1,2),i=1,maxtyp) /
     &  0.20606,0.65971,0.00000,0.00000,0.00000,0.75331,
     &  0.00000,0.00000,0.00000,0.00000,0.36237,0.32966,
     &  0.49279,0.34519,0.73013,0.54428,0.72052,0.72664,
     &  0.78058,0.75467,0.00000,0.00000,0.00000,0.00000,
     &  0.00000,0.00000,0.00000,0.00000,0.36200,0.32000,
     &  0.00000,0.00000,0.41200,0.36600,0.00000,0.00000,
     &  0.00000,0.00000/
c
c Pesp, eem parameters
c        khi       eta      atom    MMtype                      Definition
c    0.68903   0.39888         1         H                 common hydrogen
c    0.71998   0.34395         6         C                   common carbon
c    0.97104   0.46763         7         N                 common nitrogen
c    0.95419   0.43623         8         O                   common oxigen
c    0.78155   0.24617        16         S                  common sulphur
c    0.67920   0.17446        12        Mg                common magnesium
c    0.98387   0.13229        15         P               common phosporous
c    0.86408   0.40514         9         F                 common fluorine
c    0.76957   0.17213        17        Cl                 common chlorine
c    0.77709   0.15474        35        Br                  common bromine
c    0.31627   0.90661         1       HAc                   acidic proton
c    0.58475   0.54282         1       Hpo         H bound to electrophile
c    0.61286   0.82238         1       Hpm    H bound to weak electrophile
c    0.67301   0.72481         1        HC        H bound to alkane carbon
c    0.68654   0.67974         1       HC3                       H in -CH3
c    0.54822   0.44969         6        CO                 carbonil carbon
c    0.79906   0.33085         6       CAr                 aromatic carbon
c    0.75858   0.28429         6      CArp       polarized aromatic carbon
c    0.72259   0.28054         6        CT                      sp3 carbon
c    0.84720   0.70094         6       CT3                  carbon in -CH3
c    0.78794   0.30423         6        CX                      sp2 carbon
c    0.85476   0.38483         6        CZ                       sp carbon
c    0.91123   0.40572         7        NT                    sp3 nitrogen
c    0.48744   0.43578         7        Np     quaterner positive nitrogen
c    0.80779   0.28151         7        NX                    sp2 nitrogen
c    0.98950   0.48874         7        NZ                     sp nitrogen
c    1.15452   0.50429         7       NAr               aromatic nitrogen
c    0.77898   0.35097         7      NArp      aromatic-positive nitrogen
c    0.71947   0.31954         7       NCO                  amide nitrogen
c    0.96737   0.43334         8        OH                       OH oxigen
c    0.65563   0.29674         8        Op                 positive oxigen
c    1.10775   0.41545         8        On                      oxidanione
c    0.81599   0.35269         8       OAr                 aromatic oxigen
c    0.82099   0.26674         8       Oox                      oxo-oxigen
c    0.84823   0.33950         8        OS                 aetheric oxigen
c    0.69661   0.25867         8      OAcH                acidic OH oxigen
c    0.77413   0.25308        16       SAc                sulphate sulphur
c    0.88299   0.41097        16        ST                     sp3 sulphur
c    0.84700   0.26207        16        SX                     sp2 sulphur
c
c currently only common types implemented HCNOF Mg P S Cl Br
c
      data ((peparm(i,k),k=1,2),i=1,10) /
     &  0.68903,0.39888,
     &  0.71998,0.34395,
     &  0.97104,0.46763,
     &  0.95419,0.43623,
     &  0.86408,0.40514,
     &  0.67920,0.17446,
     &  0.98387,0.13229,
     &  0.78155,0.24617,
     &  0.76957,0.17213,
     &  0.77709,0.15474/

c from ESFF parameterisation
c
c 1,2   H,H+
c 3-5   Csp3, Csp2, Csp
c 6-8   Nsp3, Nsp2, Nsp
c 9-11  Osp3, Osp2, Osp
c 12    F
c 13-14 Psp3, Psp2
c 15-16 Ssp3, Ssp2
c 17    Cl
c 18    Br
c 19    I
c
c hybridisation specific currently not used, only first atom 

      data ((esffprm(i,k),k=1,2),i=1,19) /
     &  0.233,0.440,0.252,0.440,
     &  0.2904,0.382,0.316,0.384,0.366,0.389,
     &  0.392,0.454,0.419,0.454,0.490,0.464,
     &  0.480,0.518,0.527,0.519,0.625,0.529,
     &  0.431,0.582,
     &  0.306,0.309,0.323,0.311,
     &  0.365,0.346,0.399,0.349,
     &  0.328,0.374,
     &  0.300,0.343,
     &  0.358,0.304/

c eem NPA supported elements HCNOF

      data (ipt(i,1),i=1,mxel) /1,0,
     1        0,0,0,6,7,8,9,0,
     2        0,0,0,0,0,0,0,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     4        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     5        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     4        0,0,0,0,0/

c eem Mull supported elements HCNOF + est. P Cl

      data (ipt(i,2),i=1,mxel) /1,0,
     1        0,0,0,6,7,8,9,0,
     2        0,0,0,0,15,0,17,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     4        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     5        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     4        0,0,0,0,0/

c eem PESP supported elements HCNOF Mg P S Cl Br

      data (ipt(i,3),i=1,mxel) /1,0,
     1        0,0,0,2,3,4,5,0,
     2        0,6,0,0,7,8,9,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,
     4        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     5        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     4        0,0,0,0,0/


c eem ESFF supported elements HCNOF  P S Cl Br I
c plus hybridisation specific, currently not used
 
      data (ipt(i,4),i=1,mxel) /1,0,
     1        0,0,0,3,6,9,12,0,
     2        0,0,0,0,13,15,17,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,
     4        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,
     5        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     3        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     4        0,0,0,0,0/

      istat = 0

      icnt = 0
      ioverf = 0

      do i=1,iatoms
          if (iasel.gt.0.or.(iasel.lt.-3.and.iasel.eq.iresid(i)) )
     &    then

            iexcl = 0
            do k=1,mexcl
               if (ianz(i).eq.ianexc(k)) then
                  iexcl = 1
                  qat(i) = qexcl(k)
                  print*,' '
                  print*,'Excluded metal center ',ianz(i)
                  print*,'Set formal charge: ',qat(i)
                  print*,' '
               endif
            end do

            if (ianz(i).eq.100) iexcl = 1

            if (iexcl.eq.0) then
             icnt = icnt + 1
             if (icnt.lt.mxeat) then
                ipntr(icnt) = i
                do j=1,2
                   ipatm = ipt(ianz(i),iop)
                   if (ipatm.eq.0) then
                      call inferr(
     &                 'no parameters for element '//elemnt(ianz(i)),0)
                      ihasq = 0
                      istat = 1
                      return
                   endif
                   if (iop.eq.1) then
c NPA
                      var(icnt,j) = param(ipatm,j)
                   elseif (iop.eq.2) then
c Mull
                      var(icnt,j) = pparam(ipatm,j)
                   elseif (iop.eq.3) then
c PESP
                      var(icnt,j) = peparm(ipatm,j)
                   elseif (iop.eq.4) then
c ESFF
                      var(icnt,j) = esffprm(ipatm,j)
                   endif
                end do
c                print*,i,' ',ianz(i),(var(icnt,j),j=1,2)
             else
                icnt = mxeat
                ioverf = 1
             endif

            endif
          endif
      end do

      if (ioverf.eq.1) then
          call inferr(
     &     'increase parameter mxeat in subroutine valdis',0)
      endif

      numat = icnt

      return
      end

      subroutine eemcald(var,ipntr,numat,ianz,coo,qat)
c
      implicit double precision(a-h,o-z), integer (i-n)
      parameter (mxeat=300)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /totchg/ itot
      common /athlp/ iatoms, mxnat
      dimension det(2)
      dimension coo(3,*),qat(*),ianz(*)
      dimension var(mxeat,2),ipntr(mxeat),work(mxeat+1,mxeat+1)
      dimension x(mxeat+1,mxeat+1),y(mxeat+1), ipvt(mxeat+1),q(mxeat+1)

      do i=1,(numat-1)
         x(i,i)       = 2*var(i,2)
         x(i,numat+1) = -1
         x(numat+1,i) = 1

         do j=i+1,numat
            x(i,j) = ( coo(1,ipntr(i)) - coo(1,ipntr(j)) )**2 +
     &               ( coo(2,ipntr(i)) - coo(2,ipntr(j)) )**2 +
     &               ( coo(3,ipntr(i)) - coo(3,ipntr(j)) )**2 
            x(i,j) = 1.0d0/dsqrt(x(i,j))
            x(j,i) = x(i,j)
         end do

      end do
      x(numat,numat)     = 2*var(numat,2)
      x(numat,numat+1)   = -1
      x(numat+1,numat)   = 1
      x(numat+1,numat+1) = 0

      y(numat+1)       = dble(itot)

      do i=1,numat
         y(i) = -var(i,1)
      end do

      call dgefa(x,mxeat+1,numat+1,ipvt,info)
      call dgedi(x,mxeat+1,(numat+1),ipvt,det,work,01)

      call mtmul(x,y,q,numat)

      write (*,'(a)') ' '
      write (*,'(a)') 'EEM charges'
      write (*,'(a)') ' '
      qtot = 0.0d0
      do i=1,(numat)
          j = ipntr(i)
          qat(j) = q(i)
          qtot = qtot + q(i)
          write (*,'(i5,1x,i3,1x,f10.5)') j,ianz(j),qat(j)
      end do
      write (*,'(a)') ' '
      write (*,'(a,f10.3)') 'Sum of EEM charges = ',qtot
      ihasq = 1

      return
      end

c
      subroutine mtmul(a,y,b,numat)
c
      parameter (mxeat=300)
c
      integer i,j,numat
      double precision a(mxeat+1,mxeat+1),y(mxeat+1),b(mxeat+1)
c
      do i=1,numat+1

         b(i) = 0.0

         do j=1,numat+1
            b(i) = b(i) + a(i,j)*y(j)
         end do

      end do
c
      return
      end
c
      subroutine dgedi(a,lda,n,ipvt,det,work,job)
      implicit double precision(a-h,o-z)
      dimension a(lda,*),det(2),work(*),ipvt(*)
c
c     dgedi computes the determinant and inverse of a matrix
c     using the factors computed by dgeco or dgefa.
c
c     on entry
c
c        a       double precision(lda, n)
c                the output from dgeco or dgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from dgeco or dgefa.
c
c        work    double precision(n)
c                work vector.  contents destroyed.
c
c        job     integer
c                = 11   both determinant and inverse.
c                = 01   inverse only.
c                = 10   determinant only.
c
c     on return
c
c        a       inverse of original matrix if requested.
c                otherwise unchanged.
c
c        det     double precision(2)
c                determinant of original matrix if requested.
c                otherwise not referenced.
c                determinant = det(1) * 10.0**det(2)
c                with  1.0 .le. abs(det(1)) .lt. 10.0
c                or  det(1) .eq. 0.0 .
c
c     error condition
c
c        a division by zero will occur if the input factor contains
c        a zero on the diagonal and the inverse is requested.
c        it will not occur if the subroutines are called correctly
c        and if dgeco has set rcond .gt. 0.0 or dgefa has set
c        info .eq. 0 .
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,dscal,dswap
c     fortran abs,mod
c
c     compute determinant
c
      if (job/10 .eq. 0) go to 70
         det(1) = 1.0d+00
         det(2) = 0.0d+00
         ten = 10.0d+00
         do 50 i = 1, n
            if (ipvt(i) .ne. i) det(1) = -det(1)
            det(1) = a(i,i)*det(1)
c        ...exit
            if (det(1) .eq. 0.0d+00) go to 60
   10       if (abs(det(1)) .ge. 1.0d+00) go to 20
               det(1) = ten*det(1)
               det(2) = det(2) - 1.0d+00
            go to 10
   20       continue
   30       if (abs(det(1)) .lt. ten) go to 40
               det(1) = det(1)/ten
               det(2) = det(2) + 1.0d+00
            go to 30
   40       continue
   50    continue
   60    continue
   70 continue
c
c     compute inverse(u)
c
      if (mod(job,10) .eq. 0) return
         do k = 1, n
            a(k,k) = 1.0d+00/a(k,k)
            t = -a(k,k)
            call dscal(k-1,t,a(1,k),1)
            kp1 = k + 1
            if (n .lt. kp1) go to 90
            do j = kp1, n
               t = a(k,j)
               a(k,j) = 0.0d+00
               call daxpy(k,t,a(1,k),1,a(1,j),1)
            end do
   90       continue
         end do
c
c        form inverse(u)*inverse(l)
c
         nm1 = n - 1
         if (nm1 .lt. 1) return
         do kb = 1, nm1
            k = n - kb
            kp1 = k + 1
            do i = kp1, n
               work(i) = a(i,k)
               a(i,k) = 0.0d+00
            end do
            do j = kp1, n
               t = work(j)
               call daxpy(n,t,a(1,j),1,a(1,k),1)
            end do
            l = ipvt(k)
            if (l .ne. k) call dswap(n,a(1,k),1,a(1,l),1)
         end do

      return
      end

      subroutine dgefa(a,lda,n,ipvt,info)
      implicit double precision(a-h,o-z)
      dimension a(lda,*),ipvt(*)
c
c     dgefa factors a double precision matrix by gaussian elimination.
c
c     dgefa is usually called by dgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for dgeco) = (1 + 9/n)*(time for dgefa) .
c
c     on entry
c
c        a       double precision(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that dgesl or dgedi will divide by zero
c                     if called.  use  rcond  in dgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,dscal,idamax
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1

      if (nm1.lt.1) goto 70

      do k=1,nm1
         kp1 = k + 1

c        find l = pivot index

         l = idamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l

c        zero pivot implies this column already triangularized

         if (a(l,k).eq.0.0d0) then
            info = k
         else

c           interchange if necessary

            if (l.ne.k) then
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
            endif

c           compute multipliers

            t = -1.0d+00/a(k,k)
            call dscal(n-k,t,a(k+1,k),1)

c           row elimination with column indexing

            do j = kp1, n

               t = a(l,j)

               if (l.ne.k) then
                  a(l,j) = a(k,j)
                  a(k,j) = t
               endif

               call daxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
            end do

         endif

      end do

   70 continue

      ipvt(n) = n
      if (a(n,n) .eq. 0.0d+00) info = n

      return
      end

      double precision function dasum(n,dx,incx)

c     takes the sum of the absolute values.

      double precision dx(1),dtemp
      integer i,incx,m,mp1,n,nincx

      dasum = 0.0d+00
      dtemp = 0.0d+00

      if (n.le.0) return

      if (incx.ne.1) then

         nincx = n*incx

         do i=1,nincx,incx
           dtemp = dtemp + abs(dx(i))
         end do

         dasum = dtemp

      else

         m = mod(n,6)

         if (m.ne.0) then

            do i = 1,m
              dtemp = dtemp + abs(dx(i))
            end do

            if (n.lt.6) then
               dasum = dtemp
               return
            endif

         endif

         mp1 = m + 1

         do i = mp1,n,6
           dtemp = dtemp + abs(dx(i)) + abs(dx(i + 1)) + abs(dx(i + 2))
     &     + abs(dx(i + 3)) + abs(dx(i + 4)) + abs(dx(i + 5))
         end do

         dasum = dtemp

      endif

      return
      end

      subroutine daxpy(n,da,dx,incx,dy,incy)
      implicit double precision(a-h,o-z)
      dimension dx(1),dy(1)
c
c     constant times a vector plus a vector.
c           dy(i) = dy(i) + da * dx(i)
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      if (n.le.0) return
      if (da .eq. 0.0d0) return

      if (incx.eq.1.and.incy.eq.1) then
         m = mod(n,4)
         if (m.ne.0) then

            do i = 1,m
              dy(i) = dy(i) + da*dx(i)
            end do

            if (n.lt.4) return
         endif

         mp1 = m + 1

         do i = mp1,n,4
           dy(i) = dy(i) + da*dx(i)
           dy(i + 1) = dy(i + 1) + da*dx(i + 1)
           dy(i + 2) = dy(i + 2) + da*dx(i + 2)
           dy(i + 3) = dy(i + 3) + da*dx(i + 3)
         end do

      else

c        code for unequal increments or equal increments
c        not equal to 1

         ix = 1
         iy = 1

         if (incx.lt.0) ix = (-n+1)*incx + 1
         if (incy.lt.0) iy = (-n+1)*incy + 1

         do i = 1,n
           dy(iy) = dy(iy) + da*dx(ix)
           ix = ix + incx
           iy = iy + incy
         end do

      endif

      return
      end

      subroutine dcopy(n,dx,incx,dy,incy)
      implicit double precision(a-h,o-z)
      dimension dx(*),dy(*)
c
c     copies a vector.
c           dy(i) <== dx(i)
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dx(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        dy(i) = dx(i)
        dy(i + 1) = dx(i + 1)
        dy(i + 2) = dx(i + 2)
        dy(i + 3) = dx(i + 3)
        dy(i + 4) = dx(i + 4)
        dy(i + 5) = dx(i + 5)
        dy(i + 6) = dx(i + 6)
   50 continue
      return
      end

      double precision function ddot(n,dx,incx,dy,incy)
      implicit double precision(a-h,o-z)
      dimension dx(1),dy(1)
c
c     forms the dot product of two vectors.
c           dot = dx(i) * dy(i)
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      ddot = 0.0d+00
      dtemp = 0.0d+00
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      ddot = dtemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dx(i)*dy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dtemp = dtemp + dx(i)*dy(i) + dx(i + 1)*dy(i + 1) +
     *   dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
   50 continue
   60 ddot = dtemp
      return
      end

      double precision function dnrm2 ( n, dx, incx)
      integer          next
      double precision   dx(1), cutlo, cuthi, hitest, sum, xmax,zero,one
      data   zero, one /0.0d+00, 1.0d+00/
c
c     euclidean norm of the n-vector stored in dx() with storage
c     increment incx .
c     if    n .le. 0 return with result = 0.
c     if n .ge. 1 then incx must be .ge. 1
c
c           c.l.lawson, 1978 jan 08
c
c     four phase method     using two built-in constants that are
c     hopefully applicable to all machines.
c         cutlo = maximum of  sqrt(u/eps)  over all known machines.
c         cuthi = minimum of  sqrt(v)      over all known machines.
c     where
c         eps = smallest no. such that eps + 1. .gt. 1.
c         u   = smallest positive no.   (underflow limit)
c         v   = largest  no.            (overflow  limit)
c
c     brief outline of algorithm..
c
c     phase 1    scans zero components.
c     move to phase 2 when a component is nonzero and .le. cutlo
c     move to phase 3 when a component is .gt. cutlo
c     move to phase 4 when a component is .ge. cuthi/m
c     where m = n for x() real and m = 2*n for complex.
c
c     values for cutlo and cuthi..
c     from the environmental parameters listed in the imsl converter
c     document the limiting values are as follows..
c     cutlo, s.p.   u/eps = 2**(-102) for  honeywell.  close seconds are
c                   univac and dec at 2**(-103)
c                   thus cutlo = 2**(-51) = 4.44089e-16
c     cuthi, s.p.   v = 2**127 for univac, honeywell, and dec.
c                   thus cuthi = 2**(63.5) = 1.30438e19
c     cutlo, d.p.   u/eps = 2**(-67) for honeywell and dec.
c                   thus cutlo = 2**(-33.5) = 8.23181d-11
c     cuthi, d.p.   same as s.p.  cuthi = 1.30438d+19
c     data cutlo, cuthi / 8.232d-11,  1.304d+19 /
c     data cutlo, cuthi / 4.441e-16,  1.304e19 /
      data cutlo, cuthi / 8.232d-11,  1.304d+19 /
c
      j = 0

      if (n.le.0) then
         dnrm2  = zero
         return
      endif
c
cc      assign 30 to next
      next = 30
      sum = zero
      nn = n * incx
c                                                 begin main loop
      i = 1
cc   20    go to next,(30, 50, 70, 110)
20    if (next.eq.30) then
         goto 30
      else if (next.eq.50) then
         goto 50
      else if (next.eq.70) then
         goto 70
      else if (next.eq.110) then
         goto 110
      endif

c 1st jump

   30 if( abs(dx(i)) .gt. cutlo) go to 85
cc      assign 50 to next
      next = 50
      xmax = zero
c
c                        phase 1.  sum is zero
c
c 2nd jump

   50 if( dx(i) .eq. zero) go to 200
      if( abs(dx(i)) .gt. cutlo) go to 85
c
c                                prepare for phase 2.
cc      assign 70 to next
      next = 70
      go to 105
c
c                                prepare for phase 4.
c
  100 i = j
cc      assign 110 to next
      next = 110
      sum = (sum / dx(i)) / dx(i)
  105 xmax = abs(dx(i))
      go to 115
c
c                   phase 2.  sum is small.
c                             scale to avoid destructive underflow.
c
c 3rd jump
   70 if( abs(dx(i)) .gt. cutlo ) go to 75
c
c                     common code for phases 2 and 4.
c                     in phase 4 sum is large.  scale to avoid overflow.
c
c 4th jump
  110 if (abs(dx(i)).le.xmax) go to 115
         sum = one + sum * (xmax / dx(i))**2
         xmax = abs(dx(i))
         go to 200
c
  115 sum = sum + (dx(i)/xmax)**2
      go to 200
c
c
c                  prepare for phase 3.
c
   75 sum = (sum * xmax) * xmax
c
c
c     for real or d.p. set hitest = cuthi/n
c     for complex      set hitest = cuthi/(2*n)
c
   85 hitest = cuthi/n
c
c                   phase 3.  sum is mid-range.  no scaling.
c
      do j =i,nn,incx
         if(abs(dx(j)) .ge. hitest) go to 100
         sum = sum + dx(j)**2
      end do

      dnrm2 = sqrt(sum)

      return
c
  200 continue
      i = i + incx
      if ( i .le. nn ) go to 20
c
c              end of main loop.
c
c              compute square root and adjust for scaling.
c
      dnrm2 = xmax * sqrt(sum)

      return
      end

      subroutine drot(n,dx,incx,dy,incy,c,s)
      implicit double precision(a-h,o-z)
      dimension dx(1),dy(1)
c
c     applies a plane rotation.
c           dx(i) =  c*dx(i) + s*dy(i)
c           dy(i) = -s*dx(i) + c*dy(i)
c     jack dongarra, linpack, 3/11/78.
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do i = 1,n
        dtemp = c*dx(ix) + s*dy(iy)
        dy(iy) = c*dy(iy) - s*dx(ix)
        dx(ix) = dtemp
        ix = ix + incx
        iy = iy + incy
      end do

      return
c
c       code for both increments equal to 1
c
   20 do i = 1,n
        dtemp = c*dx(i) + s*dy(i)
        dy(i) = c*dy(i) - s*dx(i)
        dx(i) = dtemp
      end do

      return
      end

      subroutine drotg(da,db,c,s)
c
c     construct givens plane rotation.
c     jack dongarra, linpack, 3/11/78.
c
      double precision da,db,c,s,roe,scale,r,z
      double precision zero, one
c
      parameter (zero=0.0d+00, one=1.0d+00)
c
c-----------------------------------------------------------------------
c
c
      roe = db
      if( abs(da) .gt. abs(db) ) roe = da
      scale = abs(da) + abs(db)
      if ( scale .eq. zero ) then
         c = one
         s = zero
         r = zero
      else
         r = scale*sqrt((da/scale)**2 + (db/scale)**2)
         r = sign(one,roe)*r
         c = da/r
         s = db/r
      endif
      z = one
      if( abs(da) .gt. abs(db) ) z = s
      if( abs(db) .ge. abs(da) .and. c .ne. zero ) z = one/c
      da = r
      db = z

      return
      end

      subroutine dscal(n,da,dx,incx)
      implicit double precision(a-h,o-z)
      dimension dx(1)
c
c     scales a vector by a constant.
c           dx(i) = da * dx(i)
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx

      do i = 1,nincx,incx
        dx(i) = da*dx(i)
      end do

      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if ( m .eq. 0 ) go to 40
      do i = 1,m
        dx(i) = da*dx(i)
      end do
      if( n .lt. 5 ) return

   40 mp1 = m + 1
      do i = mp1,n,5
        dx(i) = da*dx(i)
        dx(i + 1) = da*dx(i + 1)
        dx(i + 2) = da*dx(i + 2)
        dx(i + 3) = da*dx(i + 3)
        dx(i + 4) = da*dx(i + 4)
      end do

      return
      end

      subroutine dswap(n,dx,incx,dy,incy)
      implicit double precision(a-h,o-z)
      dimension dx(1),dy(1)
c
c     interchanges two vectors.
c           dx(i) <==> dy(i)
c     uses unrolled loops for increments equal one.
c     jack dongarra, linpack, 3/11/78.
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do i = 1,n
        dtemp = dx(ix)
        dx(ix) = dy(iy)
        dy(iy) = dtemp
        ix = ix + incx
        iy = iy + incy
      end do

      return
c
c       code for both increments equal to 1
c
c
c       clean-up loop
c
   20 m = mod(n,3)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dx(i)
        dx(i) = dy(i)
        dy(i) = dtemp
   30 continue
      if( n .lt. 3 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,3
        dtemp = dx(i)
        dx(i) = dy(i)
        dy(i) = dtemp
        dtemp = dx(i + 1)
        dx(i + 1) = dy(i + 1)
        dy(i + 1) = dtemp
        dtemp = dx(i + 2)
        dx(i + 2) = dy(i + 2)
        dy(i + 2) = dtemp
   50 continue
      return
      end

      integer function idamax(n,dx,incx)
      implicit double precision(a-h,o-z)
      dimension dx(1)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c
      idamax = 0
      if( n .lt. 1 ) return
      idamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      rmax = abs(dx(1))
      ix = ix + incx

      do i = 2,n
         if (abs(dx(ix)).gt.rmax) then
            idamax = i
            rmax = abs(dx(ix))
         endif
         ix = ix + incx
      end do

      return
c
c        code for increment equal to 1
c
   20 rmax = abs(dx(1))
      do i = 2,n
         if(abs(dx(i)).gt.rmax) then
            idamax = i
            rmax = abs(dx(i))
         endif
      end do

      return
      end

      subroutine dgemv(forma,m,n,alpha,a,lda,x,incx,beta,y,incy)
      implicit double precision(a-h,o-z)
      character*1 forma
      dimension a(lda,*),x(*),y(*)
      parameter (zero=0.0d+00, one=1.0d+00)
c
c        clone of -dgemv- written by mike schmidt
c
      locy = 1
      if(forma.eq.'t') go to 200
c
c                  y = alpha * a * x + beta * y
c
      if (alpha.eq.one  .and.  beta.eq.zero) then
         do i=1,m
            y(locy) =       ddot(n,a(i,1),lda,x,incx)
            locy = locy+incy
         end do
      else
         do i=1,m
            y(locy) = alpha*ddot(n,a(i,1),lda,x,incx) + beta*y(locy)
            locy = locy+incy
         end do
      end if
      return
c
c                  y = alpha * a-transpose * x + beta * y
c
  200 continue

      if(alpha.eq.one  .and.  beta.eq.zero) then
         do i=1,n
            y(locy) =       ddot(m,a(1,i),1,x,incx)
            locy = locy+incy
         end do
      else
         do i=1,n
            y(locy) = alpha*ddot(m,a(1,i),1,x,incx) + beta*y(locy)
            locy = locy+incy
         end do
      end if

      return
      end

      subroutine filnam(filn,nnn)
      character name*70,filn*(*)

      i1 = 0
      do i = 1,nnn
         if (filn(i:i).ne.' ') then
            i1 = i1 + 1
            name(i1:i1) = filn(i:i)
         endif
      end do

      do i = 1,nnn
         filn(i:i) = ' '
      end do

      do i = 1,i1
         filn(i:i) = name(i:i)
      end do

      return
      end

      subroutine distchd(coo)
c
c
      implicit double precision(a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension coo(3,*)

      tol = 0.1d0
      do i=1,iatoms
         do j=i+1,iatoms
             dd = 0.0d0
             do k=1,3
                d1 = coo(k,i) - coo(k,j)
                d2 = d1*d1
                dd = dd + d2
             end do 
             if (dd.lt.tol) print*,'close ',i,' ',j
         end do
      end do

      return
      end

      subroutine sigini
      implicit double precision(a-h,o-z)
      parameter (mxsigm=16)
      parameter (mxmol2=41)
      common /sigma/ siga(mxsigm),sigb(mxsigm),sigc(mxsigm),
     &               sigd(mxsigm),impmol2(mxmol2)
c      data sigs  /"H ","C3","C2","C1","N3","N2","N1","O3","O2","F ",
c     &       "Cl","Br","I ","S3","P ","DU"/     
      data siga /7.17,7.98,8.79,10.39,11.54,12.87,15.68,14.18,
     &       17.07,14.66, 11.00, 10.08,9.90,10.14,8.9,0.0/
      data sigb /6.24,9.18,9.32,9.45,10.82,11.15,11.70,12.92,
     &           13.79,13.85,9.69,8.47,7.96,9.13,8.24,0.0/
      data sigc /-0.56,1.88,1.51,0.73,1.36,0.85,-0.27,1.39,
     &           0.47,2.31,1.35,1.16,0.96,1.38,0.96,0.0/
      data impmol2 /16,16,16,16,2,3,4,3,3,5,6,7,6,6,6,5,
     &           8,9,9,8,8,14,14,14,14,15,1,1,1,10,11,12,13,
     &           16,16,16,16,16,16,16,16/

c sybyl atom types to gasteiger types
c1 any
c2 hal
c3 het
c4 hev
c5 C.3     2
c6 C.2     3
c7 C.1     4
c8 C.ar    3
c9 C.cat   ?
c10 N.3    5
c11 N.2    6
c12 N.1    7
c13 N.ar   6
c14 N.am   6
c15 N.pl3  6
c16 N.4    5
c17 O.3    8
c18 O.2    9
c19 O.co2  9
c20 O.spc  8
c21 O.t3p  8
c22 S.3    14
c23 S.2    14
c24 S.O    14
c25 S.O2   14
c26 P.3    15
c27 H      1
c28 H.spc  1
c29 H.t3p  1
c30 F      10
c31 Cl     11
c32 Br     12
c33 I      13
c34 Si
c35 Lp
c36 Du
c37 Na
c38 K
c39 Ca
c40 Li
c41 Al

c unknown is DU 16

      do i=1,mxsigm
         sigd(i) = siga(i) + sigb(i) + sigc(i)
      end do
      sigd(15) = 1.0d0

      return
      end
                              
      subroutine inigad(qtot,qat,ianz,iconn,ityp)
      implicit double precision(a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (mxsigm=16)
      parameter (mxmol2=41)
      common /sigma/ siga(mxsigm),sigb(mxsigm),sigc(mxsigm),
     &               sigd(mxsigm),impmol2(mxmol2)
      common /athlp/ iatoms, mxnat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      integer*2 ityp
      common /types/ iff
      dimension qat(*),ianz(*),iconn(mxcon+1,*),ityp(*)

      ihasq = 0
      iff = 5
      call dotyp(0)
      qtot = 0.0d0
  
      do i=1,iatoms
         qat(i) = 0.0d0
         ia = ianz(i)

         if (ia.eq.6) then
           if (ityp(i).eq.9) qat(i) = 1.0d0
         elseif (ia.eq.7) then
           ibnd = 0
           do j=1,iconn(1,i)
              if (iconn(1+j,i).gt.0) ibnd = ibnd + 1
           end do
           if (ibnd.eq.4) qat(i) = 1.0d0
         elseif (ia.eq.8) then
c carboxyl
           if (ityp(i).eq.19) qat(i) = -0.5d0
         endif
         qtot = qtot + qat(i)
      end do

      return
      end

      subroutine clqgas(ishoh)
      implicit double precision(a-h,o-z)
      logical dozme
      common /getpnt/irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &               iconv,ircus,dozme
      parameter (mxheta=150)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      istat = 0

      if (ipdbon.eq.1) then

         call numhet(nhmol)
         do i=4,nhmol
            if (i.ne.ishoh) then
               print*,' '
               if (ihashz.eq.1) then
                  print*,'HETATM residue ',hetz(i+1)
               else
                  print*,'HETATM residue ',(i+1-4)
               endif
               print*,' '
               call calgas(-i,1,istat)
            endif
         end do

        print*,' '
        print*,'WARNING: Total charges of the different HETATM residues'
        print*,'         assumed zero. If this is NOT correct, assign '
        print*,'         HETATM charges individually, by clicking with'
        print*,'         2nd mouse button on the residue and select   '
        print*,'         Calculate Charges'
        print*,' '

      else
         call calgas(1,1,istat)
      endif

      if (istat.eq.1) call messg(14)

      return
      end

      subroutine calgad(iasel,iprnt,istat,qat,ianz,iconn,iresid,ityp)
      implicit double precision(a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (mxsigm=16)
      parameter (mxmol2=41)
      common /sigma/ siga(mxsigm),sigb(mxsigm),sigc(mxsigm),
     &               sigd(mxsigm),impmol2(mxmol2)
      common /athlp/ iatoms, mxnat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      integer*2 ityp
      common /types/ iff
      dimension zz(numat1)
      dimension qat(*),ianz(*),iconn(mxcon+1,*),ityp(*),iresid(*)

      call sigini
  
      ihasq = 0
      istat = 0
      iff = 5
      call dotyp(0)
  
      do i=1,iatoms
         if (iasel.gt.0.or.(iasel.lt.-3.and.iasel.eq.iresid(i)) )
     &   then

            it = ityp(i)

            if (it.gt.0.and.it.le.mxmol2) then
                l = impmol2(it)
            else
                print*,'Gasteiger: Untyped mol2 atom type.'
                istat = 1
                return
            endif

            if (i.le.numat1) then
                zz(i) = siga(l)
            else
                print*,'array for gasteiger calculation to small'
                istat = 1
                return
            endif

            qat(i) = 0.0d0
            ia = ianz(i)

            if (ia.eq.6) then

              if (ityp(i).eq.9) qat(i) = 1.0d0

            elseif (ia.eq.7) then

              ibnd = 0
              do j=1,iconn(1,i)
                 if (iconn(1+j,i).gt.0) ibnd = ibnd + 1
              end do
              if (ibnd.eq.4) qat(i) = 1.0d0

c              if (N3+) qat(i) = 1.0d0

            elseif (ia.eq.8) then
c carboxyl
              if (ityp(i).eq.19) qat(i) = -0.5d0

            endif
         endif
      end do

      fac = 1.0d0
      icnt = 0

      do while (.true.)

          fac = fac*0.5d0
          sd1 = 0.0d0

          do i=1,iatoms

           if (iasel.gt.0.or.(iasel.lt.-3.and.iasel.eq.iresid(i)) )
     &     then

             l = impmol2(ityp(i))

             if (sigd(l).ne.1.0d0) then

                qt = qat(i)
                do j=1,iconn(1,i)
                   if (iconn(1+j,i).gt.0) then
                      jj = iabs(iconn(1+j,i))
                      ll = impmol2(ityp(jj))
                      if (sigd(ll).ne.1.0d0) then
                         sd2 = sigd(ll)
                         if (i.le.numat1.and.jj.le.numat1) then
                            if (zz(jj).gt.zz(i)) sd2 = sigd(l)
                         endif
                         if (ianz(i).eq.1.or.ianz(jj).eq.1) 
     &                      sd2 = 20.02d0
                         if (i.le.numat1.and.jj.le.numat1) then
                            qat(i) = qat(i) + (zz(jj) - zz(i))*fac/sd2
                         endif
                      endif
                   endif
                end do

                qt = dabs(qat(i) - qt)
                if (qt.gt.sd1) sd1 = qt

             endif

           endif
          end do

          if (sd1.ge.1.0d-3) then

             do i=1,iatoms

              if (iasel.gt.0.or.(iasel.lt.-3.and.iasel.eq.iresid(i)) )
     &        then
                l = impmol2(ityp(i))
                zz(i) = siga(l) + sigb(l)*qat(i) + sigc(l)*qat(i)*qat(i)
              endif

             end do

          endif 

          icnt = icnt + 1

          if (.not.(sd1.gt.1.0d-3.and.icnt.le.5)) goto 100
      end do

100   continue

      if (iprnt.eq.1) then
         write (*,'(a)') ' '
         write (*,'(a)') 'Gasteiger charges'
         write (*,'(a)') ' '
      endif

      qtot = 0.0d0

      do i=1,iatoms
        if (ianz(i).ne.100) then
          if (iasel.gt.0.or.(iasel.lt.-3.and.iasel.eq.iresid(i)) )
     &    then
             qtot = qtot + qat(i)
             if (iprnt.eq.1) 
     &            write (*,'(i5,1x,i3,1x,f10.5)') i,ianz(i),qat(i)
          endif
        endif
      end do

      if (iprnt.eq.1) then
        write (*,'(a)') ' '
        write (*,'(a,f10.3)') 'Sum of Gasteiger charges = ',qtot
      endif

      ihasq = 1
      return
      end

      subroutine clqeem(iop,ishoh)
      implicit double precision(a-h,o-z)
      logical dozme
      common /getpnt/irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &               iconv,ircus,dozme
      parameter (mxheta=150)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)

      istat = 0

      if (ipdbon.eq.1) then

         call numhet(nhmol)
         do i=4,nhmol
            if (i.ne.ishoh) then
               print*,' '
               if (ihashz.eq.1) then
                  print*,'HETATM residue ',hetz(i+1)
               else
                  print*,'HETATM residue ',(i+1-4)
               endif
               print*,' '
               call eem(iop,-i,istat)
            endif
         end do

        print*,' '
        print*,'WARNING: Total charges of the different HETATM residues'
        print*,'         assumed zero. If this is NOT correct, assign '
        print*,'         HETATM charges individually, by clicking with'
        print*,'         2nd mouse button on the residue and select   '
        print*,'         Calculate Charges'
        print*,' '

      else
         call eem(iop,1,istat)
      endif

      if (istat.eq.1) call messg(14)

      return
      end

      subroutine clceem(ishoh)
      implicit double precision(a-h,o-z)
      logical dozme
      common /getpnt/irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &               iconv,ircus,dozme
      common /types/ iff
      istat = 0

      if (iff.eq.7) then
         if (ipdbon.eq.1) then
            call numhet(nhmol)
            do i=4,nhmol
               if (i.ne.ishoh) then
                  call eem(3,-i,istat)
               endif
            end do
         else
            call eem(3,1,istat)
         endif
      endif

      print*,' '
      print*,'EEM: Electronegativity Equalization Method:'
      print*,' '
      print*,' Patrick Bultinck et al'
      print*,' J. Phys. Chem. A (2002)'
      print*,' '

      if (istat.eq.1) call messg(14)

      return
      end

      subroutine inferr(str,isev)
      implicit double precision (a-h,o-z)
c
c     print info/error
c
      character*(*) str
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plot / iplot,iplwin,icolps
      logical zsev
      common /wrtcom/ zsev
cd     write(iun3,'(a)')'enter subroutine inferr'

      if (iplot.eq.6) then
          call molstr(str,len(str),iplwin)
          if (isev.eq.1) then
               write(iun3,*) ' '
               write(iun3,*) str
          endif
      else
          write(iun3,*) ' '
          write(iun3,*) str
          if (isev.eq.1.and.zsev) stop
      endif

cd     write(iun3,'(a)')'leave subroutine inferr'
      return
      end

      subroutine zmterr(str,icard,ivar,isev)
      implicit double precision (a-h,o-z)
c
c     print zmat parse error
c
      character*(*) str
      character*137 dumstr
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /plot / iplot,iplwin,icolps

      if (iplot.eq.6) then
          if (isev.eq.1) then
              dumstr = 'ZMAT NOT parsed: '//str
              call errzme(dumstr,len(str)+17,icard,ivar)
              write(iun3,*) str
              write(iun3,*) 'Center ',icard 
          else
              call errzme(str,len(str),icard,ivar)
          endif
      else
          write(iun3,*) str
c          if (isev.eq.1) stop
      endif

      return
      end

      subroutine rotc(gamma)
      implicit double precision (a-h,o-z)
      common/rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg

c--   beta expected in degrees
      radc = gamma / todeg
      cmat(2,2) =  dcos(radc)
      cmat(2,3) =  dsin(radc)
      cmat(3,2) = -dsin(radc)
      cmat(3,3) =  dcos(radc)

      return
      end

      subroutine grdcad(dens,npts1,npts2,iprnt,space,
     &                  p,paa,psi,grd,hess,
     &                  phi,dphi,dxpsi,dypsi,dzpsi,
     &                  vectrs,vectrb,focc,focb,ireord)

c THIS IS REALLY grdcal

c     routine calculates the z-values of the plot plane
c     output array dens and step
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      logical calcu,valenc,bonds,ovrlap,atomic,doori,
     &  ostep,fine,oscal,dolap,purden,onden,doelf
      integer space
      parameter (numatm=2000)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /eulx/   ca,cb,sa,sb,cc,sc
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd

      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      dimension dens(*),p(*),paa(*),psi(*),grd(3,*),hess(6,*)
      dimension hes(6),g(3),car(3)
      dimension phi(*),dphi(3,*),dxpsi(*),dypsi(*),dzpsi(*)
      dimension vectrs(*),vectrb(*),focc(*),focb(*),ireord(*)

      toang = 0.52917706d0
      fermi = 0.121300565d0
      tol = 2.871d-5

      purden = onden(idum)

      call curs(1)
      call parrat

      if (iprnt.eq.1) call inferr('Calculation of Grid',0)
      cutoff = 1.0d-7
c      if (.false.) call cmpgau(paa,psi,grd,hess,ipsi)

      radius1 = 0.5d0 * r(1)
      radius2 = 0.5d0 * r(2)
      rf1     = r(1) / dble(npts1-1)
      rf2     = r(2) / dble(npts2-1)
      pmax    = -100000.d0
      pmin    =  100000.d0
      ij      = 0

      call detpre(ipreca)

      do ic=1,npts1

          x2 = -radius1+dble(ic-1)*rf1

          do jc=1,npts2

              ij =  ij + 1
              y2 = -radius2+dble(jc-1)*rf2
              x  = v1(1)*x2 + v2(1)*y2 + px
              y  = v1(2)*x2 + v2(2)*y2 + py
              z  = v1(3)*x2 + v2(3)*y2 + pz

              if (molpot.or.elpot.or.chpot) then

c  Molpot = calculate electrostatic potential using Multipoles 
c  Elpot  = calculate ab initio electrostatic potential 

                 calcu=.true.

                 do l=1,natoms
                     xk = x - xyz(1,l)
                     yk = y - xyz(2,l)
                     zk = z - xyz(3,l)
                     r2 = xk*xk + yk*yk + zk*zk
                     r2 = r2 + 1.d-10
                     r1 = dsqrt(r2)

                     if (space.eq.1) then
                        if (r1.lt.0.1d0) calcu = .false.
                     else
                        if (r1.lt.vdwr(nat(l))/toang) calcu = .false.
                     endif

                 end do

                 if (calcu) then
                   if (chpot) then
                      car(1) = x
                      car(2) = y
                      car(3) = z
                      call clmon(car,dens(ij))
                   else
                      if (molpot) call calc(x,y,z,dens(ij))
                      if (elpot) call espot(x,y,z,dens(ij),0)
                   endif
                 else
                   dens(ij) = 0.0d0
                 endif

              else

                 if (iftyp.eq.1) then
                    call slater(x,y,z,psi)
                 elseif (iftyp.eq.5.and.isgau.eq.0) then
                    call adffun(x,y,z,psi)
                 else
                    if (ipsi.eq.0.and.dolap) then
                       call denhes(x,y,z,psi,grd,hess,norbs,dolap)
                    else
                       if (doelf) then
                          call gaudxyz(x,y,z,psi,dxpsi,dypsi,dzpsi,
     &                                 norbs,1,ic,jc)
                       else
                          call gaussian(x,y,z,psi,norbs,ipreca,ic,jc)
                       endif
                    endif
                 endif

                 sum = 0.0d0
                 gradfa = 0.0d0

                 if (ipsi.eq.0)  then
                     if (dolap) then
                        call calhes(psi,grd,hess,den,g,hes)
                        sum = hes(1) + hes(2) + hes(3)
                        if (dabs(sum).lt.cutoff) sum = 0.0d0
                        if (dabs(sum).gt.20.0d0) then
                            if (sum.gt.0.0d0) then
                               sum = 20.0d0
                            else
                               sum = -20.0d0
                            endif
                        endif

                     else

                        if (purden) then
                           call denfst(sum,psi)
                        else
                           do i=1,norbs
                               sum = sum - psi(i)*psi(i)
     &                                *p((i-1)*mxorb+i)*0.5d0
                               do j=1,i
                                   sum = sum + psi(i)*psi(j)
     &                                *p((j-1)*mxorb+i)
                               end do
                           end do
                           sum = sum + sum

                           if (doelf) then

                             call calelf(psi,phi,dphi,
     &                                   dxpsi,dypsi,dzpsi,
     &                                   vectrs,vectrb,focc,focb,
     &                                   gradfab,dn)


                           endif

                        endif

                     endif

                 else
              

                     do i=1,norbs
                         sum = sum + paa(i)*psi(i)
                     end do

                 endif

                 if (doelf) then

                    gradf=gradfab+tol*dn
                    ratio=gradf*gradf*fermi*dn**(-16.0d0/3.0d0)
                    dens(ij) = 1.d0/(1.0d0+ratio)
                    
                 else
                    dens(ij) = sum * one
                 endif
              endif

              if (dens(ij).gt.pmax) pmax = dens(ij)
              if (dens(ij).lt.pmin) pmin = dens(ij)

           end do
      end do

c
c------------- end grid points loop -----------------------
c

      call curs(0)
      if (iprnt.eq.1) then
      write(iun3,'(//''***** GRID POINT DENSITY/INTENSITY *****''//)')
      write(iun3,'('' MAXIMUM DENSITY/INTENSITY = '',f13.5)')pmax
      write(iun3,'('' MINIMUM DENSITY/INTENSITY = '',f13.5)')pmin
      write(iun3,'(/''ON A TOTAL OF '',i3,''*'',i3,'' POINTS'')')npts1,
     & npts2
      endif
      pmax = max(pmax,-pmin)
      if (iprnt.eq.1) then
         if (pmax.lt.1.d-5) write(iun3,2222)
         if (pmax.gt.1.d 5) write(iun3,2223)
      endif
      if (pmax.lt.1.d-5) pmax = 0.0d0

      call parstp

2222  format(' DENSITY OF PLOT IS VERY LOW-',
     &       ' SUGGEST YOU CHECK YOUR DATA')
2223  format(' DENSITY OF PLOT IS VERY HIGH-',
     &       ' SUGGEST YOU CHECK YOUR DATA')

      return
      end

      subroutine cmpgau(paa,psi,grd,hess,ipsi)
c     test: compare with the gaussian program
c# hf/6-31g** 6d gfinput iop(6/7=3) cube=orbitals \
c  iop(6/49=-1) iop(6/33=2)
c  oh = 0.942774, hoh = 106.053
cgridfile
c  -80    0.000000    0.000000    0.000000
c   -1    1.000000    0.000000    0.000000
c    3    0.000000    1.000000    0.000000
c    3    0.000000    0.000000    1.000000
c1	(orbital number)
c or
c# hf/6-31g** 6d gfinput iop(6/7=3) cube=density iop(6/49=-1) iop(6/23=2)
c iop(6/24=2)
c The last iop is to stop gaussian to disregard core orbitals
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension xyz(3,9),psi(*),grd(3,*),hess(6,*),
     &          hes(6),g(3),paa(*)
      data ((xyz(j,i),j=1,3),i=1,9) /
     & 0.000000, 0.000000, 0.000000,
     & 0.000000, 0.000000, 1.000000,
     & 0.000000, 0.000000, 2.000000,
     & 0.000000, 1.000000, 0.000000,
     & 0.000000, 1.000000, 1.000000,
     & 0.000000, 1.000000, 2.000000,
     & 0.000000, 2.000000, 0.000000,
     & 0.000000, 2.000000, 1.000000,
     & 0.000000, 2.000000, 2.000000/


      print*,'density and its gradient'
      print*,' '
      do i=1,9
        call denhes(xyz(1,i),xyz(2,i),xyz(3,i),
     &              psi,grd,hess,norbs,.true.)
c         call gaussian(xyz(1,i),xyz(2,i),xyz(3,i),psi,norbs)
         if (ipsi.eq.0)  then
             call calhes(psi,grd,hess,den,g,hes)
             write(*,'(i3,1(1pe13.5))') i,den
             write(*,'(i3,3(1pe13.5))') i,(g(l),l=1,3)
             write(*,'(i3,6(1pe13.5))') i,(hes(l),l=1,6)
         else
            sum = 0.0d0
            do j=1,norbs
               sum = sum + paa(j)*psi(j)
            end do
            print*,i,sum
         endif
      end do

      return
      end

      subroutine detone
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /moldat/ natoms, norbs, nelecs,nat(numatm)

      if (natoms.eq.1) then
         v1(1) = 1.0d0
         v1(2) = 0.0d0
         v1(3) = 0.0d0
         v2(1) = 0.0d0
         v2(2) = 1.0d0
         v2(3) = 0.0d0
         r(1) = 5.0d0
         r(2) = 5.0d0
         r(3) = 5.0d0
         px = 0.0d0
         py = 0.0d0
         pz = 0.0d0
         cx = 0.0d0
         cy = 0.0d0
         cz = 1.0d0
      endif

      return
      end

      subroutine detpre(ipreca)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
 
      ipreca = 1
      vl1 = vlen(v1)
      vl2 = vlen(v2)
      if (vl1.eq.0.0.or.vl2.eq.0.0.or.natoms.eq.1) ipreca = 0

      return
      end

      subroutine grdcd(npts1,npts2,iprnt,space,dens)
      implicit double precision (a-h,o-z)
      integer space

c THIS IS REALLY grdcl

      dimension dens(*)

      call preczo
      call precal(npts1,npts2)
      call detone
      call grdcal(dens,npts1,npts2,iprnt,space)

      return
      end

      subroutine resedd(iedlog)
      implicit double precision (a-h,o-z)

c THIS IS REALLY resedl

      common /grdhlp/ mx3d,mx3d2
      dimension iedlog(*)

      do i=1,mx3d2
         iedlog(i) = 1
      end do

      return
      end

      subroutine precal(npts1,npts2)
      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common/prefa/ prexpx(numpre,numcex),prexpy(numpre,numcex),
     &              prexpz(numcex)
      dimension d1(3),v1t(3),v2t(3)


      radius1 = 0.5d0 * r(1)
      radius2 = 0.5d0 * r(2)
      rf1     = radius1 / dble(npts1-1) * 2.d0
      rf2     = radius2 / dble(npts2-1) * 2.d0

      vl = vlen(v1)

      do i=1,3
         v1t(i) = v1(i) / vl
      end do

      vl = vlen(v2)

      do i=1,3
         v2t(i) = v2(i) / vl
      end do

      ipnt = 0
      do ishell=1,nshell

          d1(1) = px - gx(ishell)
          d1(2) = py - gy(ishell)
          d1(3) = pz - gz(ishell)

          call timpsc(d1,v1t,dx)
          call timpsc(d1,v2t,dy)

          do igauss=1,shelln(ishell)

             iex = shella(ishell) + igauss - 1
             ipnth = ipnt + igauss
             ex  = exx(iex)

             do i=1,npts1

                x2 = -radius1 + dble(i-1)*rf1
   
                xk = x2 + dx

                prexpx(i,ipnth) = dexp(-ex*xk*xk)

             end do

             do j=1,npts2

                y2 = -radius2 + dble(j-1)*rf2
   
                yk = y2 + dy

                prexpy(j,ipnth) = dexp(-ex*yk*yk)

             end do

          end do
          ipnt = ipnt + shelln(ishell)
      end do

      return
      end

      subroutine precz(rz,nptsz,k)
      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common/prefa/ prexpx(numpre,numcex),prexpy(numpre,numcex),
     &              prexpz(numcex)
      dimension d1(3),v3(3)

      radius3 = 0.5d0 * rz
      rf3     = radius3 / dble(nptsz-1) * 2.d0

      v3(1) = cx
      v3(2) = cy
      v3(3) = cz

      vl = vlen(v3)
      do i=1,3
         v3(i) = v3(i) / vl
      end do

      ipnt = 0
      do ishell=1,nshell

          d1(1) = px - gx(ishell)
          d1(2) = py - gy(ishell)
          d1(3) = pz - gz(ishell)

          call timpsc(d1,v3,dz)

          do igauss=1,shelln(ishell)

             iex = shella(ishell) + igauss - 1
             ipnth = ipnt + igauss
             ex  = exx(iex)


             z2 = radius3 - dble(k-1)*rf3
   
             zk = z2 + dz

             prexpz(ipnth) = dexp(-ex*zk*zk)


          end do
          ipnt = ipnt + shelln(ishell)
      end do

      return
      end

      subroutine preczo
      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common/prefa/ prexpx(numpre,numcex),prexpy(numpre,numcex),
     &              prexpz(numcex)
      dimension d1(3),v3(3)

      v3(1) = cx
      v3(2) = cy
      v3(3) = cz

      vl = vlen(v3)
      do i=1,3
         v3(i) = v3(i) / vl
      end do

      ipnt = 0
      do ishell=1,nshell

          d1(1) = px - gx(ishell)
          d1(2) = py - gy(ishell)
          d1(3) = pz - gz(ishell)

          call timpsc(d1,v3,zk)

          do igauss=1,shelln(ishell)

             iex = shella(ishell) + igauss - 1
             ipnth = ipnt + igauss
             ex  = exx(iex)

             prexpz(ipnth) = dexp(-ex*zk*zk)


          end do

          ipnt = ipnt + shelln(ishell)

      end do

      return
      end

      subroutine denfsd(sum,psi,vectrs,vectrb,focc,focb)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension psi(*),vectrs(*),vectrb(*),focc(*),focb(*)

      sum = 0.0d0
      do k=1,norbs
         if (focc(k).gt.0.00001d0) then
            summ = 0.0d0
            do i=1,norbs
                summ = summ + 
     &                 vectrs((k-1)*mxorb+i)*psi(i)
            end do
            sum = sum + focc(k)*summ*summ
         endif
      end do

      if (iuhf.eq.1) then
         do k=1,norbs
            if (focb(k).gt.0.0d0) then
               summ = 0.0d0
               do i=1,norbs
                   summ = summ + 
     &                    vectrb((k-1)*mxorb+i)*psi(i)
               end do
               if (ispd.eq.0) then
                   sum = sum + focb(k)*summ*summ
               else
                   sum = sum - focb(k)*summ*summ
               endif
            endif
         end do
      endif

      return
      end

      subroutine calelf(psi,phi,dphi,dxpsi,dypsi,dzpsi,
     &                  vectrs,vectrb,focc,focb,gradf,dn)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension psi(*),phi(*),dphi(3,*),dxpsi(*),dypsi(*),dzpsi(*)
      dimension vectrs(*),vectrb(*),focc(*),focb(*)

      gradfa = 0.0d0
      gradfb = 0.0d0

      do j=1,norbs
         phi(j) = 0.0d0
         dphi(1,j) = 0.0d0
         dphi(2,j) = 0.0d0
         dphi(3,j) = 0.0d0
      end do

      do i=1,norbs
         do j=1,norbs
           phi(i) = phi(i) + vectrs((i-1)*mxorb+j)*psi(j)
           dphi(1,i) = dphi(1,i) + vectrs((i-1)*mxorb+j)*dxpsi(j)
           dphi(2,i) = dphi(2,i) + vectrs((i-1)*mxorb+j)*dypsi(j)
           dphi(3,i) = dphi(3,i) + vectrs((i-1)*mxorb+j)*dzpsi(j)
         end do
      end do

      do i=1,norbs
        if (focc(i).gt.0.0) then
         do j=i,norbs
           if (focc(j).gt.0.0) then
             phidx= phi(i)*dphi(1,j)-phi(j)*dphi(1,i)
             phidy= phi(i)*dphi(2,j)-phi(j)*dphi(2,i)
             phidz= phi(i)*dphi(3,j)-phi(j)*dphi(3,i)
             pll = phidx*phidx + phidy*phidy + phidz*phidz 
             gradfa = gradfa + pll
           endif
         end do
        endif
      end do
 

      if (iuhf.eq.1) then

         do j=1,norbs
            phi(j) = 0.0d0
            dphi(1,j) = 0.0d0
            dphi(2,j) = 0.0d0
            dphi(3,j) = 0.0d0
         end do

         do i=1,norbs
            do j=1,norbs
              phi(i) = phi(i) + vectrb((i-1)*mxorb+j)*psi(j)
              dphi(1,i) = dphi(1,i) + vectrb((i-1)*mxorb+j)*dxpsi(j)
              dphi(2,i) = dphi(2,i) + vectrb((i-1)*mxorb+j)*dypsi(j)
              dphi(3,i) = dphi(3,i) + vectrb((i-1)*mxorb+j)*dzpsi(j)
            end do
         end do

         do i=1,norbs
           if (focb(i).gt.0.0) then
            do j=i,norbs
              if (focb(j).gt.0.0) then
                phidx= phi(i)*dphi(1,j)-phi(j)*dphi(1,i)
                phidy= phi(i)*dphi(2,j)-phi(j)*dphi(2,i)
                phidz= phi(i)*dphi(3,j)-phi(j)*dphi(3,i)
                pll = phidx*phidx + phidy*phidy + phidz*phidz 
                gradfb = gradfb + pll
              endif
            end do
           endif
         end do

      else
         gradfa = gradfa + gradfa
      endif

      gradf = gradfa + gradfb

      dna = 0.0d0
      do j=1,norbs
        dna = dna + focc(j)*phi(j)*phi(j)
      end do

      dnb = 0.0d0
      if (iuhf.eq.1) then
         do j=1,norbs
           dnb = dnb + focb(j)*phi(j)*phi(j)
         end do
      endif

      dn = dna + dnb

      return
      end

      subroutine parfd(coo,fscal)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (maxfat=1000)
      parameter (mxel=100)
      parameter (mxcon=10)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat

      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      dimension coo(3,*)

      fdefsc = 10.0d0
      if (iftyp.eq.2.or.iftyp.eq.3) fdefsc = -fdefsc

      do i=1,iatoms
         do j=1,3
             fc(j,i) = coo(j,i) + fdefsc*fscal*fxyz(j,i)
         end do
      end do

      call parptr(135,fc,fdum,idum)

      return
      end

      subroutine fcij(itype,istrt,isp,idf,cij)
      implicit double precision (a-h,o-z)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer shella,shelln,shellt,shellc,shladf,aos
      dimension cij(35)
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp

      if (itype-3.lt.0) then
         cij(1) = c1(isp)
         if (itype.gt.0) then
            cij(2) = c2(isp)
            cij(3) = c2(isp)
            cij(4) = c2(isp)
            if (itype-1.gt.0) then
               iidf = idf + isp - istrt
               cij( 5) = c3(iidf)
               cij( 6) = c3(iidf)
               cij( 7) = c3(iidf)
               cij( 8) = c3(iidf)*dsqrt(3.0d0)
               cij( 9) = cij(8)
               cij(10) = cij(8)
            endif
         endif
      elseif (itype.eq.3) then
         iidf = idf + isp - istrt
         cij(11) = c4(iidf)
         cij(12) = c4(iidf)
         cij(13) = c4(iidf)
         cij(14) = c4(iidf)*dsqrt(5.0d0)
         cij(15) = cij(14)
         cij(16) = cij(14)
         cij(17) = cij(14)
         cij(18) = cij(14)
         cij(19) = cij(14)
         cij(20) = c4(iidf)*dsqrt(15.0d0)
      else
         iidf = idf + isp - istrt
         cij(21) = c5(iidf)
         cij(22) = c5(iidf)
         cij(23) = c5(iidf)
         cij(24) = c5(iidf)*dsqrt(7.0d0)
         cij(25) = cij(24)
         cij(26) = cij(24)
         cij(27) = cij(24)
         cij(28) = cij(24)
         cij(29) = cij(24)
         cij(30) = c5(iidf)*dsqrt(35.0d0/3.0d0)
         cij(31) = cij(30)
         cij(32) = cij(30)
         cij(33) = c5(iidf)*dsqrt(35.0d0)
         cij(34) = cij(33)
         cij(35) = cij(33)
      endif
 
      return
      end

      subroutine gtbpar(istat,i1,i2,bl,bk)
      implicit real (a-h,o-z), integer (i-n)
      integer*2 i1, i2
      parameter (mxbnd=86)
      integer bndcon
      common /bndpar/ bnd(2,mxbnd),bndcon(2,mxbnd)
      parameter (mxamb=1590)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      logical doamb, dogaff
      parameter (mxgff=72)
      parameter (mxgbnd=747)
      integer gfbcon
      common /gfbpar/ gfbnd(2,mxgbnd),gfbcon(2,mxgbnd)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      parameter (mxcor=42)
      common /corr/   iatcor(2,mxcor)
      logical docora, docorb, doinit
      
      istat = 0
      doamb = .false.
      dogaff = .false.
      docora = .true.
      docorb = .false.
      doinit = .true.

      if (i1.gt.0.and.i2.gt.0) then
         doamb = .true.
      elseif (i1.lt.0.or.i2.lt.0) then
         dogaff = .true.
      endif

      if (doamb) then
         iac = ambcls(i1)
         ibc = ambcls(i2)

         do k=1,mxbnd 
            if (
     &       (iac.eq.bndcon(1,k).and.ibc.eq.bndcon(2,k))
     &          .or.
     &       (ibc.eq.bndcon(1,k).and.iac.eq.bndcon(2,k))
     &      ) then
               istat = 1
               bl = bnd(2,k)
               bk = bnd(1,k)
            endif
         end do

         if (istat.eq.0.and.(i1.ge.1254.and.i2.ge.1254)) then
            iac = amb2gf(i1)
            ibc = amb2gf(i2)
            dogaff = .true.
            doinit = .false.
         endif

      endif

      if (dogaff) then

         if (doinit) then
            if (i1.gt.0) then
               iac = mapagf(ambcls(i1))
            else
               iac = abs(i1)
               if (iac.eq.72) iac = 6
            endif
            if (i2.gt.0) then
               ibc = mapagf(ambcls(i2))
            else
               ibc = abs(i2)
               if (ibc.eq.72) ibc = 6
            endif
         endif

10       continue

         do k=1,mxgbnd 
            if (
     &       (iac.eq.gfbcon(1,k).and.ibc.eq.gfbcon(2,k))
     &          .or.
     &       (ibc.eq.gfbcon(1,k).and.iac.eq.gfbcon(2,k))
     &      ) then
               istat = 1
               bl = gfbnd(2,k)
               bk = gfbnd(1,k)
            endif
         end do

         if (istat.ne.1.and.docora) then

            do i=1,mxcor
               if (iac.eq.iatcor(1,i)) iac = iatcor(2,i)
            end do

            docora = .false.
            docorb = .true.
            goto 10
         endif

         if (istat.ne.1.and.docorb) then

            do i=1,mxcor
               if (ibc.eq.iatcor(1,i)) ibc = iatcor(2,i)
            end do

            docorb = .false.
            goto 10
         endif

      endif

      return
      end

      subroutine bndard(istat,nbnd,ibnd,bl,bk,maxbnd,iconn,ityp,iopt)
c
c     create bond list from the connection array and assign parameters
c
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      parameter (mxbnd=86)
      integer bndcon
      common /bndpar/ bnd(2,mxbnd),bndcon(2,mxbnd)
      parameter (mxamb=1590)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      integer*2 ityp
      dimension iconn(mxcon+1,*),ityp(*),iopt(*),
     &          ibnd(2,*),bl(*),bk(*)

      nbnd = 0
      istat = 1

      do i=1,iatoms
         do j=1,iconn(1,i)
            jj = iconn(j+1,i)
            if (jj.gt.0) then
               if (i.lt.jj.and.(iopt(i).eq.1.or.iopt(jj).eq.1)) then
                  if (nbnd.lt.maxbnd) then
                     nbnd = nbnd + 1
                     ibnd(1,nbnd) = i
                     ibnd(2,nbnd) = jj
                     call gtbpar(istat,
     &                    ityp(i),ityp(jj),bl(nbnd),bk(nbnd))
                     if (istat.eq.0) write(iun5,*) 
     &                       'Missing Bond parameter: ',
     &                               abs(ityp(i)),abs(ityp(jj))
                  else
                     istat = 0
                  endif
               endif
            endif
         end do
      end do

      return
      end

      subroutine bond(eb,nbnd,ibnd,bl,bk,coo,forces)
      implicit real (a-h,o-z), integer (i-n)
      common /athlp/  iatoms, mxnat
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast

      dimension ibnd(2,*), bl(*), bk(*), coo(3,*), forces(3,*)
      dimension vab(3)

      eb = 0.0e0

      do i = 1, nbnd
         ia = ibnd(1,i)
         ib = ibnd(2,i)
         bopt = bl(i)
         fk = bk(i)

            do j=1,3
               vab(j) = coo(j,ia) - coo(j,ib)
            end do

            if (box) call reddis(vab)

            rab = vlen(vab)
            dt = rab - bopt

            dt2 = dt * dt
            e = fk * dt2 
            deddt = 2.0e0 * fk * dt

            de = deddt / rab

            call vscal(vab,3,de)

            eb = eb + e
          
            do j=1,3
               forces(j,ia) = forces(j,ia) + vab(j)
               forces(j,ib) = forces(j,ib) - vab(j)
            end do

      end do

      return
      end

      subroutine addd(imo,ipsi,iao,
     &                p,paa,psi)
c THIS IS REALLY atmd
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /atopla/ xsym(numatm),ysym(numatm),zsym(numatm),
     &                isym(numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      dimension p(*),paa(*),psi(*)

      ipreca = 0
      write(iun3,'(//''ELECTR. DENSITY/INTENSITY AT ATOMS '',
     &   ''LYING IN THE PLANE OF THE PLOT''//)')
      write(iun3,
     &   '(''  ATOM    X         Y         Z           VALUE'')')
      write(iun3,'(//)')
      do l=1,natoms
        if (isym(l).eq.1) then
           if (imo.eq.1) then
              call slater(xyz(1,l),xyz(2,l),xyz(3,l),psi)
           elseif (iao.eq.1.and.isgau.eq.0) then
              call adffun(xyz(1,l),xyz(2,l),xyz(3,l),psi)
           else
              call gaussian(xyz(1,l),xyz(2,l),xyz(3,l),psi,norbs,
     &                      ipreca,0,0)
           endif
           sum = 0.0d0
           if (ipsi.eq.0)  then
              do i=1,norbs
                 sum = sum - psi(i)*psi(i)*p((i-1)*mxorb+i)*0.5d0
                 do j=1,i
                    sum = sum + psi(i)*psi(j)*p((j-1)*mxorb+i)
                 end do
              end do
              sum = sum + sum
           else
              do i=1,norbs
                 sum = sum + paa(i)*psi(i)
              end do
           endif
          write(iun3,222)elemnt(nat(l)),(xyz(ig,l),ig=1,3),sum
        endif
      end do

222   format(4x,a2,3f10.5,2x,f13.5)

      return
      end

      subroutine defpc
c     count atoms in the xy,xz,yz planes
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)

      px  = 0.0d0
      py  = 0.0d0
      pz  = 0.0d0

      cx  = 0.0d0
      cy  = 0.0d0
      cz  = 0.0d0

      nxy = 0
      nxz = 0
      nyz = 0

      do l=1,natoms
         xinpxy    = xyz(1,l)*.0d0 + xyz(2,l)*.0d0 + xyz(3,l)*1.d0
         xinpxy    = xinpxy * xinpxy
         xinpxz    = xyz(1,l)*.0d0 + xyz(2,l)*1.d0 + xyz(3,l)*.0d0
         xinpxz    = xinpxz * xinpxz
         xinpyz    = xyz(1,l)*1.d0 + xyz(2,l)*.0d0 + xyz(3,l)*.0d0
         xinpyz    = xinpyz * xinpyz
         if (xinpxy.lt.1.d-10) nxy = nxy + 1
         if (xinpxz.lt.1.d-10) nxz = nxz + 1
         if (xinpyz.lt.1.d-10) nyz = nyz + 1
      end do

      if (natoms.gt.2) then
         if (nxy.ge.3.or.nxz.ge.3.or.nyz.ge.3) then
            iplat = 0
            if (nxy.ge.nxz.and.nxy.ge.nyz) then
                cz = 1.0d0
            elseif (nxz.ge.nxy.and.nxz.ge.nyz) then
                cy = 1.0d0
            else
                cx = 1.0d0
            endif
         else
            call parpla(1,2,3,istat)
            if (istat.eq.1) then
               do i=4,natoms
                  call parpla(1,2,i,istat)
                  if (istat.eq.0) goto 100
               end do
            endif
         endif
100      continue
      else
         iplat = 0
         if (nxy.eq.2) then
            cz = 1.0d0
         elseif (nxz.eq.2) then
            cy = 1.0d0
         elseif (nyz.eq.2) then
            cz = 1.0d0
         else
            cx = xyz(1,2) - xyz(1,1)
            cy = xyz(2,2) - xyz(2,1)
            cz = xyz(3,2) - xyz(3,1)
         endif
      endif

      return
      end

      subroutine rota(alfa)
      implicit double precision (a-h,o-z)
      common/rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg

c--   alfa expected in degrees
      rada = alfa / todeg
      amat(1,1) =  dcos(rada)
      amat(1,2) =  dsin(rada)
      amat(2,1) = -dsin(rada)
      amat(2,2) =  dcos(rada)

      return
      end

      program ambfor
c
c  AMBER General Force Field for organic mol. (June, 2003)
c  The AMBFOR GAFF implementation:
c  
c   1 X   Placeholder for wildcard
c   2 c   Sp2 C carbonyl group 
c   3 c1  Sp C
c   4 c2  Sp2 C  
c   5 c3  Sp3 C
c   6 ca  Sp2 C in pure aromatic systems
c   7 cp  Head Sp2 C that connect two rings in biphenyl sys. 
c   8 cq  Head Sp2 C that connect two rings in biphenyl sys. identical to cp 
c   9 cc  Sp2 carbons in non-pure aromatic systems
c  10 cd  Sp2 carbons in non-pure aromatic systems, identical to cc
c  11 ce  Inner Sp2 carbons in conjugated systems
c  12 cf  Inner Sp2 carbons in conjugated systems, identical to ce
c  13 cg  Inner Sp carbons in conjugated systems
c  14 ch  Inner Sp carbons in conjugated systems, identical to cg
c  15 cx  Sp3 carbons in triangle systems
c  16 cy  Sp3 carbons in square systems
c  17 cu  Sp2 carbons in triangle systems
c  18 cv  Sp2 carbons in square systems
c  19 h1  H bonded to aliphatic carbon with 1 electrwd. group  
c  20 h2  H bonded to aliphatic carbon with 2 electrwd. group 
c  21 h3  H bonded to aliphatic carbon with 3 electrwd. group 
c  22 h4  H bonded to non-sp3 carbon with 1 electrwd. group 
c  23 h5  H bonded to non-sp3 carbon with 2 electrwd. group 
c  24 ha  H bonded to aromatic carbon  
c  25 hc  H bonded to aliphatic carbon without electrwd. group 
c  26 hn  H bonded to nitrogen atoms
c  27 ho  Hydroxyl group
c  28 hp  H bonded to phosphate 
c  29 hs  Hydrogen bonded to sulphur 
c  30 hw  Hydrogen in water 
c  31 hx  H bonded to C next to positively charged group  
c  32 f   Fluorine
c  33 cl  Chlorine 
c  34 br  Bromine 
c  35 i   Iodine 
c  36 n   Sp2 nitrogen in amide groups
c  37 n1  Sp N  
c  38 n2  aliphatic Sp2 N with two connected atoms 
c  39 n3  Sp3 N with three connected atoms
c  40 n4  Sp3 N with four connected atoms 
c  41 na  Sp2 N with three connected atoms 
c  42 nb  Sp2 N in pure aromatic systems 
c  43 nc  Sp2 N in non-pure aromatic systems
c  44 nd  Sp2 N in non-pure aromatic systems, identical to nc
c  45 ne  Inner Sp2 N in conjugated systems
c  46 nf  Inner Sp2 N in conjugated systems, identical to ne
c  47 nh  Amine N connected one or more aromatic rings 
c  48 no  Nitro N  
c  49 o   Oxygen with one connected atom
c  50 oh  Oxygen in hydroxyl group
c  51 os  Ether and ester oxygen
c  52 ow  Oxygen in water 
c  53 p2  Phosphate with two connected atoms 
c  54 p3  Phosphate with three connected atoms, such as PH3
c  55 p4  Phosphate with three connected atoms, such as O=P(CH3)2
c  56 p5  Phosphate with four connected atoms, such as O=P(OH)3
c  57 pb  Sp2 P in pure aromatic systems 
c  58 pc  Sp2 P in non-pure aromatic systems
c  59 pd  Sp2 P in non-pure aromatic systems, identical to pc
c  60 pe  Inner Sp2 P in conjugated systems
c  61 pf  Inner Sp2 P in conjugated systems, identical to pe
c  62 px  Special p4 in conjugated systems
c  63 py  Special p5 in conjugated systems
c  64 s   S with one connected atom 
c  65 s2  S with two connected atom, involved at least one double bond  
c  66 s4  S with three connected atoms 
c  67 s6  S with four connected atoms 
c  68 sh  Sp3 S connected with hydrogen 
c  69 ss  Sp3 S in thio-ester and thio-ether
c  70 sx  Special s4 in conjugated systems
c  71 sy  Special s6 in conjugated systems
c  72 cz  Sp2 carbon in guadinium
c
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxion=2000)
      character line*132,fniun*132
      character argstr*75
      logical opfil,gargpl,osingl,dolbfgs,oqscal
cmpi      include 'mpif.h'
      common /fnam/ fniun, lenf
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      logical box,cell,addbox,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /passe/ emin
      common /passq/ scalq
      common /athlp/  iatoms, mxnat
      common /prot/ ireswr
      logical doint
      common /intr/ ecold,evold,ewold,iprog,doint
      common /convg/ icyc
      common /debug/ ideb
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      integer taskid
      common /mpih/ nproc,taskid
      character*3 ambstr
      character*2 gffstr
      character liris*256
      common /ffstr/ ambstr(mxamb), gffstr(mxgff)
      data (ambstr(i),i=1,100) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','HC ','CT ','HC ','CT ','HC ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','CT ','HC ','CT ','HC ','CT ','HC ',
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CT ','HC ',
     & 'CT ','HC ','CT ','HC ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','H1 ','OH ','HO ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','H1 ','OH ','HO ','CT ','HC ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','H1 ','SH ','HS ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','H1 ','S  ','N  ','CT ','C  ','O  ','H1 '/
      data (ambstr(i),i=101,200) /
     & 'CT ','HC ','CT ','HC ','CT ','H1 ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','CA ','CA ','HA ','CA ','HA ','CA ',
     & 'HA ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CA ',
     & 'CA ','HA ','CA ','HA ','C  ','OH ','HO ','N  ','CT ','C  ',
     & 'H  ','O  ','H1 ','CT ','HC ','C* ','CW ','H4 ','CB ','NA ',
     & 'H  ','CN ','CA ','HA ','CA ','HA ','CA ','HA ','CA ','HA ',
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CC ','NA ',
     & 'H  ','CW ','H4 ','CR ','H5 ','NA ','H  ','N  ','CT ','C  ',
     & 'H  ','O  ','H1 ','CT ','HC ','CC ','NA ','H  ','CV ','H4 ',
     & 'CR ','H5 ','NB ','N  ','CT ','C  ','H  ','O  ','H1 ','CT '/
      data (ambstr(i),i=201,300) /
     & 'HC ','CC ','NB ','CW ','H4 ','CR ','H5 ','NA ','H  ','N  ',
     & 'CT ','C  ','H  ','O  ','H1 ','CT ','HC ','C  ','O2 ','N  ',
     & 'CT ','C  ','H  ','O  ','H1 ','CT ','HC ','C  ','O  ','N  ',
     & 'H  ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CT ',
     & 'HC ','C  ','O2 ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ',
     & 'HC ','CT ','HC ','C  ','O  ','N  ','H  ','N  ','CT ','C  ',
     & 'H  ','O  ','H1 ','CT ','HC ','CT ','H1 ','S  ','CT ','H1 ',
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ','CT ','HC ',
     & 'CT ','HC ','CT ','HP ','N3 ','H  ','N  ','CT ','C  ','H  ',
     & 'O  ','H1 ','CT ','HC ','CT ','HC ','CT ','H1 ','N2 ','H  '/
      data (ambstr(i),i=301,400) /
     & 'CA ','N2 ','H  ','N  ','CT ','C  ','H  ','O  ','H1 ','CT ',
     & 'HC ','CT ','HC ','CT ','HP ','N3 ','H  ','N  ','CT ','C  ',
     & 'H  ','O  ','CT ','HC ','N  ','CT ','C  ','H  ','O  ','H1 ',
     & 'CT ','HC ','CT ','HC ','C  ','O  ','C  ','H  ','O  ','CT ',
     & 'HC ','C  ','O  ','N  ','H  ','N  ','H  ','CT ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  '/
      data (ambstr(i),i=401,500) /
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','CT ',
     & 'HP ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ',
     & 'H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ',
     & 'H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  ','H1 ','N3 ',
     & 'CT ','C  ','H  ','O  ','H1 ','N3 ','CT ','C  ','H  ','O  '/
      data (ambstr(i),i=501,600) /
     & 'N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ',
     & 'O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ',
     & 'C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ',
     & 'N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ',
     & 'O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ',
     & 'C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','O2 ','H1 ','N  ',
     & 'CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ',
     & 'H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ',
     & 'H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ',
     & 'CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 '/
      data (ambstr(i),i=601,659) /
     & 'H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ',
     & 'H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ',
     & 'CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ',
     & 'H1 ','N  ','CT ','C  ','H  ','O2 ','H1 ','N  ','CT ','C  ',
     & 'H  ','O2 ','H1 ','N  ','CT ','C  ','H  ','O2 ','OW ','HW ',
     & 'Li+','Na+','K+ ','Rb+','Cs+','Mg+','Ca+','Zn+','Cl-'/

c     some neutral residues

      data (ambstr(i),i=660,671) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ',
     & 'C  ','O  ','OH ','HO '/ 
      data (ambstr(i),i=672,685) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ',
     & 'CT ','HC ','C  ','O  ','OH ','HO '/ 
      data (ambstr(i),i=686,701) /
     & 'N  ','CT ','C  ','H  ','O  ','H1 ','CT ','HC ',
     & 'CT ','HC ','CT ','HC ','CT ','HP ','N3 ','H  '/ 

      data (ambstr(i),i=1001,1100) /
     & 'OS ','CT ','H1 ','H1 ','CT ','H1 ','OS ','CT ','H2 ','CT ',
     & 'H1 ','CT ','H1 ','OH ','HO ','OS ','N* ','CB ','CB ','NB ',
     & 'CK ','NC ','CQ ','NC ','CA ','H5 ','N2 ','H  ','H  ','H5 ',
     & 'OS ','CT ','H1 ','H1 ','CT ','H1 ','OS ','CT ','H2 ','CT ',
     & 'H1 ','CT ','H1 ','OH ','HO ','OS ','N* ','CB ','CB ','NB ',
     & 'CK ','NC ','CA ','NA ','C  ','H  ','N2 ','H  ','H  ','O  ',
     & 'H5 ','OS ','CT ','H1 ','H1 ','CT ','H1 ','OS ','CT ','H2 ',
     & 'CT ','H1 ','CT ','H1 ','OH ','HO ','OS ','N* ','C  ','NC ',
     & 'CA ','CM ','CM ','O  ','N2 ','H  ','H  ','HA ','H4 ','OS ',
     & 'CT ','H1 ','H1 ','CT ','H1 ','OS ','CT ','H2 ','CT ','H1 '/

      data (ambstr(i),i=1101,1200) /
     & 'CT ','H1 ','OH ','HO ','OS ','N* ','C  ','NA ','C  ','CM ',
     & 'CM ','O  ','H  ','O  ','HA ','H4 ','OS ','CT ','H1 ','H1 ',
     & 'CT ','H1 ','OS ','CT ','H2 ','CT ','H1 ','CT ','HC ','HC ',
     & 'OS ','N* ','CB ','CB ','NB ','CK ','NC ','CQ ','NC ','CA ',
     & 'H5 ','N2 ','H  ','H  ','H5 ','OS ','CT ','H1 ','H1 ','CT ',
     & 'H1 ','OS ','CT ','H2 ','CT ','H1 ','CT ','HC ','HC ','OS ',
     & 'N* ','CB ','CB ','NB ','CK ','NC ','CA ','NA ','C  ','H  ',
     & 'N2 ','H  ','H  ','O  ','H5 ','OS ','CT ','H1 ','H1 ','CT ',
     & 'H1 ','OS ','CT ','H2 ','CT ','H1 ','CT ','HC ','HC ','OS ',
     & 'N* ','C  ','NC ','CA ','CM ','CM ','O  ','N2 ','H  ','H  '/

      data (ambstr(i),i=1201,1253) /
     & 'HA ','H4 ','OS ','CT ','H1 ','H1 ','CT ','H1 ','OS ','CT ',
     & 'H2 ','CT ','H1 ','CT ','HC ','HC ','OS ','N* ','C  ','NA ',
     & 'C  ','CM ','CM ','O  ','H  ','O  ','CT ','HC ','H4 ','P  ',
     & 'O2 ','OH ','HO ','OS ','P  ','O2 ','OH ','HO ','OS ','P  ',
     & 'O2 ','P  ','O2 ','OH ','HO ','OS ','P  ','O2 ','OH ','HO ',
     & 'OS ','P  ','O2 '/

c modified nucl

      data (ambstr(i),i=1254,1284) /
     & 'OS','CT','H1','H1','CT','H1','OS','CT','H2','CT','H1',
     & 'CT','H1','OH','HO','OS','N*','CB','CB','NB','CK','NC',
     & 'CQ','N*','C ','H1','N ','H ','H5','CT','H1'/

      data (ambstr(i),i=1285,1311) /
     & 'OS', 'CM', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'N*', 'C ', 'NC',
     & 'CA', 'CT', 'CM', 'H4', 'O ', 'N2', 'H ', 'CT', 'HC'/

      data (ambstr(i),i=1312,1338) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OS', 'OS', 'N*', 'C ', 'O ', 'NC',
     & 'CA', 'N2', 'H ', 'CM', 'HA', 'CM', 'H4', 'CT', 'H1'/
 
      data (ambstr(i),i=1339,1369) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'N*', 'CB', 'CB',
     & 'NB', 'CK', 'H5', 'NC', 'CA', 'NA', 'H ', 'C ', 'O ',
     & 'N ', 'H ', 'CT', 'H1'/ 

      data (ambstr(i),i=1370,1399) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'N*', 'CB', 'CB',
     & 'NB', 'CK', 'NC', 'CA', 'NA', 'C ', 'O ', 'H ', 'H5',
     & 'N2', 'CT', 'H1'/

      data (ambstr(i),i=1400,1430) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'N*', 'CB', 'CB',
     & 'NA', 'CK', 'NC', 'CA', 'NA', 'C ', 'O ', 'H ', 'H5',
     & 'N2', 'H ', 'CT', 'H1'/

      data (ambstr(i),i=1431,1460) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OS', 'OS', 'N*', 'CB', 'CB', 'NB',
     & 'CK', 'NC', 'CA', 'NA', 'C ', 'O ', 'H ', 'H5', 'N2',
     & 'H ', 'CT', 'H1'/ 

      data (ambstr(i),i=1461,1511) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H1', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'N*', 'CB', 'CB',
     & 'NB', 'CK', 'N*', 'CB', 'N*', 'C ', 'O ', 'NB', 'CC',
     & 'CC', 'H5', 'CT', 'H1', 'CT', 'HC', 'CT', 'HC', 'CT',
     & 'HC', 'CT', 'H1', 'C ', 'O ', 'OS', 'CT', 'H1', 'N ',
     & 'H ', 'C ', 'O ', 'OS', 'CT', 'H1'/ 

      data (ambstr(i),i=1512,1537) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'N ', 'C ', 'N ',
     & 'C ', 'CT', 'CT', 'O ', 'O ', 'H ', 'HC', 'H1'/ 

      data (ambstr(i),i=1538,1564) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H2', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'N*', 'C ', 'NA',
     & 'C ', 'CM', 'CM', 'O ', 'O ', 'H ', 'H4', 'CT', 'HC'/

      data (ambstr(i),i=1565,1590) /
     & 'OS', 'CT', 'H1', 'CT', 'H1', 'OS', 'CT', 'H1', 'CT',
     & 'H1', 'CT', 'H1', 'OH', 'HO', 'OS', 'CM', 'CM', 'NA',
     & 'C ', 'NA', 'C ', 'O ', 'O ', 'H4', 'H ', 'H '/

c GAFF
      data gffstr /
     &  'x ', 'c ', 'c1', 'c2', 'c3', 'ca', 'cp', 'cq', 'cc', 'cd',
     &  'ce', 'cf', 'cg', 'ch', 'cx', 'cy', 'cu', 'cv', 'h1', 'h2',
     &  'h3', 'h4', 'h5', 'ha', 'hc', 'hn', 'ho', 'hp', 'hs', 'hw',
     &  'hx', 'f ', 'cl', 'br', 'i ', 'n ', 'n1', 'n2', 'n3', 'n4',
     &  'na', 'nb', 'nc', 'nd', 'ne', 'nf', 'nh', 'no', 'o ', 'oh',
     &  'os', 'ow', 'p2', 'p3', 'p4', 'p5', 'pb', 'pc', 'pd', 'pe',
     &  'pf', 'px', 'py', 's ', 's2', 's4', 's6', 'sh', 'ss', 'sx',
     &  'sy', 'cz'/

      idebug  = 0
      osingl  = .false.
      oqscal  = .false.
      scalq   = 1.0e0
      dolbfgs   = .true.
      box     = .false.
      addbox  = .false.
      usecut  = .false.
      usesw   = .false.
      fast = .true.
      doint = .true.
      iprog = 1
      imon = 0
      iarc = 0
      iout = 1
      ilog = 0
c      icyc = 0
      gtol = 0.03e0
      nsd  = 100000
      ireswr = 0
      iff99sb = 1
      iff99bc = 0
      ionpl = 1
      nproc = 1
      ideb = 0
      lammps = 0
  
      n = iargc()

      nargs = iargc()
      call getarg(0,liris)
      call parsfn(liris,linlen(liris))

      if (idebug.eq.1) then
         if (.not.opfil(61,"log",3,1,0,0)) then
            stop
         endif
      endif

      icnt = 1
      lenf = -1
      do while (icnt.le.n)
         call getarg(icnt,line)
         if (idebug.eq.1) write(61,*) "=",line,"="
         if (line(1:1).eq.'-') then

            if (line(1:2).eq.'-v') then
               idebug = 1
            elseif (line(1:2).eq.'-m') then
               imon = 1
            elseif (line(1:2).eq.'-M') then
               imon = 2
            elseif (line(1:2).eq.'-b') then
               addbox = .true.
            elseif (line(1:2).eq.'-n') then
               ilog = 1
            elseif (line(1:2).eq.'-i') then
               fast = .false.
            elseif (line(1:2).eq.'-l') then
               lammps = 1
            elseif (line(1:2).eq.'-N') then
               usecut = .true.
            elseif (line(1:2).eq.'-a') then
               iarc = 1
            elseif (line(1:2).eq.'-p') then
               dolbfgs = .false.
            elseif (line(1:2).eq.'-s') then
               osingl = .true.
            elseif (line(1:2).eq.'-S') then
               oqscal = .true.
               if (gargpl('-S',icnt,line,argstr)) then
                  scalq = reada(argstr,1,len(argstr))
               endif
            elseif (line(1:2).eq.'-x') then
               iff99sb = 0
            elseif (line(1:2).eq.'-y') then
               iff99bc = 1
            elseif (line(1:2).eq.'-z') then
               ionpl = 0
            elseif (line(1:2).eq.'-g') then
               if (gargpl('-g',icnt,line,argstr)) then
                  gtol = reada(argstr,1,len(argstr))
               endif
            elseif (line(1:2).eq.'-c') then
               if (gargpl('-c',icnt,line,argstr)) then
                  read(argstr,*) nsd
               endif
            elseif (line(1:2).eq.'-C') then
               usecut = .true.
               usesw  = .true.
            elseif (line(1:2).eq.'-h') then
               call prthlp
               stop
            else 
               if (idebug.eq.1) then
                 write(61,*) 'Unknown commandline option '//line(1:2)
               else
                 print*, 'Unknown commandline option '//line(1:2)
                 call prthlp
               endif
               stop
            endif

         else

            lenf = index(line,' ')-1
            if (linlen(line).gt.lenf) lenf = linlen(line)
            call fndchr(line(1:lenf),lenf,'.',idot)
            call fndchr(line(1:lenf),lenf,'/',isl)
            if (idot.gt.0.and.idot.gt.isl) then
               fniun = line(1:idot-1)
            else
               fniun = line(1:linlen(line))
            endif
            lenf = linlen(fniun)
            if (idebug.eq.1) 
     &         write(61,*) fniun(1:lenf),lenf
            call opfiles
            icnt = n

         endif

         icnt = icnt + 1

      end do

c     no input file found

      if (lenf.eq.-1) then
         print*, 'Missing input file '
         call prthlp
         stop
      endif

      if (idebug.eq.1) then
         write(61,*) "end of argument parsing"
         write(61,*) "gtol=",gtol," nsd=",nsd
         close(61)
      endif

cmpi      call mpi_init(ierr)
cmpi      call mpi_comm_size(mpi_comm_world, nproc, ierr)

      call param

      call parptr(6,fdum,fdum,nproc)
      call parptr(7,fdum,fdum,taskid)
      call parptr(11,fdum,fdum,lammps)

      if (iff99sb.eq.1) call ff99sb
      if (iff99bc.eq.1) call ff99bc

      call getinp(istat)

      call settmp()

      if (addbox.and.box) addbox = .false.

      call conn34(istat)

      call bndarr(istat)
      call angarr(istat)
      call itrarr(istat)
      call torarr(istat)
      call asschg(idebug)

      if (idebug.eq.1) then
         call prttor(istat)
         call pritor(istat)
      endif

      if (addbox) then
         box = .true.
         call makbox
         call allbox
         if (nion.ne.0) call cntwat
         call filbox
      else
         call allbck
      endif

      if (cell) then
         call initxp
         dolbfgs   = .false.
      endif

      if (usesw) then
         cutoff = 8.0e0
         call inisw
         call bldlst
      endif

      if (iatoms.gt.333.and.dolbfgs) then
c      if (dolbfgs) then
         call lbfgs(emin,gtol,nsd)
      else
         dolbfgs = .false.
         call optimise(emin,gtol,nsd)
      endif

      if (box) call appbnx()
      if (imon.ne.0) then
         icyc = icyc + 1
         call wrmon(icyc,emin)
      endif

      call rstdir()
      call wrtout(iun3,emin)
      close(iun3)

      if (iarc.eq.1) close(iun4)
      if (ilog.eq.1) close(iun5)

cmpi      call mpi_finalize(ierr)

      end

      subroutine prthlp
      implicit real (a-h,o-z)

      print*, 
     &           'Usage: ambfor [commandline options] ambfor_file[.xyz]'
      print*, ' '
      print*, '  Commandline options:'
      print*, '    -m     - used in conjuction with molden'
      print*, '             produces a file per iteration:'
      print*, '             ambfor_file.001 etc.'
      print*, '    -M     - same as -m, only now binary'
      print*, '    -n     - write optimisation details to '
      print*, '             ambfor_file.log'
      print*, '    -N     - use cutoff'
      print*, '    -C     - use neighbourlist and switch functions'
      print*, '    -a     - concatenate intermediate structures'
      print*, '             into an archive file : ambfor_file.arc'
      print*, '    -p     - use Powell-Beale conjugate gradients'
      print*, '             (default is LBFGS (atoms > 333)'
      print*, '    -s     - calculate single point energy'
      print*, '    -c 10000 - maximum iterations'
      print*, '    -g 0.01  - gradient convergence criterium'
      print*, '    -b       - generate water filled box'
      print*, '    -x       - use amber ff99 force field '
      print*, '               (default amber ff99sb)'
      print*, '    -y       - use amber ff99bsc0 DNA/RNA force field '
      print*, '    -z       - random placement ions (with -b)'
      print*, '    -l       - print conversion to lammps'
      print*, '    -h       - this help message'
      print*, ' '

      return
      end

      subroutine prtene(nfun,f,gnorm)
      implicit real (a-h,o-z)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      integer taskid
      common /mpih/ nproc,taskid

      if (nproc.eq.1.or.(nproc.gt.1.and.taskid.eq.0)) then
          write(iun5,'(i6,a,f12.3,a,f12.3)') 
     &      nfun,' Emin=',f,' gnorm=',gnorm
      endif

      return
      end

      subroutine pareul
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /eulx/   ca,cb,sa,sb,cc,sc
      common /rd3d/   ird3d
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      dimension t(3),u(3)

      cl = cx*cx + cy*cy + cz*cz
      cl = dsqrt(cl)
      cx = cx/cl
      cy = cy/cl
      cz = cz/cl

      if (cx.eq.0.d0.and.cy.eq.0.d0) cz = 1.d0
c
c calculate direction cosines and sines that determine the 
c orientation of the plot plane with respect to the coordinate
c system
c
      xy = cx*cx + cy*cy
      if (xy.gt.1.d-15) then
          r1 = dsqrt(xy+cz*cz)
          xy = dsqrt(xy)
          ca = cx/xy
          cb = cz/r1
          sa = cy/xy
          sb = xy/r1
      else
          ca = 1.d0
          cb = 1.d0
          sa = 0.d0
          sb = 0.d0
      endif

      v1(1) = ca*cb
      v1(2) = sa*cb
      v1(3) = -sb

      v2(1) = -sa
      v2(2) = ca
      v2(3) = 0.0d0

      if (iplat.eq.0.and.ird3d.eq.1) then
         do i=1,natoms
            t(1) = xyz(1,i) - px
            t(2) = xyz(2,i) - py
            t(3) = xyz(3,i) - pz
            u(1) = cx
            u(2) = cy
            u(3) = cz
            call impsc(u,t,cozy)
            if (abs(cozy).lt.1.0d-4) then
               iplat = i
               goto 10
            end if
         end do
      end if

10    if (iplat.gt.0) then
         t(1) = xyz(1,iplat) - px
         t(2) = xyz(2,iplat) - py
         t(3) = xyz(3,iplat) - pz
         call vsc1(t,1.0d0,1.0d-4)
         call impsc(v1,t,cc)
         call impsc(v2,t,sc)
         do j=1,3
            v1(j) = t(j)
         end do
         t(1) = cx
         t(2) = cy
         t(3) = cz
         call crprod(t,v1,v2)
         call vsc1(v2,1.0d0,1.0d-4)
      else
         cc = 1.0d0
         sc = 0.0d0
      endif

      return
      end

      subroutine parrat
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /plrat/ rat(3)

c      print*,'edx,edy,edz, ',(r(i),i=1,3)

      rat(1) = 1.0d0
      rat(2) = r(2) / r(1)
      rat(3) = r(3) / r(1)

      if (rat(2).gt.1.0d0) then
         rat(1) = r(1) / r(2)
         rat(2) = 1.0d0
         rat(3) = r(3) / r(2)
      endif

      return
      end

      subroutine calc(x,y,z,pot)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxsite=300)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
      character*8   ctag
      common /multip/ q(lmaxf,mxsite),car(3,mxsite),ctag(mxsite),
     &                nsites
      common /extchg/ exchg(3,3),iexchg(3),nexchg
      dimension pvec(3)
c in this procedure the calculation order is inversed
c we use
c 
c   a      b      c      d       
c ---- + ---- + ---- + ---- = ((((d /x**2+c) /x**2)+b) /x**2) +a) /x
c   x    x**3   x**5   x**7   
c
      rt3  =        dsqrt(3.0d0)
      rt6  = 0.25d0*dsqrt(6.0d0)
      rt10 = 0.25d0*dsqrt(10.0d0)
      rt15 = 0.5d0 *dsqrt(15.0d0)

      pot = 0.0d0 
      do i=1,nsites

         pvec(1) = x-car(1,i)
         pvec(2) = y-car(2,i)
         pvec(3) = z-car(3,i)
         qp1     = pvec(1)*pvec(1)
         qp2     = pvec(2)*pvec(2)
         qp3     = pvec(3)*pvec(3)
         r2      = qp1+qp2+qp3
         r       = dsqrt(r2)
         pot     = pot 
     & +((((
     &(q(10,i)*0.5d0*(5.0d0*pvec(3)*qp3-3.0d0*r2*pvec(3))+
     & q(11,i)*rt6*(5.0d0*pvec(1)*qp3-r2*pvec(1))+
     & q(12,i)*rt6*(5.0d0*pvec(2)*qp3-r2*pvec(2))+
     & q(13,i)*rt15*pvec(3)*(qp1-qp2)+
     & q(14,i)*2.0d0*rt15*pvec(1)*pvec(2)*pvec(3)+
     & q(15,i)*rt10*pvec(1)*(qp1-3.0d0*qp2)+
     & q(16,i)*rt10*(-pvec(2))*(qp2-3.0d0*qp1)))/r2
     & +(q(5,i)*0.5d0*(3.0d0*qp3-r2)+
     & q(6,i)*rt3*pvec(1)*pvec(3)+
     & q(7,i)*rt3*pvec(2)*pvec(3)+
     & q(8,i)*0.5d0*rt3*(qp1-qp2)+
     & q(9,i)*rt3*pvec(1)*pvec(2)))/r2
     & +(q(2,i)*pvec(3)+q(3,i)*pvec(1)+q(4,i)*pvec(2)))/r2
     & +q(1,i))/r
      end do


      if (nexchg.ne.0) then
          do i=1,nexchg
             xt = exchg(1,i) - x
             yt = exchg(2,i) - y
             zt = exchg(3,i) - z
             rsq = xt*xt + yt*yt + zt*zt
             if (rsq.ge.1.0d-8) then
                if (iexchg(i).eq.1) then
                   pot = pot + dsqrt(1.0d0 / rsq)
                else
                   pot = pot - dsqrt(1.0d0 / rsq)
                endif
             endif
          end do
      endif

      return
      end 

      subroutine clmod(car,pot,coo,qat)
      implicit double precision (a-h,o-z), integer( i-n)
      common /athlp/ iatoms, mxnat
      dimension car(3),coo(3,*),qat(*)

      pot = 0.0d0
      do i=1,iatoms
         r = dsqrt(dist2(car,coo(1,i)))
         pot = pot + qat(i)/r
      end do

      return
      end 

      subroutine clmond(car,pot,idoloc,coo,qat,icont,ncont)
      implicit double precision (a-h,o-z), integer( i-n)
      common /athlp/ iatoms, mxnat
      dimension car(3),coo(3,*),qat(*),icont(*)

      cutoff = 900.0d0
      pot = 0.0d0

      if (idoloc.eq.1) then
         do l=1,ncont
            i = icont(l)
            if (i.gt.0.and.i.le.mxnat) then
               r2 = dist2(car,coo(1,i))
               pot = pot + qat(i)/r2
            endif
         end do
      else
         do i=1,iatoms
            r2 = dist2(car,coo(1,i))
            r = dsqrt(r2)
            pot = pot + qat(i)/r
         end do
      endif

      return
      end 

      subroutine rdorcd(idebug,irtype,istats,
     &                 ianz,iatoms,focc,focb,nocc,nocb,ncols,ncolb)

c THIS IS REALLY rdorca

      implicit double precision ( a-h,o-z)
      parameter (numat1=20000)
      parameter (mxonh=100)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      common /qmchar/ qch(numat1),ihasesp
      character*137 line,cline
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      common /pntlin/ lpnt(MAXPNT)
      dimension focc(*),focb(*),ianz(*)

      istats = 1
      irtype = 0
      istatio = 0
      toang=0.52917706d0
      irtype = 1
      ihbas = 0
      ihorb = 0
      ioni = 0
      do i=1,MAXPNT
         lpnt(i) = -1
      end do

      call rewmf
      call srctmf(line,'* Geometry Optimization Run *',
     &                 '* Single Point Calculation *',
     &                 '* Energy+Gradient Calculation *',istat)
      if (istat.eq.0) call srctmf(line,'*    Relaxed Surface Scan    *',
     &                 '*                       TS OPTIMIZATION',
     &                 '*                GEOMETRY OPTIMIZATION ',
     &                           istat)
      if (istat.eq.0) goto 1000
      if (index(line,'Single').ne.0) irtype = 1
      if (index(line,'Geometry').ne.0) irtype = 2
      if (index(line,'OPTIMIZATION').ne.0) irtype = 2
      if (index(line,'Scan').ne.0) irtype = 2
      if (index(line,'Gradient').ne.0) irtype = 1
      call srcdmf(line,'ORCA NUMERICAL FREQUENCIES',
     &                 'VIBRATIONAL FREQUENCIES',
     &                 istat)
      if (istat.ne.0) irtype = 4

c      call srchmf(line,'$rem',istat)
c      if (istat.eq.0) goto 1000
c
c      do while (.true.)
c          call rdmf(line,cline,istat)
c          if (istat.eq.0) goto 10
c          if (index(cline,'$END').ne.0) goto 10
c          if (index(cline,' SP').ne.0) irtype = 1
c          if (index(cline,' OPT').ne.0) irtype = 2
c          if (index(cline,'FREQ').ne.0) irtype = 4
c          if (index(cline,'PRINT_').ne.0) then
c             if (index(cline,'ORBITALS').ne.0) then
c                 if (index(cline,'TRUE').ne.0) ihbas = 1
c             endif
c             if (index(cline,'GENERAL_BASIS').ne.0) then
c                 if (index(cline,'TRUE').ne.0) ihorb = 1
c             endif
c          endif
c      end do
c
c10    continue
c
c      call rewmf
c
c     
c     look for number of orbitals and electrons
c
c
c      call srchmf(line,'beta electrons',istat)
c      if (istat.eq.0) then
c         call inferr('no electrons line found!',1)
c          goto 1000
c      endif
c
c      read(line,'(11x,i8,11x,i8)',err=1000,end=1000) neleca,nelecb
c
c      nelecs = neleca + nelecb
c
c      call srchmf(line,'basis functions',istat)
c      if (istat.eq.0) then
c         call inferr('no basis functions found!',1)
c         goto 1000
c      endif
c      
c      i1 = index(line,'basis functions')
c      i2 = index(line,'and')
c      line = line(i2+3:i1-1)
c      read(line,*,err=1000,end=1000) norbs
c
c      if (norbs.gt.mxorb) 
c     &   call inferr('Exceeding MaxNum of Orbitals!',1)
c
c      ncols  = norbs
c      ncolb  = norbs
cc
c      do i=1,min0(mxorb,norbs)
c         focc(i) = 0.0d0
c      end do
c      do i=1,min0(mxorb,neleca)
c         focc(i) = 1.0d0
c      end do
c
c      call rewmf
c
c      call srchmf(line,'Final Beta MO Coefficients',istat)
c      if (istat.ne.0) then
c         iuhf=1
c         nocc=neleca
c         nocb=nelecb
c         do i=1,min0(mxorb,norbs)
c            focb(i) = 0.0d0
c         end do
c         do i=1,min0(mxorb,nelecb)
c            focb(i) = 1.0d0
c         end do
c      else
c         nocc=max0(neleca,nelecb)
c         do i=1,min0(mxorb,nelecb)
c            focc(i) = focc(i) + 1.0d0
c         end do
c      endif
c
      call rewmf

      if (irtype.eq.1.or.irtype.eq.4) then
         ipnt = 1
         call orcxyz(idebug,ipnt,istat)
      elseif (irtype.eq.2) then
         ipnt = 1
         do while(.true.)
            call orcxyz(idebug,ipnt,istat)
            if (istat.eq.0) goto 50
            ipnt = ipnt + 1
         end do
50       continue
      endif

      call cooxyz(ianz,iatoms)

c      call rewmf
c      if (ihbas.eq.1) then
c         call rdbas(idebug,2,istat)
c         call norml
c         if (istat.eq.0) goto 1000
c      endif
c
c      if (idebug.eq.1) 
c     &    call inferr('Succesfully read basis-set',0)
c      if (idebug.eq.1) call basprt(iun3,.false.,.false.)
c      if (norbs.gt.mxorb) goto 1000
c
c      if (ihorb.eq.1) then
c
c          call rdqvec(idebug,istat)
c          if (istat.eq.0) goto 1000
c          if (idebug.eq.1) call inferr('Succesfully read vectors',0)
c       
c      endif

      if (idebug.eq.1) 
     &         call inferr('Succesfully read Orca output',0)

      return

1000  if (idebug.eq.1) 
     &         call inferr('Error reading Orca output!',1)
      istats = 0
      return

      end

      subroutine prsomd(molin)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,caps
      character*40 title
      character*2 gstr
      dimension molin(*)
      
      call rewfil

      imol = 1
      molin(1) = 1
      nmols = 0
      ilin = 0


1        call nxtlin(line,jstat)
         if (jstat.eq.1) goto 100
         if (jstat.eq.2) goto 200
         caps = line
         len1  = len(line)
         call tocap(caps,len1)
         ilin = ilin + 1
         if (index(caps,'* O   R   C   A *').eq.0) goto 1

         if (nmols.lt.maxmol) then
            nmols = nmols + 1
            molin(nmols) = ilin
            title = 'molecule '//gstr(nmols)
            if (nmols.gt.1) call parsfn(title,linlen(title),13)
         endif

         goto 1


100   ielin = ilin
      if (nmols.eq.0) then
         nmols = 1
         title = 'molecule '//gstr(nmols)
      endif
      call parsfn(title,linlen(title),13)

      return

200   return
      end

      subroutine orcxyd(idebug,ipnt,istat,
     &                 ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      parameter (maxfat=1000)
      integer getlin
      logical gnreal
      character*137 line,lline,cline,str
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /athlp/  iatoms, mxnat
      common /coord / xyz(3,numatm)
      common /curlin/ line
      common /pntlin/ lpnt(MAXPNT)
      character*2 elemnt,tstr,tocapf
      common /elem/elemnt(mxel)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat)
      integer getmf
      dimension r(3),coo(3,*),ianz(*)

      toang=0.52917706d0
      istat = 1
      call haszm(.false.)

      if (idebug.eq.1) print*,'ipnt=',ipnt,' lpnt=',lpnt(ipnt)

      if (lpnt(ipnt).ne.-1) then
         call putmf(lpnt(ipnt))
      else
         call rewmf
         do i=1,ipnt
            if (ipnt.eq.1) then
               call srctmf(line,'OPTIMIZATION CYCLE',
     &                 '* Single Point Calculation *',
     &                 '* Energy+Gradient Calculation *',istats)
               if (istats.eq.0) goto 100
            else
               call srchmf(line,'OPTIMIZATION CYCLE',istats)
               if (istats.eq.0) goto 100
            endif
            call srchmf(lline,'CARTESIAN COORDINATES (ANGSTROEM)',
     &                            istats)
            if (istats.eq.0) goto 100
            lpnt(ipnt) = getmf()
         end do
      endif

      call rdmf(lline,cline,istats)

      i = 0
      if (idebug.eq.1)  print*,'coordinates'

      do while(.true.)
          if (getlin(1).eq.1) then
             if (line(1:4).ne.'----') then
                ktype = nxtwrd(str,nstr,itype,rtype)
                tstr = '  '
                if (ktype.eq.0) goto 50
                if (ktype.eq.1.and.nstr.le.2) then
                   i = i + 1
                   ianz(i) = 0
                   if (nstr.eq.1) tstr(2:2) = str(1:1)
                   if (nstr.eq.2) tstr(1:2) = str(1:2)
                   do k=1,mxel
                     if (tocapf(tstr).eq.tocapf(elemnt(k))) then
                           ianz(i) = k
                     endif
                   end do
                endif
                if (gnreal(r,3,.false.)) then
                   if (idebug.eq.1)  then
                       print*,elemnt(ianz(i)),(r(j),j=1,3)
                   endif
                   do j=1,3
                       coo(j,i) = r(j) / toang
                   end do
                else
                   goto 100
                endif
             endif
          else 
             goto 100
          endif
      end do

50    iatoms = i

      call srcdmf(lline,'CARTESIAN GRADIENT',
     &                  'INTERNAL COORDINATES (ANGSTROEM)',istats)
      if (istats.eq.0) goto 200

      if (icdex(lline,'INTERNAL').ne.0) then
         if (getlin(1).ne.1) goto 200
         call convzmat(coo,ianz,iatoms,2,0,0)
         call srchmf(lline,'CARTESIAN GRADIENT',istats)
         if (istats.eq.0) goto 200
      endif

      if (getlin(1).ne.1) goto 200
      if (idebug.eq.1)  print*,'forces'
      call rdmf(lline,cline,istats)

      do i=1,iatoms
         if (getlin(1).ne.1) goto 200
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (gnreal(r,3,.false.)) then
            if (idebug.eq.1)  print*,elemnt(ianz(i)),(r(j),j=1,3)
            do j=1,3
               fxyz(j,i) = r(j)
            end do
         endif
      end do

      return

100   istat = 0
      call rewmf
      return

200   istat = -1
      return
      end

c      subroutine rdqvcd(idebug,istats,
c     &                  vectrs,vectrb,eiga,eigb,ncols,ncolb)
c      implicit double precision (a-h,o-z)
c      parameter (numatm=2000)
c      character*137 line
c      common /orbhlp/ mxorb,iuhf,ispd
c      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
c      common /moldat/ natoms, norbs, nelecs,nat(numatm)
c      common /rdwr/   iun1,iun2,iun3,iun4,iun5
c      common /curlin/ line
c      integer getlin
c      character*137 lline,str
c      real eiga,eigb
c      dimension vectrs(*),vectrb(*),eiga(*),eigb(*)
c
c      istats = 1
c      ido5d = 1
c      ido7f = 1
c      ido9g = 1
c
c      call rewmf
c
c      call srchmf(lline,'Final Alpha MO Eigenvalues',istat)
c      if (istat.eq.0) goto 100
c
c      ncols = 0
c      nlines = 0
c      do i=1,norbs
c
c          if (getlin(1).ne.1) goto 100
c          nlines = nlines + 1
c          ktype = nxtwrd(str,nstr,itype,rtype)
c          if (ktype.eq.1) goto 10
c
c          if (getlin(1).eq.1) then
c             ktype = nxtwrd(str,nstr,itype,rtype)
c             do j=1,6
c                ktype = nxtwrd(str,nstr,itype,rtype)
c                if (ktype.eq.3) then
c                    ncols = ncols + 1
c                    eiga(ncols) = real(rtype)
c                elseif (ktype.eq.0) then
c                    goto 10
c                else
c                    goto 100
c                endif
c             end do
c          else
c             goto 100
c          endif
c      end do
c      
c10    ncol = 0
c
c      if (getlin(1).ne.1) goto 100
c      do i=1,nlines
c         if (getlin(1).ne.1) goto 100
c         do j=1,norbs
c             if (getlin(1).ne.1) goto 100
c             ktype = nxtwrd(str,nstr,itype,rtype)
c             ncolt = ncol  
c             do k=1,6
c                ktype = nxtwrd(str,nstr,itype,rtype)
c                if (ktype.eq.3) then
c                    ncolt = ncolt + 1
c                    vectrs((ncolt-1)*mxorb+j) = rtype
c                elseif (ktype.eq.0) then
c                    goto 20
c                else
c                    goto 100
c                endif
c             end do
c20           continue
c         end do
c         ncol = ncol + 6
c      end do
c
c      if (iuhf.eq.1) then
c         call srchmf(lline,'Final Beta MO Eigenvalues',istat)
c         if (istat.eq.0) goto 100
c      endif
c
c      return
c
c100   istats = 0
c      return
c      end

      subroutine geoorc(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character*137 line,str
      common /curlin/ line
      integer getlin
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

      call rewmf

      igcvav = 1
      ifmxav = 1
      ifrmav = 1
      idmxav = 1
      idrmav = 1
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0

      call rewfil

      call srchmf(line,'DISPERSION CORRECTION',istat)
      if (istat.eq.1) then
          idodis = 1
      else
          idodis = 0
      endif
      call rewfil

      do while(.true.)
         call srchmf(line,'OPTIMIZATION CYCLE',istat)
         if (istat.eq.0) goto 100

         if (ngeoms.lt.mxpnt) then
            ngeoms = ngeoms + 1
         else
            goto 100
         endif

         if (idodis.eq.1) then
            call srchmf(line,'FINAL SINGLE POINT ENERGY',istat)
            if (istat.eq.0) goto 100
            ido = 0
            if (icdex(line,'FINAL').ne.0) then
               ido = 1
            endif
            ktype = nxtwrd(str,nstr,itype,rtype)
            ktype = nxtwrd(str,nstr,itype,rtype)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ido.eq.1) then
               ktype = nxtwrd(str,nstr,itype,rtype)
            endif
         else
80          call srchmf(line,'Total Energy',istat)
            if (istat.eq.0) goto 100
            if (icdex(line,": E  = ").ne.0) then
              i = icdex(line,"=")
              line = line(i+1:)
            else if (icdex(line,":").ne.0) then
              i = icdex(line,":")
              line = line(i+1:)
            else
              goto 80
            endif
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         epoints(ngeoms) = rtype

         call srchmf(line,'Geometry convergence',istats)
         if (istats.eq.0) goto 100
         if (getlin(1).ne.1) goto 100
         if (getlin(1).ne.1) goto 100
  
         if (getlin(1).ne.1) goto 100
         if (icdex(line,'change').ne.0) then
            if (getlin(1).ne.1) goto 100
         end if
         if (icdex(line,'diff').ne.0) then
            if (getlin(1).ne.1) goto 100
         end if
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         forrms(ngeoms) = rtype

         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         formax(ngeoms) = rtype

         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         disrms(ngeoms) = rtype

         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         dismax(ngeoms) = rtype

         isav(ngeoms) = 1
      end do

100   nepnts = ngeoms

      return
      end

      subroutine cnvorc
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      character*137 line,str
      common /curlin/ line
      integer getlin

      call rewmf

      icvav1 = 0
      icvav2 = 0
      jstrt1 = 1
      jstrt2 = 1
      jend1 = 0
      jend2 = 0
      ifrst = 1


c     SCF convergence 

      do while(.true.)
         call srchmf(line,'SCF ITERATIONS',istat)
         if (istat.eq.0) goto 100
         if (getlin(1).ne.1) goto 100
         if (getlin(1).ne.1) goto 100
         do while(.true.)
            if (ifrst.eq.1.and.jend1.ge.MAXITER) goto 10
            if (ifrst.eq.0.and.jend2.ge.MAXITER) goto 100
            if (getlin(1).ne.1) goto 100
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.0) then
                goto 10
            else
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.3) then
                  if (ifrst.eq.1) then
                      jend1 = jend1 + 1
                      convg1(jend1) = rtype
                  else 
                      jend2 = jend2 + 1
                      convg2(jend2) = rtype
                  endif
               endif
            endif
         end do
10       if (ifrst.eq.1) then
            ifrst = 0
            icvav1 = 1
         else
            icvav2 = 1
         endif
      end do

100   return
      end

      logical function zreado(nz,ianz,iz,bl,alpha,beta)
c
c      z-matrix reading routine for orca output.
c
      implicit double precision (a-h,o-z)
      character *2 iel,tstr
      character *2 tocapf
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal, gnint

      dimension ianz(*), bl(*), alpha(*), beta(*)
      dimension iz(4,*), izz(3), r(3)
      dimension iel(100)

      data iel/'bq',
     $         'h ', 'he',
     $         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     $         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     $         'k ', 'ca',
     $                     'sc', 'ti', 'v ', 'cr', 'mn',
     $                     'fe', 'co', 'ni', 'cu', 'zn',
     $                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     $ 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     $ 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     $ 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     $ 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     $ 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     $ 'bk','cf','x '  /

      zreado = .true.

      nz = 0

      do while (.true.)

         if (getlin(1).ne.1) goto 200

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.0) then
             return
         elseif (ktype.eq.1) then

             nz = nz + 1

             ianz(nz) = 0
             if (nstr.eq.1) tstr(2:2) = str(1:1)
             if (nstr.eq.2) tstr(1:2) = str(1:2)

             do i=1,100
                if (tocapf(tstr).eq.tocapf(iel(i))) ianz(nz) = i - 1
             end do

             if (gnint(izz,3,.false.)) then
                do i=1,3
                   iz(i,nz) = izz(i)
                end do
             else
                goto 200
             endif

             if (gnreal(r,3,.false.)) then
                bl(nz)    = r(1)
                alpha(nz) = r(2)
                beta(nz)  = r(3)
                do i=1,3
                   iz(i,nz) = izz(i)
                end do
             else
                goto 200
             endif

         endif

      end do

200   call inferr('error in z-matrix !',0)
      zreado = .false.

      return
      end

      subroutine getofd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*137 line,str
      common /curlin/ line
      integer getlin
      dimension coo(3,*)

      istat = 1

      ivibs = 0
      ihasi = 0
      call rewmf

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in Orca Frequencies

      nvibs = 3*natoms - 6
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1

      call srchmf(line,'VIBRATIONAL FREQUENCIES',istat)
      if (istat.eq.0) goto 10

      if (getlin(1).ne.1) goto 100
      if (getlin(1).ne.1) goto 100

      do i=1,natoms*3
         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
            if (nstr.ge.3) then
               if (str(1:3).eq."Sca") then
                   if (getlin(1).ne.1) goto 100
                   if (getlin(1).ne.1) goto 100
               endif
            endif
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            ivibs = ivibs + 1
            freq(ivibs) = rtype
            frint(ivibs) = 0.0d0
         endif
      end do

      call srchmf(line,'IR SPECTRUM',istat)
      if (istat.eq.0) goto 10
      call redel(line,4)

      do i=1,natoms*3
         if (getlin(1).ne.1) goto 100
         if (linlen(line).le.1) goto 10
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
            l = index(str,':')
            if (l.gt.0) then
               ifrq  = dint(reada(str,1,l-1))
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.3) then
                  frint(ifrq+1) = rtype
                  ihasi = 1
               endif
            endif
         else
            goto 100
         endif
      end do

10    nfreq = ivibs
      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)

      return

100   istat = 0
      return
      end 

      subroutine ocoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr
      character*2 gstr
      character*4 tstr
      real freqt
      dimension freqt(9)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      dimension r(3)

c     Get ifreq 'th Norm. Cordinates from Orca Output

      istat = 1

      call rewmf
      call iatnox(iatoms)
      nvibs = nfreq

      ifreqt = ifreq - 1
      ioff = ifreqt - ((ifreqt-1)/5)*5
      call srchmf(line,'NORMAL MODES',istat)
      if (istat.eq.0) goto 100

      call redel(line,6)

      ivibs = 0
      do while(.true.)
         call redel(line,1)
         if (ivibs.gt.nvibs) goto 20
         if (linlen(line).le.1) goto 20
         
         tstr = ' '//gstr(ifreqt)//' '

         if (index(line,tstr).ne.0) then
             do i=1,iatoms
                do j=1,3
                    call nxtlin(line,jstat)
                    if (jstat.eq.1.or.jstat.eq.2) goto 100
                    read(line,'(11x,6f11.6)',err=100,end=100) 
     &                   (freqt(k),k=1,6)
                    a(j,i) = freqt(ioff)
                end do
             end do
         else
             call redel(line,iatoms*3)
         endif
         ivibs = ivibs + 6
      end do

20    if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine cntgaus(ireord)
      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /orbhlp/ mxorb,iuhf,ispd
      dimension ireord(*)

      do i=1,mxorb
         ireord(i) = -1
      end do

      ico = 1

      do ishell=1,nshell
          do igauss=1,shelln(ishell)
             itel = 0
             i = shellt(ishell)
             if (i.eq.4) goto 10
             if (i.eq.3) goto 9
             if ((i.eq.2).and.(shellc(ishell).eq.2)) goto 8
             if ((i.eq.1).and.(shellc(ishell).eq.1)) goto 6

c************* S-FUNCTIONS ******************************

             itel = itel + 1
             if (i.eq.0) goto 100

c************* P-FUNCTIONS ******************************

6            itel = itel + 3
             if (i.eq.1) goto 100

c************ D-FUNCTIONS *******************************

8            itot = ico + itel
             if (ido5d.eq.1) then
                nror = 5
             else
                nror = 6
             endif

             do jj=1,nror
                ireord(ico+itel+jj-1) = 2
             end do

             itel = itel + nror

             if (i.eq.2) goto 100

c************ F-FUNCTIONS *******************************

9            itot = ico + itel
             if (ido7f.eq.1) then
                nror = 7
             else
                nror = 10
             endif

             do jj=1,nror
                ireord(ico+itel+jj-1) = 3
             end do

             itel = itel + nror

             if (i.eq.3) goto 100

c*********** G-FUNCTIONS *******************************

10           itot = ico + itel
             if (ido9g.eq.1) then
                nror = 9
             else
                nror = 15
             endif

             do jj=1,nror
                ireord(ico+itel+jj-1) = 4
             end do

             itel = itel + nror

             if (i.eq.4) goto 100

100          continue
          end do

          ico = ico + itel

      end do

      return
      end

      subroutine gaussian(x,y,z,psi,norbs,ipreca,ic,jc)
      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common/prefa/ prexpx(numpre,numcex),prexpy(numpre,numcex),
     &              prexpz(numcex)
      common /congau/ d3,d5,d7,g1,g2,g3,g4,g5,g6,r1,r2,r3,r4,
     &                r3ov2,z1,z2,z3,igcon
      dimension psi(*)

      call gaucon

      do i=1,norbs
        psi(i) = 0.0d0
      end do

      ipnt = 0
      ico = 1

      do 420 ishell=1,nshell

          xk = x - gx(ishell)
          yk = y - gy(ishell)
          zk = z - gz(ishell)
          rr = xk*xk + yk*yk + zk*zk

          do 471 igauss=1,shelln(ishell)

          ipnth = ipnt + igauss

          if (ipreca.eq.1) then
             ex = prexpx(ic,ipnth) *
     &            prexpy(jc,ipnth) *
     &            prexpz(ipnth)

          else
             ex = dexp(-exx(shella(ishell)+igauss-1)*rr)
          endif

          itel = 0
          i = shellt(ishell)
          if (i.eq.4) goto 10
          if (i.eq.3) goto 9
          if ((i.eq.2).and.(shellc(ishell).eq.2)) goto 8
          if ((i.eq.1).and.(shellc(ishell).eq.1)) goto 6

c************* S-FUNCTIONS ******************************

          cons = ex * c1(shella(ishell)+igauss-1)
          psi(ico+itel) = psi(ico+itel) + cons
          itel = itel + 1
          if (i.eq.0) goto 471

C************* P-FUNCTIONS ******************************

   6      conp = ex * c2(shella(ishell)+igauss-1)
          psi(ico+itel) = psi(ico+itel) + xk*conp
          itel = itel + 1
          psi(ico+itel) = psi(ico+itel) + yk*conp
          itel = itel + 1
          psi(ico+itel) = psi(ico+itel) + zk*conp
          itel = itel + 1
          if (i.eq.1) goto 471

C****** D-FUNCTIONS **********************************  

    8     cond = ex * c3(shladf(ishell)+igauss-1)
          if (ido5d.eq.1) then
c D 0
             psi(ico+itel) = psi(ico+itel) +
     &          (-0.5d0*(xk*xk+yk*yk)+zk*zk)*cond
             itel = itel + 1
c D+1
             psi(ico+itel) = psi(ico+itel) +xk*zk*cond*d3
             itel = itel + 1
c D-1
             psi(ico+itel) = psi(ico+itel) +yk*zk*cond*d3
             itel = itel + 1
c D+2
             psi(ico+itel) = psi(ico+itel) +
     &          r3ov2*(xk*xk-yk*yk)*cond
             itel = itel + 1
c D-2
             psi(ico+itel) = psi(ico+itel) +xk*yk*cond*d3
             itel = itel + 1
          else
             psi(ico+itel) = psi(ico+itel) +xk*xk*cond
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +yk*yk*cond
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +zk*zk*cond
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +xk*yk*cond*d3
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +xk*zk*cond*d3
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +yk*zk*cond*d3
             itel = itel + 1
          endif
          if(i.eq.2) goto 471

C******* F-FUNCTIONS *********************************    

    9     conf = ex * c4(shladf(ishell)+igauss-1)

          if (ido7f.eq.1) then

             xxx = xk*xk*xk
             yyy = yk*yk*yk
             zzz = zk*zk*zk
             xyy = xk*yk*yk*d5
             xxy = xk*xk*yk*d5
             xxz = xk*xk*zk*d5
             xzz = xk*zk*zk*d5
             yzz = yk*zk*zk*d5
             yyz = yk*yk*zk*d5
             xyz = xk*yk*zk*d5*d3
c F 0
             psi(ico+itel) = psi(ico+itel) + 
     &         (zzz-r2*(xxz+yyz))*conf
             itel = itel + 1
c F+1
             psi(ico+itel) = psi(ico+itel) + 
     &         (z1*xzz-xxx-z2*xyy)*r4*conf
             itel = itel + 1
c F-1
             psi(ico+itel) = psi(ico+itel) + 
     &         (z1*yzz-yyy-z2*xxy)*r4*conf
             itel = itel + 1
c F+2
             psi(ico+itel) = psi(ico+itel) + 
     &         (xxz-yyz)*r3*conf
             itel = itel + 1
c F-2
             psi(ico+itel) = psi(ico+itel) + 
     &         xyz*conf
             itel = itel + 1
c F+3
             psi(ico+itel) = psi(ico+itel) + 
     &         (xxx-z3*xyy)*r1*conf
             itel = itel + 1
c F-3
             psi(ico+itel) = psi(ico+itel) + 
     &         (z3*xxy-yyy)*r1*conf
             itel = itel + 1

          else

             psi(ico+itel) = psi(ico+itel) + xk*xk*xk*conf
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + yk*yk*yk*conf
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + zk*zk*zk*conf
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk*yk*yk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk*xk*yk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk*xk*zk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk*zk*zk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + yk*zk*zk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + yk*yk*zk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk*yk*zk*conf*d3*d5
             itel = itel + 1

          endif

          goto 471

C******* G-FUNCTIONS *********************************    

   10     cong = ex * c5(shladf(ishell)+igauss-1)

          if (ido9g.eq.1) then

             xxxx = xk*xk*xk*xk
             yyyy = yk*yk*yk*yk
             zzzz = zk*zk*zk*zk
             xxxy = xk*xk*xk*yk
             xxxz = xk*xk*xk*zk
             yyyx = yk*yk*yk*xk
             yyyz = yk*yk*yk*zk
             zzzx = zk*zk*zk*xk
             zzzy = zk*zk*zk*yk
             xxyy = xk*xk*yk*yk
             xxzz = xk*xk*zk*zk
             yyzz = yk*yk*zk*zk
             xxyz = xk*xk*yk*zk
             yyxz = yk*yk*xk*zk
             zzxy = zk*zk*xk*yk
c G 0
             psi(ico+itel) = psi(ico+itel) + 
     &         (0.375d0*xxxx + 0.375d0*yyyy + zzzz
     &          - 3.0d0*xxzz - 3.0d0*yyzz  + 0.75d0*xxyy)*cong
             itel = itel + 1
c G+1
             psi(ico+itel) = psi(ico+itel) + 
     &         g1*(4.0d0*zzzx - 3.0d0*yyxz - 3.0d0*xxxz)*cong
             itel = itel + 1
c G-1
             psi(ico+itel) = psi(ico+itel) + 
     &         g1*(4.0d0*zzzy - 3.0d0*xxyz - 3.0d0*yyyz)*cong
             itel = itel + 1
c G+2
             psi(ico+itel) = psi(ico+itel) + 
     &         g2*(6.0d0*xxzz - 6.0d0*yyzz - xxxx + yyyy)*cong
             itel = itel + 1
c G-2
             psi(ico+itel) = psi(ico+itel) + 
     &         g3*(6.0d0*zzxy - xxxy - yyyx)*cong
             itel = itel + 1
c G+3
             psi(ico+itel) = psi(ico+itel) + 
     &         g4*(xxxz - 3.0d0*yyxz)*cong
             itel = itel + 1
c G-3
             psi(ico+itel) = psi(ico+itel) + 
     &         g4*(3.0d0*xxyz - yyyz)*cong
             itel = itel + 1
c G+4
             psi(ico+itel) = psi(ico+itel) + 
     &         g5*(xxxx - 6.0d0*xxyy + yyyy)*cong
             itel = itel + 1
c G-4
             psi(ico+itel) = psi(ico+itel) + 
     &         g6*(xxxy - yyyx)*cong
             itel = itel + 1

          else

c xxxx
             psi(ico+itel) = psi(ico+itel) + xk*xk*xk*xk*cong
             itel = itel + 1
c yyyy
             psi(ico+itel) = psi(ico+itel) + yk*yk*yk*yk*cong
             itel = itel + 1
c zzzz
             psi(ico+itel) = psi(ico+itel) + zk*zk*zk*zk*cong
             itel = itel + 1
c xxxy
             psi(ico+itel) = psi(ico+itel) + xk*xk*xk*yk*cong*d7
             itel = itel + 1
c xxxz
             psi(ico+itel) = psi(ico+itel) + xk*xk*xk*zk*cong*d7
             itel = itel + 1
c yyyx
             psi(ico+itel) = psi(ico+itel) + yk*yk*yk*xk*cong*d7
             itel = itel + 1
c yyyz
             psi(ico+itel) = psi(ico+itel) + yk*yk*yk*zk*cong*d7
             itel = itel + 1
c zzzx
             psi(ico+itel) = psi(ico+itel) + zk*zk*zk*xk*cong*d7
             itel = itel + 1
c zzzy
             psi(ico+itel) = psi(ico+itel) + zk*zk*zk*yk*cong*d7
             itel = itel + 1
c xxyy
             psi(ico+itel) = psi(ico+itel) + xk*xk*yk*yk*cong*d5*d7/d3
             itel = itel + 1
c xxzz
             psi(ico+itel) = psi(ico+itel) + xk*xk*zk*zk*cong*d5*d7/d3
             itel = itel + 1
c yyzz
             psi(ico+itel) = psi(ico+itel) + yk*yk*zk*zk*cong*d5*d7/d3
             itel = itel + 1
c xxyz
             psi(ico+itel) = psi(ico+itel) + xk*xk*yk*zk*cong*d5*d7
             itel = itel + 1
c yyxz
             psi(ico+itel) = psi(ico+itel) + yk*yk*xk*zk*cong*d5*d7
             itel = itel + 1
c zzxy
             psi(ico+itel) = psi(ico+itel) + zk*zk*xk*yk*cong*d5*d7
             itel = itel + 1

          endif

          goto 471

471       continue

          ipnt = ipnt + shelln(ishell)
          ico = ico + itel

420   continue

      if (ico-1.ne.norbs)  print*,"ico-1 ",ico-1," norbs ",norbs
      if (ico-1.ne.norbs) 
     & call inferr('GAUSSIAN: number of orbitals incorrect',1)

      return
      end

      subroutine gaucon
      implicit double precision (a-h,o-z)
      common /congau/ d3,d5,d7,g1,g2,g3,g4,g5,g6,r1,r2,r3,r4,
     &                r3ov2,z1,z2,z3,igcon

      if (igcon.eq.1) return

      d3 = dsqrt(3.0d0)
      d5 = dsqrt(5.0d0)
      d7 = dsqrt(7.0d0)
      z1 = 4.0d0/d5
      z2 = 1.0d0/d5
      z3 = 3.0d0/d5
      r1 = 0.5d0*dsqrt(5.0d0/2.0d0)
      r2 = 1.5d0/d5
      r3ov2 = 0.5d0*dsqrt(3.0d0)
      r3 = r3ov2
      r4 = 0.5d0*dsqrt(3.0d0/2.0d0)

      g1 = dsqrt(5.0d0/8.0d0)
      g2 = dsqrt(5.0d0/16.0d0)
      g3 = dsqrt(5.0d0/4.0d0)
      g4 = dsqrt(35.0d0/8.0d0)
      g5 = dsqrt(35.0d0/64.0d0)
      g6 = dsqrt(35.0d0/4.0d0)

      igcon = 1

      return
      end

      subroutine gcres
      implicit double precision (a-h,o-z)
      common /congau/ d3,d5,d7,g1,g2,g3,g4,g5,g6,r1,r2,r3,r4,
     &                r3ov2,z1,z2,z3,igcon

      igcon = 0

      return
      end

      subroutine denhes(x,y,z,psi,grd,hess,norbs,dolap)
      implicit double precision (a-h,o-z)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      logical dolap
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /gauhlp/ d6to5(6,5),f10to7(10,7),g15to9(15,9),
     &                plmn(35),lmn(3,35)
      dimension psi(*),grd(3,*),hess(6,*),d(3),d2(3),
     &          tpsi(10),tgrd(3,10),thess(6,10)


      call denini

      dsmall = 1.0d-10
      do i=1,norbs
        psi(i) = 0.0d0
      end do

      if (dolap) then
         do i=1,norbs
           do j=1,3
              grd(j,i) = 0.0d0
              hess(j,i) = 0.0d0
              hess(j+3,i) = 0.0d0
           end do
         end do
      endif

      ico = 1

      do 420 ishell=1,nshell

          d(1) = x - gx(ishell)
          d(2) = y - gy(ishell)
          d(3) = z - gz(ishell)

          do j=1,3
             if (dabs(d(j)).lt.dsmall) d(j) = dsmall
          end do

          r2 = 0.0d0

          do j=1,3
             d2(j) = d(j)*d(j)
             r2 = r2 + d2(j)
          end do

          i = shellt(ishell)

          do 471 igauss=1,shelln(ishell)

          expon = exx(shella(ishell)+igauss-1)
          ex = dexp(-expon*r2)
          ex2 = 2.0d0*expon
          itel = 0

          if (i.eq.4) goto 10
          if (i.eq.3) goto 9
          if ((i.eq.2).and.(shellc(ishell).eq.2)) goto 8
          if ((i.eq.1).and.(shellc(ishell).eq.1)) goto 6

c************* S-FUNCTIONS ******************************

          cons = ex * c1(shella(ishell)+igauss-1)
          indh = ico + itel
          call calcl(d,d2,psi(indh),grd(1,indh),hess(1,indh),
     &               cons,ex2,1,1,dolap)
          itel = itel + 1
          if (i.eq.0) goto 471

C************* P-FUNCTIONS ******************************

   6      conp = ex * c2(shella(ishell)+igauss-1)
          indh = ico + itel
          call calcl(d,d2,psi(indh),grd(1,indh),hess(1,indh),
     &               conp,ex2,2,4,dolap)
          itel = itel + 3
          if (i.eq.1) goto 471

C****** D-FUNCTIONS **********************************  

    8     cond = ex * c3(shladf(ishell)+igauss-1)

          if (ido5d.eq.1) then

             call cleart(tpsi,tgrd,thess,dolap)
             call calcl(d,d2,tpsi,tgrd,thess,cond,ex2,5,10,dolap)

c D 0, D+1, D-1, D+2, D-2

             do j=1,5
                ipos = ico + itel
                do k=1,6
                   psi(ipos) = psi(ipos) + d6to5(k,j)*tpsi(k)
                   if (dolap) then
                      do l=1,3
                         grd(l,ipos) = grd(l,ipos) + 
     &                                 d6to5(k,j)*tgrd(l,k)
                      end do
                      do l=1,6
                         hess(l,ipos) = hess(l,ipos) + 
     &                                  d6to5(k,j)*thess(l,k)
                      end do
                   endif
                end do
                itel = itel + 1
             end do

          else

c xx,yy,zz,xy,xz,yz

             ipos = ico + itel
             call calcl(d,d2,psi(ipos),grd(1,ipos),hess(1,ipos),
     &                  cond,ex2,5,10,dolap)
             itel = itel + 6

          endif

          if (i.eq.2) goto 471

C******* F-FUNCTIONS *********************************    

    9     conf = ex * c4(shladf(ishell)+igauss-1)

          if (ido7f.eq.1) then

             call cleart(tpsi,tgrd,thess,dolap)
             call calcl(d,d2,tpsi,tgrd,thess,conf,ex2,11,20,dolap)

c F 0, F+1, F-1, F+2, F-2, F+3, F-3

             do j=1,7
                ipos = ico + itel
                do k=1,10
                   psi(ipos) = psi(ipos) + f10to7(k,j)*tpsi(k)
                   if (dolap) then
                      do l=1,3
                         grd(l,ipos) = grd(l,ipos) + 
     &                                 f10to7(k,j)*tgrd(l,k)
                      end do
                      do l=1,6
                         hess(l,ipos) = hess(l,ipos) + 
     &                                  f10to7(k,j)*thess(l,k)
                      end do
                   endif
                end do
                itel = itel + 1
             end do

          else

c xxx, yyy, zzz, xyy, xxy, xxz, xzz, yzz, yyz, xyz

             ipos = ico + itel
             call calcl(d,d2,psi(ipos),grd(1,ipos),hess(1,ipos),
     &                  conf,ex2,11,20,dolap)
             itel = itel + 10

          endif

          goto 471

C******* G-FUNCTIONS *********************************    

   10     cong = ex * c4(shladf(ishell)+igauss-1)

          if (ido9g.eq.1) then

             call cleart(tpsi,tgrd,thess,dolap)
             call calcl(d,d2,tpsi,tgrd,thess,cong,ex2,21,35,dolap)

c G 0, G+1, G-1, G+2, G-2, G+3, G-3, G+4, G-4

             do j=1,9
                ipos = ico + itel
                do k=1,15
                   psi(ipos) = psi(ipos) + g15to9(k,j)*tpsi(k)
                   if (dolap) then
                      do l=1,3
                         grd(l,ipos) = grd(l,ipos) + 
     &                                 g15to9(k,j)*tgrd(l,k)
                      end do
                      do l=1,6
                         hess(l,ipos) = hess(l,ipos) + 
     &                                  g15to9(k,j)*thess(l,k)
                      end do
                   endif
                end do
                itel = itel + 1
             end do

          else

c xxxx, yyyy, zzzz, xxxy xxxz yyyx yyyz zzzx zzzy xxyy xxzz yyzz
c xxyz yyxz zzxy

             ipos = ico + itel
             call calcl(d,d2,psi(ipos),grd(1,ipos),hess(1,ipos),
     &                  cong,ex2,21,35,dolap)
          endif
c
471       continue
c
c
          ico = ico + itel
  420     continue
      if (ico-1.ne.norbs) 
     & call inferr('GAUSSIAN: number of orbitals incorrect',1)

      return
      end

      subroutine denini
      implicit double precision (a-h,o-z)
      common /gauhlp/ d6to5(6,5),f10to7(10,7),g15to9(15,9),
     &                plmn(35),lmn(3,35)
      data plmn /35*1.0d0/
      data ((lmn(j,i),j=1,3),i=1,35) /
     & 0,0,0, 1,0,0, 0,1,0, 0,0,1, 2,0,0, 0,2,0, 0,0,2, 1,1,0,
     & 1,0,1, 0,1,1, 3,0,0, 0,3,0, 0,0,3, 1,2,0, 2,1,0, 2,0,1,
     & 1,0,2, 0,1,2, 0,2,1, 1,1,1, 4,0,0, 0,4,0, 0,0,4, 3,1,0,
     & 3,0,1, 1,3,0, 0,3,1, 1,0,3, 0,1,3, 2,2,0, 2,0,2, 0,2,2,
     & 2,1,1, 1,2,1, 1,1,2/

      if (d6to5(3,1).eq.1.0d0) return

      d3 = dsqrt(3.0d0)
      d5 = dsqrt(5.0d0)
      d7 = dsqrt(7.0d0)

      plmn(8) = d3
      plmn(9) = d3
      plmn(10) = d3

      plmn(14) = d5
      plmn(15) = d5
      plmn(16) = d5
      plmn(17) = d5
      plmn(18) = d5
      plmn(19) = d5
      plmn(20) = d5*d3
      plmn(24) = d7
      plmn(25) = d7
      plmn(26) = d7
      plmn(27) = d7
      plmn(28) = d7
      plmn(29) = d7
      plmn(30) = d5*d7/d3
      plmn(31) = d5*d7/d3
      plmn(32) = d5*d7/d3
      plmn(33) = d5*d7
      plmn(34) = d5*d7
      plmn(35) = d5*d7

      z1 = 4.0d0/d5
      z2 = 1.0d0/d5
      z3 = 3.0d0/d5
      r1 = 0.5d0*dsqrt(5.0d0/2.0d0)
      r2 = 1.5d0/d5
      r3ov2 = 0.5d0*d3
      r3 = r3ov2
      r4 = 0.5d0*dsqrt(3.0d0/2.0d0)

      do i=1,5
        do j=1,6
           d6to5(j,i) = 0.0d0
        end do
      end do

      d6to5(1,1) = -0.5d0
      d6to5(2,1) = -0.5d0
      d6to5(3,1) = 1.0d0
      d6to5(5,2) = 1.0d0
      d6to5(6,3) = 1.0d0
      d6to5(1,4) = r3ov2
      d6to5(2,4) = -r3ov2
      d6to5(4,5) = 1.0d0

      do i=1,7
        do j=1,10
           f10to7(j,i) = 0.0d0
        end do
      end do

      f10to7(3,1) = 1.0d0
      f10to7(6,1) = -r2
      f10to7(9,1) = -r2
      f10to7(1,2) = -r4
      f10to7(4,2) = -z2*r4
      f10to7(7,2) = z1*r4
      f10to7(2,3) = -r4
      f10to7(5,3) = -z2*r4
      f10to7(8,3) = z1*r4
      f10to7(6,4) = r3
      f10to7(9,4) = -r3
      f10to7(10,5) = 1.0d0
      f10to7(1,6) = r1
      f10to7(4,6) = -z3*r1
      f10to7(2,7) = -r1
      f10to7(5,7) = z3*r1

      do i=1,9
        do j=1,15
           g15to9(j,i) = 0.0d0
        end do
      end do

c G0, g+1, G-1, G+2, G-2, G+3, G-3, G+4, G-4

      g1 = dsqrt(5.0d0/8.0d0)
      g2 = dsqrt(5.0d0/16.0d0)
      g3 = dsqrt(5.0d0/4.0d0)
      g4 = dsqrt(35.0d0/8.0d0)
      g5 = dsqrt(35.0d0/64.0d0)
      g6 = dsqrt(35.0d0/4.0d0)
c G 0
      g15to9(1,1)  = 0.375d0
      g15to9(2,1)  = 0.375d0
      g15to9(3,1)  = 1.0d0
      g15to9(10,1) = 0.75d0
      g15to9(11,1) = -3.0d0
      g15to9(12,1) = -3.0d0
c G+1
      g15to9(5,2)  = -3.0d0*g1
      g15to9(8,2)  =  4.0d0*g1
      g15to9(14,2) = -3.0d0*g1
c G-1
      g15to9(7,3)  = -3.0d0*g1
      g15to9(9,3)  =  4.0d0*g1
      g15to9(13,3) = -3.0d0*g1
c G+2
      g15to9(1,4)  = -1.0d0*g2
      g15to9(2,4)  =  1.0d0*g2
      g15to9(11,4) =  6.0d0*g2
      g15to9(12,4) = -6.0d0*g2
c G-2
      g15to9(4,5)  = -1.0d0*g3
      g15to9(6,5)  = -1.0d0*g3
      g15to9(15,5) =  6.0d0*g3
c G+3
      g15to9(5,6)  = -3.0d0*g4
      g15to9(14,6) =  1.0d0*g4
c G-3
      g15to9(7,7)  = -1.0d0*g4
      g15to9(13,7) =  3.0d0*g4
c G+4
      g15to9(1,8)  =  1.0d0*g5
      g15to9(2,8)  =  1.0d0*g5
      g15to9(10,8) = -6.0d0*g5
c G-4
      g15to9(4,9)  =  1.0d0*g6
      g15to9(6,9)  = -1.0d0*g6

      return
      end

      subroutine calcl(d,d2,tpsi,tgrd,thess,con,ex2,ibeg,iend,dolap)
      implicit double precision (a-h,o-z)
      logical dolap
      common /gauhlp/ d6to5(6,5),f10to7(10,7),g15to9(15,9),
     &                plmn(35),lmn(3,35)
      dimension tpsi(*),tgrd(3,*),thess(6,*),d(3),d2(3),f(3),f2(3)

      do i=1,iend-ibeg+1

          indh = ibeg+i-1
          gau = 1.0d0
          do j=1,3
             l = lmn(j,indh)
c             if (l.ne.0) gau = gau * d(j)**l
             gau = gau * d(j)**l
          end do
          gau = gau * con*plmn(indh)
          tpsi(i) = tpsi(i) + gau
          
          if (.not.dolap) goto 100

          do j=1,3
              l = lmn(j,indh)
              f(j) = dble(l)/d(j) - ex2*d(j)
              f2(j) = -dble(l)/d2(j) - ex2
              tgrd(j,i) = tgrd(j,i) + f(j)*gau
          end do

          do j=1,6
              jh = j+4
              fact = 1.0d0
              do k=1,3
                 l = lmn(k,jh)
c                 if (l.ne.0) fact = fact * f(k)**l
                 fact = fact * f(k)**l
              end do
              if (j.le.3) fact = fact + f2(j)
              thess(j,i) = thess(j,i) + fact*gau
          end do

100       continue
      end do

      return
      end

      subroutine cleart(tpsi,tgrd,thess,dolap)
      implicit double precision (a-h,o-z)
      logical dolap
      dimension tpsi(*),tgrd(3,*),thess(6,*)

      do i=1,10
         tpsi(i) = 0.0d0
      end do

      if (.not.dolap) return

      do i=1,10

         do j=1,3
            tgrd(j,i) = 0.0d0
         end do

         do j=1,6
            thess(j,i) = 0.0d0
         end do

      end do

      return
      end

      subroutine calhed(psi,grd,hess,den,g,hes,p)
c THIS IS REALLY calhes
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd

      dimension p(*),psi(*),grd(3,*),hess(6,*), g(3),hes(6)

      den = 0.0d0

      do k=1,3
         g(k) = 0.0d0
      end do

      do k=1,6
         hes(k) = 0.0d0
      end do

      do i=1,norbs
          do j=1,i
             pij = p((j-1)*mxorb+i)
             if (i.ne.j) pij = pij + pij
             den = den + psi(i)*psi(j)*pij
             do k=1,3
               g(k) = g(k) + (psi(i)*grd(k,j) + psi(j)*grd(k,i))*pij
             end do
             hes(1) = hes(1) + (psi(i)*hess(1,j) + psi(j)*hess(1,i)
     &                       + 2.0d0*grd(1,i)*grd(1,j))*pij
             hes(2) = hes(2) + (psi(i)*hess(2,j) + psi(j)*hess(2,i)
     &                       + 2.0d0*grd(2,i)*grd(2,j))*pij
             hes(3) = hes(3) + (psi(i)*hess(3,j) + psi(j)*hess(3,i)
     &                       + 2.0d0*grd(3,i)*grd(3,j))*pij
             hes(4) = hes(4) + pij*(
     &                grd(1,i)*grd(2,j) + psi(j)*hess(4,i) +
     &                grd(2,i)*grd(1,j) + psi(i)*hess(4,j))
             hes(5) = hes(5) + pij*(
     &                grd(1,i)*grd(3,j) + psi(j)*hess(5,i) +
     &                grd(3,i)*grd(1,j) + psi(i)*hess(5,j))
             hes(6) = hes(6) + pij*(
     &                grd(2,i)*grd(3,j) + psi(j)*hess(6,i) +
     &                grd(3,i)*grd(2,j) + psi(i)*hess(6,j))
          end do
      end do

      return
      end

      subroutine gaudxyz(x,y,z,psi,dxpsi,dypsi,dzpsi,
     &                    norbs,ipreca,ic,jc)
      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common/prefa/ prexpx(numpre,numcex),prexpy(numpre,numcex),
     &              prexpz(numcex)
      common /congau/ d3,d5,d7,g1,g2,g3,g4,g5,g6,r1,r2,r3,r4,
     &                r3ov2,z1,z2,z3,igcon
      dimension psi(*),dxpsi(*),dypsi(*),dzpsi(*)

      call gaucon

      do i=1,norbs
        psi(i) = 0.0d0
        dxpsi(i) = 0.0d0
        dypsi(i) = 0.0d0
        dzpsi(i) = 0.0d0
      end do

      ipnt = 0
      ico = 1

      do 420 ishell=1,nshell

          xk = x - gx(ishell)
          yk = y - gy(ishell)
          zk = z - gz(ishell)
          rr = xk*xk + yk*yk + zk*zk
          xk2 = xk*xk
          yk2 = yk*yk
          zk2 = zk*zk
          xyk = xk*yk
          xzk = xk*zk
          yzk = yk*zk
          xyzk = xk*yk*zk
          xk3 = xk*xk*xk
          yk3 = yk*yk*yk
          zk3 = zk*zk*zk

          do 471 igauss=1,shelln(ishell)

          ipnth = ipnt + igauss

          ex = dexp(-exx(shella(ishell)+igauss-1)*rr)
          exh = exx(shella(ishell)+igauss-1)

          itel = 0
          i = shellt(ishell)
          if (i.eq.4) goto 10
          if (i.eq.3) goto 9
          if ((i.eq.2).and.(shellc(ishell).eq.2)) goto 8
          if ((i.eq.1).and.(shellc(ishell).eq.1)) goto 6

c************* S-FUNCTIONS ******************************

          cons = ex * c1(shella(ishell)+igauss-1)
          psi(ico+itel) = psi(ico+itel) + cons
          dxpsi(ico+itel) = dxpsi(ico+itel) 
     &                      - 2.0d0*xk*exh*cons
          dypsi(ico+itel) = dypsi(ico+itel) 
     &                      - 2.0d0*yk*exh*cons
          dzpsi(ico+itel) = dzpsi(ico+itel) 
     &                      - 2.0d0*zk*exh*cons
          itel = itel + 1
          if (i.eq.0) goto 471

C************* P-FUNCTIONS ******************************

   6      conp = ex * c2(shella(ishell)+igauss-1)
          psi(ico+itel) = psi(ico+itel) + xk*conp
          dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*conp
          dypsi(ico+itel) = dypsi(ico+itel) 
     &                             - 2.0d0*xyk*exh*conp
          dzpsi(ico+itel) = dzpsi(ico+itel) 
     &                             - 2.0d0*xzk*exh*conp
          itel = itel + 1

          psi(ico+itel) = psi(ico+itel) + yk*conp
          dxpsi(ico+itel) = dxpsi(ico+itel) 
     &                             - 2.0d0*xyk*exh*conp
          dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*yk2*exh)*conp
          dzpsi(ico+itel) = dzpsi(ico+itel) 
     &                             - 2.0d0*yzk*exh*conp
          itel = itel + 1

          psi(ico+itel) = psi(ico+itel) + zk*conp
          dxpsi(ico+itel) = dxpsi(ico+itel) 
     &                             - 2.0d0*xzk*exh*conp
          dypsi(ico+itel) = dypsi(ico+itel) 
     &                             - 2.0d0*yzk*exh*conp
          dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*conp
          itel = itel + 1
          if (i.eq.1) goto 471

C****** D-FUNCTIONS **********************************  

    8     cond = ex * c3(shladf(ishell)+igauss-1)
          if (ido5d.eq.1) then
c D 0
             psi(ico+itel) = psi(ico+itel) +
     &          (-0.5d0*(xk*xk+yk*yk)+zk*zk)*cond
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &          (-1.0d0 + (xk2+yk2-2.0d0*zk2)*exh)*xk*cond
             dypsi(ico+itel) = dypsi(ico+itel) +
     &          (-1.0d0 + (xk2+yk2-2.0d0*zk2)*exh)*yk*cond
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &          ( 2.0d0 + (xk2+yk2-2.0d0*zk2)*exh)*zk*cond
             itel = itel + 1
c D+1
             psi(ico+itel) = psi(ico+itel) +xk*zk*cond*d3
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*zk*cond*d3
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                             - 2.0d0*xyzk*exh*cond*d3
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*xk*cond*d3
             itel = itel + 1
c D-1
             psi(ico+itel) = psi(ico+itel) +yk*zk*cond*d3
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                             - 2.0d0*xyzk*exh*cond*d3
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*yk2*exh)*zk*cond*d3
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*yk*cond*d3
             itel = itel + 1
c D+2
             psi(ico+itel) = psi(ico+itel) +
     &          r3ov2*(xk*xk-yk*yk)*cond
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &          r3ov2*(1.0d0 - (xk2-yk2)*exh)*2.0d0*xk*cond
             dypsi(ico+itel) = dypsi(ico+itel) -
     &          r3ov2*(1.0d0 + (xk2-yk2)*exh)*2.0d0*yk*cond
             dzpsi(ico+itel) = dzpsi(ico+itel) -
     &          r3ov2*(xk2-yk2)*exh*2.0d0*zk*cond
             itel = itel + 1
c D-2
             psi(ico+itel) = psi(ico+itel) + xk*yk*cond*d3
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*yk*cond*d3
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*yk2*exh)*xk*cond*d3
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*xyzk*exh*cond*d3
             itel = itel + 1
          else
             psi(ico+itel) = psi(ico+itel) + xk2*cond
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (2.0d0 - 2.0d0*xk2*exh)*xk*cond
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                              -2.0d0*xk2*exh*yk*cond
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*xk2*exh*zk*cond
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +yk2*cond
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                             - 2.0d0*yk2*exh*xk*cond
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (2.0d0  -2.0d0*yk2*exh)*yk*cond
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*yk2*exh*zk*cond
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +zk2*cond
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                             - 2.0d0*zk2*exh*xk*cond
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                              -2.0d0*zk2*exh*yk*cond
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (2.0d0 - 2.0d0*zk2*exh)*zk*cond
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +xyk*cond*d3
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*yk*cond*d3
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*yk2*exh)*xk*cond*d3
             dzpsi(ico+itel) = dzpsi(ico+itel) 
     &                             - 2.0d0*xyzk*exh*cond*d3
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +xzk*cond*d3
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*zk*cond*d3
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                             - 2.0d0*xyzk*exh*cond*d3
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*xk*cond*d3
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) +yzk*cond*d3
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                             - 2.0d0*xyzk*exh*cond*d3
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*yk2*exh)*zk*cond*d3
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*yk*cond*d3
             itel = itel + 1
          endif
          if(i.eq.2) goto 471

C******* F-FUNCTIONS *********************************    

    9     conf = ex * c4(shladf(ishell)+igauss-1)

          if (ido7f.eq.1) then

             xxx = xk*xk*xk
             yyy = yk*yk*yk
             zzz = zk*zk*zk
             xyy = xk*yk*yk*d5
             xxy = xk*xk*yk*d5
             xxz = xk*xk*zk*d5
             xzz = xk*zk*zk*d5
             yzz = yk*zk*zk*d5
             yyz = yk*yk*zk*d5
             xyz = xk*yk*zk*d5*d3
c F 0
             psi(ico+itel) = psi(ico+itel) + 
     &         (zzz-r2*(xxz+yyz))*conf
             itel = itel + 1
c F+1
             psi(ico+itel) = psi(ico+itel) + 
     &         (z1*xzz-xxx-z2*xyy)*r4*conf
             itel = itel + 1
c F-1
             psi(ico+itel) = psi(ico+itel) + 
     &         (z1*yzz-yyy-z2*xxy)*r4*conf
             itel = itel + 1
c F+2
             psi(ico+itel) = psi(ico+itel) + 
     &         (xxz-yyz)*r3*conf
             itel = itel + 1
c F-2
             psi(ico+itel) = psi(ico+itel) + 
     &         xyz*conf
             itel = itel + 1
c F+3
             psi(ico+itel) = psi(ico+itel) + 
     &         (xxx-z3*xyy)*r1*conf
             itel = itel + 1
c F-3
             psi(ico+itel) = psi(ico+itel) + 
     &         (z3*xxy-yyy)*r1*conf
             itel = itel + 1

          else

             psi(ico+itel) = psi(ico+itel) + xk3*conf
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (3.0d0 - 2.0d0*xk2*exh)*xk2*conf
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                              -2.0d0*xk3*exh*yk*conf
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*xk3*exh*zk*conf
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + yk3*conf
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                              -2.0d0*yk3*exh*xk*conf
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (3.0d0 - 2.0d0*yk2*exh)*yk2*conf
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*yk3*exh*zk*conf
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + zk3*conf
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                             - 2.0d0*zk3*exh*xk*conf
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                             - 2.0d0*zk3*exh*zk*conf
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (3.0d0 - 2.0d0*zk2*exh)*zk2*conf
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk*yk2*conf*d5
c this one is hard
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*yk2*conf*d5
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - yk2*exh)*2.0d0*xyk*conf*d5
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*zxk*exh*yk2*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk2*yk*conf*d5
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - xk2*exh)*2.0d0*xyk*conf*d5
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*yk2*exh)*2.0d0*xk2*conf*d5
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*xyk*exh*xk2*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk2*zk*conf*d5
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - xk2*exh)*2.0d0*xzk*conf*d5
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                             - 2.0d0*yzk*exh*xk2*conf*d5
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*xk2*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xk*zk2*conf*d5
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*zk2*conf*d5
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                             - 2.0d0*xyk*exh*zk2*conf*d5
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - zk2*exh)*2.0d0*xzk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + yk*zk2*conf*d5
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                              -2.0d0*xyk*exh*zk2*conf*d5
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - yk2*exh)*2.0d0*zk2*conf*d5
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - zk2*exh)*2.0d0*yzk*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + yk2*zk*conf*d5
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                              -2.0d0*xzk*exh*yk2*conf*d5
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - yk2*exh)*2.0d0*yzk*conf*d5
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*yk2*conf*d5
             itel = itel + 1
             psi(ico+itel) = psi(ico+itel) + xyzk*conf*d3*d5
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*xk2*exh)*yzk*conf*d3*d5
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*yk2*exh)*xzk*conf*d3*d5
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 - 2.0d0*zk2*exh)*xyk*conf*d3*d5
             itel = itel + 1

          endif

          goto 471

C******* G-FUNCTIONS *********************************    

   10     cong = ex * c5(shladf(ishell)+igauss-1)

          if (ido9g.eq.1) then

             xxxx = xk*xk*xk*xk
             yyyy = yk*yk*yk*yk
             zzzz = zk*zk*zk*zk
             xxxy = xk*xk*xk*yk
             xxxz = xk*xk*xk*zk
             yyyx = yk*yk*yk*xk
             yyyz = yk*yk*yk*zk
             zzzx = zk*zk*zk*xk
             zzzy = zk*zk*zk*yk
             xxyy = xk*xk*yk*yk
             xxzz = xk*xk*zk*zk
             yyzz = yk*yk*zk*zk
             xxyz = xk*xk*yk*zk
             yyxz = yk*yk*xk*zk
             zzxy = zk*zk*xk*yk
c G 0
             psi(ico+itel) = psi(ico+itel) + 
     &         (0.375d0*xxxx + 0.375d0*yyyy + zzzz
     &          - 3.0d0*xxzz - 3.0d0*yyzz  + 0.75d0*xxyy)*cong
             itel = itel + 1
c G+1
             psi(ico+itel) = psi(ico+itel) + 
     &         g1*(4.0d0*zzzx - 3.0d0*yyxz - 3.0d0*xxxz)*cong
             itel = itel + 1
c G-1
             psi(ico+itel) = psi(ico+itel) + 
     &         g1*(4.0d0*zzzy - 3.0d0*xxyz - 3.0d0*yyyz)*cong
             itel = itel + 1
c G+2
             psi(ico+itel) = psi(ico+itel) + 
     &         g2*(6.0d0*xxzz - 6.0d0*yyzz - xxxx + yyyy)*cong
             itel = itel + 1
c G-2
             psi(ico+itel) = psi(ico+itel) + 
     &         g3*(6.0d0*zzxy - xxxy - yyyx)*cong
             itel = itel + 1
c G+3
             psi(ico+itel) = psi(ico+itel) + 
     &         g4*(xxxz - 3.0d0*yyxz)*cong
             itel = itel + 1
c G-3
             psi(ico+itel) = psi(ico+itel) + 
     &         g4*(3.0d0*xxyz - yyyz)*cong
             itel = itel + 1
c G+4
             psi(ico+itel) = psi(ico+itel) + 
     &         g5*(xxxx - 6.0d0*xxyy + yyyy)*cong
             itel = itel + 1
c G-4
             psi(ico+itel) = psi(ico+itel) + 
     &         g6*(xxxy - yyyx)*cong
             itel = itel + 1

          else

c xxxx
             psi(ico+itel) = psi(ico+itel) + xk*xk*xk*xk*cong
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (2.0d0 - xk2*exh)*2.0d0*xk3*cong
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                             - 2.0d0*xyk*exh*xk3*cong
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*xzk*exh*xk3*cong
             itel = itel + 1
c yyyy
             psi(ico+itel) = psi(ico+itel) + yk*yk*yk*yk*cong
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                             - 2.0d0*yxk*exh*yk3*cong
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (2.0d0 - yk2*exh)*2.0d0*yk3*cong
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                             - 2.0d0*yzk*exh*yk3*cong
             itel = itel + 1
c zzzz
             psi(ico+itel) = psi(ico+itel) + zk*zk*zk*zk*cong
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                             - 2.0d0*xzk*exh*zk3*cong
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                             - 2.0d0*yzk*exh*zk3*cong
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (2.0d0 - zk2*exh)*2.0d0*zk3*cong
             itel = itel + 1
c xxxy
             psi(ico+itel) = psi(ico+itel) + xk*xk*xk*yk*cong*d7
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (3.0d0 -2.0d0*xk2*exh)*xk2*yk*cong*d7
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 -2.0d0*yk2*exh)*xk3*cong*d7
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                            - 2.0d0*yzk*exh*xk3*cong*d7
             itel = itel + 1
c xxxz
             psi(ico+itel) = psi(ico+itel) + xk*xk*xk*zk*cong*d7
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (3.0d0 -2.0d0*xk2*exh)*xk2*zk*cong*d7
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                            - 2.0d0*yzk*exh*xk3*cong*d7
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*zk2*exh)*xk3*cong*d7
             itel = itel + 1
c yyyx
             psi(ico+itel) = psi(ico+itel) + yk*yk*yk*xk*cong*d7
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*xk2*exh)*yk3*cong*d7
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (3.0d0 -2.0d0*yk2*exh)*yk2*xk*cong*d7
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                            - 2.0d0*xzk*exh*yk3*cong*d7
             itel = itel + 1
c yyyz
             psi(ico+itel) = psi(ico+itel) + yk*yk*yk*zk*cong*d7
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                            - 2.0d0*xzk*exh*yk3*cong*d7
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (3.0d0 -2.0d0*yk2*exh)*yk2*zk*cong*d7
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*zk2*exh)*yk3*cong*d7
             itel = itel + 1
c zzzx
             psi(ico+itel) = psi(ico+itel) + zk*zk*zk*xk*cong*d7
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*xk2*exh)*zk3*cong*d7
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                            - 2.0d0*xyk*exh*zk3*cong*d7
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (3.0d0 -2.0d0*zk2*exh)*zk2*xk*cong*d7
             itel = itel + 1
c zzzy
             psi(ico+itel) = psi(ico+itel) + zk*zk*zk*yk*cong*d7
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                            - 2.0d0*xyk*exh*zk3*cong*d7
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 -2.0d0*yk2*exh)*zk3*cong*d7
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (3.0d0 -2.0d0*zk2*exh)*zk2*yk*cong*d7
             itel = itel + 1
c xxyy
             psi(ico+itel) = psi(ico+itel) + xk*xk*yk*yk*cong*d5*d7/d3
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 -xk2*exh)*2.0d0*yk2*xk*cong*d5*d7/d3
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 -yk2*exh)*2.0d0*xk2*yk*cong*d5*d7/d3
             dzpsi(ico+itel) = dzpsi(ico+itel)  
     &                            - 2.0d0*zk*exh*xk2*yk2*cong*d5*d7/d3
             itel = itel + 1
c xxzz
             psi(ico+itel) = psi(ico+itel) + xk*xk*zk*zk*cong*d5*d7/d3
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 -xk2*exh)*2.0d0*zk2*xk*cong*d5*d7/d3
             dypsi(ico+itel) = dypsi(ico+itel)  
     &                            - 2.0d0*yk*exh*xk2*zk2*cong*d5*d7/d3
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 -zk2*exh)*2.0d0*xk2*zk*cong*d5*d7/d3
             itel = itel + 1
c yyzz
             psi(ico+itel) = psi(ico+itel) + yk*yk*zk*zk*cong*d5*d7/d3
             dxpsi(ico+itel) = dxpsi(ico+itel)  
     &                            - 2.0d0*xk*exh*yk2*zk2*cong*d5*d7/d3
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 -yk2*exh)*2.0d0*zk2*yk*cong*d5*d7/d3
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 -zk2*exh)*2.0d0*yk2*zk*cong*d5*d7/d3
             itel = itel + 1
c xxyz
             psi(ico+itel) = psi(ico+itel) + xk*xk*yk*zk*cong*d5*d7
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 -xk2*exh)*2.0d0*xyzk*cong*d5*d7
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 -2.0d0*yk2*exh)*xk2*zk*cong*d5*d7
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*zk2*exh)*xk2*yk*cong*d5*d7
             itel = itel + 1
c yyxz
             psi(ico+itel) = psi(ico+itel) + yk*yk*xk*zk*cong*d5*d7
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*xk2*exh)*yk2*zk*cong*d5*d7
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 -yk2*exh)*2.0d0*xyzk*cong*d5*d7
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*zk2*exh)*yk2*xk*cong*d5*d7
             itel = itel + 1
c zzxy
             psi(ico+itel) = psi(ico+itel) + zk*zk*xk*yk*cong*d5*d7
             dxpsi(ico+itel) = dxpsi(ico+itel) +
     &                      (1.0d0 -2.0d0*xk2*exh)*zk2*yk*cong*d5*d7
             dypsi(ico+itel) = dypsi(ico+itel) +
     &                      (1.0d0 -2.0d0*yk2*exh)*zk2*xk*cong*d5*d7
             dzpsi(ico+itel) = dzpsi(ico+itel) +
     &                      (1.0d0 -zk2*exh)*2.0d0*xyzk*cong*d5*d7
             itel = itel + 1

          endif

          goto 471

471       continue

          ipnt = ipnt + shelln(ishell)
          ico = ico + itel

420   continue

      if (ico-1.ne.norbs) 
     & call inferr('GAUSSIAN: number of orbitals incorrect',1)

      return
      end

      subroutine exxtod(npr,norbs,vectrs,vectrb,focc,focb,
     &                  eiga,eigb)

c Write wfn file form gaussian shell structure
c Only works for cartesian gaussians (not the pure D,F, or G)
c G not implemented (iupp and ilow have, pnorm)

      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (numatm=2000)
      parameter (mxel=100)

      
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp

      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp

      common /congau/ d3,d5,d7,g1,g2,g3,g4,g5,g6,r1,r2,r3,r4,
     &                r3ov2,z1,z2,z3,igcon
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, nummo, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      character*2 elemnt,swel
      common /elem/  elemnt(mxel)
      logical opfil
      real eiga,eigb
      integer genaos

      dimension ilow(5,5),iupp(5)
      dimension itdat(35),pnorm(35)
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*)
      dimension cmop(npr,norbs), cmopb(npr,norbs),
     &          itype(npr),icent(npr),expon(npr)
      dimension swel(mxel)

      data itdat/1,2,3,4,5,6,7,8,9,10,11,12,13,17,14,15,18,19,16,20,
     &           21,22,23,24,25,26,27,28,29,30,31,32,33,34,35/
      data iupp/1,4,10,20,35/
      data ilow/5*1,1,2,5,11,21,1,1,5,11,21,1,1,5,11,21,
     &          1,1,5,11,21/
      data pnorm/35*1.0d0/
 
      if (ido5d.eq.1.or.ido7f.eq.1.or.ido9g.eq.1) then
         print*,"Write of wfn not supported for use with pure D,F,G"
         return
      endif

      idum = genaos(.false.)

      do i=1,mxel
         swel(i) = '  '
         if (elemnt(i)(1:1).eq.' ') then
            swel(i)(1:1) = elemnt(i)(2:2)
         else
            swel(i) = elemnt(i)
         endif
      end do

      pnorm(8)  = d3
      pnorm(9)  = d3
      pnorm(10) = d3
      pnorm(14) = d5
      pnorm(15) = d5
      pnorm(16) = d5
      pnorm(17) = d5
      pnorm(18) = d5
      pnorm(19) = d5
      pnorm(20) = sqrt(15.0d0)
      pnorm(24) = d7
      pnorm(25) = d7
      pnorm(26) = d7
      pnorm(27) = d7
      pnorm(28) = d7
      pnorm(29) = d7
      pnorm(30) = d5*d7/d3
      pnorm(31) = d5*d7/d3
      pnorm(32) = d5*d7/d3
      pnorm(33) = d5*d7
      pnorm(34) = d5*d7
      pnorm(35) = d5*d7

      ipr = 0
      jpr = 0

      do is=1,nshell
        istart = ilow(shellt(is)+1,shellc(is)+1)
        iend = iupp(shellt(is)+1)

        do i=istart,iend

          mu = aos(is) - 1 + i

          do j=1,shelln(is)

            ipr = ipr + 1
            itype(ipr) = itdat(i)
            icent(ipr) = jan(is)
            expon(ipr) = exx(shella(is) + j-1)

            if (i.eq.1) then
              fact = pnorm(i) * c1(shella(is)+j-1)
            elseif (i.le.4) then
              fact = pnorm(i) * c2(shella(is)+j-1)
            elseif (i.le.10) then
              fact = pnorm(i) * c3(shladf(is)+j-1)
            elseif (i.le.20) then
              fact = pnorm(i) * c4(shladf(is)+j-1)
            elseif (i.le.35) then
              fact = pnorm(i) * c5(shladf(is)+j-1)
            else
              print*,'Illegal I in exxtop.'
            endIf

            do mo=1,norbs
              cmop(ipr,mo) = fact*vectrs((mo-1)*mxorb+mu)

              if (iuhf.eq.1) then
                 cmopb(ipr,mo) = fact*vectrb((mo-1)*mxorb+mu)
              endif
            end do

          end do
        end do
      end do
      
      escf = 0.0d0
      vt = 1.0d0

      iunit = 56
      if (.not.opfil(56,'molden.wfn',10,1,0,0)) return

      nmo = 0
      do i=1,norbs
         if (abs(focc(i)).gt.1.d-9) nmo = nmo  + 1
         if (abs(focb(i)).gt.1.d-9) nmo = nmo  + 1
      end do

      write(iunit,'(a)') 'Molden generated WFN file'

      write(iunit,
     & "('GAUSSIAN',i15,' MOL ORBITALS',i7,' PRIMITIVES',i9,' NUCLEI')") 
     &           nmo, npr, natoms

      write(iunit,
     &  "(2x,a2,i4,4x,'(CENTRE',I3,')',1x,3f12.8,'  CHARGE =',f5.1)") 
     &  (swel(nat(i)),i,i,(xyz(j,i),j=1,3),dble(nat(i)),i=1,natoms)

      write(iunit,"('CENTRE ASSIGNMENTS  ',20i3)") icent
      write(iunit,"('TYPE ASSIGNMENTS    ',20i3)") itype
      write(iunit,"('EXPONENTS ',5d14.7)") expon

      do i=1,norbs
        if (abs(focc(i)).gt.1.d-9) then
         write(iunit,"('MO',i5,'     MO 0.0        OCC NO = ',f12.7,
     &                '  ORB. ENERGY =', f12.7)") 
     &               i, focc(i), eiga(i)
         write(iunit,'(5d16.8)') (cmop(ipr,i),ipr=1,npr)
        endif
      end do

      if (iuhf.eq.1) then
        do i=1,norbs
         if (abs(focb(i)).gt.1.d-9) then
         write(iunit,"('MO',i5,'     MO 0.0        OCC NO = ',f12.7,
     &                '  ORB. ENERGY =', f12.7)") 
     &               (i+norbs), focb(i), eigb(i)
         write(iunit,'(5d16.8)') (cmopb(ipr,i),ipr=1,npr)
         endif
        end do
      endif

      write(iunit,"('END DATA',/,
     & ' THE  HF ENERGY = ',1f19.12,' THE VIRIAL(-V/T)= ',1f12.8)")
     &       escf,vt

      return
      end

      subroutine calnpr(npr)
      implicit double precision (a-h,o-z)
      parameter (numpre=500)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp

      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp

      npr = 0
      do is = 1,nshell
        isc = shellc(is)
        ist = shellt(is)
        if (ist.eq.1.and.isc.ne.1) then
           itmp = 4
        else
           itmp = ((ist+2)*(ist+1))/2
        endif
        npr = npr + itmp*shelln(is)
      end do

      return
      end

      subroutine wrtwfn
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)

      call calnpr(npr)
      call exxtop(npr,norbs)

      return
      end

      subroutine getmul
      implicit double precision (a-h,o-z), integer ( i-n)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*137 line
c     Dirk Huckriede got Bug out 25 Nov 93

      call search(line,'distributed multipole analysis module',
     &            istat)
      do i=1,13
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 100

      end do
3        call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 100

         if (index(line,'site').ne.0) call site(line)
         if (index(line,'total multipoles referred to origin').ne.0) 
     &   goto 2
         goto 3
2     continue
      return
100   call inferr('DMA: Premature End Of File !',1)
      end

      program unmullik

c written by g.schaftenaar
c to convert the unformatted GRAPH file to a formatted
c FGRAPH file , which can be read by a VAX

      implicit double precision (a-h,o-z)

      parameter (maxhev=75 , maxlit=75 )
      parameter (numatm=maxhev+maxlit)
      parameter (maxorb=4*maxhev+maxlit)
      parameter (morb2=maxorb**2)
      dimension h(morb2),c(morb2)
      common
     1       /molkst/ numat,nat(numatm),nfirst(numatm),nmidle(numatm),
     2                nlast(numatm), norbs, nelecs,nalpha,nbeta,
     3                nclose,nopen,ndumy,fract
      common /expont/ zs(numatm),zp(numatm),zd(numatm)
      dimension xyz(3,numatm)

c     First do the reading

      call filopn(13,'GRAPH','UNFORMATTED','UNKNOWN')
      rewind(13)

      read(13)numat,norbs,nelecs,((xyz(i,j),j=1,numat),i=1,3)
      if (numat.gt.numatm.or.norbs.gt.maxorb) stop 
     1    'Limits 150 atoms 375 orbitals'
      read(13)(nlast(i),nfirst(i),i=1,numat)
      read(13)(zs(i),i=1,numat),(zp(i),i=1,numat),
     1         (zd(i),i=1,numat),(nat(i),i=1,numat)
      linear=norbs*norbs
      read(13)(c(i),i=1,linear)
      read(13)(h(i),i=1,linear)

c     Now do the writing

      call filopn(14,'FGRAPH','FORMATTED','UNKNOWN')
      write(14,*)numat,norbs,nelecs,((xyz(i,j),j=1,numat),i=1,3)
      write(14,*)(nlast(i),nfirst(i),i=1,numat)
      write(14,*)(zs(i),i=1,numat),(zp(i),i=1,numat),
     1         (zd(i),i=1,numat),(nat(i),i=1,numat)
      write(14,*)(c(i),i=1,linear)
      write(14,*)(h(i),i=1,linear)

      end
      subroutine filopn(iunit, filnam, fmt, stat)
      character*(*) filnam, fmt, stat
      character*80 envfil
C
      call getenv(filnam,envfil)
      i = 80
   10 if (envfil(i:i) .ne. ' ') goto 20
      i = i - 1
      if (i .gt. 0) goto 10
   20 if (i .eq. 0) then
        open(unit=iunit, file=filnam, form=fmt, status=stat)
      else
        open(unit=iunit, file=envfil(1:i), form=fmt, status=stat)
      endif
      return
      end

      subroutine geogam(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      logical optxyz
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character lstr*137
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

cd     write(iun3,'(a)')'enter subroutine geogam'
      call rewfil
      igcvav = 1
      ifmxav = 1
      ifrmav = 1
      idmxav = 1
      idrmav = 1
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0

      optxyz = .false.
      call search(lstr,'optxyz',istat)
      if (istat.ne.0) optxyz = .true.
      if (optxyz) then
         ifrmav = 0
         idmxav = 0
         idrmav = 0
      endif

      do i=1,mxpnt
         if (optxyz) then
            call search(lstr,'nuclear coordinates',istat)
         else
            call search(lstr,'-  point',istat)
         endif
         if (istat.eq.0) goto 100

10       ibeg = index(lstr,'point') + 5
         lstr = lstr(ibeg:)
c
c...     Try using i4 format first if that fails there might
c...     be a space less so try i3 format, if that fails as well
c...     give up
c
         read(lstr,'(i4)',end=100,err=20) ntemp
         goto 30
20       read(lstr,'(i3)',end=100,err=100) ntemp
30       continue
         if (optxyz) ntemp = ntemp + 1

         if (optxyz) then
             call searchd(lstr,'total energy',
     &              'largest component of gradient',istat)
         else
             call searcht(lstr,'total energy','information on',
     &                     '-  point',istat)
         endif
         if (istat.eq.0) goto 100
         if (index(lstr,'total energy').eq.21) then
             if (linlen(lstr).eq.61) then
                read(lstr,'(43x,f18.10)',end=100,err=100) 
     &              epoints(ntemp)
             else if (linlen(lstr).eq.55) then
                read(lstr,'(37x,f18.10)',end=100,err=100) 
     &              epoints(ntemp)
             else if (linlen(lstr).eq.54) then
                read(lstr,'(38x,f16.10)',end=100,err=100) 
     &              epoints(ntemp)
             else if (linlen(lstr).eq.52) then
                read(lstr,'(37x,f16.10)',end=100,err=100) 
     &              epoints(ntemp)
             endif
             nepnts = ntemp
             if (optxyz) then
                 call search(lstr,'largest component of gradient',istat)
             else
                 call searchd(lstr,'information on',
     &                     '-  point',istat)
                 if (istat.eq.0) goto 100
             endif
         elseif (index(lstr,'total energy').eq.11) then
             if (linlen(lstr).eq.69) then
                read(lstr,'(33x,f18.10)',end=100,err=100) 
     &              epoints(ntemp)
             else if (linlen(lstr).eq.57) then
                read(lstr,'(39x,f18.10)',end=100,err=100) 
     &              epoints(ntemp)
             else if (linlen(lstr).eq.53) then
                read(lstr,'(37x,f16.10)',end=100,err=100) 
     &              epoints(ntemp)
             else if (linlen(lstr).eq.52) then
                read(lstr,'(37x,f15.8)',end=100,err=100) 
     &              epoints(ntemp)
             else
                read(lstr,'(28x,f18.10)',end=100,err=100)
     &              epoints(ntemp)
             endif
             nepnts = ntemp
             if (optxyz) then
                 call search(lstr,'largest component of gradient',istat)
             else
                 call searcht(lstr,'information on','information for',
     &                     '-  point',istat)
                 if (istat.eq.0) goto 100
             endif
         else
             epoints(ntemp) = 0.0d0
             nepnts = ntemp
         endif

         isav(ntemp) = 1
         if ( index(lstr,'-  point').ne.0 .or.
     &        index(lstr,'-  POINT').ne.0 ) then
            isav(ntemp) = 0
            ngeoms = ntemp
            goto 10
         endif

         if (optxyz) then
            ngeoms = ntemp
            read(lstr,'(61x,f15.7)',end=100,err=100)
     &            formax(ngeoms)
            forrms(ngeoms) = 0.0d0
            dismax(ngeoms) = 0.0d0
            disrms(ngeoms) = 0.0d0
         else
            call redel(lstr,2)

            call nxtlin(lstr,jstat)
            if (jstat.eq.1.or.jstat.eq.2) goto 100
            read(lstr,'(21x,f14.8,15x,f14.8)',end=100,err=100) 
     &           tmp3,dmaxt

            call nxtlin(lstr,jstat)
            if (jstat.eq.1.or.jstat.eq.2) goto 100
            read(lstr,'(21x,f14.8,15x,f14.8)',end=100,err=100) 
     &           tmp4,drmst

            call nxtlin(lstr,jstat)
            if (jstat.eq.1.or.jstat.eq.2) goto 100
            read(lstr,'(21x,f14.8,15x,f14.8)',end=100,err=100) 
     &           tmp1,fmaxt

            call nxtlin(lstr,jstat)
            if (jstat.eq.1.or.jstat.eq.2) goto 100
            read(lstr,'(21x,f14.8,15x,f14.8)',end=100,err=100) 
     &           tmp2,frmst

            ngeoms = ntemp
            formax(ngeoms) = tmp1
            forrms(ngeoms) = tmp2
            dismax(ngeoms) = tmp3
            disrms(ngeoms) = tmp4
         endif

      end do
100   continue
      if (ngeoms.eq.0) then
          igcvav = 0
          ifmxav = 0
          ifrmav = 0
          idmxav = 0
          idrmav = 0
          ieav = 0
      endif

cd     write(iun3,*)'*** ngeom=',ngeom
cd     write(iun3,'(a)')'leave subroutine geogam'
      return
      end

      subroutine impsc(a,b,c)
      implicit double precision (a-h,o-z)
      dimension a(3),b(3)

      rimp = 0.0d0
    
      do i=1,3
         rimp = rimp + a(i)*b(i)
      end do

      al = vlen(a)
      bl = vlen(b)

      if (al.gt.0.0d0.and.bl.gt.0.0d0) then
         c = rimp/(vlen(a)*vlen(b))
      else
         c = 0.0d0
      endif

      return
      end

      subroutine timpsc(a,b,c)
      implicit double precision (a-h,o-z)
      dimension a(3),b(3)

      c = 0.0d0
    
      do i=1,3
         c = c + a(i)*b(i)
      end do

      return
      end

      subroutine rdmadd(idebug,istatio,istats,
     &                 vectrs,vectrb,focc,focb,eiga,eigb,
     &                 averag,p,halfs,psi,
     &                 nocc,nocb,ncols,ncolb,
     &                 formax,forrms,dismax,disrms,epoints,isav,q)

c THIS IS REALLY rdmaux
 
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXITER=1000)
      common /athlp/ iatoms, mxnat
      common /moldat/ natoms,norbs,nelecs,nat(numatm) 
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      character*137 line,str
      character*2 elt
      character*2 elemnt,tocapf
      common /elem/elemnt(mxel)
      common /mopac/  nfirst(numatm),nlast(numatm),
     &                npq(numatm),pqn(numatm),emus(numatm),
     &                emup(numatm),emud(numatm),consts(numatm),
     &                constp(numatm),constd(numatm),npqref(54)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /curlin/ line
      integer getlin
      logical gnreal
      real eiga,eigb
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*),
     &          averag(*),p(*),halfs(*),psi(*)
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*),q(*)

      istatio = 1
      toang = 0.52917706d0
      isgau = 0
      istats = 0
      iatfnd = 1
      nelecs = 0
      relecs = 0.0d0
      norbs = 0
      irtype = 0
      ngeoms = 0

      if (idebug.eq.1) call inferr('subroutine rdmaux',0)

      call rewfil

      call search(line,'ATOM_EL',istat)
      if (istat.eq.1) then
         natoms = intlin(line,istat)
         if (istat.eq.0) goto 100

         n40 = natoms / 40
         if (natoms.gt.n40*40) n40 = n40 + 1

         itel = 0
         do j=1,n40

            if (getlin(0).ne.1) goto 100

            do i=1,40

                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) then
                   itel = itel + 1
                   elt = str(1:2)
                   if (nstr.eq.1) elt = ' '//str(1:1)
                   do k=1,mxel
                     if (tocapf(elt).eq.tocapf(elemnt(k))) nat(itel) = k
                   end do
                elseif (ktype.eq.0) then
                   goto 5
                else
                   print*,line
                   call inferr('string expected',1)
                   goto 100
                endif

            end do

         end do

      else
         call inferr('No ATOM_EL card found',1)
         goto 100
      end if

5     continue

      call search(line,'AO_ATOMINDEX',istat)
      if (istat.eq.1) then
         norbs = intlin(line,istat)
         if (istat.eq.0) goto 100
         if (norbs.gt.mxorb) then
             nsiz = norbs/256 
             lsiz = norbs - nsiz*256
             if (lsiz.gt.0) nsiz = nsiz + 1
             nsiz = nsiz*256
             call allorb(nsiz,0)
             call rewfil
             istats = -1
             return
         endif

         itel = 0
         iold = 0

         do while (.true.)

50          if (getlin(0).ne.1) goto 100
            if (index(line,'=').ne.0) goto 15

            do while (.true.)

                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.2) then
                   itel = itel + 1
                   if (itype.ne.iold) then
                       nfirst(itype) = itel
                       if (itype.gt.1) nlast(itype-1) = itel - 1
                   endif
                   iold = itype
                elseif (ktype.eq.0) then
                   goto 50
                else
                   print*,line
                   call inferr('integer expected',1)
                   goto 100
                endif

            end do

         end do

      else
         call inferr('No AO_ATOMINDEX card found',1)
         goto 100
      end if

15    nlast(itype) = itel

      call search(line,'AO_ZETA',istat)
      if (istat.eq.1) then
         n10 = norbs / 10
         if (norbs.gt.n10*10) n10 = n10 + 1

         itel = 0
         do j=1,n10

            if (getlin(0).ne.1) goto 100

            do i=1,10
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then
                   itel = itel + 1
                   do k=1,natoms
                      n1 = nfirst(k)
                      n2 = nlast(k)
                      if (itel.eq.n1  .and.itel.le.n2) emus(k) = rtype
                      if (itel.eq.n1+1.and.itel.le.n2) emup(k) = rtype
                      if (itel.eq.n1+4.and.itel.le.n2) emud(k) = rtype
                   end do
                elseif (ktype.eq.0) then
                   goto 25
                else
                   print*,line
                   call inferr('real expected',1)
                   goto 100
                endif
            end do

         end do

      else
         call inferr('No AO_ZETA card found',1)
         goto 100
      end if

25    continue


      if (idebug.eq.1) then
         print*,'AO_ZETA: atom  zetas  zetap zetad'
         do i=1,natoms
            print*,i,emus(i),emup(i),emud(i)
         end do
      endif

      call search(line,'NUM_ELECTRONS=',istat)
      if (istat.eq.1) then
         i1 = index(line,'=')
         nelecs = dint(reada(line,i1+1,len(line)))
      else
         call inferr('No NUM_ELECTRONS card found',1)
         goto 100
      end if

      call search(line,'Final SCF results',istat)

      cf = 5.2917715d-11*1.601917d-19/3.33564d-30

      call search(line,'DIP_VEC',istat)
      if (istat.eq.1) then
         if (idebug.eq.1) call inferr('DIP_VEC card found',0)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (gnreal(dipo,3,.false.)) then
             ihsdp = 1
             do i=1,3
                dipo(i) = dipo(i)/cf
             end do
         endif

      else
         call inferr('No DIP_VEC card found',1)
         goto 100
      end if

      call search(line,'ATOM_X',istat)
      if (istat.eq.1) then
         if (idebug.eq.1) call inferr('ATOM_X card found',0)
      else
         call inferr('No ATOMS_X card found',1)
         iatfnd = 0
         goto 100
      end if
 
      call gtapnt(natoms,xyz,istat)

      if (idebug.eq.1) then
         print*,'ATOM_X'
         do i=1,natoms
             print*,(xyz(j,i),j=1,3)
         end do
      endif

      call search(line,'ATOM_CHARGES',istat)
      if (istat.eq.1) then
         if (idebug.eq.1) call inferr('ATOM_CHARGES card found',0)

         n10 = natoms / 10
         if (natoms.gt.n10*10) n10 = n10 + 1

         itel = 0
         iold = 0

         do j=1,n10

            if (getlin(0).ne.1) goto 100

            do i=1,10

                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then
                   itel = itel + 1
                   q(itel) = rtype
                elseif (ktype.eq.0) then
                   goto 30
                else
                   print*,line
                   call inferr('ATOM_CHARGES: real expected',1)
                   goto 100
                endif

            end do

         end do

      else
         call inferr('No ATOM_CHARGES card found',1)
         goto 100
      end if

30    ihasq = 1

      linear = (norbs*(norbs+1))/2

      call search(line,'OVERLAP_MATRIX',istat)
      if (istat.eq.1) then
         if (getlin(0).ne.1) goto 100
         n10 = linear / 10
         if (linear.gt.n10*10) n10 = n10 + 1

         jtel = 0

         do j=1,n10

            if (getlin(0).ne.1) goto 100

            do i=1,10
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then

                   jtel = jtel + 1
                   vectrs(jtel) = rtype

                elseif (ktype.eq.0) then
                   goto 35
                else
                   print*,line
                   call inferr('OVERLAP_MATRIX: real expected',1)
                   goto 100
                endif
            end do

         end do

      else
         call inferr('No OVERLAP_MATRIX card found',1)
         goto 100
      end if

35    continue

      call rsp(vectrs,norbs,norbs,psi,p)

      do i=1,norbs
         psi(i) = 1.d0/dsqrt(dabs(psi(i)))
      end do

      do i=1,norbs
         do j=1,i

            sum = 0.d0

            do k=1,norbs
               sum = sum + p(i+(k-1)*norbs)*psi(k)
     &                    *p(j+(k-1)*norbs)
            end do

            halfs((i-1)*norbs+j) = sum
            halfs((j-1)*norbs+i) = sum

         end do
      end do

      call search(line,'EIGENVECTORS[',istat)
      if (istat.eq.1) then
         if (index(line,'ALPHA').ne.0) iuhf = 1
         n1 = index(line,'EIGENVECTORS[')
         n2 = index(line,']')
         if (n1.gt.0.and.n2.gt.0) then
            n10 = dint(reada(line,n1+13,n2-1))
            n10 = n10 / 10
         else
            n10 = norbs*norbs / 10
            if (norbs*norbs.gt.n10*10) n10 = n10 + 1
         endif

         itel = 1
         jtel = 0

         do j=1,n10

            if (getlin(0).ne.1) goto 100

            do i=1,10
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then

                   jtel = jtel + 1
                   if (jtel.gt.norbs) then
                      jtel = 1
                      itel = itel + 1
                   endif
                   p((itel-1)*mxorb+jtel) = rtype

                elseif (ktype.eq.0) then
                   goto 45
                else
                   print*,line
                   call inferr('EIGENVECTORS: real expected',1)
                   goto 100
                endif
            end do

         end do

      else
         call inferr('No EIGENVECTORS card found',1)
         goto 100
      end if

45    continue

      call search(line,'EIGENVALUES[',istat)
      if (istat.eq.1) then
         n1 = index(line,'EIGENVALUES[')
         n2 = index(line,']')
         if (n1.gt.0.and.n2.gt.0) then
            n10 = dint(reada(line,n1+12,n2-1))
            n10 = n10 / 10
         else
            n10 = norbs / 10
            if (norbs.gt.n10*10) n10 = n10 + 1
         endif

         itel = 0

         do j=1,n10

            if (getlin(0).ne.1) goto 100

            do i=1,10
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then

                   itel = itel + 1
                   eiga(itel) = rtype

                elseif (ktype.eq.0) then
                   goto 55
                else
                   print*,line
                   call inferr('EIGENVALUES: real expected',1)
                   goto 100
                endif
            end do

         end do

      else
         call inferr('No EIGENVALUES card found',1)
         goto 100
      end if

55    continue

      do i=1,norbs
         focc(i) = 0.0d0
      end do
     
      call search(line,'_OCCUPANCIES[',istat)
      if (istat.eq.1) then
       
         if (index(line,'ALPHA').ne.0) then
            iuhf = 1
            nt = 40
         else
            nt = 10
         endif

         n1 = index(line,'_OCCUPANCIES[')
         n2 = index(line,']')
         if (n1.gt.0.and.n2.gt.0) then
            nc = dint(reada(line,n1+13,n2-1))
            nc = nc / 10
         else
            nc = norbs / nt
            if (norbs.gt.nc*nt) nc = nc + 1
         endif

         itel = 0

         do j=1,nc

            if (getlin(0).ne.1) goto 100

            do i=1,nt
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then

                   itel = itel + 1
                   focc(itel) = rtype
                   if (itel.eq.norbs) goto 65

                elseif (ktype.eq.2) then

                   itel = itel + 1
                   focc(itel) = dble(itype)
                   if (itel.eq.norbs) goto 65

                elseif (ktype.eq.0) then
                   goto 65
                else
                   print*,line
                   call inferr('OCCUPANCIES: real expected',1)
                   goto 100
                endif
            end do

         end do

      else
         call inferr('No OCCUPANCIES card found',1)
         goto 100
      end if

65    nocc = 0
      do i=1,norbs
         if (focc(i).gt.0.0d0) nocc = nocc + 1
      end do
      ncols = norbs


      if (iuhf.eq.1) then
         call averab(averag,p,focc)
      else
         call averg(averag,p)
      endif

      call mulpxs(p,halfs,psi,vectrs)
    
      if (iuhf.eq.1) then
         call rewfil

         call search(line,'BETA_EIGENVECTORS[',istat)
         if (istat.eq.1) then
            n10 = norbs*norbs / 10
            if (norbs*norbs.gt.n10*10) n10 = n10 + 1
   
            itel = 1
            jtel = 0
   
            do j=1,n10
   
               if (getlin(0).ne.1) goto 100
   
               do i=1,10
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.3) then
   
                      jtel = jtel + 1
                      if (jtel.gt.norbs) then
                         jtel = 1
                         itel = itel + 1
                      endif
                      p((itel-1)*mxorb+jtel) = rtype
   
                   elseif (ktype.eq.0) then
                      goto 75
                   else
                      print*,line
                      call inferr('EIGENVECTORS: real expected',1)
                      goto 100
                   endif
               end do
   
            end do
   
         else
            call inferr('No EIGENVECTORS card found',1)
            goto 100
         end if
   
75       continue
   
         call search(line,'BETA_EIGENVALUES[',istat)
         if (istat.eq.1) then
            n10 = norbs / 10
            if (norbs.gt.n10*10) n10 = n10 + 1
   
            itel = 0
   
            do j=1,n10
   
               if (getlin(0).ne.1) goto 100
   
               do i=1,10
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.3) then
   
                      itel = itel + 1
                      eigb(itel) = rtype
   
                   elseif (ktype.eq.0) then
                      goto 85
                   else
                      print*,line
                      call inferr('EIGENVALUES: real expected',1)
                      goto 100
                   endif
               end do
   
            end do
   
         else
            call inferr('No EIGENVALUES card found',1)
            goto 100
         end if
   
85       continue
   
         do i=1,norbs
            focb(i) = 0.0d0
         end do
        
         call search(line,'BETA_MOLECULAR_ORBITAL_OCCUPANCIES[',istat)
         if (istat.eq.1) then
            if (index(line,'BETA').ne.0) then
               nt = 40
            else
               nt = 10
            endif

            nc = norbs / nt
            if (norbs.gt.nc*nt) nc = nc + 1
   
            itel = 0
   
            do j=1,nc
   
               if (getlin(0).ne.1) goto 100
   
               do i=1,nt
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.3) then
   
                      itel = itel + 1
                      focb(itel) = rtype
                      if (itel.eq.norbs) goto 95
   
                    elseif (ktype.eq.2) then

                      itel = itel + 1
                      focb(itel) = dble(itype)
                      if (itel.eq.norbs) goto 95

                   elseif (ktype.eq.0) then
                      goto 95
                   else
                      print*,line
                      call inferr('OCCUPANCIES: real expected',1)
                      goto 100
                   endif
               end do
   
            end do
   
         else
            call inferr('No OCCUPANCIES card found',1)
            goto 100
         end if
   
95       nocb = 0
         do i=1,norbs
            if (focb(i).gt.0.0d0) nocb = nocb + 1
         end do
         ncolb = norbs
   
         do i=1,norbs
            vectrb(i) = averag(i)
         end do

         call averab(averag,p,focb)

         do i=1,norbs
            averag(i) = averag(i) + vectrb(i)
         end do

         call mulpxs(p,halfs,psi,vectrb)

      endif

      call setcst

      call rewfil

      nepnts = 0
      do while (.true.)
         call search(line,'HEAT_OF_FORM_UPDATED',istat)
         if (istat.eq.1) then
            ieav = 1
            nepnts = nepnts + 1
            isav(nepnts) = 1
            epoints(nepnts) = rallin(line,istat)
            call search(line,'GRADIENT_UPDATED',istat)
            if (istat.eq.1) then
               ifmxav = 1
               formax(nepnts) = rallin(line,istat)
            endif
         else
            goto 110
         endif
      end do

110   if (nepnts.gt.0) then
         ngeoms = nepnts
         igcvav = 1
      endif

      if (idebug.eq.1) then
         print*,'HEAT OF FORMATION'
         do i=1,nepnts
            print*,epoints(i)
         end do
      endif

      if (idebug.eq.1) call inferr('AUX: MO data read',0)

      istats = 1
      return

100   continue

c
c      call rewmf
c
c      call srchmf(line,'[FREQ]',istat)
c
c      if (istat.eq.0) then
c
c         call inferr('No FREQ card found',0)
c
c      else
c         irtype = 4
c         if (idebug.eq.1) call inferr('FREQ card found',0)
c         if (iatfnd.ne.1) then
c             call getfra(istat)
c             call getint(istat)
c         endif
c      endif
c

      return
      end


      integer function intlin(line,istat)
      implicit double precision (a-h,o-z)
      character*137 line

      istat = 0
      intlin = 0
      i1 = index(line,'[')
      i2 = index(line,']')
      if (i1.eq.0.or.i2.eq.0) return

      intlin = reada(line,i1+1,i2-1)
      istat = 1

      return
      end

      double precision function rallin(line,istat)
      implicit double precision (a-h,o-z)
      character*137 line

      istat = 0
      rallin = 0
      i1 = index(line,'=')
      if (i1.eq.0.or.i2.eq.0) return

      rallin = reada(line,i1+1,len(line))
      istat = 1

      return
      end

      subroutine rsp(a,n,nvect,root,vect)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(*), root(n), vect(n,n)
      dimension rwork(8*20000), iwork(20000)

      call evvrsp(-1,n,nvect,n*n, n,a,rwork,iwork,root,vect,0,i)

      return
      end

      subroutine evvrsp (msgfl,n,nvect,lena,nv,a,b,ind,root,vect,iorder
     &                 ,ierr)

c       finds   (all) eigenvalues    and    (some or all) eigenvectors
c       of a real symmetric packed matrix.
c
c       the method as presented in this routine consists of four steps:
c       first, the input matrix is reduced to tridiagonal form by the
c       householder technique (orthogonal similarity transformations).
c       second, the roots are located using the rational ql method.
c       third, the vectors of the tridiagonal form are evaluated by the
c       inverse iteration technique.  vectors for degenerate or near-
c       degenerate roots are forced to be orthogonal.
c       fourth, the tridiagonal vectors are rotated to vectors of the
c       original array.
c
c    on entry -
c       msgfl  - integer (logical unit no.)
c                file where error messages will be printed.
c                if msgfl is 0, error messages will be printed on lu 6.
c                if msgfl is negative, no error messages printed.
c       n      - integer
c                order of matrix a.
c       nvect  - integer
c                number of vectors desired.  0 .le. nvect .le. n.
c       lena   - integer
c                dimension of  a  in calling routine.  must not be less
c                than (n*n+n)/2.
c       nv     - integer
c                row dimension of vect in calling routine.   n .le. nv.
c       a      - working precision real (lena)
c                input matrix, rows of the lower triangle packed into
c                linear array of dimension n*(n+1)/2.  the packed order
c                is a(1,1), a(2,1), a(2,2), a(3,1), a(3,2), ...
c       b      - working precision real (n,8)
c                scratch array, 8*n elements
c       ind    - integer (n)
c                scratch array of length n.
c       iorder - integer
c                root ordering flag.
c                = 0, roots will be put in ascending order.
c                = 2, roots will be put in descending order.
c
c    on exit -
c       a      - destoryed.  now holds reflection operators.
c       root   - working precision real (n)
c                all eigenvalues in ascending or descending order.
c                  if iorder = 0, root(1) .le. ... .le. root(n)
c                  if iorder = 2, root(1) .ge. ... .ge. root(n)
c       vect   - working precision real (nv,nvect)
c                eigenvectors for root(1), ..., root(nvect).
c       ierr   - integer
c                = 0 if no error detected,
c                = k if iteration for k-th eigenvalue failed,
c                = -k if iteration for k-th eigenvector failed.
c                (failures should be very rare.  contact c. moler.)
c
c

      implicit double precision (a-h,o-z), integer (i-n)
      logical goparr,dskwrk,maswrk

      common /par/ me,master,nproc,ibtyp,iptim,goparr,dskwrk,maswrk
      dimension a(lena),b(n,8),root(n),vect(nv,*),ind(n)

  900 format(26h0*** evvrsp parameters ***/
     +       14h ***      n = ,i8,4h ***/
     +       14h ***  nvect = ,i8,4h ***/
     +       14h ***   lena = ,i8,4h ***/
     +       14h ***     nv = ,i8,4h ***/
     +       14h *** iorder = ,i8,4h ***/
     +       14h ***   ierr = ,i8,4h ***)
  901 format(37h value of lena is less than (n*n+n)/2)
  902 format(39h eqlrat has failed to converge for root,i5)
  903 format(18h nv is less than n)
  904 format(41h einvit has failed to converge for vector,i5)
  905 format(51h value of iorder must be 0 (smallest root first) or
     *      ,23h 2 (largest root first))
  906 format(' value of n is less than or equal zero')

      lmsgfl = msgfl

      if (msgfl.eq.0) lmsgfl=6

      ierr = n - 1
      if (n.le.0) goto 800
      ierr = n + 1

      if ((n*n+n)/2.gt.lena) goto 810

c        reduce real symmetric matrix a to tridiagonal form

      call etred3(n,lena,a,b(1,1),b(1,2),b(1,3))

c        find all eigenvalues of tridiagonal matrix

      call eqlrat(n,b(1,1),b(1,2),b(1,3),root,ind,ierr,b(1,4))

      if (ierr.ne.0) goto 820

c         check the desired order of the eigenvalues

      b(1,3) = float(iorder)

      if (iorder .eq. 0) go to 300

         if (iorder .ne. 2) go to 850

c         order roots in descending order (largest first)...
c         turn root and ind arrays end for end

         do i = 1, n/2
            j = n+1-i
            t = root(i)
            root(i) = root(j)
            root(j) = t
            l = ind(i)
            ind(i) = ind(j)
            ind(j) = l
         end do

c           find i and j marking the start and end of a sequence
c           of degenerate roots

         i=0
         do while(.true.)
            i = i+1
            if (i.gt.n) goto 300
            do j=i,n
               if (root(j).ne.root(i)) goto 240
            end do
            j = n + 1
  240       continue
            j = j - 1
            if (j.ne.i) then

c                    turn around ind between i and j

               jsv = j
               klim = (j-i+1)/2
               do k=1,klim
                  l = ind(j)
                  ind(j) = ind(i)
                  ind(i) = l
                  i = i+1
                  j = j-1
               end do
               i = jsv
            endif

         end do
c
  300 continue
c
      if (nvect.le.0) return
      if (nv.lt.n) goto 830

c        find eigenvectors of tri-diagonal matrix via inverse iteration

      ierr = lmsgfl
      call einvit(nv,n,b(1,1),b(1,2),b(1,3),nvect,root,ind,
     &            vect,ierr,b(1,4),b(1,5),b(1,6),b(1,7),b(1,8))
      if (ierr.ne.0) goto 840

c        find eigenvectors of symmetric matrix via back transformation

  400 continue
      call etrbk3(nv,n,lena,a,nvect,vect)
      return

c        error message section

  800 if (lmsgfl .lt. 0) return
      if (maswrk) write(lmsgfl,906)
      go to 890

  810 if (lmsgfl .lt. 0) return
      if (maswrk) write(lmsgfl,901)
      go to 890

  820 if (lmsgfl .lt. 0) return
      if (maswrk) write(lmsgfl,902) ierr
      go to 890

  830 if (lmsgfl .lt. 0) return
      if (maswrk) write(lmsgfl,903)
      go to 890

  840 continue
      if ((lmsgfl .gt. 0).and.(maswrk)) write(lmsgfl,904) -ierr
      go to 400

  850 ierr=-1
      if (lmsgfl .lt. 0) return
      if (maswrk) write(lmsgfl,905)
      go to 890

  890 continue
      if (maswrk) write(lmsgfl,900) n,nvect,lena,nv,iorder,ierr
      return
      end

      subroutine freda(l,d,a,e)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(*),d(l),e(l)

      jk = 1

c     .......... form reduced a ..........

      do j = 1, l
         f = d(j)
         g = e(j)
 
         do k = 1, j
            a(jk) = a(jk) - f * e(k) - g * d(k)
            jk = jk + 1
         end do
 
      end do

      return
      end

      subroutine einvit(nm,n,d,e,e2,m,w,ind,z,ierr,rv1,rv2,rv3,rv4,rv6)

c       this routine finds those eigenvectors of a tridiagonal
c       symmetric matrix corresponding to specified eigenvalues.
c
c    method -
c       inverse iteration.
c
c    on entry -
c       nm     - integer
c                must be set to the row dimension of two-dimensional
c                array parameters as declared in the calling routine
c                dimension statement.
c       n      - integer
c       d      - w.p. real (n)
c                contains the diagonal elements of the input matrix.
c       e      - w.p. real (n)
c                contains the subdiagonal elements of the input matrix
c                in its last n-1 positions.  e(1) is arbitrary.
c       e2     - w.p. real (n)
c                contains the squares of corresponding elements of e,
c                with zeros corresponding to negligible elements of e.
c                e(i) is considered negligible if it is not larger than
c                the product of the relative machine precision and the
c                sum of the magnitudes of d(i) and d(i-1).  e2(1) must
c                contain 0.0 if the eigenvalues are in ascending order,
c                or 2.0 if the eigenvalues are in descending order.
c                if tqlrat, bisect, tridib, or imtqlv
c                has been used to find the eigenvalues, their
c                output e2 array is exactly what is expected here.
c       m      - integer
c                the number of specified eigenvectors.
c       w      - w.p. real (m)
c                contains the m eigenvalues in ascending
c                or descending order.
c       ind    - integer (m)
c                contains in first m positions the submatrix indices
c                associated with the corresponding eigenvalues in w --
c                1 for eigenvalues belonging to the first submatrix
c                from the top, 2 for those belonging to the second
c                submatrix, etc.
c       ierr   - integer (logical unit number)
c                logical unit for error messages
c
c    on exit -
c       all input arrays are unaltered.
c       z      - w.p. real (nm,m)
c                contains the associated set of orthonormal
c                eigenvectors. any vector which which fails to converge
c                is left as is (but normalized) when iterating stopped.
c       ierr   - integer
c                set to
c                zero    for normal return,
c                -r      if the eigenvector corresponding to the r-th
c                        eigenvalue fails to converge in 5 iterations.
c                        (only last failure to converge is reported)
c
c       rv1, rv2, rv3, rv4, and rv6 are temporary storage arrays.
c
c       rv1    - w.p. real (n)
c                diagonal elements of u from lu decomposition
c       rv2    - w.p. real (n)
c                super(1)-diagonal elements of u from lu decomposition
c       rv3    - w.p. real (n)
c                super(2)-diagonal elements of u from lu decomposition
c       rv4    - w.p. real (n)
c                elements defining l in lu decomposition
c       rv6    - w.p. real (n)
c                approximate eigenvector
c

      implicit double precision (a-h,o-z), integer (i-n)

      logical convgd,goparr,dskwrk,maswrk
      integer group,p,q,r,s,submat,tag
      double precision norm

      common /par/ me,master,nproc,ibtyp,iptim,goparr,dskwrk,maswrk

      dimension d(n),e(n+1),e2(n),w(m),z(nm,m),ind(m),
     &          rv1(n),rv2(n),rv3(n),rv4(n),rv6(n)

  001 format(' eigenvector routine einvit did not converge for vector'
     *      ,i5,'.  norm =',1p,e10.2,' performance index =',e10.2/
     *      ' (an error halt will occur if the pi is greater than 100)')

c-----------------------------------------------------------------------

      zero   = 0.0d0
      one    = 1.0d0
      grptol = 0.001d0
      epscal = 0.5d0
      hundrd = 100.0d0
      ten    = 10.0d0

      luemsg = ierr
      ierr   = 0
      x0     = zero
      uk     = zero
      norm   = zero
      eps2   = zero
      eps3   = zero
      eps4   = zero
      group  = 0
      tag    = 0
      order  = one - e2(1)
      q      = 0

      do submat=1,n

         p = q + 1

c        .......... establish and process next submatrix ..........

         do q=p,n-1
            if (e2(q+1).eq.zero) goto 140
         end do

         q = n
  140    continue


c        .......... find vectors by inverse iteration ..........

         tag = tag + 1
         anorm = zero
         s = 0

         do r=1,m

            if (ind(r).eq.tag) then

               its = 1
               x1 = w(r)

               if (s.eq.0) then

c        .......... check for isolated root ..........

                  xu = one
                  if (p.eq.q) then
                     rv6(p) = one
                     convgd = .true.
                     goto 860
                  endif

                  norm = abs(d(p))

                  do i=p+1,q
                     norm = max( norm, abs(d(i)) + abs(e(i)) )
                  end do

c        .......... eps2 is the criterion for grouping,
c                   eps3 replaces zero pivots and equal
c                   roots are modified by eps3,
c                   eps4 is taken very small to avoid overflow .........

                  eps2 = grptol * norm
                  eps3 = epscal * epslon(norm)
                  uk = q - p + 1
                  eps4 = uk * eps3
                  uk = eps4 / sqrt(uk)
                  s = p
                  group = 0

               else

c        .......... look for close or coincident roots ..........

                  if (abs(x1-x0).ge.eps2) then

c                    roots are seperate

                     group = 0

                  else

c                    roots are close

                     group = group + 1

                     if (order*(x1 - x0).le.eps3) 
     &                   x1 = x0 + order * eps3

                  endif

c        .......... elimination with interchanges and
c                   initialization of vector ..........

               endif

               u = d(p) - x1
               v = e(p+1)
               rv6(p) = uk

               do i=p+1,q

                  rv6(i) = uk

                  if (abs(e(i)).gt.abs(u)) then

c                    exchange rows before elimination

c                     *** warning -- a divide check may occur here if
c                      e2 array has not been specified correctly .......

                     xu = u / e(i)
                     rv4(i) = xu
                     rv1(i-1) = e(i)
                     rv2(i-1) = d(i) - x1
                     rv3(i-1) = e(i+1)
                     u = v - xu * rv2(i-1)
                     v = -xu * rv3(i-1)

                  else

c                       straight elimination

                     xu = e(i) / u
                     rv4(i) = xu
                     rv1(i-1) = u
                     rv2(i-1) = v
                     rv3(i-1) = zero
                     u = d(i) - x1 - xu * v
                     v = e(i+1)

                  end if

               end do

               if (abs(u).le.eps3) u = eps3

               rv1(q) = u
               rv2(q) = zero
               rv3(q) = zero

c                 do inverse iterations

               convgd = .false.

               do its=1,5

                  if (its.ne.1) then
 
c                    .......... forward substitution ..........
 
                     if (norm.eq.zero) then

                        rv6(s) = eps4
                        s = s + 1

                        if (s.gt.q) s = p

                     else

                        xu = eps4 / norm
                        call dscal(q-p+1,xu,rv6(p),1)

                     endif

c                     ... elimination operations on next vector

                     do i=p+1,q

                        u = rv6(i)

c                         if rv1(i-1) .eq. e(i), a row interchange
c                         was performed earlier in the
c                         triangularization process ..........

                        if (rv1(i-1).eq.e(i)) then

                           u = rv6(i-1)
                           rv6(i-1) = rv6(i)

                        else

                           u = rv6(i)

                        endif

                        rv6(i) = u - rv4(i) * rv6(i-1)

                     end do

                  endif

c           .......... back substitution

                  rv6(q) = rv6(q) / rv1(q)
                  v = u
                  u = rv6(q)
                  norm = abs(u)

                  do i=q-1,p,-1

                     rv6(i) = (rv6(i) - u*rv2(i) - v*rv3(i)) / rv1(i)
                     v = u
                     u = rv6(i)
                     norm = norm + abs(u)

                  end do

                  if (group.ne.0) then

c                 ....... orthogonalize with respect to previous
c                         members of group ..........

                     j = r

                     do jj=1,group

                        do while(ind(j).ne.tag)
                           j = j - 1
                        end do

                        call daxpy(q-p+1,-ddot(q-p+1,rv6(p),1,z(p,j),1),
     &                             z(p,j),1,rv6(p),1)
                     end do

                     norm = dasum(q-p+1,rv6(p),1)

                  endif

                  if (convgd) goto 840
                  if (norm.ge.one) convgd = .true.

c                 end its loop
               end do

c        .......... normalize so that sum of squares is
c                   1 and expand to full order ..........

  840          continue

               xu = one / dnrm2(q-p+1,rv6(p),1)

  860          continue

               do i=1,p-1
                  z(i,r) = zero
               end do

               do i=p,q
                  z(i,r) = rv6(i) * xu
               end do

               do i=q+1,n
                  z(i,r) = zero
               end do

               if (.not.convgd) then
   
                  rho = estpi1(q-p+1,x1,d(p),e(p),z(p,r),anorm)

                  if (rho.ge.ten .and. luemsg.gt.0 .and. maswrk)
     &                write(luemsg,001) r,norm,rho

c               *** set error -- non-converged eigenvector ..........

                  if (rho.gt.hundrd) ierr = -r

               endif

               x0 = x1

c              endif  (ind(r).eq.tag)
            endif

c           end do r=1,m
         end do

         if (q.eq.n) return

c        end do submat=1,n
      end do

      return
      end

      subroutine elau(hinv,l,d,a,e)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(*),d(l),e(l)


      zero = 0.0d+00
      half = 0.5d+00

      jl = l
      e(1) = a(1) * d(1)
      jk = 2

      do j=2,jl

         f = d(j)
         g = zero
         jm1 = j - 1

         do k=1,jm1

            g = g + a(jk) * d(k)
            e(k) = e(k) + a(jk) * f
            jk = jk + 1

         end do

         e(j) = g + a(jk) * f
         jk = jk + 1

      end do

c     .......... form p ..........

      f = zero

      do j=1,l

         e(j) = e(j) * hinv
         f = f + e(j) * d(j)

      end do

c     .......... form q ..........

      hh = f * half * hinv

      do j=1,l
         e(j) = e(j) - hh * d(j)
      end do

      return
      end

c
c
c    authors -
c       this routine was taken from eispack edition 3 dated 4/6/83
c       this version is by s. t. elbert, ames laboratory-usdoe nov 1986
c
c    purpose -
c       estimate unit roundoff in quantities of size x.
c
c    on entry -
c       x      - working precision real
c                values to find epslon for
c
c    on exit -
c       epslon - working precision real
c                smallest positive value such that x+epslon .ne. zero
c
c    qualifications -
c       this routine should perform properly on all systems
c       satisfying the following two assumptions,
c          1.  the base used in representing floating point
c              numbers is not a power of three.
c          2.  the quantity  a  in statement 10 is represented to
c              the accuracy used in floating point variables
c              that are stored in memory.
c       the statement number 10 and the go to 10 are intended to
c       force optimizing compilers to generate code satisfying
c       assumption 2.
c       under these assumptions, it should be true that,
c              a  is not exactly equal to four-thirds,
c              b  has a zero for its last bit or digit,
c              c  is not exactly equal to one,
c              eps  measures the separation of 1.0 from
c                   the next larger floating point number.
c       the developers of eispack would appreciate being informed
c       about any systems where these assumptions do not hold.
c
c    differences from eispack 3 -
c       use is made of parameter statements and intrinsic functions
c       --no executeable code changes--
c
c    external routines - none
c    intrinsic functions - abs
c
c    note -
c       questions and comments concerning eispack should be directed to
c       b. s. garbow, applied math. division, argonne national lab.
c
c
      double precision function epslon(x)
      implicit double precision (a-h,o-z), integer (i-n)

      a = 4.0d0/3.0d0
      eps = 0.0d0

      do while(eps.eq.0.0d0)
         b = a - 1.0d0
         c = b + b + b
         eps = abs(c - 1.0d0)
      end do

      epslon = eps*abs(x)

      return
      end

      subroutine eqlrat(n,diag,e,e2in,d,ind,ierr,e2)

c       this routine finds the eigenvalues of a symmetric
c       tridiagonal matrix
c
c    on entry -
c       n      - integer
c                the order of the matrix.
c       d      - w.p. real (n)
c                contains the diagonal elements of the input matrix.
c       e2     - w.p. real (n)
c                contains the squares of the subdiagonal elements of
c                the input matrix in its last n-1 positions.
c                e2(1) is arbitrary.
c
c     on exit -
c       d      - w.p. real (n)
c                contains the eigenvalues in ascending order.  if an
c                error exit is made, the eigenvalues are correct and
c                ordered for indices 1,2,...ierr-1, but may not be
c                the smallest eigenvalues.
c       e2     - w.p. real (n)
c                destroyed.
c       ierr   - integer
c                set to
c                zero       for normal return,
c                j          if the j-th eigenvalue has not been
c                           determined after 30 iterations.
c

      implicit double precision (a-h,o-z), integer (i-n)
      dimension d(n),e(n),e2(n),diag(n),e2in(n),ind(n)

      scale  = 1.0d0/64.0d0
      ierr   = 0
      d(1)   = diag(1)
      ind(1) = 1
      k      = 0
      itag   = 0

      if (n.eq.1) return

      do i=2,n

         d(i)    = diag(i)
         e2(i-1) = e2in(i)

      end do

      f = 0.0d0
      t = 0.0d0
      b = epslon(1.0d0)
      c = b*b
      b = b*scale
      e2(n) = 0.0d0

      do l=1,n

         h = abs(d(l)) + abs(e(l))

         if (t.lt.h) then

            t = h
            b = epslon(t)
            c = b*b
            b = b*scale

         endif

c     .......... look for small squared sub-diagonal element ..........

         m = l 

         do while(e2(m).gt.c)
            m = m + 1
         end do

c     .......... e2(n) is always zero, so there is an exit
c                from the loop ..........

         if (m.gt.k) then

            if (m.ne.n) e2in(m+1) = 0.0d0
            k = m
            itag = itag + 1

         endif

         if (m.eq.l) goto 100

c           iterate

         do j=1,30

c              .......... form shift ..........

            l1 = l + 1
            s = sqrt(e2(l))
            g = d(l)
            p = (d(l1) - g) / (2.0d0*s)
            r = sqrt(p*p+1.0d0)
            d(l) = s / (p + sign(r,p))
            h = g - d(l)

            do i=l1,n
               d(i) = d(i) - h
            end do

            f = f + h

c              .......... rational ql transformation ..........

            g = d(m) + b
            h = g
            s = 0.0d0

            do i=m-1,l,-1

               p = g * h
               r = p + e2(i)
               e2(i+1) = s*r
               s = e2(i) / r
               d(i+1) = h + s*(h + d(i))
               g = d(i) - e2(i) / g   + b
               h = g*p / r

            end do

            e2(l) = s*g
            d(l)  = h

c              .......... guard against underflow in convergence test

            if (h.eq.0.0d0 .or. abs(e2(l)).le.abs(c/h) ) goto 100
            e2(l) = h*e2(l)
            if (e2(l).eq.0.0d0) goto 100

         end do

c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........

         ierr = l
         return


c     converged

100      p = d(l) + f

c           .......... order eigenvalues ..........

         i = 1

         if (l.ne.1) then

            if (p.ge.d(1)) then

               i = l - 1

c           .......... loop to find ordered position

               do while(p.lt.d(i))
                  i = i - 1
               end do

               i = i + 1

            endif

            if (i.ne.l) then

               do ii=l,i+1,-1
                  d(ii) = d(ii-1)
                  ind(ii) = ind(ii-1)
               end do

            endif


         endif

         d(i) = p
         ind(i) = itag

      end do

      return
      end

      subroutine etrbk3(nm,n,nv,a,m,z)

c       this routine forms the eigenvectors of a real symmetric
c       matrix by back transforming those of the corresponding
c       symmetric tridiagonal matrix determined by  etred3.
c
c    method -
c       the calculation is carried out by forming the matrix product
c          q*z
c       where  q  is a product of the orthogonal symmetric matrices
c                q = prod(i)[1 - u(i)*.transpose.u(i)*h(i)]
c       u  is the augmented sub-diagonal rows of  a  and
c       z  is the set of eigenvectors of the tridiagonal
c       matrix  f  which was formed from the original symmetric
c       matrix  c  by the similarity transformation
c                f = q(transpose) c q

      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(nv),z(nm,m)

      if (m.eq.0 .or. n.le.2) return

      ii = 3

      do i=3,n

         iz = ii + 1
         ii = ii + i
         h  = a(ii)

         if (h.ne.0.0d0) then

            im1 = i - 1

            do j=1,m
               s = -( ddot(im1,a(iz),1,z(1,j),1) * h) * h
               call daxpy(im1,s,a(iz),1,z(1,j),1)
            end do

         endif

      end do

      return
      end

      subroutine etred3(n,nv,a,d,e,e2)

c       this routine reduces a real symmetric (packed) matrix, stored
c       as a one-dimensional array, to a symmetric tridiagonal matrix
c       using orthogonal similarity transformations, preserving the
c       information about the transformations in  a.
c
c    method -
c       the tridiagonal reduction is performed in the following way.
c       starting with j=n, the elements in the j-th row to the
c       left of the diagonal are first scaled, to avoid possible
c       underflow in the transformation that might result in severe
c       departure from orthogonality.  the sum of squares  sigma  of
c       these scaled elements is next formed.  then, a vector  u  and
c       a scalar
c                      h = u(transpose) * u / 2
c       define a reflection operator
c                      p = i - u * u(transpose) / h
c       which is orthogonal and symmetric and for which the
c       similiarity transformation  pap  eliminates the elements in
c       the j-th row of  a  to the left of the subdiagonal and the
c       symmetrical elements in the j-th column.
c
c       the non-zero components of  u  are the elements of the j-th
c       row to the left of the diagonal with the last of them
c       augmented by the square root of  sigma  prefixed by the sign
c       of the subdiagonal element.  by storing the transformed sub-
c       diagonal element in  e(j)  and not overwriting the row
c       elements eliminated in the transformation, full information
c       about  p  is save for later use in  etrbk3.
c
c       the transformation sets  e2(j)  equal to  sigma  and  e(j)
c       equal to the square root of  sigma  prefixed by the sign
c       of the replaced subdiagonal element.
c
c       the above steps are repeated on further rows of the
c       transformed  a  in reverse order until  a  is reduced to tri-
c       diagonal form, that is, repeated for  j = n-1,n-2,...,3.
c
      implicit double precision (a-h,o-z), integer (i-n)
      dimension a(nv+2),d(n+1),e(n+1),e2(n+1)

      if (n.le.2) goto 100

      iz0 = (n*n+n)/2
      aiimax = abs(a(iz0))

      do i=n,3,-1

         l = i - 1
         iia = iz0
         iz0 = iz0 - i
         aiimax = max(aiimax, abs(a(iia)))
         scale = dasum(l,a(iz0+1),1)

         if (scale.eq.abs(a(iia-1)) .or. aiimax+scale.eq.aiimax) then

c           this row is already in tri-diagonal form

            d(i) = a(iia)

            if (aiimax+d(i).eq.aiimax) d(i) = 0.0d0

            e(i) = a(iia-1)

            if (aiimax+e(i).eq.aiimax) e(i) = 0.0d0

            e2(i) = e(i)*e(i)
            a(iia) = 0.0d0

         else

            scalei = 1.0d0 / scale
            call dscal(l,scalei,a(iz0+1),1)
            hroot = dnrm2(l,a(iz0+1),1)

            f = a(iz0+l)
            g = -sign(hroot,f)
            e(i) = scale * g
            e2(i) = e(i)*e(i)
            h = hroot*hroot - f * g
            a(iz0+l) = f - g
            d(i) = a(iia)
            a(iia) = 1.0d0 / sqrt(h)

c           .......... form p then q in e(1:l) ..........

            call elau(1.0d0/h,l,a(iz0+1),a,e)

c           .......... form reduced a ..........

            call freda(l,a(iz0+1),a,e)

         endif

      end do

100   e(1) = 1.0d0
      e2(1)= 1.0d0
      d(1) = a(1)
      e(2) = a(2)
      e2(2)= a(2)*a(2)
      d(2) = a(3)

      return
      end

      function estpi1(n,eval,d,e,x,anorm)

c       evaluate symmetric tridiagonal matrix performance index
c       for 1 eigenvector

c    method -
c       this routine forms the 1-norm of the residual matrix a*x-x*eval
c       where  a  is a symmetric tridiagonal matrix stored
c       in the diagonal (d) and sub-diagonal (e) vectors, eval is the
c       eigenvalue of an eigenvector of  a,  namely  x.
c       this norm is scaled by machine accuracy for the problem size.
c       all norms appearing in the comments below are 1-norms.
c
c    on entry -
c       n      - integer
c                the order of the matrix  a.
c       eval   - w.p. real
c                the eigenvalue corresponding to vector  x.
c       d      - w.p. real (n)
c                the diagonal vector of  a.
c       e      - w.p. real (n)
c                the sub-diagonal vector of  a.
c       x      - w.p. real (n)
c                an eigenvector of  a.
c       anorm  - w.p. real
c                the norm of  a  if it has been previously computed.
c
c    on exit -
c       anorm  - w.p. real
c                the norm of  a, computed if initially zero.
c       estpi1 - w.p. real
c          !!a*x-x*eval!! / (epslon(10*n)*!!a!!*!!x!!);
c          where epslon(x) is the smallest number such that
c             x + epslon(x) .ne. x
c
c          estpi1 .lt. 1 == satisfactory performance
c                 .ge. 1 and .le. 100 == marginal performance
c                 .gt. 100 == poor performance
c          (see lect. notes in comp. sci. vol.6 pp 124-125)
c
      implicit double precision (a-h,o-z), integer (i-n)
      dimension d(n), e(n), x(n)

      estpi1 = 0.0d0

      if (n.le.1) return

      size = 10 * n

      if (anorm.eq.0.0d0) then

c        compute norm of  a

         anorm = max( abs(d(1)) + abs(e(2))
     &               ,abs(d(n)) + abs(e(n)))
         do i=2,n-1
            anorm = max( anorm, abs(e(i))+abs(d(i))+abs(e(i+1)))
         end do

         if (anorm.eq.0.0d0) anorm = 1.0d0

      endif

c     compute norms of residual and eigenvector

      xnorm = abs(x(1)) + abs(x(n))
      rnorm = abs( (d(1)-eval)*x(1) + e(2)*x(2))
     &       +abs( (d(n)-eval)*x(n) + e(n)*x(n-1))

      do i=2,n-1
         xnorm = xnorm + abs(x(i))
         rnorm = rnorm + abs(e(i)*x(i-1) + (d(i)-eval)*x(i)
     &                                     + e(i+1)*x(i+1))
      end do

      estpi1 = rnorm / (epslon(size)*anorm*xnorm)

      return
      end

      subroutine prtxyz
      parameter (numatm=2000)
      implicit double precision (a-h,o-z), integer (i-n)
      common /moldat/ natoms,norbs,nelecs,nat(numatm) 
      common /coord / xyz(3,numatm)
         print*,'test'
         do i=1,natoms
             print*,(xyz(j,i),j=1,3)
         end do

      return
      end

      subroutine gtapnt(natoms,xyz,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      character*137 line,str
      integer getlin
      common /curlin/ line
      dimension xyz(3,*)

      istat = 0
      do i=1,natoms

          if (getlin(0).ne.1) goto 100

          do j=1,3
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                xyz(j,i) = rtype
             else
                print*,line
                call inferr('ATOM_X: real expected',1)
                goto 100
             endif
          end do

      end do

      istat = 1

100   return
      end

      subroutine mult(c,s,vecs,n)
      implicit double precision (a-h,o-z)
      dimension c(n,*), s(n,*), vecs(n,*)

c     operation:-
c                                vecs=back-transformed eigenvectors
c     vecs  =  c*s               c   =un-back-transformed vectors
c                                s   =1/sqrt(overlap matrix)

      do i=1,n
         do j=1,n

            sum=0.d0

            do k=1,n
               sum = sum + c(k,i)*s(j,k)
            end do

            vecs(j,i) = sum

         end do
      end do

      return
      end

      subroutine averab(averag,p,focc)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms,norbs,nelecs,nat(numatm)
      common /mopac/  nfirst(numatm),nlast(numatm),
     &                npq(numatm),pqn(numatm),emus(numatm),
     &                emup(numatm),emud(numatm),consts(numatm),
     &                constp(numatm),constd(numatm),npqref(54)
      dimension averag(*),p(*),focc(*)

      do i=1,norbs
        x = 0.d0
        do j=1,norbs
           x = x + p((j-1)*mxorb+i)**2*focc(j)*0.5d0
        end do
        averag(i) = x*2
      end do

c
c loop to calculate spherical-average atomic orbital occupancy
c
      do i=1,natoms

           il = nfirst(i)
           iu = nlast(i)
           ir = iu - il + 1

           goto (120,130,130,130,140,140,140,140,140),ir
140            x = 0.d0

               do j=1,5
                   ji = j + il + 3
                   x = x + averag(ji)
               end do

               x = x*0.2d0

               do j=1,5
                   ji = j + il + 3
                   averag(ji) = x
               end do

130            x = 0.d0

               do j=1,3
                   ji = j + il
                   x = x + averag(ji)
               end do

               x = x*0.333333d0

               do j=1,3
                   ji = j + il
                   averag(ji) = x
               end do

120       continue
      end do

      return
      end

      function ifblen(string)
      implicit double precision (a-h,o-z)
      character*(*) string

      do i=len(string),1,-1
         ifblen = i
         if (string(i:i).ne.' ') return
      end do

      ifblen = 0

      return
      end

      subroutine tomold(rout,isel,inum)
      implicit double precision (a-h,o-z)
      real rout
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      dimension isel(4)

      call intcor(intc,rout,isel,inum)
c      if (inum.eq.4) then
c         print*,"dihedral ",isel(1),isel(2),isel(3),isel(4),rout
c      endif
      if (intc.eq.0) then
          write(iun3,*) 'Error calculating internal coordinate'
c          write(iun3,*) 'isel ',(isel(i),i=1,inum)
      endif

      return
      end

      subroutine setmon(isel,inum)
      implicit double precision (a-h,o-z)
      parameter (maxdm=20)
      real rout
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      dimension isel(4)

      if (inum.eq.2) then
          if (ndm.lt.maxdm) then
             call intcor(intc,rout,isel,inum)
             if (intc.eq.1) then
                ndm = ndm + 1
                idmon(1,ndm) = isel(1)
                idmon(2,ndm) = isel(2)
                rdm(ndm) = dble(rout)*0.52917706d0
             endif
             call domcon(ndm,0)
          else
             call inferr('To many Distance Monitors',0)
          endif
      endif

      return
      end

      subroutine stjmon(coupl,isel,inum)
      implicit double precision (a-h,o-z)
      parameter (maxdm=20)
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      dimension isel(4)

      if (inum.eq.2) then
          if (ndm.lt.maxdm) then
             ndm = ndm + 1
             idmon(1,ndm) = isel(1)
             idmon(2,ndm) = isel(2)
             rdm(ndm) = coupl
             call domcon(ndm,0)
          else
             call inferr('To many Monitors',0)
          endif
      endif

      return
      end

      subroutine clrmod(iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (maxdm=20)
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      logical found
      dimension icnn(mxcon),iconn(mxcon+1,*)

      do i=1,ndm

         k = idmon(1,i)
         n = iconn(1,k)
         icnt = 0
         found = .false.
         do j=n,1,-1
            if (iconn(1+j,k).ne.-idmon(2,i).or.found) then
                icnt = icnt + 1
                icnn(icnt) = iconn(1+j,k)
            else
                found = .true.
            endif
         end do
         do j=1,icnt
            iconn(1+(icnt-j+1),k) = icnn(j)
         end do
         iconn(1,k) = icnt

         k = idmon(2,i)
         n = iconn(1,k)
         icnt = 0
         found = .false.
         do j=n,1,-1
            if (iconn(1+j,k).ne.-idmon(1,i).or.found) then
                icnt = icnt + 1
                icnn(icnt) = iconn(1+j,k)
            else
                found = .true.
            endif
         end do
         do j=1,icnt
            iconn(1+(icnt-j+1),k) = icnn(j)
         end do
         iconn(1,k) = icnt

      end do
      
      ndm = 0

      return
      end

      subroutine intcod(intc,rout,isel,inum,coo)
      implicit double precision (a-h,o-z)
      parameter (small=1.0d-5)
      common /athlp/ iatoms, mxnat
      real rout
      dimension v1(3),v2(3),v3(3),c12(3),c23(3),isel(4),coo(3,*)

      intc = 1

      todeg = 45.0d0 / datan(1.0d0)

      do i=1,3
          v1(i) = coo(i,isel(1)) - coo(i,isel(2))
          if (inum.ge.3) v2(i) = coo(i,isel(3)) - coo(i,isel(2))
          if (inum.ge.4) v3(i) = coo(i,isel(4)) - coo(i,isel(3))
      end do

      if (inum.eq.2) then
          rout = vlen(v1)
      endif

      if (inum.eq.3) then
          call impsc(v1,v2,cosb)
          if (cosb.gt.1.0d0) cosb = 1.0d0
          if (cosb.lt.-1.0d0) cosb = -1.0d0
          rout = dacos(cosb)*todeg
      endif

      if (inum.eq.4) then

          rout = 0.0

          do i=1,4
             if (isel(i).lt.1.or.isel(i).gt.iatoms) goto 100
             do j=i+1,4
                if (isel(i).eq.isel(j)) goto 100
             end do
          end do

          call crprod(v1,v2,c12)

          do i=1,3
             v2(i) = -v2(i)
          end do

          call crprod(v2,v3,c23)
          if (vlen(c12).eq.0.0d0.or.vlen(c23).eq.0.0d0) goto 100

          call impsc(c12,c23,cosb)
          call crprod(c12,c23,v1)

          if (vlen(v1) .lt. small ) then
              dihsgn = 1.0d0
          else
              call impsc(v1,v2,dihsgn)
              if (dihsgn.ge.0.0d0) then
                 dihsgn = -1.0d0
              else
                 dihsgn = 1.0d0
              endif
          endif

          if (cosb.gt.1.0d0) cosb = 1.0d0
          if (cosb.lt.-1.0d0) cosb = -1.0d0
          rout = dacos(cosb)*todeg*dihsgn
      endif

      return

100   intc = 0
      return
      end

      subroutine espchrg(valc,nvalc,doiso,dmachg)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /coord/ xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      character keywrd*320,keyori*320
      common /keywrd/ keywrd,keyori
      parameter (max3d=61)
      parameter (mesp = (max3d*max3d*max3d+max3d)/4)
      parameter (mdum = (max3d*max3d*max3d+max3d) - mesp*4)
      common /spa3d/  connl(3,mesp), esp(mesp), dum(mdum)
      logical keyr,keyi,dmachg,doiso
      dimension valc(*)

c
c     KEYWORDS:                                              Default
c
c     ESPCH          triggers calculation esp charges
c     DMACH          triggers calculation dmaesp charges
c     MPFIT          triggers calculation Multipole Fit
c     NUMSURF=n      the number of connolly surfaces           (4)
c     CONNSC=n.n     initial scalefactor vdwaals radii         (1.4)
c     CONNINCR=n.n   increment scalefactor for next surface    (0.2)
c     PTDEN=n.n      Density of points per Unit Area           (3.0)
c
c     DIPX=n.n       specifies dipole moment to be fitted to
c     DIPY=n.n       specifies dipole moment to be fitted to
c     DIPZ=n.n       specifies dipole moment to be fitted to
c
c     The default is not to fit the dipole moment
c
c     When constructing atomspheres use as principle axis :
c     (if you want to reproduce symmetry)
c
c     AXIS-X,AXIS-Y,AXIS-Z                                    AXIS-Z
c
c     After BESLER,MERZ,KOLLMAN J. COMPUT. CHEM.
c
C     Added keyword (B. P. van Eijck, 2006):
C     CHADD     read non-atomic charge centers from file "molden.def"

      if (.not.keyr(keywrd,'CONNSC',scale)) then
          scale = 1.4d0
      endif

      if (.not.keyr(keywrd,'CONNINCR',scincr)) then
          scincr = 0.20d0
      endif

      if (keyi(keywrd,'NUMSURF',nsurf)) then
          if (doiso) nvalc = nsurf
      else
          nsurf = 4
      endif

c     Density of points per Unit Area

      if (.not.keyr(keywrd,'PTDEN',den)) then
          den = 3.0d0
      endif
      
c     Fit to dipole as well ?

      idip = 0

c     dx,dy,dz not used when idip = 0


      if (keyr(keywrd,'DIPX',dx).and.keyr(keywrd,'DIPY',dy).and.
     &    keyr(keywrd,'DIPZ',dz)) then
          idip = 1
      else
          dx = 0.0d0
          dy = 0.0d0
          dz = 0.0d0
      endif

      iaxis = 3
      if (index(keywrd,'AXIS-X').ne.0) then
          iaxis = 1      
      endif
      if (index(keywrd,'AXIS-Y').ne.0) then
          iaxis = 2      
      endif
      if (index(keywrd,'AXIS-Z').ne.0) then
          iaxis = 3      
      endif
c
c     now calculate the surface points
c
      nesp = 0
      if (doiso) then
         print*,'======================================'
         print*,'charges from isodensity surfaces'
         print*,'Number of surface(s): ',nvalc
         print*,'Surface contour value(s): ',(valc(j),j=1,nvalc)
         print*,'======================================'
         call isoden(valc,nvalc,scincr,nesp,-1)
      else
         do i = 1,nsurf
            call connol(scale,den,nesp,iaxis)
            scale = scale + scincr
         end do
      endif
c
c     next calculate the esp at the points calculated by connol
c
      do i = 1,nesp
         if (dmachg) then
            call calc(connl(1,i),connl(2,i),connl(3,i),esp(i))
         else
            call espot(connl(1,i),connl(2,i),connl(3,i),esp(i),0)
         endif
      end do

      ichadd = 0

      if (index(keywrd,'CHADD').ne.0) then
c
c        Read non-atomic charge sites from file CHADD
c
         print*,' Reading non-atomic charge sites'
         open(48,file='molden.def',status='OLD',err=200)
         ichadd = 1
         goto 210
  200    continue
         stop ' ***** No file MOLDEN.DEF present. Continue?'
  210    continue
      endif

      ichrg = 0
      if (index(keywrd,'MPFIT').ne.0) then
         call mpolefit(idip,nesp,esp,connl,dx,dy,dz,ichrg,
     &                 dmachg,keywrd,ichadd)
      else
         if (dmachg) then
            idmach = 1
         else
            idmach = 0
         endif
         call espfit(idip,nesp,esp,connl,dx,dy,dz,ichrg,idmach,ichadd)
      endif

      if (index(keywrd,'ARESP').ne.0) call aresp(nesp,ichrg)

      return
      end

      subroutine espfid(idip,nesp,esp,connl,dx,dy,dz,iz,idmach,ichadd,
     &                  qat)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension al((numatm+4)**2),a(numatm,numatm),b(numatm+4)
      dimension esp(*),connl(3,*),qat(*)

c
c     conversion factor for debye to atomic units
c
      cf = 5.2917715d-11*1.601917d-19/3.33564d-30

c     calculate total charge on the molecule

      iz = 0
      do i=1,natoms
          if (nat(i).ne.99) then
             iz = iz + nat(i)
          endif
      end do
      iz = iz - nelecs

      if (iz.ne.0) write(iun3,*) 'Charge of molecule = ',iz
c      print*,'charge nuclei ',iz,' nelec ',nelecs

      rms = 0.0d0
      rrms = 0.0d0

      do i=natoms+1,numatm
         nat(i) = 99
      end do

      elemnt(99) = ' X'

c     Read additional charge sites from file CHADD

      if (ichadd.ne.0) then

         toang = 0.52917706d0
         call chadd(natoms)

         do j=1,natoms
            write(iun3,'(i4,3f10.5,i4,a)') j,(xyz(m,j)*toang,m=1,3),
     &                                     nat(j),elemnt(nat(j))
         end do

      endif

c
c     the following sets up the linear equation a*q=b
c     set up the a(j,k) array
c
      do j=1,natoms
         b(j) = 0.d0
      end do
      do i=1,nesp
         do j=1,natoms
            rij = dsqrt((xyz(1,j)-connl(1,i))**2 +
     &      (xyz(2,j)-connl(2,i))**2 + (xyz(3,j)-connl(3,i))**2)
            b(j) = b(j) + esp(i)*1.d0/rij
         end do
      end do

      do k=1,natoms
         do j=1,natoms
            a(j,k) = 0.0d0
            do i=1,nesp
               rik = dsqrt((xyz(1,k)-connl(1,i))**2 + 
     &         (xyz(2,k)-connl(2,i))**2 + (xyz(3,k)-connl(3,i))**2)
               rij = dsqrt((xyz(1,j)-connl(1,i))**2 + 
     &         (xyz(2,j)-connl(2,i))**2 + (xyz(3,j)-connl(3,i))**2)
               a(j,k) = a(j,k) + 1.d0/rik*1.d0/rij
            end do
         end do
         a(natoms+1,k) = 1.d0
         a(k,natoms+1) = 1.d0
         a(natoms+1,natoms+1) = 0.d0
         if(idip .eq. 1) then
            a(natoms+2,k) = xyz(1,k)
            a(k,natoms+2) = xyz(1,k)
            a(natoms+2,natoms+2) = 0.d0
            a(natoms+3,k) = xyz(2,k)
            a(k,natoms+3) = xyz(2,k)
            a(natoms+3,natoms+3) = 0.d0
            a(natoms+4,k) = xyz(3,k)
            a(k,natoms+4) = xyz(3,k)
            a(natoms+4,natoms+4) = 0.d0
         endif
      end do
      b(natoms+1) = dfloat(iz)
      b(natoms+2) = dx/cf
      b(natoms+3) = dy/cf
      b(natoms+4) = dz/cf


c
c     insert charge and dipolar (if desired) constraints
c
      if (idip.eq.1) then
         ndim = natoms + 4
      else
         ndim = natoms + 1
      endif

      l = 0
      do i=1,ndim
         do j=1,ndim
            l = l + 1
            al(l) = a(i,j)
         end do
      end do
      call matinv(al,ndim,det)
      l = 0
      do i=1,ndim
         do j=1,ndim
            l = l + 1
            a(i,j) = al(l)
         end do
      end do
      do i=1,ndim
         qat(i) = 0.d0
         do j=1,ndim
            qat(i) = qat(i) + a(i,j)*b(j)
         end do
      end do
c
c     calculate root mean square fits and relative root mean square fits
c
      do i=1,nesp
         espc = 0.d0
         do j=1,natoms
            rij=dsqrt((xyz(1,j)-connl(1,i))**2+(xyz(2,j)-connl(2,i))**2
     &      +(xyz(3,j)-connl(3,i))**2)
            espc = espc + qat(j)/rij
         end do
         rms = rms + (espc-esp(i))**2
         rrms = rrms + esp(i)**2
      end do
      rms = dsqrt(rms/nesp)
      rrms = rms / dsqrt(rrms/nesp)
      rms = rms*627.51d0

      write(iun3,'(15x,''ATOM NO.    TYPE    CHARGE'')')
      write(iun3,*)' '
      qtot = 0.d0
      do i=1,natoms
         qtot = qtot + qat(i)
         write(iun3,'(17x,i2,9x,a2,1x,f10.4)')i,elemnt(nat(i)),qat(i)
      end do

      write(iun3,*)' '
      write(iun3,*) 'THE TOTAL CHARGE IS:       ',qtot
      write(iun3,*)' '

      write(iun3,*) 'THE NUMBER OF POINTS IS:   ',nesp
      write(iun3,*) 'THE RMS DEVIATION IS (kcal/mol):      ',rms
      write(iun3,*) 'THE RRMS DEVIATION IS:     ',rrms

c      if (iz.ne.0) return

      write(iun3,*)' '
      write(iun3,*) 
     & 'DIPOLE MOMENT EVALUATED FROM POINT CHARGES (debye)'
      write(iun3,'(12x,'' X        Y        Z       TOTAL'')')
      write(iun3,*)' '

      dipx = 0
      dipy = 0
      dipz = 0
      do i=1,natoms
         dipx = dipx + xyz(1,i)*qat(i)
         dipy = dipy + xyz(2,i)*qat(i)
         dipz = dipz + xyz(3,i)*qat(i)
      end do
      dip = dsqrt(dipx**2+dipy**2+dipz**2)

      write(iun3,'(8x,4f9.4)') dipx*cf,dipy*cf,dipz*cf,dip*cf

      ihasq = 1

      jmode = 0
      if (idmach.eq.1) jmode = 1
      call wrxyz(jmode)

      return
      end

      subroutine connol(scale,dens,nesp,iaxis)
      implicit double precision (a-h,o-z)
      parameter (mxptn=5000)
      parameter (numatm=2000)
      parameter (mxel=100)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      parameter (max3d=61)
      parameter (mesp = (max3d*max3d*max3d+max3d)/4)
      parameter (mdum = (max3d*max3d*max3d+max3d) - mesp*4)
      common /spa3d/  connl(3,mesp), esp(mesp), dum(mdum)
      common /esprad/ vander(mxel)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension rad(numatm)
      dimension con(3,mxptn)
      dimension inbr(200),cnbr(3,200),rnbr(200)
      logical mnbr(200)
      dimension ci(3), temp0(3)
      dimension cw(3)
      logical collid

      pi = 4.d0*datan(1.d0)
      bohr = 0.529177249d+00
      iop = 1
      den = dens
      do i=1,natoms
         rad(i) = vander(nat(i))*scale/bohr
         if (rad(i) .lt. 0.01d0) then
            write(iun3,*) 'zero van der waals radius for atom ',nat(i)
         endif
      end do
c
c     big loop for each atom
c
      do iatom = 1, natoms
c
c     transfer values from large arrays to iatom variables
c
         ri = rad(iatom)
         do k = 1,3
            ci(k) = xyz(k,iatom)
         end do
c
c     gather the neighboring atoms of iatom
c
         nnbr = 0
         do jatom = 1, natoms
            if (iatom .eq. jatom) goto 60
            d2 = dist2(ci,xyz(1,jatom))
            if (d2 .ge. (ri+rad(jatom)) ** 2) goto 60
c
c     we have a new neighbor
c     transfer atom coordinates, radius and surface request number
c
            nnbr = nnbr + 1
            if (nnbr .gt. 200)then
               write(iun3,*) 'too many neighbors:',nnbr
               stop
            endif
            inbr(nnbr) = jatom
            do k = 1,3
               cnbr(k,nnbr) = xyz(k,jatom)
            end do
            rnbr(nnbr) = rad(jatom)
60          continue
         end do
c
c     contact surface
c
         ncon = (4 * pi * ri ** 2) * den
         if (ncon .gt. mxptn) then
             write(iun3,*) ncon,' points requested'
             ncon = mxptn
             write(iun3,*) 'restrain grid to ',ncon,' pts /atom'
         endif
c
c     this call may decrease ncon somewhat
c
         if ( ncon .eq. 0) then
            write(iun3,*) 'vector length of zero in connol'
            stop
         endif
         call mksph1(con,ncon,iaxis)
c
c     contact probe placement loop
c
         do i = 1,ncon
            do k = 1,3
               cw(k) = ci(k) + ri * con(k,i)
            end do
c
c     check for collision with neighboring atoms
c
            if (collid(cw,cnbr,rnbr,mnbr,nnbr,1,
     &      jnbr,knbr)) goto 100
            do kk=1,3
               temp0(kk) = ci(kk)+ri*con(kk,i)
            end do
c
c     store point in connl and increment nesp
c
            nesp = nesp + 1
            if (nesp .gt. mesp) then
               write(iun3,*) 'to many points generated in connol'
               write(iun3,*) ' reduce nsurf, scale, den, or scincr'
               stop
            endif
            connl(1,nesp) = temp0(1)
            connl(2,nesp) = temp0(2)
            connl(3,nesp) = temp0(3)
  100       continue
         end do
  110    continue
      end do

      return
      end

      logical function collid(cw,cnbr,rnbr,mnbr,nnbr,ishape,
     &                        jnbr,knbr)
      implicit double precision (a-h,o-z)
      dimension cw(3)
      dimension cnbr(3,200)
      dimension rnbr(200)
      logical mnbr(200)
      if (nnbr .le. 0) goto 20
c
c     check whether probe is too close to any neighbor
c
      do 10 i = 1, nnbr
         if (ishape .gt. 1 .and. i .eq. jnbr) goto 10
         if (ishape .eq. 3 .and. (i .eq. knbr .or. .not. mnbr(i)))
     1   goto 10
         sumrad = rnbr(i)
         vect1 = dabs(cw(1) - cnbr(1,i))
         if (vect1 .ge. sumrad) goto 10
         vect2 = dabs(cw(2) - cnbr(2,i))
         if (vect2 .ge. sumrad) goto 10
         vect3 = dabs(cw(3) - cnbr(3,i))
         if (vect3 .ge. sumrad) goto 10
         sr2 = sumrad * sumrad
         dd2 = vect1*vect1 + vect2*vect2 + vect3*vect3
         if (dd2 .lt. sr2) goto 30
   10 continue
   20 continue
      collid = .false.
      goto 40
   30 continue
      collid = .true.
   40 continue
      return
      end

      subroutine mksph1(u,n,iaxis)
      implicit double precision (a-h,o-z)
      dimension u(3,n)

      pi = 4.d0*datan(1.d0)
      nequat = dsqrt(n * pi)
      nvert = nequat/2
      nu = 0
      do i = 1,nvert+1
         fi = (pi * (i-1)) / nvert
         z = dcos(fi)
         xy = dsin(fi)
         nhor = nequat * xy
         if (nhor .lt. 1) nhor = 1
         do j = 1,nhor
            fj = (2.d0 * pi * (j-1)) / nhor
            x = dcos(fj) * xy
            y = dsin(fj) * xy
            if (nu .ge. n) goto 30
            nu = nu + 1
            if (iaxis.eq.1) then
               u(1,nu) = z
               u(2,nu) = y
               u(3,nu) = x
            elseif (iaxis.eq.2) then
               u(1,nu) = x
               u(2,nu) = z
               u(3,nu) = y
            elseif (iaxis.eq.3) then
               u(1,nu) = x
               u(2,nu) = y
               u(3,nu) = z
            endif
         end do
      end do
   30 continue

      n = nu

      return
      end

c      subroutine mksph2(c,norder,npts,t)
c      implicit double precision (a-h,o-z)
c      dimension c(3,*)
c
cc     Extended octahedron
c
c      pi = 4.d0*datan(1.d0)
c      r2 = dsqrt(2.0d0)/2.0d0
c      r3 = dsqrt(3.0d0)/3.0d0
c      r6 = dsqrt(6.0d0)/6.0d0
c
c      npts = 6
c
c      c(1,1) = -r6
c      c(2,1) = r2
c      c(3,1) = r3
c
c      c(1,2) = -r6
c      c(2,2) = -r2
c      c(3,2) = r3
c
c      c(1,3) = 2.0d0*r6
c      c(2,3) = 0.0d0
c      c(3,3) = r3
c
c      c(1,4) = r6
c      c(2,4) = r2
c      c(3,4) = -r3
c
c      c(1,5) = r6
c      c(2,5) = -r2
c      c(3,5) = -r3
c
c      c(1,6) = -2.0d0*r6
c      c(2,6) = 0.0d0
c      c(3,6) = -r3
c
cc      t = dsqrt(2.0d0)
cc      return
c
c      do n=1,norder-1
c         t = dsqrt(2.0d0*(1.0d0 - dcos(pi/2.0d0**n)))
c         t2 = t*1.40d0
c         nn = npts
c         do i=1,nn
c            do j=i+1,nn
c               if (dist2(c(1,i),c(1,j))-t*t.lt.0.01d0) then
cc                if (dabs(dist2(c(1,i),c(1,j))-t2*t2).lt.0.01d0) then
cc               if (dist2(c(1,i),c(1,j)).lt.1.01d0) then
c                  npts = npts + 1
c                  call newpt(c(1,i),c(1,j),c(1,npts))
c               endif
c            end do
c         end do
c      end do
c
c      t = dsqrt(2.0d0*(1.0d0 - dcos(pi/2.0d0**norder)))
c
c      return
c      end
c
c      subroutine mksph3(cc,npts,t)
c      implicit double precision (a-h,o-z)
c      dimension cc(3,*)
c
cc     Extended icosahedron
c
c      pi = 4.d0*datan(1.d0)
c      r5 = dsqrt(5.0d0)
c      a = dsqrt(10.0d0+2.0d0*r5)/2.0d0
c      b = dsqrt(50.0d0+10.0d0*r5)/10.0d0
c      c = dsqrt(50.0d0-10.0d0*r5)/10.0d0
c      d = dsqrt(25.0d0+10.0d0*r5)/5.0d0
c      e = (1.0d0+r5)/2.0d0
c      d0 = 0.0d0
c      d1 = 1.0d0
c
c      npts = 12
c
c      cc(1,1) = d0
c      cc(2,1) = d0
c      cc(3,1) = a
c
c      cc(1,2) = 2.0d0*b
c      cc(2,2) = d0
c      cc(3,2) = b
c
c      cc(1,3) = c
c      cc(2,3) = e
c      cc(3,3) = b
c
c      cc(1,4) = -d
c      cc(2,4) = d1
c      cc(3,4) = b
c
c      cc(1,5) = -d
c      cc(2,5) = -d1
c      cc(3,5) = b
c
c      cc(1,6) = c
c      cc(2,6) = -e
c      cc(3,6) = b
c
c      cc(1,7) = d
c      cc(2,7) = d1
c      cc(3,7) = -b
c
c      cc(1,8) = -c
c      cc(2,8) = e
c      cc(3,8) = -b
c
c      cc(1,9) = -2.0d0*b
c      cc(2,9) = d0
c      cc(3,9) = -b
c
c      cc(1,10) = -c
c      cc(2,10) = -e
c      cc(3,10) = -b
c
c      cc(1,11) = d
c      cc(2,11) = -d1
c      cc(3,11) = -b
c
c      cc(1,12) = d0
c      cc(2,12) = d0
c      cc(3,12) = -a
c
c      do i=1,npts
c         do j=1,3
c            cc(j,i) = cc(j,i)/(b*r5)
c         end do
c      end do
c
c      t = 2.0d0/(b*r5)
c
c         nn = npts
c         do i=1,nn
c            do j=i+1,nn
c               if (dabs(dist2(cc(1,i),cc(1,j))-t*t).lt.0.01d0) then
c                  npts = npts + 1
c                  call newpt(cc(1,i),cc(1,j),cc(1,npts))
c               endif
c            end do
c         end do
c
c      t = 0.765d0
c
c      return
c      end

      subroutine mksph4(c,rad,grdw,cn,npts)
      implicit double precision (a-h,o-z)
      dimension c(3),cn(3,*)

      npts = 0
      rad2 = rad*rad

      imxz = (c(3)+rad)/grdw
      imnz = (c(3)-rad)/grdw

      do i=imnz,imxz
          z = i*grdw
          zz = dabs(z-c(3))
          r12 = rad2 - zz*zz
          if (r12.gt.0.0d0) then
            r1 = dsqrt(r12)
            imxx = (c(1)+r1)/grdw
            imnx = (c(1)-r1)/grdw
            imxy = (c(2)+r1)/grdw
            imny = (c(2)-r1)/grdw
            do j=imnx,imxx
                x = j*grdw
                xx = x-c(1)
                yy = r1*r1 - xx*xx
                if (yy.gt.0.0d0) then
                   yy = dsqrt(yy)
                   npts = npts + 1
                   cn(1,npts) = x
                   cn(2,npts) = c(2) + yy
                   cn(3,npts) = z
                   npts = npts + 1
                   cn(1,npts) = x
                   cn(2,npts) = c(2) - yy
                   cn(3,npts) = z
                endif
            end do
            do j=imny,imxy
                y = j*grdw
                yy = y-c(2)
                xx = r1*r1 - yy*yy
                if (xx.gt.0.0d0) then
                   xx = dsqrt(xx)
                   npts = npts + 1
                   cn(1,npts) = c(1) + xx
                   cn(2,npts) = y
                   cn(3,npts) = z
                   npts = npts + 1
                   cn(1,npts) = c(1) - xx
                   cn(2,npts) = y
                   cn(3,npts) = z
                endif
            end do
          endif
      end do

      imxx = (c(1)+rad)/grdw
      imnx = (c(1)-rad)/grdw

      imxy = (c(2)+rad)/grdw
      imny = (c(2)-rad)/grdw


      do i=imnx,imxx
          x = i*grdw
          xx = x-c(1)
          do j=imny,imxy
             y = j*grdw
             yy = y-c(2)
             r1 = xx*xx+yy*yy
             if (r1.lt.rad2) then
                zz = dsqrt(rad2-r1)
                npts = npts + 1
                cn(1,npts) = x
                cn(2,npts) = y
                cn(3,npts) = c(3) + zz
                npts = npts + 1
                cn(1,npts) = x
                cn(2,npts) = y
                cn(3,npts) = c(3) - zz
             endif
          end do
      end do

      return
      end

      subroutine mkscod(c,rad,grdw,iptr,npts,coo,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxipts=500)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension c(3),ic(mxipts),v1(3),v2(3),d(4),ii(4)
      dimension coo(3,*),iconn(mxcon+1,*)

      gr2 = grdw*grdw*2.000001d0
      tol = 0.001d0

      do n=1,3

        imx = dint((c(n)+rad)/grdw)
        imn = dint((c(n)-rad)/grdw)
  
        do i=imn,imx

            z = dble(i)*grdw
            nc = 0

            do j=1,npts
               if (dabs(coo(n,iptr+j)-z).lt.tol) then
                  if (nc.lt.mxipts) then
                     nc = nc + 1
                     ic(nc) = iptr+j
                  endif
               endif
            end do

            do j=1,nc

               jj = ic(j)

               do l=1,4
                  d(l)  = 10000.0d0
                  ii(l) = 0
               end do

               do k=1,nc

                  if (j.ne.k) then

                    dd2 = dist2(coo(1,ic(j)),coo(1,ic(k)))

                    il = 0
                    if (dd2.lt.d(1)) then
                       il = 1
                    elseif (dd2.lt.d(2)) then
                       il = 2
                    elseif (dd2.lt.d(3)) then
                       il = 3
                    elseif (dd2.lt.d(4)) then
                       il = 4
                    endif

                    if (il.ne.0) then

                       do l=4,1+il,-1
                          ii(l) = ii(l-1)
                          d(l)  = d(l-1)
                       end do

                       ii(il) = k
                       d (il) = dd2

                    endif

                  endif

               end do

               if (ii(1).ne.0.and.d(1).le.gr2) then
                  iconn(1,jj) = iconn(1,jj) + 1
                  iconn(iconn(1,jj)+1,jj) = ic(ii(1))
               endif

               if (ii(1).ne.0.and.ii(2).ne.0) then

                  it = 0

                  do l=1,3
                     v1(l) = coo(l,jj) - coo(l,ic(ii(1)))
                     v2(l) = coo(l,jj) - coo(l,ic(ii(2)))
                  end do

                  v = v1(1)*v2(1) + v1(2)*v2(2) + v1(3)*v2(3)

                  if (v.lt.0.0d0) then

                     it = ii(2)
                     dt = d(2)

                  elseif (ii(3).ne.0) then

                     do l=1,3
                        v2(l) = coo(l,jj) - coo(l,ic(ii(3)))
                     end do

                     v = v1(1)*v2(1) + v1(2)*v2(2) + v1(3)*v2(3)

                     if (v.lt.0.0d0) then
                        it = ii(3)
                        dt = d(3)
                     else
                        it = ii(4)
                        dt = d(4)
                     endif

                  endif

                  if ((it.gt.0.and.it.le.mxipts).and.dt.le.gr2) then

                     if (jj.gt.0.and.jj.lt.mxnat) then

                        ijj = iconn(1,jj)

                        if (ijj.lt.mxcon) then
                           iconn(1,jj) = ijj + 1
                           iconn(iconn(1,jj)+1,jj) = ic(it)
                        endif

                     endif

                  endif

               endif
            end do
        end do
      end do

      return
      end

      subroutine newpt(c1,c2,c3)
      implicit double precision (a-h,o-z)
      dimension c1(3),c2(3),c3(3)

      do i=1,3
         c3(i) = c1(i) + c2(i)
      end do

      cl = vlen(c3)

      do i=1,3
         c3(i) = c3(i)/cl
      end do

      return
      end

      double precision function dist2(a,b)
c
c     determine distances between neighboring atoms
c
      implicit double precision (a-h,o-z)
      dimension a(3)
      dimension b(3)

      d1 = a(1)-b(1)
      d2 = a(2)-b(2)
      d3 = a(3)-b(3)

      dist2 = d1*d1 + d2*d2 + d3*d3
c      dist2 = (a(1)-b(1))**2 + (a(2)-b(2))**2 + (a(3)-b(3))**2

      return
      end

      subroutine matinv(a,n,d)
      implicit double precision (a-h,o-z)
      dimension a(*)
c
c     inverts a general square matrix
c     
      dimension l(500), m(500)

      tol = 1.d-8

      d  = 1.d0
      nk = -n

      do k=1,n

         nk   = nk + n
         l(k) = k
         m(k) = k
         kk   = nk + k
         biga = a(kk)

         do j=k,n
            iz = n*(j-1)
            do i=k,n
               ij = iz + i
               if (dabs(biga)-dabs(a(ij)).lt.0) then
                  biga = a(ij)
                  l(k) = i
                  m(k) = j
               endif
            end do
         end do

         j = l(k)

         if ((j-k).gt.0) then

            ki = k - n

            do i=1,n
               ki    = ki + n
               holo  = -a(ki)
               ji    = ki - k + j
               a(ki) = a(ji)
               a(ji) = holo
            end do

         endif

         i = m(k)

         if ((i-k).gt.0) then

            jp = n*(i-1)

            do j=1,n
               jk = nk + j
               ji = jp + j
               holo  = -a(jk)
               a(jk) = a(ji)
               a(ji) = holo
            end do
         endif

         if (dabs(biga)-tol.lt.0) then
            d = 0.d0
            return
         endif

         do i=1,n
            if ((i-k).ne.0) then
               ik = nk + i
               a(ik) = a(ik)/(-biga)
            endif
         end do

         do i=1,n

            ik = nk + i
            ij = i - n

            do j=1,n
               ij = ij + n
               if ((i-k).ne.0) then
                  if ((j-k).ne.0) then
                     kj = ij - i + k
                     a(ij) = a(ik)*a(kj)+a(ij)
                  endif
               endif
            end do

         end do

         kj = k - n
         do j=1,n
            kj = kj + n
            if ((j-k).ne.0) then
               a(kj) = a(kj)/biga
            endif
         end do
         d     = min(d*biga,1.d10)
         a(kk) = 1.d0/biga
      end do

      k=n

      do while(.true.)

         k = k - 1

         if (k.gt.0) then

           i = l(k)

           if ((i-k).gt.0) then

             jq = n*(k-1)
             jr = n*(i-1)

             do j=1,n
                jk    = jq + j
                holo  = a(jk)
                ji    = jr + j
                a(jk) = -a(ji)
                a(ji) = holo
             end do

           endif

         else

           return

         endif

         j = m(k)

         if ((j-k).gt.0) then

            ki = k - n

            do i=1,n
               ki    = ki + n
               holo  = a(ki)
               ji    = ki + j - k
               a(ki) = -a(ji)
               a(ji) = holo
            end do

         endif

      end do

      return
      end

      double precision function rad(i,ianz)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /esprad/ vander(mxel)
      dimension ianz(*)

      bohr = 0.529177249d+00
      rad = vander(ianz(i))/bohr

      return
      end

      subroutine connld(dens,idomap,isp,
     &                  coo,ianz,iaton,iatclr,iresid,
     &                  iconn,isurf)
      implicit double precision (a-h,o-z)
      parameter (mxptn=5000)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (max3d=61)
      parameter (mxesp=max3d*max3d*max3d+max3d) 
      parameter (mxplev=5)
      common /athlp/  iatoms, mxnat
      common /surf/   natorg,nosncd
      common /spa3d/  esp(mxesp)

      common /potlev/ grdw, plevel(mxplev),ipcol(mxplev+1),nplev
      common /esprad/ vander(mxel)
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension con(3,mxptn)
      dimension inbr(200),cnbr(3,200),rnbr(200)
      logical mnbr(200)
      logical collid
      dimension ci(3), temp0(3)
      dimension cw(3), jt(2,3),dmn(2,3),ic(3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*),isurf(*)

      data plevel /-0.1d0,-0.05d0,0.0d0,0.05d0,0.1d0/
      data ipcol /7,5,4,2,9,1/

      itsrf = 0
      nplev = 5
      call setcod(0.05d0)

      call parptr(18,esp,fdum,idum)

      idebug = 1

      pi = 4.d0*datan(1.d0)


      bohr = 0.529177249d+00
      den = dens
      t = 0.0d0

      if (isp.eq.5) then
          nesp = iatoms
          iatoms = natorg
          goto 200
      endif

      if (natorg.eq.0) then
          natorg = iatoms
      else
          iatoms = natorg
      endif
      nesp = iatoms

c      if (isp.eq.3) call mksph3(con,ncon,t)
c
c     big loop for each atom
c
      call inferr(
     &          'Starting generation of surface',0)
      do iatom = 1, iatoms

         if (ianz(iatom).ge.99.or.isurf(iatom).lt.1) goto 110
c
c     transfer values from large arrays to iatom variables
c
         ri = rad(iatom,ianz)
         do k = 1,3
            ci(k) = coo(k,iatom)
         end do
c
c     gather the neighboring atoms of iatom
c
         nnbr = 0
         do jatom = 1, iatoms
            if (ianz(jatom).ge.99.or.isurf(jatom).lt.1) goto 60
            if (iatom .eq. jatom) goto 60
            d2 = dist2(ci,coo(1,jatom))
            if (d2 .ge. (ri+rad(jatom,ianz)) ** 2) goto 60
c
c     we have a new neighbor
c     transfer atom coordinates, radius and surface request number
c
            nnbr = nnbr + 1
            if (nnbr .gt. 200)then
               write(iun3,*) 'too many neighbors:',nnbr
               stop
            endif
            inbr(nnbr) = jatom
            do k = 1,3
               cnbr(k,nnbr) = coo(k,jatom)
            end do
            rnbr(nnbr) = rad(jatom,ianz)
60          continue
         end do
c
c     contact surface
c

         if (isp.eq.1) then
            ncon = (4 * pi * ri ** 2) * den
            if (ncon .gt. mxptn) ncon = mxptn
         elseif (isp.eq.2.or.isp.eq.4) then
            ncon = 1
         endif

c
c     this call may decrease ncon somewhat
c
         if ( ncon .eq. 0) then
            write(iun3,*) 'vector length of zero in connol'
            stop
         endif

         if (isp.eq.1) then
             call mksph1(con,ncon,3)
c         elseif (isp.eq.2) then
c             call mksph2(con,2,ncon,t)
         elseif (isp.eq.4) then
             call mksph4(ci,ri,grdw,con,ncon)
         endif
c
c     contact probe placement loop
c
         nold = nesp
         do i = 1,ncon
            do k = 1,3
               if (isp.eq.4) then
                  cw(k) = con(k,i)
               else
                  cw(k) = ci(k) + ri * con(k,i)
               endif
            end do
c
c     check for collision with neighboring atoms
c
            if (collid(cw,cnbr,rnbr,mnbr,nnbr,1,
     &      jnbr,knbr)) goto 100
            do j=iatoms+1,nold
               if (dist2(coo(1,j),cw).lt.1.0d-5) goto 100
            end do
            do kk=1,3
               if (isp.eq.4) then
                  temp0(kk) = con(kk,i)
               else
                  temp0(kk) = ci(kk)+ri*con(kk,i)
               endif
            end do
c
c     store point in connl and increment nesp
c
            nesp = nesp + 1
            if (nesp .gt. mxnat) then
               call inferr(
     &          'to many points, surface incomplete !',0)
               nesp = nesp - 1
               goto 200
            endif
            coo(1,nesp) = temp0(1)
            coo(2,nesp) = temp0(2)
            coo(3,nesp) = temp0(3)
            ianz(nesp) = 100
            iaton(nesp) = 1
            iresid(nesp) = iatom
            iatclr(nesp) = iatclr(iatom)
            isurf(nesp) = 0
            iconn(1,nesp) = 0
  100       continue
         end do
         if (isp.eq.4) then
            npts = nesp - nold
            call mkscon(ci,ri,grdw,nold,npts)
            goto 110
         endif

         if (isp.eq.3) then
            tl = t*ri
            thresh = tl*tl
         elseif (isp.eq.2) then
            tl = t*ri*1.4d0
            thresh = tl*tl
         else
            thresh = 2.5d0
         endif

         do i=nold+1,nesp
            do j=i+1,nesp
               if (dist2(coo(1,i),coo(1,j))-thresh.le.0.05d0) then
                if (iconn(1,i).lt.mxcon.and.iconn(1,j).lt.mxcon) then
                  nc = iconn(1,i)
                  if (nc.lt.mxcon) then
                     iconn(1,i) = nc + 1
                     iconn(nc+2,i) = j
                  endif
                  nc = iconn(1,j)
                  if (nc.lt.mxcon) then
                     iconn(1,j) = nc + 1
                     iconn(nc+2,j) = i
                  endif
                endif
               endif
            end do
         end do

  110    continue
      end do

  200 continue


      if (idomap.ne.0) then
         emin = 10000.0d0
         emax = -emin
         do i=iatoms+1,nesp
             if (idomap.eq.1) then
                call espot(coo(1,i),coo(2,i),coo(3,i),esp(i),0)
             elseif (idomap.eq.2) then
                call calc(coo(1,i),coo(2,i),coo(3,i),esp(i))
             elseif (idomap.eq.3) then
                call clmon(coo(1,i),esp(i))
             endif
             if (esp(i).lt.emin) emin = esp(i)
             if (esp(i).gt.emax) emax = esp(i)
         end do
         if (idebug.eq.1) then
             print*,' '
             print*,'emin = ',emin,' emax = ',emax
             print*,' '
         endif
         call clrcod(iatoms,nesp,idebug)
      endif

      if (isp.eq.5) goto 2222

      if (isp.eq.4) then
         thresh = grdw*grdw*2.000001d0
      else
         thresh = 2.5d0
      endif

      do i=iatoms+1,nesp
         jlast = 0
         if (isp.eq.4) then
            do l=1,3
               dmn(1,l) = 10000.0d0
               dmn(2,l) = 10000.0d0
               jt(1,l) = 0
               jt(2,l) = 0
            end do
         endif

         icn = 0
         iatom = iresid(i)

         do j=iatoms+1,nesp

               jatom = iresid(j)

               if (jatom.ne.jlast) then
                   jlast = jatom
                   icn = 0
                   if (iatom.ne.jatom) then
                      d2 = dist2(coo(1,iatom),coo(1,jatom))
                      if (d2.le.(rad(iatom,ianz)+rad(jatom,ianz))**2) 
     &                   icn = 1
                   endif
               endif

               if (icn.eq.1) then
                  if (isp.eq.4) then
                     ii = 0
                     do l=1,3
                        if (coo(l,i).eq.coo(l,j)) then
                           ii = l
                        endif
                     end do
                  else
                     ii = 1
                  endif
                  dd = dist2(coo(1,i),coo(1,j))
                  if (dd.lt.thresh.and.ii.ne.0.and.dd.ne.0.0d0) then
                     if (isp.eq.4) then
                        if (dd.lt.dmn(1,ii)) then
                           dmn(2,ii) = dmn(1,ii)
                           jt(2,ii) = jt(1,ii)
                           dmn(1,ii) = dd
                           jt(1,ii) = j
                        elseif (dd.lt.dmn(2,ii)) then
                           dmn(2,ii) = dd
                           jt(2,ii) = j
                        endif
                     else
                        nc = iconn(1,i)
                        if (nc.lt.mxcon) then
                           iconn(1,i) = nc + 1
                           iconn(nc+2,i) = j
                        endif
                        nc = iconn(1,j)
                        if (nc.lt.mxcon) then
                           iconn(1,j) = nc + 1
                           iconn(nc+2,j) = i
                        endif
                     endif
                  endif
               endif
         end do
         if (isp.eq.4) then
            do l=1,3
               ic(l) = 0
            end do
            nc = iconn(1,i)
            do j=1,nc
               do l=1,3
                  if (coo(l,i).eq.coo(l,iconn(1+j,i))) then
                     ic(l) = ic(l) + 1
                  endif
               end do
            end do
            do l=1,3
              ii = 0
              if (jt(1,l).ne.0.and.ic(l).le.1) then
                 ii = 1
                 if (jt(2,l).ne.0.and.ic(l).eq.0) ii = 2
              endif
              do j=1,ii
                 nc = iconn(1,i)
                 if (nc.lt.mxcon) then
                    iconn(1,i) = nc + 1
                    iconn(nc+2,i) = jt(j,l)
                 endif
              end do
            end do
         endif
      end do

2222  continue

      do i=iatoms+1,nesp
         iresid(i) = -4
      end do

      iatoms = nesp

      call inferr(
     &          'Surface generation completed !',0)

      return
      end

      subroutine clrsrd(isurf)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /surf/ natorg,nosncd
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      dimension isurf(*)

      if (natorg.ne.0) iatoms = natorg

      do i=1,iatoms
          isurf(i) = 0
      end do
      
      if (ifogl.eq.1) call srfclr
         
      return
      end

      subroutine csrft(isurf)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /surf/ natorg,nosncd
      dimension isurf(*)

      if (natorg.ne.0) iatoms = natorg

      do i=1,iatoms
          isurf(i) = 0
      end do
      
      return
      end

      subroutine allsrd(idocol,idomap,idocal,isp,
     &                  isurf,iaton,ianz,iatclr)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /surf/ natorg,nosncd
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      dimension isurf(*),iaton(*),ianz(*),iatclr(*)

      do i=1,iatoms
          if (isurf(i).eq.0.and.iaton(i).gt.0
     &        .and.ianz(i).lt.99) then
             isurf(i) = 1
             if (idocol.eq.1) iatclr(i) = 15
          endif
      end do
      
      if (ifogl.eq.1) then
         srfloc = 0
         call asurf(idomap,idocal)
      else
         call connlp(1.0d0,idomap,isp)
      endif

      return
      end

      subroutine alasrd(iresid,isurf,iams,ihets)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      dimension iresid(*),isurf(*),iams(*),ihets(*)

      do j=1,iatoms
         if (iresid(j).gt.0) then
            if (iams(iresid(j)).eq.1) then
               isurf(j) = 1
            endif
         elseif (iresid(j).le.-4) then
            if (ihets(iabs(iresid(j))+1).eq.1) then
               isurf(j) = 1
            endif
         endif
      end do

      return
      end

      subroutine clrcdd(natorg,natoms,idebug,iatclr)
      implicit double precision (a-h,o-z)
      parameter (max3d=61)
      parameter (mxesp=max3d*max3d*max3d+max3d) 
      parameter (mxplev=5)
      common /potlev/ grdw, plevel(mxplev),ipcol(mxplev+1),nplev
      common /spa3d/  esp(mxesp)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension iatclr(*), iespst(mxplev+1)

      do i=1,nplev+1
         iespst(i) = 0
      end do

      do i=natorg+1,natoms
          icolor = ipcol(1)
          ilev = 1
          do j=1,nplev
             if (esp(i).gt.plevel(j)) then
                icolor = ipcol(j+1)
                ilev = j+1
             endif
          end do
          iespst(ilev) = iespst(ilev) + 1
          iatclr(i) = icolor
      end do

      if (idebug.eq.1) then
          write(iun3,'(''-----------------------------------'')')
          write(iun3,'('' 1              esp < '',f10.5,'' '',i5)')
     &          plevel(1),iespst(1)
          do i=1,nplev-1
           write(iun3,'(i2,'' '',f10.5,'' < esp < '',
     &     f10.5,'' '',i5)') i+1,plevel(i),plevel(i+1),iespst(i+1)
          end do
          i = nplev+1
          write(iun3,'(i2,''              esp > '',f10.5,'' '',i5)')
     &       i,plevel(i-1),iespst(i)
          write(iun3,'(''-----------------------------------'')')
      endif

      return
      end

      subroutine setcod(spacin)
      implicit double precision (a-h,o-z)
      parameter (mxplev=5)
      common /potlev/ grdw, plevel(mxplev),ipcol(mxplev+1),nplev
      common /mapcls/ valcol(5),colmap(3,5)

      valcol(1) = -2.0d0*spacin
      valcol(2) = -1.0d0*spacin
      valcol(3) = 0.0d0
      valcol(4) = spacin
      valcol(5) = 2.0d0*spacin

c      print*,'valcol=',(valcol(i),i=1,5)

      nlev = nplev/2
      if (nplev-nlev*2.ne.1) return

      plevel(nlev+1) = 0.0d0
      do i=1,nlev
          plevel(i) = -(nlev+1-i)*spacin
          plevel(nlev+1+i) = i*spacin
      end do

      return
      end

      subroutine aresp(nesp,ichrg)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      parameter (max3d=61)
      parameter (mesp = (max3d*max3d*max3d+max3d)/4)
      parameter (mdum = (max3d*max3d*max3d+max3d) - mesp*4)
      common /spa3d/  connl(3,mesp), esp(mesp), dum(mdum)

      open(unit=50,form='formatted',file='resp.in',status='unknown',
     &     err=1000)
      write(50,'(a)') 'Molden generated aresp inputfile'
      write(50,'(a)') ' &cntrl nmol=1, ihfree=1'
      write(50,'(a)') ' &end'
      write(50,'(a)') '1.0'
      write(50,'(a)') 'Subtitle'
      write(50,'(2i5)') ichrg,natoms
      izero = 0
      do i=1,natoms
          write(50,'(2i5)') nat(i),izero
      end do
      write(50,'(a)') ' '
      close(50)

      open(unit=50,form='formatted',file='esp.in',status='unknown',
     &     err=1000)
      write(50,'(2i5)') natoms,nesp
      do i=1,natoms
          write(50,'(17x,3E16.7)') (xyz(j,i),j=1,3)
      end do
      do i=1,nesp
          write(50,'(1x,4E16.7)') esp(i),(connl(j,i),j=1,3)
      end do
      write(50,'(a)') ' '
      close(50)

      return
1000  call inferr('Could open file',0)
      return
      end

      subroutine wrxyd(jmode,q)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf
      dimension q(*)

      toang  = 0.52917706d0
      
      lc = linlen(curdir)
      if (icmdf.eq.1) then
         open(unit=46,form='formatted',file=curdir(1:lc)//'esp.xyz',
     &        status='unknown',err=2000)
      else
         open(unit=46,form='formatted',file='esp.xyz',
     &        status='unknown',err=2000)
      endif

      write(46,'(i5)') natoms
      if (jmode.eq.1) then
         write(46,'(a)') 'Molden DMA esp fitted charges'
      elseif (jmode.eq.2) then
         write(46,'(a)') 'Molden Mulliken charges'
      else
         write(46,'(a)') 'Molden esp fitted charges'
      endif

      do i=1,natoms
          write(46,'(a2,1x,3(f12.6,1x),f9.6)') 
     &        elemnt(nat(i)),(xyz(j,i)*toang,j=1,3),q(i)
      end do

      close(46)

      write(iun3,*) 'Wrote XYZ file esp.xyz'
      return

2000  write(iun3,*) 'Couldnt write XYZ file esp.xyz'
      return
      end

      subroutine chadd(natoms)
c
c     Reads information from file 48 and adds virtual coordinates
c
      parameter (numatm=2000)
      implicit double precision (a-h,o-z)
      common /coord / xyz(3,numatm)
      character*137 line,str,tstr
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      integer getlin
      double precision xyz
      dimension rba(3),rca(3),r(3)

      iunt = iun2
      iun2 = 48

      do while (getlin(0).eq.1)

c        Add a new virtual atom. Note: distances are atomic units!

         p = 0.0d0
         q = 0.0d0
         s = 0.0d0

         natoms = natoms + 1

         tstr = line
         ivatyp = 0

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            ia = itype
         else
            ivatyp = -1
            goto 200
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            ib = itype
         else
            ivatyp = -1
            goto 200
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            p = rtype
         else
            ivatyp = -1
            goto 200
         endif

         do m=1,3
            rba(m) = xyz(m,ib) - xyz(m,ia)
         end do

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            ic = itype
            ivatyp = 1
         elseif (ktype.eq.0) then
            goto 200
         else
            ivatyp = -1
            goto 200
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            q = rtype
         elseif (ktype.eq.0) then
            goto 200
         else
            ivatyp = -1
            goto 200
         endif

         do m=1,3
            rca(m) = xyz(m,ic) - xyz(m,ia)
         end do

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            s = rtype
            ivatyp = 2
         elseif (ktype.eq.0) then
            goto 200
         else
            ivatyp = -1
            goto 200
         endif

200      if (ivatyp.eq.-1) then

            print*,' Incorrect line on unit :'
            print*,tstr
            stop

         elseif (ivatyp.eq.0) then

c           Virtual atom in a bond

            do m=1,3
               xyz(m,natoms) = xyz(m,ia) + p*rba(m)
            end do

            write(iun3,20) natoms,(xyz(m,natoms),m=1,3),ia,ib,p

         elseif (ivatyp.eq.1) then

c           Virtual atom in a plane

            do m=1,3
               xyz(m,natoms) = xyz(m,ia) + p*rba(m) + q*rca(m)
            end do

            write(iun3,20) natoms,(xyz(m,natoms),m=1,3),ia,ib,p,ic,q

         elseif (ivatyp.eq.2) then

c           Virtual atom in three dimensions

            s = s*0.52917706d0

c           s krijgt (tijdelijk?) de dimensie A^(-1)

            r(1) = rba(2)*rca(3) - rba(3)*rca(2)
            r(2) = rba(3)*rca(1) - rba(1)*rca(3)
            r(3) = rba(1)*rca(2) - rba(2)*rca(1)

            d2 = 0

            do m=1,3
               d = p*rba(m) + q*rca(m) + s*r(m)
               xyz(m,natoms) = xyz(m,ia) + d
               d2 = d2 + d*d
            end do

            write(iun3,20) natoms,(xyz(m,natoms),m=1,3),ia,ib,p,ic,q,s,
     &           sqrt(d2)*0.52917706d0

c               print*,(rba(m),m=1,3),sqrt(rba(1)**2+rba(2)**2+rba(3)**2)
c               print*,(rca(m),m=1,3),sqrt(rca(1)**2+rca(2)**2+rca(3)**2)
c               print*,(r(m),m=1,3),sqrt(r(1)**2+r(2)**2+r(3)**2)

         endif

      end do

      iun2 = iunt

   20 format(' New atom',i4,3f10.5,2i4,f8.3,i4,2f8.3,f12.3)

      return
      end

      subroutine rotm
      implicit double precision (a-h,o-z)
      common/rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg

      do i=1,3
         do j=1,3
           rmat(i,j) = 0.0d0
         end do
      end do
      do i=1,3
         do j=1,3
            do k=1,3
               rmat(i,j)=rmat(i,j)+amat(i,k)*bmat(k,j)
            end do
         end do
      end do

      return
      end

      subroutine rotcod(b,coo)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat

      common/rotxyz/amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg
      dimension temp(3,3),b(3,*),coo(3,*)

      do i=1,3
          do j=1,3
             temp(i,j) = amat(i,1)*bmat(1,j) +
     &                   amat(i,2)*bmat(2,j) +
     &                   amat(i,3)*bmat(3,j) 
          end do
      end do

      do i=1,3
          do j=1,3
             rmat(i,j) = temp(i,1)*cmat(1,j) +
     &                   temp(i,2)*cmat(2,j) +
     &                   temp(i,3)*cmat(3,j) 
          end do
      end do

      do i=1,iatoms
          do j=1,3
             b(j,i) = rmat(j,1)*coo(1,i) + rmat(j,2)*coo(2,i)
     &                + rmat(j,3)*coo(3,i)
          end do
      end do

      return
      end

      subroutine mpolefit(idip,nesp,esp,connl,dx,dy,dz,iz,dmachg,
     &                    keywrd,ichadd)

c Routine for fitting of atomic monopoles, dipoles and quadrupoles to
c the electrostatic potential. Multipoles are obtained in spherical 
c tensor form, in coordinate system of the molecule, 
c and are given in atomic units.
c
c       Q_00
c       Q_10  Q_1c  Q_1s
c       Q_20  Q_21c Q_21s Q_22c Q_22s
c
c Fitting strategy is based on:
c Hinsen and Roux, J. Comp. Chem. 1997, 18, 368
c using Singular Value Decomposition 
c constraints are imposed by elimination
c
c Wijnand Mooij, may 1998

c
c     process keywords ATPOL MPTOL MPEQUIV
c
c ATPOL sets the use of charge, dipole and quadrupole on each atom
c Default is M+D+Q, except for hydrogen M+D
c
c     ATPOL=(atnum1/icode,atnum2-atnum10/icode,...)
c
c     icode = +1 (if monopole) +2 (if dipole) +4 (if quadrupole)
c     
c  SV tolerance (default 1D-5)
c
c     MPTOL=value
c
c  Equivalences can be set for groups of atoms.
c  Note that equivalences are set in variable numbers, not in atom number;
c  these will differ when dipoles, quadrupoles are used.
c  examp: if atom 1=M+D+Q, then charge on atom 2 has variable number 10
c
c     MPEQUIV=(var1,var2,var3/var4,var5/...)
c

      implicit double precision (a-h,o-z)
      logical dmachg
      dimension esp(*), connl(3,*)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (mesp = 30000)
      parameter (np = 200)
      parameter (tolc=1d-10)
      parameter (tol=1d-5)
      parameter (lfmax=2)
      parameter (lfmaxf=(lfmax+1)*(lfmax+1))     
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line
      common /curlin/ line
      character*(*) keywrd
      character*137 keyhlp,tstr,strt
      logical keyr
      dimension u(mesp,np),v(np,np),w(np)
      dimension b(np,np),c(np),p(np,np),binvc(np),esp1(mesp)
      dimension scratch(np)
      dimension pvec(3),temp(5)
      dimension ict(50)
      logical monopole,dipole,quadrupole
      common /mpfit/ q(lfmaxf,numatm),
     &     monopole(numatm),dipole(numatm),quadrupole(numatm)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon

      write(iun3,*) ' ---------------- '
      write(iun3,*) '     MPOLEFIT'   
      write(iun3,*) ' ---------------- '

      do i=1,numatm
         monopole(i)   = .true.
         dipole(i)     = .false.
         quadrupole(i) = .false.
      end do

      do i=natoms+1,numatm
         nat(i) = 99
      end do

      elemnt(99) = ' X'

      call setmp(keywrd)

c Check for user-input SV tolerance

      if (.not.keyr(keywrd,'MPTOL',toll)) then
         toll = tol
      endif
      write(iun3,*) 'MPTOL =',toll

      rt3 = dsqrt(3.0d0)
c
c     conversion factor for debye to atomic units
c
      cf = 5.2917715d-11*1.601917d-19 / 3.33564d-30
      toang = 0.52917706d0
     
c     calculate total charge on the molecule

      iz = 0
      do i=1,natoms
          iz = iz + nat(i)
      end do
      iz = iz - nelecs
      if (iz.ne.0) write(iun3,*) 'Charge of molecule = ',iz

      if (ichadd.ne.0) then

         call chadd(natoms)

         do j=1,natoms
            write(iun3,'(i4,3f10.5,i4,a)') j,(xyz(m,j)*toang,m=1,3),
     &           nat(j),elemnt(nat(j))
         end do

      endif


c Set the number of variables

      nvar = 0
      do i=1,natoms
         if (monopole(i)) nvar = nvar + 1
         if (dipole(i)) nvar = nvar + 3
         if (quadrupole(i)) nvar = nvar + 5
      end do
      
      if (nvar.gt.np) then
         write(iun3,*) 'Too many parameters in mpolefit'
         stop
      endif
      if (nesp.gt.mesp) then
         write(iun3,*) 'Too many ESP points in mpolefit'
         stop
      endif

c Set up the constraint relation b*q=c

      ivar = 0
      do j=1,natoms

         if (monopole(j)) then
            ivar = ivar + 1
            b(1,ivar) = 1.d0
            if (idip.eq.1) then
               b(2,ivar) = xyz(1,j)
               b(3,ivar) = xyz(2,j)
               b(4,ivar) = xyz(3,j)
            endif
         endif

         if (dipole(j)) then
            do k=1,3
               b(1,ivar+k) = 0.d0
            end do
            if (idip.eq.1) then

c              X-component  of dipole

               b(2,ivar+1) = 0.d0
               b(2,ivar+2) = 1.d0
               b(2,ivar+3) = 0.d0

c              Y-component  of dipole

               b(3,ivar+1) = 0.d0
               b(3,ivar+2) = 0.d0
               b(3,ivar+3) = 1.d0

c              Z-component  of dipole

               b(4,ivar+1) = 1.d0
               b(4,ivar+2) = 0.d0
               b(4,ivar+3) = 0.d0
            endif
            ivar = ivar + 3
         endif

         if (quadrupole(j)) then
            do k=1,5
               b(1,ivar+k) = 0.d0
            end do
            if (idip.eq.1) then
               do k=1,5
                  do i=2,4
                     b(i,ivar+k) = 0.d0
                  end do
               end do
            endif
            ivar = ivar + 5
         endif

      end do
      
      c(1) = dfloat(iz)
      ncon = 1

      if (idip.eq.1) then
         c(2) = dx/cf
         c(3) = dy/cf
         c(4) = dz/cf
         ncon = 4
      endif

c     Augment the constraint matrix to square

      do i=ncon+1,nvar
         do j=1,nvar      
            b(i,j) = 0.d0
         end do
         c(i) = 0.d0
      end do


c Set equivalences in constraint matrix

      i = index(keywrd,'MPEQUIV')
      if (i.ne.0) then
         i1 = index(keywrd(i+1:),'(')
         if (i1.ne.0) then
           i2 = index(keywrd(i+1:),')')
           if (i2.ne.0) then
              keyhlp = keywrd(i+i1+1:i+i2-1)
              l = i2 - i1 - 1
              call spatrm(keyhlp,l)
              call setlin(keyhlp,47)
              keyhlp = line(1:l)
              do while (nxtwrd(tstr,nstr,itype,rtype).eq.1)
                  keyhlp = line(1:l)
                  call setlin(tstr,44)
                  n = 0
                  do while (nxtwrd(strt,nstr,itype,rtype).eq.2)
                      n = n + 1
                      ict(n) = itype
                  end do
                  do k=2,n
                     ncon = ncon + 1
                     b(ncon,ict(1)) = 1.d0
                     b(ncon,ict(k)) = -1.d0
c                     print*,'b(',ncon,',',ict(1),') = 1.0d0',
c  &                         ' b(',ncon,',',ict(k),') = -1.0d0'
                  end do
                  call setlin(keyhlp,0)
              end do
           endif
         endif
      endif

 13   format(6f9.4)

      write(iun3,*) 'Number of variables :       ',nvar
      write(iun3,*) 'Number of constraints :     ',ncon

      if (ncon.gt.nvar) then
         write(iun3,*) 'More constraints than variables in mpolefit'
         stop
      endif


c Copy b to u. B is needed later on.

      do i=1,nvar
         do j=1,nvar
            u(j,i) = b(j,i)
         end do
      end do

      call svd(mesp,nvar,nvar,u,w,.true.,u,.true.,v,ierr,scratch,np)

      wmax = 0.d0
      do j=1,nvar
         if (w(j).gt.wmax) wmax = w(j)
      end do     
       

      thresh = tolc*wmax
      if (thresh.lt.1d-10) thresh = 1d-10

      nsvd = 0
      do j=1,nvar
         if (w(j).lt.thresh) then
              nsvd = nsvd + 1
              w(j) = 0.d0
         endif
      end do
      write(iun3,*) 'Rank of constraint matrix : ',nvar-nsvd
    
c  Calculate  1/w(i)*Utranspose, in p            

      do i=1,nvar
         if (w(i).ne.0.d0) then
            do j=1,nvar
               p(i,j) = u(j,i) / w(i)
            end do
         else
            do j=1,nvar
               p(i,j) = 0.d0
            end do
         endif
      end do
      
c Inverse of B, in u

      do i=1,nvar
         do j=1,nvar
            u(i,j) = 0.d0
            do k=1,nvar
               u(i,j) = u(i,j) + v(i,k)*p(k,j)
            end do
         end do
      end do

c     Calculate p=1-binv*b

      do i=1,nvar
         do j=1,nvar
            p(i,j) = 0.d0
            do k=1,nvar
               p(i,j) = p(i,j) - u(i,k)*b(k,j)
            end do
         end do
         p(i,i) = p(i,i) + 1.d0
      end do

c Calculate binv*c

      do i=1,nvar
         binvc(i) = 0.0d0
         do j=1,nvar
            binvc(i) = binvc(i) + u(i,j)*c(j)
         end do
      end do


      do i=1,nesp
         do j=1,nvar
            u(i,j) = 0.d0
         end do
         esp1(i) = esp(i)
      end do

c     Set up design matrix A`=AP en p`=p-A*Binv*C

      do i=1,nesp
         ivar = 0
         do j=1,natoms

            if (monopole(j)) then
               ivar = ivar + 1
               pvec(1) = connl(1,i) - xyz(1,j)
               pvec(2) = connl(2,i) - xyz(2,j)
               pvec(3) = connl(3,i) - xyz(3,j)
               qp1 = pvec(1)*pvec(1)
               qp2 = pvec(2)*pvec(2)
               qp3 = pvec(3)*pvec(3)
               r2 = qp1 + qp2 + qp3
               r = dsqrt(r2)
               temp1 = 1.d0 / r
               do k=1,nvar
                    u(i,k) = u(i,k) + temp1*p(ivar,k)
               end do
               esp1(i) = esp1(i) - temp1*binvc(ivar)
            endif

            if (dipole(j)) then
               pvec(1) = connl(1,i) - xyz(1,j)
               pvec(2) = connl(2,i) - xyz(2,j)
               pvec(3) = connl(3,i) - xyz(3,j)
               qp1 = pvec(1)*pvec(1)
               qp2 = pvec(2)*pvec(2)
               qp3 = pvec(3)*pvec(3)
               r2 = qp1 + qp2 + qp3
               r = dsqrt(r2)
               r3= r2*r
               temp(1) = pvec(3) / r3
               temp(2) = pvec(1) / r3
               temp(3) = pvec(2) / r3
               do kk=1,3
                  do k=1,nvar
                     u(i,k) = u(i,k) + temp(kk)*p(ivar+kk,k)
                  end do
                  esp1(i) = esp1(i) - temp(kk)*binvc(ivar+kk)
               end do
               ivar = ivar + 3
            endif

            if (quadrupole(j)) then
               pvec(1) = connl(1,i) - xyz(1,j)
               pvec(2) = connl(2,i) - xyz(2,j)
               pvec(3) = connl(3,i) - xyz(3,j)
               qp1 = pvec(1)*pvec(1)
               qp2 = pvec(2)*pvec(2)
               qp3 = pvec(3)*pvec(3)
               r2 = qp1 + qp2 + qp3
               r = dsqrt(r2)
               r5 = r2*r2*r
               temp(1) = 0.5d0 * (3.0d0*qp3 - r2)/ r5
               temp(2) = rt3*pvec(1)*pvec(3)/r5
               temp(3) = rt3*pvec(2)*pvec(3)/r5
               temp(4) = 0.5d0*rt3*(qp1 - qp2)/r5
               temp(5) = rt3*pvec(1)*pvec(2)/r5
               do kk=1,5
                  do k=1,nvar
                     u(i,k) = u(i,k) + temp(kk)*p(ivar+kk,k)
                  end do
                  esp1(i) = esp1(i) - temp(kk)*binvc(ivar+kk)
               end do
               ivar = ivar + 5
            endif
         end do
      end do

      call svd(mesp,nesp,nvar,u,w,.true.,u,.true.,v,ierr,scratch,np)

      wmax = 0.d0
      do j=1,nvar
         if (w(j).gt.wmax) wmax = w(j)
      end do     
      thresh = toll*wmax
      if (thresh.lt.1d-10) thresh = 1d-10

      nsvd = 0
      do j=1,nvar
         if (w(j).lt.thresh) then
             w(j) = 0.d0
             nsvd = nsvd + 1
         endif
      end do

      write(iun3,*) 'Rank of design matrix AP :  ',nvar-nsvd

c Solve for p`

      do i=1,nvar
         s = 0.d0
         if (w(i).ne.0.d0) then
             do j=1,nesp
                s = s + u(j,i)*esp1(j)
             end do
             s = s / w(i)
         endif
         scratch(i) = s
      end do
      do i=1,nvar
         s = 0.d0
         do j=1,nvar
            s = s + v(i,j)*scratch(j)
         end do
         c(i) = s
      end do

      
c Solution obeying constraints from q=BinvC + p*c
c stored in w

      do i=1,nvar
         w(i) = binvc(i)
         do j=1,nvar
           w(i) = w(i) + p(i,j)*c(j)
         end do
      end do

c     Store fitted multipoles  

      ivar = 0
      do i=1, natoms

         if (monopole(i)) then
            ivar = ivar + 1
            q(1,i) = w(ivar)
         else 
            q(1,i) = 0.d0
         endif

         if (dipole(i)) then
            do j=1,3
               ivar = ivar + 1
               q(1+j,i) = w(ivar)
            end do
         else
            do j=1,3
               q(1+j,i) = 0.d0
            end do
         endif

         if (quadrupole(i)) then
            do j=1,5
               ivar = ivar + 1
               q(4+j,i) = w(ivar)
            end do
         else
            do j=1,5
               q(4+j,i) = 0.d0
            end do
         endif

      end do
            
c
c     calculate root mean square fits and relative root mean square fits
c
      rms = 0.d0
      rrms = 0.d0
      do i=1,nesp
         espc = 0.d0
         call calc2(connl(1,i),connl(2,i),connl(3,i),espc)
         rms = rms + (espc-esp(i))**2
         rrms = rrms + esp(i)**2
      end do

      rms = dsqrt(rms/nesp)
      rrms = rms / dsqrt(rrms/nesp)
      rms = rms*627.51d0

      write(iun3,'(5x,''ATOM NO.    TYPE'')')
      write(iun3,*)' '

      qtot = 0.d0
      do i=1,natoms
         qtot = qtot + q(1,i)
         write(iun3,'(7x,i2,9x,a2,1x,f9.5)')i,elemnt(nat(i)),q(1,i)
         write(iun3,'(21x,3f9.5)') (q(j,i),j=2,4)
         write(iun3,'(21x,5f9.5)') (q(j,i),j=5,9)
      end do

      write(iun3,*)' '
      write(iun3,*) 'THE TOTAL CHARGE IS:       ',qtot
      write(iun3,*)' '

      write(iun3,*) 'THE NUMBER OF POINTS IS:   ',nesp
      write(iun3,*) 'THE RMS DEVIATION IS:      ',rms
      write(iun3,*) 'THE RRMS DEVIATION IS:     ',rrms

      write(iun3,*)' '
      write(iun3,*) 
     &     'DIPOLE MOMENT EVALUATED FROM Monopoles and Dipoles (debye)'
      write(iun3,'(12x,'' X        Y        Z       TOTAL'')')
      write(iun3,*)' '

      dipx = 0
      dipy = 0
      dipz = 0

      do i=1,natoms
         dipx = dipx + xyz(1,i)*q(1,i)
         dipy = dipy + xyz(2,i)*q(1,i)
         dipz = dipz + xyz(3,i)*q(1,i)
      end do

      dip = dsqrt(dipx**2+dipy**2+dipz**2)

      write(iun3,'(8x,4f9.4,4x,"Charge")')
     &              dipx*cf,dipy*cf,dipz*cf,dip*cf
      dipx = 0
      dipy = 0
      dipz = 0

      do i=1,natoms
         dipx = dipx + q(3,i)
         dipy = dipy + q(4,i)
         dipz = dipz + q(2,i)
      end do

      dip = dsqrt(dipx**2+dipy**2+dipz**2)
      write(iun3,'(8x,4f9.4,4x,"Dipole")')
     &                dipx*cf,dipy*cf,dipz*cf,dip*cf

      dipx = 0
      dipy = 0
      dipz = 0

      do i=1,natoms
         dipx = dipx + xyz(1,i)*q(1,i)
         dipy = dipy + xyz(2,i)*q(1,i)
         dipz = dipz + xyz(3,i)*q(1,i)
         dipx = dipx + q(3,i)
         dipy = dipy + q(4,i)
         dipz = dipz + q(2,i)
      end do

      dip = dsqrt(dipx**2+dipy**2+dipz**2)
      write(iun3,'(8x,4f9.4,4x,"Total/")') 
     &               dipx*cf,dipy*cf,dipz*cf,dip*cf

      dipo(1) = dipx
      dipo(2) = dipy
      dipo(3) = dipz
      ihsdp = 3

      call cpypol

      open(unit=46,form='formatted',file='esp.xyz',
     &    status='unknown',err=200)

      write(46,'(i5)') natoms
      write(46,'(a)') 'Molden MPOLEFIT fitted charges'
      do i=1,natoms
          write(46,'(a2,1x,3(f9.6,1x),f9.6)')
     &        elemnt(nat(i)),(xyz(j,i)*0.52917706d0,j=1,3),q(1,i)
      end do
      close(46)

      return

  200 write(iun3,*) 'Couldnt write XYZ file esp.xyz'
      end

    
      subroutine setmp(keywrd)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (lfmax=2)
      parameter (lfmaxf=(lfmax+1)*(lfmax+1))     
      logical monopole,dipole,quadrupole
      common /mpfit/ q(lfmaxf,numatm),
     &     monopole(numatm),dipole(numatm),quadrupole(numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      character*(*) keywrd
      dimension poles(numatm)

      indx = index(keywrd,'ATPOL')

      if (indx.ne.0) then
         do i=1,natoms
            monopole(i) = .false.
            dipole(i) = .false.
            quadrupole(i) = .false.
            poles(i) = 7
            if (nat(i).eq.1) poles(i) = 3
         end do
         call occin(indx,poles,numatm)
         do i=1,natoms
            j = int(poles(i))
            if (j.ge.4) then
               quadrupole(i) = .true.
               j = j - 4
            endif
            if (j.ge.2) then
               dipole(i) = .true.
               j = j - 2
            endif
            if (j.eq.1) monopole(i) = .true.
         end do
      else
         do i=1,natoms
            monopole(i) = .true.
            dipole(i) = .true.
            quadrupole(i) = .true.
            if (nat(i).eq.1) then
               quadrupole(i)=.false.
           endif
         end do
      endif

      return
      end

      subroutine calc2(x,y,z,pot)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (lfmax=2)
      parameter (lfmaxf=(lfmax+1)*(lfmax+1))
      parameter (numatm=2000)
      logical monopole,dipole,quadrupole
      common /mpfit/ q(lfmaxf,numatm),
     &     monopole(numatm),dipole(numatm),quadrupole(numatm)
      common /coord/ xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)

      dimension pvec(3)
c in this procedure the calculation order is inversed
c we use
c 
c   a      b      c      d       
c ---- + ---- + ---- + ---- = ((((d /x**2+c) /x**2)+b) /x**2) +a) /x
c   x    x**3   x**5   x**7   
c
      rt3=dsqrt(3.0d0)

      pot=0.0d0 
      do 10 i=1,natoms
         pvec(1)=x-xyz(1,i)
         pvec(2)=y-xyz(2,i)
         pvec(3)=z-xyz(3,i)
         qp1=pvec(1)*pvec(1)
         qp2=pvec(2)*pvec(2)
         qp3=pvec(3)*pvec(3)
         r2= qp1+qp2+qp3
         r=dsqrt(r2)
      pot = pot 
     & +(((
     & (q(5,i)*0.5d0*(3.0d0*qp3-r2)+
     & q(6,i)*rt3*pvec(1)*pvec(3)+
     & q(7,i)*rt3*pvec(2)*pvec(3)+
     & q(8,i)*0.5d0*rt3*(qp1-qp2)+
     & q(9,i)*rt3*pvec(1)*pvec(2)))/r2
     & +(q(2,i)*pvec(3)+q(3,i)*pvec(1)+q(4,i)*pvec(2)))/r2
     & +q(1,i))/r
10    continue

      return
      end 

      subroutine cpypol
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      parameter (lfmax=2)
      parameter (lfmaxf=(lfmax+1)*(lfmax+1))
      parameter (mxsite=300)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
      logical monopole,dipole,quadrupole
      common /mpfit/ q(lfmaxf,numatm),
     &     monopole(numatm),dipole(numatm),quadrupole(numatm)
      character*8   ctag
      common /multip/ qmom(lmaxf,mxsite),car(3,mxsite),ctag(mxsite),
     &                nsites
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)

      do i=1,natoms
         do j=1,lmaxf
             qmom(j,i) = 0.0d0
         end do
         do j=1,lfmaxf
             qmom(j,i) = q(j,i)
         end do
         do j=1,3
             car(j,i) = xyz(j,i)
         end do
      end do

      nsites = natoms

      return
      end


      SUBROUTINE SVD (NM, M, N, A, W, MATU, U, MATV, V, IERR, RV1, nn)
C
C***PURPOSE  Perform the singular value decomposition of a rectangular
C            matrix.
C***LIBRARY   SLATEC
C
C     This subroutine is a translation of the ALGOL procedure SVD,
C     NUM. MATH. 14, 403-420(1970) by Golub and Reinsch.
C     HANDBOOK FOR AUTO. COMP., VOL II-LINEAR ALGEBRA, 134-151(1971).
C
C     This subroutine determines the singular value decomposition
C          T
C     A=USV  of a REAL M by N rectangular matrix.  Householder
C     bidiagonalization and a variant of the QR algorithm are used.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A, U, V, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C          Note that NM must be at least as large as the maximum
C          of M and N.
C
C        M is the number of rows of A and U.
C
C        N is the number of columns of A and U and the order of V.
C
C        A contains the rectangular input matrix to be decomposed.  A is
C          a two-dimensional REAL array, dimensioned A(NM,N).
C
C        MATU should be set to .TRUE. if the U matrix in the
C          decomposition is desired, and to .FALSE. otherwise.
C          MATU is a LOGICAL variable.
C
C        MATV should be set to .TRUE. if the V matrix in the
C          decomposition is desired, and to .FALSE. otherwise.
C          MATV is a LOGICAL variable.
C
C     On Output
C
C        A is unaltered (unless overwritten by U or V).
C
C        W contains the N (non-negative) singular values of A (the
C          diagonal elements of S).  They are unordered.  If an
C          error exit is made, the singular values should be correct
C          for indices IERR+1, IERR+2, ..., N.  W is a one-dimensional
C          REAL array, dimensioned W(N).
C
C        U contains the matrix U (orthogonal column vectors) of the
C          decomposition if MATU has been set to .TRUE.  Otherwise,
C          U is used as a temporary array.  U may coincide with A.
C          If an error exit is made, the columns of U corresponding
C          to indices of correct singular values should be correct.
C          U is a two-dimensional REAL array, dimensioned U(NM,N).
C
C        V contains the matrix V (orthogonal) of the decomposition if
C          MATV has been set to .TRUE.  Otherwise, V is not referenced.
C          V may also coincide with A if U does not.  If an error
C          exit is made, the columns of V corresponding to indices of
C          correct singular values should be correct.  V is a two-
C          dimensional REAL array, dimensioned V(NM,N).
c+++ Changed: V can not coincide with A, as for memory reasons v is limited
c to V(nn,nn). 

C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          K          if the K-th singular value has not been
C                     determined after 30 iterations.
C
C        RV1 is a one-dimensional REAL array used for temporary storage,
C          dimensioned RV1(N).
c+++Changed: NN must be set to the row dimension of the two-dimensional
C          array parameters V, as declared in the calling
C          program dimension statement.  NN is an INTEGER variable.
C          Note that NN must be at least as large as the maximum of N.

c
c

C

C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
      INTEGER I,J,K,L,M,N,II,I1,KK,K1,LL,L1,MN,NM,ITS,IERR,nn
      double precision A(NM,*),W(*),U(NM,*),V(nn,*),RV1(*)
      double precision C,F,G,H,S,X,Y,Z,SCALE,S1
      LOGICAL MATU,MATV
C
      IERR = 0

C
      DO 100 I = 1, M
C
         DO 100 J = 1, N
            U(I,J) = A(I,J)
  100 CONTINUE
C     .......... HOUSEHOLDER REDUCTION TO BIDIAGONAL FORM ..........
      G = 0.0d0
      SCALE = 0.0d0
      S1 = 0.0d0
C
      DO 300 I = 1, N
         L = I + 1
         RV1(I) = SCALE * G
         G = 0.0d0
         S = 0.0d0
         SCALE = 0.0d0
         IF (I .GT. M) GO TO 210
C
         DO 120 K = I, M
  120    SCALE = SCALE + ABS(U(K,I))
C
         IF (SCALE .EQ. 0.0d0) GO TO 210
C
         DO 130 K = I, M
            U(K,I) = U(K,I) / SCALE
            S = S + U(K,I)**2
  130    CONTINUE
C
         F = U(I,I)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,I) = F - G
         IF (I .EQ. N) GO TO 190
C
         DO 150 J = L, N
            S = 0.0d0
C
            DO 140 K = I, M
  140       S = S + U(K,I) * U(K,J)
C
            F = S / H
C
            DO 150 K = I, M
               U(K,J) = U(K,J) + F * U(K,I)
  150    CONTINUE
C
  190    DO 200 K = I, M
  200    U(K,I) = SCALE * U(K,I)
C
  210    W(I) = SCALE * G
         G = 0.0d0
         S = 0.0d0
         SCALE = 0.0d0
         IF (I .GT. M .OR. I .EQ. N) GO TO 290
C
         DO 220 K = L, N
  220    SCALE = SCALE + ABS(U(I,K))
C
         IF (SCALE .EQ. 0.0d0) GO TO 290
C
         DO 230 K = L, N
            U(I,K) = U(I,K) / SCALE
            S = S + U(I,K)**2
  230    CONTINUE
C
         F = U(I,L)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,L) = F - G
C
         DO 240 K = L, N
  240    RV1(K) = U(I,K) / H
C
         IF (I .EQ. M) GO TO 270
C
         DO 260 J = L, M
            S = 0.0d0
C
            DO 250 K = L, N
  250       S = S + U(J,K) * U(I,K)
C
            DO 260 K = L, N
               U(J,K) = U(J,K) + S * RV1(K)
  260    CONTINUE
C
  270    DO 280 K = L, N
  280    U(I,K) = SCALE * U(I,K)
C
  290    S1 = MAX(S1,ABS(W(I))+ABS(RV1(I)))
  300 CONTINUE
C     .......... ACCUMULATION OF RIGHT-HAND TRANSFORMATIONS ..........
      IF (.NOT. MATV) GO TO 410
C     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
      DO 400 II = 1, N
         I = N + 1 - II
         IF (I .EQ. N) GO TO 390
         IF (G .EQ. 0.0d0) GO TO 360
C
         DO 320 J = L, N
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
  320    V(J,I) = (U(I,J) / U(I,L)) / G
C
         DO 350 J = L, N
            S = 0.0d0
C
            DO 340 K = L, N
  340       S = S + U(I,K) * V(K,J)
C
            DO 350 K = L, N
               V(K,J) = V(K,J) + S * V(K,I)
  350    CONTINUE
C
  360    DO 380 J = L, N
            V(I,J) = 0.0d0
            V(J,I) = 0.0d0
  380    CONTINUE
C
  390    V(I,I) = 1.0d0
         G = RV1(I)
         L = I
  400 CONTINUE
C     .......... ACCUMULATION OF LEFT-HAND TRANSFORMATIONS ..........
  410 IF (.NOT. MATU) GO TO 510
C     ..........FOR I=MIN(M,N) STEP -1 UNTIL 1 DO -- ..........
      MN = N
      IF (M .LT. N) MN = M
C
      DO 500 II = 1, MN
         I = MN + 1 - II
         L = I + 1
         G = W(I)
         IF (I .EQ. N) GO TO 430
C
         DO 420 J = L, N
  420    U(I,J) = 0.0d0
C
  430    IF (G .EQ. 0.0d0) GO TO 475
         IF (I .EQ. MN) GO TO 460
C
         DO 450 J = L, N
            S = 0.0d0
C
            DO 440 K = L, M
  440       S = S + U(K,I) * U(K,J)
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            F = (S / U(I,I)) / G
C
            DO 450 K = I, M
               U(K,J) = U(K,J) + F * U(K,I)
  450    CONTINUE
C
  460    DO 470 J = I, M
  470    U(J,I) = U(J,I) / G
C
         GO TO 490
C
  475    DO 480 J = I, M
  480    U(J,I) = 0.0d0
C
  490    U(I,I) = U(I,I) + 1.0d0
  500 CONTINUE
C     .......... DIAGONALIZATION OF THE BIDIAGONAL FORM ..........
  510 CONTINUE
C     .......... FOR K=N STEP -1 UNTIL 1 DO -- ..........
      DO 700 KK = 1, N
         K1 = N - KK
         K = K1 + 1
         ITS = 0
C     .......... TEST FOR SPLITTING.
C                FOR L=K STEP -1 UNTIL 1 DO -- ..........
  520    DO 530 LL = 1, K
            L1 = K - LL
            L = L1 + 1
            IF (S1 + ABS(RV1(L)) .EQ. S1) GO TO 565
C     .......... RV1(1) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
            IF (S1 + ABS(W(L1)) .EQ. S1) GO TO 540
  530    CONTINUE
C     .......... CANCELLATION OF RV1(L) IF L GREATER THAN 1 ..........
  540    C = 0.0d0
         S = 1.0d0
C
         DO 560 I = L, K
            F = S * RV1(I)
            RV1(I) = C * RV1(I)
            IF (S1 + ABS(F) .EQ. S1) GO TO 565
            G = W(I)
            H = dsqrt(f*f+g*g)
            W(I) = H
            C = G / H
            S = -F / H
            IF (.NOT. MATU) GO TO 560
C
            DO 550 J = 1, M
               Y = U(J,L1)
               Z = U(J,I)
               U(J,L1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  550       CONTINUE
C
  560    CONTINUE
C     .......... TEST FOR CONVERGENCE ..........
  565    Z = W(K)
         IF (L .EQ. K) GO TO 650
C     .......... SHIFT FROM BOTTOM 2 BY 2 MINOR ..........
         IF (ITS .EQ. 30) GO TO 1000
         ITS = ITS + 1
         X = W(L)
         Y = W(K1)
         G = RV1(K1)
         H = RV1(K)
         F = 0.5d0 * (((G + Z) / H) * ((G - Z) / Y) + Y / H - H / Y)
         G = dsqrt(F*F+1.0d0)
         F = X - (Z / X) * Z + (H / X) * (Y / (F + SIGN(G,F)) - H)
C     .......... NEXT QR TRANSFORMATION ..........
         C = 1.0d0
         S = 1.0d0
C
         DO 600 I1 = L, K1
            I = I1 + 1
            G = RV1(I)
            Y = W(I)
            H = S * G
            G = C * G
            Z = dsqrt(F*f+H*h)
            RV1(I1) = Z
            C = F / Z
            S = H / Z
            F = X * C + G * S
            G = -X * S + G * C
            H = Y * S
            Y = Y * C
            IF (.NOT. MATV) GO TO 575
C
            DO 570 J = 1, N
               X = V(J,I1)
               Z = V(J,I)
               V(J,I1) = X * C + Z * S
               V(J,I) = -X * S + Z * C
  570       CONTINUE
C
  575       Z = dsqrt(F*f+H*h)
            W(I1) = Z
C     .......... ROTATION CAN BE ARBITRARY IF Z IS ZERO ..........
            IF (Z .EQ. 0.0d0) GO TO 580
            C = F / Z
            S = H / Z
  580       F = C * G + S * Y
            X = -S * G + C * Y
            IF (.NOT. MATU) GO TO 600
C
            DO 590 J = 1, M
               Y = U(J,I1)
               Z = U(J,I)
               U(J,I1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  590       CONTINUE
C
  600    CONTINUE
C
         RV1(L) = 0.0d0
         RV1(K) = F
         W(K) = X
         GO TO 520
C     .......... CONVERGENCE ..........
  650    IF (Z .GE. 0.0d0) GO TO 700
C     .......... W(K) IS MADE NON-NEGATIVE ..........
         W(K) = -Z
         IF (.NOT. MATV) GO TO 700
C
         DO 690 J = 1, N
  690    V(J,K) = -V(J,K)
C
  700 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO A
C                SINGULAR VALUE AFTER 30 ITERATIONS ..........
 1000 IERR = K
 1001 RETURN
      END

c This program removes the redundancy in wrl-files from marching cube alg.
c and thus shortens them by about a factor 4. The program is called by 
c       short_wrl  filename(incl. path)
c filename must have extension wrl.
c A new file is written which end on '+.wrl'
c This program was written by 
c Dr. Andreas Klamt, COSMOlogic GmbH&CoKG, Leverkusen, Germany (17/08/2000)
c It may be freely used without removal of the copyright statement.
c Adapted by G.Schaftenaar to include processing of molden VRML orbitals
c     maxpts is the maximum number of non-redundant vertices 
c     Thus the number of redundant vertices may be about 5*maxpts
      parameter (maxpts=500000)
      dimension x(3,maxpts),id(maxpts),r(3)
      logical isz(maxpts)
      character*150 zeile
c
      call getarg(1,zeile)
      ind=index(zeile,'.wrl')
      if (ind.eq.0) stop 'No wrl-file!!!'
      open (7,file=zeile, status='old')
      open (8,file=zeile(:ind)//'+.wrl', status='unknown')
5     read(7,'(a)') zeile
      ind=index(zeile,'                                            ')-1
      write(8,'(a)') zeile(:ind)
      if(index(zeile,'coord Coordinate { point [').eq.0) go to 5
      l=0
      do 30 i=1,500000
        isz(i)=.false.
        k=l+1
        read(7,'(a)') zeile
        read(zeile,*,err=50) (x(ix,k),ix=1,3)
        do 10 j=1,l
          if((x(1,j)-x(1,k))**2 .gt. 1.d-10) go to 10
          if((x(2,j)-x(2,k))**2 .gt. 1.d-10) go to 10
          if((x(3,j)-x(3,k))**2 .gt. 1.d-10) go to 10
          id(i)=j-1
          go to 30
10      continue
        id(i)=l
        l=l+1
        isz(i)=.true.
        write(8,'(3f12.5,1h,)') (x(ix,l),ix=1,3)
30    continue
50    np=i-1
      ind=index(zeile,'                                            ')-1
      write(8,'(a)') zeile(:ind)
51    read(7,'(a)') zeile
      ind=index(zeile,'                                            ')-1
      write(8,'(a)') zeile(:ind)
      if(index(zeile,'normal Normal { vector [').eq.0) go to 51
      do i=1,np
        read(7,*)  r
        if(isz(i)) write(8,'(3f10.6,1h,)') r
      end do
61    read(7,'(a)') zeile
      ind=index(zeile,'                                            ')-1
      write(8,'(a)') zeile(:ind)
      if(index(zeile,'CIndex [').ne.0) go to 72
      if(index(zeile,'color Color { color [').eq.0) go to 61
      do i=1,np
        read(7,*)  r
        if(isz(i)) write(8,'(3f7.3,1h,)') r
      end do
71    read(7,'(a)') zeile
      ind=index(zeile,'                                            ')-1
      write(8,'(a)') zeile(:ind)
      if(index(zeile,'CIndex [').eq.0) go to 71
72    print *,'Vertices reduced from',np,' to',l
      print *,'by Short_wrl, a program from COSMOlogic ',
     &      '(www.cosmologic.de)'
73    read(7,'(a)') zeile 
      if (index(zeile,']').ne.0) then
        ind=index(zeile,
     &    '                                            ')-1
        write(8,'(a)') zeile(:ind)
        go to 81
      endif
      read(zeile,*)  i1,i2,i3
      write(8,'(3(i7,1h,)3h-1,)') id(i1+1),id(i2+1),id(i3+1)
      goto 73
81    read(7,'(a)',end=91) zeile
      ind=index(zeile,'                                            ')-1
      write(8,'(a)') zeile(:ind)
      if(index(zeile,'CIndex [').eq.0) go to 81
82    read(7,'(a)') zeile 
      if (index(zeile,']').ne.0) then
        ind=index(zeile,
     &    '                                            ')-1
        write(8,'(a)') zeile(:ind)
        go to 83
      endif
      read(zeile,*)  i1,i2,i3
      write(8,'(3(i7,1h,)3h-1,)') id(i1+1),id(i2+1),id(i3+1)
      goto 82
83    read(7,'(a)',end=91) zeile
      ind=index(zeile,'                                            ')-1
      write(8,'(a)') zeile(:ind)
      goto 83
91    end

C This soubroutine reads in information from {}.out files 
C of CPMD (car-parrinello molecular dynamics code) of J.Hutter et al.
C This module has been written by TEODORO LAINO 
C NEST Laboratories - INFM - Scuola Normale Superiore - Sept 2002
C Distributed with the permission of TEODORO LAINO

      subroutine rdcpmddd(idebug,ibefo,istatio,ioxyz,irtype,ihsend,
     &                  istats,vectrs,vectrb,focc,focb,eiga,eigb,
     &                  nocc,nocb,ncols,ncolb)

c THIS IS REALLY cpmd subroutine interface to molden

      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line
      real eiga,eigb
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*)

      istats = 1
      ioxyz = 1
      istatio = 0
      iuhf = 0

      if (idebug.eq.1) write(iun3,'(a)')'subroutine rdcpmd'
c 
c..  CPMD gives information on number of populated states
c..
      call search(line,'NUMBER OF STATES:',istat)
      if (istat.eq.1) then 
         read(line(50:),*)norbs
         call search(line,'NUMBER OF ELECTRONS',istat)
         read(line(50:),*) xelec
         nelecs=int(xelec)
      endif   
      call rewfil

      if (norbs .gt. mxorb) then

c we'll never reach this condition with CPMD
c at least at the moment...
c Next thing to do is to read orbital information from restart file...

         call inferr('Exceeding MaxNum of Orbitals!',1)
         goto 1000
      endif

c==== Establish RUNTYPE  ====
C..
c.. ! irtype=3 ! MOLECULAR DYNAMICS
c.. ! irtype=2 ! OPTIMIZATION GEOMETRY
c.. ! irtype=1 ! OPTIMIZATION WAVEFUNCTION
c.. ! irtype=4 ! VIBRATIONAL ANALYSIS
c.. ! irtype=5 ! Reading just geometry ! Unknown flag
c..            ! Here you can add whatever you want to implement
c..
      call search(line,'MOLECULAR DYNAMICS',istat)
      if (istat.ne.0) then 
         irtype = 3

c In molecular dynamics you have to read coordinates from
c TRAJECTORY file and information from CPMD input file

      else 
         call rewfil
         call search(line,'GEOMETRY OPTIMIZATION',istat)
         if (istat.ne.0) then 
            irtype = 2

c In geometry optimization the coordinates and info must be
c read from input CPMD file

         else 
            call rewfil
            call search(line,'VIBRATIONAL ANALYSIS',istat)
            if (istat.ne.0) then 
               irtype = 4

c In vibrational analysis the normal coordinates must be read
c from MOLVIB file.

            else 
               call rewfil
               call searchd(line,'WAVEFUNCTION OPTIMIZATION',
     *              'PROPERTIES',istat)
               if (istat.ne.0) then 
                  irtype = 1

c In wavefunction optimization (single point) or properties 
c calculation we read just molecular geometry and display it!!

               else
                  call inferr('Reading just Geometry!',1)                  
                  irtype = 5
               endif
            endif
         endif
      endif
      
      call search(line,'END OF GEOMETRY OPTIMIZATION',istat)
      if (istat.eq.1) istatio = 1

      call rewfil
c
c==== First read coordinates 
c
      if (irtype.eq.1.or.irtype.eq.5) then
c
c ====== Stationary Point ================
c
         call rdcpmolu(istat)

         if (istat.eq.0) goto 1000 

         call xyzcoo(1,0,0)

      endif

      return

1000  istats = 0
      call inferr('ERROR reading CPMD output file!',1)
      return
      end


      subroutine rdcpmold(istats,coo,ianz)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000,mxel=100)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      common /athlp/  iatoms, mxnat
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      character*137 line,str
      integer getlin
      logical dobohr,docoo,excyc
      character elemnt*2
      common /elem/elemnt(mxel)
      dimension coo(3,*),ianz(*)
c
c====== read molecular geometry ==================
c
c     sline = search this line first
c     iemlin = then skip this many lines
c
      istats = 1
      toang = 0.52917706d0
      docoo = .false.
      dobohr = .false.

c      write(*,*)'debug: rdcpmolu!'
      call search(line,'********* ATOMS *********',istat)
      if (istat.eq.0) goto 1000
      call redel(line,1)

      if (docoo) then
         iatoms = 0
      else
         natoms = 0
      endif

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) return
         if (index(line,'********').ne.0) return
         if (docoo) then
            iatoms = iatoms + 1
         else
            natoms = natoms + 1
         endif
         ktype = nxtwrd(str,nstr,itype,rtype) 
         if (ktype.ne.2) goto 1000
         ktype = nxtwrd(str,nstr,itype,rtype) 
         if (ktype.ne.1) goto 1000

         indexb = index(str(1:2),' ')
c         write(*,'(A,4I5)')str(1:2),ichar(str(1:1)),ichar(str(2:2)),
c     &        ichar(' '),indexb
         if (indexb.eq.2) str = ' '//str
         itype = 0
         excyc = .false.
         do while (.not.excyc)
            itype = itype + 1
c            write(*,'(2A)')str(1:2),elemnt(itype)
            if (index(str(1:2),elemnt(itype)).ne.0) excyc = .true.
            if (itype.gt.mxel) then
               write(*,'(A)')'Error determining atomic number!'
               goto 1000
            endif
         end do

c itype atomic number

         if (docoo) then
            ianz(iatoms) = itype
         else
            nat(natoms) = itype
         endif

         do i=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 1000
            if (dobohr) rtype = rtype / toang
            if (docoo) then
               coo(i,iatoms) = rtype
            else
               xyz(i,natoms) = rtype
            endif
         end do
      end do

1000  istats = 0
      call inferr('CPMD: ERROR reading molecular geometry!',1)
      stop
      return
      end

      subroutine cpmdpd(ipnt,istat,coo,ianz)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (maxfat=1000)
      parameter (mxel=100)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat
      integer getlin
      logical excyc
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*137 line,str
      common /curlin/ line
      character elemnt*2
      common /elem/elemnt(mxel)
      dimension coo(3,*),ianz(*)
c
c     Read Next Point in geometry optimization
c
      toang=0.52917706d0
      iatoms = 0
      jatoms = 0

      call search(line,
     &     'ATOM          COORDINATES                GRADIENTS',
     &     istat)

      if (istat.eq.0) return

      call haszm(.false.)

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) return
         if (index(line,'********').ne.0) return
         iatoms=iatoms+1
         jatoms=jatoms+1
         ktype = nxtwrd(str,nstr,itype,rtype) 
         if (ktype.ne.2) goto 1000
         ktype = nxtwrd(str,nstr,itype,rtype) 
         if (ktype.ne.1) goto 1000

         indexb = index(str(1:2),' ')
         if (indexb.eq.2) str = ' '//str
         itype = 0
         excyc = .false.
         do while (.not.excyc)
            itype = itype + 1
            if (index(str(1:2),elemnt(itype)).ne.0) excyc = .true.
            if (itype.gt.mxel) then
               write(*,'(A)')'Error determining atomic number!'
               goto 1000
            endif
         end do

c itype atomic number

         ianz(iatoms) = itype

c read geometries...

         do i=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 1000
            coo(i,iatoms) = rtype 
         end do

c read gradients...

         do i=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 1000
            fxyz(i,jatoms) = rtype
         end do
      end do
      
      return

1000  istat = 0
      return

      end

      subroutine geocpmd(formax,forrms,dismax,disrms,epoints,isav,
     &                   istatc)
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character lstr*137
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

      istatc = -1
c
c     Read Geometry Convergence data
c
      call rewfil
      igcvav = 1
      ifmxav = 1
      ifrmav = 1
      idmxav = 0
      idrmav = 0
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0

      i = 0
      do while (.true.)
         call search(lstr,' GEOMETRY STEP NR. ',istat)
         if (istat.eq.0) goto 100
         i = i + 1
         if (i.le.mxpnt) then
            ngeoms =  ngeoms + 1
            isav(i) = 1
 
            call nxtlin(lstr,jstat)
            i1 = index(lstr,'ETOT=')
            epoints(i) = reada(lstr,i1+6,len(lstr))
            i1 = index(lstr,'GNMAX=')
            formax(i) = reada(lstr,i1+7,len(lstr))
            call nxtlin(lstr,jstat)
            i1 = index(lstr,'GNORM=')
            forrms(i) = reada(lstr,i1+7,len(lstr))
c            write(*,*)epoints(i),formax(i),forrms(i)
         else
            istatc = i
         endif
      end do

100   continue
      if (ngeoms.eq.0) then
          igcvav = 0
          ifmxav = 0
          ifrmav = 0
          idmxav = 0
          idrmav = 0
          ieav = 0
      else
          nepnts = ngeoms
      endif

      return
      end

      subroutine cnvcpmd
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      common /curlin/ line
      character*137 line,str
      integer getlin
      logical last,datlin

c
c     Read Scf Convergence data type... In cpmd we don't have
c     a real scf calculation but an optimization of the wavefunction
c     Here we read how energy and gradient of WF converges...
c
      call rewfil
      icvav1 = 1
      icvav2 = 1

      call searchd(line,' NFI      GEMAX',' ETOT        DETOT',istat)
      if (istat.eq.0) goto 1000

      jstrt1 = 0

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) goto 100
         indiis = index('ODIIS|',line)
         if (indiis.eq.0) then
            if (datlin(line)) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.ne.2) goto 1000
               jend1 = itype
               if (jend1.gt.MAXITER) then
                  write(*,'(a)')'Reached maximum number of iterations!'
                  goto 100
               endif
               do i=1,3
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if ((ktype.eq.3).and.(i.eq.3)) then
                     convg1(jend1) = rtype
                  endif
               end do
               if (jstrt1.eq.0) jstrt1 = jend1
            endif
         endif 
      end do

100   continue

      last = .false.

c we try to understand how many WFoptimization have been performed...

      NUMOPT = 0
      do while (istat.ne.0)
         NUMOPT = NUMOPT+1
         call search(line,' GEOMETRY STEP NR.',istat)
      end do
      
      NUMOPT = NUMOPT - 2
      IF (NUMOPT.lt.0) goto 2000 

      call rewfil
      do i=1,NUMOPT
         call search(line,' GEOMETRY STEP NR.',istat)
      end do

      do i=1,4 
         call nxtlin(line,jstat)
      end do

c     there could be somethingelse appended to file 
c     before wavefunction optimization cycle 
      call checkdummylines_scf(iun2,istat)

      if (istat.eq.0) goto 2000

      last = .true.
      jstrt2 = 0

      do while (getlin(0).eq.1)
         if (linlen(line).le.1) goto 2000
         indiis = index('ODIIS|',line)
         if (indiis.eq.0) then
            if (datlin(line)) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.ne.2) goto 2000
               jend2 = itype
               if (jend2.gt.MAXITER) then
                  write(*,'(A)')'Reached maximum number of iterations!'
                  goto 999
               endif
               do i=1,3
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if ((ktype.eq.3).and.(i.eq.3)) then
                     convg2(jend2) = rtype
                  endif
               end do
               if (jstrt2.eq.0) jstrt2 = jend2
            endif
         endif 
      end do

 999  continue

      return

1000  icvav1 = 0
      icvav2 = 0
      return

2000  if (.not.last) then
         icvav2 = 0
      endif

      return

      end

      subroutine cpmdgetfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      common /curlin/ line
      character*137 line,str
      integer getlin
      dimension coo(3,*)

      istat = 1

      ivibs = 0
      ihasi = 0
      idirct = 1
      nframe = 5
      iframe = 0
      call rewfil

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
	  fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in CPMD  Frequencies

      call search(line,'PURIFICATION OF DYNAMICAL MATRIX',istat)
      if (istat.eq.0) goto 100
      call redel(line,4)
 10   if (getlin(0).eq.0) goto 100
      do i=1,4
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3.and.ktype.ne.0) then
            write(*,'(A,I6)')'Number of vibrational frequencies read: ',
     &           ivibs
            goto 200
         elseif (ktype.eq.0) then
            goto 100
         else
            ivibs = ivibs + 1
            freq(ivibs) = rtype 
         endif
      end do
20    continue
      goto 10

100   if (ivibs.eq.0) istat = 0

      nfreq = ivibs
      call parptr(1,freq,freq,nfreq)

      return

 200  call inferr('Error reading CPMD frequencies!',1)
      istat=0
      return
      end 

      subroutine cpmdcoorg(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /curlin/ line
      character*137 line,str
      integer getlin

c     Get ifreq 'th Norm. Cordinates from CPMD MOLVIB FILE...

      iunt = iun2
      iun2 = iun5
      ncol = 8
      istat = 1
      call iatnox(iatoms)
      ndim = iatoms*3
      call rewfil

      call search(line,'>>>>>>> NEW SET',istat)
      if (istat.eq.0) goto 1000

c     columns have been stored in order of 8 eigenvectors...

      n1 = ifreq/ncol
      n2 = mod(ifreq,ncol)
      if (n2.eq.0) then 
         n1 = n1 - 1
         n2 = ncol
      endif

      numjump = ((iatoms*3)+3)*n1
      do i=1,numjump
         call nxtlin(line,jstat)
      end do
c
      do i=1,3
         call nxtlin(line,jstat)
      end do

c     put the pointer at the beginning of the data file...

      do i=1,iatoms
         do k=1,3
            if (getlin(0).eq.0) goto 1000
            do j=1,n2
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.ne.3) goto 1000
            enddo
            a(k,i) = rtype
         end do
      end do
     
      if (idebug.eq.1) call prtfr(ifreq)
      iun2 = iunt
      return

1000  istat = 0
      call inferr('Error reading Norm. Coords. in MOLVIB!',0)
      iun2 = iunt
      return
      end


      subroutine dyncpdd(ipoints,isav,epoints)
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character lstr*137,line*137
      common /curlin/ line
      dimension epoints(*),isav(*)

c
c     Read Molecular Dynamics data
c
      call rewfil
      ipoints = 0
      nread = 6
      igcvav = 1
      ieav = 1
      nepnts = 0
      ngeoms = 0
      ifmxav = 0
      ifrmav = 0
      idmxav = 0
      idrmav = 0

      call search(lstr,
     &     'NFI    EKINC   TEMPP           EKS      ECLASSIC    ',istat)
      
      do i=1,mxpnt
10       call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 100
         leng=linlen(line)
         ktype = nxtwrd(lstr,nstr,itype,rtype)
         if (leng.eq.0) goto 100
         if (ktype.ne.2) goto 10
         if (i.ne.itype) goto 1000
         isav(i) = 1
         ngeoms =  ngeoms + 1
         do j=2,nread
            ktype = nxtwrd(lstr,nstr,itype,rtype)
         end do
         if (ktype.ne.3) goto 100
         epoints(i) = rtype
      end do

100   continue
      if (ngeoms.eq.0) then
          igcvav = 0
          ifmxav = 0
          ifrmav = 0
          idmxav = 0
          idrmav = 0
          ieav   = 0
      else
          nepnts = ngeoms
      endif

      ipoints = ngeoms
      return

 1000 call inferr('Error reading molecular dynamics data!',0)
      return

      end

      subroutine cpmdptdyd(ipnt,istat,coo)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (maxfat=1000)
      parameter (mxel=100)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat
      integer getlin
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*137 line,str
      common /curlin/ line
      character elemnt*2
      common /elem/elemnt(mxel)
      dimension coo(3,*)
c
c     Read Next Point in geometry optimization
c
      toang=0.52917706d0
      call rewfil

      call search(line,'NEW',istat)

      if (istat.eq.0) call rewfil
      numlinetojump = iatoms*(ipnt-1)
      do i=1,numlinetojump
         call nxtlin(line,jstat)
      end do

      call haszm(.false.)

      do i=1,iatoms
         if (getlin(0).eq.0) return
         if (linlen(line).le.1) return
         ktype = nxtwrd(str,nstr,itype,rtype) 
         if (ktype.ne.2) goto 1000

c read geometries...

         do j=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 1000
            coo(j,i) = rtype 
         end do
      end do
      
      return

1000  istat = 0
      return
      end

      subroutine wrcpdd(iun,ianz,coo,
     &                  nat,icel,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (numat1=20000)
      parameter (mxel=100)
      parameter (mxsg=238)
      common /athlp/ iatoms, mxnat
      character*7 spnam
      common /spgrnm/ spnam(mxsg)
      character*2 elemnt,tocapf
      common /elem/elemnt(mxel)
      character*80 pseudopot,string
      dimension iatomdone(numat1),ianz(*),coo(3,*)

      toang = 0.52917706d0
      torad = datan(1.0d0) / 45.0d0

      do i=1,iatoms
         iatomdone(i)=0
      end do

      if (icel.ne.1) then
         call inferr('No Cell Data !',0)
         return
      endif

      call fdat(2,0,0,0,0,0)

      nstor = mxnat-nat
      pseudopot='_Pseudopotential KLEINMAN-BYLANDER'
      dalp = alpha
      dbet = beta
      dgam = gamma
c     dump input to file cpmd.inp
      write(iun,'(a/)') 
     &     '# Car-Parrinello Molecular Dynamics Input File. '
      write(iun,'(A)')'&CPMD'
      write(iun,'(A)')' MOLECULAR DYNAMICS'
      write(iun,'(A)')' QUENCH BO '
      write(iun,'(A)')' MAXSTEP'
      write(iun,'(A)')' 10'
      write(iun,'(A)')' EMASS'
      write(iun,'(A)')' 280.'
      write(iun,'(A)')' SCALED MASSES'
      write(iun,'(A)')' TIMESTEP '
      write(iun,'(A)')' 6.'
      write(iun,'(A)')' ISOLATED MOLECULE'
      write(iun,'(A/)')'&END'
      write(iun,'(A)')'&SYSTEM'
      write(iun,'(A)')' SYMMETRY'
      write(iun,'(A)')'  0'
      write(iun,'(A)')' CELL'
      write(iun,'(1x,3(f7.4,4x),3(f7.2,4x))') a/toang,b/a,c/a,
     &     dcos(dalp),dcos(dbet),dcos(dgam)
      write(iun,'(A)')' CHARGE'
      write(iun,'(A)')' 0 '
      write(iun,'(A)')' CUTOFF'
      write(iun,'(A)')' 60'
      write(iun,'(A/)')'&END'
      write(iun,'(A)')'&DFT'
      write(iun,'(A)')' FUNCTIONAL BLYP'
      write(iun,'(A)')' NEWCODE'
      write(iun,'(A/)')'&END'
      write(iun,'(A)')'&ATOMS'
c     scrittura della geometria molecolare....
      natoms=iatoms-8 

      do i=1,natoms
         if (iatomdone(i).eq.0) then
c     count how many elements of this kind we have...
            tocapf = elemnt(ianz(i))    
            numatkind = 1
            do j=i+1,natoms
               jj = ianz(j)
               if (tocapf(1:2).eq.elemnt(jj)(1:2)) numatkind=numatkind+1
            end do

c            print *,numatkind,natoms
c     now we write what we have to....

            indb = 1
            if (tocapf(1:1).eq.' ') indb = 2
            string = '*'//tocapf(indb:2)//pseudopot
            write(iun,'(a)')string
            if (tocapf.ne.' H') then
               write(iun,'(a)')' LMAX=P'
            else
               write(iun,'(a)')' LMAX=S'
            endif
            write(iun,'(i4)') numatkind
            do j=i,natoms
               jj=ianz(j)
               if (tocapf(1:2).eq.elemnt(jj)(1:2)) then
                  iatomdone(j)=1
                  write(iun,'(2x,3f12.6,i10)')(coo(k,j),k=1,3),j
               end if
            end do
            write(iun,'(a)')' ' 
         endif
      end do
      write(iun,'(a)')'&END'

      call inferr('Wrote file: cpmd.inp',0)      
      return
      end

      subroutine cpmdceld(nspg, 
     &                    xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (mxsg=238)
      character*137 line
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*7 spnam
      common /spgrnm/ spnam(mxsg)
      common /curlin/ line
      logical pbcon
      character*137 string

      pbcon=.true.
      toang   = 0.52917706d0
      toangle = 45.d0/datan(1.d0)
      istat = 1
      call rewfil

c     In the future fix this approximation...

      nspg = 1
      write(*,'(2A)')'CPMD interface can, at the moment,  work',
     &     ' only with P1 point group!'

      call search(line,'CELL DIMENSION:',istat)
      if (istat.eq.0) goto 100

      ind1=index(line,'CELL DIMENSION:')
      line=line(ind1+16:)
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.eq.3) a = rtype
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.eq.3) b = rtype * a
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.eq.3) c = rtype * a
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.eq.3) alpha = acos(rtype)*toangle
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.eq.3) beta = acos(rtype)*toangle
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.eq.3) gamma = acos(rtype)*toangle

      call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,1)

      return

100   istat = 0
      call inferr('cpmdcell: error reading cell parameter.',0)
      return
      end

      subroutine checkdummylines_scf(iun2,istat)
      implicit double precision(a-h,o-z)
      common /curlin/ line
      character*137 line,string


5     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.ne.2) goto  5
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.ne.3) goto  5
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.ne.3) goto  5
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.ne.3) goto  5
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.ne.3) goto  5
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.ne.3) goto  5
      ktype = nxtwrd(string,nstr,itype,rtype)
      if (ktype.ne.0) goto  5

      call bckfil
      istat = 1
      return

 100  continue
      istat = 0
      return
      end

      subroutine rdnwcd(idebug,irtype,istats,
     &                 ianz,iatoms,focc,focb,nocc,nocb,ncols,ncolb,coo)

c THIS IS REALLY rdnwch

      implicit double precision ( a-h,o-z)
      parameter (numat1=20000)
      parameter (mxonh=100)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      integer getlin
      logical gnreal
      common /qmchar/ qch(numat1),ihasesp
      character*137 line,cline
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      character*2 elemnt,tstr,str,tocapf
      common /elem/elemnt(mxel)
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      common /pntlin/ lpnt(MAXPNT)
      common /ecce/ iecce,imod
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      dimension focc(*),focb(*),ianz(*)
      dimension r(3),coo(3,*)

      istats = 1
      irtype = 0
      istatio = 0
      toang=0.52917706d0
      irtype = 1
      ihbas = 0
      ihorb = 0
      ioni = 0
      do i=1,MAXPNT
         lpnt(i) = -1
      end do

      if (iecce.eq.1) then
         imod = 0
         rewind(iun2)
         call entag(idebug,istat)
         if (natoms.eq.0) return
         iatoms = natoms
         rewind(iun2)
         call enchg(istat)
         rewind(iun2)
         ipnt = nwpnts(imod)
         rewind(iun2)
         call enwxyz(0,ipnt,imod,istat)

         natoms = 0
         do i=1,iatoms
            if (ianz(i).ne.99) then
               natoms = natoms + 1
               nat(natoms) = ianz(i)
               do j=1,3
                  xyz(j,natoms) = coo(j,i)
               end do
            endif
         end do

         call search(line,'basis \"ao basis\" cartesian',istat)
         call rdbas(idebug,3,istat)
         if (idebug.eq.1) call basprt(iun3,.false.,.false.)
         if (istat.eq.0) then
            print*,line
            call inferr('Error reading Basis set',1)
            goto 1000
         endif

         call norml
         isgau = 1

         call rdvct(idebug,istat)

         call rewfil

         irtype = 1
         call search(line,'task_hessian%begin%frequencies',istat)
         if (istat.ne.0) irtype = 4

         call rewfil

         call enmull(idebug,istat)

      else

         call rewmf

         call srctmf(line,'XYZ format geometry',
     &                    'number of quantum atoms',
     &                    'No. of atoms     :',
     &                     istat)
         if (istat.ne.0) then
            if (icdex(line,'quantum').ne.0) then
               natoms = dint(reada(line,25,len(line)))
            else if (icdex(line,'No.').ne.0) then
               natoms = dint(reada(line,29,len(line)))
            else
               call redel(line,2)
               natoms = dint(reada(line,1,len(line)))
            endif
         endif

         call rewmf
         irtype = 1
         call srcdmf(line,'NWChem Geometry Optimization',
     &                 'NWChem Nuclear Hessian and Frequency',istat)
         if (istat.ne.0) then
            irtype = 2
            if (icdex(line,'Frequency').ne.0) irtype = 4
         else
            call rewmf
         endif

         if (irtype.eq.1) then
            ipnt = 1
            call nwxyz(idebug,ipnt,istat)
         elseif (irtype.eq.4) then
            ipnt = 1
            call fnwxyz(idebug,istat)
         elseif (irtype.eq.2) then
            ipnt = 1
            do while(.true.)
               call nwxyz(idebug,ipnt,istat)
               if (istat.eq.0) goto 50
               ipnt = ipnt + 1
            end do
50          continue
         endif

         call rewmf
         call srchmf(line,'Chemical Shielding Tensors',istat)
         if (istat.ne.0) then
            call bckfil
            call nmcshl
         endif

      endif

      if (idebug.eq.1) 
     &         call inferr('Succesfully read NWchem output',0)

      return

1000  if (idebug.eq.1) 
     &         call inferr('Error reading NWchem output!',1)
      istats = 0
      return

      end

      subroutine enchg(istat)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /athlp/  iatoms, mxnat
      integer getlin
      character*137 line
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5

      istat = 1

      nelecs = 0
      do i=1,natoms
          nelecs =  nelecs + nat(i)
      end do

      call search(line,'%begin%input file',istats)
      if (istats.ne.1) goto 100

      do while (.true.)

       if (getlin(1).eq.1) then
             if (icdex(line,'%end%input file').ne.0) return
             if (icdex(line,'charge ').ne.0) then
                 line = line(8:)
                 nchg = reada(line,1,len(line))
                 nelecs =  nelecs - nchg
             endif
       else
          goto 100
       endif

      end do

      return

 100  istat = 0
      return
      end

      subroutine entad(idebug,istat,ianz)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /molhlp/ katoms, kat(numatm)
      common /athlp/  iatoms, mxnat
      integer getlin
      character*137 line
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*2 elemnt,tstr,str,tocapf
      common /elem/elemnt(mxel)
      common /ecce/ iecce,imod
      dimension ianz(*)

      istat = 1
      imod = 0
      call search(line,'%begin%atomic tags',istats)
      if (istats.ne.1.and.iecce.eq.1) then
         call search(line,'%begin%input file',istats)
         if (istats.eq.1) then
            call search(line,'geometry',istats)
            if (istats.eq.1) then
               imod = 1
            else
               print*,"NO geometry FOUND,"//
     &                "VERSION of ECCE NOT SUPPORTED"
               return
            endif
         else
            print*,"NO %begin%input file FOUND,"//
     &             "VERSION of ECCE NOT SUPPORTED"
            return
         endif
      endif

      natoms = 0
      katoms = 0

      do while (.true.)

       if (getlin(1).eq.1) then

             if (imod.eq.1) then
                if (icdex(line,'end').ne.0) return
             else
                if (icdex(line,'%end%atomic tags').ne.0) return
             endif

             natoms = natoms + 1
             katoms = katoms + 1
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.1) then
                if (nstr.eq.1) then
                   tstr(2:2) = str(1:1)
                   tstr(1:1) = ' '
                elseif (nstr.eq.2) then
                   tstr(1:2) = str(1:2)
                endif
                do k=1,mxel
                   if (tocapf(tstr).eq.tocapf(elemnt(k))) then
                      if (k.eq.99) then
                         natoms = natoms -  1
                         kat(katoms) = -1
                      else
                         nat(natoms) = k
                         kat(katoms) = 1
                      endif
                   endif
                end do
                ianz(natoms) = nat(natoms)
             else
                goto 100
             endif
        endif
      end do

      return

 100  istat = 0
      return
      end

      subroutine enmuld(idebug,istat,qat)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /molhlp/ katoms, kat(numatm)
      integer getlin
      character*137 line
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*2 elemnt,tstr,str,tocapf
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      dimension qat(*)

      istat = 1
      call search(line,'%begin%total mulliken atomic charges',
     &            istats)
      if (istats.ne.1) goto 100

      ihasq = 1

      i = 0
      ii = 0
      do while (.true.)

10     if (getlin(1).eq.1) then

          if (icdex(line,'%end%total mulliken').ne.0) return

          do while (.true.)
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                i = i + 1
                if (kat(i).ne.-1) then
                   ii = ii + 1
                   qat(ii) = rtype
                endif
             else if (ktype.eq.0) then
                goto 10
             else
                goto 100
             endif
          end do
        endif
      end do

      return

 100  istat = 0
      return
      end

      integer function nwpnts(imod)
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
      character*137 line
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5

      rewind(iun2)

      nwpnts = 0
      if (imod.eq.0) then
         do while (.true.)
            call search(line,'%begin%cartesian coordinates',istat)
            if (istat.ne.1) then
               return
            else
               nwpnts = nwpnts + 1
            endif
         end do
      endif

      return
      end

      subroutine enwxyd(idebug,ipnt,imod,istat,
     &                  ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      integer getlin
      logical gnreal
      character*137 line,lline,str
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /molhlp/ katoms, kat(numatm)
      common /athlp/  iatoms, mxnat
      common /coord / xyz(3,numatm)
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*2 elemnt,tstr,tocapf
      common /elem/elemnt(mxel)
      dimension r(3),coo(3,*),ianz(*)

      toang=0.52917706d0
      istat = 1
      call haszm(.false.)


      if (idebug.eq.1)  print*,'coordinates'

      if (imod.eq.0) then
         do i=1,ipnt
            call search(line,'%begin%cartesian coordinates',istat)
            if (istat.ne.1) goto 100
         end do
      else if (imod.eq.1) then
         call search(line,'%begin%input file',istat)
         if (istat.eq.0) goto 100
         call search(line,'geometry',istat)
         if (istat.eq.0) goto 100
      endif

      ii = 0
      do i=1,katoms
          if (getlin(1).eq.1) then
             if (imod.eq.1) then
                ktype = nxtwrd(str,nstr,itype,rtype)
             endif
             if (kat(i).ne.-1) then
                ii = ii + 1
                if (gnreal(r,3,.false.)) then
                   do j=1,3
                       coo(j,ii) = r(j) / toang
                   end do
                else
                   goto 100
                endif
             endif
          else 
             goto 100
          endif
      end do

      return

100   istat = 0

      call rewfil
      return

      end

      subroutine nwxyd(idebug,ipnt,istat,
     &                 ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      integer getlin
      logical gnreal
      character*137 line,lline,str
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /athlp/  iatoms, mxnat
      common /coord / xyz(3,numatm)
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*2 elemnt,tstr,tocapf
      common /elem/elemnt(mxel)
      common /pntlin/ lpnt(MAXPNT)
      common /pntcnv/ icv(MAXPNT)
      integer getmf
      dimension r(3),coo(3,*),ianz(*)

      toang=0.52917706d0
      istat = 1
      call haszm(.false.)

      if (lpnt(ipnt).ne.-1) then
         call putmf(lpnt(ipnt))
      else
         icv(ipnt) = 0
         call rewmf
         do i=1,ipnt
             call srchmf(line,'Output coordinates',istats)
             if (icdex(line,'angstroms').ne.0) icv(ipnt) = 1
             if (istats.eq.0) goto 100
             lpnt(ipnt) = getmf() + 1
         end do
      endif

      if (icv(ipnt).eq.0) toang = 1.0d0
      if (idebug.eq.1)  print*,'coordinates'

      do i=1,3
         call rdmf(line,lline,istat)
      end do

      do i=1,natoms
          if (getlin(1).eq.1) then
                ktype = nxtwrd(str,nstr,itype,rtype)
                ktype = nxtwrd(str,nstr,itype,rtype)
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then
                   nat(i) = dint(rtype)
                   ianz(i) = nat(i)
                else
                   goto 100
                endif

                if (gnreal(r,3,.false.)) then
                   if (idebug.eq.1)  then
                       print*,elemnt(nat(i)),(r(j),j=1,3)
                   endif
                   do j=1,3
                       xyz(j,i) = r(j) / toang
                       coo(j,i) = xyz(j,i)
                   end do
                else
                   goto 100
                endif
          else 
             goto 100
          endif
      end do

      iatoms = natoms

      return

100   istat = 0
      call rewmf
      return

      end

      subroutine fnwxyd(idebug,istat,
     &                  ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      parameter (maxfat=1000)
      integer getlin
      logical gnreal
      character*137 line,lline,str
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /athlp/  iatoms, mxnat
      common /coord / xyz(3,numatm)
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character*2 elemnt,tstr,tocapf
      common /elem/elemnt(mxel)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat)
      integer getmf
      dimension r(3),coo(3,*),ianz(*)

      toang=0.52917706d0
      istat = 1
      call haszm(.false.)

      call rewmf
      call srchmf(line,'Atom information',istats)
      if (istats.eq.0) goto 100

      call redel(line,2)

      natoms = 0 
      do while (.true.)
          if (getlin(1).eq.1) then
                if (line(2:6).eq.'-----') goto 200

                natoms = natoms + 1
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) then
                   if (nstr.eq.1) then
                      tstr(2:2) = str(1:1)
                      tstr(1:1) = ' '
                   elseif (nstr.eq.2) then
                      tstr(1:2) = str(1:2)
                   endif
                   do k=1,mxel
                      if (tocapf(tstr).eq.tocapf(elemnt(k))) then
                         nat(natoms) = k
                      endif
                   end do
                   ianz(natoms) = nat(natoms)
                else
                   goto 100
                endif

                ktype = nxtwrd(str,nstr,itype,rtype)

                if (gnreal(r,3,.false.)) then
                   if (idebug.eq.1)  then
                       print*,elemnt(nat(natoms)),(r(j),j=1,3)
                   endif
                   do j=1,3
                       xyz(j,natoms) = r(j) / toang
                       coo(j,natoms) = xyz(j,natoms) * toang
                   end do
                else
                   goto 100
                endif
          else 
             goto 100
          endif
      end do

200   continue

      iatoms = natoms

      return

100   istat = 0
      call rewmf
      return

      end

      subroutine egeonw(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character*137 line,str
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      integer getlin
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

      call rewfil

      igcvav = 1
      ifmxav = 1
      ifrmav = 1
      idmxav = 1
      idrmav = 1
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0

      do while(.true.)

         call search(line,'task_gradient%begin%total energy',istats)
         if (istats.ne.1) goto 100

         if (getlin(1).ne.1) goto 100

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            ngeoms = ngeoms + 1
            epoints(ngeoms) = rtype
         else
            goto 100
         endif
         

         call search(line,'%begin%gradient norm',istats)
         if (istats.ne.1) goto 100

         if (getlin(1).ne.1) goto 100

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            forrms(ngeoms) = rtype
         else
            goto 100
         endif
         
         call search(line,'%begin%gradient max',istats)
         if (istats.ne.1) goto 100

         if (getlin(1).ne.1) goto 100

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            formax(ngeoms) = rtype
         else
            goto 100
         endif
         
         isav(ngeoms) = 1
      end do

100   nepnts = ngeoms

      return
      end

      subroutine geonwc(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character*137 line,str
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      integer getlin
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

      call rewmf

      igcvav = 1
      ifmxav = 1
      ifrmav = 1
      idmxav = 1
      idrmav = 1
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0

      do while(.true.)

         call srcdmf(line,'@ Step       Energy',
     &                    '  Step       Energy',istats)
         if (istats.ne.1) goto 100
         call redel(line,1)
         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            if (itype.lt.mxpnt) then
               ngeoms = itype + 1
            else
            endif
         else
            goto 100
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            epoints(ngeoms) = rtype
         else
            goto 100
         endif
         
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            formax(ngeoms) = rtype
         else
            goto 100
         endif
         
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            forrms(ngeoms) = rtype
         else
            goto 100
         endif
         
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            disrms(ngeoms) = rtype
         else
            goto 100
         endif
         
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            dismax(ngeoms) = rtype
         else
            goto 100
         endif
         
         isav(ngeoms) = 1
      end do

100   nepnts = ngeoms

      return
      end

      subroutine cnvnwc
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      character*137 line,str
      common /curlin/ line
      integer getlin

      call rewmf

      icvav1 = 0
      icvav2 = 0
      jstrt1 = 1
      jstrt2 = 1
      jend1 = 0
      jend2 = 0
      ifrst = 1


c     SCF convergence 

      do while(.true.)
         call srchmf(line,'SCF ITERATIONS',istat)
         if (istat.eq.0) goto 100
         if (getlin(1).ne.1) goto 100
         if (getlin(1).ne.1) goto 100
         do while(.true.)
            if (ifrst.eq.1.and.jend1.ge.MAXITER) goto 10
            if (ifrst.eq.0.and.jend2.ge.MAXITER) goto 100
            if (getlin(1).ne.1) goto 100
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.0) then
                goto 10
            else
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.3) then
                  if (ifrst.eq.1) then
                      jend1 = jend1 + 1
                      convg1(jend1) = rtype
                  else 
                      jend2 = jend2 + 1
                      convg2(jend2) = rtype
                  endif
               endif
            endif
         end do
10       if (ifrst.eq.1) then
            ifrst = 0
            icvav1 = 1
         else
            icvav2 = 1
         endif
      end do

100   return
      end

      subroutine ecvnwc
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      character*137 line,str
      common /curlin/ line
      integer getlin

      call rewfil

      icvav1 = 0
      icvav2 = 0
      jstrt1 = 1
      jstrt2 = 1
      jend1 = 0
      jend2 = 0
      ifrst = 1
      ione = -1


c     SCF convergence 

      do while(.true.)
10       call searchd(line,'scf%begin%total energy',
     &                     '%begin%one-electron energy',istat)
         if (istat.eq.0) goto 100

         if (icdex(line,'one-electron').ne.0) then
            if (ifrst.eq.1) then
               ifrst = 0
               icvav1 = 1
            else
               ione = 1
               icvav2 = 1
               goto 10
            endif
         endif

         if (icdex(line,'total energy').ne.0) then
            if (ifrst.eq.0) then
               if (ione.eq.1) jend2 = 0
               ione = -1
            endif
         endif

         if (getlin(1).ne.1) goto 100
         if (ifrst.eq.1.and.jend1.ge.MAXITER) goto 100
         if (ifrst.eq.0.and.jend2.ge.MAXITER) goto 100

         ktype = nxtwrd(str,nstr,itype,rtype)

         if (ktype.eq.3) then
             if (ifrst.eq.1) then
                jend1 = jend1 + 1
                convg1(jend1) = rtype
             else 
                jend2 = jend2 + 1
                convg2(jend2) = rtype
             endif
         else
             goto 100
         endif


      end do

100   return
      end

      subroutine getnfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*137 line,str
      common /curlin/ line
      integer getlin
      dimension coo(3,*)

      istat = 1

      ivibs = 0
      ihasi = 0
      idirct = 1
      nframe = 5
      iframe = 0
      call rewmf

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in NWchem Frequencies

      nvibs = 3*natoms - 6
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1

      call srchmf(line,'Eckart algorithm',istat)
      if (istat.eq.0) goto 10
      call srchmf(line,'NORMAL MODE EIGENVECTORS',istat)
      if (istat.eq.0) goto 10

      call srchmf(line,'Infra Red Intensities',istat)
      if (istat.eq.0) goto 10
      if (getlin(1).ne.1) goto 100
      if (getlin(1).ne.1) goto 100

      do i=1,natoms*3
         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            ivibs = ivibs + 1
            freq(ivibs) = rtype
         else
            goto 100
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            ihasi = 1
            frint(ivibs) = rtype
         else
            goto 100
         endif
      end do

10    nfreq = ivibs
      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)

      do i=1,6
         frint(i) = 0.0d0
      end do

      return

100   istat = 0
      return
      end 

      subroutine nwcord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr
      character*2 gstr
      character*4 tstr
      real freqt
      dimension freqt(9)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      dimension r(3)

c     Get ifreq 'th Norm. Cordinates from NWchem Output

      istat = 1

      call rewmf
      call iatnox(iatoms)
      nvibs = nfreq

      ioff = ifreq - ((ifreq-1)/6)*6
      call srchmf(line,'Eckart algorithm',istat)
      if (istat.eq.0) goto 100
      call srchmf(line,'NORMAL MODE EIGENVECTORS',istat)
      if (istat.eq.0) goto 100

      call redel(line,3)

      ivibs = 0
      do while(.true.)
         call redel(line,1)
         if (ivibs.gt.nvibs) goto 20
         if (linlen(line).le.1) goto 20
         
         tstr = ' '//gstr(ifreq)//' '

         if (index(line,tstr).ne.0) then
             call redel(line,3)
             do i=1,iatoms
                do j=1,3
                    call nxtlin(line,jstat)
                    read(line,'(12x,6f12.5)',err=100,end=100) 
     &                   (freqt(k),k=1,6)
                    a(j,i) = freqt(ioff)
                end do
             end do
         else
             call redel(line,3)
             call redel(line,iatoms*3)
         endif
         call redel(line,1)
         ivibs = ivibs + 6
      end do

20    if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine egtnfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*137 line,str
      common /curlin/ line
      integer getlin
      dimension coo(3,*)

      istat = 1

      ivibs = 0
      ihasi = 0
      idirct = 1
      nframe = 5
      iframe = 0
      call rewfil

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in NWchem Frequencies

      nvibs = 3*natoms
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1

      call search(line,'hessian%begin%frequencies',istat)
      if (istat.eq.0) goto 100

      do while (.true.)
10       if (getlin(1).ne.1) goto 100

         do while (.true.)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               ivibs = ivibs + 1
               freq(ivibs) = rtype
            else if (ktype.eq.0) then
               goto 10
            else
               goto 20
            endif
         end do
      end do

20    nfreq = ivibs

      call search(line,'hessian%begin%intensities',istat)
      if (istat.eq.0) goto 100

      ihasi = 1
      ivibs = 0
      do while (.true.)
30       if (getlin(1).ne.1) goto 100

         do while (.true.)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.3) then
               ivibs = ivibs + 1
               frint(ivibs) = rtype
            else if (ktype.eq.0) then
               goto 30
            else
               goto 40
            endif
         end do
      end do

40    call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)

      return

100   istat = 0
      return
      end 

      subroutine enwcrd(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*137 lstr
      character*2 gstr
      character*4 tstr
      real freqt
      dimension freqt(9)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      dimension r(3)

c     Get ifreq 'th Norm. Cordinates from NWchem Output

      istat = 1

      call rewfil
      call iatnox(iatoms)
      nvibs = nfreq/3

      call search(line,'%begin%normal modes',istat)
      if (istat.eq.0) goto 100

      jvibs = 1

      do while(.true.)
         
         ivibs = 1
         ixyz = 0

30       if (getlin(1).ne.1) goto 100

         do while (.true.)

            ktype = nxtwrd(str,nstr,itype,rtype)

            if (ktype.eq.3) then

               ixyz = ixyz + 1

               if (ixyz.gt.3) then
                  ixyz = 1
                  ivibs = ivibs + 1
                  if (ivibs.gt.nvibs) ivibs = nvibs
               endif

               a(ixyz,ivibs) = rtype


            else if (ktype.eq.0) then
               if (ivibs.eq.nvibs.and.ixyz.ge.3) then
                   ivibs = 1
                   ixyz = 0
                   if (jvibs.eq.ifreq) then
                      goto 20
                   else
                      jvibs = jvibs + 1
                      goto 30
                   endif
               else
                   goto 30
               endif
            else
               goto 20
            endif
         end do

      end do

20    if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine nmcshd(couplj)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character*137 line
      common /nmr/    shlnuc(numatm),ihsnmr
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension couplj(*)

      call rewmf
      call srchmf(line,'Chemical Shielding Tensors',istat)
      if (istat.ne.0) then
          do i=1,natoms
             call srchmf(line,' isotropic =',istat)
             if (istat.ne.0) then
                 i1 = icdex(line,'=')
                 if (i1.ne.0) then
                    shlnuc(i) = reada(line,i1+1,len(line))
                 endif
             endif
          end do
          ihsnmr = 1

          call search(line,'Indirect Spin-Spin Tensors',istat)
          if (istat.ne.0) then
             ihsnmr = 2
             do i=1,natoms
                do j=1,natoms
                   if (i.ne.j) then
                      call search(line,
     &                   'Isotropic Spin-Spin Coupling',istat)
                      if (istat.ne.0) then
                         i1 = icdex(line,'=')
                         if (i1.ne.0) then
                            couplj((i-1)*natoms + j) = 
     &                            reada(line,i1+1,len(line))
                         endif
                      endif
                   endif
                end do
             end do
          endif
      endif

      return
      end

      subroutine rdgdud(idebug,ibefo,istatio,irtype,istats,
     &                 focc,focb,nocc,nocb,ncols,ncolb,coo,ianz)

c THIS IS REALLY rdgaus

      implicit double precision ( a-h,o-z)
      parameter (numat1=20000)
      parameter (mxonh=100)
      common /athlp/ iatoms, mxnat
      common /qmchar/ qch(numat1),ihasesp
      parameter (numatm=2000)
      parameter (mxel=100)
      character*137 line,lint
      character*2 els
      common /coord / xyz(3,numatm)
      common /pseudo /ipseud,ivale(numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor,
     &                ixyz98,iopr,isymm,irc,imp2,icntp,itd
      common /gauver/ ivers
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      common /nmr/    shlnuc(numatm),ihsnmr
      common /uvspec/ ihasex
      logical rohf
      dimension focc(*),focb(*),v1(3)
      dimension coo(3,*),ianz(*)

      istats = 1
      irtype = 0
      istatio = 0
      isymm = 1
      rohf = .false.
      ig94 = 0
      ixyz98 = 0
      iopr = 0
      irc = 0
      imp2 = 0
      itd = 0
      icntp = 0
      ihasex = 0

      call search(line,' ***********************',istat)
      call nxtlin(line,jstat)
      if (line(11:12).eq.'DV') then
          ivers = 2003
      else
          read(line,'(10x,i2)') ivers
          if (ivers.eq.3) ivers = 2003
          if (ivers.eq.9) ivers = 2009
          if (ivers.eq.16) ivers = 2016
          if (ivers.ge.94) ig94 = 1
      endif
      if (ivers.ge.98) then
          ixyz98 = 1
          call search(line,'will use Cartesian coordinates',istat)
          if (istat.ne.0) ixyz98 = 2
          call rewfil
      endif

      if (ig94.eq.0) then
         call search(line,'Restricted open shell SCF:',istat)
         if (istat.ne.0) rohf = .true.
         call rewfil
      endif
      
      call searchd(line,'Frequencies --',
     &                  'Excitation energies and oscillator strengths:',
     &                  istat)
      if (istat.ne.0) then
          if (index(line,'Frequencies --').ne.0) irtype = 4
          if (index(line,'Excitation').ne.0) then
              ihasex = 1
              call gttrns(ist)
          endif
      endif
      call rewfil

      call search(line,'Symmetry turned off',istat)
      if (istat.ne.0) isymm = 0
      call rewfil

      call search(line,'IRC-IRC-IRC',istat)
      if (istat.ne.0) then
         irc = 1
         call search(line,'Integration scheme',istat)
         if (istat.ne.0) then
             if (icdex(line,'HPC').ne.0) irc = 2
         endif
      endif
      call rewfil

      call searchd(line,'Computing MP2 derivatives',
     &                  'Computing MP2/KS-MP2 derivatives',istat)
      if (istat.ne.0) imp2 = 1
      call rewfil

      call search(line,'Computing CIS/TD-HF/TD-KS derivatives',istat)
      if (istat.ne.0) itd = 1
      call rewfil


      call search(line,'Counterpoise: corrected',istat)
      if (istat.ne.0) icntp = 1
      call rewfil

      call searchd(line,'ONIOM: saving','ONIOM: Cut',istat)
      if (istat.ne.0) then
         ioni = 1
         nion = 0
         do while (index(line,'Cut').ne.0)
            if (nion.lt.mxonh) then
               nion = nion + 1
               id = index(line,'/') + 1
               els = line(id:id+1)
               if (els(2:2).eq.' ') then
                  els = ' '//els(1:1)
               endif
               do i=1,99
                  if (els.eq.elemnt(i)) natonh(nion) = i
               end do
               if (line(id+8:id+8).eq.' ') then
                  read(line(id+2:id+38),'(i6,7x,i6,8x,f10.6)') 
     &              ionih(nion),icntat(nion),fct(nion)
               else if (line(id+7:id+7).eq.' ') then
                  read(line(id+2:id+35),'(i5,7x,i5,8x,f9.6)') 
     &              ionih(nion),icntat(nion),fct(nion)
               else
                  print*,'error reading ONIOM: Cut atoms'
               endif
            endif
            call redel(line,1)
         end do
         if (idebug.eq.1) then
            print*,'Oniom boundary atoms:'
            do i=1,nion
               print*,natonh(i),' ',ionih(i)
            end do
         endif
      else 
         ioni = 0
      endif
      
      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('no high level on model system found!',1)
            goto 1000
         endif
      endif
c     
c     look for number of orbitals and electrons
c
      call search(line,'primitive gaussians',istat)
      if (istat.eq.0) then
         call inferr('no primitive gaussian found!',1)
         goto 1000
      endif
      if (index(line,'primitive gaussians').eq.30) then
         read(line,'(1x,i3)',err=1000,end=1000) norbs
      else
         read(line,'(1x,i5)',err=1000,end=1000) norbs
      endif
      if (norbs.gt.mxorb) 
     &   call inferr('Exceeding MaxNum of Orbitals!',1)
      call search(line,'alpha electrons',istat)
      if (istat.eq.0) then
         call inferr('no alpha electrons found!',1)
          goto 1000
      endif
      if (index(line,'alpha electrons').eq.6) then
         read(line,'(1x,i3,21x,i4)',err=1000,end=1000) neleca,nelecb
      else
         read(line,'(1x,i5,20x,i5)',err=1000,end=1000) neleca,nelecb
      endif
      nelecs = neleca + nelecb
      iorbs = 0
      call search(line,'One-electron integrals computed using',istat)
      if (istat.eq.0) then
         call rewfil
         call search(line,'alpha electrons',istat)
      endif
      do i=1,30
         call nxtlin(line,jstat)
         if (jstat.eq.1) goto 999
         if (index(line,'RelInt:').eq.0) then
            if (index(line,'NBsUse=').ne.0) then
               read(line,'(9x,i5)',err=1000,end=1000) iorbs
            endif
         endif
      end do
999   continue
      if (ig94.eq.1) then
         ncols  = norbs
         ncolb  = norbs
         if (iorbs.ne.0) then
            ncols = iorbs
            ncolb = iorbs
         endif
      else
         ncols  = max0(neleca+5,nelecb+5)
         ncols  = min0(ncols,norbs)
         if (rohf) ncols = norbs
         ncolb  = ncols
      endif
c
      do i=1,min0(mxorb,norbs)
         focc(i) = 0.0d0
      end do
      do i=1,min0(mxorb,neleca)
         focc(i) = 1.0d0
      end do

      call rewfil
      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('no high level on model system found!',1)
            goto 1000
         endif
      endif
c      call searchd(line,'UHF open shell SCF','E(UHF)',istat)
      call search(line,'Beta Molecular Orbital Coefficients',istat)
      if (istat.ne.0) then
         iuhf=1
         nocc=neleca
         nocb=nelecb
         do i=1,min0(mxorb,norbs)
            focb(i) = 0.0d0
         end do
         do i=1,min0(mxorb,nelecb)
            focb(i) = 1.0d0
         end do
      else
         nocc=max0(neleca,nelecb)
         do i=1,min0(mxorb,nelecb)
            focc(i) = focc(i) + 1.0d0
         end do
      endif
c
      call search(line,'-- Stationary point found',istat)
      call rewfil
      ihssta = istat

c      if (ivers.ge.2009) then
c          ibefo = 1
c          write(iun3,*)
c     &          'Warning G09: using orbitals input geometry!'
c          write(iun3,*) ' '
c      endif

      if (istat.eq.0.or.ibefo.eq.1.or.(istat.eq.1.and.irtype.eq.4)) 
     &then
          write(iun3,*)'First standard orientation encountered used'
          write(iun3,*)'for density calculations'
          call search(line,'Z-MATRIX (ANGSTROMS AND DEGREES)',istat)
          if (istat.eq.0) then
              call haszm(.false.)
          else
              call redel(line,2)
              if (irtype.eq.4) then
                 call convzmat(coo,ianz,iatoms,1,0,1)
              else
                 call convzmat(coo,ianz,iatoms,1,1,1)
              endif
          endif
          call rdcor(idebug,istat)
          if (istat.eq.0) goto 1000
          if (idebug.eq.1) 
     &    call inferr('Succesfully read coordinates',0)
      else
          istatio = 1

          write(iun3,*)'Coordinates of stationary point used'
          write(iun3,*)'for density calculations'

10        call rdcor(idebug,istat)
          if (istat.eq.0) goto 20
          if (idebug.eq.1) 
     &    call inferr('found coordinates',0)
          goto 10
20        continue
      endif
c
      call rewfil
      call search(line,'Charges from ESP fit',istat)
      if (ihssta.eq.1) call search(line,'Charges from ESP fit',istat)
      if (istat.eq.1) then
          call redel(line,2)
          do i=1,natoms
              call nxtlin(line,jstat)
              if (jstat.eq.1.or.jstat.eq.2) goto 1000
              if (linlen(line).eq.18) then
                 read(line,'(7x,f11.6)',err=1000,end=1000) qch(i)
              else if (linlen(line).eq.21) then
                 read(line,'(11x,f11.6)',err=1000,end=1000) qch(i)
              endif
          end do
          ihasesp = 1
      endif

      call rewfil
      call fndor(idebug)

      if (ixyz98.gt.0.and.natoms.gt.50) then

c check for IOP(2/11=1)

         call rewfil
         call search(line,' 2/',istat)
         if (istat.eq.1) then
            if (ichar(line(1:1)).eq.32.and.
     &          ichar(line(2:2)).eq.50.and.
     &          ichar(line(3:3)).eq.47) then
               if (index(line,'11=1').ne.0) then
                  iopr = 1
               endif
            endif
         endif
      endif

      if (ioni.eq.1) then

c coordinates are read, calculate the coordinates of the oniom link 
c atoms

         do j=1,nion
            do k=1,3
                v1(k) = xyz(k,ionih(j))-xyz(k,icntat(j))
            end do
            do k=1,3
               xyzi(k,j) = xyz(k,icntat(j)) + 
     &          fct(j)*v1(k)
            end do
         end do
         call xyzcoo(1,0,0)

      endif

      call rewfil
      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('no high level on model system found!',1)
            goto 1000
         endif
      endif

c if ioni=1, rdbas transforms the xyz array to those of H layer only

      call rdbas(idebug,0,istat)
      call norml

      if (istat.eq.0) goto 1000
      if (idebug.eq.1) 
     &    call inferr('Succesfully read basis-set',0)
      if (idebug.eq.1) call basprt(iun3,.false.,.false.)
      if (norbs.gt.mxorb) goto 1000

      call search(line,'Pseudopotential Parameters',istat)
      if (istat.eq.1) then
         ipseud = 1
         call redel(line,4)
         do i=1,natoms
            call nxtlin(line,jstat)
            call nxtlin(lint,jstat)
            if (icdex(lint,'No pseudo').ne.0) then
               read(line,'(14x,i3)') ivale(i) 
            else
               read(line,'(26x,i3)') ivale(i) 
               do while(.true.)
                  call redel(line,1)
                  if (line(5:5).ne.' ') then
                     call bckfil
                     goto 100
                  endif
               end do
            endif
100         continue
         end do
      endif

      natbck = natoms
      if (ioni.eq.1) then

c     rdbas sets the array iomap, when ioni=1

         natmp = 0
         do i=1,numatm
            if (iomap(i).ne.0) natmp = natmp + 1
         end do
         natoms = natmp
      endif

      call rewfil
      if (ioni.eq.1.and.istatio.eq.1) then
         call search(line,'-- Stationary point found',istat)
         if (istat.eq.0) then
            call inferr('no Stationary point found!',1)
            goto 1000
         endif
      endif

      call nmrshl
      if (ihsnmr.eq.2) call nmrcpl(idebug)
      call rewfil

      if (ioni.eq.1) then
         call searchd(line,'high level on model system',
     &                     'generating new system at layer 1',istat)
         if (istat.eq.0) then
            call inferr('error reading vectors: '//
     &      'no high level on model system found for Stationary point!'
     &      ,1)
            call inferr(
     &   'no vectors for high level on model system '//
     &   'of stationary point: try molden -b',1)
            goto 1000
         endif
      endif
      if (istatio.eq.1) then
         call rdvect(idebug,ig94,istat)
         istato = istat

         if (ioni.ne.1) then

            if (ivers.lt.2009) then

               call rdvect(idebug,ig94,istat)
               if (istat.eq.0.and.istato.eq.0) goto 1000
               
            else
               call search(line,'Population analysis using',istat)
               if (istat.eq.1) then
                  call rdvect(idebug,ig94,istat)
                  if (istat.eq.0.and.istato.eq.0) goto 1000
               endif
            endif

         else if (ioni.eq.1.and.istato.eq.0) then

            call inferr(
     &   'no vectors for high level on model system '//
     &   'of stationary point: use molden -b',1)
            goto 1000

         endif

      else

         call rdvect(idebug,ig94,istat)
         if (istat.eq.0) goto 1000

      endif

      if (idebug.eq.1) call inferr('Succesfully read vectors',0)


      if (idebug.eq.1) 
     &         call inferr('Succesfully read Gaussian output',0)

      return

1000  if (idebug.eq.1)  then
          call inferr('Error reading Gaussian output!',1)
          print*,line
      endif

      istats = 0
      return

      end

      subroutine cubtst(iun,ijag)
      implicit double precision ( a-h,o-z)
      character*137 line,str
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /grdhlp/ mx3d,mx3d2
      integer currec,bigend,buflen
      common /rdrec/ iund,currec
      common /isend/ bigend,nlen
      character keywrd*320, keyori*320
      character filnam*10
      common /keywrd/ keywrd,keyori
      equivalence (bufft(1),nfast)
      equivalence (bufft(5),nmed)
      equivalence (bufft(9),nslow)
      integer getlin
      character*4 buff(40)
      integer*2 buf2(256)
      character*1 bufft(1024)
      integer*2 idum

      if (ijag.eq.1) then
c Jaguar cube
         iuntmp = iun2
         iun2 = iun

         do while(getlin(1).eq.1)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               if (nstr.ge.4) then
                  if (icdex(str,'npts').ne.0) then
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts1 = itype
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts2 = itype
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts3 = itype
                  endif
               endif
            endif
         end do

      elseif (ijag.eq.2) then

         iund = 10
         bigend = 1
         nlen = 1
         currec = 0
         buflen = 40
         close(10)

10       open(unit=iund,file=keywrd,access="direct",
     &        recl=nlen)

         call getrec(buff,buflen,1,ierr)
         if (ierr.eq.1) then
            bigend = 0
            currec = 0
            rewind(iund)
            call getrec(buff,buflen,1,ierr)
            if (ierr.eq.1.and.nlen.eq.1) then
               currec = 0
               bigend = 1
               nlen = 4
               close(iund)
               goto 10
            endif
         endif

         if (ierr.eq.1) then
            ijag = -1
            return
         endif

         call byter(buff(26),npts1)
         call byter(buff(27),npts2)
         call byter(buff(28),npts3)

         rewind(iund)
         currec = 0

      elseif (ijag.eq.3) then

c O map (DSN6)

         iund = 10
         bigend = 1
         nlen = 1
         currec = -1

12       open(unit=iund,file=keywrd(1:linlen(keywrd)),access="direct",
     &        recl=nlen)

         call getrc2(buf2,ierr)
         if (ierr.eq.1) then

            bigend = 0
            currec = -1
            call getrc2(buf2,ierr)
            if (ierr.eq.1.and.nlen.eq.1) then

               currec = -1
               bigend = 1
               nlen = 2
               close(iund)
               goto 12

            endif

         endif

         if (ierr.eq.1) then
            ijag = -1
            return
         endif

         npts1 = int(buf2(4))
         npts2 = int(buf2(5))
         npts3 = int(buf2(6))

c         print*,'npts ',npts1,npts2,npts3
         currec = -1

      elseif (ijag.eq.4) then

c ccp4 map

         iund = 10
         ix = index(keywrd,".ccp4");
         open(unit=iund,file=keywrd(1:ix+4)//char(0),access='stream')

         rewind(iund)
         read(iund,pos=1) bufft

         if (ierr.eq.1) then
            ijag = -1
            return
         endif

         npts1 = nfast
         npts2 = nmed
         npts3 = nslow

         currec = -1

      elseif (ijag.eq.5) then

c maestro .plt map

         open(unit=iun,file=keywrd(1:linlen(keywrd)))

         iuntmp = iun2
         iun2 = iun

         do while(getlin(1).eq.1)
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) then
               if (nstr.ge.4) then
                  if (icdex(str,'npts').ne.0) then
                      line = line(5:)
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts1 = itype
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) npts2 = itype
                      ktype = nxtwrd(str,nstr,itype,rtype)
                      if (ktype.eq.2) then
                                      npts3 = itype
                                      goto 15
                      endif
                  endif
               endif
            endif
         end do

15       continue
      else

         read(iun,'(a)') line
         read(iun,'(a)') line
         read(iun,'(a)') line

         read(iun,'(i5)') npts1
         read(iun,'(i5)') npts2
         read(iun,'(i5)') npts3

      endif

      nptsmx = mx3d
      if (npts1.gt.nptsmx) nptsmx = npts1
      if (npts2.gt.nptsmx) nptsmx = npts2
      if (npts3.gt.nptsmx) nptsmx = npts3
      if (ijag.eq.3) then
          iptsmx = nptsmx/8
          if (nptsmx.gt.iptsmx*8) nptsmx = (iptsmx+1)*8
      endif

      if (ijag.eq.5) call allgrd2(nptsmx)
      if (nptsmx.gt.mx3d) then
         call allgrd(nptsmx)
      endif

      if (ijag.eq.1) then
         rewind iun2
         iun2 = iuntmp
      else
         rewind iun
      endif

      return

100   print*,'error reading grid file'
      return
      end

      subroutine rdcubd(npts1,npts2,npts3,iposng,ipsi,istat,iun,
     &                  idebug,denn,pmnn)
      implicit double precision ( a-h,o-z)

c THIS IS REALLY rdcube

      parameter (numatm=2000)
      parameter (mxel=100)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /grdhlp/ mx3d,mx3d2
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /eulx/   ca,cb,sa,sb,cc,sc
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /zproj/  zval(numatm),nindx(numatm),nconn(numatm)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      character*137 line,lstr,str
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical gnreal,oampac,ojag
      integer getlin
      dimension orig(3),tmp(3),dtmp(6)
      dimension denn(*),pmnn(*)

      ojag = .false.
      if (istat.eq.1) ojag = .true.

      istat = 1
      itype = 0
      toang  = 0.52917706d0
      rneg = 0.0d0

      if (ojag) then

c Jaguar cube file

         iuntmp = iun2
         iun2 = iun
         do while(.true.)
            if (getlin(1).eq.1) then
               if (icdex(line,'&end').ne.0) goto 10
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1) then
                  if (nstr.eq.4) then
                     if (icdex(str,'npts').ne.0) then
                        ktype = nxtwrd(str,nstr,itype,rtype)
                        if (ktype.eq.2) npts1 = itype
                        ktype = nxtwrd(str,nstr,itype,rtype)
                        if (ktype.eq.2) npts2 = itype
                        ktype = nxtwrd(str,nstr,itype,rtype)
                        if (ktype.eq.2) npts3 = itype
                     endif
                  elseif (nstr.eq.6) then
                     if (icdex(str,'orig').ne.0) then
                        if (.not.gnreal(orig,3,.false.)) goto 100
                     endif
                  elseif (nstr.eq.7) then
                     if (icdex(str,'extent').ne.0) then
                        if (str(7:7).eq.'x'.or.str(7:7).eq.'X') then
                           if (.not.gnreal(v1,3,.false.)) goto 100
                        endif
                        if (str(7:7).eq.'y'.or.str(7:7).eq.'Y') then
                           if (.not.gnreal(v2,3,.false.)) goto 100
                        endif
                        if (str(7:7).eq.'z'.or.str(7:7).eq.'Z') then
                           if (.not.gnreal(tmp,3,.false.)) goto 100
                        endif
                     endif
                  endif
               endif
            endif 
         end do
10       natoms = 0
         nat(1) = 99

      else

c Gaussian Cube

         read(iun,'(a)') line
         read(iun,'(a)') line
         if (index(line,'Density').ne.0) itype = 0
         if (index(line,'MO coefficients').ne.0) itype = 1
         ipsi = itype

         read(iun,'(a)') line
         oampac = (linlen(line).eq.44)
         if (oampac) then
            read(line,'(i5,3f13.6)') natoms,(orig(i),i=1,3)
         else
            read(line,'(i5,3f12.6)') natoms,(orig(i),i=1,3)
         endif
         if (natoms.lt.0) itype = 1
         natoms = iabs(natoms)

         if (oampac) then
            read(iun,'(i5,3f13.6)') npts1,(v1(i),i=1,3)
            read(iun,'(i5,3f13.6)') npts2,(v2(i),i=1,3)
            read(iun,'(i5,3f13.6)') npts3,(tmp(i),i=1,3)
         else
            read(iun,'(i5,3f12.6)') npts1,(v1(i),i=1,3)
            read(iun,'(i5,3f12.6)') npts2,(v2(i),i=1,3)
            read(iun,'(i5,3f12.6)') npts3,(tmp(i),i=1,3)
         endif

      endif

      if (npts1.gt.mx3d.or.npts2.gt.mx3d.or.npts3.gt.mx3d) then
          lstr = 'dimension greater than maximum !'
          print*,'npts1 ',npts1,' npts2 ',npts2,' npts3 ',npts3,
     &           ' maxdim ',mx3d 
          goto 100
      endif

      if (ojag) then

         r(1) = vlen(v1)
         r(2) = vlen(v2)
         r(3) = vlen(tmp)

         px = orig(1) + (v1(1) + v2(1) + tmp(1))/2.0d0
         py = orig(2) + (v1(2) + v2(2) + tmp(2))/2.0d0
         pz = orig(3) + (v1(3) + v2(3) + tmp(3))/2.0d0

      else

         r(1) = vlen(v1)*(npts1-1)
         r(2) = vlen(v2)*(npts2-1)
         r(3) = vlen(tmp)*(npts3-1)

         px = orig(1) + ((npts1-1)*v1(1) + (npts2-1)*v2(1) + 
     &                   (npts3-1)*tmp(1))/2.0d0
         py = orig(2) + ((npts1-1)*v1(2) + (npts2-1)*v2(2) + 
     &                   (npts3-1)*tmp(2))/2.0d0
         pz = orig(3) + ((npts1-1)*v1(3) + (npts2-1)*v2(3) + 
     &                   (npts3-1)*tmp(3))/2.0d0

      endif

      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(tmp,1.0d0,1.0d-4)


      cx = tmp(1)
      cy = tmp(2)
      cz = tmp(3)

      if (.not.ojag) then
         do i=1,natoms
            if (oampac) then
               read(iun,'(i5,4f13.6)') nat(i),tdum,(xyz(j,i),j=1,3)
            else
               read(iun,'(i5,4f12.6)') nat(i),tdum,(xyz(j,i),j=1,3)
            endif
         end do
      endif

      if (idebug.eq.1) then
         print*,'r=',(r(i),i=1,3)
         print*,'px py pz ',px,py,pz
         print*,'cx cy cz ',cx,cy,cz
         print*,'v1=',(v1(i),i=1,3)
         print*,'v2=',(v2(i),i=1,3)
         if (ojag) then
            do i=1,natoms
               print*, nat(i),(xyz(j,i),j=1,3)
            end do
         endif
      endif

      call crprod(v1,v2,dtmp)
      call impsc(dtmp,tmp,cosb)
      if (1.0d0-dabs(cosb).gt.0.001d0) then
          lstr = 'Only rectangular grids supported !'
          print*,'ERROR: Only rectangular grids supported ',cosb
          goto 100
      endif

      if (.not.ojag.and.itype.eq.1) then
         read(iun,'(i5)') no
         if (no.gt.1) then
            lstr = 'ONLY single orbital cube files are supported !'
            goto 100
         endif
         nlines = (no + 1) / 10
         if (no+1 - nlines*10.gt.0) nlines = nlines + 1
         do i=1,nlines-1
            read(iun,'(a)') line
         end do
      endif

      ij = 0
      iposng = 0
      
      if (ojag) then

c Jaguar cube file

         do i=1,npts1
            do j=1,npts2
               ij = ij + 1
               do k=1,npts3

                 if (getlin(0).eq.1) then
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.3) then
                      if (rtype.lt.0.0d0) iposng = 1
                      denn((k-1)*mx3d2 + ij) = rtype 
                   endif
                 else
                   lstr = 'Not enough lines'
                   goto 100
                 endif

               end do
            end do
         end do

      else

c Gaussian Cube

         do i=1,npts1
            do j=1,npts2
               ij = ij + 1
               kk = 0
               do while (kk.lt.npts3)
                  n = 6
                  if (npts3-kk.lt.n) n = npts3-kk
                  read(iun,'(6E13.5)') (dtmp(k),k=1,n)
                  do k=1,n
                     denn((npts3-(kk+k))*mx3d2 + ij) = dtmp(k)
                     if (dtmp(k).lt.rneg) rneg = dtmp(k)
                  end do
                  kk = kk + 6
               end do
            end do
         end do
      endif

c allow tolerance for density, since gaussian density cubes often
c have small negative values

      if (dabs(rneg).gt.1.0d08) iposng = 1

      iplat = 0

      ca = v2(2)
      sa = -v2(1)
      sb = -v1(3)
      if (dabs(ca).gt.0.001d0) then
         cb = v1(1) / ca
      else
         cb = v1(2) / sa
      endif

      cc = 1.0d0
      sc = 0.0d0

      if (cx.eq.0.d0.and.cy.eq.0.d0) cz = 1.d0
      xy = cx*cx + cy*cy

      if (xy.gt.1.d-15) then
          r1 = dsqrt(xy+cz*cz)
          xy = dsqrt(xy)
          ca = cx/xy
          cb = cz/r1
          sa = cy/xy
          sb = xy/r1
      else
          ca = 1.d0
          cb = 1.d0
          sa = 0.d0
          sb = 0.d0
      endif

      cc = 1.0d0
      sc = 0.0d0

      call pareul
      call parrat
      call proato

      do i=1,npts3
          pmnn(i) = 100000.d0
      end do

      do i=1,natoms
         nconn(i) = 0
         do j=1,natoms
           if (i.ne.j) then
            dmaxsq = (vdwr(nat(i)) + vdwr(nat(j)))**2
            dijsq = ((xyz(1,i)-xyz(1,j))*toang)**2
     &             +((xyz(2,i)-xyz(2,j))*toang)**2
     &             +((xyz(3,i)-xyz(3,j))*toang)**2
            if (dijsq.lt.dmaxsq) then
                nconn(i) = nconn(i) + 1
            endif
           endif
         end do
      end do

      call xyzcoo(1,0,0)

      ofrst = .false.

      if (ojag) iun2 = iuntmp

      lstr = 'found cube file'
      call inferr(lstr,0)
      return

100   continue
110   istat = 0
      if (ojag) iun2 = iuntmp
      call inferr(lstr,0)

      return
      end

      subroutine rdvasd(npts1,npts2,npts3,iposng,istat,lenf,
     &                  idocub,idebug,denn,pmnn,bucket,
     &                  coo,ianz,iatclr,iconn,
     &                  nnat,norg,icent,inorm,ncon,nspg,ichx,
     &                  nopr,ir,it,
     &                  xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision ( a-h,o-z)

c THIS IS REALLY rdvasp

      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (mxcon=10)
      parameter (lnbuck=10)
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /grdhlp/ mx3d,mx3d2
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /eulx/   ca,cb,sa,sb,cc,sc
      integer*2 ir,it
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /zproj/  zval(numatm),nindx(numatm),nconn(numatm)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/elemnt(mxel)

      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,lstr
      logical opfil,gnreal
      integer getlin
      character*137 str
      character*2 tocapf
      character keywrd*320, keyori*320
      common /keywrd/ keywrd,keyori
      dimension tmp(3),dtmp(10),xyzt(3)
      dimension ieltyp(20),ielnum(20)
      dimension denn(*),pmnn(*),bucket(*)
      dimension coo(3,*),ianz(*),iatclr(*),iconn(mxcon+1,*),
     &          ir(3,3,192),it(3,192)

      logical felem
      character*137 strtmp
      common /vasp/nheadx,natx


      istat = 1
      itype = 0
      toang  = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)
      lstr = ' '

      if (idocub.eq.1) then
         iuntmp = iun2
         iun2 = 21

         if (.not.opfil(21,keywrd(1:lenf),lenf,1,1,0)) then
            lstr = keywrd(1:lenf)//' non-existent'
            goto 110
         endif
      endif


c title

      natt = 0

      if (idocub.eq.1) then
         call nxtlin(line,jstat)
      else

         felem = .false.

         if (getlin(0).eq.1) then
            do while(.true.)
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.1.and.(nstr.eq.1.or.nstr.eq.2)) then
                  if (nstr.eq.1) then
                     str(2:2) = str(1:1)
                     str(1:1) = ' '
                  endif
                  ity = 0
                  do i=1,99
                     if (tocapf(str).eq.tocapf(elemnt(i))) ity = i
                  end do
                  if (ity.ne.0) then
                     felem = .true.
                     natt = natt + 1
                     ieltyp(natt) = ity
                  endif 
               else
                  goto 10
               endif
            end do
         endif
      endif

10    continue

c scale factor

      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.3) then
            scl = rtype
         endif
      endif

c unit vectors

      if (getlin(0).eq.1) then
         if (.not.gnreal(v1,3,.false.)) goto 100
      else
         goto 100
      endif

      if (getlin(0).eq.1) then
         if (.not.gnreal(v2,3,.false.)) goto 100
      else
         goto 100
      endif

      if (getlin(0).eq.1) then
         if (.not.gnreal(tmp,3,.false.)) goto 100
      else
         goto 100
      endif

      r(1) = vlen(v1)*scl
      r(2) = vlen(v2)*scl
      r(3) = vlen(tmp)*scl
      if (r(1).le.0.0d0.or.r(2).le.0.0d0.or.r(3).le.0.0d0) goto 100

      a = r(1)
      b = r(2)
      c = r(3)
      call impsc(v2,tmp,csa)
      call impsc(v1,tmp,csb)
      call impsc(v1,v2,csc)
      alpha = dacos(csa)*todeg
      beta = dacos(csb)*todeg
      gamma = dacos(csc)*todeg
      nspg = 1

      call prcell(nspg,a,b,c,alpha,beta,gamma)
      call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,1)
      call cprot(nspg,nopr,icent,ir,it,.false.)
      if (idebug.eq.1) call prop(nopr,ir,it)

c In new POSCARs there might be a line here to give the elements names

      if (getlin(0).eq.1) then

         call gtplin(strtmp)
         ktype = nxtwrd(str,nstr,itype,rtype)

         if (ktype.eq.1) then

            if (.not.felem) then
               call setlin(strtmp,0)
               natt = 0
               do while(.true.)
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.1.and.(nstr.eq.1.or.nstr.eq.2)) then
                     if (nstr.eq.1) then
                        str(2:2) = str(1:1)
                        str(1:1) = ' '
                     endif
                     ity = 0
                     do i=1,99
                        if (tocapf(str).eq.tocapf(elemnt(i))) ity = i
                     end do
                     if (ity.ne.0) then
                        felem = .true.
                        natt = natt + 1
                        ieltyp(natt) = ity
                     endif 
                  else
                     goto 11
                  endif
               end do
 11            continue
            endif

c    we now read the number of atoms of each sort

            natoms = 0
            ity = 0
            if (getlin(0).eq.1) then
               do i=1,50
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) then
                     natoms = natoms + itype
                     ity = ity + 1
                     ielnum(ity) = itype
                  else
                     goto 20
                  endif
               end do
            else
               goto 100
            endif
            
 20         continue

         elseif (ktype.eq.2) THEN

c in fact, it is already the number of atoms of each sort   
c we read them from the stored line

            call setlin(strtmp,0)
            natoms = 0
            ity = 0
            do i=1,50
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.2) then
                  natoms = natoms + itype
                  ity = ity + 1
                  ielnum(ity) = itype
               else
                  goto 21
               endif
            end do
          
 21         continue
         endif
      endif

      natx = natoms

c      if (natt.eq.ity) then
      if (natt.ge.ity) then
         natt=ity
         k = 0
         do i=1,natt
            do j=1,ielnum(i)
               k = k + 1
               ianz(k) = ieltyp(i)
               nat(k) = ieltyp(i)
            end do
         end do
      endif

c Check for Direct (=fractional coordinates)

      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.1) then
            call tocap(str,nstr)
            if (str(1:1).eq.'S') then
               if (getlin(0).eq.1) then
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.ne.1) goto 100
               endif
            endif

            if (str(1:1).ne.'C'.and.str(1:1).ne.'c'.and.
     &          str(1:1).ne.'K'.and.str(1:1).ne.'k') then
               str  = 'DIRECT'
               nstr = 6
            endif
         else
            goto 100
         endif
      end if

c read in fractional coordinates

      do i=1,natoms
         if (natt.ne.ity) then
            nat(i) = 99
            ianz(i) = 99
         endif
         if (getlin(0).eq.1) then
            if (.not.gnreal(xyzt,3,.false.)) goto 100
            do j=1,3
               xyz(j,i) = v1(j)*scl*xyzt(1) + v2(j)*scl*xyzt(2) +
     &                    tmp(j)*scl*xyzt(3)
               coo(j,i) = xyzt(j)
            end do
         else
            goto 100
         endif
      end do

c      if (idocub.eq.0) then

         ncon = 1
         inorm = 0 
         iatoms = natoms
         nnat = natoms
         norg = natoms
         nstor = mxnat-iatoms
         do i=1,iatoms

            do j=1,3
               coo(j,nstor+i) = coo(j,i)
            end do
   
            call fr2crt(coo(1,i),xa,ya,yb,za,zb,zc)
            do j=1,3
                coo(j,i) = coo(j,i)/toang
            end do
            ianz(nstor+i) = ianz(i)
            iatclr(nstor+i) = 1

         end do

         call doconn
         call dohcon(0)
   
         do i=1,iatoms
            do j=1,iconn(1,i)+1
               iconn(j,nstor+i) = iconn(j,i)
            end do
         end do


c      endif

      ichx = 1

      if (idocub.eq.0) then
          istat = 2
          return
      endif

      call nxtlin(line,jstat)

c x,y,z dimension of grid

      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            npts1 = itype
         else
            goto 100
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            npts2 = itype
         else
            goto 100
         endif
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            npts3 = itype
         else
            goto 100
         endif
      else
         goto 100
      endif

      if (npts1.gt.mx3d.or.npts2.gt.mx3d.or.npts3.gt.mx3d) then
          lstr = 'dimension greater than maximum !'
          print*,'npts1 ',npts1,' npts2 ',npts2,' npts3 ',npts3,
     &           ' maxdim ',mx3d 
          goto 100
      endif

      px = (scl*v1(1) + scl*v2(1) + scl*tmp(1))/2.0d0
      py = (scl*v1(2) + scl*v2(2) + scl*tmp(2))/2.0d0
      pz = (scl*v1(3) + scl*v2(3) + scl*tmp(3))/2.0d0

c      do i=1,natoms
c         xyz(1,i) = xyz(1,i) + px
c         xyz(2,i) = xyz(2,i) + py
c         xyz(3,i) = xyz(3,i) + pz
c      end do

      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(tmp,1.0d0,1.0d-4)


      cx = tmp(1)
      cy = tmp(2)
      cz = tmp(3)

      if (idebug.eq.1) then
         print*,'r=',(r(i),i=1,3)
         print*,'px py pz ',px,py,pz
         print*,'cx cy cz ',cx,cy,cz
         print*,'v1=',(v1(i),i=1,3)
         print*,'v2=',(v2(i),i=1,3)
         do i=1,natoms
            print*, nat(i),(xyz(j,i),j=1,3)
         end do
      endif

      call crprod(v1,v2,dtmp)
      call impsc(dtmp,tmp,cosb)
      if (1.0d0-dabs(cosb).gt.0.001d0) then
          lstr = 'Only rectangular grids supported !'
          print*,'ERROR: Only rectangular grids supported ',cosb
          goto 100
      endif

      j = 1
      k = 1
      ijkt = 0
      iposng = 0
      nall = npts1*npts2*npts3
      ib = 0
      nb = (npts1/lnbuck)*lnbuck
      if (npts1.gt.nb) nb = nb + lnbuck

      do while (ijkt.lt.nall)
c fill bucket
c          ijkt = ijk
          do while (ib.lt.nb.and.ijkt.lt.nall)
             n = lnbuck
             if (nall-ijkt.lt.n) n = nall-ijkt
c             print*,'n=',n,' bucket',bucket(ib),' ',nall,' ',ijkt
             read(21,'(10f8.3)') (bucket(ib+l),l=1,n)
             ib = ib + n
             ijkt = ijkt + n
          end do
c full bucket
          ib = ib - npts1
c fill density array
          do i=1,npts1
             denn((k-1)*mx3d2 + (i-1)*npts2+j) = bucket(i)
          end do
c          print*,j,' ',k
c          print*,(bucket(l),l=1,npts1)
c move access bucket to beginning of bucket
          do l=1,ib
             bucket(l) = bucket(npts1+l)
          end do
          j = j + 1
          if (j.gt.npts2) then
             j = 1
             k = k + 1
          endif
c          ijk = ijk + npts1
      end do

      iplat = 0

      ca = v2(2)
      sa = -v2(1)
      sb = -v1(3)
      if (dabs(ca).gt.0.001d0) then
         cb = v1(1) / ca
      else
         cb = v1(2) / sa
      endif

      cc = 1.0d0
      sc = 0.0d0

      call parrat
      call proato

      do i=1,npts3
          pmnn(i) = 100000.d0
      end do

      do i=1,natoms
         nconn(i) = 0
         do j=1,natoms
           if (i.ne.j) then
            dmaxsq = (vdwr(nat(i)) + vdwr(nat(j)))**2
            dijsq = ((xyz(1,i)-xyz(1,j))*toang)**2
     &             +((xyz(2,i)-xyz(2,j))*toang)**2
     &             +((xyz(3,i)-xyz(3,j))*toang)**2
            if (dijsq.lt.dmaxsq) then
                nconn(i) = nconn(i) + 1
            endif
           endif
         end do
      end do

      if (idocub.eq.1) then
          close(21)
          call xyzcoo(1,0,0)
      endif

      ofrst = .false.

      if (idocub.eq.1) iun2 = iuntmp

      lstr = 'found cube file'
      call inferr(lstr,0)
      return

100   if (idocub.eq.1) close(21)
110   if (idocub.eq.1) iun2 = iuntmp
      istat = 0
      call inferr(lstr,0)

      return
      end

      subroutine wrvasd(iun,coo,ianz,
     &                  xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision ( a-h,o-z)
      parameter (mxel=100)
      parameter (mxetyp=20)
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/elemnt(mxel)
      logical fndel
      dimension tmp(3),tr(3),rr(3,3),ieltyp(mxetyp),ielnum(mxetyp)
      dimension coo(3,*),ianz(*)

      toang  = 0.52917706d0

      natt = 0
      do i=1,mxetyp
         ielnum(i) = 0
      end do

      do i=1,iatoms

         if (ianz(i).gt.0.and.ianz(i).lt.99) then

            fndel = .false.
            do j=1,natt
               if (ianz(i).eq.ieltyp(j)) then
                  ielnum(j) = ielnum(j) + 1
                  fndel = .true.
               endif
            end do

            if (.not.fndel) then
               natt = natt + 1
               ieltyp(natt) = ianz(i)
               ielnum(natt) = 1
            endif

         endif

      end do

      write(iun,'(20(a2,1x))') (elemnt(ieltyp(i)),i=1,natt)

      scl = 1.0d0
      write(iun,'(f12.6)') scl

      call setrr(alpha,beta,gamma,a,b,c,rr)

      tmp(1) = 1.0d0
      tmp(2) = 0.0d0
      tmp(3) = 0.0d0
c      call fr2crt(tmp,xa,ya,yb,za,zb,zc)
      do k=1,3
         tr(k) = trc(tmp,rr,k)
      end do

c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)
      
      tmp(1) = 0.0d0
      tmp(2) = 1.0d0
      tmp(3) = 0.0d0
c      call fr2crt(tmp,xa,ya,yb,za,zb,zc)
      do k=1,3
         tr(k) = trc(tmp,rr,k)
      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      tmp(1) = 0.0d0
      tmp(2) = 0.0d0
      tmp(3) = 1.0d0
c      call fr2crt(tmp,xa,ya,yb,za,zb,zc)
      do k=1,3
         tr(k) = trc(tmp,rr,k)
      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      write(iun,'(20(i3,1x))') (ielnum(i),i=1,natt)

      write(iun,'(a)') 'Direct'

      do k=1,natt

         do i=1,iatoms
            if (ianz(i).eq.ieltyp(k)) then
               do j=1,3
                  tmp(j) = coo(j,i) * toang
               end do
               call crt2fr(tmp,tr,xa,ya,yb,za,zb,zc)
               write(iun,'(3(f12.6,1x))') (tr(j),j=1,3)
            endif
         end do

      end do

      call inferr('Wrote file: POSCAR',0)

      return
      end

      subroutine wrmopd(iun,coo,ianz,
     &                  xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision ( a-h,o-z)
      parameter (mxel=100)
      parameter (mxetyp=20)
      common /athlp/ iatoms, mxnat
      character*2 elemnt
      common /elem/elemnt(mxel)
      dimension tmp(3)
c      dimension tr(3),rr(3,3)
      dimension coo(3,*),ianz(*)

      toang  = 0.52917706d0

      write(iun,'(a)') 'AM1 NOINTER XYZ'
      write(iun,'(a)') ' '
      write(iun,'(a)') ' '

c      call setrr(alpha,beta,gamma,a,b,c,rr)



      do i=1,iatoms
          do j=1,3
             tmp(j) = coo(j,i) * toang
          end do
          if (ianz(i).gt.0.and.ianz(i).lt.99) then
             if (i.eq.1) then
                write(iun,'(a2,1x,3(f12.6,a3))') elemnt(ianz(i)),
     &            tmp(1),' 0 ',tmp(2),' 0 ',tmp(3),' 0 '
             else
                write(iun,'(a2,1x,3(f12.6,a3))') elemnt(ianz(i)),
     &            tmp(1),' 1 ',tmp(2),' 1 ',tmp(3),' 1 '
             endif
          endif
      end do



      tmp(1) = 1.0d0
      tmp(2) = 0.0d0
      tmp(3) = 0.0d0
      call fr2crt(tmp,xa,ya,yb,za,zb,zc)
c      do k=1,3
c         tr(k) = trc(tmp,rr,k)
c      end do

      write(iun,'(a3,3(f12.6,a3))') 
     &    'Tv ',tmp(1),' 1 ',tmp(2),' 0 ',tmp(3),' 0 '
c      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)
      
      tmp(1) = 0.0d0
      tmp(2) = 1.0d0
      tmp(3) = 0.0d0
      call fr2crt(tmp,xa,ya,yb,za,zb,zc)
c      do k=1,3
c         tr(k) = trc(tmp,rr,k)
c      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)
      write(iun,'(a3,3(f12.6,a3))') 
     &    'Tv ',tmp(1),' 0 ',tmp(2),' 1 ',tmp(3),' 0 '
c      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      tmp(1) = 0.0d0
      tmp(2) = 0.0d0
      tmp(3) = 1.0d0

      call fr2crt(tmp,xa,ya,yb,za,zb,zc)

c      do k=1,3
c         tr(k) = trc(tmp,rr,k)
c      end do
c      write(iun,'(3(f12.6,1x))') (tmp(i),i=1,3)

      write(iun,'(a3,3(f12.6,a3))') 
     &    'Tv ',tmp(1),' 0 ',tmp(2),' 0 ',tmp(3),' 1 '
c      write(iun,'(3(f12.6,1x))') (tr(i),i=1,3)

      call inferr('Wrote file: mopac.dat',0)

      return
      end

      subroutine rdgrdd(npts1,npts2,npts3,iun,istat,
     &                  denn,dens,pmnn,buff)
      implicit double precision (a-h,o-z)
      parameter (mxdir=500)
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /grdhlp/ mx3d,mx3d2
      common /comsrf/  vo(3), rr(3),vv1(3),vv2(3),vv3(3), wo(3),
     &                 sl(3),isl
      common /cnthlp/ rng1,rng2,vlcnt,vlcnt2
      real ra,orig,den
      character*137 lstr
      character*4 buff(*)
      character*72 header
      integer currec,bigend,buflen
      common /rdrec/ iund,currec
      common /isend/ bigend,nlen
      dimension orig(3)
      dimension denn(*),pmnn(*),dens(*)

c nnx,nny,nnz    the number of points in x, y and z direction
c ra             real step along x,y and z direction per point
c rx,ry,rz       origin of the grid

      toang  = 0.52917706d0
      istat = 1
      lstr = ' '

      iplat = 0

      buflen = mx3d2
      rewind(iund)
      call getrec(buff,buflen,0,ierr)

      do i =1,18
         header(4*(i-1)+1:4*i) = buff(i)(1:4)
      end do

      print*,'header = ',header

      call byter(buff(26),npts2)
      call byter(buff(27),npts1)
      call byter(buff(28),npts3)

      print*,'npts1=',npts1,' npts2=',npts2,' npts3=',npts3

      call byter(buff(29),ra)

      ra = ra / toang

      print*,'ra=',ra

      call byter(buff(30),orig(2))
      call byter(buff(31),orig(1))
      call byter(buff(32),orig(3))

      print*,'orgx,orgy,orgz ',orig(1),' ',orig(2),' ',orig(3)

      v1(1) = 0.0d0
      v1(2) = 1.0d0
      v1(3) = 0.0d0

      v2(1) = 1.0d0
      v2(2) = 0.0d0
      v2(3) = 0.0d0

      r(1) = dble(ra)*dble(npts1-1)
      r(2) = dble(ra)*dble(npts2-1)
      r(3) = dble(ra)*dble(npts3-1)

      do i=1,3
         orig(i) = orig(i) / toang
         rr(i)  = r(i)
         vv1(i) = v1(i)
         vv2(i) = v2(i)
         vv3(i) = 0.0d0
         sl(i) = 1.0d0
      end do

      vv3(3) = 1.0d0

      isl = 1
      sl(1) = -1.0d0
      sl(2) = -r(2)/r(1)
      sl(3) = -r(3)/r(1)

      call vnrm(sl)

      px =  dble(orig(2))
      py =  dble(orig(1))
      pz =  dble(orig(3))


      vo(1) = px
      vo(2) = py
      vo(3) = pz

      cx = 0.0d0
      cy = 0.0d0
      cz = 1.0d0

      pmax = -1000000.d0
      pmin = 1000000.d0

      do k=1,npts3

c get plate

         call getrec(buff,buflen,0,ierr)
         if (ierr.eq.1) goto 100

         call byter(buff(1),nz)
         call byter(buff(2),nx)
         call byter(buff(3),ny)

c         print*,'nz,nx,ny ',nz,' ',nx,' ',ny

         call getrec(buff,buflen,0,ierr)

         ij = 0
         do i=1,ny
            do j=1,nx
               ij = ij + 1
               call byter(buff(ij),den)
               dens((j-1)*ny+i) = dble(den)
            end do
         end do
         do i=1,nx*ny
            denn((nz-1)*mx3d2 + i) = dens(i)
            if (dens(i).gt.pmax) pmax = dens(i)
            if (dens(i).lt.pmin) pmin = dens(i)
         end do

      end do

      rng1 = pmin
      rng2 = pmax

      call messg(22)

      ofrst = .false.

      lstr = 'found grid file'
      call inferr(lstr,0)
      return

100   istat = 0
      lstr = 'error reading GRID file'
      call inferr(lstr,0)
      return
      end

      subroutine rdccpd(npts1,npts2,npts3,iun,istat,
     &                  denn,dens,pmnn,ichx,a,b,c)
      implicit double precision (a-h,o-z)
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      common /grdhlp/ mx3d,mx3d2
      common /cnthlp/ rng1,rng2,vlcnt,vlcnt2
      integer currec,bigend
      common /rdrec/ iund,currec
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 lstr
      dimension denn(*),pmnn(*),dens(*)

      integer*4 nfast,nmed,nslow,mode,nsfast,nsmed,nsslow
      integer*4 mx,my,mz,mapc,mapr,maps,ispg,nsymbt
      real*4 abc(3),alpha,beta,gamma,dmin,dmax,dmean
      real*4 ori(3),dtemp,r1,r2,r3

      equivalence (buff(1),nfast)
      equivalence (buff(5),nmed)
      equivalence (buff(9),nslow)
      equivalence (buff(13),mode)
      equivalence (buff(17),nsfast)
      equivalence (buff(21),nsmed)
      equivalence (buff(25),nsslow)
      equivalence (buff(29),mx)
      equivalence (buff(33),my)
      equivalence (buff(37),mz)
      equivalence (buff(41),abc(1))
      equivalence (buff(53),alpha)
      equivalence (buff(57),beta)
      equivalence (buff(61),gamma)
      equivalence (buff(65),mapc)
      equivalence (buff(69),mapr)
      equivalence (buff(73),maps)
      equivalence (buff(77),dmin)
      equivalence (buff(81),dmax)
      equivalence (buff(85),dmean)
      equivalence (buff(89),ispg)
      equivalence (buff(93),nsymbt)
      equivalence (buff(197),ori(1))
      character*1 buff(1024)
      character*1 extbuf(1024)
      dimension n(3),ns(3),dtemp(10000)


      todeg = 45.0d0 / datan(1.0d0)
      toang  = 0.52917706d0
      istat = 1
      lstr = ' '

      read(iund,pos=1) buff

      a = dble(abc(1))
      b = dble(abc(2))
      c = dble(abc(3))

      write(iun3,*) " "
      write(iun3,'(3(a,f7.3))') "a=",abc(1)," b=",abc(2)," c= ",abc(3)
      write(iun3,*) " "

      abc(1) = abc(1) / toang
      abc(2) = abc(2) / toang
      abc(3) = abc(3) / toang

      write(iun3,*) " "
      write(iun3,'(3(a,f7.3))') "alpha ",alpha," beta ",beta,
     &                          " gamma ",gamma
      write(iun3,*) " "

      alpha = alpha / todeg
      beta  = beta  / todeg
      gamma = gamma / todeg

      abc(1) = abc(1) / float(mx)
      abc(2) = abc(2) / float(my)
      abc(3) = abc(3) / float(mz)

      v1(1) = dble(abc(1))
      v1(2) = 0.0d0
      v1(3) = 0.0d0
    
      v2(1) = dble(cos(gamma) * abc(2))
      v2(2) = dble(sin(gamma) * abc(2))
      v2(3) = 0.0d0
    
      z1 = dble(cos(beta))
      z2 = dble((cos(alpha) - cos(beta)*cos(gamma)) / sin(gamma))
      z3 = dble(sqrt(1.0 - z1*z1 - z2*z2));

      v3(1) = z1 * dble(abc(3))
      v3(2) = z2 * dble(abc(3))
      v3(3) = z3 * dble(abc(3))
    
c     Convert the origin from grid space to cartesian coordinates
c     nsfast,nsmed,nsslow convert to vo

      n(1) = nfast
      n(2) = nmed
      n(3) = nslow

      ns(1) = nsfast
      ns(2) = nsmed
      ns(3) = nsslow

c      print*,"ns(1-3) ",ns(1),ns(2),ns(3)

      vo(1) = v1(1) * dble(ns(mapc)) + 
     &        v2(1) * dble(ns(mapr)) + v3(1) * dble(ns(maps))
      vo(2) = v2(2) * dble(ns(mapr)) + v3(2) * dble(ns(maps))
      vo(3) =                          v3(3) * dble(ns(maps))

c     normalise basis vectors

      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(v3,1.0d0,1.0d-4)

      isl = 1
      sl(1) = 1.0d0
      sl(2) = b/a
      sl(3) = c/a
      call vnrm(sl)


      r(1) = abc(mapc)*dble(n(mapc))
      r(2) = abc(mapr)*dble(n(mapr))
      r(3) = abc(maps)*dble(n(maps))

      r1 = real(r(mapc))
      r2 = real(r(mapr))
      r3 = real(r(maps))

c nfast,nmed,nslow corresponds to npts1,npts2,npts3
c nsfast,nsmed,nsslow corresponds to 

c      print*," nfast=",nfast," nmed=",nmed," nz=",nslow
c      print*,"mode=",mode
c      print*,"nsfast=",nsfast," nsmed=",nsmed,
c     +         " nsslow=",nsslow
c      print*," mx=",mx," my=",my," mz=",mz
c      print*,"a=",a," b=",b," c=",c
c      print*,"alpha=",alpha," beta=",beta," gamma=",gamma
c      print*,"mapc=",mapc," mapr=",mapr," maps=",maps
      write(iun3,'(3(a,f7.3))') "dmin= ",dmin," dmax= ",dmax,
     &                          " dmean= ",dmean
      write(iun3,*) " "
c      print*,"ispg=",ispg
c      print*,"nsymbt=",nsymbt
c      print*,"ORI=",(ori(i),i=1,3)

c      inquire(iund,pos=ipos)
      read(iund,pos=1024)(extbuf(i),i=1,nsymbt)

c      print*,extbuf(1:nsymbt)

      pmax = -1000000.d0
      pmin = 1000000.d0

c      print*,"npts1,npts2,npts3 ",n(mapc),n(mapr),n(maps)
      npts1 = n(mapc)
      npts2 = n(mapr)
      npts3 = n(maps)
      mxind = mx3d*mx3d2

      no = n(mapc)*n(mapr)

      write(iun3,'(a,3(x,i3))') "slow,medium,fast ",
     &                           n(maps),n(mapc),n(mapr)
      write(iun3,*) " "

      do k=1,n(maps)
         ipos = 1024+nsymbt+(k-1)*no*4 + 1
         read(iund,pos=ipos) (dtemp(ii),ii=1,no)

         do i=1,n(mapc)
            do j=1,n(mapr)
                ind = i + (j-1)*n(mapc) + (k-1)*mx3d2

                if (ind.le.mxind) then
                    ii = j + n(mapr)*(i-1)
                    denn(ind) = dtemp(ii)

                    if (dtemp(ii).gt.pmax) pmax = dtemp(ii)
                    if (dtemp(ii).lt.pmin) pmin = dtemp(ii)

                else
                    print*,"ind ",ind," mx3d2 "," error d=",dtemp(ii)
                endif
            end do
         end do
      end do

      close(unit=iund)

      vlcnt = 1.00d0
      lstr = 'found ccp4 file'

      call inferr(lstr,0)

      rng1 = pmin
      rng2 = pmax

      ichx = 1

      call messg(16)

      return

100   istat = 0
      lstr = 'error reading ccp4 file'
      call inferr(lstr,0)
      return

      end

      subroutine rdomad(npts1,npts2,npts3,iun,istat,
     &                  denn,dens,pmnn,ichx)
      implicit double precision (a-h,o-z)
      parameter (mxdir=500)
      logical dolap, lapdbl
      common /vropt/ ivtwo,ihand,ivadd
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      common /grdhlp/ mx3d,mx3d2
      common /cnthlp/ rng1,rng2,vlcnt,vlcnt2
      character*137 lstr
      integer*2 buff(256),i1to2
      integer*1 bff(512)
      integer currec,bigend
      common /rdrec/ iund,currec
      common /isend/ bigend,nlen
      equivalence (buff,bff)
      dimension denn(*),pmnn(*),dens(*), fdum(3)

c nnx,nny,nnz    the number of points in x, y and z direction
c ra             real step along x,y and z direction per point
c rx,ry,rz       origin of the grid

      istat = 1
      lstr = ' '

      toang  = 0.52917706d0
      iplat = 0

      currec = -1
      call getrc2(buff,ierr)

c 7-9 number of grid points in x,y,z

      npts1 = int(buff(7))
      npts2 = int(buff(8))
      npts3 = int(buff(9))

      print*,' '
      print*,'O/DSN6 map file:'
      print*,' '
      print*,'npts1 npts2 npts3 ',npts1,npts2,npts3

c 1-3 lower limits for x,y,z

      ior1 = int(buff(1)) 
      ior2 = int(buff(2)) 
      ior3 = int(buff(3)) 

      print*,'orgx,orgy,orgz ',ior1,ior2,ior3

c 4-6 limit range for x,y,z

      iex1 = int(buff(4)) 
      iex2 = int(buff(5)) 
      iex3 = int(buff(6)) 

      print*,'iex1,iex2,iex3 ',iex1,iex2,iex3

c     the grid does not cover the whole unit cell, but just the molecule
c     the grid therefor does not run from 1 to npts in each direction but
c     from ior1 to ior1 + iex1 -1 (in the x direction)
c     we need npts1,npts2,npts3 however to calculate the spacing between
c     two consequetive grid points in all three directions 
c     (together with a,b,c)
c
c     the problem with existing molden maps is they have equally many
c     points to the right and left of the origin (vo)
c     in these new maps the origin is not the center of the map, but
c     the start of the map in all three directions (npts1=npts2=npts3=1)


c 18 F1

      sc  =  1.0d0 / dble(buff(18))
      sca  =  1.0d0 / (dble(buff(18)) * toang)

c     the spacing between two consequetive grid points in all three directions 

c 10-12 cell dimensions (times F1) in x,y,z
c sca gets F1 (buff(18) out again 

      a = sca * dble(buff(10)) / dble(npts1)
      b = sca * dble(buff(11)) / dble(npts2)
      c = sca * dble(buff(12)) / dble(npts3)

      print*,'a b c',sc*dble(buff(10)),sc*dble(buff(11)),
     *               sc*dble(buff(12))

c 13-15 cell angles (times F1) in x,y,z
c sc gets F1 (buff(18) out again 

      alpha = sc * dble(buff(13)) * 3.14159265d0 / 180.0d0
      beta = sc * dble(buff(14)) * 3.14159265d0 / 180.0d0
      gamma = sc * dble(buff(15)) * 3.14159265d0 / 180.0d0

c 16 multiplicative term (times F2) for density value to map to [0,255]
c 17 additive term (times F2) for density value to map to [0,255]
c 19 F2

      prod = dble(buff(16)) / dble(buff(19))
      plus = dble(buff(17)) / dble(buff(19))

      print*,'alpha beta gamma ',sc*dble(buff(13)),sc*dble(buff(14)),
     &                           sc*dble(buff(15))

      v1(1) = a
      v1(2) = 0.0d0
      v1(3) = 0.0d0
    
      v2(1) = dcos(gamma) * b
      v2(2) = dsin(gamma) * b
      v2(3) = 0.0d0
    
      z1 = dcos(beta)
      z2 = (dcos(alpha) - dcos(beta)*dcos(gamma)) / dsin(gamma)
      z3 = dsqrt(1.0 - z1*z1 - z2*z2);

      v3(1) = z1 * c
      v3(2) = z2 * c
      v3(3) = z3 * c
    
c     Convert the origin from grid space to cartesian coordinates

      vo(1) = v1(1) * dble(ior1) + 
     &        v2(1) * dble(ior2) + v3(1) * dble(ior3)
      vo(2) = v2(2) * dble(ior2) + v3(2) * dble(ior3)
      vo(3) =                      v3(3) * dble(ior3)
     
c     normalise basis vectors

      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(v3,1.0d0,1.0d-4)

      isl = 1
      sl(1) = 1.0d0
      sl(2) = b/a
      sl(3) = c/a
      call vnrm(sl)

      r(1) = a*dble(iex1-1)
      r(2) = b*dble(iex2-1)
      r(3) = c*dble(iex3-1)

      print*,'r ',(r(i),i=1,3)
      npts1 = iex1
      npts2 = iex2
      npts3 = iex3

c     spacing between consequetive points in the three directions
c     rf1 = r(1) / dble(iex1-1)
c     rf2 = r(2) / dble(iex2-1)
c     rf3 = r(3) / dble(iex3-1)
c
c     do kc=1,npts3 do ic=1,npts2 do jc=1,npts3
c     coordinates of each grid point (jc,ic,kc) rt(1,2,3)
c     rt(1) = v1(1)*(jc-1)*rf1 + v2(1)*(ic-1)*rf2 + v3(1)*(kc-1)*rf3 + vo(1)
c     rt(2) = v1(2)*(jc-1)*rf1 + v2(2)*(ic-1)*rf2 + v3(2)*(kc-1)*rf3 + vo(2)
c     rt(3) = v1(3)*(jc-1)*rf1 + v2(3)*(ic-1)*rf2 + v3(3)*(kc-1)*rf3 + vo(3)
c
c     we have to change rotbck to:
c      do i=1,3
c         wn(i) = v1(i)*(w1)*r(1) +
c     &           v2(i)*(w2)*r(2) +
c     &           v3(i)*(w3)*r(3) + vo(i)
c      end do
c
c alternatively we could make it a general purpose routine by specifying
c in common comsrf what is the location of the origin in grid coordinates
c

      pmax = -1000000.d0
      pmin = 1000000.d0

      ibrik = npts1/8
      if (npts1.gt.ibrik*8) ibrik = ibrik + 1
      jbrik = npts2/8
      if (npts2.gt.jbrik*8) jbrik = jbrik + 1
      kbrik = npts3/8
      if (npts3.gt.kbrik*8) kbrik = kbrik + 1

      mxind = mx3d*mx3d2

      do k=1,kbrik
         do j=1,jbrik
            do i=1,ibrik

               call getrc2(buff,ierr)

               do iz=1,8
                  if ((iz + (k-1)*8).le.npts3) then
                     do iy=1,8
                        if ((iy + (j-1)*8).le.npts2) then
                           do ix=1,8

                              if ((ix + (i-1)*8).le.npts1) then

                                ipnt = ix        +
     &                                 (iy-1)*8  +
     &                                 (iz-1)*64 
                                den = dble(i1to2(bff(ipnt))) - plus
                                den = den / prod

                                iind = (ix+(i-1)*8)          +
     &                                ((iy+(j-1)*8)-1)*npts1 +
     &                                ((iz+(k-1)*8)-1)*mx3d2 

                                if (iind.le.mxind) then
                                   denn(iind) = den

                                   if (den.gt.pmax) pmax = den
                                   if (den.lt.pmin) pmin = den
                                endif

                              endif
                        
                           end do
                        endif
                     end do
                  endif
               end do

            end do
         end do
      end do

      do i=1,npts3
         pmnn(i) = 100000.d0
      end do

      print*,'Dens Max=',pmax,' Dens Min=',pmin
      rng1 = pmin
      rng2 = pmax

      vlcnt = 1.00d0
      lstr = 'found omap file'
      call inferr(lstr,0)

      ichx = 1

      close(iun)
      call messg(16)

      return

100   istat = 0
      lstr = 'error reading OMAP/DSN6 file'
      call inferr(lstr,0)
      return
      end

      subroutine dpomad(iopt,denn)
      implicit double precision (a-h,o-z)
      logical dolap, lapdbl
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      common /cnthlp/ rng1,rng2,vlcnt,vlcnt2
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      common /vropt/ ivtwo,ihand,ivadd
      dimension origin(3),rt(3)
      dimension denn(*),fdum(3)

      call curs(1)
      wo(1) = 0.0d0
      wo(2) = 0.0d0
      wo(3) = 0.0d0

      do i=1,3
         origin(i) = 0.0d0
         rt(i) = 1.0d0
      end do

      ipsi   = 0
      dolap  = .false.
      lapdbl = .false.
      if (iopt.eq.1) then
         itrans = 0
      else
         itrans = 1
      endif
      mapit  = 0

      ivtwot = ivtwo
      ivtwo = 4

      call mcubes(npts1,npts2,npts3,denn,fdum,mapit,origin,vlcnt,
     &                      vlcnt2,rt,ipsi,dolap,lapdbl,itrans,iun)

      ivtwo = ivtwot

      call curs(0)

      return
      end

      subroutine pltmad(denn)
      implicit double precision (a-h,o-z)
      logical dolap, lapdbl
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      common /cnthlp/ rng1,rng2,vlcnt,vlcnt2
      integer srfmap, srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      common /vropt/ ivtwo,ihand,ivadd
      dimension origin(3),rt(3)
      dimension denn(*),fdum(3)

      call curs(1)
      wo(1) = 0.0d0
      wo(2) = 0.0d0
      wo(3) = 0.0d0

      do i=1,3
         origin(i) = 0.0d0
         rt(i) = 1.0d0
      end do

      ipsi   = 1
      dolap  = .false.
      lapdbl = .false.
      itrans = 0
      mapit  = 0

      ivtwot = ivtwo
      ivtwo = 4

c      print*,"npts ",npts1,npts2,npts3," vlcnt ",vlcnt,vlcnt2
      call mcubes(npts1,npts2,npts3,denn,fdum,mapit,origin,vlcnt,
     &                      vlcnt2,rt,ipsi,dolap,lapdbl,itrans,iun)

      ivtwo = ivtwot

      call curs(0)

      return
      end

      subroutine byter(intin,intout)
      implicit none
      integer intin, intout,bigend,nlen
      common /isend/ bigend,nlen

      if (bigend.eq.1) then
         intout = intin
      else
         call mvbits( intin, 24, 8, intout, 0  )
         call mvbits( intin, 16, 8, intout, 8  )
         call mvbits( intin,  8, 8, intout, 16 )
         call mvbits( intin,  0, 8, intout, 24 )
      endif

      return
      end

      subroutine getrec(buff,buflen,isil,ierr)
      implicit real (a-h,o-z)
      character*4 buff(*)
      integer recln,currec,ierr,buflen
      common /rdrec/ iund,currec

      ierr = 0
      currec = currec + 1

      read(iund,rec=currec,err=100) intin

      call byter(intin,intout)

      recln = intout/4

      if (recln.gt.buflen) goto 100

      do i =1,recln
         read(iund,rec=currec+i,err=100) buff(i)
      end do
   
      currec = currec + recln
      currec = currec + 1

      read(iund,rec=currec,err=100) intin


      call byter(intin,intchk)

      if (intout.ne.intchk) then
         ierr = 1
         if (isil.eq.0) print*,'getrec: error reading file'
      endif

      return

100   ierr = 1
      return
      end

      subroutine bytr2(intin)
      implicit none
      integer bigend,nlen,i
      integer*2 intin(256),intout
      common /isend/ bigend,nlen

      do i=1,256
         if (bigend.ne.1) then
            call mvbits( intin(i),  8, 8, intout, 0 )
            call mvbits( intin(i),  0, 8, intout, 8 )
            intin(i) = intout
         endif
      end do

      return
      end

      integer*2 function i1to2(intin)
      integer*1 intin

      i1to2 = intin
      if (i1to2.lt.0) i1to2 = abs(intin) + 128
      return
      end

      subroutine getrc2(buff,ierr)
      implicit real (a-h,o-z)
      integer*2 buff(256)
      integer currec,ierr
      integer*2 into
      common /rdrec/ iund,currec

      ierr = 0
      currec = currec + 1

      do i =1,256
         read(iund,rec=currec+i,err=100) buff(i)
      end do
   
      call bytr2(buff)
      if (currec.eq.0) then
         if (buff(19).ne.100) goto 100
      endif

      currec = currec + 255

      return

100   ierr = 1
      return
      end

      subroutine fndor(idebug)
      implicit double precision ( a-h,o-z)
      character*137 line
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor,
     &                ixyz98,iopr,isymm,irc,imp2,icntp,itd

      if (idebug.eq.1) print*,'start find orientations'
      ifor = 0
      nzm = 0
      nso = 0
      nio = 0
      nzo = 0 
      istat = 1
      do while(istat.eq.1)
         call searchq(line,'Z-MATRIX (ANGSTROMS',
     &                     'Standard orientation:',
     &                     'Input orientation:',
     &                     'Z-Matrix orientation:',istat)
         if (icdex(line,'Z-MATRIX (ANGSTROMS').ne.0) nzm = nzm + 1
         if (icdex(line,'Standard orientation:').ne.0) nso = nso + 1
         if (icdex(line,'Input orientation:').ne.0) nio = nio + 1
         if (icdex(line,'Z-Matrix orientation:').ne.0) nzo = nzo + 1
      end do

      if (nso.eq.nio) ioropt = 1
      if (nso.eq.0.and.nio.eq.0) ioropt = 0
      if (nso.gt.nio) ioropt = 2
      if (nso.lt.nio) ioropt = 3

      if (idebug.eq.1) then
         print*,'nzm=',nzm,' nso=',nso,' nio=',nio,' nzo=',nzo
      endif

      return
      end

      subroutine wrcubd(npts1,npts2,npts3,ipsi,denn)

c THIS IS REALLY wrcube

      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /grdhlp/ mx3d,mx3d2
      dimension v3(3),o(3),p(3),dtmp(6),denn(*)

      iun = 21

c     normalize the perpendicular vector

      rn = dsqrt(cx*cx+cy*cy+cz*cz)

      v3(1) = cx / rn
      v3(2) = cy / rn
      v3(3) = cz / rn

      p(1) = px
      p(2) = py
      p(3) = pz

c     calculate the origin for the cube

      do i=1,3
         o(i) = p(i) - 0.5d0*(v1(i)*r(1) + v2(i)*r(2) + v3(i)*r(3))
      end do

      write(iun,'(a)') 'Molden generated cube file'

      if (ipsi.eq.0) then
         write(iun,*) 'Density'
      else
         if (ipsi.lt.0) then
            write(iun,'(''Beta Orbital '',i4)') iabs(ipsi)
         else
            write(iun,'(''Orbital '',i4)') ipsi
         endif
      endif

c     number of atoms and origin of the cube

      write(iun,'(i5,4(f12.6))') natoms,(o(i),i=1,3)

c     number of points in each dimension, and voxel size

      write(iun,'(i5,4(f12.6))') npts1,
     &            (v1(i)*r(1)/dble(npts1-1),i=1,3)
      write(iun,'(i5,4(f12.6))') npts2,
     &            (v2(i)*r(2)/dble(npts2-1),i=1,3)
      write(iun,'(i5,4(f12.6))') npts3,
     &            (v3(i)*r(3)/dble(npts3-1),i=1,3)

c     atomic numbers and coordinates of the atoms (in bohrs)

      do i=1,natoms
        write(iun,'(i5,4(f12.6))') nat(i),0.0,(xyz(j,i),j=1,3)
      end do

c     density data

      ij = 0 

      do i=1,npts1
         do j=1,npts2
            ij = ij + 1
            kk = 0
            do while (kk.lt.npts3)
               n = 6
               if (npts3-kk.lt.n) n = npts3-kk
               do k=1,n
                  dtmp(k) = denn((npts3-(kk+k))*mx3d2 + ij)
                  if (dtmp(k).lt.0.0d0) then
                     if (dtmp(k).gt.-1.0d-99) dtmp(k) = -1.0d-99
                  else
                     if (dtmp(k).lt.1.0d-99) dtmp(k) = 1.0d-99
                  endif
               end do
               write(iun,'(6E13.5)') (dtmp(k),k=1,n)
               kk = kk + 6
            end do
         end do
      end do

      return
      end

      subroutine nmrshl
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character*137 line
      common /nmr/    shlnuc(numatm),ihsnmr
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      call searchd(line,'GIAO Magnetic shielding',
     &                 'Magnetic shielding (ppm)',istat)
      if (istat.ne.0) then
          do i=1,natoms
             call redel(line,1)
             i1 = icdex(line,'Isotropic =')
             if (i1.ne.0) then
                 read(line(i1+11:i1+22),'(f11.4)') shlnuc(i)
             endif
             call redel(line,4)
          end do
          ihsnmr = 1

          call search(line,'Total nuclear spin-spin coupling J',istat)
          if (istat.ne.0) ihsnmr = 2
      else
          call rewfil
          call searchd(line,'Total nuclear spin-spin coupling J',
     &                      'Fermi Contact (FC) contribution to J',
     &                      istat)
          if (istat.ne.0) ihsnmr = 2
      endif

      return
      end

      subroutine nmrcpd(idebug,couplj)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character*137 line
      common /nmr/    shlnuc(numatm),ihsnmr
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension couplj(*)

      ntimes = natoms/5
      nt = mod(natoms,5)
      if (nt.ne.0) ntimes = ntimes + 1
      
      ndone = 0
      do l=1,ntimes
         call redel(line,1)
         nitems = 5
         ndo = ndone + nitems
         if (ndo.gt.natoms) nitems = nitems - (ndo - natoms)
         do i=(l-1)*5+1,natoms
            call redel(line,1)
            read(line,'(7x,5f14.10)') 
     &          (couplj((i-1)*natoms+(l-1)*5+j),j=1,nitems)
         end do
         ndone = ndone + nitems
      end do

      if (idebug.eq.1) then
         do i=1,natoms
            print*,'atom ',i,' ',(couplj((i-1)*natoms+j),j=1,i)
         end do
      endif

      return
      end

      subroutine qmtot
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /totchg/ itot

      cor = 0.0d0
      do i=1,natoms
         cor = cor + nat(i)
      end do
      itot = cor - nelecs

      return
      end

      subroutine rdpld(npts1,npts2,npts3,iun,istat,
     &                  denn,dens,pmnn)
      implicit double precision (a-h,o-z)
      common /comsrf/  vo(3), r(3),v1(3),v2(3),v3(3), wo(3),
     &                 sl(3),isl
      common /grdhlp/ mx3d,mx3d2
      common /cnthlp/ rng1,rng2,vlcnt,vlcnt2
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      integer getlin
      character*137 str
      character*137 line
      logical gnreal,gnint
      common /curlin/ line
      dimension denn(*),pmnn(*),dens(*),tmp(3),itmp(3)

      todeg = 45.0d0 / datan(1.0d0)
      toang  = 0.52917706d0
      istat = 1

      call redel(line,1)

      if (linlen(line).ge.5) then
         if (line(1:5).ne."&plot") goto 100
      endif

c do we need to adjust for angstrom or atomic units ?

      do while (getlin(0).eq.1)
         if (linlen(line).eq.44) then

            if (line(1:7).eq."origin=") then
               line = line(8:)
         
               if (gnreal(vo,3,.false.)) then
c                  print*,"vo ",vo(1),vo(2),vo(3)
               endif
            else if (line(1:8).eq."extentx=") then
               line = line(9:)

               if (gnreal(tmp,3,.false.)) then
                  r(1) = tmp(1)
               endif
            else if (line(1:8).eq."extenty=") then
               line = line(9:)
   
               if (gnreal(tmp,3,.false.)) then
                  r(2) = tmp(2)
               endif
            else if (line(1:8).eq."extentz=") then
               line = line(9:)

               if (gnreal(tmp,3,.false.)) then
                  r(3) = tmp(3)
               endif
            else if (line(1:5).eq."npts=") then
               line = line(6:)

               if (gnint(itmp,3,.false.)) then
                  npts1 = itmp(1)
                  npts2 = itmp(2)
                  npts3 = itmp(3)
               endif
            else
               goto 100
            endif
         
         endif

         if (line(1:4).eq."&end") goto 10

      end do

10    continue

      pmax = -1000000.d0
      pmin = 1000000.d0

      do i=1,npts1
         do j=1,npts2
            do k=1,npts3

               if (getlin(0).eq.1) then
c get grid value
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.3) then
                     indx = (k-1)*mx3d2 + npts1*(j-1) + i;
                     denn(indx) = rtype
                     if (rtype.gt.pmax) pmax = rtype
                     if (rtype.lt.pmin) pmin = rtype
                  else
                     goto 100
                  endif
               endif
            end do
         end do
      end do
 
      v1(1) = 1.0d0
      v1(2) = 0.0d0
      v1(3) = 0.0d0
    
      v2(1) = 0.0d0
      v2(2) = 1.0d0
      v2(3) = 0.0d0
    
      v3(1) = 0.0d0
      v3(2) = 0.0d0
      v3(3) = 1.0d0
    
      call vsc1(v1,1.0d0,1.0d-4)
      call vsc1(v2,1.0d0,1.0d-4)
      call vsc1(v3,1.0d0,1.0d-4)

      isl = 1
      sl(1) = 1.0d0
      sl(2) = 1.0d0
      sl(3) = 1.0d0
      call vnrm(sl)

      mxind = mx3d*mx3d2

      close(unit=iun)

      vlcnt = 1.00d0
      line = 'found maestro .plt file'

      call inferr(line,0)

      rng1 = pmin
      rng2 = pmax
      write(6,"(2(a,f7.3))") "pmin ",pmin," pmax ",pmax

      ichx = 1

      return

100   istat = 0
      line = 'error reading .plt file'
      call inferr(line,0)
      return

      end

      subroutine tessa(axis,cosi,sinu,dist,cori,crot,natoms,tol)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      dimension axis(3),dist(numat1),cori(3,numat1),
     &          crot(3,numat1)
      dimension vect1(3),vect2(3),vect3(3)

      if (vlen(axis).lt.tol) stop 'tessa: rotation axis = 0 vector'

      iatoms = natoms
      if (iatoms.gt.numat1) iatoms = numat1

      do k=1,iatoms

         if (dist(k).gt.tol) then

            do j=1,3
               vect1(j) = axis(j)
            end do

            call impsc(vect1,cori(1,k),cott)

            if (dabs(dabs(cott)-1.0d0).gt.tol) then

               call crprod(vect1,cori(1,k),vect2)
               call crprod(vect2,vect1,vect3)
               call impsc(vect3,cori(1,k),sitt)
               call vsc1(vect1,dist(k)*cott,tol)
               call vsc1(vect2,dist(k)*sitt,tol)
               call vsc1(vect3,dist(k)*sitt,tol)
                        
               do j=1,3
                  crot(j,k) = vect1(j) + sinu*vect2(j) + cosi*vect3(j)
               end do

            else

               do j=1,3
                  crot(j,k) = cori(j,k)
               end do

            endif
         else

            do j=1,3
               crot(j,k) = cori(j,k)
            end do

         endif

      end do

      return
      end

      subroutine gaupod(istat,coo,ianz)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (numat1=20000)
      parameter (maxfat=1000)
      parameter (numatm=2000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor,
     &                ixyz98,iopr,isymm,irc,imp2,icntp,itd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character lstr*137
      common /curlin/ lstr
      character*23 stmp
      character*25 sirc
      integer getlin
      logical gnreal
      dimension itemp(numat1),ctemp(3,numat1)
      dimension coo(3,*),ianz(*),r(3)

      toang = 0.52917706d0
      ig98 = 0

      stmp = 'Input orientation:'
      ns = 18
      if (ixyz98.gt.0.and.(ioropt.eq.2)) then
          stmp = 'Standard orientation:'
          ns = 22
      endif

      sirc = 'Item               Value'
      nis = 24
      if (irc.eq.2) then
         sirc = '  Delta-x Convergence'
         nis = 21
      endif

c     istat = 0     no Z-Matrix orientation found
c     istat = -1    no Cartesian Forces found
c     istat = ge 1  both Standard orientation and forces found

c
c     Gaussian forces are in the Z-matrix orientation (not in standard)
c
5     if ((nzm.eq.nzo.or.2*nzm.eq.nzo).and.nzm.gt.0.and.ixyz98.ne.2) 
     &   then
         call search(lstr,'Z-MATRIX (ANGSTROMS',istat)
      elseif (nzo.gt.0.and.ixyz98.ne.2) then
         call search(lstr,'Z-Matrix orientation:',istat)
      else
         call search(lstr,stmp(1:ns),istat)
      endif

      if (istat.eq.0 ) return
      if (index(lstr,'Z-MATRIX (ANGSTROMS').eq.0) then
         call haszm(.false.)
         call bckfil
      else
         call redel(lstr,2)
         call convzmat(coo,ianz,iatoms,1,0,1)
      endif

      call searchd(lstr,'Z-Matrix orientation:',stmp(1:ns),istat)
      if (istat.eq.0) then
         return
      else
         call redel(lstr,2)
         call nxtlin(lstr,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 100
         if (icdex(lstr,'Type').ne.0) ig98 = 1
         call redel(lstr,1)
      endif

      nz = 0

      do while ( .true. )
         if (getlin(1).eq.1) then
            if (lstr(2:4).eq.'---') goto 10
            nz = nz + 1
            ktype = nxtwrd(lstr,nstr,itype,rtype)
            ktype = nxtwrd(lstr,nstr,itype,rtype)
            if (ktype.ne.2) goto 100
            itemp(nz) = itype
            if (ig98.eq.1) then
               ktype = nxtwrd(lstr,nstr,itype,rtype)
               if (ktype.ne.2) goto 100
            endif
            if (gnreal(r,3,.false.)) then
                do j=1,3
                   ctemp(j,nz) = r(j)
                end do
            else
                goto 100
            endif
         endif
      end do

10    continue

c get rid off dummy atoms

      iatoms = 0
      do 400 i=1,nz
         if(itemp(i))400,500,500
500      iatoms = iatoms + 1
         ianz(iatoms) = itemp(i)
         do j=1,3
            coo(j,iatoms) = ctemp(j,i)
         end do
400   continue 

      do i=1,iatoms
c         print*,'coo ',i,(coo(j,i),j=1,3)
         do j=1,3
             coo(j,i) = coo(j,i)/toang
         end do
      end do

c gaussian 98 doesnt do more than 50 atoms forces print

c      if (ixyz98.gt.0.and.iatoms.gt.50.and.iopr.eq.0) goto 100

      if (((nzm.eq.nzo.or.2*nzm.eq.nzo).and.nzm.gt.0)
     &   .or.nzo.gt.0) then
         call searcht(lstr,'Forces (Hartrees/Bohr)',
     &   'Z-MATRIX (ANGSTROMS',
     &   'Z-Matrix orientation:',istat)
      else
         call searchd(lstr,'Forces (Hartrees/Bohr)',
     &   stmp(1:ns),istat)
      endif

      if (istat.eq.0) goto 200
      if (icdex(lstr,'Forces (Hartrees/Bohr)').eq.0) then
           istat = -1
           call bckfil
           return
      endif
      call redel(lstr,2)
      do i=1,iatoms
         call nxtlin(lstr,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200
         read(lstr,'(23x,3(f15.9))',err=200)(fxyz(j,i),j=1,3)
c         print*,(fxyz(j,i),j=1,3)
      end do

      if (irc.ne.0) then

         if (((nzm.eq.nzo.or.2*nzm.eq.nzo).and.nzm.gt.0)
     &      .or.nzo.gt.0) then
            call searcht(lstr,sirc(1:nis),
     &      'Z-MATRIX (ANGSTROMS',
     &      'Z-Matrix orientation:',istat)
         else
            call searchd(lstr,sirc(1:ns),stmp(1:ns),istat)
         endif
         if (istat.eq.0) goto 300

         if (irc.eq.1) then

            if (icdex(lstr,'Item').eq.0) then
                 call bckfil
                 goto 300
            endif

            icv1 = 0
            icv2 = 0
            icv3 = 0
            icv4 = 0

            call redel(lstr,1)
            if (icdex(lstr,'YES').ne.0) icv1 = 1
            call redel(lstr,1)
            if (icdex(lstr,'YES').ne.0) icv2 = 1
            call redel(lstr,1)
            if (icdex(lstr,'YES').ne.0) icv3 = 1
            call redel(lstr,1)
            if (icdex(lstr,'YES').ne.0) icv4 = 1
            icv = icv1 + icv2 + icv3 + icv4
            if (icv.ne.4) goto 5
            istat = 1

         elseif (irc.eq.2) then

            if (icdex(lstr,' NOT met').ne.0) goto 5
            istat = 1

         endif

      endif

      return

100   istat = 0
      return
200   istat =-1 
      return
300   istat = 1
      return
      end

      subroutine plend(title,notitle)
      implicit double precision (a-h,o-z)
      character title*80, keywrd*320, keyhlp*80, keyori*320
      character esc, eot
      logical notitle
      common /keywrd/ keywrd,keyori
      common /rdwr/   iun1,iun2,iun3,iun4,iun5


      esc = char(27)
      eot = char(4)

      keyhlp(1:80)  = title(1:80)
      keyori(1:320) = keywrd(1:320)
      n1 = 1
      n2 = 1
      do i=1,320
         if (i.lt.80) then
           if (title(i:i).eq.'('.or.title(i:i).eq.')') then
             keyhlp(i+n1:80)       = title(i:80-n1)
             keyhlp(i+n1-1:i+n1-1) = char(92)
             n1 = n1 + 1
           endif
         endif
         if (keywrd(i:i).eq.'('.or.keywrd(i:i).eq.')') then
           keyori(i+n2:320)      = keywrd(i:320-n2)
           keyori(i+n2-1:i+n2-1) = char(92)
           n2 = n2 + 1
         endif
      end do

      if (.not.notitle) then
         write(iun4,'(''titleandlogo {'')')
         write(iun4,'(''labelcol'')')
         write(iun4,'(''2100 1700 m'')')
         write(iun4,'(''('',a,'') show'')')keyhlp(1:40)
         write(iun4,'(''2100 1640 m'')')
         write(iun4,'(''('',a,'') show'')')keyhlp(41:80)
         write(iun4,'(''2100 1580 m'')')
         write(iun4,'(''('',a,'') show'')')keyori(1:40)
         write(iun4,'(''2100 1520 m'')')
         write(iun4,'(''('',a,'') show'')')keyori(41:80)
         write(iun4,'(''2100 1460 m'')')
         write(iun4,'(''('',a,'') show'')')keywrd(81:120)
         write(iun4,'(''2100 1400 m'')')
         write(iun4,'(''('',a,'') show'')')keywrd(121:160)
         write(iun4,'(''/print { 0 0 moveto '',
     &       ''4 0 (MOLDEN) ashow } def'')')
         write(iun4,'(''2200 1850 translate'')')
         write(iun4,'(''4.0 4.0 scale'')')
         write(iun4,'(''.95 -.05 0'')')
         write(iun4,
     &       '(''{setgray print -1.5 +1.5 translate } for'')')
         write(iun4,'(''1 setgray print'')')
         write(iun4,'(''} if'')')
      endif
      call plpend

      return
      end

      subroutine plpend
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      write(iun4,'(''/#copies    1 def'')')
      write(iun4,'(''showpage'')')
      write(iun4,'(''39.00 753.00 translate'')')
      write(iun4,'(''-90.00 rotate'')')
      write(iun4,'(''1 setlinewidth'')')
      write(iun4,'(''2 setlinecap'')')
      write(iun4,'(''0.240000 0.240000 scale'')')
      write(iun4,'(''n'')')

      return
      end

      subroutine actamd(inum,ikleur,iopt,idosrf,
     &                  iaton,iatclr,iresid,isurf,
     &            icalf,ncalf,ianf,islu,nchain,iamino,ihet,
     &            iclhet,reson,iams,isal,ishoh,ision)
      implicit double precision (a-h,o-z)
      parameter (mxheta=150)
      common /athlp/ iatoms, mxnat
      common /surf/ natorg,nosncd
      integer reson
      parameter (mxres=42)
      parameter (mxchai=50)
      common /clfhlp/ isndcl(4),iamicl(mxres),ichcol(mxchai)
      integer srfmap,srfloc
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      parameter (mxaln=20)
      common /palign/  nalign,istst(mxaln),istch(mxaln),istres(mxaln),
     &                 istcol(mxaln),istptr(mxaln)
      common /cllab/  iclon,iclpnt(4)
      logical bbone,dowat,doion
      dimension iaton(*),iatclr(*),iresid(*),isurf(*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),ihet(*),
     &          iclhet(*),reson(*),iams(*),isal(*)

      if (inum.le.0.and.inum.ge.-3) return

      iclup = 0
      icllow = 0
      if (iclon.eq.1) then
         icllow = iclpnt(1)
         iclup = icllow + 7
      endif 

      dowat = .false.
      doion = .false.

      if (inum.lt.-3) then
         iht = abs(inum) + 1
      endif

      if (-ishoh.eq.inum) dowat = .true.
      if (ision.lt.0.and.ision.ge.inum) doion = .true.

      iactkl = ikleur
      if (ikleur.eq.0.and.inum.gt.0) then
          if (nalign.gt.0) then
             do i=1,nalign
                if (inum.le.istres(i)) then
                    iactkl = istcol(i) + 1
                    goto 10
                endif
             end do
10           continue
          else
             if (iamino(inum).ne.0) iactkl = iamicl(iamino(inum))
          endif
      endif
c      if (ikleur.eq.0.and.inum.lt.-3) iactkl = 1
      if (ikleur.eq.0.and.inum.lt.-3) then
          if (iht.le.mxheta) then
             iactkl = iclhet(iht)
          endif
      endif

      if (inum.gt.0) then
          if (iopt.eq.0) then
              reson(inum) = 0
          else
              if (ifogl.eq.1.and.idosrf.eq.1) iams(inum) = 1
              reson(inum) = 1
          endif
      elseif (inum.lt.-3) then
          if (iht.le.mxheta) then
             ihet(iht) = iopt
             if (iopt.ne.0) iclhet(iht) = iactkl
          endif
      endif

      do i=1,iatoms
          
          ir = iresid(i)
          if (ir.eq.inum.or.
     &      (dowat.and.ir.lt.inum.and.((ir.gt.ision.and.ision.lt.0).or.
     &      ision.gt.0)).or.(doion.and.iresid(i).le.inum)) then
             if (iopt.eq.1) then
                    iaton(i) = 1
                    if (i.lt.icllow.or.i.gt.iclup) iatclr(i) = iactkl
                    if (idosrf.eq.1) isurf(i) = 1
             else
                if (iamino(abs(inum)).gt.23) then
                    n = 6
                else
                    n = 3
                endif
                bbone = .false.
                do j=1,n
                    if (i.eq.icalf(j,abs(inum))) bbone = .true.
                end do
                if (bbone.and.ihet(isal(abs(inum))+1).eq.0) then
                     do k=1,nchain
                         do j=ianf(k),islu(k)
                            do l=1,n
                               if (i.eq.icalf(l,j)) 
     &                         iatclr(icalf(l,j)) = ichcol(k)
                            end do
                         end do
                     end do
                else
                    if (i.lt.icllow.or.i.gt.iclup) iaton(i) = 0
                endif
             endif
          endif
      end do

      return
      end

      subroutine actexd(que,lque,ikleur,idosrf,ncalf,iamino)
      implicit double precision (a-h,o-z)
      dimension iamino(*)
      logical oque
      integer que(20)

      do i=1,ncalf
         oque = .true.
         do j=1,lque
            iq = que(j)
            ia = iamino(i+j-1)
            if (iq.ne.21.and.iq.ne.ia) then
                if(.not.(((iq.eq.9.or.iq.eq.10).and.ia.eq.21) .or.
     &            ((iq.eq.13.or.iq.eq.14).and.ia.eq.22) )) then
                   oque = .false.
                endif
            endif
         end do
         if (oque) then
            do j=1,lque
               call actami(i+j-1,ikleur,1,idosrf)
            end do
         endif
      end do

      return
      end

      subroutine aacod(vrad,ires,str,nstr,istsrf,iresid,isurf,
     &                 ncalf,ianf,islu,nchain,iamino,ihet,reson,
     &                 isal,irsnr,achain);
c Process commands from the residue commands window
      implicit double precision (a-h,o-z)
      parameter (mxheta=150)
      parameter (mxres=42)
      common /athlp/ iatoms, mxnat
      integer reson
      common /hlpsrf/ npts1,npts2,npts3,srfmap,srfloc,ifogl,itsrf
      character*1 achain
      common /aachlp/ scndst(3),onelet(21)
      common /amino/  aminos(mxres)
      common /helpar/ helrod, ihtype
      common /surf/ natorg,noscnd

      integer que(20)
      logical doque,oclr,oami,oorg,ohasc
      integer srfmap,srfloc
      character keywrd*160
      character*3 aminos,scndst
      character*20 amique
      character*1 onelet,ach
      character*(*) str
      dimension iresid(*),isurf(*)
      dimension iamis(mxres)
      dimension ianf(*),islu(*),iamino(*),ihet(*),reson(*),
     &          isal(*),irsnr(*),achain(*)


      data scndst/'HEL','BET','BCK'/

      data onelet/'G','A','S','C','T','I','V','M','D','N','L','K',
     &            'E','Q','P','R','H','F','Y','W','X'/


      toang  = 0.52917706d0
      keywrd = str(1:nstr)
      call tocap(keywrd,nstr)

      if (index(keywrd,'SURON').ne.0) then
          istsrf = 1
          if (index(keywrd,'MAPPED').ne.0) srfmap = 3
          if (index(keywrd,'LOCAL').ne.0) srfloc = 1
          if (index(keywrd,'GLOBAL').ne.0) srfloc = 0
          call inferr('Switching on Surface Drawing',0)
          return
      endif
      if (index(keywrd,'SUROFF').ne.0) then
          istsrf = 0
          srfmap = 0
          srfloc = 1
          call inferr('Switching off Surface Drawing',0)
          return
      endif

      do i=1,mxres
         iamis(i) = 0
      end do

      doque = .false.
      ibr1 = index(keywrd,'(')
      ibr2 = index(keywrd,')')
      if (ibr1.ne.0.and.ibr2.ne.0.and.ibr2.gt.ibr1) then
          nque = ibr2-ibr1-1
          if (nque.gt.20) then
             call inferr('(Too long) !',0)
          else
             doque = .true.
             amique = keywrd(ibr1+1:ibr2-1)
             do i=ibr1,ibr2
                keywrd(i:i) = ' '
             end do
             lque = 0
             do i=1,nque
                kque = 0
                do j=1,21
                   if (amique(i:i).eq.onelet(j)) then
                      lque = lque + 1
                      que(lque) = j
                      kque = 1
                   endif
                end do
                if (amique(i:i).ne.' '.and.kque.eq.0) 
     &          call inferr('Unrecognised Symbol(s) ignored !',0)
             end do
          endif
      endif

      oami = .false.
      oclr = (index(keywrd,'NOT').ne.0)
      if (oclr) oami = .true.
      if (index(keywrd,'ALL').ne.0.or.
     &    index(keywrd,'CLEAR').ne.0) then
         oami = .true.
         i1 = 1
         i2 = mxres
         if (index(keywrd,'AMINO').ne.0) i2 = 23
         if (index(keywrd,'NUCL').ne.0) i1 = 24
         do i=i1,i2
            iamis(i) = 1
         end do
      endif

      if (index(keywrd,'CLEAR').ne.0) oclr = .true.

      if (istsrf.eq.1) then
          idosrf = 1
      else
          idosrf = 0
      endif
      if (index(keywrd,'SURF').ne.0) idosrf = 1

      if (idosrf.eq.1.and.oclr) then
          call clrsrf
          return
      endif

      if (idosrf.eq.1.and.oami.and.ifogl.ne.1) then
          call allsrf(1,0,1,4)
          return
      endif

c ires may alternatively contain color

      ikleur = ires
      if (ikleur.lt.1.or.ikleur.gt.15) ikleur = 0
      ii = index(keywrd,'COL')
      if (ii.ne.0) then
          keywrd(ii:ii+2) = '   '
      endif

      if (index(keywrd,'NEIGH').ne.0) then
         rdist = 3.0d0
         ires1 = index(keywrd,'=') 
         if (ires1.ne.0) 
     &     rdist = reada(keywrd,ires1+1,len(keywrd))*1
         rdist = rdist / toang
         call proxim(iresid(ires),rdist,0,idosrf)
      endif

      if (index(keywrd,'ROD').ne.0) then
         ihtype = 1
         vrad = .0d0
      endif
      if (index(keywrd,'BAL').ne.0) then
         ihtype = 0
         vrad = .9d0 / toang
      endif

      if (index(keywrd,'-').eq.0) then
         do ii=1,3
            if (index(keywrd,scndst(ii)).ne.0) then
               inclbb = 0
               if (index(keywrd,'INCL').ne.0) inclbb = 1
               if (oclr) then
                  ihet(ii) = 0
                  call acthel(0,ii-1,ikleur,inclbb)
               else
                  ihet(ii) = 1
                  call acthel(1,ii-1,ikleur,inclbb)
               endif
            endif
         end do
      endif

      if (index(keywrd,'CHA').ne.0.or.
     &    index(keywrd,'POS').ne.0.or.
     &    index(keywrd,'POL').ne.0) then
         oami = .true.
         iamis(12) = 1
         iamis(16) = 1
         iamis(17) = 1
      endif
      if (index(keywrd,'CHA').ne.0.or.index(keywrd,'NEG').ne.0.or.
     &    index(keywrd,'POL').ne.0) then
         oami = .true.
         iamis( 9) = 1
         iamis(13) = 1
      endif
      if (index(keywrd,'POL').ne.0) then
         oami = .true.
         iamis(10) = 1
         iamis(14) = 1
         iamis(3) = 1
         iamis(5) = 1
      endif
      if (index(keywrd,'ARO').ne.0) then
         oami = .true.
         iamis(18) = 1
         iamis(19) = 1
         iamis(20) = 1
      endif
      if (index(keywrd,'ALI').ne.0) then
         oami = .true.
         iamis(1) = 1
         iamis(2) = 1
         iamis(6) = 1
         iamis(7) = 1
         iamis(11) = 1
         iamis(15) = 1
      endif

      do i =1,mxres
         if (index(keywrd,aminos(i)).ne.0) then
            oami = .true.
            iamis(i) = 1
         endif
      end do

      if (oami) then
         do i=1,mxres
            if (iamis(i).eq.1) then
               do j=1,islu(nchain)
                  if (iamino(j).eq.i) then
                     if (oclr) then
                        call actami(j,ikleur,0,idosrf)
                     else
                        call actami(j,ikleur,1,idosrf)
                     endif
                  endif
               end do
            endif
         end do
      else
         iscnd = -1
         if (index(keywrd,'HEL').ne.0) then
             iscnd = 0
         elseif (index(keywrd,'BET').ne.0) then
             iscnd = 1
         elseif (index(keywrd,'RND').ne.0) then
             iscnd = 3
         endif
         ires1 = reada(keywrd,1,len(keywrd))*1
         ires2 = index(keywrd,'-') 
         istar = index(keywrd,'*')
         ichp = index(keywrd,':')
         if (ires2.ne.0) then
            ires2 = reada(keywrd,ires2+1,len(keywrd))*1
         else
            ires2 = ires1
         endif
         oorg = ohasc(ncalf,achain)
         if (ichp.ne.0) then
            ach = keywrd(ichp+1:ichp+1)
            iach = ichar(ach)
            if (iach.ge.65.and.iach.le.90) then
               ifnd = 0
               do j=1,ncalf
                  if (achain(j).eq.ach) ifnd = 1
               end do
               if (ifnd.eq.0) then
                  call inferr('Chain '//ach//' NOT found!',0)
                  ich = 1
                  ires1 = 0
                  oorg = .false.
               endif
            elseif (iach.eq.32) then
               ach = achain(1)
               ich = 1
            else
               ich = reada(keywrd,ichp+1,len(keywrd))*1
               if (ich.lt.1.or.ich.gt.nchain) then
                   call inferr('Invalid Chain number',0)
               else
                   ach = achain(ich)
               endif
            endif
         else
            ach = ' '
            ich = 1
         endif
         if (istar.ne.0.and.ichp.ne.0) then
            if (istar.lt.ichp) then
              if (.not.oorg) then
                ires1 = irsnr(ianf(ich))
                ires2 = irsnr(islu(ich))
              else
                ires1 = 0
                ires2 = 0
                do j=1,ncalf
                   if (achain(j).eq.ach) then
                      if (ires1.eq.0) then
                         ires1 = j
                      endif
                      ires2 = j
                   endif
                end do
              endif
            endif
         endif
         if (ires1.ne.0) then
            if (iscnd.eq.-1) then
               if (index(keywrd,'PRINT').ne.0) then
                  do i=ires1,ires2
                     do j=1,ncalf
                        if (irsnr(j).eq.i)
     &                    print*,i,' ',isal(j)
                     end do
                  end do
               else
                  do i=ires1,ires2
                     if (oorg.and.ach.ne.' ') then
                        do j=1,ncalf
                           if (irsnr(j).eq.i.and.achain(j).eq.ach)
     &                        call actami(j,ikleur,1,idosrf)
                        end do
                     else
                        do j=1,ncalf
                           if (irsnr(j).eq.i)
     &                        call actami(j,ikleur,1,idosrf)
                        end do
                     endif
                  end do
               endif
            else
               iatoms = noscnd
               do i=1,iatoms
                  if (isurf(i).eq.1) idosrf = 1
               end do
               natorg = 0
               do i=ires1,ires2
                  isal(ianf(ich)+i-1) = iscnd
               end do
               call actcal(1)
               do i=1,ncalf
                  reson(i) = 0
               end do
               do i=4,mxheta
                  ihet(i) = 0
               end do
               call ribbon(0,0,1,0,0,0,0)
               call ribbon(1,0,1,0,0,0,0)
               call ribbon(2,0,1,0,0,0,0)
               call ribbon(3,0,1,0,0,0,0)
               do i=1,4
                  ihet(i) = 1
               end do
            endif
         endif
      endif

      if (doque) call actexp(que,lque,ikleur,idosrf)

      if (idosrf.eq.1.and..not.oclr) then
          if (ifogl.eq.1) then
             call initsrf
          else
             call connlp(1.0d0,0,4)
          endif
      endif

      return
      end

      logical function ohasc(ncalf,achain)
      implicit double precision (a-h,o-z)
      character*1 achain
      dimension achain(*)

      ohasc = .true.
      ihasc = 0
      do i=1,ncalf
         if (achain(i).eq.' ') ihasc = ihasc + 1
      end do
      if (ihasc.eq.ncalf) ohasc = .false.

      return
      end

      subroutine proxid(itarg,thresh,ikleur,idosrf,coo,iresid,ishoh)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      logical uniq,debug
      parameter (mxnb=1000)
      dimension ineigh(mxnb)
      dimension coo(3,*),iresid(*)

      debug = .false.

      do i=1,mxnb
         ineigh(i) = 0
      end do
      numnb = 0

      do i=1,iatoms
         if (iresid(i).eq.itarg) then
            do j=1,iatoms
               if (iresid(j).ne.itarg.and.iresid(j).ne.-ishoh) then
                  dist = dsqrt(dist2(coo(1,i),coo(1,j)))
                  if (dist.lt.thresh) then
                     uniq = .true.
                     do k=1,numnb
                        if (ineigh(k).eq.iresid(j)) uniq = .false.
                     end do
                     if (uniq) then
                        numnb = numnb + 1
                        ineigh(numnb) = iresid(j)
                     endif
                  endif
               endif
            end do
         endif
      end do
      
      if (debug) then
         print*,'neighbouring residues'
         do i=1,numnb
            print*,i,' ',ineigh(i)
         end do
      endif

      do i=1,numnb
         call actami(ineigh(i),ikleur,1,idosrf)
      end do

      return
      end

      subroutine proxd(itarg,backb,adds,idocom,thresh,
     &                 coo,iresid,iaton,iconn,iams,ishoh)
      implicit double precision (a-h,o-z)
      parameter (maxdm=20)
      parameter (maxrs=100)
      parameter (mxcon=10)
      parameter (mxra=100)
      logical dozme,notcon,ispdb
      common /getpnt/irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &               iconv,ircus,dozme
      common /athlp/ iatoms, mxnat
      common /distmn/ rdm(maxdm),idmon(2,maxdm),ndm
      integer backb,adds
      dimension irs(mxra),irss(maxrs)
      dimension coo(3,*),iresid(*),iaton(*),iconn(mxcon+1,*),iams(*)

      call clrmon

      do i=1,maxdm
         rdm(i) = 1.0d10
      end do
      ndm = maxdm

      nrss = 0
      toang  = 0.52917706d0

      ispdb = (ipdbon.eq.1)

      ir1 = iresid(itarg)
      nrs = 0
      if (ispdb) then
         do i=1,iatoms
            ir2 = iresid(i)
            if (ir1.eq.ir2) then
               if (nrs.lt.mxra) then
                  nrs = nrs + 1
                  irs(nrs) = i
               endif
            endif
         end do
      else
         nrs = 1
         irs(1) = itarg
      endif

      do i=1,iatoms
        ir2 = iresid(i)
        if (iresid(i).gt.0.or.iresid(i).lt.-3) then
          if ((.not.ispdb.and.i.ne.itarg).or.
     &             (ispdb.and.ir1.ne.ir2)) then
c     &             (backb.eq.1.and.ir1.ne.ir2.and.ir2.gt.0)) then
           do n=1,nrs
             in = irs(n)
             dist = dsqrt(dist2(coo(1,i),coo(1,in)))
             if (dist.lt.thresh/toang) then
                ihrss = 0
                do j=1,nrss
                   if (irss(j).eq.ir2) ihrss = 1
                end do
                if (ihrss.eq.0) then
                   if (nrss.lt.maxrs) then
                      nrss = nrss + 1
                      irss(nrss) = ir2
                   endif
                endif
             endif
             do j=1,ndm
                if (dist.lt.rdm(j)) then
                    notcon = .true.
                    do k=1,iconn(1,in)
                       kk = iconn(1+k,in)
                       if (kk.eq.i) then
                           notcon = .false.
                       else
                          do l=1,iconn(1,iabs(kk))
                             ll = iconn(1+l,iabs(kk))
                             if (ll.eq.i) then
                                notcon = .false.
                             elseif (ll.ne.in) then
                                do m=1,iconn(1,iabs(ll))
                                   mm = iconn(1+m,iabs(ll))
                                   if (mm.eq.i) then
                                      notcon = .false.
                                   elseif (mm.ne.kk.and.backb.eq.1) then
                                      do nm=1,iconn(1,iabs(mm))
                                        km = iconn(1+nm,iabs(mm))
                                        if (km.eq.i) notcon = .false.
                                      end do
                                   endif
                                end do
                             endif
                          end do
                       endif
                    end do
                    if (iresid(i).eq.-ishoh) notcon = .true.
                    if (notcon) then
                       do m=ndm-1,j,-1
                          idmon(1,m+1) = idmon(1,m)
                          idmon(2,m+1) = idmon(2,m)
                          rdm(m+1) = rdm(m)
                       end do
                       idmon(1,j) = in
                       idmon(2,j) = i
                       rdm(j) = dist
                       goto 100
                    endif
                endif
             end do
100          continue

           end do
          endif
        endif
      end do
      

      if (ispdb) then
         do i=1,nrss
            if (irss(i).ne.-ishoh) call actami(irss(i),0,1,0)
            if (adds.eq.1.and.irss(i).gt.0) iams(irss(i)) = 1
         end do
         do i=1,maxdm
            ir = iresid(idmon(2,i))
            if (ir.eq.-ishoh) then
               iaton(idmon(2,i)) = 1
            else
c               call actami(iresid(idmon(2,i)),0,1,0)
            endif
         end do
      else
         do i=1,maxdm
            iaton(idmon(2,i)) = 1
         end do
      endif

      if (idocom.eq.1) then
         call domcon(ndm,1)
      else
         call clrmon
      endif

      return
      end

      subroutine mulddd(vdwr,moddma,idomul,idodma,p,qat,iconn)

c THIS IS REALLY muldma

      implicit double precision(a-h,o-z)
c
c     Mulliken Charges and/or Distributed Multipole Analysis
c
c
c max rank hexadecapole, l=4
c
c explicit energy expressions only available upto hexadecapole
c d functions contribute upto l=4
c we will be missing some higher contributions from f-functions
c
c total number of functions is (lmax+1)**2
c
c for l you have k=-l,-l+1,..,0,l-1,l
c for k.ne.0 the Qlk (or Rlk) are complex:
c
c Ql, k = 1/sqrt(2)(-1)**k {Qlkc + i Qlks}
c Ql,-k = 1/sqrt(2) {Qlkc - i Qlks}
c
c same thing for the regular solid harmonics Rlk, both expressions
c are used shifting overlap density contributions to atomic sites
c
c an s-p overlap kan have a maximum rank of 1(=0+1) but the shifted
c multipole doesnt converge at the same rank, but much higher
c
c moddma
c        = 0 stadard dma; all overlap density shifted to atoms
c        = 1 sites consist of atoms + points halfway bonds
c        = 2 sites consist of atoms + centers of gaussian products
c

      parameter (mxcon=10)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (mxel=100)
      parameter (mxsite=300)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
      parameter (mxint=225)
      logical debug,dohb
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /gauhlp/ d6to5(6,5),f10to7(10,7),g15to9(15,9),
     &                plmn(35),lmn(3,35)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /pseudo/ ipseud,ivale(numatm)
      common /coord / xyz(3,numatm)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      character*8   ctag,ctagd
      common /multip/ qmom(lmaxf,mxsite),car(3,mxsite),ctag(mxsite),
     &                nsites
      common /setp/   pgau(3),p1(3),p2(3),gam,pigam2,fac
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /athlp/  iatoms, mxnat

      dimension co1(3),co2(3),ca(35),cb(35),s2(mxint,34)
      dimension p(*),q(lmaxf), vdwr(*), temp(3),dp(3),dpn(3),ltmp(3)
      dimension shlp(mxint),shlpd(mxint,3)
      dimension qat(*),iconn(mxcon+1,*)

      if (isgau.ne.1) return

      debug = .false.
      dohb = .true.
      bohr = 0.529177249d+00
      rt3 = dsqrt(3.0d0)
      rt5 = dsqrt(5.0d0)
      rt8 = dsqrt(8.0d0)
      rt35 = dsqrt(35.0d0)
      cf = 5.2917715d-11*1.601917d-19/3.33564d-30
      ctagd = '        '

      call denini
      call setcon

      if (idomul.eq.1) then
         do i=1,3
            dp(i) = 0.0d0
            dpn(i) = 0.0d0
         end do
         do i=1,natoms
            if (ipseud.eq.1) then
               qat(i) = dble(ivale(i))
            else
               if (nat(i).eq.99) then
                  qat(i) = 0.0d0
               else
                  qat(i) = dble(nat(i))
               endif
            endif
            do j=1,3
               dpn(j) = dpn(j) + qat(i)*xyz(j,i)
            end do
         end do
         ihasq = 1
      endif

      if (idodma.eq.1) then
         nsites = natoms
         if (nsites.gt.mxsite) then
            nsites = mxsite
            write(iun3,*) 'exceded max. # of sites, increase mxsite'
         endif
         do i=1,natoms
            if (ipseud.eq.1) then
               qmom(1,i) = dble(ivale(i))
            else
               qmom(1,i) = dble(nat(i))
            endif
            ctag(i) = ctagd
            ctag(i) = elemnt(nat(i))
            do j=2,lmaxf
               qmom(j,i) = 0.0d0
            end do
            do j=1,3
               car(j,i) = xyz(j,i)
            end do
         end do

         if (moddma.eq.1) then
            call xyzcoo(1,0,0)
            call doconn
            if (dohb) call dohcon(0)
            do i=1,natoms
                do k=1,iconn(1,i)
                   j = abs(iconn(1+k,i))
c               do j=i+1,natoms
c                   ttot = 0.0d0
c                   do k=1,3
c                       temp(k) = xyz(k,j) - xyz(k,i)
c                       ttot = ttot + temp(k)*temp(k)
c                   end do
c                   dvdw = (vdwr(nat(i))+vdwr(nat(j))) / bohr
c                   dvdw2 = dvdw*dvdw
c                   if (ttot.lt.dvdw2) then
                   if (j.gt.i) then
                       if (nsites.lt.mxsite) then
                          nsites = nsites + 1
                          ctag(nsites) = ctagd
                          ctag(nsites)(1:2) = elemnt(nat(i))
                          ctag(nsites)(3:4) = ' -'
                          ctag(nsites)(5:6) = elemnt(nat(j))
                          do l=1,3
                             temp(l) = xyz(l,j) - xyz(l,i)
                             car(l,nsites) = xyz(l,i) + temp(l)/2.0d0
                          end do
                          do l=1,lmaxf
                             qmom(l,nsites) = 0.0d0
                          end do
                        else
                          write(iun3,*) 'exceded max. # of sites'
                        endif
                   endif
               end do
            end do
         endif
      endif
c
c     loop over shell pairs.
c

      iao = 0
      do ishell = 1, nshell
        isha = shella(ishell)
        isht = shellt(ishell)
        ishc = shellc(ishell)
        ishn = shelln(ishell)
        iat = jan(ishell)
        co1(1) = gx(ishell)
        co1(2) = gy(ishell)
        co1(3) = gz(ishell)
        call qtype(isht,ishc,ibeg,iend)
        jao = 0
        iendt = iend

        do jshell = 1,ishell
c        do jshell = 1,nshell
          jsha = shella(jshell)
          jsht = shellt(jshell)
          jshc = shellc(jshell)
          jshn = shelln(jshell)
          jat = jan(jshell)
          co2(1) = gx(jshell)
          co2(2) = gy(jshell)
          co2(3) = gz(jshell)
          call qtype(jsht,jshc,jbeg,jend)

          nrank = isht+jsht
          if (nrank.gt.lmax) nrank = lmax

          s1or2 = 2.0d0
          if (ishell.eq.jshell) s1or2 = 1.0d0

          jendt = jend

c===================================================
c         i loop over primitive gaussians

          do igauss=1,ishn
             ex1 = exx(isha+igauss-1)
             call fcij(isht,isha,isha+igauss-1,shladf(ishell),ca)

c            j loop over primitive gaussians

             
             jdim = jshn
             if (ishell.eq.jshell) jdim = igauss

             do jgauss=1,jdim
c             do jgauss=1,jshn
                iend = iendt
                jend = jendt
                ex2 = exx(jsha+jgauss-1)
                call fcij(jsht,jsha,jsha+jgauss-1,shladf(jshell),cb)
                call psetup(ex1,co1,ex2,co2)
                f1or2 = 1.0d0
                if (ishell.eq.jshell.and.igauss.ne.jgauss) f1or2 = 2.0d0

c
c loop over basis functions
c
              do i=1,lmaxf
                q(i) = 0.0d0
              end do

              kk = 0
              do ifun=ibeg,iend
                 do jfun=jbeg,jend
                   kk = kk + 1

                   call sint(lmn(1,ifun),lmn(1,jfun),s)
                   shlp(kk) = ca(ifun)*cb(jfun)*s

                   do id=1,3
                      do idd=1,3
                         ltmp(idd) = lmn(idd,ifun)
                         if (idd.eq.id) ltmp(idd) = ltmp(idd) + 1
                      end do
                      call sint(ltmp,lmn(1,jfun),s0)
                      shlpd(kk,id) = ca(ifun)*cb(jfun)*s0
                   end do

                   if (idodma.eq.1) then
                      nn = 1
                      if (nrank.ge.1) nn = 3
                      if (nrank.ge.2) nn = 9
                      if (nrank.ge.3) nn = 19
                      if (nrank.ge.4) nn = 34

                      do i=1,nn
                         call 
     &                dsint(lmn(1,ifun),lmn(1,jfun),lmn(1,1+i),ss)
                         s2(kk,i) = ca(ifun)*cb(jfun)*ss
                      end do

                   endif

                 end do
              end do

              call purdf(isht,jsht,ibeg,jbeg,iend,jend,shlp)
              iend = iendt
              jend = jendt
              call purdf(isht,jsht,ibeg,jbeg,iend,jend,shlpd(1,1))
              iend = iendt
              jend = jendt
              call purdf(isht,jsht,ibeg,jbeg,iend,jend,shlpd(1,2))
              iend = iendt
              jend = jendt
              call purdf(isht,jsht,ibeg,jbeg,iend,jend,shlpd(1,3))

              if (idodma.eq.1) then
                 nn = 1
                 if (nrank.ge.1) nn = 3
                 if (nrank.ge.2) nn = 9
                 if (nrank.ge.3) nn = 19
                 if (nrank.ge.4) nn = 34
                 do i=1,nn
                    iend = iendt
                    jend = jendt
                    call purdf(isht,jsht,ibeg,jbeg,iend,jend,s2(1,i))
                 end do
              endif

              kk = 0
              iiao = iao
              do ifun=ibeg,iend
               iiao = iiao + 1
               jjao = jao
              do jfun=jbeg,jend
               jjao = jjao + 1
                kk = kk + 1

                fcom = ca(ifun)*cb(jfun)*p((jjao-1)*mxorb+iiao)
     &                 *s1or2*f1or2
                fcomh = p((jjao-1)*mxorb+iiao)
     &                 *s1or2*f1or2

c q0
                call sint(lmn(1,ifun),lmn(1,jfun),s)
                q(1) = q(1) - fcomh*shlp(kk)

                do id=1,3
                   dp(id) = dp(id) - 
     &               (shlpd(kk,id) + co1(id)*shlp(kk))*fcomh
                end do

                if (idodma.eq.1) then

                   if (nrank.ge.1) then
c q10,q11c,q11s
                      q(2) = q(2) - fcomh*s2(kk,3)
   
                      q(3) = q(3) - fcomh*s2(kk,1)

                      q(4) = q(4) - fcomh*s2(kk,2)
                   endif


                   if (nrank.ge.2) then
c q20,q21c,q21s,q22c,q22s

                      q(5) = q(5) - 
     &                       fcomh*(s2(kk,6)-0.5d0*(s2(kk,4)+s2(kk,5)))
                      q(6) = q(6) - rt3*fcomh*s2(kk,8)
                      q(7) = q(7) - rt3*fcomh*s2(kk,9)
                      q(8) = q(8) - 0.5d0*rt3*fcomh*(s2(kk,4)-s2(kk,5))
                      q(9) = q(9) - rt3*fcomh*s2(kk,7)
                   endif

                   if (nrank.ge.3) then
c q30,q31c,q31s,q32c,q32s,q33c,q33s

                      q(10) = q(10) - fcomh*
     &                        (s2(kk,12) - 1.5d0*(s2(kk,15)+ s2(kk,18)))
                      q(11) = q(11) - fcomh*rt3/rt8*
     &                        (4.0d0*s2(kk,16) - s2(kk,10) - s2(kk,13))
                      q(12) = q(12) - fcomh*rt3/rt8*
     &                        (4.0d0*s2(kk,17) - s2(kk,14) - s2(kk,11))
                      q(13) = q(13) - fcomh*0.5d0*rt3*rt5*
     &                        (s2(kk,15) - s2(kk,18))
                      q(14) = q(14) - fcomh*rt3*rt5*s2(kk,19)
                      q(15) = q(15) - fcomh*rt5/rt8*
     &                        (      s2(kk,10) - 3.0d0*s2(kk,13))
                      q(16) = q(16) - fcomh*rt5/rt8*
     &                        (3.0d0*s2(kk,14) -       s2(kk,11))
                   endif

                   if (nrank.ge.4) then
c q40,q41c,q41s,q42c,q42s,q43c,q43s,q44c,q44s

                      q(17) = q(17) - fcomh*0.125d0*
     &                     (8.0d0*s2(kk,22)+3.0d0*(s2(kk,20)+s2(kk,21))+
     &                     6.0d0*s2(kk,29)-24.0d0*(s2(kk,30)+s2(kk,31)))
                      q(18) = q(18) - fcomh*rt5/rt8*
     &                     (4.0d0*s2(kk,27)-3.0d0*(s2(kk,24)+s2(kk,33)))
                      q(19) = q(19) - fcomh*rt5/rt8*
     &                     (4.0d0*s2(kk,28)-3.0d0*(s2(kk,26)+s2(kk,32)))
                      q(20) = q(20) - fcomh*0.25d0*rt5*
     &                     (s2(kk,21)-s2(kk,20)+
     &                      6.0d0*(s2(kk,30)-s2(kk,31)))
                      q(21) = q(21) - fcomh*0.5d0*rt5*
     &                       (6.0d0*s2(kk,34)-s2(kk,23)-s2(kk,25))
                      q(22) = q(22) - fcomh*rt35/rt8*
     &                       (s2(kk,24)-3.0d0*s2(kk,33))
                      q(23) = q(23) - fcomh*rt35/rt8*
     &                       (3.0d0*s2(kk,32)-s2(kk,26))
                      q(24) = q(24) - fcomh*0.125d0*rt35*
     &                       (s2(kk,20)+s2(kk,21)-6.0d0*s2(kk,29))
                      q(25) = q(25) - fcomh*0.5d0*rt35*
     &                       (s2(kk,23)-s2(kk,25))
                   endif
                end if

               end do
               end do
c--- end loop basis functions

               if (debug) then
                  write(iun3,'(6i4)') iat,jat,
     &              ishell,jshell,isha+igauss-1,jsha+jgauss-1
                  write(iun3,'(f10.6)') q(1)
                  if (idodma.eq.1) then
                    write(iun3,'(3f10.6)') (q(i),i=2,4)
                    write(iun3,'(5f10.6)') (q(i),i=5,9)
                    write(iun3,'(7f10.6)') (q(i),i=10,16)
                    write(iun3,'(9f10.6)') (q(i),i=17,25)
                  endif
               endif

               if (idomul.eq.1) then
                  if (iat.eq.jat) then
                      qat(iat) = qat(iat) + q(1)
                  else
                      qat(iat) = qat(iat) + 0.5d0*q(1)
                      qat(jat) = qat(jat) + 0.5d0*q(1)
                  endif
               endif
               if (idodma.eq.1) then
                  if (iat.eq.jat) then
c
c atomic contribution
c
                      do i=1,(nrank+1)**2
                         qmom(i,iat) = qmom(i,iat) + q(i)
                      end do
                  else
c
c partition and shift overlap contribution
c
                      if (moddma.le.1.or.
     &                   (moddma.eq.2.and.nrank.eq.0)) then
                         call partq(q,nrank,pgau)
                      else
                        ttot = 0.0d0
                        do k=1,3
                            temp(k) = xyz(k,jat) - xyz(k,iat)
                            ttot = ttot + temp(k)*temp(k)
                        end do
                        dvdw = (vdwr(nat(iat))+vdwr(nat(jat))) / bohr
                        dvdw2 = dvdw*dvdw
                        if (ttot.lt.dvdw2) then
                          if (nsites.lt.mxsite) then
c
c Create New site at P
c
                            nsites = nsites + 1
                            ctag(nsites) = ctagd
                            ctag(nsites)(1:2) = elemnt(nat(iat))
                            ctag(nsites)(3:4) = ' -'
                            ctag(nsites)(5:6) = elemnt(nat(jat))
                            do k=1,3
                               car(k,nsites) = pgau(k)
                            end do
                            do k=1,lmaxf
                               qmom(k,nsites) = q(k)
                            end do
                          else
                            if (nsites.ge.mxsite) then
            write(iun3,*) 'exceded max. # of sites, increase mxsite'
                            endif
                            call partq(q,nrank,pgau)
                          endif
                        else
                            call partq(q,nrank,pgau)
                        endif
                      endif
                  endif
               endif
             end do
          end do
c--- end loops primitives

c===================================================

        jao = jao + (jend-jbeg+1)
        jend = jendt
        end do
        iao = iao + (iend-ibeg+1)
        iend = iendt
      end do
c---- end loop shells

      if (idomul.eq.1) then
         write(iun3,'(a)') ' '
         write(iun3,'(24x,a)') 'Mulliken Charges'
         write(iun3,'(24x,a)') '================'
         write(iun3,'(a)') ' '
         qtot = 0.0d0
         do i=1,natoms
            write(iun3,'(14x,a2,a,f8.4)') elemnt(nat(i)),' ',qat(i)
c            write(iun3,'(14x,a2,a,f10.6)') elemnt(nat(i)),' ',qat(i)
            qtot = qtot + qat(i)
         end do

         write(iun3,'(a)') ' '
         write(iun3,'(a,f8.4)') 'Sum of Mulliken Charges: ',qtot

         if (.true.) then
         write(iun3,'(a)') ' '
         write(iun3,'(24x,a)') 'Dipole moment (Debye)'
         write(iun3,'(24x,a)') '======================='
         write(iun3,'(17x,a)') 
     &            '      X           Y           Z          Scalar'
         write(iun3,'(a)') ' '
         write(iun3,'(a,4(f11.4,1x))') 'Nuclear          ',
     &       (dpn(i)*cf,i=1,3),vlen(dpn)*cf
         write(iun3,'(a,4(f11.4,1x))') 'Electronic       ',
     &       (dp(i)*cf,i=1,3),vlen(dp)*cf
         do i=1,3
            dipo(i) = (dp(i) + dpn(i))
         end do
         ihsdp = 1
         do i=1,3
            dp(i) = (dp(i) + dpn(i))*cf
         end do
         write(iun3,'(a,4(f11.4,1x))') 'Total            ',
     &     (dp(i),i=1,3),vlen(dp)
         endif
         write(iun3,'(a)') ' '
         
      endif

      if (idodma.eq.1) then
      write(iun3,*) ' '
         if (moddma.eq.0) then
            write(iun3,*) 
     &    'stadard dma; all overlap density shifted to atoms'
         elseif (moddma.eq.1) then
            write(iun3,*) 
     &    'DMA sites consist of atoms + points halfway bonds'
         else
            write(iun3,*) 
     &    'DMA sites consist of atoms + centers of gaussian products'
         endif
         write(iun3,'(a)') ' '
         write(iun3,'(24x,a)') '     DMA        '
         write(iun3,'(24x,a)') '================'
         write(iun3,'(a)') ' '
         write(iun3,'(a,i4)') 'Number of sites ',nsites
         write(iun3,'(a)') ' '
         do i=1,nsites
            write(iun3,'(14x,a8,a,3f10.4)') ctag(i),' ',
     &                                     (car(j,i),j=1,3)
            write(iun3,'(f10.6)') qmom(1,i)
            write(iun3,'(3f10.6)') (qmom(j,i),j=2,4)
            write(iun3,'(5f10.6)') (qmom(j,i),j=5,9)
            write(iun3,'(7f10.6)') (qmom(j,i),j=10,16)
            write(iun3,'(9f10.6)') (qmom(j,i),j=17,25)
         end do
      endif

      return
      end
   
      subroutine stind(p,qat)
c THIS IS REALLY stint
      implicit double precision(a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      parameter (mxel=100)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /gauhlp/ d6to5(6,5),f10to7(10,7),g15to9(15,9),
     &                plmn(35),lmn(3,35)
      common /orbhlp/ mxorb,iuhf,ispd
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /pseudo / ipseud,ivale(numatm)
      common /coord / xyz(3,numatm)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      character*2 elemnt
      common /elem/   elemnt(mxel)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      dimension co1(3),co2(3),ca(35),cb(35)
      dimension p(*),qat(*)

      call denini

c
c     loop over shell pairs.
c

      do i=1,natoms
         if (ipseud.eq.1) then
            qat(i) = dble(ivale(i))
         else
            qat(i) = dble(nat(i))
         endif
      end do

      iao = 0
      do ishell = 1, nshell
        isha = shella(ishell)
        isht = shellt(ishell)
        ishc = shellc(ishell)
        ishn = shelln(ishell)
        iat = jan(ishell)
        co1(1) = gx(ishell)
        co1(2) = gy(ishell)
        co1(3) = gz(ishell)
        call qtype(isht,ishc,ibeg,iend)

        do ifun=ibeg,iend
          iao = iao + 1
          jao = 0
c        do jshell = 1,ishell
        do jshell = 1,nshell
          jsha = shella(jshell)
          jsht = shellt(jshell)
          jshc = shellc(jshell)
          jshn = shelln(jshell)
          jat = jan(jshell)
          co2(1) = gx(jshell)
          co2(2) = gy(jshell)
          co2(3) = gz(jshell)
          call qtype(jsht,jshc,jbeg,jend)

          do jfun=jbeg,jend
          jao = jao + 1
          s12 = 0.0d0
          t12 = 0.0d0

c===================================================
c         i loop over primitive gaussians

          do igauss=1,ishn
             ex1 = exx(isha+igauss-1)
             call fcij(isht,isha,isha+igauss-1,shladf(ishell),ca)

c            j loop over primitive gaussians

             do jgauss=1,jshn
                ex2 = exx(jsha+jgauss-1)
                call fcij(jsht,jsha,jsha+jgauss-1,shladf(jshell),cb)
                call psetup(ex1,co1,ex2,co2)

                call sint(lmn(1,ifun),lmn(1,jfun),s)
                s12 = s12 + ca(ifun)*cb(jfun)*s

c
c Kinetic energy integral
                call tint(lmn(1,ifun),lmn(1,jfun),t,ex2)
                t12 = t12 + ca(ifun)*cb(jfun)*t
             end do
          end do

         if (iat.eq.jat) then
             qat(iat) = qat(iat) - p((jao-1)*mxorb+iao)*s12
         else
             qat(iat) = qat(iat) - 0.5d0*p((jao-1)*mxorb+iao)*s12
             qat(jat) = qat(jat) - 0.5d0*p((jao-1)*mxorb+iao)*s12
         endif
        write(*,'(2(a,i3,a,i3,a,f16.8))') 's(',ifun,',',jfun,') = ',s12,
     &            't(',ifun,',',jfun,') = ',t12
c===================================================
          end do
          end do

        end do
      end do

c
c Nuclear attraction integrals, we have these, they are the same integrals
c We need for the electrostatic potential
c We sum over the atoms and multiply by atom number.
c
c      do i=1,natoms
c          print*,'atom ',i,' ========V=========='
c          call espot(xyz(1,i),xyz(2,i),xyz(3,i),epje,1)
c          print*,'==================='
c      end do

      return
      end
   
      subroutine qtype(itype,icons,ibeg,iend)
      implicit double precision(a-h,o-z)

      ibeg = 1
      if (itype.eq.4) then
          ibeg = 21
          iend = 35
      elseif (itype.eq.3) then
          ibeg = 11
          iend = 20
      elseif (itype.eq.2) then
          iend = 10
          if (icons.eq.2) ibeg = 5
      elseif (itype.eq.1) then
          iend = 4
          if (icons.eq.1) ibeg = 2
      elseif (itype.eq.0) then
          iend = 1
      endif

      return
      end

      subroutine tint(lmn1,lmn2,t12,alpha2)
      implicit double precision(a-h,o-z)
      dimension lmn1(3),lmn2(3)
      dimension lmnb(3)

      t12 = 0.0d0

      do i=1,3

c a2(2l2+1)<0|0>

          call sint(lmn1,lmn2,s12)
          t12 = t12 + alpha2*(2.0d0*lmn2(i)+1.0d0)*s12

c -2a2**2<0|+2>

          do j=1,3
             lmnb(j) = lmn2(j)
          end do
          lmnb(i) = lmnb(i) + 2
          call sint(lmn1,lmnb,s12)
          t12 = t12 - 2.0d0*alpha2*alpha2*s12

c -0.5l2(l2-1)<0|-2>

          if (lmn2(i).gt.1) then
             do j=1,3
                lmnb(j) = lmn2(j)
             end do
             lmnb(i) = lmnb(i) - 2
             call sint(lmn1,lmnb,s12)
             t12 = t12 - 0.5d0*lmn2(i)*(lmn2(i)-1)*s12
          endif

      end do
       
      return
      end

      subroutine dsint(lmn1,lmn2,ipinc,s12)
      implicit double precision(a-h,o-z)
      common /setp/ p(3),p1(3),p2(3),gam,pigam2,fac
      dimension lmn1(3),lmn2(3),ipinc(3)
      dimension xyzi(3)

      do i=1,3
         xyzi(i) = 0.0d0
      end do

      do j=1,3
         do i=0,lmn1(j)+lmn2(j)
            ip = i + ipinc(j)
            if (ip-(ip/2)*2.eq.0) 
     &      xyzi(j) = xyzi(j) + (fkxyz(p1,p2,lmn1(j),lmn2(j),i,j)
     &                *ifac2(ip-1)*pigam2/(2.0d0*gam)**(dble(ip)/2.0d0))
         end do
      end do

      s12 = fac*xyzi(1)*xyzi(2)*xyzi(3)

      return
      end

      subroutine sint(lmn1,lmn2,s12)
      implicit double precision(a-h,o-z)
      common /setp/ p(3),p1(3),p2(3),gam,pigam2,fac
      dimension lmn1(3),lmn2(3)
      dimension xyzi(3)

      do i=1,3
         xyzi(i) = 0.0d0
      end do

      do j=1,3
         do i=0,(lmn1(j)+lmn2(j))/2
            xyzi(j) = xyzi(j) + (fkxyz(p1,p2,lmn1(j),lmn2(j),2*i,j)
     &                *ifac2(2*i-1)*pigam2/(2.0d0*gam)**i)
         end do
      end do

      s12 = fac*xyzi(1)*xyzi(2)*xyzi(3)

      return
      end

      subroutine psetup(alpha1,c1,alpha2,c2)
      implicit double precision(a-h,o-z)
      common /setp/ p(3),p1(3),p2(3),gam,pigam2,fac
      dimension c1(3),c2(3)

      pi = 4.d0*datan(1.d0)
      gam = alpha1 + alpha2

      d2 = 0.0d0
      do i=1,3
         c12 = c1(i) - c2(i)
         d2 = d2 + c12*c12
         p(i) = (alpha1*c1(i) + alpha2*c2(i)) / gam
         p1(i) = p(i) - c1(i)
         p2(i) = p(i) - c2(i)
      end do
      
      fac = dexp(-alpha1*alpha2*d2/gam)

      pigam2 = dsqrt(pi/gam)

      return
      end

      double precision function fkxyz(pa,pb,l1,l2,k,iaxis)
      implicit double precision(a-h,o-z)
      dimension pa(3),pb(3)

      fkxyz = 0.0d0

      do i=0,l1
         do j=0,l2
            if (i+j.eq.k) then
               prod = fioverj(l1,i)*fioverj(l2,j)
               if (l1-i.gt.0) prod = prod*(pa(iaxis)**(l1-i))
               if (l2-j.gt.0) prod = prod*(pb(iaxis)**(l2-j))
               fkxyz = fkxyz + prod
            endif
         end do
      end do

      return
      end

      integer function ifac(n)
       
      ifac = 1
      do i=1,n
        ifac = ifac * i
      end do

      return
      end
          
      integer function ifac2(n)
       
      ifac2 = 1
      do i=1,n,2
        ifac2 = ifac2 * i
      end do

      return
      end
          
      double precision function fioverj(i,j)

      fioverj = dble(ifac(i)) / dble((ifac(j) * ifac(i-j)))

      return
      end

      double precision function drfmol(arg)
      implicit double precision(a-h,o-z)
      common /merrf/ p,a(5)
      data p/0.3275911d0/
      data a/0.254829592d0,-0.284496736d0,1.421413741d0,
     &      -1.453152027d0,1.061405429d0/
      
c      check this
      t = 1.0d0/(1.0d0 + p*arg)
      tn = t
      poly = a(1)*tn
      do i=2,5
         tn = tn*t
         poly = poly + a(i)*tn
      end do
      
      drfmol = 1.0d0 -poly*dexp(-arg*arg) 

      return
      end

      subroutine partq(q,nrank,p)
      implicit double precision (a-h, o-z)
      parameter (mxsite=300)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
      parameter (rtol=1.0d-4)
      character*8   ctag
      common /multip/ qmom(lmaxf,mxsite),car(3,mxsite),ctag(mxsite),
     &                nsites
      dimension q(*), p(3), r2(mxsite), iquiv(mxsite)

      lfun = (nrank+1)*(nrank+1)
c
c Partition and shift overlap multipoles to nearest center(s)
c
      r2min = 100000.0d0
      ihit = 0

      do i=1,nsites
         r2(i) = (p(1)-car(1,i))**2 + (p(2)-car(2,i))**2 +
     &           (p(3)-car(3,i))**2
         if (r2(i).lt.r2min) then
             r2min = r2(i)
             ihit = i
         endif
      end do

      if (ihit.ne.0) then
         
c Check for other centers with the same distance to P

         nequiv = 1
         iquiv(nequiv) = ihit
         do i=1,nsites
            if (i.ne.ihit.and.dabs(r2(i)-r2min).lt.rtol) then
                nequiv = nequiv + 1
                iquiv(nequiv) = i
            endif
         end do
         
c Partition multipoles over equivalent centers

         if (nequiv.gt.1) then
            do i=1,lfun
                q(i) = q(i)/dble(nequiv)
            end do
         endif

c Shift multipoles to equivalent centers

         do i=1,nequiv
            k = iquiv(i)
            call shiftq(q,0,nrank,p(1)-car(1,k),p(2)-car(2,k),
     &            p(3)-car(3,k),qmom(1,k),lmax)
         end do
      endif

      return
      end

      subroutine shiftq(q,lomin,lomax,x,y,z,qn,lnmax)
      implicit double precision (a-h, o-z)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
 
c
c shift multipoles q of ranks lmin to lmax at P 
c (center of overlap gaussian) to new point S (qn)
c
c          l  k  -               - (1/2)
c          -- -- | (l+m)   (l-m) |
c Qlm(S) = \  \  | |   | * |   | |  Qkq(P) * Rl-k,m-1(S-P)
c          /  /  | (k+q)   (k-q) |
c          -- -- -               -
c         k=0 q=-k
c
c x,y,z = (S-P)
c
c for k.ne.0 the Qlk (or Rlk) are complex:
c
c Ql, k = 1/sqrt(2)(-1)**k {Qlkc + i Qlks}
c Ql,-k = 1/sqrt(2) {Qlkc - i Qlks}
c
 
      dimension q(*), qn(*), r(lmaxf)

      call solidh(x,y,z,lnmax,r)

c  ln is rank of target multipole

      do ln = lomin,lnmax
         kn = ln*ln+1
         mn = 0

c  l is rank of source multipoles

100      do l = lomin,min(ln,lomax)
            lr = ln - l
            l2 = l*l
            lr2 = lr*lr
            do m = max(-l,mn-lr),min(l,mn+lr)
                if (m.eq.0) then
                  qc =  q(l2+1)
                  qs =  0.0d0
                else
                  qc =  q(l2+2*iabs(m))
                  qs =  q(l2+2*iabs(m)+1)
                  if (m.lt.0) qs = -qs
                endif

                mr = mn - m

                if (mr.eq.0) then
                  rc =  r(lr2+1)
                  rs =  0.0d0
                else
                  rc =  r(lr2+2*iabs(mr))
                  rs =  r(lr2+2*iabs(mr)+1)
                  if (mr.lt.0) rs = -rs
                endif

                fac = 0.5d0*qrsgn(mn)/(qrsgn(m)*qrsgn(mr))
                root = dsqrt(fioverj(ln-mn,l-m)*fioverj(ln+mn,l+m))

                qn(kn) = qn(kn) + root*fac*(qc*rc-qs*rs)
                if (mn.gt.0)
     &              qn(kn+1) = qn(kn+1) + root*fac*(qc*rs+qs*rc)
            end do
         end do
 
         mn = mn + 1
         kn = ln*ln+2*mn
         if (mn.le.ln) goto 100
      end do

      return
      end

      double precision function qrsgn(m)
      implicit double precision (a-h, o-z)
      parameter (hrt2=0.7071067811865475244d0)

      if (m.eq.0) then
         qrsgn = 0.5d0
      elseif (m.lt.0) then
         qrsgn = hrt2
      else
         if (mod(m,2).eq.0) then
            qrsgn = hrt2
         else
            qrsgn = -hrt2
         endif
      endif

      return
      end

      subroutine solidh (x,y,z,j,r)
      implicit double precision (a-h, o-z)
 
c  computes regular solid harmonics r**k ckq(theta,phi) for ranks k up
c  to j, if j > =  0;
c  or irregular solid harmonics r**(-k-1) ckq(theta,phi) for ranks k up
c  to |j|, if j < 0.
 
      dimension r(*)
 
c  locations in r are used as follows:
 
c        1    2    3    4    5    6    7    8    9   10   11  ...
c  kq  =  00   10   11c  11s  20   21c  21s  22c  22s  30   31c ...
 
c  r(k,0) is real and is left in location k**2 + 1.
c  r(k,mc) and r(k,ms) are sqrt(2) times the real and imaginary parts
c  respectively of the complex solid harmonic r(k,-m)*  =  (-1)**m r(k,m),
c  and are left in locations k**2 + 2m and k**2 + 2m + 1 respectively.
c
c  S.l. Price et al, Molecular Physics, 1984, 52, 987: Table 1
c
c  R00  = 1
c 
c  R10  = z
c  R11c = x
c  R11s = y
c
c  R20  = 0.5(3z**2-r**2)
c  R21c = dsqrt(3)xz
c  R21s = dsqrt(3)yz
c  R22c = 0.5*dsqrt(3)(x**2-y**2)
c  R22s = dsqrt(3)xy
c
c  etc ..
c

      l = abs(j)

      rr = x*x + y*y + z*z
 
      if (j.lt.0) then
c  irregular
        rr = 1.0/rr
        rfx = x*rr
        rfy = y*rr
        rfz = z*rr
        r(1) = dsqrt(rr)
        r(2) = rfz*r(1)
        r(3) = rfx*r(1)
        r(4) = rfy*r(1)
 
      else
c  regular
        r(1) = 1.0
        r(2) = z
        r(3) = x
        r(4) = y
        rfz = z
        rfx = x
        rfy = y
      endif
 
c  remaining values are found using recursion formulae, relating
c  the new set n to the current set k and the previous set p.
 
      k = 1
10    n  = k + 1
      ln = n*n + 1
      lk = k*k + 1
      lp = (k-1)**2 + 1
      a2kp1 = k+k + 1
 
c  obtain r(k+1,0) from r(k,0)*r(1,0) and r(k-1,0)
 
      r(ln) = (a2kp1*r(lk)*rfz-k*rr*r(lp))/(k+1)
 
      m = 1
      ln = ln + 1
      lk = lk + 1
      lp = lp + 1
      if (k.eq.1) goto 40
 
c  obtain r(k+1,m) from r(k,m)*r(1,0) and r(k-1,m)
 
20    r(ln) = (a2kp1*r(lk)*rfz-dsqrt(dble((k+m)*(k-m)))*rr*r(lp))
     &                /dsqrt(dble((n+m)*(n-m)))
      r(ln+1) = (a2kp1*r(lk+1)*rfz-dsqrt(dble((k+m)*(k-m)))*rr*r(lp+1))
     &                /dsqrt(dble((n+m)*(n-m)))
      m  = m + 1
      ln = ln + 2
      lk = lk + 2
      lp = lp + 2
      if (m.lt.k) goto 20
 
c  obtain r(k+1,k) from r(k,k)*r(1,0)
 
40    r(ln) = dsqrt(dble(n+k))*r(lk)*rfz
      r(ln+1) = dsqrt(dble(n+k))*r(lk+1)*rfz
      ln = ln + 2
 
c  obtain r(k+1,k+1) from r(k,k)*r(1,1)
 
      s = dsqrt(dble(n+k))/dsqrt(dble(n+n))
      r(ln) = s*(rfx*r(lk)-rfy*r(lk+1))
      r(ln+1) = s*(rfx*r(lk+1)+rfy*r(lk))
 
      k = k + 1
      if (k.lt.l) goto 10
      return
 
      end

      subroutine caldid(q,coo)
      implicit double precision (a-h, o-z)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /athlp/ iatoms, mxnat
      dimension q(*),coo(3,*)

      do i=1,3
         dipo(i) = 0.0d0
      end do

      do i=1,iatoms
         dipo(1) = dipo(1) + coo(1,i)*q(i)
         dipo(2) = dipo(2) + coo(2,i)*q(i)
         dipo(3) = dipo(3) + coo(3,i)*q(i)
      end do
 
      ihsdp = 2

      return
 
      end

      subroutine prtdip
      implicit double precision (a-h, o-z)
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      cf = 5.2917715d-11*1.601917d-19/3.33564d-30

      write(iun3,'(a)') '   '
      if (ihsdp.eq.1) then
         write(iun3,'(a)') 
     &         'Dipole moment calculated from Wavefunction:'
      elseif (ihsdp.eq.2) then
         write(iun3,'(a)') 
     &         'Dipole moment calculated from partial charges:'
      elseif (ihsdp.eq.3) then
         write(iun3,'(a)') 
     &         'Dipole moment evaluated  from Monopoles and Dipoles:'
      endif
      write(iun3,'(a)') '   '

      write(iun3,'(a)') ' '
      write(iun3,'(24x,a)') 'Dipole moment (Debye)'
      write(iun3,'(24x,a)') '======================='
      write(iun3,'(17x,a)') 
     &         '      X           Y           Z          Scalar'
      write(iun3,'(a)') ' '
      write(iun3,'(a,4(f11.4,1x))') '                 ',
     &    (dipo(i)*cf,i=1,3),vlen(dipo)*cf

      return
      end

      subroutine oginid(r,adjus,natoms,nat,icol,xsym,ysym,zsym,
     &                  vdwr,cnst,npts1,npts2,iorb,dens)
      implicit double precision (a-h,o-z)
      dimension r(*),xsym(*),ysym(*),zsym(*),vdwr(*)
      dimension nat(*),icol(*),dens(*)

      idum = 0

      return
      end

      subroutine vdwlj(ev,nac,iac,nad,iad,coo,iconn,ityp,forces,potscl,
     &                 iopt)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxamb=1590)
      integer ambcls
      common /typpar/ ambchg(mxamb),ambcls(mxamb)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      parameter (mxgff=72)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      common /athlp/  iatoms, mxnat
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      integer*2 ityp
      dimension ded(3),vr(3)
      dimension coo(3,*),ityp(*),iconn(mxcon+1,*),
     &          forces(3,*),potscl(*),iopt(*),
     &          nac(*),nad(*),iac(mxac,*),iad(mxad,*)

      ev = 0.0e0
      v14sc = 0.5e0

      do i=1,iatoms

         i1 = int(ityp(i))
         if (i1.gt.0) then
            il = ambcls(i1)
            vdwr1 = ambvdwr(il)
            vdwe1 = ambvdwe(il)
         elseif (i1.le.0) then
            i1 = iabs(i1)
            vdwr1 = gfvdw(1,i1)
            vdwe1 = gfvdw(2,i1)
         endif

         do j=i+1,iatoms
            potscl(j) = 1.0e0
         end do

         do j=1,iconn(1,i)
            jj = iconn(j+1,i)
            if (jj.gt.0) then
               potscl(jj) = 0.0e0
            endif
         end do

         do j=1,nac(i)
            potscl(iac(j,i)) = 0.0e0
         end do

         do j=1,nad(i)
            potscl(iad(j,i)) = v14sc
         end do

         if (vdwe1.ne.0.0e0) then

           do k=i+1,iatoms

            if (potscl(k).ne.0.0e0.and.
     &          (iopt(i).eq.1.or.iopt(k).eq.1) ) then

               i2 = int(ityp(k))
               if (i2.gt.0) then
                  kl = ambcls(i2)
                  vdwr2 = ambvdwr(kl)
                  vdwe2 = ambvdwe(kl)
               elseif (i2.le.0) then
                  i2 = iabs(i2)
                  vdwr2 = gfvdw(1,i2)
                  vdwe2 = gfvdw(2,i2)
               endif

               if (vdwe2.ne.0.0e0) then

                  do j=1,3
                     vr(j) = coo(j,i) - coo(j,k)
                  end do
 
                  if (box) call reddis(vr)

                  rv2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

                  if (rv2.le.cutof2) then

c          [ (Rmin)**12       (Rmin)**6 ]
c e = eps  [ (----)     - 2.0 (----)    ]
c          [ ( r  )           ( r  )    ]


c alternatively we could precalculate these vdwr(il,kl)
c                                           vdwe(il,kl)
                     rsum = vdwr1 + vdwr2
                     epsm = sqrt(vdwe1 * vdwe2)

                     epsm = epsm * potscl(k)
                     rv   = sqrt(rv2)
		     rs2  = rsum*rsum
		     rs3  = rs2*rsum
                     p6   = (rs3*rs3) / (rv2*rv2*rv2)
                     p12  = p6 * p6

                     e    = epsm * (p12 - 2.0e0*p6)
                     de   = epsm * (p12 - p6) * (-12.0e0/rv)

                     de   = de / rv

                     do j=1,3
                        ded(j) = de * vr(j)
                     end do

                     ev   = ev + e
   
                     do j=1,3
                        forces(j,i) = forces(j,i) + ded(j)
                        forces(j,k) = forces(j,k) - ded(j)
                     end do

                  end if

               end if
            end if
           end do
         end if
      end do

      return
      end

      subroutine maxmid(npts1,npts2,scale,dens)
      implicit double precision (a-h,o-z)

c THIS IS REALLY maxmin

      logical euclid, yes
      common /cntval/ cntval, euclid, yes, icnt, iflag
      dimension dens(*)

      fact1 = 1.d0 / (npts1-1)
      fact2 = 1.d0 / (npts2-1)

      do 20 i=2,npts1-1
          do 20 j=2,npts2-1
              l = j + (i-1)*npts2
              k = l - npts2
              m = l + npts2
              if (dens(l).ge.dens(l-1)) goto 20
              if (dens(l).ge.dens(l+1)) goto 20
              if (dens(l).ge.dens(k-1)) goto 20
              if (dens(l).ge.dens(k  )) goto 20
              if (dens(l).ge.dens(k+1)) goto 20
              if (dens(l).ge.dens(m-1)) goto 20
              if (dens(l).ge.dens(m  )) goto 20
              if (dens(l).ge.dens(m+1)) goto 20
c
c found a minimum
c
              x = 1.d0 - (i-1)*fact1
              y = 1.d0 - (j-1)*fact2
              if (euclid) then
                 z = 0.d0
              else
                 z = dens(l)*scale
              endif
              call eulstr(x,y,z,dens(l))
  20  continue

      do 40 i=2,npts1-1
          do 40 j=2,npts2-1
              l = j + (i-1)*npts2
              k = l - npts2
              m = l + npts2
              if(dens(l).le.dens(l-1)) goto 40
              if(dens(l).le.dens(l+1)) goto 40
              if(dens(l).le.dens(k-1)) goto 40
              if(dens(l).le.dens(k  )) goto 40
              if(dens(l).le.dens(k+1)) goto 40
              if(dens(l).le.dens(m-1)) goto 40
              if(dens(l).le.dens(m  )) goto 40
              if(dens(l).le.dens(m+1)) goto 40
c
c found a maximum
c
              x = 1.d0 - (i-1)*fact1
              y = 1.d0 - (j-1)*fact2
              if (euclid) then
                 z = 0.d0
              else
                 z = dens(l)*scale
              endif
              call eulstr(x,y,z,dens(l))
  40  continue

      return
      end

      subroutine hcoodd(istat,ioatms,nstrt,iaddh,
     &                  ipdbt,coo,ianz,iaton,iresid,iconn,
     &                  icalf,ncalf,ianf,islu,nchain,iamino)
c hcoord, hbond en vadar hebben geen ioadd provisie
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat

      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      integer*2 ipdbt
      logical hashy
      dimension tmp(3),ipdbt(*)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*)

      istat = 1

c     nhbond in A.U. Atomic Units

      if (iatoms+ncalf.le.mxnat.and.ncalf.gt.0) then
         nhatm = iatoms
         do k=1,nchain
c
c           first residue
c
	  ianfk = ianf(k)
          if (icalf(2,ianf(k)).eq.0) ianfk = ianfk+1
          if (iamino(ianfk).le.23.and.ianfk.ge.nstrt.and.
     &        ianfk.gt.0) then
            hashy = .false.
            if (iaddh.eq.1) hashy = .true.
            do n=1,iconn(1,icalf(2,ianfk))
               nn = abs(iconn(n+1,icalf(2,ianfk)))
               if (ianz(nn).eq.1.and.nn.gt.ioatms) then
                  hashy = .true.
                  icalf(4,ianf(k)) = nn
                  iaton(nn) = 0
                  iresid(nn) = ianf(k)
               endif
            end do
            if (.not.hashy.and.iamino(ianfk).ne.15.and.
     &         iamino(ianfk).ne.0) then
               call bckok(ibckok,ianfk,2)
               if (ibckok.eq.1) then
                  icor = 0
                  do j=1,iconn(1,icalf(2,ianfk))
                     jc = iconn(1+j,icalf(2,ianfk))
                     jc = iabs(jc)
                     if (iresid(jc).lt.-3) then
                        if (ianz(jc).eq.6) then
                           do jj=1,iconn(1,jc)
                              jo = iconn(1+jj,jc)
                              jo = iabs(jo)
                              if (ianz(jo).eq.8) then
                                icor = jo
                              endif
                           end do
                        endif
                     endif
                  end do
                  nhatm = nhatm + 1
                  icalf(4,ianfk) = nhatm
                  if (icor.ne.0) then
                     do j=1,3
                        tmp(j) = 2.0d0*coo(j,icalf(2,ianf(k))) 
     &                         - coo(j,icalf(1,ianf(k)))
     &                         - coo(j,icor)
                     end do
                     tmpl = vlen(tmp)
                     do j=1,3
                        coo(j,nhatm) = coo(j,icalf(2,ianf(k))) 
     &                                 +(tmp(j)/tmpl)*1.89d0
                     end do
                  else

                     do j=1,3
                        tmp(j) = coo(j,icalf(1,ianf(k))) 
     &                         - coo(j,icalf(3,ianf(k)))
                     end do
                     tmpl = vlen(tmp)
                     if (icalf(2,ianf(k)).gt.0) then
                        do j=1,3
                           coo(j,nhatm) = coo(j,icalf(2,ianf(k))) 
     &                                    +(tmp(j)/tmpl)*1.89d0
                        end do
                     endif
                  endif
                  iaton(nhatm) = 0
                  ianz(nhatm) = 1
                  iconn(1,nhatm) = 1
                  m = icalf(2,ianf(k))
                  if (m.ne.-1) then
                     iconn(2,nhatm) = m
                     iconn(1,m) = iconn(1,m) + 1
                     iconn(1+iconn(1,m),m) = nhatm
                  endif
                  iresid(nhatm) = ianf(k)
                  ipdbt(nhatm) = 1
               endif
            endif
            ihb(1,ianfk) = 0
            ihb(2,ianfk) = 0
           endif
c
c           other residues
c
           if (ianfk.ge.nstrt) then
            do i=ianfk+1,islu(k)
             if (iamino(i).le.23) then
               icalf(4,i) = 0
               hashy = .false.
               do n=1,iconn(1,icalf(2,i))
                  nn = abs(iconn(n+1,icalf(2,i)))
                  if (ianz(nn).eq.1.and.nn.gt.ioatms) then
                     hashy = .true.
                     icalf(4,i) = nn
                     iaton(nn) = 0
                     iresid(nn) = i
                  endif
               end do

               if (.not.hashy.and.iamino(i).ne.15) then

                  m = icalf(2,i)
                  idxc = icalf(3,i-1)
                  idxo = 0

                  do j=1,iconn(1,idxc)
                     kk = abs(iconn(j+1,idxc))
                     if (ianz(kk).eq.8.and.kk.gt.ioatms) idxo = kk
                  end do

                  call bckok(ibckok,i,2)

                  if (idxo.ne.0.and.ibckok.eq.1) then

                     nhatm = nhatm + 1
                     icalf(4,i) = nhatm

                     do j=1,3
                        tmp(j) = coo(j,idxc) - coo(j,idxo)
                     end do

                     tmpl = vlen(tmp)

                     do j=1,3
                        coo(j,nhatm) = coo(j,m) +
     &                             (tmp(j) / tmpl)*1.89d0
                     end do

                     iaton(nhatm) = 0
                     ianz(nhatm) = 1
                     iconn(1,nhatm) = 1
                     iconn(2,nhatm) = m
                     iconn(1,m) = iconn(1,m) + 1
                     iconn(1+iconn(1,m),m) = nhatm
                     iresid(nhatm) = i
                     ipdbt(nhatm) = 1
                  else
                     icalf(4,i) = 0
                  endif

               endif

               ihb(1,i) = 0
               ihb(2,i) = 0
              endif
            end do
           endif
         end do
         iatoms = nhatm
      else
         istat = 0
         do i=1,ncalf
            if (iamino(i).le.23) icalf(4,i) = 0
         end do
      endif

      return
      end

      double precision function phi(idx,icalf,ncalf,ianf,nchain)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      real dihed
      dimension isel(4)
      dimension icalf(6,*),ianf(*)

      phi = 0.0d0

      do i=1,nchain
        if (idx.eq.ianf(i)) return
      end do

      if (idx.le.ncalf.and.idx.gt.1) then
         call bckok(ibckok,idx,2)
         if (ibckok.eq.1) then
            isel(1) = icalf(3,idx-1)
            isel(2) = icalf(2,idx)
            isel(3) = icalf(1,idx)
            isel(4) = icalf(3,idx)
            call tomold(dihed,isel,4)
            phi = dihed
         endif
      endif

      return
      end

      double precision function psi(idx,icalf,ncalf,islu,nchain)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      real dihed
      dimension isel(4)
      dimension icalf(6,*),islu(*)

      psi = 0.0d0

      do i=1,nchain
        if (idx.eq.islu(i)) return
      end do

      if (idx.lt.ncalf.and.idx.ge.1) then
         isel(1) = icalf(2,idx)
         isel(2) = icalf(1,idx)
         isel(3) = icalf(3,idx)
         isel(4) = icalf(2,idx+1)
         call tomold(dihed,isel,4)
         psi = dihed
      endif

      return
      end

      subroutine hand(idx1,idx2,hang,coo,ianz,iconn,icalf)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      dimension tmp(3),tem(3),coo(3,*),ianz(*),iconn(mxcon+1,*)
      dimension icalf(6,*)

      idxc = icalf(3,idx1)
      idxo = 0
      do j=1,iconn(1,idxc)
         k = abs(iconn(j+1,idxc))
         if (ianz(k).eq.8) idxo = k
      end do
      if (idxo.eq.0) then
          print*,'subroutine hang: c without o'
          hang = 0.0d0
      else
         do j=1,3
            tmp(j) = coo(j,idxo) - coo(j,idxc)
         end do
   
         idxn = icalf(2,idx2)
         do j=1,3
            tem(j) = coo(j,idxn) - coo(j,icalf(4,idx2))
         end do

         call impsc(tmp,tem,cosb)
         hang = cosb
      endif
      
      return
      end

      integer function indhb(idx,distnw)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)

      dismax = 0.0d0
      do j=1,2
         if (ihb(j,idx).eq.0) then
            indhb = j
            return
         elseif (hbd(j,idx).gt.dismax) then
            dismax = hbd(j,idx)
            maxid = j
         endif
      end do
      indhb = -1
      if (distnw.lt.hbd(maxid,idx)) indhb = maxid

      return
      end

      subroutine hbodd(ioatms,nstrt,coo,ianz,iconn,
     &                 icalf,ncalf,iamino)
c hcoord, hbond en vadar hebben geen ioadd provisie
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      dimension tmp(3),tem(3)
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*)
      dimension icalf(6,*),iamino(*)
  
      todeg=45.0d0/datan(1.0d0)

      do k=nstrt,ncalf
         dismin = 4.0d0/0.52917706d0
         do i=nstrt,ncalf
           if ((icalf(4,i).ne.0.and.icalf(3,k).ne.0)
     &      .and.iamino(i).le.23) then
            idxc = icalf(3,k)
            idxo = 0
            do j=1,iconn(1,idxc)
               m = abs(iconn(j+1,idxc))
               if (ianz(m).eq.8.and.m.gt.ioatms) idxo = m
            end do
            do j=1,3
               tmp(j) = coo(j,idxo) - coo(j,icalf(4,i))
            end do
            dho = vlen(tmp)
            do j=1,3
               tem(j) = coo(j,idxo) - coo(j,icalf(2,i))
            end do
            dno = vlen(tem)
c check if angstrom
            if (dho.lt.6.6d0.and.dho.lt.dno.and.i.ne.k) then
               call hang(k,i,hand)
               cosb = hand
               if (dabs(dacos(cosb)*todeg).lt.95.d0.and.dho.lt.dismin
     &         .and.dho.lt.(5.1d0+1.89d0*dabs(cosb))) then
                  dismin = dho
                  i1 = indhb(k,dho)
                  if (i1.ne.-1) then
                     if (i1.eq.1.or.(i1.eq.2.and.ihb(1,k).ne.i)) then
                        ihb(i1,k) = i
                        hbd(i1,k) = dho
                     endif
                  endif
                  i2 = indhb(i,dho)
                  if (i2.ne.-1) then
                     if (i2.eq.1.or.(i2.eq.2.and.ihb(1,i).ne.k)) then
                        ihb(i2,i) = k
                        hbd(i2,i) = dho
                     endif
                  endif
               endif
            endif
          endif
         end do
      end do

      return
      end

      subroutine vadar(ioatms,nstrt,
     &                 icalf,ncalf,ianf,islu,nchain,iamino,isal)
c hcoord, hbond en vadar hebben geen ioadd provisie
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      logical legitb
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),isal(*)

      phlast = 0.0d0

c hoe is isal geinitialiseerd -1 ?

c 0 Helix
c 1 Beta
c 2 RNA/DNA
c 3 Coil

      do i=nstrt,ncalf
        if (iamino(i).le.23) then
         ph = phi(i,icalf,ncalf,ianf,nchain)
         ps = psi(i,icalf,ncalf,islu,nchain)
         if (ihb(1,i).ne.0) then
            if (legitb(i,0).and.ph.lt.-34.d0.and.ph.gt.-118.d0
     &          .and.ps.gt.-95.d0.and.ps.lt.6.d0) then
                isal(i) = 0
c hoe zit het met i=1, hieronder
                if (i.gt.1.and.isal(i-1).ne.0.and.isal(i-2).ne.
     &              0.and.phlast.lt.-55.d0.and.phlast.gt.-90.d0) 
     &              isal(i-1) = 0
                
            elseif (legitb(i,4).and.isal(i-1).eq.0) then
                isal(i) = 0
            elseif (legitb(i,1).and.ph.lt.-45.d0.and.ph.gt.-180.d0
     &          .and.((ps.gt.95.d0.and.ps.lt.180.d0).or.
     &          (ps.lt.-170.d0.and.ps.gt.-180.d0))) then
                isal(i) = 1
                if (i.gt.1.and.isal(i-1).ne.1.and.isal(i-2).ne.
     &          1.and.phlast.lt.-100.d0) isal(i-1) = 1
            elseif (legitb(i,5).and.ph.lt.-95.d0) then
                isal(i) = 1
            else
                if (i.gt.1.and.isal(i-1).eq.0.and.ph.lt.-55.d0
     &              .and.ph.gt.-100.d0) then
                    isal(i) = 0
                else
                    isal(i) = 3
                endif
            endif
         else
            isal(i) = 3
         endif
         phlast = ph
        else
           isal(i) = 2
        endif
      end do

c     smoothing

      do i=nstrt+2,ncalf-1
         if (isal(i-1).eq.1.and.isal(i).eq.3.and.isal(i+1).eq.1)
     &       isal(i) = 1
      end do
      do i=nstrt+2,ncalf-1
         if (isal(i-1).ne.1.and.isal(i).eq.1.and.isal(i+1).ne.1)
     &       isal(i) = 3
      end do
      do i=nstrt+2,ncalf-1
         if (isal(i-1).ne.0.and.isal(i).eq.0.and.isal(i+1).ne.0)
     &       isal(i) = 3
      end do

c     filter

      icount = 1
      ilast = 0
      do i=nstrt+2,ncalf
         if (isal(i).eq.isal(i-1)) then
            icount = icount + 1
         else
            if (ilast.eq.0.and.icount.lt.4) then
               do j=i-1,i-icount,-1
                  isal(j) = 3
               end do
            endif
            if (ilast.eq.1.and.icount.lt.4) then
               do j=i-1,i-icount,-1
                  isal(j) = 3
               end do
            endif
            icount = 1
         endif
         ilast = isal(i)
      end do

c      do i=1,nchain
c         if (iamino(ianf(i)).gt.23) isal(ianf(i)) = 3
c      end do

      return
      end

      logical function legitb(idx,itype)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      logical b3, b4

      b3 = .false.
      b4 = .false.
      
      legitb = .true.
      do i=1,2
         idist = abs(ihb(i,idx) - idx)
         if (ihb(i,idx).eq.0) idist = 0

         if (itype.eq.0) then
            if (idist.gt.2.and.idist.lt.6) return
         elseif (itype.eq.4) then
            if (idist.eq.3) b3 = .true.
            if (idist.eq.4) b4 = .true.
            if (b3.and.b4) return
         elseif (itype.eq.1) then
            if (idist.gt.2) return
         elseif (itype.eq.5) then
            if (idist.ge.6) return
         endif

      end do

      legitb = .false.

      return
      end

      subroutine acthd(iopt,hbfilt,coo,iconn,ianz,icalf,ncalf)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (numcal=50000)
      common /hbonds/ hbd(2,numcal),ihb(2,numcal)
      dimension tmp(3)
      dimension coo(3,*),iconn(mxcon+1,*),ianz(*)
      dimension icalf(6,*)

      do i=1,ncalf
        if (icalf(4,i).ne.0) then
         if (ihb(1,i).ne.0.and.hbd(1,i).lt.hbfilt) then

            m = icalf(4,i)
            idxc = icalf(3,ihb(1,i))
            ioxy = 0

            do j=1,iconn(1,idxc)
               n = abs(iconn(j+1,idxc))
               if (ianz(n).eq.8) ioxy = n
            end do

            do j=1,3
               tmp(j) = coo(j,m) - coo(j,ioxy)
            end do

            tmpl = vlen(tmp)

            if (dabs(tmpl-hbd(1,i)).gt.1.0d-3) then

               m = icalf(4,ihb(1,i))
               idxc = icalf(3,i)
               ioxy = 0

               do j=1,iconn(1,idxc)
                  n = abs(iconn(j+1,idxc))
                  if (ianz(n).eq.8) ioxy = n
               end do

            endif

            call hbconn(iopt,ioxy,m)

            if (ihb(2,i).ne.0.and.hbd(2,i).lt.hbfilt) then
               m = icalf(4,i)
               idxc = icalf(3,ihb(2,i))
               ioxy = 0

               do j=1,iconn(1,idxc)
                  n = abs(iconn(j+1,idxc))
                  if (ianz(n).eq.8) ioxy = n
               end do

               do j=1,3
                  tmp(j) = coo(j,m) - coo(j,ioxy)
               end do

               tmpl = vlen(tmp)

               if (dabs(tmpl-hbd(2,i)).gt.1.0d-3) then
                  m = icalf(4,ihb(2,i))
                  idxc = icalf(3,i)
                  ioxy = 0

                  do j=1,iconn(1,idxc)
                     n = abs(iconn(j+1,idxc))
                     if (ianz(n).eq.8) ioxy = n
                  end do

               endif

               call hbconn(iopt,ioxy,m)

            endif
         endif
       endif
      end do

      return
      end

      subroutine disabd(iopt,ianz,iaton,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      dimension ianz(*),iaton(*),iconn(mxcon+1,*)

      do i=1,iatoms
          if (ianz(i).eq.1) then
             if (iopt.eq.0) then
                iaton(i) = 1
             elseif (iopt.eq.1) then
                iaton(i) = 0
             elseif (iopt.eq.2) then
                if (iconn(1,i).eq.1) then
                    if (iconn(2,i).gt.0) iaton(i) = 0
                elseif (iconn(1,i).eq.2) then
                    if (iconn(2,i).gt.0.and.iconn(3,i).gt.0) 
     &                  iaton(i) = 0
               
                endif
             endif
          endif
      end do

      return
      end

      subroutine hbcond(iopt,iat1,iat2,ianz,iatclr,iaton,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      dimension ianz(*),iatclr(*),iaton(*),iconn(mxcon+1,*)


      if (iat1.ne.0) then
         if (iopt.eq.1) then
            iaton(iat2) = 1
            iaton(iat1) = 1
            iatclr(iat2) = 15
            iatclr(iat1) = icol(ianz(iat1))
            iconn(1,iat2) = iconn(1,iat2) + 1
            iconn(1+iconn(1,iat2),iat2) = -iat1
            iconn(1,iat1) = iconn(1,iat1) + 1
            iconn(1+iconn(1,iat1),iat1) = -iat2
         else
            iaton(iat2) = 0
            iaton(iat1) = 0
            iconn(1,iat2) = iconn(1,iat2) - 1
            iconn(1,iat1) = iconn(1,iat1) - 1
         endif
      endif
 
      return
      end

      subroutine ribbd(issdon)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /surf/  natorg,noscnd

c      call getnat(natoms)
c      iatoms = natoms
      noscnd = iatoms
c      natorg = iatoms

      call ribbon(0,0,1,0,0,0,0)
      call ribbon(1,0,1,0,0,0,0)
      call ribbon(2,0,1,0,0,0,0)
      call ribbon(3,0,1,0,0,0,0)

      call setarr(8,noscnd,idum)

      issdon = 1

      return
      end

      subroutine getcdh(ires,ichain,ianf,islu,nchain)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      dimension ianf(*),islu(*)

      ichain = 1

      do i=1,nchain
         if (ires.ge.ianf(i).and.ires.le.islu(i)) ichain = i
      end do

      return
      end

      subroutine ribbod(istat,iscnd,dogl,nr,iungl,
     &                  ipart,ist,ichain,tori,
     &                  coo,ianz,iaton,iatclr,iresid,iconn,
     &                  icalf,ncalf,ianff,isluu,nchain,iamino,
     &                  isal,ihashb)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (alpha = 32.0d0, beta = -11.0d0)
      parameter (torad = 3.1415926536/180.0)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (ncmx=32)
      common /strips/ qnormo(3),crpnto(3,ncmx),crnrmo(3,ncmx),
     &                numcir,nquad
      common /nfhlp/ nfree
      integer dogl
      dimension vec1(3),vec2(3),quad(3,4),cooh(3,numcal),
     &          coot(3,numcal),cooca(3,numcal),hint(3),cvec(3),rvec(3)
      dimension tori(3),qnrm(3),hintb(3,3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*)
      dimension icalf(6,*),ianff(*),isluu(*),iamino(*),isal(*)
      dimension ianf(mxchai),islu(mxchai)

      istat = 1

      if (iscnd.eq.0) then
         iheldf = 3
      elseif (iscnd.eq.1) then
         iheldf = 4
      elseif (iscnd.eq.2) then
         iheldf = 10
      endif

      do i=1,nchain
         ianf(i) = ianff(i)
         call bckok(ibckok,ianf(i),1)
         if (ibckok.eq.0) then
             isal(ianf(i)) = 10
             ianf(i) = ianf(i) + 1
         endif
         islu(i) = isluu(i)
         call bckok(ibckok,islu(i),1)
         if (ibckok.eq.0) then
            isal(islu(i)) = 10
            if (islu(i).gt.1) then
               islu(i) = islu(i) - 1
            endif
         endif
      end do

      if (ipart.eq.1) then
         istrt  = ist
      else
         istrt  = 1
         nfree = iatoms + 1
      endif
      iatorg = iatoms
      cilrad = 0.2d0 / 0.52917706d0
      hlxwid = 2.4d0 / 0.52917706d0
      if (iscnd.eq.0) then
          hermhx = 4.7d0 / 0.52917706d0
      else
          hermhx = 3.0d0 / 0.52917706d0
      endif
      cos1 = dcos(torad*alpha)
      sin1 = dsin(torad*alpha)
      cos2 = dcos(torad*beta)
      sin2 = dsin(torad*beta)
 
100   continue

      if (istrt.ge.ncalf) then
          if (ipart.eq.1) ist = istrt
          return
      endif

      lhelx = 0
      ifrst = 0
      ilast = 0
      ia = 0
      is = 0

      do i=istrt,ncalf
         if (isal(i).eq.iscnd.and.ifrst.eq.0) then
             ifrst = i
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    ia = ianf(nn)
                    is = islu(nn)
                endif
             end do
         endif

         if (iscnd.eq.3.and.
     &      (isal(i).eq.3.and.isal(i+1).ne.3)) then
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    ia = ianf(nn)
                    is = islu(nn)
                endif
             end do
             if (i.eq.ia) then
                ifrst = i
                lhelx = 2
                ilast = ifrst + 1
                istrt = ilast + 1
                goto 20
             endif
         endif

         if (iscnd.eq.3.and.
     &      (isal(i).ne.3.and.isal(i+1).eq.3)) then
c             print*,i,islu(nchain),isal(i),isal(islu(nchain))
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    ia = ianf(nn)
                    is = islu(nn)
                endif
             end do
             if (i+1.eq.is) then
                ifrst = i
                lhelx = 2
                ilast = ifrst + 1
                istrt = ilast + 1
                goto 20
             endif
         endif

         if (iscnd.eq.3.and.
     &      ((isal(i).eq.0.and.isal(i+1).eq.1).or.
     &      (isal(i).eq.1.and.isal(i+1).eq.0))) then
             iia = 0
             iis = 0
             do nn=1,nchain
                if (i.ge.ianf(nn).and.i.le.islu(nn)) then
                    iia = ianf(nn)
                    iis = islu(nn)
                endif
             end do
             if (i.ne.iia.and.i.ne.iis.and.i+1.ne.iis) then
                ifrst = i
                lhelx = 2
                ilast = ifrst + 1
                istrt = ilast + 1
                goto 20
             endif
         endif

         if (i.eq.ncalf.and.ifrst.eq.0) then
             if (ipart.eq.1) ist = i
             return
         endif
             
         if (isal(i).ne.iscnd.and.ifrst.ne.0) goto 10

         if (isal(i).eq.iscnd) lhelx = lhelx + 1
         if (i.eq.is.and.ifrst.ne.0) goto 10

      end do
10    ilast = ifrst + lhelx - 1
      istrt = ilast + 1
 

      if (iscnd.eq.3) then
         if (ifrst.gt.ia) then
            ifrst = ifrst - 1
            lhelx = lhelx + 1
         endif
         if (ifrst+lhelx-1.lt.is) lhelx = lhelx + 1
         if (lhelx.eq.1) goto 100
      endif

      if (iscnd.eq.2) then
         if (ifrst.gt.ia) then
            ifrst = ifrst - 1
            lhelx = lhelx + 1
         endif
         if (ifrst+lhelx-1.lt.is) lhelx = lhelx + 1
         if (lhelx.eq.1) goto 100
      endif

20    iqopt = 1

      if (ipart.eq.1.and.iscnd.ge.2.and.ifrst.gt.islu(ichain)) then
          ist = ilast
          return
      endif

c minimim Helix/Beta length of Four
 
      if (lhelx.le.0) then
          if (ipart.eq.1) ist = ilast
          return
      endif

      if (lhelx.gt.numcal) lhelx = numcal
      if (iscnd.ne.3.and.lhelx.lt.4.and.iamino(ifrst).le.23
     &    .and.ihashb.eq.0) goto 100
      if (iscnd.ne.3.and.lhelx.lt.3.and.iamino(ifrst).le.23) goto 100
      if (iscnd.eq.2.and.lhelx.eq.1) goto 100

      ihlx = 0
      do i=1,lhelx
         call bckok(ibckok,ifrst+i-1,1)
         if (ibckok.eq.1) then
            ihlx = ihlx + 1
            do j=1,3
               cooca(j,i) = coo(j,icalf(1,ifrst+i-1))
            end do
         endif
      end do
      lhelx = ihlx
 
c mag alleen in combinatie met chain break voor of na
c anders trek een recht lijntje
c      if (lhelx.le.2) goto 100
      if (iscnd.eq.3.and.lhelx.le.2) goto 100

c compute tangent vectors for ca's in 
 
      do ica = 2,lhelx-1

        if (iscnd.eq.1) then
c           do j=1,3
c first try
c              cvec(j) = cooca(j,ica) - 
c     &                 (cooca(j,ica+1) + cooca(j,ica-1))*0.5d0
c           end do
c           call vsc1(cvec,1.0d0,1.0d-4)
           do j=1,3
              vec1(j) = cooca(j,ica) - cooca(j,ica-1)
              vec2(j) = cooca(j,ica+1) - cooca(j,ica)
           end do
           call crprod(vec1,vec2,cvec)
           call vsc1(cvec,1.0d0,1.0d-4)
           
           do j=1,3
              cooh(j,ica) = cvec(j)
           end do

           do j=1,3
              cvec(j) = cooca(j,ica+1) - cooca(j,ica-1)
           end do
           call vsc1(cvec,1.0d0,1.0d-4)

           do j=1,3
              vec1(j) = cooca(j,ica) - cooca(j,ica-1)
              vec2(j) = cooca(j,ica+1) - cooca(j,ica)
           end do
           call crprod(vec1,vec2,rvec)
           call vsc1(rvec,1.0d0,1.0d-4)
 
           do j=1,3
              coot(j,ica) = (cos2*cvec(j) + sin2*rvec(j))*hermhx
           end do

        else
           do j=1,3
              cvec(j) = cooca(j,ica+1) - cooca(j,ica-1)
           end do
           call vsc1(cvec,1.0d0,1.0d-4)

           do j=1,3
              vec1(j) = cooca(j,ica) - cooca(j,ica-1)
              vec2(j) = cooca(j,ica+1) - cooca(j,ica)
           end do
           call crprod(vec1,vec2,rvec)
           call vsc1(rvec,1.0d0,1.0d-4)
 
           do j=1,3
              cooh(j,ica) = cos1*rvec(j) + sin1*cvec(j)
              coot(j,ica) = (cos2*cvec(j) + sin2*rvec(j))*hermhx
           end do
        endif
 
      end do
 
c find ca before and after chain
c Later check for chain break
 
      if (ifrst.gt.ia) ifrst = ifrst - 1
      if (ilast.lt.is) ilast = ilast + 1
 
c start initialization

      do j=1,3
           cooh(j,1) = cooh(j,2)
           if (icalf(1,ifrst).gt.0) then
              coot(j,1) = cooca(j,2) - coo(j,icalf(1,ifrst))
           else
              coot(j,1) = cooca(j,2)
           endif
           if (lhelx.eq.2) cooh(j,1) = -coot(j,1)
      end do
      call vsc1(coot(1,1),hermhx,1.0d-4)
 
c end initialization
 
      do j=1,3
         cooh(j,lhelx) = cooh(j,lhelx-1)
         if (iscnd.eq.1) then
            coot(j,lhelx) = coot(j,lhelx-1)
         else
            if (icalf(1,ilast).ne.0) then
               coot(j,lhelx) = coo(j,icalf(1,ilast)) - cooca(j,lhelx-1)
            endif
         endif
      end do
      call vsc1(coot(1,lhelx),hermhx,1.0d-4)

      if (iscnd.eq.1) then

c strand align and smooth
c alternating vector flip for subsequent ca's

        do ica=2,lhelx
           call timpsc(cooh(1,ica-1),cooh(1,ica),cimp)
           if (cimp.lt.0.0d0) then
              do j=1,3
                  cooh(j,ica) = -1.0d0 * cooh(j,ica)
              end do
           endif
        end do
        do ica=2,lhelx-1
           do j=1,3
               cooh(j,ica) = 
     &           cooh(j,ica-1) + cooh(j,ica) + cooh(j,ica+1)
           end do
           call vsc1(cooh(1,ica),1.0d0,1.0d-4)
        end do
        do ica=2,lhelx-1
           do j=1,3
               cooca(j,ica) = 0.5d0*(cooca(j,ica) +
     &           (cooca(j,ica-1) + cooca(j,ica+1))*0.5d0)
           end do
        end do

        if (dogl.eq.1.and.nr.eq.1) 
     &     write(iungl,'(a)') '[RIBBON] STRANDTOP'
c        if (dogl.eq.1.and.nr.ge.2) 
c     &     write(iungl,'(a)') '[RIBBON] STRANDBOTTOM'
      else
        if (dogl.eq.1.and.nr.eq.1.and.iscnd.lt.2) 
     &     write(iungl,'(a)') '[RIBBON] HELIXOUT'
c        if (dogl.eq.1.and.nr.ge.2.and.iscnd.lt.2) 
c     &     write(iungl,'(a)') '[RIBBON] HELIXIN'
        if (dogl.eq.1.and.nr.ge.2.and.iscnd.lt.2) 
     &     write(iungl,'(a)') '[HELIXIN]'
        if (dogl.eq.1.and.nr.eq.1.and.iscnd.eq.2) 
     &   write(iungl,'(a)') '[RIBBON] RNA'
        if (dogl.eq.1.and.nr.eq.1.and.iscnd.eq.3) 
     &   write(iungl,'(a)') '[RIBBON] COIL'
      endif

      if (dogl.eq.2) write(iungl,'(a)') 'mesh {'

 
c helix first segment edge

      do j=1,3
         if (dogl.ge.1) then
            if (iscnd.eq.1) then
               quad(j,1) = cooca(j,1) + hlxwid*cooh(j,1)/2.0d0
               quad(j,4) = cooca(j,1) - hlxwid*cooh(j,1)/2.0d0
            else
               quad(j,1) = cooca(j,1) + cilrad*cooh(j,1)
               quad(j,4) = cooca(j,1) - cilrad*cooh(j,1)
            endif
            hintb(j,3) = cooca(j,1)
         else
            if (nfree.le.mxnat) then
               coo(j,nfree)   = cooca(j,1)
            endif
         endif
      end do

      if (dogl.eq.0) then
         if (nfree.le.mxnat) then
            iconn(1,nfree) = 1
            iconn(2,nfree) = nfree+1
            iaton(nfree) = 1
            iatclr(nfree) = iheldf
            ianz(nfree) = 100
            iresid(nfree) = -iscnd
            nfree = nfree + 1
         else
            goto 1000
         endif
      endif
 
c helix/strand start 
 
      do iquad = 1, nquad
        t = dfloat(iquad)/dfloat(nquad)
 
        call intpol(hint,t,cooca(1,1),cooca(1,2),coot(1,1),coot(1,2))

        if (iscnd.eq.1) then
           rscal = hlxwid/2.0d0
        else
           rscal = cilrad + (hlxwid/2.0d0 - cilrad)*
     &          0.5d0*(-dcos(180.0d0*torad*t) + 1.0d0)
        endif

        do j=1,3
           if (dogl.ge.1) then
              vec1(j) = rscal*cooh(j,1)
              quad(j,2) = hint(j) + vec1(j)
              quad(j,3) = hint(j) - vec1(j)
              hintb(j,1) = hintb(j,2)
              hintb(j,2) = hintb(j,3)
              hintb(j,3) = hint(j)
           else
              if (nfree.le.mxnat) then
                 coo(j,nfree)   = hint(j)
              else
                 goto 1000
              endif
           endif
        end do

        if (dogl.ge.1) then

c compute normal

           call vsc1(vec1,1.0d0,1.0d-8)
           do j=1,3
              vec2(j) = (quad(j,1) + quad(j,4))*0.5d0 -
     &                  (quad(j,2) + quad(j,3))*0.5d0
           end do
           call vsc1(vec2,1.0d0,1.0d-8)
           call crprod(vec1,vec2,qnrm)
           call vsc1(qnrm,1.0d0,1.0d-8)

c put out quadrilateral

           if (iscnd.ge.2) then
              if (iquad.ge.2) then
                  call wrcoil(hintb(1,1),hintb(1,2),
     &                        hintb(1,3),iungl,tori,iqopt,dogl)
                  iqopt = 2
              endif
           else
              call wrquad(quad,qnrm,iungl,tori,iqopt,nr,dogl)
              iqopt = 2
           endif
           do j=1,3
              quad(j,1) = quad(j,2)
              quad(j,4) = quad(j,3)
           end do

        else

           if (nfree.le.mxnat) then
              iconn(1,nfree) = 2
              iconn(2,nfree) = nfree+1
              iconn(3,nfree) = nfree-1
              iaton(nfree) = 1
              iatclr(nfree) = iheldf
              ianz(nfree) = 100
              iresid(nfree) = -iscnd
              nfree = nfree + 1
           else
              goto 1000
           endif

        endif

      end do
 
c helix/strand main 
 
      do ica = 2, lhelx - 2
        do iquad = 1, nquad

          t = dfloat(iquad)/dfloat(nquad)
 
          call intpol(hint,t,cooca(1,ica),cooca(1,ica+1),
     &                coot(1,ica),coot(1,ica+1))

          rscal = hlxwid/2.0d0
          do j=1,3
             vec1(j) = (1.0d0-t)*cooh(j,ica) + t*cooh(j,ica+1)
          end do

          call vsc1(vec1,rscal,1.0d-4)

          do j=1,3
              if (dogl.ge.1) then
                 quad(j,2) = hint(j) + vec1(j)
                 quad(j,3) = hint(j) - vec1(j)
                 hintb(j,1) = hintb(j,2)
                 hintb(j,2) = hintb(j,3)
                 hintb(j,3) = hint(j)
              else
                 if (nfree.le.mxnat) then
                    coo(j,nfree)   = hint(j)
                 else
                    goto 1000
                 endif
              endif
          end do

          if (dogl.ge.1) then

c compute normal

             call vsc1(vec1,1.0d0,1.0d-8)
             do j=1,3
                vec2(j) = (quad(j,1) + quad(j,4))*0.5d0 -
     &                    (quad(j,2) + quad(j,3))*0.5d0
             end do
             call vsc1(vec2,1.0d0,1.0d-8)
             call crprod(vec1,vec2,qnrm)
             call vsc1(qnrm,1.0d0,1.0d-8)

c put out quadrilateral

             if (iscnd.ge.2) then
                call wrcoil(hintb(1,1),hintb(1,2),
     &                      hintb(1,3),iungl,tori,iqopt,dogl)
             else
                call wrquad(quad,qnrm,iungl,tori,iqopt,nr,dogl)
             endif
             do j=1,3
                quad(j,1) = quad(j,2)
                quad(j,4) = quad(j,3)
             end do

          else

             if (nfree.le.mxnat) then
                iconn(1,nfree) = 2
                iconn(2,nfree) = nfree+1
                iconn(3,nfree) = nfree-1
                iaton(nfree) = 1
                iatclr(nfree) = iheldf
                ianz(nfree) = 100
                iresid(nfree) = -iscnd
                nfree = nfree + 1
             else
                goto 1000
             endif

          endif


        end do
      end do
 
c helix/strand end
 
      if (lhelx.eq.2 ) then
        if (dogl.ge.1) then
           goto 200
        else
           if (nfree-1.le.mxnat) then
              iconn(1,nfree-1) = 1
              iconn(2,nfree-1) = iconn(3,nfree-1)
           else
              goto 1000
           endif
           goto 100
        endif
      endif

      do iquad = 1, nquad
        t = dfloat(iquad)/dfloat(nquad)
 
        call intpol(hint,t,cooca(1,lhelx-1),cooca(1,lhelx),
     &              coot(1,lhelx-1),coot(1,lhelx))

        if (iscnd.eq.1) then
           rscal = 1.8d0*hlxwid*(1.01d0-t)/2.0d0
        else
           rscal = cilrad + (hlxwid/2.0d0 - cilrad)*
     &          0.5d0*(dcos(180.0d0*torad*t) + 1.0d0)
        endif
        do j=1,3
           if (dogl.ge.1) then
              vec1(j) = rscal*cooh(j,lhelx)
              quad(j,2) = hint(j) + vec1(j)
              quad(j,3) = hint(j) - vec1(j)
              hintb(j,1) = hintb(j,2)
              hintb(j,2) = hintb(j,3)
              hintb(j,3) = hint(j)
           else
              if (nfree.le.mxnat) then
                 coo(j,nfree)   = hint(j)
              else
                 goto 1000
              endif
           endif
        end do

        if (dogl.ge.1) then

c compute normal

           call vsc1(vec1,1.0d0,1.0d-8)
           do j=1,3
              vec2(j) = (quad(j,1) + quad(j,4))*0.5d0 -
     &                  (quad(j,2) + quad(j,3))*0.5d0
           end do
           call vsc1(vec2,1.0d0,1.0d-8)
           call crprod(vec1,vec2,qnrm)
           call vsc1(qnrm,1.0d0,1.0d-8)


c put out quadrilateral

           if (iscnd.ge.2) then
              call wrcoil(hintb(1,1),hintb(1,2),
     &                      hintb(1,3),iungl,tori,iqopt,dogl)
           else
              call wrquad(quad,qnrm,iungl,tori,iqopt,nr,dogl)
           endif
           do j=1,3
              quad(j,1) = quad(j,2)
              quad(j,4) = quad(j,3)
           end do

        else

           if (nfree.le.mxnat) then
              iconn(1,nfree) = 2
              iconn(2,nfree) = nfree-1
              iconn(3,nfree) = nfree+1
              iaton(nfree) = 1
              iatclr(nfree) = iheldf
              ianz(nfree) = 100
              iresid(nfree) = -iscnd
              nfree = nfree + 1
           else
              goto 1000
           endif

        endif
 

      end do
 
200   continue

      if (dogl.ge.1) then

         if (iscnd.ge.2) then

            do j=1,3
              hintb(j,1) = hintb(j,2)
              hintb(j,2) = hintb(j,3)
c              hintb(j,3) = cooca(j,lhelx+1)
            end do

            do j=1,3
              hintb(j,3) = hintb(j,2) + (hintb(j,2) - hintb(j,1))
            end do

            call wrcoil(hintb(1,1),hintb(1,2),
     &                  hintb(1,3),iungl,tori,iqopt,dogl)
         else
            call wrquad(quad,qnrm,iungl,tori,3,nr,dogl)
         endif

      endif

      if (dogl.eq.2) then

         if (iscnd.eq.1) then
           if (nr.eq.1)
     &        write(iungl,'(a)') 'texture { STRANDTOP }'
           if (nr.ge.2)
     &        write(iungl,'(a)') 'texture { STRANDBOTTOM }'
         else
           if (nr.eq.1.and.iscnd.lt.2)
     &        write(iungl,'(a)') 'texture { HELIXOUT }'
           if (nr.ge.2.and.iscnd.lt.2)
     &        write(iungl,'(a)') 'texture { HELIXIN }'
           if (nr.eq.1.and.iscnd.eq.2)
     &      write(iungl,'(a)') 'texture { RNA }'
           if (nr.eq.1.and.iscnd.eq.3)
     &      write(iungl,'(a)') 'texture { COIL }'
         endif

         write(iungl,'(a)') '}'

      endif

      if (ipart.eq.1) then

         if (iscnd.ge.2) then
            if (ilast.gt.islu(ichain)) then
               ist = ilast
               return
            endif
         else
            ist = ilast
            return
         endif
      endif

      if (dogl.ge.1) goto 100


      if (nfree-1.le.mxnat) then
          iatoms = nfree-1
          iconn(1,nfree-1) = 1
      else
          goto 1000
      endif

      goto 100

1000  istat = 0
      iatoms = iatorg
      istart = istrt
      return
 
      end

      subroutine intpol(cnew,g,c1,c2,v1,v2)
      implicit double precision (a-h,o-z)
      dimension cnew(3),c1(3),c2(3),v1(3),v2(3)
 
      do i = 1, 3
        cnew(i) = c1(i)*(2.0*g*g*g - 3.0*g*g + 1.0)
     &          + c2(i)*(-2.0*g*g*g + 3.0*g*g)
     &          + v1(i)*(g*g*g - 2.0*g*g + g) + v2(i)*(g*g*g - g*g)
      end do
 
      return
      end

      subroutine wrquad(quad,qnrm,iungl,tori,iopt,nr,dogl)
      implicit double precision (a-h,o-z)
      parameter (ncmx=32)
      common /strips/ qnormo(3),crpnto(3,ncmx),crnrmo(3,ncmx),
     &                numcir,nquad
      integer dogl
      dimension quad(3,4),v1(3),v2(3),tori(3)
      dimension quadt(3,4),qnew(3),qnrm(3)

 
      ribbw = 0.4d0
      qs = 1.0

      call vsc1(qnrm,1.0d0,1.0d-4)

      if (iopt.eq.1.and.nr.eq.4) then

c in between side quad of begin

         do j=1,3
            quadt(j,1) = quad(j,4) + qnrm(j)*ribbw
            quadt(j,2) = quad(j,4) - qnrm(j)*ribbw
            quadt(j,3) = quad(j,1) - qnrm(j)*ribbw
            quadt(j,4) = quad(j,1) + qnrm(j)*ribbw
         end do
         do j=1,3
            qnew(j) = (quad(j,2) + quad(j,3))*0.5d0 -
     &                (quad(j,1) + quad(j,4))*0.5d0
         end do
         call vsc1(qnew,1.0d0,1.0d-4)

         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'
         call wrvert(qnew,qs,quadt(1,1),tori,iungl,dogl)
         call wrvert(qnew,qs,quadt(1,4),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,qs,quadt(1,3),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         call wrvert(qnew,qs,quadt(1,3),tori,iungl,dogl)
         call wrvert(qnew,qs,quadt(1,2),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,qs,quadt(1,1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif

      endif

      if (iopt.eq.1) then
         do j=1,3
            qnew(j) = qnrm(j)
         end do
      elseif (iopt.eq.2) then
         do j=1,3
            qnew(j) = qnrm(j) + qnormo(j)
         end do
      elseif (iopt.eq.3) then
         do j=1,3
            qnew(j) = qnormo(j)
         end do
      endif

      call vsc1(qnew,1.0d0,1.0d-4)

c top and bottom strip

      if (nr.eq.1.or.nr.eq.2) then
         do i=1,4
            do j=1,3
               if (nr.eq.1) then
                  qs = 1.0
                  quadt(j,i) = quad(j,i) + qnew(j)*ribbw
               elseif (nr.eq.2) then
                  qs = -1.0
                  quadt(j,5-i) = quad(j,i) - qnew(j)*ribbw
               endif
            end do
         end do
      endif

c left side strip

      if (nr.eq.3) then
         qs = -1.0
         do j=1,3
            quadt(j,1) = quad(j,1) - qnew(j)*ribbw
            quadt(j,2) = quad(j,2) - qnew(j)*ribbw
         end do
         do j=1,3
            quadt(j,4) = quad(j,1) + qnew(j)*ribbw
            quadt(j,3) = quad(j,2) + qnew(j)*ribbw
         end do
         do j=1,3
            qnew(j) = quad(j,4) - quad(j,1)
         end do
         call vsc1(qnew,1.0d0,1.0d-4)
      endif

c right side strip

      if (nr.eq.4) then
         qs = 1.0
         do j=1,3
            quadt(j,1) = quad(j,4) + qnew(j)*ribbw
            quadt(j,2) = quad(j,3) + qnew(j)*ribbw
         end do
         do j=1,3
            quadt(j,4) = quad(j,4) - qnew(j)*ribbw
            quadt(j,3) = quad(j,3) - qnew(j)*ribbw
         end do
         do j=1,3
            qnew(j) = quad(j,4) - quad(j,1)
         end do
         call vsc1(qnew,1.0d0,1.0d-4)
      endif


      if (iopt.eq.2.or.iopt.eq.3) then

         if (dogl.eq.2) then
            call wrvert(qnew,qs,quadt(1,4),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         call wrvert(qnew,qs,quadt(1,4),tori,iungl,dogl)
         call wrvert(qnew,qs,quadt(1,1),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(crnrmo(1,1),qs,crpnto(1,1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif
      endif

      if (iopt.eq.1.or.iopt.eq.2) then
         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'

         call wrvert(qnew,qs,quadt(1,1),tori,iungl,dogl)
         call wrvert(qnew,qs,quadt(1,4),tori,iungl,dogl)

         if (dogl.eq.2) then
            do i=1,4
               do j=1,3
                  crpnto(j,1) = quadt(j,1)
                  crnrmo(j,1) = qnew(j)
               end do
            end do
         endif

      endif

      if (iopt.eq.3.and.nr.eq.4) then

c in between side quad of begin

         qs = -1.0d0;

         do j=1,3
            quadt(j,1) = quad(j,1) + qnrm(j)*ribbw
            quadt(j,4) = quad(j,4) + qnrm(j)*ribbw
            quadt(j,2) = quad(j,1) - qnrm(j)*ribbw
            quadt(j,3) = quad(j,4) - qnrm(j)*ribbw
         end do
         do j=1,3
            v1(j) = quadt(j,4) - quadt(j,1)
            v2(j) = quadt(j,2) - quadt(j,1)
         end do
         call crprod(v1,v2,qnew)
         call vsc1(qnew,1.0d0,1.0d-8)

         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'
         call wrvert(qnew,qs,quadt(1,1),tori,iungl,dogl)
         call wrvert(qnew,qs,quadt(1,4),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,qs,quadt(1,3),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         call wrvert(qnew,qs,quadt(1,3),tori,iungl,dogl)
         call wrvert(qnew,qs,quadt(1,2),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(qnew,qs,quadt(1,1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif

      endif

      do j=1,3
         qnormo(j) = qnrm(j)
      end do


      return
      end

      subroutine wrcoil(c1,c2,c3,iungl,tori,iopt,dogl)
      implicit double precision (a-h,o-z)
      parameter (ncmx=32)
      common /strips/ qnormo(3),crpnto(3,ncmx),crnrmo(3,ncmx),
     &                numcir,nquad
      integer dogl
      dimension c1(3),c2(3),c3(3),v1(3),v2(3),vt1(3),vt2(3),vt3(3)
      dimension tori(3),cirpnt(3,ncmx),cirnrm(3,ncmx)
      dimension ids(2)
 
      pi = 3.141592654d0
      twopi = 2*pi
      coilw = 0.5d0
      ids(1) = 1
      ids(2) = -1


c iopt = 1, first segment, only c2 and c3 defined

      do j=1,3
         vt1(j) = c1(j) - c2(j)
         vt2(j) = c3(j) - c2(j)
      end do
      call crprod(vt1,vt2,v2)
      call vsc1(v2,1.0d0,1.0d-8)

      call vsc1(vt1,1.0d0,1.0d-8)
      call vsc1(vt2,1.0d0,1.0d-8)

      do j=1,3
         v1(j) = vt1(j) + vt2(j)
      end do
      call vsc1(v1,1.0d0,1.0d-8)

      if (vlen(v1).lt.1.0d-8.and.iopt.ne.1) then
         do j=1,3
            v2(j) = crnrmo(j,numcir)
         end do
         call crprod(vt1,v2,v1)
      endif

      call crprod(v1,v2,vt3)

      
      do i=1,numcir
         s = twopi * dble(i)/dble(numcir)
         do j=1,3
            cirnrm(j,i) = dsin(s)*v1(j) + dcos(s)*v2(j)
            cirpnt(j,i) = c2(j) + cirnrm(j,i)*coilw
         end do
      end do

      if (iopt.eq.1) then

         call crprod(v2,vt1,v1)
         call vsc1(v1,1.0d0,1.0d-8)

         do i=1,numcir
            s = twopi * dble(i)/dble(numcir)
            do j=1,3
               crnrmo(j,i) = dsin(s)*v1(j) + dcos(s)*v2(j)
               crpnto(j,i) = c1(j) + crnrmo(j,i)*coilw
            end do
         end do

      endif

      idir = 1
      dismin = 10000.0d0
      do l=1,2
         do iof=0,numcir-1
            dsq = 0.0d0
            do i=1,numcir
               i1 = i
               i2 = iof + ids(l)*i
               if (i2.gt.numcir) then
                  i2 = i2 - numcir
               elseif (i2.lt.1) then
                  i2 = i2 + numcir
               endif
               dsq = dsq + dist2(crpnto(1,i1),cirpnt(1,i2))
            end do
            if (dsq.lt.dismin) then
               dismin = dsq
               ioff = iof
               idir = ids(l)
            endif
         end do
      end do

c write quads

      do i=1,numcir
         i1 = i
         i2 = i + 1
         if (i2.gt.numcir) i2 = i2 - numcir
         l1 = ioff + idir*i
         if (l1.gt.numcir) then
            l1 = l1 - numcir
         elseif (l1.lt.1) then
            l1 = l1 + numcir
         endif
         l2 = ioff + idir*(i+1)
         if (l2.gt.numcir) then
            l2 = l2 - numcir
         elseif (l2.lt.1) then
            l2 = l2 + numcir
         endif

c dogl.eq.2 (povray), split quad up in to triangles

         if (dogl.eq.2) write(iungl,'(a)') 'smooth_triangle {'
         call wrvert(crnrmo(1,i1),1.0d0,crpnto(1,i1),tori,iungl,dogl)
         call wrvert(crnrmo(1,i2),1.0d0,crpnto(1,i2),tori,iungl,dogl)
         if (dogl.eq.2) then
            call wrvert(cirnrm(1,l2),1.0d0,cirpnt(1,l2),tori,iungl,dogl)
            write(iungl,'(a)') '}'
            write(iungl,'(a)') 'smooth_triangle {'
         endif

         if (l1.le.ncmx.and.l2.le.ncmx) then
            call wrvert(cirnrm(1,l2),1.0d0,cirpnt(1,l2),tori,iungl,dogl)
            call wrvert(cirnrm(1,l1),1.0d0,cirpnt(1,l1),tori,iungl,dogl)
         endif
         if (dogl.eq.2) then
            call wrvert(crnrmo(1,i1),1.0d0,crpnto(1,i1),tori,iungl,dogl)
            write(iungl,'(a)') '}'
         endif

      end do

      do i=1,numcir
         do j=1,3
            crnrmo(j,i) = cirnrm(j,i)
            crpnto(j,i) = cirpnt(j,i)
         end do
      end do

      return
      end

      subroutine wrvert(qnrm,qs,qvert,tori,iungl,dogl)
      implicit double precision (a-h,o-z)
      integer dogl
      common /setogl/ idirogl
      dimension qnrm(3),qvert(3),tori(3)

      toang = 0.52917706d0

      if (idirogl.eq.1) then
c        call ognrm(qnrm(1),qnrm(2),qnrm(3))
        call ognrm(qnrm(1)*qs,qnrm(2)*qs,qnrm(3)*qs)
        call ogvrt(qvert(1),qvert(2),qvert(3))
      else
        if (dogl.eq.1) then
         write(iungl,'(3(f9.6,1x))') qnrm(1)*qs,qnrm(2)*qs,qnrm(3)*qs
         write(iungl,'(3(f12.6,1x))') (qvert(1)-tori(1))*toang,
     &     (qvert(2)-tori(2))*toang,(qvert(3)-tori(3))*toang
        elseif (dogl.eq.2) then
         write(iungl,'(2(a,3(f12.6,a)))')
     &   '<',(qvert(1)-tori(1))*toang,',',(qvert(2)-tori(2))*toang,
     &   ',',(qvert(3)-tori(3))*toang,'>, ',
     &   '<',qnrm(1),',',qnrm(2),',',qnrm(3),'>'
        endif
      endif

      return
      end

      subroutine ribgl(ianf,nchain,ncalf,iatoms)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /setogl/ idirogl
      dimension ianf(*)

      idirogl = 1
      iun = 47
      open(unit=iun,form='formatted',status='scratch')

      call ribgll(iun,ianf,nchain,ncalf,iatoms)

      close(iun)
      idirogl = 0

      return
      end

      subroutine ribgll(iun,ianf,nchain,ncalf,iatoms)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /nfhlp/ nfree
      common /setogl/ idirogl
      dimension ianf(*)

      nfree = iatoms + 1

c helix

      istart = 1

      if (idirogl.eq.1) call ribpnt(1,0)
      
      do while (istart.lt.ncalf)

         if (idirogl.eq.1) then
            call ogribb(0)
            call sribcol(2)
         endif

         ist = istart
         call ribbon(0,1,1,iun,1,ist,0)
         if (idirogl.eq.1) then
            call sribcol(3)
            call setcll
         endif
         ist = istart
         call ribbon(0,1,2,iun,1,ist,0)
         ist = istart
         call ribbon(0,1,3,iun,1,ist,0)
         ist = istart
         call ribbon(0,1,4,iun,1,ist,0)

         istart = ist

         call getchn(ist,ichain)
         if (idirogl.eq.1) call ogendd(ichain)

      end do

      if (idirogl.eq.1) call ribpnt(0,0)

c strand

      istart = 1

      if (idirogl.eq.1) call ribpnt(1,1)

      do while (istart.lt.ncalf)

         if (idirogl.eq.1) then
            call ogribb(1)
            call sribcol(1)
         endif

         ist = istart
         call ribbon(1,1,1,iun,1,ist,0)
         ist = istart
         call ribbon(1,1,2,iun,1,ist,0)
         ist = istart
         call ribbon(1,1,3,iun,1,ist,0)
         ist = istart
         call ribbon(1,1,4,iun,1,ist,0)

         istart = ist

         call getchn(ist,ichain)
         if (idirogl.eq.1) call ogendd(ichain)

      end do

      if (idirogl.eq.1) then
          call ribpnt(0,1)
          call ribpnt(1,2)
      endif

      do i=1,nchain
          ist = ianf(i)
c rna
          if (idirogl.eq.1) then
             call ogribb(2)
             call sribcol(4)
          endif
          call ribbon(2,1,1,iun,1,ist,i)
          if (idirogl.eq.1) then
             call ogendd(i)
          endif
      end do

      if (idirogl.eq.1) then
          call ribpnt(0,2)
          call ribpnt(1,3)
      endif

      do i=1,nchain
          ist = ianf(i)
c coil
          if (idirogl.eq.1) then
             call ogribb(3)
             call sribcol(5)
          endif
          call ribbon(3,1,1,iun,1,ist,i)
          if (idirogl.eq.1) then
             call ogendd(i)
          endif

      end do

      if (idirogl.eq.1) call ribpnt(0,3)
  
      close(iun)

      return
      end

      integer function getlin(ieq)
      character*137 line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      common /mflin/  linmf

      getlin = 1

      line(1:1) = " "
      call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100

      linmf = linmf + 1
      do i=1,137
         if (ichar(line(i:i)).eq.9) line(i:i) = ' '
      end do

      if (ieq.eq.1.or.ieq.eq.2) then
         do i=1,137
            if (ichar(line(i:i)).eq.61) line(i:i) = ' '
         end do
      endif

      if (ieq.eq.2) then
         do i=1,137
            ii = ichar(line(i:i))
            if (ii.eq.40.or.ii.eq.41.or.ii.eq.34.or.ii.eq.39) 
     &         line(i:i) = ' '
         end do
      endif

      if (ieq.eq.3) then
         do while (.true.)
            i1 = index(line,'(')
            i2 = index(line,')')
            if (i1.gt.0.and.i2.gt.0) then
               line = line(1:i1-1)//line(i2+1:)
            else
               return
            endif
         end do
      endif

      return

100   getlin = 0
      return
      end

      subroutine setlin(str,ic)
      character*(*) str
      character*137 line
      common /curlin/ line

      line = str
      if (ic.ne.0) then
         do i=1,linlen(str)
            if (ichar(line(i:i)).eq.ic) line(i:i) = ' '
         end do
      endif

      return
      end

      integer function nxtwrd(string,strlen,itype,rtype)
c
c      string           nxtwrd = 1 
c      integer          nxtwrd = 2 
c      real             nxtwrd = 3 
c      no word          nxtwrd = 0
c
      character*(*) string
      integer itype,strlen,ilen,iend
      double precision rtype
      double precision reada
      logical chkstr
      character*137 line
      common /curlin/ line

      nxtwrd = 0
      
      ilen = 0
      llen = linlen(line)
      if (ilen.gt.len(line)) then
          ilen = len(line)
      endif
      if (llen.eq.0) return

      do while (line(1:1).eq.' ')
          line = line(2:)
      end do

      iend = index(line,' ')
      if (iend.eq.0) then
         iend = llen
      else
         iend = iend - 1
      endif
      if (chkstr(line,iend)) then
           nxtwrd = 1
           string = line(1:iend)
           strlen = iend
      elseif (index(line(1:iend),'.').ne.0) then
           nxtwrd = 3
           rtype = reada(line,1,iend)
      else
           nxtwrd = 2
           itype = reada(line,1,iend)
      endif

      line = line(iend+1:)

      return
      end

      integer function nxtwrz(string,strlen,itype,rtype)
c
c      string           nxtwrd = 1 
c      integer          nxtwrd = 2 
c      real             nxtwrd = 3 
c      n*int            nxtwrd = 4 
c      no word          nxtwrd = 0
c
      character*(*) string
      integer itype,strlen
      double precision rtype
      double precision reada
      logical chkstd
      character*137 line
      common /curlin/ line

      nxtwrz = 0
      
      llen = linlen(line)
      if (llen.eq.0) return

      do while (line(1:1).eq.' ')
          line = line(2:)
      end do

      iend = index(line,' ')
      if (iend.eq.0) then
         iend = llen
      else
         iend = iend - 1
      endif
      if (chkstd(line,iend)) then
           nxtwrz = 1
           string = line(1:iend)
           strlen = iend
      elseif (index(line(1:iend),'.').ne.0) then
           if (index(line(1:iend),'*').ne.0) then
              ied = index(line,'*')
              if (ied.eq.0) then
                 ied = llen
              else
                 ied = ied - 1
              endif
              itype = reada(line,1,ied)
              nxtwrz = 4
           else
              nxtwrz = 3
              rtype = reada(line,1,iend)
           endif
      else
           nxtwrz = 2
           itype = reada(line,1,iend)
      endif

      line = line(iend+1:)

      return
      end

      integer function nxtwrx(string,strlen,itype,rtype)
c
c      string           nxtwrd = 1 
c      integer          nxtwrd = 2 
c      real             nxtwrd = 3 
c      no word          nxtwrd = 0
c
      character*(*) string
      integer itype,strlen
      double precision rtype
      double precision reada
      logical chkstr
      character*137 line
      common /curlin/ line

      nxtwrx = 0
      
      nine  = ichar('9')
      izero = ichar('0')

      llen = linlen(line)
      if (llen.eq.0) return

      do while (line(1:1).eq.' ')
          line = line(2:)
      end do

      if (llen.gt.3) then
          do i=1,llen-2
              ii = ichar(line(i+1:i+1))
              if (line(i:i).eq.'('.and.line(i+2:i+2).eq.')'.and.
     &           (ii.ge.izero.and.ii.le.nine)) then
                 line = line(i-1:)//line(i+3:)
              endif
          end do
      endif

      llen = linlen(line)
      if (llen.eq.0) return

      iend = index(line,' ')
      if (iend.eq.0) then
         iend = llen
      else
         iend = iend - 1
      endif

      if (chkstr(line,iend)) then
           nxtwrx = 1
           string = line(1:iend)
           strlen = iend
      elseif (index(line(1:iend),'.').ne.0) then
           nxtwrx = 3
           rtype = reada(line,1,iend)
      else
           nxtwrx = 2
           itype = reada(line,1,iend)
      endif

      line = line(iend+1:)

      return
      end

      logical function chkstr(line,iend)
      integer ie,iee,id,idd,nine,izero,minus
      integer iplus,idot,icomma,islash
      character*(*) line
      chkstr = .false.

      ie    = ichar('e')
      iee   = ichar('E')
      id    = ichar('d')
      idd   = ichar('D')
      nine  = ichar('9')
      izero = ichar('0')
      minus = ichar('-')
      iplus = ichar('+')
      idot  = ichar('.')
      icomma = ichar(',')
      islash  = ichar('/')

      ihase = 0
      idig = 0
      do i=1,iend
         n = ichar(line(i:i))
         if ((n.eq.ie.or.n.eq.iee.or.n.eq.id.or.n.eq.idd)
     &      .and.ihase.eq.0.and.idig.eq.1) then
             n = izero
             ihase = 1
         endif
         if (n.ne.0) then
            if (n.lt.iplus.or.n.gt.nine.or.n.eq.islash
     &          .or.n.eq.icomma) goto 100
            idig = 1
         endif
      end do

      n = ichar(line(1:1))
      n2 = ichar(line(2:2))
      if (iend.eq.1) then
         if (n.eq.minus) goto 100
         if (n.eq.iplus) goto 100
         if (n.eq.ie.or.n.eq.iee) goto 100
         if (n.eq.id.or.n.eq.idd) goto 100
      elseif (iend.gt.1) then
         if (n.eq.minus.and.n2.eq.minus) goto 100
      endif

      return
100   chkstr = .true.
      return
      end

      logical function chkstd(line,iend)
      character*(*) line
      chkstd = .false.

      ie    = ichar('e')
      iee   = ichar('E')
      id    = ichar('d')
      idd   = ichar('D')
      nine  = ichar('9')
      izero = ichar('0')
      minus = ichar('-')
      iplus = ichar('+')
      idot  = ichar('.')
      icomma = ichar(',')
      islash = ichar('/')
      istar  = ichar('*')

      ihase = 0
      idig = 0
      do i=1,iend
         n = ichar(line(i:i))
         if ((n.eq.ie.or.n.eq.iee.or.n.eq.id.or.n.eq.idd)
     &      .and.ihase.eq.0.and.idig.eq.1) then
             n = izero
             ihase = 1
         endif
         if ((n.lt.iplus.or.n.gt.nine.or.n.eq.islash
     &       .or.n.eq.icomma).and.n.ne.istar) goto 100
         idig = 1
      end do

      n = ichar(line(1:1))
      n2 = ichar(line(2:2))
      if (iend.eq.1) then
         if (n.eq.minus) goto 100
         if (n.eq.iplus) goto 100
         if (n.eq.ie.or.n.eq.iee) goto 100
         if (n.eq.id.or.n.eq.idd) goto 100
      elseif (iend.gt.1) then
         if (n.eq.minus.and.n2.eq.minus) goto 100
      endif

      return
100   chkstd = .true.
      return
      end

      integer function linlen(line)
      character*(*) line
      integer i,n

      linlen = 0

      do i=len(line),1,-1
         n = ichar(line(i:i))
         if (n.gt.32.and.n.le.126) goto 100
      end do

      return
100   linlen = i
      return
      end

      logical function dat3ln(lin)
      integer i,itype,ktype,nstr
      double precision rtype
      character*(*) lin
      character*137 str
      character*137 line
      common /curlin/ line

      dat3ln = .true.

      line = lin

      do i=1,3
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3.and.ktype.ne.2) goto 100
      end do

      return
100   dat3ln = .false.
      return
      end

      logical function datlin(line)
      character*(*) line

      datlin = .true.

      do i=1,linlen(line)
         n = ichar(line(i:i))
         if ((n.lt.43.or.n.gt.57).and.n.ne.32.and.n.ne.68.
     &       and.n.ne.100.and.n.ne.69.and.n.ne.101) goto 100
      end do

      return
100   datlin = .false.
      return
      end

      logical function gnreal(r,n,doget)
      implicit double precision (a-h,o-z)
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical doget
      dimension r(*)

      gnreal = .true.

      if (doget) then
         if (getlin(0).ne.1) gnreal = .false.
      endif

      if (gnreal) then
          do i=1,n
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                r(i) = rtype
             elseif (ktype.eq.2) then
                r(i) = dble(itype)
             else
                gnreal = .false.
             endif
          end do
      endif

      return
      end
    
      logical function gnint(iarr,n,doget)
      implicit double precision (a-h,o-z)
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical doget
      dimension iarr(*)

      gnint = .true.

      if (doget) then
         if (getlin(0).ne.1) gnint = .false.
      endif


      if (gnint) then
          do i=1,n
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.2) then
                iarr(i) = itype
             else
                gnint = .false.
             endif
          end do
      endif

      return
      end
    
      subroutine lsparm(str,l)
      character*(*) str

      l = len(str)
      do i=1,l
         if (str(i:i).ne.' ') goto 10
      end do
10    str = str(i:)
      l = linlen(str)
      return
      end

      subroutine spatrm(str,l)
      character*(*) str

      j = 1
      l = len(str)
      do while (j.le.l) 
         if (str(j:j).eq.' ') then
           if (l.eq.1) then
              return
           else
              if (j.ne.l) then
                 if (j.eq.1) then
                    str(1:l-1) = str(2:l)
                    str(l:l) = ' '
                 else
c                    str(j:l-1) = str(j:j-1)//str(j+1:l)
                    str(j:l-1) = str(j+1:l)
                    str(l:l) = ' '
                 endif
              endif
              l = l - 1
           endif
         else
           j = j + 1
         endif
      end do

c      if (l.lt.len(str)) str(l+1:l+1) = char(0)

      return
      end

      integer function krnd(r)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)

      krnd = int(r)
      if (r-dfloat(krnd).ge.0.5d0) krnd = krnd + 1

      return
      end

      subroutine rmnull(line)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*137 line

      ii = 0
      do while (ii.le.137)
         ii = ii + 1
         jj = ichar(line(ii:ii))
         if (jj.eq.0) then
            do kk=ii,136
               line(kk:kk) = line(kk+1:kk+1)
            end do
            if (ii.eq.138) return
            ii = ii - 1
         endif
         if (jj.eq.10.or.jj.eq.13) return
      end do

      return
      end

      subroutine rwfile()
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      rewind iun2

      return
      end

      subroutine bcfile()
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      backspace iun2

      return
      end

      subroutine nxline(line,istat)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      character*137 line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      istat = 0

      read(iun2,'(a)',end=100,err=200) line

      return
100   istat = 1
      return
200   istat = 2
      return
      end

      subroutine getind(igtinp,
     &                         iconn,iopt,iresid,ityp,coo,q)
      implicit real (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str
      character*2 catom, catomt, tolowf,iel
      parameter (mxcon=10)
      parameter (numres=50000)
      parameter (mxion=2000)
      common /athlp/ iatoms, mxnat
      integer*2 ityp
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      character*137 line
      common /curlin/ line
      logical box,cell,fast,adjatm
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      character*3 hetz
      common /resstr/ hetz(numres)
      logical dall,osingl,gnreal,dolbfgs,oqscal
      dimension coo(3,*),iconn(mxcon+1,*),q(*),ityp(*),iopt(*)
      dimension iresid(*)
      dimension dmn(3),dmx(3),ddif(3)

      big = 1000000.0e0
      small = -1000000.0e0

      do i=1,3
         dmn(i) = big
         dmx(i) = small
      end do

      do i=1,numres
         hetz(i) = "   "
      end do

c      idebug = 0
      iform = 0
      igtinp = 1
      dall = .false.
      ifndhn = 0

      if (idebug.eq.1) write(iun5,*) 'subroutine getinp'

c get number of atoms

      line = ''
      if (getlin(0).eq.1) then

         if (icdex(line,'[AMBFOR]').ne.0) then
            iform = 1
            ic = icdex(line,'box')
            if (ic.ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               box = .true.
               if (gnreal(abc,3,.false.)) then
                  do i=1,3
                     abc2(i) = 0.5e0*abc(i)
                  end do
               else
                  box = .false.
               endif
            endif
            
            ic = icdex(line,'cell')
            if (ic.ne.0) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               ktype = nxtwrd(str,nstr,itype,rtype)
               cell = .true.
               if (gnreal(abc,3,.false.)) then
                  do i=1,3
                     abc2(i) = 0.5e0*abc(i)
                  end do
                  if (gnreal(angles,3,.false.)) then
                     call setop(abc(1),abc(2),abc(3),
     &                          angles(1),angles(2),angles(3))
                  else
                     cell = .false.
                  endif
               else
                  cell = .false.
               endif
            endif
            
            if (getlin(0).eq.1) idum = 1
         endif

         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            iatoms = itype
            if (iatoms.gt.mxnat) then
               dall = .true.
               goto 100
            endif
         else
            goto 100
         endif
      else
         goto 100
      endif

110   continue

      do iat=1,iatoms
         if (getlin(0).eq.1) then
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.ne.2) goto 100
           if (iform.eq.1) then
               iopt(iat) = itype
           else
               iopt(iat) = 1
           endif
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.1) then
                 if (nstr.eq.1) then
                    catomt(1:1) = str(1:1)
                    catomt(2:2) = ' '
                 else
                    catomt = str(1:2)
                    if (catomt(2:2).eq.'+'.or.catomt(2:2).eq.'-'
     &                 .or.catomt(2:2).eq.'*') catomt(2:2) = ' '
                 endif
                 catom = tolowf(catomt)
           else
              goto 100
           endif

           do i=1,3
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) then
                 coo(i,iat) = rtype
                 if (box) then
                    if (rtype.lt.dmn(i)) dmn(i) = rtype
                    if (rtype.gt.dmx(i)) dmx(i) = rtype
                 endif
              else
                 goto 100
              endif
           end do

           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.2) then

c for atom types 2001-2011 (tinker convention) -> 649-659
              if (itype.gt.2000) itype = itype - 1352

              ityp(iat) = itype

              if (itype.lt.0) then

c this is a gaff atom type, so read in an extra charge field                 

                 ktype = nxtwrd(str,nstr,itype,rtype)
                 if (ktype.eq.3) then
                    q(iat) = rtype
                 else
                    goto 100
                 endif
              endif

           else
              goto 100
           endif
           nc = 0
           do i=1,mxcon
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.2) then
                 iconn(i+1,iat) = itype
                 nc = nc + 1
              endif
           end do
           iconn(1,iat) = nc
        else
          goto 100
        endif
      end do

      natnow = 0
      numwat = 0
      if (box) then

        iat = 0
        do while (iat.lt.iatoms)
          iat = iat + 1
          it1 = ityp(iat)
          it2 = ityp(iat+1)
          it3 = ityp(iat+2)
          if (it1.eq.649.and.it2.eq.650.and.it3.eq.650) then
              if (natnow.eq.0) natnow = iat
              iat = iat + 2
          else
              natnow = 0
          endif
        end do

        if (natnow.ne.0) natnow = natnow - 1

        numwat = (iatoms - natnow)/3

      endif
      
      
      if (getlin(0).eq.1) then
         if (icdex(line,'[RESIDUES]').ne.0) then
             ihsres = 0
             do while (getlin(0).eq.1)
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.2) then
                   ihsres = ihsres + 1
                   irs = itype
                   ires(ihsres) = irs
                endif
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.2) then
                   istrt = itype
                   ibeg(ihsres) = istrt
                   if (ihsres.gt.1) iend(ihsres-1) = istrt - 1
                endif
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) then
                   if (nstr.eq.3) then
                      hetz(ihsres) = str(1:3)
                   endif
                endif
                do i=istrt,iatoms
                   iresid(i) = irs
                end do
             end do
             iend(ihsres) = iatoms
         endif
      endif

      if (box) then
         adjatm = .false.
         do i=1,3
            ddif(i) = dmx(i) - dmn(i)
            if (ddif(i).gt.abc(i)) adjatm = .true.
         end do
         if (adjatm) then
            if (idebug.eq.1) then
               print*,'adjusted atom coordinates to fit in box:'
               print*,''
               print*,'min x,y,z ',(dmn(i),i=1,3)
               print*,'max x,y,z ',(dmx(i),i=1,3)
               print*,'max-min x,y,z ',(dmx(i)-dmn(i),i=1,3)
               print*,'abc ',(abc(i),i=1,3)
               print*,''
            endif
            call appbnd(coo,ityp)
         endif
      endif

      return

100   if (dall) then
         rewind iun2
         igtinp = -1
         return
      endif

      igtinp = 0

      return
      end

      integer function getlin(ieq)
      character*137 line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      common /mflin/  linmf

      getlin = 1
      read(iun2,'(a)',err=100,end=100) line
      linmf = linmf + 1
      do i=1,137
         if (ichar(line(i:i)).eq.9) line(i:i) = ' '
      end do

      if (ieq.eq.1.or.ieq.eq.2) then
         do i=1,137
            if (ichar(line(i:i)).eq.61) line(i:i) = ' '
         end do
      endif

      if (ieq.eq.2) then
         do i=1,137
            ii = ichar(line(i:i))
            if (ii.eq.40.or.ii.eq.41.or.ii.eq.34) line(i:i) = ' '
         end do
      endif

      return
100   getlin = 0
      return
      end

      integer function nxtwrd(string,strlen,itype,rtype)
c
c      string           nxtwrd = 1 
c      integer          nxtwrd = 2 
c      real             nxtwrd = 3 
c      no word          nxtwrd = 0
c
      character*(*) string
      integer itype,strlen
      real rtype
      real reada
      logical chkstr
      character*137 line
      common /curlin/ line

      nxtwrd = 0
      
      llen = linlen(line)
      if (llen.eq.0) return

      do while (line(1:1).eq.' ')
          line = line(2:)
      end do

      iend = index(line,' ')
      if (iend.eq.0) then
         iend = llen
      else
         iend = iend - 1
      endif
      if (chkstr(line,iend)) then
           nxtwrd = 1
           string = line(1:iend)
           strlen = iend
      elseif (index(line(1:iend),'.').ne.0) then
           nxtwrd = 3
           rtype = reada(line,1,iend)
      else
           nxtwrd = 2
           itype = reada(line,1,iend)
      endif

      line = line(iend+1:)

      return
      end

      logical function chkstr(line,iend)
      character*(*) line
      chkstr = .false.

      ie    = ichar('e')
      iee   = ichar('E')
      id    = ichar('d')
      idd   = ichar('D')
      nine  = ichar('9')
      izero = ichar('0')
      minus = ichar('-')
      iplus = ichar('+')
      idot  = ichar('.')
      icomma = ichar(',')
      islash  = ichar('/')

      ihase = 0
      idig = 0
      do i=1,iend
         n = ichar(line(i:i))
         if ((n.eq.ie.or.n.eq.iee.or.n.eq.id.or.n.eq.idd)
     &      .and.ihase.eq.0.and.idig.eq.1) then
             n = izero
             ihase = 1
         endif
         if (n.lt.iplus.or.n.gt.nine.or.n.eq.islash
     &       .or.n.eq.icomma) goto 100
         idig = 1
      end do

      n = ichar(line(1:1))
      n2 = ichar(line(2:2))
      if (iend.eq.1) then
         if (n.eq.minus) goto 100
         if (n.eq.iplus) goto 100
         if (n.eq.ie.or.n.eq.iee) goto 100
         if (n.eq.id.or.n.eq.idd) goto 100
      elseif (iend.gt.1) then
         if (n.eq.minus.and.n2.eq.minus) goto 100
      endif

      return
100   chkstr = .true.
      return
      end

      integer function linlen(line)
      character*(*) line

      linlen = 0

      do i=len(line),1,-1
         n = ichar(line(i:i))
         if (n.gt.32.and.n.le.126) goto 100
      end do

      return
100   linlen = i
      return
      end

      real function reada(a,istart,ll)
      implicit real (a-h,o-z)
      character*1 a(ll)
      logical multi,scient

      nine  = ichar('9')
      izero = ichar('0')
      minus = ichar('-')
      iplus = ichar('+')
      idot  = ichar('.')
      ie    = ichar('E')
      iee   = ichar('e')
      id    = ichar('D')
      idd   = ichar('d')
      idig  = 0
      k1    = 0
      k2    = 0
      k3    = 0
      one   = 1.d0
      x     = 1.d0
      do j=istart,ll
         n = ichar(a(j))
         if((n.le.nine.and.n.ge.izero).or. n.eq.minus.or.n.eq.idot)
     &   goto 7
      end do
      reada = 0.d0
      return

7     continue
c     before the dot
      do i=j,ll
         n = ichar(a(i))
         if (n.le.nine.and.n.ge.izero) then
            idig = idig + 1
            if (idig.gt.10) then
               ii = i
               goto 90
            endif
            k1 = k1*10 + n - izero
         elseif (n.eq.minus.and.i.eq.j) then
             one = -1.d0
         elseif (n.eq.idot) then
             goto 30
         else
             ii = i
             goto 90
         endif
      end do
30    continue
c     after the dot
      idig = 0
      do ii=i+1,ll
         n = ichar(a(ii))
         if (n.le.nine.and.n.ge.izero) then
            idig = idig + 1
            if (idig.gt.9) goto 90
            k2 = k2*10 + n - izero
            x = x /10
         elseif (n.eq.minus.and.ii.eq.i) then
            x = -x
         else
            goto 90
         endif
      end do
90    continue
      scient = .false.
      do jj=ii,ll
         n = ichar(a(jj))
         if (n.eq.ie.or.n.eq.iee.or.n.eq.id.or.n.eq.idd) goto 95
      end do
      goto 100
95    continue
         if (jj.lt.159) then
            scient = .true.
            n = ichar(a(jj+1))
            if (n.eq.minus.or.n.eq.iplus) then
                multi = .true.
                if (n.eq.minus) multi = .false.
                idig = 0
                do j=jj+2,ll
                   n = ichar(a(j))
                   if (n.le.nine.and.n.ge.izero) then
                       idig = idig + 1
                       if (idig.gt.9) goto 90
                       k3 = k3*10 + n - izero
                   else
                      goto 100
                   endif
                end do
            endif
         endif

100   continue
      reada = one * ( k1 + k2 * x)
      if (scient) then
          if (multi) then
              reada = reada * 10**k3
          else
              if (k3.gt.25) then
                 reada = 0.0e0
              else
                 reada = reada / 10**k3
              endif
          endif
      endif

      return
      end

      logical function gnreal(r,n,doget)
      implicit real (a-h,o-z)
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical doget
      dimension r(*)

      gnreal = .true.

      if (doget) then
         if (getlin(0).ne.1) gnreal = .false.
      endif

      if (gnreal) then
          do i=1,n
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (ktype.eq.3) then
                r(i) = rtype
             elseif (ktype.eq.2) then
                r(i) = dble(itype)
             else
                gnreal = .false.
             endif
          end do
      endif

      return
      end
    
      subroutine getpar
      implicit real (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str
      character*137 line
      common /curlin/ line
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      parameter (mxgff=72)
      parameter (mxamb=1590)
      integer amb2gf
      common /gftyp/  gfvdw(2,mxgff),amb2gf(mxamb)
      logical opfil,opar

      iun2t = iun2
      opar = .false.
      if (opfil(62,'param',5,1,1,1)) then
         iun2 = 62
         if (getlin(0).eq.1) then
            if (icdex(line,'[PARAM]').ne.0) opar = .true.
         endif
         if (opar) then
            do while (.true.)
                if (getlin(0).eq.1) then
                   it = 0
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.2) then
                      it = itype
                   else
                      goto 100
                   endif
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.3) then
                      par1 = rtype
                   else
                      goto 100
                   endif
                   ktype = nxtwrd(str,nstr,itype,rtype)
                   if (ktype.eq.3) then
                      par2 = rtype
                   else
                      goto 100
                   endif
                   if (it.gt.0.and.it.le.mxgff) then
                      print*,'old ityp ',it,gfvdw(1,it),gfvdw(2,it)
                      gfvdw(1,it) = par1
                      gfvdw(2,it) = par2
                      print*,'new ityp ',it,gfvdw(1,it),gfvdw(2,it)
                   endif
                else
                   goto 100
                endif
            end do
         endif
      else
         return
      endif

      iun2 = iun2t
      return

100   close(62)
      iun2 = iun2t

      return
      end
    

      subroutine parstp
      implicit double precision (a-h,o-z)
      logical ostep,fine,oscal
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      dimension setval(20)

      setval(1)  = 1.d-4
      setval(2)  = 2.5d-4
      setval(3)  = 5.d-4
      setval(4)  = 1.d-3
      setval(5)  = 2.5d-3
      setval(6)  = 5.d-3
      setval(7)  = 1.d-2
      setval(8)  = 2.5d-2
      setval(9)  = 5.d-2
      setval(10) = 1.d-1
      setval(11) = 2.5d-1
      setval(12) = 5.d-1
      setval(13) = 1.d 0
      setval(14) = 2.5d 0
      setval(15) = 5.d 0
      setval(16) = 1.d 1
      setval(17) = 2.5d 1
      setval(18) = 5.d 1
      setval(19) = 1.d 2
      setval(20) = 2.5d 2

      do 215 i=1,20
  215        if(pmax*cut.lt.setval(i)) goto 216
      if(i.eq.21) i=20
  216 step=setval(i)*0.05d0

      if (ostep) step = stepf

      if(fine) then
          dellh=0.249999d0
      else
          dellh=1.d0
      endif
      step=step*dellh

      if (pmax.eq.0.0d0) then
         scale =1.0d0
      else
         scale = -0.5d0/pmax
      endif
      if (oscal) scale = scalf

      return
      end

      subroutine caldis(calds,crot,fdist,cdist,tol,ianz)
      implicit double precision (a-h,o-z)
      parameter (bignum=1.0d12)
      parameter (numat1=20000)
      common /athlp/ iatoms, mxnat
      common /gamori/imap(numat1),cstand(3,numat1),istand(numat1),
     &               msucc
      dimension crot(3,numat1),fdist(numat1),cdist(numat1)
      dimension ianz(*)

c dist = the shortest distance found between a particular atom of crot
c        whilst screening it against all of the atoms of cstand
c dis  = the total sum over all atoms of dist(iatom)

      calds = 0.0d0

      natoms = iatoms
      if (iatoms.gt.numat1) natoms = numat1

      do k=1,natoms
         dist = bignum
         imap(k) = 0
         do l=1,natoms
            if((ianz(k).eq.istand(l)).and.
     &      ((fdist(k)-cdist(l))**2.lt.tol)) then
                distt = 0.0d0
                do j=1,3
                   distt = distt + 
     &             (crot(j,k)-cstand(j,l))**2
                end do
                if (distt.lt.dist) then
                   dist = distt
                   imap(k) = l
                endif
            endif
         end do
         calds = calds + dsqrt(dist)
      end do

      calds = dsqrt(calds)

      return
      end

      subroutine searchd(line,name1,name2,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name1,name2
      character*137 caps1, caps2

      istat = 0
      caps1 = name1
      caps2 = name2
      len1  = len(name1)
      len2  = len(name2)
      call tocap(caps1,len1)
      call tocap(caps2,len2)
1     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      if (index(line,name1).eq.0.and.index(line,name2).eq.0
     &.and.index(line,caps1(1:len1)).eq.0
     &.and.index(line,caps2(1:len2)).eq.0) go to 1
c
      istat=1
      return
c
100   call rewfil
c
      return
      end 

      subroutine seardu(line,name1,name2,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name1,name2
      character*137 caps1, caps2, caps3

      istat = 0
      len1  = min(137,len(name1))
      len2  = min(137,len(name2))
      caps1 = name1(1:len1)
      caps2 = name2(1:len2)
      call tocap(caps1,len1)
      call tocap(caps2,len2)

1     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      len3  = min(137,len(line))
      caps3 = line(1:len3)
      call tocap(caps3,len3)
      if (index(caps3,caps1(1:len1)).eq.0.and.
     &    index(caps3,caps2(1:len2)).eq.0) goto 1
 
      istat = 1
      return
 
100   call rewfil
      return
 
      end 

      subroutine seartu(line,name1,name2,name3,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name1,name2,name3
      character*137 caps1, caps2, caps3, capst

      istat = 0
      len1  = min(137,len(name1))
      len2  = min(137,len(name2))
      len3  = min(137,len(name3))
      caps1 = name1(1:len1)
      caps2 = name2(1:len2)
      caps3 = name3(1:len3)
      call tocap(caps1,len1)
      call tocap(caps2,len2)
      call tocap(caps3,len3)

1     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      lent  = min(137,len(line))
      capst = line(1:lent)
      call tocap(capst,lent)
      if (index(capst,caps1(1:len1)).eq.0.and.
     &    index(capst,caps2(1:len2)).eq.0.and.
     &    index(capst,caps3(1:len3)).eq.0) goto 1
 
      istat = 1
      return
 
100   call rewfil
      return
 
      end 

      subroutine searcht(line,name1,name2,name3,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name1,name2,name3
      character*137 caps1, caps2, caps3

      istat = 0
      caps1 = name1
      caps2 = name2
      caps3 = name3
      len1  = len(name1)
      len2  = len(name2)
      len3  = len(name3)
      call tocap(caps1,len1)
      call tocap(caps2,len2)
      call tocap(caps3,len3)
1     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      if (index(line,name1).eq.0.and.index(line,name2).eq.0
     &.and.index(line,name3).eq.0
     &.and.index(line,caps1(1:len1)).eq.0
     &.and.index(line,caps2(1:len2)).eq.0
     &.and.index(line,caps3(1:len3)).eq.0) go to 1
c
      istat=1
      return
c
100   call rewfil
      return
c
      end 

      subroutine searchq(line,name1,name2,name3,name4,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name1,name2,name3,name4
      character*137 caps1, caps2, caps3, caps4

      istat = 0
      caps1 = name1
      caps2 = name2
      caps3 = name3
      caps4 = name4
      len1  = len(name1)
      len2  = len(name2)
      len3  = len(name3)
      len4  = len(name4)
      call tocap(caps1,len1)
      call tocap(caps2,len2)
      call tocap(caps3,len3)
      call tocap(caps4,len4)
1     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      if (index(line,name1).eq.0.and.index(line,name2).eq.0
     &.and.index(line,name3).eq.0.and.index(line,name4).eq.0
     &.and.index(line,caps1(1:len1)).eq.0
     &.and.index(line,caps2(1:len2)).eq.0
     &.and.index(line,caps3(1:len3)).eq.0
     &.and.index(line,caps4(1:len4)).eq.0) go to 1
c
      istat=1
      return
c
100   call rewfil
      return
c
      end 

      subroutine searchv(line,name1,name2,name3,name4,name5,istat)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*(*) line,name1,name2,name3,name4,name5
      character*137 caps1, caps2, caps3, caps4, caps5

      istat = 0
      caps1 = name1
      caps2 = name2
      caps3 = name3
      caps4 = name4
      caps5 = name5
      len1  = len(name1)
      len2  = len(name2)
      len3  = len(name3)
      len4  = len(name4)
      len5  = len(name5)
      call tocap(caps1,len1)
      call tocap(caps2,len2)
      call tocap(caps3,len3)
      call tocap(caps4,len4)
      call tocap(caps5,len5)
1     call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      if (index(line,name1).eq.0.and.index(line,name2).eq.0
     &.and.index(line,name3).eq.0.and.index(line,name4).eq.0
     &.and.index(line,name5).eq.0.and.index(line,caps1(1:len1)).eq.0
     &.and.index(line,caps2(1:len2)).eq.0
     &.and.index(line,caps3(1:len3)).eq.0
     &.and.index(line,caps4(1:len4)).eq.0
     &.and.index(line,caps5(1:len5)).eq.0) go to 1
c
      istat=1
      return
c
100   call rewfil
      return
c
      end 

      subroutine samind(istat,ianz,iresid,iconn,ipdbt,
     &                  icalf,ncalf,iamino)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      integer*2 ipdbt
      dimension icd(3),icdh(3),icdhn(3)
      dimension ianz(*),iresid(*),iconn(mxcon+1,*),ipdbt(*)
      dimension icalf(6,*),iamino(*)
  
      istat = 0

      do i=1,iatoms
         iresid(i) = -4
      end do

      do k=1,ncalf

      icbet = 0
      icalp = icalf(1,k)
      call setvar(iresid,mxnat,icalf(1,k),k)
      call setvr2(ipdbt,mxnat,icalf(1,k),2)
      call setvr2(ipdbt,mxnat,icalf(2,k),1)
      call setvr2(ipdbt,mxnat,icalf(3,k),3)

      ich = 0
      do i=1,iconn(1,icalf(1,k))
         ii = abs(iconn(i+1,icalf(1,k)))
         call setvar(iresid,mxnat,ii,k)
         if (ianz(ii).eq.6.and.ii.ne.icalf(3,k)) icbet = ii
         if (ianz(ii).eq.1) then
            ich = ich + 1
            call setvr2(ipdbt,mxnat,ii,3 + ich)
         endif
      end do
      inh = 0
      do i=1,iconn(1,icalf(2,k))
         ii = abs(iconn(i+1,icalf(2,k)))
         if (ianz(ii).eq.1) then
            inh = inh + 1
            call setvar(iresid,mxnat,ii,k)
            call setvr2(ipdbt,mxnat,ii,inh)
         endif
      end do
      io = 0
      do i=1,iconn(1,icalf(3,k))
         ii = abs(iconn(i+1,icalf(3,k)))
         if (ianz(ii).eq.8) then
            io = io + 1
            call setvar(iresid,mxnat,ii,k)
            if (io.eq.1) then
               call setvr2(ipdbt,mxnat,ii,4)
            else
               call setvr2(ipdbt,mxnat,ii,38)
            endif
         endif
      end do
      iamino(k) = 0
      if (icbet.eq.0) then
c Glycine
         iamino(k) = 1
         goto 100
      endif

      call setvr2(ipdbt,mxnat,icbet,5)
      icc = 0
      icn = 0
      ico = 0
      ics = 0
      ich = 0
      do i=1,iconn(1,icbet)
         ii = abs(iconn(i+1,icbet))
         call setvar(iresid,mxnat,ii,k)
         if (ianz(ii).eq.6) icc = icc + 1
         if (ianz(ii).eq.7) icn = icn + 1
         if (ianz(ii).eq.8) ico = ico + 1
         if (ianz(ii).eq.16) ics = ics + 1
         if (ianz(ii).eq.1) then
            ich = ich + 1
            call setvr2(ipdbt,mxnat,ii,6 + ich)
         endif
      end do
      itot = icc + icn + ico + ics

      if (itot.eq.1) then
c Alanine
         iamino(k) = 2
         goto 100
      endif

      if (itot.eq.2.and.icc.eq.1.and.ico.eq.1) then
c Serine
         iamino(k) = 3
         do i=1,iconn(1,icbet)
            ii = abs(iconn(i+1,icbet))
            if (ianz(ii).eq.8) then
               call setvr2(ipdbt,mxnat,ii,31)
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  if (ianz(nn).eq.1) then 
                      call setvar(iresid,mxnat,nn,k)
                      call setvr2(ipdbt,mxnat,nn,10)
                  endif
               end do
            endif
         end do
         goto 100
      endif

      if (itot.eq.2.and.icc.eq.1.and.ics.eq.1) then
c Cysteine
         iamino(k) = 4
         do i=1,iconn(1,icbet)
            ii = abs(iconn(i+1,icbet))
            if (ianz(ii).eq.16) then
               call setvr2(ipdbt,mxnat,ii,37)
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  if (ianz(nn).eq.1) then
                     call setvr2(ipdbt,mxnat,nn,10)
                     call setvar(iresid,mxnat,nn,k)
                  endif
               end do
            endif
         end do
         goto 100
      endif

      if (itot.eq.3.and.icc.eq.2.and.ico.eq.1) then
c Threonine
         iamino(k) = 5
         do i=1,iconn(1,icbet)
            ii = abs(iconn(i+1,icbet))
            ia = ianz(ii)
            ich = 0
            if ((ia.eq.6.and.ii.ne.icalp)
     &          .or.ia.eq.8) then
               if (ia.eq.8) call setvr2(ipdbt,mxnat,ii,32)
               if (ia.eq.6) call setvr2(ipdbt,mxnat,ii,8)
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  if (ianz(nn).eq.1) then
                     if (ia.eq.8) then
                        call setvr2(ipdbt,mxnat,nn,13)
                     else
                        ich = ich + 1
                        call setvr2(ipdbt,mxnat,nn,15 + ich)
                     endif
                  endif
                  call setvar(iresid,mxnat,nn,k)
               end do
            endif
         end do
         goto 100
      endif

      if (itot.eq.3.and.icc.eq.3) then

         icg1 = 0
         do i=1,iconn(1,icbet)
            ii = abs(iconn(i+1,icbet))
            if (ianz(ii).eq.6.and.ii.ne.icalp) then
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  ia = ianz(nn)
                  if (ia.eq.6.and.nn.ne.icbet) icg1 = ii
               end do
               if (icg1.eq.0) icg1 = ii
            endif
         end do

         do i=1,iconn(1,icbet)
            ii = abs(iconn(i+1,icbet))
            if (ianz(ii).eq.6.and.ii.ne.icalp) then
               call setvr2(ipdbt,mxnat,ii,8)
               if (ii.eq.icg1) call setvr2(ipdbt,mxnat,ii,7)
               ih = 0
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  ia = ianz(nn)
                  call setvar(iresid,mxnat,nn,k)
                  if (ia.eq.6.and.nn.ne.icbet) then
c Isoleucine
                     iamino(k) = 6
                     call setvr2(ipdbt,mxnat,nn,10)
                     ich2 = 0
                     do l=1,iconn(1,nn)
                       ll = abs(iconn(l+1,nn))
                       call setvar(iresid,mxnat,ll,k)
                       if (ianz(ll).eq.1) then
                          ich2 = ich2 + 1
                          call setvr2(ipdbt,mxnat,ll,21+ich2)
                       endif
                     end do
 
                  elseif (ia.eq.1) then

                     ih = ih + 1
                     call setvr2(ipdbt,mxnat,nn,15+ih)
                     if (ii.eq.icg1) call setvr2(ipdbt,mxnat,nn,12+ih)

                  endif
               end do

            endif
         end do
c Valine
         if (iamino(k).ne.6) iamino(k) = 7
         goto 100
      endif

      if (itot.ne.2) print*, 'error in classifying aminoacids'

      icgam = 0
      do i=1,iconn(1,icbet)
         ii = abs(iconn(i+1,icbet))
         if (ianz(ii).eq.6.and.ii.ne.icbet.and.ii.ne.icalp) then
            icgam = ii
            call setvr2(ipdbt,mxnat,icgam,6)
         endif
      end do
      icc = 0
      icn = 0
      ico = 0
      ics = 0
      ich = 0
      do i=1,iconn(1,icgam)
         ii = abs(iconn(i+1,icgam))
         ia = ianz(ii)
         call setvar(iresid,mxnat,ii,k)
         if (ia.eq.1) then
             ich = ich + 1
             call setvr2(ipdbt,mxnat,ii,9+ich)
         endif
         if (ia.eq.6) icc = icc + 1
         if (ia.eq.7) icn = icn + 1
         if (ia.eq.8) ico = ico + 1
         if (ia.eq.16) ics = ics + 1
      end do
      itot = icc + icn + ico + ics

      if (itot.eq.2.and.icc.eq.1.and.ics.eq.1) then
c Methionine
          iamino(k) = 8
          do i=1,iconn(1,icgam)
             ii = abs(iconn(i+1,icgam))
             if (ianz(ii).eq.16) then
                call setvr2(ipdbt,mxnat,ii,36)
                do n=1,iconn(1,ii)
                   nn = abs(iconn(n+1,ii))
                   if (ianz(nn).eq.6.and.nn.ne.icgam) then
                     call setvr2(ipdbt,mxnat,nn,12)
                     call setvar(iresid,mxnat,nn,k)
                     ich = 0
                     do l=1,iconn(1,nn)
                       ll = abs(iconn(l+1,nn))
                       if (ianz(ll).eq.1) then
                          call setvar(iresid,mxnat,ll,k)
                          ich = ich + 1
                          call setvr2(ipdbt,mxnat,ll,27+ich)
                       endif
                     end do
                   endif
                end do
             endif
          end do
          goto 100
      endif

      if (itot.eq.2.and.icc.eq.2) then
         icdel = 0
         do i=1,iconn(1,icgam)
            ii = abs(iconn(i+1,icgam))
            if(ianz(ii).eq.6.and.ii.ne.icbet) icdel = ii
         end do
         icc = 0
         icn = 0
         ico = 0
         ics = 0
         do i=1,iconn(1,icdel)
            ii = abs(iconn(i+1,icdel))
            call setvar(iresid,mxnat,ii,k)
            if (ianz(ii).eq.6) icc = icc + 1
            if (ianz(ii).eq.7) icn = icn + 1
            if (ianz(ii).eq.8) ico = ico + 1
            if (ianz(ii).eq.16) ics = ics + 1
         end do
         itot = icc + icn + ico + ics

         if (itot.eq.2.and.icc.eq.2) then
c Lysine
          iamino(k) = 12
          call setvr2(ipdbt,mxnat,icdel,9)
          ich = 0
          do i=1,iconn(1,icdel)
             ii = abs(iconn(i+1,icdel))
             ia = ianz(ii)
             if (ia.eq.6.and.ii.ne.icgam) then
                call setvr2(ipdbt,mxnat,ii,12)
                ich2 = 0
                do n=1,iconn(1,ii)
                   nn = abs(iconn(n+1,ii))
                   call setvar(iresid,mxnat,nn,k)
                   if (ianz(nn).eq.7) then
                     call setvr2(ipdbt,mxnat,nn,27)
                     inh = 0
                     do l=1,iconn(1,nn)
                       ll = abs(iconn(l+1,nn))
                       call setvar(iresid,mxnat,ll,k)
                       if (ianz(ll).eq.1) then
                         inh = inh + 1
                         call setvr2(ipdbt,mxnat,ll,39+inh)
                       endif
                     end do
                   endif
                   if (ianz(nn).eq.1) then
                     ich2 = ich2 + 1
                     call setvr2(ipdbt,mxnat,nn,27+ich2)
                   endif
                end do
             endif
             if (ia.eq.1) then
                ich = ich + 1
                call setvr2(ipdbt,mxnat,ii,18+ich)
             endif
          end do
          goto 100
         endif

         if (itot.eq.2.and.icc.eq.1.and.icn.eq.1) then

            call setvr2(ipdbt,mxnat,icdel,9)
            ich = 0
            do i=1,iconn(1,icdel)
               ii = abs(iconn(i+1,icdel))
               ia = ianz(ii)
               if (ia.eq.1) then
                  ich = ich + 1
                  call setvr2(ipdbt,mxnat,ii,18+ich)
               endif
            end do

            do i=1,iconn(1,icdel)
               ii = abs(iconn(i+1,icdel))
               ia = ianz(ii)
               if (ia.eq.7) then
                  if (icalf(2,k).eq.ii) then
c Proline
                      iamino(k) = 15
                      goto 100
                  else
c Arginine
                     call setvr2(ipdbt,mxnat,ii,22)
                     iamino(k) = 16
                  endif
                  do n=1,iconn(1,ii)
                     nn = abs(iconn(n+1,ii))
                     call setvar(iresid,mxnat,nn,k)
                     if (ianz(nn).eq.6.and.nn.ne.icdel) then
                        call setvr2(ipdbt,mxnat,nn,17)
                        inn = 0
                        do l=1,iconn(1,nn)
                           ll = abs(iconn(l+1,nn))
                           call setvar(iresid,mxnat,ll,k)
                           if (ianz(ll).eq.7.and.ll.ne.ii) then
                              inn = inn + 1
                              call setvr2(ipdbt,mxnat,ll,24+inn)
                              inh = 0
                              do m=1,iconn(1,ll)
                                 mm = abs(iconn(m+1,ll))
                                 call setvar(iresid,mxnat,mm,k)
                                 if (ianz(mm).eq.1) then
                                    inh = inh + 1
                                    if (inn.eq.1) then
                                       call 
     &                                 setvr2(ipdbt,mxnat,mm,54+inh)
                                    else
                                       call 
     &                                 setvr2(ipdbt,mxnat,mm,57+inh)
                                    endif
                                 endif
                              end do
                           endif
                        end do
                     endif
                     if (ianz(nn).eq.1) call setvr2(ipdbt,mxnat,nn,28)
                  end do
                  goto 100
               endif
            end do
         endif

         if (itot.eq.3.and.icc.eq.1.and.ico.eq.2) then
c Glutamate
            call setvr2(ipdbt,mxnat,icdel,9)
            iamino(k) = 13
            io = 0
            do i=1,iconn(1,icdel)
               ii = abs(iconn(i+1,icdel))
               if (ianz(ii).eq.8) then
                  io = io + 1
                  call setvr2(ipdbt,mxnat,ii,33+io)
                  do n=1,iconn(1,ii)
                     nn = abs(iconn(n+1,ii))
                     call setvar(iresid,mxnat,nn,k)
                  end do
               endif
            end do
            goto 100
         endif

         if (itot.eq.3.and.icc.eq.1.and.ico.eq.1.and.icn.eq.1) then
c Glutamine
            call setvr2(ipdbt,mxnat,icdel,9)
            iamino(k) = 14
            do i=1,iconn(1,icdel)
               ii = abs(iconn(i+1,icdel))
               ia = ianz(ii)
               if (ia.eq.8) then
                  call setvr2(ipdbt,mxnat,ii,34)
               elseif (ia.eq.7) then
                  call setvr2(ipdbt,mxnat,ii,24)
                  inh = 0
                  do n=1,iconn(1,ii)
                     nn = abs(iconn(n+1,ii))
                     call setvar(iresid,mxnat,nn,k)
                     if (ianz(nn).eq.1) then
                        inh = inh + 1
                        call setvr2(ipdbt,mxnat,nn,33+inh)
                     endif
                  end do
               endif
            end do
            goto 100
         endif
      endif

      if (itot.eq.3.and.icc.eq.2.and.ico.eq.1) then
c HydroxyProline
         iamino(k) = 15
         do i=1,iconn(1,icgam)
            ii = abs(iconn(i+1,icgam))
            if (ianz(ii).eq.8.or.ianz(ii).eq.6) then
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  call setvar(iresid,mxnat,nn,k)
               end do
            endif
         end do
         goto 100
      endif

      if (itot.eq.3.and.icc.eq.1.and.ico.eq.2) then
c Aspartate
         iamino(k) = 9
         io = 0
         do i=1,iconn(1,icgam)
            ii = abs(iconn(i+1,icgam))
            if (ianz(ii).eq.8) then
               io = io + 1
               call setvr2(ipdbt,mxnat,ii,28+io)
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  call setvar(iresid,mxnat,nn,k)
               end do
            endif
         end do
         goto 100
      endif

      if (itot.eq.3.and.icc.eq.2.and.icn.eq.1) then
c Histidine
         iamino(k) = 17
         do i=1,iconn(1,icgam)
            ii = abs(iconn(i+1,icgam))
            ia = ianz(ii)
            if ((ia.eq.6.and.ii.ne.icbet).or.ia.eq.7) 
     &      then
               if (ia.eq.6) call setvr2(ipdbt,mxnat,ii,11)
               if (ia.eq.7) call setvr2(ipdbt,mxnat,ii,20)
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  na = ianz(nn)
                  if (nn.ne.icgam) then
                     if (na.eq.1.or.na.eq.6.or.na.eq.7) 
     &                  call setvar(iresid,mxnat,nn,k)
                     if (na.eq.1) then
                        if (ia.eq.7) then
                           call setvr2(ipdbt,mxnat,nn,22)
                        else
                           call setvr2(ipdbt,mxnat,nn,25)
                        endif
                     endif
                     if (na.eq.6) call setvr2(ipdbt,mxnat,nn,13)
                     if (na.eq.7) call setvr2(ipdbt,mxnat,nn,24)
                     do l=1,iconn(1,nn)
                        ll = abs(iconn(l+1,nn))
                        if (ianz(ll).eq.1) then
                           call setvar(iresid,mxnat,ll,k)
                           if (na.eq.6) then
                              call setvr2(ipdbt,mxnat,ll,31)
                           else
                              call setvr2(ipdbt,mxnat,ll,34)
                           endif
                        endif
                     end do
                  endif
               end do
            endif
         end do
         goto 100
      endif

      if (itot.eq.3.and.icc.eq.1.and.ico.eq.1.and.icn.eq.1) then
c Asparagine
         iamino(k) = 10
         do i=1,iconn(1,icgam)
            ii = abs(iconn(i+1,icgam))
            ia = ianz(ii)
            if (ia.eq.8.or.ia.eq.7) then
               if (ia.eq.8) call setvr2(ipdbt,mxnat,ii,29)
               if (ia.eq.7) then
                  call setvr2(ipdbt,mxnat,ii,21)
                  inh = 0
                  do n=1,iconn(1,ii)
                     nn = abs(iconn(n+1,ii))
                     call setvar(iresid,mxnat,nn,k)
                     if (ianz(nn).eq.1) then
                        inh = inh + 1
                        call setvr2(ipdbt,mxnat,nn,24+inh)
                     endif
                  end do
               endif
            endif
         end do
         goto 100
      endif

      if (itot.eq.3.and.icc.eq.3) then

         itrp = 0
         ice2 = 0
         inn = 0
         do i=1,iconn(1,icgam)
            ii = abs(iconn(i+1,icgam))
            if (ianz(ii).eq.6.and.ii.ne.icbet) then
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  if (nn.ne.icgam.and.ianz(nn).eq.7) then
c Tryptophan
                      iamino(k) = 20
                      itrp = 1
                      inn = nn
                  endif
               end do
               if (itrp.eq.1) then
                  do n=1,iconn(1,ii)
                     nn = abs(iconn(n+1,ii))
                     if (nn.ne.icgam.and.ianz(nn).eq.6) then
                        do m=1,iconn(1,nn)
                          mm = abs(iconn(m+1,nn))
                          if (mm.ne.ii.and.mm.eq.inn) ice2 = nn
                        end do
                     endif
                  end do
               endif
            endif
         end do
    
         l = 0
         icc = 0
         do i=1,2
            icd(i) = 0
            icdh(i) = 0
            icdhn(i) = 0
         end do

         do i=1,iconn(1,icgam)
            ii = abs(iconn(i+1,icgam))
            if (ianz(ii).eq.6.and.ii.ne.icbet) then
               icc = icc + 1
               icd(icc) = ii
               if (icc.eq.1) then
                  call setvr2(ipdbt,mxnat,ii,10)
               else
                  call setvr2(ipdbt,mxnat,ii,11)
               endif
               do n=1,iconn(1,ii)
                  nn = abs(iconn(n+1,ii))
                  na = ianz(nn)
                  if (nn.ne.icgam) then

                     call setvar(iresid,mxnat,nn,k)
                  
                     if (na.eq.6) then
                         l = 1
                         if (itrp.eq.1) then
                            if (nn.eq.ice2) then
                               call setvr2(ipdbt,mxnat,nn,14)
                            else
                               call setvr2(ipdbt,mxnat,nn,15)
                            endif
                         else
                            if (icc.eq.1) then
                               call setvr2(ipdbt,mxnat,nn,13)
                            else
                               call setvr2(ipdbt,mxnat,nn,14)
                            endif
                         endif
                     elseif (na.eq.1) then
                         icdh(icc) = nn
                         icdhn(icc) = icdhn(icc) + 1
                         if (icc.eq.1) then
                            call setvr2(ipdbt,mxnat,nn,22+icdhn(1)-1)
                         else
                            call setvr2(ipdbt,mxnat,nn,25+icdhn(2)-1)
                         endif
                     elseif (na.eq.7) then
c Tryptophan
                         iamino(k) = 20
                         call setvr2(ipdbt,mxnat,nn,23)
                         if (ii.ne.icd(1)) then
                            call setvr2(ipdbt,mxnat,icd(1),11)
                            call setvr2(ipdbt,mxnat,icd(2),10)
                            call setvr2(ipdbt,mxnat,icdh(1),25)
                            call setvr2(ipdbt,mxnat,icdh(2),22)
                         endif
                     endif

                     do m=1,iconn(1,nn)
                       mm = abs(iconn(m+1,nn))
                       ma = ianz(mm)
                       call setvar(iresid,mxnat,mm,k)
                       if (mm.ne.ii) then
                        if (ma.eq.6.and.na.ne.7) then
                        
                           if (itrp.eq.1) then
                              if (nn.eq.ice2) then
                                 call setvr2(ipdbt,mxnat,mm,18)
                              else
                                 call setvr2(ipdbt,mxnat,mm,19)
                              endif
                           else
                              call setvr2(ipdbt,mxnat,mm,17)
                           endif

                           do j=1,iconn(1,mm)
                              jj = abs(iconn(j+1,mm))
                              ja = ianz(jj)
                              if (jj.ne.nn) then
                              call setvar(iresid,mxnat,jj,k)
c Tyrosine
                              if (ja.eq.8) then
                                 iamino(k) = 19
                                 call setvr2(ipdbt,mxnat,jj,33)
                              elseif (ja.eq.6.and.itrp.eq.1) then
                                 call setvr2(ipdbt,mxnat,jj,16)
                              elseif (ja.eq.1) then
                                 if (itrp.eq.1) then
                                    if (nn.eq.ice2) then
                                       call setvr2(ipdbt,mxnat,jj,46)
                                    else
                                       call setvr2(ipdbt,mxnat,jj,49)
                                    endif
                                 else
                                    call setvr2(ipdbt,mxnat,jj,40)
                                 endif
                              endif
                              do l=1,iconn(1,jj)
                                 ll = abs(iconn(l+1,jj))
                                 if (ianz(ll).eq.1.and.ll.ne.mm) then
                                    call setvar(iresid,mxnat,ll,k)
                                    if (ja.eq.8) then
                                       call setvr2(ipdbt,mxnat,ll,52)
                                    else
                                       if (itrp.eq.1)
     &                                 call setvr2(ipdbt,mxnat,ll,58)
                                    endif
                                 endif
                              end do
                              endif
                           end do

                        elseif (ma.eq.1) then

                           if (na.eq.7) then
                              call setvr2(ipdbt,mxnat,mm,31)
                           else
                              if (itrp.eq.1) then
                                 call setvr2(ipdbt,mxnat,mm,37)
                              else
                                 if (icc.eq.1) then
                                    call setvr2(ipdbt,mxnat,mm,31)
                                 else
                                    call setvr2(ipdbt,mxnat,mm,34)
                                 endif
                              endif
                           endif

                        endif

                       endif
                     end do
                  endif
               end do
            endif
         end do
         if (l.eq.0) then
c Leucine
            iamino(k) = 11
            goto 100
         endif
      endif
c Phenylalanine
      if (iamino(k).ne.20.and.iamino(k).ne.19) iamino(k) = 18

100   continue
      end do

      istat = 1

      return
      end

      subroutine setvar(iarr,nelm,ielm,ival)
      implicit double precision (a-h,o-z)
      dimension iarr(*)

      if (ielm.gt.0.and.ielm.le.nelm) iarr(ielm) = ival
         
      return
      end

      subroutine setvr2(iarr,nelm,ielm,ival)
      implicit double precision (a-h,o-z)
      integer*2 iarr
      dimension iarr(*)

      if (ielm.gt.0.and.ielm.le.nelm) iarr(ielm) = ival
         
      return
      end

      logical function chkhs(ihpdb)
      implicit double precision (a-h,o-z)
      parameter (mxhsym=64)
      dimension ihpdb(*)

      chkhs = .false.
      do i=2,mxhsym*3
         if (ihpdb(i).ne.0) chkhs = .true.
      end do

      return
      end

      subroutine getpdd(ires,ipdb,ihpdb,
     &                  ianz,iresid,ipdbt)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat

      parameter (mxsym=103)
      parameter (mxhsym=64)
      integer*2 ipdbt
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension ianz(*),iresid(*),ipdbt(*)

      do i=1,mxsym
          ipdb(i) = 0
      end do
      do i=1,mxhsym*3
          ihpdb(i) = 0
      end do

      do i=1,iatoms
          if (iresid(i).eq.ires) then
              if (ipdbt(i).ne.0) then
                  if (ianz(i).eq.1) then
                     ihpdb(ipdbt(i)) = i
                  else
                     ipdb(ipdbt(i)) = i
                  endif
              endif
          endif
      end do

      return
      end

      subroutine bckod(ibckok,ires,iop,
     &                  ianz,iresid,ipdbt,iamino)
      implicit double precision (a-h,o-z)

      parameter (mxsym=103)
      common /athlp/ iatoms, mxnat
      integer*2 ipdbt
      dimension ipdb(mxsym)
      dimension ianz(*),iresid(*),ipdbt(*),iamino(*)

c checks if Calpha is present (iop=1)

      ibckok = 0

      do i=1,mxsym
          ipdb(i) = 0
      end do

      do i=1,iatoms
          if (iresid(i).eq.ires) then
              if (ipdbt(i).ne.0) then
                  if (ianz(i).ne.1) then
                     ipdb(ipdbt(i)) = i
                  endif
              endif
          endif
      end do

c has Calpha
      if (iamino(ires).gt.23) then
         if (iop.eq.1.and.(ipdb(43).ne.0.or.ipdb(46).ne.0)) 
     &       ibckok = 1
      else
         if (iop.eq.1.and.ipdb(2).ne.0) ibckok = 1
         if (iop.eq.2.and.
     &      (ipdb(1).ne.0.and.ipdb(2).ne.0.and.ipdb(3).ne.0)
     &      ) ibckok = 1
      endif

      return
      end

      subroutine rdqchd(idebug,irtype,istats,
     &                 focc,focb,nocc,nocb,ncols,ncolb)

c THIS IS REALLY rdqchm

      implicit double precision ( a-h,o-z)
      parameter (numat1=20000)
      parameter (mxonh=100)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      common /qmchar/ qch(numat1),ihasesp
      character*137 line,cline
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /oniomh/ ioni,nion,ionih(mxonh),natonh(mxonh),
     &                iomap(numatm),icntat(mxonh),fct(mxonh),
     &                xyzi(3,mxonh)
      common /pntlin/ lpnt(MAXPNT)
      dimension focc(*),focb(*)

      istats = 1
      irtype = 0
      istatio = 0
      toang=0.52917706d0
      irtype = 1
      ihbas = 0
      ihorb = 0
      ioni = 0
      do i=1,MAXPNT
         lpnt(i) = -1
      end do

      call rewmf
      call srchmf(line,'$rem',istat)
      if (istat.eq.0) goto 1000

      do while (.true.)
          call rdmf(line,cline,istat)
          if (istat.eq.0) goto 10
          if (index(cline,'$END').ne.0) goto 10
          if (index(cline,' SP').ne.0) irtype = 1
          if (index(cline,' OPT').ne.0) irtype = 2
          if (index(cline,'FREQ').ne.0) irtype = 4
          if (index(cline,'PRINT_').ne.0) then
             if (index(cline,'ORBITALS').ne.0) then
                 if (index(cline,'TRUE').ne.0) ihbas = 1
             endif
             if (index(cline,'GENERAL_BASIS').ne.0) then
                 if (index(cline,'TRUE').ne.0) ihorb = 1
             endif
          endif
      end do

10    continue

      call rewmf

c     
c     look for number of orbitals and electrons
c

      call srchmf(line,'beta electrons',istat)
      if (istat.eq.0) then
         call inferr('no electrons line found!',1)
          goto 1000
      endif

      read(line,'(11x,i8,11x,i8)',err=1000,end=1000) neleca,nelecb

      nelecs = neleca + nelecb

      call srchmf(line,'basis functions',istat)
      if (istat.eq.0) then
         call inferr('no basis functions found!',1)
         goto 1000
      endif
      
      i1 = index(line,'basis functions')
      i2 = index(line,'and')
      line = line(i2+3:i1-1)
      read(line,*,err=1000,end=1000) norbs

      if (norbs.gt.mxorb) 
     &   call inferr('Exceeding MaxNum of Orbitals!',1)

      ncols  = norbs
      ncolb  = norbs
c
      do i=1,min0(mxorb,norbs)
         focc(i) = 0.0d0
      end do
      do i=1,min0(mxorb,neleca)
         focc(i) = 1.0d0
      end do

      call rewmf

      call srchmf(line,'Final Beta MO Coefficients',istat)
      if (istat.ne.0) then
         iuhf=1
         nocc=neleca
         nocb=nelecb
         do i=1,min0(mxorb,norbs)
            focb(i) = 0.0d0
         end do
         do i=1,min0(mxorb,nelecb)
            focb(i) = 1.0d0
         end do
      else
         nocc=max0(neleca,nelecb)
         do i=1,min0(mxorb,nelecb)
            focc(i) = focc(i) + 1.0d0
         end do
      endif
c
      call rewmf
      do while(.true.)
         call qcxyz(idebug,.true.,0,istat)
         if (istat.eq.0) goto 50
      end do
50    continue
      call xyzcoo(1,0,0)

      call rewmf
      if (ihbas.eq.1) then
         call rdbas(idebug,2,istat)
         call norml
         if (istat.eq.0) goto 1000
      endif

      if (idebug.eq.1) 
     &    call inferr('Succesfully read basis-set',0)
      if (idebug.eq.1) call basprt(iun3,.false.,.false.)
      if (norbs.gt.mxorb) goto 1000

      if (ihorb.eq.1) then

          call rdqvec(idebug,istat)
          if (istat.eq.0) goto 1000
          if (idebug.eq.1) call inferr('Succesfully read vectors',0)
       
      endif

c      call rewfil
c      call search(line,'Charges from ESP fit',istat)
c      if (istatio.eq.1) call search(line,'Charges from ESP fit',istat)
c      if (istat.eq.1) then
c          call redel(line,2)
c          do i=1,natbck
c              call nxtlin(line,jstat)
c              if (jstat.eq.1.or.jstat.eq.2) goto 1000
c              if (linlen(line).eq.18) then
c                 read(line,'(7x,f11.6)',err=1000,end=1000) qch(i)
c              else if (linlen(line).eq.21) then
c                 read(line,'(11x,f11.6)',err=1000,end=1000) qch(i)
c              endif
c          end do
c          ihasesp = 1
c      endif
c
c      call rewfil



      if (idebug.eq.1) 
     &         call inferr('Succesfully read QChem output',0)

      return

1000  if (idebug.eq.1) 
     &         call inferr('Error reading QChem output!',1)
      istats = 0
      return

      end

      subroutine prsqmd(molin)
      implicit double precision (a-h,o-z)
      common /mfdata/ nmols,imol,iendmf,ielin,maxmol,mollin
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line,caps
      character*40 title
      character*2 gstr
      dimension molin(*)
      
      call rewfil

      imol = 1
      molin(1) = 0
      nmols = 0
      ilin = 0


1        call nxtlin(line,jstat)
         if (jstat.eq.1) goto 100
         if (jstat.eq.2) goto 200

         caps = line
         len1  = len(line)
         call tocap(caps,len1)
         ilin = ilin + 1
         if (index(caps,'$COMMENT').ne.0) then
            call nxtlin(line,jstat)
            if (jstat.eq.1) goto 100
            if (jstat.eq.2) goto 200
            title = line(1:40)
            ilin = ilin + 1
         endif
         if (index(caps,'WELCOME TO Q-CHEM').eq.0) goto 1

         if (nmols.lt.maxmol) then
            nmols = nmols + 1
            molin(nmols) = ilin
            if (nmols.gt.1) call parsfn(title,linlen(title),13)
            title = 'molecule '//gstr(nmols)
         endif

         goto 1


100   ielin = ilin
      if (nmols.eq.0) then
         nmols = 1
         title = 'molecule '//gstr(nmols)
      endif
      call parsfn(title,linlen(title),13)

      return

200   return
      end

      subroutine qcxyd(idebug,nuclear,ipnt,istat,
     &                 ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (MAXPNT=2000)
      parameter (maxfat=1000)
      integer getlin
      logical gnreal,nuclear
      character*137 line,lline,cline,str
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /athlp/  iatoms, mxnat
      common /coord / xyz(3,numatm)
      common /curlin/ line
      common /pntlin/ lpnt(MAXPNT)
      character*2 elemnt,tstr,tocapf
      common /elem/elemnt(mxel)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat)
      integer getmf
      dimension r(3),coo(3,*),ianz(*)

      toang=0.52917706d0
      istat = 1
      call haszm(.false.)

      if (nuclear) then
         call srchmf(lline,'Standard Nuclear Orientation',istats)
         if (istats.eq.0) goto 100
         call rdmf(lline,cline,istats)
         call rdmf(lline,cline,istats)
      else
         if (idebug.eq.1) print*,'ipnt=',ipnt,'lpnt=',lpnt(ipnt)
         if (lpnt(ipnt).ne.-1) then
            call putmf(lpnt(ipnt))
         else
            call rewmf
            do i=1,ipnt
               call srchmf(lline,'Optimization Cycle:',istats)
               if (istats.eq.0) goto 100
               lpnt(ipnt) = getmf()
            end do
         endif
         call rdmf(lline,cline,istats)
         call rdmf(lline,cline,istats)
         call rdmf(lline,cline,istats)
      endif

      i = 0
      if (idebug.eq.1)  print*,'coordinates'
      do while(.true.)
          if (getlin(1).eq.1) then
             if (icdex(line,'ATOM').eq.0) then
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.2) goto 50
                i = i + 1
                ianz(i) = 0
                ktype = nxtwrd(str,nstr,itype,rtype)
                tstr = '  '
                if (ktype.eq.1) then
                   if (nstr.eq.1) tstr(2:2) = str(1:1)
                   if (nstr.eq.2) tstr(1:2) = str(1:2)
                   do k=1,mxel
                     if (tocapf(tstr).eq.tocapf(elemnt(k))) then
                        if (nuclear) then
                           nat(i) = k
                        else 
                           ianz(i) = k
                        endif
                     endif
                   end do
                endif
                if (gnreal(r,3,.false.)) then
                   if (idebug.eq.1)  then
                      if (nuclear) then
                         print*,elemnt(nat(i)),(r(j),j=1,3)
                      else
                         print*,elemnt(ianz(i)),(r(j),j=1,3)
                      endif
                   endif
                   do j=1,3
                      if (nuclear) then
                         xyz(j,i) = r(j) / toang
                      else
                         coo(j,i) = r(j) / toang
                      endif
                   end do
                else
                   goto 100
                endif
             endif
          else 
             goto 100
          endif
      end do

50    if (nuclear) then
         natoms = i
      else
         iatoms = i
      endif

      if (.not.nuclear) then
          call srchmf(lline,'Cartesian Gradient',istats)
          if (istats.eq.0) goto 200
          if (getlin(1).ne.1) goto 200
          if (idebug.eq.1)  print*,'forces'
          do i=1,iatoms
             if (getlin(1).ne.1) goto 200
             ktype = nxtwrd(str,nstr,itype,rtype)
             ktype = nxtwrd(str,nstr,itype,rtype)
             if (gnreal(r,3,.false.)) then
                if (idebug.eq.1)  print*,elemnt(ianz(i)),(r(j),j=1,3)
                do j=1,3
                   fxyz(j,i) = r(j)
                end do
             endif
          end do
      endif

      return

100   istat = 0
      call rewmf
      return
200   istat = -1
      return
      end

      subroutine rdqvcd(idebug,istats,
     &                  vectrs,vectrb,eiga,eigb,ncols,ncolb)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      character*137 line
      common /orbhlp/ mxorb,iuhf,ispd
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /curlin/ line
      integer getlin
      character*137 lline,str
      real eiga,eigb
      dimension vectrs(*),vectrb(*),eiga(*),eigb(*)

      istats = 1
      ido5d = 1
      ido7f = 1
      ido9g = 1

      call rewmf

      call srchmf(lline,'Final Alpha MO Eigenvalues',istat)
      if (istat.eq.0) goto 100

      ncols = 0
      nlines = 0
      do i=1,norbs

          if (getlin(1).ne.1) goto 100
          nlines = nlines + 1
          ktype = nxtwrd(str,nstr,itype,rtype)
          if (ktype.eq.1) goto 10

          if (getlin(1).eq.1) then
             ktype = nxtwrd(str,nstr,itype,rtype)
             do j=1,6
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then
                    ncols = ncols + 1
                    eiga(ncols) = real(rtype)
                elseif (ktype.eq.0) then
                    goto 10
                else
                    goto 100
                endif
             end do
          else
             goto 100
          endif
      end do
      
10    ncol = 0

      if (getlin(1).ne.1) goto 100
      do i=1,nlines
         if (getlin(1).ne.1) goto 100
         do j=1,norbs
             if (getlin(1).ne.1) goto 100
             ktype = nxtwrd(str,nstr,itype,rtype)
             ncolt = ncol  
             do k=1,6
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.3) then
                    ncolt = ncolt + 1
                    vectrs((ncolt-1)*mxorb+j) = rtype
                elseif (ktype.eq.0) then
                    goto 20
                else
                    goto 100
                endif
             end do
20           continue
         end do
         ncol = ncol + 6
      end do

      if (iuhf.eq.1) then
         call srchmf(lline,'Final Beta MO Eigenvalues',istat)
         if (istat.eq.0) goto 100
      endif

      return

100   istats = 0
      return
      end

      subroutine geoqcm(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      character*137 line,str
      common /curlin/ line
      integer getlin
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

      call rewmf

      igcvav = 1
      ifmxav = 1
      ifrmav = 0
      idmxav = 1
      idrmav = 0
      ieav = 1
      nepnts = 0
      ngeoms = 0
      dmaxt = 0.0d0
      fmaxt = 0.0d0
      drmst = 0.0d0
      frmst = 0.0d0

      do while(.true.)
         call srchmf(line,'Optimization Cycle:',istat)
         if (istat.eq.0) goto 100

         if (ngeoms.lt.mxpnt) then
            ngeoms = ngeoms + 1
         else
            goto 100
         endif

         call srchmf(line,'Energy is',istat)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         epoints(ngeoms) = rtype

         call srchmf(line,'Cnvgd?',istats)
         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         formax(ngeoms) = rtype
         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.ne.3) goto 100
         dismax(ngeoms) = rtype
         isav(ngeoms) = 1
      end do

100   nepnts = ngeoms

      return
      end

      subroutine cnvqcm
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      character*137 line,str
      common /curlin/ line
      integer getlin

      call rewmf

      icvav1 = 0
      icvav2 = 0
      jstrt1 = 1
      jstrt2 = 1
      jend1 = 0
      jend2 = 0
      ifrst = 1


c     SCF convergence 

      do while(.true.)
         call srchmf(line,'Cycle       Energy',istat)
         if (istat.eq.0) goto 100
         if (getlin(1).ne.1) goto 100
         do while(.true.)
            if (ifrst.eq.1.and.jend1.ge.MAXITER) goto 10
            if (ifrst.eq.0.and.jend2.ge.MAXITER) goto 100
            if (getlin(1).ne.1) goto 100
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.1) goto 10
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 100
            if (ifrst.eq.1) then
                jend1 = jend1 + 1
                convg1(jend1) = rtype
            else 
                jend2 = jend2 + 1
                convg2(jend2) = rtype
            endif
         end do
10       if (ifrst.eq.1) then
            ifrst = 0
            icvav1 = 1
         else
            icvav2 = 1
         endif
      end do

100   return
      end

      subroutine getqfd(istat,coo)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      real freq,frmul,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      common /athlp/ iatoms, mxnat
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
      character*137 line,str
      common /curlin/ line
      integer getlin
      dimension coo(3,*)

      istat = 1

      ivibs = 0
      ihasi = 1
      call rewmf

      call iatnox(natoms)

      do i=1,natoms
        do j=1,3
           fcoo(j,i) = coo(j,i)
        end do
      end do

c     Read in Qchem Frequencies

      nvibs = 3*natoms - 6
      if (natoms.eq.1) nvibs = 0
      if (natoms.eq.2) nvibs = 1

      do while(.true.)
         call srchmf(line,'Frequency:',istat)
         if (istat.eq.0) goto 10

         ivibst = ivibs
         ktype = nxtwrd(str,nstr,itype,rtype)
         do j=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 20
            ivibs = ivibs + 1
            freq(ivibs) = rtype
         end do

20       if (getlin(1).ne.1) goto 100
         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         ktype = nxtwrd(str,nstr,itype,rtype)
         do j=1,3
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.ne.3) goto 30
            ivibst = ivibst + 1
            frint(ivibst) = rtype
         end do
30       continue

      end do

10    nfreq = ivibs
      call parptr(1,freq,freq,nfreq)
      call parptr(112,frint,ramint,ihasi)

      return

100   istat = 0
      return
      end 

      subroutine qcoord(idebug,ifreq,istat)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      character*2 gstr
      character*5 tstr
      real freqt
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      character*137 line,str
      common /curlin/ line
      integer getlin
      logical gnreal
      dimension r(3)

c     Get ifreq 'th Norm. Coordinates from Qchem Output

      istat = 1

      toang=0.52917706d0
      call rewmf

      call iatnox(iatoms)

      nvibs = nfreq
      ifrh = (ifreq-1) / 3
      ifrl = ifreq - ifrh*3
      do i=1,ifrh+1
         call srchmf(line,'Frequency:',istat)
         if (istat.eq.0) goto 100
      end do
      call srchmf(line,'X      Y      Z',istat)
      if (istat.eq.0) goto 100

      do i=1,iatoms
         if (getlin(1).ne.1) goto 100
         ktype = nxtwrd(str,nstr,itype,rtype)
         do j=1,ifrl
            if (gnreal(r,3,.false.)) then
               do k=1,3
                   a(k,i) = r(k) / toang
               end do
            else
               goto 100
            endif
         end do
      end do


      if (idebug.eq.1) call prtfr(ifreq)
      return

100   istat = 0
      call inferr('Error reading Norm. Coords. !',0)
      return
      end

      subroutine draw(iz,jz,jdir,a,ib,ic,id,pz,mdim)
      implicit double precision (a-h,o-z)
      dimension a(mdim,mdim), idirx(6), idiry(6)
      logical ai,aj,ak,lc(4), yes, euclid
***********************************************************************
*
*   DRAW DRAWS CONTOURS, STARTING AT POINT IZ,JZ.
*   JDIR = STARTING DIRECTION, IF 1 THEN IN +X DIRECTION
*                                 2 THEN IN +Y DIRECTION
*                                 3 THEN IN -X DIRECTION
*                                 4 THEN IN -Y DIRECTION
*    A   = ARRAY TO BE PLOTTED
*    B,C = WORK SPACES OF SIZE SUITABLE TO HOLD 5000 AND 4000 LOGICAL
*          ELEMENTS.
*    PZ  = VALUE OF THIRD DIMENSION. SET TO ZERO IF NOT WANTED.
*    MDIM= SIZE OF FIRST DIMENSION OF A.
***********************************************************************
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common/cntr/r1,imax,jmax
      equivalence (lc(1),ilc)
      dimension id(mdim,*),ib(*),ic(2000,2)
      data idirx/1,0,-1,0,1,0/,idiry/0,1,0,-1,0,1/

      icount =-5
      idir = jdir
      ilc = 0
      ipen = 1
      i = iz
      j = jz
      iflab = 1
      if (iflag.eq.0) iflab = 0
    1 aa = a(i,j)
      ai = (aa.lt.0.)
      idx = idirx(idir)
      idy = idiry(idir)
      ab = a(i+idx,j+idy)
      factor= aa/(aa-ab)
      py = (imax-i-factor*idx)/(imax-1)
      px = (jmax-j-factor*idy)/(jmax-1)

      if (iflab.eq.0) then
         iflab = 1
         yes = .true.
         call euler(px,py,pz,ipen)
         yes = .false.
      endif

      if (ipen.eq.2.or.r1.gt.0.d0) 
     &      r1 = r1 + dsqrt((cx-px)**2 + (cy-py)**2)

      if (id(i,j).eq.1.and.id(i+idx,j+idy).eq.1)then
        call propnt(px,py,pz,ipen)
        ipen = 2
      else
        ipen = 1
      endif

      cy = py
      cx = px

      icount = icount + 1
      if (idir/2*2.ne.idir) goto 5
      if (idir.ne.2) goto 6
      number = j
      m = 1
      goto 7
    6 number= j-1
      m = imax
    7 k = (number-1)*imax +i
      if (ib(k).eq.0) return
      ib(k) = 0
      if (i.eq.m) return
      goto 3
    5 if (j.ne.1.and.j.ne.jmax) goto 3
      number = idir*j
      if (number.ne.3.and.number.ne.jmax) goto 3
      if (number.eq.3) then
          ic(i-1,1) = 0
      else
          ic(i,2) = 0
      endif
      return
    3 continue
      iddx = i + idirx(idir+1)
      iddy = j + idiry(idir+1)
      ac = a(iddx+idx,iddy+idy)
      aj = (ac.lt.0.)
      ad = a(iddx,iddy)
      ak = (ad.lt.0.)
      fa = 1
      if (aj.and.ak) goto 10
      if (.not.(aj.or.ak)) goto 11
      fa=0.
      if ((ai.or..not.ak).and.(.not.ai.or.ak)) goto 4
      fa= aa*ac-ab*ad
      if (fa.ge.0.) goto 4
   15 idir = idir + 1
      if (idir.eq.5) idir = 1
      goto 1
 4    i = iddx
      j = iddy
      if (fa.eq.0) goto 1
      i = i + idx
      j = j + idy
      idir = idir - 1
      if (idir.eq.0) idir = 4
      goto 1
   10 if (ai) goto 4
      goto 15
 11   if(ai) goto 15
      goto 4

      end

      subroutine inisw
      implicit real (a-h,o-z)
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw

      cutof2 = cutoff*cutoff
      cuton  = cutoff - 1.0e0

      cuton2 = cuton*cuton
      tmp    = cutof2 - cuton2
      conof3 = tmp*tmp*tmp
      isw = 1


      return
      end

      real function swvdw(rij2)
      implicit real (a-h,o-z)
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw

      if (rij2.ge.cutof2) then
          swvdw = 0.0e0
      elseif (rij2.le.cuton2) then
          swvdw = 1.0e0
      else
          rd1 = cutof2 - rij2
          rd2 = cutof2 + 2.0e0*rij2 - 3.0e0*cuton2
          swvdw = (rd1*rd1*rd2)/conof3
      endif

      return
      end

      real function swdvdw(rij2)
c 
c derivative of VDW switch function
c
      implicit real (a-h,o-z)
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw

      if (rij2.ge.cutof2) then
          swdvdw = 0.0e0
      elseif (rij2.le.cuton2) then
          swdvdw = 1.0e0
      else
          rd1 = cutof2 - rij2
c          rd2 = rij2 - cuton2
c          swdvdw = 12.0e0*rd1*rd2/conof3
          rd2 = cutof2 + 2.0e0*rij2 - 3.0e0*cuton2
          rij = sqrt(rij2)
          swdvdw = 4.0e0*rij*rd1*(rd1-rd2)/conof3
      endif

      return
      end

c swchg not used, instead same function as swvdw used for charge cutoff

      subroutine swchg(rij2,s,ds)
      implicit real (a-h,o-z)
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw


      if (rij2.ge.cutof2) then
         s = 0.0e0
         ds = 0.0e0
      else
         frac = rij2/cutof2
         frac2 = frac*frac
         s = 1.0e0 - frac
         s = s*s
         ds = (frac2 - frac)*4.0e0
c        ds = ds/rij
c        we put the rij of de = de / r also in here
c           de = e*ds - e*s/r , de = de / r => 
c                de = e*ds/rij - e*s/rij2
c now       de = e*ds - e*s
         s = s/rij2
         ds = ds/rij2
      endif
          
      return
      end

      subroutine bldlsd(coo,iresid,nlst,lst,istat)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxneib=200)
      parameter (numres=50000)
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      common /athlp/  iatoms, mxnat
      common /residu/  qtot,ihsres,
     &                 ires(numres),ibeg(numres),iend(numres)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      logical doit
      dimension coo(3,*),iresid(*),nlst(*),lst(*),vr(3),loclst(mxneib)

      if (istat.eq.0) then
         usesw = .false.
         print*,'Not enough memory to use cutoff/switch'
         return
      endif

      cutf1 = cutoff + 1.0e0
      cutf2 = cutf1*cutf1

c Build nonbonded interaction list, iatoms*mxneib
c each atom can have a max of mxneib neighbours within cutoff of 8 angs
c now not an atom is stored, but a residue

      do i=1,iatoms
         nlst(i) = 0
         do j=i+1,iatoms

            if (box) then
               do k=1,3
                  vr(k) = coo(k,i) - coo(k,j)
               end do
               call reddis(vr)
               r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)
               doit = (r2.lt.cutf2)
            else
               doit = (dist2(coo(1,i),coo(1,j)).lt.cutf2)
            endif

            if (doit) then
               if (nlst(i).lt.mxneib) then
                  ido = 1
                  do k=1,nlst(i)
                     if (iresid(j).eq.lst((i-1)*mxneib+k)) ido = 0
                  end do
                  if (ido.eq.1) then
                     nlst(i) = nlst(i) + 1
                     lst((i-1)*mxneib+nlst(i)) = iresid(j)
                  endif
               else
                  print*,"neighbour list full for atom ",i
                  print*,"increase mxneib "
               endif
            endif
         end do
      end do

      do i=1,ihsres
         if (ires(i).gt.0) then
            nloc = nlst(ibeg(i))
            do j=1,nloc
               loclst(j) = lst((ibeg(i)-1)*mxneib+j)
            end do
            do j=ibeg(i)+1,iend(i)
               do k=1,nlst(j)
                  ir = lst((j-1)*mxneib+k)
                  ido = 1
                  do l=1,nloc
                     if (ir.eq.loclst(l)) ido = 0
                  end do
                  if (ido.eq.1) then
                     if (nloc.lt.mxneib) then
                        nloc = nloc + 1
                        loclst(nloc) = ir
                     else
                        print*,"neighbour list full for atom ",ibeg(i)
                        print*,"increase mxneib "
                     endif
                  endif
               end do
            end do
            do j=ibeg(i),iend(i)
               nlst(j) = nloc
               do l=1,nloc
                  lst((j-1)*mxneib+l) = loclst(l)
               end do
            end do
         endif
      end do

      return
      end

      logical function resinc(iatom,nlst,lst,ires)
      implicit real (a-h,o-z)
      parameter (mxneib=200)
      dimension lst(*)


      resinc = .false.
      do i=1,nlst
         if (lst((iatom-1)*mxneib + i).eq.ires) then
             resinc = .true.
             return
         endif
      end do

      return
      end

      real function dist2(a,b)
c
c     determine distances between neighboring atoms
c
      implicit real (a-h,o-z)
      dimension a(3)
      dimension b(3)

      d1 = a(1)-b(1)
      d2 = a(2)-b(2)
      d3 = a(3)-b(3)

      dist2 = d1*d1 + d2*d2 + d3*d3

      return
      end

      subroutine premul
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcls=50)
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /prem/ rs(mxcls,mxcls),es(mxcls,mxcls),iprem

      do i=1,mxcls
         do j=1,mxcls
            rst = ambvdwr(i) + ambvdwr(j)
            rs(i,j) = rst*rst*rst*rst*rst*rst
            es(i,j) = sqrt(ambvdwe(i)*ambvdwe(j))
         end do
      end do

      call allerf
      call alltab

      iprem = 1

      return
      end

      subroutine prmulr
      implicit real(a-h,o-z), integer (i-n)
      parameter (mxcls=50)
      real ambvdwr,ambvdwe
      common /clspar/ ambvdwr(mxcls),ambvdwe(mxcls),mapagf(mxcls)
      common /premr/ rs(mxcls,mxcls),es(mxcls,mxcls),iprem

      do i=1,mxcls
         do j=1,mxcls
            rst = real(ambvdwr(i) + ambvdwr(j))
            rs(i,j) = rst*rst*rst*rst*rst*rst
            es(i,j) = sqrt(real(ambvdwe(i)*ambvdwe(j)))
         end do
      end do

      iprem = 1

      call alltab

      return
      end

      subroutine alltab
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxion=2000)
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/ numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      common /atab/ ialtab

      if (ialtab.eq.1) return

      call watcnt
      call watlst(niwat)
      call stutab

      ialtab = 1

      return
      end

      subroutine stutad(woo,whh,woh,dewoo,dewhh,dewoh)
      implicit real (a-h,o-z), integer (i-n)
      dimension woo(*),whh(*),woh(*),dewoo(*),dewhh(*),dewoh(*)

      rcut  = 9.0e0
      rcinv = 1.0e0 / rcut
      rc2inv =  rcinv * rcinv

      econv = 332.05382e0
      qo    = -0.8340e0
      qh    = 0.4170e0
      vro   = 1.7683e0
      veo   = 0.1520e0
      vrh   = 0.0001e0
      veh   = 0.0e0

      poo   = econv*qo*qo
      rst   = 2.0e0*vro
      rst2  = rst*rst
      pr6oo = rst2*rst2*rst2
      epsoo = veo

      phh   = econv*qh*qh
      pr6hh = 0.0e0
      epshh = 0.0e0

      poh   = econv*qo*qh
      rst   = vro + vrh
      rst2  = rst*rst
      pr6oh = rst2*rst2*rst2
      epsoh = sqrt(veo*veh)

      nsize = 9000

      do i=1,nsize

         r     = dble(i) / 1000.0e0
         rinv  = 1.0e0 / r
         r2inv = rinv*rinv
         r6inv = r2inv*r2inv*r2inv

         p6    = pr6oo*r6inv
         p12   = p6*p6
         eq    = poo * (rinv - rcinv + (r-rcut)*rc2inv)
         ev    = epsoo*(p12-2.0e0*p6)

         woo(i) = eq + ev

c         if (i.lt.8000) print*,i,' woo ',woo(i),
c     &                  ' dwoo ',woo(i-1)-woo(i)
         de = epsoo * (p12 - p6) * (-12.0e0)
         dewoo(i) =  (de-eq)*r2inv + poo*rinv*rc2inv

         eq    = phh * (rinv - rcinv + (r-rcut)*rc2inv)

         whh(i) = eq

         dewhh(i) =  -eq*r2inv + phh*rinv*rc2inv

         p6    = pr6oh*r6inv
         p12   = p6*p6
         eq    = poh * (rinv - rcinv + (r-rcut)*rc2inv)
         ev    = epsoh*(p12-2.0e0*p6)

         woh(i) = eq + ev

         de = epsoh * (p12 - p6) * (-12.0e0)
         dewoh(i) =  (de-eq)*r2inv + poh*rinv*rc2inv

      end do

      do i=9000,10000
         woo(i) = 0.0e0
         woh(i) = 0.0e0
         whh(i) = 0.0e0
         dewoo(i) = 0.0e0
         dewoh(i) = 0.0e0
         dewhh(i) = 0.0e0
      end do

      return
      end

      subroutine etutad(nsize,woo,whh,woh,dewoo,dewhh,dewoh)
      implicit real (a-h,o-z), integer (i-n)
      dimension woo(*),whh(*),woh(*),dewoo(*),dewhh(*),dewoh(*)

      econv = 332.05382e0
      qo    = -0.8340e0
      qh    = 0.4170e0
      vro   = 1.7683e0
      veo   = 0.1520e0
      vrh   = 0.0001e0
      veh   = 0.0e0

      poo   = econv*qo*qo
      rst   = 2.0e0*vro
      rst2  = rst*rst
      pr6oo = rst2*rst2*rst2
      epsoo = veo

      phh   = econv*qh*qh
      pr6hh = 0.0e0
      epshh = 0.0e0

      poh   = econv*qo*qh
      rst   = vro + vrh
      rst2  = rst*rst
      pr6oh = rst2*rst2*rst2
      epsoh = sqrt(veo*veh)

      do i=1,nsize

         r     = real(i) / 1000.0e0
         rinv  = 1.0e0 / r
         r2inv = rinv*rinv
         r6inv = r2inv*r2inv*r2inv

         p6    = pr6oo*r6inv
         p12   = p6*p6
         eq    = poo * rinv
         ev    = epsoo*(p12-2.0e0*p6)

         woo(i) = eq + ev

         de = epsoo * (p12 - p6) * (-12.0e0)
         dewoo(i) =  (de-eq)*r2inv

         eq    = phh * rinv

         whh(i) = eq

         dewhh(i) =  -eq*r2inv

         p6    = pr6oh*r6inv
         p12   = p6*p6
         eq    = poh * rinv
         ev    = epsoh*(p12-2.0e0*p6)

         woh(i) = eq + ev

         de = epsoh * (p12 - p6) * (-12.0e0)
         dewoh(i) =  (de-eq)*r2inv

      end do

      return
      end

      subroutine allerd(aprerf,aprexp)
      implicit real (a-h,o-z), integer (i-n)
      real aprerf,aprexp,alaf,pi,spi,f
      dimension aprerf(*),aprexp(*)

      alfa   = 0.3e0
      pi     = 4.e0*atan(1.e0)
      spi    = sqrt(pi)
      
      do i=1,1800000

         r     = dble(i) / 1000000.0e0
         aprerf(i) = real(erfc(r))

      end do

      do i=1,3240000

         f     = - float(i) / 1000000.0e0
         aprexp(i) = 2.0*alfa*exp(f)/spi

      end do

      return
      end

c      subroutine allerd(aprerf,aprexp)
c      implicit real (a-h,o-z), integer (i-n)
c      real aprerf,aprexp,alaf,pi,spi,f
c      dimension aprerf(*),aprexp(*)
c
c      alfa   = 0.2e0
c      pi     = 4.e0*atan(1.e0)
c      spi    = sqrt(pi)
c      
c      do i=1,3000000
c
c         r     = dble(i) / 1000000.0e0
c         aprerf(i) = real(erfc(r))
c
c      end do
c
c      do i=1,9000000
c
c         f     = - float(i) / 1000000.0e0
c         aprexp(i) = 2.0*alfa*exp(f)/spi
c
c      end do
c
c      return
c      end

      subroutine apperfd(r,fc,aprerf)
      implicit real (a-h,o-z), integer (i-n)
      real aprerf,r1000,x,w
      dimension aprerf(*)

      thou = 1000000.0e0

      if (r.le.10.0e0) then
          r1000 = real(r)*thou
          ir = int(r1000)
          x = (r1000 - float(ir))
          fc = dble((1.0e0-x)*aprerf(ir) + x*aprerf(ir+1))
      endif

      return
      end

      subroutine enegdd(energy,coo,forces,fintr,fwat,fx,fy,fz,
     &                  potscl,iopt,iresid,
     &                  nac,iac,nad,iad,
     &                  nbnd,ibnd,bl,bk,
     &                  nang,iang,ango,ak,
     &                  nt,it,trs1,trs2,trs3,trs4,
     &                  nti,iti,trsi1,trsi2,
     &                  q,iconn,ityp,iwtpr,nlst,lst)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxac=3*mxcon)
      parameter (mxad=9*mxcon)
      parameter (mxion=2000)
      common /athlp/  iatoms, mxnat
      logical box,cell,fast
      common /pbc/ abc(3),abc2(3),angles(3),box,cell,fast
      common /h2oer/  numwat,natnow,nion,iontyp,ionpl,iw(mxion),niwat
      logical usecut,usesw
      common /limits/ cutoff, cutof2,cuton, cuton2,conof3,usecut,usesw
      logical osingl,dolbfgs,oqscal
      common /opts/ idebug,imon,iarc,ilog,iout,osingl,dolbfgs,oqscal
      common /passe/ emin
      logical doint
      common /intr/ ecold,evold,ewold,iprog,doint
      common /wesc/ iwesc
      common /mpih/ nproc,idt
      integer*2 ityp
      real evs,ecs,fx,fy,fz
      dimension forces(3,*),potscl(*),iopt(*),iresid(*)
      dimension fintr(3,*),fwat(3,*),fx(*),fy(*),fz(*)
      dimension nac(*),nad(*),iac(mxac,*),iad(mxad,*)
      dimension ibnd(2,*), bl(*), bk(*)
      dimension iang(3,*),ango(*),ak(*)
      dimension it(4,*),trs1(4,*),trs2(4,*),trs3(4,*),trs4(4,*)
      dimension iti(4,*),trsi1(4,*),trsi2(4,*)
      dimension coo(3,*),q(*),iconn(mxcon+1,*),ityp(*),iwtpr(*)
      dimension nlst(*),lst(*)
      dimension cellder(6)

      eb  = 0.0e0
      ea  = 0.0e0
      eit = 0.0e0
      et  = 0.0e0
      ev  = 0.0e0
      ec  = 0.0e0
      ew  = 0.0e0
      euin = 0.0e0

      do i=1,iatoms
         do j=1,3
            forces(j,i) = 0.0e0
            if (doint) then
               fwat(j,i)  = 0.0e0
               fintr(j,i) = 0.0e0
            endif
         end do
         
      end do

      if (cell) then
          call var2cl(coo,iatoms)
          
c          call uinner(euin,cellder,coo,forces,q,iatoms)
      endif

      call bond (eb,nbnd,ibnd,bl,bk,coo,forces)

      call angle(ea,nang,iang,ango,ak,coo,forces)
      call tors (eit,1,
     &                nt,it,trs1,trs2,trs3,trs4,
     &                nti,iti,trsi1,trsi2,
     &                coo,forces)
      call tors (et,0,
     &                nt,it,trs1,trs2,trs3,trs4,
     &                nti,iti,trsi1,trsi2,
     &                coo,forces)

      if (cell) then
          call qvc(ec,ev,nac,iac,nad,iad,iresid,coo,iconn,
     &             q,forces,cellder,iopt,ityp)
      else
          if (usecut) then
             if (usesw) then
                 call qenvdw(ec,ev,nac,iac,nad,iad,iresid,
     &                  coo,iconn,q,forces,iopt,nlst,lst,ityp)
             else
                 call qvnoe(ec,ev,nac,iac,nad,iad,iresid,coo,iconn,
     &                  q,forces,iopt,ityp,iwtpr)
             endif
          else
          
          
                 if (doint) then
                    call qvdwrd(ec,ev,fintr,
     &                           nac,iac,nad,iad,iresid,coo,iconn,
     &                           q,iopt,ityp)
                    ecold = ec
                    evold = ev
                 else
                    ec = ecold
                    ev = evold
                 endif

                 do i=1,iatoms
                    do j=1,3
                       forces(j,i) = forces(j,i) + fintr(j,i)
                    end do
                 end do

          endif

          if (fast.and.box) then
              if (doint) then
                 call fstwat(ew,coo,fwat,q)
                 ewold = ew
              else
                 ew = ewold
              endif
              do i=1,iatoms
                 do j=1,3
                    forces(j,i) = forces(j,i) + fwat(j,i)
                 end do
              end do
          endif

      endif

      energy = eb + ea + eit + et + ev + ec + euin
      if (fast.and.box) energy = energy + ew

      emin = energy

      if (idebug.eq.1) then
        print*,'eb=',eb,'ea=',ea,'eit=',eit,'et=',et,'ev=',ev,'ec=',ec
        if (fast.and.box) print*,'ew=',ew
        print*,'energy=',energy
      endif

      do i=1,iatoms
         if (iopt(i).eq.1) then
            do j=1,3
               forces(j,i) = -forces(j,i)
            end do
         else
            do j=1,3
               forces(j,i) = 0.0e0
            end do
         endif
      end do

      if (cell) then
         call grd2var(cellder,forces,iatoms)
         call getcel(a,b,c,alpha,beta,gamma)
c         call prcldr(cellder,coo)
      endif

      if (iwesc.eq.1) then
         call wexit
      endif

      return
      end

      integer function genaos(count)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer shella, shelln, shellt, shellc, shladf, aos
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /slagau/ ihasd,isgau,ido5d,ido7f,ido9g,ihasg

      logical count
 
      genaos = 0
      itel = 1
      do 100 i = 1, nshell
c S
          if (shellt(i).eq.0) then
              aos(i) = itel
              itel = itel + 1
              goto 100
          endif

c sp
          if (shellt(i).ne.1.or.shellc(i).eq.1) goto 330
              aos(i) = itel
              itel = itel + 4
              goto 100

c p
330       if (shellt(i).eq.1) then
               aos(i) = itel - 1
               itel = itel + 3
               goto 100
          endif

c spd
          if (shellt(i).ne.2.or.shellc(i).ne.0) goto 350
              aos(i) = itel
              if (ido5d.eq.1) then
                 itel = itel + 9
              else
                 itel = itel + 10
              endif
              goto 100
c d

350       if (shellt(i).eq.2) then
              aos(i) = itel - 4
              if (ido5d.eq.1) then
                 itel = itel + 5
              else
                 itel = itel + 6
              endif
              goto 100
          endif

c          if (shellt(i).ne.3.or.(shellc(i).ne.0.and.shellc(i).ne.3))
c     &        call inferr('error in genaos',1)
          if (shellt(i).ne.3.or.(shellc(i).eq.2)) goto 370
          aos(i) = itel - 10
          if (ido7f.eq.1) then
             itel = itel + 7
          else
             itel = itel + 10
          endif
          goto 100

370       if (shellt(i).ne.4.or.(shellc(i).eq.2))
     &        call inferr('error in genaos',1)
          aos(i) = itel - 20
          if (ido9g.eq.1) then
             itel = itel + 9
          else
             itel = itel + 15
          endif
100       continue

      aos(nshell+1) = itel
      nbasis = itel - 1
      if (count) then
          genaos = nbasis
      else
          if (nbasis.ne.norbs) 
     &       call inferr('genaos: nbasis.ne.norbs',1)
      endif

      return
      end

      subroutine crprod(a,b,c)
c
c       calculates cross product:   a x b = c
c                                   -   -   -
      implicit double precision (a-h,o-z)
      dimension a(3),b(3),c(3)
c
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end
      subroutine crpros(a,b,c)
c
c       calculates cross product:   a x b = c
c                                   -   -   -
      implicit double precision (a-h,o-z)
      real b
      dimension a(3),b(3),c(3)
c
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end

      subroutine arbper(a,b)
      implicit double precision (a-h,o-z)
      dimension a(3),b(3)

      a1 = dabs(a(1))
      a2 = dabs(a(2))
      a3 = dabs(a(3))

      do i=1,3
         b(i) = 0.0d0
      end do

      if (a1.lt.a2) then
         if (a1.lt.a3) then
            b(1) = 1.0d0
         else
            b(3) = 1.0d0
         endif
      else
         if (a2.lt.a3) then
            b(2) = 1.0d0
         else
            b(3) = 1.0d0
         endif
      endif

      return
      end

      subroutine occin(i,gocc,ndim)
      implicit double precision (a-h,o-z)
      character*320 keywrd,keyori,string
      common /keywrd/ keywrd,keyori
      character*30  cunit
      dimension gocc(*)

      ind = i + 4
      i = index(keywrd(ind:320),'=')
      i1 = index(keywrd(i+ind:320),'(')
      i2 = index(keywrd(i+ind:320),')')
      string(1:i2-i1-1) = keywrd(i+ind+i1:i+ind+i2-1)
      l = i2 - i1 - 1
      j = 1

2300  if (string(j:j).eq.' ') then
        if (j.le.l-1) then
           string(j:l-1) = string(j+1:l)
        endif
        l = l - 1 
      else
        j = j + 1
      endif
      if (j.ne.l+1) goto 2300

2400  i = index(string(1:l),',')
      if (i.eq.0) then
         cunit(1:l) = string(1:l)
         i = l + 1
         l = 0
      else
         cunit(1:i-1) = string(1:i-1)
         string(1:l-i) = string(i+1:l) 
         l = l - i
      endif
      ind = index(cunit(1:i-1),'/')
      jnd = index(cunit(1:i-1),'-')
      if (jnd.eq.0) then
         ibeg = int(reada(cunit(1:ind-1)//' ',1,len(cunit)))
         iend = ibeg
      else
         ibeg = int(reada(cunit(1:jnd-1)//' ',1,len(cunit)))
         iend = int(reada(cunit(jnd+1:ind-1)//' ',1,len(cunit)))
      endif

      if (iend.lt.ibeg)
     &   call inferr('OCCU: orbital label1 exceeds label2 ',1)

      if (ibeg.gt.ndim.or.iend.gt.ndim) 
     &   call inferr('OCCU: orbital label > No. of Orbitals',1)

      val = reada(cunit(ind+1:i-1)//' ',1,len(cunit))

      do k=ibeg,iend
         gocc(k) = val
      end do

      if (l.ne.0) goto 2400

      return
      end

      subroutine plmold(coo,qat,rzp,ixp,iyp,
     &                 iconn,ianz,iaton,iatclr,iresid,inat,lab,labhet,
     &                 xv,yv,zv,c0,
     &                 icalf,ncalf,ianf,islu,nchain,iamino,reson,
     &                 icxp,icyp,irsnr,achain,scali)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat
      common /cllab/ iclon,iclpnt(4)
      character*2 clstr,ccell
      common /clchr/ clstr(4)
      common /surf/  natorg,noscnd
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /gracom/ uscl,colscd,colscpd,ivdwpl

      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      parameter (mxres=42)
      integer reson
      character*1 achain
      character*3 aminos
      common /amino/aminos(mxres)
      logical dsurf,scnd,dcell,doq
      integer dolabs,fancy,shade,atcol,persp,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo

      real xx
      integer*2 ixx(24)
      character str*13
      dimension zvect(3)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*),iconn(mxcon+1,*),
     &          ianz(*),iaton(*),iatclr(*),iresid(*),inat(*),qat(*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),reson(*),
     &          icxp(*),icyp(*),irsnr(*),lab(*),labhet(*)

      toang  = 0.52917706d0
      doq = (ihasq.eq.1.and.iqon.eq.3)
      roddef = 0.7d0*vrad(1) 
      zvect(1) = 0.0d0
      zvect(2) = 0.0d0
      zvect(3) = 1.0d0

      scalp = 20.0d0
c      scalp = scali / 2.0d0
      icltan = 8
      colscp = colscpd*uscl

      call gethei(ihigh)

c     coordinates viewpoint

      do j=1,iatoms
          call rott(coo(1,j),coo(2,j),coo(3,j),xc,yc,zc,1)
          rzp(j) = zc
          rp = c0/(zv - rzp(j) + c0)
          if (iaton(j).ge.1.and.(zv-rzp(j)).gt.0.0d0) then
             ixp(j) = (0.5d0 -rp*(xc - xv)/scalp)*ihigh
             iyp(j) = (0.5d0 -rp*(yc - yv)/scalp)*ihigh
          else
             ixp(j) = 0
             iyp(j) = 0
          endif
      end do

      if (ipdbon.eq.1) then
         do k=1,ncalf
             j = icalf(1,k)
             call rott(coo(1,j),coo(2,j),coo(3,j),xc,yc,zc,1)
             rp = c0/(zv - zc + c0)
             if ((zv-zc).gt.0.0d0) then
                icxp(k) = (0.5d0 -rp*(xc - xv)/scalp)*ihigh
                icyp(k) = (0.5d0 -rp*(yc - yv)/scalp)*ihigh
             else
                icxp(k) = 0
                icyp(k) = 0
             endif
         end do
      endif

      inr = 0
      call shsort(iatoms,rzp,inat)

      inr = 0
      call labnr(inr)

      if (fancy.eq.1) then

         do i=1,iatoms
c Max number of shades per color is 10:(0-9)
            k = inat(i)
            dsurf = .false.
            if (k.gt.natorg.and.natorg.ne.0) dsurf = .true.
            scnd = .false.
            if (backb.eq.1.and.iresid(k).le.0.and.iresid(k).ge.-3) 
     &          scnd = .true.
            if (iaton(k).ge.1.and.(zv-rzp(k)).gt.0.0d0) then
            tmp = c0 / (zv - rzp(k) + c0)
            xs = (zv-rzp(k))/scali
            rfac = (1.0d0-colscp*xs*xs)
            if (rfac.lt.0.0d0) rfac = 0.d0
            if (.not.dsurf) then
               itemp = 9*rfac
               ia = 0
               if (iaton(k).ge.2) ia = iaton(k)
               if (ivdwpl.eq.1.and..not.scnd) then
                  isph = (vdwr(ianz(k))*tmp/(toang*scalp))*ihigh*2.4d0
     &                   + 0.5d0
               else
                  isph = (vrad(ianz(k))*tmp/scalp)*ihigh*2 + 0.5d0
               endif
               if (shade.eq.1) then
                  if (atcol.eq.1) then
                     i1 = 16 +(icol(ianz(k))-1)*10
                  else
                     i1 = 16 +(iatclr(k)-1)*10
                  endif
                  i2 = itemp
                  call plsph3(iyp(k),ixp(k),isph,ia,i1,i2)
               else
                  if (atcol.eq.1) then
                     kcol = icol(ianz(k))
                  else
                     kcol = iatclr(k)
                  endif
                  call setcol(kcol)
                  call plsph(iyp(k),ixp(k),isph,ia)
               endif
               
               call stlab(iresid(k),ilab,idres,iqon,lab,labhet)

               if (dolabs.eq.1.or.idres.eq.1) then
                   if (shade.eq.1) then
                      kcol = 56 + 9*rfac
                   else
                      kcol = 15
                   endif
                   call setcol(kcol)
                   call pllab(ixp(k),iyp(k),ianz(k),k,
     &                        qat(k),inr,ilab,iresid(k),0)

               endif
            endif
            if (dsurf.and.iclon.eq.1) then
               dcell = .false.
               do ik=1,4
                  if (k.eq.iclpnt(ik)) then
                     dcell = .true.
                     ccell = clstr(ik)
                  endif
               end do

               if (dcell) then
                  if (shade.eq.1) then
                     kcol = 56 + 9*rfac
                  else
                     kcol = 15
                  endif
                  call setcol(kcol)
                  call drwstr(ixp(k),iyp(k),ccell,2,k)
               endif
            endif


            xx = 3.0
            call cwidth(xx)
            call sollin

            if(iconn(1,k).gt.mxcon)
     &          write(iun3,*) 'plmol bigger than mxcon'
            do j=1,iconn(1,k)
              im = iconn(j+1,k)
              m = abs(im)
              if (iaton(m).ge.1.and.rzp(k).le.rzp(m)
     &            .and.(zv-rzp(m)).gt.0.0d0) then
                  if (dsurf) then
                     if (atcol.eq.1) then
                         if (iatclr(k).ne.iatclr(m)) then
                            call astck
     &                  (zvect,colscp,scalp,icltan,m,k,ihigh,shade,0,1)
                         else
                            call mstck(zvect,colscp,icltan,m,k,shade,0)
                         endif
                     else
                         call astck(zvect,colscp,scalp,icltan,
     &                              m,k,ihigh,shade,0,0)
                     endif
                  else
                     if (im.lt.0) then
                       call astck(zvect,colscp,scalp,icltan,
     &                              m,k,ihigh,shade,1,0)
                     else
                      if (ivdwpl.eq.0.or.scnd) 
     &                 call fstck(roddef,rfac,scalp,zvect,colscp,icltan,
     &                          m,k,ihigh,shade,atcol,scnd)
          
                     endif
                  endif
              endif
            end do
            if (fyesno.eq.1) 
     &          call plfcp(shade,ixx,k,ihigh,colscp,icltan,zvect,scalp)
            if (idipon.eq.1) call pldipp(shade,ihigh,colscp,icltan,zvect
     &                           ,dipo,scalp,coo,ianz,xv,yv,zv,c0,scali)
            endif
         end do
      else

        if (atcol.eq.1) then
         do i=1,iatoms
            k = inat(i)
            if (iaton(k).ge.1.and.(zv-rzp(k)).gt.0.0d0) then
            scnd = .false.
            if (backb.eq.1.and.iresid(k).le.0.and.iresid(k).ge.-3) 
     &          scnd = .true.
            dsurf = .false.
            if (k.gt.natorg.and.natorg.ne.0) dsurf = .true.
            ia = 0
            if (iatoms.eq.1) ia = 2
            if (iaton(k).ge.2) ia = iaton(k)
            if (ia.ne.0) call plsel(iyp(k),ixp(k),ia)

            call stlab(iresid(k),ilab,idres,iqon,lab,labhet)

            if ((dolabs.eq.1.and..not.dsurf).or.
     &          (dsurf.and.iclon.eq.1)) then
                if (shade.eq.1) then
                   xs = (zv-rzp(k))/scali
                   rfac = (1.0d0-colscp*xs*xs)
                   if (rfac.lt.0.0d0) rfac = 0.d0
                   kcol = 56 + 9*rfac
                else
                   kcol = 15
                endif
                call setcol(kcol)

                if (dsurf.and.iclon.eq.1) then
                   dcell = .false.
                   do ik=1,4
                      if (k.eq.iclpnt(ik)) then
                         dcell = .true.
                         ccell = clstr(ik)
                      endif
                   end do
                   if (dcell)
     &                call drwstr(ixp(k),iyp(k),ccell,2,k)
                else
                   call pllab(ixp(k),iyp(k),ianz(k),k,
     &                        qat(k),inr,ilab,iresid(k),0)
                endif
            endif
            nc = 0
            do j=1,iconn(1,k)
              im = iconn(j+1,k)
              m = abs(im)
              if (iaton(m).ge.1.and.rzp(k).le.rzp(m)
     &            .and.(zv-rzp(m)).gt.0.0d0) then
                if (scnd.and..not.dsurf) then
                  call mstck(zvect,colscp,icltan,m,k,shade,0)
                else
                  id = 0
                  if (im.lt.0) id = 1
                  call astck
     &                 (zvect,colscp,scalp,icltan,m,k,ihigh,shade,id,0)
                endif
              endif
              if (iaton(m).ge.1.and.im.gt.0) nc = nc + 1
            end do
            if (nc.eq.0) call snglat(zvect,scalp,colscp,icltan,k,ihigh,
     &                               shade,atcol,1,0,0)
            if (fyesno.eq.1) 
     &          call plfcp(shade,ixx,k,ihigh,colscp,icltan,zvect,scalp)
            if (idipon.eq.1) call pldipp(shade,ihigh,colscp,icltan,zvect
     &                           ,dipo,scalp,coo,ianz,xv,yv,zv,c0,scali)
            endif
         end do
        else
         do i=1,iatoms
            k = inat(i)
            if (iaton(k).ge.1.and.(zv-rzp(k)).gt.0.0d0) then
            ia = 0
            if (iatoms.eq.1) ia = 2
            if (iaton(k).ge.2) ia = iaton(k)
            if (ia.ne.0) call plsel(iyp(k),ixp(k),ia)
            dsurf = .false.
            if (k.gt.natorg.and.natorg.ne.0) dsurf = .true.

            call stlab(iresid(k),ilab,idres,iqon,lab,labhet)

            if (((dolabs.eq.1.or.idres.eq.1).and..not.dsurf).or.
     &          (dsurf.and.iclon.eq.1)) then
                if (shade.eq.1) then
                   xs = (zv-rzp(k))/scali
                   rfac = (1.0d0-colscp*xs*xs)
                   if (rfac.lt.0.0d0) rfac = 0.d0
                   kcol = 56 + 9*rfac
                else
                   kcol = 15
                endif
                call setcol(kcol)

                if (dsurf.and.iclon.eq.1) then
                   dcell = .false.
                   do ik=1,4
                      if (k.eq.iclpnt(ik)) then
                         dcell = .true.
                         ccell = clstr(ik)
                      endif
                   end do
                   if (dcell)
     &                call drwstr(ixp(k),iyp(k),ccell,2,k)
                else
                   call pllab(ixp(k),iyp(k),ianz(k),k,
     &                        qat(k),inr,ilab,iresid(k),0)
                endif
            endif
            nc = 0
            do j=1,iconn(1,k)
              im = iconn(j+1,k)
              m = abs(im)
              if (iaton(m).ge.1.and.rzp(k).le.rzp(m)
     &            .and.(zv-rzp(m)).gt.0.0d0) then
                 if (im.lt.0) then
                     call astck
     &                 (zvect,colscp,scalp,icltan,m,k,ihigh,shade,1,1)
                 else
                    if (iatclr(k).ne.iatclr(m)) then
                       call astck
     &                 (zvect,colscp,scalp,icltan,m,k,ihigh,shade,0,1)
                    else
                       call mstck(zvect,colscp,icltan,m,k,shade,0)
                    endif
                 endif
              endif
              if (iaton(m).ge.1.and.im.gt.0) nc = nc + 1
            end do
            if (nc.eq.0) call snglat(zvect,scalp,colscp,icltan,k,ihigh,
     &                               shade,atcol,1,0,0)
            if (fyesno.eq.1) 
     &          call plfcp(shade,ixx,k,ihigh,colscp,icltan,zvect,scalp)
            if (idipon.eq.1) call pldipp(shade,ihigh,colscp,icltan,zvect
     &                           ,dipo,scalp,coo,ianz,xv,yv,zv,c0,scali)
            endif
         end do
        endif

      endif

      xx = 1.0
      call cwidth(xx)
      call sollin

      if (iqon.eq.5.and.ipdbon.eq.1.and.dolabs.eq.1) then
         nstr = 8
         if (nchain.gt.1) nstr = 10
         do k=1,nchain
            do j=ianf(k),islu(k)
               jj = j - ianf(k) + 1
               if (reson(j).eq.1) then
                  l = icalf(1,j)
                  if (zv-rzp(l).gt.0.0d0) then
                     if (shade.eq.1) then
                        xs = (zv-rzp(l))/scali
                        rfac = (1.0d0-colscp*xs*xs)
                        if (rfac.lt.0.0d0) rfac = 0.d0
                        kcol = 156 + 9*rfac
                     else
                        kcol = 15
                     endif
                     call setcol(kcol)
                     str(1:3) = aminos(iamino(j))
                     str(4:4) = ' '
c                     write(str(5:8),'(i4)') jj
                     write(str(5:8),'(i4)') irsnr(j)
                     if (nchain.gt.1) then
                        str(9:9) = '.'
c                        if (k.lt.10) str(10:10) = char(k+48)
                        if (k.lt.10) str(10:10) = achain(j)
                     endif
                     call drwstr(ixp(l),iyp(l),str,nstr,l)
                  endif
               endif
            end do
         end do
      end if
      
      call reslab

      return
      end

      subroutine plfcd(shade,ixx,k,ihigh,colsc,icltan,zvect,scalp,
     &                 coo,rzp,ixp,iyp,
     &                 xv,yv,zv,c0,scali)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat)
      dimension tmp1(3),tmp2(3),zvect(3)
      real xx
      integer*2 ixx(24)
      integer shade
      dimension coo(3,*),rzp(*),ixp(*),iyp(*)

      do l=1,3
          tmp1(l) = fc(l,k) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      itemp = abs(icltan*cot1)
      xs = (zv-rzp(k))/scali
      rfac = (1.0d0-colsc*xs*xs)

      if (rfac.lt.0.0d0) rfac = 0.d0
      if (rfac.gt.1.0d0) rfac = 1.d0

      itmp = 5*rfac
      if (shade.eq.1) then
         kcol = 16+(9-itemp)*rfac
      else
         kcol = 25
      endif

      call setcol(kcol)

      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call sollin

      ixx(2) = ixp(k)
      ixx(1) = iyp(k)

      call rotts(fc(1,k),fc(2,k),fc(3,k),xc,yc,zc,1)

      rp = c0/(zv - zc + c0)
      ixx(4) = (0.5d0 - rp*(xc-xv)/scalp)*ihigh
      ixx(3) = (0.5d0 - rp*(yc-yv)/scalp)*ihigh

      call drawseg(ixx,1,0)

      return
      end

      subroutine pldipp(shade,ihigh,colsc,icltan,zvect,dipo,scalp,
     &                 coo,ianz,xv,yv,zv,c0,scali)
      implicit double precision (a-h,o-z)
      parameter (maxfat=1000)
      common /athlp/ iatoms, mxnat
      real xx
      integer*2 ixx(4)
      integer shade
      dimension tmp1(3),tmp2(3),tmp3(3),zvect(3)
      dimension coo(3,*),ianz(*),dipo(*)

      call cntvec(tmp1,coo,ianz,iatoms)

      do l=1,3
          tmp2(l) = dipo(l) - tmp1(l)
      end do

      call rott(tmp2(1),tmp2(2),tmp2(3),tmp3(1),tmp3(2),tmp3(3),0)
      call impsc(tmp3,zvect,cot1)

      call rott(tmp1(1),tmp1(2),tmp1(3),xc,yc,zc,1)
      rp = c0/(zv - zc + c0)
      ixx(2) = (0.5d0 - rp*(xc-xv)/scalp)*ihigh
      ixx(1) = (0.5d0 - rp*(yc-yv)/scalp)*ihigh

      itemp = abs(icltan*cot1)
      xs = (zv-zc)/scali

      rfac  = (1.0d0-colsc*xs*xs)
      if (rfac.lt.0.0d0) rfac = 0.d0
      if (rfac.gt.1.0d0) rfac = 1.d0

      itmp = 5*rfac

      if (shade.eq.1) then
         kcol = 16+(9-itemp)*rfac
      else
         kcol = 25
      endif

      call setcol(kcol)

      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call sollin


      call rott(dipo(1),dipo(2),dipo(3),xc,yc,zc,1)

      rp = c0/(zv - zc + c0)
      ixx(4) = (0.5d0 - rp*(xc-xv)/scalp)*ihigh
      ixx(3) = (0.5d0 - rp*(yc-yv)/scalp)*ihigh

      call drawseg(ixx,1,0)

      return
      end

      subroutine mstcd(zvect,colsc,icltan,m,k,shade,idash,
     &                 coo,rzp,ixp,iyp,iatclr,zv,scali)
      implicit double precision (a-h,o-z)
      integer shade
      real xx
      integer*2 ixx(24)
      dimension tmp1(3),tmp2(3),zvect(3)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*),iatclr(*)

      do l=1,3
         tmp1(l) = coo(l,m) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      itemp = icltan*cot1
      xs = (zv -(rzp(k) + 0.5d0*(rzp(m) - rzp(k))))/scali
      rfac = (1.0d0-colsc*xs*xs)

      if (rfac.lt.0.0d0) rfac = 0.d0
      if (shade.eq.1) then
         kcol = 16 +(iatclr(k)-1)*10+(9-itemp)*rfac
      else
         kcol = iatclr(k)
      endif

      call setcol(kcol)

      itmp = 6*rfac
      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0 

      call cwidth(xx)
      call dash(idash)

      ixx(1) = iyp(k)
      ixx(2) = ixp(k)
      ixx(3) = iyp(m)
      ixx(4) = ixp(m)

      call drawseg(ixx,1,0)
      call dash(0)

      return
      end

      subroutine astcd(zvect,colsc,scalp,icltan,m,k,ihigh,shade,
     &                 idash,imon,coo,rzp,ixp,iyp,ianz,iatclr,
     &                 xv,yv,zv,c0,scali)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      integer shade
      real xx
      integer*2 ixx(24)
      dimension temp(6),tmp1(3),tmp2(3),zvect(3)
      dimension coo(3,*),rzp(*),ixp(*),iyp(*),ianz(*),iatclr(*)

      ik = ianz(k)
      im = ianz(m)

      do l=1,3
         tmp1(l) = coo(l,m) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      itemp = icltan*cot1

      do l=1,3
         temp(l) = (coo(l,m) - coo(l,k))/2.0d0 + coo(l,k)
      end do

      call rott(temp(1),temp(2),temp(3),xc,yc,zc,1)

      rzt = zc
      rp = c0/(zv - rzt + c0)

      ixt = (0.5d0 -rp*(xc - xv)/scalp)*ihigh
      iyt = (0.5d0 -rp*(yc - yv)/scalp)*ihigh

      xs = (zv -(rzp(k) + 0.5d0*(rzt - rzp(k))))/scali
      rfac = (1.0d0-colsc*xs*xs)

      if (rfac.lt.0.0d0) rfac = 0.d0
      if (imon.eq.1) then
         icolt = iatclr(k)
      else
         if (ik.eq.6.and.icol(ik).eq.14) then
            icolt = 10
         else
            icolt = icol(ik)
         endif
      endif

      if (shade.eq.1) then
         kcol = 16+(icolt-1)*10+(9-itemp)*rfac
      else
         kcol = icolt
      endif

      call setcol(kcol)

      itmp = 6*rfac
      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call dash(idash)

      ixx(1) = iyp(k)
      ixx(2) = ixp(k)
      ixx(3) = iyt
      ixx(4) = ixt

      call drawseg(ixx,1,0)

      xs = (zv -(rzp(m) + 0.5d0*(rzt - rzp(m))))/scali
      rfac = (1.0d0-colsc*xs*xs)
      if (rfac.lt.0.0d0) rfac = 0.d0

      if (imon.eq.1) then
         icolt = iatclr(m)
      else
         if (im.eq.6.and.icol(im).eq.14) then
            icolt = 10
         else
            icolt = icol(im)
         endif
      endif

      if (shade.eq.1) then
         kcol = 16+(icolt-1)*10+(9-itemp)*rfac
      else
         kcol = icolt
      endif

      call setcol(kcol)

      itmp = 6*rfac
      xx = (itmp+5)/2+0.5
      if (xx.lt.0.5) xx = 1.0

      call cwidth(xx)
      call dash(idash)

      ixx(1) = iyp(m)
      ixx(2) = ixp(m)
      ixx(3) = iyt
      ixx(4) = ixt

      call drawseg(ixx,1,0)
      call dash(0)

      if (idash.eq.1) call pldst(k,m,ixt,iyt,0)

      return
      end

      subroutine fstcd(roddef,rfac,scalp,zvect,colsc,icltan,m,k,
     &                 ihigh,shade,atcol,scnd,coo,rzp,ianz,iatclr,
     &                 xv,yv,zv,c0,scali)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /helpar/ helrod, ihtype
      logical scnd,twostk
      integer shade,atcol
      real xx, cosa, sina
      dimension tmp1(3),tmp2(3),tmp3(3),zvect(3)
      dimension rtmp1(3),rtmp2(3),rtmp3(3)
      dimension coo(3,*),rzp(*),ianz(*),iatclr(*)

      tol = 1.0d-5

      ik = ianz(k)
      im = ianz(m)
      v1 = vrad(ik)
      v2 = vrad(im)
      twostk = .false.

      if (atcol.eq.1) then
         if (ik.ne.im) twostk = .true.
      else
         if (iatclr(k).ne.iatclr(m)) twostk = .true.
      endif


      if (ik.eq.100.and.im.eq.100) then
          rodrad = helrod
      elseif (ik.ne.1.and.im.ne.1) then
c          rodrad = roddef*2
          rodrad = 0.46d0*v1
          if (v2.lt.v1) rodrad = 0.46d0*v2
      else
          rodrad = roddef
      endif

      rodrd2 = rodrad*rodrad

      do l=1,3
         tmp1(l) = coo(l,m) - coo(l,k)
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),tmp2(1),tmp2(2),tmp2(3),0)
      call impsc(tmp2,zvect,cot1)

      do l=1,3
         tmp1(l) = coo(l,k) - coo(l,m)
      end do

      if (v1.lt.rodrad.and.v2.lt.rodrad) then

         do l=1,3
            tmp2(l) = coo(l,k)
         end do

         do l=1,3
            tmp3(l) = coo(l,m)
         end do

      else

         sc1 = dsqrt(dabs(v1*v1-rodrd2))

         call vsc1(tmp1,sc1,tol)

         do l=1,3
            tmp2(l) = coo(l,k) - tmp1(l)
         end do

         sc2 = dsqrt(dabs(v2*v2-rodrd2))
         call vsc1(tmp1,sc2,tol)

         do l=1,3
            tmp3(l) = coo(l,m) + tmp1(l)
         end do 

      endif

      do l=1,3
         if (twostk) then
            tmp1(l) = (tmp3(l) - tmp2(l))/2.0d0 + tmp2(l)
         else
            tmp1(l) = coo(l,m)
         endif
      end do

      call rott(tmp1(1),tmp1(2),tmp1(3),rtmp1(1),rtmp1(2),rtmp1(3),1)
      call rott(tmp2(1),tmp2(2),tmp2(3),rtmp2(1),rtmp2(2),rtmp2(3),1)
      call rott(tmp3(1),tmp3(2),tmp3(3),rtmp3(1),rtmp3(2),rtmp3(3),1)

      rp1 = c0/(zv - rtmp2(3) + c0)
      rp2 = c0/(zv - rtmp1(3) + c0)

      idiam1 = (rp1*rodrad/scalp)*ihigh
      idiam3 = (rp2*rodrad/scalp)*ihigh

      itemp = 5*cot1

      if (shade.eq.1) then
         if (atcol.eq.1.and..not.scnd) then
            i1 = 16 +(icol(ik)-1)*10
         else 
            i1 = 16 +(iatclr(k)-1)*10
         endif
         i2 = (9-itemp)*rfac+.5d0
      else
         if (atcol.eq.1.and..not.scnd) then
            i1 = icol(ik)
         else
            i1 = iatclr(k)
         endif
      endif

      icy1 = (0.5d0 -rp1*(rtmp2(1) - xv)/scalp)*ihigh
      icx1 = (0.5d0 -rp1*(rtmp2(2) - yv)/scalp)*ihigh
      icy2 = (0.5d0 -rp2*(rtmp1(1) - xv)/scalp)*ihigh
      icx2 = (0.5d0 -rp2*(rtmp1(2) - yv)/scalp)*ihigh

      do l=1,3
         tmp1(l) = rtmp2(l) - rtmp1(l)
      end do

      call impsc(tmp1,zvect,cosb)

      idiam2 = (rp1*dabs(cosb)*rodrad/scalp)*ihigh
      tmp1(1) =  icy1 - icy2
      tmp1(2) =  icx1 - icx2

      clll = dsqrt(tmp1(1)*tmp1(1) + tmp1(2)*tmp1(2))

      if (clll.lt.tol) clll = tol
      irodl = clll +1

      cosa = tmp1(1)/clll
      sina = -tmp1(2)/clll

      if (shade.eq.1) then
          call plrod3(icx1,icy1,idiam1,idiam2,idiam3,irodl,
     &                i1,i2,cosa,sina)
      else
          call plrodx(icx1,icy1,idiam1,idiam2,idiam3,irodl,
     &                i1,cosa,sina)
      endif

      if (twostk) then
         idiam1 = (rp1*rodrad/scalp)*ihigh
         xs = (zv-rzp(m))/scali

         rfac = (1.0d0-colsc*xs*xs)
         if (rfac.lt.0.0d0) rfac = 0.d0

         if (shade.eq.1) then
            if (atcol.eq.1.and..not.scnd) then
               i1 = 16 +(icol(im)-1)*10
            else
               i1 = 16 +(iatclr(m)-1)*10
            endif
            i2 = (9-itemp)*rfac+.5d0
         else
            if (atcol.eq.1.and..not.scnd) then
               i1 = icol(im)
            else
               i1 = iatclr(m)
            endif
         endif

         rp3 = c0/(zv - rtmp3(3) + c0)
         idiam3 = (rp3*rodrad/scalp)*ihigh

         icy3 = (0.5d0 -rp3*(rtmp3(1) - xv)/scalp)*ihigh
         icx3 = (0.5d0 -rp3*(rtmp3(2) - yv)/scalp)*ihigh

         do l=1,3
            tmp1(l) = rtmp1(l) - rtmp3(l)
         end do

         call impsc(tmp1,zvect,cosb)

         idiam2 = (rp1*dabs(cosb)*rodrad/scalp)*ihigh

         tmp1(1) =  icy3 - icy2
         tmp1(2) =  icx3 - icx2

         clll = dsqrt(tmp1(1)*tmp1(1) + tmp1(2)*tmp1(2))

         if (clll.lt.tol) clll = tol
         irodl = clll 

         cosa = -tmp1(1)/clll
         sina = tmp1(2)/clll

         if (shade.eq.1) then
             call plrod3(icx2,icy2,idiam1,idiam2,idiam3,irodl,
     &                   i1,i2,cosa,sina)
         else
             call plrodx(icx2,icy2,idiam1,idiam2,idiam3,irodl,
     &                   i1,cosa,sina)
         endif

      endif

      return
      end

      subroutine files(oempty,idocub,idogrd)
      implicit double precision (a-h,o-z)
      character keywrd*320, keyori*320
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf
      logical oempty
      character fniun*256
c      character temps*80
      common /fnunit/ fniun
      common /keywrd/ keywrd,keyori

c
c----- process FILE or CUBE directive --------------------
c
      idocub = 0
      idogrd = 0
      i = index(keywrd,'FILE=')
      if (i.eq.0) then
         i = index(keywrd,'GAUCUB')
         if (i.ne.0) then
            idocub = 1
            icmdf = 1
         endif
      endif
      if (i.eq.0) then
         i = index(keywrd,'RDBAS')
         if (i.ne.0) then
            idogrd = 1
            icmdf = 1
         endif
         return
      endif
      if (i.ne.0) then
         ind = i + 4
         i   = index(keywrd(ind:320),'=')
         do j=i+ind,320
            if (ichar(keywrd(j:j)).ne.32) goto 2170
         end do
2170     ind1 = j
         do j=ind1,320
            if (ichar(keywrd(j:j)).eq.32) goto 2190
         end do
2190     ind2 = j-1

         if (index(keyori(ind1:ind2),'/').eq.1) then
            open(unit=iun2,form='formatted',file=keyori(ind1:ind2),
     &        status='old',err=2200)
            fniun = keyori(ind1:ind2)
         else
            ld = linlen(curdir)
            open(unit=iun2,form='formatted',
     &        file=curdir(1:ld)//keyori(ind1:ind2),
     &        status='old',err=2200)
            fniun = curdir(1:ld)//keyori(ind1:ind2)
         endif
         do j=ind1,ind2
            keyori(j:j) = ' '
            keywrd(j:j) = ' '
         end do
         icmdf = 1
      else
         call inferr('Keyword FILE not supplied !!',1)
         oempty = .true.
         icmdf = 0
      endif

      return

2200  write(iun3,*) 
     &   'File '//keyori(ind1:ind2)//' does not exist !!!!!!!'
c      call inferr(temps,1)
      oempty = .true.
      icmdf = 0
      return
      end

      subroutine filkey(fname,iun,iform)
      implicit double precision (a-h,o-z)
      character keywrd*320, keyori*320
      character fname*(*)
      character fniun*256
      common /fnunit/ fniun
      common /keywrd/ keywrd,keyori
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf

      ln = len(fname)
      i = index(keywrd,fname(1:ln))

      if (i.ne.0) then

         ind = i + ln
         i   = index(keywrd(ind:320),'=')

         do j=i+ind,320
            if (ichar(keywrd(j:j)).ne.32) goto 2170
         end do
2170     ind1 = j

         do j=ind1,320
            if (ichar(keywrd(j:j)).eq.32) goto 2190
         end do
2190     ind2 = j-1

         if (iform.eq.1) then
            if (index(keyori(ind1:ind2),'/').eq.1) then
              open(unit=iun,form='formatted',
     &           file=keyori(ind1:ind2),status='new',err=2200)
              fniun = keyori(ind1:ind2)
            else
              if (icmdf.eq.1) then
                ld = linlen(curdir)
                open(unit=iun,form='formatted',
     &           file=curdir(1:ld)//keyori(ind1:ind2),
     &           status='new',err=2200)
                 fniun = curdir(1:ld)//keyori(ind1:ind2)
              else
                open(unit=iun,form='formatted',
     &           file=keyori(ind1:ind2),
     &           status='new',err=2200)
                 fniun = keyori(ind1:ind2)
              endif
            endif
         else
            if (index(keyori(ind1:ind2),'/').eq.1) then
                open(unit=iun,form='unformatted',
     &           file=keyori(ind1:ind2),status='new',err=2200)
                fniun = keyori(ind1:ind2)
            else
              if (icmdf.eq.1) then
                ld = linlen(curdir)
                open(unit=iun,form='unformatted',
     &           file=curdir(1:ld)//keyori(ind1:ind2),
     &           status='new',err=2200)
                fniun = curdir(1:ld)//keyori(ind1:ind2)
              else
                open(unit=iun,form='unformatted',
     &           file=keyori(ind1:ind2),
     &           status='new',err=2200)
                fniun = keyori(ind1:ind2)
              endif
            endif
         endif

         do j=ind1,ind2
            keyori(j:j) = ' '
            keywrd(j:j) = ' '
         end do
      endif

2200  continue
      return
      end

      subroutine filmap(mapit)
      implicit double precision (a-h,o-z)
      character keywrd*320, keyori*320
      common /keywrd/ keywrd,keyori
      character*80 mapfil
      character*80 grdfil
      common /maphlp/ mapfil,grdfil
      character curdir*1024
      common /cwd/ curdir

c
c----- process MAPFIL directive --------------------
c
      mapit = 0
      i = index(keywrd,'MAPFIL')
      if (i.ne.0) then
         mapit = 1
         ind = i + 4
         i   = index(keywrd(ind:320),'=')
         do j=i+ind,320
            if (ichar(keywrd(j:j)).ne.32) goto 2170
         end do
2170     ind1 = j
         do j=ind1,320
            if (ichar(keywrd(j:j)).eq.32) goto 2190
         end do
2190     ind2 = j-1
         if (index(keyori(ind1:ind2),'/').eq.1) then
            mapfil = keyori(ind1:ind2)
         else
            ld = linlen(curdir)
            mapfil = curdir(1:ld)//keyori(ind1:ind2)
         endif
      endif

      call filgrd()

      return
      end

      subroutine filgrd()
      implicit double precision (a-h,o-z)
      character keywrd*320, keyori*320
      common /keywrd/ keywrd,keyori
      character*80 mapfil
      character*80 grdfil
      common /maphlp/ mapfil,grdfil
      character curdir*1024
      common /cwd/ curdir

c
c----- process RDBAS directive --------------------
c
      i = index(keywrd,'RDBAS=')
      if (i.ne.0) then
         ind = i + 5
         i   = index(keywrd(ind:320),'=')
         do j=ind+i,320
            if (ichar(keywrd(j:j)).ne.32) goto 2170
         end do
2170     ind1 = j
         do j=ind1,320
            if (ichar(keywrd(j:j)).eq.32) goto 2190
         end do
2190     ind2 = j-1

         if (index(keyori(ind1:ind2),'/').eq.1) then
            grdfil = keyori(ind1:ind2)
         else
            ld = linlen(curdir)
            grdfil = curdir(1:ld)//keyori(ind1:ind2)
         endif
      endif

      return
      end

      subroutine zread(nz,ianz,iz,bl,alpha,beta)
c
c
c
c      z-matrix reading routine.
c      It expects to be positioned after the string point #
c      adapted by g.schaftenaar from sprint gamess
c
c
      implicit double precision (a-h,o-z)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character * 2 iel,jel
      character *137 string
      dimension ianz(*), bl(*), alpha(*), beta(*)
      dimension iz(4,*)
      dimension iel(100)
c
c      note that lower case letters are used in the atomic symbols
c      and in some of the format statements in hollereith strings.
c
      data iel/'bq',
     $         'h ', 'he',
     $         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     $         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     $         'k ', 'ca',
     $                     'sc', 'ti', 'v ', 'cr', 'mn',
     $                     'fe', 'co', 'ni', 'cu', 'zn',
     $                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     $ 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     $ 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     $ 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     $ 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     $ 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     $ 'bk','cf','x '  /
 2110 format(1x,i2,2x,i2,3x,a2)
 2111 format(1x,i3,2x,i3,3x,a2)
 2210 format(1x,i2,2x,i2,3x,a2,3x,i2,2x,f9.6,2x,i3)
 2211 format(1x,i3,2x,i3,3x,a2,2x,i3,2x,f9.6,2x,i4)
 2310 format(1x,i2,2x,i2,3x,a2,3x,i2,2x,f9.6,2x,i3,2x,
     $          i2,1x,f8.3,2x,i3)
 2311 format(1x,i3,2x,i3,3x,a2,2x,i3,2x,f9.6,2x,i4,2x,
     $          i3,1x,f8.3,2x,i4)
 2410 format(1x,i2,2x,i2,3x,a2,3x,i2,2x,f9.6,2x,i3,2x,
     $          i2,1x,f8.3,2x,i3,2x,i2,1x,f8.3,2x,i3,2x,i2)
 2411 format(1x,i3,2x,i3,3x,a2,2x,i3,2x,f9.6,2x,i4,2x,
     $          i3,1x,f8.3,2x,i4,2x,i3,1x,f8.3,2x,i4,2x,i2)
c
c
c
c     print the heading.
c
c
c     first card of z-matrix.
c
      jmode = 0
      call nxtlin(string,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 200

      if (string(4:4).ne.' ') jmode = 1
      if ( index(string(2:5),'====') .ne. 0 ) return
      if (jmode.eq.0) then
         read(string,2110,err=200) icard,icent,jel
      else
         read(string,2111,err=200) icard,icent,jel
      endif

      do i=1,100
         if ( jel .eq. iel(i) ) ianz(1) = i - 1
      end do

      nz = 1    
  
c
c     second card of the z-matrix.
c
      call nxtlin(string,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 200
      if ( index(string(2:5),'====') .ne. 0 ) return
      if (jmode.eq.0) then
         read(string,2210,err=200) icard,icent,jel,iz(1,2),pbl,np1
      else
         read(string,2211,err=200) icard,icent,jel,iz(1,2),pbl,np1
      endif

      do i=1,100
         if ( jel .eq. iel(i) ) ianz(2) = i - 1
      end do

      bl(2) = pbl
      nz = 2

c
c     third card.
c
      call nxtlin(string,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 200

      if ( index(string(2:5),'====') .ne. 0 ) return
      if (jmode.eq.0) then
         read(string,2310,err=200) 
     &   icard,icent,jel,iz(1,3),pbl,np1,iz(2,3),pa,np2
      else
         read(string,2311,err=200) 
     &   icard,icent,jel,iz(1,3),pbl,np1,iz(2,3),pa,np2
      endif

      do i=1,100
         if ( jel .eq. iel(i) ) ianz(3) = i - 1
      end do

      bl(3) = pbl
      alpha(3) = pa
      nz=3
c
c     cards 4 through nz.
c
      do while (.true.)
         call nxtlin(string,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200

         if ( index(string(2:5),'====') .ne. 0 ) return
         nz = nz + 1
         if (jmode.eq.0) then
            read(string,2410,err=200) icard,icent,jel,iz(1,nz),pbl,np1,
     &                        iz(2,nz),pa,np2,iz(3,nz),pb,np3,iz(4,nz)
         else
            read(string,2411,err=200) icard,icent,jel,iz(1,nz),pbl,np1,
     &                        iz(2,nz),pa,np2,iz(3,nz),pb,np3,iz(4,nz)
         endif

         do i=1,100
            if ( jel .eq. iel(i) ) ianz(nz) = i - 1
         end do

         bl(icard) = pbl
         alpha(icard) = pa
         beta(icard) = pb

      end do

200   call inferr('error in z-matrix !',0)
      call inferr(string,0)

      return
      end

      logical function zreadg(nz,ianz,iz,bl,alpha,beta)
c
c
c
c      z-matrix reading routine for gaussian output.
c      It expects to be positioned after the string point #
c      adapted by g.schaftenaar from sprint gamess
c
c
      implicit double precision (a-h,o-z)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      character *2 iel,jel
      character *100 string
      character *2 tocapf
      dimension ianz(*), bl(*), alpha(*), beta(*)
      dimension iz(4,*)
      dimension iel(100)
c
c      note that lower case letters are used in the atomic symbols
c      and in some of the format statements in hollereith strings.
c
      data iel/'bq',
     $         'h ', 'he',
     $         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     $         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     $         'k ', 'ca',
     $                     'sc', 'ti', 'v ', 'cr', 'mn',
     $                     'fe', 'co', 'ni', 'cu', 'zn',
     $                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     $ 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     $ 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     $ 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     $ 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     $ 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     $ 'bk','cf','x '  /
 2110 format(1x,i3,1x,i3,2x,a2)
 2210 format(1x,i3,1x,i3,2x,a2,2x,i3,f11.6)
 2310 format(1x,i3,1x,i3,2x,a2,2x,i3,f11.6,6x,i3,1x,f8.3)
 2410 format(1x,i3,1x,i3,2x,a2,2x,i3,f11.6,6x,i3,1x,f8.3,
     $          6x,i3,1x,f8.3,6x,i3)
 2111 format(1x,i6,1x,i6,2x,a2)
 2211 format(1x,i6,1x,i6,2x,a2,2x,i6,f11.6)
 2311 format(1x,i6,1x,i6,2x,a2,2x,i6,f11.6,9x,i6,1x,f8.3)
 2411 format(1x,i6,1x,i6,2x,a2,2x,i6,f11.6,9x,i6,1x,f8.3,
     $          9x,i6,1x,f8.3,9x,i6)
      zreadg = .true.
      iform = 1

c     first card of z-matrix.

      call nxtlin(string,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 200

      il = linlen(string)
      if (il.eq.12.or.il.eq.11) then
         iform = 1
      else
         iform = 2
      endif
      if ( index(string(2:5),'----') .ne. 0 ) return

      if (iform.eq.1) then
         read(string,2110,err=200) icard,icent,jel
      else
         read(string,2111,err=200) icard,icent,jel
      endif

      do i=1,100
         if (tocapf(jel).eq.tocapf(iel(i))) ianz(1) = i - 1
      end do
      nz = 1    
  

c     second card of the z-matrix.

      call nxtlin(string,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 200

      if ( index(string(2:5),'----') .ne. 0 ) return
      if (iform.eq.1) then
         read(string,2210,err=200) icard,icent,jel,iz(1,2),pbl
      else
         read(string,2211,err=200) icard,icent,jel,iz(1,2),pbl
      endif

      do i=1,100
         if (tocapf(jel).eq.tocapf(iel(i))) ianz(2) = i - 1
      end do

      if (iz(1,2).le.0) then
          zreadg = .false.
          return
      endif

      bl(2) = pbl
      nz = 2


c     third card.

      call nxtlin(string,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 200

      if ( index(string(2:5),'----') .ne. 0 ) return

      if (iform.eq.1) then
         read(string,2310,err=200) icard,icent,jel,iz(1,3),pbl,
     &                             iz(2,3),pa
      else
         read(string,2311,err=200) icard,icent,jel,iz(1,3),pbl,
     &                             iz(2,3),pa
      endif

      do i=1,100
         if (tocapf(jel).eq.tocapf(iel(i))) ianz(3) = i - 1
      end do

      bl(3) = pbl
      alpha(3) = pa
      nz=3

c     cards 4 through nz.

      do while (.true.)
         call nxtlin(string,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200

         if ( index(string(2:5),'----') .ne. 0 ) return
         nz = nz + 1
         if (iform.eq.1) then
            read(string,2410,err=200) icard,icent,jel,iz(1,nz),pbl,
     &                    iz(2,nz),pa,iz(3,nz),pb,iz(4,nz)
         else
            read(string,2411,err=200) icard,icent,jel,iz(1,nz),pbl,
     &                    iz(2,nz),pa,iz(3,nz),pb,iz(4,nz)
         endif

         do i=1,100
            if (tocapf(jel).eq.tocapf(iel(i))) ianz(nz) = i - 1
         end do

         bl(icard) = pbl
         alpha(icard) = pa
         beta(icard) = pb
      end do

200   call inferr('error in z-matrix !',0)
      call inferr(string,0)

      return
      end

      subroutine plotin
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plot /  iplot,iplwin,icolps
      common /keywrd/ keywrd,keyori
      character*320 keywrd,keyori

c-------- determine graphics device ----------------------
c
c     Keyword        Description                        iplot
c
c     FIGURE         figure (gcg software)              0
c     HPGL           Hewlett Packard Graphics Language  1
c     HP2393         Hewlett Packard terminal           2
c     TEK4014        Tektronics 4014                    3
c     POSTSCRIPT     Postscript for laserwriters        4
c     SILLY,OPENGL   OpenGL Version                     5
c     XWINDOWS       Xwindow                            6
c
      if (index(keywrd,'FIG').ne.0) iplot = 0
      if (index(keywrd,'HPGL').ne.0) iplot = 1
      if (index(keywrd,'HP23').ne.0) iplot = 2
      if (index(keywrd,'TEK4').ne.0) iplot = 3
      if (index(keywrd,'POST').ne.0) iplot = 4
      if (index(keywrd,'SILLY').ne.0) iplot = 5
      if (index(keywrd,'OPENGL').ne.0) iplot = 5
      if (index(keywrd,'XWIN').ne.0) iplot = 6

      return
      end

      subroutine oriin(i)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /keywrd/ keywrd,keyori
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common/orihlp/ori(numatm),iuser(numatm),oalpha(numatm),
     $              obeta(numatm),norien,ibal
      character*320 keywrd,keyori,string
      character*30  cunit

      norien = 0
      i1 = index(keywrd(i+1:320),'(')
      i2 = index(keywrd(i+1:320),')')
      string(1:i2-i1-1) = keywrd(i+i1+1:i+i2-1)
      l = i2 - i1 - 1
      j = 1
2300  if (string(j:j).eq.' ') then
        if (j.le.l-1) then
           string(j:l-1) = string(j+1:l)
        endif
        l = l - 1 
      else
        j = j + 1
      endif
      if (j.ne.l+1) goto 2300
2400  i = index(string(1:l),',')
      if (i.eq.0) then
         cunit(1:l) = string(1:l)
         i = l + 1
         l = 0
      else
         cunit(1:i-1)  = string(1:i-1)
         string(1:l-i) = string(i+1:l) 
         l = l - i
      endif
c---- cunit now contains item between "," or "( ," or ", )"
      ind = index(cunit(1:i-1),'/')
      jnd = ind + index(cunit(ind+1:i-1),'/')
      if (ind.eq.0) then
         k = int(reada(cunit(1:i-1)//' ',1,len(cunit)))
         if (nat(k).ne.8.and.nat(k).ne.9.and.nat(k).ne.16
     &      .and.nat(k).ne.17) 
     &      call inferr('ORIENT: allowed atoms are O,F,S,CL',1)
         norien        = norien + 1
         ori(norien)   = k
         iuser(norien) = 0
      elseif (jnd.gt.ind) then
         k = int(reada(cunit(1:ind-1)//' ',1,len(cunit)))
         if (nat(k).ne.8.and.nat(k).ne.9.and.nat(k).ne.16
     &      .and.nat(k).ne.17) 
     &      call inferr('ORIENT: allowed atoms are O,F,S,CL',1)
         norien         = norien + 1
         ori(norien)    = k
         iuser(norien)  = 1
         oalpha(norien) = reada(cunit(ind+1:jnd-1)//' ',1,len(cunit))
         obeta(norien)  = reada(cunit(jnd+1:i-1)//' ',1,len(cunit))
      else
         call inferr('error in ORIENT directive',1)
      endif
      if (l.ne.0) goto 2400

      return
      end

c!!!!!! Start of the xwindow dummys !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c     Delete or put a "C" in the first colomn of the following lines
c     when the xwindow driver is to be installed 
c!!!!!!
      subroutine xwin(xx,yy,ind,str,nstr,inct,incp)
      implicit double precision (a-h,o-z)
      real xx,yy
      character str*100
      print*,'XWindow Driver not installed'
      stop
      end
      subroutine molstr(str,idum1,idum2)
      implicit double precision (a-h,o-z)
      character str*(*)
      stop
      end
      subroutine errzme(str,idum1,idum2,idum3)
      implicit double precision (a-h,o-z)
      character str*(*)
      stop
      end
      subroutine butset(idum1,idum2,idum3)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine drawseg(iseg,idum1,idum2)
      implicit double precision (a-h,o-z)
      integer*2 iseg(*)
      stop
      end
      subroutine drwseg(iseg,idum1,idum2)
      implicit double precision (a-h,o-z)
      integer*2 iseg(*)
      stop
      end
      subroutine dash(ion)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine setcol(ion)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine curs(ion)
      implicit double precision (a-h,o-z)
      return
      end
      subroutine messg(ion)
      implicit double precision (a-h,o-z)
      return
      end
      subroutine doexp
      stop
      end
      subroutine dlogo
      stop
      end
      subroutine unstip
      stop
      end
      subroutine ststip
      stop
      end
      subroutine drwgeo
      stop
      end
      subroutine upzme
      stop
      end
      subroutine qupd
      stop
      end
      subroutine wrtres
      return
      end
      subroutine chkmpi
      return
      end
      subroutine setion()
      stop
      end
      subroutine ogribb(i)
      integer i
      stop
      end
      subroutine stowat(i)
      integer i
      return
      end
      subroutine nmrcpl(idebug)
      integer i
      return
      end
      subroutine ogendd(i)
      integer i
      stop
      end
      subroutine crsco
      stop
      end
      subroutine upsco
      stop
      end
      subroutine ogreset
      return
      end
      subroutine bldlst
      return
      end
      subroutine dlystr
      return
      end
      subroutine cpmf
      stop
      end
      subroutine srfclr
      stop
      end
      subroutine initsrf
      return
      end
      subroutine asurf(i,j)
      integer i,j
      stop
      end
      subroutine sribcol(i)
      integer i
      stop
      end
      subroutine setcll
      return
      end
      subroutine ribpnt(i,j)
      integer i,j
      return
      end
      subroutine ogbegg(i,j,k,l,r,m,s)
      integer i,j,k,l
      double precision r
      character s*(*)
      stop
      end
      subroutine ogvrt(r1,r2,r3)
      double precision r1,r2,r3
      stop
      end
      subroutine ognrm(r1,r2,r3)
      double precision r1,r2,r3
      stop
      end
      subroutine ogcoll(r1,r2,r3)
      double precision r1,r2,r3
      stop
      end
      subroutine rqsrt(i1,r1,i2)
      double precision r1
      stop
      end
      subroutine getene(i,j)
      return
      end
      subroutine gettrr(i,j)
      return
      end
      subroutine gtfrm(i)
      return
      end
      subroutine gethei(ihigh)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine plsph(ixp,iyp,iatoms,ia)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine plsph3(ixp,iyp,iatoms,ia,i1,i2)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine plsel(ixp,iyp,ia)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine labnr(ia)
      implicit double precision (a-h,o-z)
      ia = 0
      return
      end
      subroutine cnvfrg(ia)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine plrodx(ixp,iyp,d1,id2,id3,irod,i1,ca,sa)
      implicit double precision (a-h,o-z)
      real ca,sa
      stop
      end
      subroutine plrod3(ixp,iyp,d1,id2,id3,irod,i1,i2,ca,sa)
      implicit double precision (a-h,o-z)
      real ca,sa
      stop
      end
      integer function islck(i)
      implicit double precision (a-h,o-z)
      islck = 0
      return
      end
      integer function mseed()
      implicit double precision (a-h,o-z)
      mseed = 0
      return
      end
      subroutine drwstr(ixp,iyp,str,nstr,ind)
      implicit double precision (a-h,o-z)
      character*2 str
      stop
      end
      subroutine drwqstr(ixp,iyp,ian,q,ind)
      implicit double precision (a-h,o-z)
      stop
      end
      subroutine drwgl(x1,y1,x2,y2,i1,i2,i3,i4)
      real x1,y1,x2,y2
      stop
      end
      subroutine drwpol(iarray,i1,i2,i3,i4,i5)
      integer*2 iarray(8)
      stop
      end
      subroutine gtht(i,ires)
      implicit double precision (a-h,o-z), integer (i-n)
      stop
      end
      subroutine gethet(i,n,str)
      implicit double precision (a-h,o-z), integer (i-n)
      character str*(*)
      stop
      end
      subroutine parsfn(str,idum1,idum2)
      implicit double precision (a-h,o-z)
      character str*(*)
      return
      end
      subroutine prslab(str,idum1,idum2)
      implicit double precision (a-h,o-z)
      character str*(*)
      return
      end
      subroutine parfns(str,idum1)
      implicit double precision (a-h,o-z)
      character str*(*)
      return
      end
      subroutine parpoi(
     &            nzm,nso,nio,nzo,ioropt,ifor,ixyz98,iopr,isymm,irc,
     &            imp2,icntp,msucc,ioni,ipart,mopopt,isbin,irtype,
     &            ipdbgro,ifav,ioxyz,iconv,ircus,nscnd,iscst,ialtyp)
      return
      end
      subroutine parptr(i1,x,y,i2)
      real x,y
      return
      end
      subroutine parstr(str,idum1)
      implicit double precision (a-h,o-z)
      character str*(*)
      return
      end
      subroutine confrm(iop,istat)
      stop
      end
      subroutine exstr(str,idum1,idum2)
      implicit double precision (a-h,o-z)
      character str*(*)
      return
      end
      subroutine sysstr(str,idum1)
      implicit double precision (a-h,o-z)
      character str*(*)
      return
      end
      subroutine readsq(iamin,angs,namin)
      implicit double precision (a-h,o-z)
      dimension iamin(*),angs(7,*)
      return
      end

      subroutine cwidth(idum1)
      implicit double precision (a-h,o-z)
      stop
      end

      subroutine sollin
      stop
      end

      subroutine tounx
      implicit double precision (a-h,o-z)
      idum = 0
      return
      end
c dummys for zmatrix mallocs

      subroutine chkmaz(istat)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      common /atcom/  coo(3,numat1),rzp(numat1),ianz(numat1),
     &                iaton(numat1),iatclr(numat1),iresid(numat1),
     &                ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /hring/  lring(numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)

      call chkmzz(istat,qat,rzp,ianzz,imap,ianz,lring,ityp,ipdbt)

      return
      end

      subroutine ogmon()
      implicit double precision (a-h,o-z)
      print*,'XWindow Driver not installed'
      stop
      end

      subroutine fndmaz(ixyz,istat)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianz(maxat),iz(4,maxat),imap(maxat)

      call fndmzz(ixyz,istat,imap)

      return
      end

      subroutine mapxzz(iun,imod,iff,izmtmp,istat)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                iianz(maxat),iz(4,maxat),imap(maxat)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call mapzzz(iun,imod,iff,izmtmp,istat,bl,alph,bet,ibl,ialph,
     &            ibet,imap,iianz,iz,ianz)

      return
      end

      subroutine wrzmat(iun,iopt)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (maxat=1000)
      parameter (MAXPNT=2000)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call wrzmaz(iun,iopt,bl,alph,bet,ibl,ialph,
     &            ibet,imap,ianzz,iz,epoints,ianz)

      return
      end

      subroutine wline(iun,iopt,igamb)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)

      call wlinz(iun,iopt,igamb,bl,alph,bet,ibl,ialph,
     &           ibet,imap,ianzz,iz,iconn,ianz,ityp,qat)

      return
      end

      subroutine dumlin(isel,blv,alphv,betv)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /zmsbck/ lwrit(numat1)
      dimension isel(*)

      call dumliz(isel,blv,alphv,betv,bl,alph,bet,ibl,ialph,
     &            ibet,imap,ianzz,iz,lwrit,ianz)

      return
      end

      subroutine plinzz(isel,istat)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /zmsbck/ lwrit(numat1)
      dimension isel(*)

      call plinz(isel,istat,bl,alph,bet,ibl,ialph,
     &            ibet,imap,ianzz,iz,lwrit,ianz)

      return
      end

      subroutine prtzm
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianz(maxat),iz(4,maxat),imap(maxat)

      call prtzz(bl,alph,bet,ibl,ialph,ibet,imap,ianz,iz)

      return
      end

      subroutine getzmz(istat)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianz(maxat),iz(4,maxat),imap(maxat)

      call getzzz(istat,bl,alph,bet,ibl,ialph,ibet,imap,ianz,iz)

      return
      end

      subroutine dumzm(cc,ianc,nnatoms)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      dimension cc(3,*),ianc(*)
      dimension ian(maxat),c(3,maxat),cz(3,maxat),
     &          alpha(maxat),beta(maxat)

      call dumzz(cc,ianc,nnatoms,bl,alph,bet,ibl,ialph,ibet,
     &           imap,ianzz,iz,c,cz,alpha,beta,ian,coo,iresid,
     &           issdon)

      return
      end

      subroutine convzmat(cc,ianc,nnatoms,igo,ico,ido)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianz(maxat),iz(4,maxat),imap(maxat)
      dimension cc(3,*),ianc(*)
      dimension ian(maxat),c(3,maxat),cz(3,maxat),
     &          alpha(maxat),beta(maxat)

      call convzmzz(cc,ianc,nnatoms,igo,ico,ido,
     &           bl,alph,bet,ibl,ialph,ibet,
     &           imap,ianz,iz,c,cz,alpha,beta,ian)

      return
      end

      subroutine getmop(nnatoms,heat,igo,ico,istat)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension ian(maxat),c(3,maxat),cz(3,maxat),
     &          alpha(maxat),beta(maxat)

      call getmdp(coo,ianz,nnatoms,heat,igo,ico,istat,
     &           bl,alph,bet,ibl,ialph,ibet,
     &           imap,ianzz,iz,c,cz,alpha,beta,ian)

      return
      end

      subroutine getzm(nnatoms,igo,ico,istat)
      implicit double precision (a-h,o-z)
      parameter (maxat=1000)
      common /zmatin/ bl(maxat),alph(maxat),bet(maxat),
     &                ibl(maxat),ialph(maxat),ibet(maxat),
     &                ianzz(maxat),iz(4,maxat),imap(maxat)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension ian(maxat),c(3,maxat),cz(3,maxat),
     &          alpha(maxat),beta(maxat)

      call getzd(coo,ianz,nnatoms,igo,ico,istat,
     &           bl,alph,bet,ibl,ialph,ibet,
     &           imap,ianzz,iz,c,cz,alpha,beta,ian)

      return
      end

      subroutine allorb(isiz,ifrst)
      implicit double precision (a-h,o-z), integer (i-n)

      idum = 0

      return
      end

      subroutine allgrd(isiz)
      implicit double precision (a-h,o-z), integer (i-n)

      idum = 0

      return
      end

      subroutine allgeo(isiz,ifrst)
      implicit double precision (a-h,o-z), integer (i-n)

      idum = 0

      return
      end

      subroutine allcoo(isiz,ifrst)
      implicit double precision (a-h,o-z), integer (i-n)

      idum = 0

      return
      end

      subroutine almgrd()
      implicit double precision (a-h,o-z), integer (i-n)

      idum = 0

      return
      end

      subroutine dozmt(istat)
      implicit double precision (a-h,o-z), integer (i-n)

      istat = 0

      return
      end

      subroutine adffun(x,y,z,psi)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      real stoalfa,stobnorm
      common /ADF/    istos(5,maxorb),naorbs,stoalfa(maxorb),
     &                stobnorm(maxorb)
      dimension psi(*)

      call adffud(x,y,z,psi,
     &            stoalfa,stobnorm,istos,naorbs)
      return
      end

      subroutine atdd(imo,ipsi,iao)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      common /dynhlp/ qd(maxorb*maxorb),pd(maxorb),gd(3,maxorb),
     &                hd(6,maxorb)

      call addd(imo,ipsi,iao,p,paa,pd)

      return
      end

      subroutine denmad(ido)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      common /sphere/ averag(maxorb)
      common /dynhlp/ qd(maxorb*maxorb),pd(maxorb),gd(3,maxorb),
     &                hd(6,maxorb)


      call denmdd(ido,vectrs,vectrb,focc,focb,p,paa,averag,qd)

      return
      end

      subroutine densmat(ido)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      common /densty/ p(maxorb*maxorb), paa(maxorb)

      call densmad(ido,vectrs,vectrb,focc,focb,p,nocc)

      return
      end

      subroutine densmto(ido)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /densty/ p(maxorb*maxorb), paa(maxorb)

      call densmtd(ido,vectrs,focc,p,nocc)

      return
      end

      subroutine espot(x,y,z,epot,idebug)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /densty/ p(maxorb*maxorb), paa(maxorb)

      call espod(x,y,z,epot,idebug,p)

      return
      end

      subroutine espgrd(npts1,npts2,npts3,idebug)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (max3d=61)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)
      common /densty/ p(maxorb*maxorb), paa(maxorb)

c arguments missing, xden,yden,zden !!!
c      call espgrdd(npts1,npts2,npts3,idebug,denn,p)

      return
      end

      subroutine boys(norb,nor,dmao,vecs)
      implicit double precision (a-h,o-z), integer (i-n)
      dimension nor(*),dmao(*),vecs(*)

      print*,"Boys not available in noxwin"

      return
      end

      subroutine newdenmak
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      common /dynhlp/ qd(maxorb*maxorb),pd(maxorb),gd(3,maxorb),
     &                hd(6,maxorb)

      call newdenmad(p,qd)

      return
      end

      subroutine calhes(psi,grd,hess,den,g,hes)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      dimension psi(*),grd(3,*),hess(6,*), g(3),hes(6)

      call calhed(psi,grd,hess,den,g,hes,p)

      return
      end

      subroutine grdcal(dens,npts1,npts2,iprnt,space)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      common /dynhlp/ qd(maxorb*maxorb),pd(maxorb),gd(3,maxorb),
     &                hd(6,maxorb)
      common /elfhlp/ phi(maxorb),dphi(3,maxorb),
     &                dxpsi(maxorb),dypsi(maxorb),dzpsi(maxorb)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      integer space
      dimension dens(*)

      call grdcad(dens,npts1,npts2,iprnt,space,
     &            p,paa,pd,gd,hd,
     &            phi,dphi,dxpsi,dypsi,dzpsi,
     &            vectrs,vectrb,focc,focb)

      return
      end

      subroutine exxtop(npr,norbs)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call exxtod(npr,norbs,vectrs,vectrb,focc,focb,eiga,eigb)

      return
      end

      subroutine prtvec
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call prtved(vectrs,vectrb,eiga,eigb,ncols,ncolb)

      return
      end

      subroutine stint
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (numat1=20000)
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      common /chgbck/ qat(numat1)

      call stind(p,qat)

      return
      end

      subroutine muldmd(vdwr,moddma,idm,idd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      dimension vdwr(*)

      call mulddd(vdwr,moddma,idm,idd,p,qat,iconn)

      return
      end

      subroutine mopin(istat,ibin,impas)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /densty/ p(maxorb*maxorb), paa(maxorb)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)
      common /dynhlp/ qd(maxorb*maxorb),pd(maxorb),gd(3,maxorb),
     &                hd(6,maxorb)
      common /sphere/ averag(maxorb)

      call mopdd(istat,ibin,impas,vectrs,averag,p,focc,eiga,qd,pd,
     &           nocc,ncols)

      return
      end

      subroutine rdgad(idebug,ibefo,istatio,ioxyz,irtype,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call rdgdd(idebug,ibefo,istatio,ioxyz,irtype,istats,
     &           vectrs,vectrb,focc,focb,eiga,eigb,nocc,nocb,ncols,
     &           ncolb,coo,ianz)

      return
      end

      subroutine rdgamd(idebug,ibefo,istatio,ioxyz,irtype,
     &                  ihsend,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call rdgadd(idebug,ibefo,istatio,ioxyz,irtype,ihsend,istats,
     &            vectrs,vectrb,focc,focb,eiga,eigb,
     &            nocc,nocb,ncols,ncolb)

      return
      end

      subroutine rdcpmdd(idebug,ibefo,istatio,ioxyz,irtype,
     &                  ihsend,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call rdcpmddd(idebug,ibefo,istatio,ioxyz,irtype,ihsend,istats,
     &     vectrs,vectrb,focc,focb,eiga,eigb,
     &     nocc,nocb,ncols,ncolb)
 
      return
      end

      subroutine rdgaud(idebug,ibefo,istatio,irtype,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      call rdgdud(idebug,ibefo,istatio,irtype,istats,focc,focb,
     &            nocc,nocb,ncols,ncolb,coo,ianz)

      return
      end

      subroutine rdmaud(idebug,istatio,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (MAXPNT=2000)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)
      common /dynhlp/ qd(maxorb*maxorb),pd(maxorb),gd(3,maxorb),
     &                hd(6,maxorb)
      common /sphere/ averag(maxorb)

      call rdmadd(idebug,istatio,istats,
     &            vectrs,vectrb,focc,focb,eiga,eigb,
     &            averag,p,qd,pd,nocc,nocb,ncols,ncolb,
     &            formax,forrms,dismax,disrms,epoints,isav,qat)

      return
      end

      subroutine rdmold(idebug,istatio,irtype,iesp,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (MAXPNT=2000)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)
      real stoalfa,stobnorm
      common /ADF/    istos(5,maxorb),naorbs,stoalfa(maxorb),
     &                stobnorm(maxorb)
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)

      call rdmodd(idebug,istatio,irtype,iesp,istats,
     &            vectrs,vectrb,focc,focb,eiga,eigb,nocc,nocb,
     &            ncols,ncolb,stoalfa,stobnorm,istos,naorbs,
     &            formax,forrms,dismax,disrms,epoints,isav)

      return
      end

      subroutine prtmolf(iun,ihaszm,ipoints)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (MAXPNT=2000)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)
      real stoalfa,stobnorm
      common /ADF/    istos(5,maxorb),naorbs,stoalfa(maxorb),
     &                stobnorm(maxorb)
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call prtmold(iun,ihaszm,ipoints,
     &            vectrs,vectrb,focc,focb,eiga,eigb,nocc,nocb,
     &            ncols,ncolb,stoalfa,stobnorm,istos,naorbs,
     &            formax,forrms,dismax,disrms,epoints,isav,ianz)

      return
      end

      subroutine rdvect(idebug,ig94,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call rdvecd(idebug,ig94,istats,vectrs,vectrb,focc,eiga,eigb,
     &            ncols,ncolb)

      return
      end

      subroutine datin(npts1,npts2,npts3)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)


      call datid(npts1,npts2,npts3,ncols,ncolb,focc,focb,eiga,eigb)

      return
      end

      subroutine homo(ipsi)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call homod(ipsi,focc,focb,eiga,eigb)

      return
      end

      subroutine lumo(ipsi)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call lumod(ipsi,focc,focb,eiga,eigb)

      return
      end

      subroutine occup(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb

      call occupd(istat,focc,focb)

      return
      end

      subroutine cntour(a,mdim,imax,jmax,pz,value,r11,id)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)
      dimension a(mdim,*), id(mdim,*)

      call cntoud(a,mdim,imax,jmax,pz,value,r11,id,ix)

      return
      end

      subroutine den3d(npts1,npts2,scale)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call dendd(npts1,npts2,scale,dens,edx,edy,iedlog)

      return
      end

      subroutine dencnt(npts1,npts2,fcnt)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)
      dimension fcnt(*)

      call dencnd(npts1,npts2,fcnt,dens,iedlog)

      return
      end

      subroutine grdcl(npts1,npts2,iprnt,ispace)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call grdcd(npts1,npts2,iprnt,ispace,dens)

      return
      end

      subroutine rdqchm(idebug,irtype,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb

      call rdqchd(idebug,irtype,istat,focc,focb,nocc,nocb,ncols,ncolb)

      return
      end

      subroutine rdqvec(idebug,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      real eiga,eigb
      common /eigval/ eiga(maxorb),eigb(maxorb)

      call rdqvcd(idebug,istats,
     &                  vectrs,vectrb,eiga,eigb,ncols,ncolb)

      return
      end

      subroutine rdorca(idebug,irtype,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb

      call rdorcd(idebug,irtype,istat,ianz,iatoms,
     &            focc,focb,nocc,nocb,ncols,ncolb)

      return
      end

      subroutine pltspec(inum)
      implicit double precision (a-h,o-z), integer (i-n)

      return
      end

      subroutine prsogl
      implicit double precision (a-h,o-z), integer (i-n)

      return
      end

      subroutine rdnwch(idebug,irtype,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb

      call rdnwcd(idebug,irtype,istats,
     &                 ianz,iatoms,focc,focb,nocc,nocb,ncols,ncolb)

      return
      end

      subroutine nmcshl
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (maxcpl=100)
      dimension couplj(maxcpl*maxcpl)

      call nmcshd(couplj)

      return
      end

      subroutine resedl
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call resedd(iedlog)

      return
      end

      subroutine maxmin(npts1,npts2,scale)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call maxmid(npts1,npts2,scale,dens)

      return
      end

      subroutine plden(ndim1,ndim2,scale,icells,adjus,idisml)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call plded(ndim1,ndim2,scale,icells,adjus,idisml,
     &           dens,ix,iy,rz)

      return
      end

      subroutine p3dv(iun,scale,ndimx,ndimz,adjus)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call p3dd(iun,scale,ndimx,ndimz,adjus,dens)

      return
      end

      subroutine rdcube(npts1,npts2,npts3,iposng,ipsi,istat,iun,idebug)
      implicit double precision (a-h,o-z)
      parameter (max3d=61)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)

      call rdcubd(npts1,npts2,npts3,iposng,ipsi,istat,iun,idebug,
     &            denn,pmnn)

      return
      end

      subroutine wrcube(npts1,npts2,npts3,ipsi)
      implicit double precision (a-h,o-z)
      parameter (max3d=61)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)

      call wrcubd(npts1,npts2,npts3,ipsi,denn)

      return
      end

      subroutine rdgrd(npts1,npts2,npts3,iun,istat)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma
      character*4 buff(max3d2)

      call rdgrdd(npts1,npts2,npts3,iun,istat,
     &            denn,dens,pmnn,buff,ichx)

      return
      end

      subroutine dpomap(iopt)
      implicit double precision (a-h,o-z)
      parameter (max3d=61)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)

      call dpomad(iopt,denn)

      return
      end

      subroutine rdomap(npts1,npts2,npts3,iun,istat)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rdomad(npts1,npts2,npts3,iun,istat,
     &            denn,dens,pmnn,ichx)

      return
      end

      subroutine rdvasp(npts1,npts2,npts3,iposng,istat,lenf,idocub,
     &                  idebug)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rdvasd(npts1,npts2,npts3,iposng,istat,lenf,idocub,
     &            idebug,denn,pmnn,bucket,coo,ianz,iatclr,iconn,
     &            nat,norg,icent,inorm,ncon,nspg,ichx,
     &            nopr,ir,it,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine rdinfo(npts1,npts2,isubtr,istat)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call rdinfd(npts1,npts2,isubtr,istat,adjus,dens)

      return
      end

      subroutine rd3inf(npts1,npts2,npts3,isubtr,adjus,istat)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call rd3ind(npts1,npts2,npts3,isubtr,adjus,istat,
     &            denn,pmnn,denst)

      return
      end

      subroutine rd3chk(npts1,npts2,npts3,igauss,impas,istat)
      implicit double precision (a-h,o-z)
      parameter (maxm3d=10)
      common /map3d/  fmap(maxm3d*maxm3d*maxm3d),mxm3d

      call rd3chd(npts1,npts2,npts3,igauss,impas,istat,fmap)

      return
      end

      subroutine wrinfo(npts1,npts2)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call wrinfd(npts1,npts2,dens)

      return
      end

      subroutine wr3inf(npts1,npts2,npts3,adjus)
      implicit double precision (a-h,o-z)
      parameter (max3d=61)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)

      call wr3ind(npts1,npts2,npts3,adjus,denn)

      return
      end

      subroutine denfst(sum,psi)
      implicit double precision (a-h,o-z)
      parameter (maxorb=256)
      common /vectrs/ vectrs(maxorb*maxorb),focc(maxorb),nocc,ncols
      common /vectrb/ vectrb(maxorb*maxorb),focb(maxorb),nocb,ncolb
      dimension psi(*)

      call denfsd(sum,psi,vectrs,vectrb,focc,focb)

      return
      end

      subroutine spaced(npts1,npts2,npts3,valcnt,idofil,adjus,
     &                  ipsprt,idisml,idvrml,mapit)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      parameter (maxm3d=10)

      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)
      common /map3d/  fmap(maxm3d*maxm3d*maxm3d),mxm3d

      call spacdd(npts1,npts2,npts3,valcnt,idofil,adjus,ipsprt,
     &            idisml,idvrml,mapit,denn,pmnn,iedlog,fmap)

      return
      end

      subroutine spasrf(npts1,npts2,npts3,valcnt)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /spa3d/  denn(max3d*max3d*max3d),pmnn(max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call spasrd(npts1,npts2,npts3,valcnt,denn,pmnn,dens,iedlog)

      return
      end

      subroutine isoden(valc,nvalc,scincr,nespt,iwhere)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)

      call isoded(valc,nvalc,scincr,nespt,iwhere,dens,iedlog)

      return
      end

      subroutine wrcart(iun,dopdb,idogau,ipdbwh)
      parameter (MAXPNT=2000)
      implicit double precision ( a-h,o-z )
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call wrcard(iun,dopdb,idogau,ipdbwh,epoints,
     &            ncalf,ianf,islu,nchain,iamino,reson,irsnr,achain)

      return
      end

      subroutine plvend(iun,iloop)
      parameter (MAXPNT=2000)
      implicit double precision ( a-h,o-z )
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call plvedd(iun,iloop,epoints,scal)

      return
      end

      subroutine dyncpmd(ipoints)
      parameter (MAXPNT=2000)
      implicit double precision ( a-h,o-z )
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)

      call dyncpdd(ipoints,isav,epoints)

      return
      end

      subroutine progeo(ipoints,iff,istat)
      parameter (MAXPNT=2000)
      implicit double precision ( a-h,o-z )
      common /geocnv2/ formax(MAXPNT),forrms(MAXPNT),dismax(MAXPNT),
     &                 disrms(MAXPNT),epoints(MAXPNT),isav(MAXPNT)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call proged(ipoints,iff,istat,
     &            formax,forrms,dismax,disrms,epoints,isav,ichx)

      return
      end

      subroutine oginit(r,adjus,natoms,nat,icol,xsym,ysym,zsym,
     &                  vdwr,cnst,npts1,npts2,iorb)
      implicit double precision (a-h,o-z)
      parameter (lnbuck=10)
      parameter (max3d=61)
      parameter (max3d2=max3d*max3d)
      common /grdall/ dens(max3d2),denst(max3d2),edx(max3d2),
     &                edy(max3d2),rz(max3d2),bucket(max3d+lnbuck),
     &                iedlog(max3d2),ix(max3d2),iy(max3d2)
      dimension r(*),xsym(*),ysym(*),zsym(*),vdwr(*)
      dimension nat(*),icol(*)

      call oginid(r,adjus,natoms,nat,icol,xsym,ysym,zsym,
     &            vdwr,cnst,npts1,npts2,iorb,dens)

      return
      end

      subroutine anim
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call anid(coo,ianz)

      return
      end

      subroutine actami(inum,ikleur,iopt,idosrf)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain

      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)

      call actamd(inum,ikleur,iopt,idosrf,iaton,iatclr,iresid,isurf,
     &            icalf,ncalf,ianf,islu,nchain,iamino,ihet,
     &            iclhet,reson,iams,isal,ishoh)

      return
      end

      subroutine actexp(que,lque,ikleur,idosrf)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)

      integer reson
      character*1 achain

      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      call actexd(que,lque,ikleur,idosrf,
     &            ncalf,iamino)

      return
      end

      subroutine aacom(vrad,ires,str,nstr,istsrf)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain

      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)
      dimension vrad(*)

      call aacod(vrad,ires,str,nstr,istsrf,iresid,isurf,
     &           ncalf,ianf,islu,nchain,iamino,ihet,reson,
     &           isal,irsnr,achain);

      return
      end

      subroutine actcal(iopt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain

      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call actcad(iopt,iaton,iatclr,iresid,icalf,ianf,islu,nchain,
     &            iamino,ibck);

      return
      end

      subroutine acthel(iopt,iscnd,jcolsp,inclbb)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain

      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      call acthed(iopt,iscnd,jcolsp,inclbb,iaton,iatclr,iresid,iconn,
     &            icalf,ianf,islu,nchain,iamino,ihet,reson,
     &            isal,ibck)

      return
      end

      subroutine actss(iopt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call actsd(iopt,ianz,iaton,iatclr,iresid,iconn)

      return
      end

      subroutine pmfass(iopt,dochg)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      integer dochg
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain

      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      call pmfasd(iopt,dochg,ianz,iresid,iconn,ityp,ncalf,iamino)

      return
      end

      subroutine dfiass
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call dfiasd(ityp,ncalf,iamino)

      return
      end

      subroutine updres
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call updred(coo,ncalf,icalf)

      return
      end

      subroutine dfires
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call dfired(coo,icalf,ncalf,iamino)

      return
      end

      subroutine twodfi(tdfi,ires1,ires2)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call twodfd(tdfi,ires1,ires2,coo,ityp)

      return
      end

      subroutine twodfib(tdfi,ires1,ires2)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call twodfid(tdfi,ires1,ires2,coo,ityp)

      return
      end

      subroutine onedfi(tdfi,ires1)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call onedfd(tdfi,ires1,coo,ityp)

      return
      end

      subroutine totpmf(ttpmf)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call totpmd(ttpmf,coo,ianz,iaton,iatclr,ityp)

      return
      end

      subroutine pmfinf(iatm)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call pmfind(iatm,coo,ianz,ityp)

      return
      end

      subroutine ipmtyp(iptm,iat,ian,idochg)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)

      call ipmtyd(iptm,iat,ian,idochg,ianz,iconn,qat)

      return
      end

      subroutine clmon(car,pot)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      dimension car(*)

      call clmod(car,pot,coo,qat)

      return
      end

      subroutine clmons(car,pot,idoloc)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      common /condens/ icont(numat1),ncont
      dimension car(*)

      call clmond(car,pot,idoloc,coo,qat,icont,ncont)

      return
      end

      subroutine calfa(istat,istpdb,iaddh,ioatms,nstrt,ioadd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call calfd(istat,istpdb,iaddh,ioatms,nstrt,ioadd,ianz,iconn,ityp,
     &           icalf,ncalf,ianf,islu,nchain,iamino,
     &           isal,irsnr,ihashb)

      return
      end

      subroutine docct
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call doccd(coo,ianz)

      return
      end

      subroutine docent
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)

      call docend(t,coo,ianz)

      return
      end

      subroutine valdis(var,ipntr,numat,iop,iasel,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxeat=300)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      dimension var(mxeat,2),ipntr(mxeat)

      call valdid(var,ipntr,numat,iop,iasel,istat,ianz,iresid,qat)

      return
      end

      subroutine eemcalc(var,ipntr,numat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (mxeat=300)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      dimension var(mxeat,2),ipntr(mxeat)

      call eemcald(var,ipntr,numat,ianz,coo,qat)

      return
      end

      subroutine distchk
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call distchd(coo)

      return
      end

      subroutine calgas(iasel,iprnt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call calgad(iasel,iprnt,istat,qat,ianz,iconn,iresid,ityp)

      return
      end

      subroutine mkscon(c,rad,grdw,iptr,npts)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension c(*)

      call mkscod(c,rad,grdw,iptr,npts,coo,iconn)

      return
      end

      subroutine connlp(dens,idomap,isp)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)

      call connld(dens,idomap,isp,coo,ianz,iaton,iatclr,iresid,iconn,
     &            isurf)

      return
      end

      subroutine allsrf(idocol,idomap,idocal,isp)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)

      call allsrd(idocol,idomap,idocal,isp,isurf,iaton,ianz,iatclr)

      return
      end

      subroutine alasrf
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call alasrd(iresid,isurf,iams,ihets)

      return
      end

      subroutine clrsrf
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      common /srfbck/ isurf(numat1)

      call clrsrd(isurf)

      return
      end

      subroutine propnt(qx,qy,qz,ipen)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call propnd(qx,qy,qz,ipen,
     &            coo,ianz,iaton,iatclr,iresid,iconn)

      return
      end

      subroutine getfr(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call getfd(istat,coo)

      return
      end

      subroutine ggetfr(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call ggetfd(istat,coo)

      return
      end

      subroutine getfrm(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call getfrd(istat,coo,ianz)

      return
      end

      subroutine getfra(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call getfrad(istat,ianz)

      return
      end

      subroutine nxtpnt(iopt,fancy,atcol,dolabs,backb,wpnt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer dolabs,fancy,atcol,backb
      logical wpnt

      call nxtpnd(iopt,fancy,atcol,dolabs,backb,wpnt,coo)

      return
      end

      subroutine scalfr(iopt,fancy,atcol,dolabs,backb,wpnt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer dolabs,fancy,shade,atcol,backb
      logical wpnt
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call scalfd(iopt,fancy,atcol,dolabs,backb,wpnt,t,coo,
     &            scal,scali,smag)

      return
      end

      subroutine resfr
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call resfd(coo)

      return
      end

      subroutine tofcoo
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call tofcod(coo)

      return
      end

      subroutine iatnox
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call iatnod(ianz)

      return
      end

      subroutine gampoi(ipoint,istat,ioxyz)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call gampod(ipoint,istat,ioxyz,coo,ianz)

      return
      end

      subroutine gaupoi(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call gaupod(istat,coo,ianz)

      return
      end

      subroutine getpoi(icomm,ifd,iff,idoscl,ioatms,ioadd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call getpod(icomm,ifd,iff,idoscl,ioatms,ioadd,coo,ianz,iaton,
     &            iconn,scal,scali,smag,nat,ichx,icrtp)

      return
      end

      subroutine doconn
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call docond(coo,iconn,ianz)

      return
      end

      subroutine dohcon(ihflag)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)

      call dohcod(ihflag,coo,ianz,iconn,isurf)

      return
      end

      subroutine nohcon
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call nohcod(iconn)

      return
      end

      subroutine doscal
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)
      common /pers/  xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call doscad(t,coo,zv,pincr,scal,scali,smag,iscupd)

      return
      end

      subroutine redcon
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call redcod(iconn)

      return
      end

      subroutine domcon(ipt,idoall)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      monmod = 2

      call domcod(ipt,idoall,monmod,iconn)

      return
      end

      subroutine getxyz(igetxy,heat,iaddprv)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call getxyd(igetxy,heat,iaddprv,coo,ianz,iaton,iatclr,iconn,qat,
     &                  nat,norg,icent,nspg,ichx,nopr,ir,it,
     &                  xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      if (igetxy.eq.-1) then
          print*,'exceded maxnum of atoms!'
          igetxy = 0
      endif

      return
      end

      subroutine aln2ml(iopt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call aln2md(iopt,istat,coo,ianz,iaton,iatclr,iresid)

      return
      end

      subroutine alnrot(vec,irot)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension vec(*)

      call alnrod(vec,irot,coo)

      return
      end

      subroutine alnwrt
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call alnwrd(coo,ianz)

      return
      end

      subroutine alnsel(isel)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension isel(4)

      call alnsed(isel,coo)

      return
      end

      subroutine getchr(igetca)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      common /chgbck/ qat(numat1)

      call getchd(igetca,qat)

      return
      end

      subroutine getmol(igetmo,iadd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)

      call getmod(igetmo,iadd,coo,qat,ianz,iaton,iconn,iresid)

      return
      end

      subroutine outmol(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call outmod(iun,coo,ianz,iconn)

      return
      end

      subroutine mopaco(istats,mopopt,irtype)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call mopacd(istats,mopopt,irtype,ianz,iatclr,iconn,coo,qat,
     &            nat,icent,nspg,ichx,nopr,ir,it,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine parfc
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call parfd(coo,fscal)

      return
      end

      subroutine plmol
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      common /pltmp/  inat(numat1)
      common /pers/xv,yv,zv,c0,pincr
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call plmod(coo,qat,rzp,ixp,iyp,iconn,ianz,iaton,iatclr,iresid,
     &           inat,lab,labhet,xv,yv,icalf,ncalf,icxp,icyp,
     &           scal,scali)

      return
      end

      subroutine plmolp
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      common /pltmp/  inat(numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)

      call plmold(coo,qat,rzp,ixp,iyp,iconn,ianz,iaton,iatclr,iresid,
     &           inat,lab,labhet,xv,yv,zv,c0,
     &           icalf,ncalf,ianf,islu,nchain,iamino,reson,
     &           icxp,icyp,irsnr,scali)

      return
      end

      subroutine plfc(shade,ixx,k,ihigh,colsc,icltan,zvect)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade
      dimension zvect(*)

      call plfd(shade,ixx,k,ihigh,colsc,icltan,zvect,
     &          coo,rzp,ixp,iyp,xv,yv,scal,scali)

      return
      end

      subroutine plfcp(shade,ixx,k,ihigh,colsc,icltan,zvect,scalp)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade
      dimension zvect(*)

      call plfcd(shade,ixx,k,ihigh,colsc,icltan,zvect,scalp,
     &           coo,rzp,izp,iyp,xv,yv,zv,c0,scali)

      return
      end

      subroutine mstick(zvect,colsc,icltan,m,k,shade,idash)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade
      dimension zvect(*)

      call msticd(zvect,colsc,icltan,m,k,shade,idash,
     &            coo,rzp,ixp,iyp,iatclr,zv,scali)

      return
      end

      subroutine mstck(zvect,colsc,icltan,m,k,shade,idash)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade
      dimension zvect(*)

      call mstcd(zvect,colsc,icltan,m,k,shade,idash,
     &           coo,rzp,ixp,iyp,iatclr,scali)

      return
      end

      subroutine sstick
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call ssticd(coo,ixp,iyp,iaton,iconn,xv,yv,scal)

      return
      end

      subroutine astick(zvect,colsc,icltan,m,k,ihigh,shade,idash,imon)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade
      dimension zvect(*)

      call asticd(zvect,colsc,icltan,m,k,ihigh,shade,idash,imon,
     &            coo,rzp,ixp,iyp,ianz,iatclr,xv,yv,scal,scali)

      return
      end

      subroutine astck(zvect,colsc,scalp,icltan,m,k,ihigh,shade,idash,
     &                 imon)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade
      dimension zvect(*)

      call astcd(zvect,colsc,scalp,icltan,m,k,ihigh,shade,idash,imon,
     &           coo,rzp,ixp,iyp,ianz,iatclr,
     &           xv,yv,zv,c0,scali)

      return
      end

      subroutine snglat(zvect,scalp,colsc,icltan,k,ihigh,shade,atcol,
     &                  ipersp,ipost,icolps)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade,atcol
      dimension zvect(*)

      call snglad(zvect,scalp,colsc,icltan,k,ihigh,shade,atcol,
     &            ipersp,ipost,icolps,coo,rzp,ixp,iyp,ianz,iatclr,
     &            xv,yv,zv,c0,scal,scali)

      return
      end

      subroutine fstick(roddef,rfac,zvect,colsc,icltan,m,k,ihigh,shade,
     &                  atcol,scnd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade,atcol
      logical scnd
      dimension zvect(*)

      call fsticd(roddef,rfac,zvect,colsc,icltan,m,k,ihigh,shade,
     &            atcol,scnd,coo,rzp,ianz,iatclr,xv,yv,scal,scali)

      return
      end

      subroutine fstck(roddef,rfac,scalp,zvect,colsc,icltan,m,k,ihigh,
     &                 shade,atcol,scnd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pers/xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade,atcol
      logical scnd
      dimension zvect(*)

      call fstcd(roddef,rfac,scalp,zvect,colsc,icltan,m,k,ihigh,
     &           shade,atcol,scnd,coo,rzp,ianz,iatclr,
     &           xv,yv,zv,c0,scali)

      return
      end

      subroutine pldstg
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call pldstd(ixp,iyp)

      return
      end

      subroutine plalab(iqon)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call plalad(iqon,rzp,ixp,iyp,
     &            icalf,ianf,islu,nchain,iamino,reson,irsnr,achain,
     &            scali)

      return
      end

      subroutine reslab
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call reslad(rzp,ixp,iyp,iconn,
     &            icalf,nchain,iamino,reson,irsnr,lab,ihet,
     &            achain,ncalf,scali)

      return
      end

      subroutine plalb(iami)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call plald(iami,ixp,iyp,icalf,iamino,irsnr)

      return
      end

      subroutine pllab(ixp,iyp,ianz,k,qat,inr,iqon,ires,ipost)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call pllad(ixp,iyp,ianz,k,qat,inr,iqon,ires,ipost,ityp,ipbdt,
     &           iamino,reson)

      return
      end

      subroutine plpost(backb,dolabs,icolps,fancy,atcol,persp,shade,
     &                  idelx)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /pltmp/  inat(numat1)
      common /chgbck/ qat(numat1)
      common /pers/  xv,yv,zv,c0,pincr
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer shade,atcol,persp,fancy,dolabs,backb

      call plposd(backb,dolabs,icolps,fancy,atcol,persp,shade,idelx,
     &            ixp,iyp,rzp,inat,qat,xv,yv,zv,
     &            icalf,ncalf,ianf,islu,nchain,iamino,reson,scal)

      return
      end

      subroutine plvrml(iun,fancy,atcol,dolabs,ihnd,backb,dohead)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      logical dohead
      integer atcol,fancy,dolabs,backb
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)
      common /sclcom/ scal,fscal,scali,smag,iscupd
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call plvrmd(iun,fancy,atcol,dolabs,ihnd,backb,dohead,
     &            rz,t,coo,ianz,iaton,iatclr,iresid,iconn,
     &            icalf,ianf,islu,nchain,iamino,reson,scal,scali)

      return
      end

      subroutine plvst(iun,jcol,k,atcol,hndexl)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer atcol
      logical hndexl
      dimension jcol(3,16)

      call plvsd(iun,jcol,k,atcol,hndexl,coo,ianz,iaton,iatclr,iconn)

      return
      end

      subroutine hcoord(ioatms,nstrt,iaddh)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      istat = 1

      call hcoodd(istat,ioatms,nstrt,iaddh,ipdbt,coo,ianz,iaton,iresid,
     &            iconn,icalf,ncalf,ianf,islu,nchain,iamino)

      if (istat.eq.0) print*,'No room to add hydrogens'

      return
      end

      subroutine hang(idx1,idx2,hng)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call hand(idx1,idx2,hng,coo,ianz,iconn,icalf)

      return
      end

      subroutine hbond(ioatms,nstrt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call hbodd(ioatms,nstrt,coo,ianz,iconn,
     &           icalf,ncalf,iamino)

      return
      end

      subroutine acthb(iopt,hbfilt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call acthd(iopt,hbfilt,coo,iconn,ianz,icalf,ncalf)

      return
      end

      subroutine disabh(iopt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call disabd(iopt,ianz,iaton,iconn)

      return
      end

      subroutine hbconn(iopt,iat1,iat2)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call hbcond(iopt,iat1,iat2,ianz,iatclr,iaton,iconn)

      return
      end

      subroutine getchn(ires,ichain)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call getcdh(ires,ichain,ianf,islu,nchain)

      return
      end

      subroutine ribbon(iscnd,idogl,nr,iungl,ipart,ist,ichain)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      istat = 1

      call ribbod(istat,iscnd,iidogl,nr,iungl,ipart,ist,ichain,t,
     &            coo,ianz,iaton,iatclr,iresid,iconn,
     &            icalf,ncalf,ianf,islu,nchain,iamino,isal,ihashb)

      if (istat.eq.0) then
         if (iscnd.eq.0) then
            print*,'No room to add helices'
         elseif (iscnd.eq.1) then
            print*,'No room to add beta sheets'
         elseif (iscnd.eq.2) then
            print*,'No room to add DNA backbone'
         endif
      endif

      return
      end

      subroutine proxim(itarg,thresh,ikleur,idosrf)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call proxid(itarg,thresh,ikleur,idosrf,coo,iresid,ishoh)

      return
      end

      subroutine proxic(itarg,backb,adds,idocom,thresh)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      integer backb,adds

      call proxd(itarg,backb,adds,idocom,thresh,
     &           coo,iresid,iaton,iconn,iams,ishoh)

      return
      end

      subroutine rdchx(idebug,iop,istdbd,iuseab,moddma,istat,
     &                 icssr)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rdchd(idebug,iop,istdbd,iuseab,moddma,istat,
     &           icrtp,icssr,coo,iconn,ianz,iatclr,ityp,qat,
     &           nat,icent,inorm,ncon,nspg,kz,ichx,icrtp,nopr,ir,it,
     &           xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)


      return
      end

      subroutine rfbio(idebug,ifrst,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rfbid(idebug,ifrst,istat,coo,qat,ianz,iatclr,iconn,
     &                 nat,icent,inorm,ncon,nspg,kz,nopr,ir,it,
     &                 xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine getxdt(ipnt,nat,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call getxdd(ipnt,nat,istat,coo)

      return
      end

      subroutine rfdat(idebug,doest,istat,refcod)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma
      character*8 refcod
      logical doest

      call rfdad(idebug,doest,istat,refcod,coo,ianz,iatclr,iconn,
     &           nat,norg,icent,inorm,ncon,nspg,kz,nopr,ir,it,
     &           xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine fdat(iop,ifrst,istdbd,iuseab,moddma,idebug)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /zmsbck/ lwrit(numat1)
      common /hring/  lring(numat1)
      common /sclcom/ scal,fscal,scali,smag,iscupd
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call fdad(iop,ifrst,istdbd,iuseab,moddma,idebug,
     &     coo,qat,ianz,iaton,iatclr,iresid,iconn,lwrit,lring,ityp,
     &     scal,scali,smag,nat,norg,icent,inorm,ncon,nspg,nopr,ir,it,
     &     xa,ya,yb,za,zb,zc,a,b,c)


      return
      end

      subroutine delat(iat,iacn,iorg,mxdma)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call delad(iat,iacn,iorg,mxdma,coo,ianz,iatclr,qat,ityp)

      return
      end

      subroutine polh(nat,ipolh,iatom)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call pold(nat,ipolh,iatom,ianz,iconn)

      return
      end

      subroutine ifnn(ifn,noff,ia1,ia2)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call ifnd(ifn,noff,ia1,ia2,iconn)

      return
      end

      subroutine rdgro(idebug,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call rdgrod(idebug,istat,coo,qat,ianz,iatclr,iresid,iconn,
     &            ityp,ipdbt,
     &            icalf,ncalf,ianf,islu,nchain,iamino,reson,
     &            isal,irsnr,ishoh)

      if (istat.eq.-1) then
          print*,'exceeded maximum atoms !'
          istat = 0
      endif

      return
      end

      subroutine addbox(v1,v2,v3)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call addbod(v1,v2,v3,coo,ianz,iatclr,iconn)

      return
      end

      subroutine addtbx(v1,v2,v3)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call addtbd(v1,v2,v3,coo,ianz,iatclr,iconn,iaton,iresid)

      return
      end

      subroutine gropt(ipnt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call gropd(ipnt,coo)

      return
      end

      subroutine rdmol(idebug,ipdbon,ioadd,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      istat = 1

      call rdmod(idebug,ipdbon,ioadd,istat,coo,qat,
     &           ianz,iatclr,iresid,iconn,ityp,ipdbt,
     &           icalf,ncalf,ianf,islu,nchain,iamino,reson,
     &           isal,ishoh,ihashb,
     &           nat,norg,icent,ncon,nspg,kz,ichx,nopr,ir,it,
     &           xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      if (istat.eq.-1) then
          print*,'exceeded maximum atoms !'
          istat = 0
      endif

      return
      end

      subroutine wrmol(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      common /pltmp/  inat(numat1)
      common /hring/  lring(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrmod(iun,coo,qat,ianz,iaton,iatclr,iconn,
     &           iresid,lring,inat,ityp,ipdbt,
     &           icalf,ncalf,iamino,ishoh,
     &           nat,nspg,ichx,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine ispn(ispt,iat,irng,idochg,ifive)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      common /zmsbck/ lwrit(numat1)
      common /hring/  lring(numat1)

      call ispnd(ispt,iat,irng,idochg,ifive,
     &          qat,ianz,iaton,iconn,lwrit,lring)

      return
      end

      subroutine wrcrys(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrcryd(iun,ianz,coo,
     &            nat,nspg,ichx,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine rdcif(idebug,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rdcifd(idebug,istat,coo,ianz,iconn,iatclr,
     &            nat,icent,ncon,nspg,nopr,ir,it,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine rdshlx(idebug,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rdshld(idebug,istat,coo,ianz,iconn,iatclr,
     &            nat,icent,ncon,nspg,kz,nopr,ir,it,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine wrshlx(iun,idospf)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrshld(iun,idospf,coo,ianz,
     &            nat,icent,nspg,kz,ichx,nopr,ir,it,
     &            a,b,c,alpha,beta,gamma)

      return
      end

      subroutine wrcif(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrcifd(iun,coo,ianz,
     &            nat,nspg,ichx,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine cllrot(vec,irot,ifd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma
      dimension vec(*)

      call cllrod(vec,irot,ifd,coo,ianz,
     &            nat,xa,ya,yb,za,zb,zc)

      return
      end

      subroutine zm2fr(cm,ctmp,imkeep)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma
      dimension cm(3,3),ctmp(3,*),imkeep(3)

      call zm2fd(cm,ctmp,imkeep,coo,ianz,iatclr,iconn,
     &           nat,ichx,xa,ya,yb,za,zb,zc)

      return
      end

      subroutine wrchx(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrchd(iun,coo,ianz,iatclr,iconn,qat,ityp,
     &           nat,inorm,nspg,ichx,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine rdmsi(idebug,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rdmsd(idebug,istat,coo,ianz,iatclr,iconn,qat,
     &           nat,icent,ncon,nspg,ichx,nopr,ir,it,
     &           xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine wrmsi(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrmsd(iun,coo,ianz,iconn,qat,
     &           nat,nspg,ichx,xa,ya,yb,za,zb,zc)

      return
      end

      subroutine rdcpmolu(istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call rdcpmold(istats,coo,ianz)

      return
      end

      subroutine cpmdpt(ipnt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call cpmdpd(ipnt,istat,coo,ianz)

      return
      end

      subroutine cpmdgetfr(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call cpmdgetfd(istat,coo)

      return
      end

      subroutine cpmdcell
      implicit double precision (a-h,o-z), integer (i-n)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call cpmdceld(nspg,xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine cpmdptdyn(ipnt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call cpmdptdyd(ipnt,istat,coo)

      return
      end

      subroutine wrcpmd(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrcpdd(iun,ianz,coo,
     &            nat,ichx,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine rdmolu(sline,iemlin,idocoo,idobohr,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call rdmodu(sline,iemlin,idocoo,idobohr,istats,coo,ianz)

      return
      end

      subroutine gamupt(ipnt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call gamupd(ipnt,istat,coo,ianz)

      return
      end

      subroutine ugetfr(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call ugetfd(istat,coo)

      return
      end

      subroutine wrvasp(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrvasd(iun,coo,ianz,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine wrmopa(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrmopd(iun,coo,ianz,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine wrfc(iun3)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call wrfd(iun3,coo)

      return
      end

      subroutine rdfc(ipnt,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call rdfd(ipnt,istats,coo)

      return
      end

      subroutine rdmsf(idebug,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call rdmdf(idebug,istat,coo,ianz,iatclr,iconn,qat,ityp,
     &           nat,norg,icent,inorm,ncon,nspg,kz,ichx,nopr,ir,it,
     &           xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine rdpdb(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call rdpdd(istat,coo,ianz,ihashb)

      return
      end

      subroutine pdbstd(istat,doscnd,ioadd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      integer doscnd
   
      istat = 1

      call pdbsdd(istat,doscnd,ioadd,coo,ianz,iaton,iresid,iconn,ityp,
     &            ncalf,ianf,islu,nchain,iamino,ihet,
     &            isal,irsnr,achain,ihashb,ishoh)

      if (istat.eq.-1) then
          print*,'exceeded maximum atoms !'
          istat = 0
      endif

      return
      end

      subroutine conpdb
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call conpdd(ianz,iconn,iresid,ncalf,iamino)

      return
      end

      subroutine convpdb
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call convpdd(ianz,iconn,iresid,ncalf,iamino)

      return
      end

      subroutine conslv
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call consld(iconn,iresid)

      return
      end

      subroutine connij(idcon,i,j,idoconv)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call connid(idcon,i,j,idoconv,iconn,ianz,coo)

      return
      end

      subroutine setchg(iat,iopt)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)

      call setchd(iat,iopt,qat,ityp)

      return
      end

      subroutine flagh(ihpdb,iat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      common /srfbck/ isurf(numat1)
      dimension ihpdb(*)

      call flagd(ihpdb,iat,isurf)

      return
      end

      subroutine conat(ipdb,iat1,iat2,iop)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension ipdb(*)

      call conad(ipdb,iat1,iat2,iop,iconn)

      return
      end

      subroutine conath(ipdb,ihpdb,iat1,iat2)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension ipdb(*),ihpdb(*)

      call conatd(ipdb,ihpdb,iat1,iat2,iconn)

      return
      end

      subroutine pdbtyp(ipdb,ihpdb,jres,ihashy)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      dimension ipdb(*),ihpdb(*)

      call pdbtyd(ipdb,ihpdb,jres,ihashy,ipdbt)

      return
      end

      subroutine typeit(ipdb,jres,ihpdb,ihashy)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      dimension ipdb(*),ihpdb(*)

      call typeid(ipdb,jres,ihpdb,ihashy,ianz,iconn,ityp)

      return
      end

      subroutine typamb(ipdb,jres,ihpdb,ihashy)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      dimension ipdb(*),ihpdb(*)

      call typamd(ipdb,jres,ihpdb,ihashy,ianz,iconn,ityp)

      return
      end

      subroutine typamo(ipdb,jres,ihpdb,ihashy)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      dimension ipdb(*),ihpdb(*)

      call typado(ipdb,jres,ihpdb,ihashy,ianz,iconn,ityp)

      return
      end

      subroutine mkback(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      dimension ipdb(*),ihpdb(*)

      call mkbacd(ipdb,ihpdb,jres,icres,ihashy,idoconv,iconn,coo,
     &            icalf,ianf,islu,nchain,iamino)

      return
      end

      subroutine mknbck(ipdb,ihpdb,jres,icres,ihashy,idoconv)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      dimension ipdb(*),ihpdb(*)

      call mknbcd(ipdb,ihpdb,jres,icres,ihashy,idoconv,iconn,coo,
     &            icalf,ianf,islu,nchain,iamino)

      return
      end

      subroutine sftlab(i)
      implicit double precision (a-h,o-z), integer (i-n)

      idum = i

      return
      end

      subroutine addhs(ires,jres,ipdb,ihpdb,nterm)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /srfbck/ isurf(numat1)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      dimension ipdb(*),ihpdb(*)

      call addhd(ires,jres,ipdb,ihpdb,nterm,ianz,iaton,iatclr,iresid,
     &           iconn,isurf,ipdbt,ityp,ncalf,icalf,coo)

      return
      end

      subroutine numhet(num)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call numhed(num,iresid)

      return
      end

      subroutine qcxyz(idebug,nuclear,ipnt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call qcxyd(idebug,nuclear,ipnt,istat,ianz,coo)

      return
      end

      subroutine orcxyz(idebug,ipnt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call orcxyd(idebug,ipnt,istat,ianz,coo)

      return
      end

      subroutine nwxyz(idebug,ipnt,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call nwxyd(idebug,ipnt,istat,ianz,coo)

      return
      end

      subroutine fnwxyz(idebug,istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call fnwxyd(idebug,istat,ianz,coo)

      return
      end

      subroutine getqfr(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call getqfd(istat,coo)

      return
      end

      subroutine getofr(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call getofd(istat,coo)

      return
      end

      subroutine getnfr(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call getnfd(istat,coo)

      return
      end

      subroutine rotcor(b)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension b(3,*)

      call rotcod(b,coo)

      return
      end

      subroutine rotmom(ipoint,ifav)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call rotmod(ipoint,ifav,coo)

      return
      end

      subroutine rotfir(ioxyz)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call rotfid(ioxyz,ianz,coo)

      return
      end

      subroutine setorg(iatom)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)

      call setord(iatom,t,coo)

      return
      end

      subroutine samino(istat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call samind(istat,ianz,iresid,iconn,ipdbt,icalf,ncalf,iamino)

      return
      end

      subroutine getpdb(ires,ipdb,ihpdb)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      dimension ipdb(*),ihpdb(*)

      call getpdd(ires,ipdb,ihpdb,ianz,iresid,ipdbt)

      return
      end

      subroutine bckok(ibckok,ires,iop)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call bckod(ibckok,ires,iop,ianz,iresid,ipdbt,iamino)

      return
      end

      subroutine wrsrf(iun,nesp,iesp)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call wrsrd(iun,nesp,iesp,ianz,iatclr,iconn,coo)

      return
      end

      subroutine rdsrf(iun,istats,iesp,iaddprv,idebug)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call rdsrd(iun,istats,iesp,iaddprv,idebug,
     &           ianz,iaton,iatclr,iresid,iconn,coo)

      return
      end

      subroutine srfden(x,y,z,f)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)
      common /condens/ icont(numat1),ncont

      call srfded(x,y,z,f,ianz,isurf,coo,icont,ncont)

      return
      end

      subroutine defsrf
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /srfbck/ isurf(numat1)

      call defsrd(isurf,coo)

      return
      end

      subroutine clrmon
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call clrmod(iconn)

      return
      end

      subroutine intcor(intc,rout,isel,inum)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      real rout
      dimension isel(4)

      call intcod(intc,rout,isel,inum,coo)

      return
      end

      subroutine xyzcoo(idocopy,idoconv,ioadd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call xyzcod(idocopy,idoconv,ioadd,ianz,coo)

      return
      end

      subroutine wrmsf(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      common /hring/  lring(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrmsfd(iun,coo,qat,ianz,iaton,iatclr,iresid,
     &           iconn,lring,ityp,nat,nspg,ichx,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine wrtnk(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /hring/  lring(numat1)

      call wrtnd(iun,ianz,iaton,iconn,lring,ityp,coo)

      return
      end

      subroutine wrgff(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      common /srfbck/ isurf(numat1)
      common /hring/  lring(numat1)
      common /zmsbck/ lwrit(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call wrgfd(iun,ianz,iaton,iconn,isurf,lring,lwrit,
     &           ncalf,ishoh,iresid,ityp,coo,qat,
     &           xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine wrogl(iun)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /hring/  lring(numat1)
      common /rotmat/rx(3),ry(3),rz(3),t(3), td(3)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call wrogd(iun,rx,ry,rz,lring,coo,rzp,reson,ianf,nchain,ncalf)

      return
      end

      subroutine rdbin(iun,heat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /hring/  lring(numat1)

      call rdbid(iun,heat,
     &            coo,ianz,iatclr,iconn,lring,
     &            ichx,nat,norg,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine getnat(natoms)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /athlp/ iatoms, mxnat

      natoms = 0

      do i=1,iatoms
         if (ianz(i).lt.100.and.ianz(i).gt.0) natoms = natoms + 1
      end do

      return
      end

      subroutine allon(ntota,nwat,nion,nsign,newat,nresi)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /athlp/ iatoms, mxnat

      do i=nwat,natoms
         iaton(i) = 1
         iatclr(i) = 1
      end do

      return
      end

      subroutine gettyp(ires,iat1,iat2)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call gettyd(ires,iat1,iat2,ityp,ipdbt,ianz,iresid,
     &            iamino,icalf,ncalf)

      return
      end

      subroutine chkbrk
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call chkbrd(iconn,icalf,ianf,islu,iamino,isal,reson,ncalf,nchain)

      return
      end

      subroutine gettnk(igttnk,idebug,ipdbon,iffset,iheat,heat)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      common /srfbck/ isurf(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma
c      integer*2 ir,it
c      common /cell/   natc,ndum(6),ichx,icrtp,nopr,
c     &                ir(3,3,192),it(3,192),rdum(12)

      call gettnd(igttnk,idebug,ipdbon,iffset,iheat,heat,
     &            ianz,iconn,iatclr,ityp,coo,qat,isurf,
     &            issdon,iclon,ichx,ishoh,ision,nspg,
     &            nat,norg,xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      if (igttnk.eq.-1) igttnk = 0

      return
      end

      subroutine tnkfst(igttnk,idebug,ialloc)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /hring/  lring(numat1)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma

      call tnkfsd(igttnk,idebug,ialloc,
     &            coo,ianz,iatclr,iconn,lring,
     &            ichx,nat,norg,
     &            xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      if (igttnk.eq.-1) igttnk = 0

      return
      end

      subroutine dotyp(icel)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /zmsbck/ lwrit(numat1)
      common /hring/  lring(numat1)
      common /chgbck/ qat(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma
      common /condens/ icont(numat1),ncont

      call dotyd(icel,ianz,iaton,iatclr,iconn,iresid,
     &           lwrit,lring,ityp,coo,qat,icont,
     &           icalf,ncalf,ianf,islu,nchain,iamino,ishoh,
     &           nat,a,b,c,alpha,beta,gamma)

      return
      end

      subroutine espfit(idip,nesp,esp,connl,dx,dy,dz,iz,dmachg,ichadd)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      common /chgbck/ qat(numat1)
      logical dmachg
      dimension esp(*),connl(3,*)

      call espfid(idip,nesp,esp,connl,dx,dy,dz,iz,dmachg,ichadd,qat)

      return
      end

      subroutine allzmt(ipdbon)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call allzmd(ipdbon,ianz,iaton,coo)

      return
      end

      subroutine ligzmt
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call ligzmd(ianz,iaton)

      return
      end

      subroutine pdbzmt
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call pdbzmd(ianz,iaton,iresid,iconn)

      return
      end

      subroutine haswat(ino)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call haswad(ino,ianz,iaton,iresid,iconn)

      return
      end

      subroutine intzmt(ispdb)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /hring/  lring(numat1)
      common /srfbck/ isurf(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call intzmd(ispdb,ianz,iaton,iresid,iconn,lwrit,lring,
     &            icalf,ianf,islu,nchain,iamino)

      return
      end

      subroutine icrcon(icrcn,isel,idisc,ndisc,nanz,ispdb)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /zmsbck/ lwrit(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      dimension isel(*),idisc(*)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call icrcod(icrcn,isel,idisc,ndisc,nanz,ispdb,
     &            ianz,iaton,iconn,lwrit,coo,icalf,ncalf)

      return
      end

      subroutine calcx(ical,isel,nx)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      dimension isel(*)

      call calcd(ical,isel,nx,ianz,iaton,iconn,coo)

      return
      end

      subroutine prelea(iprel,ilead,isel,ispdb,ithree)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /zmsbck/ lwrit(numat1)
      dimension isel(*)

      call prelead(iprel,ilead,isel,ispdb,ithree,
     &             ianz,iaton,iresid,iconn,lwrit)

      return
      end

      subroutine preleh(iprel,ilead,isel,ispdb,ithree)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /zmsbck/ lwrit(numat1)
      dimension isel(*)

      call prelehd(iprel,ilead,isel,ispdb,ithree,
     &            ianz,iaton,iresid,iconn,lwrit)

      return
      end

      subroutine rdbas(idebug,idfree,istats)
      implicit double precision (a-h,o-z), integer (i-n)
      parameter (numat1=20000)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)

      call rdbad(idebug,idfree,istats,ityp)

      return
      end

      subroutine setis(nres,istart)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /srfbck/ isurf(numat1)

      call setid(nres,istart,isurf,iresid,ipdbt)

      return
      end

      subroutine clkbck(istsurf,incp,ifogl)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call clkbcd(istsurf,incp,ifogl,iresid,coo,icalf,ncalf,reson)

      return
      end

      subroutine newfil(idebug,istat,inc,ioadd,ioatms,nstrt,namols,
     &                  nxtmf,ipdbon,namls,iof)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call newfid(idebug,istat,inc,ioadd,ioatms,nstrt,namols,
     &            nxtmf,ipdbon,namls,iof,iaton,iatclr,iresid,
     &            ncalf)

      return
      end

      subroutine setarr(iop,iopval,ioatms)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      common /chgbck/ qat(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /sclcom/ scal,fscal,scali,smag,iscupd
      common /pers/  xv,yv,zv,c0,pincr
      integer*2 ir,it
      common /cell/   nat,norg,icent,inorm,ncon,nspg,kz,ichx,icrtp,
     &                nopr,ir(3,3,192),it(3,192),
     &                xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /pnthlp/ ipoints,ipnt
      character*3 hetz
      common /clfstr/ ihashz,ihetq(mxheta),ihqset(mxheta),ihhadd(mxheta)
     &                ,labhet(mxheta),ilcset,ligcat(mxheta),hetz(mxheta)

      call setard(iop,iopval,ioatms,
     &            ianz,iaton,iatclr,iresid,iconn,qat,
     &            ihet,iclhet,reson,lab,labhet,iclset,ligcat,
     &            iams,ihets,irsnr,
     &            ncalf,issdon,scal,scali,fscal,smag,
     &            xv,yv,xv,pincr,nat,ichx,icrtp,ipoints,ngeoms)

      return
      end

      subroutine epvrml(vdwr,moddma,natoms,norbs,idops)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call epvrmd(vdwr,moddma,natoms,norbs,idops,iaton)

      return
      end

      subroutine clrcod(natorg,natoms,idebug)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call clrcdd(natorg,natoms,idebug,iatclr)

      return
      end

      subroutine pckrot(istat,iatsel)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call pckrod(istat,iatsel,iresid,iconn)

      return
      end

      subroutine wrxyz(jmode)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      common /chgbck/ qat(numat1)

      call wrxyd(jmode,qat)

      return
      end

      subroutine caldip
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /chgbck/ qat(numat1)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call caldid(qat,coo)

      return
      end

      subroutine hetnum(idum)
      implicit double precision (a-h,o-z)

      idum = 0

      return
      end

      subroutine chkmol2(iok)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/ coo(3,numat1),rzp(numat1),ianz(numat1),
     &               iaton(numat1),iatclr(numat1),iresid(numat1),
     &               ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      
      call chkmld(iok,ianz,ityp)

      return
      end

      subroutine chktmp
      implicit double precision (a-h,o-z)

      idum = 0

      return
      end

      subroutine xyzrot(inct,theang)
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)

      call xyzrod(inct,theang,rx,ry,rz)

      return
      end

      subroutine rotts(x,y,z,xc,yc,zc,itran)
      implicit double precision (a-h,o-z)
      real x,y,z
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)

      call rottd(x,y,z,xc,yc,zc,itran,
     &                 rx,ry,rz,t)

      return
      end

      subroutine rott(x,y,z,xc,yc,zc,itran)
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)

      call rotd(x,y,z,xc,yc,zc,itran,
     &                 rx,ry,rz,t)

      return
      end

      subroutine inirot
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)

      call inirod(rx,ry,rz,t)

      return
      end

      subroutine mtinv3
      implicit double precision (a-h,o-z)
      common /rotmat/rx(3),ry(3),rz(3),t(3),td(3)

      call mtind3(rx,ry,rz)

      return
      end

      subroutine mktrn(inct,incp)
      implicit double precision (a-h,o-z)
      common /pers/  xv,yv,zv,c0,pincr
      common /sclcom/ scal,fscal,scali,smag,iscupd

      call mktrd(inct,incp,xv,yv,zv,pincr,scal,scali,smag)

      return
      end

      subroutine setxyv
      implicit double precision (a-h,o-z)
      common /pers/  xv,yv,zv,c0,pincr

      call setxyd(xv,yv)

      return
      end

      subroutine chkbck(iupogl)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /atcom/  coo(3,numat1),rzp(numat1),ianz(numat1),
     &                iaton(numat1),iatclr(numat1),iresid(numat1),
     &                ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call chkbcd(ncalf,ihet,reson,iaton,iatclr,ision)

      return
      end

      subroutine ribbs
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call ribbd(issdon)

      return
      end

      subroutine setchn(iopt)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call setcdd(iopt,nchain,ianf,islu,irsnr,achain)

      return
      end

      subroutine acthlp(iop1,iop2,iop3)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call acthld(iop1,iop2,iop3,ihet)

      return
      end

      subroutine acttog(iop1,iop2,iop3)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call acttod(iop1,iop2,iop3,ihet)

      return
      end

      subroutine acttag(iop1,iop2,iop3)
      implicit double precision (a-h,o-z)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call acttad(iop1,iop2,iop3,ihet,ision)

      return
      end

      subroutine calpsa(v,cval,pol,psa,tsa,exs,idepth)
      implicit double precision (a-h,o-z)

      idum = idepth

      return
      end

      subroutine tpsa
      implicit double precision (a-h,o-z)

      idum = i

      return
      end

      subroutine tstpsa(p1,p2,p3,i)
      implicit double precision (a-h,o-z)

      idum = i

      return
      end

      subroutine tomap(imap,iambfr)
      implicit double precision (a-h,o-z)

      imap = 0
      iambfr = 0

      return
      end

      subroutine upajob
      implicit double precision (a-h,o-z)

      idum = 0

      return
      end

      subroutine fndoh(itar,ang,ires,copt,istat)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/  coo(3,numat1),rzp(numat1),ianz(numat1),
     &                iaton(numat1),iatclr(numat1),iresid(numat1),
     &                ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      dimension copt(3)

      call fndod(itar,ang,ires,copt,istat,
     &           coo,qat,iconn,ityp,iresid,irsnr,ncalf,icalf)


      return
      end

      subroutine evwat
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/  coo(3,numat1),rzp(numat1),ianz(numat1),
     &                iaton(numat1),iatclr(numat1),iresid(numat1),
     &                ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      common /chgbck/ qat(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)

      call evwad(coo,qat,iresid,irsnr,iatclr,iaton,iconn,ianz,
     &           ncalf,icalf,ityp,ipdbt)


      return
      end

      subroutine quwat(nwat)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/  coo(3,numat1),rzp(numat1),ianz(numat1),
     &                iaton(numat1),iatclr(numat1),iresid(numat1),
     &                ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call quwad(nwat,iresid,iconn,ianz)


      return
      end

      subroutine opthyd(lflp,lhis,lres,lwat)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/  coo(3,numat1),rzp(numat1),ianz(numat1),
     &                iaton(numat1),iatclr(numat1),iresid(numat1),
     &                ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)
      integer*2 ityp,ipdbt
      common /typbck/ ityp(numat1),ipdbt(numat1)
      parameter (numcal=50000)
      parameter (mxchai=50)
      parameter (mxheta=150)
      parameter (mxres=42)
      integer reson
      character*1 achain
      common /calf/ rphi(numcal),rpsi(numcal),
     &              icalf(6,numcal),ncalf,ianf(mxchai),islu(mxchai),
     &              nchain,iamino(numcal),ihet(mxheta),
     &              iclhet(mxheta),reson(numcal),issdon,
     &              icxp(numcal),icyp(numcal),
     &              iams(numcal),ihets(mxheta),ibck(4),
     &              isal(numcal),irsnr(numcal),lab(numcal),ihashb,
     &              ishoh,ision,achain(numcal)
      common /chgbck/ qat(numat1)
      dimension iupres(500)

      call opthdd(lflp,lhis,lres,lwat,
     &            iupres,nupres,irsnr,
     &            ncalf,icalf,coo,qat,iconn,ianz,iresid,iamino,
     &            ityp,ipdbt)

      return
      end

      subroutine gtfcor(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-z)

      idum = i1

      return
      end

      subroutine jdxwr
      implicit double precision (a-h,o-z)

      idum = i1

      return
      end

      subroutine chkcoo(kcoo,kcooh)
      implicit double precision (a-h,o-z)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /atcom/  coo(3,numat1),rzp(numat1),ianz(numat1),
     &                iaton(numat1),iatclr(numat1),iresid(numat1),
     &                ixp(numat1),iyp(numat1),iconn(mxcon+1,numat1)

      call chkcod(kcoo,kcooh,ianz,iconn)

      return
      end

      subroutine tautom
      implicit double precision (a-h,o-z)

      return
      end

      subroutine appchg
      implicit double precision (a-h,o-z)

      return
      end

      subroutine addchg
      implicit double precision (a-h,o-z)

      return
      end

      subroutine mopxyz(iun)
      implicit double precision (a-h,o-z)
      integer iun

      return
      end

      subroutine srti(n,iror,inat)
      implicit double precision (a-h,o-z)
      integer n,iror,inat

      return
      end

      subroutine nxtlin(str,istat)
      implicit double precision (a-h,o-z)
      character str*(*)
      
      call nxline(str,istat)

      return
      end

      subroutine redel(str,n)
      implicit double precision (a-h,o-z)
      character str*(*)
      
      call readel(str,n)

      return
      end

      subroutine rewmf()
      implicit double precision (a-h,o-z)
      parameter (maxmol=100)
      common /mfdatah/ mollin(maxmol)
      
      call rewmd(mollin)

      return
      end

      subroutine prsqmf()
      implicit double precision (a-h,o-z)
      parameter (maxmol=100)
      common /mfdatah/ mollin(maxmol)
      
      call prsqmd(mollin)

      return
      end

      subroutine prsomf()
      implicit double precision (a-h,o-z)
      parameter (maxmol=100)
      common /mfdatah/ mollin(maxmol)
      
      call prsomd(mollin)

      return
      end

      subroutine prsgmf(iopt)
      implicit double precision (a-h,o-z)
      parameter (maxmol=100)
      common /mfdatah/ mollin(maxmol)
      
      call prsqmd(iopt,mollin)

      return
      end

      subroutine parsmf()
      implicit double precision (a-h,o-z)
      parameter (maxmol=100)
      common /mfdatah/ mollin(maxmol)
      
      call parsmd(mollin)

      return
      end

      subroutine rewfil()
      implicit double precision (a-h,o-z)
      
      call rwfile()

      return
      end

      subroutine bckfil()
      implicit double precision (a-h,o-z)
      
      call bcfile()

      return
      end

!!!!!! End of the xwindow dummys !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine getxyd(igetxy,heat,iaddprv,
     &                  coo,ianz,iaton,iatclr,iconn,qat,
     &                  nat,norg,icent,nspg,ichx,nopr,ir,it,
     &                  xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,o-z), integer ( i-n)
      integer getlin
      character*137 str
      character*2 catom, catomt, tolowf,iel
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (maxsym=108)
      common /athlp/  iatoms, mxnat
      common /zmfrst/ ihaszm, nz, mxzat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /surf/   natorg,noscnd
      character*137 line
      common /curlin/ line
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /xyzopt/ ixyz,ipdbwh,iambch,nwramb,nions,ntota,nresi
      common /align/  vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /cllab/  iclon,iclpnt(4)
      common /cllhlp/ ico(3,8),icn(4,8),mcol(32)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /hlpxyz/ igsxyz

      integer*2 ir,it
      logical addcel,gnreal,dall
      dimension iel(maxsym),icel(8),rr(3,3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*),
     &          qat(*),ir(3,3,192),it(3,192)
      data iel/'bq',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x ','oo','oa','ob','oc','ab','bc','ac','zz'/

      igetxy = 1
      addcel = .false.
      dall = .false.
      ncell = 0
      toang = 0.52917706d0
      todeg = 45.0d0 / datan(1.0d0)
      igusxyz = 0
      icnv = 0

c get number of atoms

      if (ircus.eq.1) then
         call searchv(line,'***** BEGIN IRC',
     &      'TIME                Q          P',
     &      'KINETIC       POTENTIAL       TOTAL',
     &      '$data','units=angs',istat)
         if (istat.ne.0) then
            if (index(line,'units=angs').ne.0) then
               icnv = 1
               call searchq(line,'***** BEGIN IRC',
     &            'TIME                Q          P',
     &            'KINETIC       POTENTIAL       TOTAL',
     &            '$data',istat)
            endif
            if (istat.ne.0) then
               igust = 0
               if (index(line,'KINETIC').ne.0.or.
     &             index(line,'TIME').ne.0) then
                  igust = 1
                  call redel(line,1)
               endif
               if (icdex(line,'$data').ne.0) then
                  igusxyz = 1
               endif
            endif
         else
            goto 100
         endif
      else if (igsxyz.eq.1) then
         do while (.true.)
            if (getlin(0).eq.1) then
               ktype = nxtwrd(str,nstr,itype,rtype)
               if (ktype.eq.2) then
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) goto 110
               endif
            else
               goto 100
            endif
         end do
      else
         if (getlin(0).eq.1) then
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (ktype.eq.2) then
               if (iaddprv.eq.1) then
                   iscst = iatoms
                   nscnd = itype
                   natoms = nscnd
                   if (iatoms+nscnd.gt.mxnat) then
                       dall = .true.
                       goto 100
                   endif
               else
                   iscst = 0
                   iatoms = itype
                   natoms = iatoms
                   if (iatoms.gt.mxnat) then
                       dall = .true.
                       goto 100
                   endif
               endif
            else
               goto 100
            endif
         else
            goto 100
         endif
      endif

c get Heat of formation

      heat = 0.0d0
      heato = 0.0d0
      iefnd = 0
      if (igusxyz.eq.0) then
         if (getlin(1).eq.1) then
             do while(.true.)
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ircus.eq.1) then
                   if (ktype.eq.1) then
                       if (nstr.eq.2) then
                          if (str.eq.'E=') iefnd = 1
                       endif
                   endif
                endif
                if (ktype.eq.3) then
                   heato = heat
                   heat = rtype
                endif
                if (ircus.eq.1) then
                   if (ktype.eq.0.or.(ktype.eq.3.and.iefnd.eq.1)) then
                      if (igust.eq.1) heat = heato
                      goto 110
                   endif
                else
                   if (ktype.eq.0.or.ktype.eq.3) goto 110
                endif
             end do
         else
            goto 100
         endif
      else
         call redel(line,1)
      endif
      
110   continue

      if (ircus.eq.1.or.igsxyz.eq.1) then
         if (ircus.eq.1) then
            if (igust.eq.1) then
               call search(line,'CARTESIAN COORDINATES',istat)
            else
               call redel(line,1)
            endif
         endif
         iatoms = 0
         do while (getlin(0).eq.1)

            if (ircus.eq.1) then
               if (line(1:4).eq.' ---') goto 120
               if (igusxyz.ne.0) then
                  if (icdex(line,'$end').ne.0) goto 120
               endif
            endif
            ktype = nxtwrd(str,nstr,itype,rtype)
            if (igsxyz.eq.1) then
               if (ktype.eq.0) goto 120
               if (ktype.eq.1) then
                 iatmp = 0
                 if (nstr.eq.1) then
                    catomt(1:1) = str(1:1)
                    catomt(2:2) = ' '
                 else
                    catomt = str(1:2)
                 endif
                 catom = tolowf(catomt)
                 do j=1,maxsym
                    if (catom .eq. iel(j)) iatmp = j - 1
                 end do
                 if (catom.eq.'xx'.or.catom.eq.'bq') iatmp = 99
                 if (iatmp.le.0.or.iatmp.gt.maxsym-1) goto 100
                 ianz(iatoms+1) = iatmp
                 icnv = 1
               endif
            else
               if (ktype.eq.1) then
                  if (nstr.ge.4) then
                     if (str(1:4).eq.'****') goto 120
                     if (str(1:4).eq.'MASS') goto 120
                  endif
               endif
            endif
            iatoms = iatoms + 1

            if (ircus.eq.1) then
                 if (igust.eq.0.or.igusxyz.eq.1) 
     &                ktype = nxtwrd(str,nstr,itype,rtype)

                 if (ktype.eq.3) then
                    ianz(iatoms) = int(rtype)
                 else
                    goto 100
                 endif
            endif

            if (.not.gnreal(coo(1,iatoms),3,.false.)) goto 100
            if (icnv.eq.1) then
               do i=1,3
                  coo(i,iatoms) = coo(i,iatoms) / toang
               end do
            endif
            
         end do

120      continue
         call bckfil
         call doconn
         ihaszm = 0
         return
      endif

      if (natoms.eq.0) goto 100

      do iat=iscst+1,iscst+natoms
         if (getlin(0).eq.1) then
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.1) then
                 iatmp = 0
                 if (nstr.eq.1) then
                    catomt(1:1) = str(1:1)
                    catomt(2:2) = ' '
                 else
                    catomt = str(1:2)
                 endif
                 catom = tolowf(catomt)
                 do j=1,maxsym
                    if (catom .eq. iel(j)) iatmp = j - 1
                 end do
                 if (catom.eq.'xx'.or.catom.eq.'bq') iatmp = 99
                 if (iatmp.le.0.or.iatmp.gt.maxsym-1) goto 100
                 if (iatmp.eq.106.and.ncell.eq.0) iatmp = 89
                 if (iatmp.gt.99) then
                    icel(iatmp-99) = iat
                    addcel = .true.
                    ncell = ncell + 1
                 else
                    if (addcel) then
                        call inferr('Cell points before atoms',1)
                        goto 100
                    endif
                 endif
                 ianz(iat) = iatmp
           else
              goto 100
           endif
           do i=1,4
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) then
                 if (i.eq.4) then
                    qat(iat) = rtype
                    ihasq = 1
                 else
                    coo(i,iat) = rtype / toang
                 endif
              elseif (ktype.eq.2.and.i.ne.4) then
                 coo(i,iat) = dble(itype) / toang
              else
                 if (i.ne.4) goto 100
              endif
           end do
        else
          goto 100
        endif
      end do

      iatoms = natoms + iscst

c look for cell data

      if (getlin(0).ne.1) goto 130
      if (getlin(0).ne.1) then
         call bckfil
         goto 130
      endif

      if (icdex(line,'Unit cell').eq.0) then

         call bckfil
         call bckfil

      else

         do i=1,3
           if (getlin(0).eq.1) then
              if (.not.gnreal(rr(1,i),3,.false.)) goto 100
           endif
         end do
         nspg = 1
         a = vlen(rr(1,1))
         b = vlen(rr(1,2))
         c = vlen(rr(1,3))
         call impsc(rr(1,2),rr(1,3),csa)
         call impsc(rr(1,1),rr(1,3),csb)
         call impsc(rr(1,1),rr(1,2),csc)
         alpha = dacos(csa)*todeg
         beta = dacos(csb)*todeg
         gamma = dacos(csc)*todeg
         call prcell(nspg,a,b,c,alpha,beta,gamma)
         call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,1)
         call cprot(nspg,nopr,icent,ir,it,.false.)
         call prop(nopr,ir,it)
         call cpmol(nat,norg,a,b,c,alpha,beta,gamma,
     &              coo,ianz,iatclr,iconn)

         iftyp = 6
         ichx = 1
         call fdat(1,0,0,0,0,0)

      endif

130   continue

      if (iaddprv.eq.1) then
         do i=iscst+1,iscst+nscnd
             do j=1,3
                iaton(i) = 1
             end do
         end do
      endif

      if (addcel) iatoms = iatoms - 8
      if (iaddprv.eq.1) then
         call convar(coo,iconn,ianz,nscnd,iscst)
      else
         call cooxyz(ianz,iatoms)
         call doconn
      endif
      if (addcel) then
         natorg = iatoms
         iclon = 1
         iclpnt(1) = icel(1)
         iclpnt(2) = icel(2)
         iclpnt(3) = icel(3)
         iclpnt(4) = icel(4)
         do i=1,8
            l = icel(i)
            iconn(1,l) = icn(1,i)
            do j=2,4
               iconn(j,l) = iatoms + icn(j,i)
            end do
            ianz(l) = 100
            iatclr(l) = 11
         end do
         iatoms = iatoms + 8
      endif

      if (iaddprv.eq.0) ihaszm = 0

      return

100   if (dall) then
         call rewfil
         iatoms = iscst
         igetxy = -1
         return
      endif
      igetxy = 0
      return
      end

      subroutine aln2md(iopt,istat,
     &                  coo,ianz,iaton,iatclr,iresid)
      implicit double precision (a-h,o-z)
      logical fndsnd,ocen
      parameter (mxpsav=100)
      common /athlp/ iatoms, mxnat
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      common /cllmat/rrx(3),rry(3),rrz(3),tr(3),tz(3),tzorg(3),itz
      common /cllsav/rdum(12,mxpsav),npsav
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      dimension vec1(3),vec2(3),vec3(3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*)

      istat = 1
      fndsnd = .false.
      ocen = .true.

      ialtyp = iopt

      if (ialtyp.eq.0) then
         call getxyz(igetxy,heat,1)
         if (igetxy.eq.1) then
             fndsnd = .true.
         else
             fndsnd = .false.
         endif
         if (.not.fndsnd) then
             call rdsrf(iun2,istats,iesp,1,0)
             if (istats.eq.1) fndsnd = .true.
         endif
         if (.not.fndsnd) then
            print*,'This is not an xyz or molden surface file !'
            istat = 0
            return
         endif
      else if (ialtyp.eq.1) then
         ioatms = iatoms
         do i=1,iatoms
            if (iresid(i).le.0.and.iresid(i).ge.-3) then
               ioatms = i - 1
               goto 3000
            endif
         end do
3000     namols = namols + 1
         iatoms = ioatms
         iscst = ioatms
         
         call pdbstd(istat,1,1)
         if (istat.eq.-1) then
            call allcoo(50000,0)
            call pdbstd(istat,1,1)
         endif
         if (istat.eq.1) then
            fndsnd = .true.
            call xyzcoo(0,1,1)
c
c commented out calfa because it added hydrogens to structure1 in 
c the space of structure 2: it SHOULD NOT do that
c            call calfa(istat,1,1,ioatms+1,1,1)
c
            call dohcon(2)
            ocen = .false.
            nscnd = iatoms - ioatms
         else
            istat = 0
            print*,'This is not a valid PDB file !'
            return
         endif
      else if (ialtyp.eq.2) then
         namols = namols + 1
         fndsnd = .true.
         ialtyp = 1
         ocen = .false.
      else if (ialtyp.eq.3) then
         namols = namols + 1
         fndsnd = .true.
         ialtyp = 0
      endif

      if (fndsnd) then

         call cntvec(vec1,coo,ianz,iscst)
         call cntvec(vec2,coo(1,iscst+1),ianz(iscst+1),nscnd)

         do i=1,3
             vec3(i) = vec1(i) - vec2(i) 
         end do

         if (ialtyp.ne.1) then

            do i=1,nscnd
               call trcoo(vec3,coo(1,iscst+i))
            end do

            do i=1,3
               tr(i) = vec1(i)
               tz(i) = vec1(i)
            end do

         else

c set center of mol2  (tr)
c set pos mol2 to center of mol1 (tz)

            do i=1,3
               tr(i) = vec2(i)
               if (iocnt.eq.1) then
                  tz(i) = vec3(i)
               else
                  tz(i) = 0.0d0
               endif
            end do
c
c           copy coordinates of second molecule to the top of the
c           coordinate array
c
            nstrt = mxnat-nscnd
            do i=1,nscnd
               do j=1,3
                  coo(j,nstrt+i) = coo(j,iscst+i)
               end do
               ianz(nstrt+i) = ianz(iscst+i)
            end do
         endif

         if (ocen) call docent


         do i=1,iscst
             if (ianz(i).ne.100) then
                iatclr(i) = 1
             endif
         end do
         irs = iresid(iscst+1)
         if (irs.le.0.and.irs.ge.-3) irs = -4
         do i=iscst+1,iscst+nscnd
             iatclr(i) = 5
             iaton(i) = 1
c             iresid(i) = -4
             if (irs.eq.-4) iresid(i) = irs
         end do

         if (ialtyp.eq.1) then
c vec1 is just a dummy in this case, doesnt do anything
c            call inirot
            call clini
            call alnrot(vec1,1)
            call ligzmt
            call pmfass(0,0)
            npsav = 0
         endif

         call mtinv3
         call rarbxi
         call rarbyi
         call rarbzi

      endif

      return
      end

      subroutine alnrod(vec,irot,coo)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      dimension vec(3),tzt(3)
      dimension coo(3,*)

      nstrt = mxnat-nscnd

      if (irot.eq.1) then

c do rotation

         if (ialtyp.eq.1) then

            do i=1,nscnd
               x = coo(1,nstrt+i)
               y = coo(2,nstrt+i)
               z = coo(3,nstrt+i)
               coo(1,iscst+i) = 
     &           (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)+t(1)
               coo(2,iscst+i) = 
     &           (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)+t(2)
               coo(3,iscst+i) = 
     &           (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)+t(3)
               do j=1,3
                  coo(j,iscst+i) = coo(j,iscst+i) + tz(j)
               end do
            end do

         else

            do i=iscst+1,iscst+nscnd
               x = coo(1,i)
               y = coo(2,i)
               z = coo(3,i)
               coo(1,i) = 
     &     (x-tz(1))*rx(1)+(y-tz(2))*rx(2)+(z-tz(3))*rx(3)+tz(1)
               coo(2,i) = 
     &     (x-tz(1))*ry(1)+(y-tz(2))*ry(2)+(z-tz(3))*ry(3)+tz(2)
               coo(3,i) = 
     &     (x-tz(1))*rz(1)+(y-tz(2))*rz(2)+(z-tz(3))*rz(3)+tz(3)
            end do

         endif

      else

c do translation

         if (ialtyp.eq.1) then
            do j=1,3
               tz(j) = tz(j) - vec(j)
            end do
            do i=1,nscnd
               x = coo(1,nstrt+i)
               y = coo(2,nstrt+i)
               z = coo(3,nstrt+i)
               coo(1,iscst+i) = 
     &           (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)+t(1)
               coo(2,iscst+i) = 
     &           (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)+t(2)
               coo(3,iscst+i) = 
     &           (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)+t(3)
               do j=1,3
                  coo(j,iscst+i) = coo(j,iscst+i) + tz(j)
               end do
            end do
            do j=1,3
               tzt(j) = tzorg(j) - tz(j)
            end do
            vl = vlen(tzt)
            if (vl.gt.1.0) call updres
         else
            do i=iscst+1,iscst+nscnd
               do j=1,3
                  coo(j,i) = coo(j,i) - vec(j)
               end do
            end do
c            do j=1,3
c               t(j) = t(j) + vec(j)
c            end do
            do j=1,3
               tz(j) = tz(j) - vec(j)
            end do
         endif

      endif

      return
      end

      subroutine alnsorg(iatom,coo)
      implicit double precision (a-h,o-z)
      common /athlp/ iatoms, mxnat
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      dimension coo(3,*)

      nstrt = mxnat-nscnd

      if (ialtyp.eq.1) then

         if (iatom.le.iscst) then
             call inferr('This is not an atom of docked molecule !',0)
             return
         endif
         im = iatom - iscst

         x = coo(1,nstrt+im)
         y = coo(2,nstrt+im)
         z = coo(3,nstrt+im)

         xn = 
     &      (x-t(1))*rx(1)+(y-t(2))*rx(2)+(z-t(3))*rx(3)-(x-t(1))
         yn = 
     &      (x-t(1))*ry(1)+(y-t(2))*ry(2)+(z-t(3))*ry(3)-(y-t(2))
         zn = 
     &      (x-t(1))*rz(1)+(y-t(2))*rz(2)+(z-t(3))*rz(3)-(z-t(3))

         t(1) = x
         t(2) = y
         t(3) = z

         tz(1) = tz(1) + xn
         tz(2) = tz(2) + yn
         tz(3) = tz(3) + zn

      else

         do i=1,3
c            t(i) = coo(i,iatom)
            tz(i) = coo(i,iatom)
         end do

      endif


      return
      end

      subroutine alnsav()
      implicit double precision (a-h,o-z)
      parameter (mxpsav=100)
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /cllsav/rxs(3,mxpsav),rys(3,mxpsav),rzs(3,mxpsav),
     &               tzs(3,mxpsav),npsav

      if (npsav.lt.mxpsav) then
         npsav = npsav + 1

         do j=1,3
            rxs(j,npsav) = rx(j)
            rys(j,npsav) = ry(j)
            rzs(j,npsav) = rz(j)
            tzs(j,npsav) = tz(j)
         end do

      endif

      return
      end

      subroutine alnwrd(coo,ianz)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      common /athlp/ iatoms, mxnat
      parameter (mxpsav=100)
      common /cllmat/rx(3),ry(3),rz(3),t(3),tz(3),tzorg(3),itz
      common /cllsav/rxs(3,mxpsav),rys(3,mxpsav),rzs(3,mxpsav),
     &               tzs(3,mxpsav),npsav
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      character*2 ggstr,tocapf, elemnt
      common /elem/elemnt(mxel)
      logical opfil
      dimension xyzt(3)
      dimension coo(3,*),ianz(*)

      toang = 0.52917706d0
      iun = 46
      ires = 1
      nstrt = mxnat-nscnd

      do l=1,npsav
         if (opfil(iun,'pose.'//ggstr(l-1),7,1,0,0)) then
            write(iun,'(a)') 'HEADER'
            do i=1,nscnd
               x = coo(1,nstrt+i)
               y = coo(2,nstrt+i)
               z = coo(3,nstrt+i)
               xyzt(1) = (x-t(1))*rxs(1,l)+(y-t(2))*rxs(2,l)+
     &                   (z-t(3))*rxs(3,l)+t(1)
               xyzt(2) = (x-t(1))*rys(1,l)+(y-t(2))*rys(2,l)+
     &                   (z-t(3))*rys(3,l)+t(2)
               xyzt(3) = (x-t(1))*rzs(1,l)+(y-t(2))*rzs(2,l)+
     &                   (z-t(3))*rzs(3,l)+t(3)
               do j=1,3
                  xyzt(j) = xyzt(j) + tzs(j,l)
               end do
               ian = ianz(nstrt+i)
               write(iun,'(a6,i5,1x,a4,1x,i3,2x,i4,4x,3f8.3)')
     &            'HETATM',i,tocapf(elemnt(ian))//'  ',
     &             ires,ires,(xyzt(j)*toang,j=1,3)
            end do
            close(iun)
         endif
      end do

      return
      end

      subroutine alnsed(isel,coo)
      implicit double precision (a-h,o-z)
      common /align/ vecs(3,3),nscnd,iscst,ialtyp,iocnt
      integer dolabs,fancy,persp,shade,atcol,fyesno,backb
      common /displ/ fancy,shade,atcol,dolabs,persp,irtcel,
     &               ifd,fyesno,backb,logo
      dimension isel(6),isel1(3),isel2(3),vec(3),coo(3,*)

      do i=1,3
         j = isel((i-1)*2+1)
         k = isel((i-1)*2+2)
         if (j.le.iscst.and.k.gt.iscst) then
            isel1(i) = j
            isel2(i) = k - iscst
         elseif (k.le.iscst.and.j.gt.iscst) then
            isel1(i) = k
            isel2(i) = j - iscst
            if (i.eq.1) then
                idum = isel(1)
                isel(1) = isel(2)
                isel(2) = idum
            endif
         else
            call inferr('atom pair of same molecule ',0)
            return
         endif
      end do

      do i=1,3
          vec(i) = coo(i,isel(1)) - coo(i,isel(2))
      end do

      do i=1,nscnd
         call trcoo(vec,coo(1,iscst+i))
      end do
   
      call alntwo(coo,isel1,coo(1,iscst+1),nscnd,isel2)

      call setorg(isel(2))

      irtcel = 0

      return
      end

      subroutine getchd(igetca,qat)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      integer getlin
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      character*137 str
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      character*137 line
      common /curlin/ line
      logical gnreal
      dimension r(3),qat(*)

      igetca = 1
      if (getlin(0).eq.1) then
         ktype = nxtwrd(str,nstr,itype,rtype)
         if (ktype.eq.2) then
            iatoms = itype
            if (iatoms.ne.natoms) goto 100
         else
            goto 100
         endif
      else
         goto 100
      endif
      call redel(line,1)

      do i=1,iatoms
         if (getlin(0).eq.1) then
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.ne.1) goto 100
           if (.not.gnreal(r,3,.false.)) goto 100
           ktype = nxtwrd(str,nstr,itype,rtype)
           if (ktype.eq.3) then
               qat(i) = rtype
           else
               goto 100
           endif
         endif
      end do

      ihasq = 1

      return
100   igetca = 0
      return
      end

      double precision function deter(r)
      implicit double precision (a-h,o-z)
      dimension r(3,3)
c  calculate the determinant of a 3x3 matrix

      deter = r(1,1)*r(2,2)*r(3,3) - r(1,3)*r(2,2)*r(3,1) +
     &        r(2,1)*r(3,2)*r(1,3) - r(2,3)*r(3,2)*r(1,1) +
     &        r(3,1)*r(1,2)*r(2,3) - r(3,3)*r(1,2)*r(2,1)
      return
      end

      subroutine invmat3(r,ri)
      implicit double precision (a-h,o-z)
      dimension r(3,3),ri(3,3)

c  invert matrix M

      det = deter(r)
      ri(1,1) = (r(2,2)*r(3,3)-r(2,3)*r(3,2)) / det
      ri(1,2) = (r(1,3)*r(3,2)-r(1,2)*r(3,3)) / det
      ri(1,3) = (r(1,2)*r(2,3)-r(1,3)*r(2,2)) / det
      ri(2,1) = (r(2,3)*r(3,1)-r(2,1)*r(3,3)) / det
      ri(2,2) = (r(1,1)*r(3,3)-r(1,3)*r(3,1)) / det
      ri(2,3) = (r(1,3)*r(2,1)-r(1,1)*r(2,3)) / det
      ri(3,1) = (r(2,1)*r(3,2)-r(2,2)*r(3,1)) / det
      ri(3,2) = (r(1,2)*r(3,1)-r(1,1)*r(3,2)) / det
      ri(3,3) = (r(1,1)*r(2,2)-r(1,2)*r(2,1)) / det

      return
      end

      subroutine getmod(igetmo,iadd,coo,qat,ianz,iaton,iconn,iresid)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      parameter (mxcon=10)
      parameter (maxsym=108)
      character*80 title
      character*2 catom, catomt, tolowf,iel
      character*5 vers
      common /athlp/ iatoms, mxnat
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      character*137 str
      character*137 line
      common /curlin/ line
      character*137 cas,nsc
      common /regis/  cas,nsc
      common /align/  vecs(3,3),nscnd,iscst,ialtyp,iocnt
      logical  valenc,bonds,ovrlap,atomic,doori,dolap,doelf
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /totchg/ itot
      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      logical ocorin
      dimension iel(maxsym),ichg(8),iqtmp(8),iresid(*)
      dimension coo(3,*),ianz(*),qat(*),iaton(*),iconn(mxcon+1,*)
      data iel/'lp',
     &         'h ', 'he',
     &         'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 'ne',
     &         'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar',
     &         'k ', 'ca',
     &                     'sc', 'ti', 'v ', 'cr', 'mn',
     &                     'fe', 'co', 'ni', 'cu', 'zn',
     &                     'ga', 'ge', 'as', 'se', 'br', 'kr',
     & 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag','cd',
     & 'in','sn','sb','te','i ','xe','cs','ba','la','ce','pr','nd',
     & 'pm','sm','eu','gd','tb','dy','ho','er','tm','yb','lu','hf',
     & 'ta','w ','re','os','ir','pt','au','hg','tl','pb','bi','po',
     & 'at','rn','fr','ra','ac','th','pa','u ','np','pu','am','cm',
     & 'bk','cf','x ','oo','oa','ob','oc','ab','bc','ac','zz'/

      igetmo = 1
      ocorin = .false.
      itot = 0

      if (iadd.eq.0) iatoms = 0
      nbnds = 0

      toang = 0.52917706d0

      if (idebug.eq.1) print*,'subroutine getmod'

      call rewmf

c get title line

      call nxtlin(line,jstat)
      if (icdex(line,'[Molden Format]').ne.0) goto 100
      if (icdex(line,'%begin%input').ne.0) goto 100
      if (icdex(line,'Entering Gaussian System').ne.0) goto 100
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      read (line,'(a)',end=100,err=100) title
      if (title(1:4).eq.'$$$$') then
         call redel(line,1)
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 100
         read (line,'(a)',end=100,err=100) title
      endif

      call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100

      call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      if (line(1:6).eq.'Corina') ocorin = .true.

      call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 100
      if (linlen(line).ge.39) then
         read (line,'(i3,i3,6x,i1,21x,a5)',end=100,err=100) 
     &   itmp,nbnds,ister,vers
         if (iadd.eq.1) then
c iscst set in xwin.c
            iatoms = iscst
            nscnd = itmp
            natoms = nscnd
            
         else
            iscst = 0
            iatoms = itmp
            natoms = iatoms
         endif
         if (vers.ne.'V2000'.and.vers.ne.'V3000') goto 100
      else
         if (ocorin) then
            if (linlen(line).ge.6) then
               read (line,'(i3,i3)',end=100,err=100) 
     &               itmp,nbnds
               if (iadd.eq.1) then
                  iatoms = iscst
                  nscnd = itmp
                  natoms = nscnd
               else
                  iscst = 0
                  iatoms = itmp
                  natoms = iatoms
               endif
               goto 100
            else
               goto 100
            endif
         else
            goto 100
         endif
      endif

      call numhet(nhmol)
      nhmol = nhmol + 1
      nhmol = -nhmol

      do i=iscst+1,mxnat
         qat(i) = 0.0d0
      end do
      ichgrec = 0

      do i=iscst+1,iscst+natoms
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 100
         read (line,'(3f10.4,1x,a2,6x,i3)',err=100) 
     &       (coo(j,i),j=1,3),catomt,itchg
         do j=1,3
            coo(j,i) = coo(j,i) / toang
         end do
         iatmp = 0
         catom = tolowf(catomt)
         do j=1,maxsym
            if (catom .eq. iel(j)) iatmp = j - 1
         end do
         if (catom.eq.'lp') iatmp = 99
         if (iatmp.le.0.or.iatmp.gt.maxsym-1) goto 100
         ianz(i) = iatmp
         qat(i) = dble(itchg)
         iconn(1,i) = 0
         iresid(i) = nhmol
      end do

      do i=1,nbnds
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 100
         read (line,'(3i3)',end=100,err=100) 
     &      iat1,iat2,ibndtyp
         if (iconn(1,iscst+iat1).lt.mxcon) then
            iconn(1,iscst+iat1) = iconn(1,iscst+iat1) + 1
            iconn(1+iconn(1,iscst+iat1),iscst+iat1) = iscst+iat2
         endif
         if (iconn(1,iscst+iat2).lt.mxcon) then
            iconn(1,iscst+iat2) = iconn(1,iscst+iat2) + 1
            iconn(1+iconn(1,iscst+iat2),iscst+iat2) = iscst+iat1
         endif
      end do

      do while (.true.) 
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200
         if (linlen(line).ge.1) then
            if (line(1:6).eq.'M  CHG') then
               ihasq = 1
               if (ichgrec.eq.0) then
                  do i=iscst+1,iscst+natoms
                     qat(i) = 0.0d0
                  end do
                  ichgrec = 1
               endif
               nchg = 0
               itot = 0
               read(line,'(6x,i3)') nchg
               read(line,'(9x,8(1x,i3,1x,i3))') 
     &               (ichg(i),iqtmp(i),i=1,nchg)
               do i=1,nchg
                 qat(iscst+ichg(i)) = dble(iqtmp(i))
                 itot = itot + iqtmp(i)
               end do
            else if (line(1:4).eq.'$$$$') then
               goto 150
c            else if (line(1:6).eq.'M  END') then
c               goto 150
            else
               if (index(line,'<NSC>').ne.0) then
                  call nxtlin(line,jstat)
                  if (jstat.eq.1) goto 200
                  if (jstat.eq.2) goto 100
                  read (line,'(a)',end=200,err=100) nsc
               endif
               if (index(line,'<CAS_RN>').ne.0) then
                  call nxtlin(line,jstat)
                  if (jstat.eq.1) goto 200
                  if (jstat.eq.2) goto 100
                  read (line,'(a)',end=200,err=100) cas
               endif

               if (index(line,'<PUBCHEM_MMFF94_PARTIAL_CHARGES>').ne.0) 
     &         then
                  call nxtlin(line,jstat)
                  if (jstat.eq.1) goto 200
                  if (jstat.eq.2) goto 100
                  ktype = nxtwrd(str,nstr,itype,rtype)
                  if (ktype.eq.2) then
                     do i=iscst+1,iscst+itmp
                        qat(i) = 0.0d0
                     end do
                     jatoms = itype
                     do i=iscst+1,iscst+jatoms
                         call nxtlin(line,jstat)
                         if (jstat.eq.1) goto 200
                         if (jstat.eq.2) goto 100

                         ktype = nxtwrd(str,nstr,itype,rtype)
                         if (ktype.eq.2) then
                            iat = itype
                            if (iat.lt.1.or.iat.gt.iscst+natoms) then
                               print*,
     &                     "Atom index < 0 or > number of atoms"
                               goto 160
                            endif
                         else
                            goto 160
                         endif

                         ktype = nxtwrd(str,nstr,itype,rtype)
                         if (ktype.eq.2) then
                            qat(iscst+iat) = dble(itype)
                         endif
                         if (ktype.eq.3) then
                            qat(iscst+iat) = rtype
                         endif

                     end do
                     ihasq = 1
                     goto 150
                  endif
               endif
160            continue

            endif
         endif
      end do

150   if (iadd.eq.1) then
         do i=iscst+1,iscst+nscnd
             iaton(i) = 1
         end do
         call convar(coo,iconn,ianz,nscnd,iscst)
         ihaszm = 0
         iatoms = iscst+nscnd
         if (idebug.eq.1) write(*,"(a)") line
         
      else
         call cooxyz(ianz,iatoms)
         call doconn
         if (idebug.eq.1) write(*,"(a)") line
      endif

      if (idebug.eq.1) write(*,"(a)") line
200   continue
      ihaszm = 0

      return
100   igetmo = 0
      if (idebug.eq.1) write(*,"(a)") line
      return
      end

      subroutine sdfsep(iun)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      write(iun,'(a)') '$$$$'

      return
      end

      subroutine outmod(iun,coo,ianz,iconn)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxcon=10)
      parameter (maxsym=108)
      parameter (mxel=100)
      character*2 elemnt,tocapf
      character*3 atom,atomt
      common /athlp/  iatoms, mxnat
      common /elem/   elemnt(mxel)
      character*137 line
      common /curlin/ line
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension coo(3,*),ianz(*),iconn(mxcon+1,*)
      dimension vec1(3),vec2(3)

      toang = 0.52917706d0
      natoms = iatoms
      nbnds = 0
      idochg = 0

      do i=1,natoms
         do j=1,iconn(1,i)
            if (iconn(1+j,i).gt.0) then
               if (iconn(1+j,i).gt.i) nbnds = nbnds + 1
            endif
         end do
      end do

      write(iun,'(a)') ' '
      write(iun,'(a)') '  -MOLDEN-'
      write(iun,'(a)') 'Molden generated mol file'
      write(iun,'(i3,i3,a)') natoms,nbnds,
     &          '  0  0  0  0  0  0  0  0999 V2000'

      do i=1,natoms
         atomt = '   '
         atomt(1:2) = tocapf(elemnt(ianz(i)))
         call leftj(atomt,atom)
         write(iun,'(3f10.4,a1,a3,a)') (coo(j,i)*toang,j=1,3),' ',
     &      atom, ' 0  0  0  0  0  0  0  0  0  0  0  0'
      end do
    
      do i=1,natoms
         do j=1,iconn(1,i)
            k = iconn(1+j,i)
            if (k.gt.0) then
               if (k.gt.i) then
                  ibt = ibtyp(i,k,idochg,0,ianz)
c                  call inplane(i,k,inp1,vec1)
c                  call inplane(k,i,inp2,vec2)
                  call inpland(i,k,inp1,vec1,coo,iconn,ianz)
                  call inpland(k,i,inp2,vec2,coo,iconn,ianz)
                  if (ibt.eq.2.and.
     &                (inp1.eq.0.or.inp2.eq.0)) ibt = 1
                  if (ibt.eq.2.and.
     &                (inp1.eq.1.and.inp2.eq.1)) then
                      rimp = 0.0
                      do ii=1,3
                         rimp = rimp + vec1(ii)*vec2(ii)
                      end do
                      if ((1.0 - dabs(rimp)).gt.0.1) ibt = 1
                  endif
                  write(iun,'(3i3,a)') i,k,ibt,
     &               '  0  0  0  0'
               endif
            endif
         end do
      end do

      write(iun,'(a)') 'M  END'

      return
      end

      subroutine xyzcod(idocopy,idoconv,ioadd,
     &                  ianz,coo)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /athlp/  iatoms, mxnat
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /surf/   natorg,noscnd
      dimension coo(3,*),ianz(*)

      toang = 0.52917706d0

      if (idocopy.eq.1) iatoms = natoms

      noff = 1
      if (ioadd.eq.1) noff = natorg + 1

      do i=noff,iatoms
         if (idocopy.eq.1) ianz(i) = nat(i)
         do j=1,3
           if (idoconv.eq.1) then
              if (idocopy.eq.1) then
                 coo(j,i) = xyz(j,i) / toang
              else
                 coo(j,i) = coo(j,i) / toang
              endif
           else
              coo(j,i) = xyz(j,i)
           endif
         end do
      end do

      if (ioadd.eq.1) natorg = 0

      return
      end

      subroutine cooxyz(ianz,iatoms)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension ianz(*)
      
      natoms = iatoms
      if (natoms.gt.numatm) natoms = numatm

      do i=1,natoms
         nat(i) = ianz(i)
      end do

      return
      end

      subroutine rdgdd(idebug,ibefo,istatio,ioxyz,irtype,istats,
     &                 vectrs,vectrb,focc,focb,eiga,eigb,
     &                 nocc,nocb,ncols,ncolb,coo,ianz)

c THIS IS REALLY rdgam

      implicit double precision (a-h,o-z), integer (i-n)
      common /athlp/ iatoms, mxnat
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      parameter (mxel=100)
      character*2 elemnt
      common /elem/elemnt(mxel)
      character*137 line
      logical local
      real eiga,eigb
      dimension vectrs(*),vectrb(*),focc(*),focb(*),eiga(*),eigb(*)
      dimension coo(3,*),ianz(*)

      istats = 1
      ioxyz = 0
      istatio = 0
cd     write(iun3,'(a)')'enter subroutine rdgam'

      irtype = 0
      call search(line,'run type',istat)
      if (istat.eq.0) goto 1000
      call tocap(line,136)
      if (index(line,'SCF').ne.0)      irtype = 1
      if (index(line,'OPTIMIZE').ne.0) irtype = 2
      if (index(line,'OPTXYZ').ne.0)   irtype = 3
      if (index(line,'FORCE').ne.0)    irtype = 4
      if (index(line,'HESSIAN').ne.0)  irtype = 4
      call rewfil

      if (ibefo.eq.1.or.irtype.eq.1.or.irtype.eq.4) goto 17
c
c======= read nuclear coordinates ================
c
      ncnt = 0
      call rewfil
111   continue
         call search(line,'nuclear coordinates',istat)
         if (istat.eq.0) then
            if (ioxyz.eq.1) then
               call search(line,'molecular orbitals',istat)
               if (istat.eq.0) ncnt = 0
            endif
            if ((ioxyz.eq.1.and.ncnt.gt.1).or.
     &          (ioxyz.eq.0.and.ncnt.ge.1)) then
               istatio = 1
               goto 12
            else
               goto 17
            endif
         endif
         if (ncnt.eq.0.and.line(2:6).eq.'point') ioxyz = 1
         ncnt = ncnt + 1
            
         call redel(line,2)
         call rdgeom(numatm,xyz,nat,natoms,istat)
      goto 111

17    istatio = 0
      call search(line,'input z-matrix',istat)
      if (istat.eq.0) ioxyz = 1
      if (ioxyz.eq.0) then
         call redel(line,1)
         call search(line,'z-matrix',istat)
         if (istat.eq.0) goto 1000
         call redel(line,2)
         call convzmat(coo,ianz,iatoms,0,1,0)
      endif
      call rdmolg(istat)
      if (istat.eq.0) goto 1000

12    continue
      if (istatio.eq.1) then
         call inferr('Using Density of stationary point',0)
      else
         call inferr('Using Density of first point',0)
      endif

      call rdbasg(idebug,.false.,istat)
      if (istat.eq.0) goto 1000
c
c============ read norbs nelecs ==================
c
      do i=1,norbs
         focc(i) = 0.0d0
         eiga(i) = 0.0d0
         focb(i) = 0.0d0
         eigb(i) = 0.0d0
      end do
c      call search(line,'total number of basis func',istat)
      call search(line,'basis functions',istat)
      if (index(line,'cartesian').ne.0) then
         read(line,'(45x,i5)',err=1000) norbs
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
         read(line,'(45x,i5)',err=1000) nelecs
      else
         read(line,'(38x,i5)',err=1000) norbs
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
         read(line,'(38x,i5)',err=1000) nelecs
      endif
      if (norbs .gt. mxorb) then
         call inferr('Exceeding MaxNum of Orbitals!',1)
         goto 1000
      endif
      call searchd(line,'scf type','scf mode',istat)
      if (index(line,'uhf').ne.0) goto 7000
c
c     read occupancies
c
      if (index(line,'casscf').ne.0.and.
     &    (irtype.eq.1.or.irtype.eq.4)) then
         call search(line,'active space',istat)
         if (istat.ne.0) then
            read(line,'(24x,i3,3x,i3)',err=1000)ncore,nact
            nact=nact-ncore
         endif
         call search(line,
     &        'active orbitals to diagonalise density matrix',istat)
         if (istat.ne.0) then
            call redel(line,6)
            call rdcasocc(ncore,nact,focc,nocc,istat)
            if (istat.eq.0) then
               ncols = norbs
               call rewfil
            else
               ncols = min0(nocc+12,norbs)
            endif
         else
            ncols = norbs
            call inferr('Missing occupation numbers use CANON 1',1)
         endif
      else
         call rdocc(0,norbs,focc,eiga,nocc,istat)
         if (istat.eq.0) then
            ncols = norbs
            call rewfil
         else
            ncols = min0(nocc+5,norbs)
         endif
      endif
c
c     read vectors
c
      local = .false.
      call searchq(line,'gvb natural orbital','eigenvectors',
     &             'alpha spin lmo',
     &             'casscf mos (canonicalised)',istat)

      if (istat.eq.0) then
         if (istatio.eq.1) then
            call rewfil
         else
            goto 1000
         endif
      else
         if (index(line,'gvb natural orbital').ne.0) then
           call redel(line,11)
         else if (index(line,'alpha spin lmo').ne.0) then
           call redel(line,5)
           local = .true.
         else if (index(line,'casscf mos (canonicalised)').ne.0) then
           call redel(line,4)
           local = .true.
         else
           call redel(line,9)
         endif
         call readvv(vectrs,norbs,nocc,local)
         if (ibefo.eq.1) then
cd           write(iun3,'(a)')'leave subroutine rdgam'
            return
         endif
      endif
c
c======= try for the vectors of an optimise or saddle job====
c
6000  call searcht(line,'m.o. irrep        orbital',
     &                  'm.o.  irrep  orbital',
     &                  'm.o. irrep  orbital',istat)
      if (istat.eq.1) then
         call bckfil
         call rdocc(0,norbs,focc,eiga,nocc,istat)
         if (istat.eq.0) goto 1000
         ncols = min0(nocc+5,norbs)
         call search(line,'molecular orbitals',istat)
         if (istat.eq.0) goto 1000
         call redel(line,9)
         call readvv(vectrs,norbs,nocc,.false.)
      endif
c
c try for spinfree mp2
c
c      call search(line,'spinfree mp2 natural orbitals',istat)
c      if (istat.eq.1) then
c      endif

cd     write(iun3,'(a)')'leave subroutine rdgam'
      return
c
c====== uhf part ==============================
c
7000  iuhf = 1
      call rdocc(1,norbs,focc,eiga,nocc,istat)
      if (istat.eq.0) goto 1000
      ncols = min0(nocc+5,norbs)
      call search(line,'eigenvectors',istat)
      if (istat.eq.0) then
          call inferr('Missing Alpha eigenvectors',1)
          goto 1000
      endif
      call redel(line,9)
      call readvv(vectrs,norbs,nocc,.false.)
c
      call rdocc(2,norbs,focb,eigb,nocb,istat)
      if (istat.eq.0) goto 1000
      ncolb = min0(nocb+5,norbs)
      call search(line,'eigenvectors',istat)
      if (istat.eq.0) then
          call inferr('Missing Beta eigenvectors',1)
          goto 1000
      endif
      call redel(line,9)
      call readvv(vectrb,norbs,nocb,.false.)
      if (ibefo.eq.1) then
cd        write(iun3,'(a)')'leave subroutine rdgam'
         return
      endif
c
c======= try for the vectors of an optimise or saddle job====
c
      if (istatio.eq.0) then
cd        write(iun3,'(a)')'leave subroutine rdgam'
         return
      endif

      call rdocc(1,norbs,focc,eiga,nocc,istat)
      if (istat.eq.0) goto 1000
      ncols = min0(nocc+5,norbs)
      call search(line,'molecular orbitals',istat)
      if (istat.eq.1) then
         call redel(line,9)
         call readvv(vectrs,norbs,nocc,.false.)
         call rdocc(2,norbs,focb,eigb,nocb,istat)
         if (istat.eq.0) goto 1000
         ncolb = min0(nocb+5,norbs)
         call search(line,'molecular orbitals',istat)
         if (istat.eq.0) then
            call inferr('missing Beta orbitals or occupancies',1)
            goto 1000
         endif
         call redel(line,9)
         call readvv(vectrb,norbs,nocb,.false.)
      endif
cd     write(iun3,'(a)')'leave subroutine rdgam'
      return

1000  istats = 0
      call inferr('ERROR reading GAMESS output file!',1)
cd     write(iun3,'(a)')'leave subroutine rdgam'
      return
      end

      subroutine rdbasg(idebug,us,istats)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      character*137 line
      character*8  dchar
      character*4  dchar1, ylabel(26)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      logical onewat, us
      dimension nangm(26),ncons(26)
      data ylabel /'1s','2s','2p','2sp','3s','3p','3sp',
     +     '3d','4s','4p','4sp','4d','5s','5p','5d',
     +     's','p','d','f','g','k','l','m','5sp','****','****'/
      data nangm /0,0,1,1,0,1,1,2,0,1,1,2,0,1,2,0,1,2,3,4,0,1,
     +            2,1,0,0/
      data ncons /0,0,1,0,0,1,0,2,0,1,0,2,0,1,2,0,1,2,3,4,0,0,
     +            0,0,0,0/
c ?? what about k,l,m ??
c answ k = s, l = sp, and m = spd; we dont handle spd yet

c
c====== read basis set info ======================
c
      istats = 1
      if (idebug.eq.1) write(iun3,'(a)')'enter subroutine rdbasg'
      call rewfil

      iguspc = 0
      if (us) then
         call search(line,'ATOMIC BASIS SET',istat)
         if (istat.eq.0) then
            call inferr('no ATOMIC BASIS SET found !',1)
            goto 1000
         endif
         if (index(line,'ATOMIC BASIS SET').eq.5) iguspc = 1
         call redel(line,5)
      else
         call search(line,'molecular basis set',istat)
         if (istat.eq.0) then
            call inferr('no molecular basis set found !',1)
            goto 1000
         endif
         call redel(line,9)
      endif

c start loop

      nshold = 0
      iprold = 1
      idf = 0
      iatcnt = 0
      igusn = 0

100   call nxtlin(line,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 1000
      if (iguspc.eq.1) line = ' '//line
      read(line,'(1x,a)',err=1000) dchar
      if (dchar.eq.'========'.or.dchar.eq.'TOTAL NU'
     &    .or.dchar.eq.'WARNING!') goto 200
      if (index(line,'.').eq.0.and.linlen(line).gt.1) then

c new atom

         onewat = .true.
         iatcnt = iatcnt + 1
      else
         if (linlen(line).gt.1) then
            if (us) then
               dchar1 = '    '
               if (line(8:10).eq.'   ') then
                  read(line,'(10x,a)') dchar1(1:2)
               else
                  read(line,'(7x,a)') dchar1(1:2)
               endif
            else
               read(line,'(21x,a)') dchar1
            endif
            call tolow(dchar1,4)

c data line

            if (index(dchar1,'sp').ne.0.or.index(dchar1,'l').ne.0) then

              if (us) then

c gamess-us
               if (index(line,'(').eq.0 ) then
                  igusn = 1
                  if (index(line,'.').eq.34) then
                     read(line,9005,err=1000) 
     &                  nshell,dchar1,iprim,ex,cd1,cd2
                  elseif (index(line,'.').eq.28) then
                     read(line,9004,err=1000) 
     &                  nshell,dchar1,iprim,ex,cd1,cd2
                  else
                     read(line,9003,err=1000) 
     &                  nshell,dchar1,iprim,ex,cd1,cd2
                  endif
               else
                  if (index(line,'(').eq.48) then
                     read(line,9002,err=1000) 
     &                  nshell,dchar1,iprim,ex,cd1,cd2
                  else
                     read(line,9001,err=1000) 
     &                  nshell,dchar1,iprim,ex,cd1,cd2
                  endif
               endif

              else

c gamess-uk

               read(line,9000,err=1000) nshell,dchar1,iprim,ex,cd1,cd2

              endif

            else

              if (us) then

c gamess-us
               if (index(line,'(').eq.0) then
                  igusn = 1
                  if (index(line,'.').eq.34) then
                     read(line,9005,err=1000) nshell,dchar1,iprim,ex,cd1
                  elseif (index(line,'.').eq.28) then
                     read(line,9004,err=1000) nshell,dchar1,iprim,ex,cd1
                  else
                     read(line,9003,err=1000) nshell,dchar1,iprim,ex,cd1
                  endif
               else
                  if (index(line,'(').eq.48) then
                     read(line,8002,err=1000) nshell,dchar1,iprim,ex,cd1
                  else
                     read(line,8001,err=1000) nshell,dchar1,iprim,ex,cd1
                  endif
               endif

              else

c gamess-uk
               read(line,8000,err=1000) nshell,dchar1,iprim,ex,cd1

              endif

            endif

            call tolow(dchar1,4)
            exx(iprim) = ex
            ityp = locatc(ylabel,26,dchar1)
      go to (1220,1220,1240,1280,1220,1240,1280,1260,1220,1240,1280,
     +      1260,1220,1240,1260,1220,1240,1260,1250,1270,
     +      1220,1280,1260,1280),ityp
c S
 1220       if (igusn.eq.1) call renorm(ex,cd1,0)
            c1(iprim) = cd1
            go to 1300
c P
 1240       if (igusn.eq.1) call renorm(ex,cd1,1)
            c2(iprim) = cd1 
            go to 1300
c D
 1260       if (igusn.eq.1) call renorm(ex,cd1,2)
            idf=idf+1
            c3(idf) = cd1 
            go to 1300
c F
 1250       if (igusn.eq.1) call renorm(ex,cd1,3)
            idf=idf+1
            c4(idf) = cd1 
            go to 1300
 1270       if (igusn.eq.1) call renorm(ex,cd1,4)
            idf=idf+1
            c5(idf) = cd1 
            go to 1300
c SP
 1280       if (igusn.eq.1) then
                call renorm(ex,cd1,0)
                call renorm(ex,cd2,1)
            endif
            c1(iprim) = cd1 
            c2(iprim) = cd2 
 1300       continue

            if (nshell.ne.nshold) then

c   starting new shell

              if (nshold.ne.0) then

                 shelln(nshold) = iprim-iprold
                 iprold = iprim

                 if (ngap.ne.0.and.onewat) then

c   copy read shells to skipped shells

                    nskip = nshold - nfirst + 1
                    natsk = ngap / nskip
                    nanci = nfirst - ngap

                    do j=0,natsk
                      do i=0,nskip-1
                       shella(nanci+j*nskip+i) = shella(nfirst+i)
                       shelln(nanci+j*nskip+i) = shelln(nfirst+i)
                       shellc(nanci+j*nskip+i) = shellc(nfirst+i)
                       shellt(nanci+j*nskip+i) = shellt(nfirst+i)
                       shladf(nanci+j*nskip+i) = shladf(nfirst+i)
                       gx(nanci+j*nskip+i) = xyz(1,iatcnt-1+j)
                       gy(nanci+j*nskip+i) = xyz(2,iatcnt-1+j)
                       gz(nanci+j*nskip+i) = xyz(3,iatcnt-1+j)
                      end do
                    end do

                    iatcnt = iatcnt + natsk
                 endif

              endif
              if (onewat) then
                  if (nshell-1.ne.nshold) then

c  have equivalent centres been skipped

                     ngap = nshell - nshold - 1
                     nfirst= nshell
                  else
                     ngap = 0
                  endif
              endif
              shella(nshell) = iprim
              shladf(nshell) = idf
              shellt(nshell) = nangm(ityp)
              shellc(nshell) = ncons(ityp)
              gx(nshell) = xyz(1,iatcnt)
              gy(nshell) = xyz(2,iatcnt)
              gz(nshell) = xyz(3,iatcnt)
            endif
            nshold = nshell
            onewat = .false.
         endif
      endif
      goto 100

200   continue

c     round up last shell

      shelln(nshell) = iprim - iprold + 1
      if (ngap.ne.0) then
c     copy read shells to skipped shells
         nskip = nshold - nfirst + 1
         natsk = ngap / nskip
         nanci = nfirst - ngap

         do j=0,natsk
           do i=0,nskip-1
            shella(nanci+j*nskip+i) = shella(nfirst+i)
            shelln(nanci+j*nskip+i) = shelln(nfirst+i)
            shellc(nanci+j*nskip+i) = shellc(nfirst+i)
            shellt(nanci+j*nskip+i) = shellt(nfirst+i)
            shladf(nanci+j*nskip+i) = shladf(nfirst+i)
            gx(nanci+j*nskip+i) = xyz(1,iatcnt+j)
            gy(nanci+j*nskip+i) = xyz(2,iatcnt+j)
            gz(nanci+j*nskip+i) = xyz(3,iatcnt+j)
           end do
         end do
      endif

      do i=1,nshell
         do j=1,natoms
            d1 = (gx(i) - xyz(1,j))**2
            d2 = (gy(i) - xyz(2,j))**2
            d3 = (gz(i) - xyz(3,j))**2
            dtot=d1+d2+d3
            if (dtot.lt.1.0d-6) jan(i)=j
         end do
      end do

      if (idebug.eq.1) call basprt(iun3,.false.,.false.)
      if (idebug.eq.1) write(iun3,'(a)')'leave subroutine rdbasg'
      return

1000  istats = 0
      call inferr('ERROR reading GAMESS Basis set!',1)
      if (idebug.eq.1) write(iun3,'(a)')'leave subroutine rdbasg'
      return
9000  format(15x,i3,3x,a4,3x,i3,1x,2f15.6,18x,f15.6)
9001  format(1x,i3,3x,a2,i4,1x,f15.6,f12.6,14x,f12.6)
9002  format(1x,i3,3x,a2,i4,1x,f15.6,f18.12,20x,f18.12)
9003  format(1x,i3,3x,a2,i4,f20.7,2f20.12)
9004  format(1x,i3,3x,a2,i4,f22.7,2f20.12)
9005  format(1x,i6,3x,a2,i7,f22.7,2f18.12)
8000  format(15x,i3,3x,a4,3x,i3,1x,2f15.6)
8001  format(1x,i3,3x,a2,i4,1x,f15.6,f12.6)
8002  format(1x,i3,3x,a2,i4,1x,f15.6,f18.12)
      end

      subroutine rdmolg(istats)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /coord / xyz(3,numatm)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line
c
c====== read molecular geometry ==================
c
cd     write(iun3,*)'enter subroutine rdmolg'
      istats = 1
      call rewfil
      call search(line,'molecular geometry',istat)
      if (istat.eq.0) goto 1000
      call search(line,'atom   atomic',istat)
      if (istat.eq.0) goto 1000
      call redel(line,3)

         natoms = 0
5        call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
         if (line(10:14).eq.'*****') then
cd           write(iun3,*)'leave subroutine rdmolg'
            return
         endif
         if (line(11:70).eq.' ') goto 5
         natoms = natoms + 1
         read(line,'(22x,f5.1,3(f12.7,3x),i5)',err=1000) charge,
     &   xyz(1,natoms),xyz(2,natoms),xyz(3,natoms),idum
         nat(natoms) = charge
         if (index(line,'bq').ne.0.or.index(line,'BQ').ne.0)
     &   natoms = natoms - 1
         goto 5

1000  istats = 0
cd     write(iun3,*)'leave subroutine rdmolg'
      call inferr('ERROR reading molecular geometry!',1)
      return
      end

      subroutine rdocc(imode,norbs,focc,eig,nocc,istat)
      implicit double precision (a-h,o-z), integer ( i-n)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line
      real eig
      dimension eig(*),focc(*)

      istat = 1

      if (imode.eq.0) then
         call searcht(line,'m.o. irrep        orbital',
     &                     'm.o.  irrep  orbital',
     &                     'm.o. irrep  orbital',istat)
         call redel(line,2)
      elseif (imode.eq.1) then
         call search(line,'alpha set',istat)
         if (istat.eq.0) call inferr('missing - alpha set - orbitals',1)
         iels = 7
         if (index(line,'--').ne.0) iels = 5
         call redel(line,iels)
      elseif (imode.eq.2) then
         call search(line,'beta set',istat)
         if (istat.eq.0) call inferr('missing - beta set - orbitals',1)
         iels = 7
         if (index(line,'--').ne.0) iels = 5
         call redel(line,iels)
      endif
      if (istat.eq.0) return
      istat = 1

      nocc = 0
      do i=1,norbs
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
         if (line(39:39).eq.'.') then
            read(line,'(11x,f16.8,16x,f14.4)',err=1000) 
     &        eig(i),focc(i)
         else
            read(line,'(11x,f16.8,f20.7)',err=1000) eig(i),focc(i)
         endif
         if (focc(i).gt.0.0d0) nocc = nocc + 1
      end do

      return

1000  if (nocc.eq.0) istat = 0
      return
      end

      subroutine rdcasocc(ncore,nact,focc,nocc,istat)
      implicit double precision (a-h,o-z), integer ( i-n)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*137 line
      dimension focc(*)

      istat = 1
      max=8

      nocc = 0
 10   if (nocc.lt.ncore+nact) then
         ibot=nocc+1
         itop=min0(nocc+max,ncore+nact)
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
         read(line,'(10x,8f14.7)',err=1000) (focc(i),i=ibot,itop)
         call nxtlin(line,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 1000
         nocc=itop
         goto 10
      endif

      do i=1,ncore
         focc(i)=2.0d0
      enddo

      return

1000  if (nocc.eq.0) istat = 0
      return
      end

      subroutine rdgeom(numatm,coo,ianz,iatoms,istat)
      implicit double precision (a-h,p-w), integer (i-n), logical (o)
      dimension coo(3,*)
      dimension ianz(*)
      character*137 line
      character*2   tstr
      character*2   tocapf
      parameter (mxel=100)
      character*2   elemnt
      common /elem/elemnt(mxel)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
c
c     Read a GAMESS-UK geometry. If no geometry with in the current
c     format is found we'll try older formats.
c
c     We assume the first line we read contains something like
c     "x              y              z            chg  tag",
c     "atom             x              y              z",      or
c     "atom             x              y              z            chg"
c
c
cd     write(iun3,'(a)')'enter subroutine rdgeom'
      istat = 0
      iatoms = 0
      call redel(line,1)
      if (index(line,'tag').ne.0) then
c
c...     found a geometry in the current format
c
         call redel(line,1)
100      call redel(line,1)
         if (index(line,'====').eq.0) then
            iatoms = iatoms + 1
            read(line,'(2x,3f15.7,10x,a2)',err=900)
     &           coo(1,iatoms),coo(2,iatoms),coo(3,iatoms),tstr
            if (tstr(2:2).eq.' ') then
               tstr(2:2) = tstr(1:1)
               tstr(1:1) = ' '
            endif
            do jj=1,99
               if(tocapf(tstr).eq.tocapf(elemnt(jj))) ianz(iatoms) = jj
            enddo
            if (tocapf(tstr).eq.'BQ') iatoms=iatoms-1
            goto 100
         endif
      else 
c
c        Found one of old formats
c
c...     skip a potentially present empty line
c
         call redel(line,1)
         if (index(line,'.').ne.0) then
            call bckfil
         elseif (index(line,'======').ne.0) then
            call redel(line,1)
         endif
c
c...     old formats the same from here on
c
200      call redel(line,1)
         if (index(line,'.').ne.0) then
            iatoms=iatoms+1
            read(line,'(20x,a2,8x,3f15.6)',err=900)
     &           tstr,coo(1,iatoms),coo(2,iatoms),coo(3,iatoms)
            if (tstr(2:2).eq.' ') then
               tstr(2:2) = tstr(1:1)
               tstr(1:1) = ' '
            endif
            do jj=1,99
               if(tocapf(tstr).eq.tocapf(elemnt(jj))) ianz(iatoms) = jj
            enddo
            if (tocapf(tstr).eq.'BQ') iatoms=iatoms-1
            goto 200
         endif
      endif
cd     write(iun3,'(a)')'leave subroutine rdgeom'
      return

900   istat=-1
cd     write(iun3,'(a)')'leave subroutine rdgeom'
      return
      end

      subroutine densmad(idebug,
     &                   vectrs,vectrb,focc,focb,p,nocc)

c THIS IS REALLY densmat

c NEW style atomic density matrices to file (Bjoern Pedersen)

      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      common /orbhlp/ mxorb,iuhf,ispd
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*137 line
      logical gamess,gamus,gauss,statio
      dimension vectrs(*),vectrb(*),focc(*),focb(*),p(*)

c--------------read vectors off atom and create
c--------------atomic density matrix in data form
c============read norbs nelecs ==================

c---------is it gamess, gaussian or mopac ?-----------
cd     write(iun3,'(a)')'enter subroutine densmat'
      gamess = .false.
      gauss = .false.
      gamus = .false.

      call rewfil

      call searchd(line,'g a m e s s','M.W.SCHMIDT',istat)
      if (istat.ne.0) then
         gamess = .true.
         if (index(line,'M.W.SCHMIDT').ne.0) gamus = .true.
      else
         call rewfil
         call seardu(line,'Gaussian System',
     &        'part of the Gaussian',istat)
         if (istat.ne.0) then
            gauss = .true.
         endif
      endif


c     try gamess-US, then gaussian then gamess-UK(old routine)    

      call rewfil
      istat=0
      if (gamus) then 
         call rdgamu(idebug,.false.,statio,irtype,.false.,istat)
      else if (gauss) then
         call rdgaus(idebug,.false.,statio,irtype,istat)
      else if (gamess)then
         call search(line,'total number of basis func',istat)
         if (index(line,'cartesian').ne.0) then
            read(line,'(45x,i5)') norbs
            call nxtlin(line,jstat)
            call nxtlin(line,jstat)
            read(line,'(45x,i5)') nelecs
         else
            read(line,'(38x,i5)') norbs
            call nxtlin(line,jstat)
            read(line,'(38x,i5)') nelecs
         endif
      
c
c     read occupancies
c
         call search(line,'m.o.  irrep  orbital',istat)
         call redel(line,2)
         nocc = 0
         do i=1,norbs
            call nxtlin(line,jstat)
            read(line,'(11x,f16.8,f20.7)') eig,focc(i)
            if (focc(i).gt.0.0d0) nocc = nocc + 1
         end do
c
c     read vectors
c
         if (idebug.eq.1) write(iun3,*)'read in occupancies'
         call searchd(line,'gvb natural orbital','eigenvectors'
     &                ,istat)
         if ( index(line,'gvb natural orbital').ne.0)then
           call redel(line,11)
         else
           call redel(line,9)
         endif
         call readvv(vectrs,norbs,nocc,.false.)

c     end of old input(gamess-UK)

      endif


      if (idebug.eq.1) then
          write(iun3,*)' norbs=',norbs,' nelecs=',nelecs
          write(iun3,*)' vectors'
          call prev(vectrs,norbs,norbs,mxorb)
      endif

c
c     construct density matrix
c
      call dmat(p,vectrs,vectrb,focc,focb)

      if (idebug.eq.1) then
          write(iun3,*)'p-matrix'
          call prev(p,norbs,norbs,mxorb)
      endif

      open(unit=99,file='basiinf.mbi',form='formatted',status='unknown')

      write (99,'(A4,A3)') 'ATOM',' XX'
      write (99,'(A8,A8)') 'CHARGE','NORBS'
      write (99,'(i4,i10)') nelecs,norbs
      do i=1,norbs
         write (99,'(6f15.10)') (p((j-1)*mxorb + i),j=1,norbs) 
      end do
      write (99,*) '*******************************************' 
      close(99)

cd     write(iun3,'(a)')'leave subroutine densmat'
      return
      end

c OLD style gamess-UK atomic density matrices, as data statements

      subroutine densmtd(idebug,
     &                   v,pop,p,nocc)

c THIS ISREALLY densmto

      implicit double precision (a-h,o-z), integer ( i-n)
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      character*137 line
      common /orbhlp/ mxorb,iuhf,ispd
      dimension v(*),pop(*),p(*)

c-------------- read vectors off atom and create
c-------------- atomic density matrix in data form
c============ read norbs nelecs ==================

cd     write(iun3,'(a)')'enter subroutine densmto'
c      call search(line,'total number of basis func',istat)
      call search(line,'basis functions',istat)
      if (index(line,'cartesian').ne.0) then
         read(line,'(45x,i5)') norbs
         call nxtlin(line,jstat)
         call nxtlin(line,jstat)
         read(line,'(45x,i5)') nelecs
      else
         read(line,'(38x,i5)') norbs
         call nxtlin(line,jstat)
         read(line,'(38x,i5)') nelecs
      endif

      if (idebug.eq.1) 
     &    write(iun3,*)' norbs=',norbs,' nelecs=',nelecs
c
c     read occupancies
c
      call search(line,'m.o.  irrep  orbital',istat)
      call redel(line,2)
      nocc = 0
      do i=1,norbs
         call nxtlin(line,jstat)
         read(line,'(11x,f16.8,f20.7)') eig,pop(i)
         if (pop(i).gt.0.0d0) nocc = nocc + 1
      end do
c
c     read vectors
c
      if (idebug.eq.1) write(iun3,*)'read in occupancies'
      call searchd(line,'gvb natural orbital','eigenvectors'
     &             ,istat)
      if ( index(line,'gvb natural orbital').ne.0)then
        call redel(line,11)
      else
        call redel(line,9)
      endif
      call readvv(v,norbs,nocc,.false.)
      if (idebug.eq.1) write(iun3,*)'vectors'
c
c     construct density matrix
c
      if (idebug.eq.1) call prev(v,norbs,norbs,mxorb)
      call dmato(v,pop,norbs,p)
      if (idebug.eq.1) write(iun3,*)'p-matrix'
      if (idebug.eq.1) call prev(p,norbs,norbs,norbs)
c
c     print densitymatrix in data form
c
      n2    = norbs * norbs
      nrow  = n2 / 3
      nlast = n2 - nrow*3
      noff  = 0
      if (nlast.eq.0) noff = -1
      ntel  = 1
      write(iun3,'(a)')'      data string/'

      do k=1,nrow+noff
         write(iun3,'(a6,3(f15.10,a2,a1))')'     &',p(ntel),'d0',
     &   char(44),p(ntel+1),'d0',char(44),p(ntel+2),'d0',char(44)
         ntel = ntel + 3
      end do

      if (nlast.eq.0) then
         write(iun3,'(a6,3(f15.10,a2,a1))')'     &',p(ntel),'d0',
     &   char(44),p(ntel+1),'d0',char(44),p(ntel+2),'d0','/'
      endif

      if (nlast.eq.1) then
         write(iun3,'(a6,f15.10,a2,a1)')'     &',p(ntel),'d0','/'
      elseif (nlast.eq.2) then
         write(iun3,'(a6,2(f15.10,a2,a1))')'     &',p(ntel),'d0',
     &   char(44),p(ntel+1),'d0','/'
      endif

cd     write(iun3,'(a)')'leave subroutine densmto'
      return
      end

      subroutine site(line)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxsite=300)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
      common /multip/ q(lmaxf,mxsite),car(3,mxsite),ctag(mxsite),
     &                nsites
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*8   ctag,attag
      character*137 line

10    read(line,11) nsites,attag 
11    format(5x,i3,7x,a8)
      ctag(nsites) = attag
      
      do i=1,lmaxf
         q(i,nsites) = 0.0d0
      end do

      call nxtlin(line,jstat)
      call nxtlin(line,jstat)
      call nxtlin(line,jstat)

      read(line,12) car(1,nsites),car(2,nsites),car(3,nsites)
12    format(6x,f10.6,5x,f10.6,5x,f10.6)

15    call nxtlin(line,jstat)
      if( index(line,'site').ne.0.) goto 10
      if(index(line,'total multipoles referred to origin').ne.0) return
      call getreal(line,'q00 ',q(1,nsites))
      call getreal(line,'q10 ',q(2,nsites))
      call getreal(line,'q11c',q(3,nsites))
      call getreal(line,'q11s',q(4,nsites))
      call getreal(line,'q20 ',q(5,nsites))
      call getreal(line,'q21c',q(6,nsites))
      call getreal(line,'q21s',q(7,nsites))
      call getreal(line,'q22c',q(8,nsites))
      call getreal(line,'q22s',q(9,nsites))
      call getreal(line,'q30 ',q(10,nsites))
      call getreal(line,'q31c',q(11,nsites))
      call getreal(line,'q31s',q(12,nsites))
      call getreal(line,'q32c',q(13,nsites))
      call getreal(line,'q32s',q(14,nsites))
      call getreal(line,'q33c',q(15,nsites))
      call getreal(line,'q33s',q(16,nsites))
      goto 15
      end

      subroutine euler(px,py,pz,ipen)
      implicit double precision (a-h,o-z)
************************************************************************
*
* EULER DOES A SIMPLE EULERIAN TRANSFORM ON THE POINT PX,PY,PZ TO
* PRODUCE A POINT FOR PLOTTING. 
*    SET THE PLANE OF THE PLOT
*            PX,PY,PZ = POINT IN 3-D SPACE TO MOVE THE PEN TO.
*            IPEN     = 1 DO NOT DRAW A LINE, = 2 DRAW A LINE.
************************************************************************
      common /eul/ ca,cb,sa,sb,ccab,scab,ssab,scba
      common /plrat/ rat(3)

      cx = ccab*(px-0.5d0)*rat(1) + scab*(py-0.5d0)*rat(2) - 
     &     sb*pz*rat(3)
      cy =  -sa*(px-0.5d0)*rat(1) +   ca*(py-0.5d0)*rat(2)
      call plotgr(ipen,cx,cy)

      return
      end

      subroutine propnd(qx,qy,qz,ipen,
     &                  coo,ianz,iaton,iatclr,iresid,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      parameter (max3d=61)
      parameter (mesp = (max3d*max3d*max3d+max3d)/4)
      parameter (mdum = (max3d*max3d*max3d+max3d) - mesp*4)
      common /athlp/ iatoms, mxnat
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /spa3d/  connl(3,mesp), esp(mesp), dum(mdum)
      common /pntsta/ iproj,idrcol,nesp
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*)

      if (iproj.eq.1) then

          call euler(qx,qy,qz,ipen)

      elseif (iproj.eq.0) then

          if (iatoms.lt.mxnat) then
             iatoms = iatoms + 1

             x = (0.5d0-qx)*r(1)
             y = (0.5d0-qy)*r(2)

             coo(1,iatoms) = v1(1)*x + v2(1)*y + px
             coo(2,iatoms) = v1(2)*x + v2(2)*y + py
             coo(3,iatoms) = v1(3)*x + v2(3)*y + pz

             iaton(iatoms) = 1
             ianz(iatoms) = 100
             iatclr(iatoms) = idrcol
             iresid(iatoms) = -4
             if (ipen.eq.2) then
                iconn(2,iatoms) = iatoms - 1
                iconn(1,iatoms) = 1
                l = iconn(1,iatoms-1)
                if (l.lt.mxcon) then
                   iconn(l+2,iatoms-1) = iatoms
                   iconn(1,iatoms-1) = l + 1
                endif
             else
                iconn(1,iatoms) = 0
             endif
          endif

      elseif (iproj.eq.-1) then

          if (nesp.lt.mesp) then
             nesp = nesp + 1

             x = (0.5d0-qx)*r(1)
             y = (0.5d0-qy)*r(2)

             connl(1,nesp) = v1(1)*x + v2(1)*y + px
             connl(2,nesp) = v1(2)*x + v2(2)*y + py
             connl(3,nesp) = v1(3)*x + v2(3)*y + pz
          endif

      endif

      return
      end

      subroutine mulprt
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (mxsite=300)
      parameter (lmax=4)
      parameter (lmaxf=(lmax+1)*(lmax+1))
      character*8   ctag
      common /multip/ q(lmaxf,mxsite),car(3,mxsite),ctag(mxsite),
     &                nsites

      common /rdwr/   iun1,iun2,iun3,iun4,iun5

      write(iun3,*)' '
      write(iun3,*)'========== multipoles =========='
      write(iun3,*)' '

      do ij=1,nsites
         write(iun3,*)'***** site ',ij,' *****'
         write(iun3,*)' '
         write(iun3,*)'tag ',ctag(ij)
         write(iun3,*)' '
         write(iun3,*)'coordinates ',(car(j,ij),j=1,3)
         write(iun3,*)' '
         write(iun3,*)'q(',ij,')=',q(1,ij)
         do i=1,3
           write(iun3,*)'dip(',ij,',',i,')=', q(i+1,ij)
         end do
         do i=1,5
           write(iun3,*)'qua(',ij,',',i,')=', q(i+4,ij)
         end do
         do i=1,7
           write(iun3,*)'octa(',ij,',',i,')=',q(i+9,ij)
         end do
      end do

      write(iun3,*)' '
      write(iun3,*)'================================'
      write(iun3,*)' '

      return
      end

      subroutine rys(norder,x,root,weight)
      implicit double precision (a-h,o-z)
      dimension root(*),weight(*)
      common /ryscom/ et(3745),ew(3745),cut(2,8),ltw(5),istrt(5)
      common /hermit/ hr(36),hw(36)
      dimension d(6)
 
      if (norder.le.0.or.norder.gt.8) stop 'error in rys'
 
      choose  =  x / (4.0d0 + x)

      if (choose.ge.cut(2,norder)) then

c     hermite polynomial

         indx = (norder*(norder-1))/2
         do i = 1,norder
            indx = indx + 1
            root(i) = hr(indx)**2 / x
            weight(i) = hw(indx) / dsqrt(x)
         end do
         return
      endif

      if (choose.ge.cut(1,norder).or.norder.gt.5) then
         call ryspol(norder,x,root,weight)
         return
      endif

      m      = ltw(norder)*choose
      alfa   = ltw(norder)*choose-dfloat(m)
      beta   = 1.d0-alfa
      at     = alfa*(alfa*alfa-1.d0)/6.0d0
      ap     = beta*(beta*beta-1.d0)/6.0d0
      d(6)   = at*(alfa*alfa-4.d0)*0.05d0
      d(1)   = ap*(beta*beta-4.d0)*0.05d0
      d(2)   =              d(6) - 4.0d0*d(1)            +       ap
      d(3)   = beta - 4.0d0*d(6) + 6.0d0*d(1) +       at - 2.0d0*ap
      d(4)   = alfa + 6.0d0*d(6) - 4.0d0*d(1) - 2.0d0*at +       ap
      d(5)   =      - 4.0d0*d(6) +       d(1) +       at
      indx = istrt(norder)
      do i = 1,norder
         root(i) = evertt(et(indx),d,m)
         weight(i) = evertt(ew(indx),d,m)
         weight(i) = dsqrt(weight(i))
         indx = indx + ltw(norder) + 3
      end do

      return
      end
      double precision function evertt(t,d,m)
      implicit double precision (a-h,o-z)
c
c     everett interpolation
c
      dimension t(*),d(*)
 
      evertt = 0.0d0
      do i=1,6
         evertt = evertt + d(i)*t(m+i)
      end do
 
      return
      end

      subroutine setang(px,py,pz,theta,phi)
      implicit double precision (a-h,o-z)
      common /eul/ ca,cb,sa,sb,ccab,scab,ssab,scba

      todeg = 45.0d0 / datan(1.0d0)
*
* SET UP COS AND SINE ANGLES 
*
      xy = px*px + py*py
      if (xy.gt.1.d-15) then
          r1 = dsqrt(xy + pz*pz)
          xy = dsqrt(xy)
          ca = px / xy
          cb = pz / r1
          sa = py / xy
          sb = xy / r1
      else
          ca = 1.0d0
          cb = 1.0d0
          sa = 0.0d0
          sb = 0.0d0
      endif
      theta = dasin(sa) * todeg
      phi   = dasin(sb) * todeg
      ccab  = ca * cb
      scab  = sa * cb
      ssab  = sa * sb
      scba  = sb * ca

      return
      end

      subroutine actsd(iopt,
     &                 ianz,iaton,iatclr,iresid,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxcon=10)
      common /athlp/ iatoms, mxnat
      character*2 gstr
      character lstr*137
      dimension ianz(*),iaton(*),iatclr(*),iresid(*),iconn(mxcon+1,*)

c     shouldnt issdon be set here ?

      iss = 0
      do i=1,iatoms
         if (ianz(i).eq.16) then
             do j=1,iconn(1,i)
                if (ianz(abs(iconn(j+1,i))).eq.16) then
                   ires1 = iresid(i)
                   ires2 = iresid(abs(iconn(j+1,i)))
                   if (iopt.eq.1) then
                      call actami(ires1,0,1,0)
                      call actami(ires2,0,1,0)
                      iss = iss + 1
                      iaton(i) = 1
                      iaton(abs(iconn(j+1,i))) = 1
                      iatclr(i) = 2
                      iatclr(abs(iconn(j+1,i))) = 2
                   else
                      call actami(ires1,0,0,0)
                      call actami(ires2,0,0,0)
                      iaton(i) = 0
                      iaton(abs(iconn(j+1,i))) = 0
                   endif
                endif
             end do
         endif
      end do

      if (iopt.eq.1) then
         if (iss.eq.0) then
            call inferr('No Sulfur Bridges Found !',0)
         else
            lstr = gstr(iss/2)//' Sulfur Bridges Found'
            call inferr(lstr,0)
         endif
      endif

      return
      end

      subroutine plded(ndim1,ndim2,scale,icells,adjus,idisml,
     &                 dens,ix,iy,rz)
      implicit double precision (a-h,o-z)

c THIS IS REALLY plden

      parameter (mxel=100)
      parameter (numatm=2000)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)

      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /eul/   ca,cb,sa,sb,ccab,scab,ssab,scba
      common /atopla/ xsym(numatm),ysym(numatm),zsym(numatm),
     &                isym(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      real xx, yy
      character str*100
      integer*2 ipl1(8)
      integer*2 ipl2(8)
      integer*2 ixx(4)
      dimension temp1(3),temp2(3),temp3(3),zvect(3)
      dimension dens(*),ix(*),iy(*),rz(*)

      npoly = 4
      zvect(1) = -0.5d0
      zvect(2) = -0.5d0
      zvect(3) = -1.5d0

      npts = ndim1*ndim2
      scald = -1.0d0*scale*ndim1
      scle1  = ndim1*1.2d0 * r(2) / r(1)
      scle2  = ndim2*1.2d0
      nmed1 = ndim1/2
      nmed2 = ndim2/2
      if (ndim1-nmed1*2.eq.1) nmed1 = nmed1 + 1
      if (ndim2-nmed2*2.eq.1) nmed2 = nmed2 + 1

      call gethei(ihigh)

      ij = 0
      do i=1,ndim1
         do j=1,ndim2
           ij = ij + 1
           ix(ij) = (ccab*(i-nmed1)/scle1 + scab*(j-nmed2)/scle2 -
     &              sb*dens(ij)*scald/scle1 + 0.5d0)*ihigh
           iy(ij) = (0.6d0-(-sa*(i-nmed1)/scle1 + ca*(j-nmed2)/scle2))
     &              *ihigh
           rz(ij) = (scba*(i-nmed1)+ssab*(j-nmed2)+cb*dens(ij)*scald)
         end do
      end do

      k = 0
      do i=1,ndim1
         do j =1,ndim2
           k = k + 1
           if (i.ne.ndim1.and.j.ne.ndim2) then
              m = k + ndim2
              ipl1(1) = iy(k)
              ipl1(2) = ix(k)
              ipl1(3) = iy(k+1)
              ipl1(4) = ix(k+1)
              ipl1(5) = iy(m)
              ipl1(6) = ix(m)
              ipl1(7) = iy(k)
              ipl1(8) = ix(k)
   
              ipl2(1) = iy(k+1)
              ipl2(2) = ix(k+1)
              ipl2(3) = iy(m)
              ipl2(4) = ix(m)
              ipl2(5) = iy(m+1)
              ipl2(6) = ix(m+1)
              ipl2(7) = iy(k+1)
              ipl2(8) = ix(k+1)
   
              if (icells.ge.256) then
               temp1(1) = (ix(k) - ix(k+1)) *1.0d0
               temp1(2) = (iy(k) - iy(k+1)) *1.0d0
               temp1(3) = ((rz(k) - rz(k+1))/scle1)*ihigh
               temp2(1) = (ix(m) - ix(k+1)) *1.0d0
               temp2(2) = (iy(m) - iy(k+1)) *1.0d0
               temp2(3) = ((rz(m) - rz(k+1))/scle1)*ihigh
               call crprod(temp1,temp2,temp3)
               call impsc(temp3,zvect,cot1)
               temp1(1) = (ix(k+1) - ix(m)) *1.0d0
               temp1(2) = (iy(k+1) - iy(m)) *1.0d0
               temp1(3) = ((rz(k+1) - rz(m))/scle1)*ihigh
               temp2(1) = (ix(m+1) - ix(m)) *1.0d0
               temp2(2) = (iy(m+1) - iy(m)) *1.0d0
               temp2(3) = ((rz(m+1) - rz(m))/scle1)*ihigh
               call crprod(temp1,temp2,temp3)
               call impsc(temp3,zvect,cot2)
               cot2 = -1.0d0*cot2
               ctt1 = 5.0d0*cot1 +0.5
               ctt2 = 5.0d0*cot2 +0.5
               icol1 = 130 + ctt1
               icol2 = 130 + ctt2
               if (icol1.lt.126) icol1 = 126
               if (icol2.lt.126) icol2 = 126
              else
               icol1 = 12
               icol2 = 12
              endif
   
              call drwpol(ipl1,npoly,icol1,1,0,1)
              call drwpol(ipl2,npoly,icol2,1,0,1)

           endif
         end do
      end do

      if (idisml.eq.0) return

      xx=3.0
      call xwin(xx,yy,10,str,nstr,idum1,idum2)
      call xwin(xx,yy,8,str,nstr,idum1,idum2)

      do i=1,natoms
         xa = -xsym(i)*ndim1 / r(1)
         ya = -ysym(i)*ndim2 / r(2)
         za = -zsym(i)*ndim1 / r(1)
         do j=i+1,natoms
              dmaxsq = (vdwr(nat(i))+vdwr(nat(j)))**2
              dijsq = ((xyz(1,i)-xyz(1,j))*adjus)**2
     +               +((xyz(2,i)-xyz(2,j))*adjus)**2
     +               +((xyz(3,i)-xyz(3,j))*adjus)**2
              if (dijsq.lt.dmaxsq) then
                  if (isym(i).eq.1.and.isym(j).eq.1) then
                     if (icells.eq.2) then
                        xx = 0.0
                     else
                        xx = 1.0
                     endif
                     call unstip
                  else
                     xx = 11.0
                     call ststip
                  endif
                  yy= 0.0
                  call xwin(xx,yy,99,str,nstr,idum1,idum2)
                  xb = -xsym(j)*ndim1 / r(1)
                  yb = -ysym(j)*ndim2 / r(2)
                  zb = -zsym(j)*ndim1 / r(1)
                  ixx(2) = ((ccab*xa/scle1+scab*ya/scle2-sb*za/scle1)
     &                     + 0.5d0)*ihigh
                  ixx(1) = (0.6d0-(-sa*xa/scle1+ca*ya/scle2))*ihigh
                  ixx(4) = ((ccab*xb/scle1+scab*yb/scle2-sb*zb/scle1)
     &                     + 0.5d0)*ihigh
                  ixx(3) = (0.6d0-(-sa*xb/scle1+ca*yb/scle2))*ihigh
                  call drawseg(ixx,1,0)
              endif 
         end do
      end do
      call unstip
      xx=1.0
      call xwin(xx,yy,10,str,nstr,idum1,idum2)
      call xwin(xx,yy,8,str,nstr,idum1,idum2)

      return
      end

      subroutine p3dd(iun,scale,ndimx,ndimz,adjus,dens)
      implicit double precision (a-h,o-z)

c THIS IS REALLY p3dv

      common /plrat/ rat(3)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      dimension dens(*)

      hinvx = dble(1.0d0/ndimx)
      hinvz = dble(1.0d0/ndimz)
      write(iun,'(''#VRML V2.0 utf8'')')
      write(iun,*) 'NavigationInfo { type ',char(34),
     &             'EXAMINE',char(34),' }'
      write(iun,*) 'Viewpoint { position -0.5 0 0.5 description ',
     &              char(34),'MoldenVRML',char(34),' }'
      write(iun,*) '#Background {'
      write(iun,*) '#skyColor [0 0.2 0.7,0 0.5 1,1 1 1 ]'
      write(iun,*) '#skyAngle [ 1.309, 1.571 ]'
      write(iun,*) '#groundColor [0.1 0.1 0,0.4 0.25 0.2,0.6 0.6 0.6]'
      write(iun,*) '#groundAngle [1.309,1.571]}'
      write(iun,*) 'Transform {'
      write(iun,*) 'translation -0.5 0 -0.5'
      write(iun,*) 'rotation 0 0 1 3.1415927'
      write(iun,*) 'children ['
      write(iun,*) 'Transform {'
      write(iun,*) '  scale ',hinvx,' ',hinvx,' ',hinvx
c      write(iun,*) '  translation -1.0 0.0 -1.0'
c      write(iun,*) '  translation -1.0 0.0 ',-1.0 + rat(1) / rat(2)
      write(iun,*) '  translation ',-0.5*r(2)/r(1),' 0.0 -0.5'
      write(iun,*) '  children ['
      write(iun,*) '    Shape {'
      write(iun,*) '       appearance Appearance {'
      write(iun,*) '         material Material {'
      write(iun,*) '           diffuseColor 1.0 0.0 1.0'
      write(iun,*) '         }'
      write(iun,*) '       }'
      write(iun,*) '       geometry ElevationGrid {'
      write(iun,*) '        xDimension ',ndimz
      write(iun,*) '        zDimension ',ndimx
      write(iun,*) '        xSpacing ',(dble(ndimx)/dble(ndimz))*
     &                                 (r(2)/r(1))
      write(iun,*) '        zSpacing 1'
      write(iun,*) '        solid FALSE'
      write(iun,*) '        height ['
      ij = 0
      do i=1,ndimz
          do j=1,ndimx
             ij = ij + 1
             write(iun,*) '                ',
     &               dens(ij)*scale*dble(ndimx)
          end do
      end do
      write(iun,*) '               ]'
      write(iun,*) '       }'
      write(iun,*) '    }'
      write(iun,*) '  ]'
      write(iun,*) '}'

      write(iun,*) 'Transform {'
      write(iun,*) ' rotation 1 0 0 1.5708'
      write(iun,*) ' children ['
      call plvmol(iun,ndimx,adjus)
      write(iun,*) '  ]'
      write(iun,*) '}'
      
      write(iun,*) '  ]'
      write(iun,*) '}'

      return
      end

      subroutine geogau(formax,forrms,dismax,disrms,epoints,isav)
      implicit double precision (a-h,o-z)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      common /gauori/ nzm,nso,nio,nzo,ioropt,ifor,
     &                ixyz98,iopr,isymm,irc,imp2,icntp,itd
      common /gauver/ ivers
      character*137 line,str
      character*25 sirc
      common /curlin/ line
      integer getlin
      dimension formax(*),forrms(*),dismax(*),disrms(*),epoints(*)
      dimension isav(*)

      sirc = 'Item               Value'
      nis = 24
      if (irc.eq.2) then
         sirc = '  Delta-x Convergence'
         nis = 22
      endif

      call rewfil
      isemi = 0
      ioni = 0
      call searchd(line,'ONIOM: generating','calculation of energy',
     &             istat)
      if (istat.ne.0) then
         if (icdex(line,'ONIOM:').ne.0) then
            ioni = 1
         elseif (icdex(line,'External').ne.0) then
            isemi = 1
         elseif (icdex(line,'second derivatives').eq.0) then
            if (icdex(line,'AM1').ne.0) isemi = 1
            if (icdex(line,'MNDO').ne.0) isemi = 1
            if (icdex(line,'MINDO3').ne.0) isemi = 1
            if (icdex(line,'PM3').ne.0) isemi = 1
            if (icdex(line,'CNDO').ne.0) isemi = 1
            if (icdex(line,'INDO').ne.0) isemi = 1
            if (icdex(line,'AMBER').ne.0) isemi = 1
            if (icdex(line,'UFF').ne.0) isemi = 1
            if (icdex(line,'Dreiding').ne.0) isemi = 1
            if (icdex(line,'MM2').ne.0) isemi = 1
            if (icdex(line,'MM3').ne.0) isemi = 1

         endif
      endif
      call rewfil
      
      igcvav = 1
      ifmxav = 1
      ifrmav = 1
      idmxav = 1
      idrmav = 1
      ieav = 1


      nepnts = 0
      ngeoms = 0
      igeoms = 0
      do i=1,mxpnt
         if (isemi.eq.1) then
            call srclit(line,' Energy=',istat)
         elseif (ioni.eq.1) then
            call search(line,'ONIOM: extrapolated energy =',istat)
         elseif (icntp.eq.1) then
            call search(line,'Counterpoise: corrected energy =',istat)
         elseif (imp2.eq.1) then
            call searchd(line,'EUMP2 =','E(RMP2)=',istat)
         elseif (itd.eq.1) then
            call search(line,'E(TD-HF/TD-KS)',istat)
         else
            call searchd(line,'SCF Done:','MCSCF converged',istat)
         endif
         if (istat.eq.0) goto 100

10       if (nepnts.eq.mxpnt) then
            call inferr('exceeded MAXPNT !',1)
            return
         endif

         etmp = 0.0d0
         if (irc.eq.0) nepnts = nepnts + 1

         imcscf = 0
         if (icdex(line,'MCSCF').ne.0) then
             imcscf = 1
c             call scback(line,'... DO AN EXTRA-',istat)
             call scback(line,'... Do an extra-',istat)
             call bckfil
             if (ivers.lt.2009) then
                call bckfil
             endif
             call nxtlin(line,jstat)
             i1 = index(line,'E=')
             if (i1.gt.0) i1 = i1 + 1
         elseif (icdex(line,'MP2').ne.0) then
             it1 = icdex(line,'EUMP2 =')
             if (it1.ne.0) i1 = it1 + 6
             it1 = icdex(line,'E(RMP2)=')
             if (it1.ne.0) i1 = it1 + 9
         else
             i1 = index(line,'=')
         endif
         if (i1.gt.0) then
             if (irc.gt.0) then
                etmp = reada(line,i1+1,len(line))
             else
                epoints(nepnts) = reada(line,i1+1,len(line))
             endif
         endif

         if (imcscf.eq.1) then
             call search(line,'MCSCF converged',istat)
             call searchd(line,
     &           'MCSCF converged',sirc(1:nis),istat)
         else
             if (isemi.eq.1) then
                call searchd(line,
     &           'Energy=',sirc(1:nis),istat)
             elseif (ioni.eq.1) then
                call searchd(line,
     &           'ONIOM: extrapolated energy =',sirc(1:nis),istat)
             elseif (icntp.eq.1) then
                call searchd(line,'Counterpoise: corrected energy',
     &           sirc(1:nis),istat)
             elseif (imp2.eq.1) then
                call searcht(line,'EUMP2 =','E(RMP2)=',
     &           sirc(1:nis),istat)
             elseif (itd.eq.1) then
                call searchd(line,'E(TD-HF/TD-KS)',
     &           sirc(1:nis),istat)
             else
                call searcht(line,
     &           'SCF Done:',sirc(1:nis),
     &           'Corrected End Point Energy ',istat)
             endif
         endif
         if (istat.eq.0) goto 100

         if (icdex(line,'Corrected').ne.0) then

             i1 = index(line,'=')
             etmp = reada(line,i1+1,len(line))
             nepnts = nepnts + 1
             igeoms = igeoms + 1
             epoints(nepnts) = etmp
             isav(nepnts) = 0 
    
         else if (icdex(line,'Item').ne.0) then


c            read(iun2,'(26x,f8.6,5x,f8.6)',end=100,err=100) tmp1,fmaxt
            icv1 = 0
            icv2 = 0
            icv3 = 0
            icv4 = 0
            if (getlin(0).eq.1) then
                if (icdex(line,'YES').ne.0) icv1 = 1
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) tmp1 = 0.0d0
                if (ktype.eq.3) tmp1 = rtype
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) fmaxt = 0.0d0
                if (ktype.eq.3) fmaxt = rtype
            else
                goto 100
            endif

c            read(iun2,'(26x,f8.6,5x,f8.6)',end=100,err=100) tmp2,frmst
            if (getlin(0).eq.1) then
                if (icdex(line,'YES').ne.0) icv2 = 1
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) tmp2 = 0.0d0
                if (ktype.eq.3) tmp2 = rtype
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) frmst = 0.0d0
                if (ktype.eq.3) frmst = rtype
            else
                goto 100
            endif

c            read(iun2,'(26x,f8.6,5x,f8.6)',end=100,err=100) tmp3,dmaxt
            if (getlin(0).eq.1) then
                if (icdex(line,'YES').ne.0) icv3 = 1
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) tmp3 = 0.0d0
                if (ktype.eq.3) tmp3 = rtype
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) dmaxt = 0.0d0
                if (ktype.eq.3) dmaxt = rtype
            else
                goto 100
            endif

c            read(iun2,'(26x,f8.6,5x,f8.6)',end=100,err=100) tmp4,drmst
            if (getlin(0).eq.1) then
                if (icdex(line,'YES').ne.0) icv4 = 1
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.ne.1) goto 100
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) tmp4 = 0.0d0
                if (ktype.eq.3) tmp4 = rtype
                ktype = nxtwrd(str,nstr,itype,rtype)
                if (ktype.eq.1) drmst = 0.0d0
                if (ktype.eq.3) drmst = rtype
            else
                goto 100
            endif

            icv = icv1 + icv2 + icv3 + icv4
            if (irc.eq.1) then
                if (icv.ne.4) then
                   goto 10
                else
                   nepnts = nepnts + 1
                   epoints(nepnts) = etmp
                endif
            endif

            igeoms = igeoms + 1
            isav(nepnts) = 1
            formax(nepnts) = tmp1
            forrms(nepnts) = tmp2
            dismax(nepnts) = tmp3
            disrms(nepnts) = tmp4

         else if (icdex(line,'Delta-x').ne.0) then

            if (icdex(line,' NOT met').ne.0) goto 10
            nepnts = nepnts + 1
            igeoms = igeoms + 1
            epoints(nepnts) = etmp
            isav(nepnts) = 0 

         else

            isav(nepnts) = 0 
            goto 10

         endif

      end do

100   continue

      if (igeoms.eq.0.or.igeoms.eq.1) then
         ngeoms = igeoms
         igcvav = 0
         ifmxav = 0
         ifrmav = 0
         idmxav = 0
         idrmav = 0
         ieav = 0
      else
         ngeoms = nepnts
      endif

      return
      end

      character*2 function tocapf(line)
      character*2 line

      tocapf = line

      do i=1,2
         j = ichar(tocapf(i:i))
         if (j.ge.97.and.j.le.122) tocapf(i:i) = char(j-32)
      end do

      return
      end

      character*2 function tolowf(line)
      character*2 line

      tolowf = line

      do i=1,2
         j = ichar(tolowf(i:i))
         if (j.ge.65.and.j.le.90) tolowf(i:i) = char(j+32)
      end do

      return
      end

      subroutine plvrmd(iun,fancy,atcol,dolabs,ihnd,backb,dohead,
     &                  rz,t,coo,ianz,iaton,iatclr,iresid,iconn,
     &                  icalf,ianf,islu,nchain,iamino,reson,
     &                  scal,scali)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat

      common /cllab/ iclon,iclpnt(4)
      character*2 clstr,ccell
      common /clchr/ clstr(4)
      common /gracom/uscl,colscd,colscpd,ivdwpl

      logical doscnd, dohead
      integer reson
      parameter (mxres=42)
      character*3    aminos
      common /amino/ aminos(mxres)
      character*2    elemnt
      common /elem/  elemnt(mxel)
      common /surf/  natorg,noscnd
      common /vrcol/ jcol(3,16)
      common /vropt/ ivtwo,ihand,ivadd
      common /helpar/helrod, ihtype

      character str*13
      logical dsurf
      integer dolabs,fancy,atcol,backb
      dimension rz(3),t(3),tmp(3), tlpos(3), nat(mxel)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iresid(*),
     &          iconn(mxcon+1,*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),reson(*)

      toang  = 0.52917706d0
      roddef = 0.7d0*vrad(1)
      doscnd = .true.

      if (iatoms.eq.0) return

      ihand = ihnd

      call plcini

      if (ivtwo.eq.2) then

c povray

          xc = 0.0d0
          yc = 0.0d0
          zc = 1.0d0
          tmp(1) = zc*rz(1)
          tmp(2) = zc*rz(2)
          tmp(3) = zc*rz(3)

          do i=1,3
             tmp(i) = tmp(i)*scali*2.5d0 + t(i)
          end do

          tlpos(1) = 9.0d0
          tlpos(2) = 9.0d0
          tlpos(3) = 9.0d0

          call plphd(iun,ihand,tmp,t,tlpos)

      elseif (ivtwo.eq.1) then
         if (dohead) then
            write(iun,'(''#VRML V2.0 utf8'')')
            write(iun,*) 'NavigationInfo { type ',char(34),
     &                   'EXAMINE',char(34),' }'
            write(iun,*) 'Viewpoint { position 0 0 ',scal,
     &        ' description ',char(34),'MoldenVRML',char(34),' }'
         else
            write(iun,*) 'Group {'
            write(iun,*) ' children ['
         endif
      else
         write(iun,'(''#VRML V1.0 ascii'')')
      endif

      if (fancy.eq.1.or.ivtwo.eq.2) then
         do i=1,iatoms
           ia = ianz(i)
           if (iaton(i).ge.1.and.ia.ne.100) then
            if (atcol.eq.1) then
               ic = icol(ia)
            else
               ic = iatclr(i)
            endif
            if (ivdwpl.eq.1) then
               call plvsph(iun,jcol,ic,coo(1,i),vdwr(ia)/toang)
            else
               call plvsph(iun,jcol,ic,coo(1,i),vrad(ia))
            endif
            n = iconn(1,i)
            if (n.ne.0) then
               do j=1,n
                 im = iconn(j+1,i)
                 m = abs(im)
                 ma = ianz(m)
                 if (iaton(m).ge.1.and.ma.ne.100.and.im.gt.0) then
c                    if (ia.ne.1.and.im.ne.1) then
                        rodrad = roddef*2
c                    else
c                        rodrad = roddef
c                    endif
                    ido = 1
                    if (ma.eq.ia) then
                       if (m.gt.i) then
                          do l=1,3
                             tmp(l) = coo(l,m)
                          end do
                       else
                          ido = 0
                       endif
                    else
                       do l=1,3
                          tmp(l) = 
     &                   (coo(l,m) - coo(l,i))/2.0d0 + coo(l,i)
                       end do
                    endif
                    if (ido.eq.1) then
                           call plvrod(iun,1,jcol,ic,
     &                          coo(1,i),tmp,rodrad)
                    endif
                 endif
               end do
            endif
           endif
         end do

         if (ivtwo.eq.2) goto 100
         if (ivtwo.eq.1) then
            write(iun,*) 'Transform {'
            write(iun,*) '  children ['
         else
            write(iun,*) 'Separator {'
         endif
         do k=1,15
            nat(k) = 0
         end do
         do i=1,iatoms
            if (iaton(i).ge.1.and.(i.gt.natorg.and.natorg.ne.0)) then
               k = iatclr(i)
               nat(k) = nat(k) + 1
            endif
         end do
         do k=1,15
            if (nat(k).gt.0) then
               call plvst(iun,jcol,k,0,.true.)
            endif
         end do
         if (ivtwo.eq.1) write(iun,*) '  ]'
         write(iun,*) '}'
100      continue
      else
c
c        multi colored sticks
c
         if (ivtwo.eq.1) then
            write(iun,*) 'Transform {'
            write(iun,*) '  children ['
         else
            write(iun,*) 'Separator {'
         endif

         if (atcol.eq.1) then
            kmax = mxel
         else
            kmax = 15
         endif
         do k=1,kmax
            nat(k) = 0
         end do
         do i=1,iatoms
            if (iaton(i).ge.1) then
               if (atcol.eq.1) then
                  k = ianz(i)
               else
                  k = iatclr(i)
               endif
               nat(k) = nat(k) + 1
            endif
         end do
         do k=1,kmax
            if (nat(k).gt.0) call plvst(iun,jcol,k,atcol,.false.)
         end do
         if (ivtwo.eq.1) write(iun,*) '  ]'
         write(iun,*) '}'
      endif

      if (doscnd) then
         do i=1,iatoms
           dsurf = .false.
           if (i.gt.natorg.and.natorg.ne.0) dsurf = .true.
           if (iaton(i).ge.1.and.ianz(i).eq.100.and..not.dsurf) then
              n = iconn(1,i)
              if (n.ne.0) then
                 do j=1,n
                    im = iconn(j+1,i)
                    m = abs(im)
                    if (iaton(m).ge.1.and.ianz(m).eq.100) then
                       ic = iatclr(i)
                       if (m.gt.i) then
                           call plvrod(iun,1,jcol,ic,
     &                          coo(1,i),coo(1,m),helrod)
                       else
                           if (n.eq.1) 
     &                     call plvsph(iun,jcol,ic,coo(1,i),helrod)
                       endif
                    endif
                 end do
              endif
           endif
         end do
      endif

      if (iclon.eq.1) then
          ic = 15
          do i=1,4
             ccell = clstr(i)
             do j=1,3
                 tmp(j) = coo(j,iclpnt(i))
             end do
             call pltxt(iun,jcol,ic,tmp,ccell,2)
          end do
      endif

      if (backb.eq.1.and.dolabs.eq.1) then
          ic = 15
          do k=1,nchain
             do j=ianf(k),islu(k)
                jj = j - ianf(k) + 1
                if (reson(j).eq.1) then
                   l = icalf(1,j)
                   do i=1,3
                      tmp(i) = coo(i,l)
                   end do
                   str = '             '
                   str(1:3) = aminos(iamino(j))
                   str(4:4) = ' '
                   write(str(5:8),'(i4)') jj
                   if (nchain.gt.1) then
                       str(9:9) = '.'
                       if (k.lt.10) str(10:10) = char(k+48)
                   endif
                   call pltxt(iun,jcol,ic,tmp,str,1)
                endif
             end do
          end do
      endif

      if (ivtwo.eq.1.and..not.dohead) write(iun,*) ']},'

c
c --- Close out the object, and display it --- FPA 2/27/2000
c
      if (ivtwo .eq. 2) then
        write(iun,*) '}'
        write(iun,*) 'object {molecule}'
      end if
c
      ihand = 0

      return
      end

      subroutine pltxt(iun,jcol,ic,c,str,isize)
      implicit double precision (a-h,o-z)
      common /vropt/ ivtwo,ihand,ivadd
      dimension jcol(3,16), c(3)
      character*(*) str

      if (ivtwo.eq.2) then
      elseif (ivtwo.eq.1) then
         write(iun,*) 'Transform {'
         write(iun,'(''  translation '',3f12.5)') (c(j),j=1,3)
         write(iun,*) '  children ['
         write(iun,*) '    Shape {'
         write(iun,*) '      appearance Appearance {'
         call plvcol(iun,jcol,ic,.false.)
         write(iun,*) '      }'
         write(iun,*) '      geometry Text {'
         write(iun,*) '        string ',
     &                char(34),str,char(34)
         write(iun,*) '        fontStyle FontStyle { size ',isize,' }'
         write(iun,*) '      }'
         write(iun,*) '    }'
         write(iun,*) '  ]'
         write(iun,*) '}'
      else
         write(iun,*) 'Separator {'
         call plvcol(iun,jcol,ic,.false.)
         write(iun,*) '   Transform {'
         write(iun,'(''      translation '',3f12.5)') (c(j),j=1,3)
         write(iun,*) '   }'
         write(iun,*) '   AsciiText { string ',
     &                char(34),str,char(34),' }'
         write(iun,*) '}'
      endif

      return
      end

      subroutine plvcol(iun,jcol,ic,emit)
      implicit double precision (a-h,o-z)
      logical emit
      common /vropt/ ivtwo,ihand,ivadd
      dimension jcol(3,16)

      if (ivtwo.eq.2) then

c        write(iun,*) '  texture {'
c        write(iun,
c     &  '(''pigment { color <'',f12.5,'','',f12.5,'','',f12.5,''> }'')')
c     &              (float(jcol(l,ic))/255,l=1,3)
c        write(iun,*) 
c     &  ' finish { ambient BSAMBI diffuse BSDIFF specular BSSPEC}'
c        write(iun,*) '  }'
         write(iun,*) 'texture { color',char(ic+64),' }'

      elseif (ivtwo.eq.1) then
         write(iun,*) '        material Material {'
      else
         write(iun,*) 'Material {'
      endif

      if (ivtwo.ne.2) then

           write(iun,'(''          diffuseColor  '',3f12.5)') 
     &              (float(jcol(l,ic))/255,l=1,3)
           if ((ivtwo.eq.0.or.ivtwo.eq.1).and.emit) then
              write(iun,'(''          emissiveColor '',3f12.5)') 
     &              (float(jcol(l,ic))/255,l=1,3)
           endif
           write(iun,*) '        }'

      endif


      return
      end

      subroutine plvcoo(iun,t)
      implicit double precision (a-h,o-z)
      dimension t(3)

      write(iun,'(f12.5,'' '',f12.5,'' '',f12.5,'','')') (t(l),l=1,3)

      return
      end

      subroutine plvrod(iun,iaddsp,jcol,ic,p1,p2,rad)
      implicit double precision (a-h,o-z)
      common /vropt/ ivtwo,ihand,ivadd
      dimension p1(3),p2(3),p3(3),v1(3),v2(3),v3(3)
      dimension jcol(3,16)

      do i=1,3
         v1(i) = p2(i) - p1(i)
         v2(i) = 0.0d0
         p3(i) = v1(i)/2.0d0 + p1(i)
      end do
      v2(2) = 1.0d0

      call impsc(v1,v2,cosa)
      if (dabs(cosa).eq.1.0d0) then
         angle = 0.0d0
         do i=1,3
            v3(i) = 0.0d0
         end do
         v3(2) = 1.0d0
      else
         angle = dacos(cosa)
         call crprod(v2,v1,v3)
         vl = vlen(v3)
         do i=1,3
            v3(i) = v3(i) / vl
         end do
      endif

      if (iaddsp.ne.0) call plvsph(iun,jcol,ic,p1,rad*.999d0)

      if (ivtwo.eq.2) then
         write(iun,*) 'cylinder {'
         if (ihand.eq.1) then
         write(iun,
     &   '(''<'',f12.5,'','',f12.5,'','',f12.5,''>, '',
     &     ''<'',f12.5,'','',f12.5,'','',f12.5,''>, '',f12.5)')
     &   -p1(2),p1(1),-p1(3),-p2(2),p2(1),-p2(3),rad
         else
         write(iun,
     &   '(''<'',f12.5,'','',f12.5,'','',f12.5,''>, '',
     &     ''<'',f12.5,'','',f12.5,'','',f12.5,''>, '',f12.5)')
     &   (p1(i),i=1,3),(p2(j),j=1,3),rad
         endif
         call plvcol(iun,jcol,ic,.false.)
         write(iun,*) '}'
      elseif (ivtwo.eq.1) then
         write(iun,*) 'Transform {'
         write(iun,'(''  translation '',3f12.5)') (p3(i),i=1,3)
         write(iun,'(''  rotation '',4f12.5)') (v3(i),i=1,3),angle
         write(iun,*) '  children ['
         write(iun,*) '    Shape {'
         write(iun,*) '      appearance Appearance {'
         call plvcol(iun,jcol,ic,.false.)
         write(iun,*) '      }'
         write(iun,*) '      geometry Cylinder {'
         write(iun,*) '         radius ',real(rad)
         write(iun,*) '         height ',real(vlen(v1))
         write(iun,*) '         top    FALSE'
         write(iun,*) '         bottom FALSE'
         write(iun,*) '      }'
         write(iun,*) '    }'
         write(iun,*) '  ]'
         write(iun,*) '}'
      elseif (ivtwo.eq.0) then
         write(iun,*) 'Separator {'
         call plvcol(iun,jcol,ic,.false.)
         write(iun,*) '   Transform {'
         write(iun,'(''      translation '',3f12.5)') (p3(i),i=1,3)
         write(iun,'(''      rotation '',4f12.5)') (v3(i),i=1,3),angle
         write(iun,*) '   }'
         write(iun,*) '   Cylinder {'
         write(iun,*) '      parts SIDES'
         write(iun,*) '      radius ',real(rad)
         write(iun,*) '      height ',real(vlen(v1))
         write(iun,*) '   }'
         write(iun,*) '}'
      endif

      return
      end

      subroutine plvsph(iun,jcol,ic,p1,rad)
      implicit double precision (a-h,o-z)
      common /vropt/ ivtwo,ihand,ivadd
      dimension p1(3)
      dimension jcol(3,16)

      if (ivtwo.eq.2) then
         write(iun,'(''sphere { '')')
         if (ihand.eq.1) then
         write(iun,
     &   '(''<'',f12.5,'','',f12.5,'','',f12.5,''>, '',f12.5)')
     &   -p1(2),p1(1),-p1(3),rad
         else
         write(iun,
     &   '(''<'',f12.5,'','',f12.5,'','',f12.5,''>, '',f12.5)')
     &   (p1(i),i=1,3),rad
         endif
         call plvcol(iun,jcol,ic,.false.)
         write(iun,'('' }'')')
      elseif (ivtwo.eq.1) then
         write(iun,*) 'Transform {'
         write(iun,'(''  translation '',3f12.5)') (p1(i),i=1,3)
         write(iun,*) '  children ['
         write(iun,*) '    Shape {'
         write(iun,*) '      appearance Appearance {'
         call plvcol(iun,jcol,ic,.false.)
         write(iun,*) '      }'
         write(iun,'(''      geometry Sphere { radius '',f10.5,'' }'')')
     &                 rad
         write(iun,*) '    }'
         write(iun,*) '  ]'
         write(iun,*) '}'
      elseif (ivtwo.eq.0) then
         write(iun,*) 'Separator {'
         call plvcol(iun,jcol,ic,.false.)
         write(iun,*) '   Transform {'
         write(iun,'(''      translation '',3f12.5)') (p1(i),i=1,3)
         write(iun,*) '   }'
         write(iun,'(''   Sphere { radius '',f10.5,'' }'')') rad
         write(iun,*) '}'
      endif

      return
      end

      subroutine plvsd(iun,jcol,k,atcol,hndexl,
     &                 coo,ianz,iaton,iatclr,iconn)
      implicit double precision (a-h,o-z)
      parameter (mxel=100)
      parameter (mxcon=10)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat
      common /vropt/ ivtwo,ihand,ivadd
      logical hndexl
      integer atcol
      dimension jcol(3,16), tmp(3)
      dimension coo(3,*),ianz(*),iaton(*),iatclr(*),iconn(mxcon+1,*)

      if (atcol.eq.1) then
         ic = icol(k)
         if (k.eq.6) ic = 10
      else
         ic = k
      endif

      if (ivtwo.eq.1) then
         write(iun,*) '    Shape {'
         write(iun,*) '      appearance Appearance {'
         call plvcol(iun,jcol,ic,.true.)
         write(iun,*) '      }'
         write(iun,*) '      geometry IndexedLineSet {'
         write(iun,*) '        coord Coordinate { point ['
      else
         call plvcol(iun,jcol,ic,.true.)
         write(iun,*) 'Coordinate3 { point ['
      endif

c
      do i=1,iatoms
        iaa = ianz(i)
        if (atcol.eq.1) then
           ia = iaa
        else
           ia = iatclr(i)
           if (hndexl.and.iaa.ne.100) ia = 0
        endif
        if (iaton(i).ge.1.and.ia.eq.k) then
         n = iconn(1,i)
         if (n.ne.0) then
            call plvcoo(iun,coo(1,i))
            do j=1,n
              im = iconn(j+1,i)
              m = abs(im)
              if (atcol.eq.1) then
                 ma = ianz(m)
              else
                 ma = iatclr(m)
              endif
              if (iaton(m).ge.1) then
                 ido = 1
                 if (ma.eq.k) then
                    if (m.gt.i) then
                       do l=1,3
                          tmp(l) = coo(l,m)
                       end do
                    else
                       ido = 0
                    endif
                 else
                    do l=1,3
                       tmp(l) = 
     &                (coo(l,m) - coo(l,i))/2.0d0 + coo(l,i)
                    end do
                 endif
                 if (ido.eq.1) call plvcoo(iun,tmp)
              endif
            end do
         endif
        endif
      end do
      write(iun,*) ']}'
c
      if (ivtwo.eq.1) then
         write(iun,*) '        coordIndex ['
      else
         write(iun,*) 'IndexedLineSet { coordIndex ['
      endif

      icnt = 0
      do i=1,iatoms
        iaa = ianz(i)
        if (atcol.eq.1) then
           ia = iaa
        else
           ia = iatclr(i)
           if (hndexl.and.iaa.ne.100) ia = 0
        endif
        if (iaton(i).ge.1.and.ia.eq.k) then
         n = iconn(1,i)
         if (n.ne.0) then
            itmp = icnt
            icnt = icnt + 1
            do j=1,n
              im = iconn(j+1,i)
              m = abs(im)
              if (atcol.eq.1) then
                 ma = ianz(m)
              else
                 ma = iatclr(m)
              endif
              if (iaton(m).ge.1) then
                 ido = 1
                 if (ma.eq.k.and.m.le.i) ido = 0
                 if (ido.eq.1) then
                  write(iun,'(i5,'','',i5,'',-1,'')') 
     &                  itmp,icnt
                  icnt = icnt + 1
                 endif
              endif
            end do
         endif
        endif
      end do
      if (ivtwo.eq.1) then
         write(iun,*) '        ]'
      else
         write(iun,*) ']}'
      endif

      if (ivtwo.eq.1) then
         write(iun,*) '      }'
         write(iun,*) '    }'
      endif

      return
      end

      subroutine plvmol(iun,npts,adjus)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /atopla/ xsym(numatm),ysym(numatm),zsym(numatm),
     &                isym(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /vrcol/ jcol(3,16)
      logical opfil
      dimension tmp1(3),tmp2(3),tmp3(3)

      roddef = (0.115d0/0.52917706d0)/r(1)
      if (adjus.eq.1.0d0) roddef = roddef*0.52917706d0

      if (opfil(43,'molden_connect',14,1,1,1)) then

         call messg(7)
         do i=1,natoms
            ia = nat(i)
            ic = icol(ia)
            tmp1(1) = -ysym(i) / r(1)
            tmp1(2) = -xsym(i) / r(1)
            tmp1(3) = -zsym(i) / r(1)
            call plvsph(iun,jcol,ic,tmp1,roddef)
         end do

         do while (.true.)

            read(43,*,end=100) i1,i2
            ia = nat(i1)
            ic = icol(ia)
            tmp1(1) = -ysym(i1) / r(1)
            tmp1(2) = -xsym(i1) / r(1)
            tmp1(3) = -zsym(i1) / r(1)
            if (i2.lt.0) then
               read(43,*,end=100) j1,j2,j3,j4,j5
               ja = nat(j1)
               nc = 0
               tmp2(1) = 0.0d0
               tmp2(2) = 0.0d0
               tmp2(3) = 0.0d0
               if (j1.ne.0) then
                  tmp2(1) = tmp2(1) - ysym(j1) / r(1)
                  tmp2(2) = tmp2(2) - xsym(j1) / r(1)
                  tmp2(3) = tmp2(3) - zsym(j1) / r(1)
                  nc = nc + 1
               endif
               if (j2.ne.0) then
                  tmp2(1) = tmp2(1) - ysym(j2) / r(1)
                  tmp2(2) = tmp2(2) - xsym(j2) / r(1)
                  tmp2(3) = tmp2(3) - zsym(j2) / r(1)
                  nc = nc + 1
               endif
               if (j3.ne.0) then
                  tmp2(1) = tmp2(1) - ysym(j3) / r(1)
                  tmp2(2) = tmp2(2) - xsym(j3) / r(1)
                  tmp2(3) = tmp2(3) - zsym(j3) / r(1)
                  nc = nc + 1
               endif
               if (j4.ne.0) then
                  tmp2(1) = tmp2(1) - ysym(j4) / r(1)
                  tmp2(2) = tmp2(2) - xsym(j4) / r(1)
                  tmp2(3) = tmp2(3) - zsym(j4) / r(1)
                  nc = nc + 1
               endif
               if (j5.ne.0) then
                  tmp2(1) = tmp2(1) - ysym(j5) / r(1)
                  tmp2(2) = tmp2(2) - xsym(j5) / r(1)
                  tmp2(3) = tmp2(3) - zsym(j5) / r(1)
                  nc = nc + 1
               endif
               do i=1,3
                  tmp2(i) = tmp2(i) / dble(nc)
               end do
               call plvsph(iun,jcol,icol(ja),tmp2,roddef)
            else
               ja = nat(i2)
               tmp2(1) = -ysym(i2) / r(1)
               tmp2(2) = -xsym(i2) / r(1)
               tmp2(3) = -zsym(i2) / r(1)
            endif
            if (ja.eq.ia) then
               do l=1,3
                  tmp3(l) = tmp2(l)
               end do
               call plvrod(iun,0,jcol,ic,tmp1,tmp3,roddef)
            else
               do l=1,3
                  tmp3(l) = 
     &           (tmp2(l) - tmp1(l))/2.0d0 + tmp1(l)
               end do
               call plvrod(iun,0,jcol,ic,tmp1,tmp3,roddef)
               ic = icol(ja)
               do l=1,3
                  tmp1(l) = tmp2(l)
               end do
               call plvrod(iun,0,jcol,ic,tmp1,tmp3,roddef)
            endif

         end do
100      close(43)
         return
      endif

      do i=1,natoms
         ia = nat(i)
         ic = icol(ia)
         tmp1(1) = -ysym(i) / r(1)
         tmp1(2) = -xsym(i) / r(1)
         tmp1(3) = -zsym(i) / r(1)
         call plvsph(iun,jcol,ic,tmp1,roddef)
         do j=1,natoms
            ja = nat(j)
            tmp2(1) = -ysym(j) / r(1)
            tmp2(2) = -xsym(j) / r(1)
            tmp2(3) = -zsym(j) / r(1)
            dmaxsq = (vdwr(ia) + vdwr(ja))**2
            dijsq = ((xyz(1,i)-xyz(1,j))*adjus)**2
     &             +((xyz(2,i)-xyz(2,j))*adjus)**2
     &             +((xyz(3,i)-xyz(3,j))*adjus)**2
            if (dijsq.lt.dmaxsq) then
                 ido = 1
                 if (ja.eq.ia) then
                    if (j.gt.i) then
                       do l=1,3
                          tmp3(l) = tmp2(l)
                       end do
                    else
                       ido = 0
                    endif
                 else
                    do l=1,3
                       tmp3(l) = 
     &                (tmp2(l) - tmp1(l))/2.0d0 + tmp1(l)
                    end do
                 endif
                 if (ido.eq.1) then
                        call plvrod(iun,0,jcol,ic,
     &                       tmp1,tmp3,roddef)
                 endif
              endif
         end do
      end do

      return
      end

      subroutine calcgr(ind,jnd,knd,fvals,griddim,xydim,scale,gr)
      implicit double precision (a-h,o-z), integer ( i-n)
      integer griddim(3), xydim
      integer dir(3), dir1(3), dir2(3)
      dimension fvals(*),scale(3),gr(3)

      
      dir(1) = ind
      dir(2) = jnd
      dir(3) = knd

      do i=1,3
        fact = 1.0d0
        do j=1,3
            dir1(j) = dir(j)
            dir2(j) = dir(j)
        end do
        if (dir(i).eq.0) then
            dir2(i) = dir2(i) + 1
        elseif (dir(i).eq.(griddim(i)-1)) then
            dir1(i) = dir1(i) - 1
        else
            dir1(i) = dir1(i) - 1
            dir2(i) = dir2(i) + 1
            fact = 0.5d0
        endif
        f2 = fvals(dir2(1) + dir2(2)*griddim(1) + dir2(3)*xydim)
        f1 = fvals(dir1(1) + dir1(2)*griddim(1) + dir1(3)*xydim)
        gr(i) = fact * (f2 - f1) / scale(i)

c        f3 = fvals(dir(1) + dir(2)*griddim(1) + dir(3)*xydim)
c        if (dir(i).eq.0.or.dir(i).eq.(griddim(i)-1)) then
c           gr(i) = fact * (f2 - f1) / scale(i)
c        else
c           gr(i) = fact * ((f3 - f1) + (f2-f3)) / scale(i)
c        endif
      end do

      return
      end



      subroutine mcubes(nx,ny,nz,fvals,fmap,mapit,origin,cntval1,
     &                  cntval2,rad,orb,dolap,lapdbl,trans,iun)
c>>>
c>>> Added Common Block /vrcol/ to get the colors  FPA 3/07/2000
c>>>
      implicit double precision (a-h,o-z), integer ( i-n)
      integer trans, griddim(3), xydim, casemask(8)
      integer cases
      integer orb,iptr,pptr,wpass,npass,tptr,caseptr,findex,posneg
      logical dolap,lapdbl,cneg,utrian
      character*80 lstr
      common /cubes/ cases(16,256),lines(2,12)
      common /vrcol/ jcol(3,16)
      common /vropt/ ivtwo,ihand,ivadd
      common /grdhlp/ mx3d,mx3d2
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      logical valenc,bonds,ovrlap,atomic,doori,dum,doelf
      common /option/ idum,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dum,doelf
      common /psa/   psa, tsa, exs, pol, pol2, epmin, epmax, ipsa,
     &               icpsa, idtpsa
c>>>
c --- variables for POV macros --- FPA 3/7/2000
      integer colors
      double precision colrgb
      dimension colrgb(3)
c ---                          ---
c>>>
      dimension index(3), linepts(2)
      dimension fvals(*),fmap(*),origin(3),scale(3),cntvls(2)
      dimension grd(3),xyz(3),txyz(3,3),tgrd(3,3),cval(3),g(3),c(3)
      dimension cubval(8), cbmval(8), cubxyz(8,3), cubgr(3,8),rad(3)
      dimension tc(3,3),col(3)
      data casemask /1,2,4,8,16,32,64,128/
      data lines /1,2,2,3,4,3,1,4,5,6,6,7,8,7,5,8,1,5,2,6,4,8,3,7/
      data ((cases(i,j),i=1,16),j=1,50) /
     & -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,3,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,1,9,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,8,3,9,8,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,3,1,2,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 9,2,11,0,2,9,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 2,8,3,2,11,8,11,9,8,-1,-1,-1,-1,-1,-1,-1,
     & 3,10,2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,10,2,8,10,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,9,0,2,3,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,10,2,1,9,10,9,8,10,-1,-1,-1,-1,-1,-1,-1,
     & 3,11,1,10,11,3,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,11,1,0,8,11,8,10,11,-1,-1,-1,-1,-1,-1,-1,
     & 3,9,0,3,10,9,10,11,9,-1,-1,-1,-1,-1,-1,-1,
     & 9,8,11,11,8,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,7,8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,3,0,7,3,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,1,9,8,4,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,1,9,4,7,1,7,3,1,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,11,8,4,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 3,4,7,3,0,4,1,2,11,-1,-1,-1,-1,-1,-1,-1,
     & 9,2,11,9,0,2,8,4,7,-1,-1,-1,-1,-1,-1,-1,
     & 2,11,9,2,9,7,2,7,3,7,9,4,-1,-1,-1,-1,
     & 8,4,7,3,10,2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 10,4,7,10,2,4,2,0,4,-1,-1,-1,-1,-1,-1,-1,
     & 9,0,1,8,4,7,2,3,10,-1,-1,-1,-1,-1,-1,-1,
     & 4,7,10,9,4,10,9,10,2,9,2,1,-1,-1,-1,-1,
     & 3,11,1,3,10,11,7,8,4,-1,-1,-1,-1,-1,-1,-1,
     & 1,10,11,1,4,10,1,0,4,7,10,4,-1,-1,-1,-1,
     & 4,7,8,9,0,10,9,10,11,10,0,3,-1,-1,-1,-1,
     & 4,7,10,4,10,9,9,10,11,-1,-1,-1,-1,-1,-1,-1,
     & 9,5,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 9,5,4,0,8,3,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,5,4,1,5,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 8,5,4,8,3,5,3,1,5,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,11,9,5,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 3,0,8,1,2,11,4,9,5,-1,-1,-1,-1,-1,-1,-1,
     & 5,2,11,5,4,2,4,0,2,-1,-1,-1,-1,-1,-1,-1,
     & 2,11,5,3,2,5,3,5,4,3,4,8,-1,-1,-1,-1,
     & 9,5,4,2,3,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,10,2,0,8,10,4,9,5,-1,-1,-1,-1,-1,-1,-1,
     & 0,5,4,0,1,5,2,3,10,-1,-1,-1,-1,-1,-1,-1,
     & 2,1,5,2,5,8,2,8,10,4,8,5,-1,-1,-1,-1,
     & 11,3,10,11,1,3,9,5,4,-1,-1,-1,-1,-1,-1,-1,
     & 4,9,5,0,8,1,8,11,1,8,10,11,-1,-1,-1,-1,
     & 5,4,0,5,0,10,5,10,11,10,0,3,-1,-1,-1,-1,
     & 5,4,8,5,8,11,11,8,10,-1,-1,-1,-1,-1,-1,-1,
     & 9,7,8,5,7,9,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 9,3,0,9,5,3,5,7,3,-1,-1,-1,-1,-1,-1,-1/
      data ((cases(i,j),i=1,16),j=51,100) /
     & 0,7,8,0,1,7,1,5,7,-1,-1,-1,-1,-1,-1,-1,
     & 1,5,3,3,5,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 9,7,8,9,5,7,11,1,2,-1,-1,-1,-1,-1,-1,-1,
     & 11,1,2,9,5,0,5,3,0,5,7,3,-1,-1,-1,-1,
     & 8,0,2,8,2,5,8,5,7,11,5,2,-1,-1,-1,-1,
     & 2,11,5,2,5,3,3,5,7,-1,-1,-1,-1,-1,-1,-1,
     & 7,9,5,7,8,9,3,10,2,-1,-1,-1,-1,-1,-1,-1,
     & 9,5,7,9,7,2,9,2,0,2,7,10,-1,-1,-1,-1,
     & 2,3,10,0,1,8,1,7,8,1,5,7,-1,-1,-1,-1,
     & 10,2,1,10,1,7,7,1,5,-1,-1,-1,-1,-1,-1,-1,
     & 9,5,8,8,5,7,11,1,3,11,3,10,-1,-1,-1,-1,
     & 5,7,0,5,0,9,7,10,0,1,0,11,10,11,0,-1,
     & 10,11,0,10,0,3,11,5,0,8,0,7,5,7,0,-1,
     & 10,11,5,7,10,5,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 11,6,5,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,3,5,11,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 9,0,1,5,11,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,8,3,1,9,8,5,11,6,-1,-1,-1,-1,-1,-1,-1,
     & 1,6,5,2,6,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,6,5,1,2,6,3,0,8,-1,-1,-1,-1,-1,-1,-1,
     & 9,6,5,9,0,6,0,2,6,-1,-1,-1,-1,-1,-1,-1,
     & 5,9,8,5,8,2,5,2,6,3,2,8,-1,-1,-1,-1,
     & 2,3,10,11,6,5,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 10,0,8,10,2,0,11,6,5,-1,-1,-1,-1,-1,-1,-1,
     & 0,1,9,2,3,10,5,11,6,-1,-1,-1,-1,-1,-1,-1,
     & 5,11,6,1,9,2,9,10,2,9,8,10,-1,-1,-1,-1,
     & 6,3,10,6,5,3,5,1,3,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,10,0,10,5,0,5,1,5,10,6,-1,-1,-1,-1,
     & 3,10,6,0,3,6,0,6,5,0,5,9,-1,-1,-1,-1,
     & 6,5,9,6,9,10,10,9,8,-1,-1,-1,-1,-1,-1,-1,
     & 5,11,6,4,7,8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,3,0,4,7,3,6,5,11,-1,-1,-1,-1,-1,-1,-1,
     & 1,9,0,5,11,6,8,4,7,-1,-1,-1,-1,-1,-1,-1,
     & 11,6,5,1,9,7,1,7,3,7,9,4,-1,-1,-1,-1,
     & 6,1,2,6,5,1,4,7,8,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,5,5,2,6,3,0,4,3,4,7,-1,-1,-1,-1,
     & 8,4,7,9,0,5,0,6,5,0,2,6,-1,-1,-1,-1,
     & 7,3,9,7,9,4,3,2,9,5,9,6,2,6,9,-1,
     & 3,10,2,7,8,4,11,6,5,-1,-1,-1,-1,-1,-1,-1,
     & 5,11,6,4,7,2,4,2,0,2,7,10,-1,-1,-1,-1,
     & 0,1,9,4,7,8,2,3,10,5,11,6,-1,-1,-1,-1,
     & 9,2,1,9,10,2,9,4,10,7,10,4,5,11,6,-1,
     & 8,4,7,3,10,5,3,5,1,5,10,6,-1,-1,-1,-1,
     & 5,1,10,5,10,6,1,0,10,7,10,4,0,4,10,-1,
     & 0,5,9,0,6,5,0,3,6,10,6,3,8,4,7,-1,
     & 6,5,9,6,9,10,4,7,9,7,10,9,-1,-1,-1,-1,
     & 11,4,9,6,4,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,11,6,4,9,11,0,8,3,-1,-1,-1,-1,-1,-1,-1,
     & 11,0,1,11,6,0,6,4,0,-1,-1,-1,-1,-1,-1,-1,
     & 8,3,1,8,1,6,8,6,4,6,1,11,-1,-1,-1,-1/
      data ((cases(i,j),i=1,16),j=101,150) /
     & 1,4,9,1,2,4,2,6,4,-1,-1,-1,-1,-1,-1,-1,
     & 3,0,8,1,2,9,2,4,9,2,6,4,-1,-1,-1,-1,
     & 0,2,4,4,2,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 8,3,2,8,2,4,4,2,6,-1,-1,-1,-1,-1,-1,-1,
     & 11,4,9,11,6,4,10,2,3,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,2,2,8,10,4,9,11,4,11,6,-1,-1,-1,-1,
     & 3,10,2,0,1,6,0,6,4,6,1,11,-1,-1,-1,-1,
     & 6,4,1,6,1,11,4,8,1,2,1,10,8,10,1,-1,
     & 9,6,4,9,3,6,9,1,3,10,6,3,-1,-1,-1,-1,
     & 8,10,1,8,1,0,10,6,1,9,1,4,6,4,1,-1,
     & 3,10,6,3,6,0,0,6,4,-1,-1,-1,-1,-1,-1,-1,
     & 6,4,8,10,6,8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 7,11,6,7,8,11,8,9,11,-1,-1,-1,-1,-1,-1,-1,
     & 0,7,3,0,11,7,0,9,11,6,7,11,-1,-1,-1,-1,
     & 11,6,7,1,11,7,1,7,8,1,8,0,-1,-1,-1,-1,
     & 11,6,7,11,7,1,1,7,3,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,6,1,6,8,1,8,9,8,6,7,-1,-1,-1,-1,
     & 2,6,9,2,9,1,6,7,9,0,9,3,7,3,9,-1,
     & 7,8,0,7,0,6,6,0,2,-1,-1,-1,-1,-1,-1,-1,
     & 7,3,2,6,7,2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 2,3,10,11,6,8,11,8,9,8,6,7,-1,-1,-1,-1,
     & 2,0,7,2,7,10,0,9,7,6,7,11,9,11,7,-1,
     & 1,8,0,1,7,8,1,11,7,6,7,11,2,3,10,-1,
     & 10,2,1,10,1,7,11,6,1,6,7,1,-1,-1,-1,-1,
     & 8,9,6,8,6,7,9,1,6,10,6,3,1,3,6,-1,
     & 0,9,1,10,6,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 7,8,0,7,0,6,3,10,0,10,6,0,-1,-1,-1,-1,
     & 7,10,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 7,6,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 3,0,8,10,7,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,1,9,10,7,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 8,1,9,8,3,1,10,7,6,-1,-1,-1,-1,-1,-1,-1,
     & 11,1,2,6,10,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,11,3,0,8,6,10,7,-1,-1,-1,-1,-1,-1,-1,
     & 2,9,0,2,11,9,6,10,7,-1,-1,-1,-1,-1,-1,-1,
     & 6,10,7,2,11,3,11,8,3,11,9,8,-1,-1,-1,-1,
     & 7,2,3,6,2,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 7,0,8,7,6,0,6,2,0,-1,-1,-1,-1,-1,-1,-1,
     & 2,7,6,2,3,7,0,1,9,-1,-1,-1,-1,-1,-1,-1,
     & 1,6,2,1,8,6,1,9,8,8,7,6,-1,-1,-1,-1,
     & 11,7,6,11,1,7,1,3,7,-1,-1,-1,-1,-1,-1,-1,
     & 11,7,6,1,7,11,1,8,7,1,0,8,-1,-1,-1,-1,
     & 0,3,7,0,7,11,0,11,9,6,11,7,-1,-1,-1,-1,
     & 7,6,11,7,11,8,8,11,9,-1,-1,-1,-1,-1,-1,-1,
     & 6,8,4,10,8,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 3,6,10,3,0,6,0,4,6,-1,-1,-1,-1,-1,-1,-1,
     & 8,6,10,8,4,6,9,0,1,-1,-1,-1,-1,-1,-1,-1,
     & 9,4,6,9,6,3,9,3,1,10,3,6,-1,-1,-1,-1,
     & 6,8,4,6,10,8,2,11,1,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,11,3,0,10,0,6,10,0,4,6,-1,-1,-1,-1/
      data ((cases(i,j),i=1,16),j=151,200) /
     & 4,10,8,4,6,10,0,2,9,2,11,9,-1,-1,-1,-1,
     & 11,9,3,11,3,2,9,4,3,10,3,6,4,6,3,-1,
     & 8,2,3,8,4,2,4,6,2,-1,-1,-1,-1,-1,-1,-1,
     & 0,4,2,4,6,2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,9,0,2,3,4,2,4,6,4,3,8,-1,-1,-1,-1,
     & 1,9,4,1,4,2,2,4,6,-1,-1,-1,-1,-1,-1,-1,
     & 8,1,3,8,6,1,8,4,6,6,11,1,-1,-1,-1,-1,
     & 11,1,0,11,0,6,6,0,4,-1,-1,-1,-1,-1,-1,-1,
     & 4,6,3,4,3,8,6,11,3,0,3,9,11,9,3,-1,
     & 11,9,4,6,11,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,9,5,7,6,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,3,4,9,5,10,7,6,-1,-1,-1,-1,-1,-1,-1,
     & 5,0,1,5,4,0,7,6,10,-1,-1,-1,-1,-1,-1,-1,
     & 10,7,6,8,3,4,3,5,4,3,1,5,-1,-1,-1,-1,
     & 9,5,4,11,1,2,7,6,10,-1,-1,-1,-1,-1,-1,-1,
     & 6,10,7,1,2,11,0,8,3,4,9,5,-1,-1,-1,-1,
     & 7,6,10,5,4,11,4,2,11,4,0,2,-1,-1,-1,-1,
     & 3,4,8,3,5,4,3,2,5,11,5,2,10,7,6,-1,
     & 7,2,3,7,6,2,5,4,9,-1,-1,-1,-1,-1,-1,-1,
     & 9,5,4,0,8,6,0,6,2,6,8,7,-1,-1,-1,-1,
     & 3,6,2,3,7,6,1,5,0,5,4,0,-1,-1,-1,-1,
     & 6,2,8,6,8,7,2,1,8,4,8,5,1,5,8,-1,
     & 9,5,4,11,1,6,1,7,6,1,3,7,-1,-1,-1,-1,
     & 1,6,11,1,7,6,1,0,7,8,7,0,9,5,4,-1,
     & 4,0,11,4,11,5,0,3,11,6,11,7,3,7,11,-1,
     & 7,6,11,7,11,8,5,4,11,4,8,11,-1,-1,-1,-1,
     & 6,9,5,6,10,9,10,8,9,-1,-1,-1,-1,-1,-1,-1,
     & 3,6,10,0,6,3,0,5,6,0,9,5,-1,-1,-1,-1,
     & 0,10,8,0,5,10,0,1,5,5,6,10,-1,-1,-1,-1,
     & 6,10,3,6,3,5,5,3,1,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,11,9,5,10,9,10,8,10,5,6,-1,-1,-1,-1,
     & 0,10,3,0,6,10,0,9,6,5,6,9,1,2,11,-1,
     & 10,8,5,10,5,6,8,0,5,11,5,2,0,2,5,-1,
     & 6,10,3,6,3,5,2,11,3,11,5,3,-1,-1,-1,-1,
     & 5,8,9,5,2,8,5,6,2,3,8,2,-1,-1,-1,-1,
     & 9,5,6,9,6,0,0,6,2,-1,-1,-1,-1,-1,-1,-1,
     & 1,5,8,1,8,0,5,6,8,3,8,2,6,2,8,-1,
     & 1,5,6,2,1,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,3,6,1,6,11,3,8,6,5,6,9,8,9,6,-1,
     & 11,1,0,11,0,6,9,5,0,5,6,0,-1,-1,-1,-1,
     & 0,3,8,5,6,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 11,5,6,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 10,5,11,7,5,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 10,5,11,10,7,5,8,3,0,-1,-1,-1,-1,-1,-1,-1,
     & 5,10,7,5,11,10,1,9,0,-1,-1,-1,-1,-1,-1,-1,
     & 11,7,5,11,10,7,9,8,1,8,3,1,-1,-1,-1,-1,
     & 10,1,2,10,7,1,7,5,1,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,3,1,2,7,1,7,5,7,2,10,-1,-1,-1,-1,
     & 9,7,5,9,2,7,9,0,2,2,10,7,-1,-1,-1,-1,
     & 7,5,2,7,2,10,5,9,2,3,2,8,9,8,2,-1/
      data ((cases(i,j),i=1,16),j=201,250) /
     & 2,5,11,2,3,5,3,7,5,-1,-1,-1,-1,-1,-1,-1,
     & 8,2,0,8,5,2,8,7,5,11,2,5,-1,-1,-1,-1,
     & 9,0,1,5,11,3,5,3,7,3,11,2,-1,-1,-1,-1,
     & 9,8,2,9,2,1,8,7,2,11,2,5,7,5,2,-1,
     & 1,3,5,3,7,5,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,7,0,7,1,1,7,5,-1,-1,-1,-1,-1,-1,-1,
     & 9,0,3,9,3,5,5,3,7,-1,-1,-1,-1,-1,-1,-1,
     & 9,8,7,5,9,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 5,8,4,5,11,8,11,10,8,-1,-1,-1,-1,-1,-1,-1,
     & 5,0,4,5,10,0,5,11,10,10,3,0,-1,-1,-1,-1,
     & 0,1,9,8,4,11,8,11,10,11,4,5,-1,-1,-1,-1,
     & 11,10,4,11,4,5,10,3,4,9,4,1,3,1,4,-1,
     & 2,5,1,2,8,5,2,10,8,4,5,8,-1,-1,-1,-1,
     & 0,4,10,0,10,3,4,5,10,2,10,1,5,1,10,-1,
     & 0,2,5,0,5,9,2,10,5,4,5,8,10,8,5,-1,
     & 9,4,5,2,10,3,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 2,5,11,3,5,2,3,4,5,3,8,4,-1,-1,-1,-1,
     & 5,11,2,5,2,4,4,2,0,-1,-1,-1,-1,-1,-1,-1,
     & 3,11,2,3,5,11,3,8,5,4,5,8,0,1,9,-1,
     & 5,11,2,5,2,4,1,9,2,9,4,2,-1,-1,-1,-1,
     & 8,4,5,8,5,3,3,5,1,-1,-1,-1,-1,-1,-1,-1,
     & 0,4,5,1,0,5,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 8,4,5,8,5,3,9,0,5,0,3,5,-1,-1,-1,-1,
     & 9,4,5,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,10,7,4,9,10,9,11,10,-1,-1,-1,-1,-1,-1,-1,
     & 0,8,3,4,9,7,9,10,7,9,11,10,-1,-1,-1,-1,
     & 1,11,10,1,10,4,1,4,0,7,4,10,-1,-1,-1,-1,
     & 3,1,4,3,4,8,1,11,4,7,4,10,11,10,4,-1,
     & 4,10,7,9,10,4,9,2,10,9,1,2,-1,-1,-1,-1,
     & 9,7,4,9,10,7,9,1,10,2,10,1,0,8,3,-1,
     & 10,7,4,10,4,2,2,4,0,-1,-1,-1,-1,-1,-1,-1,
     & 10,7,4,10,4,2,8,3,4,3,2,4,-1,-1,-1,-1,
     & 2,9,11,2,7,9,2,3,7,7,4,9,-1,-1,-1,-1,
     & 9,11,7,9,7,4,11,2,7,8,7,0,2,0,7,-1,
     & 3,7,11,3,11,2,7,4,11,1,11,0,4,0,11,-1,
     & 1,11,2,8,7,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,9,1,4,1,7,7,1,3,-1,-1,-1,-1,-1,-1,-1,
     & 4,9,1,4,1,7,0,8,1,8,7,1,-1,-1,-1,-1,
     & 4,0,3,7,4,3,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 4,8,7,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 9,11,8,11,10,8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 3,0,9,3,9,10,10,9,11,-1,-1,-1,-1,-1,-1,-1,
     & 0,1,11,0,11,8,8,11,10,-1,-1,-1,-1,-1,-1,-1,
     & 3,1,11,10,3,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,2,10,1,10,9,9,10,8,-1,-1,-1,-1,-1,-1,-1,
     & 3,0,9,3,9,10,1,2,9,2,10,9,-1,-1,-1,-1,
     & 0,2,10,8,0,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 3,2,10,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 2,3,8,2,8,11,11,8,9,-1,-1,-1,-1,-1,-1,-1,
     & 9,11,2,0,9,2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/
      data ((cases(i,j),i=1,16),j=251,256) /
     & 2,3,8,2,8,11,0,1,8,1,11,8,-1,-1,-1,-1,
     & 1,11,2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 1,3,8,9,1,8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,9,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & 0,3,8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     & -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/
  
      emax  = -1000000.0d0
      emin  =  1000000.0d0
      epmax = -1000000.0d0
      epmin =  1000000.0d0
      psa   = 0.0d0
      tsa   = 0.0d0
      exs   = 0.0d0

c ityp
c  0   orbital
c  1   normal density
c  2   laplacian
c  3   mapped electrostatic potential
c  4   electrostatic potential
c  5   difference density
c  6   unknown

      ityp = 0
      if (orb.eq.0) then
         if (doelf) then
            ityp = 6
         elseif (trans.eq.1) then
            ityp = 1
         elseif (dolap) then
            ityp = 2
         elseif (mapit.eq.1) then
            ityp = 3
         elseif (molpot.or.elpot.or.chpot) then
            ityp = 4
         elseif (bonds) then
            ityp = 5
         else
            ityp = 7
         endif
      else
         ityp = 0
      endif

      icolver = 0
      if (mapit.eq.1.and.ivtwo.eq.1) then
         open(unit=47,form='formatted',status='scratch',err=10)
         icolver = 1
      endif
10    continue
      
      griddim(1) = nx
      griddim(2) = ny
      griddim(3) = nz

c rad(2) slaat op scale(1) en griddim(1)

      do i=1,3
          scale(i) = 1.0d0/(griddim(i)-1.0d0)
      end do
      scale(1) = scale(1) * rad(2) / rad(1)
      scale(3) = scale(3) * rad(3) / rad(1)

      cntvls(1) = cntval1
      cntvls(2) = cntval2

      npass = 3
      if (trans.eq.1.or.(dolap.and..not.lapdbl).or.
     &    mapit.eq.1) npass = 2
      if (ivtwo.eq.4) then
          npass = 3
          if (trans.eq.1.or.(dolap.and..not.lapdbl).or.
     &        mapit.eq.1) npass = 1
      endif

      do wpass=0,npass
         if (wpass.eq.0) then
             if (ivtwo.eq.3.or.ivtwo.eq.4) then
             elseif (ivtwo.eq.2) then
                write(iun,'(''camera {'')')
                write(iun,*) 'location <0.0, 0.0, 3.0>'
                write(iun,*) 'look_at <0.0, 0.0, 0.0>'
                write(iun,*) 'angle 15'
                write(iun,'(''}'')')
                write(iun,*) 
     &            'light_source { <9, 9, 9> color rgb<1, 1, 1> }'
                write(iun,*) '#declare MeshGold = texture {'
                write(iun,*) 
     &              'pigment { color rgbf<0.96, 0.82, 0.65, 0.7> }'
                write(iun,*) 
     &             'finish { ambient 0.4 diffuse 0.4 specular 0.9}'
                write(iun,*) '}'
                write(iun,*) '#declare MeshRed = texture {'
                write(iun,*) 
     &             'pigment { color rgbf<0.8, 0.2, 0.2, 0.7> }'
                write(iun,*) 
     &             'finish { ambient 0.2 diffuse 0.6 specular 0.9}'
                write(iun,*) '}'
                write(iun,*) '#declare MeshBlue = texture {'
                write(iun,*) 
     &             'pigment { color rgbf<0.2, 0.2, 0.8, 0.7> }'
                write(iun,*) 
     &             'finish { ambient 0.2 diffuse 0.6 specular 0.9}'
                write(iun,*) '}'
                write(iun,*) '#declare BSAMBI = 0.2;'
                write(iun,*) '#declare BSDIFF = 0.8;'
                write(iun,*) '#declare BSSPEC = 0.8;'
c>>>
c>>>  Redefine the Colors for the Atoms, etc, here.
c>>>  FPA 3/07/2000
c>>>
                do colors = 1,15
c
                    write(iun,'(a14,a1,a3)') '#declare color',
     &                                       char(colors+64),' = '
                    write(iun,*) 'texture { '
                    do n = 1,3
                       colrgb(n) = (dble(jcol(n,colors))/255.0d0)
                    end do
                    write(iun,'(a15,3f8.4,a3)') ' pigment { rgb<',
     &                         (colrgb(n),n=1,3),' >}'
                    write(iun,*)
     &        'finish {ambient BSAMBI diffuse BSDIFF specular BSSPEC}'
                    write(iun,*)'}'
                 end do
c
c --- Declare the molecule object ---- FPA 2/27/2000
c
                 write(iun,*) '# declare molecule = union { '
c>>
c>>
             elseif (ivtwo.eq.1) then
                write(iun,'(''#VRML V2.0 utf8'')')
                write(iun,*) 'NavigationInfo { type ',char(34),
     &                       'EXAMINE',char(34),' }'
                write(iun,*) 'Viewpoint { position 0.0 0.0 1.0 ',
     &                       'description ',char(34),'MoldenVRML',
     &                        char(34),' }'
                if (ivadd.eq.1) then
                   write(iun,*) 'Background {'
                   write(iun,*) 
     &             'skyColor [1.0 1.0 0.9,0.5 0.5 0.4,0.2 0.2 0.1]'
                   write(iun,*)
     &             'skyAngle [1.571,2.771]}'
                   write(iun,*) 'PointLight { on TRUE'
                   write(iun,*) '             location 0.0 0.5 0.5'
                   write(iun,*) '             radius 100.0'
                   write(iun,*) '             intensity 1.0'
                   write(iun,*) '             ambientIntensity 0.3'
                   write(iun,*) '             color 1.0 1.0 1.0'
                   write(iun,*) '             attenuation 1.0 0.0 0.0'
                   write(iun,*) '           }'
                endif

                write(iun,*) 'WorldInfo {'
                write(iun,*) '  title ',char(34),'MoldenVRML',char(34)
                write(iun,*) '  info ',char(34)
             else
                write(iun,'(''#VRML V1.0 ascii'')')
                write(iun,*) 'Separator {'
                write(iun,*) 'Info { string ',char(34),
     &                     'Created by Molden'
             endif
             if (ivtwo.lt.2) then
             if (orb.eq.0) then
                if (trans.eq.1) then
                   write(iun,*) '               Density'
                else
                   if (dolap) then
                      write(iun,*) 
     &                '               Laplacian'

                   else
                      write(iun,*) 
     &                '               Molecular Difference Density'
                   endif
                endif
             else
                write(iun,'(''               orbital '',i4)') orb
             endif
             write(iun,'(''               Contour Value: '',f12.5)') 
     &             cntval1
             write(iun,'(''               Grid Size    : '',f12.5)') 
     &             rad(1)
             write(iun,*) char(34),' }'
             endif

             if (ivtwo.eq.3.or.ivtwo.eq.4) then
                i0 = 1
                if (mapit.eq.1) i0 = 3
                if (trans.eq.1) i0 = -1*i0
                if (ivtwo.eq.3) then
                   call ogbeg(i0,orb,cntval1)
                else
                   call ogbegg(i0,i0,ityp,orb,cntval1,mapit,lstr)
                endif
             elseif (ivtwo.eq.2) then
                write(iun,*) 'mesh {'
             elseif (ivtwo.eq.1) then
                write(iun,*) '   PROTO Surface ['
                write(iun,*) '   field SFFloat aInt 0.0'
                write(iun,*) '   field SFColor dCol 1.0 0.1 0.1'
                write(iun,*) '   field SFColor sCol 0.8 0.8 0.8'
                write(iun,*) '   field SFFloat shi 0.75'
                write(iun,*) '   field SFFloat trans 0.0'
                write(iun,*) '   field MFInt32 CIndex [ ]'
                write(iun,*) '   ]'
                write(iun,*) '   {'
                write(iun,*) '    Group {'
                write(iun,*) '    children ['
                write(iun,*) '    DEF Trigger TouchSensor { }'
                write(iun,*) '    Shape {'
                write(iun,*) '      appearance Appearance {'
                write(iun,*) '       material DEF CT Material {'
                write(iun,*) '        ambientIntensity IS aInt'
                write(iun,*) '        diffuseColor IS dCol'
                write(iun,*) '        specularColor IS sCol'
                write(iun,*) '        shininess IS shi'
                write(iun,*) '        transparency IS trans'
                write(iun,*) '       }'
                write(iun,*) '      }'
                write(iun,*) '      geometry IndexedFaceSet {'
                write(iun,*) '        coord Coordinate { point [ '
             else
                write(iun,*) 
     &              'NormalBinding { value PER_VERTEX_INDEXED }'
                write(iun,*) 'Coordinate3 { point [ '
             endif
         endif

         if (wpass.eq.1) then
             if (ivtwo.eq.2.or.ivtwo.eq.3.or.ivtwo.eq.4) then
             elseif (ivtwo.eq.1) then
                write(iun,*) '        normalPerVertex TRUE'
                write(iun,*) '        normal Normal { vector [ '
                if (icolver.eq.1.and.ivtwo.eq.1) then
                  write(47,*) '        colorPerVertex TRUE'
                  write(47,*) '        color Color { color [ '
                endif
             else
                write(iun,*) 'Normal { vector [ '
             endif
         endif

         if (wpass.eq.2) then
             if (ivtwo.eq.3.or.ivtwo.eq.4) then
             elseif (ivtwo.eq.2) then
             elseif (ivtwo.eq.1) then
                write(iun,*) '   Surface {'
                if (orb.eq.0.and..not.dolap) then
                   write(iun,*) '     aInt 0.0'
                   write(iun,*) '     dCol 1.0 1.0 0.0'
                   write(iun,*) '     sCol 0.9 0.8 0.8'
                   write(iun,*) '     shi 0.55'
                   if (trans.eq.1) write(iun,*) '     trans 0.5'
                else
                   if (ivadd.eq.1) then
                      write(iun,*) '     aInt 0.7'
                   else
                      write(iun,*) '     aInt 0.0'
                   endif
                   write(iun,*) '     dCol 0.15 0.15 1.0'
                   write(iun,*) '     sCol 0.8 0.8 0.8'
                   write(iun,*) '     shi 0.75'
                   if (trans.eq.1) write(iun,*) '     trans 0.6'
                endif
                write(iun,*) '     CIndex ['
             else
                call plvmat(iun,1,orb,trans,dolap)
                write(iun,*) 'IndexedFaceSet { coordIndex [ '
             endif
         endif

         if (wpass.eq.3) then
             if (ivtwo.eq.3.or.ivtwo.eq.4) then
                i1 = 2
                if (ivtwo.eq.3) then
                   call ogbeg(i1,orb,cntval2)
                else
                   call ogbegg(i1,i1,ityp,orb,cntval2,mapit,lstr)
                endif
             elseif (ivtwo.eq.2) then
                write(iun,*) 'mesh {'
             elseif (ivtwo.eq.1) then
                write(iun,*) '   Surface {'
                if (ivadd.eq.1) then
                   write(iun,*) '     aInt 0.7'
                else
                   write(iun,*) '     aInt 0.0'
                endif
                write(iun,*) '     dCol 1.0 0.1 0.1'
                write(iun,*) '     sCol 0.8 0.8 0.8'
                write(iun,*) '     shi 0.75'
                if (trans.eq.1) write(iun,*) '     trans 0.6'
                write(iun,*) '     CIndex ['
             else
                call plvmat(iun,2,orb,trans,dolap)
                write(iun,*) 'IndexedFaceSet { coordIndex [ '
             endif
         endif

         iptr = 0
         pptr = 0
c         xydim = griddim(1) * griddim(2)
         xydim = mx3d2
         do posneg=1,2
            contval = cntvls(posneg)
            cneg = .false.
            if (contval.lt.0.0d0) cneg = .true.
      

            do k=0,griddim(3)-2
               cubxyz(1,3) = origin(3) + k*scale(3)
               ztmp = origin(3) + (k+1)*scale(3)

               do j=0,griddim(2)-2
                  cubxyz(1,2) = origin(2) + j*scale(2)
                  ytmp = origin(2) + (j+1)*scale(2)

                  do i=0,griddim(1)-2
                     findex = i + j*griddim(1) + k*xydim + 1

c                    create Cube Function Values

                     cubval(1) = fvals(findex)
                     cubval(2) = fvals(findex+1)
                     cubval(3) = fvals(findex+1 + griddim(1))
                     cubval(4) = fvals(findex + griddim(1))
                     cubval(5) = fvals(findex + xydim)
                     cubval(6) = fvals(findex+1 + xydim)
                     cubval(7) = fvals(findex+1 + griddim(1) + xydim)
                     cubval(8) = fvals(findex + griddim(1) + xydim)

                     if (mapit.eq.1) then
                        cbmval(1) = fmap(findex)
                        cbmval(2) = fmap(findex+1)
                        cbmval(3) = fmap(findex+1 + griddim(1))
                        cbmval(4) = fmap(findex + griddim(1))
                        cbmval(5) = fmap(findex + xydim)
                        cbmval(6) = fmap(findex+1 + xydim)
                        cbmval(7) = fmap(findex+1 + griddim(1) + xydim)
                        cbmval(8) = fmap(findex + griddim(1) + xydim)
                     endif

c                    which of the 256 cases is it ?

                     caseptr = 1
                     do l=1,8
                         if (cneg) then
                            if (cubval(l).ge.contval) 
     &                      caseptr = caseptr + casemask(l)
                         else
                            if (cubval(l).le.contval) 
     &                      caseptr = caseptr + casemask(l)
                         endif
                     end do

                     if (caseptr.eq.1.or.caseptr.eq.256 ) goto 100


c                    create Cube points

                     cubxyz(1,1) = origin(1) + i*scale(1)
                     xtmp = origin(1) + (i+1)*scale(1)

                     cubxyz(2,1) = xtmp
                     cubxyz(2,2) = cubxyz(1,2)
                     cubxyz(2,3) = cubxyz(1,3)

                     cubxyz(3,1) = xtmp
                     cubxyz(3,2) = ytmp
                     cubxyz(3,3) = cubxyz(1,3)

                     cubxyz(4,1) = cubxyz(1,1)
                     cubxyz(4,2) = ytmp
                     cubxyz(4,3) = cubxyz(1,3)

                     cubxyz(5,1) = cubxyz(1,1)
                     cubxyz(5,2) = cubxyz(1,2)
                     cubxyz(5,3) = ztmp

                     cubxyz(6,1) = xtmp
                     cubxyz(6,2) = cubxyz(1,2)
                     cubxyz(6,3) = ztmp

                     cubxyz(7,1) = xtmp
                     cubxyz(7,2) = ytmp
                     cubxyz(7,3) = ztmp

                     cubxyz(8,1) = cubxyz(1,1)
                     cubxyz(8,2) = ytmp
                     cubxyz(8,3) = ztmp

c                    create Cube gradients

                     call calcgr(i,j,k,fvals,griddim,xydim,
     &                           scale,cubgr(1,1))
                     call calcgr(i+1,j,k,fvals,griddim,xydim,
     &                           scale,cubgr(1,2))
                     call calcgr(i+1,j+1,k,fvals,griddim,xydim,
     &                           scale,cubgr(1,3))
                     call calcgr(i,j+1,k,fvals,griddim,xydim,
     &                           scale,cubgr(1,4))
                     call calcgr(i,j,k+1,fvals,griddim,xydim,
     &                           scale,cubgr(1,5))
                     call calcgr(i+1,j,k+1,fvals,griddim,xydim,
     &                           scale,cubgr(1,6))
                     call calcgr(i+1,j+1,k+1,fvals,griddim,xydim,
     &                           scale,cubgr(1,7))
                     call calcgr(i,j+1,k+1,fvals,griddim,xydim,
     &                           scale,cubgr(1,8))

                     tptr = 1
                     do while (cases(tptr,caseptr).gt.-1)
                        do l=0,2
                           linepts(1) = 
     &                       lines(1,cases(tptr+l,caseptr)+1)
                           linepts(2) = 
     &                       lines(2,cases(tptr+l,caseptr)+1)
                           factor = (contval - cubval(linepts(1))) / 
     &                       (cubval(linepts(2)) - cubval(linepts(1)))
                             
                           do m=1,3
                               xyz(m) = cubxyz(linepts(1),m) + factor*
     &                   (cubxyz(linepts(2),m) - cubxyz(linepts(1),m))
                               txyz(m,l+1) = xyz(m)
                               grd(m) = cubgr(m,linepts(1)) + factor*
     &                   (cubgr(m,linepts(2)) - cubgr(m,linepts(1)))
                           end do
                           if (mapit.eq.1) then
                               cval(l+1) = cbmval(linepts(1)) + factor*
     &                        (cbmval(linepts(2)) - cbmval(linepts(1)))
                               if (cval(l+1).gt.emax) emax = cval(l+1)
                               if (cval(l+1).lt.emin) emin = cval(l+1)
                           endif
                           if ((wpass.eq.0).and.ivtwo.lt.2)
     &                        write(iun,'(3f12.5,a)') (xyz(n),n=1,3),','
               
                           index(l+1) = iptr
                           call normal(grd)
                           if (contval.gt.0.0) call arrsgn(grd,3)
                           if (ivtwo.ge.2) then
                              do m=1,3
                                 tgrd(m,l+1) = grd(m)
                              end do
                           endif
                           if (wpass.eq.1.and.ivtwo.lt.2)
     &                        write(iun,'(3f10.6,a)') (grd(n),n=1,3),','
                           if (wpass.eq.1.and.icolver.eq.1) then
                              call parcol(cval(l+1),col)
                              write(47,'(3f7.3,a)') (col(n),n=1,3),','
                           endif
                           iptr = iptr + 1
                        end do

                        if (((wpass.eq.0.and.posneg.eq.1).or.(
     &                        wpass.eq.3.and.posneg.eq.2))
     &                      .and.ivtwo.ge.2) then
                         if (utrian(txyz)) then
                          if (ivtwo.eq.2)  then
                              write(iun,*) 'smooth_triangle {'
                           do l=1,3
                             if (l.eq.3) then
                              write(iun,'(2(a,3(f10.6,a)))') 
     &              '<',txyz(1,l),',',txyz(2,l),',',txyz(3,l),'>, ',
     &              '<',tgrd(1,l),',',tgrd(2,l),',',tgrd(3,l),'>'
                             else
                              write(iun,'(2(a,3(f10.6,a)))') 
     &              '<',txyz(1,l),',',txyz(2,l),',',txyz(3,l),'>, ',
     &              '<',tgrd(1,l),',',tgrd(2,l),',',tgrd(3,l),'>,'
                             endif
                           end do
                           write(iun,*) '}'
                          else
                          endif

                          if (ivtwo.eq.3) then

                           do l=1,3
                            if (mapit.eq.1) then
                               call parcol(cval(l),col)
                               call ogcol(col(1),col(2),col(3))
                            endif
                            call ognorm(tgrd(1,l),tgrd(2,l),tgrd(3,l))
                            call ogvert(txyz(1,l),txyz(2,l),txyz(3,l))
                           end do

                          elseif (ivtwo.eq.4) then

                           do l=1,3
                            if (mapit.eq.1) then
                               call parcol(cval(l),col)
                               call tstpsa(cval,pol,pol2,ir)
                               if (ir.eq.3.and.icpsa.eq.1) then
                                 cav = cval(1)+cval(2)+cval(3)
                                 if (cav.gt.0) then
                                    call ogcoll(0.0d0,0.0d0,1.0d0)
                                 else
                                    call ogcoll(1.0d0,0.0d0,0.0d0)
                                 endif
                               else
                                 call ogcoll(col(1),col(2),col(3))
                               endif
                            endif
                            call rtgbck(tgrd(1,l),tgrd(2,l),tgrd(3,l),g)
                            call ognrm(g(1),g(2),g(3))
                            call rotbck(txyz(1,l),txyz(2,l),txyz(3,l),c)
                            call ogvrt(c(1),c(2),c(3))
                            do m=1,3
                               tc(m,l) = c(m)
                               if (cval(m).gt.epmax) epmax = cval(m)
                               if (cval(m).lt.epmin) epmin = cval(m)
                            end do
                           end do

                           if (mapit.eq.1.and.ipsa.eq.1) then 
                               call calpsa(tc,cval,pol,pol2,
     &                                     psa,tsa,exs,3)
                           endif

                          endif
                         endif
                        endif

                        if (ivtwo.lt.2) then
                          if (wpass.eq.2.and.posneg.eq.1) then
                               write(iun,'(3(i7,'',''),a)') 
     &                         (index(n),n=1,3),'-1,'
                          endif
                          if (wpass.eq.3.and.posneg.eq.2)then
                               write(iun,'(3(i7,'',''),a)') 
     &                         (index(n),n=1,3),'-1,'
                          endif
                        endif
                        pptr = pptr + 1
                        tptr = tptr + 3

                     end do
100               continue
                  end do
               end do
            end do
         end do

         if (ivtwo.eq.3.or.ivtwo.eq.4) then
            if (wpass.eq.0.or.wpass.eq.3) then
                if (ivtwo.eq.3) then
                   call ogend
                else
                   call ogendd(-1)
                endif
            endif
         elseif (ivtwo.eq.2) then
            if (wpass.eq.0) then
               if (npass.eq.2) then
                  write(iun,*) ' texture { MeshGold }'
                  write(iun,*) '}'
               else
                  write(iun,*) ' texture { MeshBlue }'
                  write(iun,*) '}'
               endif
            elseif (wpass.eq.3) then
               write(iun,*) ' texture { MeshRed }'
               write(iun,*) '}'
            endif
         else
            write(iun,*) ']}'
            if (icolver.eq.1.and.wpass.eq.1) then
               rewind(47)
               do while (.true.)
                  read(47,'(a)',end=200) lstr
                  write(iun,'(a)') lstr(1:linlen(lstr))
               end do
200            close(47)
               write(iun,*) ']}'
            endif
         endif

         if (wpass.eq.1.and.ivtwo.eq.1) then
            write(iun,*) '        coordIndex IS CIndex'
            write(iun,*) '  }'
            write(iun,*) ' }'
            write(iun,*) ' ]}'
            write(iun,*) 'DEF TTScript Script {'
            write(iun,*) '        eventIn SFTime  touchTime'
            write(iun,*) '        eventOut        SFFloat Trans'
            write(iun,*) '        field           SFBool  opaque TRUE'
            write(iun,*) '        url'
            write(iun,*) '          ',char(34),'vrmlscript:'
            write(iun,*) '               function touchTime (timeVal) {'
            write(iun,*) '                 if (opaque == true) {'
            write(iun,*) '                        Trans = 0.4;'
            write(iun,*) '                        opaque = false;'
            write(iun,*) '                 } else {'
            write(iun,*) '                        Trans = 0.0;'
            write(iun,*) '                        opaque = true;'
            write(iun,*) '                 }'
            write(iun,*) '                }'
            write(iun,*) '          ',char(34)
            write(iun,*) '}'
            write(iun,*) 'ROUTE Trigger.touchTime TO TTScript.touchTime'
            write(iun,*) 'ROUTE TTScript.Trans TO CT.transparency'
            write(iun,*) '}'
         endif

      end do

      if (ivtwo.eq.0) write(iun,*) '}'

      if (mapit.eq.1) then
         print*,' '
         print*,'Emax = ',emax
         print*,'Emin = ',emin
         print*,' '
         if (ipsa.eq.1) call prtpsa
      endif

      return
      end


      subroutine normal(x)
      implicit double precision (a-h,o-z)
      dimension x(3)

      den = dsqrt(x(1)*x(1) + x(2)*x(2) + x(3)*x(3))
      if (den.ne.0.0d0) then
         do i=1,3
            x(i) = x(i) / den
         end do
      endif

      return
      end

      subroutine arrsgn(x,n)
      implicit double precision (a-h,o-z)
      dimension x(3)

      do i=1,3
         x(i) = -x(i)
      end do

      return
      end

      logical function utrian(txyz)
      implicit double precision (a-h,o-z)
      dimension txyz(3,3)

      utrian = .true.

      if (txyz(1,1).eq.txyz(1,2).and.txyz(2,1).eq.txyz(2,2).and.
     & txyz(3,1).eq.txyz(3,2)) utrian = .false.

      if (txyz(1,1).eq.txyz(1,3).and.txyz(2,1).eq.txyz(2,3).and.
     & txyz(3,1).eq.txyz(3,3)) utrian = .false.

      if (txyz(1,2).eq.txyz(1,3).and.txyz(2,2).eq.txyz(2,3).and.
     & txyz(3,2).eq.txyz(3,3)) utrian = .false.

      return
      end

      subroutine epvrmd(vdwr,moddma,natoms,norbs,idops,iaton)
      implicit double precision (a-h,o-z)
      logical valenc,bonds,ovrlap,atomic,doori,denok,dolap,opfil
      logical ctoz,molpot,elpot,chpot,doelf
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      character vrmlfil*256
      common /vrunit/ vrmlfil
      character curdir*1024
      common /cwd/ curdir
      common /cmdfil/ icmdf

      dimension vdwr(*),iaton(*)

      if ((iftyp.ge.2.and.iftyp.le.4).and.norbs.ne.0) then
          iopt = 2
          if (elpot) iopt = 1
          call xyzcoo(1,0,0)

          do i=1,natoms
              iaton(i) = 1
          end do

          call doconn
          ipsi = 0
          dolap = .false.
          doelf = .false.
          call denmak(denok)
          if (iopt.eq.2)
     &          call muldma(vdwr,moddma,.true.,.true.)
          call allsrf(0,iopt,1,4)
          call doscal
          if (idops.eq.1) then
             call plpost(0,0,1,1,1,0,1,0)
             call qupd
          else
             iun = 46
             lv = linlen(vrmlfil)
             lc = linlen(curdir)
             if (index(vrmlfil(1:lv),'/').eq.1.or.icmdf.eq.0) then
                vrmlfil = vrmlfil(1:lv)
             else
                vrmlfil = curdir(1:lc)//vrmlfil(1:lv)
             endif
             if (opfil(iun,vrmlfil,linlen(vrmlfil),1,0,0)) then
                call plvrml(iun,1,1,0,1,0,.true.)
                close(iun)
             endif
          endif
      else
          call inferr('No Electrostatic Potential !',1)
      endif
      
      stop

      return
      end

      subroutine plvhd(iun)
      implicit double precision (a-h,o-z)

      write(iun,'(''#VRML V2.0 utf8'')')
      write(iun,*) 'NavigationInfo { type ',char(34),
     &             'EXAMINE',char(34),' }'
      write(iun,*) 'DEF V0 Viewpoint { position 0 0 0 }'
      write(iun,*) ' Background {'
      write(iun,*) 'skyColor [0 0.2 0.7,0 0.5 1,1 1 1 ]'
      write(iun,*) 'skyAngle [ 1.309, 1.571 ]'
      write(iun,*) 'groundColor [0.1 0.1 0,0.4 0.25 0.2,0.6 0.6 0.6]'
      write(iun,*) 'groundAngle [1.309,1.571]}'

      write(iun,*) 'DEF ANIME Transform {'
      write(iun,*) '  children ['
      write(iun,*) '    DEF Sensor SphereSensor { },'
      write(iun,*) '    DEF MOLDENS Switch {'
      write(iun,*) '      whichChoice 0'
      write(iun,*) '      choice ['

      return
      end

      subroutine plvedd(iun,loop,epoints,scal)
      implicit double precision (a-h,o-z)
      common /pnthlp/ ipoints,ipnt
      common /geocnv/ fmaxt,frmst,dmaxt,drmst,fgmin,fgmax,dgmin,dgmax,
     &                enmax,enmin,ngeoms,nepnts,igcvav,ifmxav,ifrmav,
     &                idmxav,idrmav,ieav,ifrav,mxpnt
      integer loop
      dimension epoints(*)


      write(iun,*) '      ]'
      write(iun,*) '    }'
      write(iun,*) '  ]'
      write(iun,*) '}'
      write(iun,*) ' '
      if (loop.eq.1) then
         write(iun,*) 'DEF MOLDEN_TIMER TimeSensor {'
         write(iun,*) 'cycleInterval 1 loop TRUE stopTime 1}'
      else
         write(iun,*) 
     &   'DEF MOLDEN_TIMER TimeSensor { cycleInterval 10 }'
      endif
      write(iun,*) ' '

      write(iun,*) 'EXTERNPROTO SwitchInterpolator ['
      write(iun,*) 'eventIn SFFloat set_fraction'
      write(iun,*) 'eventIn SFVec3f hud_translation'
      write(iun,*) 'eventIn SFRotation hud_rotation'
      write(iun,*) 'eventOut SFInt32 value_changed'
      write(iun,*) 'eventOut SFTime touchTime'
      write(iun,*) 'eventOut SFVec3f v0_position'
      write(iun,*) 'field MFFloat key'
      write(iun,*) 'field MFFloat keyValue'
      write(iun,*) 'field MFFloat Energies'
      write(iun,*) 'field MFInt32 Window'
      write(iun,*) 'field SFVec3f vpnt'
      write(iun,*) '] ',char(34),
     &    'http://www.cmbi.kun.nl/~schaft/molden/wrl/animator.wrl',
     &             char(34)
      write(iun,*) ' '


      write(iun,*) 'DEF MOLDEN_ANIMATOR SwitchInterpolator {'
      write(iun,*) '  key [0,1]'
      write(iun,*) '  keyValue [0,',ipoints-1,']'
      write(iun,*) '  Energies ['
      do i=1,ipoints-1
         write(iun,'(f12.6,a)') epoints(i),','
      end do
      write(iun,'(f12.6)') epoints(ipoints)
      write(iun,*) '  ]'
      if (loop.eq.1) then
         write(iun,*) '  Window [0,0]'
      else
         write(iun,*) '  Window [2,1]'
      endif
      write(iun,*) '  vpnt 0 0 ',scal
      write(iun,*) '}'

      write(iun,*) 
     &'DEF P0 ProximitySensor{ center 0 0 0 size 100 100 100 }'
      write(iun,*) 
     &'ROUTE Sensor.rotation_changed TO ANIME.set_rotation'
      write(iun,*) 
     &'ROUTE P0.position_changed TO MOLDEN_ANIMATOR.hud_translation'
      write(iun,*) 
     &'ROUTE P0.orientation_changed TO MOLDEN_ANIMATOR.hud_rotation'
      write(iun,*) 
     &'ROUTE MOLDEN_ANIMATOR.v0_position TO V0.set_position'
      write(iun,*) 
     &'ROUTE MOLDEN_ANIMATOR.touchTime TO MOLDEN_TIMER.startTime'
      write(iun,*) 'ROUTE MOLDEN_TIMER.fraction_changed TO ',
     &             'MOLDEN_ANIMATOR.set_fraction'
      write(iun,*) 
     &'ROUTE MOLDEN_ANIMATOR.value_changed TO MOLDENS.whichChoice'

      return
      end

      subroutine plvmat(iun,iopt,orb,trans,dolap)
      implicit double precision (a-h,o-z)
      integer orb,trans
      logical dolap

      write(iun,*) 'Material {'

      if (iopt.eq.1) then
         if (orb.eq.0.and..not.dolap) then
            write(iun,*) '          ambientColor 1.000 1.000 1.000'
            write(iun,*) '          diffuseColor 1.000 1.000 0.000'
            write(iun,*) '          specularColor 0.900 0.800 0.800'
            write(iun,*) '          shininess 0.550'
         else
            write(iun,*) '          ambientColor 0.150 0.150 1.000'
            write(iun,*) '          diffuseColor 0.150 0.150 1.000'
            write(iun,*) '          specularColor 0.800 0.800 0.800'
            write(iun,*) '          shininess 0.750'
         endif
      else
         write(iun,*) '          ambientColor 1.000 0.000 0.000'
         write(iun,*) '          diffuseColor 1.000 0.100 0.100'
         write(iun,*) '          specularColor 0.800 0.800 0.800'
         write(iun,*) '          shininess 0.750'
      endif

      if (trans.eq.1)
     &     write(iun,*) '          transparency 0.55'
      write(iun,*) '}'

      return
      end

      subroutine parcol(cval,col)
      implicit double precision (a-h,o-z)
      common /mapcls/ valcol(5),colmap(3,5)
      dimension col(3)

      if (cval.lt.valcol(1)) then
         i1 = 1
         i2 = 1
      elseif (cval.lt.valcol(2)) then
         i1 = 1
         i2 = 2
      elseif (cval.lt.valcol(3)) then
         i1 = 2
         i2 = 3
      elseif (cval.lt.valcol(4)) then
         i1 = 3
         i2 = 4
      elseif (cval.lt.valcol(5)) then
         i1 = 4
         i2 = 5
      else
         i1 = 5
         i2 = 5
      endif

      if (i1.ne.i2) then
         factor = (cval - valcol(i1)) / (valcol(i2) - valcol(i1))
         do j=1,3
            col(j) = colmap(j,i1) + 
     &               factor*(colmap(j,i2) - colmap(j,i1))
         end do
      else
         do j=1,3
            col(j) = colmap(j,i1)
         end do
      endif

      return
      end

      subroutine plcini
      implicit double precision (a-h,o-z)
      common /vrcol/ jcol(3,16)

      data jcol(1,1),jcol(2,1),jcol(3,1) /255,0,0/
      data jcol(1,2),jcol(2,2),jcol(3,2) /255,159,9/
      data jcol(1,3),jcol(2,3),jcol(3,3) /0,255,0/
      data jcol(1,4),jcol(2,4),jcol(3,4) /78,255,187/
      data jcol(1,5),jcol(2,5),jcol(3,5) /0,255,255/
      data jcol(1,6),jcol(2,6),jcol(3,6) /255,191,0/
      data jcol(1,7),jcol(2,7),jcol(3,7) /132,193,214/
      data jcol(1,8),jcol(2,8),jcol(3,8) /115,115,115/
      data jcol(1,9),jcol(2,9),jcol(3,9) /255,0,255/
      data jcol(1,10),jcol(2,10),jcol(3,10) /16,176,16/
      data jcol(1,11),jcol(2,11),jcol(3,11) /239,202,140/
      data jcol(1,12),jcol(2,12),jcol(3,12) /255,122,0/
      data jcol(1,13),jcol(2,13),jcol(3,13) /230,214,92/
      data jcol(1,14),jcol(2,14),jcol(3,14) /184,56,6/
      data jcol(1,15),jcol(2,15),jcol(3,15) /255,255,255/

      idum = 1

      return
      end

      subroutine plphd(iun,ihand,tmp,t,tlpos)
      implicit double precision (a-h,o-z)
      common /vrcol/ jcol(3,16)
c
c --- variables for POV macros ---
c
      integer colors
      double precision colrgb
      dimension colrgb(3),tmp(3),t(3),tlpos(3)

      write(iun,'(''camera {'')')
      if (ihand.eq.1) then

         write(iun,
     &     '(''location <'',f12.5,'','',f12.5,'','',f12.5,''>'')')
     &     -tmp(2),tmp(1),-tmp(3)
         write(iun,
     &     '(''look_at <'',f12.5,'','',f12.5,'','',f12.5,''>'')')
     &      -t(2),t(1),-t(3)

      else

         write(iun,
     &     '(''location <'',f12.5,'','',f12.5,'','',f12.5,''>'')')
     &      (tmp(j),j=1,3)
         write(iun,'(''right < -1.33,  0,  0>'')')
         write(iun,
     &     '(''look_at <'',f12.5,'','',f12.5,'','',f12.5,''>'')')
     &      (t(j),j=1,3)

      endif

      write(iun,*) 'angle 45'
      write(iun,'(''}'')')

      if (ihand.eq.1) then
         write(iun,'(''sky_sphere {'')')
         write(iun,'(''  pigment {'')')
         write(iun,'(''    gradient y'')')
         write(iun,'(''    color_map {'')')
         write(iun,'(''      [0 color rgb <1, 0, 0>]'')')
         write(iun,'(''      [1 color rgb <0, 0, 1>]'')')
         write(iun,'(''    }'')')
         write(iun,'(''    scale 2'')')
         write(iun,'(''    translate -1'')')
         write(iun,'(''  }'')')
         write(iun,'(''}'')')
      else 
         write(iun,'(''background { color <0.6, 0.6, 0.6> }'')')
      endif

      write(iun,
     & '(''light_source { <'',f12.5,'','',f12.5,'','',f12.5,''>'')')
     &  (tlpos(j),j=1,3)
      write(iun,'('' color rgb<1, 1, 1> }'')')

      write(iun,*) '#declare BSAMBI = 0.2;'
      write(iun,*) '#declare BSDIFF = 0.8;'
      write(iun,*) '#declare BSSPEC = 0.8;'
c
c----- Add macros for colors ----- FPA 2/27/2000 
c
c general form is:
c  #declare color1 = 
c           texture {
c           pigment {color rgb <r1, r2, r3> }
c           finish {BSAMBI, BSDIFF, BSSPEC }
c           }
c
c
      do colors = 1,15
c              
           write(iun,'(a14,a1,a3)') '#declare color',
     1                      char(colors+64),' = '
           write(iun,*) 'texture { '
           do n = 1,3
                colrgb(n) = (real(jcol(n,colors))/255.0)
           end do
           write(iun,'(a15,3f8.4,a3)') ' pigment { rgb<',
     1                     (colrgb(n),n=1,3),
     2                     ' >}'
           write(iun,*)
     1        'finish {ambient BSAMBI diffuse BSDIFF specular BSSPEC}'
           write(iun,*)'}'

       end do
c
c --- Declare the molecule object ---- FPA 2/27/2000
c
       write(iun,*) '# declare molecule = union { '
c ---

       return
       end

      subroutine prtpsa
      implicit double precision (a-h,o-z)
      common /psa/ psa, tsa, exs, pol, pol2, epmin, epmax, ipsa,
     &             icpsa, idtpsa

      write(*,'(a,f8.5)') "Apolar Potential: < ",pol
      write(*,'(a,f8.5)') "Apolar Potential: > ",pol2
      write(*,'(a,f8.3,a)') "Polar Surface area: ",psa," Angstrom**2"
      write(*,'(a,f8.3,a)') "Total Surface area: ",tsa," Angstrom**2"
      write(*,'(a,f5.2,a)') "PSA percentage: ",100.0d0*psa/tsa," %"
      write(*,'(a,f8.3)') "Minimum Potential on surface: ",epmin
      write(*,'(a,f8.3)') "Maximum Potential on surface: ",epmax
      write(*,'(a,f10.6,a,f10.6)') "EXS: ",exs," ",exs/tsa

      if (idtpsa.eq.1) call tpsa

      return
      end

      subroutine wcubev(nx,ny,nz,fvals,origin,rad)
      implicit double precision (a-h,o-z), integer ( i-n)
      parameter (numatm=2000)
      parameter (mxel=100)
      integer griddim(3), xydim, findex
      character*80 lstr
      common /grdhlp/ mx3d,mx3d2
      common /coord / xyz(3,numatm)
      character*2 elemnt
      common /elem/elemnt(mxel)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension fvals(*),origin(3),scale(3)
      dimension cubxyz(3), rad(3), c(3)
  
      open(unit=80,form='formatted',file='points',err=10)
      
      griddim(1) = nx
      griddim(2) = ny
      griddim(3) = nz

c rad(2) slaat op scale(1) en griddim(1)

      do i=1,3
          scale(i) = 1.0d0/(griddim(i)-1.0d0)
      end do
      scale(1) = scale(1) * rad(2) / rad(1)
      scale(3) = scale(3) * rad(3) / rad(1)

      xydim = mx3d2

      write(80,'(a)') '$CONTRL UNITS=BOHR $END'
      write(80,'(a)') '$DATA'
      write(80,'(a)') 'title'
      write(80,'(a)') 'c1'
      write(80,'(a)') ''

      do i=1,natoms
          write(80,'(a2,1x,i3,1x,3(f9.4,1x))') 
     &       elemnt(nat(i)),nat(i),(xyz(l,i),l=1,3)
      end do

      write(80,'(a)') '$END'
      write(80,'(a)') '$ELPOT IEPOT=1 WHERE=POINTS OUTPUT=BOTH $END'
      write(80,'(a)') '$POINTS'
      
      write(80,'(a,i8)') 'BOHR ',nx*ny*nz
      do k=0,griddim(3)-1
         cubxyz(3) = origin(3) + k*scale(3)

         do j=0,griddim(2)-1
            cubxyz(2) = origin(2) + j*scale(2)

            do i=0,griddim(1)-1
               cubxyz(1) = origin(1) + i*scale(1)

               findex = i + j*griddim(1) + k*xydim + 1
               cubval = fvals(findex)

               call rotbck(cubxyz(1),cubxyz(2),cubxyz(3),c)
               write(80,'(3(f9.4,1x))') (c(l),l=1,3)

            end do
         end do
      end do

      write(80,'(a)') '$END'
      close(80)

      return

10    print*,'error writing file'
      return
      end

      subroutine dolift(rlift)
      implicit double precision (a-h,o-z)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      dimension d2(3)

      d2(1) = cx
      d2(2) = cy
      d2(3) = cz

      d2norm = dsqrt(d2(1)*d2(1)+d2(2)*d2(2)+d2(3)*d2(3))
      if (d2norm.lt.1.0d0-8) return

      do i=1,3
         d2(i) = d2(i)*rlift/d2norm
      end do

      px = px + d2(1)
      py = py + d2(2)
      pz = pz + d2(3)

      return
      end

      subroutine prprsc(rs,sc,iconn,ityp)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      integer*2 ityp
      common /athlp/  iatoms, mxnat
      common /ambgff/ iambat(mxamb),igffat(mxgff)
      dimension iconn(mxcon+1,*),ityp(*)
      dimension rs(*),sc(*)

      do i=1,iatoms
            itypi = ityp(i)
            if (itypi.lt.0) then
               ia = igffat(itypi)
            else
               ia = iambat(itypi)
            endif
            n = iconn(1,i)
            if (ia.eq.1) then
               rs(i) = 1.25e0
               if (n.ne.0) then
                  k = iconn(2,i)
                  if (ia.eq.7)  rs(i) = 1.15e0
                  if (ia.eq.8)  rs(i) = 1.05e0
               endif
            else if (ia.eq.3) then
               rs(i) = 1.432e0
            else if (ia.eq.6) then
               rs(i) = 1.90e0
               if (n.ne.3) rs(i) = 1.875e0
               if (n.ne.2) rs(i) = 1.825e0
            else if (ia.eq.7) then
               rs(i) = 1.7063e0
               if (n.eq.4)  rs(i) = 1.625e0
               if (n.eq.1)  rs(i) = 1.60e0
            else if (ia.eq.8) then
               rs(i) = 1.535e0
               if (n.eq.1) rs(i) = 1.48e0
            else if (ia.eq.9) then
               rs(i) = 1.47e0
            else if (ia.eq.10) then
               rs(i) = 1.39e0
            else if (ia.eq.11) then
               rs(i) = 1.992e0
            else if (ia.eq.12) then
               rs(i) = 1.70e0
            else if (ia.eq.14) then
               rs(i) = 1.80e0
            else if (ia.eq.15) then
               rs(i) = 1.87e0
            else if (ia.eq.16) then
               rs(i) = 1.775e0
            else if (ia.eq.17) then
               rs(i) = 1.735e0
            else if (ia.eq.18) then
               rs(i) = 1.70e0
            else if (ia.eq.19) then
               rs(i) = 2.123e0
            else if (ia.eq.20) then
               rs(i) = 1.817e0
            else if (ia.eq.35) then
               rs(i) = 1.90e0
            else if (ia.eq.36) then
               rs(i) = 1.812e0
            else if (ia.eq.37) then
               rs(i) = 2.26e0
            else if (ia.eq.53) then
               rs(i) = 2.10e0
            else if (ia.eq.54) then
               rs(i) = 1.967e0
            else if (ia.eq.55) then
               rs(i) = 2.507e0
            else if (ia.eq.56) then
               rs(i) = 2.188e0
            else
               rs(i) = 2.0e0
            end if
      end do

      do i=1,iatoms

          sc(i) = 0.80e0
          itypi = ityp(i)

          if (itypi.lt.0) then
             ia = igffat(itypi)
          else
             ia = iambat(itypi)
          endif

          if (ia.eq.1)   sc(i) = 0.85e0
          if (ia.eq.6)   sc(i) = 0.72e0
          if (ia.eq.7)   sc(i) = 0.79e0
          if (ia.eq.8)   sc(i) = 0.85e0
          if (ia.eq.9)   sc(i) = 0.88e0
          if (ia.eq.15)  sc(i) = 0.86e0
          if (ia.eq.16)  sc(i) = 0.96e0
          if (ia.eq.26)  sc(i) = 0.88e0
      end do

      return
      end

      subroutine born(coo,rs,brad,sc,iconn,ityp)
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      integer*2 ityp
      dimension coo(3,*),iconn(mxcon+1,*),ityp(*)
      dimension rs(*),brad(*),sc(*),vr(3)

      call prprsc(rs,sc,iconn,ityp)

      do i=1,iatoms
         rs(i) = rs(i) - 0.09e0
      end do

c calculate born radii, HTC scheme

      do i=1,iatoms

            ri = rs(i)
            sum = 1.0e0 / ri

            do k=1,iatoms

               if (i.ne.k) then

                  do j=1,3
                     vr(j) = coo(j,k) - coo(j,i)
                  end do

                  r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

                  r = sqrt(r2)
                  rk = rs(k)
                  sk = rk*sc(k)
                  sk2 = sk*sk

                  if (ri.lt.r+sk) then
                     dl = 1.0e0 / dble(max(ri,r-sk))
                     du = 1.0e0 / (r+sk)
                     dl2 = dl * dl
                     du2 = du * du
                     term = dl - du + 0.25e0*r*(du2-dl2)
     &                         + (0.5e0/r)*log(du/dl)
     &                         + (0.25e0*sk2/r)*(dl2-du2)
                     sum = sum - 0.5e0*term
                  end if

               end if

            end do

            brad(i) = 1.0e0 / sum
            brad(i) = dble(max(ri,brad(i)))

      end do

      return
      end

      subroutine esolv(coo,forces,drb,rs,brad,sc,q,
     &                 iconn,ityp)
c calculate born solvation
      implicit real (a-h,o-z), integer (i-n)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      integer*2 ityp
      dimension coo(3,*),iconn(mxcon+1,*),ityp(*)
      dimension forces(3,*),q(*),drb(*)
      dimension rs(*),brad(*),sc(*)

      es = 0.0e0
      do i = 1, iatoms
         drb(i) = 0.0e0
      end do

c calculate rs, brad and sc

      call born(coo,rs,brad,sc,iconn,ityp)

      term = 16.0e0*datan(1.d0)

      do i = 1, iatoms

c do we have to use + 0.09 here, doffset ??

          ri = rs(i) + 0.09e0
          rb = brad(i)
          if (rb .ne. 0.0e0) then
             e = 0.0054e0 * term * (ri+1.4e0)**2 * (ri/rb)**6
             es = es + e
             drb(i) = drb(i) - 6.0e0*e/rb
          end if
      end do

      call egbsa(coo,forces,drb,q,brad)

      call bself(coo,forces,drb,rs,brad,sc)

      return
      end

      subroutine egbsa(coo,forces,drb,q,brad)
      implicit real (a-h,o-z), integer (i-n)
      common /athlp/  iatoms, mxnat
      dimension coo(3,*),forces(3,*),q(*),drb(*),vr(3),ded(3)
      dimension brad(*)

      dwater = 78.3e0
      f = -332.05382e0 * (1.0e0 - 1.0e0/dwater)

      do i=1,iatoms

         fi = f * q(i)
         rbi = brad(i)

         do k=i,iatoms

               do j=1,3
                  vr(j) = coo(j,i) - coo(j,k)
               end do
               r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)

               r = sqrt(r2)
               rbk = brad(k)
               fik = fi * q(k)
               rb2 = rbi * rbk
               ex = exp(-0.25e0*r2/rb2)
               fgb2 = r2 + rb2*ex
               fgb = sqrt(fgb2)
               e = fik / fgb
               de = -e * (r-0.25e0*r*ex) / fgb2
               derb = -e * ex*(0.5e0+0.125e0*r2/rb2) / fgb2

c should this happen ??

               if (i.eq.k) then

                  e = 0.5e0 * e
                  es = es + e
                  drbi = derb * rbk
                  drb(i) = drb(i) + drbi

               else

                  es = es + e
                  de = de / r

                  do j=1,3
                     ded(j) = de * vr(j)
                     forces(j,i) = forces(j,i) + ded(j)
                     forces(j,k) = forces(j,k) - ded(j)
                  end do

                  drbi = derb * rbk
                  drbk = derb * rbi
                  drb(i) = drb(i) + drbi
                  drb(k) = drb(k) + drbk

               end if

         end do
      end do

      return
      end

      subroutine bself(coo,forces,drb,rs,brad,sc)
      implicit real (a-h,o-z), integer (i-n)
      common /athlp/  iatoms, mxnat
      dimension coo(3,*),forces(3,*),drb(*),ded(3),vr(3)
      dimension rs(*),brad(*),sc(*)

      do i =1,iatoms

         ri = rs(i)
         rb2 = brad(i) * brad(i)

         do k =1,iatoms

               if (k.ne.i) then

                  do j=1,3
                     vr(j) = coo(j,k) - coo(j,i)
                  end do

                  rk = rs(k)
                  sk = rk * sc(k)
                  sk2 = sk * sk
                  r2 = vr(1)*vr(1) + vr(2)*vr(2) + vr(3)*vr(3)
                  r = sqrt(r2)

                  if (ri.lt.r+sk) then

                     dl = 1.0e0 / dble(max(ri,r-sk))
                     du = 1.0e0 / (r+sk)
                     dl2 = dl * dl
                     du2 = du * du
                     dl3 = dl * dl2
                     du3 = du * du2

                     fac = 1.0e0
                     if (ri.ge.r-sk) fac = 0.0e0

                     t1 = 0.5e0*dl2 + 0.25e0*sk2*dl3/r
     &                       - 0.25e0*(dl/r+dl3*r)
                     t2 = -0.5e0*du2 - 0.25e0*sk2*du3/r
     &                       + 0.25e0*(du/r+du3*r)
                     t3 = 0.125e0*(1.0e0+sk2/r2)*(dl2-du2)
     &                       + 0.25e0*log(du/dl)/r2
                     de = drb(i) * rb2 * (fac*t1+t2+t3) / r

                     do j=1,3
                        ded(j) = de * vr(j)
                     end do

                     do j=1,3
                        forces(j,i) = forces(j,i) + ded(j)
                        forces(j,k) = forces(j,k) - ded(j)
                     end do

                  end if
               end if
          end do
      end do

      return
      end

      subroutine vec(small,ohoh,u,c,j,k)
      implicit double precision (a-h,o-z)
      logical ohoh
 
      dimension c(*),r(3),u(3)
 
      data dzero/0.0d0/
 
      jtemp = (j-1)*3
      ktemp = (k-1)*3
      r2 = dzero

      do i=1,3
         r(i) = c(i+jtemp) - c(i+ktemp)
         r2   = r2 + r(i)*r(i)
      end do

      r2 = dsqrt(r2)
      ohoh = r2.lt.small
      if (ohoh) return

      do i=1,3
         u(i) = r(i)/r2
      end do

      return
      end

      subroutine wrmod(iun,
     &               coo,qat,ianz,iaton,iatclr,iconn,iresid,
     &               lring,ityp,ipdbt,
     &               icalf,ncalf,iamino,ishoh)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      parameter (mxel=100)
      parameter (mxt=14)
      parameter (mxmol2=41)
      parameter (mxamb=1590)
      parameter (mxgff=72)
      parameter (mxres=42)
      parameter (mxsym=103)
      parameter (mxhsym=64)
      common /athlp/ iatoms, mxnat
      character*2 elemnt,tocapf,atom
      common /elem/elemnt(mxel)
      common /charge/ ihasq
      character*6 atmp
      character*4 atype
      common /atypes/ ihbt(mxt),atype(mxt)
      common /types/ iff
      character*5 mol2
      character*20 ambstr
      common /ftypes/ihasl(11),mol2(mxmol2),ambstr(mxamb)
      common /pdbon/ ipdbon
      character*3 pdbsym,hsym,ambtnk
      character*2 gffstr
      common /symbol/ pdbsym(mxsym),hsym(mxhsym),
     &                ambtnk(mxamb),gffstr(mxgff)
      character*3 aminos
      common /amino/aminos(mxres)
      real energy
      common /ener/iener,energy,lig(3),iprot(3),iconf
      logical ochg
      dimension ipdb(mxsym),ihpdb(mxhsym*3)
      dimension coo(3,*),qat(*),ianz(*),iaton(*),iatclr(*),
     &          iconn(mxcon+1,*),iresid(*),ityp(*),ipdbt(*),lring(*)
      dimension icalf(6,*),iamino(*)
      data atype /'    ','.1  ','.2  ','.3  ','.4  ','.ar ','.cat',
     &            '.am ','.pl3','.co2','.spc','.t3p','.O  ','.O2 '/
      data ihbt /   3   ,  1   ,  2   ,  3   ,  3   ,  4   ,  4   ,
     &              3   ,  3   ,  2   ,  3   ,  3   ,  2   ,  2   /

      toang = 0.52917706d0
      torad = datan(1.0d0) / 45.0d0

c     eerst geen h-bonds

      jflg = 0
      natoms = iatoms
      nbnds = 0
      idochg = 0

      if (ihasq.eq.1) idochg = 1

      iatred = 0
      do i=1,natoms
         if (.not.(ianz(i).eq.100.and.
     &        (iresid(i).le.0.and.iresid(i).ge.-3))) then
            iatred = iatred + 1
            do j=1,iconn(1,i)
               if (iconn(1+j,i).gt.0) then
                  if (iconn(1+j,i).gt.i) nbnds = nbnds + 1
               endif
            end do
         endif
      end do
      natoms = iatred

      do i=1,natoms
         lring(i) = 0
         iaton(i) = 2
      end do


      write(iun,'(a)') '@<TRIPOS>MOLECULE'

      if (iener.eq.1) then
         write(iun,'(a,f9.3,2(a,i3,x,i3,x,i3),a,i6)') 'E=',energy,
     &                           ' lig ',lig(1),lig(2),lig(3),
     &                           ' prot ',iprot(1),iprot(2),iprot(3),
     &                           ' conf ',iconf
      else
         write(iun,*) 'Molden generated mol2'
      endif

      write(iun,'(3(i6,1x))') natoms,nbnds,1
      write(iun,*) 'SMALL'

      if (idochg.eq.1) then
         write(iun,*) 'USER_CHARGES'
      else
         write(iun,*) 'NO_CHARGES'
      endif

      write(iun,*) '****'
      write(iun,*) '****'

      write(iun,'(a)') '@<TRIPOS>ATOM'

      do i=1,iatoms

               atom = tocapf(elemnt(ianz(i)))

               if (idochg.eq.1) then
                  q = qat(i)
               else
                  q = 0.0d0
               endif

               atmp = ' '//mol2(ityp(i))
               if (.not.(ianz(i).eq.100.and.
     &              (iresid(i).le.0.and.iresid(i).ge.-3))) then
                   write(iun,1000) 
     &                  i,atom,(coo(j,i)*toang,j=1,3),atmp,q
               endif
      end do

      write(iun,'(a)') '@<TRIPOS>BOND'

      ibnds = 1

      do i=1,natoms
         do j=1,iconn(1,i)
               k = iconn(1+j,i)
               if (k.gt.0) then
                  if (k.gt.i) then
                     ibt = ibtyp(i,k,idochg,0,ianz)
                     if (ibt.eq.2) then
                        ifl1 = 0
                        ifl2 = 0
                        do jj=1,iconn(1,i)
                           kk = iconn(1+jj,i)
                           if (kk.gt.0.and.kk.ne.k) then
                               ibth = ibtyp(i,kk,idochg,0,ianz)
                               if (ibth.eq.2.or.ibth.eq.4) ifl1 = 1
                           endif
                        end do
                        do jj=1,iconn(1,k)
                           kk = iconn(1+jj,k)
                           if (kk.gt.0.and.kk.ne.i) then
                               ibth = ibtyp(k,kk,idochg,0,ianz)
                               if (ibth.eq.2.or.ibth.eq.4) ifl2 = 1
                           endif
                        end do
                        if (ifl1.eq.1.and.ifl2.eq.1) ibt = 1
                     endif
                     if (ibt.eq.4) then
                        write(iun,'(3(i6,1x),a)') ibnds,i,k,'    ar'
                     else
                        write(iun,'(4(i6,1x))') ibnds,i,k,ibt
                     endif
                     ibnds = ibnds + 1
                  endif
               endif
          end do
      end do

      write(iun,'(a)') '@<TRIPOS>SUBSTRUCTURE'
      write(iun,*) '     1 RES1       1'

      call chkmol2(iok)
      if (iok.eq.0) then
          print*,"WARNING Mol2: atom type inconsistancy,"
          print*,"Please retyp !"
      endif

      if (jflg.eq.1)
     &    print*,"WARNING Mol2: untyped atoms !"

      do i=1,natoms
         iaton(i) = 1
      end do

1000  format(i6,1x,a2,1x,3(f10.4,1x),a6,' 1 RES1',f10.4)
1001  format(i6,1x,a4,1x,3(f10.4,1x),a6,1x,i4,1x,a3,f10.4,1x,a)
1002  format(i6,1x,a4,1x,3(f10.4,1x),a6,1x,i4,1x,a4,f10.4,1x,a)

      return
      end

      subroutine ispnd(ispn,iat,irng,idochg,ifive,
     &                      qat,ianz,iaton,iconn,lwrit,lring)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      common /athlp/  iatoms, mxnat
      logical ringg
      real angle,dihed
      dimension iring(6),isel(4),icnn(mxcon),icnn2(mxcon),ioke(2)
      dimension qat(*),iconn(mxcon+1,*),ianz(*),iaton(*),
     &          lwrit(*),lring(*)

c ifive not only signals look for five membered aromatic rings
c but also c==0 counts for no Pi electrons
c
c determine number of bonds and filter out hydrogen bonds

      ibnds = 0
      inn = 0
      do i=1,iconn(1,iat)
         if (iconn(i+1,iat).gt.0) then
            ibnds = ibnds + 1
            icnn(ibnds) = iconn(i+1,iat)
            if (ianz(iconn(i+1,iat)).eq.7) inn = inn + 1
         endif
      end do

      ispn = 1
      irng = 0
      ian = ianz(iat)
      if (ian.eq.6) then
         ispn = 4
         if (ibnds.eq.3) then
            ispn = 3
            if (inn.eq.3) ispn = 7
         elseif (ibnds.eq.2) then
            ispn = 2
         endif
      elseif (ian.eq.7) then
         ispn = 4
         if (ibnds.eq.4) then
            ispn = 5
         elseif (ibnds.eq.1) then
            ispn = 2
         elseif (ibnds.eq.2) then
            isel(1) = icnn(1)
            isel(2) = iat
            isel(3) = icnn(2)
            ispn = 2
            call intcor(intc,angle,isel,3)
            if (intc.eq.1) then
                if (abs(angle).lt.170.0e0) ispn = 3
            endif
         elseif (ibnds.eq.3) then
            ispn = 4
            isel(1) = iat
            isel(2) = icnn(1)
            isel(3) = icnn(2)
            isel(4) = icnn(3)
            call intcor(intc,dihed,isel,4)
            if (intc.eq.1) then
                if (abs(dihed).lt.3.0e0) ispn = 9
            endif
            inco = 0
            do i=1,3
               jat = icnn(i)
               call flth(jat,icnn2,ibnds2,iconn)
               if (ianz(jat).eq.6.and.ibnds2.eq.3) then
                   do j=1,3
                      kat = icnn2(j)
                      if (ianz(kat).eq.8) then
                         call flth(kat,icnn2,ibnds2,iconn)
                         if (ibnds2.eq.1) inco = jat
                      endif
                   end do
               endif
            end do
            if (inco.ne.0) then
               iamid = 1
               do i=1,3
                  jat = icnn(i)
                  if (jat.ne.inco) then
                     if (.not.(ianz(jat).eq.1.or.ianz(jat).eq.6.or.
     &                         ianz(jat).eq.7))
     &                 iamid = 0
                  endif
               end do
               if (iamid.eq.1) ispn = 8
            endif
         endif
      elseif (ian.eq.8.or.ian.eq.16) then
         ispn = 4
         if (ibnds.eq.1) then
            ispn = 3
            jat = icnn(1)
            if (ian.eq.8.and.
     &         (ianz(jat).eq.15.or.ianz(jat).eq.6)) then
               ipo2 = 0
               call flth(jat,icnn2,ibnds2,iconn)
               do i=1,ibnds2
                  kat = icnn2(i)
                  if (kat.gt.0) then
                     if (ianz(kat).eq.8.and.
     &                icred(kat,idum1,idum2,ianz,iconn).eq.1) 
     &                      ipo2 = ipo2 + 1
                  endif
               end do
               if (ipo2.eq.2) ispn = 10
            endif
         endif
         if (ian.eq.16) then
            iso2 = 0
            do i=1,ibnds
               call flth(icnn(i),icnn2,ibnds2,iconn)
               if (ianz(icnn(i)).eq.8.and.ibnds2.eq.1)
     &            iso2 = iso2 + 1
            end do
            if (iso2.eq.1) ispn = 13
            if (iso2.eq.2) ispn = 14
         endif
      elseif (ian.eq.15) then
         ispn = 4
      endif

      if (ian.ne.6.and.ian.ne.7.and.ian.ne.8.and.ian.ne.15
     &    .and.ian.ne.16) return

      do i=1,iatoms
         lring(i) = 0
      end do

      do ii=1,2
         ioke(ii) = 0
         narel = 0
         if (ringg(iat,iring,nring,.true.,ianz,iaton,iconn,
     &             lwrit,lring)) then
            irng = -1
            if (nring.eq.6.or.nring.eq.5) then
               do i=1,nring
                  jat = iring(i)
                  iann = ianz(jat)
                  if (iann.eq.6) then
                     narel = narel + 1
                     if (ifive.eq.1) then
                        call flth(jat,icnn2,ibnds2,iconn)
                        do j=1,ibnds2
                           kat = icnn2(j)
                           if (ianz(kat).eq.8.or.
     &                         ianz(kat).eq.16) then
                              if (icred(kat,idum1,idum2,ianz,iconn)
     &                            .eq.1) narel = narel - 1
                           endif
                        end do
                     endif
                  elseif (iann.eq.8.or.iann.eq.16) then
                     narel = narel + 2
                  elseif (iann.eq.15) then
                     narel = narel + 1
                  elseif (iann.eq.7) then
                     call flth(jat,icnn2,inb,iconn)
                     if (inb.eq.2.or.inb.eq.3) then
                        if (inb.eq.3) then
                           if (idochg.eq.1) then
                              if (abs(qat(jat)-1.0d0).gt.0.1d0) then
                                 narel = narel + 2
                              else
                                 narel = narel + 1
                              endif
                           else
                              narel = narel + 2
                           endif
                        elseif (inb.eq.2) then
                           narel = narel + 1
                        endif
                     else
                        ioke(ii) = 0
                     endif
                  endif
               end do
            endif
            if ((nring.eq.6.or.(nring.eq.5.and.ifive.eq.1))
     &         .and.narel.eq.6) ioke(ii) = nring
            do i=1,nring
               lring(iring(i)) = 1
            end do
         endif
      end do
      if (ioke(1).gt.0.or.ioke(2).gt.0) then
          if (ian.ne.8) ispn = 6
          if (ioke(1).eq.6.or.ioke(2).eq.6) irng = 1
          if (ioke(1).eq.5.or.ioke(2).eq.5) then
              irng = 2
              if (ian.eq.16) ispn = 3
          endif
          if (ioke(1).eq.6.and.ioke(2).eq.6) then
              irng = 3
          elseif (ioke(1).eq.5.and.ioke(2).eq.5) then
              irng = 4
          elseif (ioke(1).gt.0.and.ioke(2).gt.0) then
              irng = 5
          endif
      endif

      call flush
      return
      end 

      subroutine chkmld(iok,ianz,ityp)
      parameter (mxmol2=41)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      save mol2ck
      common /athlp/ iatoms, mxnat
      dimension mol2ck(mxmol2),ianz(*),ityp(*)
      data mol2ck / 0,0,0,0,
     &    6,6,6,6,6,
     &    7,7,7,7,7,7,7,
     &    8,8,8,8,8,
     &    16,16,16,16,15,
     &    1,1,1,
     &    9,17,35,53,14,0,0,
     &    11,19,20,3,13/

      iok = 1

      imiss = 0
      do i=1,iatoms
         it = ityp(i)
         if (it.le.0) then
            iat1 = 0
         else
            iat1 = mol2ck(ityp(i))
         endif
         iat2 = ianz(i)
         if (iat1.ne.0) then
            if (iat1.ne.iat2) imiss = imiss + 1
            if (iat1.ne.iat2) print*,"i ",i
         endif
      end do

      if (imiss.gt.0) iok = 0

      return
      end

      subroutine flth(iat,icnn,ibnds,iconn)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxcon=10)
      dimension iconn(mxcon+1,*),icnn(mxcon)

      ibnds = 0
      do i=1,iconn(1,iat)
         if (iconn(i+1,iat).gt.0) then
            ibnds = ibnds + 1
            icnn(ibnds) = iconn(i+1,iat)
         endif
      end do

      return
      end

      logical function ochg(idum,ianz)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (numatm=2000)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      dimension ianz(*)

      ochg = .true.
      if (natoms.eq.0) ochg = .false.
      do i=1,natoms
         if (nat(i).ne.ianz(i)) ochg = .false.
      end do

      return
      end

      subroutine rdinfd(npts1,npts2,isubtr,istat,dens,denst)
      implicit double precision (a-h,o-z)

c THIS IS REALLY rdinfo

      parameter (numatm=2000)
      logical valenc,bonds,ovrlap,atomic,doori,ostep,fine,dolap
      logical oscal,doelf
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /grdhlp/ mx3d,mx3d2
      character*80 mapfil
      character*80 grdfil
      common /maphlp/ mapfil,grdfil
      logical denok,opfil
      character lstr*137
      dimension txyz(3),dens(*),denst(*)

      small = 1.0d-4
      istat = 1

      m  = linlen(grdfil)

      if (.not.opfil(21,grdfil(1:m),m,0,1,0)) then
         lstr = 'gridfile non-existent'
         goto 100
      endif
      lstr = 'trying '//grdfil(1:m)

      pmax   = -100000.d0
      pmin   =  100000.d0
c      ipsi = 0
c      bonds  = .false.
c      atomic = .false.
c      ovrlap = .false.

      read(21,end=100,err=100) katoms
      if (isubtr.eq.0) then
         natoms = katoms
      else
         if (katoms.ne.natoms) then
            lstr = 'number of read atoms incorrect'
            goto 100
         endif
      endif

      taccu = 0
      do i=1,natoms
         read(21,end=100,err=100)(txyz(j),j=1,3)
         if (isubtr.eq.0) then
            do j=1,3
               xyz(j,i) = txyz(j)
            end do
         else
            taccu = taccu + (vlen(txyz) - vlen(xyz(1,i)))**2
         endif
      end do
      if (isubtr.ne.0) then
         if (taccu.gt.small) then
            lstr = 'cartesian coordinates read incorrect'
            goto 100
         endif
      endif

      read(21,end=100,err=100) 
     &    px, py, pz, cx, cy, cz, r(1),r(2),npts1,npts2

      if (npts1.gt.mx3d.or.npts2.gt.mx3d) then
          lstr = 'dimension greater than maximum !'
          print*,'npts1 ',npts1,' npts2 ',npts2,' maxdim ',mx3d
          goto 100
      endif

      r(3) = r(1)

c      ipsi = 0
c      bonds  = .false.
c      atomic = .false.
c      ovrlap = .false.
      if (ipsi.ne.0.or.
     &       (ipsi.eq.0.and.(bonds.or.atomic.or.ovrlap))) then
         call messg(11)
      endif
c      call pareul
c      call proato
c      call denmak(denok)
c      call grdcal(dens,npts1,npts2,1,0)

      read(21,end=100,err=100) (denst(i),i=1,npts1*npts2)
      do i=1,npts1*npts2
         if (isubtr.eq.0) then
            dens(i) = denst(i)
         else
            dens(i) = dens(i) - denst(i)
         endif
         if (dens(i).gt.pmax) pmax = dens(i)
         if (dens(i).lt.pmin) pmin = dens(i)
      end do

      pmax = max(pmax,-pmin)

      step = 0.005d0

      close(21)

      lstr = 'found '//grdfil(1:m)
      call inferr(lstr,0)
      return

100   close(21)
      istat = 0
      natoms = 0
      call inferr(lstr,0)
      return
      end

      subroutine tstrd3
      implicit double precision (a-h,o-z)
      common /grdhlp/ mx3d,mx3d2
      character*80 mapfil
      character*80 grdfil
      common /maphlp/ mapfil,grdfil

      logical opfil

      small = 1.0d-4
      istat = 1

      m = linlen(grdfil)
      if (.not.opfil(21,grdfil(1:m),m,0,1,0)) return

      rewind(21)
      read(21,end=100,err=100) katoms

      read(21,end=100,err=100) (natt,i=1,katoms)

      read(21,end=100,err=100) adjust

      do i=1,katoms
         read(21,end=100,err=100)(txyz,j=1,3)
      end do

      read(21,end=100,err=100) pxt, pyt, pzt, cxt, cyt, czt, 
     &                 rt,rt,rt, npts1,npts2,npts3,iplt

      nptsmx = npts1
      if (npts2.gt.nptsmx) nptsmx = npts2
      if (npts3.gt.nptsmx) nptsmx = npts3

      if (nptsmx.gt.mx3d) call allgrd(nptsmx)

100   close(21)

      return
      end

      subroutine rd3ind(npts1,npts2,npts3,isubtr,adjus,istat,
     &                  denn,pmnn,denst)
      implicit double precision (a-h,o-z)

c THIS REALLY rd3inf

      parameter (numatm=2000)
      logical valenc,bonds,ovrlap,atomic,doori,ostep,fine,dolap
      logical oscal,doelf
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      common /option/ ipsi,idebug,valenc,bonds,ovrlap,atomic,doori,
     &                dolap,doelf
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /rd3d/   ird3d
      common /grdhlp/ mx3d,mx3d2
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      character*80 mapfil
      character*80 grdfil
      common /maphlp/ mapfil,grdfil
      logical denok,opfil

      character lstr*137
      dimension txyz(3),natt(numatm),rt(3),np(3)
      dimension denn(*),pmnn(*),denst(*)

      small = 1.0d-4
      istat = 1

      if ((ipsi.ne.0.or.bonds.or.atomic.or.ovrlap)
     &    .and.isubtr.eq.1) then
          call inferr('Only Normal Density Can be Subtracted!',0)
          istat = 0
          return
      endif

      m = linlen(grdfil)
      if (.not.opfil(21,grdfil(1:m),m,0,1,0)) then
         lstr = '3dgridfile non-existent'
         goto 100
      endif
      rewind(21)

      ird3d = 1
      read(21,end=100,err=100) katoms
      if (isubtr.eq.1) then
         if (katoms.ne.natoms) then
            lstr = 'number of read atoms incorrect'
            goto 100
         endif
      else
         natoms = katoms
      endif

      read(21,end=100,err=100) (natt(i),i=1,natoms)

      read(21,end=100,err=100) adjust
      if (isubtr.eq.0) adjus = adjust
c      print*,'adjust=',adjust

      taccu = 0
      do i=1,natoms
         read(21,end=100,err=100)(txyz(j),j=1,3)
         if (isubtr.eq.1) then
            taccu = taccu + (vlen(txyz) - vlen(xyz(1,i)))**2
         else
            nat(i) = natt(i)
            do j=1,3
                xyz(j,i) = txyz(j)
            end do
         endif
      end do
      if (taccu.gt.small.and.isubtr.eq.1) then
         lstr = 'cartesian coordinates read incorrect'
         goto 100
      endif

      read(21,end=100,err=100) pxt, pyt, pzt, cxt, cyt, czt, 
     &                 rt(1),rt(2),rt(3), np(1),np(2),np(3),iplt

      write(*,'(a,3(f9.3,1x))') 'Center',pxt,pyt,pzt
      write(*,'(a,3(f9.3,1x))') 'Line  ',cxt,cyt,czt
      write(*,'(a,3(f9.3,1x))') 'edge  ',rt(1),rt(2),rt(3)

      if (np(1).gt.mx3d.or.np(2).gt.mx3d.or.np(3).gt.mx3d) then
          lstr = 'dimension greater than maximum !'
          print*,'npts1 ',np(1),' npts2 ',np(2),' npts3 ',np(3),
     &           ' maxdim ',mx3d
          goto 100
      endif


      if (isubtr.eq.1) then
         if (pxt.ne.px.or.pyt.ne.py.or.pzt.ne.pz
     &   .or.cxt.ne.cx.or.cyt.ne.cy.or.czt.ne.cz
     &   .or.rt(1).ne.r(1).or.rt(2).ne.r(2).or.rt(3).ne.r(3)
     &   .or.np(1).ne.npts1.or.np(2).ne.npts2.or.np(3).ne.npts3
     &   .or.iplt.ne.iplat) then
            lstr = 'NOT the same CENTER,LINE or EDGE used !'
            print*,'old px py pz ',px,py,pz,' cx cy cz ',cx,cy,cz
            print*,'    edx,edy,edz ',r(1),r(2),r(3),' iplat ',iplat
            print*,'    npts1,npts2,npts3 ',npts1,npts2,npts3
            print*,'new px py pz ',pxt,pyt,pzt,' cx cy cz ',cxt,cyt,czt
            print*,'    edx,edy,edz ',rt(1),rt(2),rt(3),' iplat ',iplat
            print*,'    npts1,npts2,npts3 ',np(1),np(2),np(3)
            goto 100
         endif
      else
         iplat = iplt
         px = pxt
         py = pyt
         pz = pzt
         cx = cxt
         cy = cyt
         cz = czt

         cl = cxt*cxt + cyt*cyt + czt*czt
         cl = dsqrt(cl)
         cx = cx/cl
         cy = cy/cl
         cz = cz/cl

         do i=1,3
            r(i) = rt(i)
         end do
         npts1 = np(1)
         npts2 = np(2)
         npts3 = np(3)

         call pareul
         call parrat
         call proato
         ipsi = 0
         ofrst = .false.
      endif

      do j=1,npts3
         pmnn(j) = 100000.d0
         read(21,end=100)(denst(i),i=1,npts1*npts2)
         do i=1,npts1*npts2
            if (isubtr.eq.1) then
               denn((j-1)*mx3d2 + i) = denn((j-1)*mx3d2 + i) 
     &                                    - denst(i)
            else
               denn((j-1)*mx3d2 + i) = denst(i)
            endif
         end do
      end do

      close(21)

      lstr = 'found '//grdfil(1:m)
      call inferr(lstr,0)
      return

100   close(21)
      natoms = 0
      istat = 0
      call inferr(lstr,0)
      return
      end

      subroutine rd3chd(npts1,npts2,npts3,igauss,impas,istat,fmap)
      implicit double precision (a-h,o-z)
      common /grdhlp/ mx3d,mx3d2
      character*80 mapfil
      character*80 grdfil
      common /maphlp/ mapfil,grdfil
      character lstr*137
      logical opfil,oampac
      dimension np(3),dtmp(6)
      dimension fmap(*)

      istat = 1
      itype = 0
      iform = 0
      if (igauss.eq.1) iform = 1
      iun = 21

      m = linlen(mapfil)
      if (.not.opfil(iun,mapfil(1:m),m,iform,1,0)) then
         lstr = 'mapfile non-existent'
         call inferr(lstr,0)
         call messg(8)
         istat = 0
         return
      endif

      lstr = 'read error'

      if (igauss.eq.1) then
         read(iun,'(a)',end=100) lstr
         read(iun,'(a)',end=100) lstr
         if (index(lstr,'Density').ne.0) itype = 0
         if (index(lstr,'MO coefficients').ne.0) itype = 1
         read(iun,'(a)') lstr
         oampac = (linlen(lstr).eq.44)
         if (oampac) then
            read(lstr,'(i5,3f13.6)') natoms,(rdum,i=1,3)
         else
            read(lstr,'(i5,3f12.6)') natoms,(rdum,i=1,3)
         endif
         if (natoms.lt.0) itype = 1
         natoms = iabs(natoms)

         if (oampac) then
            read(iun,'(i5,3f13.6)') np(1),(rdum,i=1,3)
            read(iun,'(i5,3f13.6)') np(2),(rdum,i=1,3)
            read(iun,'(i5,3f13.6)') np(3),(rdum,i=1,3)
         else
            read(iun,'(i5,3f12.6)') np(1),(rdum,i=1,3)
            read(iun,'(i5,3f12.6)') np(2),(rdum,i=1,3)
            read(iun,'(i5,3f12.6)') np(3),(rdum,i=1,3)
         endif

         do i=1,natoms
            read(iun,'(a)') lstr
         end do

         if (itype.eq.1) then
            read(iun,'(i5)') no
            if (no.gt.1) then
               lstr = 'ONLY single orbital cube files are supported !'
               goto 100
            endif
            nlines = (no + 1) / 10
            if (no+1 - nlines*10.gt.0) nlines = nlines + 1
            do i=1,nlines-1
               read(iun,'(a)') lstr
            end do
         endif

      else
         read(iun,end=100) katoms
         read(iun,end=100) (idum,i=1,katoms)
         read(iun,end=100) rdum
         do i=1,katoms
            read(iun,end=100) (rdum,j=1,3)
         end do
         read(iun,end=100) (rdum,i=1,9),np(1),np(2),np(3),idum
      endif

      if (np(1).ne.npts1.or.np(2).ne.npts2.or.np(3).ne.npts3) then
        print*,'npts1-3 ',npts1,npts2,npts3,' np1-3 ',np(1),np(2),np(3)
          lstr = 'dimensions grid dont match first grids !'
          call messg(10)
          close(iun)
          istat = 0
          return
      endif

      if (impas.eq.0) then

         call almgrd

      else

         lstr = 'read error'

         if (igauss.eq.1) then

            ij = 0
            do i=1,npts1
               do j=1,npts2
                  ij = ij + 1
                  kk = 0
                  do while (kk.lt.npts3)
                     n = 6
                     if (npts3-kk.lt.n) n = npts3-kk
                     read(iun,'(6E13.5)') (dtmp(k),k=1,n)
                     do k=1,n
                        fmap((npts3-(kk+k))*mx3d2 + ij) = dtmp(k)
                     end do
                     kk = kk + 6
                  end do
               end do
            end do

         else

            do j=1,npts3
               read(iun,end=100)(fmap((j-1)*mx3d2 + i),
     &              i=1,npts1*npts2)
            end do

         endif

      endif

      
      close(iun)

      return

100   istat = 0
      close(iun)
      call inferr(lstr,0)
      call messg(10)
      return
      end

      subroutine rotatg(nat,idebug)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      common /rotxyz/ amat(3,3),bmat(3,3),cmat(3,3),rmat(3,3),todeg
      common /orient/ o321g(9,9),o431g(9,9),o631g(9,9),f321g(9,9),
     &                f431g(9,9),f631g(9,9),s321g(13,13),s431g(13,13),
     &                s631g(13,13),cl321g(13,13),cl431g(13,13),
     &                cl631g(13,13)
      common /orihlp/ ori(numatm),iuser(numatm),oalpha(numatm),
     $                obeta(numatm),norien,ibal
      common /del1/   dmolin(169),dofscl(169)
      common /del2/   d11(3,3),d12(3,3),d21(3,3),d22(3,3),
     &                f11(3),f12(3),f21(3),f22(3),occ(3),
     &                p(3,3),g(3,3),ibasis,idim
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension angle(2)

c###### split valence part ###############
c     dmolin contains the atomic part off the molecular
c            density matrix
c     dofscl   contains the oriented atomic density matrix
c            on return
c     idim   dimension of atomic density matrix without
c            polarisation function (=9 for o and f,
c                                   =13 for s and cl )
c     d11,d12,d21,d22
c            contain the p*p p*p' p'*p and p'*p' parts
c            of the atomic density matrix
c     f11,f12,f21,f22
c            idem,but now only diagonal terms
c
c--- initialisation -----
c
      todeg = 45.0d0 / datan(1.0d0)
      delold = 1.0d5

      amat(1,3) = 0.0d0
      amat(2,3) = 0.0d0
      amat(3,1) = 0.0d0
      amat(3,2) = 0.0d0
      amat(3,3) = 1.0d0
      bmat(1,2) = 0.0d0
      bmat(2,1) = 0.0d0
      bmat(2,2) = 1.0d0
      bmat(2,3) = 0.0d0
      bmat(3,2) = 0.0d0

      if (ibasis.eq.0) then

c----- sto3g ----------

         if (nat.eq.8.or.nat.eq.16) then
            occ(1) = 2.0d0
            occ(2) = 1.0d0
            occ(3) = 1.0d0
         endif
         if (nat.eq.9.or.nat.eq.17) then
            occ(1) = 2.0d0
            occ(2) = 2.0d0
            occ(3) = 1.0d0
         endif

      else

c------- spit valence -------

         if (nat.eq.8) then

           if (ibasis.eq.1) then

              do i=1,9
                 do j=1,9
                    dofscl(j+(i-1)*idim) = o321g(i,j)
                 end do
              end do

           elseif (ibasis.eq.2) then

              do i=1,9
                 do j=1,9
                    dofscl(j+(i-1)*idim) = o431g(i,j)
                 end do
              end do

           elseif (ibasis.eq.3) then

              do i=1,9
                 do j=1,9
                    dofscl(j+(i-1)*idim) = o631g(i,j)
                 end do
              end do

           endif

         endif

         if (nat.eq.9) then
           if (ibasis.eq.1) then

              do i=1,9
                 do j=1,9
                    dofscl(j+(i-1)*idim) = f321g(i,j)
                 end do
              end do

           elseif (ibasis.eq.2) then

              do i=1,9
                 do j=1,9
                    dofscl(j+(i-1)*idim) = f431g(i,j)
                 end do
              end do

           elseif (ibasis.eq.3) then

              do i=1,9
                 do j=1,9
                    dofscl(j+(i-1)*idim) = f631g(i,j)
                 end do
              end do

           endif
         endif

         if (nat.eq.16) then

           if (ibasis.eq.1) then

              do i=1,13
                 do j=1,13
                    dofscl(j+(i-1)*idim) = s321g(i,j)
                 end do
              end do

           elseif (ibasis.eq.2) then

              do i=1,13
                 do j=1,13
                    dofscl(j+(i-1)*idim) = s431g(i,j)
                 end do
              end do

           elseif (ibasis.eq.3) then

              do i=1,13
                 do j=1,13
                    dofscl(j+(i-1)*idim) = s631g(i,j)
                 end do
              end do

           endif

         endif

         if (nat.eq.17) then

           if (ibasis.eq.1) then

              do i=1,13
                 do j=1,13
                    dofscl(j+(i-1)*idim) = cl321g(i,j)
                 end do
              end do

           elseif (ibasis.eq.2) then

              do i=1,13
                 do j=1,13
                    dofscl(j+(i-1)*idim) = cl431g(i,j)
                 end do
              end do

           elseif (ibasis.eq.3) then

              do i=1,13
                 do j=1,13
                    dofscl(j+(i-1)*idim) = cl631g(i,j)
                 end do
              end do

           endif

         endif

         idim2=idim*idim
         do i=1,3
            f11(i) = dofscl(idim2+(i-7)*(idim+1))
            f12(i) = dofscl(idim2+(i-3)*idim-7+i)
            f21(i) = f12(i)
            f22(i) = dofscl(idim2+(i-3)*(idim+1))
         end do
      endif

c---- end initialisation -----

      write(iun3,*)' '
      write(iun3,*)'p-part atomic density matrix before orientation'
      write(iun3,*)' '

      if (ibasis.ne.0) then

          do i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dofscl(k1+idim-7+j),j=1,3),
     &                   (dofscl(k1+idim-3+j),j=1,3)
          end do

          write(iun3,*)' '

          do i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dofscl(k2+idim-7+j),j=1,3),
     &                   (dofscl(k2+idim-3+j),j=1,3)
          end do

      else

          write(iun3,'(f9.4,a)')occ(1),'   0.0000   0.0000'
          write(iun3,'(a,f9.4,a)')'   0.0000',occ(2),'   0.0000'
          write(iun3,'(a,f9.4)')'   0.0000   0.0000',occ(3)

      endif

      write(iun3,*)' '

      if (iuser(ibal).eq.1) then
         angle(1) = oalpha(ibal)
         angle(2) = obeta(ibal)
         delta    = del(angle)
         goto 1400
      endif

c----- start of coarse search ----

      do ia=0,180,10

         angle(1) = dfloat(ia)

         do ib=0,180,10

            angle(2) = dfloat(ib)
            delta = del(angle)

            if (delta.lt.delold) then
                 delold = delta
                 alopt  = angle(1)
                 beopt  = angle(2)
            endif

         end do

      end do

      angle(1) = alopt
      angle(2) = beopt

c----- end of coarse search ------

c----- start of medium search ----

      alco = alopt
      beco = beopt

      do ia=1,21

         angle(1) = alco + dfloat(ia-1)-10.0d0

         do ib=1,21

            angle(2) = beco + dfloat(ib-1)-10.0d0
            delta    = del(angle)

            if (delta.lt.delold) then
              delold = delta
              alopt  = angle(1)
              beopt  = angle(2)
            endif

         end do

       end do

c----- end of medium search ------

c----- start of fine search ----

      alco = alopt
      beco = beopt

      do ia=1,21

         angle(1) = alco + dfloat(ia-1)*0.1d0-1.0d0

         do ib=1,21

            angle(2) = beco + dfloat(ib-1)*0.1d0-1.0d0
            delta    = del(angle)

            if (delta.lt.delold) then
              delold = delta
              alopt  = angle(1)
              beopt  = angle(2)
            endif

         end do

      end do

c----- end of fine search ------

      angle(1) = alopt
      angle(2) = beopt
      delta    = del(angle)

1400  continue

      write(iun3,*)' '
      write(iun3,*)'delta squared                  =',delta
      write(iun3,*)'alfa  optimised                =',angle(1)
      write(iun3,*)'beta  optimised                =',angle(2)
      write(iun3,*)' '
      write(iun3,*)'-------- rot-matrix ----------'
      write(iun3,*)' '

      do i=1,3
         write(iun3,120)(rmat(i,j),j=1,3)
      end do

      write(iun3,*)' '

      if (ibasis.eq.0) then

          write(iun3,*)'p-part molecular density matrix'
          write(iun3,*)' '

          do i=1,3
             write(iun3,120)(g(i,j),j=1,3)
          end do

          write(iun3,*)' '
          write(iun3,*)'p-part oriented atomic density matrix'
          write(iun3,*)' '

          do i=1,3
             write(iun3,120)(p(i,j),j=1,3)
          end do

      else

          write(iun3,*)'p-part molecular density matrix'
          write(iun3,*)' '

          do i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dmolin(k1+idim-7+j),j=1,3),
     &                      (dmolin(k1+idim-3+j),j=1,3)
          end do

          write(iun3,*)' '

          do i=1,3
             k1=(idim-8+i)*idim
             k2=(idim-4+i)*idim
             write(iun3,130)(dmolin(k2+idim-7+j),j=1,3),
     &                   (dmolin(k2+idim-3+j),j=1,3)
          end do

          write(iun3,*)' '
          write(iun3,*)'p-part oriented atomic density matrix'
          write(iun3,*)' '

          do i=1,3
             write(iun3,130)(d11(i,j),j=1,3),(d12(i,j),j=1,3)
          end do

          write(iun3,*)' '

          do i=1,3
             write(iun3,130)(d21(i,j),j=1,3),(d22(i,j),j=1,3)
          end do

          write(iun3,*)' '
      endif

120   format(10x,3f9.4)
130   format(10x,3f9.4,2x,3f9.4)

      return
      end

      subroutine eulstr(px,py,pz,rval)
      implicit double precision (a-h,o-z)
c     print string
      real xx, yy
      character*80 str
      logical euclid, yes
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /eul/    ca,cb,sa,sb,ccab,scab,ssab,scba
      common /plrat/  rat(3)
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plot / iplot,iplwin,icolps

      roff = 0.01d0
      if (rval.lt.10000.0d0.and.rval.ge.1.0d0) then
          write(str,'(f7.1)') rval
          nstr = 7
      else
          write(str,'(f7.4)') rval
          nstr = 7
      endif
      cy = ccab*(px-0.5d0)*rat(1) + scab*(py-0.5d0)*rat(2) 
     &     - sb*pz*rat(3)
      cx =  -sa*(px-0.5d0)*rat(1) +   ca*(py-0.5d0)*rat(2)

      if (euclid) then
         r2 = 1.0d0
      else
         r2 = dsqrt(2.0d0)
      endif
      cx = 0.5d0 + cx / r2
      cy = 0.5d0 + cy / r2

      if (iplot.eq.6) then
         if (rval.le.0.d0) then
            xx = 5.0
         else
            xx = 7.0
         endif
         call xwin(xx,yy,99,str,nstr,idum1,idum2)
         xx = cx - roff
         yy = cy
         call xwin(xx,yy,2,str,nstr,idum1,idum2)
         xx = cx + roff
         yy = cy
         call xwin(xx,yy,3,str,nstr,idum1,idum2)
         xx = cx 
         yy = cy - roff
         call xwin(xx,yy,2,str,nstr,idum1,idum2)
         xx = cx
         yy = cy + roff
         call xwin(xx,yy,3,str,nstr,idum1,idum2)
         xx = 5.0
         call xwin(xx,yy,99,str,nstr,idum1,idum2)
         xx = cx
         yy = cy 
         call xwin(xx,yy,4,str,nstr,idum1,idum2)
      endif

      if (iplot.eq.4) then
         write(iun4,'(''   0.5 setgray'')')
         write(iun4,'(''n '',i4,'' '',i4,'' 10 0 360 arc fill'')')
     +   int(cx*2000),int(cy*2000+125)
         write(iun4,'(''   0 setgray'')')
         write(iun4,'(i4,'' '',i4,'' m (   '',a,'') show'')')
     +   int(cx*2000),int(cy*2000+125),str(1:nstr)
      endif

      return
      end

      subroutine planky(npts1,npts2,npts3,keywrd,defau)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxvalc=10)
      logical defau
      logical keyi,keyr,keyiv,keyrv,keyirv
      character*(*) keywrd
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /coord / xyz(3,numatm)
      common /moldat/ natoms, norbs, nelecs, nat(numatm)
      logical oscal,ostep,fine
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      common /srfhlp/edge,ctval(mxvalc),pxyz(3),nvalc,nspts,istyp
      common /grdhlp/ mx3d,mx3d2
      dimension d1(3),d2(3),c12(3)

      todeg = 45.0d0 / datan(1.0d0)
      iflag = 0
      imxflg = 0

      if (.not.keyrv(keywrd,'CENTER',px,py,pz)) then
          if (keyi(keywrd,'CENTER',i)) then
             if (i.gt.natoms) then
                call inferr('CENTER: Atom Nr. > Nr. of Atoms !',1)
                return
             endif
             iplat = 0
             iflag = 1
             px = xyz(1,i)
             py = xyz(2,i)
             pz = xyz(3,i)
          endif
      else
          iplat = 0
          iflag = 1
      endif

      if (.not.keyrv(keywrd,'LINE',cx,cy,cz)) then
          if (keyi(keywrd,'LINE',i)) then
             if (i.gt.natoms) then
                call inferr('LINE: Atom Nr. > Nr. of Atoms !',1)
                return
             endif
             iplat = 0
             iflag = 1
             cx = xyz(1,i) - px
             cy = xyz(2,i) - py
             cz = xyz(3,i) - pz
          endif
      else
          iplat = 0
          iflag = 1
      endif

      if (keyiv(keywrd,'PLANE',iat1,iat2,iat3)) then
          if (iflag.eq.1) then
             call inferr('CENTER/LINE and Plane EXCLUSIVE!',1)
             return
          endif
          if((iat1.gt.natoms).or.(iat2.gt.natoms).or.(iat3.gt.natoms))
     &    then
             call inferr('PLANE: Atom nr. > number of atoms !',1)
             return
          endif
          call parpla(iat1,iat2,iat3,istat)
          if (istat.eq.1) print*,'Three atoms lie on a line !'
          iflag = 2
      endif

      if (iflag.eq.0.and.defau) call defpc

      if (keyirv(keywrd,'ROT',iata,iatb,degree)) then
          if (iflag.eq.1.or.iflag.eq.0) then
            if (iflag.eq.1) 
     &         call inferr('Center/Line and Rot are EXCLUSIVE',1)
            if (iflag.eq.0) 
     &         call inferr('ROT used before PLANE !',1)
            return
          endif
          if (((iata.ne.iat1).and.(iata.ne.iat2).and.(iata.ne.iat3))
     &    .or.((iatb.ne.iat1).and.(iatb.ne.iat2).and.(iatb.ne.iat3)))
     &    then
             call inferr('ROT: atom used not used with Plane !',1)
             return
          endif
          radian = degree / todeg
          do i=1,3
            d1(i) = (xyz(i,iatb) - xyz(i,iata))
          end do
          d2(1) = cx
          d2(2) = cy
          d2(3) = cz
          px = xyz(1,iata) + 0.5d0*d1(1)
          py = xyz(2,iata) + 0.5d0*d1(2)
          px = xyz(3,iata) + 0.5d0*d1(3)
          d2norm = vlen(d2)
          do i=1,3
            d2(i) = d2(i)/d2norm
          end do
          call crprod(d1,d2,c12)
          c12nrm = vlen(c12)
          do i=1,3
            c12(i) = c12(i)/c12nrm
          end do
          cx = dcos(radian)*d2(1) - dsin(radian)*c12(1)
          cy = dcos(radian)*d2(2) - dsin(radian)*c12(2)
          cz = dcos(radian)*d2(3) - dsin(radian)*c12(3)
          iplat = 0
      endif

      if (keyr(keywrd,'LIFT',rlift)) call dolift(rlift)

      if (.not.keyr(keywrd,'EDGE',r(1))) then
         if (defau) call defrad(.false.)
      else
         r(2) = r(1)
         r(3) = r(1)
      endif

      if (.not.keyr(keywrd,'EDZ',r(3))) then
         r(3) = r(1)
      endif

      if (.not.keyr(keywrd,'EDY',r(2))) then
         r(2) = r(1)
      endif

      if (.not.keyr(keywrd,'EDX',r(1))) idum = 1

      if (r(1).lt.0.01d0) then
         r(1) = 3.0
         r(2) = r(1)
         r(3) = r(1)
      endif

      if (keyi(keywrd,'NPTSX',npts1)) then
         if (npts1.gt.mx3d) imxflg = 1
      endif
      if (keyi(keywrd,'NPTSY',npts2)) then
         if (npts2.gt.mx3d) imxflg = 1
      endif
      if (keyi(keywrd,'NPTSZ',npts3)) then
         if (npts3.gt.mx3d) imxflg = 1
      endif

      if (imxflg.eq.1) then
         nptsmx = npts1
         if (npts2.gt.nptsmx) nptsmx = npts2
         if (npts3.gt.nptsmx) nptsmx = npts3
         call allgrd(nptsmx)
         if (nptsmx.gt.mx3d) then
             call inferr('Exceeding maximum points !',1)
             if (npts1.gt.mx3d) npts1 = mx3d
             if (npts2.gt.mx3d) npts2 = mx3d
             if (npts3.gt.mx3d) npts3 = mx3d
         endif
      endif

      oneold = one
      if (.not.keyr(keywrd,'PHASE',one)) then
         if (index(keywrd,'PHASE').ne.0) one = -1.d0*one
      else
         if (one.eq.0.0d0) one = -1.d0*oneold
      endif

      if (index(keywrd,'ALIGN').ne.0) then
         px = pxyz(1)
         py = pxyz(2)
         pz = pxyz(3)
         iplat = 0
      endif

      write(iun3,10) px, py, pz, cx, cy, cz, r(1), r(2), r(3)
10    format(9x,'  CENTER OF GRAPH           AXIS OF GRAPH       RADII',
     1/9X,      'PX      PY      PZ        CX      CY      CZ',
     24X,      'EDX   EDY   EDY',
     3/,5X,3F8.3,F10.3,2F8.3,3F6.1,///)

      return
      end

      logical function keyi(keyl,keyw,ival)
      implicit double precision (a-h,o-z)
      character*(*) keyl,keyw
      
      keyi = .false.
      l = linlen(keyw)
      i = index(keyl,keyw)
      if (i.ne.0) then
          if ((i.eq.1.or.keyl(i-1:i-1).eq.' ').and.
     &         keyl(i+l:i+l).eq.'=') then
             ival = reada(keyl,i,len(keyl))
             keyi = .true.
          endif
      endif

      return
      end

      logical function keyr(keyl,keyw,rval)
      implicit double precision (a-h,o-z)
      character*(*) keyl,keyw
      
      keyr = .false.
      i = index(keyl,keyw)
      l = linlen(keyw)
      if (i.ne.0) then
          if ((i.eq.1.or.keyl(i-1:i-1).eq.' ').and.
     &         keyl(i+l:i+l).eq.'=') then
             rval = reada(keyl,i,len(keyl))
             keyr = .true.
          endif
      endif

      return
      end

      logical function keyrv(keyl,keyw,r1,r2,r3)
      implicit double precision (a-h,o-z)
      character*(*) keyl,keyw
      
      keyrv = .false.
      kend = len(keyl)

      i = index(keyl,keyw)
      if (i.eq.0) return
      i = i + len(keyw)
      j = index(keyl(i:kend),'(')
      if (j.eq.0) return
      do k=0,j-2
         if (keyl(i+k:i+k).ne.' '.and.keyl(i+k:i+k).ne.'=') return
      end do
      i = i + j 
      r1 = reada(keyl,i,len(keyl))
      j = index(keyl(i:kend),',')
      if (j.eq.0) return
      i = i + j 
      r2 = reada(keyl,i,len(keyl))
      j = index(keyl(i:kend),',')
      if (j.eq.0) return
      i = i + j 
      r3 = reada(keyl,i,len(keyl))

      keyrv = .true.
      return
      end

      integer function keyr3v(keyl,keyw,r,n)
      implicit double precision (a-h,o-z)
      character*(*) keyl,keyw
      dimension r(*)
      
      keyr3v = 0
      kend = len(keyl)

      i = index(keyl,keyw)
      if (i.eq.0) return
      i = i + len(keyw)
      j = index(keyl(i:kend),'(')
      if (j.eq.0) return
      do k=0,j-2
         if (keyl(i+k:i+k).ne.' '.and.keyl(i+k:i+k).ne.'=') return
      end do

      do l=1,n
         i = i + j 
         r(l) = reada(keyl,i,len(keyl))
         keyr3v = keyr3v + 1
         j = index(keyl(i:kend),',')
         if (j.eq.0) return
      end do

      return
      end

      logical function keyiv(keyl,keyw,i1,i2,i3)
      implicit double precision (a-h,o-z)
      character*(*) keyl,keyw
      
      keyiv = .false.
      kend = len(keyl)

      i = index(keyl,keyw)
      if (i.eq.0) return
      i = i + len(keyw)
      j = index(keyl(i:kend),'(')
      if (j.eq.0) return
      do k=0,j-2
         if (keyl(i+k:i+k).ne.' '.and.keyl(i+k:i+k).ne.'=') return
      end do
      i = i + j 
      i1 = reada(keyl,i,len(keyl))
      j = index(keyl(i:kend),',')
      if (j.eq.0) return
      i = i + j 
      i2 = reada(keyl,i,len(keyl))
      j = index(keyl(i:kend),',')
      if (j.eq.0) return
      i = i + j 
      i3 = reada(keyl,i,len(keyl))

      keyiv = .true.
      return
      end

      logical function keyirv(keyl,keyw,i1,i2,r)
      implicit double precision (a-h,o-z)
      character*(*) keyl,keyw
      
      keyirv = .false.
      kend = len(keyl)

      i = index(keyl,keyw)
      if (i.eq.0) return
      i = i + len(keyw)
      j = index(keyl(i:kend),'(')
      if (j.eq.0) return
      do k=0,j-2
         if (keyl(i+k:i+k).ne.' '.and.keyl(i+k:i+k).ne.'=') return
      end do
      i = i + j 
      i1 = reada(keyl,i,len(keyl))
      j = index(keyl(i:kend),',')
      if (j.eq.0) return
      i = i + j 
      i2 = reada(keyl,i,len(keyl))
      j = index(keyl(i:kend),',')
      if (j.eq.0) return
      i = i + j 
      r = reada(keyl,i,len(keyl))

      keyirv = .true.
      return
      end

      subroutine fndcal(itarg,isel,indx,istat,icalf,ncalf)
      implicit double precision (a-h,p-x),integer (i-n),logical (o)
      dimension icalf(6,*)

      istat = 1
      do i=1,ncalf
         if (icalf(isel,i).eq.itarg) then
            indx = i
            return
         endif
      end do

      istat = 0
      return
      end

      character*5 function tk4014(ix,iy)
      integer highx,highy,lowx,lowy,extrax,extray,extra
c
c     tektronix-4014
c
c     highx  = <bit-7> ... <bit-11> von ix
c     highy  = <bit-7> ... <bit-11> von iy
c     lowx   = <bit-2> ... <bit-6>  von ix
c     lowy   = <bit-2> ... <bit-6>  von iy
c     extrax = <bit-0> ... <bit-1>  von ix
c     extray = <bit-0> ... <bit-1>  von iy
c
      highx=mod(ix/128,32)
      highy=mod(iy/128,32)
      lowx=mod(ix/4,32)
      lowy=mod(iy/4,32)
      extrax=mod(ix,4)
      extray=mod(iy,4)
c
c     extra  <bit-0> <bit-1>  extrax
c            <bit-2> <bit-3>  extray
c
      extra=4*extray+extrax
c
c
c     tag bits <bit-6> <bit-5>
c                 0       1      highx/y
c                 1       0      lowx
c                 1       1      lowy/extra
c
c
      highx=highx+32
c     set the 5. bit (beginning with bit 0)
      highy=highy+32
      lowx=lowx+64
c     set the 6. bit (beginning with bit 0)
      lowy=lowy+32+64
c     set the 5.+6. bit (beginning with bit 0)
      extra=extra+32+64
c     set the 5.+6. bit (beginning with bit 0)
c
      tk4014=char(highy)//char(extra)//char(lowy)//
     &        char(highx)//char(lowx)
      return
      end

      subroutine cntoud(a,mdim,imax,jmax,pz,value,r11,id,ib)
      implicit double precision (a-h,o-z)

c THIS IS REALLY cntour

      dimension  a(mdim,*)
      logical oclose,osshad,ofill,ofrst
      integer*2 ixx
      common /fill /  ixx(1000),nixx,ihight,icol1
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /cntr/   r1,im,jm
      dimension id(mdim,*),ib(*),ic(2000,2)

************************************************************************
*
* GENERAL CONTOUR-DRAWING ROUTINE.
*
*  ON INPUT:
*      A      = 2-D ARRAY OF POINTS DEFINING HEIGHT IN MAP-SPACE.
*      MDIM   = SIZE OF FIRST DIMENSION OF A.
*      IMAX   = LENGTH OF ONE SIDE OF ARRAY WITHIN A.
*      JMAX   = LENGTH OF THE OTHER SIDE OF THE ARRAY WITHIN A.
*      PZ     = VALUE OF Z DIRECTION IF 3-D PLOTS ARE BEING DRAWN.
*      VALUE  = VALUE OF CONTOUR.
*  ON EXIT R11= LENGTH OF CONTOUR. THIS IS THE TOTAL LENGTH OF ALL LINES
*               MAKING UP THE CONTOUR, OPEN AND CLOSED.
************************************************************************
      im = imax
      r1 = 0.d0
      jm = jmax
C
C  SET UP STRING FOR LATER ANNOTATION OF CONTOURS.
C
      number = dabs(value)
C
C  THE FOLLOWING CODE SUBTRACTS THE VALUE OF THE VALUE BEING SOUGHT
C  FROM ALL ELEMENTS OF A, SO THAT THE ZERO VALUE WILL BE SOUGHT
C  HEREAFTER. 
C
      do i=1,imax
         do j=1,jmax
            a(i,j) = a(i,j) - value
         end do
      end do

      r11 = r1
      jmax1 = jmax-1
      imax1 = imax-1

      do i=1,imax
          do j=1,jmax1
             aa = a(i,j)
             ab = a(i,j+1)
C
C  IF A CONTOUR  PASSES CLOSE TO AN ELEMENT OF A, THE CORRESPONDING
C  ELEMENT OF LOGICAL ARRAY B IS SET.
C
             if ((aa.ge.0..and.ab.lt.0.).or.
     &           (aa.lt.0..and.ab.ge.0.)) then
                ib(imax*(j-1)+i) = 1
             else
                ib(imax*(j-1)+i) = 0
             endif

          end do
      end do

      K = 1
      do j=1,jmax,jmax1
          ab = a(1,j)
          do i=1,imax1
              aa = ab
              ab = a(i+1,j)
C
C  THE ARRAY C HAS THE SAME FUNCTION AS B, BUT ON THE BOUNDARY OF THE
C  AREA.
C
              if ((aa.ge.0..and.ab.lt.0.).or.
     &            (aa.lt.0..and.ab.ge.0.)) then
                  ic(i,k) = 1
              else
                  ic(i,k) = 0
              endif
          end do
          k = 2
      end do
C
C   DRAW UNCLOSED CONTOURS (IE STARTING ON A BOUNDARY).
C
      oclose = .false.
      do i=1,imax1
          if (ic(i,1).eq.1) call draw(i,1,1,a,ib,ic,id,pz,mdim)
          if (ic(i,2).eq.1) call draw(i+1,jmax,3,a,ib,ic,id,pz,mdim)
      end do
C
C  DRAW INTERIOR CONTOURS PASSING CLOSE TO BOUNDARY POINTS.
C
      do j=1,jmax1
        if (ib((j-1)*imax+1).eq.1) 
     &     call draw(1,j+1,4,a,ib,ic,id,pz,mdim)
        if (ib(j*imax).eq.1) 
     &     call draw(imax,j,2,a,ib,ic,id,pz,mdim)
      end do

      if (ofill) then
         idum = 1
         cdum1 = 0.0d0
         cdum2 = 0.0d0
         call plotgr(idum,cdum1,cdum2)
      endif
C
C  DRAW OTHER INTERIOR CONTOURS.
C
      oclose = .true.
      if (ofill) nixx = 0

      do i=2,imax1
         do j=1,jmax1
            if (ib((j-1)*imax+i).eq.1) 
     &         call draw(i,j,2,a,ib,ic,id,pz,mdim)
         end do
      end do

      if (ofill) then
         idum = 1
         cdum1 = 0.0d0
         cdum2 = 0.0d0
         call plotgr(idum,cdum1,cdum2)
      endif
      oclose = .false.
*
*  RESTORE "A" MATRIX TO IT'S ORIGINAL VALUE.
*
      do i=1,imax
          do j=1,jmax
              a(i,j) = a(i,j) + value
          end do
      end do

      return
      end

      subroutine plposd(backb,dolabs,icolps,fancy,atcol,persp,shade,
     &                  idelx,coo,ianz,iaton,iresid,iatclr,iconn,
     &                  ixpp,iypp,rzpp,inat,qat,
     &                  xv,yv,zv,
     &                  icalf,ncalf,ianf,islu,nchain,iamino,reson,
     &                  scal)
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (mxcon=10)
      parameter (small=1.0d-4)
      common /elmcom/ vdwr(mxel),vrad(mxel),icol(mxel)
      common /athlp/ iatoms, mxnat
      common /surf/  natorg,noscnd
      common /cllab/ iclon,iclpnt(4)
      character*2 clstr,ccell
      common /charge/ dipo(3),ihasq,ihsdp,iqon,idipon
      common /clchr/  clstr(4)
      common /gracom/ uscl,colscd,colscpd,ivdwpl
      logical dozme
      common /getpnt/ irtype,ipdbon,ipdbgro,ifav,ioxyz,
     &                iconv,ircus,dozme

      logical dosol,isbck,isbck1,dsurf,dcell,dclpnt
      logical doq
      integer dolabs,fancy,persp,shade,atcol,coltp,backb
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      parameter (mxres=42)
      integer reson
      character*3 aminos
      common /amino/aminos(mxres)
      character*2 elemnt
      common /elem/ elemnt(mxel)
c
c     Add normal coordinate arrows
c
      parameter (maxfat=1000)
      parameter (maxfrq=maxfat*3)
      real freq,a
      common /freq/ freq(maxfrq),a(3,maxfat),fcoo(3,maxfat),
     &              frint(maxfrq),ramint(maxfrq),nfreq,ihasi
      real frmul
      common /frwrk/ frthr,frmul,idirct,iframe,nframe,iloop,ifrq,normc
c
      character*13 str
      dimension ixpp(*),iypp(*),rzpp(*)
      dimension ctemp1(3),ctemp2(3),ctemp3(3),ctemp4(3),zvect(3)
      dimension coo(3,*),ianz(*),iaton(*),iresid(*),iatclr(*),
     &          iconn(mxcon+1,*),inat(*),qat(*)
      dimension icalf(6,*),ianf(*),islu(*),iamino(*),reson(*)

      if (iatoms.le.0) return

      toang  = 0.52917706d0
      doq = (ihasq.eq.1.and.iqon.eq.3)
      tol = small
      ipost = 2000
      roddef = 0.7d0*vrad(1)
      scle = scal/1.2d0
      zvect(1) = 0.0d0
      zvect(2) = 0.0d0
      zvect(3) = 1.0d0


      rzmax = 0.0d0

      do j=1,iatoms
         call rott(coo(1,j),coo(2,j),coo(3,j),xc,yc,zc,1)
         ixpp(j) = (0.5d0 +(xc - xv)/scle)*ipost
         iypp(j) = (0.5d0 -(yc - yv)/scle)*ipost
         rzpp(j) = zc
         rtmp = dabs(rzpp(j))
         if (rtmp.gt.rzmax) rzmax = rtmp
      end do

      call shsort(iatoms,rzpp,inat)

      inr = 0
      call labnr(inr)

      do i=1,iatoms
         k = inat(i)
         if (persp.eq.1.and.zv-rzpp(k).lt.0.0d0) goto 100
         dsurf = .false.
         if (k.gt.natorg.and.natorg.ne.0) dsurf = .true.
         if (iaton(k).ge.1.and..not.(ianz(k).eq.99.and.idelx.eq.1)) then
         isbck1 = .false.
         if (backb.eq.1.and.iresid(k).gt.0) then
            nn = 6
            if (iamino(iresid(k)).le.23) nn=3
            do ii=1,nn
               call fndcal(k,ii,idum,istat,icalf,ncalf)
               if (istat.eq.1) isbck1 = .true.
            end do
         endif
         if ((backb.eq.0.and.fancy.eq.1).or.
     &      (backb.eq.1.and.fancy.eq.1.and.(iresid(k).lt.-3.or.
     &      (iresid(k).gt.0.and.reson(iresid(k)).eq.1)))) then
            if (ivdwpl.eq.1) then
               isph = vdwr(ianz(k))/(toang*scle)*ipost
               if (dsurf) isph = 0
            else
               isph = (vrad(ianz(k))/scle)*ipost
            endif
            write(iun4,*)'/rx ',iypp(k),' def'
            write(iun4,*)'/ry ',ixpp(k),' def'
            if (icolps.eq.1) then
               if (atcol.eq.1) then
                  write(iun4,*)'/col ',icol(ianz(k)),' def'
               else
                  write(iun4,*)'/col ',iatclr(k),' def'
               endif
            else
               write(iun4,*)'/col 0 def'
            endif
            write(iun4,*)'/rad ',isph,' def'
            write(iun4,*)'doatom'
         endif
         dcell = .false.
         dclpnt = .false.
         if (dsurf.and.iclon.eq.1) then
            do ik=1,4
              if (k.eq.iclpnt(ik)) then
                  dcell = .true.
                  ccell = clstr(ik)
              endif
            end do
            if (k.le.natorg+8) dclpnt = .true.
         endif
        
         nc = 0
         do j=1,iconn(1,k)
            im = iconn(j+1,k)
            m = abs(im)
            if (iaton(m).ge.1.and.im.gt.0) nc = nc + 1
            if (iaton(m).ge.1.and.rzpp(k).le.rzpp(m).and.
     &          .not.(ianz(m).eq.99.and.idelx.eq.1)) then
             isbck = .false.
             if (backb.eq.1.and.iresid(m).gt.0.and.isbck1) then
                nn = 6
                if (iamino(iresid(m)).le.23) nn=3
                do ii=1,nn
                   call fndcal(m,ii,idum,istat,icalf,ncalf)
                   if (istat.eq.1) isbck = .true.
                end do
             endif
             if (((backb.eq.0.and.fancy.eq.1).or.
     &            (backb.eq.1.and.(iresid(k).lt.-3.or.
     &           (iresid(k).gt.0.and..not.isbck))
     &           .and.fancy.eq.1)).and..not.dsurf) then
c
c stick between displayed atoms
c
              
              v1 = vrad(ianz(k))
              v2 = vrad(ianz(m))
              if (ianz(k).ne.1.and.ianz(m).ne.1) then
c                  rodrad = roddef*2
                  rodrad = 0.46d0*v1
                  if (v2.lt.v1) rodrad = 0.46d0*v2
              else
                  rodrad = roddef
              endif
              do l=1,3
                 ctemp1(l) = coo(l,k) - coo(l,m)
              end do
              sc1 = dsqrt(dabs(vrad(ianz(k))**2-rodrad**2))
              call vsc1(ctemp1,sc1,tol)
              do l=1,3
                 ctemp2(l) = coo(l,k) - ctemp1(l)
              end do
              sc2 = dsqrt(dabs(vrad(ianz(m))**2-rodrad**2))
              call vsc1(ctemp1,sc2,tol)
              do l=1,3
                 ctemp3(l) = coo(l,m) + ctemp1(l)
              end do
              sct = 1.0d0
             else
c              rodrad = roddef*2
              rodrad = 0.304d0
              do l=1,3
                 ctemp2(l) = coo(l,k)
                 ctemp3(l) = coo(l,m)
              end do

c this 1.2 is only there for esthetics get it out

              sct = 1.2d0*(rzpp(k) + rzpp(m))/(2.0d0*rzmax) + 2.0d0
             endif

             call rott(ctemp2(1),ctemp2(2),ctemp2(3),xc,yc,zc,1)
             iy1 = (0.5d0 +(xc - xv)/scle)*ipost
             ix1 = (0.5d0 -(yc - yv)/scle)*ipost
             call rott(ctemp3(1),ctemp3(2),ctemp3(3),xc,yc,zc,1)
             iy2 = (0.5d0 +(xc - xv)/scle)*ipost
             ix2 = (0.5d0 -(yc - yv)/scle)*ipost
             do l=1,3
                ctemp4(l) = (coo(l,m) - coo(l,k))/2.0d0 + coo(l,k)
             end do
             call rott(ctemp4(1),ctemp4(2),ctemp4(3),xc,yc,zc,1)
             iy3 = (0.5d0 +(xc - xv)/scle)*ipost
             ix3 = (0.5d0 -(yc - yv)/scle)*ipost


             ihd = (sct*rodrad/scle)*ipost

             if (backb.eq.1) then
                if (isbck.or.(iresid(k).le.0.and.iresid(k).ge.-3))
     &          then
                   dosol = .true.
                else
                   if (fancy.eq.1.and..not.dsurf) then
                      dosol = .true.
                   else
                      dosol = .false.
                   endif
                endif
             else 
                dosol = .false.
                if (fancy.eq.1.and..not.dsurf) dosol = .true.
             endif
             if (im.lt.0) dosol = .false.

             ctemp1(1) = 1.0d0*(ixpp(k)-ixpp(m))
             ctemp1(2) = 1.0d0*(iypp(k)-iypp(m))
             ctemp1(3) = ((rzpp(k)-rzpp(m))/scal)*ipost
             call impsc(ctemp1,zvect,cosb)
             cosb = dabs(cosb)
             if (cosb.lt.1.0d-07) cosb = 1.0d-07

             if (dosol) then
               call plbnd(iun4,ix1,iy1,ix2,iy2,ihd,im,icolps,iresid(k),
     &          iatclr(k),cosb,backb,atcol,shade,isbck,dosol,dclpnt)
             else
               coltp = atcol
               if (fancy.eq.1.and.dsurf) then
                   if (coltp.eq.1) then
                      coltp = 0
                   else
                      coltp = 1
                   endif
               endif

               if (coltp.eq.1.and..not.dclpnt) then
                  ic1 = icol(ianz(k))
                  ic2 = icol(ianz(m))
                  if (ianz(k).eq.6) ic1 = 10
                  if (ianz(m).eq.6) ic2 = 10
               else
                  ic1 = iatclr(k)
                  ic2 = iatclr(m)
               endif
               if (icolps.eq.1.and.ianz(k).ne.ianz(m)) then
                call plbnd(iun4,ix1,iy1,ix3,iy3,ihd,im,icolps,iresid(k),
     &          ic1,cosb,backb,atcol,shade,isbck,dosol,dclpnt)
                call plbnd(iun4,ix3,iy3,ix2,iy2,ihd,im,icolps,iresid(m),
     &          ic2,cosb,backb,atcol,shade,isbck,dosol,dclpnt)
               else
                call plbnd(iun4,ix1,iy1,ix2,iy2,ihd,im,icolps,iresid(k),
     &          ic1,cosb,backb,atcol,shade,isbck,dosol,dclpnt)
               endif
               if (im.lt.0) call pldst(k,m,ix3,iy3,1)
             endif

            endif
         end do
         if (nc.eq.0.and.fancy.eq.0) call snglat(zvect,scle,0.0d0,0,
     &                               k,ipost, shade,atcol,0,1,icolps)
         if (dcell) then
             write(iun4,'(''labelcol'')')
             write(iun4,*) iypp(k),' ',ixpp(k),
     &         ' m (',ccell,') show'
         endif


         if (dolabs.ge.1.and..not.dsurf) then
            call pllab(ixpp(k),iypp(k),ianz(k),k,qat(k),inr,iqon,
     &                 iresid(k),1)
         endif
         endif
100      continue
      end do

      if (ifrq.gt.0) then

         amplit = 15.0d0*frmul
         arrow = 0.2d0

         do j=1,iatoms

c     normal vector

            call rott(coo(1,j)+amplit*a(1,j),
     &           coo(2,j)+amplit*a(2,j),
     &           coo(3,j)+amplit*a(3,j),xc,yc,zc,1)
            ixfp = (0.5d0 +(xc - xv)/scle)*ipost
            iyfp = (0.5d0 -(yc - yv)/scle)*ipost
            dsq = dsqrt(dble((ixpp(j)-ixfp)**2+(iypp(j)-iyfp)**2))
            if (dsq.ge.(50*frthr)) then
               write(iun4,*)'/x1',iypp(j),' def'
               write(iun4,*)'/y1',ixpp(j),' def'
               write(iun4,*)'/x2',iyfp,' def'
               write(iun4,*)'/y2',ixfp,' def'
               write(iun4,*)'0 setcol'
               write(iun4,*)'dostick'

c     add arrows

               length = 50
               dx = ixpp(j)-ixfp
               if (dx.lt.0.0d0) length = -length
               if (dabs(dx).gt.1.0d-10) then
                  ang = datan((iypp(j)-iyfp)/dx)
               else
                  ang = 1.57079632679489661922
                  if ((iypp(j)-iyfp).le.0.0d0) ang=-ang
               endif
               write(iun4,*)'/x1',iyfp,' def'
               write(iun4,*)'/y1',ixfp,' def'
               write(iun4,*)'/x2',iyfp+length*sin(ang+arrow),' def'
               write(iun4,*)'/y2',ixfp+length*cos(ang+arrow),' def'
               write(iun4,*)'0 setcol'
               write(iun4,*)'dostick'
               write(iun4,*)'/x1',iyfp,' def'
               write(iun4,*)'/y1',ixfp,' def'
               write(iun4,*)'/x2',iyfp+length*sin(ang-arrow),' def'
               write(iun4,*)'/y2',ixfp+length*cos(ang-arrow),' def'
               write(iun4,*)'0 setcol'
               write(iun4,*)'dostick'

            endif

         end do

      endif

      if (iqon.eq.5.and.ipdbon.eq.1.and.dolabs.eq.1) then
         write(iun4,'(''labelcol'')')
         do k=1,nchain
            do j=ianf(k),islu(k)
               jj = j - ianf(k) + 1
               if (reson(j).eq.1) then
                  l = icalf(1,j)
                  str(1:3) = aminos(iamino(j))
                  str(4:4) = ' '
                  write(str(5:8),'(i4)') jj
                  if (nchain.gt.1) then
                     str(9:9) = '.'
                     if (k.lt.10) str(10:10) = char(k+48)
                  endif
                  write(iun4,*) iypp(l),' ',ixpp(l),' m (',str,') show'
               endif
            end do
         end do
      end if

      return
      end

      subroutine plbnd(iun4,ix1,iy1,ix2,iy2,ihd,im,icolps,ires,iatclr,
     &                 cosb,backb,atcol,shade,isbck,dosol,dclpnt)
      implicit double precision (a-h,o-z)
      parameter (cosm=0.1d0)
      logical isbck,dosol,dclpnt
      integer shade,atcol,backb

      write(iun4,*)'/x1 ',ix1,' def'
      write(iun4,*)'/y1 ',iy1,' def'
      write(iun4,*)'/x2 ',ix2,' def'
      write(iun4,*)'/y2 ',iy2,' def'
      if (.not.dosol.and.(icolps.eq.0.or.iatclr.eq.15)
     &    .and.dabs(cosb).lt.cosm) then
         rsgn = 1.0d0
         if (cosb.lt.0.0d0) rsgn = -1.0d0
         cosb = cosm*rsgn 
      endif
      write(iun4,*)'/cosb ',real(cosb),' def'

      if (dosol) then
          if (icolps.eq.1) then
             if ((atcol.eq.1.and..not.(ires.le.0.and.
     &           ires.ge.-3.and.backb.eq.1)).or.isbck) then
                write(iun4,*)'/col 0 def'
             else
                write(iun4,*)'/col ',iatclr,' def'
             endif
          else
                write(iun4,*)'/col 0 def'
          endif
          write(iun4,*)'/hd ',ihd,' def'
          write(iun4,*)'dorod'
      else
          if (icolps.eq.1) then
              if (dclpnt) then
                 write(iun4,*) 'cellcol'
              else
                 if (iatclr.eq.15.and.shade.eq.0) then
                    write(iun4,*) 0,' setcol'
                 else
                    write(iun4,*) iatclr,' setcol'
                 endif
              endif
          endif
          if (im.lt.0) then
              if (icolps.eq.1) write(iun4,*)'1 setcol'
              write(iun4,*) '0 setlinecap [8 14] 0 setdash'
              write(iun4,*) '5 setlinewidth'
          endif
          if (shade.eq.1) then
             write(iun4,*)'doshadedstick'
          else
             write(iun4,*)'dostick'
          endif
          if (im.lt.0) then
              if (icolps.eq.1) write(iun4,*)'0 setgray'
              write(iun4,*) '2 setlinecap [] 0 setdash'
              write(iun4,*) '2 setlinewidth'
          endif
      endif

      return
      end

      subroutine getreal(line,stri,vari)
      implicit double precision (a-h,o-z), integer ( i-n)
      character*137 line
      character*4   stri
      indx = index(line,stri)
      if (indx.ne.0) then
         vari = reada(line,indx+6,len(line))
      endif

      return
      end

      subroutine gampod(ipoint,istat,ioxyz,coo,ianz)
      implicit double precision (a-h,p-w),integer (i-n),logical (o)
      parameter (maxfat=1000)
      real fxyz,fc
      common /forcom/fxyz(3,maxfat),fc(3,maxfat) 
      common /athlp/ iatoms, mxnat

      character*2 gstr
      character*3 tstr
      character*5 hstr,hstrt
      character lstr*137
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      dimension coo(3,*),ianz(*)

cd     write(iun3,'(a)')'enter subroutine gampoi'

      if (ioxyz.eq.1) then
c
c        cartesian optim.
c
         if (ipoint.gt.99) then
            hstrt = hstr(ipoint)
            tstr = hstrt(2:4)
            call search(lstr,' point '//tstr,istat)
         else
            call search(lstr,' point  '//gstr(ipoint),istat)
         endif
         if ( istat .eq. 0 ) then
cd           write(iun3,'(a)')'leave subroutine gampoi'
            return
         endif
         call redel(lstr,2)
         call rdgeom(mxnat,coo,ianz,iatoms,istat)
         call haszm(.false.)
      else
c
c standard optim
c
         call searchd(lstr,'-  point '//gstr(ipoint),
     &                     '-  point  '//gstr(ipoint), istat)
         if ( istat .eq. 0 ) then
cd           write(iun3,'(a)')'leave subroutine gampoi'
            return
         endif
         call redel(lstr,7)
         call convzmat(coo,ianz,iatoms,0,1,0)
      endif

      call searchd(lstr,'gradient of the energy',
     &             '-  point',istat)
      if ( istat .eq. 0 ) return
      if ( index(lstr,'-  point').ne.0 .or. 
     &     index(lstr,'-  POINT').ne.0 ) then
           istat = -1
           call bckfil
cd          write(iun3,'(a)')'leave subroutine gampoi'
           return
      endif

      call search(lstr,' atom',istmp)
      call bckfil
      call bckfil
      call bckfil
      max = 0
140   min = max + 1
      max = max + 8
      if ( max .gt. iatoms ) max = iatoms
      call redel(lstr,5)
      do n=1,3
         call nxtlin(lstr,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 200
         read(lstr,'(6x,8(f15.7))',err=200)(fxyz(n,i),i=min,max)
      end do
      if ( max .lt. iatoms ) goto 140

cd     write(iun3,'(a)')'leave subroutine gampoi'
      return

200   istat =-1 
cd     write(iun3,'(a)')'leave subroutine gampoi'
      return
      end

      subroutine settc(cnam,i,j)
      character*3 cnam,cstr(7)
      character*80 tmps
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      dimension iang(7),icon(7)
      data cstr/'S  ','P  ','D  ','F  ','SP ','SPD','G  '/
      data iang/0,1,2,3,1,2,4/
      data icon/0,1,2,3,0,0,4/

      do k=1,7
         if (cnam.eq.cstr(k)) goto 20
      end do
      tmps = 'Unrecognised type of shell >>'//cnam//'<<'
      call inferr(tmps,1)
20    i = iang(k)
      j = icon(k)

      return
      end

      subroutine mpolefit(idip,nesp,esp,connl,dx,dy,dz,iz,dmachg,
     &                    keywrd,ichadd)
      implicit double precision (a-h,o-z)
      logical dmachg
      dimension esp(*), connl(3,*)
      character*(*) keywrd

      print*,'!!!!!!!!!!! This executable has NO MPFIT !!!!!!'
      call inferr('This executable has NO MPFIT',0)
      idum = 1

      return
      end

      subroutine dendd(npts1,npts2,scale,dens,edx,edy,iedlog)
      implicit double precision (a-h,o-z)
      real xx,yy
      character str*100

c THIS IS REALLY den3d

      parameter (isize=2000)
      character keywrd*320, keyori*320
      common /hide/   upx(isize),upy(isize),downx(isize),downy(isize),
     &                nup,ndown
      common /keywrd/ keywrd,keyori
      common /plot/   iplot,iplwin,icolps
      dimension dens(*),edx(*),edy(*),iedlog(*)
c
c   make a 3d picture ------
c
      factx = 1.d0 / (npts1-1)
      facty = 1.d0 / (npts2-1)

      if (iplot.eq.6) then
        xx = 15.0
        yy = 0.0
        call xwin(xx,yy,99,str,nstr,idum1,idum2)
      endif

      if (index(keywrd,'TRAN') .ne. 0 ) goto 100

c     make a 3d picture with hidden lines

      do i=0,npts1-1
         ii = i*npts2
         ij = ii + 1
         xvect = 1.d0 - i*factx
         call eulerh(xvect,1.d0,(dens(ij))*scale,edx(ij),edy(ij))
         do j = 2,npts2
           yvect = 1.0d0 - (j-1)*facty
           ij = i*npts2 + j
           call eulerh(xvect,yvect,(dens(ij))*scale,edx(ij),edy(ij))
         end do
      end do

      do i=1,npts2
         ij = i
         xvect = 1.d0 - (i-1)*facty
         call eulerh(1.d0,xvect,(dens(ij))*scale,edx(ij),edy(ij))
         iedlog(ij) = 0
         do j=1,npts1-1
             yvect = j*factx
             ij = j*npts2 + i
             call eulerh(1.d0-yvect,xvect,(dens(ij))*scale
     +       ,edx(ij),edy(ij))
             iedlog(ij) = 0
         end do
      end do

      nup = 1
      nsq = npts1*npts2
      fxt = edx(npts2)
      fyt = edy(npts2)
      upx(1) = fxt
      downx(1) = fxt
      upy(1) = fyt
      downy(1) = fyt
      iedlog(npts2) = 1
      call plotgr(1,fyt,fxt)

      do j=2,npts1
         ij = j*npts2
         nup = nup + 1
         fxt = edx(ij)
         fyt = edy(ij)
         iedlog(ij) = 1
         upx(nup) = fxt
         downx(nup) = fxt
         upy(nup) = fyt
         downy(nup) = fyt
         call plotgr(2,fyt,fxt)
      end do

      fxt = edx(nsq)
      fyt = edy(nsq)
      call plotgr(1,fyt,fxt)
      do i=2,npts2
         ij = nsq - i + 1
         nup = nup + 1
         fxt = edx(ij)
         fyt = edy(ij)
         iedlog(ij) = 1
         upx(nup) = fxt
         downx(nup) = fxt
         upy(nup) = fyt
         downy(nup) = fyt
         call plotgr(2,fyt,fxt)
      end do

      ndown = nup
      do k=2,npts1
         do l=2,npts2
            ij = (npts1-k)*npts2 + npts2 - l
            x1 = edx(ij+2)
            y1 = edy(ij+2)
            x2 = edx(ij+1)
            y2 = edy(ij+1)
            ij = ij + npts2 + 1
            x3 = edx(ij)
            y3 = edy(ij)
            call hidedr(x1,y1,x2,y2,x3,y3,iedlog(ij))
         end do
      end do

      return

100   continue

c     make a transparent 3d picture 

      do i=0,npts1-1
         ii = i*npts2
         ij = ii + 1
         xvect = 1.d0 - i*factx
         call euler(xvect,1.d0,(dens(ij))*scale,1)
         do j=2,npts2
           yvect = 1.0d0 - (j-1)*facty
           ij = i*npts2 + j
           call euler(xvect,yvect,(dens(ij))*scale,2)
         end do
      end do

      do i=1,npts2
         ij=i
         xvect=1.d0-(i-1)*facty
         call euler(1.d0,xvect,(dens(ij))*scale,1)
         do j=1,npts1-1
            yvect = j*factx
            ij = j*npts2 + i
            call euler(1.d0-yvect,xvect,(dens(ij))*scale,2)
         end do
      end do

      return
      end

      subroutine heaps(nwords,arr,iarr)
      implicit double precision (a-h,o-z)
      dimension arr(*),iarr(*)

      do j=1,nwords
          iarr(j)=j
      end do
      l=nwords/2+1
      ir=nwords
10      continue
            if(l.gt.1) then
               l=l-1
               iarrt=iarr(l)
               arrt=arr(iarrt)
            else
               iarrt=iarr(ir)
               arrt=arr(iarrt)
               iarr(ir)=iarr(1)
               ir=ir-1
               if(ir.eq.1)then
                   iarr(1)=iarrt
                   goto 100
               endif
            endif
            i=l
            j=l+l
20          if(j.le.ir)then
               if(j.lt.ir)then
                  if(arr(iarr(j)).lt.arr(iarr(j+1)))j=j+1
               endif
               if(arrt.lt.arr(iarr(j)))then
                  iarr(i)=iarr(j)
                  i=j
                  j=j+j
               else
                  j=ir+1
               endif
           goto 20
           endif
           iarr(i)=iarrt
        goto 10
100     continue

        return
        end

      subroutine basprt(iun,gcompl,docrys)
      implicit double precision (a-h,o-z),integer (i-n)
      parameter (numatm=2000)
      parameter (mxel=100)
      parameter (numprm=1600)
      parameter (numcex=numprm*3)
      integer jan,shella,shelln,shellt,shellc,shladf,aos,
     &        nshell,maxtyp
      common/b/exx(numcex),
     &         c1(numcex),c2(numcex),c3(numprm),c4(numprm),c5(numprm),
     &         shladf(numprm),gx(numprm),gy(numprm),gz(numprm),
     &         jan(numprm),shella(numprm),shelln(numprm),shellt(numprm),
     &         shellc(numprm),aos(numprm),nshell,maxtyp
      character*2 elm
      common /elem/elm(mxel)
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      logical gcompl,docrys,dowrt
      character*3  namesh(5,5)
      character*3  name
      dimension iatflg(mxel),ich(7)
      data namesh/'s  ','sp ','spd','f  ','g  ',
     &            '???','p  ','d  ','???','g  ',
     &            's  ','sp ','d  ','f  ','g  ',
     &            's  ','sp ','d  ','f  ','g  ',
     &            's  ','sp ','d  ','f  ','g  '/
      data pi32 /5.56832799683170d0/
      data pt187 /1.875d+00/
      data pt5,pt75,pt656 /0.5d0,0.75d0,6.5625d0/
      data ich /2,8,6,10,18,14,18/
 1000 format(' ****')
 1010 format(a2,' atom ',i3)
 1020 format(1x,a3,1x,i2,' 1.00')
 1030 format(4d18.10)
 1040 format('################## Basis set #################')
 1050 format(' ',/)
c
      if (docrys) then
         do i=1,mxel
            iatflg(i) = 0
         end do
         natsh = 1
         do i=2,nshell
            if (jan(i).ne.jan(i-1)) then
               nt = nat(jan(i-1))
               if (iatflg(nt).eq.0) iatflg(nt) = natsh
               natsh = 0
            endif
            natsh = natsh + 1
         end do
         nt = nat(jan(nshell))
         if (iatflg(nt).eq.0) iatflg(nt) = natsh
      endif

      if (.not.gcompl.and..not.docrys) write(iun,1040)
      do i = 1, nshell
          if ((i.gt.1.and.jan(i).ne.jan(i-1)).and..not.docrys) then
              if (gcompl) then
                 write(iun,'(a)') '  '
              else
                 write(iun,1000)
              endif
          endif
          if (i.eq.1.or.jan(i).ne.jan(i-1)) then
              icht = nat(jan(i))
              if (docrys) then
                 dowrt = .false.
                 if (iatflg(nat(jan(i))).ne.0) then
                    write(iun,'(i3,1x,i3)') nat(jan(i)),
     &                        iatflg(nat(jan(i)))
                    iatflg(nat(jan(i))) = 0
                    dowrt = .true.
                 endif
              else
                 if (gcompl) then
                    write(iun,'(i3,a)') jan(i),' 0'
                 else
                    write(iun,1010)elm(nat(jan(i))),jan(i)
                 endif
                 dowrt = .true.
              endif
          endif
          if (.not.dowrt) goto 100

          iscod = 0
          if(shellt(i).eq.0) iscod = 0
          if(shellt(i).eq.1.and.shellc(i).eq.1) iscod = 2
          if(shellt(i).eq.1.and.shellc(i).ne.1) iscod = 1
          if(shellt(i).eq.2.and.shellc(i).eq.0) iscod = 4
          if(shellt(i).eq.2.and.shellc(i).ne.0) iscod = 3
          if(shellt(i).eq.3) iscod = 5
          if(shellt(i).eq.4) iscod = 6

          if (docrys.and.(iscod.ge.4)) then
              call inferr('CRYSTAL: spd/f/g not supported !',0)
              return
          endif

          ichpr = ich(iscod+1)
          if (icht.lt.ichpr) then
             ichpr = icht
             icht = 0
          else
             icht = icht - ichpr
          endif

          if (docrys) then
             write(iun,'(a,i1,a,i2,a,f3.1,a)') 
     &           '0 ',iscod,' ',shelln(i),' ',dfloat(ichpr),' 1.0'
          else
             name = namesh(shellt(i)+1,shellc(i)+1)
             write(iun,1020) name, shelln(i)
          endif

          mm = shella(i)
          mmdf = shladf(i)
          do j = 1, shelln(i)
              ee = exx(mm)+exx(mm)
              facs = pi32/(ee*dsqrt(ee))
              facp = dsqrt(pt5*facs/ee)
              facd = dsqrt(pt75*facs/(ee*ee))
              facf = dsqrt(pt187*facs/(ee**3))
              facg = dsqrt(pt656*facs/(ee**4))
              facs = dsqrt(facs)
              if (iscod.eq.0) write(iun,1030)exx(mm),c1(mm)*facs
              if (iscod.eq.2)
     &            write(iun,1030) exx(mm), c2(mm)*facp
              if (iscod.eq.1)
     &            write(iun,1030) exx(mm), c1(mm)*facs, c2(mm)*facp
              if (iscod.eq.4)
     &            write(iun,1030) exx(mm), c1(mm)*facs, c2(mm)*facp
     &                          , c3(mmdf)*facd
              if (iscod.eq.3)
     &            write(iun,1030) exx(mm), c3(mmdf)*facd
              if (iscod.eq.5) write(iun,1030)exx(mm),c4(mmdf)*facf
              if (iscod.eq.6) write(iun,1030)exx(mm),c5(mmdf)*facg
              mm = mm + 1
              mmdf = mmdf + 1
          end do
100       continue
      end do

      if (docrys) then
         write(iun,'(a)') '99 0'
      else
         write(iun,1050)
      endif

      return
      end

      subroutine defrad(doiso)
c     supplies default radius ( see keyword EDGE )
      implicit double precision (a-h,o-z)
      parameter (numatm=2000)
      parameter (mxvalc=10)
      parameter (max3d=61)
      common /plane/  px, py, pz, cx, cy, cz, r(3),v1(3),v2(3),iplat
      common /moldat/ natoms, norbs, nelecs,nat(numatm)
      common /coord / xyz(3,numatm)
      common /srfhlp/edge,ctval(mxvalc),pxyz(3),nvalc,nspts,istyp
      logical doiso
      dimension vec(3)

      if (doiso) then

         call cntvc2(pxyz,xyz,natoms)
         edge = 0.0d0
         do i=1,natoms
            dist = dist2(pxyz,xyz(1,i))
            if (dist.gt.edge) edge = dist
         end do
         edge = dsqrt(edge)*2.0d0

         edge = edge + 7.0d0

         nspts = edge / 0.3d0
         if (nspts.gt.max3d) nspts = max3d

      else

         call cntvec(vec,xyz,nat,natoms)
         r(1) = 0.0d0
         do i=1,natoms
            dist = (xyz(1,i)-px)**2 + 
     &             (xyz(2,i)-py)**2 + 
     &             (xyz(3,i)-pz)**2
            if (dist.gt.r(1)) r(1) = dist
         end do
         r(1) = dsqrt(r(1))*2.4d0
         r(2) = r(1)
         r(3) = r(1)

      endif

      return
      end

      subroutine pltab(fcnt)
      implicit double precision (a-h,o-z)
      logical  euclid, yes, oscal,ostep,fine
      real xx, yy
      character str*100, esc, etx, lf, gs, us
      character tk4014*5

      common /plot/   iplot,iplwin,icolps
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /plspec/ step,stepf,scale,scalf,cut,pmin,pmax,one,
     &                oscal,ostep,fine
      dimension fcnt(*)

      etx    = char(3)
      lf     = char(10)
      esc    = char(27)
      gs     = char(29)
      us     = char(31)
                                                                                
      if (iplot.eq.0) then
        write(iun4,'(a)') '.m 1.25 1.0' 
        write(iun4,'(''.pt NUMBER OF CONTOURS ='',i4,a)') icnt
        write(iun4,'(a)') '.m 1.15 1.0' 
        write(iun4,'(''.pt CONTOUR INTERVAL ='',f13.6)') step
        write(iun4,'(a)') '.ch 1.2'
        write(iun4,'(a)') '.td 0.0' 
        write(iun4,'(a)') '.m 1.05 0.58' 
        write(iun4,'(''.pt  CONTOUR    VALUE'')')
      endif

      if (iplot.eq.1) then
         write(iun4,'(''PU46,18;LBNUMBER OF CONTOURS ='',i4,a,'';'')')
     +   icnt,etx
         write(iun4,'(''PU44,18;LBCONTOUR INTERVAL ='',f13.6,a,'';'')') 
     +   step,etx
         write(iun4,'(a)') 'SC0,1,0,1;DI;SL0;' 
         write(iun4,'(''PU1.05,0.58;LB CONTOUR    VALUE'',a,'';'')')
     +   etx
      endif

      if (iplot.eq.2) then
         write(iun4,'(a,''*pa408,222Z'')')esc
         write(iun4,'(a,''*lCONTOUR  VALUE'',a)')esc,lf
      endif

      if (iplot.eq.3) then
c         write(iun4,*)esc//'/0d'
         write(iun4,*)gs//tk4014(int(1.05*3100),int(0.58*3100))
     +              //us//'CONTOUR VALUE'
      endif

      if (iplot.eq.4) then
         write(iun4,'(''tabel {'')')
         write(iun4,'(''   1 setlinewidth'')')
         write(iun4,'(''2150 1285 m'')')
         write(iun4,'(''( CONTOUR   VALUE) show'')')
      endif

      if (iplot.eq.6) then
        xx= 15.0
        yy= 0.0
        call xwin(xx,yy,99,str,nstr,idum1,idum2)
        xx= 1.02
        yy= 0.85
        call xwin(xx,yy,4,'CONTOUR VALUE',13,idum1,idum2)
      endif

c-------------- plot contour value tabel 

        do i=1,icnt
         fpos = 0.55d0 - 0.02d0*dble(i)
         if (i.lt.26) then

           if (iplot.eq.0) then
              write(iun4,'(''.m 1.05 '',f8.5)') fpos
              write(iun4,'(''.pt '',i3,1x,f13.5)')i,fcnt(i)
           endif

           if (iplot.eq.1) then
              write(iun4,'(''PU1.05,'',f8.5,'';'')') fpos
              write(iun4,'(''LB'',i3,1x,f13.5,a,'';'')')i,fcnt(i),etx
           endif

           if (iplot.eq.2) then
              write(iun4,'(a,''*pa408,'',i3,''Z'')')esc,int(fpos*389)
              write(iun4,'(a,''*l'',i3,1x,f9.5,a)')esc,i,fcnt(i),lf
           endif

           if (iplot.eq.3) then
c              write(iun4,*)esc//'/0d'
              write(iun4,'(a,i3,1x,f9.5)')gs//tk4014(int(1.05*3100),
     +                 int(fpos*3100))//us,i,fcnt(i)
           endif

           if (iplot.eq.4) then
              write(iun4,'(''2150 '',i4, '' m'')')int(fpos*2000+125)
              write(iun4,'(''('',i3,10x,f13.5,'') show'')')i,
     +               fcnt(i)
           endif

           if (iplot.eq.6) then
             write(str,'(i3,1x,f9.5)') i,fcnt(i)
             if (fcnt(i) .ge. 0.0) then
               xx = 2.0
             else
               xx = 1.0
             endif
             yy = 0.0
             call xwin(xx,yy,99,str,nstr,idum1,idum2)
             xx = 1.02
             fpos = 0.80d0 - 0.03d0*dble(i)
             yy = fpos
             call xwin(xx,yy,4,str,13,idum1,idum2)
           endif

         endif
         if (i.eq.26) then

           if (iplot.eq.0) then
              write(iun4,'(''.m 1.05 '',f8.5)') fpos
              write(iun4,'(''.pt ............'')')
           endif

           if (iplot.eq.1) then
              write(iun4,'(''PU1.05,'',f8.5,'';'')') fpos
              write(iun4,'(''LB ............'',a,'';'')')etx
           endif

           if (iplot.eq.2) then
              write(iun4,'(a,''*pa408,'',i3,''Z'')')esc,int(fpos*389)
              write(iun4,'(a,''*l ............'',a)')esc,lf
           endif

           if (iplot.eq.3) then
c              write(iun4,*)esc//'/0d'
              write(iun4,*)gs//tk4014(int(1.05*3100),
     +                 int(fpos*3100))//us//'  ............'
           endif

           if (iplot.eq.4) then
              write(iun4,'(''2150 '',i4, '' m'')')int(fpos*2000+125)
              write(iun4,'(''(   ............) show'')')
           endif

           if (iplot.eq.6) then
             xx = 15.0
             yy = 0.0
             call xwin(xx,yy,99,str,nstr,idum1,idum2)
             xx = 1.02
             fpos = 0.80d0 - 0.03d0*dble(i)
             yy = fpos
             call xwin(xx,yy,4,'  ...........',13,idum1,idum2)
           endif

         endif
      end do

      if (iplot.eq.0) then
        write(iun4,'(a)') '.m 1.05 0.60' 
        write(iun4,'(a)') '.d 1.30 0.60' 
        write(iun4,'(a)') '.d 1.30 0.00' 
        write(iun4,'(a)') '.d 1.05 0.00' 
        write(iun4,'(a)') '.d 1.05 0.60' 
      endif

      if (iplot.eq.1) then
        write(iun4,'(''PU1.05,0.60;'')') 
        write(iun4,'(''PD1.30,0.60;'')') 
        write(iun4,'(''PD1.30,0.00;'')') 
        write(iun4,'(''PD1.05,0.00;'')') 
        write(iun4,'(''PD1.05,0.60;'')') 
      endif

      if (iplot.eq.2) then
      write(iun4,'(a,''*pa408,233,506,233,506,0,408,0,408,233Z'')')
     +        esc
      endif

      if (iplot.eq.4) then
        write(iun4,'(''n'')')
        write(iun4,'(''2100 1325 m'')')
        write(iun4,'(''2600 1325 l'')')
        write(iun4,'(''2600 125 l'')')
        write(iun4,'(''2100 125 l'')')
        write(iun4,'(''2100 1325 l'')')
        write(iun4,'(''s'')')
        write(iun4,'(''} if'')')
      endif

      return
      end

      subroutine vclr(a,incr,n)
      implicit double precision (a-h,o-z)
      dimension a(*)

      if(incr.eq.1) then
        do loop=1,n
          a(loop) = 0.0d0
        end do
      else
        loopi=1
        do loop=1,n
           a(loopi)=0.0d0
           loopi=loopi+incr
        end do
      endif

      return
      end

      subroutine fmtset
      implicit double precision (a-h,o-z)
      common /fm/    c(17),dflt(17),cutoff
      dimension ftmp(15)

      c(1) = dsqrt(4.0d0*datan(1.0d0))

      tmp = 0.5d0
      do i=2,17
         c(i) = c(i-1)*tmp
         tmp = tmp + 1.0d0
      end do

      tmp = 1.0d0
      dflt(1) = 1.0d0
      do i = 2,17
         tmp = tmp + 2.0d0
         dflt(i) = 1.0d0 / tmp
      end do

      tmp = 20.0d0
10    call fmtgen(ftmp,tmp,1,istatus)
      if (istatus.eq.0) then
         tmp = tmp - 1.0d0
         if (tmp-10.0d0.lt.0.0d0) then
            return
         else
            goto 10
         endif
      endif
      cutoff = tmp + 1.0d0

      return
      end
      subroutine fmtgen(f,t,m,istatus)
      implicit double precision (a-h,o-z)
      dimension f(m)
      common /fm/  c(17),dflt(17),cutoff

      tol = 10.0d-66
c      tol = 10.0d-39
c      VMS only tolerates this value
      istatus = 0

      if (dabs(t).le.0.0d0) then
         do i=1,m
            f(i) = dflt(i)
         end do
         return
      endif

      exx = 0.0d0
      if (dabs(t).ge.50.0d0) then
         f(m) = 0.5d0*c(m) / (t**(dfloat(m) - 0.5d0))
         goto 200
      endif

      exx = dexp(-t)
      if (dabs(t).lt.cutoff) then
         a = dfloat(m-1) + 0.5d0
         deel = 1.0d0 / a
         sig = deel
         do i=2,400
            a = a + 1.0d0
            deel = deel*t / a
            sig = sig + deel
            if (dabs(deel/sig)-tol.lt.0.0d0) then
                f(m) = 0.5d0*sig*exx
                goto 200
            endif
         end do
      endif

      b = dfloat(m-1) + 0.5d0
      a = dfloat(m-1) - 0.5d0
      ca = 0.5d0*dsqrt(4.0d0*datan(1.0d0))*(t**(1-m))/dsqrt(t)
      if (m-1.ne.0) then
         do i=1,m-1
            b = b - 1.0d0
            ca = ca*b
         end do
      endif
      wim = 0.5d0*exx / t
      sig = 0.0d0
      if (wim.eq.0.0d0) goto 100
      wp = wim / ca
      deel = 1.0d0
      sig = 1.0d0
      no = dint(t) + m - 1
      do i=2,no
         deel = deel*a / t
         sig = sig + deel
         if (dabs(deel*wp / sig) - tol.le.0.0d0) goto 100
         a = a - 1.0d0
      end do
      istatus = 1
      return

100   f(m) = ca - wim*sig

200   tmp = dfloat(2*m-3)
      if (m-1.eq.0) return

      do i=1,m-1
         f(m-i) = (2.0d0*t*f(m-i+1) + exx) / tmp
         tmp = tmp - 2.0d0
      end do

      return
      end

      subroutine rdmdf(idebug,istat,coo,ianz,iatclr,iconn,qat,ityp,
     &                 nat,norg,icent,inorm,ncon,nspg,kz,ichx,
     &                 nopr,ir,it,
     &                 xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma)
      implicit double precision (a-h,p-z),integer (i-n),logical (o)
      parameter (mxmsf=235)
      parameter (numatm=2000)
      parameter (numat1=20000)
      parameter (mxcon=10)
      common /athlp/iatoms, mxnat
      integer*2 ir,it
      character*137 line,str
      common /curlin/ line
      common /rdwr/ iun1,iun2,iun3,iun4,iun5
      common /msft/ ltyp(mxmsf)
      logical ctoz,molpot,elpot,chpot
      common /choic/  iftyp,isbin,ctoz,molpot,elpot,chpot
      integer*2 ityp
      common /types/ iff
      character*80 col
      character*200 header
      character*100 fname
      character*6 atnam
      character*10 version,label
      character*4 type
      character*4 c4dum
      character*6 c6dum
      integer*2 i2dum,ii2dum,i22dum
      real rdum,rrdum
      dimension rrdum(numat1),
     &          ii2dum(numat1),i22dum(8,numat1)
      dimension coo(3,*),ianz(*),iatclr(*),iconn(mxcon+1,*),qat(*),
     &          ityp(*),ir(3,3,192),it(3,192)
      data ltyp /4*1,99,4,5,1,1,20*6,10*7,20*8,10*15,10*16,3,11,12,
     &           19,20,25,26,30,37,55,14,13,9,17,35,53,29,23,24,27,
     &           28,33,34,38,39,40,41,42,44,45,46,47,48,50,51,56,74,
     &           76,78,79,80,82,83,57,58,59,89,90,92,52,84,85,43,
     &           21,22,31,32,49,72,73,77,81,87,88,60,61,62,63,64,65,
     &           66,67,68,69,70,71,91,93,94,95,96,97,98,5*99,
     &           2,10,18,36,54,86,99,99,75,14,2*99,7*7,3*99,10*6,17,
     &           4*6,6*7,3*8,6*99,3*7,7*99,3*6,15,7,99/

      if (idebug.eq.1) print*,'routine rdmsf'

      istat = 1
      toang = 0.52917706d0
      ncon = 0

      read(iun2,err=90,end=90) ns,nr,iatoms,version,header

      if (nr.eq.0.or.iatoms.eq.0) goto 90
c
c  read titles
c

      col(1:3) = '   '
      do while (col(1:3).ne.'END')
         read(iun2,err=90,end=90) col
      end do
c
c read segment info
c
      read(iun2,err=90,end=90) (c4dum,i=1,ns)
      read(iun2,err=90,end=90) (i2dum,i=1,ns)
      read(iun2,err=90,end=90) (i2dum,i=1,ns)

c
c read residue information
c
      read(iun2,err=90,end=90) (c6dum,i=1,nr)
      read(iun2,err=90,end=90) (c4dum,i=1,nr)
      read(iun2,err=90,end=90) (i2dum,i=1,nr)
      read(iun2,err=90,end=90) (i2dum,i=1,nr)
      read(iun2,err=90,end=90) (i2dum,i=1,nr)

      do j=1,4
         read(iun2,err=90,end=90) (rdum,i=1,nr)
      end do
c
c read atom info
c
      do j=1,3
         read(iun2,err=90,end=90) (rrdum(i),i=1,iatoms)
         do i=1,iatoms
            coo(j,i) = dble(rrdum(i))/toang
         end do
      end do

      do i=1,iatoms
         iatclr(i) = 1
         iconn(1,i) = 0
      end do

      if (idebug.eq.1) then
         do i=1,iatoms
            print*,i,' ',(coo(j,i),j=1,3)
         end do
      endif
 
      read(iun2,err=90,end=90) (atnam,i=1,iatoms)

      read(iun2,err=90,end=90) (i2dum,i=1,iatoms)

      read(iun2,err=90,end=90) (ii2dum(i),i=1,iatoms)

      if (idebug.eq.1) then
         print*,'atom types:'
         do i=1,iatoms
            print*,i,' ',ii2dum(i)
         end do
      endif

      do i=1,iatoms
         if (ii2dum(i).gt.mxmsf) then
            ianz(i) = 99
            ityp(i) = mxmsf
         else
            ianz(i) = ltyp(int(ii2dum(i)))
            ityp(i) = ii2dum(i)
         endif
      end do

      iff = 6

      read(iun2,err=90,end=90) (rrdum(i),i=1,iatoms)
      do i=1,iatoms
          qat(i) = dble(rrdum(i))
      end do
      ihasq = 1

c
c read the extra data
c

10    read(iun2,err=90,end=100) label,type,nitems,fname

      if (type.eq.'REAL'.or.type.eq.'ASTR') then

        read(iun2,end=90,err=90) (rdum,n=1,nitems)

      elseif (type.eq.'REA3') then

        do i=1,3
            read(iun2,end=90,err=90) (rrdum(j),j=1,nitems)
            do j=1,nitems
c               coo(i,j) = dble(rrdum(j))
            end do
        end do

      elseif (type.eq.'INT4') then

        read(iun2,end=90,err=90) (i4dum,n=1,nitems)

      elseif (type.eq.'INT2') then

        read(iun2,end=90,err=90) (i2dum,n=1,nitems)

      elseif (type.eq.'BOND') then

        if (label.eq.'CONNECT   ') then

          read(iun2,end=90,err=90) 
     &      (ii2dum(i),(i22dum(j,i),j=1,ii2dum(i)),i=1,nitems)
          do i=1,nitems
             iconn(1,i) = int(ii2dum(i))
             if (iconn(1,i).gt.mxcon) iconn(1,i) = mxcon
             do j=1,iconn(1,i)
                iconn(1+j,i) = int(i22dum(j,i))
             end do
          end do
          ncon = 1

          call redcon

        elseif (label.eq.'ORDER     ') then

          read(iun2,end=90,err=90)
     &      (i2dum,(i2dum,j=1,2),i=1,nitems)

        endif

      elseif (type.eq.'SYMM') then

        kz = 0
        idone = 0
        do while(idone.eq.0)
           read(iun2,end=90,err=90) col(1:80)
           if (col(1:4).eq.'CELL'.and.iatoms.lt.1000) then
              line(1:80) = col(1:80)
              ktype = nxtwrd(str,nstr,itype,rtype)
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) a = rtype
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) b = rtype
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) c = rtype
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) alpha = rtype
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) beta = rtype
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.3) gamma = rtype
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.2) then
                 if (itype.ne.1) goto 100
              else 
                 goto 100
              endif
              ktype = nxtwrd(str,nstr,itype,rtype)
              if (ktype.eq.2) nspg = itype

              call prcell(nspg,a,b,c,alpha,beta,gamma)
              call setop(xa,ya,yb,za,zb,zc,a,b,c,alpha,beta,gamma,1)
              call cpmol(nat,norg,a,b,c,alpha,beta,gamma,
     &                   coo,ianz,iatclr,iconn)
              call cprot(nspg,nopr,icent,ir,it,.false.)
              istat = 2
              ichx = 1
           elseif (col(1:3).eq.'END') then
              idone = 1
           endif

        end do

      endif

      goto 10
c
90    call inferr('Error reading MSF',0)
      iatoms = 0
      istat = 0
      iff = 0
      return

100   continue
      iftyp = 6
      call cooxyz(ianz,iatoms)
      if (iatoms.gt.100) call haszm(.true.)
      return
      end

      subroutine cnvgam
      parameter (MAXITER=1000)
      implicit double precision (a-h,o-z)
      logical direct,dft,casscf
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /convrg/ convg1(MAXITER),convg2(MAXITER),cnvmax,cnvmin,
     &jstrt1,jend1,jstrt2,jend2,icvav1,icvav2
      common /orbhlp/ mxorb,iuhf,ispd
      character lstr*137

cd     write(iun3,'(a)')'enter subroutine cnvgam'
      call rewfil
      icvav1 = 1
      icvav2 = 1
      jstrt1 = 0
      jstrt2 = 0
      jend1 = 0
      jend2 = 0
      iels  = 2
      iels2 = 10
      if (iuhf.eq.1) then
         iels  = 3
         iels2 = 12
      endif

      direct = .false.
      dft    = .false.
      casscf = .false.
      call search(lstr,'casscf options',istat)
      if (istat.eq.1) casscf = .true.
      call search(lstr,'* Direct-scf',istat)
      if (istat.eq.1) direct = .true.
      call search(lstr,'CCP1 DFT MODULE',istat)
      if (istat.eq.1) dft = .true.
      if (casscf) goto 60

c     SCF convergence first point

      call searchd(lstr,'  cycle          total     electronic',
     &                  '  cycle           total      electronic',istat)
      if (istat.eq.0) goto 300
      call redel(lstr,iels)
      jstrt1 = 0

10    if (direct) then
         call searchd
     &        (lstr,'  cycle          total     electronic',
     &              '  cycle           total      electronic',istat)
         if (istat.eq.0) goto 20
         call redel(lstr,iels)
      endif
      if (.not.direct.and.dft) then
         call redel(lstr,iels2)
      endif
      call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 300
      if (lstr(1:8).eq.'        ') goto 20
      read(lstr,'(i4,4x,f15.8)',err=300) jend1,convt
      convg1(jend1) = convt
      if (jstrt1.eq.0) jstrt1 = jend1
      goto 10

60    continue
      jstrt1 = 1
      jend1  = 0
70    call search(lstr,'cycle    time   tester               energy',
     &            istat)
      if (istat.ne.0) then
         call redel(lstr,2)
80       call nxtlin(lstr,jstat)
         if (jstat.eq.1.or.jstat.eq.2) goto 300
         if (lstr(1:8).ne.'        ') then
            jend1=jend1+1
            read(lstr,'(24x,f20.7)',err=300)convg1(jend1)
            goto 80
         endif
         goto 70
      endif

20    continue

c     Possibly SCF convergence info when incomplete scf

      call search(lstr,'terminating due to incomplete scf',istat)
      if (istat.eq.0) goto 400

50    call bckfil
      call bckfil
      call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 400
      if (lstr(1:8).eq.'        ') goto 50
      call bckfil
      jend2 = 0

100   call nxtlin(lstr,jstat)
      if (jstat.eq.1.or.jstat.eq.2) goto 400
      if (lstr(1:8).eq.'        ') goto 200
      read(lstr,'(i4,4x,f15.8)',err=400) jstrt2,convt
      convg2(jstrt2) = convt
      if (jend2.eq.0) jend2 = jstrt2
      call bckfil
      call bckfil
      goto 100
c
200   continue
cd     write(iun3,'(a)')'leave subroutine cnvgam'
      return

300   icvav1 = 0
      icvav2 = 0
cd     write(iun3,'(a)')'leave subroutine cnvgam'
      return

400   icvav2 = 0
cd     write(iun3,'(a)')'leave subroutine cnvgam'
      return

      end

      subroutine stoc(maxnz,nz,ipart,imn,imx,ianz,iz,bl,alph,bet,
     $           ottest,natoms,ian,c,cz,imap,alpha,beta,
     $           oerror,oconv,odum)
c
c     imap(zmatline) = xyzline
c
      implicit double precision (a-h,p-z), logical (o)
      common /rdwr/  iun1,iun2,iun3,iun4,iun5
      common /hlpzm/ iloos
      character*80 errmsg
      dimension ianz(*),iz(4,*),bl(*),alpha(*),beta(*),ian(*),
     $          c(*),cz(*),alph(*),bet(*),imap(*)
      dimension u1(3),u2(3),u3(3),u4(3),vj(3),vp(3),v3(3)
      dimension t1(3),t2(3),t3(3),s1(3),s2(3),s3(3),s4(3)
      logical door
c
      data dzero/0.0d0/,done/1.0d0/,two/2.0d0/
      data tenm5/1.0d-5/,tenm6/1.0d-6/
      data f180/180.0d0/,four/4.0d0/
      data tenm10/1.0d-10/
      data tetdat/109.471d0/, toldat/0.001d0/, three/3.d0/
c
 2001 format(1x,i3,' tetrahedral angles replaced')
c
      otest(ccc) =  dabs(ccc-tettst) .lt. tettol
      errmsg = 'incipient floating point error detected !'

      door = .true.
      id = 0
      do i=1,3
         if (cz((i-1)*3+1).eq.0.0d0.and.cz((i-1)*3+2).eq.0.0d0
     &       .and.cz((i-1)*3+3).eq.0.0d0) id = id +1
      end do
      if (id.ge.2) door = .false.

      if (cz(1).eq.cz(4).and.cz(2).eq.cz(5).and.cz(3).eq.cz(6))
     &  door = .false.
      if (cz(1).eq.cz(7).and.cz(2).eq.cz(8).and.cz(3).eq.cz(9))
     &  door = .false.
      if (cz(4).eq.cz(7).and.cz(5).eq.cz(8).and.cz(6).eq.cz(9))
     &  door = .false.

c
c
c     check for potential overflow.
c
      if (oconv) then
         conver = 1.0d0/0.52917706d0
      else
         conver = 1.0d0
      endif

      if (ipart.ne.0) then
         il = imn
         if (il.lt.2) il = 2
         ih = imx
      else
         il = 2
         ih = nz
      endif
      
      if (nz.gt.maxnz) then
         oerror = .true.
         call zmterr('z-matrix cards is greater than the maximum !',
     &               -1,0,1)
         return
      endif
      oerror = .false.
      if (ih .lt. 2) goto 14

      do i=il,ih
         if (i.gt.3.and.iabs(iz(4,i)).gt.1) then
            oerror = .true.
            call zmterr('invalid beta angle type (z4) !',i,-4,1)
            return
         endif
         if (i.eq.2.and.iz(1,2).eq.1) goto 9
         if (i.eq.3.and.iz(1,3).lt.i.and.iz(2,3).lt.i.and.
     &       iz(1,3).gt.0.and.iz(2,3).gt.0) goto 9
         if (i.gt.3.and.iz(1,i).lt.i.and.iz(2,i).lt.i.and.iz(3,i).lt.i
     &       .and.iz(1,i).gt.0.and.iz(2,i).gt.0.and.iz(3,i).gt.0) goto 9
            oerror = .true.
            l = 0
            if (iz(1,i).ge.i) l = -1
            if (iz(2,i).ge.i) l = -2
            if (iz(3,i).ge.i) l = -3
            if (iloos.eq.0) then
               call zmterr('reference made to an undefined center !',
     &                      i,l,1)
            else 
               if (nz.gt.2) then
                   call zmterr('reference made to an undefined center !'
     &                          ,i,l,1)
               endif
            endif
            return
    9    continue
         if (i.eq.3.and.iz(1,i).eq.iz(2,i)) then
             oerror = .true.
             call zmterr(
     &      'multiple references to a center on the same card !',i,0,1)
             return
         endif
         if (i.gt.3.and.(iz(1,i).eq.iz(2,i).or.iz(1,i).eq.iz(3,i).or.
     &        iz(2,i).eq.iz(3,i))) then
            oerror = .true.
            call zmterr(
     &     'multiple references to a center on the same card !',i,0,1)
            return
         endif
      end do
   14 continue

      pi = four * datan(done)
      torad = pi/f180
c
c     set up for laundering tetrahedral angles.
c     this feature is only invoked when test=.true..
c
      tetang = dacos(-done/three)
      tettst = tetdat * torad
      tettol = toldat * torad
c
c     zero temporary coordinate array cz
c
      if (door) then
         do l=1,3
            t1(l) = cz(l)
            t2(l) = cz(3+l)
            t3(l) = cz(6+l)
         end do
      endif

      nz3 = 3*nz
      if (ipart.eq.0) call vclr(cz,1,nz3)
c
c     move angles to local arrays and optionally test for
c     tetrahedral angles
c     test alpha for out of range 0 to 180 degrees
c     test for negative bond lengths.
c
      numtet = 0

      do i=il,ih

         alpha(i) = alph(i) * torad
         beta(i)  = bet(i) * torad

         if (bl(i).le.dzero .and. i.ne.1) then
            oerror = .true.
            call zmterr('negative bond length !',i,1,1)
            return
         endif

         if (i.gt.2 .and..not.(alpha(i).ge.dzero.and.alpha(i).le.pi))
     &   then
            oerror = .true.
            call zmterr(
     &     'angle alpha is outside the valid range of 0 to 180 !',i,2,1)
            return
         endif
         if (ottest .and. i.gt.3) then
            if (otest(alpha(i))) then
               alpha(i) = tetang
               alph(i)  = tetdat
               numtet = numtet + 1
            endif
            if (otest(beta(i))) then
               beta(i) = tetang
               bet(i)  = tetdat
               numtet = numtet + 1
            endif
            if (iz(4,i).ne.0) then
               if (.not.(beta(i).ge.dzero .and. beta(i).le.pi))
     &         then
                  oerror = .true.
                  call zmterr(
     &    'Dihedral is outside the valid range of 0 to 180 !',i,3,1)
                  return
               endif
            endif
         endif

      end do

c      if( (numtet.ne.0) .and. (iun3.ne.0) ) write(iun3,2001)numtet
c
c     z-coordinate, atom 2.
c
      if (door) then
         do l=1,3
            cz(l) = t1(l)
            s1(l) = t2(l) - t1(l)
         end do
         call vsc1(s1,1.0d0,1.0d-4)
         do l=1,3
            cz(3+l) = t1(l)+s1(l)*bl(2)*conver
         end do
      else
         cz(6) = bl(2)*conver
      endif

      if (ih.lt.3) goto 260
c
c     x-coordinate, center 3.
c
      if (door) then
         if (iz(1,3).eq.1) then
            do l=1,3
               s2(l) = t3(l) - t1(l)
            end do
         else
            do l=1,3
               s2(l) = t3(l) - t2(l)
               s1(l) = -s1(l)
            end do
         endif

         call vsc1(s2,1.0d0,1.0d-4)
         call crprod(s1,s2,s3)
         call crprod(s1,s3,s4)
         call vsc1(s4,1.0d0,1.0d-4)

         do l=1,3
            s3(l) = -dsin(alpha(3))*s4(l) + dcos(alpha(3))*s1(l)
         end do

         call vsc1(s3,bl(3)*conver,1.0d-4)
         if (iz(1,3).eq.1) then
            do l=1,3
               cz(6+l) = cz(l) + s3(l)
            end do
         else
            do l=1,3
               cz(6+l) = cz(3+l) + s3(l)
            end do
         endif
      else
         cz(7) = bl(3)*conver* dsin(alpha(3))

         if (iz(1,3).eq.1) then
c
c     z-coordinate, center 3.
c
            cz(9) = bl(3)*conver* dcos(alpha(3))
         else
c
c     z-coordinate on center 3 as a function of z-coordinate, center 2.
c
            cz(9) = cz(6)-bl(3)*conver* dcos(alpha(3))
         endif
      endif
c
c     beware of linear molecule.
c
      if (ih.lt.4) goto 260

      if (door) then 
         if (ipart.ne.0) then
            i = imn
            if (i.lt.4) i = 4
         else
            i = 4
         endif
         goto 90
      endif

      if (ipart.ne.0) then
         il1 = imn
         if (il1.lt.4) il1 = 4
         ih = imx
      else
         il1 = 4
         ih = nz
      endif

      do i=il1,ih
         ind3 = (i-1)*3
         if (dabs(cz(1+ind3-3)).ge.tenm5) goto 90
         cz(1+ind3) = bl(i)*conver* dsin(alpha(i))
         itemp = (iz(1,i)-1)*3
         jtemp = (iz(2,i)-1)*3
         cz(3+ind3) = cz(3+itemp)-bl(i)*conver* dcos(alpha(i))*
     $                dsign(done,cz(3+itemp)-cz(3+jtemp))
      end do

   90 k=i
      if (k.gt.ih) goto 260
      do j=k,ih
         jnd3 = (j-1)*3
         dcaj = dcos(alpha(j))
         dsaj = dsin(alpha(j))
         dcbj = dcos(beta(j))
         dsbj = dsin(beta(j))
         if (iz(4,j).eq.0) then
   
            call vec(tenm6,ovec,u1,cz,iz(2,j),iz(3,j))
            if (ovec) then
               oerror = .true.
               call zmterr(errmsg,i,0,1)
               return
            endif
   
            call vec(tenm6,ovec,u2,cz,iz(1,j),iz(2,j))
            if (ovec) then
               oerror = .true.
               call zmterr(errmsg,i,0,1)
               return
            endif
   
            call crprod(u1,u2,vp)
   
            arg = done - (u1(1)*u2(1)+u1(2)*u2(2)+u1(3)*u2(3))**2
            if (arg .lt. dzero) then
               oerror = .true.
               call zmterr(errmsg,i,0,1)
               return
            endif
   
            r = dsqrt(arg)
            if (r .lt. tenm6) then
               oerror = .true.
               call zmterr(errmsg,i,0,1)
               return
            endif
   
            do i=1,3
               u3(i) = vp(i)/r
            end do
            call crprod(u3,u2,u4)
            do i=1,3
               vj(i)      = bl(j)*conver*(-u2(i)*dcaj+u4(i)*dsaj*dcbj
     &                      +u3(i)*dsaj*dsbj)
               itemp      = (iz(1,j)-1)*3
               cz(i+jnd3) = vj(i)+cz(i+itemp)
            end do
   
         else
   
            if (iabs(iz(4,j))-1.eq.0) then
   
               call vec(tenm6,ovec,u1,cz,iz(1,j),iz(3,j))
   
               if (ovec) then
                   oerror = .true.
                   call zmterr(errmsg,i,0,1)
                   return
               endif
   
               call vec(tenm6,ovec,u2,cz,iz(2,j),iz(1,j))
               if (ovec) then
                  oerror = .true.
                  call zmterr(errmsg,i,0,1)
                  return
               endif
   
               czeta=-(u1(1)*u2(1)+u1(2)*u2(2)+u1(3)*u2(3))
               denom = done - czeta ** 2
   
               if ( dabs(denom) .lt. tenm6) then
                  oerror = .true.
                  call zmterr(errmsg,i,0,1)
                  return
               endif
   
               aj    = (-dcbj+czeta*dcaj)/denom
               bj    = (dcaj-czeta*dcbj)/denom
               r     = dzero
               gamma = pi/two
               if (dabs(czeta) .ge. tenm6) then
                  if (czeta .lt. dzero) r = pi
                  if (denom .lt. dzero) then
                     oerror = .true.
                     call zmterr(errmsg,i,0,1)
                     return
                  endif
                  gamma = datan(dsqrt(denom)/czeta)+r
               endif
   
               dj = dzero
   
               if (dabs(gamma+alpha(j)+beta(j)-two*pi)
     &             -tenm6.ge.0.0d0) then
                  arg = (done + aj*dcbj - bj*dcaj)  /  denom
                  if (arg .lt. dzero) then
                     oerror = .true.
                     call zmterr(errmsg,i,0,1)
                     return
                  endif
                  dj =  dfloat(iz(4,j)) * dsqrt(arg)
               endif
   
               call crprod(u1,u2,v3)
               do i=1,3
                  u3(i)      = aj*u1(i)+bj*u2(i)+dj*v3(i)
                  vj(i)      = bl(j)*conver*u3(i)
                  itemp      = (iz(1,j)-1)*3
                  cz(i+jnd3) = vj(i)+cz(i+itemp)
               end do
   
            else
   
               call vec(tenm6,ovec,u1,cz,iz(1,j),iz(3,j))
               if (ovec) then
                  oerror = .true.
                  call zmterr(errmsg,i,0,1)
                  return
               endif
   
               call vec(tenm6,ovec,u2,cz,iz(2,j),iz(1,j))
               if (ovec) then
                  oerror = .true.
                  call zmterr(errmsg,i,0,1)
                  return
               endif
   
               czeta=-(u1(1)*u2(1)+u1(2)*u2(2)+u1(3)*u2(3))
               call crprod(u1,u2,v3)
               v3mag = dsqrt(v3(1)*v3(1)+v3(2)*v3(2)+v3(3)*v3(3))
               denom = done - czeta**2
   
               if (dabs(denom) .le. tenm6) then
                  oerror = .true.
                  call zmterr(errmsg,i,0,1)
                  return
               endif
   
               aj = v3mag*dcbj / denom
               arg = (done-dcaj*dcaj-aj*dcbj*v3mag) / denom
               if (arg .lt. dzero) then
                  oerror = .true.
                  call zmterr(errmsg,i,0,1)
                  return
               endif
   
               bj = dsqrt(arg)
   
               if (iz(4,j)-2.ne.0) bj = -bj
   
               dj = bj*czeta+dcaj
               do i=1,3
                  u3(i)      = bj*u1(i)+dj*u2(i)+aj*v3(i)
                  vj(i)      = bl(j)*conver*u3(i)
                  itemp      = (iz(1,j)-1)*3
                  cz(i+jnd3) = vj(i)+cz(i+itemp)
               end do
   
            endif
   
         endif

      end do
c
c     eliminate dummy atoms.  dummy atoms are characterized by
c     negative atomic numbers.  ghost atoms have zero atomic
c     numbers.  ghost atoms are not eliminated.
c
  260 continue

      if (ipart.ne.0) then
         iaind = (il-1)*3
         do i=il,ih
            imap(i)     = i
            ian(i) = ianz(i)
            c(1+iaind)  = cz(1+iaind)
            c(2+iaind)  = cz(2+iaind)
            c(3+iaind)  = cz(3+iaind)
            iaind       = iaind+3
         end do
         return
      endif

      natoms=0
      iaind = 0
      naind = 0
      do i=1,nz
         imap(i) = 0
         if (.not.(.not.odum.and.ianz(i).eq.99)) then
            natoms      = natoms+1
            imap(i)     = natoms
            ian(natoms) = ianz(i)
            c(1+naind)  = cz(1+iaind)
            c(2+naind)  = cz(2+iaind)
            c(3+naind)  = cz(3+iaind)
            naind       = naind+3
         endif
         iaind       = iaind+3
      end do

      if (ipart.ne.0) return
c
c     check for superposed atoms
c
      do i=nz,1,-1
         do j=1,nz
            if (i.ne.j.and.imap(i).ne.0.and.imap(j).ne.0) then
               if (dist2(c((imap(i)-1)*3+1),c((imap(j)-1)*3+1))
     &             .lt.tenm6) then
                   call zmterr('Superimposed atoms !',i,0,0)
                   print*,'Zmat to xyz: Superimposed atoms:'
                   print*,'atoms ',j,',',i,' ',ian(j),' ',ian(i)
                   print*,'mapatoms ',imap(j),',',imap(i),
     &                     ian(imap(j)),ian(imap(i))
                   goto 285
               endif
            endif
         end do
      end do
285   continue
c
c     'tidy' up the coordinates.
c
      nat3 = 3*natoms
      do i=1,nat3
         if (dabs(c(i)).le.tenm10) then
            c(i) = dzero
         endif
      end do

      return
      end

      subroutine stocc(maxnz,nz,iz,bl,alph,bet,
     $           alpha,beta,ierror)

c     this routine checks the number of error that would be made by stoc

      implicit double precision (a-h,p-z), logical (o)
      dimension iz(4,*),bl(*),alpha(*),beta(*),
     $          alph(*),bet(*)
c
      data dzero/0.0d0/,done/1.0d0/
      data f180/180.0d0/,four/4.0d0/
      data tetdat/109.471d0/, toldat/0.001d0/, three/3.d0/
c
      otest(ccc) =  dabs(ccc-tettst) .lt. tettol
c
      ierror = 0
      if (nz.gt.maxnz) ierror = ierror + 1
      if (nz .lt. 2) goto 14
      do i=2,nz
         if (i.gt.3.and.iabs(iz(4,i)).gt.1) ierror = ierror + 1
         if (i.eq.2.and.iz(1,2).eq.1) goto 9
         if (i.eq.3.and.iz(1,3).lt.i.and.iz(2,3).lt.i.and.
     &       iz(1,3).gt.0.and.iz(2,3).gt.0) goto 9
         if (i.gt.3.and.iz(1,i).lt.i.and.iz(2,i).lt.i.and.iz(3,i).lt.i
     &       .and.iz(1,i).gt.0.and.iz(2,i).gt.0.and.iz(3,i).gt.0) goto 9
            ierror = ierror + 1
    9    continue
         if (i.eq.3.and.iz(1,i).eq.iz(2,i)) then
            ierror = ierror + 1
         endif
         if (i.gt.3.and.(iz(1,i).eq.iz(2,i).or.iz(1,i).eq.iz(3,i).or.
     &        iz(2,i).eq.iz(3,i))) then
            ierror = ierror + 1
         endif
      end do
   14 continue
      pi=four* datan(done)
      torad=pi/f180
c
      tetang = dacos(-done/three)
      tettst = tetdat * torad
      tettol = toldat * torad
c
      numtet = 0
      do 20 i=1,nz
         alpha(i) = alph(i) * torad
         beta(i)  = bet(i) * torad
         if (bl(i).gt.dzero .or. i.eq.1) goto 15
            ierror = ierror + 1
   15    continue
         if (i.le.2 .or. (alpha(i).ge.dzero.and.alpha(i).le.pi)) goto 16
            ierror = ierror + 1
   16    continue
         if (.not. otest(alpha(i))) goto 17
            alpha(i) = tetang
            alph(i)  = tetdat
            numtet = numtet + 1
   17    if (.not. otest(beta(i))) goto 18
            beta(i) = tetang
            bet(i)  = tetdat
            numtet = numtet + 1
   18    continue
         if (iz(4,i).eq.0 .or. i.le.3) goto 20
         if (beta(i).ge.dzero .and. beta(i).le.pi) goto 20
            ierror = ierror + 1
   20 continue

      return
      end

       logical function gargpl(fl,n,strng1,strng2)
       integer n,fln
       character*(*) fl
       character*(*) strng1,strng2

       gargpl = .false.
       
       fln = len(fl)
       if (strng1(1:fln).ne.fl) return 
       if (strng1(fln+1:fln+1).eq.' ') then
           n = n + 1
           call getarg(n,strng2)
           if (strng2(1:1).eq.'-'.or.strng2(1:1).eq.' ') return
           strng2 = strng2(1:index(strng2,' ')-1)
       else
           strng2 = strng1(fln+1:index(strng1,' ')-1)
       endif
       gargpl = .true.

       return
       end

      subroutine plotgr(ipen,dy,dx)
      implicit double precision (a-h,o-z)
      parameter (mxfill = 1000)
      logical euclid, yes
      common /rdwr/   iun1,iun2,iun3,iun4,iun5
      character*64 carray
      character*5 tk4014
      character*13 str
      real xx, yy
      integer*2 ixx
      logical oclose,osshad,ofill,ofrst
      common /spacom/ grey,iscol,oclose,osshad,ofill,ofrst
      common /fill /  ixx(mxfill),nixx,ihight,icol1
      common /plot / iplot,iplwin,icolps
      common /cntval/ cntval, euclid, yes, icnt, iflag
      common /tektro/ carray, ic
c      integer istmnt
      character*2 gstr

      if (euclid) then
         r2 = 1.0d0
      else
         r2 = dsqrt(2.0d0)
      endif

      dx = 0.5d0 + dx / r2
      dy = 0.5d0 + dy / r2

      isgrey = 0
      if (grey.lt.1.0) isgrey = 1

      if (iplot.eq.6) then
         xx = dx
         yy = dy
         if (ipen.eq.1) then
             if (oclose.and.ofill) then
                if (nixx.gt.1) then
                   nixx = nixx + 1
                   ixx(2*nixx-1) = ixx(1)
                   ixx(2*nixx)   = ixx(2)
                   icol1 = 10
                   if (isgrey.eq.1) icol1  = 6
                   call drwpol(ixx,nixx,icol1,0,isgrey,1)
                endif
                nixx = 1
                ixx(1) = dx*ihight
                ixx(2) = (1.0-dy)*ihight
             endif
             call xwin(xx,yy,2,str,nstr,inct,incp)
             if (yes.and.euclid) then
                 str = gstr(icnt)
                 call xwin(xx,yy,4,str,2,inct,incp)
             endif 
         else
             if (oclose.and.ofill) then
                 if (nixx.le.mxfill-2) then
                    nixx = nixx + 1
                    ixx(2*nixx-1) = dx*ihight
                    ixx(2*nixx)   = (1.0-dy)*ihight
                 endif
             endif
             call xwin(xx,yy,3,str,nstr,inct,incp)
         endif
         return
      endif

      dx = max(0.d0,min(1.d0,dx))
      dy = max(0.d0,min(1.d0,dy))

c      istmnt = ipen
c      if (ipen.eq.2) then
c        if (iplot.eq.0) assign 20 to istmnt
c        if (iplot.eq.1) assign 40 to istmnt
c        if (iplot.eq.2) assign 60 to istmnt
c        if (iplot.eq.4) assign 100 to istmnt
c      else
c        if (iplot.eq.0) assign 10 to istmnt
c        if (iplot.eq.1) assign 30 to istmnt
c        if (iplot.eq.2) assign 50 to istmnt
c        if (iplot.eq.4) assign 90 to istmnt
c      endif

      if (iplot.eq.0) then
          if (ipen.eq.2) then
             write(iun4,'(a,2f8.5)') '.d',dx,dy
          else
             write(iun4,'(a,2f8.5)') '.m',dx,dy
          endif
      endif

      if (iplot.eq.1) then
          if (ipen.eq.2) then
             write(iun4,'(a,2f8.4,a)') 'PD',dx,dy,';'
          else
             write(iun4,'(a,2f8.4,a)') 'PU',dx,dy,';'
          endif
      endif

      if (iplot.eq.2) then
          if (ipen.eq.2) then
              write(iun4,'(a,a,i3,a,i3,a)') 
     &           char(27),'*pb',int(dx*389),',',int(dy*389),'Z'
          else
              write(iun4,'(a,a,i3,a,i3,a)') 
     &           char(27),'*pa',int(dx*389),',',int(dy*389),'Z'
          endif
      endif

      if (iplot.eq.4) then
        if (ipen.ne.2) then
          if (oclose.and.ofill) then
              write(iun4,*) 'closepath'
              write(iun4,*) 'gsave'
              if (icolps.eq.1) then
                 if (isgrey.eq.1) then
                    write(iun4,*) 'negfill setcol'
                 else
                    write(iun4,*) 'posfill setcol'
                 endif
              else
                 write(iun4,*)  grey,' setgray'
              endif
              write(iun4,*) 'fill'
              write(iun4,*) 'grestore'
              if (icolps.eq.0) then
                 write(iun4,*) '0 setgray'
              endif
          endif

          write(iun4,'(''s'')')

          if (euclid) then
             if (yes) then
                write(iun4,'(''tabel {'',i4,'' '',i4,'' m ('',
     &                     i2,'') show } if'')')
     &           int(dx*2000),int(dy*2000+125),icnt
             else
                if (cntval.ne.99.999)
     &           write(iun4,'(''contourvalues {'',i4,'' '',i4,'' m ('',
     &                     f10.6,'') show } if'')')
     &           int(dx*2000),int(dy*2000+125),cntval
             endif
          endif

          write(iun4,'(''n'')')

        endif

        if (ipen.eq.2) then
          write(iun4,'(a,i4,a,i4,a)') 
     &       ' ',int(dx*2000),' ',int(dy*2000)+125,' l'
        else
          write(iun4,'(a,i4,a,i4,a)') 
     &       ' ',int(dx*2000),' ',int(dy*2000)+125,' m'
        endif

      endif

      if (iplot.eq.3) then

         if (ipen.eq.1) then
c-- voer laaste line series uit
           if (carray(1:1).eq.char(29)) then
            carray(7+ic*5:7+ic*5) = char(13)
            write(iun4,'(a)') carray(1:7+ic*5)
           endif
           carray(1:1) = char(29)
           carray(2:6) = tk4014(int(dx*3100),int(dy*3100))
           ic = 0

         else

           if (ic.eq.9) then
             carray(7+ic*5:7+ic*5) = char(13)
             write(iun4,'(a)') carray(1:7+ic*5)
             carray(2:6)  = carray(2+ic*5:6+ic*5)
             carray(7:11) = tk4014(int(dx*3100),int(dy*3100))
             ic = 1
           else
             ic = ic + 1
             carray(2+ic*5:6+ic*5) = tk4014(int(dx*3100),
     &       int(dy*3100))
           endif

         endif
      endif
c10    format('.m',f8.5,f8.5)  
c20    format('.d',f8.5,f8.5)
c30    format('PU',f8.4,f8.4,';')  
c40    format('PD',f8.4,f8.4,';')
c50    format(a,'*pa',i3,',',i3,'Z')
c60    format(a,'*pb',i3,',',i3,'Z')
c90    format(' ',i4,' ',i4,' m')
c100    format(' ',i4,' ',i4,' l')

      if (yes.and.euclid) then
        if (iplot.eq.0) then
           write(iun4,'(''.to 3'')')
           write(iun4,'(''.ch 1.2'')')
           write(iun4,'(''.pt '',i2)') icnt
           write(iun4,'(''.to 5'')')
           write(iun4,'(''.ch 1.5'')')
        endif
        if (iplot.eq.1) then
           write(iun4,'(''LB'',i2,a,'';'')')icnt,char(3)
        endif
      endif

      return
      end

#!/bin/bash
APP="gmolden"
MP="MimeType="
EXTS="pdb xyz mol2 ogl fdat arc ins molf irc zmt msi-car freq shelx gulp mopac-input"
COMMENT="$APP's data file"
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# Create directories if missing
mkdir -p ~/.local/share/mime/packages
mkdir -p ~/.local/share/applications
mkdir -p ~/.icons

if [ -f ~/.icons/gmolden.png ]; then 
   echo " "
   echo "File extensions already registered, run again (y/n) ?"
   echo " "
   read ANSWER
   if [ "$ANSWER" = "n" ]; then
      exit
   fi
fi

NEXTS=""
OKEXTS=""

for EXT in $EXTS; do
  touch /tmp/file.$EXT
  OF=`gio info /tmp/file.$EXT | grep standard::content-type | awk '{ print $(NF) }'`
  if [ $OF != 'text/plain' ]
  then
     if ! gio mime --query $OF | grep 'No recommended applications' 
     then
        NEXTS+=$EXT" "
     else
        OKEXTS+=$EXT" "
     fi
  else
     OKEXTS+=$EXT" "
  fi
done

echo " "
echo 'Overriding existing associations:'
echo  $NEXTS
echo " "
echo "Continue (y/n) ?"
echo " "
read ANSWER
if [ "$ANSWER" = "n" ]; then
   exit
fi

for EXT in $EXTS; do
# Create mime xml 
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<mime-info xmlns=\"http://www.freedesktop.org/standards/shared-mime-info\">
    <mime-type type=\"application/x-$EXT\">
        <comment>$COMMENT</comment>
        <icon name=\"application-x-$EXT\"/>
        <glob pattern=\"*.$EXT\"/>
    </mime-type>
</mime-info>" > ~/.local/share/mime/packages/application-x-$EXT.xml
MP=$MP"application/x-$EXT;chemical/x-$EXT;"
cp haux/gmolden.png ~/.icons/application-x-$EXT.png
cp haux/gmolden.png ~/.icons/chemical-x-$EXT.png
done

# Create application desktop
echo "[Desktop Entry]
Name=$APP
Exec=$DIR/$APP %U
$MP
Icon=$HOME/.icons/$APP.png
Terminal=false
Type=Application
StartupNotify=true
Categories=
Comment=
"> ~/.local/share/applications/$APP.desktop

# update databases for both application and mime
update-desktop-database ~/.local/share/applications
update-mime-database    ~/.local/share/mime

sudo cp ~/.local/share/applications/$APP.desktop /usr/share/app-install/desktop/$APP:$APP.desktop
#sudo cp haux/gmolden.png /usr/share/app-install/icons/
#sudo cp haux/gmolden.png /usr/share/pixmaps
#sudo gtk-update-icon-cache /usr/share/app-install
#sudo update-app-install
# copy associated icons to pixmaps

#!/bin/csh
#
if (! $#argv) then
  echo "Usage: multi_vrml.csh vrmlfile1 vrmlfile2 ... vrmlfileN"
  echo " "
  echo "Output: multi_vrml.wrl"
endif
#
cat << EOF > multi_vrml.wrl
#VRML V2.0 utf8
 NavigationInfo { type "EXAMINE" }
 Viewpoint { position 0 0    23.98028488515462     }
 Group {
   children [
     DEF MOLDEN_TOUCH TouchSensor { },
     DEF MOLDENS Switch {
       whichChoice 0
       choice [
EOF
#
set cnt = 0
foreach file ( $* )
@ cnt = $cnt + 1
cat << EOF >> multi_vrml.wrl
          Group {
            children        Inline {
              url "$file"
              bboxCenter  0 0 0
              bboxSize    1.4 1.7 1.4
            }
          }
EOF
end
#
@ cnt = $cnt - 1
cat << EOF >> multi_vrml.wrl
       ]
     }
   ]
 }
  
 DEF MOLDEN_TIMER TimeSensor { cycleInterval 8 }
  
 PROTO SwitchInterpolator [
   eventIn SFFloat set_fraction
   eventOut SFInt32 value_changed
   field MFFloat key [ ]
   field MFFloat keyValue [ ]
 ]
 {
   DEF INTERP ScalarInterpolator {
     set_fraction IS set_fraction
     key IS key
     keyValue IS keyValue
   }
   DEF INTEGERIZE Script {
     eventIn SFFloat scalarValue
     eventOut SFInt32 value_changed IS value_changed
     url [
       "vrmlscript:
          function scalarValue(scalar) {
            value_changed = Math.floor(scalar);
          }",
          "Float2Int.class"
     ]
   }
   ROUTE INTERP.value_changed TO 
   INTEGERIZE.scalarValue
 }
 DEF MOLDEN_ANIMATOR SwitchInterpolator {
   key [0,1]
   keyValue [0, $cnt]
 }
 ROUTE MOLDEN_TOUCH.touchTime TO
 MOLDEN_TIMER.startTime
 ROUTE MOLDEN_TIMER.fraction_changed TO 
 MOLDEN_ANIMATOR.set_fraction
 ROUTE MOLDEN_ANIMATOR.value_changed TO 
 MOLDENS.whichChoice
EOF
#

BEGIN{j=0
at_symbol[1]="H"
at_symbol[6]="C"
at_symbol[7]="N"
at_symbol[8]="O"
}
{
 if ($1=="Z-Matrix" && $2=="orientation:") {
   getline
   getline
   getline
   getline
   getline
   i=0
   while (NF!=1) {
      i++
      at[i]=$2
      if (NF==5) {
        x[i]=$3
        y[i]=$4
        z[i]=$5 
        }
      else {
        x[i]=$4
        y[i]=$5
        z[i]=$6 
        }
      getline
      }
   }
  if ($1=="SCF" && $2=="Done:") {
    energy=$5
    }
  if ($3=="Threshold") {
    getline
    if ($5=="YES") uno=1
      else uno=0
    getline 
    if ($5=="YES") dos=1
      else dos=0
    getline 
    if ($5=="YES") tres=1
      else tres=0
    getline 
    if ($5=="YES") cuatro=1
      else cuatro=0
    if (uno==1 && dos==1 && tres==1 && cuatro==1) {
      j++
      print i
      print "Point ",j, " Energy= ",energy
      for (k=1;k<=i;k++) {
        print at_symbol[at[k]], x[k], y[k], z[k]
        }
      }
    }
}

#!/bin/sh
#
# Adapted by Joao Lins, Instituto de Quimica da U.F.R.J.
#
# For really large computations, you can ultimately try:
# 1,\$s/numprm=400/numprm=1600/
#
# For more grid points try (For Gaussian and Vasp cube files)
# 1,\$s/mx3d=61/mx3d=122/
#
# To increase maximum allowed connections (In xwin.c change #define MXCON 6)
# 1,\$s/mxcon=6/mxcon=10/
#
# To increase maximum number of atoms for the Z-matrix (For converting
# proteins to Z-matrix) (Also change in xwin.c: #define MAXAT 1000)
# 1,\$s/maxat=1000/maxat=20000/
#
# 1,\$s/maxorb=256/maxorb=1024/
#
# IMPORTANT: molden3.6 has dynamic memory alloaction for the maxorb stuff
#            and for the protein Z-Matrix (the latter not for z-mat reading)
#            So the maxorb and maxat paramters should in general not be
#            tempered with
#
cat <<EOF > /tmp/sed.tmp
1,\$s/MAXPNT=1000/MAXPNT=200/
EOF
#
for file in *.f 
do
   echo Operating on $file
   mv $file ${file}.org
   sed -f /tmp/sed.tmp ${file}.org > $file
done
rm -f /tmp/sed.tmp
